void compute_GHPLs_Ginac(int weight, double u, double v, double *GPL1, double *GPL2, double *GPL3, double *GPL4, double *HPL1, double *HPL2, double *HPL3, double *HPL4) {
  
  GiNaC::Digits=17;
 
  assert(u>=0);
  assert(u<=1-v);
  assert(v>=0);
  assert(v<=1);
  if (weight < 1 || weight > 4) {
    assert(false && "ERROR: weight in compute_GHPLs_Ginac must be between 1 and 4. Exiting...");
  }

  for (int i=0; i<2; i++) {
    HPL1[i] = GiNaC::ex_to<GiNaC::numeric>(GiNaC::H(GiNaC::lst(i),v).evalf()).to_double();
    if (weight >= 2) {
      for (int j=0; j<2; j++) {
 	HPL2[i+2*j] = GiNaC::ex_to<GiNaC::numeric>(GiNaC::H(GiNaC::lst(i,j),v).evalf()).to_double();
 	if (weight >= 3) {
 	  for (int k=0; k<2; k++) {
 	    HPL3[i+2*j+2*2*k] = GiNaC::ex_to<GiNaC::numeric>(GiNaC::H(GiNaC::lst(i,j,k),v).evalf()).to_double();
 	    if (weight >= 4) {
 	      for (int l=0; l<2; l++) {
 		HPL4[i+2*j+2*2*k+2*2*2*l] = GiNaC::ex_to<GiNaC::numeric>(GiNaC::H(GiNaC::lst(i,j,k,l),v).evalf()).to_double();
 	      }
 	    }
 	  }
 	}
      }
    }
  }
  
  double mapping[] = {0,1,1-v,-v};
    
  for (int i=0; i<4; i++) {
    double ai = mapping[i];
    GPL1[i] = GiNaC::ex_to<GiNaC::numeric>(GiNaC::G(GiNaC::lst(ai),u).evalf()).to_double();
    if (weight >= 2) {
      for (int j=0; j<4; j++) {
	double aj = mapping[j];
 	GPL2[i+4*j] = GiNaC::ex_to<GiNaC::numeric>(GiNaC::G(GiNaC::lst(ai,aj),u).evalf()).to_double();
 	if (weight >= 3) {
 	  for (int k=0; k<4; k++) {
 	    double ak = mapping[k];
 	    GPL3[i+4*j+4*4*k] = GiNaC::ex_to<GiNaC::numeric>(GiNaC::G(GiNaC::lst(ai,aj,ak),u).evalf()).to_double();
 	    if (weight >= 4) {
 	      for (int l=0; l<4; l++) {
 		double al = mapping[l];
 		GPL4[i+4*j+4*4*k+4*4*4*l] = GiNaC::ex_to<GiNaC::numeric>(GiNaC::G(GiNaC::lst(ai,aj,ak,al),u).evalf()).to_double();
 	      }
 	    }
 	  }
 	}
      }
    }
  }
}
