c The expansion of h in powers of as/2pi, as defined in Stefano's notes

      function h1_TT(i,j,beta,cost)
      ! For h1 I write everything in terms of the T3T4
      ! and T3T3 color structures, set the rest to zero
      implicit none
      double precision h1_TT,beta,cost
      integer i,j
      double precision Fex1_T3T4,Fex1_CF
      external Fex1_T3T4,Fex1_CF

      h1_TT = 0.d0

      if((i.eq.3).and.(j.eq.4))then
        h1_TT = Fex1_T3T4(beta,cost)
      endif

      if((i.eq.3).and.(j.eq.3))then
        h1_TT = Fex1_CF(beta,cost)
      endif

      return
      end


      function h2_TT(i,j,beta,cost,nf)
      ! For h2 I write everything in terms of the T3T4
      ! and TITj color structures, set the rest to zero
      ! Here B=pT2/m2 and A=4*pIpj^2/m2/s
      ! cost is the angle of p3 w.r.t. p1
      implicit none
      double precision h2_TT,beta,cost
      integer i,j
      double precision Fex2_and_11_T3T4,Fex2_TITj,Fex1_1_TITj
      double precision A,B
      double precision pi,beta0,CA,nf
      external Fex2_and_11_T3T4,Fex2_TITj,Fex1_1_TITj

      CA = 3.d0
      pi = 3.1415926535897932385d0
      beta0 = (11.*CA - 2.*nf)/(12.*pi)

      h2_TT = 0.d0

      if((i.eq.3).and.(j.eq.4))then
        h2_TT = Fex2_and_11_T3T4(beta,cost)
      endif

      if( ((i.eq.3).and.(j.eq.1)).or.
     &    ((i.eq.4).and.(j.eq.2)) )then
        B = (beta**2.d0*(1.d0 - cost**2.d0))/(1.d0 - beta**2.d0)
        A = (1.d0 - beta*cost)**2.d0/(1.d0 - beta**2.d0)
        h2_TT = Fex2_TITj(B,A,CA,nf)-2.d0*pi*beta0*Fex1_1_TITj(B,A)
      endif

      if( ((i.eq.3).and.(j.eq.2)).or.
     &    ((i.eq.4).and.(j.eq.1)) )then
        B = (beta**2.d0*(1.d0 - cost**2.d0))/(1.d0 - beta**2.d0)
        A = (1.d0 + beta*cost)**2.d0/(1.d0 - beta**2.d0) 
        h2_TT = Fex2_TITj(B,A,CA,nf)-2.d0*pi*beta0*Fex1_1_TITj(B,A)
      endif

      return
      end


      function h2_TTTT(i,j,k,l,beta,cost)
      ! I put here all the contributions coming from the terms
      ! <Fex1(0)^2> -1/2 <Fex,1(0)>^2
      ! I write everything in terms of the color structures
      ! T3T4T3T4, T3T4T3T3 and T3T3T3T3, set the rest to zero
      implicit none
      double precision h2_TTTT,beta,cost
      integer i,j,k,l
      double precision Fex1sq_T3T4sq,Fex1sq_CFsq,Fex1sq_T3T4CF
      double precision sqFex1_T3T4sq,sqFex1_CFsq,sqFex1_T3T4CF 
      external Fex1sq_T3T4sq,Fex1sq_CFsq,Fex1sq_T3T4CF 
      external sqFex1_T3T4sq,sqFex1_CFsq,sqFex1_T3T4CF 

      h2_TTTT = 0.d0

      if((i.eq.3).and.(j.eq.4).and.(k.eq.3).and.(l.eq.4))then
        h2_TTTT = Fex1sq_T3T4sq(beta,cost)
     &            -1.d0/2.d0*sqFex1_T3T4sq(beta,cost)
!        write (*,*) "Fex1sq_T3T4sq(beta,cost) = ",
!     &   Fex1sq_T3T4sq(beta,cost)
!        write (*,*) "sqFex1_T3T4sq(beta,cost) = ",
!     &   sqFex1_T3T4sq(beta,cost)
      endif

      if((i.eq.3).and.(j.eq.4).and.(k.eq.3).and.(l.eq.3))then
        h2_TTTT = Fex1sq_T3T4CF(beta,cost)
     &            -1.d0/2.d0*sqFex1_T3T4CF(beta,cost)
!        write (*,*) "Fex1sq_T3T4CF(beta,cost) = ",
!     &   Fex1sq_T3T4CF(beta,cost)
!        write (*,*) "sqFex1_T3T4CF(beta,cost) = ",
!     &   sqFex1_T3T4CF(beta,cost)
      endif

      if((i.eq.3).and.(j.eq.3).and.(k.eq.3).and.(l.eq.3))then
        h2_TTTT = Fex1sq_CFsq(beta,cost)
     &            -1.d0/2.d0*sqFex1_CFsq(beta,cost)
!        write (*,*) "Fex1sq_CFsq(beta,cost) = ",
!     &   Fex1sq_CFsq(beta,cost)
!        write (*,*) "sqFex1_CFsq(beta,cost) = ",
!     &   sqFex1_CFsq(beta,cost)
      endif

      return
      end
