#include "header.hpp"

#include "ppv01.amplitude.gg.set.hpp"

void ppv01_amplitude_gg_initialization(munich * MUC){
  static Logger logger("ppv01_amplitude_gg_initialization");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (MUC->osi->switch_OL){
#ifdef OPENLOOPS
    MUC->asi = new ppv01_amplitude_gg_OpenLoops_set();
#endif
  }
  else if (MUC->osi->switch_RCL){
#ifdef RECOLA
    MUC->asi = new ppv01_amplitude_gg_Recola_set();
#endif
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


ppv01_amplitude_gg_set::ppv01_amplitude_gg_set(){
  Logger logger("ppv01_amplitude_gg_set::ppv01_amplitude_gg_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "constructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

ppv01_amplitude_gg_set::~ppv01_amplitude_gg_set(){
  Logger logger("ppv01_amplitude_gg_set::~ppv01_amplitude_gg_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "destructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void ppv01_amplitude_gg_set::initialization_H1gg_QCD_2loop(){
  static Logger logger("ppv01_amplitude_gg_set::initialization_H1gg_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  osi->QT_H1_delta_QCD = 0.;
  logger << LOG_DEBUG << "osi->QT_H1_delta_QCD = " << osi->QT_H1_delta_QCD << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

/*
void ppv01_amplitude_gg_set::calculate_H1gg_QCD_2loop(){
  static Logger logger("ppv01_amplitude_gg_set::calculate_H1gg_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  /*
  logger << LOG_FATAL << "Amplitudes have not been implemented yet." << endline_flush;
  exit(1);

  osi->QT_H1_delta_QCD = osi->QT_A1;
  osi->QT_H1_delta_QCD /= 2;
  osi->QT_H1_delta_QCD /= (osi->alpha_S * inv2pi * osi->QT_A0);
  logger << LOG_DEBUG << "osi->QT_H1_delta_QCD = " << osi->QT_H1_delta_QCD << endline_flush;
*//*

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
  */
