#ifndef ppll02_AMPLITUDE_SET_HPP
#define ppll02_AMPLITUDE_SET_HPP

void ppll02_amplitude_initialization(munich * MUC);

using namespace std;

class ppll02_amplitude_set : virtual public amplitude_set {
private:

public:
  ppll02_amplitude_set();
  virtual ~ppll02_amplitude_set();
  
  virtual void initialization_H2_QCD_2loop();
  virtual void calculate_H2_QCD_2loop();

  // QCD 2-loop amplitudes
  double_complex F1;
  double_complex F2;
  double delta_I1;
  double beta0;
  // QCD I-operator
  double K;
  double delta_qT;
  double D2a;
  double g1a;
  double delta_I2;

};


#ifdef OPENLOOPS
class ppll02_amplitude_OpenLoops_set : virtual public amplitude_OpenLoops_set, virtual public ppll02_amplitude_set {
private:

public:
  ppll02_amplitude_OpenLoops_set(){}
  virtual ~ppll02_amplitude_OpenLoops_set(){}
  
};
#endif


#ifdef RECOLA
class ppll02_amplitude_Recola_set : virtual public amplitude_Recola_set, virtual public ppll02_amplitude_set {
private:

public:
  ppll02_amplitude_Recola_set(){}
  virtual ~ppll02_amplitude_Recola_set(){}
  
};
#endif

#endif
