#ifndef ppllh03_AMPLITUDE_SET_HPP
#define ppllh03_AMPLITUDE_SET_HPP

void ppllh03_amplitude_initialization(munich * MUC);

using namespace std;

class ppllh03_amplitude_set : virtual public amplitude_set {
private:

public:
  ppllh03_amplitude_set();
  ~ppllh03_amplitude_set();
  
  //  double_complex ppll22_F2_q(double LR);
  virtual void calculate_H2_QCD_2loop_initialization_ingredients();
  void calculate_H2_QCD_2loop();
  void calculate_H1gg_QCD_2loop();

  // QCD 2-loop amplitudes
  double_complex F1;
  double_complex F2;
  double delta_I1;
  double beta0;
  // QCD I-operator
  double K;
  double delta_qT;
  double D2a;
  double g1a;
  double delta_I2;
};


#ifdef OPENLOOPS
class ppllh03_amplitude_OpenLoops_set : public amplitude_OpenLoops_set, public ppllh03_amplitude_set {
private:

public:
  ppllh03_amplitude_OpenLoops_set();
  ~ppllh03_amplitude_OpenLoops_set();
  
  void initialization_process();

};
#endif


#ifdef RECOLA
class ppllh03_amplitude_Recola_set : public amplitude_Recola_set, public ppllh03_amplitude_set {
private:

public:
  ppllh03_amplitude_Recola_set();
  ~ppllh03_amplitude_Recola_set();
  
  void initialization_process();

};
#endif

#endif
