#ifndef ppqq20_AMPLITUDE_SET_HPP
#define ppqq20_AMPLITUDE_SET_HPP

void ppqq20_amplitude_initialization(munich * MUC);

using namespace std;

class ppqq20_amplitude_set : virtual public amplitude_set {
private:

public:
  ppqq20_amplitude_set();
  ~ppqq20_amplitude_set();
  
  void calculate_QT_kinematics();
  virtual void calculate_fourcolourcorrelators();
  void calculate_Ft1born();
  void calculate_Ft1born_4correlator();
  void calculate_Gamma1born();
  void calculate_Gamma1loop();
  void calculate_commutator_Gamma1_Ft1();
  void calculate_Gamma2();
  void calculate_Gamma1_squared();

  char * get_fortran_path(string cpp_path, int & length_path);
  void initialization_grid();
  virtual void calculate_H2_2loop_ingredients(){}
  void calculate_H2_2loop();

  string output_amplitude_VT_QCD();
  string output_amplitude_CT_QCD();
  string output_amplitude_VT2_QCD();
  string output_amplitude_CT2_QCD();

  
  double M1M1;
  double M0M0;
  double M0M0_3434;
  double M2M0;
  vector<vector<vector<vector<double> > > > M0M04c;
  vector<vector<double> > M0M0cc;
  vector<vector<double> > M1M0cc;
  vector<vector<double> > imM1M0cc;
  double M1M0;
  double imM1M0;

  double m_HQ;
  double m2_HQ;

  double mu_Q;
  
  char * ch_path_Fex2_T3T4_CA;
  int len_Fex2_T3T4_CA;
  char * ch_path_Fex2_T3T4_nf;
  int len_Fex2_T3T4_nf;
  char * ch_path_Fex11_T3T4;
  int len_Fex11_T3T4;

  char * ch_path_Fex1sq_T3T4T3T4;
  int len_Fex1sq_T3T4T3T4;
  char * ch_path_Fex1sq_T3T4TITj;
  int len_Fex1sq_T3T4TITj;
  char * ch_path_Fex1sq_TITjTKTl;
  int len_Fex1sq_TITjTKTl;

  char * ch_path_gridgg;
  int len_gridgg;
  char * ch_path_gridqq;
  int len_gridqq;
      
  double CA;
  double nf;
  double b0; 
  double b1;
  
  int temp_channel;
  double Ci;
  double gama1;
  double gama2;

  
  double q2;
  double v34;
  double log_v34;
  double frac_v34;
  double dilogpT2m2;
  double logmT2m2;
  double L34;
  double gammacusp2_v;
  double y34;
  double beta34;
  double arg_1mv34_1pv34;
  double dilog1mv34_1pv34;
  double trilog1mv34_1pv34;
  double log_2v34_1pv34;
};


#ifdef OPENLOOPS

class ppqq20_amplitude_OpenLoops_set : public amplitude_OpenLoops_set, public ppqq20_amplitude_set {
private:

public:
  ppqq20_amplitude_OpenLoops_set();
  ~ppqq20_amplitude_OpenLoops_set();
  
  void initialization_process();

  void calculate_ME2_cf_twocolourcorrelators();
  void calculate_ME2_loopcf_twocolourcorrelators();

  void calculate_ME2_VT_QCD();
  void calculate_ME2_CT_QCD();
  void calculate_ME2_VT2_QCD();
  void calculate_ME2_VT2_QCD_H0_doublespinflip();
  void calculate_ME2_VT2_QCD_H0_DG();
  void calculate_ME2_CT2_QCD();

  void calculate_H2_2loop_ingredients();

  int process_id_loopxloop;
  int process_id_imag;

  double m0_OL;
  double * m2cc;
  double * m2l1;
  double * m2loopcc;
  double * m2l1_im;
  double * m2loopcc_im;
  double * m2l2;
  double * loopcc_m2l1_im;
  double * loopcc_M2loopcc_im;
  double * loopcc_m2l1;
  double * loopcc_m2loopcc;

};
#endif


#ifdef RECOLA
class ppqq20_amplitude_Recola_set : public amplitude_Recola_set, public ppqq20_amplitude_set {
private:

public:
  ppqq20_amplitude_Recola_set();
  ~ppqq20_amplitude_Recola_set();
  
  void initialization_process();
  void set_phasespacepoint_OLformat();
  
  void calculate_ME2_cf_twocolourcorrelators();
  void calculate_ME2_loopcf_twocolourcorrelators();

  void calculate_ME2_VT_QCD();
  void calculate_ME2_CT_QCD();
  void calculate_ME2_VT2_QCD();
  void calculate_ME2_VT2_QCD_H0_doublespinflip();
  void calculate_ME2_VT2_QCD_H0_DG();
  void calculate_ME2_CT2_QCD();

  void calculate_H2_2loop_ingredients();

  int n_momentum;
  double * P_OLformat;
};
#endif

#endif
