#ifndef ppnenex02_PHASESPACE_SET_HPP
#define ppnenex02_PHASESPACE_SET_HPP

using namespace std;

class ppnenex02_phasespace_set : public phasespace_set {
private:

public:
  ppnenex02_phasespace_set(){}
  ~ppnenex02_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_020_ddx_vevex(int x_a);
  void ac_psp_020_ddx_vevex(int x_a, int channel);
  void ag_psp_020_ddx_vevex(int x_a, int zero);
  void ax_psp_020_uux_vevex(int x_a);
  void ac_psp_020_uux_vevex(int x_a, int channel);
  void ag_psp_020_uux_vevex(int x_a, int zero);
  void ax_psp_020_bbx_vevex(int x_a);
  void ac_psp_020_bbx_vevex(int x_a, int channel);
  void ag_psp_020_bbx_vevex(int x_a, int zero);
  void ax_psp_220_gg_vevex(int x_a);
  void ac_psp_220_gg_vevex(int x_a, int channel);
  void ag_psp_220_gg_vevex(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_120_gd_vevexd(int x_a);
  void ac_psp_120_gd_vevexd(int x_a, int channel);
  void ag_psp_120_gd_vevexd(int x_a, int zero);
  void ax_psp_120_gu_vevexu(int x_a);
  void ac_psp_120_gu_vevexu(int x_a, int channel);
  void ag_psp_120_gu_vevexu(int x_a, int zero);
  void ax_psp_120_gb_vevexb(int x_a);
  void ac_psp_120_gb_vevexb(int x_a, int channel);
  void ag_psp_120_gb_vevexb(int x_a, int zero);
  void ax_psp_120_gdx_vevexdx(int x_a);
  void ac_psp_120_gdx_vevexdx(int x_a, int channel);
  void ag_psp_120_gdx_vevexdx(int x_a, int zero);
  void ax_psp_120_gux_vevexux(int x_a);
  void ac_psp_120_gux_vevexux(int x_a, int channel);
  void ag_psp_120_gux_vevexux(int x_a, int zero);
  void ax_psp_120_gbx_vevexbx(int x_a);
  void ac_psp_120_gbx_vevexbx(int x_a, int channel);
  void ag_psp_120_gbx_vevexbx(int x_a, int zero);
  void ax_psp_120_ddx_vevexg(int x_a);
  void ac_psp_120_ddx_vevexg(int x_a, int channel);
  void ag_psp_120_ddx_vevexg(int x_a, int zero);
  void ax_psp_030_da_vevexd(int x_a);
  void ac_psp_030_da_vevexd(int x_a, int channel);
  void ag_psp_030_da_vevexd(int x_a, int zero);
  void ax_psp_120_uux_vevexg(int x_a);
  void ac_psp_120_uux_vevexg(int x_a, int channel);
  void ag_psp_120_uux_vevexg(int x_a, int zero);
  void ax_psp_030_ua_vevexu(int x_a);
  void ac_psp_030_ua_vevexu(int x_a, int channel);
  void ag_psp_030_ua_vevexu(int x_a, int zero);
  void ax_psp_120_bbx_vevexg(int x_a);
  void ac_psp_120_bbx_vevexg(int x_a, int channel);
  void ag_psp_120_bbx_vevexg(int x_a, int zero);
  void ax_psp_030_ba_vevexb(int x_a);
  void ac_psp_030_ba_vevexb(int x_a, int channel);
  void ag_psp_030_ba_vevexb(int x_a, int zero);
  void ax_psp_030_dxa_vevexdx(int x_a);
  void ac_psp_030_dxa_vevexdx(int x_a, int channel);
  void ag_psp_030_dxa_vevexdx(int x_a, int zero);
  void ax_psp_030_uxa_vevexux(int x_a);
  void ac_psp_030_uxa_vevexux(int x_a, int channel);
  void ag_psp_030_uxa_vevexux(int x_a, int zero);
  void ax_psp_030_bxa_vevexbx(int x_a);
  void ac_psp_030_bxa_vevexbx(int x_a, int channel);
  void ag_psp_030_bxa_vevexbx(int x_a, int zero);
  void ax_psp_030_ddx_vevexa(int x_a);
  void ac_psp_030_ddx_vevexa(int x_a, int channel);
  void ag_psp_030_ddx_vevexa(int x_a, int zero);
  void ax_psp_030_uux_vevexa(int x_a);
  void ac_psp_030_uux_vevexa(int x_a, int channel);
  void ag_psp_030_uux_vevexa(int x_a, int zero);
  void ax_psp_030_bbx_vevexa(int x_a);
  void ac_psp_030_bbx_vevexa(int x_a, int channel);
  void ag_psp_030_bbx_vevexa(int x_a, int zero);
  void ax_psp_320_gg_vevexg(int x_a);
  void ac_psp_320_gg_vevexg(int x_a, int channel);
  void ag_psp_320_gg_vevexg(int x_a, int zero);
  void ax_psp_320_gd_vevexd(int x_a);
  void ac_psp_320_gd_vevexd(int x_a, int channel);
  void ag_psp_320_gd_vevexd(int x_a, int zero);
  void ax_psp_320_gu_vevexu(int x_a);
  void ac_psp_320_gu_vevexu(int x_a, int channel);
  void ag_psp_320_gu_vevexu(int x_a, int zero);
  void ax_psp_320_gb_vevexb(int x_a);
  void ac_psp_320_gb_vevexb(int x_a, int channel);
  void ag_psp_320_gb_vevexb(int x_a, int zero);
  void ax_psp_320_gdx_vevexdx(int x_a);
  void ac_psp_320_gdx_vevexdx(int x_a, int channel);
  void ag_psp_320_gdx_vevexdx(int x_a, int zero);
  void ax_psp_320_gux_vevexux(int x_a);
  void ac_psp_320_gux_vevexux(int x_a, int channel);
  void ag_psp_320_gux_vevexux(int x_a, int zero);
  void ax_psp_320_gbx_vevexbx(int x_a);
  void ac_psp_320_gbx_vevexbx(int x_a, int channel);
  void ag_psp_320_gbx_vevexbx(int x_a, int zero);
  void ax_psp_320_ddx_vevexg(int x_a);
  void ac_psp_320_ddx_vevexg(int x_a, int channel);
  void ag_psp_320_ddx_vevexg(int x_a, int zero);
  void ax_psp_320_uux_vevexg(int x_a);
  void ac_psp_320_uux_vevexg(int x_a, int channel);
  void ag_psp_320_uux_vevexg(int x_a, int zero);
  void ax_psp_320_bbx_vevexg(int x_a);
  void ac_psp_320_bbx_vevexg(int x_a, int channel);
  void ag_psp_320_bbx_vevexg(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_220_gg_vevexddx(int x_a);
  void ac_psp_220_gg_vevexddx(int x_a, int channel);
  void ag_psp_220_gg_vevexddx(int x_a, int zero);
  void ax_psp_220_gg_vevexuux(int x_a);
  void ac_psp_220_gg_vevexuux(int x_a, int channel);
  void ag_psp_220_gg_vevexuux(int x_a, int zero);
  void ax_psp_220_gg_vevexbbx(int x_a);
  void ac_psp_220_gg_vevexbbx(int x_a, int channel);
  void ag_psp_220_gg_vevexbbx(int x_a, int zero);
  void ax_psp_220_gd_vevexgd(int x_a);
  void ac_psp_220_gd_vevexgd(int x_a, int channel);
  void ag_psp_220_gd_vevexgd(int x_a, int zero);
  void ax_psp_220_gu_vevexgu(int x_a);
  void ac_psp_220_gu_vevexgu(int x_a, int channel);
  void ag_psp_220_gu_vevexgu(int x_a, int zero);
  void ax_psp_220_gb_vevexgb(int x_a);
  void ac_psp_220_gb_vevexgb(int x_a, int channel);
  void ag_psp_220_gb_vevexgb(int x_a, int zero);
  void ax_psp_220_gdx_vevexgdx(int x_a);
  void ac_psp_220_gdx_vevexgdx(int x_a, int channel);
  void ag_psp_220_gdx_vevexgdx(int x_a, int zero);
  void ax_psp_220_gux_vevexgux(int x_a);
  void ac_psp_220_gux_vevexgux(int x_a, int channel);
  void ag_psp_220_gux_vevexgux(int x_a, int zero);
  void ax_psp_220_gbx_vevexgbx(int x_a);
  void ac_psp_220_gbx_vevexgbx(int x_a, int channel);
  void ag_psp_220_gbx_vevexgbx(int x_a, int zero);
  void ax_psp_220_dd_vevexdd(int x_a);
  void ac_psp_220_dd_vevexdd(int x_a, int channel);
  void ag_psp_220_dd_vevexdd(int x_a, int zero);
  void ax_psp_220_du_vevexdu(int x_a);
  void ac_psp_220_du_vevexdu(int x_a, int channel);
  void ag_psp_220_du_vevexdu(int x_a, int zero);
  void ax_psp_220_ds_vevexds(int x_a);
  void ac_psp_220_ds_vevexds(int x_a, int channel);
  void ag_psp_220_ds_vevexds(int x_a, int zero);
  void ax_psp_220_dc_vevexdc(int x_a);
  void ac_psp_220_dc_vevexdc(int x_a, int channel);
  void ag_psp_220_dc_vevexdc(int x_a, int zero);
  void ax_psp_220_db_vevexdb(int x_a);
  void ac_psp_220_db_vevexdb(int x_a, int channel);
  void ag_psp_220_db_vevexdb(int x_a, int zero);
  void ax_psp_220_ddx_vevexgg(int x_a);
  void ac_psp_220_ddx_vevexgg(int x_a, int channel);
  void ag_psp_220_ddx_vevexgg(int x_a, int zero);
  void ax_psp_220_ddx_vevexddx(int x_a);
  void ac_psp_220_ddx_vevexddx(int x_a, int channel);
  void ag_psp_220_ddx_vevexddx(int x_a, int zero);
  void ax_psp_220_ddx_vevexuux(int x_a);
  void ac_psp_220_ddx_vevexuux(int x_a, int channel);
  void ag_psp_220_ddx_vevexuux(int x_a, int zero);
  void ax_psp_220_ddx_vevexssx(int x_a);
  void ac_psp_220_ddx_vevexssx(int x_a, int channel);
  void ag_psp_220_ddx_vevexssx(int x_a, int zero);
  void ax_psp_220_ddx_vevexccx(int x_a);
  void ac_psp_220_ddx_vevexccx(int x_a, int channel);
  void ag_psp_220_ddx_vevexccx(int x_a, int zero);
  void ax_psp_220_ddx_vevexbbx(int x_a);
  void ac_psp_220_ddx_vevexbbx(int x_a, int channel);
  void ag_psp_220_ddx_vevexbbx(int x_a, int zero);
  void ax_psp_220_dux_vevexdux(int x_a);
  void ac_psp_220_dux_vevexdux(int x_a, int channel);
  void ag_psp_220_dux_vevexdux(int x_a, int zero);
  void ax_psp_220_dsx_vevexdsx(int x_a);
  void ac_psp_220_dsx_vevexdsx(int x_a, int channel);
  void ag_psp_220_dsx_vevexdsx(int x_a, int zero);
  void ax_psp_220_dcx_vevexdcx(int x_a);
  void ac_psp_220_dcx_vevexdcx(int x_a, int channel);
  void ag_psp_220_dcx_vevexdcx(int x_a, int zero);
  void ax_psp_220_dbx_vevexdbx(int x_a);
  void ac_psp_220_dbx_vevexdbx(int x_a, int channel);
  void ag_psp_220_dbx_vevexdbx(int x_a, int zero);
  void ax_psp_220_uu_vevexuu(int x_a);
  void ac_psp_220_uu_vevexuu(int x_a, int channel);
  void ag_psp_220_uu_vevexuu(int x_a, int zero);
  void ax_psp_220_uc_vevexuc(int x_a);
  void ac_psp_220_uc_vevexuc(int x_a, int channel);
  void ag_psp_220_uc_vevexuc(int x_a, int zero);
  void ax_psp_220_ub_vevexub(int x_a);
  void ac_psp_220_ub_vevexub(int x_a, int channel);
  void ag_psp_220_ub_vevexub(int x_a, int zero);
  void ax_psp_220_udx_vevexudx(int x_a);
  void ac_psp_220_udx_vevexudx(int x_a, int channel);
  void ag_psp_220_udx_vevexudx(int x_a, int zero);
  void ax_psp_220_uux_vevexgg(int x_a);
  void ac_psp_220_uux_vevexgg(int x_a, int channel);
  void ag_psp_220_uux_vevexgg(int x_a, int zero);
  void ax_psp_220_uux_vevexddx(int x_a);
  void ac_psp_220_uux_vevexddx(int x_a, int channel);
  void ag_psp_220_uux_vevexddx(int x_a, int zero);
  void ax_psp_220_uux_vevexuux(int x_a);
  void ac_psp_220_uux_vevexuux(int x_a, int channel);
  void ag_psp_220_uux_vevexuux(int x_a, int zero);
  void ax_psp_220_uux_vevexssx(int x_a);
  void ac_psp_220_uux_vevexssx(int x_a, int channel);
  void ag_psp_220_uux_vevexssx(int x_a, int zero);
  void ax_psp_220_uux_vevexccx(int x_a);
  void ac_psp_220_uux_vevexccx(int x_a, int channel);
  void ag_psp_220_uux_vevexccx(int x_a, int zero);
  void ax_psp_220_uux_vevexbbx(int x_a);
  void ac_psp_220_uux_vevexbbx(int x_a, int channel);
  void ag_psp_220_uux_vevexbbx(int x_a, int zero);
  void ax_psp_220_usx_vevexusx(int x_a);
  void ac_psp_220_usx_vevexusx(int x_a, int channel);
  void ag_psp_220_usx_vevexusx(int x_a, int zero);
  void ax_psp_220_ucx_vevexucx(int x_a);
  void ac_psp_220_ucx_vevexucx(int x_a, int channel);
  void ag_psp_220_ucx_vevexucx(int x_a, int zero);
  void ax_psp_220_ubx_vevexubx(int x_a);
  void ac_psp_220_ubx_vevexubx(int x_a, int channel);
  void ag_psp_220_ubx_vevexubx(int x_a, int zero);
  void ax_psp_220_bb_vevexbb(int x_a);
  void ac_psp_220_bb_vevexbb(int x_a, int channel);
  void ag_psp_220_bb_vevexbb(int x_a, int zero);
  void ax_psp_220_bdx_vevexbdx(int x_a);
  void ac_psp_220_bdx_vevexbdx(int x_a, int channel);
  void ag_psp_220_bdx_vevexbdx(int x_a, int zero);
  void ax_psp_220_bux_vevexbux(int x_a);
  void ac_psp_220_bux_vevexbux(int x_a, int channel);
  void ag_psp_220_bux_vevexbux(int x_a, int zero);
  void ax_psp_220_bbx_vevexgg(int x_a);
  void ac_psp_220_bbx_vevexgg(int x_a, int channel);
  void ag_psp_220_bbx_vevexgg(int x_a, int zero);
  void ax_psp_220_bbx_vevexddx(int x_a);
  void ac_psp_220_bbx_vevexddx(int x_a, int channel);
  void ag_psp_220_bbx_vevexddx(int x_a, int zero);
  void ax_psp_220_bbx_vevexuux(int x_a);
  void ac_psp_220_bbx_vevexuux(int x_a, int channel);
  void ag_psp_220_bbx_vevexuux(int x_a, int zero);
  void ax_psp_220_bbx_vevexbbx(int x_a);
  void ac_psp_220_bbx_vevexbbx(int x_a, int channel);
  void ag_psp_220_bbx_vevexbbx(int x_a, int zero);
  void ax_psp_220_dxdx_vevexdxdx(int x_a);
  void ac_psp_220_dxdx_vevexdxdx(int x_a, int channel);
  void ag_psp_220_dxdx_vevexdxdx(int x_a, int zero);
  void ax_psp_220_dxux_vevexdxux(int x_a);
  void ac_psp_220_dxux_vevexdxux(int x_a, int channel);
  void ag_psp_220_dxux_vevexdxux(int x_a, int zero);
  void ax_psp_220_dxsx_vevexdxsx(int x_a);
  void ac_psp_220_dxsx_vevexdxsx(int x_a, int channel);
  void ag_psp_220_dxsx_vevexdxsx(int x_a, int zero);
  void ax_psp_220_dxcx_vevexdxcx(int x_a);
  void ac_psp_220_dxcx_vevexdxcx(int x_a, int channel);
  void ag_psp_220_dxcx_vevexdxcx(int x_a, int zero);
  void ax_psp_220_dxbx_vevexdxbx(int x_a);
  void ac_psp_220_dxbx_vevexdxbx(int x_a, int channel);
  void ag_psp_220_dxbx_vevexdxbx(int x_a, int zero);
  void ax_psp_220_uxux_vevexuxux(int x_a);
  void ac_psp_220_uxux_vevexuxux(int x_a, int channel);
  void ag_psp_220_uxux_vevexuxux(int x_a, int zero);
  void ax_psp_220_uxcx_vevexuxcx(int x_a);
  void ac_psp_220_uxcx_vevexuxcx(int x_a, int channel);
  void ag_psp_220_uxcx_vevexuxcx(int x_a, int zero);
  void ax_psp_220_uxbx_vevexuxbx(int x_a);
  void ac_psp_220_uxbx_vevexuxbx(int x_a, int channel);
  void ag_psp_220_uxbx_vevexuxbx(int x_a, int zero);
  void ax_psp_220_bxbx_vevexbxbx(int x_a);
  void ac_psp_220_bxbx_vevexbxbx(int x_a, int channel);
  void ag_psp_220_bxbx_vevexbxbx(int x_a, int zero);

};
#endif
