#ifndef ppttx20_PHASESPACE_SET_HPP
#define ppttx20_PHASESPACE_SET_HPP

using namespace std;

class ppttx20_phasespace_set : public phasespace_set {
private:

public:
  ppttx20_phasespace_set(){}
  ~ppttx20_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_200_gg_ttx(int x_a);
  void ac_psp_200_gg_ttx(int x_a, int channel);
  void ag_psp_200_gg_ttx(int x_a, int zero);
  void ax_psp_200_ddx_ttx(int x_a);
  void ac_psp_200_ddx_ttx(int x_a, int channel);
  void ag_psp_200_ddx_ttx(int x_a, int zero);
  void ax_psp_200_uux_ttx(int x_a);
  void ac_psp_200_uux_ttx(int x_a, int channel);
  void ag_psp_200_uux_ttx(int x_a, int zero);
  void ax_psp_200_bbx_ttx(int x_a);
  void ac_psp_200_bbx_ttx(int x_a, int channel);
  void ag_psp_200_bbx_ttx(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_300_gg_ttxg(int x_a);
  void ac_psp_300_gg_ttxg(int x_a, int channel);
  void ag_psp_300_gg_ttxg(int x_a, int zero);
  void ax_psp_300_gd_ttxd(int x_a);
  void ac_psp_300_gd_ttxd(int x_a, int channel);
  void ag_psp_300_gd_ttxd(int x_a, int zero);
  void ax_psp_300_gu_ttxu(int x_a);
  void ac_psp_300_gu_ttxu(int x_a, int channel);
  void ag_psp_300_gu_ttxu(int x_a, int zero);
  void ax_psp_300_gb_ttxb(int x_a);
  void ac_psp_300_gb_ttxb(int x_a, int channel);
  void ag_psp_300_gb_ttxb(int x_a, int zero);
  void ax_psp_300_gdx_ttxdx(int x_a);
  void ac_psp_300_gdx_ttxdx(int x_a, int channel);
  void ag_psp_300_gdx_ttxdx(int x_a, int zero);
  void ax_psp_300_gux_ttxux(int x_a);
  void ac_psp_300_gux_ttxux(int x_a, int channel);
  void ag_psp_300_gux_ttxux(int x_a, int zero);
  void ax_psp_300_gbx_ttxbx(int x_a);
  void ac_psp_300_gbx_ttxbx(int x_a, int channel);
  void ag_psp_300_gbx_ttxbx(int x_a, int zero);
  void ax_psp_300_ddx_ttxg(int x_a);
  void ac_psp_300_ddx_ttxg(int x_a, int channel);
  void ag_psp_300_ddx_ttxg(int x_a, int zero);
  void ax_psp_300_uux_ttxg(int x_a);
  void ac_psp_300_uux_ttxg(int x_a, int channel);
  void ag_psp_300_uux_ttxg(int x_a, int zero);
  void ax_psp_300_bbx_ttxg(int x_a);
  void ac_psp_300_bbx_ttxg(int x_a, int channel);
  void ag_psp_300_bbx_ttxg(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_400_gg_ttxgg(int x_a);
  void ac_psp_400_gg_ttxgg(int x_a, int channel);
  void ag_psp_400_gg_ttxgg(int x_a, int zero);
  void ax_psp_400_gg_ttxddx(int x_a);
  void ac_psp_400_gg_ttxddx(int x_a, int channel);
  void ag_psp_400_gg_ttxddx(int x_a, int zero);
  void ax_psp_400_gg_ttxuux(int x_a);
  void ac_psp_400_gg_ttxuux(int x_a, int channel);
  void ag_psp_400_gg_ttxuux(int x_a, int zero);
  void ax_psp_400_gg_ttxbbx(int x_a);
  void ac_psp_400_gg_ttxbbx(int x_a, int channel);
  void ag_psp_400_gg_ttxbbx(int x_a, int zero);
  void ax_psp_400_gd_ttxgd(int x_a);
  void ac_psp_400_gd_ttxgd(int x_a, int channel);
  void ag_psp_400_gd_ttxgd(int x_a, int zero);
  void ax_psp_400_gu_ttxgu(int x_a);
  void ac_psp_400_gu_ttxgu(int x_a, int channel);
  void ag_psp_400_gu_ttxgu(int x_a, int zero);
  void ax_psp_400_gb_ttxgb(int x_a);
  void ac_psp_400_gb_ttxgb(int x_a, int channel);
  void ag_psp_400_gb_ttxgb(int x_a, int zero);
  void ax_psp_400_gdx_ttxgdx(int x_a);
  void ac_psp_400_gdx_ttxgdx(int x_a, int channel);
  void ag_psp_400_gdx_ttxgdx(int x_a, int zero);
  void ax_psp_400_gux_ttxgux(int x_a);
  void ac_psp_400_gux_ttxgux(int x_a, int channel);
  void ag_psp_400_gux_ttxgux(int x_a, int zero);
  void ax_psp_400_gbx_ttxgbx(int x_a);
  void ac_psp_400_gbx_ttxgbx(int x_a, int channel);
  void ag_psp_400_gbx_ttxgbx(int x_a, int zero);
  void ax_psp_400_dd_ttxdd(int x_a);
  void ac_psp_400_dd_ttxdd(int x_a, int channel);
  void ag_psp_400_dd_ttxdd(int x_a, int zero);
  void ax_psp_400_du_ttxdu(int x_a);
  void ac_psp_400_du_ttxdu(int x_a, int channel);
  void ag_psp_400_du_ttxdu(int x_a, int zero);
  void ax_psp_400_ds_ttxds(int x_a);
  void ac_psp_400_ds_ttxds(int x_a, int channel);
  void ag_psp_400_ds_ttxds(int x_a, int zero);
  void ax_psp_400_dc_ttxdc(int x_a);
  void ac_psp_400_dc_ttxdc(int x_a, int channel);
  void ag_psp_400_dc_ttxdc(int x_a, int zero);
  void ax_psp_400_db_ttxdb(int x_a);
  void ac_psp_400_db_ttxdb(int x_a, int channel);
  void ag_psp_400_db_ttxdb(int x_a, int zero);
  void ax_psp_400_ddx_ttxgg(int x_a);
  void ac_psp_400_ddx_ttxgg(int x_a, int channel);
  void ag_psp_400_ddx_ttxgg(int x_a, int zero);
  void ax_psp_400_ddx_ttxddx(int x_a);
  void ac_psp_400_ddx_ttxddx(int x_a, int channel);
  void ag_psp_400_ddx_ttxddx(int x_a, int zero);
  void ax_psp_400_ddx_ttxuux(int x_a);
  void ac_psp_400_ddx_ttxuux(int x_a, int channel);
  void ag_psp_400_ddx_ttxuux(int x_a, int zero);
  void ax_psp_400_ddx_ttxssx(int x_a);
  void ac_psp_400_ddx_ttxssx(int x_a, int channel);
  void ag_psp_400_ddx_ttxssx(int x_a, int zero);
  void ax_psp_400_ddx_ttxccx(int x_a);
  void ac_psp_400_ddx_ttxccx(int x_a, int channel);
  void ag_psp_400_ddx_ttxccx(int x_a, int zero);
  void ax_psp_400_ddx_ttxbbx(int x_a);
  void ac_psp_400_ddx_ttxbbx(int x_a, int channel);
  void ag_psp_400_ddx_ttxbbx(int x_a, int zero);
  void ax_psp_400_dux_ttxdux(int x_a);
  void ac_psp_400_dux_ttxdux(int x_a, int channel);
  void ag_psp_400_dux_ttxdux(int x_a, int zero);
  void ax_psp_400_dsx_ttxdsx(int x_a);
  void ac_psp_400_dsx_ttxdsx(int x_a, int channel);
  void ag_psp_400_dsx_ttxdsx(int x_a, int zero);
  void ax_psp_400_dcx_ttxdcx(int x_a);
  void ac_psp_400_dcx_ttxdcx(int x_a, int channel);
  void ag_psp_400_dcx_ttxdcx(int x_a, int zero);
  void ax_psp_400_dbx_ttxdbx(int x_a);
  void ac_psp_400_dbx_ttxdbx(int x_a, int channel);
  void ag_psp_400_dbx_ttxdbx(int x_a, int zero);
  void ax_psp_400_uu_ttxuu(int x_a);
  void ac_psp_400_uu_ttxuu(int x_a, int channel);
  void ag_psp_400_uu_ttxuu(int x_a, int zero);
  void ax_psp_400_uc_ttxuc(int x_a);
  void ac_psp_400_uc_ttxuc(int x_a, int channel);
  void ag_psp_400_uc_ttxuc(int x_a, int zero);
  void ax_psp_400_ub_ttxub(int x_a);
  void ac_psp_400_ub_ttxub(int x_a, int channel);
  void ag_psp_400_ub_ttxub(int x_a, int zero);
  void ax_psp_400_udx_ttxudx(int x_a);
  void ac_psp_400_udx_ttxudx(int x_a, int channel);
  void ag_psp_400_udx_ttxudx(int x_a, int zero);
  void ax_psp_400_uux_ttxgg(int x_a);
  void ac_psp_400_uux_ttxgg(int x_a, int channel);
  void ag_psp_400_uux_ttxgg(int x_a, int zero);
  void ax_psp_400_uux_ttxddx(int x_a);
  void ac_psp_400_uux_ttxddx(int x_a, int channel);
  void ag_psp_400_uux_ttxddx(int x_a, int zero);
  void ax_psp_400_uux_ttxuux(int x_a);
  void ac_psp_400_uux_ttxuux(int x_a, int channel);
  void ag_psp_400_uux_ttxuux(int x_a, int zero);
  void ax_psp_400_uux_ttxssx(int x_a);
  void ac_psp_400_uux_ttxssx(int x_a, int channel);
  void ag_psp_400_uux_ttxssx(int x_a, int zero);
  void ax_psp_400_uux_ttxccx(int x_a);
  void ac_psp_400_uux_ttxccx(int x_a, int channel);
  void ag_psp_400_uux_ttxccx(int x_a, int zero);
  void ax_psp_400_uux_ttxbbx(int x_a);
  void ac_psp_400_uux_ttxbbx(int x_a, int channel);
  void ag_psp_400_uux_ttxbbx(int x_a, int zero);
  void ax_psp_400_usx_ttxusx(int x_a);
  void ac_psp_400_usx_ttxusx(int x_a, int channel);
  void ag_psp_400_usx_ttxusx(int x_a, int zero);
  void ax_psp_400_ucx_ttxucx(int x_a);
  void ac_psp_400_ucx_ttxucx(int x_a, int channel);
  void ag_psp_400_ucx_ttxucx(int x_a, int zero);
  void ax_psp_400_ubx_ttxubx(int x_a);
  void ac_psp_400_ubx_ttxubx(int x_a, int channel);
  void ag_psp_400_ubx_ttxubx(int x_a, int zero);
  void ax_psp_400_bb_ttxbb(int x_a);
  void ac_psp_400_bb_ttxbb(int x_a, int channel);
  void ag_psp_400_bb_ttxbb(int x_a, int zero);
  void ax_psp_400_bdx_ttxbdx(int x_a);
  void ac_psp_400_bdx_ttxbdx(int x_a, int channel);
  void ag_psp_400_bdx_ttxbdx(int x_a, int zero);
  void ax_psp_400_bux_ttxbux(int x_a);
  void ac_psp_400_bux_ttxbux(int x_a, int channel);
  void ag_psp_400_bux_ttxbux(int x_a, int zero);
  void ax_psp_400_bbx_ttxgg(int x_a);
  void ac_psp_400_bbx_ttxgg(int x_a, int channel);
  void ag_psp_400_bbx_ttxgg(int x_a, int zero);
  void ax_psp_400_bbx_ttxddx(int x_a);
  void ac_psp_400_bbx_ttxddx(int x_a, int channel);
  void ag_psp_400_bbx_ttxddx(int x_a, int zero);
  void ax_psp_400_bbx_ttxuux(int x_a);
  void ac_psp_400_bbx_ttxuux(int x_a, int channel);
  void ag_psp_400_bbx_ttxuux(int x_a, int zero);
  void ax_psp_400_bbx_ttxbbx(int x_a);
  void ac_psp_400_bbx_ttxbbx(int x_a, int channel);
  void ag_psp_400_bbx_ttxbbx(int x_a, int zero);
  void ax_psp_400_dxdx_ttxdxdx(int x_a);
  void ac_psp_400_dxdx_ttxdxdx(int x_a, int channel);
  void ag_psp_400_dxdx_ttxdxdx(int x_a, int zero);
  void ax_psp_400_dxux_ttxdxux(int x_a);
  void ac_psp_400_dxux_ttxdxux(int x_a, int channel);
  void ag_psp_400_dxux_ttxdxux(int x_a, int zero);
  void ax_psp_400_dxsx_ttxdxsx(int x_a);
  void ac_psp_400_dxsx_ttxdxsx(int x_a, int channel);
  void ag_psp_400_dxsx_ttxdxsx(int x_a, int zero);
  void ax_psp_400_dxcx_ttxdxcx(int x_a);
  void ac_psp_400_dxcx_ttxdxcx(int x_a, int channel);
  void ag_psp_400_dxcx_ttxdxcx(int x_a, int zero);
  void ax_psp_400_dxbx_ttxdxbx(int x_a);
  void ac_psp_400_dxbx_ttxdxbx(int x_a, int channel);
  void ag_psp_400_dxbx_ttxdxbx(int x_a, int zero);
  void ax_psp_400_uxux_ttxuxux(int x_a);
  void ac_psp_400_uxux_ttxuxux(int x_a, int channel);
  void ag_psp_400_uxux_ttxuxux(int x_a, int zero);
  void ax_psp_400_uxcx_ttxuxcx(int x_a);
  void ac_psp_400_uxcx_ttxuxcx(int x_a, int channel);
  void ag_psp_400_uxcx_ttxuxcx(int x_a, int zero);
  void ax_psp_400_uxbx_ttxuxbx(int x_a);
  void ac_psp_400_uxbx_ttxuxbx(int x_a, int channel);
  void ag_psp_400_uxbx_ttxuxbx(int x_a, int zero);
  void ax_psp_400_bxbx_ttxbxbx(int x_a);
  void ac_psp_400_bxbx_ttxbxbx(int x_a, int channel);
  void ag_psp_400_bxbx_ttxbxbx(int x_a, int zero);

};
#endif
