#include "header.hpp"

#include "ppaaa03.summary.hpp"

void ppaaa03_summary_generic::initialization_summary_order(size_t n_order){
  Logger logger("ppaaa03_summary_generic::initialization_summary_order");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  yorder.resize(n_order);
  for (size_t i_o = 0; i_o < n_order; i_o++){yorder[i_o] = new ppaaa03_summary_order();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_generic::initialization_summary_list(size_t n_list){
  Logger logger("ppaaa03_summary_generic::initialization_summary_list");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  xlist.resize(n_list);
  for (size_t i_l = 0; i_l < n_list; i_l++){xlist[i_l] = new ppaaa03_summary_list();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_list::initialization_summary_contribution(size_t n_contribution){
  Logger logger("ppaaa03_summary_list::initialization_summary_contribution");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  xcontribution.resize(n_contribution);
  for (size_t i_l = 0; i_l < n_contribution; i_l++){xcontribution[i_l] = new ppaaa03_summary_contribution();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_born(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 0 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(4);
    subprocess[1] = "dd~_aaa";
    subprocess[2] = "uu~_aaa";
    subprocess[3] = "bb~_aaa";
    subgroup_no_member[0] = vector<int> {1, 2, 3};
  }
  else if (in_contribution_order_alpha_s == 2 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_aaa";
    subgroup_no_member[0] = vector<int> {1};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_C_QCD(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_C_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 1 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(4);
    subprocess[1] = "dd~_aaa";
    subprocess[2] = "uu~_aaa";
    subprocess[3] = "bb~_aaa";
    subgroup_no_member[0] = vector<int> {1, 2, 3};
  }
  else if (in_contribution_order_alpha_s == 3 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_aaa";
    subgroup_no_member[0] = vector<int> {1};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_C_QEW(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_C_QEW");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 0 && in_contribution_order_alpha_e == 4 && interference == 0){
    subprocess.resize(4);
    subprocess[1] = "dd~_aaa";
    subprocess[2] = "uu~_aaa";
    subprocess[3] = "bb~_aaa";
    subgroup_no_member[0] = vector<int> {1, 2, 3};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_V_QCD(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_V_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 1 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(4);
    subprocess[1] = "dd~_aaa";
    subprocess[2] = "uu~_aaa";
    subprocess[3] = "bb~_aaa";
    subgroup_no_member[0] = vector<int> {1, 2, 3};
  }
  else if (in_contribution_order_alpha_s == 3 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_aaa";
    subgroup_no_member[0] = vector<int> {1};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_V_QEW(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_V_QEW");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 0 && in_contribution_order_alpha_e == 4 && interference == 0){
    subprocess.resize(4);
    subprocess[1] = "dd~_aaa";
    subprocess[2] = "uu~_aaa";
    subprocess[3] = "bb~_aaa";
    subgroup_no_member[0] = vector<int> {1, 2, 3};
  }
  else if (in_contribution_order_alpha_s == 2 && in_contribution_order_alpha_e == 4 && interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_aaa";
    subgroup_no_member[0] = vector<int> {1};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_C2_QCD(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_C2_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 2 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(4);
    subprocess[1] = "dd~_aaa";
    subprocess[2] = "uu~_aaa";
    subprocess[3] = "bb~_aaa";
    subgroup_no_member[0] = vector<int> {1, 2, 3};
  }
  else if (in_contribution_order_alpha_s == 3 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_aaa";
    subgroup_no_member[0] = vector<int> {1};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_V2_QCD(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_V2_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 2 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(4);
    subprocess[1] = "dd~_aaa";
    subprocess[2] = "uu~_aaa";
    subprocess[3] = "bb~_aaa";
    subgroup_no_member[0] = vector<int> {1, 2, 3};
  }
  else if (in_contribution_order_alpha_s == 4 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_aaa";
    subgroup_no_member[0] = vector<int> {1};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_R_QCD(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_R_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 1 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(10);
    subprocess[1] = "gd_aaad";
    subprocess[2] = "gu_aaau";
    subprocess[3] = "gb_aaab";
    subprocess[4] = "gd~_aaad~";
    subprocess[5] = "gu~_aaau~";
    subprocess[6] = "gb~_aaab~";
    subprocess[7] = "dd~_aaag";
    subprocess[8] = "uu~_aaag";
    subprocess[9] = "bb~_aaag";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9};
  }
  else if (in_contribution_order_alpha_s == 3 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(11);
    subprocess[1] = "gg_aaag";
    subprocess[2] = "gd_aaad";
    subprocess[3] = "gu_aaau";
    subprocess[4] = "gb_aaab";
    subprocess[5] = "gd~_aaad~";
    subprocess[6] = "gu~_aaau~";
    subprocess[7] = "gb~_aaab~";
    subprocess[8] = "dd~_aaag";
    subprocess[9] = "uu~_aaag";
    subprocess[10] = "bb~_aaag";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_R_QEW(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_R_QEW");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 0 && in_contribution_order_alpha_e == 4 && interference == 0){
    subprocess.resize(10);
    subprocess[1] = "da_aaad";
    subprocess[2] = "ua_aaau";
    subprocess[3] = "ba_aaab";
    subprocess[4] = "d~a_aaad~";
    subprocess[5] = "u~a_aaau~";
    subprocess[6] = "b~a_aaab~";
    subprocess[7] = "dd~_aaaa";
    subprocess[8] = "uu~_aaaa";
    subprocess[9] = "bb~_aaaa";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_RC_QCD(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_RC_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 2 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(10);
    subprocess[1] = "gd_aaad";
    subprocess[2] = "gu_aaau";
    subprocess[3] = "gb_aaab";
    subprocess[4] = "gd~_aaad~";
    subprocess[5] = "gu~_aaau~";
    subprocess[6] = "gb~_aaab~";
    subprocess[7] = "dd~_aaag";
    subprocess[8] = "uu~_aaag";
    subprocess[9] = "bb~_aaag";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9};
  }
  else if (in_contribution_order_alpha_s == 1 && in_contribution_order_alpha_e == 4 && interference == 0){
    subprocess.resize(10);
    subprocess[1] = "da_aaad";
    subprocess[2] = "ua_aaau";
    subprocess[3] = "ba_aaab";
    subprocess[4] = "d~a_aaad~";
    subprocess[5] = "u~a_aaau~";
    subprocess[6] = "b~a_aaab~";
    subprocess[7] = "dd~_aaaa";
    subprocess[8] = "uu~_aaaa";
    subprocess[9] = "bb~_aaaa";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_RV_QCD(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_RV_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 2 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(10);
    subprocess[1] = "gd_aaad";
    subprocess[2] = "gu_aaau";
    subprocess[3] = "gb_aaab";
    subprocess[4] = "gd~_aaad~";
    subprocess[5] = "gu~_aaau~";
    subprocess[6] = "gb~_aaab~";
    subprocess[7] = "dd~_aaag";
    subprocess[8] = "uu~_aaag";
    subprocess[9] = "bb~_aaag";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9};
  }
  else if (in_contribution_order_alpha_s == 1 && in_contribution_order_alpha_e == 4 && interference == 0){
    subprocess.resize(10);
    subprocess[1] = "da_aaad";
    subprocess[2] = "ua_aaau";
    subprocess[3] = "ba_aaab";
    subprocess[4] = "d~a_aaad~";
    subprocess[5] = "u~a_aaau~";
    subprocess[6] = "b~a_aaab~";
    subprocess[7] = "dd~_aaaa";
    subprocess[8] = "uu~_aaaa";
    subprocess[9] = "bb~_aaaa";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_summary_contribution::list_subprocess_RR_QCD(){
  Logger logger("ppaaa03_summary_contribution::list_subprocess_RR_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (in_contribution_order_alpha_s == 2 && in_contribution_order_alpha_e == 3 && interference == 0){
    subprocess.resize(54);
    subprocess[1] = "gg_aaadd~";
    subprocess[2] = "gg_aaauu~";
    subprocess[3] = "gg_aaabb~";
    subprocess[4] = "gd_aaagd";
    subprocess[5] = "gu_aaagu";
    subprocess[6] = "gb_aaagb";
    subprocess[7] = "gd~_aaagd~";
    subprocess[8] = "gu~_aaagu~";
    subprocess[9] = "gb~_aaagb~";
    subprocess[10] = "dd_aaadd";
    subprocess[11] = "du_aaadu";
    subprocess[12] = "ds_aaads";
    subprocess[13] = "dc_aaadc";
    subprocess[14] = "db_aaadb";
    subprocess[15] = "dd~_aaagg";
    subprocess[16] = "dd~_aaadd~";
    subprocess[17] = "dd~_aaauu~";
    subprocess[18] = "dd~_aaass~";
    subprocess[19] = "dd~_aaacc~";
    subprocess[20] = "dd~_aaabb~";
    subprocess[21] = "du~_aaadu~";
    subprocess[22] = "ds~_aaads~";
    subprocess[23] = "dc~_aaadc~";
    subprocess[24] = "db~_aaadb~";
    subprocess[25] = "uu_aaauu";
    subprocess[26] = "uc_aaauc";
    subprocess[27] = "ub_aaaub";
    subprocess[28] = "ud~_aaaud~";
    subprocess[29] = "uu~_aaagg";
    subprocess[30] = "uu~_aaadd~";
    subprocess[31] = "uu~_aaauu~";
    subprocess[32] = "uu~_aaass~";
    subprocess[33] = "uu~_aaacc~";
    subprocess[34] = "uu~_aaabb~";
    subprocess[35] = "us~_aaaus~";
    subprocess[36] = "uc~_aaauc~";
    subprocess[37] = "ub~_aaaub~";
    subprocess[38] = "bb_aaabb";
    subprocess[39] = "bd~_aaabd~";
    subprocess[40] = "bu~_aaabu~";
    subprocess[41] = "bb~_aaagg";
    subprocess[42] = "bb~_aaadd~";
    subprocess[43] = "bb~_aaauu~";
    subprocess[44] = "bb~_aaabb~";
    subprocess[45] = "d~d~_aaad~d~";
    subprocess[46] = "d~u~_aaad~u~";
    subprocess[47] = "d~s~_aaad~s~";
    subprocess[48] = "d~c~_aaad~c~";
    subprocess[49] = "d~b~_aaad~b~";
    subprocess[50] = "u~u~_aaau~u~";
    subprocess[51] = "u~c~_aaau~c~";
    subprocess[52] = "u~b~_aaau~b~";
    subprocess[53] = "b~b~_aaab~b~";
    subgroup_no_member[0] = vector<int> {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53};
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
