{
  static int switch_optimize_sqrts_min = USERSWITCH("optimize_sqrts_min");
  static double cut_optimize_sqrts_min = USERCUT("optimize_sqrts_min");

  static int switch_cut_M_leplep = USERSWITCH("M_leplep");
  static double cut_min_M_leplep = USERCUT("min_M_leplep");
  static double cut_min_M2_leplep = pow(cut_min_M_leplep, 2);
  static double cut_max_M_leplep = USERCUT("max_M_leplep");
  static double cut_max_M2_leplep = pow(cut_max_M_leplep, 2);

  static int switch_cut_R_leplep = USERSWITCH("R_leplep");
  static double cut_min_R_leplep = USERCUT("min_R_leplep");
  static double cut_min_R2_leplep = pow(cut_min_R_leplep, 2);
  
  static int switch_cut_R_rapidity_leplep = USERSWITCH("R_rapidity_leplep");
  static double cut_min_R_rapidity_leplep = USERCUT("min_R_rapidity_leplep");
  static double cut_min_R2_rapidity_leplep = pow(cut_min_R_rapidity_leplep, 2);

  static int switch_cut_R_eta_leplep = USERSWITCH("R_eta_leplep");
  static double cut_min_R_eta_leplep = USERCUT("min_R_eta_leplep");
  static double cut_min_R2_eta_leplep = pow(cut_min_R_eta_leplep, 2);

  static int switch_cut_R_ejet = USERSWITCH("R_ejet");
  static double cut_min_R_ejet = USERCUT("min_R_ejet");
  static double cut_min_R2_ejet = pow(cut_min_R_ejet, 2);  

  static int switch_n_jet_modified = USERSWITCH("n_jet_modified");
  static int cut_n_jet_min_modified = USERINT("n_jet_min_modified");
  static int cut_n_jet_max_modified = USERINT("n_jet_max_modified");

  static int switch_cut_M_4lep = USERSWITCH("M_leplepnunu");
  static double cut_min_M_4lep = USERCUT("min_M_leplepnunu");
  static double cut_min_M2_4lep = pow(cut_min_M_4lep, 2);
  static double cut_max_M_4lep = USERCUT("max_M_leplepnunu");
  static double cut_max_M2_4lep = pow(cut_max_M_4lep, 2);
  static double cut_min_deltaZ_M_4lep = USERCUT("min_delta_M_leplepnunu");
  static double cut_max_deltaZ_M_4lep = USERCUT("max_delta_M_leplepnunu");

  static int switch_axial_ETmiss = USERSWITCH("axial_ETmiss");
  static double cut_min_axial_ETmiss = USERCUT("min_axial_ETmiss");

  static int switch_pT_balance_Zs = USERSWITCH("pT_balance_Zs");
  static double cut_max_pT_balance_Zs = USERCUT("max_pT_balance_Zs");

  static int switch_cut_rel_HTjet_HTlep = USERSWITCH("rel_HTjet_HTlep");
  static double cut_min_rel_HTjet_HTlep = USERCUT("min_rel_HTjet_HTlep");
  

  // cut on relative HTjet/HTlep fraction
  if (switch_cut_rel_HTjet_HTlep){
    double HTjet = 0.;
    for (int i_j = 0; i_j < PARTICLE("jet").size(); i_j++){HTjet += PARTICLE("jet")[i_j].pT;}
    if (HTjet > 0.){
      double HTlep = 0.;
      for (int i_l = 0; i_l < PARTICLE("lep").size(); i_l++){HTlep += PARTICLE("lep")[i_l].pT;}
      for (int m_l = 0; m_l < PARTICLE("missing").size(); m_l++){if(m_l==0){HTlep += PARTICLE("missing")[m_l].pT;}}
      for (int p_l = 0; p_l < PARTICLE("photon").size(); p_l++){if(p_l==0){HTlep += PARTICLE("photon")[p_l].pT;}}

      if (HTjet > cut_min_rel_HTjet_HTlep * HTlep){
	cut_ps[i_a] = -1;
	logger << LOG_DEBUG_VERBOSE << "switch_cut_rel_HTjet_HTlep cut applied" << endl; 
	return;
      }
    }
  }

  if (switch_optimize_sqrts_min){
    fourvector total_momentum;
    for (int i_l = 0; i_l < NUMBER("lep"); i_l++){total_momentum = total_momentum + PARTICLE("lep")[i_l].momentum;}
    for (int i_j = 0; i_j < NUMBER("jet"); i_j++){total_momentum = total_momentum + PARTICLE("jet")[i_j].momentum;}
    for (int i_n = 0; i_n < NUMBER("nua"); i_n++){total_momentum = total_momentum + PARTICLE("nua")[i_n].momentum;}
    if (total_momentum.m() < cut_optimize_sqrts_min ){cut_ps[i_a] = -1; return;}
  }

  
  // lepton--lepton invariant-mass cut
  if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]" << "   switch_cut_M_leplep = " << switch_cut_M_leplep << endl;}
  if (switch_cut_M_leplep == 1){
    double M2_leplep = (PARTICLE("lep")[0].momentum + PARTICLE("lep")[1].momentum).m2();
    if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   PARTICLE(lep)[0] = " << PARTICLE("lep")[0].momentum << endl;}
    if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   PARTICLE(lep)[1] = " << PARTICLE("lep")[1].momentum << endl;}
    if (cut_min_M2_leplep != 0.){
      if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   M2_leplep = " << M2_leplep << " > " << cut_min_M2_leplep << endl;}

      if (M2_leplep < cut_min_M2_leplep){
	cut_ps[i_a] = -1; 
	if (switch_output_cutinfo){
	  info_cut << "[" << setw(2) << i_a << "]" << "   individual cut after cut_min_M_leplep" << endl;
	  logger << LOG_DEBUG << endl << info_cut.str();
	}
	logger << LOG_DEBUG_VERBOSE << "switch_cut_M_leplep min cut applied" << endl; 
	return;
      }
      if (cut_max_M2_leplep != 0 && M2_leplep > cut_max_M2_leplep){
	cut_ps[i_a] = -1; 
	if (switch_output_cutinfo){
	  info_cut << "[" << setw(2) << i_a << "]" << "   individual cut after cut_max_M_leplep" << endl;
	  logger << LOG_DEBUG << endl << info_cut.str();
	}
	logger << LOG_DEBUG_VERBOSE << "switch_cut_M_leplep max cut applied" << endl; 
	return;
      }
    }
  }

  // lepton lepton R-separation (rapidity-based) cut (to be applied to *any* two leptons)
  if (switch_cut_R_leplep) {
    for (int i_l1 = 0; i_l1 < PARTICLE("lep").size(); i_l1++) {
      for (int i_l2 = i_l1 + 1; i_l2 < PARTICLE("lep").size(); i_l2++) {
        double R2_rapidity_leplep = R2_rapidity(PARTICLE("lep")[i_l1], PARTICLE("lep")[i_l2]);
	if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   R2_lep[" << i_l1 << "]lep[" << i_l2 << "] = " << R2_rapidity_leplep << " > " << cut_min_R2_leplep << endl;}
        if (R2_rapidity_leplep < cut_min_R2_leplep) {
          cut_ps[i_a] = -1;
	  if (switch_output_cutinfo){
	    info_cut << "[" << setw(2) << i_a << "]" << "   process-specific cut after cut_R_leplep" << endl;
	    logger << LOG_DEBUG << endl << info_cut.str();
	  }
          return;
        }
      }
    }
  }

  if (switch_cut_R_rapidity_leplep) {
    for (int i_l1 = 0; i_l1 < PARTICLE("lep").size(); i_l1++) {
      for (int i_l2 = i_l1 + 1; i_l2 < PARTICLE("lep").size(); i_l2++) {
        double R2_rapidity_leplep = R2_rapidity(PARTICLE("lep")[i_l1], PARTICLE("lep")[i_l2]);
	if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   R2_lep[" << i_l1 << "]lep[" << i_l2 << "] = " << R2_rapidity_leplep << " > " << cut_min_R2_rapidity_leplep << endl;}
        if (R2_rapidity_leplep < cut_min_R2_rapidity_leplep) {
          cut_ps[i_a] = -1;
	  if (switch_output_cutinfo){
	    info_cut << "[" << setw(2) << i_a << "]" << "   process-specific cut after cut_R_rapidity_leplep" << endl;
	    logger << LOG_DEBUG << endl << info_cut.str();
	  }
          return;
        }
      }
    }
  }


  // lepton lepton R-separation (pseudo-rapidity-based) cut (to be applied to *any* two leptons)
  if (switch_cut_R_eta_leplep) {
    for (int i_l1 = 0; i_l1 < PARTICLE("lep").size(); i_l1++) {
      for (int i_l2 = i_l1 + 1; i_l2 < PARTICLE("lep").size(); i_l2++) {
        double R2_eta_leplep = R2_eta(PARTICLE("lep")[i_l1], PARTICLE("lep")[i_l2]);
	if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   R2_lep[" << i_l1 << "]lep[" << i_l2 << "] = " << R2_eta_leplep << " > " << cut_min_R2_eta_leplep << endl;}
        if (R2_eta_leplep < cut_min_R2_eta_leplep) {
          cut_ps[i_a] = -1;
	  if (switch_output_cutinfo){
	    info_cut << "[" << setw(2) << i_a << "]" << "   process-specific cut after cut_R_eta_leplep" << endl;
	    logger << LOG_DEBUG << endl << info_cut.str();
	  }
          return;
        }
      }
    }
  }


  // electron--jet isolation cut
  // removes jets which are too close to electrons (and reduced jet number); the electrons are not affected.
  if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]" << "   switch_cut_R_ejet = " << switch_cut_R_ejet << endl;}
  if (switch_cut_R_ejet){
    for (int i_j = 0; i_j < NUMBER("jet"); i_j++){
    //  for (int i_j = 0; i_j < PARTICLE("jet").size(); i_j++){ // separation wrt. jets below pT/ET-threshold included
      if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]" << "   switch_cut_R_ejet = " << switch_cut_R_ejet << "   i_j = " << i_j << endl;}
      // lepton--jet pseudo-rapidity isolation cuts
      for (int i_l = 0; i_l < PARTICLE("e").size(); i_l++){
	double R2_eta_ejet = R2_eta(PARTICLE("e")[i_l], PARTICLE("jet")[i_j]);
	if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   PARTICLE(e)[" << i_l << "] = " << PARTICLE("e")[i_l].momentum << endl;}
	if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   PARTICLE(jet)[" << i_j << "] = " << PARTICLE("jet")[i_j].momentum << endl;}
	if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   R2_eta_ejet = " << R2_eta_ejet << " > " << cut_min_R2_ejet << endl;}
	if (R2_eta_ejet < cut_min_R2_ejet){
	  // R2_eta_ejet should only "unidentify" jets, cut not cut events !!!
	  if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   PARTICLE(jet)[" << i_j << "] = " << PARTICLE("jet")[i_j].momentum << " is removed due to R2_eta_ejet = " << R2_eta_ejet << " > " << cut_min_R2_ejet << endl;}
	  for (int j_j = 0; j_j < NUMBER("jet"); j_j++){
	    if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   before removal:  PARTICLE(jet)[" << j_j << "] = " << PARTICLE("jet")[j_j].momentum << endl;}
	  }
	  if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   before removal:  NUMBER(jet) = " << NUMBER("jet") << endl;}
	  PARTICLE("jet").erase(PARTICLE("jet").begin() + i_j);
	  NUMBER("jet")--;
	  i_j--;
	  for (int j_j = 0; j_j < NUMBER("jet"); j_j++){
	    if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   after removal:   PARTICLE(jet)[" << j_j << "] = " << PARTICLE("jet")[j_j].momentum << endl;}
	  }
	  if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   after removal:   NUMBER(jet) = " << NUMBER("jet") << endl;}
	  break;
	}
      }
    }
  }


  // cut on the modified number of jets (must be after modifying jet content, ie, after R_ejet cut!)
  if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]" << "   switch_n_jet_modified = " << switch_n_jet_modified << endl;}
  if (switch_n_jet_modified){
    //    if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   NUMBER(jet) = " << NUMBER("jet") << endl;}
    if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   " << cut_n_jet_min_modified << " <= n_jet_modified = " << NUMBER("jet") << " <= " << cut_n_jet_max_modified << endl;}
    if (NUMBER("jet") < cut_n_jet_min_modified || NUMBER("jet") > cut_n_jet_max_modified){
      cut_ps[i_a] = -1;
      if (switch_output_cutinfo){
	info_cut << "[" << setw(2) << i_a << "]" << "   individual cut after n_jet_modified" << endl; 
	logger << LOG_DEBUG << endl << info_cut.str(); 
      }
      logger << LOG_DEBUG_VERBOSE << " cut applied" << endl; 
      return;
    }
  }


  // lepton-lepton + neutrino-neutrino invariant-mass cut
  if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]" << "   switch_cut_M_4lep = " << switch_cut_M_4lep << endl;}
  if (switch_cut_M_4lep){
    double M2_4lep = (PARTICLE("lep")[0].momentum + PARTICLE("lep")[1].momentum + PARTICLE("nua")[0].momentum + PARTICLE("nua")[1].momentum).m2();
    if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   PARTICLE(lep)[0] = " << PARTICLE("lep")[0].momentum << endl;}
    if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   PARTICLE(lep)[1] = " << PARTICLE("lep")[1].momentum << endl;}
    if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   PARTICLE(nua)[0] = " << PARTICLE("nua")[0].momentum << endl;}
    if (switch_output_cutinfo){info_cut << "[" << setw(2) << i_a << "]   PARTICLE(nua)[1] = " << PARTICLE("nua")[1].momentum << endl;}
    if (switch_output_cutinfo){if (cut_min_M_4lep != 0.){info_cut << "[" << setw(2) << i_a << "]   M2_4lep = " << M2_4lep << " > " << cut_min_M2_4lep << endl;}}
    if (switch_output_cutinfo){if (cut_max_M_4lep != 0.){info_cut << "[" << setw(2) << i_a << "]   M2_4lep = " << M2_4lep << " < " << cut_max_M2_4lep << endl;}}
    if (switch_output_cutinfo){if (cut_min_deltaZ_M_4lep != 0.){info_cut << "[" << setw(2) << i_a << "]   |M_4lep - M_Z| = " << abs(sqrt(M2_4lep) - msi->M_Z) << " > " << cut_min_deltaZ_M_4lep << endl;}}
    if (switch_output_cutinfo){if (cut_max_deltaZ_M_4lep != 0.){info_cut << "[" << setw(2) << i_a << "]   |M_4lep - M_Z| = " << abs(sqrt(M2_4lep) - msi->M_Z) << " < " << cut_max_deltaZ_M_4lep << endl;}}

    if (cut_min_M2_4lep != 0 && M2_4lep < cut_min_M2_4lep){
      cut_ps[i_a] = -1; 
      if (switch_output_cutinfo){
	info_cut << "[" << setw(2) << i_a << "]" << "   individual cut after cut_min_M_4lep" << endl; 
	logger << LOG_DEBUG << endl << info_cut.str(); 
      }
      logger << LOG_DEBUG_VERBOSE << "cut_M_leplep min cut applied" << endl; 
      return;
    }

    if (cut_max_M2_4lep != 0 && M2_4lep > cut_max_M2_4lep){
      cut_ps[i_a] = -1; 
      if (switch_output_cutinfo){
	info_cut << "[" << setw(2) << i_a << "]" << "   individual cut after cut_max_M_4lep" << endl; 
	logger << LOG_DEBUG << endl << info_cut.str(); 
      }
      logger << LOG_DEBUG_VERBOSE << "cut_M_leplep max cut applied" << endl; 
      return;
    }

    if (cut_min_deltaZ_M_4lep != 0.){
      if (abs(sqrt(M2_4lep) - msi->M_Z) < cut_min_deltaZ_M_4lep){
	cut_ps[i_a] = -1; 
	if (switch_output_cutinfo){
	  info_cut << "[" << setw(2) << i_a << "]" << "   ppemxnmnex04-cut after cut_min_deltaZ_M_4lep" << endl; 
	  logger << LOG_DEBUG << endl << info_cut.str(); 
	}
	logger << LOG_DEBUG_VERBOSE << "cut_M_leplep delta cut applied" << endl; 
	return;
      }
    }

    if (cut_max_deltaZ_M_4lep != 0.){
      if (abs(sqrt(M2_4lep) - msi->M_Z) > cut_max_deltaZ_M_4lep){
	cut_ps[i_a] = -1; 
	if (switch_output_cutinfo){
	  info_cut << "[" << setw(2) << i_a << "]" << "   ppemxnmnex04-cut after cut_max_deltaZ_M_4lep" << endl; 
	  logger << LOG_DEBUG << endl << info_cut.str(); 
	}
	logger << LOG_DEBUG_VERBOSE << "cut_M_leplep delta cut applied" << endl; 
	return;
      }
    }
  }

  // cut on axial ETmiss
  if (switch_axial_ETmiss == 1){
    
    double ET_miss = PARTICLE("missing")[0].pT;
    double phi_miss = PARTICLE("missing")[0].phi;
    double phi_Z    = (PARTICLE("lep")[0].momentum+PARTICLE("lep")[1].momentum).phi();
    double temp_dphi = abs(phi_miss - phi_Z);
    if (temp_dphi > pi){temp_dphi = f2pi - temp_dphi;}
    double axial_ETmiss = - ET_miss * cos(temp_dphi);
    if (axial_ETmiss < cut_min_axial_ETmiss){
      cut_ps[i_a] = -1; 
    }
  }

  // cut on pT balance betwen Z bosons
  if (switch_pT_balance_Zs == 1){
    double pT_miss = PARTICLE("missing")[0].pT;
    double pT_Z    = (PARTICLE("lep")[0].momentum+PARTICLE("lep")[1].momentum).pT();
    double pT_balance_Zs = abs(pT_miss-pT_Z)/pT_Z;
    if (pT_balance_Zs > cut_max_pT_balance_Zs){
      cut_ps[i_a] = -1; 
    }
  }

  if (switch_output_cutinfo){info_cut << "ppemxnmnex04_cuts passed" << endl;}
}
