#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

ppexnea03_phasespace_set::~ppexnea03_phasespace_set(){
  static Logger logger("ppexnea03_phasespace_set::~ppexnea03_phasespace_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;


  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::optimize_minv_born(){
  static Logger logger("ppexnea03_phasespace_set::optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppexnea03_phasespace_set::determination_MCchannels_born(int x_a){
  static Logger logger("ppexnea03_phasespace_set::determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 4;}
    else if (csi->no_process_parton[x_a] == 1){n_channel = 4;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ac_tau_psp_born(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppexnea03_phasespace_set::ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){tau_MC_map = vector<int> {  0, -24};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ax_psp_born(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){ax_psp_030_udx_epvea(x_a);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ac_psp_born(int x_a, int channel){
  static Logger logger("ppexnea03_phasespace_set::ac_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){ac_psp_030_udx_epvea(x_a, channel);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ag_psp_born(int x_a, int zero){
  static Logger logger("ppexnea03_phasespace_set::ag_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){ag_psp_030_udx_epvea(x_a, zero);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::optimize_minv_real(){
  static Logger logger("ppexnea03_phasespace_set::optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppexnea03_phasespace_set::determination_MCchannels_real(int x_a){
  static Logger logger("ppexnea03_phasespace_set::determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 16;}
    else if (csi->no_process_parton[x_a] == 1){n_channel = 10;}
    else if (csi->no_process_parton[x_a] == 2){n_channel = 10;}
    else if (csi->no_process_parton[x_a] == 3){n_channel = 10;}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 36;}
    else if (csi->no_process_parton[x_a] == 4){n_channel = 20;}
    else if (csi->no_process_parton[x_a] == 5){n_channel = 20;}
    else if (csi->no_process_parton[x_a] == 6){n_channel = 20;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ac_tau_psp_real(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppexnea03_phasespace_set::ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 3){tau_MC_map = vector<int> {  0};}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 4){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 5){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 6){tau_MC_map = vector<int> {  0, -24};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ax_psp_real(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){ax_psp_130_gu_epvead(x_a);}
    else if (csi->no_process_parton[x_a] == 2){ax_psp_130_gdx_epveaux(x_a);}
    else if (csi->no_process_parton[x_a] == 3){ax_psp_130_udx_epveag(x_a);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 4){ax_psp_040_ua_epvead(x_a);}
    else if (csi->no_process_parton[x_a] == 5){ax_psp_040_dxa_epveaux(x_a);}
    else if (csi->no_process_parton[x_a] == 6){ax_psp_040_udx_epveaa(x_a);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ac_psp_real(int x_a, int channel){
  static Logger logger("ppexnea03_phasespace_set::ac_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){ac_psp_130_gu_epvead(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 2){ac_psp_130_gdx_epveaux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 3){ac_psp_130_udx_epveag(x_a, channel);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 4){ac_psp_040_ua_epvead(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 5){ac_psp_040_dxa_epveaux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 6){ac_psp_040_udx_epveaa(x_a, channel);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ag_psp_real(int x_a, int zero){
  static Logger logger("ppexnea03_phasespace_set::ag_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){ag_psp_130_gu_epvead(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 2){ag_psp_130_gdx_epveaux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 3){ag_psp_130_udx_epveag(x_a, zero);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 4){ag_psp_040_ua_epvead(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 5){ag_psp_040_dxa_epveaux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 6){ag_psp_040_udx_epveaa(x_a, zero);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::optimize_minv_doublereal(){
  static Logger logger("ppexnea03_phasespace_set::optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppexnea03_phasespace_set::determination_MCchannels_doublereal(int x_a){
  static Logger logger("ppexnea03_phasespace_set::determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] ==  0){n_channel = 116;}
    else if (csi->no_process_parton[x_a] ==  1){n_channel = 46;}
    else if (csi->no_process_parton[x_a] ==  2){n_channel = 46;}
    else if (csi->no_process_parton[x_a] ==  3){n_channel = 46;}
    else if (csi->no_process_parton[x_a] ==  5){n_channel = 28;}
    else if (csi->no_process_parton[x_a] ==  6){n_channel = 14;}
    else if (csi->no_process_parton[x_a] ==  7){n_channel = 28;}
    else if (csi->no_process_parton[x_a] ==  8){n_channel = 14;}
    else if (csi->no_process_parton[x_a] ==  9){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 10){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 11){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 12){n_channel = 46;}
    else if (csi->no_process_parton[x_a] == 13){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 14){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 15){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 16){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 17){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 18){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 19){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 20){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 21){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 23){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 24){n_channel = 28;}
    else if (csi->no_process_parton[x_a] == 25){n_channel = 14;}
    else if (csi->no_process_parton[x_a] == 26){n_channel = 14;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppexnea03_phasespace_set::ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  3){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  5){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  6){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  7){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  8){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  9){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 10){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 11){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 12){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 13){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 14){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 15){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 16){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 17){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 18){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 19){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 20){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 21){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 23){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 24){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 25){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 26){tau_MC_map = vector<int> {  0};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ax_psp_doublereal(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){ax_psp_230_gg_epveadux(x_a);}
    else if (csi->no_process_parton[x_a] ==  2){ax_psp_230_gu_epveagd(x_a);}
    else if (csi->no_process_parton[x_a] ==  3){ax_psp_230_gdx_epveagux(x_a);}
    else if (csi->no_process_parton[x_a] ==  5){ax_psp_230_du_epveadd(x_a);}
    else if (csi->no_process_parton[x_a] ==  6){ax_psp_230_dc_epveads(x_a);}
    else if (csi->no_process_parton[x_a] ==  7){ax_psp_230_ddx_epveadux(x_a);}
    else if (csi->no_process_parton[x_a] ==  8){ax_psp_230_ddx_epveascx(x_a);}
    else if (csi->no_process_parton[x_a] ==  9){ax_psp_230_dsx_epveadcx(x_a);}
    else if (csi->no_process_parton[x_a] == 10){ax_psp_230_uu_epveadu(x_a);}
    else if (csi->no_process_parton[x_a] == 11){ax_psp_230_uc_epveadc(x_a);}
    else if (csi->no_process_parton[x_a] == 12){ax_psp_230_udx_epveagg(x_a);}
    else if (csi->no_process_parton[x_a] == 13){ax_psp_230_udx_epveaddx(x_a);}
    else if (csi->no_process_parton[x_a] == 14){ax_psp_230_udx_epveauux(x_a);}
    else if (csi->no_process_parton[x_a] == 15){ax_psp_230_udx_epveassx(x_a);}
    else if (csi->no_process_parton[x_a] == 16){ax_psp_230_udx_epveaccx(x_a);}
    else if (csi->no_process_parton[x_a] == 17){ax_psp_230_uux_epveadux(x_a);}
    else if (csi->no_process_parton[x_a] == 18){ax_psp_230_uux_epveascx(x_a);}
    else if (csi->no_process_parton[x_a] == 19){ax_psp_230_usx_epveadsx(x_a);}
    else if (csi->no_process_parton[x_a] == 20){ax_psp_230_usx_epveaucx(x_a);}
    else if (csi->no_process_parton[x_a] == 21){ax_psp_230_ucx_epveadcx(x_a);}
    else if (csi->no_process_parton[x_a] == 23){ax_psp_230_dxdx_epveadxux(x_a);}
    else if (csi->no_process_parton[x_a] == 24){ax_psp_230_dxux_epveauxux(x_a);}
    else if (csi->no_process_parton[x_a] == 25){ax_psp_230_dxsx_epveadxcx(x_a);}
    else if (csi->no_process_parton[x_a] == 26){ax_psp_230_dxcx_epveauxcx(x_a);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ac_psp_doublereal(int x_a, int channel){
  static Logger logger("ppexnea03_phasespace_set::ac_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){ac_psp_230_gg_epveadux(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  2){ac_psp_230_gu_epveagd(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  3){ac_psp_230_gdx_epveagux(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  5){ac_psp_230_du_epveadd(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  6){ac_psp_230_dc_epveads(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  7){ac_psp_230_ddx_epveadux(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  8){ac_psp_230_ddx_epveascx(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  9){ac_psp_230_dsx_epveadcx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 10){ac_psp_230_uu_epveadu(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 11){ac_psp_230_uc_epveadc(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 12){ac_psp_230_udx_epveagg(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 13){ac_psp_230_udx_epveaddx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 14){ac_psp_230_udx_epveauux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 15){ac_psp_230_udx_epveassx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 16){ac_psp_230_udx_epveaccx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 17){ac_psp_230_uux_epveadux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 18){ac_psp_230_uux_epveascx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 19){ac_psp_230_usx_epveadsx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 20){ac_psp_230_usx_epveaucx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 21){ac_psp_230_ucx_epveadcx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 23){ac_psp_230_dxdx_epveadxux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 24){ac_psp_230_dxux_epveauxux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 25){ac_psp_230_dxsx_epveadxcx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 26){ac_psp_230_dxcx_epveauxcx(x_a, channel);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppexnea03_phasespace_set::ag_psp_doublereal(int x_a, int zero){
  static Logger logger("ppexnea03_phasespace_set::ag_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){ag_psp_230_gg_epveadux(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  2){ag_psp_230_gu_epveagd(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  3){ag_psp_230_gdx_epveagux(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  5){ag_psp_230_du_epveadd(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  6){ag_psp_230_dc_epveads(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  7){ag_psp_230_ddx_epveadux(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  8){ag_psp_230_ddx_epveascx(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  9){ag_psp_230_dsx_epveadcx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 10){ag_psp_230_uu_epveadu(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 11){ag_psp_230_uc_epveadc(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 12){ag_psp_230_udx_epveagg(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 13){ag_psp_230_udx_epveaddx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 14){ag_psp_230_udx_epveauux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 15){ag_psp_230_udx_epveassx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 16){ag_psp_230_udx_epveaccx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 17){ag_psp_230_uux_epveadux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 18){ag_psp_230_uux_epveascx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 19){ag_psp_230_usx_epveadsx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 20){ag_psp_230_usx_epveaucx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 21){ag_psp_230_ucx_epveadcx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 23){ag_psp_230_dxdx_epveadxux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 24){ag_psp_230_dxux_epveauxux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 25){ag_psp_230_dxsx_epveadxcx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 26){ag_psp_230_dxcx_epveauxcx(x_a, zero);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
