#include "header.hpp"

#include "ppttx20.contribution.set.hpp"

ppttx20_contribution_set::~ppttx20_contribution_set(){
  static Logger logger("ppttx20_contribution_set::~ppttx20_contribution_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;


  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_contribution_set::determination_subprocess_born(int i_a){
  static Logger logger("ppttx20_contribution_set::determination_subprocess_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  const vector<int> tp = basic_type_parton[i_a];

  no_process_parton[i_a] = -1;
  vector<int> out(5);
  for (int i = 0; i < 2; i++){
    if (i == 0){out[1] = 1; out[2] = 2;}
    if (i == 1){out[1] = 2; out[2] = 1;}
    for (int o = 0; o < 1; o++){
      if (o == 0){}
      if (phasespace_order_alpha_s[i_a] == 2 && phasespace_order_alpha_e[i_a] == 0 && phasespace_order_interference[i_a] == 0){
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==   6) && (tp[4] ==  -6)){no_process_parton[i_a] = 1; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6)){no_process_parton[i_a] = 2; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6)){no_process_parton[i_a] = 2; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6)){no_process_parton[i_a] = 3; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6)){no_process_parton[i_a] = 3; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6)){no_process_parton[i_a] = 4; break;}
      }
    }
    if (no_process_parton[i_a] != -1){break;}
  }
  for (int o = 0; o < out.size(); o++){
    if (out[o] == 0){swap_parton[i_a][o] = o;}
    else {swap_parton[i_a][o] = out[o];}
  }
  if (phasespace_order_alpha_s[i_a] == 2 && phasespace_order_alpha_e[i_a] == 0 && phasespace_order_interference[i_a] == 0){
    if (no_process_parton[i_a] == 0){}
    else if (no_process_parton[i_a] == 1){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 2){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 3){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 4){symmetry_id_factor[i_a] = 1;}
    symmetry_factor = symmetry_id_factor[i_a];
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_contribution_set::combination_subprocess_born(int i_a){
  static Logger logger("ppttx20_contribution_set::combination_subprocess_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (phasespace_order_alpha_s[i_a] == 2 && phasespace_order_alpha_e[i_a] == 0 && phasespace_order_interference[i_a] == 0){
    if (no_process_parton[i_a] == 0){}
    else if (no_process_parton[i_a] == 1){
      combination_pdf.resize(1);
      combination_pdf[0] = { 1,   0,   0};   // g   g    -> t   tx   //
    }
    else if (no_process_parton[i_a] == 2){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -1};   // d   dx   -> t   tx   //
      combination_pdf[1] = { 1,   3,  -3};   // s   sx   -> t   tx   //
      combination_pdf[2] = {-1,   1,  -1};   // dx  d    -> t   tx   //
      combination_pdf[3] = {-1,   3,  -3};   // sx  s    -> t   tx   //
    }
    else if (no_process_parton[i_a] == 3){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -2};   // u   ux   -> t   tx   //
      combination_pdf[1] = { 1,   4,  -4};   // c   cx   -> t   tx   //
      combination_pdf[2] = {-1,   2,  -2};   // ux  u    -> t   tx   //
      combination_pdf[3] = {-1,   4,  -4};   // cx  c    -> t   tx   //
    }
    else if (no_process_parton[i_a] == 4){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   5,  -5};   // b   bx   -> t   tx   //
      combination_pdf[1] = {-1,   5,  -5};   // bx  b    -> t   tx   //
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_contribution_set::determination_subprocess_real(int i_a){
  static Logger logger("ppttx20_contribution_set::determination_subprocess_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  const vector<int> tp = basic_type_parton[i_a];

  no_process_parton[i_a] = -1;
  vector<int> out(6);
  for (int i = 0; i < 2; i++){
    if (i == 0){out[1] = 1; out[2] = 2;}
    if (i == 1){out[1] = 2; out[2] = 1;}
    for (int o = 0; o < 1; o++){
      if (o == 0){out[5] = 5;}
      if (phasespace_order_alpha_s[i_a] == 3 && phasespace_order_alpha_e[i_a] == 0 && phasespace_order_interference[i_a] == 0){
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0)){no_process_parton[i_a] = 1; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1)){no_process_parton[i_a] = 2; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3)){no_process_parton[i_a] = 2; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2)){no_process_parton[i_a] = 3; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4)){no_process_parton[i_a] = 3; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5)){no_process_parton[i_a] = 4; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -1)){no_process_parton[i_a] = 5; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -3)){no_process_parton[i_a] = 5; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -2)){no_process_parton[i_a] = 6; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -4)){no_process_parton[i_a] = 6; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -5)){no_process_parton[i_a] = 7; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0)){no_process_parton[i_a] = 8; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0)){no_process_parton[i_a] = 8; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0)){no_process_parton[i_a] = 9; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0)){no_process_parton[i_a] = 9; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0)){no_process_parton[i_a] = 10; break;}
      }
    }
    if (no_process_parton[i_a] != -1){break;}
  }
  for (int o = 0; o < out.size(); o++){
    if (out[o] == 0){swap_parton[i_a][o] = o;}
    else {swap_parton[i_a][o] = out[o];}
  }
  if (phasespace_order_alpha_s[i_a] == 3 && phasespace_order_alpha_e[i_a] == 0 && phasespace_order_interference[i_a] == 0){
    if (no_process_parton[i_a] == 0){}
    else if (no_process_parton[i_a] == 1){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 2){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 3){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 4){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 5){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 6){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 7){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 8){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 9){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 10){symmetry_id_factor[i_a] = 1;}
    symmetry_factor = symmetry_id_factor[i_a];
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_contribution_set::combination_subprocess_real(int i_a){
  static Logger logger("ppttx20_contribution_set::combination_subprocess_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (phasespace_order_alpha_s[i_a] == 3 && phasespace_order_alpha_e[i_a] == 0 && phasespace_order_interference[i_a] == 0){
    if (no_process_parton[i_a] == 0){}
    else if (no_process_parton[i_a] == 1){
      combination_pdf.resize(1);
      combination_pdf[0] = { 1,   0,   0};   // g   g    -> t   tx  g    //
    }
    else if (no_process_parton[i_a] == 2){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   0,   1};   // g   d    -> t   tx  d    //
      combination_pdf[1] = { 1,   0,   3};   // g   s    -> t   tx  s    //
      combination_pdf[2] = {-1,   0,   1};   // d   g    -> t   tx  d    //
      combination_pdf[3] = {-1,   0,   3};   // s   g    -> t   tx  s    //
    }
    else if (no_process_parton[i_a] == 3){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   0,   2};   // g   u    -> t   tx  u    //
      combination_pdf[1] = { 1,   0,   4};   // g   c    -> t   tx  c    //
      combination_pdf[2] = {-1,   0,   2};   // u   g    -> t   tx  u    //
      combination_pdf[3] = {-1,   0,   4};   // c   g    -> t   tx  c    //
    }
    else if (no_process_parton[i_a] == 4){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   0,   5};   // g   b    -> t   tx  b    //
      combination_pdf[1] = {-1,   0,   5};   // b   g    -> t   tx  b    //
    }
    else if (no_process_parton[i_a] == 5){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   0,  -1};   // g   dx   -> t   tx  dx   //
      combination_pdf[1] = { 1,   0,  -3};   // g   sx   -> t   tx  sx   //
      combination_pdf[2] = {-1,   0,  -1};   // dx  g    -> t   tx  dx   //
      combination_pdf[3] = {-1,   0,  -3};   // sx  g    -> t   tx  sx   //
    }
    else if (no_process_parton[i_a] == 6){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   0,  -2};   // g   ux   -> t   tx  ux   //
      combination_pdf[1] = { 1,   0,  -4};   // g   cx   -> t   tx  cx   //
      combination_pdf[2] = {-1,   0,  -2};   // ux  g    -> t   tx  ux   //
      combination_pdf[3] = {-1,   0,  -4};   // cx  g    -> t   tx  cx   //
    }
    else if (no_process_parton[i_a] == 7){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   0,  -5};   // g   bx   -> t   tx  bx   //
      combination_pdf[1] = {-1,   0,  -5};   // bx  g    -> t   tx  bx   //
    }
    else if (no_process_parton[i_a] == 8){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -1};   // d   dx   -> t   tx  g    //
      combination_pdf[1] = { 1,   3,  -3};   // s   sx   -> t   tx  g    //
      combination_pdf[2] = {-1,   1,  -1};   // dx  d    -> t   tx  g    //
      combination_pdf[3] = {-1,   3,  -3};   // sx  s    -> t   tx  g    //
    }
    else if (no_process_parton[i_a] == 9){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -2};   // u   ux   -> t   tx  g    //
      combination_pdf[1] = { 1,   4,  -4};   // c   cx   -> t   tx  g    //
      combination_pdf[2] = {-1,   2,  -2};   // ux  u    -> t   tx  g    //
      combination_pdf[3] = {-1,   4,  -4};   // cx  c    -> t   tx  g    //
    }
    else if (no_process_parton[i_a] == 10){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   5,  -5};   // b   bx   -> t   tx  g    //
      combination_pdf[1] = {-1,   5,  -5};   // bx  b    -> t   tx  g    //
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_contribution_set::determination_subprocess_doublereal(int i_a){
  static Logger logger("ppttx20_contribution_set::determination_subprocess_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  const vector<int> tp = basic_type_parton[i_a];

  no_process_parton[i_a] = -1;
  vector<int> out(7);
  for (int i = 0; i < 2; i++){
    if (i == 0){out[1] = 1; out[2] = 2;}
    if (i == 1){out[1] = 2; out[2] = 1;}
    for (int o = 0; o < 2; o++){
      if (o == 0){out[5] = 5; out[6] = 6;}
      if (o == 1){out[5] = 6; out[6] = 5;}
      if (phasespace_order_alpha_s[i_a] == 4 && phasespace_order_alpha_e[i_a] == 0 && phasespace_order_interference[i_a] == 0){
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   0)){no_process_parton[i_a] = 1; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 2; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 2; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 3; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 3; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 4; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   1)){no_process_parton[i_a] = 5; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   3)){no_process_parton[i_a] = 5; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   2)){no_process_parton[i_a] = 6; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   4)){no_process_parton[i_a] = 6; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==   5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   5)){no_process_parton[i_a] = 7; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 8; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 8; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 9; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 9; break;}
        if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 10; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==   1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==   1)){no_process_parton[i_a] = 11; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==   3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==   3)){no_process_parton[i_a] = 11; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==   2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==   2)){no_process_parton[i_a] = 12; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==   4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==   4)){no_process_parton[i_a] = 12; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==   3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==   3)){no_process_parton[i_a] = 13; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==   1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==   1)){no_process_parton[i_a] = 13; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==   4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==   4)){no_process_parton[i_a] = 14; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==   2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==   2)){no_process_parton[i_a] = 14; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==   5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==   5)){no_process_parton[i_a] = 16; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==   5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==   5)){no_process_parton[i_a] = 16; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   0)){no_process_parton[i_a] = 17; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   0)){no_process_parton[i_a] = 17; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 18; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 18; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 19; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 19; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 20; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 20; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 21; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 21; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 22; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 22; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 23; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 23; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 25; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 25; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 27; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 27; break;}
        if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 28; break;}
        if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 28; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==   2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==   2)){no_process_parton[i_a] = 29; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==   4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==   4)){no_process_parton[i_a] = 29; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==   4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==   4)){no_process_parton[i_a] = 30; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==   2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==   2)){no_process_parton[i_a] = 30; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==   5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==   5)){no_process_parton[i_a] = 31; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==   5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==   5)){no_process_parton[i_a] = 31; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 32; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 32; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   0)){no_process_parton[i_a] = 34; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   0)){no_process_parton[i_a] = 34; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 35; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 35; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 36; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 36; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 37; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 37; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 38; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 38; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 39; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 39; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 40; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 40; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 42; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 42; break;}
        if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 43; break;}
        if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 43; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==   5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==   5)){no_process_parton[i_a] = 44; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 45; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 45; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 46; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 46; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   0) && (tp[out[6]] ==   0)){no_process_parton[i_a] = 47; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   1) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 48; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   3) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 48; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   2) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 49; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   4) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 49; break;}
        if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==   5) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 50; break;}
        if ((tp[out[1]] ==  -1) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -1) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 51; break;}
        if ((tp[out[1]] ==  -3) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -3) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 51; break;}
        if ((tp[out[1]] ==  -1) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -1) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 52; break;}
        if ((tp[out[1]] ==  -3) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -3) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 52; break;}
        if ((tp[out[1]] ==  -1) && (tp[out[2]] ==  -3) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -1) && (tp[out[6]] ==  -3)){no_process_parton[i_a] = 53; break;}
        if ((tp[out[1]] ==  -3) && (tp[out[2]] ==  -1) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -3) && (tp[out[6]] ==  -1)){no_process_parton[i_a] = 53; break;}
        if ((tp[out[1]] ==  -1) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -1) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 54; break;}
        if ((tp[out[1]] ==  -3) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -3) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 54; break;}
        if ((tp[out[1]] ==  -1) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -1) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 56; break;}
        if ((tp[out[1]] ==  -3) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -3) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 56; break;}
        if ((tp[out[1]] ==  -2) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -2) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 57; break;}
        if ((tp[out[1]] ==  -4) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -4) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 57; break;}
        if ((tp[out[1]] ==  -2) && (tp[out[2]] ==  -4) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -2) && (tp[out[6]] ==  -4)){no_process_parton[i_a] = 58; break;}
        if ((tp[out[1]] ==  -4) && (tp[out[2]] ==  -2) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -4) && (tp[out[6]] ==  -2)){no_process_parton[i_a] = 58; break;}
        if ((tp[out[1]] ==  -2) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -2) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 59; break;}
        if ((tp[out[1]] ==  -4) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -4) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 59; break;}
        if ((tp[out[1]] ==  -5) && (tp[out[2]] ==  -5) && (tp[3] ==   6) && (tp[4] ==  -6) && (tp[out[5]] ==  -5) && (tp[out[6]] ==  -5)){no_process_parton[i_a] = 60; break;}
      }
    }
    if (no_process_parton[i_a] != -1){break;}
  }
  for (int o = 0; o < out.size(); o++){
    if (out[o] == 0){swap_parton[i_a][o] = o;}
    else {swap_parton[i_a][o] = out[o];}
  }
  if (phasespace_order_alpha_s[i_a] == 4 && phasespace_order_alpha_e[i_a] == 0 && phasespace_order_interference[i_a] == 0){
    if (no_process_parton[i_a] == 0){}
    else if (no_process_parton[i_a] == 1){symmetry_id_factor[i_a] = 2;}
    else if (no_process_parton[i_a] == 2){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 3){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 4){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 5){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 6){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 7){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 8){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 9){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 10){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 11){symmetry_id_factor[i_a] = 2;}
    else if (no_process_parton[i_a] == 12){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 13){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 14){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 16){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 17){symmetry_id_factor[i_a] = 2;}
    else if (no_process_parton[i_a] == 18){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 19){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 20){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 21){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 22){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 23){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 25){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 27){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 28){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 29){symmetry_id_factor[i_a] = 2;}
    else if (no_process_parton[i_a] == 30){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 31){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 32){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 34){symmetry_id_factor[i_a] = 2;}
    else if (no_process_parton[i_a] == 35){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 36){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 37){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 38){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 39){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 40){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 42){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 43){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 44){symmetry_id_factor[i_a] = 2;}
    else if (no_process_parton[i_a] == 45){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 46){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 47){symmetry_id_factor[i_a] = 2;}
    else if (no_process_parton[i_a] == 48){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 49){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 50){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 51){symmetry_id_factor[i_a] = 2;}
    else if (no_process_parton[i_a] == 52){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 53){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 54){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 56){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 57){symmetry_id_factor[i_a] = 2;}
    else if (no_process_parton[i_a] == 58){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 59){symmetry_id_factor[i_a] = 1;}
    else if (no_process_parton[i_a] == 60){symmetry_id_factor[i_a] = 2;}
    symmetry_factor = symmetry_id_factor[i_a];
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppttx20_contribution_set::combination_subprocess_doublereal(int i_a){
  static Logger logger("ppttx20_contribution_set::combination_subprocess_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (phasespace_order_alpha_s[i_a] == 4 && phasespace_order_alpha_e[i_a] == 0 && phasespace_order_interference[i_a] == 0){
    if (no_process_parton[i_a] == 0){}
    else if (no_process_parton[i_a] == 1){
      combination_pdf.resize(1);
      combination_pdf[0] = { 1,   0,   0};   // g   g    -> t   tx  g   g    //
    }
    else if (no_process_parton[i_a] == 2){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   0,   0};   // g   g    -> t   tx  d   dx   //
      combination_pdf[1] = { 1,   0,   0};   // g   g    -> t   tx  s   sx   //
    }
    else if (no_process_parton[i_a] == 3){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   0,   0};   // g   g    -> t   tx  u   ux   //
      combination_pdf[1] = { 1,   0,   0};   // g   g    -> t   tx  c   cx   //
    }
    else if (no_process_parton[i_a] == 4){
      combination_pdf.resize(1);
      combination_pdf[0] = { 1,   0,   0};   // g   g    -> t   tx  b   bx   //
    }
    else if (no_process_parton[i_a] == 5){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   0,   1};   // g   d    -> t   tx  g   d    //
      combination_pdf[1] = { 1,   0,   3};   // g   s    -> t   tx  g   s    //
      combination_pdf[2] = {-1,   0,   1};   // d   g    -> t   tx  g   d    //
      combination_pdf[3] = {-1,   0,   3};   // s   g    -> t   tx  g   s    //
    }
    else if (no_process_parton[i_a] == 6){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   0,   2};   // g   u    -> t   tx  g   u    //
      combination_pdf[1] = { 1,   0,   4};   // g   c    -> t   tx  g   c    //
      combination_pdf[2] = {-1,   0,   2};   // u   g    -> t   tx  g   u    //
      combination_pdf[3] = {-1,   0,   4};   // c   g    -> t   tx  g   c    //
    }
    else if (no_process_parton[i_a] == 7){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   0,   5};   // g   b    -> t   tx  g   b    //
      combination_pdf[1] = {-1,   0,   5};   // b   g    -> t   tx  g   b    //
    }
    else if (no_process_parton[i_a] == 8){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   0,  -1};   // g   dx   -> t   tx  g   dx   //
      combination_pdf[1] = { 1,   0,  -3};   // g   sx   -> t   tx  g   sx   //
      combination_pdf[2] = {-1,   0,  -1};   // dx  g    -> t   tx  g   dx   //
      combination_pdf[3] = {-1,   0,  -3};   // sx  g    -> t   tx  g   sx   //
    }
    else if (no_process_parton[i_a] == 9){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   0,  -2};   // g   ux   -> t   tx  g   ux   //
      combination_pdf[1] = { 1,   0,  -4};   // g   cx   -> t   tx  g   cx   //
      combination_pdf[2] = {-1,   0,  -2};   // ux  g    -> t   tx  g   ux   //
      combination_pdf[3] = {-1,   0,  -4};   // cx  g    -> t   tx  g   cx   //
    }
    else if (no_process_parton[i_a] == 10){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   0,  -5};   // g   bx   -> t   tx  g   bx   //
      combination_pdf[1] = {-1,   0,  -5};   // bx  g    -> t   tx  g   bx   //
    }
    else if (no_process_parton[i_a] == 11){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   1,   1};   // d   d    -> t   tx  d   d    //
      combination_pdf[1] = { 1,   3,   3};   // s   s    -> t   tx  s   s    //
    }
    else if (no_process_parton[i_a] == 12){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,   2};   // d   u    -> t   tx  d   u    //
      combination_pdf[1] = { 1,   3,   4};   // s   c    -> t   tx  s   c    //
      combination_pdf[2] = {-1,   1,   2};   // u   d    -> t   tx  d   u    //
      combination_pdf[3] = {-1,   3,   4};   // c   s    -> t   tx  s   c    //
    }
    else if (no_process_parton[i_a] == 13){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   1,   3};   // d   s    -> t   tx  d   s    //
      combination_pdf[1] = { 1,   3,   1};   // s   d    -> t   tx  d   s    //
    }
    else if (no_process_parton[i_a] == 14){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,   4};   // d   c    -> t   tx  d   c    //
      combination_pdf[1] = { 1,   3,   2};   // s   u    -> t   tx  u   s    //
      combination_pdf[2] = {-1,   3,   2};   // u   s    -> t   tx  u   s    //
      combination_pdf[3] = {-1,   1,   4};   // c   d    -> t   tx  d   c    //
    }
    else if (no_process_parton[i_a] == 16){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,   5};   // d   b    -> t   tx  d   b    //
      combination_pdf[1] = { 1,   3,   5};   // s   b    -> t   tx  s   b    //
      combination_pdf[2] = {-1,   1,   5};   // b   d    -> t   tx  d   b    //
      combination_pdf[3] = {-1,   3,   5};   // b   s    -> t   tx  s   b    //
    }
    else if (no_process_parton[i_a] == 17){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -1};   // d   dx   -> t   tx  g   g    //
      combination_pdf[1] = { 1,   3,  -3};   // s   sx   -> t   tx  g   g    //
      combination_pdf[2] = {-1,   1,  -1};   // dx  d    -> t   tx  g   g    //
      combination_pdf[3] = {-1,   3,  -3};   // sx  s    -> t   tx  g   g    //
    }
    else if (no_process_parton[i_a] == 18){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -1};   // d   dx   -> t   tx  d   dx   //
      combination_pdf[1] = { 1,   3,  -3};   // s   sx   -> t   tx  s   sx   //
      combination_pdf[2] = {-1,   1,  -1};   // dx  d    -> t   tx  d   dx   //
      combination_pdf[3] = {-1,   3,  -3};   // sx  s    -> t   tx  s   sx   //
    }
    else if (no_process_parton[i_a] == 19){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -1};   // d   dx   -> t   tx  u   ux   //
      combination_pdf[1] = { 1,   3,  -3};   // s   sx   -> t   tx  c   cx   //
      combination_pdf[2] = {-1,   1,  -1};   // dx  d    -> t   tx  u   ux   //
      combination_pdf[3] = {-1,   3,  -3};   // sx  s    -> t   tx  c   cx   //
    }
    else if (no_process_parton[i_a] == 20){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -1};   // d   dx   -> t   tx  s   sx   //
      combination_pdf[1] = { 1,   3,  -3};   // s   sx   -> t   tx  d   dx   //
      combination_pdf[2] = {-1,   1,  -1};   // dx  d    -> t   tx  s   sx   //
      combination_pdf[3] = {-1,   3,  -3};   // sx  s    -> t   tx  d   dx   //
    }
    else if (no_process_parton[i_a] == 21){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -1};   // d   dx   -> t   tx  c   cx   //
      combination_pdf[1] = { 1,   3,  -3};   // s   sx   -> t   tx  u   ux   //
      combination_pdf[2] = {-1,   1,  -1};   // dx  d    -> t   tx  c   cx   //
      combination_pdf[3] = {-1,   3,  -3};   // sx  s    -> t   tx  u   ux   //
    }
    else if (no_process_parton[i_a] == 22){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -1};   // d   dx   -> t   tx  b   bx   //
      combination_pdf[1] = { 1,   3,  -3};   // s   sx   -> t   tx  b   bx   //
      combination_pdf[2] = {-1,   1,  -1};   // dx  d    -> t   tx  b   bx   //
      combination_pdf[3] = {-1,   3,  -3};   // sx  s    -> t   tx  b   bx   //
    }
    else if (no_process_parton[i_a] == 23){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -2};   // d   ux   -> t   tx  d   ux   //
      combination_pdf[1] = { 1,   3,  -4};   // s   cx   -> t   tx  s   cx   //
      combination_pdf[2] = {-1,   1,  -2};   // ux  d    -> t   tx  d   ux   //
      combination_pdf[3] = {-1,   3,  -4};   // cx  s    -> t   tx  s   cx   //
    }
    else if (no_process_parton[i_a] == 25){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -3};   // d   sx   -> t   tx  d   sx   //
      combination_pdf[1] = { 1,   3,  -1};   // s   dx   -> t   tx  s   dx   //
      combination_pdf[2] = {-1,   3,  -1};   // dx  s    -> t   tx  s   dx   //
      combination_pdf[3] = {-1,   1,  -3};   // sx  d    -> t   tx  d   sx   //
    }
    else if (no_process_parton[i_a] == 27){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -4};   // d   cx   -> t   tx  d   cx   //
      combination_pdf[1] = { 1,   3,  -2};   // s   ux   -> t   tx  s   ux   //
      combination_pdf[2] = {-1,   3,  -2};   // ux  s    -> t   tx  s   ux   //
      combination_pdf[3] = {-1,   1,  -4};   // cx  d    -> t   tx  d   cx   //
    }
    else if (no_process_parton[i_a] == 28){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   1,  -5};   // d   bx   -> t   tx  d   bx   //
      combination_pdf[1] = { 1,   3,  -5};   // s   bx   -> t   tx  s   bx   //
      combination_pdf[2] = {-1,   1,  -5};   // bx  d    -> t   tx  d   bx   //
      combination_pdf[3] = {-1,   3,  -5};   // bx  s    -> t   tx  s   bx   //
    }
    else if (no_process_parton[i_a] == 29){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   2,   2};   // u   u    -> t   tx  u   u    //
      combination_pdf[1] = { 1,   4,   4};   // c   c    -> t   tx  c   c    //
    }
    else if (no_process_parton[i_a] == 30){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   2,   4};   // u   c    -> t   tx  u   c    //
      combination_pdf[1] = { 1,   4,   2};   // c   u    -> t   tx  u   c    //
    }
    else if (no_process_parton[i_a] == 31){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,   5};   // u   b    -> t   tx  u   b    //
      combination_pdf[1] = { 1,   4,   5};   // c   b    -> t   tx  c   b    //
      combination_pdf[2] = {-1,   2,   5};   // b   u    -> t   tx  u   b    //
      combination_pdf[3] = {-1,   4,   5};   // b   c    -> t   tx  c   b    //
    }
    else if (no_process_parton[i_a] == 32){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -1};   // u   dx   -> t   tx  u   dx   //
      combination_pdf[1] = { 1,   4,  -3};   // c   sx   -> t   tx  c   sx   //
      combination_pdf[2] = {-1,   2,  -1};   // dx  u    -> t   tx  u   dx   //
      combination_pdf[3] = {-1,   4,  -3};   // sx  c    -> t   tx  c   sx   //
    }
    else if (no_process_parton[i_a] == 34){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -2};   // u   ux   -> t   tx  g   g    //
      combination_pdf[1] = { 1,   4,  -4};   // c   cx   -> t   tx  g   g    //
      combination_pdf[2] = {-1,   2,  -2};   // ux  u    -> t   tx  g   g    //
      combination_pdf[3] = {-1,   4,  -4};   // cx  c    -> t   tx  g   g    //
    }
    else if (no_process_parton[i_a] == 35){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -2};   // u   ux   -> t   tx  d   dx   //
      combination_pdf[1] = { 1,   4,  -4};   // c   cx   -> t   tx  s   sx   //
      combination_pdf[2] = {-1,   2,  -2};   // ux  u    -> t   tx  d   dx   //
      combination_pdf[3] = {-1,   4,  -4};   // cx  c    -> t   tx  s   sx   //
    }
    else if (no_process_parton[i_a] == 36){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -2};   // u   ux   -> t   tx  u   ux   //
      combination_pdf[1] = { 1,   4,  -4};   // c   cx   -> t   tx  c   cx   //
      combination_pdf[2] = {-1,   2,  -2};   // ux  u    -> t   tx  u   ux   //
      combination_pdf[3] = {-1,   4,  -4};   // cx  c    -> t   tx  c   cx   //
    }
    else if (no_process_parton[i_a] == 37){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -2};   // u   ux   -> t   tx  s   sx   //
      combination_pdf[1] = { 1,   4,  -4};   // c   cx   -> t   tx  d   dx   //
      combination_pdf[2] = {-1,   2,  -2};   // ux  u    -> t   tx  s   sx   //
      combination_pdf[3] = {-1,   4,  -4};   // cx  c    -> t   tx  d   dx   //
    }
    else if (no_process_parton[i_a] == 38){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -2};   // u   ux   -> t   tx  c   cx   //
      combination_pdf[1] = { 1,   4,  -4};   // c   cx   -> t   tx  u   ux   //
      combination_pdf[2] = {-1,   2,  -2};   // ux  u    -> t   tx  c   cx   //
      combination_pdf[3] = {-1,   4,  -4};   // cx  c    -> t   tx  u   ux   //
    }
    else if (no_process_parton[i_a] == 39){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -2};   // u   ux   -> t   tx  b   bx   //
      combination_pdf[1] = { 1,   4,  -4};   // c   cx   -> t   tx  b   bx   //
      combination_pdf[2] = {-1,   2,  -2};   // ux  u    -> t   tx  b   bx   //
      combination_pdf[3] = {-1,   4,  -4};   // cx  c    -> t   tx  b   bx   //
    }
    else if (no_process_parton[i_a] == 40){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -3};   // u   sx   -> t   tx  u   sx   //
      combination_pdf[1] = { 1,   4,  -1};   // c   dx   -> t   tx  c   dx   //
      combination_pdf[2] = {-1,   4,  -1};   // dx  c    -> t   tx  c   dx   //
      combination_pdf[3] = {-1,   2,  -3};   // sx  u    -> t   tx  u   sx   //
    }
    else if (no_process_parton[i_a] == 42){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -4};   // u   cx   -> t   tx  u   cx   //
      combination_pdf[1] = { 1,   4,  -2};   // c   ux   -> t   tx  c   ux   //
      combination_pdf[2] = {-1,   4,  -2};   // ux  c    -> t   tx  c   ux   //
      combination_pdf[3] = {-1,   2,  -4};   // cx  u    -> t   tx  u   cx   //
    }
    else if (no_process_parton[i_a] == 43){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   2,  -5};   // u   bx   -> t   tx  u   bx   //
      combination_pdf[1] = { 1,   4,  -5};   // c   bx   -> t   tx  c   bx   //
      combination_pdf[2] = {-1,   2,  -5};   // bx  u    -> t   tx  u   bx   //
      combination_pdf[3] = {-1,   4,  -5};   // bx  c    -> t   tx  c   bx   //
    }
    else if (no_process_parton[i_a] == 44){
      combination_pdf.resize(1);
      combination_pdf[0] = { 1,   5,   5};   // b   b    -> t   tx  b   b    //
    }
    else if (no_process_parton[i_a] == 45){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   5,  -1};   // b   dx   -> t   tx  b   dx   //
      combination_pdf[1] = { 1,   5,  -3};   // b   sx   -> t   tx  b   sx   //
      combination_pdf[2] = {-1,   5,  -1};   // dx  b    -> t   tx  b   dx   //
      combination_pdf[3] = {-1,   5,  -3};   // sx  b    -> t   tx  b   sx   //
    }
    else if (no_process_parton[i_a] == 46){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   5,  -2};   // b   ux   -> t   tx  b   ux   //
      combination_pdf[1] = { 1,   5,  -4};   // b   cx   -> t   tx  b   cx   //
      combination_pdf[2] = {-1,   5,  -2};   // ux  b    -> t   tx  b   ux   //
      combination_pdf[3] = {-1,   5,  -4};   // cx  b    -> t   tx  b   cx   //
    }
    else if (no_process_parton[i_a] == 47){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   5,  -5};   // b   bx   -> t   tx  g   g    //
      combination_pdf[1] = {-1,   5,  -5};   // bx  b    -> t   tx  g   g    //
    }
    else if (no_process_parton[i_a] == 48){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   5,  -5};   // b   bx   -> t   tx  d   dx   //
      combination_pdf[1] = { 1,   5,  -5};   // b   bx   -> t   tx  s   sx   //
      combination_pdf[2] = {-1,   5,  -5};   // bx  b    -> t   tx  d   dx   //
      combination_pdf[3] = {-1,   5,  -5};   // bx  b    -> t   tx  s   sx   //
    }
    else if (no_process_parton[i_a] == 49){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,   5,  -5};   // b   bx   -> t   tx  u   ux   //
      combination_pdf[1] = { 1,   5,  -5};   // b   bx   -> t   tx  c   cx   //
      combination_pdf[2] = {-1,   5,  -5};   // bx  b    -> t   tx  u   ux   //
      combination_pdf[3] = {-1,   5,  -5};   // bx  b    -> t   tx  c   cx   //
    }
    else if (no_process_parton[i_a] == 50){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,   5,  -5};   // b   bx   -> t   tx  b   bx   //
      combination_pdf[1] = {-1,   5,  -5};   // bx  b    -> t   tx  b   bx   //
    }
    else if (no_process_parton[i_a] == 51){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,  -1,  -1};   // dx  dx   -> t   tx  dx  dx   //
      combination_pdf[1] = { 1,  -3,  -3};   // sx  sx   -> t   tx  sx  sx   //
    }
    else if (no_process_parton[i_a] == 52){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,  -1,  -2};   // dx  ux   -> t   tx  dx  ux   //
      combination_pdf[1] = { 1,  -3,  -4};   // sx  cx   -> t   tx  sx  cx   //
      combination_pdf[2] = {-1,  -1,  -2};   // ux  dx   -> t   tx  dx  ux   //
      combination_pdf[3] = {-1,  -3,  -4};   // cx  sx   -> t   tx  sx  cx   //
    }
    else if (no_process_parton[i_a] == 53){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,  -1,  -3};   // dx  sx   -> t   tx  dx  sx   //
      combination_pdf[1] = { 1,  -3,  -1};   // sx  dx   -> t   tx  dx  sx   //
    }
    else if (no_process_parton[i_a] == 54){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,  -1,  -4};   // dx  cx   -> t   tx  dx  cx   //
      combination_pdf[1] = { 1,  -3,  -2};   // sx  ux   -> t   tx  ux  sx   //
      combination_pdf[2] = {-1,  -3,  -2};   // ux  sx   -> t   tx  ux  sx   //
      combination_pdf[3] = {-1,  -1,  -4};   // cx  dx   -> t   tx  dx  cx   //
    }
    else if (no_process_parton[i_a] == 56){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,  -1,  -5};   // dx  bx   -> t   tx  dx  bx   //
      combination_pdf[1] = { 1,  -3,  -5};   // sx  bx   -> t   tx  sx  bx   //
      combination_pdf[2] = {-1,  -1,  -5};   // bx  dx   -> t   tx  dx  bx   //
      combination_pdf[3] = {-1,  -3,  -5};   // bx  sx   -> t   tx  sx  bx   //
    }
    else if (no_process_parton[i_a] == 57){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,  -2,  -2};   // ux  ux   -> t   tx  ux  ux   //
      combination_pdf[1] = { 1,  -4,  -4};   // cx  cx   -> t   tx  cx  cx   //
    }
    else if (no_process_parton[i_a] == 58){
      combination_pdf.resize(2);
      combination_pdf[0] = { 1,  -2,  -4};   // ux  cx   -> t   tx  ux  cx   //
      combination_pdf[1] = { 1,  -4,  -2};   // cx  ux   -> t   tx  ux  cx   //
    }
    else if (no_process_parton[i_a] == 59){
      combination_pdf.resize(4);
      combination_pdf[0] = { 1,  -2,  -5};   // ux  bx   -> t   tx  ux  bx   //
      combination_pdf[1] = { 1,  -4,  -5};   // cx  bx   -> t   tx  cx  bx   //
      combination_pdf[2] = {-1,  -2,  -5};   // bx  ux   -> t   tx  ux  bx   //
      combination_pdf[3] = {-1,  -4,  -5};   // bx  cx   -> t   tx  cx  bx   //
    }
    else if (no_process_parton[i_a] == 60){
      combination_pdf.resize(1);
      combination_pdf[0] = { 1,  -5,  -5};   // bx  bx   -> t   tx  bx  bx   //
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
