{
  static int switch_cut_M_ttx = USERSWITCH("M_ttx");
  static double cut_min_M_ttx = USERCUT("min_M_ttx");
  static double cut_min_M2_ttx = pow(cut_min_M_ttx, 2);
  static double cut_max_M_ttx = USERCUT("max_M_ttx");
  static double cut_max_M2_ttx = pow(cut_max_M_ttx, 2);

  static int switch_cut_dphi_ttx = USERSWITCH("dphi_ttx");
  static double cut_min_dphi_ttx = USERCUT("min_dphi_ttx");
  static double cut_max_dphi_ttx = USERCUT("max_dphi_ttx");

  static int switch_cut_pT_top_1st = USERSWITCH("pT_top_1st");
  static double cut_min_pT_top_1st = USERCUT("min_pT_top_1st");

  static int switch_cut_pT_top_2nd = USERSWITCH("pT_top_2nd");
  static double cut_min_pT_top_2nd = USERCUT("min_pT_top_2nd");

  logger << LOG_DEBUG_VERBOSE << "USERSWITCH(M_ttx) = " << USERSWITCH("M_ttx") << endl;
  logger << LOG_DEBUG_VERBOSE << "USERCUT(max_M_ttx) = " << USERCUT("max_M_ttx") << endl;
  logger << LOG_DEBUG_VERBOSE << "USERCUT(min_M_ttx) = " << USERCUT("min_M_ttx") << endl;
  logger << LOG_DEBUG_VERBOSE << "USERSWITCH(dphi_ttx) = " << USERSWITCH("dphi_ttx") << endl;
  logger << LOG_DEBUG_VERBOSE << "USERCUT(min_dphi_ttx) = " << USERCUT("min_dphi_ttx") << endl;
  logger << LOG_DEBUG_VERBOSE << "USERCUT(max_dphi_ttx) = " << USERCUT("max_dphi_ttx") << endl;
  logger << LOG_DEBUG_VERBOSE << "USERSWITCH(pT_top_1st) = " << USERSWITCH("pT_top_1st") << endl;
  logger << LOG_DEBUG_VERBOSE << "USERCUT(min_pT_top_1st) = " << USERCUT("min_pT_top_1st") << endl;
  logger << LOG_DEBUG_VERBOSE << "USERSWITCH(pT_top_2nd) = " << USERSWITCH("pT_top_2nd") << endl;
  logger << LOG_DEBUG_VERBOSE << "USERCUT(min_pT_top_2nd) = " << USERCUT("min_pT_top_2nd") << endl;

  // top-pair invariant-mass cut
  if (switch_cut_M_ttx){
    double M2_ttx = (PARTICLE("tjet")[0].momentum + PARTICLE("tjet")[1].momentum).m2();
    if (switch_cut_M_ttx) {
      if (M2_ttx < cut_min_M2_ttx){
	cut_ps[i_a] = -1; 
	return;
      }
      
      if (cut_max_M2_ttx != 0. && M2_ttx > cut_max_M2_ttx){
	cut_ps[i_a] = -1; 
	return;
      }
    }
  }


  // cut on azimuthal angle between ttx 
  if (switch_cut_dphi_ttx == 1){
    double dphi_ttx = abs(PARTICLE("top")[0].phi - PARTICLE("atop")[0].phi);
    if (dphi_ttx > pi){dphi_ttx = 2 * pi - dphi_ttx;}

    if (dphi_ttx < cut_min_dphi_ttx){
      cut_ps[i_a] = -1;
      return;
    }
    if (cut_max_dphi_ttx != 0. && dphi_ttx > cut_max_dphi_ttx){
      cut_ps[i_a] = -1;
      return;
    }
  }
  

  // cuts on hardest and second-hardest top 
  if (switch_cut_pT_top_1st){
    double pT_top_1st = PARTICLE("tjet")[0].pT;
    logger << LOG_DEBUG_VERBOSE << "PARTICLE(tjet)[0].pT = " << PARTICLE("tjet")[0].pT << "   cut_min_pT_top_1st = " << cut_min_pT_top_1st << endl;
    if (pT_top_1st < cut_min_pT_top_1st){
      cut_ps[i_a] = -1; 
      return;
    }
  }
  if (switch_cut_pT_top_2nd){
    double pT_top_2nd = PARTICLE("tjet")[1].pT;
    if (pT_top_2nd < cut_min_pT_top_2nd){
      cut_ps[i_a] = -1; 
      return;
    }
  }

}
