#include "header.hpp"
#ifdef OPENLOOPS

void amplitude_OpenLoops_set::calculate_ME2_RA_MIX(){
  Logger logger("amplitude_OpenLoops_set::calculate_ME2_RA_MIX");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (esi->cut_ps[0] > -1){
    set_phasespacepoint();
    ol_evaluate_tree(csi->dipole[0].process_id, P_OpenLoops, &osi->value_ME2term[0]);
    logger << LOG_DEBUG_POINT << "OpenLoops:     R_ME2 = " << setw(23) << setprecision(15) << osi->value_ME2term[0] << endline_flush;
  }
  else {osi->value_ME2term[0] = 0.;}

  osi->calculate_dipole_MIX();
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

#endif
