#include "header.hpp"
#ifdef OPENLOOPS

void amplitude_OpenLoops_set::calculate_ME2_VT2_QCD(){
  static Logger logger("amplitude_OpenLoops_set::calculate_ME2_VT2_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (osi->QT_finalstate_massive_coloured){logger << LOG_WARN << "Check if process-specific function needs to be called instead of this one!" << endl;}

  set_phasespacepoint();
  set_delta_and_mu_Q();
  /*
  ol_setparameter_double(pole_uv, osi->VA_DeltaUV);
  ol_setparameter_double(pole_ir1, osi->VA_DeltaIR1);
  ol_setparameter_double(pole_ir2, osi->VA_DeltaIR2);
  double mu_Q = (esi->p_parton[0][1] + esi->p_parton[0][2]).m();
  mu_reg = mu_Q;
  ol_setparameter_double(OL_mu_ren, mu_Q);
  ol_setparameter_double(OL_mu_reg, mu_Q);
  ol_setparameter_double(fact_uv, one);
  ol_setparameter_double(fact_ir, one);
  */
  int polenorm_0 = 0;
  ol_setparameter_int(polenorm, polenorm_0);

  //  ol_evaluate_loop2(1, P_OpenLoops, M2L2, &acc);
  ol_evaluate_full(1, P_OpenLoops, &osi->VA_b_ME2, M2L1, IRL1, M2L2, IRL2, &acc);
  //  ol_evaluate_ct(1, P_OpenLoops, &M2L0, &osi->VA_X_ME2);
  osi->VA_V_ME2 = M2L1[0] + osi->VA_X_ME2;
  // ??? One could simply use the sum as usually later...

  // double-spin-flip contribution for gg-initiated processes (so far only for QQx production):
  if (osi->initial_gg){
    calculate_ME2_VT2_QCD_H0_doublespinflip();
    calculate_ME2_VT2_QCD_H0_DG();
  }
  /*
  if (osi->initial_gg){
    osi->QT_H0_doublespinflip = 0.;
    double temp_ME2 = 0.;
    double temp_m2schsf = 0.;
    ol_evaluate_schsf(1, P_OpenLoops, &temp_ME2, 1, 2, &temp_m2schsf);
    osi->QT_H0_doublespinflip = temp_m2schsf / temp_ME2;
    osi->QT_H0_DG = 0.;
  }
  */

  if (switch_off_H2 || !osi->initial_diag){
    osi->QT_A0 = osi->VA_b_ME2;
    osi->QT_A1 = osi->VA_V_ME2;
    osi->QT_H1_delta_QCD = osi->QT_A1 / 2 / (osi->alpha_S * inv2pi * osi->QT_A0);
    osi->QT_A2 = 0.;
    osi->QT_H2_delta_QCD = 0.;
    //osi->QT_H2_delta_QCD = osi->QT_A2 / 4 / (pow(osi->alpha_S * inv2pi, 2) * osi->QT_A0);
  }
  else {
    calculate_H2_QCD_2loop();
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void amplitude_OpenLoops_set::calculate_ME2_VT2_QCD_H0_doublespinflip(){
  static Logger logger("amplitude_OpenLoops_set::calculate_ME2_VT2_QCD_H0_doublespinflip");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  osi->QT_H0_doublespinflip = 1.;
  double temp_ME2 = 0.;
  double temp_m2schsf = 0.;
  ol_evaluate_schsf(1, P_OpenLoops, &temp_ME2, 1, 2, &temp_m2schsf);
  osi->QT_H0_doublespinflip = temp_m2schsf / temp_ME2;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void amplitude_OpenLoops_set::calculate_ME2_VT2_QCD_H0_DG(){
  static Logger logger("amplitude_OpenLoops_set::calculate_ME2_VT2_QCD_H0_DG");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  osi->QT_H0_DG = 0.;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

#endif
