#include "header.hpp"

ioperator_set::ioperator_set(){}

ioperator_set::ioperator_set(string name, int type, vector<int> pair, int no_prc, vector<int> type_parton, double charge_factor, int no_emitter, int no_spectator, int type_correction, int massive){
  static Logger logger("ioperator_set::ioperator_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;
  
  _name = name;
  _type = type;
  _pair = pair;
  _no_prc = no_prc;
  _type_parton = type_parton;
  _charge_factor = charge_factor;
  _no_emitter = no_emitter;
  _no_spectator = no_spectator;
  if (no_spectator == 0){_no_OL_entry = 0;}
  else if (no_emitter < no_spectator){_no_OL_entry = (no_spectator * (no_spectator - 1)) / 2 + no_emitter;}
  else if (no_emitter > no_spectator){_no_OL_entry = (no_emitter * (no_emitter - 1)) / 2 + no_spectator;}
  else {logger << LOG_FATAL << "Should not happen !" << endline_flush; exit(1);}

  _type_correction = type_correction;
  _massive = massive;

  if (_no_emitter < _no_spectator){no_BLHA_entry = ((_no_spectator - 1) * (_no_spectator - 2)) / 2 + (_no_emitter - 1);}
  else if (_no_emitter > _no_spectator){no_BLHA_entry = ((_no_emitter - 1) * (_no_emitter - 2)) / 2 + (_no_spectator - 1);}

  if (type_parton[no_emitter] == 0){_colour_factor = C_A;}
  else if (abs(type_parton[no_emitter]) < 7){_colour_factor = C_F;}
  else {_colour_factor = 0.;}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


string ioperator_set::name() const {return _name;}
int ioperator_set::type() const {return _type;}
const vector<int> ioperator_set::pair() const {return _pair;}
int ioperator_set::no_prc() const {return _no_prc;}
const vector<int> ioperator_set::type_parton() const {return _type_parton;}
double ioperator_set::charge_factor() const {return _charge_factor;}
double ioperator_set::colour_factor() const {return _colour_factor;}
int ioperator_set::no_emitter() const {return _no_emitter;}
int ioperator_set::no_spectator() const {return _no_spectator;}
int ioperator_set::no_OL_entry() const {return _no_OL_entry;}
int ioperator_set::type_correction() const {return _type_correction;}
int ioperator_set::massive() const {return _massive;}
