#include "header.hpp"

void observable_set::calculate_dipole_MIX(){
  static Logger logger("observable_set::calculate_dipole_MIX");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int i_a = 1; i_a < n_ps; i_a++){
    if (esi->cut_ps[i_a] >= 0){
      if      (csi->dipole[i_a].type_correction() == 1){
	if (csi->dipole[i_a].massive() == 0){
	  if      (csi->dipole[i_a].type_dipole() == 1){value_ME2term[i_a] = calculate_dipole_QCD_A_ij_k(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 2){value_ME2term[i_a] = calculate_dipole_QCD_A_ij_a(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 3){value_ME2term[i_a] = calculate_dipole_QCD_A_ai_k(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 5){value_ME2term[i_a] = calculate_dipole_QCD_A_ai_b(i_a);}
	  else {logger << LOG_FATAL << "csi->dipole[" << i_a << "].type_dipole() = " << csi->dipole[i_a].type_dipole() << " is not a valid value." << endline_flush; exit(1);}
	}
	else {
	  if      (csi->dipole[i_a].type_dipole() == 1){value_ME2term[i_a] = calculate_dipole_QCD_A_ij_k_massive(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 2){value_ME2term[i_a] = calculate_dipole_QCD_A_ij_a_massive(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 3){value_ME2term[i_a] = calculate_dipole_QCD_A_ai_k(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 5){value_ME2term[i_a] = calculate_dipole_QCD_A_ai_b(i_a);}
	  else {logger << LOG_FATAL << "csi->dipole[" << i_a << "].type_dipole() = " << csi->dipole[i_a].type_dipole() << " is not a valid value." << endline_flush; exit(1);}
	}
      }
      else if (csi->dipole[i_a].type_correction() == 2){
	if (csi->dipole[i_a].massive() == 0){
	  if      (csi->dipole[i_a].type_dipole() == 1){value_ME2term[i_a] = calculate_dipole_QEW_A_ij_k(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 2){value_ME2term[i_a] = calculate_dipole_QEW_A_ij_a(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 3){value_ME2term[i_a] = calculate_dipole_QEW_A_ai_k(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 5){value_ME2term[i_a] = calculate_dipole_QEW_A_ai_b(i_a);}
	  else {logger << LOG_FATAL << "csi->dipole[" << i_a << "].type_dipole() = " << csi->dipole[i_a].type_dipole() << " is not a valid value." << endline_flush; exit(1);}
	}
	else {
	  if      (csi->dipole[i_a].type_dipole() == 1){value_ME2term[i_a] = calculate_dipole_QEW_A_ij_k_massive(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 2){value_ME2term[i_a] = calculate_dipole_QEW_A_ij_a_massive(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 3){value_ME2term[i_a] = calculate_dipole_QEW_A_ai_k(i_a);}
	  else if (csi->dipole[i_a].type_dipole() == 5){value_ME2term[i_a] = calculate_dipole_QEW_A_ai_b(i_a);}
	  else {logger << LOG_FATAL << "csi->dipole[" << i_a << "].type_dipole() = " << csi->dipole[i_a].type_dipole() << " is not a valid value." << endline_flush; exit(1);}
	}
      }
    }
    else {value_ME2term[i_a] = 0.;}
  }
  RA_ME2 = value_ME2term;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


