#include "header.hpp"

define_particle_set::define_particle_set(){
 Logger logger("define_particle_set::define_particle_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  n_observed_min = 0;
  n_observed_max = 99;
  define_pT = 0.;
  define_ET = 0.;
  //  define_eta = 1.e99;
  //  define_y = 1.e99;
  define_eta = numeric_limits<double>::infinity();
  define_y = numeric_limits<double>::infinity();

  n_partonlevel = 0;

  name = "";
  input = "";
  is_user_defined = false;
 
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


define_particle_set::define_particle_set(string & _name, string & _input){
  Logger logger("define_particle_set::define_particle_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  initialization(_name, _input);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void define_particle_set::initialization(string & _name, string & _input){
  Logger logger("define_particle_set::initialization");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  name = _name;
  input = _input;

  //  is_user_defined = false;

  n_observed_min = 0;
  n_observed_max = 99;
  //  n_observed_max = numeric_limits<int>::max();
  is_restricted_n_min = false;
  is_restricted_n_max = false;

  is_restricted_n = false;
 
  define_pT = 0.;
  define_pT_min = 0.;
  define_pT_max = numeric_limits<double>::infinity();
  is_restricted_pT = false;
  is_restricted_pT_min = false;
  is_restricted_pT_max = false;
  
  define_ET = 0.;
  define_ET_min = 0.;
  define_ET_max = numeric_limits<double>::infinity();
  is_restricted_ET = false;
  is_restricted_ET_min = false;
  is_restricted_ET_max = false;
  
  define_eta = numeric_limits<double>::infinity();
  define_abseta_min = 0.;
  define_abseta_max = numeric_limits<double>::infinity();
  is_restricted_eta = false;
  is_restricted_eta_min = false;
  is_restricted_eta_max = false;
    
  define_y = numeric_limits<double>::infinity();
  define_absy_min = 0.;
  define_absy_max = numeric_limits<double>::infinity();
  is_restricted_y = false;
  is_restricted_y_min = false;
  is_restricted_y_max = false;
  
  is_restricted = false;

  n_partonlevel = 0;

  if (input == ""){return;}
  
  logger << LOG_DEBUG << "particle " << left << setw(10) << name << " = " << input << endline_flush;

  vector<string> split_input;//(1, "");
  //  logger << LOG_INFO << "split_input.size() = " << split_input.size() << endline_flush;
  int counter = -1;
  int start = 0;
  for (int i_c = 0; i_c < input.size(); i_c++){
    if (input[i_c] == ' '){start = 0;}
    if (input[i_c] != ' ' && start == 0){
      counter++;
      split_input.push_back("");
      start = 1;
    }
    if (input[i_c] != ' '){
      split_input[counter].push_back(input[i_c]);
    }
  }
  for (int i_s = 0; i_s < split_input.size(); i_s++){
    //    logger << LOG_INFO << "split_input[" << right << setw(2) << i_s << "] = " << left << setw(10) << split_input[i_s] << endline_flush;
  }
  vector<string> definition_list;
  definition_list.push_back("ET");
  definition_list.push_back("pT");
  definition_list.push_back("|eta|");
  definition_list.push_back("|y|");
  //  definition_list.push_back("n");

  
  vector<int> identification(split_input.size(), 0);
  //  logger.newLine(LOG_INFO);
  //  logger << LOG_DEBUG << "input = " << input << endline_flush;
  //  logger.newLine(LOG_DEBUG);
  
  for (int i_s = 0; i_s < split_input.size(); i_s++){
    if (split_input[i_s] == "n"){identification[i_s] = 1;}
    if (identification[i_s]){continue;}

    for (int i_l = 0; i_l < definition_list.size(); i_l++){
      //	logger << LOG_DEBUG_VERBOSE << "split_input[" << i_s << "] = " << split_input[i_s] << "  ?=  definition_list[" << i_l << "] = " << definition_list[i_l] << endline_flush;
      if (split_input[i_s] == definition_list[i_l]){
	//	  logger << LOG_DEBUG_VERBOSE << "split_input[" << i_s << "] = " << split_input[i_s] << " = definition_list[" << i_l << "] = " << definition_list[i_l] << endline_flush;
	identification[i_s] = 2;
	break;
      }
    }
    if (identification[i_s]){continue;}

    if (split_input[i_s] == ">"){identification[i_s] = -1;}
    if (split_input[i_s] == ">="){identification[i_s] = -2;}
    if (split_input[i_s] == "="){identification[i_s] = -3;}
    if (split_input[i_s] == "<"){identification[i_s] = -4;}
    if (split_input[i_s] == "<="){identification[i_s] = -5;}
    if (identification[i_s]){continue;}

    //    bool is_double = false;
    int check_number = 0;
    for (int i_c = 0; i_c < split_input[i_s].size(); i_c++){
      if (split_input[i_s][i_c] == '+' ||
	  split_input[i_s][i_c] == '-' ||
	  split_input[i_s][i_c] == '.' ||
	  split_input[i_s][i_c] == 'e' ||
	  split_input[i_s][i_c] == '0' ||
	  split_input[i_s][i_c] == '1' ||
	  split_input[i_s][i_c] == '2' ||
	  split_input[i_s][i_c] == '3' ||
	  split_input[i_s][i_c] == '4' ||
	  split_input[i_s][i_c] == '5' ||
	  split_input[i_s][i_c] == '6' ||
	  split_input[i_s][i_c] == '7' ||
	  split_input[i_s][i_c] == '8' ||
	  split_input[i_s][i_c] == '9'){
	check_number++;
      }
      /*
      if (split_input[i_s][i_c] == '+' ||
	  split_input[i_s][i_c] == '-' ||
	  split_input[i_s][i_c] == '.' ||
	  split_input[i_s][i_c] == 'e'){
	is_double = true;
      }
      */
    }
    if (split_input[i_s].size() == check_number){
      identification[i_s] = 4;
      /*
      if (is_double){identification[i_s] = 4;}
      else {identification[i_s] = 3;}
      */
    }
  }

  for (int i_s = 0; i_s < identification.size(); i_s++){
    //    logger << LOG_INFO << "split_input[" << right << setw(2) << i_s << "] = " << left << setw(10) << split_input[i_s] << "   identification[" << right << setw(2) << i_s << "] = " << left << setw(10) << identification[i_s] << endline_flush;
    if (identification[i_s] == 0){
      logger << LOG_FATAL << "Input cannot be interpreted: " << split_input[i_s] << endline_flush;
      exit(1);
    }
  }


  vector<vector<string> > split_condition;//(1, vector<string> (1, ""));
  vector<vector<int> > split_identification;//(1, vector<string> (1, ""));
  for (int i_s = 0; i_s < identification.size(); i_s++){
    if (i_s == 0){
      split_condition.push_back(vector<string> ());
      split_identification.push_back(vector<int> ());
    }
    else {
      if (identification[i_s] > 0 && identification[i_s - 1] > 0){
	split_condition.push_back(vector<string> ());
	split_identification.push_back(vector<int> ());
      }
    }
    split_condition[split_condition.size() - 1].push_back(split_input[i_s]);
    split_identification[split_identification.size() - 1].push_back(identification[i_s]);
  }

  for (int i_c = 0; i_c < split_identification.size(); i_c++){
    //    logger << LOG_INFO << "split_condition[" << right << setw(2) << i_c << "].size() = " << right << setw(2) << split_identification[i_c].size() << "   split_identification[" << right << setw(2) << i_c << "].size() = " << right << setw(2) << split_identification[i_c].size() << endline_flush;
  }

  for (int i_c = 0; i_c < split_identification.size(); i_c++){
    int position = -1;
    int type = 0;
    string condition = "";
    for (int j_c = 0; j_c < split_identification[i_c].size(); j_c++){
      if (split_identification[i_c][j_c] == 1 || split_identification[i_c][j_c] == 2){
	if (condition == ""){condition = split_condition[i_c][j_c]; position = j_c; type = split_identification[i_c][j_c];}
	else {logger << LOG_FATAL << "Condition " << i_c << " specifies more than one observable."  << endline_flush; exit(1);}
      }
    }
    if (position == -1){logger << LOG_FATAL << "Condition " << i_c << " specifies no observable."  << endline_flush; exit(1);}
    //   logger << LOG_INFO << "particle " << _name << "   " << "condition = " << condition << "   position = " << position << "   type = " << type << endline_flush;
 
    if (type == 1){
      bool error = false;
      bool min_set = false;
      bool max_set = false;
      int min = 0;
      //      int max = numeric_limits<int>::max();
      int max = 99;
      for (int j_c = 0; j_c < split_identification[i_c].size(); j_c+=2){
	if (j_c == position){continue;}
	else if (j_c < position){
	  if (split_condition[i_c][j_c + 1] == ">"){if (max_set){error = true;} else {max = atoi(split_condition[i_c][j_c].c_str() - 1); max_set = true;}}
	  if (split_condition[i_c][j_c + 1] == ">="){if (max_set){error = true;} else {max = atoi(split_condition[i_c][j_c].c_str()); max_set = true;}}
	  if (split_condition[i_c][j_c + 1] == "="){if (min_set || max_set){error = true;} else {min = atoi(split_condition[i_c][j_c].c_str()); max = atoi(split_condition[i_c][j_c].c_str()); min_set = true; max_set = true;}}
	  if (split_condition[i_c][j_c + 1] == "<="){if (min_set){error = true;} else {min = atoi(split_condition[i_c][j_c].c_str()); min_set = true;}}
	  if (split_condition[i_c][j_c + 1] == "<"){if (min_set){error = true;} else {min = atoi(split_condition[i_c][j_c].c_str() + 1); min_set = true;}}
	}
	else if (j_c > position){
	  if (split_condition[i_c][j_c - 1] == "<"){if (max_set){error = true;} else {max = atoi(split_condition[i_c][j_c].c_str() - 1); max_set = true;}}
	  if (split_condition[i_c][j_c - 1] == "<="){if (max_set){error = true;} else {max = atoi(split_condition[i_c][j_c].c_str()); max_set = true;}}
	  if (split_condition[i_c][j_c - 1] == "="){if (min_set || max_set){error = true;} else {min = atoi(split_condition[i_c][j_c].c_str()); max = atoi(split_condition[i_c][j_c].c_str()); min_set = true; max_set = true;}}
	  if (split_condition[i_c][j_c - 1] == ">="){if (min_set){error = true;} else {min = atoi(split_condition[i_c][j_c].c_str()); min_set = true;}}
	  if (split_condition[i_c][j_c - 1] == ">"){if (min_set){error = true;} else {min = atoi(split_condition[i_c][j_c].c_str() + 1); min_set = true;}}
	}
      }
      if (error){logger << LOG_FATAL << "Condition " << i_c << " contains contradiction for particle number (too many conditions)." << endline_flush; exit(1);}
      if (condition == "n"){
	if (max < min){logger << LOG_FATAL << "Condition " << i_c << " contains contradiction for particle number (max > min)." << endline_flush; exit(1);}
	if (min_set){
	  n_observed_min = min;
	  if (min != 0){is_restricted_n_min = true;} else {is_restricted_n_min = false;}
	}
	if (max_set){
	  n_observed_max = max;
	  if (max < 99){is_restricted_n_max = true;} else {is_restricted_n_max = false;}
	  //	if (max < numeric_limits<int>::max()){is_restricted_n_max = true;}
	}
	if (is_restricted_n_min || is_restricted_n_max){is_restricted_n = true;} else {is_restricted_n = false;}
      }
    }
    else if (type == 2 || type == 3){
      bool error = false;
      bool min_set = false;
      bool max_set = false;
      bool min_equal = true;
      bool max_equal = true;
      double min = 0.;
      if (type == 3){min = -numeric_limits<double>::infinity();}
      double max = numeric_limits<double>::infinity();
      for (int j_c = 0; j_c < split_identification[i_c].size(); j_c+=2){
	if (j_c == position){continue;}
	else if (j_c < position){
	  if (split_condition[i_c][j_c + 1] == ">"){if (max_set){error = true;} else {max = atof(split_condition[i_c][j_c].c_str()); max_equal = false; max_set = true;}}
	  if (split_condition[i_c][j_c + 1] == ">="){if (max_set){error = true;} else {max = atof(split_condition[i_c][j_c].c_str()); max_equal = true; max_set = true;}}
	  if (split_condition[i_c][j_c + 1] == "="){if (min_set || max_set){error = true;} else {min = atof(split_condition[i_c][j_c].c_str()); max = atof(split_condition[i_c][j_c].c_str()); min_set = true; max_set = true;}}
	  if (split_condition[i_c][j_c + 1] == "<="){if (min_set){error = true;} else {min = atof(split_condition[i_c][j_c].c_str()); min_equal = true; min_set = true;}}
	  if (split_condition[i_c][j_c + 1] == "<"){if (min_set){error = true;} else {min = atof(split_condition[i_c][j_c].c_str()); min_equal = false; min_set = true;}}
	}
	else if (j_c > position){
	  if (split_condition[i_c][j_c - 1] == "<"){if (max_set){error = true;} else {max = atof(split_condition[i_c][j_c].c_str()); max_equal = false; max_set = true;}}
	  if (split_condition[i_c][j_c - 1] == "<="){if (max_set){error = true;} else {max = atof(split_condition[i_c][j_c].c_str()); max_equal = true; max_set = true;}}
	  if (split_condition[i_c][j_c - 1] == "="){if (min_set || max_set){error = true;} else {min = atof(split_condition[i_c][j_c].c_str()); max = atof(split_condition[i_c][j_c].c_str()); min_set = true; max_set = true;}}
	  if (split_condition[i_c][j_c - 1] == ">="){if (min_set){error = true;} else {min = atof(split_condition[i_c][j_c].c_str()); min_equal = true; min_set = true;}}
	  if (split_condition[i_c][j_c - 1] == ">"){if (min_set){error = true;} else {min = atof(split_condition[i_c][j_c].c_str()); min_equal = false; min_set = true;}}
	}
      }
      if (max_equal){logger << LOG_DEBUG_VERBOSE << "max_equal = " << max_equal << " has no effect." << endline_flush;}
      if (error){logger << LOG_FATAL << "Condition " << i_c << " contains contradiction for " << condition << " (too many conditions in one expression)." << endline_flush; exit(1);}
      if (condition == "pT"){
	if (max <= min){logger << LOG_FATAL << "Condition " << i_c << " contains contradiction for define_pT (max = " << max << " <= " << min << " = min)." << endline_flush; exit(1);}
	define_pT_min = min;
	if (min > 0. || (min == 0. && !min_equal)){is_restricted_pT_min = true;} else {is_restricted_pT_min = false;}
	define_pT_max = max;
	if (max < 1.e99){is_restricted_pT_max = true;} else {is_restricted_pT_max = false;}
	//	if (max < numeric_limits<int>::max()){is_restricted_pT_max = true;}
	if (is_restricted_pT_min || is_restricted_pT_max){is_restricted_pT = true;} else {is_restricted_pT = false;}
  	if (is_restricted_pT_min){define_pT = define_pT_min;}
     }
      if (condition == "ET"){
	if (max <= min){logger << LOG_FATAL << "Condition " << i_c << " contains contradiction for define_ET." << endline_flush; exit(1);}
	define_ET_min = min;
	if (min > 0. || (min == 0. && !min_equal)){is_restricted_ET_min = true;} else {is_restricted_ET_min = false;}
	define_ET_max = max;
	if (max < 1.e99){is_restricted_ET_max = true;} else {is_restricted_ET_max = false;}
	//	if (max < numeric_limits<int>::max()){is_restricted_ET_max = true;}
	if (is_restricted_ET_min || is_restricted_ET_max){is_restricted_ET = true;} else {is_restricted_ET = false;}
   	if (is_restricted_ET_min){define_ET = define_ET_min;}
     }
      if (condition == "|eta|"){
	if (max <= min){logger << LOG_FATAL << "Condition " << i_c << " contains contradiction for define_abseta." << endline_flush; exit(1);}
	define_abseta_min = min;
	if (min > 0. || (min == 0. && !min_equal)){is_restricted_abseta_min = true;} else {is_restricted_abseta_min = false;}
	define_abseta_max = max;
	if (max < 1.e99){is_restricted_abseta_max = true;} else {is_restricted_abseta_max = false;}
	//	if (max < numeric_limits<int>::max()){is_restricted_abseta_max = true;}
	if (is_restricted_abseta_min || is_restricted_abseta_max){is_restricted_eta = true;} else {is_restricted_eta = false;}
 	if (is_restricted_abseta_max){define_eta = define_abseta_max;}
      }
      if (condition == "|y|"){
	if (max <= min){logger << LOG_FATAL << "Condition " << i_c << " contains contradiction for define_absy." << endline_flush; exit(1);}
	define_absy_min = min;
	if (min > 0. || (min == 0. && !min_equal)){is_restricted_absy_min = true;} else {is_restricted_absy_min = false;}
	define_absy_max = max;
	if (max < 1.e99){is_restricted_absy_max = true;} else {is_restricted_absy_max = false;}
	//	if (max < numeric_limits<int>::max()){is_restricted_absy_max = true;}
	if (is_restricted_absy_min || is_restricted_absy_max){is_restricted_y = true;} else {is_restricted_y = false;}
	if (is_restricted_absy_max){define_y = define_absy_max;}
      }

    }

    /*
    if (split_identification[i_c].size() == 3){
    }
    else if (split_identification[i_c].size() == 5){
    }
    */
    else {logger << LOG_FATAL << "Condition " << i_c << " does not have the correct content."  << endline_flush;}
  }

  if (is_restricted_pT || is_restricted_ET || is_restricted_y || is_restricted_eta){is_restricted = true;}

  stringstream temp_ss;
  if (is_restricted_pT){
    if (is_restricted_pT_min && is_restricted_pT_max){temp_ss << "   " << define_pT_min << " <= pT <= " << define_pT_max;}
    else if (is_restricted_pT_min){temp_ss << "   pT > " << define_pT_min;}
    else if (is_restricted_pT_max){temp_ss << "   pT < " << define_pT_max;}
     //   temp_ss << "   " << "pT > " << define_pT;
  }
  if (is_restricted_ET){
    if (is_restricted_ET_min && is_restricted_ET_max){temp_ss << "   " << define_ET_min << " <= ET <= " << define_ET_max;}
    else if (is_restricted_ET_min){temp_ss << "   ET > " << define_ET_min;}
    else if (is_restricted_ET_max){temp_ss << "   ET < " << define_ET_max;}
     //    temp_ss << "   " << "ET > " << define_ET;
  }
  if (is_restricted_eta){
    //    temp_ss << "   " << "|eta| < " << define_eta;
    if (is_restricted_abseta_min && is_restricted_abseta_max){temp_ss << "   " << define_abseta_min << " <= |eta| <= " << define_abseta_max;}
    else if (is_restricted_abseta_min){temp_ss << "   |eta| > " << define_abseta_min;}
    else if (is_restricted_abseta_max){temp_ss << "   |eta| < " << define_abseta_max << " - " << define_eta;}
  }
  if (is_restricted_y){
    if (is_restricted_absy_min && is_restricted_absy_max){temp_ss << "   " << define_absy_min << " <= |y| <= " << define_absy_max;}
    else if (is_restricted_absy_min){temp_ss << "   |y| > " << define_absy_min;}
    else if (is_restricted_absy_max){temp_ss << "   |y| < " << define_absy_max << " - " << define_y;}
    //    temp_ss << "   " << "|y| < " << define_y;
  }
  if (is_restricted_n){
    if (is_restricted_n_min && is_restricted_n_max){temp_ss << "   " << n_observed_min << " <= n <= " << n_observed_max;}
    else if (is_restricted_n_min){temp_ss << "   n >= " << n_observed_min;}
    else if (is_restricted_n_max){temp_ss << "   n <= " << n_observed_max;}
  }
  logger << LOG_DEBUG << "particle " << left << setw(10) << name << " = " << temp_ss.str() << endline_flush;
  
  logger.newLine(LOG_DEBUG);
 
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


bool define_particle_set::check_rapidity_eta(particle * this_particle){
  Logger logger("define_particle_set::check_rapidity_eta");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  //  bool check = true;
  if (is_restricted){
    if (is_restricted_y){
      if (abs(this_particle->rapidityXX()) > define_y){
	//	logger << LOG_INFO << "finished - return " << false << " (|y| = |" << this_particle->rapidityXX() << "| > " << define_y << ")" << endline_flush;
	logger << LOG_DEBUG_VERBOSE << "finished - return " << false << " (y = " << this_particle->rapidityXX() << ")" << endline_flush;
	return false;
      }
      // ... (possible further cuts on  y  or  |y|)
    }
    if (is_restricted_eta){
      if (abs(this_particle->etaXX()) > define_eta){
	//	logger << LOG_INFO << "finished - return " << false << " (|eta| = |" << this_particle->etaXX() << "| > " << define_eta << ")" << endline_flush;
	logger << LOG_DEBUG_VERBOSE << "finished - return " << false << " (eta)" << endline_flush;
	return false;
      }
      // ... (possible further cuts on  eta  or  |eta|)
    }
  }

  //  double temp1 = this_particle->rapidityXX();
  //  double temp2 = this_particle->etaXX();

      
  logger << LOG_DEBUG_VERBOSE << "finished - return " << true << endline_flush;
  return true;
}


bool define_particle_set::check_pT_ET(particle * this_particle){
  Logger logger("define_particle_set::check_pT_ET");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  //  bool check = true;
  if (is_restricted){
    if (is_restricted_pT){
      if (abs(this_particle->pTXX()) < define_pT){
	logger << LOG_DEBUG_VERBOSE << "finished - return " << false << " (pT)" << endline_flush;
	return false;
      }
      // ... (possible further cuts on  pT)
    }
    if (is_restricted_ET){
      if (abs(this_particle->ETXX()) < define_ET){
	logger << LOG_DEBUG_VERBOSE << "finished - return " << false << " (ET)" << endline_flush;
	return false;
      }
      // ... (possible further cuts on  ET)
    }
  }
    
  logger << LOG_DEBUG_VERBOSE << "finished - return " << true << endline_flush;
  return true;
}


bool define_particle_set::cut_multiplicity(int this_n_object){
  Logger logger("define_particle_set::cut_multiplicity");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (is_restricted_n){
    if (this_n_object < n_observed_min || this_n_object > n_observed_max){
      logger << LOG_DEBUG_VERBOSE << "finished - return " << true << endline_flush;
      return true;
    }
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished - return " << false << endline_flush;
  return false;
}


ostream & operator << (ostream & s, const define_particle_set & fc){
  stringstream temp_ss;
  if (fc.is_restricted_pT){
    if (fc.is_restricted_pT_min && fc.is_restricted_pT_max){temp_ss << "   " << fc.define_pT_min << " <= pT <= " << fc.define_pT_max;}
    else if (fc.is_restricted_pT_min){temp_ss << "   pT > " << fc.define_pT_min;}
    else if (fc.is_restricted_pT_max){temp_ss << "   pT < " << fc.define_pT_max;}
     //   temp_ss << "   " << "pT > " << fc.define_pT;
  }
  if (fc.is_restricted_ET){
    if (fc.is_restricted_ET_min && fc.is_restricted_ET_max){temp_ss << "   " << fc.define_ET_min << " <= ET <= " << fc.define_ET_max;}
    else if (fc.is_restricted_ET_min){temp_ss << "   ET > " << fc.define_ET_min;}
    else if (fc.is_restricted_ET_max){temp_ss << "   ET < " << fc.define_ET_max;}
     //    temp_ss << "   " << "ET > " << fc.define_ET;
  }
  if (fc.is_restricted_eta){
    //    temp_ss << "   " << "|eta| < " << fc.define_eta;
    if (fc.is_restricted_abseta_min && fc.is_restricted_abseta_max){temp_ss << "   " << fc.define_abseta_min << " <= |eta| <= " << fc.define_abseta_max;}
    else if (fc.is_restricted_abseta_min){temp_ss << "   |eta| > " << fc.define_abseta_min;}
    else if (fc.is_restricted_abseta_max){temp_ss << "   |eta| < " << fc.define_abseta_max << " - " << fc.define_eta;}
  }
  if (fc.is_restricted_y){
    if (fc.is_restricted_absy_min && fc.is_restricted_absy_max){temp_ss << "   " << fc.define_absy_min << " <= |y| <= " << fc.define_absy_max;}
    else if (fc.is_restricted_absy_min){temp_ss << "   |y| > " << fc.define_absy_min;}
    else if (fc.is_restricted_absy_max){temp_ss << "   |y| < " << fc.define_absy_max << " - " << fc.define_y;}
    //    temp_ss << "   " << "|y| < " << fc.define_y;
  }
  if (fc.is_restricted_n){
    if (fc.is_restricted_n_min && fc.is_restricted_n_max){temp_ss << "   " << fc.n_observed_min << " <= n <= " << fc.n_observed_max;}
    else if (fc.is_restricted_n_min){temp_ss << "   n >= " << fc.n_observed_min;}
    else if (fc.is_restricted_n_max){temp_ss << "   n <= " << fc.n_observed_max;}
  }
  s << "particle   " << left << setw(10) << fc.name << " = " << temp_ss.str();
  
  return s;
}

