#include "header.hpp"

void event_set::determination_index_group_parton(){
  static Logger logger("event_set::determination_index_group_parton");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // index_group_all_parton

  index_group_protojet_parton.resize(csi->n_ps);
  for (int i_a = 0; i_a < csi->n_ps; i_a++){
    for (int i_p = 3; i_p < csi->type_parton[i_a].size(); i_p++){
      for (int i_l = 0; i_l < jet_algorithm_list.size(); i_l++){
	if (csi->type_parton[i_a][i_p] == jet_algorithm_list[i_l]){
	  // Photon are added to protojets after Frixione isolation if not identified (independent of eta/y and pT/ET) !!!
	  if (csi->type_parton[i_a][i_p] == 22){photon_jet_algorithm = 1;}
	  else {index_group_protojet_parton[i_a].push_back(i_p);}
	}
      }
    }
    stringstream temp;
    for (int i_l = 0; i_l < index_group_protojet_parton[i_a].size(); i_l++){temp << setw(5) << index_group_protojet_parton[i_a][i_l];}
    logger << LOG_DEBUG << "index_group_protojet_parton[" << i_a << "].size() = " << index_group_protojet_parton[i_a].size() << " --- " << temp.str() << endline_flush;
  }

  index_group_recombination_parton.resize(csi->n_ps);
  for (int i_a = 0; i_a < csi->n_ps; i_a++){
    for (int i_p = 3; i_p < csi->type_parton[i_a].size(); i_p++){
      logger << LOG_DEBUG << "photon_recombination_list.size() = " << photon_recombination_list.size() << endline_flush;
      for (int i_l = 0; i_l < photon_recombination_list.size(); i_l++){
	logger << LOG_DEBUG << "csi->type_parton[" << i_a << "][" << i_p << "] = " << csi->type_parton[i_a][i_p] << "   photon_recombination_list[" << i_l << "] = " << photon_recombination_list[i_l] << endline_flush;
	if (csi->type_parton[i_a][i_p] == photon_recombination_list[i_l]){
	  index_group_recombination_parton[i_a].push_back(i_p);
	}
      }
    }
    stringstream temp;
    for (int i_l = 0; i_l < index_group_recombination_parton[i_a].size(); i_l++){temp << setw(5) << index_group_recombination_parton[i_a][i_l];}
    logger << LOG_DEBUG << "index_group_recombination_parton[" << i_a << "].size() = " << index_group_recombination_parton[i_a].size() << " --- " << temp.str() << endline_flush;
  }


  index_group_photon_parton.resize(csi->n_ps);
  for (int i_a = 0; i_a < csi->n_ps; i_a++){
    for (int i_p = 3; i_p < csi->type_parton[i_a].size(); i_p++){
      if (csi->type_parton[i_a][i_p] == 22){index_group_photon_parton[i_a].push_back(i_p);}
    }
    stringstream temp;
    for (int i_l = 0; i_l < index_group_photon_parton[i_a].size(); i_l++){temp << setw(5) << index_group_photon_parton[i_a][i_l];}
    logger << LOG_DEBUG << "index_group_photon_parton[" << i_a << "].size() = " << index_group_photon_parton[i_a].size() << " --- " << temp.str() << endline_flush;
  }


  index_group_missing_parton.resize(csi->n_ps);
  for (int i_a = 0; i_a < csi->n_ps; i_a++){
    for (int i_p = 3; i_p < csi->type_parton[i_a].size(); i_p++){
      if (csi->type_parton[i_a][i_p] == 12 || csi->type_parton[i_a][i_p] == 14 || csi->type_parton[i_a][i_p] == 16 ||
	  csi->type_parton[i_a][i_p] == -12 || csi->type_parton[i_a][i_p] == -14 || csi->type_parton[i_a][i_p] == -16){
	index_group_missing_parton[i_a].push_back(i_p);
      }
    }
    stringstream temp;
    for (int i_l = 0; i_l < index_group_missing_parton[i_a].size(); i_l++){temp << setw(5) << index_group_missing_parton[i_a][i_l];}
    logger << LOG_DEBUG << "index_group_missing_parton[" << i_a << "].size() = " << index_group_missing_parton[i_a].size() << " --- " << temp.str() << endline_flush;
  }


  // rename -> index_subtraction_QCD ???
  //  ps_runtime_subtraction_QCD containts partons (type_parton numbers) whose momenta are changed by QCD dipole mappings:
  ps_runtime_subtraction_QCD.resize(csi->n_ps);
  for (int i_a = 0; i_a < csi->n_ps; i_a++){
    for (int i_p = 3; i_p < csi->type_parton[i_a].size(); i_p++){if (abs(csi->type_parton[i_a][i_p]) < 7){ps_runtime_subtraction_QCD[i_a].push_back(i_p);}}
    stringstream temp;
    for (int i_l = 0; i_l < ps_runtime_subtraction_QCD[i_a].size(); i_l++){temp << setw(5) << ps_runtime_subtraction_QCD[i_a][i_l];}
    logger << LOG_DEBUG << "ps_runtime_subtraction_QCD[" << i_a << "].size() = " << ps_runtime_subtraction_QCD[i_a].size() << " --- " << temp.str() << endline_flush;
  }


  // rename -> index_subtraction_QEW ???
  //  ps_runtime_subtraction_QEW containts partons (type_parton numbers) whose momenta are changed by QEW dipole mappings:
  ps_runtime_subtraction_QEW.resize(csi->n_ps);
  for (int i_a = 0; i_a < csi->n_ps; i_a++){
    for (int i_p = 3; i_p < csi->type_parton[i_a].size(); i_p++){if (csi->charge_parton[i_a][i_p] != 0. || csi->type_parton[i_a][i_p] == 22){ps_runtime_subtraction_QEW[i_a].push_back(i_p);}}
    stringstream temp;
    for (int i_l = 0; i_l < ps_runtime_subtraction_QEW[i_a].size(); i_l++){temp << setw(5) << ps_runtime_subtraction_QEW[i_a][i_l];}
    logger << LOG_DEBUG << "ps_runtime_subtraction_QEW[" << i_a << "].size() = " << ps_runtime_subtraction_QEW[i_a].size() << " --- " << temp.str() << endline_flush;
  }


  logger << LOG_INFO << "(event_set::output_index_group_parton)" << endline << endline << output_index_group_parton() << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}








void event_set::determination_index_group(){
  static  Logger logger("event_set::determination_index_group");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  index_group_all_parton.resize(csi->n_ps, vector<vector<int> > (object_list_selection.size()));

  for (int i_a = 0; i_a < csi->n_ps; i_a++){
    logger << LOG_DEBUG << "csi->type_parton[" << i_a << "].size() = " << csi->type_parton[i_a].size() << endline_flush;
    for (int i_p = 3; i_p < csi->type_parton[i_a].size(); i_p++){
      bool flag_jet = false;
      for (int i_j = 0; i_j < jet_algorithm_list.size(); i_j++){if (jet_algorithm_list[i_j] == csi->type_parton[i_a][i_p]){flag_jet = true; break;}}

      if (csi->is_coloured_parton[i_a][i_p] && !csi->is_massive_parton[i_a][i_p]){
	index_group_all_parton[i_a][access_object_selection["jet"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["ljet"]].push_back(i_p);
      }
      
      if (csi->type_parton[i_a][i_p] == 4 && csi->is_massive_parton[i_a][i_p]){
	index_group_all_parton[i_a][access_object_selection["charm"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["charm_qa"]].push_back(i_p);
	if (flag_jet){
	  index_group_all_parton[i_a][access_object_selection["jet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["hjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["cjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["cjet_c"]].push_back(i_p);
	}
      }
      if (csi->type_parton[i_a][i_p] == -4 && csi->is_massive_parton[i_a][i_p]){
	index_group_all_parton[i_a][access_object_selection["acharm"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["charm_qa"]].push_back(i_p);
	if (flag_jet){
	  index_group_all_parton[i_a][access_object_selection["jet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["hjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["cjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["cjet_cx"]].push_back(i_p);
	}
      }

      if (csi->type_parton[i_a][i_p] == 5 && csi->is_massive_parton[i_a][i_p]){
	index_group_all_parton[i_a][access_object_selection["bottom"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["bottom_qa"]].push_back(i_p);
	if (flag_jet){
	  index_group_all_parton[i_a][access_object_selection["jet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["hjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["bjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["bjet_b"]].push_back(i_p);
	}
      }
      if (csi->type_parton[i_a][i_p] == -5 && csi->is_massive_parton[i_a][i_p]){
	index_group_all_parton[i_a][access_object_selection["abottom"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["bottom_qa"]].push_back(i_p);
	if (flag_jet){
	  index_group_all_parton[i_a][access_object_selection["jet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["hjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["bjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["bjet_bx"]].push_back(i_p);
	}
      }

      if (csi->type_parton[i_a][i_p] == 6 && csi->is_massive_parton[i_a][i_p]){
	index_group_all_parton[i_a][access_object_selection["top"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["top_qa"]].push_back(i_p);
	if (flag_jet){
	  index_group_all_parton[i_a][access_object_selection["jet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["hjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["tjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["tjet_t"]].push_back(i_p);
	}
      }
      if (csi->type_parton[i_a][i_p] == -6 && csi->is_massive_parton[i_a][i_p]){
	index_group_all_parton[i_a][access_object_selection["atop"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["top_qa"]].push_back(i_p);
	if (flag_jet){
	  index_group_all_parton[i_a][access_object_selection["jet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["hjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["tjet"]].push_back(i_p);
	  index_group_all_parton[i_a][access_object_selection["tjet_tx"]].push_back(i_p);
	}
      }

      if (csi->type_parton[i_a][i_p] == 11){
	index_group_all_parton[i_a][access_object_selection["lep"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["lm"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["e"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["em"]].push_back(i_p);
      }
      if (csi->type_parton[i_a][i_p] == -11){
	index_group_all_parton[i_a][access_object_selection["lep"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["lp"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["e"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["ep"]].push_back(i_p);
      }

      if (csi->type_parton[i_a][i_p] == 13){
	index_group_all_parton[i_a][access_object_selection["lep"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["lm"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["mu"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["mum"]].push_back(i_p);
      }
      if (csi->type_parton[i_a][i_p] == -13){
	index_group_all_parton[i_a][access_object_selection["lep"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["lp"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["mu"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["mup"]].push_back(i_p);
      }

      if (csi->type_parton[i_a][i_p] == 15){
	index_group_all_parton[i_a][access_object_selection["lep"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["lm"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["tau"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["taum"]].push_back(i_p);
      }
      if (csi->type_parton[i_a][i_p] == -15){
	index_group_all_parton[i_a][access_object_selection["lep"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["lp"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["tau"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["taup"]].push_back(i_p);
      }

      if (csi->type_parton[i_a][i_p] == 12){
	index_group_all_parton[i_a][access_object_selection["nua"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nu"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nea"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["ne"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["missing"]].push_back(i_p);
      }
      if (csi->type_parton[i_a][i_p] == -12){
	index_group_all_parton[i_a][access_object_selection["nua"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nux"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nea"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nex"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["missing"]].push_back(i_p);
      }

      if (csi->type_parton[i_a][i_p] == 14){
	index_group_all_parton[i_a][access_object_selection["nua"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nu"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nma"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nm"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["missing"]].push_back(i_p);
      }
      if (csi->type_parton[i_a][i_p] == -14){
	index_group_all_parton[i_a][access_object_selection["nua"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nux"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nma"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nmx"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["missing"]].push_back(i_p);
      }

      if (csi->type_parton[i_a][i_p] == 16){
	index_group_all_parton[i_a][access_object_selection["nua"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nu"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nta"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nt"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["missing"]].push_back(i_p);
      }
      if (csi->type_parton[i_a][i_p] == -16){
	index_group_all_parton[i_a][access_object_selection["nua"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nux"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["nta"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["ntx"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["missing"]].push_back(i_p);
      }

      if (csi->type_parton[i_a][i_p] == 22){
	index_group_all_parton[i_a][access_object_selection["photon"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["ajet"]].push_back(i_p);
      }
      if (csi->type_parton[i_a][i_p] == 23){
	index_group_all_parton[i_a][access_object_selection["v"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["z"]].push_back(i_p);
      }
      if (csi->type_parton[i_a][i_p] == 24){
	index_group_all_parton[i_a][access_object_selection["v"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["w"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["wm"]].push_back(i_p);
      }
      if (csi->type_parton[i_a][i_p] == -24){
	index_group_all_parton[i_a][access_object_selection["v"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["w"]].push_back(i_p);
	index_group_all_parton[i_a][access_object_selection["wp"]].push_back(i_p);
      }
      if (csi->type_parton[i_a][i_p] == 25){
	index_group_all_parton[i_a][access_object_selection["h"]].push_back(i_p);
      }
    }

    // Remove multiple entries:
    for (int i_os = 0; i_os < object_list_selection.size(); i_os++){
      if (index_group_all_parton[i_a][i_os].size() > 0){
	for (size_t i_p = index_group_all_parton[i_a][i_os].size(); i_p-- > 0; ){
	  for (size_t j_p = 0; j_p < i_p; j_p++){
	    if (index_group_all_parton[i_a][i_os][i_p] == index_group_all_parton[i_a][i_os][j_p]){index_group_all_parton[i_a][i_os].erase(index_group_all_parton[i_a][i_os].begin() + i_p); break;}
	  }
	}
      }
    }
  }

  for (int i_i = 1; i_i < object_list_selection.size(); i_i++){
    //    cout << "temp_original[" << setw(3) << i_i << "] = " << temp_original[i_i] << endline_flush;
    if (object_list_selection[i_i] == "lep" || object_list_selection[i_i] == "lm" || object_list_selection[i_i] == "lp" ||
	object_list_selection[i_i] == "e" || object_list_selection[i_i] == "em" || object_list_selection[i_i] == "ep" ||
	object_list_selection[i_i] == "mu" || object_list_selection[i_i] == "mum" || object_list_selection[i_i] == "mup" ||
	object_list_selection[i_i] == "tau" || object_list_selection[i_i] == "taum" || object_list_selection[i_i] == "taup" ||
	object_list_selection[i_i] == "nua" || object_list_selection[i_i] == "nu" || object_list_selection[i_i] == "nux" ||
	object_list_selection[i_i] == "nea" || object_list_selection[i_i] == "ne" || object_list_selection[i_i] == "nex" ||
	object_list_selection[i_i] == "nma" || object_list_selection[i_i] == "nm" || object_list_selection[i_i] == "nmx" ||
	object_list_selection[i_i] == "nta" || object_list_selection[i_i] == "nt" || object_list_selection[i_i] == "ntx" ||
	object_list_selection[i_i] == "top_qa" || object_list_selection[i_i] == "top" || object_list_selection[i_i] == "atop" ||
	object_list_selection[i_i] == "bottom_qa" || object_list_selection[i_i] == "bottom" || object_list_selection[i_i] == "abottom" ||
	object_list_selection[i_i] == "charm_qa" || object_list_selection[i_i] == "charm" || object_list_selection[i_i] == "acharm" ||
	object_list_selection[i_i] == "w" || object_list_selection[i_i] == "wm" || object_list_selection[i_i] == "wp" ||
	object_list_selection[i_i] == "z" || object_list_selection[i_i] == "h" || object_list_selection[i_i] == "v"){
      index_group_original.push_back(i_i);
    }

    if (object_list_selection[i_i] == "jet" || object_list_selection[i_i] == "ljet" || object_list_selection[i_i] == "ajet" ||
	object_list_selection[i_i] == "hjet" ||
	object_list_selection[i_i] == "tjet" || object_list_selection[i_i] == "tjet_t" || object_list_selection[i_i] == "tjet_tx" ||
	object_list_selection[i_i] == "bjet" || object_list_selection[i_i] == "bjet_b" || object_list_selection[i_i] == "bjet_bx" ||
	object_list_selection[i_i] == "cjet" || object_list_selection[i_i] == "cjet_c" || object_list_selection[i_i] == "cjet_cx"){
      index_group_jet.push_back(i_i);
    }
  }

  logger << LOG_INFO << "(event_set::output_index_group_all_parton)" << endline << endline << output_index_group_all_parton() << endline_flush;
  logger << LOG_INFO << "(event_set::output_index_group_original)" << endline << endline << output_index_group_original() << endline_flush;
  logger << LOG_INFO << "(event_set::output_index_group_jet)" << endline << endline << output_index_group_jet() << endline_flush;
    
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void event_set::determination_runtime_object(){
  static  Logger logger("event_set::determination_runtime_object");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  runtime_order.resize(object_list_selection.size());
  runtime_order_inverse.resize(csi->type_parton[0].size());
  for (int i = 1; i < object_list_selection.size(); i++){
    for (int i_p = 3; i_p < csi->type_parton[0].size(); i_p++){
      int i_a = 0;  //  temporary ???
      bool flag_jet = false;
      for (int i_j = 0; i_j < jet_algorithm_list.size(); i_j++){if (jet_algorithm_list[i_j] == csi->type_parton[i_a][i_p]){flag_jet = true; break;}}
    
      if (object_list_selection[i] == "jet"){
	//      if (object_list_selection[i] == "jet" && abs(csi->type_parton[0][i_p]) < 6){
	int flag = 0;
	for (int i_j = 0; i_j < jet_algorithm_list.size(); i_j++){
	  if (jet_algorithm_list[i_j] == csi->type_parton[i_a][i_p]){flag++; break;}
	}
	if (flag){
	  runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);
	}
      }
      if (object_list_selection[i] == "ljet" && csi->is_coloured_parton[0][i_p] && !csi->is_massive_parton[0][i_p]){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}

      if (object_list_selection[i] == "bjet" && abs(csi->type_parton[0][i_p]) == 5 && flag_jet){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "bjet_b" && csi->type_parton[0][i_p] == 5 && flag_jet){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "bjet_bx" && csi->type_parton[0][i_p] == -5 && flag_jet){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "bottom_qa" && abs(csi->type_parton[0][i_p]) == 5 && csi->is_massive_parton[0][i_p]){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "bottom" && csi->type_parton[0][i_p] == 5 && csi->is_massive_parton[0][i_p]){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "abottom" && csi->type_parton[0][i_p] == -5 && csi->is_massive_parton[0][i_p]){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}

      if (object_list_selection[i] == "lep" && (abs(csi->type_parton[0][i_p]) == 11 || abs(csi->type_parton[0][i_p]) == 13 || abs(csi->type_parton[0][i_p]) == 15)){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "lm" && (csi->type_parton[0][i_p] == 11 || csi->type_parton[0][i_p] == 13 || csi->type_parton[0][i_p] == 15)){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "lp" && (csi->type_parton[0][i_p] == -11 || csi->type_parton[0][i_p] == -13 || csi->type_parton[0][i_p] == -15)){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "e" && abs(csi->type_parton[0][i_p]) == 11){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "mu" && abs(csi->type_parton[0][i_p]) == 13){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "tau" && abs(csi->type_parton[0][i_p]) == 15){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "em" && csi->type_parton[0][i_p] == 11){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "mum" && csi->type_parton[0][i_p] == 13){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "taum" && csi->type_parton[0][i_p] == 15){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "ep" && csi->type_parton[0][i_p] == -11){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "mup" && csi->type_parton[0][i_p] == -13){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "taup" && csi->type_parton[0][i_p] == -15){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}

      if (object_list_selection[i] == "nua" && (abs(csi->type_parton[0][i_p]) == 12 || abs(csi->type_parton[0][i_p]) == 14 || abs(csi->type_parton[0][i_p]) == 16)){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "nu" && (csi->type_parton[0][i_p] == 12 || csi->type_parton[0][i_p] == 14 || csi->type_parton[0][i_p] == 16)){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "nux" && (csi->type_parton[0][i_p] == -12 || csi->type_parton[0][i_p] == -14 || csi->type_parton[0][i_p] == -16)){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "nea" && abs(csi->type_parton[0][i_p]) == 12){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "nma" && abs(csi->type_parton[0][i_p]) == 14){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "nta" && abs(csi->type_parton[0][i_p]) == 16){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "ne" && csi->type_parton[0][i_p] == 12){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "nm" && csi->type_parton[0][i_p] == 14){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "nt" && csi->type_parton[0][i_p] == 16){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "nex" && csi->type_parton[0][i_p] == -12){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "nmx" && csi->type_parton[0][i_p] == -14){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "ntx" && csi->type_parton[0][i_p] == -16){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "photon" && (csi->type_parton[0][i_p] == 22 || csi->type_parton[0][i_p] == 2002 || csi->type_parton[0][i_p] == -2002)){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "tjet" && abs(csi->type_parton[0][i_p]) == 6){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "top" && csi->type_parton[0][i_p] == 6){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "atop" && csi->type_parton[0][i_p] == -6){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "wm" && csi->type_parton[0][i_p] == 24){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "wp" && csi->type_parton[0][i_p] == -24){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "z" && csi->type_parton[0][i_p] == 23){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "h" && csi->type_parton[0][i_p] == 25){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}

      if (object_list_selection[i] == "missing" && (abs(csi->type_parton[0][i_p]) == 12 ||
						   abs(csi->type_parton[0][i_p]) == 14 ||
						   abs(csi->type_parton[0][i_p]) == 16)){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
      if (object_list_selection[i] == "ajet" && (csi->type_parton[0][i_p] == 22 || csi->type_parton[0][i_p] == 2002 || csi->type_parton[0][i_p] == -2002)){runtime_order[i].push_back(i_p); runtime_order_inverse[i_p].push_back(i);}
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


