#include "header.hpp"

void event_set::perform_photon_recombination(){
  static Logger logger("event_set::perform_photon_recombination");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // hard-coded rapidity restriction !!! ???
  
  vector<int> no_rec_photon;
  vector<int> no_rec_charged_particle;
  no_rec_charged_particle = index_group_recombination_parton[ix_a];
  no_rec_photon = index_group_photon_parton[ix_a];
  // ???
  no_rec_photon.clear();

  for (int i_p = 0; i_p < index_group_photon_parton[ix_a].size(); i_p++){
    // if (abs(event_original[ix_y][ix_a][index_group_photon_parton[ix_a][i_p]].rapidityXX()) < 3){
      no_rec_photon.push_back(index_group_photon_parton[ix_a][i_p]);
    // }
    // else {
    //   if (switch_output_cutinfo){info_cut << "Photon with " << event_original[ix_y][ix_a][index_group_photon_parton[ix_a][i_p]].momentum << " excluded: rapidity = " << event_original[ix_y][ix_a][index_group_photon_parton[ix_a][i_p]].rapidityXX() << endline_flush;}
    // }
  }

   if (no_rec_photon.size() == 0){return;} // obviously, no recombination needed in that case !

  if (switch_output_cutinfo){
    info_cut << "no_rec_charged_particle.size() = " << no_rec_charged_particle.size() << endline;
    for (int i_n = 0; i_n < no_rec_charged_particle.size(); i_n++){
      info_cut << "ix_a = " << setw(2) << ix_a << "   no_rec_charged_particle[" << i_n << "] = " << no_rec_charged_particle[i_n] << endline;
    }
    info_cut << "no_rec_photon.size()           = " << no_rec_photon.size() << endline;
    for (int i_n = 0; i_n < no_rec_photon.size(); i_n++){
      info_cut << "ix_a = " << setw(2) << ix_a << "   no_rec_photon[" << i_n << "] = " << no_rec_photon[i_n] << endline;
    }
  }

  vector<vector<double> > distance(no_rec_photon.size(), vector<double> (no_rec_charged_particle.size(), 0.));
  vector<vector<double> > distance_measure_factor(no_rec_photon.size(), vector<double> (no_rec_charged_particle.size(), 1.));
  for (int i_r = 0; i_r < no_rec_photon.size(); i_r++){
    for (int i_c = 0; i_c < no_rec_charged_particle.size(); i_c++){
      if (photon_R_definition == 0){distance[i_r][i_c] = R2_eta(event_original[ix_y][ix_a][no_rec_photon[i_r]], event_original[ix_y][ix_a][no_rec_charged_particle[i_c]]);}
      else if (photon_R_definition == 1){distance[i_r][i_c] = R2_rapidity(event_original[ix_y][ix_a][no_rec_photon[i_r]], event_original[ix_y][ix_a][no_rec_charged_particle[i_c]]);}
      else if (photon_R_definition == 11){
	if (event_original[ix_y][ix_a][no_rec_charged_particle[i_c]].pT2XX() > event_original[ix_y][ix_a][no_rec_photon[i_r]].pT2XX()){
	  distance_measure_factor[i_r][i_c] = 1. / event_original[ix_y][ix_a][no_rec_charged_particle[i_c]].pT2XX();
	}
	else {
	  distance_measure_factor[i_r][i_c] = 1. / event_original[ix_y][ix_a][no_rec_photon[i_r]].pT2XX();
	}
	distance[i_r][i_c] = R2_rapidity(event_original[ix_y][ix_a][no_rec_photon[i_r]], event_original[ix_y][ix_a][no_rec_charged_particle[i_c]]);
      }
      if (switch_output_cutinfo){info_cut << "distance[" << i_r << "][" << i_c << "] = " << distance[i_r][i_c] << endline;}
    }
  }

  while (no_rec_photon.size() > 0){
    int min1_rec_photon = 0;
    int min1_rec_charged_particle = 0;
    double min1_distance = 1.e99;

    for (int i_r = 0; i_r < no_rec_photon.size(); i_r++){
      if (switch_output_cutinfo){info_cut << "phot.: [0][" << ix_a << "][" << no_rec_photon[i_r] << "] = " << event_original[ix_y][ix_a][no_rec_photon[i_r]].momentum << endline;}
      for (int i_c = 0; i_c < no_rec_charged_particle.size(); i_c++){
	if (switch_output_cutinfo){info_cut << "ch.p.: [0][" << ix_a << "][" << no_rec_charged_particle[i_c] << "] = " << event_original[ix_y][ix_a][no_rec_charged_particle[i_c]].momentum << "   distance[" << i_r << "][" << i_c << "] = " << setprecision(5) << distance[i_r][i_c] << " photon_R2 = " << photon_R2 << endline;}
	if (photon_R_definition < 10){
	  if (distance[i_r][i_c] < min1_distance){
	    min1_rec_photon = i_r;
	    min1_rec_charged_particle = i_c;
	    min1_distance = distance[i_r][i_c];
	  }
	}
	else {
	  if (distance[i_r][i_c] * distance_measure_factor[i_r][i_c]< min1_distance){
	    min1_rec_photon = i_r;
	    min1_rec_charged_particle = i_c;
	    min1_distance = distance[i_r][i_c] * distance_measure_factor[i_r][i_c];
	  }
	}
      }
    }


    // check if two leptons would be combined first (which in the present case would lead to a rejected event immediately (full jet-like algorithm needed later...):
    if (photon_R_definition == 11){
      for (int i_c = 0; i_c < no_rec_charged_particle.size(); i_c++){
	if (i_c == min1_rec_charged_particle){continue;}
	double temp_lepton_distance_R2 = R2_rapidity(event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]], event_original[ix_y][ix_a][no_rec_charged_particle[i_c]]);
 	// hard-coded 0.2^2 !!!
	if (temp_lepton_distance_R2 > 0.04){continue;}

	double temp_lepton_distance_measure;
	if (event_original[ix_y][ix_a][no_rec_charged_particle[i_c]].pT2XX() > event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]].pT2XX()){
	  temp_lepton_distance_measure = 1. / event_original[ix_y][ix_a][no_rec_charged_particle[i_c]].pT2XX();
	}
	else {
	  temp_lepton_distance_measure = 1. / event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]].pT2XX();
	}
	double temp_lepton_distance = temp_lepton_distance_measure * temp_lepton_distance_R2;
	if (temp_lepton_distance < min1_distance){
	  if (switch_output_cutinfo){info_cut << "Lepton " << no_rec_charged_particle[min1_rec_charged_particle] << " would be combined with lepton " << no_rec_charged_particle[i_c] << " before photon recombination -> Event is rejected." << endline;}
	  event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]] = particle();
	  event_original[ix_y][ix_a][no_rec_charged_particle[i_c]] = particle();
	  return;
	}
      }
    }


    if (distance[min1_rec_photon][min1_rec_charged_particle] < photon_R2){
      event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]] = event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]] + event_original[ix_y][ix_a][no_rec_photon[min1_rec_photon]];
      event_original[ix_y][ix_a][no_rec_photon[min1_rec_photon]] = particle();

      logger << LOG_DEBUG_VERBOSE << "event_original[" << ix_y << "][" << ix_a << "][" << no_rec_charged_particle[min1_rec_charged_particle] << "] = " << event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]].momentum << endline_flush;
	    //      index_unrecombined_photon.push_back(no_rec_photon[min1_rec_photon]); // why should this happen ???
      no_rec_photon.erase(no_rec_photon.begin() + min1_rec_photon, no_rec_photon.begin() + min1_rec_photon + 1);
      distance.erase(distance.begin() + min1_rec_photon, distance.begin() + min1_rec_photon + 1);
      if (photon_R_definition == 11){
	distance_measure_factor.erase(distance_measure_factor.begin() + min1_rec_photon, distance_measure_factor.begin() + min1_rec_photon + 1);
      }

      if (switch_output_cutinfo){info_cut << "Photon " << min1_rec_charged_particle << " (" << no_rec_charged_particle[min1_rec_charged_particle] << ") recombined." << endline;}
      for (int i_r = 0; i_r < no_rec_photon.size(); i_r++){
	if (photon_R_definition == 0){distance[i_r][min1_rec_charged_particle] = R2_eta(event_original[ix_y][ix_a][no_rec_photon[i_r]], event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]]);}
	else if (photon_R_definition == 1){distance[i_r][min1_rec_charged_particle] = R2_rapidity(event_original[ix_y][ix_a][no_rec_photon[i_r]], event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]]);}
	else if (photon_R_definition == 11){
	  if (event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]].pT2XX() > event_original[ix_y][ix_a][no_rec_photon[i_r]].pT2XX()){
	    distance_measure_factor[i_r][min1_rec_charged_particle] = 1. / event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]].pT2XX();
	  }
	  else {
	    distance_measure_factor[i_r][min1_rec_charged_particle] = 1. / event_original[ix_y][ix_a][no_rec_photon[i_r]].pT2XX();
	  }
	  distance[i_r][min1_rec_charged_particle] = R2_rapidity(event_original[ix_y][ix_a][no_rec_photon[i_r]], event_original[ix_y][ix_a][no_rec_charged_particle[min1_rec_charged_particle]]);
	}
      }
    }
    else {
      if (switch_output_cutinfo){info_cut << "No photons recombined." << endline;}
      for (int i_r = 0; i_r < no_rec_photon.size(); i_r++){
	index_unrecombined_photon.push_back(no_rec_photon[i_r]);
	no_rec_photon.erase(no_rec_photon.begin() + i_r);
      }
    }
  }

  if (switch_output_cutinfo){
    info_cut << "no_rec_photon.size() = " << no_rec_photon.size() << endline;
    for (int i_r = 0; i_r < no_rec_photon.size(); i_r++){
      info_cut << "no_rec_photon[" << i_r << "] = " << no_rec_photon[i_r] << endline;
    }
    info_cut << "index_unrecombined_photon.size() = " << index_unrecombined_photon.size() << endline;
    for (int i_r = 0; i_r < index_unrecombined_photon.size(); i_r++){
      info_cut << "index_unrecombined_photon[" << i_r << "] = " << index_unrecombined_photon[i_r] << endline;
    }
    info_cut << endline;
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


bool event_set::perform_photon_photon_recombination(){
  static Logger logger("event_set::perform_photon_photon_recombination");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  bool stop_photon_photon_recombination = false;
  if (event_photon[ix_y][ix_a].size() < 2){stop_photon_photon_recombination = 1;}
  bool change_photon_photon_recombination = false;
  while (!stop_photon_photon_recombination){
    double distance = photon_photon_recombination_R;
    int i_rec = -1;
    int j_rec = -1;
    for (size_t i_p = 0; i_p < event_photon[ix_y][ix_a].size(); i_p++){
      for (size_t j_p = i_p + 1; j_p < event_photon[ix_y][ix_a].size(); j_p++){
	double temp_distance = 0.;
	if (photon_R_definition == 0){temp_distance = R2_eta(event_photon[ix_y][ix_a][i_p], event_photon[ix_y][ix_a][j_p]);}
	else if (photon_R_definition == 1){temp_distance = R2_rapidity(event_photon[ix_y][ix_a][i_p], event_photon[ix_y][ix_a][j_p]);}
	if (temp_distance < distance){
	  distance = temp_distance;
	  i_rec = i_p;
	  j_rec = j_p;
	}
      }
    }
    if (i_rec != -1 && j_rec != -1){
      change_photon_photon_recombination = true;
      if (switch_output_cutinfo){
	info_cut << "photon_photon_recombination applied for the following photons (distance = " << distance << ")" << endline;
	info_cut << "event_photon[ix_y][ix_a][" << i_rec << "] = " << event_photon[ix_y][ix_a][i_rec].momentum << endline;
	info_cut << "event_photon[ix_y][ix_a][" << j_rec << "] = " << event_photon[ix_y][ix_a][j_rec].momentum << endline;
      }
      event_photon[ix_y][ix_a][i_rec] = event_photon[ix_y][ix_a][i_rec] + event_photon[ix_y][ix_a][j_rec];
      event_photon[ix_y][ix_a].erase(event_photon[ix_y][ix_a].begin() + j_rec);
    }
    else {stop_photon_photon_recombination = true;}
  }

  logger << LOG_DEBUG_VERBOSE << "finished - return " << change_photon_photon_recombination << endline_flush;
  return change_photon_photon_recombination;
}


