#include "header.hpp"

event_set::event_set(){
  Logger logger("event_set::event_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "constructor called..." << endl;
 
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

event_set::~event_set(){
  Logger logger("event_set::~event_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "destructor called..." << endl;

  logger << LOG_DEBUG_VERBOSE << "qT_basic = " << qT_basic << endline_flush;
 
  // Check if delete would make more sense here !!!
  /////  delete qT_basic;
 
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void event_set::phasespacepoint(){
  Logger logger("event_set::phasespacepoint");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->type_contribution == "born"){phasespacepoint_born();}
  else if (csi->type_contribution == "L2I"){phasespacepoint_born();}
  else if (csi->type_contribution == "RT"){phasespacepoint_real();}
  else if (csi->type_contribution == "L2RT"){phasespacepoint_real();}
  else if (csi->type_contribution == "VA"){phasespacepoint_born();}
  else if (csi->type_contribution == "RVA"){phasespacepoint_real();}
  else if (csi->type_contribution == "L2VA"){phasespacepoint_born();}
  else if (csi->type_contribution == "CA"){phasespacepoint_collinear();}
  else if (csi->type_contribution == "RCA"){phasespacepoint_realcollinear();}
  else if (csi->type_contribution == "L2CA"){phasespacepoint_collinear();}
  else if (csi->type_contribution == "RA"){phasespacepoint_real();}
  else if (csi->type_contribution == "RRA"){phasespacepoint_doublereal();}
  else if (csi->type_contribution == "L2RA"){phasespacepoint_real();}
  else if (csi->type_contribution == "VT"){phasespacepoint_collinear();}
  else if (csi->type_contribution == "L2VT"){phasespacepoint_collinear();}
  else if (csi->type_contribution == "CT"){phasespacepoint_collinear();}
  else if (csi->type_contribution == "L2CT"){phasespacepoint_collinear();}
  else if (csi->type_contribution == "PT"){phasespacepoint_collinear();}
  else if (csi->type_contribution == "L2PT"){phasespacepoint_collinear();}
  else if (csi->type_contribution == "VT2"){phasespacepoint_collinear();}
  else if (csi->type_contribution == "CT2"){phasespacepoint_collinear();}
  else if (csi->type_contribution == "PT2"){phasespacepoint_collinear();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void event_set::define_fiducial_cut_list(){
  Logger logger("event_set::define_fiducial_cut_list");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // map<string, bool> instead ???
  fiducial_cut_list.clear();
  fiducial_cut_list.push_back("M");
  fiducial_cut_list.push_back("pT");
  fiducial_cut_list.push_back("|eta|");
  fiducial_cut_list.push_back("|y|");
  fiducial_cut_list.push_back("deta");
  fiducial_cut_list.push_back("dy");
  fiducial_cut_list.push_back("absdeta");
  fiducial_cut_list.push_back("absdy");
  fiducial_cut_list.push_back("dReta");
  fiducial_cut_list.push_back("dRy");
  fiducial_cut_list.push_back("dphi");

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void event_set::determine_p_parton(){
  Logger logger("event_set::determine_p_parton");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  p_parton = start_p_parton;
  for (int i_p = 0; i_p < 3 + csi->n_particle; i_p++){p_parton[0][csi->swap_parton[0][i_p]] = psi->xbp_all[0][intpow(2, i_p - 1)];}
  if (csi->class_contribution_CS_real){for (int i_a = 1; i_a < csi->n_ps; i_a++){for (int i_p = 0; i_p < p_parton[i_a].size(); i_p++){p_parton[i_a][i_p] = psi->xbp_all[i_a][intpow(2, i_p - 1)];}}}

  /*
  // Imported from RA:
  // Check if no csi->swap_parton[i_a][i_p] is required (not used for i_a != 0 so far) !!!
  if (csi->class_contribution_CS_real){
    for (int i_a = 1; i_a < csi->n_ps; i_a++){
      for (int i_p = 0; i_p < esi->p_parton[i_a].size(); i_p++){
	esi->p_parton[i_a][csi->swap_parton[i_a][i_p]] = psi->xbp_all[i_a][intpow(2, i_p - 1)];
	//      esi->p_parton[i_a][i_p] = psi->xbp_all[i_a][intpow(2, i_p - 1)];
      }
    }
  }
  */

  if (Log::getLogThreshold() <= LOG_DEBUG_POINT){
    for (int i_p = 0; i_p < 3 + csi->n_particle; i_p++){logger << LOG_DEBUG_VERBOSE << "p_parton[0][" << csi->swap_parton[0][i_p] << "] = " << p_parton[0][csi->swap_parton[0][i_p]] << endline_flush;}
    stringstream temp_ss;
    for (int i_a = 0; i_a < csi->n_ps; i_a++){
      for (int i_p = 0; i_p < p_parton[i_a].size(); i_p++){
	temp_ss << "p_parton[" << setw(2) << i_a << "][" << setw(2) << i_p << "] -> [" << setw(3) << csi->type_parton[i_a][i_p] << "] = " << p_parton[i_a][i_p] << "   m2 = " << setw(15) << setprecision(8) << p_parton[i_a][i_p].m2() << "   m = " << setw(15) << setprecision(8) << sqrt(abs(p_parton[i_a][i_p].m2())) << endline_flush;
      }
      if (i_a < csi->n_ps - 1){temp_ss << endline;}
    }
    logger << LOG_DEBUG_POINT << "PSP" << "   i_gen = " << setw(12) << psi->i_gen << "   i_acc = " << setw(12) << psi->i_acc << "   i_rej = " << setw(12) << psi->i_rej << "   i_nan = " << setw(4) << psi->i_nan << "   i_tec = " << setw(4) << psi->i_tec << endline << endline << temp_ss.str() << endline_flush;
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void event_set::advanced_sort_by_pT(int x_a, int j_g){
  Logger logger("event_set::advanced_sort_by_pT");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  bool advanced_back_to_back_configuration = false;
  if (x_a > 0 && n_object[j_g][x_a] == 2){
    if (csi->type_contribution == "RA" || csi->type_contribution == "L2RA"){
      if (abs(event_particle_group[ix_y][x_a][j_g][0]->pTXX() - event_particle_group[ix_y][x_a][j_g][1]->pTXX()) / (event_particle_group[ix_y][x_a][j_g][0]->pTXX() + event_particle_group[ix_y][x_a][j_g][1]->pTXX()) < 1.e-12){
	advanced_back_to_back_configuration = true;
      }
    }
  }
  
  if (advanced_back_to_back_configuration){
    if (event_particle_group[ix_y][0][j_g].size() > 1){
      double delta_R2_0_0 = R2_eta(*event_particle_group[ix_y][0][j_g][0], *event_particle_group[ix_y][x_a][j_g][0]);
      double delta_R2_1_1 = R2_eta(*event_particle_group[ix_y][0][j_g][1], *event_particle_group[ix_y][x_a][j_g][1]);
      double delta_R2_0_1 = R2_eta(*event_particle_group[ix_y][0][j_g][0], *event_particle_group[ix_y][x_a][j_g][1]);
      double delta_R2_1_0 = R2_eta(*event_particle_group[ix_y][0][j_g][1], *event_particle_group[ix_y][x_a][j_g][0]);

      if (switch_output_cutinfo){
	info_cut << "[" << right << setw(2) << ix_a << "]" << "   " << "advanced_sort_by_pT: back-to-back configuration" << endline;
	info_cut << "[" << right << setw(2) << ix_a << "]" << "   " << "event_particle_group[" << ix_y << "][0][" << j_g << "][0] = " << *event_particle_group[ix_y][0][j_g][0] << endline;
	info_cut << "[" << right << setw(2) << ix_a << "]" << "   " << "event_particle_group[" << ix_y << "][0][" << j_g << "][1] = " << *event_particle_group[ix_y][0][j_g][1] << endline;
	info_cut << "[" << right << setw(2) << ix_a << "]" << "   " << "event_particle_group[" << ix_y << "][" << x_a << "][" << j_g << "][0] = " << *event_particle_group[ix_y][x_a][j_g][0] << endline;
	info_cut << "[" << right << setw(2) << ix_a << "]" << "   " << "event_particle_group[" << ix_y << "][" << x_a << "][" << j_g << "][1] = " << *event_particle_group[ix_y][x_a][j_g][1] << endline;
	
	info_cut << "[" << right << setw(2) << ix_a << "]" << "   " << "delta_R2_0_0 + delta_R2_1_1 = " << setw(15) << setprecision(8) << delta_R2_0_0 + delta_R2_1_1 << "   " << "delta_R2_0_0 = " << setw(15) << setprecision(8) << delta_R2_0_0 << "   " << "delta_R2_1_1 = " << setw(15) << setprecision(8) << delta_R2_1_1 << endline;
	info_cut << "[" << right << setw(2) << ix_a << "]" << "   " << "delta_R2_0_1 + delta_R2_1_0 = " << setw(15) << setprecision(8) << delta_R2_0_1 + delta_R2_1_0 << "   " << "delta_R2_0_1 = " << setw(15) << setprecision(8) << delta_R2_0_1 << "   " << "delta_R2_1_0 = " << setw(15) << setprecision(8) << delta_R2_1_0 << endline;
      }
      
      if (delta_R2_0_1 + delta_R2_1_0 < delta_R2_0_0 + delta_R2_1_1){
	swap(event_particle_group[ix_y][x_a][j_g][0], event_particle_group[ix_y][x_a][j_g][1]);
	if (switch_output_cutinfo){
	  info_cut << "[" << right << setw(2) << ix_a << "]" << "   " << "Momenta have been swapped in order to match real phase space." << endline;
	  info_cut << "[" << right << setw(2) << ix_a << "]" << "   " << "event_particle_group[" << ix_y << "][" << x_a << "][" << j_g << "][0] = " << event_particle_group[ix_y][x_a][j_g][0] << endline;
	  info_cut << "[" << right << setw(2) << ix_a << "]" << "   " << "event_particle_group[" << ix_y << "][" << x_a << "][" << j_g << "][1] = " << event_particle_group[ix_y][x_a][j_g][1] << endline;
	  info_cut << endline;
	}
      }
    }
  }
  else {sort(event_particle_group[ix_y][x_a][j_g].begin(), event_particle_group[ix_y][x_a][j_g].end(), XgreaterBypT);}
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

