#include "header.hpp"

void get_data(string & filename, vector<string> & readin){
  Logger logger("get_data");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // new version
  ifstream ifs(filename.c_str());
  if (!ifs.fail()){
    ifs.seekg (0, ifs.end);
    streampos end = ifs.tellg();
    ifs.seekg(0, ifs.beg);
    streampos beg = ifs.tellg();
    char * cbuffer = new char [end - beg];
    ifs.read(cbuffer, end - beg);
    ifs.close();
    stringstream temp_ss;
    for (int i_s = 0; i_s < end - beg; i_s++){
      if (cbuffer[i_s] == '\n'){readin.push_back(temp_ss.str()); temp_ss.str(""); temp_ss.clear();}
      else {temp_ss << cbuffer[i_s];}
    }
    delete [] cbuffer;
  }
  /*
  // old version
  char LineBuffer[128];
  ifstream in_result(filename.c_str());
  while (in_result.getline(LineBuffer, 128)){readin.push_back(LineBuffer);}
  in_result.close();
  */
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

/*		       
void get_data_remove_comment(string & filename, vector<string> & readin){
  Logger logger("get_data");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // new version
  ifstream ifs(filename.c_str());
  if (!ifs.fail()){
    ifs.seekg (0, ifs.end);
    streampos end = ifs.tellg();
    ifs.seekg(0, ifs.beg);
    streampos beg = ifs.tellg();
    char * cbuffer = new char [end - beg];
    ifs.read(cbuffer, end - beg);
    ifs.close();
    stringstream temp_ss;
    int comment_mode = 0;
    for (int i_s = 0; i_s < end - beg; i_s++){
      if (cbuffer[i_s] == '\n'){readin.push_back(temp_ss.str()); temp_ss.str(""); temp_ss.clear();}
      else {temp_ss << cbuffer[i_s];}
    }
    delete [] cbuffer;
  }
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
*/
			       
void get_data_split(string & filename, vector<vector<string> > & readin_data){
  Logger logger("get_data_split");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  vector<string> readin;
  
  // new version
  ifstream ifs(filename.c_str());
  if (!ifs.fail()){
    ifs.seekg (0, ifs.end);
    streampos end = ifs.tellg();
    ifs.seekg(0, ifs.beg);
    streampos beg = ifs.tellg();
    char * cbuffer = new char [end - beg];
    ifs.read(cbuffer, end - beg);
    ifs.close();
    //    stringstream temp_ss;
    //    for (int i_s = 0; i_s < end - beg; i_s++){
    //      if (cbuffer[i_s] == '\n'){readin.push_back(temp_ss.str()); temp_ss.str(""); temp_ss.clear();}
    //      else {temp_ss << cbuffer[i_s];}
    //    }
    stringstream temp_ss;
    int comment_mode = 0;
    int line_mode = 0;
    vector<string> line_split;
    for (int i_s = 0; i_s < end - beg; i_s++){
      if (cbuffer[i_s] == '#'){comment_mode = 1;}
      else if (cbuffer[i_s] == ' ' || cbuffer[i_s] == char(9) || cbuffer[i_s] == '\n'){
	if (line_mode){
	  line_mode = 0;
	  line_split.push_back(temp_ss.str());
	  temp_ss.str("");
	  temp_ss.clear();
	}
	if (cbuffer[i_s] == '\n'){
	  if (comment_mode){comment_mode = 0;}
	  else {readin_data.push_back(line_split);}
	  line_split.clear();
	}
      }
      else {
	temp_ss << cbuffer[i_s];
	if (!line_mode){line_mode = 1;}
      }
    }
    delete [] cbuffer;
  }
  /*
  // old version
  char LineBuffer[128];
  ifstream in_result(filename.c_str());
  while (in_result.getline(LineBuffer, 128)){readin.push_back(LineBuffer);}
  in_result.close();

  for (int i = 0; i < readin.size(); i++){
    vector<string> temp_s(1);
    int temp_comment = 0;
    for (int j_s = 0; j_s < readin[i].size(); j_s++){
      if (readin[i][0] == '#'){temp_comment = 1; break;}
      else if (readin[i][j_s] == ' ' || readin[i][j_s] == char(9)){
	if (temp_s[temp_s.size() - 1].size() == 0){}
	else{temp_s.push_back("");}
      }
      else {temp_s[temp_s.size() - 1].push_back(readin[i][j_s]);}
    }
    if (temp_comment == 0){
      if (temp_s[temp_s.size() - 1] == ""){temp_s.erase(temp_s.end());}
      readin_data.push_back(temp_s);
    }
  }
  */
    
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

			       
void get_userinput_from_readin(vector<string> & user_variable, vector<string> & user_variable_additional, vector<string> & user_value, vector<string> & readin){
  Logger logger("get_userinput_from_readin");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string readindata;
  for (int i = 0; i < readin.size(); i++){
    logger << LOG_DEBUG << "readin[" << setw(4) << i << "].size() = " << readin[i].size() << endline_flush;
    readindata = readin[i][0];
    if (readindata != "/" && readindata != "#" && readindata != "%"){
      int start = 0;
      user_variable.push_back("");
      user_variable_additional.push_back("");
      user_value.push_back("");
      for (int j = 0; j < readin[i].size(); j++){
	if (start == 0 || start == 1){
	  if (((readin[i][j] == ' ') || (readin[i][j] == char(9))) && start == 0){}
	  else if ((readin[i][j] != ' ') && (readin[i][j] != char(9))){
	    user_variable[user_variable.size() - 1].push_back(readin[i][j]);
	    if (start != 1){start = 1;}
	  }
	  else {start++;}
	}
	else if (start == 2){
	  if (readin[i][j] == '='){start = 5;}
	  else if ((readin[i][j] == ' ') || (readin[i][j] == char(9))){}
	  else if (start == 2){
	    start++;
	    j--;
	  }
	  else {
	    logger << LOG_ERROR << "Incorrect input in line " << i << endline_flush;
	    user_variable.erase(user_variable.end(), user_variable.end());
	    user_variable_additional.erase(user_variable_additional.end(), user_variable_additional.end());
	    user_value.erase(user_value.end(), user_value.end());
	    break;
	  }
	}
	else if (start == 3){
	  if ((readin[i][j] != '=')){
	    user_variable_additional[user_variable_additional.size() - 1].push_back(readin[i][j]);
	  }
	  else {start++; j--;} // should be the same as shifting (start == 4) here !!!
	}
	else if (start == 4){
	  // additional: should be allowed to contain ' ' !!!
	  if (readin[i][j] == '='){
	    start = 5;
	    logger << LOG_DEBUG << "before: ---" << user_variable_additional[user_variable_additional.size() - 1] << "---" << endline_flush;
	    for (int i_s = user_variable_additional[user_variable_additional.size() - 1].size() - 1; i_s > 0; i_s--){
	      if (user_variable_additional[user_variable_additional.size() - 1][i_s] == ' ' ||
		  user_variable_additional[user_variable_additional.size() - 1][i_s] == char(9)){
		user_variable_additional[user_variable_additional.size() - 1].erase(user_variable_additional[user_variable_additional.size() - 1].end() - 1, user_variable_additional[user_variable_additional.size() - 1].end());
	      }
	      else {break;}
	    }
	    logger << LOG_DEBUG << "after:  ---" << user_variable_additional[user_variable_additional.size() - 1] << "---" << endline_flush;
	  }
	  //	  else if ((readin[i][j] == ' ') || (readin[i][j] == char(9))){}
	  else {
	    logger << LOG_ERROR << "Incorrect input in line " << i << endline_flush;
	    user_variable.erase(user_variable.end(), user_variable.end());
	    user_variable_additional.erase(user_variable_additional.end(), user_variable_additional.end());
	    user_value.erase(user_value.end(), user_value.end());
	    break;
	  }
	}
	else if (start == 5 || start == 6){
	  if (((readin[i][j] == ' ') || (readin[i][j] == char(9))) && start == 5){}
	  else if ((readin[i][j] != ' ') && (readin[i][j] != char(9))){
	    user_value[user_value.size() - 1].push_back(readin[i][j]);
	    if (start != 6){start = 6;}
	  }
	  else {start++;}
	}

	else if (start == 5 || start == 6 || start == 7){
	  // start == 5: before beginning of user_value
	  // start == 6: user_value has started
	  // start == 7:
	  logger << LOG_DEBUG_VERBOSE << "readin[" << i << "][" << j << "] = " << readin[i][j] << endline_flush;
	  if (readin[i][j] == '%'){break;}
	  if (((readin[i][j] == ' ') || (readin[i][j] == char(9))) && start == 5){}
	  else if (((readin[i][j] == ' ') || (readin[i][j] == char(9))) && start > 5){start = 7;}
	  else if ((readin[i][j] != ' ') && (readin[i][j] != char(9))){
	    if (start == 7){user_value[user_value.size() - 1].push_back(' ');}
	    user_value[user_value.size() - 1].push_back(readin[i][j]);
	    start = 6;
	  }
	  else {start++;}
	}

	/*
	else if (start == 5 || start == 6){
	  if (((readin[i][j] == ' ') || (readin[i][j] == char(9))) && start == 5){}
	  else if ((readin[i][j] != ' ') && (readin[i][j] != char(9))){
	    user_value[user_value.size() - 1].push_back(readin[i][j]);
	    if (start != 6){start = 6;}
	  }
	  else {start++;}
	}
	*/

	else {break;}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

