#include "header.hpp"

void summary_generic::determination_runtime_result(){
  Logger logger("summary_generic::determination_runtime_result");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "switch_reference = " << osi->switch_reference << endline_flush;

  //  int x_m = 0;

  //  int x_q = 0;
  int x_q = osi->no_qTcut_reference_TSV;
  int x_s = osi->no_reference_TSV;
  int x_r = osi->no_scale_ren_reference_TSV;
  int x_f = osi->no_scale_fact_reference_TSV;

  logger << LOG_DEBUG << "default output from TSV (in summary routine):" << endline_flush;
  logger << LOG_DEBUG << "name_reference_TSV          = " << osi->name_reference_TSV << endline_flush;
  logger << LOG_DEBUG << "no_reference_TSV            = " << osi->no_reference_TSV << endline_flush;
  logger << LOG_DEBUG << "no_scale_ren_reference_TSV  = " << osi->no_scale_ren_reference_TSV << endline_flush;
  logger << LOG_DEBUG << "no_scale_fact_reference_TSV = " << osi->no_scale_fact_reference_TSV << endline_flush;
  logger << LOG_DEBUG << "no_qTcut_reference_TSV      = " << osi->no_qTcut_reference_TSV << endline_flush;

  // runtime extrapolation determination:

  for (int i_o = 0; i_o < yorder.size(); i_o++){
    yorder[i_o]->error2_time = 0.;
    for (int i_l = 0; i_l < yorder[i_o]->contribution_file.size(); i_l++){
      int x_l = mapping_contribution_file[yorder[i_o]->contribution_file[i_l]];
      logger << LOG_DEBUG << "yorder[" << i_o << "]->resultdirectory = " << setw(15) << yorder[i_o]-> resultdirectory << "   xlist[" << x_l << "]: error2_time = " << xlist[x_l]->xcontribution[0]->xsubprocess[0]->error2_time << endline_flush;
      yorder[i_o]->error2_time += xlist[x_l]->xcontribution[0]->xsubprocess[0]->error2_time;
    }
    logger << LOG_DEBUG << "yorder[" << i_o << "]->resultdirectory = " << setw(15) << yorder[i_o]-> resultdirectory << " :           error2_time = " << yorder[i_o]->error2_time << endline_flush;
  }

  vector<double> order_cross_section(yorder.size());
  vector<double> order_relative_error(yorder.size());
  for (int i_o = 0; i_o < order_cross_section.size(); i_o++){
    //    logger << LOG_DEBUG << "yorder[" << i_o << "].accuracy_no_normalization = " << yorder[i_o]->accuracy_no_normalization << endline_flush;

    //    logger << LOG_DEBUG << "osi->switch_reference = " << osi->switch_reference << endline_flush;
    if (osi->switch_reference == "TSV"){
      logger << LOG_DEBUG << "yorder[" << i_o << "]:   [0][0][" << x_s << "][" << x_r << "][" << x_f << "]:   result_TSV = " << setw(15) << setprecision(8) << yorder[yorder[i_o]->accuracy_no_normalization]->result_TSV[0][0][x_s][x_r][x_f] << " +- " << setw(15) << setprecision(8) << yorder[yorder[i_o]->accuracy_no_normalization]->deviation_TSV[0][0][x_s][x_r][x_f] << "   acc_rel = " << yorder[i_o]->accuracy_relative << endline_flush;
      order_cross_section[i_o] = yorder[yorder[i_o]->accuracy_no_normalization]->result_TSV[0][0][x_s][x_r][x_f];
    }
    else if (osi->switch_reference == "CV"){
      logger << LOG_DEBUG << "yorder[yorder[" << i_o << "].accuracy_no_normalization = " << yorder[i_o]->accuracy_no_normalization << "].result_CV[0][0][" << osi->no_central_scale_CV << "] = " << yorder[yorder[i_o]->accuracy_no_normalization]->result_CV[0][0][osi->no_central_scale_CV] << endline_flush;

      order_cross_section[i_o] = yorder[yorder[i_o]->accuracy_no_normalization]->result_CV[0][0][osi->no_central_scale_CV];
      ///      order_cross_section[i_o] = yorder[yorder[i_o]->accuracy_no_normalization]->result_CV[0][0][0][osi->no_central_scale_CV];
    }
    else {logger << LOG_FATAL << "Should not happen! No reference scale selected." << endline_flush; exit(1);}
    order_relative_error[i_o] = yorder[i_o]->accuracy_relative;

    //    logger << LOG_INFO << "order_cross_section[" << i_o << "] = " << order_cross_section[i_o] << "   order_relative_error[" << i_o << "] = " << order_relative_error[i_o] << endline_flush;

  }



  //  Doesn't seem to work in general !!!
  //  First calculate extrapolated runtime from each order (later to be generalied to distributions, tail-enhancement runs, etc.)

  //  ERT[i_l][j_o][i_c][i_p] -> xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->extrapolated_runtime  based on  order_cross_section[x_o = CiO[j_o]]
  vector<vector<vector<vector<double> > > > ERT(xlist.size());

  vector<vector<int> > CiO(xlist.size());
  for (int i_l = 0; i_l < xlist.size(); i_l++){
    for (int i_o = 0; i_o < yorder.size(); i_o++){
      for (int j_l = 0; j_l < yorder[i_o]->contribution_file.size(); j_l++){
	if (i_l == mapping_contribution_file[yorder[i_o]->contribution_file[j_l]]){
	 CiO[i_l].push_back(i_o);
	 break;
	}
      }
    }

    ERT[i_l].resize(CiO[i_l].size());
    for (int j_o = 0; j_o < CiO[i_l].size(); j_o++){
      // probably not needed here:
      //      int x_o = CiO[i_l][j_o];
      ERT[i_l][j_o].resize(xlist[i_l]->xcontribution.size());
      ERT[i_l][j_o][0].resize(1, 0.);
      for (int i_c = 1; i_c < xlist[i_l]->xcontribution.size(); i_c++){
	ERT[i_l][j_o][i_c].resize(xlist[i_l]->xcontribution[i_c]->xsubprocess.size(), 0.);
      }
    }
  }

  //  ESD[i_l][j_o][i_c][i_p] -> xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_deviation  based on  order_cross_section[x_o = CiO[j_o]]
  vector<vector<vector<vector<double> > > > ESD = ERT;
  //  ESND[i_l][j_o][i_c][i_p] -> xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization_deviation  based on  order_cross_section[x_o = CiO[j_o]]
  vector<vector<vector<vector<double> > > > ESND = ERT;
  //  ESN[i_l][j_o][i_c][i_p] -> xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization  based on  order_cross_section[x_o = CiO[j_o]]
  vector<vector<vector<vector<double> > > > ESN = ERT;
  //  ESE[i_l][j_o][i_c][i_p] -> xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->extrapolated_n_event  based on  order_cross_section[x_o = CiO[j_o]]
  vector<vector<vector<vector<double> > > > ENE = ERT; // should finally be 'long long' or so...


  for (int i_l = 0; i_l < xlist.size(); i_l++){
    for (int j_o = 0; j_o < CiO[i_l].size(); j_o++){
      int x_o = CiO[i_l][j_o];
      
      /*
      ERT[i_l][j_o][0][0] = 0.;
      ESD[i_l][j_o][0][0] = 0.;
      ESND[i_l][j_o][0][0] = 0.;
      */ // 1 -> 0
      for (int i_c = 0; i_c < xlist[i_l]->xcontribution.size(); i_c++){
	ERT[i_l][j_o][i_c][0] = 0.;
	ESD[i_l][j_o][i_c][0] = 0.;
	ESND[i_l][j_o][i_c][0] = 0.;
 	if (i_c == 0){continue;}

	for (int i_p = 1; i_p < xlist[i_l]->xcontribution[i_c]->xsubprocess.size(); i_p++){

	  int switch_zero_contribution = 0;
	  if (osi->switch_reference == "TSV"){
	    logger << LOG_DEBUG << "xlist[" << i_l << "]->resultdirectory = " << xlist[i_l]->resultdirectory << endline_flush;
	    logger << LOG_DEBUG << "xlist[" << i_l << "].xcontribution[" << i_c << "]->infix_contribution = " << xlist[i_l]->xcontribution[i_c]->infix_contribution << endline_flush;
	    logger << LOG_DEBUG << "xlist[" << i_l << "].xcontribution[" << i_c << "].xsubprocess[" << i_p << "]->name = " << xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->name << endline_flush;
	    logger << LOG_DEBUG << "xlist[" << i_l << "].xcontribution[" << i_c << "].xsubprocess[" << i_p << "].result_TSV[0].size() = " << xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->result_TSV[0].size() << endline_flush;
	    //	    logger << LOG_DEBUG << "xlist[" << i_l << "].xcontribution[" << i_c << "].xsubprocess[" << i_p << "].result_TSV[0][0] = " << xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->result_TSV[0][x_q][x_s][x_r][x_f] << endline_flush;
	    //	    if (xlist[i_l]->xcontribution[i_c]->active_qTcut && no_qTcut_runtime_estimate){x_q = no_qTcut_runtime_estimate;}
	    // No dummy copies for subprocess result_TSV are created any longer: y_q -> 0 required in the relevant cases !!!
	    int y_q = 0;
	    if (xlist[i_l]->xcontribution[i_c]->active_qTcut){y_q = x_q;}
	    // Check why x_q was reset and y_q not used !!!
	    if (xlist[i_l]->xcontribution[i_c]->active_qTcut && no_qTcut_runtime_estimate){y_q = no_qTcut_runtime_estimate;}
	    if (xlist[i_l]->xcontribution[i_c]->type_contribution == "PT" || xlist[i_l]->xcontribution[i_c]->type_contribution == "PT2" || xlist[i_l]->xcontribution[i_c]->type_contribution == "L2PT"){y_q = xlist[i_l]->xcontribution[i_c]->output_n_qTcut - 1;}
	    // Try setting y_q instead of x_q (until here) !!!
	    if (xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->result_TSV[0][y_q][x_s][x_r][x_f] == 0.){switch_zero_contribution = 1;}
	    if (xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->result_TSV[0][y_q][x_s][x_r][x_f] == 0.){switch_zero_contribution = 1;}
	    logger << LOG_DEBUG << "xlist[" << i_l << "].xcontribution[" << i_c << "].xsubprocess[" << i_p << "].result_TSV[0][" << y_q << "][" << x_s << "][" << x_r << "][" << x_f << "] = " << xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->result_TSV[0][y_q][x_s][x_r][x_f] << endline_flush;
	  }
	  else if (osi->switch_reference == "CV"){
	    // check why zero !!!
	    if (xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->result_CV[0][0] == 0.){switch_zero_contribution = 1;}
	  }

	  if (switch_zero_contribution){
	    ERT[i_l][j_o][i_c][i_p] = 0.;
	    ENE[i_l][j_o][i_c][i_p] = 0.;
	    ESD[i_l][j_o][i_c][i_p] = 0.;
	    ESN[i_l][j_o][i_c][i_p] = 0.;
	    ESND[i_l][j_o][i_c][i_p] = 0.;
	  }
	  else {
	    //  error2_time  seems to actually contain the sqrt of how it is named, i.e.  error * sqrt(time) !!!
	    ERT[i_l][j_o][i_c][i_p] = yorder[x_o]->error2_time * xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->error2_time / pow(order_relative_error[x_o] * order_cross_section[x_o], 2);

	    // ERT[i_l][j_o][i_c][0]  contains the sum of the extrapolated runtimes of all subprocesses in  xlist[i_l]->xcontribution[i_c] :
	    ERT[i_l][j_o][i_c][0] += ERT[i_l][j_o][i_c][i_p];

	    // ENE[i_l][j_o][i_c][i_p]  converts  extrapolated_runtime  for each subprocess into  extrapolated_n_event  by using respective  time_per_event :
	    ENE[i_l][j_o][i_c][i_p] = ERT[i_l][j_o][i_c][i_p] / xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->time_per_event;

	    // ESD[i_l][j_o][i_c][i_p]  states final absolute error of each subprocess :
	    ESD[i_l][j_o][i_c][i_p] = xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->error2_time / sqrt(ERT[i_l][j_o][i_c][i_p]);

	    // ESD[i_l][j_o][i_c][0]  states (temporarily) square of final absolute error of complete contribution  xlist[i_l]->xcontribution[i_c] :
	    ESD[i_l][j_o][i_c][0] += pow(ESD[i_l][j_o][i_c][i_p], 2);

	    //  ESN[i_l][j_o][i_c][i_p]  contains reference cross section  order_cross_section[x_o]  (defined by order  x_o ):
	    ESN[i_l][j_o][i_c][i_p] = order_cross_section[x_o];

	    //  ESN[i_l][j_o][i_c][i_p]_deviation  contains square of relative error of each subprocess  wrt.  order_cross_section[x_o] :
	    ESND[i_l][j_o][i_c][i_p] = ESD[i_l][j_o][i_c][i_p] / order_cross_section[x_o];
	    //  ESND[i_l][j_o][i_c][0]  contains sum of squares of relative errors of all subprocesses in  xlist[i_l]->xcontribution[i_c] :
	    ESND[i_l][j_o][i_c][0] += pow(ESND[i_l][j_o][i_c][i_p], 2);
	  }
	}

	//  ERT[i_l][j_o][0][0]  contatins sum of runtimes of all contributions in  xlist[i_l] :
	ERT[i_l][j_o][0][0] += ERT[i_l][j_o][i_c][0];

	//  ESN[i_l][j_o][0][0]  contains  order_cross_section[x_o]  (defined by order  x_o ):
	ESN[i_l][j_o][0][0] = order_cross_section[x_o];
	//  ESN[i_l][j_o][i_c][0]  contains  order_cross_section[x_o]  (defined by order  x_o ):
	ESN[i_l][j_o][i_c][0] = order_cross_section[x_o];

	//  ESD[i_l][j_o][0][0]  contains (temporarily) sum of  squares of absolute errors of all contributions in  xlist[i_l] :
	ESD[i_l][j_o][0][0] += ESD[i_l][j_o][i_c][0];

	//  ESD[i_l][j_o][i_c][0]  contains sqrt of sum of absolute errors of all subprocesses in  xlist[i_l]->xcontribution[i_c] :
	ESD[i_l][j_o][i_c][0] = sqrt(ESD[i_l][j_o][i_c][0]);

	//  ESND[i_l][j_o][0][0]  contains (temporarily) sum of  squares of relative errors of all contributions in  xlist[i_l] :
	ESND[i_l][j_o][0][0] += ESND[i_l][j_o][i_c][0];

	//  ESND[i_l][j_o][i_c][0]  contains sqrt of sum of relative errors of all subprocesses in  xlist[i_l]->xcontribution[i_c] :
	ESND[i_l][j_o][i_c][0] = sqrt(ESND[i_l][j_o][i_c][0]);

	// ???
	ENE[i_l][j_o][0][0] = 0.;
      }
      // again ???
      ESN[i_l][j_o][0][0] = order_cross_section[x_o];

      //  ESD[i_l][j_o][0][0]  contains sqrt of sum of squares of absolute errors of all contributions in  xlist[i_l] :
      ESD[i_l][j_o][0][0] = sqrt(ESD[i_l][j_o][0][0]);
      //  ESND[i_l][j_o][0][0]  contains sqrt of sum of squares of relative errors of all contributions in  xlist[i_l] :
      ESND[i_l][j_o][0][0] = sqrt(ESND[i_l][j_o][0][0]);
    }
  }



  // Output for extrapolated runtimes based on all possible reference cross sections:

  stringstream temp_ss;
  for (int i_l = 0; i_l < xlist.size(); i_l++){
    for (int j_o = 0; j_o < CiO[i_l].size(); j_o++){
      int x_o = CiO[i_l][j_o];
      temp_ss << left << "Output based on reference cross section  order_cross_section[" << x_o << " -> " << yorder[x_o]->resultdirectory << "] = " << order_cross_section[x_o] << endline;
      temp_ss << endline;
      for (int i_c = 0; i_c < xlist[i_l]->xcontribution.size(); i_c++){
	//	stringstream temp;
	temp_ss << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution;
	temp_ss << left << setw(20) << xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->name;
	temp_ss << time_hms_from_double(ERT[i_l][j_o][i_c][0]) << "   ";
	temp_ss << left << setw(16) << "";
	temp_ss << right << setw(16) << setprecision(8) << ESND[i_l][j_o][i_c][0];
	temp_ss << right << setw(16) << setprecision(8) << ESN[i_l][j_o][i_c][0];
	temp_ss << right << setw(16) << setprecision(8) << ESD[i_l][j_o][i_c][0];
	temp_ss << endline;
	//	temp_ss << temp.str() << endline;
	if (i_c == 0){for (int i_s = 0; i_s < 133; i_s++){temp_ss << "-";} temp_ss << endline;}
      }
      temp_ss << endline;
    }
  }
  logger << LOG_INFO << "Extrapolated runtimes" << endline << endline << temp_ss.str() << endline_flush;


  //  Now use  ESD[i_l][j_o][0][0]  to distinguish which order j_o [x_o]  determines the actual runtime in  xlist[i_l]:

  for (int i_l = 0; i_l < xlist.size(); i_l++){
    int y_o = -1;
    double min_ESD_selection = 1.e99;
    logger << LOG_INFO << "CiO[" << i_l << "].size() = " << CiO[i_l].size() << endline_flush;
    for (int j_o = 0; j_o < CiO[i_l].size(); j_o++){
      logger << LOG_INFO << "CiO[" << i_l << "][" << j_o << "] = " << CiO[i_l][j_o] << endline_flush;
       //      int x_o = CiO[i_l][j_o];
      logger << LOG_INFO << "ESD[" << i_l << "][" << j_o << "][0][0] = " << ESD[i_l][j_o][0][0] << "   min_ESD_selection = " << min_ESD_selection << endline_flush;
      if (ESD[i_l][j_o][0][0] < min_ESD_selection){y_o = j_o; min_ESD_selection = ESD[i_l][j_o][0][0];}
    }
    if (y_o == -1){logger << LOG_FATAL << "No reference cross section found! for  xlist[" << i_l << "] = " << xlist[i_l]->resultdirectory << endline_flush; exit(1);}

    for (int i_c = 0; i_c < xlist[i_l]->xcontribution.size(); i_c++){
      for (int i_p = 0; i_p < xlist[i_l]->xcontribution[i_c]->xsubprocess.size(); i_p++){
	xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->extrapolated_runtime = ERT[i_l][y_o][i_c][i_p];
	xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->extrapolated_n_event = ENE[i_l][y_o][i_c][i_p];
	xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_deviation = ESD[i_l][y_o][i_c][i_p];
	xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization = ESN[i_l][y_o][i_c][i_p];
	xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->extrapolated_sigma_normalization_deviation = ESND[i_l][y_o][i_c][i_p];

      }
    }

    int x_o = CiO[i_l][y_o];
    //    logger.newLine(LOG_INFO);
    //    logger << LOG_INFO << left << "Output based on *selected* reference cross section  order_cross_section[" << x_o << " -> " << yorder[x_o]->resultdirectory << "] = " << order_cross_section[x_o] << endline_flush;
    //    logger.newLine(LOG_INFO);
    stringstream temp_ss;
    for (int i_c = 0; i_c < xlist[i_l]->xcontribution.size(); i_c++){
      //      stringstream temp;
      temp_ss << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution;
      temp_ss << left << setw(20) << xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->name;
      temp_ss << time_hms_from_double(ERT[i_l][y_o][i_c][0]) << "   ";
      temp_ss << left << setw(16) << "";
      temp_ss << right << setw(16) << setprecision(8) << ESND[i_l][y_o][i_c][0];
      temp_ss << right << setw(16) << setprecision(8) << ESN[i_l][y_o][i_c][0];
      temp_ss << right << setw(16) << setprecision(8) << ESD[i_l][y_o][i_c][0];

      //      logger << LOG_INFO << left << setw(25) << "folder" << setw(20) << "subprocess" << setw(21) << right << "runtime" << "   " << setw(12) << "n_event" << "   " << setw(16) << "deviation" << setw(16) << "norm" << setw(16) << "norm_err" << endline_flush;
      temp_ss << endline;
      //      temp_ss << temp.str() << endline_flush;
      if (i_c == 0){for (int i_s = 0; i_s < 129; i_s++){temp_ss << "-";} temp_ss << endline;}
    }
    //    logger.newLine(LOG_INFO);
    logger << LOG_INFO << left << "Used runtimes for xlist[" << i_l << "] = " << xlist[i_l]->resultdirectory << endline << endline << "Output based on *selected* reference cross section  order_cross_section[" << x_o << " -> " << yorder[x_o]->resultdirectory << "] = " << order_cross_section[x_o] << endline << endline << temp_ss.str() << endline_flush;
  }


  //////////////////////////////////////////////////////
  //  Output information about extrapolated runtimes  //
  //////////////////////////////////////////////////////

  output_runtime_extrapolated();

  ////////////////////////////////////////////////////////////////////////////////
  //  Output information about extrapolated runtimes - input for MATRIX script  //
  ////////////////////////////////////////////////////////////////////////////////

  output_runtime_MATRIX();

  //////////////////////////////////////////////
  //  Output information about used runtimes  //
  //////////////////////////////////////////////

  output_runtime_used();
  output_combined_used_runtime();

  /////////////////////////////////////////////////////////////////////
  //  Output for new run directories based on extrapolated runtimes  //
  /////////////////////////////////////////////////////////////////////

  if (switch_generate_rundirectories){generate_rundirectories();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}




void summary_generic::output_runtime_used(){
  Logger logger("summary_generic::output_runtime_used");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename;
  double runtime_used_complete = 0.;
  for (int i_l = 0; i_l < xlist.size(); i_l++){runtime_used_complete += xlist[i_l]->xcontribution[0]->xsubprocess[0]->used_runtime;}

  ofstream outfile_used;
  filename = final_resultdirectory + "/info.used.runtime.txt";
  outfile_used.open(filename.c_str(), ofstream::out | ofstream::trunc);
  outfile_used << "Overview over contributions   " << setprecision(8) << setw(16) << runtime_used_complete / 24 / 60 / 60 << " d" << endline;
  for (int i_s = 0; i_s < 27; i_s++){outfile_used << "=";} outfile_used << endline;
  outfile_used << endline;
  outfile_used << left << setw(25) << "folder" << setw(20) << "" << setw(21) << right << "runtime" << endline;
  outfile_used << endline;

  outfile_used << left << setw(25) << "complete";
  outfile_used << left << setw(20) << "";
  outfile_used << time_hms_from_double(runtime_used_complete) << "   ";
  outfile_used << endline;
  for (int i_s = 0; i_s < 66; i_s++){outfile_used << "=";} outfile_used << endline;
  outfile_used << endline;

  for (int i_l = 0; i_l < xlist.size(); i_l++){
    for (int i_c = 0; i_c < xlist[i_l]->xcontribution.size(); i_c++){
      stringstream temp_ext_runtime;
      outfile_used << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution;
      outfile_used << left << setw(5) << xlist[i_l]->name_channel_selection;
      //      if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){outfile_used << left << setw(5) << xlist[i_l]->channel_selection;}
      //      else {outfile_used << left << setw(5) << "";}
      if (i_c == 0){outfile_used << left << setw(10) << xlist[i_l]->name_extra_selection;}
      else {outfile_used << left << setw(10) << xlist[i_l]->xcontribution[i_c]->name_extra_selection_contribution;}
     //      if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){outfile_used << left << setw(10) << xlist[i_l]->extra_selection;}
      //      else {outfile_used << left << setw(10) << "";}
      outfile_used << left << setw(5) << ""; //xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->name;
      outfile_used << time_hms_from_double(xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->used_runtime) << "   ";
      outfile_used << endline;
      if (i_c == 0){for (int i_s = 0; i_s < 66; i_s++){outfile_used << "-";} outfile_used << endline;}
    }
    outfile_used << endline;
  }
  outfile_used << endline;
  outfile_used << "Overview over subprocesses" << endline;
  for (int i_s = 0; i_s < 26; i_s++){outfile_used << "=";} outfile_used << endline;
  outfile_used << endline;
  outfile_used << left << setw(25) << "folder" << setw(20) << "subprocess" << setw(16) << right << "runtime" << "   " << setw(12) << "n_event" << "   " << setw(16) << "deviation" << setw(16) << "norm" << setw(16) << "norm_err" << endline;
  outfile_used << endline;
  for (int i_l = 0; i_l < xlist.size(); i_l++){xlist[i_l]->output_used_runtime(outfile_used);}
  outfile_used.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}



void summary_generic::output_combined_used_runtime(){
  Logger logger("summary_generic::output_combined_used_runtime");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename;
  double runtime_used_complete = 0.;
  for (int i_l = 0; i_l < xlist.size(); i_l++){runtime_used_complete += xlist[i_l]->xcontribution[0]->xsubprocess[0]->used_runtime;}

  ofstream outfile_used;
  filename = final_resultdirectory + "/info.combined.used.runtime.txt";
  outfile_used.open(filename.c_str(), ofstream::out | ofstream::trunc);
  double temp_used_runtime = 0.;
  for (int i_m = 0; i_m < extended_directory_name.size(); i_m++){
    for (int i_l = 0; i_l < xlist.size(); i_l++){
      for (int i_c = 1; i_c < xlist[i_l]->xcontribution.size(); i_c++){
	if (xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->used_runtime_group.size() == 0){continue;}
	temp_used_runtime += xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->used_runtime_group[i_m];
      }
    }
  }

  outfile_used << "Overview over contributions   " << setprecision(8) << setw(16) << temp_used_runtime / 24 / 60 / 60 << " d" << endline;
  //  outfile_used << "Overview over contributions   " << setprecision(8) << setw(16) << runtime_used_complete / 24 / 60 / 60 << " d" << endline;
  for (int i_s = 0; i_s < 27; i_s++){outfile_used << "=";} outfile_used << endline;
  outfile_used << endline;
  outfile_used << left << setw(25) << "folder" << setw(20) << "" << setw(12) << "" << setw(21) << right << "runtime" << endline;
  outfile_used << endline;
  outfile_used << left << setw(25) << "complete" << setw(20) << "" << setw(12) << "combined" << time_hms_from_double(temp_used_runtime) << "   " << endline;
  for (int i_s = 0; i_s < 78; i_s++){outfile_used << "-";} outfile_used << endline;

  for (int i_m = 0; i_m < extended_directory_name.size(); i_m++){
    double temp_used_runtime = 0.;
    for (int i_l = 0; i_l < xlist.size(); i_l++){
      for (int j_c = 1; j_c < xlist[i_l]->xcontribution.size(); j_c++){
	if (xlist[i_l]->xcontribution[j_c]->xsubprocess[0]->used_runtime_group.size() == 0){continue;}
	temp_used_runtime += xlist[i_l]->xcontribution[j_c]->xsubprocess[0]->used_runtime_group[i_m];
      }
    }
    outfile_used << left << setw(25) << "complete" << setw(20) << "" << setw(12) << extended_directory_name[i_m] << time_hms_from_double(temp_used_runtime) << "   " << endline;
    //    outfile_used << left << setw(25) << "complete" << setw(20) << "" << setw(12) << xlist[0]->xcontribution[1]->extended_directory_name[i_m] << time_hms_from_double(temp_used_runtime) << "   " << endline;
  }
  for (int i_s = 0; i_s < 78; i_s++){outfile_used << "=";} outfile_used << endline;
  outfile_used << endline;

  for (int i_l = 0; i_l < xlist.size(); i_l++){
    for (int i_c = 0; i_c < xlist[i_l]->xcontribution.size(); i_c++){
      if (i_c == 0){
	double temp_used_runtime = 0.;
	for (int j_c = 1; j_c < xlist[i_l]->xcontribution.size(); j_c++){
	  for (int i_m = 0; i_m < xlist[i_l]->xcontribution[j_c]->extended_directory_name.size(); i_m++){
	    if (xlist[i_l]->xcontribution[j_c]->xsubprocess[0]->used_runtime_group.size() == 0){continue;}
	    temp_used_runtime += xlist[i_l]->xcontribution[j_c]->xsubprocess[0]->used_runtime_group[i_m];
	  }
	}
	//	outfile_used << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution << setw(20) << "" << setw(12) << "combined" << time_hms_from_double(temp_used_runtime) << "   " << endline;
	outfile_used << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution;
	outfile_used << left << setw(5) << xlist[i_l]->name_channel_selection;
	//	if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){outfile_used << left << setw(5) << xlist[i_l]->channel_selection;}
	//	else {outfile_used << left << setw(5) << "";}
	if (i_c == 0){outfile_used << left << setw(10) << xlist[i_l]->name_extra_selection;}
	else {outfile_used << left << setw(10) << xlist[i_l]->xcontribution[i_c]->name_extra_selection_contribution;}

	//	if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){outfile_used << left << setw(10) << xlist[i_l]->extra_selection;}
	//	else {outfile_used << left << setw(10) << "";}
	outfile_used << left << setw(5) << "";
	outfile_used << setw(12) << "combined" << time_hms_from_double(temp_used_runtime) << "   " << endline;

	for (int i_s = 0; i_s < 78; i_s++){outfile_used << "-";} outfile_used << endline;
	for (int i_m = 0; i_m < xlist[i_l]->xcontribution[0]->extended_directory_name.size(); i_m++){
	  double temp_used_runtime = 0.;
	  for (int j_c = 1; j_c < xlist[i_l]->xcontribution.size(); j_c++){
	    if (xlist[i_l]->xcontribution[j_c]->xsubprocess[0]->used_runtime_group.size() == 0){continue;}
	    temp_used_runtime += xlist[i_l]->xcontribution[j_c]->xsubprocess[0]->used_runtime_group[i_m];
	  }
	  // xcontribution[1] ???
	  //	  outfile_used << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution << setw(20) << "" << setw(12) << xlist[i_l]->xcontribution[i_c]->extended_directory_name[i_m] << time_hms_from_double(temp_used_runtime) << "   " << endline;
	  outfile_used << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution;
	  outfile_used << left << setw(5) << xlist[i_l]->name_channel_selection;
	  //	  if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){outfile_used << left << setw(5) << xlist[i_l]->channel_selection;}
	  //	  else {outfile_used << left << setw(5) << "";}
	  if (i_c == 0){outfile_used << left << setw(10) << xlist[i_l]->name_extra_selection;}
	  else {outfile_used << left << setw(10) << xlist[i_l]->xcontribution[i_c]->name_extra_selection_contribution;}
	  //	  if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){outfile_used << left << setw(10) << xlist[i_l]->extra_selection;}
	  //	  else {outfile_used << left << setw(10) << "";}
	  outfile_used << left << setw(5) << "";
	  outfile_used << setw(12) << xlist[i_l]->xcontribution[i_c]->extended_directory_name[i_m] << time_hms_from_double(temp_used_runtime) << "   " << endline;
	  //	  outfile_used << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution << setw(20) << "" << setw(12) << xlist[i_l]->xcontribution[1]->extended_directory_name[i_m] << time_hms_from_double(temp_used_runtime) << "   " << endline;
	}
	for (int i_s = 0; i_s < 78; i_s++){outfile_used << "=";} outfile_used << endline;
	outfile_used << endline;
      }
      //      bool switch_mapping = false;
      //      if (xcontribution[i_c]->extended_directory.size() > 1){switch_mapping = true;}
      //      if (xlist[i_l]->switch_mapping){
      else {
	double temp_used_runtime = 0.;
	for (int i_m = 0; i_m < xlist[i_l]->xcontribution[i_c]->extended_directory_name.size(); i_m++){
	  if (xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->used_runtime_group.size() == 0){continue;}
	  temp_used_runtime += xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->used_runtime_group[i_m];
	}
	outfile_used << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution;
	outfile_used << left << setw(5) << xlist[i_l]->name_channel_selection;
	//	if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){outfile_used << left << setw(5) << xlist[i_l]->channel_selection;}
	//	else {outfile_used << left << setw(5) << "";}
	if (i_c == 0){outfile_used << left << setw(10) << xlist[i_l]->name_extra_selection;}
	else {outfile_used << left << setw(10) << xlist[i_l]->xcontribution[i_c]->name_extra_selection_contribution;}
	//	if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){outfile_used << left << setw(10) << xlist[i_l]->extra_selection;}
	//	else {outfile_used << left << setw(10) << "";}
	outfile_used << left << setw(5) << "";
	outfile_used << setw(12) << "combined" << time_hms_from_double(temp_used_runtime) << "   " << endline;
	
	for (int i_s = 0; i_s < 78; i_s++){outfile_used << "-";} outfile_used << endline;
	for (int i_m = 0; i_m < xlist[i_l]->xcontribution[i_c]->extended_directory_name.size(); i_m++){
	  if (xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->used_runtime_group.size() == 0){continue;}
	  outfile_used << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution;
	  outfile_used << left << setw(5) << xlist[i_l]->name_channel_selection;
	  //	  outfile_used << left << setw(5) << xlist[i_l]->channel_selection;
	  //	  if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){outfile_used << left << setw(5) << xlist[i_l]->channel_selection;}
	  //	  else {outfile_used << left << setw(5) << "";}
	  if (i_c == 0){outfile_used << left << setw(10) << xlist[i_l]->name_extra_selection;}
	  else {outfile_used << left << setw(10) << xlist[i_l]->xcontribution[i_c]->name_extra_selection_contribution;}

	  //	  if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){outfile_used << left << setw(10) << xlist[i_l]->extra_selection;}
	  //	  else {outfile_used << left << setw(10) << "";}
	  outfile_used << left << setw(5) << "";
	  outfile_used << setw(12) << xlist[i_l]->xcontribution[i_c]->extended_directory_name[i_m] << time_hms_from_double(xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->used_runtime_group[i_m]) << "   " << endline;
	}
	for (int i_s = 0; i_s < 78; i_s++){outfile_used << "=";} outfile_used << endline;
	outfile_used << endline;
      }
    }
    outfile_used << endline;
  }
  outfile_used << endline;


  outfile_used << "Overview over subprocesses" << endline;
  for (int i_s = 0; i_s < 26; i_s++){outfile_used << "=";} outfile_used << endline;
  outfile_used << endline;
  outfile_used << left << setw(25) << "folder" << setw(20) << "subprocess" << setw(12) << "" << setw(21) << right << "runtime" << "   " << setw(12) << "n_event" << "   " << setw(16) << "deviation" << setw(16) << "norm" << setw(16) << "norm_err" << endline;
  outfile_used << endline;
  for (int i_l = 0; i_l < xlist.size(); i_l++){xlist[i_l]->output_combined_used_runtime(outfile_used);}
  outfile_used.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}



void summary_generic::output_runtime_extrapolated(){
  Logger logger("summary_generic::output_runtime_extrapolated");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename;
  double runtime_extrapolated_complete = 0.;
  for (int i_l = 0; i_l < xlist.size(); i_l++){
    logger << LOG_DEBUG << "xlist[" << i_l << "].xcontribution[0]->xsubprocess[0]->extrapolated_runtime = " << xlist[i_l]->xcontribution[0]->xsubprocess[0]->extrapolated_runtime << endline_flush;
  }
  for (int i_l = 0; i_l < xlist.size(); i_l++){runtime_extrapolated_complete += xlist[i_l]->xcontribution[0]->xsubprocess[0]->extrapolated_runtime;}
  // check double-counting (of runtimes) around here !!!
  for (int i_l = 0; i_l < xlist.size(); i_l++){
    logger << LOG_DEBUG << "xlist[" << i_l << "].xcontribution[0]->xsubprocess[0]->extrapolated_runtime = " << xlist[i_l]->xcontribution[0]->xsubprocess[0]->extrapolated_runtime << endline_flush;
  }
  logger << LOG_DEBUG << "runtime_extrapolated_complete = " << runtime_extrapolated_complete << endline_flush;

  ofstream outfile_extrapolated;
  filename = final_resultdirectory + "/info.extrapolated.runtime.txt";
  outfile_extrapolated.open(filename.c_str(), ofstream::out | ofstream::trunc);
  outfile_extrapolated << "Overview over contributions   " << setprecision(8) << setw(16) << runtime_extrapolated_complete / 24 / 60 / 60 << " d" << endline;
  for (int i_s = 0; i_s < 27; i_s++){outfile_extrapolated << "=";} outfile_extrapolated << endline;
  outfile_extrapolated << endline;
  outfile_extrapolated << left << setw(25) << "folder" << setw(20) << "" << setw(21) << right << "runtime" << "   " << setw(12) << "" << "   " << setw(15) << "deviation" << setw(15) << "norm" << setw(15) << "norm_err" << endline;
  outfile_extrapolated << endline;

  outfile_extrapolated << left << setw(25) << "complete";
  outfile_extrapolated << left << setw(20) << "";
  outfile_extrapolated << time_hms_from_double(runtime_extrapolated_complete) << "   ";

  outfile_extrapolated << endline;
  for (int i_s = 0; i_s < 129; i_s++){outfile_extrapolated << "=";} outfile_extrapolated << endline;
  outfile_extrapolated << endline;

  for (int i_l = 0; i_l < xlist.size(); i_l++){
    for (int i_c = 0; i_c < xlist[i_l]->xcontribution.size(); i_c++){
      //      logger << LOG_DEBUG << "xlist[" << i_l << "].xcontribution[" << i_c << "].xsubprocess[0]->extrapolated_runtime = " << xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->extrapolated_runtime << endline_flush;
      outfile_extrapolated << left << setw(25) << xlist[i_l]->xcontribution[i_c]->infix_path_contribution;
      outfile_extrapolated << left << setw(5) << xlist[i_l]->name_channel_selection;
      //      if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){outfile_extrapolated << left << setw(5) << xlist[i_l]->channel_selection;}
      //      else {outfile_extrapolated << left << setw(5) << "";}
      if (i_c == 0){outfile_extrapolated << left << setw(10) << xlist[i_l]->name_extra_selection;}
      else {outfile_extrapolated << left << setw(10) << xlist[i_l]->xcontribution[i_c]->name_extra_selection_contribution;}
      //      if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){outfile_extrapolated << left << setw(10) << xlist[i_l]->extra_selection;}
      //      else {outfile_extrapolated << left << setw(10) << "";}
      outfile_extrapolated << left << setw(5) << ""; //xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->name;
      //      outfile_extrapolated << left << setw(20) << xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->name;
      outfile_extrapolated << time_hms_from_double(xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->extrapolated_runtime) << "   ";
      outfile_extrapolated << left << setw(12) << "" << "   ";
      outfile_extrapolated << right << setw(15) << setprecision(8) << xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->extrapolated_sigma_normalization_deviation;
      outfile_extrapolated << right << setw(15) << setprecision(8) << xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->extrapolated_sigma_normalization;
      outfile_extrapolated << right << setw(15) << setprecision(8) << xlist[i_l]->xcontribution[i_c]->xsubprocess[0]->extrapolated_sigma_deviation;

      //      outfile_extrapolated << left << setw(25) << "folder" << setw(20) << "subprocess" << setw(21) << right << "runtime" << "   " << setw(12) << "n_event" << "   " << setw(16) << "deviation" << setw(16) << "norm" << setw(16) << "norm_err" << endline;

      outfile_extrapolated << endline;
      if (i_c == 0){for (int i_s = 0; i_s < 129; i_s++){outfile_extrapolated << "-";} outfile_extrapolated << endline;}
    }
    outfile_extrapolated << endline;
  }
  outfile_extrapolated << endline;
  outfile_extrapolated << "Overview over subprocesses" << endline;
  for (int i_s = 0; i_s < 26; i_s++){outfile_extrapolated << "=";} outfile_extrapolated << endline;
  outfile_extrapolated << endline;
  outfile_extrapolated << left << setw(25) << "folder" << setw(20) << "subprocess" << setw(21) << right << "runtime" << "   " << setw(12) << "n_event" << "   " << setw(15) << "deviation" << setw(15) << "norm" << setw(15) << "norm_err" << endline;
  outfile_extrapolated << endline;
  for (int i_l = 0; i_l < xlist.size(); i_l++){xlist[i_l]->output_extrapolated_runtime(outfile_extrapolated);}
  outfile_extrapolated.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}



void summary_generic::generate_rundirectories(){
  Logger logger("summary_generic::generate_rundirectories");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  n_run_phasespace_optimization = phasespace_optimization.size();
  if (phasespace_optimization.size() > 1){n_run_phasespace_optimization = phasespace_optimization.size() - 1;}
  // phasespace_optimization has "combined" as its last entry, which does not contain individual contributions.
  
  newrundir_phasespace_optimization.resize(n_run_phasespace_optimization);
  for (int i_m = 0; i_m < n_run_phasespace_optimization; i_m++){newrundir_phasespace_optimization[i_m] = "newrundir" + dot_phasespace_optimization[i_m];}
  
  start_phasespace_optimization.resize(n_run_phasespace_optimization);
  for (int i_m = 0; i_m < n_run_phasespace_optimization; i_m++){start_phasespace_optimization[i_m] = "start" + dot_phasespace_optimization[i_m];}
  
  // create newrundir also for channel_selection contributions:
  channel_selection.clear();
  name_channel_selection.clear();
  dot_channel_selection.clear();
  slash_channel_selection.clear();
  for (int i_l = 0; i_l < xlist.size(); i_l++){
    bool flag = false;
    for (int i_c = 0; i_c < channel_selection.size(); i_c++){
      if (xlist[i_l]->channel_selection == channel_selection[i_c]){flag = true; break;}
    }
    if (!flag){
      channel_selection.push_back(xlist[i_l]->channel_selection);
      name_channel_selection.push_back(xlist[i_l]->name_channel_selection);
      dot_channel_selection.push_back(xlist[i_l]->dot_channel_selection);
      slash_channel_selection.push_back(xlist[i_l]->slash_channel_selection);
    }
  }
  n_channel_selection = channel_selection.size();

  logger << LOG_INFO << "n_run_phasespace_optimization  = " << n_run_phasespace_optimization << endline_flush;
  logger << LOG_INFO << "phasespace_optimization.size() = " << phasespace_optimization.size() << endline_flush;
  logger << LOG_INFO << "n_channel_selection            = " << n_channel_selection << endline_flush;

  newrundir_channel_phasespace_optimization.resize(n_channel_selection, vector<string> (n_run_phasespace_optimization));
  start_channel_phasespace_optimization.resize(n_channel_selection, vector<string> (n_run_phasespace_optimization));
  runlist_channel_phasespace_optimization.resize(n_channel_selection, vector<string> (n_run_phasespace_optimization));
  path_newrundir_channel_phasespace_optimization_result_list_runs.resize(n_channel_selection, vector<string> (n_run_phasespace_optimization));

  path_newrundir_channel_phasespace_optimization_result_infile_runs.resize(n_channel_selection, vector<string> (phasespace_optimization.size()));
 
  for (int i_c = 0; i_c < channel_selection.size(); i_c++){
    system_execute(logger, "mkdir " + final_resultdirectory + "/" + "newrundir" + slash_channel_selection[i_c]);
    for (int i_m = 0; i_m < n_run_phasespace_optimization; i_m++){
      //      start_channel_phasespace_optimization[i_c][i_m] = "start" + dot_channel_selection[i_c] + dot_phasespace_optimization[i_m];
      start_channel_phasespace_optimization[i_c][i_m] = "start" + slash_channel_selection[i_c] + slash_phasespace_optimization[i_m];
      runlist_channel_phasespace_optimization[i_c][i_m] = "result/list.runs" + slash_channel_selection[i_c] + slash_phasespace_optimization[i_m];
      newrundir_channel_phasespace_optimization[i_c][i_m] = "newrundir" + slash_channel_selection[i_c] + slash_phasespace_optimization[i_m];
      //      newrundir_channel_phasespace_optimization[i_c][i_m] = "newrundir" + dot_channel_selection[i_c] + dot_phasespace_optimization[i_m];
      path_newrundir_channel_phasespace_optimization_result_list_runs[i_c][i_m] = final_resultdirectory + "/newrundir/result/list.runs" + slash_channel_selection[i_c] + slash_phasespace_optimization[i_m];
      logger << LOG_INFO << "newrundir_channel_phasespace_optimization[" << i_c << "][" << i_m << "] = " << newrundir_channel_phasespace_optimization[i_c][i_m] << endline_flush;
      logger << LOG_INFO << "start_channel_phasespace_optimization[" << i_c << "][" << i_m << "] = " << start_channel_phasespace_optimization[i_c][i_m] << endline_flush;
      logger << LOG_INFO << "runlist_channel_phasespace_optimization[" << i_c << "][" << i_m << "] = " << runlist_channel_phasespace_optimization[i_c][i_m] << endline_flush;
      logger << LOG_INFO << "path_newrundir_channel_phasespace_optimization_result_list_runs[" << i_c << "][" << i_m << "] = " << path_newrundir_channel_phasespace_optimization_result_list_runs[i_c][i_m] << endline_flush;
    }
    for (int i_m = 0; i_m < phasespace_optimization.size(); i_m++){
      path_newrundir_channel_phasespace_optimization_result_infile_runs[i_c][i_m] = final_resultdirectory + "/newrundir/result/infile.runs" + slash_channel_selection[i_c] + slash_phasespace_optimization[i_m];
      logger << LOG_INFO << "path_newrundir_channel_phasespace_optimization_result_infile_runs[" << i_c << "][" << i_m << "] = " << path_newrundir_channel_phasespace_optimization_result_infile_runs[i_c][i_m] << endline_flush;
    }
  }



  for (int i_c = 0; i_c < channel_selection.size(); i_c++){
    for (int i_m = 0; i_m < n_run_phasespace_optimization; i_m++){
      system_execute(logger, "mkdir " + final_resultdirectory + "/" + newrundir_channel_phasespace_optimization[i_c][i_m]);
      system_execute(logger, "mkdir " + final_resultdirectory + "/" + newrundir_channel_phasespace_optimization[i_c][i_m] + "/start");
      system_execute(logger, "mkdir " + final_resultdirectory + "/" + newrundir_channel_phasespace_optimization[i_c][i_m] + "/result");
      system_execute(logger, "mkdir " + final_resultdirectory + "/" + newrundir_channel_phasespace_optimization[i_c][i_m] + "/result/infile.runs");
      system_execute(logger, "mkdir " + final_resultdirectory + "/" + newrundir_channel_phasespace_optimization[i_c][i_m] + "/result/list.runs");
      // to be superseded by path_newrundir_channel_phasespace_optimization_result_list_runs[i_c][i_m] !!!
      system_execute(logger, "mkdir " + final_resultdirectory + "/newrundir/" + start_channel_phasespace_optimization[i_c][i_m]);
      system_execute(logger, "mkdir " + path_newrundir_channel_phasespace_optimization_result_list_runs[i_c][i_m]);
    }
    for (int i_m = 0; i_m < phasespace_optimization.size(); i_m++){
      system_execute(logger, "mkdir " + path_newrundir_channel_phasespace_optimization_result_infile_runs[i_c][i_m]);
    }
  }

  bool switch_channel_selection = false;
  bool switch_optimization_selection = false;
  logger << LOG_INFO << "n_channel_selection = " << n_channel_selection << endline_flush;
  logger << LOG_INFO << "n_run_phasespace_optimization = " << n_run_phasespace_optimization << endline_flush;
  for (int i_m = 0; i_m < n_run_phasespace_optimization; i_m++){
    logger << LOG_INFO << "phasespace_optimization[" << i_m << "] = " << phasespace_optimization[i_m] << "   " << dot_phasespace_optimization[i_m] << endline;
  }
  if (n_channel_selection > 1){switch_channel_selection = true;}
  if (n_run_phasespace_optimization > 1){switch_optimization_selection = true;}

  if (switch_channel_selection){
    for (int i_cs = 0; i_cs < n_channel_selection; i_cs++){
      ofstream out_runscript_complete_main_channel;
      string runscript_complete_name_main_channel = final_resultdirectory + "/newrundir/start/MUNICH.complete" + dot_channel_selection[i_cs] + ".start.sh";
      out_runscript_complete_main_channel.open(runscript_complete_name_main_channel.c_str(), ofstream::out | ofstream::trunc);
      out_runscript_complete_main_channel << "channel" << endline;
      for (int i_m = 0; i_m < n_run_phasespace_optimization; i_m++){
	out_runscript_complete_main_channel << "./start" << slash_channel_selection[i_cs] + slash_phasespace_optimization[i_m] << "/MUNICH.complete.start.sh" << endline;
      }
      out_runscript_complete_main_channel.close();
      system_execute(logger, "chmod 744 " + runscript_complete_name_main_channel);
    }
  }

  if (switch_optimization_selection){
    for (int i_m = 0; i_m < n_run_phasespace_optimization; i_m++){
      ofstream out_runscript_complete_main_optimization;
      string runscript_complete_name_main_optimization = final_resultdirectory + "/newrundir/start/MUNICH.complete" + dot_phasespace_optimization[i_m] + ".start.sh";
      if (phasespace_optimization[i_m] == "---"){runscript_complete_name_main_optimization = final_resultdirectory + "/newrundir/start/MUNICH.complete.standard.start.sh";}
      out_runscript_complete_main_optimization.open(runscript_complete_name_main_optimization.c_str(), ofstream::out | ofstream::trunc);
      out_runscript_complete_main_optimization << "optimization" << endline;
      for (int i_cs = 0; i_cs < n_channel_selection; i_cs++){
	out_runscript_complete_main_optimization << "./start" << slash_channel_selection[i_cs] + slash_phasespace_optimization[i_m] << "/MUNICH.complete.start.sh" << endline;
      }
      out_runscript_complete_main_optimization.close();
      system_execute(logger, "chmod 744 " + runscript_complete_name_main_optimization);
    }
  }
  
  ofstream out_import_complete_main;
  string import_complete_name_main = final_resultdirectory + "/newrundir.import.sh";
  out_import_complete_main.open(import_complete_name_main.c_str(), ofstream::out | ofstream::trunc);
  /*
  if (switch_channel_selection || switch_optimization_selection){
    for (int i_cs = 0; i_cs < n_channel_selection; i_cs++){
      for (int i_m = 0; i_m < n_run_phasespace_optimization; i_m++){
	//	out_import_complete_main << "cp -r -p result/" << final_resultdirectory << "/newrundir" << dot_channel_selection[i_cs] << dot_phasespace_optimization[i_m] << "/* ../" << name_mainrundirectory << dot_channel_selection[i_cs] << dot_phasespace_optimization[i_m] << "/" << endline;
	out_import_complete_main << "cp -r -p result/" << final_resultdirectory << "/" << newrundir_channel_phasespace_optimization[i_cs][i_m] << "/* ." << slash_channel_selection[i_cs] << slash_phasespace_optimization[i_m] << "/" << endline;
      }
    }
  }
  */
  out_import_complete_main << "cp -r -p result/" << final_resultdirectory << "/newrundir/* ." << endline;
  out_import_complete_main.close();
  system_execute(logger, "chmod 744 " + import_complete_name_main );


  vector<vector<int> > counter_complete_process(n_channel_selection, vector<int> (n_run_phasespace_optimization, 0));
  vector<vector<vector<int> > > counter_list_process(n_channel_selection, vector<vector<int> > (n_run_phasespace_optimization, vector<int> (xlist.size() , 0)));
  vector<vector<vector<vector<int> > > > counter_contribution_process(n_channel_selection, vector<vector<vector<int> > > (n_run_phasespace_optimization, vector<vector<int> > (xlist.size())));

  ofstream out_runscript_main;
  string runscript_name_main;
  if (n_channel_selection > 1 && n_run_phasespace_optimization > 1){runscript_name_main = final_resultdirectory + "/newrundir/start/MUNICH.complete.CHS.PSO.start.sh";}
  else if (n_channel_selection > 1){runscript_name_main = final_resultdirectory + "/newrundir/start/MUNICH.complete.CHS.start.sh";}
  else {runscript_name_main = final_resultdirectory + "/newrundir/start/MUNICH.complete.---.start.sh";}
  out_runscript_main.open(runscript_name_main.c_str(), ofstream::out | ofstream::trunc);
  
  for (int i_cs = 0; i_cs < n_channel_selection; i_cs++){
    for (int i_m = 0; i_m < n_run_phasespace_optimization; i_m++){
      ofstream out_runscript_complete;
      /*
      string runscript_complete_name = final_resultdirectory + "/" + newrundir_channel_phasespace_optimization[i_cs][i_m] + "/MUNICH.complete.start.sh";
      logger << LOG_DEBUG << "runscript_complete_name = " << runscript_complete_name << endline_flush;
      if (runscript_name_main == runscript_complete_name){
	logger << LOG_INFO << "WARNING: EQUAL FILENAME   runscript_name_main = runscript_complete_name = " << runscript_name_main << endline_flush;
      }
      out_runscript_complete.open(runscript_complete_name.c_str(), ofstream::out | ofstream::trunc);
      */
      ofstream out_runscript_complete_main;
      string runscript_complete_name_main = final_resultdirectory + "/newrundir/start" + slash_channel_selection[i_cs] + slash_phasespace_optimization[i_m] + "/MUNICH.complete.start.sh";
      logger << LOG_DEBUG << "runscript_complete_name_main = " << runscript_complete_name_main << endline_flush;
      if (runscript_name_main == runscript_complete_name_main){
	logger << LOG_INFO << "WARNING: EQUAL FILENAME   runscript_name_main = runscript_complete_name_main = " << runscript_complete_name_main << endline_flush;
      }
      out_runscript_complete_main.open(runscript_complete_name_main.c_str(), ofstream::out | ofstream::trunc);
  
      out_runscript_main << "./start" << slash_channel_selection[i_cs] + slash_phasespace_optimization[i_m] << "/MUNICH.complete.start.sh" << endline;

      int counter_separation = 8 + 30 + 3 + 5 + 3 + 10 + 5 + 5 + 3 + 5 + 2;
      ofstream out_processlist_complete;
      string runlist_complete_name = final_resultdirectory + "/" + newrundir_channel_phasespace_optimization[i_cs][i_m] + "/list.run.subprocesses.complete" + ".txt";
      out_processlist_complete.open(runlist_complete_name.c_str(), ofstream::out | ofstream::trunc);
      for (int i_l = 0; i_l < xlist.size(); i_l++){
	if (xlist[i_l]->channel_selection != channel_selection[i_cs]){continue;}
	ofstream out_processlist_list;
	string name_processscript_list = final_resultdirectory + "/" + newrundir_channel_phasespace_optimization[i_cs][i_m] + "/start" + "/list.run.subprocesses." + xlist[i_l]->xcontribution[0]->infix_order_contribution + xlist[i_l]->dot_extra_selection +".txt";
	logger << LOG_DEBUG << "name_processscript_list = " << name_processscript_list << endline_flush;
	out_processlist_list.open(name_processscript_list.c_str(), ofstream::out | ofstream::trunc);
	ofstream out_runscript_list;
	string name_runscript_list = final_resultdirectory + "/" + newrundir_channel_phasespace_optimization[i_cs][i_m] + "/start" + "/MUNICH." + xlist[i_l]->xcontribution[0]->infix_order_contribution + xlist[i_l]->dot_extra_selection + ".start.sh";
	out_runscript_list.open(name_runscript_list.c_str(), ofstream::out | ofstream::trunc);
	logger << LOG_DEBUG << "name_runscript_list = " << name_runscript_list << endline_flush;

	ofstream out_runscript_list_main;
	string name_runscript_list_main = final_resultdirectory + "/newrundir/start" + slash_channel_selection[i_cs] + slash_phasespace_optimization[i_m] + "/MUNICH." + xlist[i_l]->xcontribution[0]->infix_order_contribution + xlist[i_l]->dot_extra_selection + ".start.sh";
	out_runscript_list_main.open(name_runscript_list_main.c_str(), ofstream::out | ofstream::trunc);
	logger << LOG_DEBUG << "name_runscript_list_main = " << name_runscript_list_main << endline_flush;

	counter_contribution_process[i_cs][i_m][i_l].resize(xlist[i_l]->xcontribution.size(), 0);
	for (int i_c = 1; i_c < xlist[i_l]->xcontribution.size(); i_c++){
	  xlist[i_l]->xcontribution[i_c]->output_extrapolated_runtime_directories(i_cs, i_m, counter_contribution_process[i_cs][i_m][i_l][i_c]);
	  out_processlist_list << right << setw(8) << "" << setw(30) << left << xlist[i_l]->xcontribution[i_c]->infix_order_contribution << "     ";
	  out_processlist_list << setw(5) << xlist[i_l]->channel_selection << "   ";
	  out_processlist_list << setw(10) << xlist[i_l]->xcontribution[i_c]->extra_selection_contribution << "     ";
	  out_processlist_list << right << setw(5) << counter_contribution_process[i_cs][i_m][i_l][i_c];
	  out_processlist_list << " ( " << setw(5) << xlist[i_l]->xcontribution[i_c]->max_number_of_jobs_for_one_channel << " )" << endline;
	  out_runscript_list << "./start" << "/MUNICH." << xlist[i_l]->xcontribution[i_c]->infix_order_contribution << xlist[i_l]->xcontribution[i_c]->dot_extra_selection_contribution << ".start.sh" << endline;
	  out_runscript_list_main << "./start" << slash_channel_selection[i_cs] + slash_phasespace_optimization[i_m] << "/MUNICH." << xlist[i_l]->xcontribution[i_c]->infix_order_contribution << xlist[i_l]->xcontribution[i_c]->dot_extra_selection_contribution << ".start.sh" << endline;
	  counter_list_process[i_cs][i_m][i_l] += counter_contribution_process[i_cs][i_m][i_l][i_c];
	}
	for (int i_s = 0; i_s < counter_separation; i_s++){out_processlist_list << "=";} out_processlist_list << endline;
	//	out_processlist_list << right << setw(8) << "========" << setw(30) << "==============================" << "===" << "=====" << "===" << "==========" << "=====" << "=====" << "===" << "=====" << "==" << endline;
	out_processlist_list << right << setw(8) << "" << setw(30) << left << xlist[i_l]->xcontribution[0]->infix_order_contribution << "   ";
	out_processlist_list << setw(5) << xlist[i_l]->channel_selection << "   ";
	out_processlist_list << setw(10) << xlist[i_l]->extra_selection << "     ";
	out_processlist_list << right << setw(5) << counter_list_process[i_cs][i_m][i_l] << endline;
	out_processlist_list.close();

	out_runscript_list.close();
	system_execute(logger, "chmod 744 " + name_runscript_list);
	out_runscript_list_main.close();
	system_execute(logger, "chmod 744 " + name_runscript_list_main);
	
	///	out_runscript_complete << "./start" << "/MUNICH." << xlist[i_l]->xcontribution[0]->infix_order_contribution << xlist[i_l]->dot_extra_selection << ".start.sh" << endline;
	out_runscript_complete_main << "./start" << slash_channel_selection[i_cs] + slash_phasespace_optimization[i_m] << "/MUNICH." << xlist[i_l]->xcontribution[0]->infix_order_contribution << xlist[i_l]->dot_extra_selection << ".start.sh" << endline;

	//	out_runscript_main << "./start" << slash_channel_selection[i_cs] + slash_phasespace_optimization[i_m] << "/MUNICH." << xlist[i_l]->xcontribution[0]->infix_order_contribution << xlist[i_l]->dot_extra_selection << ".start.sh" << endline;
	  
	out_processlist_complete << right << setw(8) << "" << setw(30) << left << xlist[i_l]->xcontribution[0]->infix_order_contribution << "   " << setw(5) << xlist[i_l]->channel_selection << "   " << setw(10) << xlist[i_l]->extra_selection << "     " << right << setw(5) << counter_list_process[i_cs][i_m][i_l] << endline;
	counter_complete_process[i_cs][i_m] += counter_list_process[i_cs][i_m][i_l];
      }
      ///      out_runscript_complete.close();
      ///      system_execute(logger, "chmod 744 " + runscript_complete_name);

      out_runscript_complete_main.close();
      system_execute(logger, "chmod 744 " + runscript_complete_name_main);

      for (int i_s = 0; i_s < counter_separation; i_s++){out_processlist_complete << "=";} out_processlist_complete << endline;
      //      out_processlist_complete << right << setw(8) << "========" << setw(30) << "==============================" << "===" << "=====" << "===" << "==========" << "=====" << "=====" << "===" << "=====" << "==" << endline;
      out_processlist_complete << right << setw(8) << "" << setw(30) << left << "complete" << "     ";
      out_processlist_complete << setw(5) << "" << "   " << setw(10) << "" << "   ";
      out_processlist_complete << right << setw(5) << counter_complete_process[i_cs][i_m] << endline;
      out_processlist_complete.close();
    }
  }
  out_runscript_main.close();
  system_execute(logger, "chmod 744 " + runscript_name_main);


  // version to fill newrundir/result/infile.runs/...

  for (int i_cs = 0; i_cs < channel_selection.size(); i_cs++){
    for (int i_m = 0; i_m < phasespace_optimization.size(); i_m++){
      for (int i_l = 0; i_l < xlist.size(); i_l++){
	if (xlist[i_l]->channel_selection != channel_selection[i_cs]){continue;}
	ofstream out_infile_result_sub;
	string infile_result_sub_name;
	infile_result_sub_name = path_newrundir_channel_phasespace_optimization_result_infile_runs[i_cs][i_m] + "/" + xlist[i_l]->xcontribution[0]->infix_order_contribution + xlist[i_l]->dot_extra_selection + ".dat";
	out_infile_result_sub.open(infile_result_sub_name.c_str(), ofstream::out | ofstream::trunc);
	write_infile_string(out_infile_result_sub, "processname", xlist[i_l]->processname);
	out_infile_result_sub << endline;
	write_infile_string(out_infile_result_sub, "resultdirectory", xlist[i_l]->xcontribution[0]->infix_order_contribution);
	write_infile_string(out_infile_result_sub, "type_perturbative_order", xlist[i_l]->type_perturbative_order);
	if (xlist[i_l]->type_subtraction_method == ""){write_infile_string(out_infile_result_sub, "subtraction_method", "---");}
	else {write_infile_string(out_infile_result_sub, "subtraction_method", xlist[i_l]->type_subtraction_method);}
	write_infile_int(out_infile_result_sub, "contribution_order_alpha_s", xlist[i_l]->in_contribution_order_alpha_s);
	write_infile_int(out_infile_result_sub, "contribution_order_alpha_e", xlist[i_l]->in_contribution_order_alpha_e);
	write_infile_int(out_infile_result_sub, "photon_induced", xlist[i_l]->photon_induced);
	write_infile_string(out_infile_result_sub, "channel_selection", xlist[i_l]->channel_selection);
	write_infile_string(out_infile_result_sub, "extra_selection", xlist[i_l]->extra_selection);
	out_infile_result_sub << endline;

	for (int i_c = 1; i_c < xlist[i_l]->xcontribution.size(); i_c++){
	  write_infile_string(out_infile_result_sub, "type_contribution", xlist[i_l]->xcontribution[i_c]->type_contribution);
	  if (xlist[i_l]->xcontribution[i_c]->type_correction == ""){write_infile_string(out_infile_result_sub, "type_correction", "---");}
	  else {write_infile_string(out_infile_result_sub, "type_correction", xlist[i_l]->xcontribution[i_c]->type_correction);}
	  write_infile_int(out_infile_result_sub, "interference", xlist[i_l]->xcontribution[i_c]->interference);
	  write_infile_string(out_infile_result_sub, "extra_selection_contribution", xlist[i_l]->xcontribution[i_c]->extra_selection_contribution);
	  if (phasespace_optimization[i_m] == "combined"){
	    for (int j_m = 0; j_m < phasespace_optimization.size() - 1; j_m++){
	      stringstream temp_ss;
	      temp_ss << runlist_channel_phasespace_optimization[i_cs][j_m] << "/runlist." << xlist[i_l]->xcontribution[i_c]->infix_order_contribution << xlist[i_l]->xcontribution[i_c]->dot_extra_selection_contribution << ".dat";
	      stringstream temp_listname;
	      temp_listname << "directory_list" << " " << name_phasespace_optimization[j_m];
	      write_infile_string(out_infile_result_sub, temp_listname.str(), temp_ss.str());
	    }
	  }
	  else {
	    stringstream temp_ss;
	    temp_ss << runlist_channel_phasespace_optimization[i_cs][i_m] << "/runlist." << xlist[i_l]->xcontribution[i_c]->infix_order_contribution << xlist[i_l]->xcontribution[i_c]->dot_extra_selection_contribution << ".dat";
	    stringstream temp_listname;
	    temp_listname << "directory_list" << " " << name_phasespace_optimization[i_m];
	    write_infile_string(out_infile_result_sub, temp_listname.str(), temp_ss.str());
	  }
	  out_infile_result_sub << endline;
	}
	out_infile_result_sub.close();
      }
    }
  }


  // version to fill newrundir..../result/infile.runs/...
  // extra result directory for channel_selection / phasespace_optimization directories (actually only used for main run, rest only useful to get appropriate summary in sub-rundirectory):

  for (int i_cs = 0; i_cs < channel_selection.size(); i_cs++){
    for (int i_m = 0; i_m < n_run_phasespace_optimization; i_m++){
      if (channel_selection[i_cs] == "---" && phasespace_optimization[i_m] == ""){continue;}
      for (int i_l = 0; i_l < xlist.size(); i_l++){
	if (xlist[i_l]->channel_selection != channel_selection[i_cs]){continue;}
	ofstream out_infile_result_sub;
	string infile_result_sub_name = final_resultdirectory + "/" + newrundir_channel_phasespace_optimization[i_cs][i_m] + "/result/infile.runs" + "/" + xlist[i_l]->xcontribution[0]->infix_order_contribution + xlist[i_l]->dot_extra_selection + ".dat";
	out_infile_result_sub.open(infile_result_sub_name.c_str(), ofstream::out | ofstream::trunc);
	write_infile_string(out_infile_result_sub, "processname", xlist[i_l]->processname);
	out_infile_result_sub << endline;
	write_infile_string(out_infile_result_sub, "resultdirectory", xlist[i_l]->xcontribution[0]->infix_order_contribution);
	write_infile_string(out_infile_result_sub, "type_perturbative_order", xlist[i_l]->type_perturbative_order);
	if (xlist[i_l]->type_subtraction_method == ""){write_infile_string(out_infile_result_sub, "subtraction_method", "---");}
	else {write_infile_string(out_infile_result_sub, "subtraction_method", xlist[i_l]->type_subtraction_method);}
	write_infile_int(out_infile_result_sub, "contribution_order_alpha_s", xlist[i_l]->in_contribution_order_alpha_s);
	write_infile_int(out_infile_result_sub, "contribution_order_alpha_e", xlist[i_l]->in_contribution_order_alpha_e);
	write_infile_int(out_infile_result_sub, "photon_induced", xlist[i_l]->photon_induced);
	write_infile_string(out_infile_result_sub, "channel_selection", xlist[i_l]->channel_selection);
	write_infile_string(out_infile_result_sub, "extra_selection", xlist[i_l]->extra_selection);
	out_infile_result_sub << endline;

	for (int i_c = 1; i_c < xlist[i_l]->xcontribution.size(); i_c++){
	  write_infile_string(out_infile_result_sub, "type_contribution", xlist[i_l]->xcontribution[i_c]->type_contribution);
	  if (xlist[i_l]->xcontribution[i_c]->type_correction == ""){write_infile_string(out_infile_result_sub, "type_correction", "---");}
	  else {write_infile_string(out_infile_result_sub, "type_correction", xlist[i_l]->xcontribution[i_c]->type_correction);}
	  write_infile_int(out_infile_result_sub, "interference", xlist[i_l]->xcontribution[i_c]->interference);
	  write_infile_string(out_infile_result_sub, "extra_selection_contribution", xlist[i_l]->xcontribution[i_c]->extra_selection_contribution);
	  stringstream temp_ss;
	  temp_ss << "result/list.runs" << "/runlist." << xlist[i_l]->xcontribution[i_c]->infix_order_contribution << xlist[i_l]->xcontribution[i_c]->dot_extra_selection_contribution << ".dat";
	  string temp_listname = "directory_list";
	  write_infile_string(out_infile_result_sub, temp_listname, temp_ss.str());
	  out_infile_result_sub << endline;
	}
	out_infile_result_sub.close();
      }
    }
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}



void summary_generic::output_runtime_MATRIX(){
  Logger logger("summary_generic::output_runtime_MATRIX");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename;
  ofstream outfile_readin_extrapolated;
  filename = final_resultdirectory + "/runtime.dat";
  outfile_readin_extrapolated.open(filename.c_str(), ofstream::out | ofstream::trunc);
  //  outfile_readin_extrapolated << left << setw(25) << "# folder" << setw(20) << "subprocess" << setw(12) << right << "runtime(s)" << "   " << setw(12) << "n_event" << "   " << setw(15) << "deviation" << setw(15) << "norm" << setw(15) << "norm_err" << endline;
  outfile_readin_extrapolated << left << setw(25) << "# folder" << setw(15) << "optimization" << setw(20) << "subprocess" << setw(12) << right << "runtime(s)" << "   " << setw(12) << "n_event" << "   " << setw(15) << "deviation" << setw(15) << "norm" << setw(15) << "norm_err" << endline;
  for (int i_l = 0; i_l < xlist.size(); i_l++){xlist[i_l]->output_runtime_MATRIX(outfile_readin_extrapolated);}
  outfile_readin_extrapolated.close();

  system_execute(logger, "cp -p " + final_resultdirectory + "/runtime.dat runtime.dat");
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

