#include "header.hpp"

#include "ppaa02.phasespace.set.hpp"

void ppaa02_phasespace_set::ax_psp_220_bbx_aagg(int x_a){
  static Logger logger("ppaa02_phasespace_set::ax_psp_220_bbx_aagg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(18);
  needed_v_smin[x_a].resize(18);
  needed_v_smin[x_a][  0] = {  24,   25,   26,   27,   28,   29,    5,    6,   17,   18}; //  10
  needed_v_smin[x_a][  1] = {   0,    4,   19,   23}; //   4
  needed_v_smin[x_a][  2] = {   0,    4}; //   2
  needed_v_smin[x_a][  3] = {   1,    2,   21,   22}; //   4
  needed_v_smin[x_a][  4] = {   1,    2}; //   2
  needed_v_smin[x_a][  5] = {   3,    8,   15,   20}; //   4
  needed_v_smin[x_a][  6] = {   3,   15}; //   2
  needed_v_smin[x_a][  7] = {   5,    6,   25,   26,   28}; //   5
  needed_v_smin[x_a][  8] = {   7,   11,   12,   16}; //   4
  needed_v_smin[x_a][  9] = {   7,   11}; //   2
  needed_v_smin[x_a][ 10] = {   8,   20}; //   2
  needed_v_smin[x_a][ 11] = {   9,   10,   13,   14}; //   4
  needed_v_smin[x_a][ 12] = {   9,   10}; //   2
  needed_v_smin[x_a][ 13] = {  12,   16}; //   2
  needed_v_smin[x_a][ 14] = {  13,   14}; //   2
  needed_v_smin[x_a][ 15] = {  17,   18,   24,   27,   29}; //   5
  needed_v_smin[x_a][ 16] = {  19,   23}; //   2
  needed_v_smin[x_a][ 17] = {  21,   22}; //   2

  v_smax[x_a].resize(10);
  needed_v_smax[x_a].resize(10);
  needed_v_smax[x_a][  0] = {  24,   25,   26,   27,   28,   29,    5,    6,   17,   18}; //  10
  needed_v_smax[x_a][  1] = {   0,    4,   19,   23}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    4,    5,    6,   25,   26,   28}; //   9
  needed_v_smax[x_a][  3] = {   1,    2,   21,   22}; //   4
  needed_v_smax[x_a][  4] = {   3,    8,   15,   20}; //   4
  needed_v_smax[x_a][  5] = {   3,    7,   11,   15,   19,   23}; //   6
  needed_v_smax[x_a][  6] = {   7,   11,   12,   16}; //   4
  needed_v_smax[x_a][  7] = {   8,    9,   10,   20,   21,   22}; //   6
  needed_v_smax[x_a][  8] = {   9,   10,   13,   14}; //   4
  needed_v_smax[x_a][  9] = {  12,   13,   14,   16,   17,   18,   24,   27,   29}; //   9

  g_p[x_a].resize(1);
  needed_g_p[x_a].resize(1);
  needed_g_p[x_a][0] = {  24,   25,   26,   27,   28,   29}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");

  g_f[x_a].resize(18);
  needed_g_f[x_a].resize(18);
  needed_g_f[x_a][0] = {   0,    4,   19,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   0,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][2] = {   1,    2,   21,   22}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");
  needed_g_f[x_a][4] = {   3,    8,   15,   20}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][5] = {   3,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax5");
  needed_g_f[x_a][6] = {   5,    6,   17,   18}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][7] = {   5,    6,   25,   26,   28}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax2");
  needed_g_f[x_a][8] = {   7,   11,   12,   16}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax6");
  needed_g_f[x_a][9] = {   7,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax5");
  needed_g_f[x_a][10] = {   8,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax7");
  needed_g_f[x_a][11] = {   9,   10,   13,   14}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][12] = {   9,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax7");
  needed_g_f[x_a][13] = {  12,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax9");
  needed_g_f[x_a][14] = {  13,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax9");
  needed_g_f[x_a][15] = {  17,   18,   24,   27,   29}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax9");
  needed_g_f[x_a][16] = {  19,   23}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax5");
  needed_g_f[x_a][17] = {  21,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax7");

  g_t[x_a].resize(46);
  needed_g_t[x_a].resize(46);
  needed_g_t[x_a][0] = {   0,    1,    2,    4,    5,    6,   26,   28}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_32");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__32_8");
  needed_g_t[x_a][6] = {   3,    7,   11,   15,   19,   23}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][7] = {   3,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__4_8");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__16_8");
  needed_g_t[x_a][10] = {   5,    6,   26}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_32");
  needed_g_t[x_a][12] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__32_16");
  needed_g_t[x_a][13] = {   7,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_20");
  needed_g_t[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__4_16");
  needed_g_t[x_a][15] = {   8,    9,   10,   20,   21,   22}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][16] = {   8,   20}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][17] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__4_8");
  needed_g_t[x_a][18] = {   9,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][19] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__4_32");
  needed_g_t[x_a][20] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][21] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__16_4");
  needed_g_t[x_a][22] = {  12,   13,   14,   16,   17,   18,   27,   29}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][23] = {  12,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][24] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][25] = {  13,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_36");
  needed_g_t[x_a][26] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__4_32");
  needed_g_t[x_a][27] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__32_4");
  needed_g_t[x_a][28] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__8_4");
  needed_g_t[x_a][29] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__16_4");
  needed_g_t[x_a][30] = {  17,   18,   27}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][31] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_32");
  needed_g_t[x_a][32] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__32_16");
  needed_g_t[x_a][33] = {  19,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_24");
  needed_g_t[x_a][34] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__8_16");
  needed_g_t[x_a][35] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__8_4");
  needed_g_t[x_a][36] = {  21,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][37] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__8_32");
  needed_g_t[x_a][38] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][39] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__16_8");
  needed_g_t[x_a][40] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][41] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][42] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][43] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_8");
  needed_g_t[x_a][44] = {  28}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__48_8");
  needed_g_t[x_a][45] = {  29}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__48_4");

  g_d[x_a].resize(1);
  needed_g_d[x_a].resize(1);
  needed_g_d[x_a][0] = {  24,   25,   26,   27,   28,   29}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(30);
  c_f[x_a].resize(30);
  c_t[x_a].resize(30);
  c_d[x_a].resize(30);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  0,   3,   5}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  4,   5}; //   2
  c_t[x_a][3] = {  6,   7,   8}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  0,   1}; //   2
  c_t[x_a][4] = {  0,   1,   9}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  6,   7}; //   2
  c_t[x_a][5] = {  0,  10,  11}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  6,   7}; //   2
  c_t[x_a][6] = {  0,  10,  12}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  8,   9}; //   2
  c_t[x_a][7] = {  6,  13,  14}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  4,  10}; //   2
  c_t[x_a][8] = { 15,  16,  17}; //   3
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = { 11,  12}; //   2
  c_t[x_a][9] = { 15,  18,  19}; //   3
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = { 11,  12}; //   2
  c_t[x_a][10] = { 15,  18,  20}; //   3
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  8,   9}; //   2
  c_t[x_a][11] = {  6,  13,  21}; //   3
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {}; //   0
  c_f[x_a][12] = {  8,  13}; //   2
  c_t[x_a][12] = { 22,  23,  24}; //   3
  c_d[x_a][12] = {}; //   0

  c_p[x_a][13] = {}; //   0
  c_f[x_a][13] = { 11,  14}; //   2
  c_t[x_a][13] = { 22,  25,  26}; //   3
  c_d[x_a][13] = {}; //   0

  c_p[x_a][14] = {}; //   0
  c_f[x_a][14] = { 11,  14}; //   2
  c_t[x_a][14] = { 22,  25,  27}; //   3
  c_d[x_a][14] = {}; //   0

  c_p[x_a][15] = {}; //   0
  c_f[x_a][15] = {  4,   5}; //   2
  c_t[x_a][15] = {  6,   7,  28}; //   3
  c_d[x_a][15] = {}; //   0

  c_p[x_a][16] = {}; //   0
  c_f[x_a][16] = {  8,  13}; //   2
  c_t[x_a][16] = { 22,  23,  29}; //   3
  c_d[x_a][16] = {}; //   0

  c_p[x_a][17] = {}; //   0
  c_f[x_a][17] = {  6,  15}; //   2
  c_t[x_a][17] = { 22,  30,  31}; //   3
  c_d[x_a][17] = {}; //   0

  c_p[x_a][18] = {}; //   0
  c_f[x_a][18] = {  6,  15}; //   2
  c_t[x_a][18] = { 22,  30,  32}; //   3
  c_d[x_a][18] = {}; //   0

  c_p[x_a][19] = {}; //   0
  c_f[x_a][19] = {  0,  16}; //   2
  c_t[x_a][19] = {  6,  33,  34}; //   3
  c_d[x_a][19] = {}; //   0

  c_p[x_a][20] = {}; //   0
  c_f[x_a][20] = {  4,  10}; //   2
  c_t[x_a][20] = { 15,  16,  35}; //   3
  c_d[x_a][20] = {}; //   0

  c_p[x_a][21] = {}; //   0
  c_f[x_a][21] = {  2,  17}; //   2
  c_t[x_a][21] = { 15,  36,  37}; //   3
  c_d[x_a][21] = {}; //   0

  c_p[x_a][22] = {}; //   0
  c_f[x_a][22] = {  2,  17}; //   2
  c_t[x_a][22] = { 15,  36,  38}; //   3
  c_d[x_a][22] = {}; //   0

  c_p[x_a][23] = {}; //   0
  c_f[x_a][23] = {  0,  16}; //   2
  c_t[x_a][23] = {  6,  33,  39}; //   3
  c_d[x_a][23] = {}; //   0

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = { 15}; //   1
  c_t[x_a][24] = { 40,  41}; //   2
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  0}; //   1
  c_f[x_a][25] = {  7}; //   1
  c_t[x_a][25] = { 42,  43}; //   2
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  0}; //   1
  c_f[x_a][26] = {  7}; //   1
  c_t[x_a][26] = {  0,  10}; //   2
  c_d[x_a][26] = {  0}; //   1

  c_p[x_a][27] = {  0}; //   1
  c_f[x_a][27] = { 15}; //   1
  c_t[x_a][27] = { 22,  30}; //   2
  c_d[x_a][27] = {  0}; //   1

  c_p[x_a][28] = {  0}; //   1
  c_f[x_a][28] = {  7}; //   1
  c_t[x_a][28] = {  0,  44}; //   2
  c_d[x_a][28] = {  0}; //   1

  c_p[x_a][29] = {  0}; //   1
  c_f[x_a][29] = { 15}; //   1
  c_t[x_a][29] = { 22,  45}; //   2
  c_d[x_a][29] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_bbx_aagg
//  channel    0: 1111(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    1: 1111(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel    2: 1111(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel    3: 1111(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    4: 1111(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel    5: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
//  channel    6: 1111(1, 2, 4, 32, 16, 8;   0,   0,   0)
//  channel    7: 1111(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel    8: 1111(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    9: 1111(1, 2, 16, 4, 32, 8;   0,   0,   0)
//  channel   10: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   11: 1111(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   12: 1111(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   13: 1111(1, 2, 8, 4, 32, 16;   0,   0,   0)
//  channel   14: 1111(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel   15: 1111(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   16: 1111(1, 2, 8, 16, 4, 32;   0,   0,   0)
//  channel   17: 1111(1, 2, 8, 16, 32, 4;   0,   0,   0)
//  channel   18: 1111(1, 2, 8, 32, 16, 4;   0,   0,   0)
//  channel   19: 1111(1, 2, 32, 8, 16, 4;   0,   0,   0)
//  channel   20: 1111(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   21: 1111(1, 2, 16, 8, 32, 4;   0,   0,   0)
//  channel   22: 1111(1, 2, 16, 32, 8, 4;   0,   0,   0)
//  channel   23: 1111(1, 2, 32, 16, 8, 4;   0,   0,   0)
//  channel   24: 2v11(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   25: 2v11(1, 2, 16, 32, 8, 4;   0,   0,   0)
//  channel   26: 12v1(1, 2, 4, 16, 32, 8;   0,   0,   0)
//  channel   27: 12v1(1, 2, 8, 16, 32, 4;   0,   0,   0)
//  channel   28: 112v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   29: 112v(1, 2, 8, 4, 16, 32;   0,   0,   0)
