#include "header.hpp"

#include "ppaa02.phasespace.set.hpp"

void ppaa02_phasespace_set::ax_psp_220_gg_aauux(int x_a){
  static Logger logger("ppaa02_phasespace_set::ax_psp_220_gg_aauux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(11);
  needed_v_smin[x_a].resize(11);
  needed_v_smin[x_a][  0] = {   4,   11,   15,   16,   21,   25,   26,   29}; //   8
  needed_v_smin[x_a][  1] = {   5,   10,   14,   17,   20,   24,   27,   28}; //   8
  needed_v_smin[x_a][  2] = {   6,    9,   13,   17,   19,   23,   27,   28}; //   8
  needed_v_smin[x_a][  3] = {   7,    8,   12,   16,   18,   22,   26,   29}; //   8
  needed_v_smin[x_a][  4] = {   8,   12,   18,    7,   22}; //   5
  needed_v_smin[x_a][  5] = {   9,   13,   19,    6,   23}; //   5
  needed_v_smin[x_a][  6] = {  10,   14,   20,    5,   24}; //   5
  needed_v_smin[x_a][  7] = {  11,   15,   21,    4,   25}; //   5
  needed_v_smin[x_a][  8] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  9] = {   0,    2}; //   2
  needed_v_smin[x_a][ 10] = {   1,    3}; //   2

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   4,   11,   15,   21,   25,   29}; //   6
  needed_v_smax[x_a][  1] = {   5,   10,   14,   20,   24,   28}; //   6
  needed_v_smax[x_a][  2] = {   6,    9,   13,   17,   19,   23,   27}; //   7
  needed_v_smax[x_a][  3] = {   7,    8,   12,   16,   18,   22,   26}; //   7
  needed_v_smax[x_a][  4] = {   8,   10,   12,   14,   18,   20,    0,    2,    5,    7,   22,   24}; //  12
  needed_v_smax[x_a][  5] = {   9,   11,   13,   15,   19,   21,    1,    3,    4,    6,   23,   25}; //  12
  needed_v_smax[x_a][  6] = {  16,   26}; //   2
  needed_v_smax[x_a][  7] = {  17,   27}; //   2
  needed_v_smax[x_a][  8] = {  28}; //   1
  needed_v_smax[x_a][  9] = {  29}; //   1
  needed_v_smax[x_a][ 10] = {   0,    1,    2,    3}; //   4

  g_p[x_a].resize(12);
  needed_g_p[x_a].resize(12);
  needed_g_p[x_a][0] = {   4,   11,   15,   21,   25,   29}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   5,   10,   14,   20,   24,   28}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   6,    9,   13,   17,   19,   23,   27}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   7,    8,   12,   16,   18,   22,   26}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   8,   12,   18}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   9,   13,   19}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {  10,   14,   20}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][7] = {  11,   15,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {  16,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][9] = {  17,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax7");
  needed_g_p[x_a][10] = {  28}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax8");
  needed_g_p[x_a][11] = {  29}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax9");

  g_f[x_a].resize(7);
  needed_g_f[x_a].resize(7);
  needed_g_f[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax10");
  needed_g_f[x_a][1] = {   0,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax4");
  needed_g_f[x_a][2] = {   1,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax5");
  needed_g_f[x_a][3] = {   4,   25}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][4] = {   5,   24}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][5] = {   6,   23}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][6] = {   7,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");

  g_t[x_a].resize(22);
  needed_g_t[x_a].resize(22);
  needed_g_t[x_a][0] = {   0,    2,   18,   20,   22,   24}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][1] = {   0,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__4_8");
  needed_g_t[x_a][3] = {   1,    3,   19,   21,   23,   25}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][4] = {   1,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__4_8");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__8_4");
  needed_g_t[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__8_4");
  needed_g_t[x_a][8] = {   4,    6,    9,   11}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__36_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__36_8");
  needed_g_t[x_a][10] = {   5,    7,    8,   10}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__20_8");
  needed_g_t[x_a][12] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__40_4");
  needed_g_t[x_a][13] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__24_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__24_4");
  needed_g_t[x_a][14] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__24_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__24_4");
  needed_g_t[x_a][15] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__40_4");
  needed_g_t[x_a][16] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__20_8");
  needed_g_t[x_a][17] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__36_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__36_8");
  needed_g_t[x_a][18] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_24");
  needed_g_t[x_a][19] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][20] = {  28}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");
  needed_g_t[x_a][21] = {  29}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(12);
  needed_g_d[x_a].resize(12);
  needed_g_d[x_a][0] = {   4,   11,   15,   16,   21,   25,   26,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {   5,   10,   14,   17,   20,   24,   27,   28}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][2] = {   6,    9,   13,   17,   19,   23,   27,   28}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   7,    8,   12,   16,   18,   22,   26,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   8,   12,   18}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   9,   13,   19}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][6] = {  10,   14,   20}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][7] = {  11,   15,   21}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][8] = {  12,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {  13,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][10] = {  16}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {  17}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(30);
  c_f[x_a].resize(30);
  c_t[x_a].resize(30);
  c_d[x_a].resize(30);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   2}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  0,   1}; //   2
  c_t[x_a][2] = {  0,   1,   6}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0,   2}; //   2
  c_t[x_a][3] = {  3,   4,   7}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  3}; //   1
  c_t[x_a][4] = {  8,   9}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {  4}; //   1
  c_t[x_a][5] = { 10,  11}; //   2
  c_d[x_a][5] = {  1}; //   1

  c_p[x_a][6] = {  2}; //   1
  c_f[x_a][6] = {  5}; //   1
  c_t[x_a][6] = {  8,  12}; //   2
  c_d[x_a][6] = {  2}; //   1

  c_p[x_a][7] = {  3}; //   1
  c_f[x_a][7] = {  6}; //   1
  c_t[x_a][7] = { 10,  13}; //   2
  c_d[x_a][7] = {  3}; //   1

  c_p[x_a][8] = {  3,   4}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = { 10}; //   1
  c_d[x_a][8] = {  4,   3}; //   2

  c_p[x_a][9] = {  2,   5}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  8}; //   1
  c_d[x_a][9] = {  5,   2}; //   2

  c_p[x_a][10] = {  1,   6}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 10}; //   1
  c_d[x_a][10] = {  6,   1}; //   2

  c_p[x_a][11] = {  0,   7}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  8}; //   1
  c_d[x_a][11] = {  7,   0}; //   2

  c_p[x_a][12] = {  3,   4}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  8,   4,   3}; //   3

  c_p[x_a][13] = {  2,   5}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  9,   5,   2}; //   3

  c_p[x_a][14] = {  1,   6}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  8,   6,   1}; //   3

  c_p[x_a][15] = {  0,   7}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  9,   7,   0}; //   3

  c_p[x_a][16] = {  3,   8}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 10,   0,   3}; //   3

  c_p[x_a][17] = {  2,   9}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 11,   1,   2}; //   3

  c_p[x_a][18] = {  3,   4}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = {  4,   3}; //   2

  c_p[x_a][19] = {  2,   5}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  3}; //   1
  c_d[x_a][19] = {  5,   2}; //   2

  c_p[x_a][20] = {  1,   6}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = {  6,   1}; //   2

  c_p[x_a][21] = {  0,   7}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  3}; //   1
  c_d[x_a][21] = {  7,   0}; //   2

  c_p[x_a][22] = {  3}; //   1
  c_f[x_a][22] = {  6}; //   1
  c_t[x_a][22] = {  0,  14}; //   2
  c_d[x_a][22] = {  3}; //   1

  c_p[x_a][23] = {  2}; //   1
  c_f[x_a][23] = {  5}; //   1
  c_t[x_a][23] = {  3,  15}; //   2
  c_d[x_a][23] = {  2}; //   1

  c_p[x_a][24] = {  1}; //   1
  c_f[x_a][24] = {  4}; //   1
  c_t[x_a][24] = {  0,  16}; //   2
  c_d[x_a][24] = {  1}; //   1

  c_p[x_a][25] = {  0}; //   1
  c_f[x_a][25] = {  3}; //   1
  c_t[x_a][25] = {  3,  17}; //   2
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  3,   8}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = { 18}; //   1
  c_d[x_a][26] = {  0,   3}; //   2

  c_p[x_a][27] = {  2,   9}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 19}; //   1
  c_d[x_a][27] = {  1,   2}; //   2

  c_p[x_a][28] = {  1,  10}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 20}; //   1
  c_d[x_a][28] = {  2,   1}; //   2

  c_p[x_a][29] = {  0,  11}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = { 21}; //   1
  c_d[x_a][29] = {  3,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_gg_aauux
//  channel    0: 1111(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    1: 1111(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    2: 1111(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel    3: 1111(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel    4: 2v11(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel    5: 2v11(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel    6: 2v11(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel    7: 2v11(1, 2, 8, 16, 4, 32;   0,   0,   0)
//  channel    8: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    9: 3yv1(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel   10: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   11: 3yv1(1, 2, 8, 4, 32, 16;   0,   0,   0)
//  channel   12: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   13: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   14: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   15: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   16: 42vv(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel   17: 42vv(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel   18: 13yv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   19: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   20: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   21: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   22: 112v(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   23: 112v(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   24: 112v(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   25: 112v(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   26: 2v2v(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel   27: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel   28: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel   29: 2v2v(1, 2, 8, 16, 4, 32;   0,   0,   0)
