#include "header.hpp"

#include "ppaa02.phasespace.set.hpp"

void ppaa02_phasespace_set::ax_psp_220_uux_aaddx(int x_a){
  static Logger logger("ppaa02_phasespace_set::ax_psp_220_uux_aaddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(15);
  needed_v_smin[x_a].resize(15);
  needed_v_smin[x_a][  0] = {   0,    1,   12,   13,   18,   19}; //   6
  needed_v_smin[x_a][  1] = {   2,    8,   11,   16}; //   4
  needed_v_smin[x_a][  2] = {   2,   16}; //   2
  needed_v_smin[x_a][  3] = {   3,    9,   10,   17}; //   4
  needed_v_smin[x_a][  4] = {   3,   17}; //   2
  needed_v_smin[x_a][  5] = {   4,    6,   10,   14}; //   4
  needed_v_smin[x_a][  6] = {   4,   14}; //   2
  needed_v_smin[x_a][  7] = {   5,    7,   11,   15}; //   4
  needed_v_smin[x_a][  8] = {   5,   15}; //   2
  needed_v_smin[x_a][  9] = {   6}; //   1
  needed_v_smin[x_a][ 10] = {   7}; //   1
  needed_v_smin[x_a][ 11] = {   8}; //   1
  needed_v_smin[x_a][ 12] = {   9}; //   1
  needed_v_smin[x_a][ 13] = {   0,   13,   19}; //   3
  needed_v_smin[x_a][ 14] = {   1,   12,   18}; //   3

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   0,    1,   12,   13,   18,   19}; //   6
  needed_v_smax[x_a][  1] = {   2,    8,   16}; //   3
  needed_v_smax[x_a][  2] = {   2,    3,   16,   17,    0,   13,   19}; //   7
  needed_v_smax[x_a][  3] = {   3,    9,   17}; //   3
  needed_v_smax[x_a][  4] = {   4,    6,   10,   14}; //   4
  needed_v_smax[x_a][  5] = {   4,    5,   14,   15,    1,   12,   18}; //   7
  needed_v_smax[x_a][  6] = {   5,    7,   11,   15}; //   4
  needed_v_smax[x_a][  7] = {   6,    8}; //   2
  needed_v_smax[x_a][  8] = {   7,    9}; //   2
  needed_v_smax[x_a][  9] = {  10}; //   1
  needed_v_smax[x_a][ 10] = {  11}; //   1

  g_p[x_a].resize(15);
  needed_g_p[x_a].resize(15);
  needed_g_p[x_a][0] = {   0,    1,   12,   13,   18,   19}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    8,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   3,    9,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   3,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][5] = {   4,    6,   10,   14}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   4,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {   5,    7,   11,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][8] = {   5,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax5");
  needed_g_p[x_a][9] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][10] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][11] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][12] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax8");
  needed_g_p[x_a][13] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax9");
  needed_g_p[x_a][14] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax10");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,   13,   19}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax2");
  needed_g_f[x_a][1] = {   1,   12,   18}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax5");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    2,    3}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][2] = {   1,    4,    5}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_8");
  needed_g_t[x_a][4] = {  12,   14,   15,   18}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][5] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][6] = {  13,   16,   17,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][7] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][8] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__48_8");
  needed_g_t[x_a][9] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__48_4");

  g_d[x_a].resize(17);
  needed_g_d[x_a].resize(17);
  needed_g_d[x_a][0] = {   0,    1,   12,   13,   18,   19}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][1] = {   2,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][2] = {   2,    8,   11,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][3] = {   3,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][4] = {   3,    9,   10,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][5] = {   4,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][6] = {   4,    6,   10,   14}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][7] = {   5,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][8] = {   5,    7,   11,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][9] = {   6,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][10] = {   6}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][11] = {   7,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][12] = {   7}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][13] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][14] = {   9}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][15] = {  10}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][16] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(20);
  c_f[x_a].resize(20);
  c_t[x_a].resize(20);
  c_d[x_a].resize(20);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  1,   2}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  1,   2}; //   2

  c_p[x_a][3] = {  3,   4}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  3,   4}; //   2

  c_p[x_a][4] = {  5,   6}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  2}; //   1
  c_d[x_a][4] = {  5,   6}; //   2

  c_p[x_a][5] = {  7,   8}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  2}; //   1
  c_d[x_a][5] = {  7,   8}; //   2

  c_p[x_a][6] = {  5,   9}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  9,  10,   6}; //   3

  c_p[x_a][7] = {  7,  10}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 11,  12,   8}; //   3

  c_p[x_a][8] = {  1,  11}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  9,  13,   2}; //   3

  c_p[x_a][9] = {  3,  12}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 11,  14,   4}; //   3

  c_p[x_a][10] = {  5,  13}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 15,   4,   6}; //   3

  c_p[x_a][11] = {  7,  14}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 16,   2,   8}; //   3

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  1}; //   1
  c_t[x_a][12] = {  4,   5}; //   2
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  6,   7}; //   2
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  5,   6}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  4}; //   1
  c_d[x_a][14] = {  5,   6}; //   2

  c_p[x_a][15] = {  7,   8}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  4}; //   1
  c_d[x_a][15] = {  7,   8}; //   2

  c_p[x_a][16] = {  1,   2}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  6}; //   1
  c_d[x_a][16] = {  1,   2}; //   2

  c_p[x_a][17] = {  3,   4}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  6}; //   1
  c_d[x_a][17] = {  3,   4}; //   2

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  1}; //   1
  c_t[x_a][18] = {  4,   8}; //   2
  c_d[x_a][18] = {  0}; //   1

  c_p[x_a][19] = {  0}; //   1
  c_f[x_a][19] = {  0}; //   1
  c_t[x_a][19] = {  6,   9}; //   2
  c_d[x_a][19] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_uux_aaddx
//  channel    0: 2v11(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    1: 2v11(1, 2, 16, 32, 8, 4;   0,   0,   0)
//  channel    2: 3yv1(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel    3: 3yv1(1, 2, 16, 4, 32, 8;   0,   0,   0)
//  channel    4: 3yv1(1, 2, 32, 8, 16, 4;   0,   0,   0)
//  channel    5: 3yv1(1, 2, 16, 8, 32, 4;   0,   0,   0)
//  channel    6: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    7: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    8: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel    9: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   10: 42vv(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel   11: 42vv(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel   12: 12v1(1, 2, 4, 16, 32, 8;   0,   0,   0)
//  channel   13: 12v1(1, 2, 8, 16, 32, 4;   0,   0,   0)
//  channel   14: 13yv(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel   15: 13yv(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel   16: 13yv(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel   17: 13yv(1, 2, 8, 16, 4, 32;   0,   0,   0)
//  channel   18: 112v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   19: 112v(1, 2, 8, 4, 16, 32;   0,   0,   0)
