#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ac_psp_230_dbx_aaadbx(int x_a, int channel){
  static Logger logger("ppaaa03_phasespace_set::ac_psp_230_dbx_aaadbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][36];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][88], 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = smin_opt[x_a][48];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][76], 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  2] = smin_opt[x_a][40];
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][84], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][  4], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][  5], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  6], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  8], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][  9], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 9));
    }
    else if (c_p[x_a][channel][i_p] ==  10){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][60]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 10], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 10));
    }
    else if (c_p[x_a][channel][i_p] ==  11){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 11], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 11));
    }
    else if (c_p[x_a][channel][i_p] ==  12){
      v_smin[x_a][ 12] = smin_opt[x_a][68];
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][56], 2);
      c_propagator(x_a,   0,  68, v_smin[x_a][ 12], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 12));
    }
    else if (c_p[x_a][channel][i_p] ==  13){
      v_smin[x_a][ 13] = smin_opt[x_a][80];
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][44], 2);
      c_propagator(x_a,   0,  80, v_smin[x_a][ 13], v_smax[x_a][  8], random_manager.get_random(x_a, 0, 13));
    }
    else if (c_p[x_a][channel][i_p] ==  14){
      v_smin[x_a][ 14] = smin_opt[x_a][72];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][52], 2);
      c_propagator(x_a,   0,  72, v_smin[x_a][ 14], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 14));
    }
    else if (c_p[x_a][channel][i_p] ==  15){
      v_smin[x_a][ 15] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][ 15], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 15));
    }
    else if (c_p[x_a][channel][i_p] ==  16){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][84]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,   0,  84, v_smin[x_a][ 16], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 16));
    }
    else if (c_p[x_a][channel][i_p] ==  17){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][84]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,   0,  84, v_smin[x_a][ 17], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 17));
    }
    else if (c_p[x_a][channel][i_p] ==  18){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][ 18], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 18));
    }
    else if (c_p[x_a][channel][i_p] ==  19){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,   0,  88, v_smin[x_a][ 19], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 19));
    }
    else if (c_p[x_a][channel][i_p] ==  20){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,   0,  88, v_smin[x_a][ 20], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 20));
    }
    else if (c_p[x_a][channel][i_p] ==  21){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][88], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  92, v_smin[x_a][ 21], v_smax[x_a][ 13], random_manager.get_random(x_a, 0, 21));
    }
    else if (c_p[x_a][channel][i_p] ==  22){
      v_smin[x_a][ 22] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][76], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  92, v_smin[x_a][ 22], v_smax[x_a][ 13], random_manager.get_random(x_a, 0, 22));
    }
    else if (c_p[x_a][channel][i_p] ==  23){
      v_smin[x_a][ 23] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][84], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  92, v_smin[x_a][ 23], v_smax[x_a][ 13], random_manager.get_random(x_a, 0, 23));
    }
    else if (c_p[x_a][channel][i_p] ==  24){
      v_smin[x_a][  0] = smin_opt[x_a][36];
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][72], sqrtsmin_opt[x_a][88]), 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  0], v_smax[x_a][ 14], random_manager.get_random(x_a, 0, 24));
    }
    else if (c_p[x_a][channel][i_p] ==  25){
      v_smin[x_a][  0] = smin_opt[x_a][36];
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][80], sqrtsmin_opt[x_a][88]), 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  0], v_smax[x_a][ 15], random_manager.get_random(x_a, 0, 25));
    }
    else if (c_p[x_a][channel][i_p] ==  26){
      v_smin[x_a][  1] = smin_opt[x_a][48];
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][68], sqrtsmin_opt[x_a][76]), 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][  1], v_smax[x_a][ 16], random_manager.get_random(x_a, 0, 26));
    }
    else if (c_p[x_a][channel][i_p] ==  27){
      v_smin[x_a][  2] = smin_opt[x_a][40];
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][68], sqrtsmin_opt[x_a][84]), 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  2], v_smax[x_a][ 17], random_manager.get_random(x_a, 0, 27));
    }
    else if (c_p[x_a][channel][i_p] ==  28){
      v_smin[x_a][  2] = smin_opt[x_a][40];
      v_smax[x_a][ 18] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][80], sqrtsmin_opt[x_a][84]), 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  2], v_smax[x_a][ 18], random_manager.get_random(x_a, 0, 28));
    }
    else if (c_p[x_a][channel][i_p] ==  29){
      v_smin[x_a][  1] = smin_opt[x_a][48];
      v_smax[x_a][ 19] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][72], sqrtsmin_opt[x_a][76]), 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][  1], v_smax[x_a][ 19], random_manager.get_random(x_a, 0, 29));
    }
    else if (c_p[x_a][channel][i_p] ==  30){
      v_smin[x_a][  0] = smin_opt[x_a][36];
      v_smax[x_a][ 20] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][88], 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  0], v_smax[x_a][ 20], random_manager.get_random(x_a, 0, 30));
    }
    else if (c_p[x_a][channel][i_p] ==  31){
      v_smin[x_a][  1] = smin_opt[x_a][48];
      v_smax[x_a][ 21] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][76], 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][  1], v_smax[x_a][ 21], random_manager.get_random(x_a, 0, 31));
    }
    else if (c_p[x_a][channel][i_p] ==  32){
      v_smin[x_a][  2] = smin_opt[x_a][40];
      v_smax[x_a][ 22] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][84], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  2], v_smax[x_a][ 22], random_manager.get_random(x_a, 0, 32));
    }
    else if (c_p[x_a][channel][i_p] ==  33){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][ 23] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  3], v_smax[x_a][ 23], random_manager.get_random(x_a, 0, 33));
    }
    else if (c_p[x_a][channel][i_p] ==  34){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][72], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][  4], v_smax[x_a][ 24], random_manager.get_random(x_a, 0, 34));
    }
    else if (c_p[x_a][channel][i_p] ==  35){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][72], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][  5], v_smax[x_a][ 24], random_manager.get_random(x_a, 0, 35));
    }
    else if (c_p[x_a][channel][i_p] ==  36){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][ 23] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  6], v_smax[x_a][ 23], random_manager.get_random(x_a, 0, 36));
    }
    else if (c_p[x_a][channel][i_p] ==  37){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][ 25] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][68], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  7], v_smax[x_a][ 25], random_manager.get_random(x_a, 0, 37));
    }
    else if (c_p[x_a][channel][i_p] ==  38){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][ 25] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][68], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  8], v_smax[x_a][ 25], random_manager.get_random(x_a, 0, 38));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][  1] = smin_opt[x_a][48];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][76], 2);
      c_timelikeinvariant(x_a,  48, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][ 24] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 24], v_smax[x_a][ 26], random_manager.get_random(x_a, 1, 2));
    }
    else if (c_f[x_a][channel][i_f] ==   3){
      v_smin[x_a][ 25] = smin_opt[x_a][96];
      v_smax[x_a][ 27] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][28], 2);
      c_timelikeinvariant(x_a,  96, v_smin[x_a][ 25], v_smax[x_a][ 27], random_manager.get_random(x_a, 1, 3));
    }
    else if (c_f[x_a][channel][i_f] ==   4){
      v_smin[x_a][ 26] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][104]);
      v_smax[x_a][ 28] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_timelikeinvariant(x_a, 104, v_smin[x_a][ 26], v_smax[x_a][ 28], random_manager.get_random(x_a, 1, 4));
    }
    else if (c_f[x_a][channel][i_f] ==   5){
      v_smin[x_a][ 27] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][104], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 27], v_smax[x_a][ 26], random_manager.get_random(x_a, 1, 5));
    }
    else if (c_f[x_a][channel][i_f] ==   6){
      v_smin[x_a][ 14] = smin_opt[x_a][72];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][52], 2);
      c_timelikeinvariant(x_a,  72, v_smin[x_a][ 14], v_smax[x_a][  9], random_manager.get_random(x_a, 1, 6));
    }
    else if (c_f[x_a][channel][i_f] ==   7){
      v_smin[x_a][ 28] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][104]);
      v_smax[x_a][ 28] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_timelikeinvariant(x_a, 104, v_smin[x_a][ 28], v_smax[x_a][ 28], random_manager.get_random(x_a, 1, 7));
    }
    else if (c_f[x_a][channel][i_f] ==   8){
      v_smin[x_a][ 29] = smin_opt[x_a][12];
      v_smax[x_a][ 29] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][112], 2);
      c_timelikeinvariant(x_a,  12, v_smin[x_a][ 29], v_smax[x_a][ 29], random_manager.get_random(x_a, 1, 8));
    }
    else if (c_f[x_a][channel][i_f] ==   9){
      v_smin[x_a][ 30] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_timelikeinvariant(x_a,  76, v_smin[x_a][ 30], v_smax[x_a][ 10], random_manager.get_random(x_a, 1, 9));
    }
    else if (c_f[x_a][channel][i_f] ==  10){
      v_smin[x_a][ 22] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][76], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  92, v_smin[x_a][ 22], v_smax[x_a][ 13], random_manager.get_random(x_a, 1, 10));
    }
    else if (c_f[x_a][channel][i_f] ==  11){
      v_smin[x_a][  2] = smin_opt[x_a][40];
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][84], 2);
      c_timelikeinvariant(x_a,  40, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 1, 11));
    }
    else if (c_f[x_a][channel][i_f] ==  12){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][  8], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 12));
    }
    else if (c_f[x_a][channel][i_f] ==  13){
      v_smin[x_a][ 31] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 30] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_timelikeinvariant(x_a, 112, v_smin[x_a][ 31], v_smax[x_a][ 30], random_manager.get_random(x_a, 1, 13));
    }
    else if (c_f[x_a][channel][i_f] ==  14){
      v_smin[x_a][ 32] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][112], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 32], v_smax[x_a][ 26], random_manager.get_random(x_a, 1, 14));
    }
    else if (c_f[x_a][channel][i_f] ==  15){
      v_smin[x_a][ 13] = smin_opt[x_a][80];
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][44], 2);
      c_timelikeinvariant(x_a,  80, v_smin[x_a][ 13], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 15));
    }
    else if (c_f[x_a][channel][i_f] ==  16){
      v_smin[x_a][ 33] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 30] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_timelikeinvariant(x_a, 112, v_smin[x_a][ 33], v_smax[x_a][ 30], random_manager.get_random(x_a, 1, 16));
    }
    else if (c_f[x_a][channel][i_f] ==  17){
      v_smin[x_a][ 34] = smin_opt[x_a][20];
      v_smax[x_a][ 31] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][104], 2);
      c_timelikeinvariant(x_a,  20, v_smin[x_a][ 34], v_smax[x_a][ 31], random_manager.get_random(x_a, 1, 17));
    }
    else if (c_f[x_a][channel][i_f] ==  18){
      v_smin[x_a][ 35] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][84]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_timelikeinvariant(x_a,  84, v_smin[x_a][ 35], v_smax[x_a][ 11], random_manager.get_random(x_a, 1, 18));
    }
    else if (c_f[x_a][channel][i_f] ==  19){
      v_smin[x_a][ 23] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][84], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  92, v_smin[x_a][ 23], v_smax[x_a][ 13], random_manager.get_random(x_a, 1, 19));
    }
    else if (c_f[x_a][channel][i_f] ==  20){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 1, 20));
    }
    else if (c_f[x_a][channel][i_f] ==  21){
      v_smin[x_a][ 36] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 32] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 36], v_smax[x_a][ 32], random_manager.get_random(x_a, 1, 21));
    }
    else if (c_f[x_a][channel][i_f] ==  22){
      v_smin[x_a][ 37] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][100]);
      v_smax[x_a][ 33] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_timelikeinvariant(x_a, 100, v_smin[x_a][ 37], v_smax[x_a][ 33], random_manager.get_random(x_a, 1, 22));
    }
    else if (c_f[x_a][channel][i_f] ==  23){
      v_smin[x_a][ 38] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][100], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 32] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 38], v_smax[x_a][ 32], random_manager.get_random(x_a, 1, 23));
    }
    else if (c_f[x_a][channel][i_f] ==  24){
      v_smin[x_a][ 12] = smin_opt[x_a][68];
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][56], 2);
      c_timelikeinvariant(x_a,  68, v_smin[x_a][ 12], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 24));
    }
    else if (c_f[x_a][channel][i_f] ==  25){
      v_smin[x_a][ 39] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][100]);
      v_smax[x_a][ 33] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_timelikeinvariant(x_a, 100, v_smin[x_a][ 39], v_smax[x_a][ 33], random_manager.get_random(x_a, 1, 25));
    }
    else if (c_f[x_a][channel][i_f] ==  26){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][  4], v_smax[x_a][  4], random_manager.get_random(x_a, 1, 26));
    }
    else if (c_f[x_a][channel][i_f] ==  27){
      v_smin[x_a][ 40] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 34] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 40], v_smax[x_a][ 34], random_manager.get_random(x_a, 1, 27));
    }
    else if (c_f[x_a][channel][i_f] ==  28){
      v_smin[x_a][ 41] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][100], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 34] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 41], v_smax[x_a][ 34], random_manager.get_random(x_a, 1, 28));
    }
    else if (c_f[x_a][channel][i_f] ==  29){
      v_smin[x_a][  0] = smin_opt[x_a][36];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][88], 2);
      c_timelikeinvariant(x_a,  36, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 1, 29));
    }
    else if (c_f[x_a][channel][i_f] ==  30){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][  5], v_smax[x_a][  4], random_manager.get_random(x_a, 1, 30));
    }
    else if (c_f[x_a][channel][i_f] ==  31){
      v_smin[x_a][ 42] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][112], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 34] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 42], v_smax[x_a][ 34], random_manager.get_random(x_a, 1, 31));
    }
    else if (c_f[x_a][channel][i_f] ==  32){
      v_smin[x_a][ 43] = smin_opt[x_a][24];
      v_smax[x_a][ 35] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][100], 2);
      c_timelikeinvariant(x_a,  24, v_smin[x_a][ 43], v_smax[x_a][ 35], random_manager.get_random(x_a, 1, 32));
    }
    else if (c_f[x_a][channel][i_f] ==  33){
      v_smin[x_a][ 44] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_timelikeinvariant(x_a,  88, v_smin[x_a][ 44], v_smax[x_a][ 12], random_manager.get_random(x_a, 1, 33));
    }
    else if (c_f[x_a][channel][i_f] ==  34){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][88], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  92, v_smin[x_a][ 21], v_smax[x_a][ 13], random_manager.get_random(x_a, 1, 34));
    }
    else if (c_f[x_a][channel][i_f] ==  35){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][  6], v_smax[x_a][  3], random_manager.get_random(x_a, 1, 35));
    }
    else if (c_f[x_a][channel][i_f] ==  36){
      v_smin[x_a][ 45] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][104], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 32] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 45], v_smax[x_a][ 32], random_manager.get_random(x_a, 1, 36));
    }
    else if (c_f[x_a][channel][i_f] ==  37){
      v_smin[x_a][ 14] = smin_opt[x_a][72];
      v_smax[x_a][ 36] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], sqrtsmin_opt[x_a][52]), 2);
      c_timelikeinvariant(x_a,  72, v_smin[x_a][ 14], v_smax[x_a][ 36], random_manager.get_random(x_a, 1, 37));
    }
    else if (c_f[x_a][channel][i_f] ==  38){
      v_smin[x_a][ 46] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][36] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 32] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 46], v_smax[x_a][ 32], random_manager.get_random(x_a, 1, 38));
    }
    else if (c_f[x_a][channel][i_f] ==  39){
      v_smin[x_a][ 13] = smin_opt[x_a][80];
      v_smax[x_a][ 37] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], sqrtsmin_opt[x_a][44]), 2);
      c_timelikeinvariant(x_a,  80, v_smin[x_a][ 13], v_smax[x_a][ 37], random_manager.get_random(x_a, 1, 39));
    }
    else if (c_f[x_a][channel][i_f] ==  40){
      v_smin[x_a][ 47] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][36] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 34] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 47], v_smax[x_a][ 34], random_manager.get_random(x_a, 1, 40));
    }
    else if (c_f[x_a][channel][i_f] ==  41){
      v_smin[x_a][ 12] = smin_opt[x_a][68];
      v_smax[x_a][ 38] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][56]), 2);
      c_timelikeinvariant(x_a,  68, v_smin[x_a][ 12], v_smax[x_a][ 38], random_manager.get_random(x_a, 1, 41));
    }
    else if (c_f[x_a][channel][i_f] ==  42){
      v_smin[x_a][ 48] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][48] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 34] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 48], v_smax[x_a][ 34], random_manager.get_random(x_a, 1, 42));
    }
    else if (c_f[x_a][channel][i_f] ==  43){
      v_smin[x_a][ 12] = smin_opt[x_a][68];
      v_smax[x_a][ 39] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][56]), 2);
      c_timelikeinvariant(x_a,  68, v_smin[x_a][ 12], v_smax[x_a][ 39], random_manager.get_random(x_a, 1, 43));
    }
    else if (c_f[x_a][channel][i_f] ==  44){
      v_smin[x_a][ 49] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][40] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 32] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 49], v_smax[x_a][ 32], random_manager.get_random(x_a, 1, 44));
    }
    else if (c_f[x_a][channel][i_f] ==  45){
      v_smin[x_a][ 13] = smin_opt[x_a][80];
      v_smax[x_a][ 40] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][44]), 2);
      c_timelikeinvariant(x_a,  80, v_smin[x_a][ 13], v_smax[x_a][ 40], random_manager.get_random(x_a, 1, 45));
    }
    else if (c_f[x_a][channel][i_f] ==  46){
      v_smin[x_a][ 50] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][40] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 50], v_smax[x_a][ 26], random_manager.get_random(x_a, 1, 46));
    }
    else if (c_f[x_a][channel][i_f] ==  47){
      v_smin[x_a][ 14] = smin_opt[x_a][72];
      v_smax[x_a][ 41] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][52]), 2);
      c_timelikeinvariant(x_a,  72, v_smin[x_a][ 14], v_smax[x_a][ 41], random_manager.get_random(x_a, 1, 47));
    }
    else if (c_f[x_a][channel][i_f] ==  48){
      v_smin[x_a][ 51] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][48] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 51], v_smax[x_a][ 26], random_manager.get_random(x_a, 1, 48));
    }
    else if (c_f[x_a][channel][i_f] ==  49){
      v_smin[x_a][ 52] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][104]);
      v_smax[x_a][ 28] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_timelikeinvariant(x_a, 104, v_smin[x_a][ 52], v_smax[x_a][ 28], random_manager.get_random(x_a, 1, 49));
    }
    else if (c_f[x_a][channel][i_f] ==  50){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_timelikeinvariant(x_a,  76, v_smin[x_a][ 18], v_smax[x_a][ 10], random_manager.get_random(x_a, 1, 50));
    }
    else if (c_f[x_a][channel][i_f] ==  51){
      v_smin[x_a][ 53] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 30] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_timelikeinvariant(x_a, 112, v_smin[x_a][ 53], v_smax[x_a][ 30], random_manager.get_random(x_a, 1, 51));
    }
    else if (c_f[x_a][channel][i_f] ==  52){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][84]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_timelikeinvariant(x_a,  84, v_smin[x_a][ 17], v_smax[x_a][ 11], random_manager.get_random(x_a, 1, 52));
    }
    else if (c_f[x_a][channel][i_f] ==  53){
      v_smin[x_a][ 54] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][ 33] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_timelikeinvariant(x_a, 100, v_smin[x_a][ 54], v_smax[x_a][ 33], random_manager.get_random(x_a, 1, 53));
    }
    else if (c_f[x_a][channel][i_f] ==  54){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][84]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_timelikeinvariant(x_a,  84, v_smin[x_a][ 16], v_smax[x_a][ 11], random_manager.get_random(x_a, 1, 54));
    }
    else if (c_f[x_a][channel][i_f] ==  55){
      v_smin[x_a][ 15] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_timelikeinvariant(x_a,  76, v_smin[x_a][ 15], v_smax[x_a][ 10], random_manager.get_random(x_a, 1, 55));
    }
    else if (c_f[x_a][channel][i_f] ==  56){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_timelikeinvariant(x_a,  88, v_smin[x_a][ 20], v_smax[x_a][ 12], random_manager.get_random(x_a, 1, 56));
    }
    else if (c_f[x_a][channel][i_f] ==  57){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_timelikeinvariant(x_a,  88, v_smin[x_a][ 19], v_smax[x_a][ 12], random_manager.get_random(x_a, 1, 57));
    }
    else if (c_f[x_a][channel][i_f] ==  58){
      v_smin[x_a][ 55] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][88], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 55], v_smax[x_a][ 26], random_manager.get_random(x_a, 1, 58));
    }
    else if (c_f[x_a][channel][i_f] ==  59){
      v_smin[x_a][ 56] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][76], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 32] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 56], v_smax[x_a][ 32], random_manager.get_random(x_a, 1, 59));
    }
    else if (c_f[x_a][channel][i_f] ==  60){
      v_smin[x_a][ 57] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][84], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 34] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 57], v_smax[x_a][ 34], random_manager.get_random(x_a, 1, 60));
    }
    else if (c_f[x_a][channel][i_f] ==  61){
      v_smin[x_a][  2] = smin_opt[x_a][40];
      v_smax[x_a][ 18] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][80], sqrtsmin_opt[x_a][84]), 2);
      c_timelikeinvariant(x_a,  40, v_smin[x_a][  2], v_smax[x_a][ 18], random_manager.get_random(x_a, 1, 61));
    }
    else if (c_f[x_a][channel][i_f] ==  62){
      v_smin[x_a][  1] = smin_opt[x_a][48];
      v_smax[x_a][ 19] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][72], sqrtsmin_opt[x_a][76]), 2);
      c_timelikeinvariant(x_a,  48, v_smin[x_a][  1], v_smax[x_a][ 19], random_manager.get_random(x_a, 1, 62));
    }
    else if (c_f[x_a][channel][i_f] ==  63){
      v_smin[x_a][  0] = smin_opt[x_a][36];
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][72], sqrtsmin_opt[x_a][88]), 2);
      c_timelikeinvariant(x_a,  36, v_smin[x_a][  0], v_smax[x_a][ 14], random_manager.get_random(x_a, 1, 63));
    }
    else if (c_f[x_a][channel][i_f] ==  64){
      v_smin[x_a][  0] = smin_opt[x_a][36];
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][80], sqrtsmin_opt[x_a][88]), 2);
      c_timelikeinvariant(x_a,  36, v_smin[x_a][  0], v_smax[x_a][ 15], random_manager.get_random(x_a, 1, 64));
    }
    else if (c_f[x_a][channel][i_f] ==  65){
      v_smin[x_a][  1] = smin_opt[x_a][48];
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][68], sqrtsmin_opt[x_a][76]), 2);
      c_timelikeinvariant(x_a,  48, v_smin[x_a][  1], v_smax[x_a][ 16], random_manager.get_random(x_a, 1, 65));
    }
    else if (c_f[x_a][channel][i_f] ==  66){
      v_smin[x_a][  2] = smin_opt[x_a][40];
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][68], sqrtsmin_opt[x_a][84]), 2);
      c_timelikeinvariant(x_a,  40, v_smin[x_a][  2], v_smax[x_a][ 17], random_manager.get_random(x_a, 1, 66));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0, 124,   1,   2,   4, 120, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0, 120,   2,   5,  64,  56, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel(x_a,   0,  56,   5,  66,   8,  48, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel(x_a,   0,  48,  66,  13,  32,  16, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel_opt(x_a,   0, 120,   2,   5,  16, 104, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel(x_a,   0, 104,   5,  18,   8,  96, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel(x_a,   0,  96,  18,  13,  64,  32, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel(x_a,   0, 104,   5,  18,  32,  72, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel(x_a,   0,  72,  18,  37,   8,  64, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  32,  92, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel_opt(x_a,   0,  92,   2,  33,  16,  76, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel(x_a,   0,  76,  33,  18,  64,  12, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
    else if (c_t[x_a][channel][i_t] ==  12){
      c_tchannel(x_a,   0,  12,  18,  97,   8,   4, random_manager.get_random(x_a, 2, 12), random_manager.get_random(x_a, 3, 12));
    }
    else if (c_t[x_a][channel][i_t] ==  13){
      c_tchannel(x_a,   0,  56,   5,  66,  16,  40, random_manager.get_random(x_a, 2, 13), random_manager.get_random(x_a, 3, 13));
    }
    else if (c_t[x_a][channel][i_t] ==  14){
      c_tchannel(x_a,   0,  40,  66,  21,  32,   8, random_manager.get_random(x_a, 2, 14), random_manager.get_random(x_a, 3, 14));
    }
    else if (c_t[x_a][channel][i_t] ==  15){
      c_tchannel_opt(x_a,   0, 120,   2,   5,   8, 112, random_manager.get_random(x_a, 2, 15), random_manager.get_random(x_a, 3, 15));
    }
    else if (c_t[x_a][channel][i_t] ==  16){
      c_tchannel(x_a,   0, 112,   5,  10,  16,  96, random_manager.get_random(x_a, 2, 16), random_manager.get_random(x_a, 3, 16));
    }
    else if (c_t[x_a][channel][i_t] ==  17){
      c_tchannel(x_a,   0,  96,  10,  21,  64,  32, random_manager.get_random(x_a, 2, 17), random_manager.get_random(x_a, 3, 17));
    }
    else if (c_t[x_a][channel][i_t] ==  18){
      c_tchannel(x_a,   0, 112,   5,  10,  32,  80, random_manager.get_random(x_a, 2, 18), random_manager.get_random(x_a, 3, 18));
    }
    else if (c_t[x_a][channel][i_t] ==  19){
      c_tchannel(x_a,   0,  80,  10,  37,  16,  64, random_manager.get_random(x_a, 2, 19), random_manager.get_random(x_a, 3, 19));
    }
    else if (c_t[x_a][channel][i_t] ==  20){
      c_tchannel_opt(x_a,   0,  92,   2,  33,   8,  84, random_manager.get_random(x_a, 2, 20), random_manager.get_random(x_a, 3, 20));
    }
    else if (c_t[x_a][channel][i_t] ==  21){
      c_tchannel(x_a,   0,  84,  33,  10,  64,  20, random_manager.get_random(x_a, 2, 21), random_manager.get_random(x_a, 3, 21));
    }
    else if (c_t[x_a][channel][i_t] ==  22){
      c_tchannel(x_a,   0,  20,  10,  97,  16,   4, random_manager.get_random(x_a, 2, 22), random_manager.get_random(x_a, 3, 22));
    }
    else if (c_t[x_a][channel][i_t] ==  23){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  16, 108, random_manager.get_random(x_a, 2, 23), random_manager.get_random(x_a, 3, 23));
    }
    else if (c_t[x_a][channel][i_t] ==  24){
      c_tchannel_opt(x_a,   0, 108,   2,  17,  64,  44, random_manager.get_random(x_a, 2, 24), random_manager.get_random(x_a, 3, 24));
    }
    else if (c_t[x_a][channel][i_t] ==  25){
      c_tchannel(x_a,   0,  44,  17,  66,   4,  40, random_manager.get_random(x_a, 2, 25), random_manager.get_random(x_a, 3, 25));
    }
    else if (c_t[x_a][channel][i_t] ==  26){
      c_tchannel_opt(x_a,   0, 108,   2,  17,   8, 100, random_manager.get_random(x_a, 2, 26), random_manager.get_random(x_a, 3, 26));
    }
    else if (c_t[x_a][channel][i_t] ==  27){
      c_tchannel(x_a,   0, 100,  17,  10,   4,  96, random_manager.get_random(x_a, 2, 27), random_manager.get_random(x_a, 3, 27));
    }
    else if (c_t[x_a][channel][i_t] ==  28){
      c_tchannel(x_a,   0, 100,  17,  10,  32,  68, random_manager.get_random(x_a, 2, 28), random_manager.get_random(x_a, 3, 28));
    }
    else if (c_t[x_a][channel][i_t] ==  29){
      c_tchannel(x_a,   0,  68,  10,  49,   4,  64, random_manager.get_random(x_a, 2, 29), random_manager.get_random(x_a, 3, 29));
    }
    else if (c_t[x_a][channel][i_t] ==  30){
      c_tchannel(x_a,   0,  20,  10,  97,   4,  16, random_manager.get_random(x_a, 2, 30), random_manager.get_random(x_a, 3, 30));
    }
    else if (c_t[x_a][channel][i_t] ==  31){
      c_tchannel_opt(x_a,   0, 124,   1,   2,   8, 116, random_manager.get_random(x_a, 2, 31), random_manager.get_random(x_a, 3, 31));
    }
    else if (c_t[x_a][channel][i_t] ==  32){
      c_tchannel_opt(x_a,   0, 116,   2,   9,  64,  52, random_manager.get_random(x_a, 2, 32), random_manager.get_random(x_a, 3, 32));
    }
    else if (c_t[x_a][channel][i_t] ==  33){
      c_tchannel(x_a,   0,  52,   9,  66,   4,  48, random_manager.get_random(x_a, 2, 33), random_manager.get_random(x_a, 3, 33));
    }
    else if (c_t[x_a][channel][i_t] ==  34){
      c_tchannel_opt(x_a,   0, 116,   2,   9,  16, 100, random_manager.get_random(x_a, 2, 34), random_manager.get_random(x_a, 3, 34));
    }
    else if (c_t[x_a][channel][i_t] ==  35){
      c_tchannel(x_a,   0, 100,   9,  18,   4,  96, random_manager.get_random(x_a, 2, 35), random_manager.get_random(x_a, 3, 35));
    }
    else if (c_t[x_a][channel][i_t] ==  36){
      c_tchannel(x_a,   0, 100,   9,  18,  32,  68, random_manager.get_random(x_a, 2, 36), random_manager.get_random(x_a, 3, 36));
    }
    else if (c_t[x_a][channel][i_t] ==  37){
      c_tchannel(x_a,   0,  68,  18,  41,   4,  64, random_manager.get_random(x_a, 2, 37), random_manager.get_random(x_a, 3, 37));
    }
    else if (c_t[x_a][channel][i_t] ==  38){
      c_tchannel(x_a,   0,  12,  18,  97,   4,   8, random_manager.get_random(x_a, 2, 38), random_manager.get_random(x_a, 3, 38));
    }
    else if (c_t[x_a][channel][i_t] ==  39){
      c_tchannel(x_a,   0,  52,   9,  66,  16,  36, random_manager.get_random(x_a, 2, 39), random_manager.get_random(x_a, 3, 39));
    }
    else if (c_t[x_a][channel][i_t] ==  40){
      c_tchannel(x_a,   0,  36,  66,  25,  32,   4, random_manager.get_random(x_a, 2, 40), random_manager.get_random(x_a, 3, 40));
    }
    else if (c_t[x_a][channel][i_t] ==  41){
      c_tchannel_opt(x_a,   0, 116,   2,   9,   4, 112, random_manager.get_random(x_a, 2, 41), random_manager.get_random(x_a, 3, 41));
    }
    else if (c_t[x_a][channel][i_t] ==  42){
      c_tchannel(x_a,   0, 112,   9,   6,  16,  96, random_manager.get_random(x_a, 2, 42), random_manager.get_random(x_a, 3, 42));
    }
    else if (c_t[x_a][channel][i_t] ==  43){
      c_tchannel(x_a,   0,  96,   6,  25,  64,  32, random_manager.get_random(x_a, 2, 43), random_manager.get_random(x_a, 3, 43));
    }
    else if (c_t[x_a][channel][i_t] ==  44){
      c_tchannel(x_a,   0, 112,   9,   6,  32,  80, random_manager.get_random(x_a, 2, 44), random_manager.get_random(x_a, 3, 44));
    }
    else if (c_t[x_a][channel][i_t] ==  45){
      c_tchannel(x_a,   0,  80,   6,  41,  16,  64, random_manager.get_random(x_a, 2, 45), random_manager.get_random(x_a, 3, 45));
    }
    else if (c_t[x_a][channel][i_t] ==  46){
      c_tchannel_opt(x_a,   0,  92,   2,  33,   4,  88, random_manager.get_random(x_a, 2, 46), random_manager.get_random(x_a, 3, 46));
    }
    else if (c_t[x_a][channel][i_t] ==  47){
      c_tchannel(x_a,   0,  88,  33,   6,  64,  24, random_manager.get_random(x_a, 2, 47), random_manager.get_random(x_a, 3, 47));
    }
    else if (c_t[x_a][channel][i_t] ==  48){
      c_tchannel(x_a,   0,  24,   6,  97,  16,   8, random_manager.get_random(x_a, 2, 48), random_manager.get_random(x_a, 3, 48));
    }
    else if (c_t[x_a][channel][i_t] ==  49){
      c_tchannel(x_a,   0,  44,  17,  66,   8,  36, random_manager.get_random(x_a, 2, 49), random_manager.get_random(x_a, 3, 49));
    }
    else if (c_t[x_a][channel][i_t] ==  50){
      c_tchannel_opt(x_a,   0, 108,   2,  17,   4, 104, random_manager.get_random(x_a, 2, 50), random_manager.get_random(x_a, 3, 50));
    }
    else if (c_t[x_a][channel][i_t] ==  51){
      c_tchannel(x_a,   0, 104,  17,   6,   8,  96, random_manager.get_random(x_a, 2, 51), random_manager.get_random(x_a, 3, 51));
    }
    else if (c_t[x_a][channel][i_t] ==  52){
      c_tchannel(x_a,   0, 104,  17,   6,  32,  72, random_manager.get_random(x_a, 2, 52), random_manager.get_random(x_a, 3, 52));
    }
    else if (c_t[x_a][channel][i_t] ==  53){
      c_tchannel(x_a,   0,  72,   6,  49,   8,  64, random_manager.get_random(x_a, 2, 53), random_manager.get_random(x_a, 3, 53));
    }
    else if (c_t[x_a][channel][i_t] ==  54){
      c_tchannel(x_a,   0,  24,   6,  97,   8,  16, random_manager.get_random(x_a, 2, 54), random_manager.get_random(x_a, 3, 54));
    }
    else if (c_t[x_a][channel][i_t] ==  55){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  16, 108, random_manager.get_random(x_a, 2, 55), random_manager.get_random(x_a, 3, 55));
    }
    else if (c_t[x_a][channel][i_t] ==  56){
      c_tchannel_opt(x_a,   0, 108,   1,  18,  36,  72, random_manager.get_random(x_a, 2, 56), random_manager.get_random(x_a, 3, 56));
    }
    else if (c_t[x_a][channel][i_t] ==  57){
      c_tchannel_opt(x_a,   0, 124,   2,   1,   8, 116, random_manager.get_random(x_a, 2, 57), random_manager.get_random(x_a, 3, 57));
    }
    else if (c_t[x_a][channel][i_t] ==  58){
      c_tchannel_opt(x_a,   0, 116,   1,  10,  36,  80, random_manager.get_random(x_a, 2, 58), random_manager.get_random(x_a, 3, 58));
    }
    else if (c_t[x_a][channel][i_t] ==  59){
      c_tchannel_opt(x_a,   0, 116,   1,  10,  48,  68, random_manager.get_random(x_a, 2, 59), random_manager.get_random(x_a, 3, 59));
    }
    else if (c_t[x_a][channel][i_t] ==  60){
      c_tchannel_opt(x_a,   0, 108,   1,  18,  40,  68, random_manager.get_random(x_a, 2, 60), random_manager.get_random(x_a, 3, 60));
    }
    else if (c_t[x_a][channel][i_t] ==  61){
      c_tchannel_opt(x_a,   0, 124,   2,   1,   4, 120, random_manager.get_random(x_a, 2, 61), random_manager.get_random(x_a, 3, 61));
    }
    else if (c_t[x_a][channel][i_t] ==  62){
      c_tchannel_opt(x_a,   0, 120,   1,   6,  40,  80, random_manager.get_random(x_a, 2, 62), random_manager.get_random(x_a, 3, 62));
    }
    else if (c_t[x_a][channel][i_t] ==  63){
      c_tchannel_opt(x_a,   0, 120,   1,   6,  48,  72, random_manager.get_random(x_a, 2, 63), random_manager.get_random(x_a, 3, 63));
    }
    else if (c_t[x_a][channel][i_t] ==  64){
      c_tchannel_opt(x_a,   0, 108,  18,   1,  64,  44, random_manager.get_random(x_a, 2, 64), random_manager.get_random(x_a, 3, 64));
    }
    else if (c_t[x_a][channel][i_t] ==  65){
      c_tchannel_opt(x_a,   0, 116,  10,   1,  64,  52, random_manager.get_random(x_a, 2, 65), random_manager.get_random(x_a, 3, 65));
    }
    else if (c_t[x_a][channel][i_t] ==  66){
      c_tchannel_opt(x_a,   0, 120,   6,   1,  64,  56, random_manager.get_random(x_a, 2, 66), random_manager.get_random(x_a, 3, 66));
    }
    else if (c_t[x_a][channel][i_t] ==  67){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  64,  60, random_manager.get_random(x_a, 2, 67), random_manager.get_random(x_a, 3, 67));
    }
    else if (c_t[x_a][channel][i_t] ==  68){
      c_tchannel(x_a,   0, 104,  18,   5,  64,  40, random_manager.get_random(x_a, 2, 68), random_manager.get_random(x_a, 3, 68));
    }
    else if (c_t[x_a][channel][i_t] ==  69){
      c_tchannel(x_a,   0,  76,  18,  33,   8,  68, random_manager.get_random(x_a, 2, 69), random_manager.get_random(x_a, 3, 69));
    }
    else if (c_t[x_a][channel][i_t] ==  70){
      c_tchannel(x_a,   0, 112,  10,   5,  64,  48, random_manager.get_random(x_a, 2, 70), random_manager.get_random(x_a, 3, 70));
    }
    else if (c_t[x_a][channel][i_t] ==  71){
      c_tchannel(x_a,   0,  84,  10,  33,  16,  68, random_manager.get_random(x_a, 2, 71), random_manager.get_random(x_a, 3, 71));
    }
    else if (c_t[x_a][channel][i_t] ==  72){
      c_tchannel(x_a,   0, 100,  10,  17,  64,  36, random_manager.get_random(x_a, 2, 72), random_manager.get_random(x_a, 3, 72));
    }
    else if (c_t[x_a][channel][i_t] ==  73){
      c_tchannel(x_a,   0,  84,  10,  33,   4,  80, random_manager.get_random(x_a, 2, 73), random_manager.get_random(x_a, 3, 73));
    }
    else if (c_t[x_a][channel][i_t] ==  74){
      c_tchannel(x_a,   0, 100,  18,   9,  64,  36, random_manager.get_random(x_a, 2, 74), random_manager.get_random(x_a, 3, 74));
    }
    else if (c_t[x_a][channel][i_t] ==  75){
      c_tchannel(x_a,   0,  76,  18,  33,   4,  72, random_manager.get_random(x_a, 2, 75), random_manager.get_random(x_a, 3, 75));
    }
    else if (c_t[x_a][channel][i_t] ==  76){
      c_tchannel(x_a,   0, 112,   6,   9,  64,  48, random_manager.get_random(x_a, 2, 76), random_manager.get_random(x_a, 3, 76));
    }
    else if (c_t[x_a][channel][i_t] ==  77){
      c_tchannel(x_a,   0,  88,   6,  33,  16,  72, random_manager.get_random(x_a, 2, 77), random_manager.get_random(x_a, 3, 77));
    }
    else if (c_t[x_a][channel][i_t] ==  78){
      c_tchannel(x_a,   0, 104,   6,  17,  64,  40, random_manager.get_random(x_a, 2, 78), random_manager.get_random(x_a, 3, 78));
    }
    else if (c_t[x_a][channel][i_t] ==  79){
      c_tchannel(x_a,   0,  88,   6,  33,   8,  80, random_manager.get_random(x_a, 2, 79), random_manager.get_random(x_a, 3, 79));
    }
    else if (c_t[x_a][channel][i_t] ==  80){
      c_tchannel_opt(x_a,   0, 120,   5,   2,  32,  88, random_manager.get_random(x_a, 2, 80), random_manager.get_random(x_a, 3, 80));
    }
    else if (c_t[x_a][channel][i_t] ==  81){
      c_tchannel_opt(x_a,   0, 108,  17,   2,  32,  76, random_manager.get_random(x_a, 2, 81), random_manager.get_random(x_a, 3, 81));
    }
    else if (c_t[x_a][channel][i_t] ==  82){
      c_tchannel_opt(x_a,   0, 116,   9,   2,  32,  84, random_manager.get_random(x_a, 2, 82), random_manager.get_random(x_a, 3, 82));
    }
    else if (c_t[x_a][channel][i_t] ==  83){
      c_tchannel_opt(x_a,   0, 120,   2,   5,  80,  40, random_manager.get_random(x_a, 2, 83), random_manager.get_random(x_a, 3, 83));
    }
    else if (c_t[x_a][channel][i_t] ==  84){
      c_tchannel(x_a,   0,  40,   5,  82,   8,  32, random_manager.get_random(x_a, 2, 84), random_manager.get_random(x_a, 3, 84));
    }
    else if (c_t[x_a][channel][i_t] ==  85){
      c_tchannel_opt(x_a,   0, 120,   2,   5,  72,  48, random_manager.get_random(x_a, 2, 85), random_manager.get_random(x_a, 3, 85));
    }
    else if (c_t[x_a][channel][i_t] ==  86){
      c_tchannel(x_a,   0,  48,   5,  74,  16,  32, random_manager.get_random(x_a, 2, 86), random_manager.get_random(x_a, 3, 86));
    }
    else if (c_t[x_a][channel][i_t] ==  87){
      c_tchannel_opt(x_a,   0, 108,   2,  17,  72,  36, random_manager.get_random(x_a, 2, 87), random_manager.get_random(x_a, 3, 87));
    }
    else if (c_t[x_a][channel][i_t] ==  88){
      c_tchannel(x_a,   0,  36,  17,  74,   4,  32, random_manager.get_random(x_a, 2, 88), random_manager.get_random(x_a, 3, 88));
    }
    else if (c_t[x_a][channel][i_t] ==  89){
      c_tchannel_opt(x_a,   0, 116,   2,   9,  80,  36, random_manager.get_random(x_a, 2, 89), random_manager.get_random(x_a, 3, 89));
    }
    else if (c_t[x_a][channel][i_t] ==  90){
      c_tchannel(x_a,   0,  36,   9,  82,   4,  32, random_manager.get_random(x_a, 2, 90), random_manager.get_random(x_a, 3, 90));
    }
    else if (c_t[x_a][channel][i_t] ==  91){
      c_tchannel_opt(x_a,   0, 116,   2,   9,  68,  48, random_manager.get_random(x_a, 2, 91), random_manager.get_random(x_a, 3, 91));
    }
    else if (c_t[x_a][channel][i_t] ==  92){
      c_tchannel(x_a,   0,  48,   9,  70,  16,  32, random_manager.get_random(x_a, 2, 92), random_manager.get_random(x_a, 3, 92));
    }
    else if (c_t[x_a][channel][i_t] ==  93){
      c_tchannel_opt(x_a,   0, 108,   2,  17,  68,  40, random_manager.get_random(x_a, 2, 93), random_manager.get_random(x_a, 3, 93));
    }
    else if (c_t[x_a][channel][i_t] ==  94){
      c_tchannel(x_a,   0,  40,  17,  70,   8,  32, random_manager.get_random(x_a, 2, 94), random_manager.get_random(x_a, 3, 94));
    }
    else if (c_t[x_a][channel][i_t] ==  95){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  36,  88, random_manager.get_random(x_a, 2, 95), random_manager.get_random(x_a, 3, 95));
    }
    else if (c_t[x_a][channel][i_t] ==  96){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  48,  76, random_manager.get_random(x_a, 2, 96), random_manager.get_random(x_a, 3, 96));
    }
    else if (c_t[x_a][channel][i_t] ==  97){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  40,  84, random_manager.get_random(x_a, 2, 97), random_manager.get_random(x_a, 3, 97));
    }
    else if (c_t[x_a][channel][i_t] ==  98){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  80,  44, random_manager.get_random(x_a, 2, 98), random_manager.get_random(x_a, 3, 98));
    }
    else if (c_t[x_a][channel][i_t] ==  99){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  72,  52, random_manager.get_random(x_a, 2, 99), random_manager.get_random(x_a, 3, 99));
    }
    else if (c_t[x_a][channel][i_t] == 100){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  68,  56, random_manager.get_random(x_a, 2, 100), random_manager.get_random(x_a, 3, 100));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  36,   4,  32, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  48,  16,  32, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  40,   8,  32, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  44,   4,  40, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  52,   4,  48, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a,  52,  16,  36, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  44,   8,  36, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  56,   8,  48, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  56,  16,  40, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a,  60,   4,  56, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a,  60,  16,  44, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
    else if (c_d[x_a][channel][i_d] ==  11){
      c_decay(x_a,  60,   8,  52, random_manager.get_random(x_a, 4, 11), random_manager.get_random(x_a, 5, 11));
    }
    else if (c_d[x_a][channel][i_d] ==  12){
      c_decay(x_a,  68,   4,  64, random_manager.get_random(x_a, 4, 12), random_manager.get_random(x_a, 5, 12));
    }
    else if (c_d[x_a][channel][i_d] ==  13){
      c_decay(x_a,  80,  16,  64, random_manager.get_random(x_a, 4, 13), random_manager.get_random(x_a, 5, 13));
    }
    else if (c_d[x_a][channel][i_d] ==  14){
      c_decay(x_a,  72,   8,  64, random_manager.get_random(x_a, 4, 14), random_manager.get_random(x_a, 5, 14));
    }
    else if (c_d[x_a][channel][i_d] ==  15){
      c_decay(x_a,  76,   4,  72, random_manager.get_random(x_a, 4, 15), random_manager.get_random(x_a, 5, 15));
    }
    else if (c_d[x_a][channel][i_d] ==  16){
      c_decay(x_a,  84,   4,  80, random_manager.get_random(x_a, 4, 16), random_manager.get_random(x_a, 5, 16));
    }
    else if (c_d[x_a][channel][i_d] ==  17){
      c_decay(x_a,  84,  16,  68, random_manager.get_random(x_a, 4, 17), random_manager.get_random(x_a, 5, 17));
    }
    else if (c_d[x_a][channel][i_d] ==  18){
      c_decay(x_a,  76,   8,  68, random_manager.get_random(x_a, 4, 18), random_manager.get_random(x_a, 5, 18));
    }
    else if (c_d[x_a][channel][i_d] ==  19){
      c_decay(x_a,  88,   8,  80, random_manager.get_random(x_a, 4, 19), random_manager.get_random(x_a, 5, 19));
    }
    else if (c_d[x_a][channel][i_d] ==  20){
      c_decay(x_a,  88,  16,  72, random_manager.get_random(x_a, 4, 20), random_manager.get_random(x_a, 5, 20));
    }
    else if (c_d[x_a][channel][i_d] ==  21){
      c_decay(x_a,  92,   4,  88, random_manager.get_random(x_a, 4, 21), random_manager.get_random(x_a, 5, 21));
    }
    else if (c_d[x_a][channel][i_d] ==  22){
      c_decay(x_a,  92,  16,  76, random_manager.get_random(x_a, 4, 22), random_manager.get_random(x_a, 5, 22));
    }
    else if (c_d[x_a][channel][i_d] ==  23){
      c_decay(x_a,  92,   8,  84, random_manager.get_random(x_a, 4, 23), random_manager.get_random(x_a, 5, 23));
    }
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
