#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ac_psp_230_ddx_aaaccx(int x_a, int channel){
  static Logger logger("ppaaa03_phasespace_set::ac_psp_230_ddx_aaaccx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][96];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][28], 2);
      c_propagator(x_a,   0,  96, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = smin_opt[x_a][36];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][88], 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_propagator(x_a,   0, 100, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  3] = smin_opt[x_a][68];
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][56], 2);
      c_propagator(x_a,   0,  68, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][100]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_propagator(x_a,   0, 100, v_smin[x_a][  4], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  5] = smin_opt[x_a][48];
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][76], 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][  5], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,   0, 112, v_smin[x_a][  6], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  7] = smin_opt[x_a][80];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][44], 2);
      c_propagator(x_a,   0,  80, v_smin[x_a][  7], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][112]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,   0, 112, v_smin[x_a][  8], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  9] = smin_opt[x_a][40];
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][84], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  9], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 9));
    }
    else if (c_p[x_a][channel][i_p] ==  10){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][104]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_propagator(x_a,   0, 104, v_smin[x_a][ 10], v_smax[x_a][  8], random_manager.get_random(x_a, 0, 10));
    }
    else if (c_p[x_a][channel][i_p] ==  11){
      v_smin[x_a][ 11] = smin_opt[x_a][72];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][52], 2);
      c_propagator(x_a,   0,  72, v_smin[x_a][ 11], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 11));
    }
    else if (c_p[x_a][channel][i_p] ==  12){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][104]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_propagator(x_a,   0, 104, v_smin[x_a][ 12], v_smax[x_a][  8], random_manager.get_random(x_a, 0, 12));
    }
    else if (c_p[x_a][channel][i_p] ==  13){
      v_smin[x_a][ 13] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][ 13], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 13));
    }
    else if (c_p[x_a][channel][i_p] ==  14){
      v_smin[x_a][ 14] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0, 108, v_smin[x_a][ 14], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 14));
    }
    else if (c_p[x_a][channel][i_p] ==  15){
      v_smin[x_a][ 15] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][ 15], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 15));
    }
    else if (c_p[x_a][channel][i_p] ==  16){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][76], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0, 108, v_smin[x_a][ 16], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 16));
    }
    else if (c_p[x_a][channel][i_p] ==  17){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][ 17], v_smax[x_a][ 13], random_manager.get_random(x_a, 0, 17));
    }
    else if (c_p[x_a][channel][i_p] ==  18){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_propagator(x_a,   0, 116, v_smin[x_a][ 18], v_smax[x_a][ 14], random_manager.get_random(x_a, 0, 18));
    }
    else if (c_p[x_a][channel][i_p] ==  19){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][84]);
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,   0,  84, v_smin[x_a][ 19], v_smax[x_a][ 15], random_manager.get_random(x_a, 0, 19));
    }
    else if (c_p[x_a][channel][i_p] ==  20){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][84], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_propagator(x_a,   0, 116, v_smin[x_a][ 20], v_smax[x_a][ 14], random_manager.get_random(x_a, 0, 20));
    }
    else if (c_p[x_a][channel][i_p] ==  21){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][ 21], v_smax[x_a][ 13], random_manager.get_random(x_a, 0, 21));
    }
    else if (c_p[x_a][channel][i_p] ==  22){
      v_smin[x_a][ 22] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][84]);
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,   0,  84, v_smin[x_a][ 22], v_smax[x_a][ 15], random_manager.get_random(x_a, 0, 22));
    }
    else if (c_p[x_a][channel][i_p] ==  23){
      v_smin[x_a][ 23] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][ 23], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 23));
    }
    else if (c_p[x_a][channel][i_p] ==  24){
      v_smin[x_a][ 24] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][ 24], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 24));
    }
    else if (c_p[x_a][channel][i_p] ==  25){
      v_smin[x_a][ 25] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][ 25], v_smax[x_a][ 16], random_manager.get_random(x_a, 0, 25));
    }
    else if (c_p[x_a][channel][i_p] ==  26){
      v_smin[x_a][ 26] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_propagator(x_a,   0, 120, v_smin[x_a][ 26], v_smax[x_a][ 17], random_manager.get_random(x_a, 0, 26));
    }
    else if (c_p[x_a][channel][i_p] ==  27){
      v_smin[x_a][ 27] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 18] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,   0,  88, v_smin[x_a][ 27], v_smax[x_a][ 18], random_manager.get_random(x_a, 0, 27));
    }
    else if (c_p[x_a][channel][i_p] ==  28){
      v_smin[x_a][ 28] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][88], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_propagator(x_a,   0, 120, v_smin[x_a][ 28], v_smax[x_a][ 17], random_manager.get_random(x_a, 0, 28));
    }
    else if (c_p[x_a][channel][i_p] ==  29){
      v_smin[x_a][ 29] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][ 29], v_smax[x_a][ 16], random_manager.get_random(x_a, 0, 29));
    }
    else if (c_p[x_a][channel][i_p] ==  30){
      v_smin[x_a][ 30] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 18] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,   0,  88, v_smin[x_a][ 30], v_smax[x_a][ 18], random_manager.get_random(x_a, 0, 30));
    }
    else if (c_p[x_a][channel][i_p] ==  31){
      v_smin[x_a][  3] = smin_opt[x_a][68];
      v_smax[x_a][ 19] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][56]), 2);
      c_propagator(x_a,   0,  68, v_smin[x_a][  3], v_smax[x_a][ 19], random_manager.get_random(x_a, 0, 31));
    }
    else if (c_p[x_a][channel][i_p] ==  32){
      v_smin[x_a][ 31] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][40] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0, 108, v_smin[x_a][ 31], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 32));
    }
    else if (c_p[x_a][channel][i_p] ==  33){
      v_smin[x_a][  1] = smin_opt[x_a][36];
      v_smax[x_a][ 20] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][72], sqrtsmin_opt[x_a][88]), 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  1], v_smax[x_a][ 20], random_manager.get_random(x_a, 0, 33));
    }
    else if (c_p[x_a][channel][i_p] ==  34){
      v_smin[x_a][ 32] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][36] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0, 108, v_smin[x_a][ 32], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 34));
    }
    else if (c_p[x_a][channel][i_p] ==  35){
      v_smin[x_a][  3] = smin_opt[x_a][68];
      v_smax[x_a][ 21] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][56]), 2);
      c_propagator(x_a,   0,  68, v_smin[x_a][  3], v_smax[x_a][ 21], random_manager.get_random(x_a, 0, 35));
    }
    else if (c_p[x_a][channel][i_p] ==  36){
      v_smin[x_a][ 33] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][48] + xbsqrts_all[x_a][68], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_propagator(x_a,   0, 116, v_smin[x_a][ 33], v_smax[x_a][ 14], random_manager.get_random(x_a, 0, 36));
    }
    else if (c_p[x_a][channel][i_p] ==  37){
      v_smin[x_a][  1] = smin_opt[x_a][36];
      v_smax[x_a][ 22] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][80], sqrtsmin_opt[x_a][88]), 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  1], v_smax[x_a][ 22], random_manager.get_random(x_a, 0, 37));
    }
    else if (c_p[x_a][channel][i_p] ==  38){
      v_smin[x_a][ 34] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][36] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_propagator(x_a,   0, 116, v_smin[x_a][ 34], v_smax[x_a][ 14], random_manager.get_random(x_a, 0, 38));
    }
    else if (c_p[x_a][channel][i_p] ==  39){
      v_smin[x_a][ 11] = smin_opt[x_a][72];
      v_smax[x_a][ 23] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][52]), 2);
      c_propagator(x_a,   0,  72, v_smin[x_a][ 11], v_smax[x_a][ 23], random_manager.get_random(x_a, 0, 39));
    }
    else if (c_p[x_a][channel][i_p] ==  40){
      v_smin[x_a][ 35] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][48] + xbsqrts_all[x_a][72], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_propagator(x_a,   0, 120, v_smin[x_a][ 35], v_smax[x_a][ 17], random_manager.get_random(x_a, 0, 40));
    }
    else if (c_p[x_a][channel][i_p] ==  41){
      v_smin[x_a][  9] = smin_opt[x_a][40];
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][80], sqrtsmin_opt[x_a][84]), 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  9], v_smax[x_a][ 24], random_manager.get_random(x_a, 0, 41));
    }
    else if (c_p[x_a][channel][i_p] ==  42){
      v_smin[x_a][ 36] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][40] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_propagator(x_a,   0, 120, v_smin[x_a][ 36], v_smax[x_a][ 17], random_manager.get_random(x_a, 0, 42));
    }
    else if (c_p[x_a][channel][i_p] ==  43){
      v_smin[x_a][ 37] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][ 25] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 37], v_smax[x_a][ 25], random_manager.get_random(x_a, 0, 43));
    }
    else if (c_p[x_a][channel][i_p] ==  44){
      v_smin[x_a][ 38] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][88], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  92, v_smin[x_a][ 38], v_smax[x_a][ 26], random_manager.get_random(x_a, 0, 44));
    }
    else if (c_p[x_a][channel][i_p] ==  45){
      v_smin[x_a][ 39] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][60]);
      v_smax[x_a][ 25] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 39], v_smax[x_a][ 25], random_manager.get_random(x_a, 0, 45));
    }
    else if (c_p[x_a][channel][i_p] ==  46){
      v_smin[x_a][ 40] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][76], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  92, v_smin[x_a][ 40], v_smax[x_a][ 26], random_manager.get_random(x_a, 0, 46));
    }
    else if (c_p[x_a][channel][i_p] ==  47){
      v_smin[x_a][ 41] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][ 25] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 41], v_smax[x_a][ 25], random_manager.get_random(x_a, 0, 47));
    }
    else if (c_p[x_a][channel][i_p] ==  48){
      v_smin[x_a][ 42] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][84], 2), smin_opt[x_a][92]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  92, v_smin[x_a][ 42], v_smax[x_a][ 26], random_manager.get_random(x_a, 0, 48));
    }
    else if (c_p[x_a][channel][i_p] ==  49){
      v_smin[x_a][  3] = smin_opt[x_a][68];
      v_smax[x_a][ 27] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][56], 2);
      c_propagator(x_a,   0,  68, v_smin[x_a][  3], v_smax[x_a][ 27], random_manager.get_random(x_a, 0, 49));
    }
    else if (c_p[x_a][channel][i_p] ==  50){
      v_smin[x_a][  1] = smin_opt[x_a][36];
      v_smax[x_a][ 28] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][88], 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  1], v_smax[x_a][ 28], random_manager.get_random(x_a, 0, 50));
    }
    else if (c_p[x_a][channel][i_p] ==  51){
      v_smin[x_a][  7] = smin_opt[x_a][80];
      v_smax[x_a][ 29] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][44], 2);
      c_propagator(x_a,   0,  80, v_smin[x_a][  7], v_smax[x_a][ 29], random_manager.get_random(x_a, 0, 51));
    }
    else if (c_p[x_a][channel][i_p] ==  52){
      v_smin[x_a][  5] = smin_opt[x_a][48];
      v_smax[x_a][ 30] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][76], 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][  5], v_smax[x_a][ 30], random_manager.get_random(x_a, 0, 52));
    }
    else if (c_p[x_a][channel][i_p] ==  53){
      v_smin[x_a][ 11] = smin_opt[x_a][72];
      v_smax[x_a][ 31] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][52], 2);
      c_propagator(x_a,   0,  72, v_smin[x_a][ 11], v_smax[x_a][ 31], random_manager.get_random(x_a, 0, 53));
    }
    else if (c_p[x_a][channel][i_p] ==  54){
      v_smin[x_a][  9] = smin_opt[x_a][40];
      v_smax[x_a][ 32] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][84], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  9], v_smax[x_a][ 32], random_manager.get_random(x_a, 0, 54));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][ 43] = smin_opt[x_a][12];
      v_smax[x_a][ 33] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][96], sqrtsmin_opt[x_a][112]), 2);
      c_timelikeinvariant(x_a,  12, v_smin[x_a][ 43], v_smax[x_a][ 33], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][ 44] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 44], v_smax[x_a][ 11], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][ 45] = smin_opt[x_a][20];
      v_smax[x_a][ 34] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][96], sqrtsmin_opt[x_a][104]), 2);
      c_timelikeinvariant(x_a,  20, v_smin[x_a][ 45], v_smax[x_a][ 34], random_manager.get_random(x_a, 1, 2));
    }
    else if (c_f[x_a][channel][i_f] ==   3){
      v_smin[x_a][ 46] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][20] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 46], v_smax[x_a][ 14], random_manager.get_random(x_a, 1, 3));
    }
    else if (c_f[x_a][channel][i_f] ==   4){
      v_smin[x_a][ 47] = smin_opt[x_a][24];
      v_smax[x_a][ 35] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][96], sqrtsmin_opt[x_a][100]), 2);
      c_timelikeinvariant(x_a,  24, v_smin[x_a][ 47], v_smax[x_a][ 35], random_manager.get_random(x_a, 1, 4));
    }
    else if (c_f[x_a][channel][i_f] ==   5){
      v_smin[x_a][ 48] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][24] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 48], v_smax[x_a][ 17], random_manager.get_random(x_a, 1, 5));
    }
    else if (c_f[x_a][channel][i_f] ==   6){
      v_smin[x_a][ 49] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][100], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 49], v_smax[x_a][ 11], random_manager.get_random(x_a, 1, 6));
    }
    else if (c_f[x_a][channel][i_f] ==   7){
      v_smin[x_a][ 50] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][100], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 50], v_smax[x_a][ 14], random_manager.get_random(x_a, 1, 7));
    }
    else if (c_f[x_a][channel][i_f] ==   8){
      v_smin[x_a][ 51] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][112], 2), smin_opt[x_a][116]);
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a, 116, v_smin[x_a][ 51], v_smax[x_a][ 14], random_manager.get_random(x_a, 1, 8));
    }
    else if (c_f[x_a][channel][i_f] ==   9){
      v_smin[x_a][ 52] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][104], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 52], v_smax[x_a][ 11], random_manager.get_random(x_a, 1, 9));
    }
    else if (c_f[x_a][channel][i_f] ==  10){
      v_smin[x_a][ 53] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][104], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 53], v_smax[x_a][ 17], random_manager.get_random(x_a, 1, 10));
    }
    else if (c_f[x_a][channel][i_f] ==  11){
      v_smin[x_a][ 54] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][112], 2), smin_opt[x_a][120]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a, 120, v_smin[x_a][ 54], v_smax[x_a][ 17], random_manager.get_random(x_a, 1, 11));
    }
    else if (c_f[x_a][channel][i_f] ==  12){
      v_smin[x_a][ 55] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][104]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_timelikeinvariant(x_a, 104, v_smin[x_a][ 55], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 12));
    }
    else if (c_f[x_a][channel][i_f] ==  13){
      v_smin[x_a][ 56] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][112]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_timelikeinvariant(x_a, 112, v_smin[x_a][ 56], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 13));
    }
    else if (c_f[x_a][channel][i_f] ==  14){
      v_smin[x_a][ 57] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][100]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_timelikeinvariant(x_a, 100, v_smin[x_a][ 57], v_smax[x_a][  2], random_manager.get_random(x_a, 1, 14));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  16, 108, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0, 108,   1,  18,  96,  12, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel(x_a,   0,  12,  18,  97,   8,   4, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel_opt(x_a,   0, 124,   2,   1,   8, 116, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel_opt(x_a,   0, 116,   1,  10,  96,  20, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel(x_a,   0,  20,  10,  97,  16,   4, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel(x_a,   0,  20,  10,  97,   4,  16, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel(x_a,   0,  12,  18,  97,   4,   8, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel_opt(x_a,   0, 124,   2,   1,   4, 120, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel_opt(x_a,   0, 120,   1,   6,  96,  24, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel(x_a,   0,  24,   6,  97,  16,   8, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel(x_a,   0,  24,   6,  97,   8,  16, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
    else if (c_t[x_a][channel][i_t] ==  12){
      c_tchannel_opt(x_a,   0, 108,  18,   1,   8, 100, random_manager.get_random(x_a, 2, 12), random_manager.get_random(x_a, 3, 12));
    }
    else if (c_t[x_a][channel][i_t] ==  13){
      c_tchannel_opt(x_a,   0, 116,  10,   1,  16, 100, random_manager.get_random(x_a, 2, 13), random_manager.get_random(x_a, 3, 13));
    }
    else if (c_t[x_a][channel][i_t] ==  14){
      c_tchannel_opt(x_a,   0, 116,  10,   1,   4, 112, random_manager.get_random(x_a, 2, 14), random_manager.get_random(x_a, 3, 14));
    }
    else if (c_t[x_a][channel][i_t] ==  15){
      c_tchannel_opt(x_a,   0, 108,  18,   1,   4, 104, random_manager.get_random(x_a, 2, 15), random_manager.get_random(x_a, 3, 15));
    }
    else if (c_t[x_a][channel][i_t] ==  16){
      c_tchannel_opt(x_a,   0, 120,   6,   1,  16, 104, random_manager.get_random(x_a, 2, 16), random_manager.get_random(x_a, 3, 16));
    }
    else if (c_t[x_a][channel][i_t] ==  17){
      c_tchannel_opt(x_a,   0, 120,   6,   1,   8, 112, random_manager.get_random(x_a, 2, 17), random_manager.get_random(x_a, 3, 17));
    }
    else if (c_t[x_a][channel][i_t] ==  18){
      c_tchannel_opt(x_a,   0, 124,   1,   2,   4, 120, random_manager.get_random(x_a, 2, 18), random_manager.get_random(x_a, 3, 18));
    }
    else if (c_t[x_a][channel][i_t] ==  19){
      c_tchannel_opt(x_a,   0, 120,   2,   5,  16, 104, random_manager.get_random(x_a, 2, 19), random_manager.get_random(x_a, 3, 19));
    }
    else if (c_t[x_a][channel][i_t] ==  20){
      c_tchannel(x_a,   0, 104,  18,   5,   8,  96, random_manager.get_random(x_a, 2, 20), random_manager.get_random(x_a, 3, 20));
    }
    else if (c_t[x_a][channel][i_t] ==  21){
      c_tchannel_opt(x_a,   0, 120,   2,   5,   8, 112, random_manager.get_random(x_a, 2, 21), random_manager.get_random(x_a, 3, 21));
    }
    else if (c_t[x_a][channel][i_t] ==  22){
      c_tchannel(x_a,   0, 112,  10,   5,  16,  96, random_manager.get_random(x_a, 2, 22), random_manager.get_random(x_a, 3, 22));
    }
    else if (c_t[x_a][channel][i_t] ==  23){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  16, 108, random_manager.get_random(x_a, 2, 23), random_manager.get_random(x_a, 3, 23));
    }
    else if (c_t[x_a][channel][i_t] ==  24){
      c_tchannel_opt(x_a,   0, 108,   2,  17,   8, 100, random_manager.get_random(x_a, 2, 24), random_manager.get_random(x_a, 3, 24));
    }
    else if (c_t[x_a][channel][i_t] ==  25){
      c_tchannel(x_a,   0, 100,  10,  17,   4,  96, random_manager.get_random(x_a, 2, 25), random_manager.get_random(x_a, 3, 25));
    }
    else if (c_t[x_a][channel][i_t] ==  26){
      c_tchannel_opt(x_a,   0, 124,   1,   2,   8, 116, random_manager.get_random(x_a, 2, 26), random_manager.get_random(x_a, 3, 26));
    }
    else if (c_t[x_a][channel][i_t] ==  27){
      c_tchannel_opt(x_a,   0, 116,   2,   9,  16, 100, random_manager.get_random(x_a, 2, 27), random_manager.get_random(x_a, 3, 27));
    }
    else if (c_t[x_a][channel][i_t] ==  28){
      c_tchannel(x_a,   0, 100,  18,   9,   4,  96, random_manager.get_random(x_a, 2, 28), random_manager.get_random(x_a, 3, 28));
    }
    else if (c_t[x_a][channel][i_t] ==  29){
      c_tchannel_opt(x_a,   0, 116,   2,   9,   4, 112, random_manager.get_random(x_a, 2, 29), random_manager.get_random(x_a, 3, 29));
    }
    else if (c_t[x_a][channel][i_t] ==  30){
      c_tchannel(x_a,   0, 112,   6,   9,  16,  96, random_manager.get_random(x_a, 2, 30), random_manager.get_random(x_a, 3, 30));
    }
    else if (c_t[x_a][channel][i_t] ==  31){
      c_tchannel_opt(x_a,   0, 108,   2,  17,   4, 104, random_manager.get_random(x_a, 2, 31), random_manager.get_random(x_a, 3, 31));
    }
    else if (c_t[x_a][channel][i_t] ==  32){
      c_tchannel(x_a,   0, 104,   6,  17,   8,  96, random_manager.get_random(x_a, 2, 32), random_manager.get_random(x_a, 3, 32));
    }
    else if (c_t[x_a][channel][i_t] ==  33){
      c_tchannel(x_a,   0, 104,   5,  18,   8,  96, random_manager.get_random(x_a, 2, 33), random_manager.get_random(x_a, 3, 33));
    }
    else if (c_t[x_a][channel][i_t] ==  34){
      c_tchannel(x_a,   0, 112,   5,  10,  16,  96, random_manager.get_random(x_a, 2, 34), random_manager.get_random(x_a, 3, 34));
    }
    else if (c_t[x_a][channel][i_t] ==  35){
      c_tchannel(x_a,   0, 100,  17,  10,   4,  96, random_manager.get_random(x_a, 2, 35), random_manager.get_random(x_a, 3, 35));
    }
    else if (c_t[x_a][channel][i_t] ==  36){
      c_tchannel(x_a,   0, 100,   9,  18,   4,  96, random_manager.get_random(x_a, 2, 36), random_manager.get_random(x_a, 3, 36));
    }
    else if (c_t[x_a][channel][i_t] ==  37){
      c_tchannel(x_a,   0, 112,   9,   6,  16,  96, random_manager.get_random(x_a, 2, 37), random_manager.get_random(x_a, 3, 37));
    }
    else if (c_t[x_a][channel][i_t] ==  38){
      c_tchannel(x_a,   0, 104,  17,   6,   8,  96, random_manager.get_random(x_a, 2, 38), random_manager.get_random(x_a, 3, 38));
    }
    else if (c_t[x_a][channel][i_t] ==  39){
      c_tchannel_opt(x_a,   0, 120,   5,   2,   8, 112, random_manager.get_random(x_a, 2, 39), random_manager.get_random(x_a, 3, 39));
    }
    else if (c_t[x_a][channel][i_t] ==  40){
      c_tchannel_opt(x_a,   0, 120,   5,   2,  16, 104, random_manager.get_random(x_a, 2, 40), random_manager.get_random(x_a, 3, 40));
    }
    else if (c_t[x_a][channel][i_t] ==  41){
      c_tchannel_opt(x_a,   0, 108,  17,   2,   4, 104, random_manager.get_random(x_a, 2, 41), random_manager.get_random(x_a, 3, 41));
    }
    else if (c_t[x_a][channel][i_t] ==  42){
      c_tchannel_opt(x_a,   0, 116,   9,   2,   4, 112, random_manager.get_random(x_a, 2, 42), random_manager.get_random(x_a, 3, 42));
    }
    else if (c_t[x_a][channel][i_t] ==  43){
      c_tchannel_opt(x_a,   0, 116,   9,   2,  16, 100, random_manager.get_random(x_a, 2, 43), random_manager.get_random(x_a, 3, 43));
    }
    else if (c_t[x_a][channel][i_t] ==  44){
      c_tchannel_opt(x_a,   0, 108,  17,   2,   8, 100, random_manager.get_random(x_a, 2, 44), random_manager.get_random(x_a, 3, 44));
    }
    else if (c_t[x_a][channel][i_t] ==  45){
      c_tchannel_opt(x_a,   0, 120,   2,   5,  96,  24, random_manager.get_random(x_a, 2, 45), random_manager.get_random(x_a, 3, 45));
    }
    else if (c_t[x_a][channel][i_t] ==  46){
      c_tchannel(x_a,   0,  24,   5,  98,   8,  16, random_manager.get_random(x_a, 2, 46), random_manager.get_random(x_a, 3, 46));
    }
    else if (c_t[x_a][channel][i_t] ==  47){
      c_tchannel(x_a,   0,  24,   5,  98,  16,   8, random_manager.get_random(x_a, 2, 47), random_manager.get_random(x_a, 3, 47));
    }
    else if (c_t[x_a][channel][i_t] ==  48){
      c_tchannel_opt(x_a,   0, 108,   2,  17,  96,  12, random_manager.get_random(x_a, 2, 48), random_manager.get_random(x_a, 3, 48));
    }
    else if (c_t[x_a][channel][i_t] ==  49){
      c_tchannel(x_a,   0,  12,  17,  98,   4,   8, random_manager.get_random(x_a, 2, 49), random_manager.get_random(x_a, 3, 49));
    }
    else if (c_t[x_a][channel][i_t] ==  50){
      c_tchannel_opt(x_a,   0, 116,   2,   9,  96,  20, random_manager.get_random(x_a, 2, 50), random_manager.get_random(x_a, 3, 50));
    }
    else if (c_t[x_a][channel][i_t] ==  51){
      c_tchannel(x_a,   0,  20,   9,  98,   4,  16, random_manager.get_random(x_a, 2, 51), random_manager.get_random(x_a, 3, 51));
    }
    else if (c_t[x_a][channel][i_t] ==  52){
      c_tchannel(x_a,   0,  20,   9,  98,  16,   4, random_manager.get_random(x_a, 2, 52), random_manager.get_random(x_a, 3, 52));
    }
    else if (c_t[x_a][channel][i_t] ==  53){
      c_tchannel(x_a,   0,  12,  17,  98,   8,   4, random_manager.get_random(x_a, 2, 53), random_manager.get_random(x_a, 3, 53));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  96,  32,  64, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a, 100,  64,  36, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  36,   4,  32, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a, 100,  32,  68, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  68,   4,  64, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a, 112,  64,  48, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  48,  16,  32, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a, 112,  32,  80, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  80,  16,  64, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a, 104,  64,  40, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a,  40,   8,  32, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
    else if (c_d[x_a][channel][i_d] ==  11){
      c_decay(x_a, 104,  32,  72, random_manager.get_random(x_a, 4, 11), random_manager.get_random(x_a, 5, 11));
    }
    else if (c_d[x_a][channel][i_d] ==  12){
      c_decay(x_a,  72,   8,  64, random_manager.get_random(x_a, 4, 12), random_manager.get_random(x_a, 5, 12));
    }
    else if (c_d[x_a][channel][i_d] ==  13){
      c_decay(x_a, 108,  64,  44, random_manager.get_random(x_a, 4, 13), random_manager.get_random(x_a, 5, 13));
    }
    else if (c_d[x_a][channel][i_d] ==  14){
      c_decay(x_a,  44,   4,  40, random_manager.get_random(x_a, 4, 14), random_manager.get_random(x_a, 5, 14));
    }
    else if (c_d[x_a][channel][i_d] ==  15){
      c_decay(x_a, 108,  32,  76, random_manager.get_random(x_a, 4, 15), random_manager.get_random(x_a, 5, 15));
    }
    else if (c_d[x_a][channel][i_d] ==  16){
      c_decay(x_a,  76,   4,  72, random_manager.get_random(x_a, 4, 16), random_manager.get_random(x_a, 5, 16));
    }
    else if (c_d[x_a][channel][i_d] ==  17){
      c_decay(x_a, 116,  64,  52, random_manager.get_random(x_a, 4, 17), random_manager.get_random(x_a, 5, 17));
    }
    else if (c_d[x_a][channel][i_d] ==  18){
      c_decay(x_a,  52,   4,  48, random_manager.get_random(x_a, 4, 18), random_manager.get_random(x_a, 5, 18));
    }
    else if (c_d[x_a][channel][i_d] ==  19){
      c_decay(x_a, 116,  32,  84, random_manager.get_random(x_a, 4, 19), random_manager.get_random(x_a, 5, 19));
    }
    else if (c_d[x_a][channel][i_d] ==  20){
      c_decay(x_a,  84,   4,  80, random_manager.get_random(x_a, 4, 20), random_manager.get_random(x_a, 5, 20));
    }
    else if (c_d[x_a][channel][i_d] ==  21){
      c_decay(x_a,  52,  16,  36, random_manager.get_random(x_a, 4, 21), random_manager.get_random(x_a, 5, 21));
    }
    else if (c_d[x_a][channel][i_d] ==  22){
      c_decay(x_a,  84,  16,  68, random_manager.get_random(x_a, 4, 22), random_manager.get_random(x_a, 5, 22));
    }
    else if (c_d[x_a][channel][i_d] ==  23){
      c_decay(x_a,  44,   8,  36, random_manager.get_random(x_a, 4, 23), random_manager.get_random(x_a, 5, 23));
    }
    else if (c_d[x_a][channel][i_d] ==  24){
      c_decay(x_a,  76,   8,  68, random_manager.get_random(x_a, 4, 24), random_manager.get_random(x_a, 5, 24));
    }
    else if (c_d[x_a][channel][i_d] ==  25){
      c_decay(x_a, 120,  64,  56, random_manager.get_random(x_a, 4, 25), random_manager.get_random(x_a, 5, 25));
    }
    else if (c_d[x_a][channel][i_d] ==  26){
      c_decay(x_a,  56,   8,  48, random_manager.get_random(x_a, 4, 26), random_manager.get_random(x_a, 5, 26));
    }
    else if (c_d[x_a][channel][i_d] ==  27){
      c_decay(x_a, 120,  32,  88, random_manager.get_random(x_a, 4, 27), random_manager.get_random(x_a, 5, 27));
    }
    else if (c_d[x_a][channel][i_d] ==  28){
      c_decay(x_a,  88,   8,  80, random_manager.get_random(x_a, 4, 28), random_manager.get_random(x_a, 5, 28));
    }
    else if (c_d[x_a][channel][i_d] ==  29){
      c_decay(x_a,  56,  16,  40, random_manager.get_random(x_a, 4, 29), random_manager.get_random(x_a, 5, 29));
    }
    else if (c_d[x_a][channel][i_d] ==  30){
      c_decay(x_a,  88,  16,  72, random_manager.get_random(x_a, 4, 30), random_manager.get_random(x_a, 5, 30));
    }
    else if (c_d[x_a][channel][i_d] ==  31){
      c_decay(x_a, 108,  68,  40, random_manager.get_random(x_a, 4, 31), random_manager.get_random(x_a, 5, 31));
    }
    else if (c_d[x_a][channel][i_d] ==  32){
      c_decay(x_a, 108,  36,  72, random_manager.get_random(x_a, 4, 32), random_manager.get_random(x_a, 5, 32));
    }
    else if (c_d[x_a][channel][i_d] ==  33){
      c_decay(x_a, 116,  68,  48, random_manager.get_random(x_a, 4, 33), random_manager.get_random(x_a, 5, 33));
    }
    else if (c_d[x_a][channel][i_d] ==  34){
      c_decay(x_a, 116,  36,  80, random_manager.get_random(x_a, 4, 34), random_manager.get_random(x_a, 5, 34));
    }
    else if (c_d[x_a][channel][i_d] ==  35){
      c_decay(x_a, 120,  72,  48, random_manager.get_random(x_a, 4, 35), random_manager.get_random(x_a, 5, 35));
    }
    else if (c_d[x_a][channel][i_d] ==  36){
      c_decay(x_a, 120,  40,  80, random_manager.get_random(x_a, 4, 36), random_manager.get_random(x_a, 5, 36));
    }
    else if (c_d[x_a][channel][i_d] ==  37){
      c_decay(x_a, 124,  64,  60, random_manager.get_random(x_a, 4, 37), random_manager.get_random(x_a, 5, 37));
    }
    else if (c_d[x_a][channel][i_d] ==  38){
      c_decay(x_a,  60,   4,  56, random_manager.get_random(x_a, 4, 38), random_manager.get_random(x_a, 5, 38));
    }
    else if (c_d[x_a][channel][i_d] ==  39){
      c_decay(x_a, 124,  32,  92, random_manager.get_random(x_a, 4, 39), random_manager.get_random(x_a, 5, 39));
    }
    else if (c_d[x_a][channel][i_d] ==  40){
      c_decay(x_a,  92,   4,  88, random_manager.get_random(x_a, 4, 40), random_manager.get_random(x_a, 5, 40));
    }
    else if (c_d[x_a][channel][i_d] ==  41){
      c_decay(x_a,  60,  16,  44, random_manager.get_random(x_a, 4, 41), random_manager.get_random(x_a, 5, 41));
    }
    else if (c_d[x_a][channel][i_d] ==  42){
      c_decay(x_a,  92,  16,  76, random_manager.get_random(x_a, 4, 42), random_manager.get_random(x_a, 5, 42));
    }
    else if (c_d[x_a][channel][i_d] ==  43){
      c_decay(x_a,  60,   8,  52, random_manager.get_random(x_a, 4, 43), random_manager.get_random(x_a, 5, 43));
    }
    else if (c_d[x_a][channel][i_d] ==  44){
      c_decay(x_a,  92,   8,  84, random_manager.get_random(x_a, 4, 44), random_manager.get_random(x_a, 5, 44));
    }
    else if (c_d[x_a][channel][i_d] ==  45){
      c_decay(x_a, 124,  68,  56, random_manager.get_random(x_a, 4, 45), random_manager.get_random(x_a, 5, 45));
    }
    else if (c_d[x_a][channel][i_d] ==  46){
      c_decay(x_a, 124,  36,  88, random_manager.get_random(x_a, 4, 46), random_manager.get_random(x_a, 5, 46));
    }
    else if (c_d[x_a][channel][i_d] ==  47){
      c_decay(x_a, 124,  80,  44, random_manager.get_random(x_a, 4, 47), random_manager.get_random(x_a, 5, 47));
    }
    else if (c_d[x_a][channel][i_d] ==  48){
      c_decay(x_a, 124,  48,  76, random_manager.get_random(x_a, 4, 48), random_manager.get_random(x_a, 5, 48));
    }
    else if (c_d[x_a][channel][i_d] ==  49){
      c_decay(x_a, 124,  72,  52, random_manager.get_random(x_a, 4, 49), random_manager.get_random(x_a, 5, 49));
    }
    else if (c_d[x_a][channel][i_d] ==  50){
      c_decay(x_a, 124,  40,  84, random_manager.get_random(x_a, 4, 50), random_manager.get_random(x_a, 5, 50));
    }
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
