#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ag_psp_230_gg_aaa(int x_a, int zero){
  static Logger logger("ppaaa03_phasespace_set::ag_psp_230_gg_aaa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][5] == nullvector){xbp_all[x_a][5] = xbp_all[x_a][1] - xbp_all[x_a][4];}
  if (xbs_all[x_a][5] == 0.){xbs_all[x_a][5] = xbp_all[x_a][5].m2();}
  if (xbs_all[x_a][5] > 0.){xbs_all[x_a][5] = 0.;}
  if (xbp_all[x_a][6] == nullvector){xbp_all[x_a][6] = xbp_all[x_a][2] - xbp_all[x_a][4];}
  if (xbs_all[x_a][6] == 0.){xbs_all[x_a][6] = xbp_all[x_a][6].m2();}
  if (xbs_all[x_a][6] > 0.){xbs_all[x_a][6] = 0.;}
  if (xbp_all[x_a][9] == nullvector){xbp_all[x_a][9] = xbp_all[x_a][1] - xbp_all[x_a][8];}
  if (xbs_all[x_a][9] == 0.){xbs_all[x_a][9] = xbp_all[x_a][9].m2();}
  if (xbs_all[x_a][9] > 0.){xbs_all[x_a][9] = 0.;}
  if (xbp_all[x_a][10] == nullvector){xbp_all[x_a][10] = xbp_all[x_a][2] - xbp_all[x_a][8];}
  if (xbs_all[x_a][10] == 0.){xbs_all[x_a][10] = xbp_all[x_a][10].m2();}
  if (xbs_all[x_a][10] > 0.){xbs_all[x_a][10] = 0.;}
  if (xbp_all[x_a][12] == nullvector){xbp_all[x_a][12] = xbp_all[x_a][4] + xbp_all[x_a][8];}
  if (xbs_all[x_a][12] == 0.){xbs_all[x_a][12] = xbp_all[x_a][12].m2();}
  if (xbs_all[x_a][12] < 0.){xbs_all[x_a][12] = 0.;}
  if (xbp_all[x_a][17] == nullvector){xbp_all[x_a][17] = xbp_all[x_a][1] - xbp_all[x_a][16];}
  if (xbs_all[x_a][17] == 0.){xbs_all[x_a][17] = xbp_all[x_a][17].m2();}
  if (xbs_all[x_a][17] > 0.){xbs_all[x_a][17] = 0.;}
  if (xbp_all[x_a][18] == nullvector){xbp_all[x_a][18] = xbp_all[x_a][2] - xbp_all[x_a][16];}
  if (xbs_all[x_a][18] == 0.){xbs_all[x_a][18] = xbp_all[x_a][18].m2();}
  if (xbs_all[x_a][18] > 0.){xbs_all[x_a][18] = 0.;}
  if (xbp_all[x_a][20] == nullvector){xbp_all[x_a][20] = xbp_all[x_a][4] + xbp_all[x_a][16];}
  if (xbs_all[x_a][20] == 0.){xbs_all[x_a][20] = xbp_all[x_a][20].m2();}
  if (xbs_all[x_a][20] < 0.){xbs_all[x_a][20] = 0.;}
  if (xbp_all[x_a][24] == nullvector){xbp_all[x_a][24] = xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][24] == 0.){xbs_all[x_a][24] = xbp_all[x_a][24].m2();}
  if (xbs_all[x_a][24] < 0.){xbs_all[x_a][24] = 0.;}
  if (xbp_all[x_a][28] == nullvector){xbp_all[x_a][28] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][28] == 0.){xbs_all[x_a][28] = xbp_all[x_a][28].m2();}
  if (xbs_all[x_a][28] < 0.){xbs_all[x_a][28] = 0.;}

  v_smin[x_a][  0] = smin_opt[x_a][12]; // 12 times
  v_smin[x_a][  1] = smin_opt[x_a][20]; // 12 times
  v_smin[x_a][  2] = smin_opt[x_a][24]; // 12 times

  v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2); // 12 times
  v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2); // 12 times
  v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2); // 12 times

  //  vector<double> g_p(6);
  {g_p[x_a][  0] = g_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 4 times
  {g_p[x_a][  1] = g_propagator(x_a,  36,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 4 times
  {g_p[x_a][  2] = g_propagator(x_a,   0,  20, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 2 */} // 4 times
  {g_p[x_a][  3] = g_propagator(x_a,  36,  20, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 2 */} // 4 times
  {g_p[x_a][  4] = g_propagator(x_a,   0,  24, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 2 */} // 4 times
  {g_p[x_a][  5] = g_propagator(x_a,  36,  24, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 2 */} // 4 times

  //  vector<double> g_f(3);
  {g_f[x_a][  0] = g_timelikeinvariant(v_smin[x_a][  2], v_smax[x_a][  2]); /* nfp 2 */} // 4 times
  {g_f[x_a][  1] = g_timelikeinvariant(v_smin[x_a][  0], v_smax[x_a][  0]); /* nfp 2 */} // 4 times
  {g_f[x_a][  2] = g_timelikeinvariant(v_smin[x_a][  1], v_smax[x_a][  1]); /* nfp 2 */} // 4 times

  //  vector<double> g_t(24);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  28,   1,   2,   4,  24); /* ntp 0 */} // 3 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,   0,  24,   2,   5,  16,   8); /* ntp 1 */} // 1 times
  {g_t[x_a][  2] = g_tchannel_opt(x_a,  36,  28,   1,   2,   4,  24); /* ntp 0 */} // 3 times
  {g_t[x_a][  3] = g_tchannel_opt(x_a,  36,  24,   2,   5,  16,   8); /* ntp 1 */} // 1 times
  {g_t[x_a][  4] = g_tchannel_opt(x_a,   0,  24,   2,   5,   8,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][  5] = g_tchannel_opt(x_a,  36,  24,   2,   5,   8,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][  6] = g_tchannel_opt(x_a,   0,  28,   1,   2,  16,  12); /* ntp 0 */} // 3 times
  {g_t[x_a][  7] = g_tchannel_opt(x_a,   0,  12,   2,  17,   8,   4); /* ntp 1 */} // 1 times
  {g_t[x_a][  8] = g_tchannel_opt(x_a,  36,  28,   1,   2,  16,  12); /* ntp 0 */} // 3 times
  {g_t[x_a][  9] = g_tchannel_opt(x_a,  36,  12,   2,  17,   8,   4); /* ntp 1 */} // 1 times
  {g_t[x_a][ 10] = g_tchannel_opt(x_a,   0,  28,   1,   2,   8,  20); /* ntp 0 */} // 3 times
  {g_t[x_a][ 11] = g_tchannel_opt(x_a,   0,  20,   2,   9,  16,   4); /* ntp 1 */} // 1 times
  {g_t[x_a][ 12] = g_tchannel_opt(x_a,  36,  28,   1,   2,   8,  20); /* ntp 0 */} // 3 times
  {g_t[x_a][ 13] = g_tchannel_opt(x_a,  36,  20,   2,   9,  16,   4); /* ntp 1 */} // 1 times
  {g_t[x_a][ 14] = g_tchannel_opt(x_a,   0,  20,   2,   9,   4,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][ 15] = g_tchannel_opt(x_a,  36,  20,   2,   9,   4,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][ 16] = g_tchannel_opt(x_a,   0,  12,   2,  17,   4,   8); /* ntp 1 */} // 1 times
  {g_t[x_a][ 17] = g_tchannel_opt(x_a,  36,  12,   2,  17,   4,   8); /* ntp 1 */} // 1 times
  {g_t[x_a][ 18] = g_tchannel_opt(x_a,   0,  28,   2,   1,  16,  12); /* ntp 0 */} // 1 times
  {g_t[x_a][ 19] = g_tchannel_opt(x_a,  36,  28,   2,   1,  16,  12); /* ntp 0 */} // 1 times
  {g_t[x_a][ 20] = g_tchannel_opt(x_a,   0,  28,   2,   1,   8,  20); /* ntp 0 */} // 1 times
  {g_t[x_a][ 21] = g_tchannel_opt(x_a,  36,  28,   2,   1,   8,  20); /* ntp 0 */} // 1 times
  {g_t[x_a][ 22] = g_tchannel_opt(x_a,   0,  28,   2,   1,   4,  24); /* ntp 0 */} // 1 times
  {g_t[x_a][ 23] = g_tchannel_opt(x_a,  36,  28,   2,   1,   4,  24); /* ntp 0 */} // 1 times

  //  vector<double> g_d(6);
  {g_d[x_a][  0] = g_decay(x_a,  12,   4,   8); /* ndp 2 */} // 8 times
  {g_d[x_a][  1] = g_decay(x_a,  20,   4,  16); /* ndp 2 */} // 8 times
  {g_d[x_a][  2] = g_decay(x_a,  24,   8,  16); /* ndp 2 */} // 8 times
  {g_d[x_a][  3] = g_decay(x_a,  28,   4,  24); /* ndp 3 */} // 4 times
  {g_d[x_a][  4] = g_decay(x_a,  28,  16,  12); /* ndp 3 */} // 4 times
  {g_d[x_a][  5] = g_decay(x_a,  28,   8,  20); /* ndp 3 */} // 4 times


  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(6);
    inv_r[1].resize(3);
    inv_r[2].resize(24);
    inv_r[3].resize(24);
    inv_r[4].resize(6);
    inv_r[5].resize(6);

    {inv_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][0]);} // 4 times
    {inv_propagator(x_a,  36,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][1]);} // 4 times
    {inv_propagator(x_a,   0,  20, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][2]);} // 4 times
    {inv_propagator(x_a,  36,  20, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][3]);} // 4 times
    {inv_propagator(x_a,   0,  24, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][4]);} // 4 times
    {inv_propagator(x_a,  36,  24, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][5]);} // 4 times

    {inv_timelikeinvariant(x_a,  24, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[1][0]);} // 4 times
    {inv_timelikeinvariant(x_a,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[1][1]);} // 4 times
    {inv_timelikeinvariant(x_a,  20, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[1][2]);} // 4 times

    {inv_tchannel_opt(x_a,   0,  28,   1,   2,   4,  24, inv_r[2][0], inv_r[3][0]);} // 3 times
    {inv_tchannel_opt(x_a,   0,  24,   2,   5,  16,   8, inv_r[2][1], inv_r[3][1]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  28,   1,   2,   4,  24, inv_r[2][2], inv_r[3][2]);} // 3 times
    {inv_tchannel_opt(x_a,  36,  24,   2,   5,  16,   8, inv_r[2][3], inv_r[3][3]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  24,   2,   5,   8,  16, inv_r[2][4], inv_r[3][4]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  24,   2,   5,   8,  16, inv_r[2][5], inv_r[3][5]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  28,   1,   2,  16,  12, inv_r[2][6], inv_r[3][6]);} // 3 times
    {inv_tchannel_opt(x_a,   0,  12,   2,  17,   8,   4, inv_r[2][7], inv_r[3][7]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  28,   1,   2,  16,  12, inv_r[2][8], inv_r[3][8]);} // 3 times
    {inv_tchannel_opt(x_a,  36,  12,   2,  17,   8,   4, inv_r[2][9], inv_r[3][9]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  28,   1,   2,   8,  20, inv_r[2][10], inv_r[3][10]);} // 3 times
    {inv_tchannel_opt(x_a,   0,  20,   2,   9,  16,   4, inv_r[2][11], inv_r[3][11]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  28,   1,   2,   8,  20, inv_r[2][12], inv_r[3][12]);} // 3 times
    {inv_tchannel_opt(x_a,  36,  20,   2,   9,  16,   4, inv_r[2][13], inv_r[3][13]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  20,   2,   9,   4,  16, inv_r[2][14], inv_r[3][14]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  20,   2,   9,   4,  16, inv_r[2][15], inv_r[3][15]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  12,   2,  17,   4,   8, inv_r[2][16], inv_r[3][16]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  12,   2,  17,   4,   8, inv_r[2][17], inv_r[3][17]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  28,   2,   1,  16,  12, inv_r[2][18], inv_r[3][18]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  28,   2,   1,  16,  12, inv_r[2][19], inv_r[3][19]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  28,   2,   1,   8,  20, inv_r[2][20], inv_r[3][20]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  28,   2,   1,   8,  20, inv_r[2][21], inv_r[3][21]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  28,   2,   1,   4,  24, inv_r[2][22], inv_r[3][22]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  28,   2,   1,   4,  24, inv_r[2][23], inv_r[3][23]);} // 1 times

    {inv_decay(x_a,  12,   4,   8, inv_r[4][0], inv_r[5][0]);} // 8 times
    {inv_decay(x_a,  20,   4,  16, inv_r[4][1], inv_r[5][1]);} // 8 times
    {inv_decay(x_a,  24,   8,  16, inv_r[4][2], inv_r[5][2]);} // 8 times
    {inv_decay(x_a,  28,   4,  24, inv_r[4][3], inv_r[5][3]);} // 4 times
    {inv_decay(x_a,  28,  16,  12, inv_r[4][4], inv_r[5][4]);} // 4 times
    {inv_decay(x_a,  28,   8,  20, inv_r[4][5], inv_r[5][5]);} // 4 times

    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(36, vector<double> (5));
      vector<double> g_IS(36, 1.);
      for (int i_c = 0; i_c < 36; i_c++){
        int ran = 0;
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 5; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  3];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_IS[  2] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  4];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_IS[  3] * g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  5];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_IS[  4] * g_f[x_a][  1] * g_t[x_a][  6] * g_t[x_a][  7];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_IS[  5] * g_f[x_a][  1] * g_t[x_a][  8] * g_t[x_a][  9];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_IS[  6] * g_f[x_a][  2] * g_t[x_a][ 10] * g_t[x_a][ 11];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_IS[  7] * g_f[x_a][  2] * g_t[x_a][ 12] * g_t[x_a][ 13];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_IS[  8] * g_f[x_a][  2] * g_t[x_a][ 10] * g_t[x_a][ 14];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_IS[  9] * g_f[x_a][  2] * g_t[x_a][ 12] * g_t[x_a][ 15];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_IS[ 10] * g_f[x_a][  1] * g_t[x_a][  6] * g_t[x_a][ 16];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_IS[ 11] * g_f[x_a][  1] * g_t[x_a][  8] * g_t[x_a][ 17];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_IS[ 12] * g_p[x_a][  0] * g_t[x_a][ 18] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_IS[ 13] * g_p[x_a][  1] * g_t[x_a][ 19] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_IS[ 14] * g_p[x_a][  2] * g_t[x_a][ 20] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_IS[ 15] * g_p[x_a][  3] * g_t[x_a][ 21] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_IS[ 16] * g_p[x_a][  4] * g_t[x_a][ 22] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_IS[ 17] * g_p[x_a][  5] * g_t[x_a][ 23] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_IS[ 18] * g_p[x_a][  4] * g_d[x_a][  3] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_IS[ 19] * g_p[x_a][  4] * g_d[x_a][  3] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_IS[ 20] * g_p[x_a][  5] * g_d[x_a][  3] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_IS[ 21] * g_p[x_a][  5] * g_d[x_a][  3] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_IS[ 22] * g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_IS[ 23] * g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  24] != 0.){MC_phasespace.g_channel[zero +  24] = g_IS[ 24] * g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  25] != 0.){MC_phasespace.g_channel[zero +  25] = g_IS[ 25] * g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  26] != 0.){MC_phasespace.g_channel[zero +  26] = g_IS[ 26] * g_p[x_a][  2] * g_d[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  27] != 0.){MC_phasespace.g_channel[zero +  27] = g_IS[ 27] * g_p[x_a][  2] * g_d[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  28] != 0.){MC_phasespace.g_channel[zero +  28] = g_IS[ 28] * g_p[x_a][  3] * g_d[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  29] != 0.){MC_phasespace.g_channel[zero +  29] = g_IS[ 29] * g_p[x_a][  3] * g_d[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  30] != 0.){MC_phasespace.g_channel[zero +  30] = g_IS[ 30] * g_p[x_a][  4] * g_t[x_a][  0] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  31] != 0.){MC_phasespace.g_channel[zero +  31] = g_IS[ 31] * g_p[x_a][  5] * g_t[x_a][  2] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  32] != 0.){MC_phasespace.g_channel[zero +  32] = g_IS[ 32] * g_p[x_a][  0] * g_t[x_a][  6] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  33] != 0.){MC_phasespace.g_channel[zero +  33] = g_IS[ 33] * g_p[x_a][  1] * g_t[x_a][  8] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  34] != 0.){MC_phasespace.g_channel[zero +  34] = g_IS[ 34] * g_p[x_a][  2] * g_t[x_a][ 10] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  35] != 0.){MC_phasespace.g_channel[zero +  35] = g_IS[ 35] * g_p[x_a][  3] * g_t[x_a][ 12] * g_d[x_a][  1];}

    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(6, 1.);
      g_IS[1].resize(3, 1.);
      g_IS[2].resize(24, 1.);
      g_IS[3].resize(6, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  1] * g_IS[2][  1];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  2] * g_IS[2][  2] * g_t[x_a][  3] * g_IS[2][  3];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  4] * g_IS[2][  4];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  2] * g_IS[2][  2] * g_t[x_a][  5] * g_IS[2][  5];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  6] * g_IS[2][  6] * g_t[x_a][  7] * g_IS[2][  7];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  8] * g_IS[2][  8] * g_t[x_a][  9] * g_IS[2][  9];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 10] * g_IS[2][ 10] * g_t[x_a][ 11] * g_IS[2][ 11];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 12] * g_IS[2][ 12] * g_t[x_a][ 13] * g_IS[2][ 13];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 10] * g_IS[2][ 10] * g_t[x_a][ 14] * g_IS[2][ 14];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 12] * g_IS[2][ 12] * g_t[x_a][ 15] * g_IS[2][ 15];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  6] * g_IS[2][  6] * g_t[x_a][ 16] * g_IS[2][ 16];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  8] * g_IS[2][  8] * g_t[x_a][ 17] * g_IS[2][ 17];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][ 18] * g_IS[2][ 18] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][ 19] * g_IS[2][ 19] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_p[x_a][  2] * g_IS[0][  2] * g_t[x_a][ 20] * g_IS[2][ 20] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_p[x_a][  3] * g_IS[0][  3] * g_t[x_a][ 21] * g_IS[2][ 21] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_p[x_a][  4] * g_IS[0][  4] * g_t[x_a][ 22] * g_IS[2][ 22] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_p[x_a][  5] * g_IS[0][  5] * g_t[x_a][ 23] * g_IS[2][ 23] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_p[x_a][  4] * g_IS[0][  4] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_p[x_a][  4] * g_IS[0][  4] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_p[x_a][  5] * g_IS[0][  5] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_p[x_a][  5] * g_IS[0][  5] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_p[x_a][  0] * g_IS[0][  0] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_p[x_a][  0] * g_IS[0][  0] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  24] != 0.){MC_phasespace.g_channel[zero +  24] = g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  25] != 0.){MC_phasespace.g_channel[zero +  25] = g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  26] != 0.){MC_phasespace.g_channel[zero +  26] = g_p[x_a][  2] * g_IS[0][  2] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  27] != 0.){MC_phasespace.g_channel[zero +  27] = g_p[x_a][  2] * g_IS[0][  2] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  28] != 0.){MC_phasespace.g_channel[zero +  28] = g_p[x_a][  3] * g_IS[0][  3] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  29] != 0.){MC_phasespace.g_channel[zero +  29] = g_p[x_a][  3] * g_IS[0][  3] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  30] != 0.){MC_phasespace.g_channel[zero +  30] = g_p[x_a][  4] * g_IS[0][  4] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  31] != 0.){MC_phasespace.g_channel[zero +  31] = g_p[x_a][  5] * g_IS[0][  5] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  32] != 0.){MC_phasespace.g_channel[zero +  32] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][  6] * g_IS[2][  6] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  33] != 0.){MC_phasespace.g_channel[zero +  33] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][  8] * g_IS[2][  8] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  34] != 0.){MC_phasespace.g_channel[zero +  34] = g_p[x_a][  2] * g_IS[0][  2] * g_t[x_a][ 10] * g_IS[2][ 10] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  35] != 0.){MC_phasespace.g_channel[zero +  35] = g_p[x_a][  3] * g_IS[0][  3] * g_t[x_a][ 12] * g_IS[2][ 12] * g_d[x_a][  1] * g_IS[3][  1];}
    }
  }

  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  3];}
    if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  4];}
    if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  5];}
    if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_f[x_a][  1] * g_t[x_a][  6] * g_t[x_a][  7];}
    if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_f[x_a][  1] * g_t[x_a][  8] * g_t[x_a][  9];}
    if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_f[x_a][  2] * g_t[x_a][ 10] * g_t[x_a][ 11];}
    if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_f[x_a][  2] * g_t[x_a][ 12] * g_t[x_a][ 13];}
    if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_f[x_a][  2] * g_t[x_a][ 10] * g_t[x_a][ 14];}
    if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_f[x_a][  2] * g_t[x_a][ 12] * g_t[x_a][ 15];}
    if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_f[x_a][  1] * g_t[x_a][  6] * g_t[x_a][ 16];}
    if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_f[x_a][  1] * g_t[x_a][  8] * g_t[x_a][ 17];}
    if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_p[x_a][  0] * g_t[x_a][ 18] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_p[x_a][  1] * g_t[x_a][ 19] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_p[x_a][  2] * g_t[x_a][ 20] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_p[x_a][  3] * g_t[x_a][ 21] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_p[x_a][  4] * g_t[x_a][ 22] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_p[x_a][  5] * g_t[x_a][ 23] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_p[x_a][  4] * g_d[x_a][  3] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_p[x_a][  4] * g_d[x_a][  3] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_p[x_a][  5] * g_d[x_a][  3] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_p[x_a][  5] * g_d[x_a][  3] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  24] != 0.){MC_phasespace.g_channel[zero +  24] = g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  25] != 0.){MC_phasespace.g_channel[zero +  25] = g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  26] != 0.){MC_phasespace.g_channel[zero +  26] = g_p[x_a][  2] * g_d[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  27] != 0.){MC_phasespace.g_channel[zero +  27] = g_p[x_a][  2] * g_d[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  28] != 0.){MC_phasespace.g_channel[zero +  28] = g_p[x_a][  3] * g_d[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  29] != 0.){MC_phasespace.g_channel[zero +  29] = g_p[x_a][  3] * g_d[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  30] != 0.){MC_phasespace.g_channel[zero +  30] = g_p[x_a][  4] * g_t[x_a][  0] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  31] != 0.){MC_phasespace.g_channel[zero +  31] = g_p[x_a][  5] * g_t[x_a][  2] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  32] != 0.){MC_phasespace.g_channel[zero +  32] = g_p[x_a][  0] * g_t[x_a][  6] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  33] != 0.){MC_phasespace.g_channel[zero +  33] = g_p[x_a][  1] * g_t[x_a][  8] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  34] != 0.){MC_phasespace.g_channel[zero +  34] = g_p[x_a][  2] * g_t[x_a][ 10] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  35] != 0.){MC_phasespace.g_channel[zero +  35] = g_p[x_a][  3] * g_t[x_a][ 12] * g_d[x_a][  1];}
  }

/*
  if (MC_phasespace.alpha[   0] != 0.){ag_channel_111(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[   1] != 0.){ag_channel_111(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[   2] != 0.){ag_channel_111(g, 1, 2, 4, 16, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[   3] != 0.){ag_channel_111(g, 1, 2, 4, 16, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[   4] != 0.){ag_channel_111(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[   5] != 0.){ag_channel_111(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[   6] != 0.){ag_channel_111(g, 1, 2, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[   7] != 0.){ag_channel_111(g, 1, 2, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[   8] != 0.){ag_channel_111(g, 1, 2, 8, 16, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[   9] != 0.){ag_channel_111(g, 1, 2, 8, 16, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[  10] != 0.){ag_channel_111(g, 1, 2, 16, 8, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  11] != 0.){ag_channel_111(g, 1, 2, 16, 8, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[  12] != 0.){ag_channel_2v1(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  13] != 0.){ag_channel_2v1(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[  14] != 0.){ag_channel_2v1(g, 1, 2, 4, 16, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  15] != 0.){ag_channel_2v1(g, 1, 2, 4, 16, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[  16] != 0.){ag_channel_2v1(g, 1, 2, 8, 16, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  17] != 0.){ag_channel_2v1(g, 1, 2, 8, 16, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[  18] != 0.){ag_channel_3yv(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  19] != 0.){ag_channel_3yv(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  20] != 0.){ag_channel_3yv(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0, psi);}
  if (MC_phasespace.alpha[  21] != 0.){ag_channel_3yv(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[  22] != 0.){ag_channel_3yv(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  23] != 0.){ag_channel_3yv(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  24] != 0.){ag_channel_3yv(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0, psi);}
  if (MC_phasespace.alpha[  25] != 0.){ag_channel_3yv(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[  26] != 0.){ag_channel_3yv(g, 1, 2, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  27] != 0.){ag_channel_3yv(g, 1, 2, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  28] != 0.){ag_channel_3yv(g, 1, 2, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0, psi);}
  if (MC_phasespace.alpha[  29] != 0.){ag_channel_3yv(g, 1, 2, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[  30] != 0.){ag_channel_12v(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  31] != 0.){ag_channel_12v(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[  32] != 0.){ag_channel_12v(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  33] != 0.){ag_channel_12v(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  if (MC_phasespace.alpha[  34] != 0.){ag_channel_12v(g, 1, 2, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (MC_phasespace.alpha[  35] != 0.){ag_channel_12v(g, 1, 2, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36, psi);}
  // channel    0: 111(1, 2, 4, 8, 16;   0,   0)
  // channel    1: 111(1, 2, 4, 8, 16;  36,  36)
  // channel    2: 111(1, 2, 4, 16, 8;   0,   0)
  // channel    3: 111(1, 2, 4, 16, 8;  36,  36)
  // channel    4: 111(1, 2, 16, 4, 8;   0,   0)
  // channel    5: 111(1, 2, 16, 4, 8;  36,  36)
  // channel    6: 111(1, 2, 8, 4, 16;   0,   0)
  // channel    7: 111(1, 2, 8, 4, 16;  36,  36)
  // channel    8: 111(1, 2, 8, 16, 4;   0,   0)
  // channel    9: 111(1, 2, 8, 16, 4;  36,  36)
  // channel   10: 111(1, 2, 16, 8, 4;   0,   0)
  // channel   11: 111(1, 2, 16, 8, 4;  36,  36)
  // channel   12: 2v1(1, 2, 4, 8, 16;   0,   0)
  // channel   13: 2v1(1, 2, 4, 8, 16;  36,  36)
  // channel   14: 2v1(1, 2, 4, 16, 8;   0,   0)
  // channel   15: 2v1(1, 2, 4, 16, 8;  36,  36)
  // channel   16: 2v1(1, 2, 8, 16, 4;   0,   0)
  // channel   17: 2v1(1, 2, 8, 16, 4;  36,  36)
  // channel   18: 3yv(1, 2, 4, 8, 16;   0,   0)
  // channel   19: 3yv(1, 2, 4, 8, 16;   0,   0)
  // channel   20: 3yv(1, 2, 4, 8, 16;  36,   0)
  // channel   21: 3yv(1, 2, 4, 8, 16;  36,  36)
  // channel   22: 3yv(1, 2, 16, 4, 8;   0,   0)
  // channel   23: 3yv(1, 2, 16, 4, 8;   0,   0)
  // channel   24: 3yv(1, 2, 16, 4, 8;  36,   0)
  // channel   25: 3yv(1, 2, 16, 4, 8;  36,  36)
  // channel   26: 3yv(1, 2, 8, 4, 16;   0,   0)
  // channel   27: 3yv(1, 2, 8, 4, 16;   0,   0)
  // channel   28: 3yv(1, 2, 8, 4, 16;  36,   0)
  // channel   29: 3yv(1, 2, 8, 4, 16;  36,  36)
  // channel   30: 12v(1, 2, 4, 8, 16;   0,   0)
  // channel   31: 12v(1, 2, 4, 8, 16;  36,  36)
  // channel   32: 12v(1, 2, 16, 4, 8;   0,   0)
  // channel   33: 12v(1, 2, 16, 4, 8;  36,  36)
  // channel   34: 12v(1, 2, 8, 4, 16;   0,   0)
  // channel   35: 12v(1, 2, 8, 4, 16;  36,  36)
*/

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
