#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ax_psp_230_gg_aaa(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_230_gg_aaa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  int needed_v_smin_0[] = {  12,   13,   22,   23,   24,   25,   32,   33,    4,    5,   10,   11}; //  12
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 12);
  int needed_v_smin_1[] = {  14,   15,   26,   27,   28,   29,   34,   35,    6,    7,    8,    9}; //  12
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 12);
  int needed_v_smin_2[] = {  16,   17,   18,   19,   20,   21,   30,   31,    0,    1,    2,    3}; //  12
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 12);

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  int needed_v_smax_0[] = {  12,   13,   22,   23,   24,   25,   32,   33,    4,    5,   10,   11}; //  12
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 12);
  int needed_v_smax_1[] = {  14,   15,   26,   27,   28,   29,   34,   35,    6,    7,    8,    9}; //  12
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 12);
  int needed_v_smax_2[] = {  16,   17,   18,   19,   20,   21,   30,   31,    0,    1,    2,    3}; //  12
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 12);

  g_p[x_a].resize(6);
  needed_g_p[x_a].resize(6);
  needed_g_p[x_a][0] = {  12,   22,   23,   32}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  13,   24,   25,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin0_smax0");
  needed_g_p[x_a][2] = {  14,   26,   27,   34}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {  15,   28,   29,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin1_smax1");
  needed_g_p[x_a][4] = {  16,   18,   19,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][5] = {  17,   20,   21,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin2_smax2");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][2] = {   6,    7,    8,    9}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    2,   30}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_24");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_8");
  needed_g_t[x_a][2] = {   1,    3,   31}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__4_24");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_5__16_8");
  needed_g_t[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_16");
  needed_g_t[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_5__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_5__8_16");
  needed_g_t[x_a][6] = {   4,   10,   32}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_4");
  needed_g_t[x_a][8] = {   5,   11,   33}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__16_12");
  needed_g_t[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_17__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_17__8_4");
  needed_g_t[x_a][10] = {   6,    8,   34}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_20");
  needed_g_t[x_a][11] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_4");
  needed_g_t[x_a][12] = {   7,    9,   35}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__8_20");
  needed_g_t[x_a][13] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_9__16_4");
  needed_g_t[x_a][14] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_16");
  needed_g_t[x_a][15] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_9__4_16");
  needed_g_t[x_a][16] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_8");
  needed_g_t[x_a][17] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_17__4_8");
  needed_g_t[x_a][18] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_12");
  needed_g_t[x_a][19] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__16_12");
  needed_g_t[x_a][20] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_20");
  needed_g_t[x_a][21] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__8_20");
  needed_g_t[x_a][22] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_24");
  needed_g_t[x_a][23] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__4_24");

  g_d[x_a].resize(6);
  needed_g_d[x_a].resize(6);
  needed_g_d[x_a][0] = {  12,   13,   22,   23,   24,   25,   32,   33}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  14,   15,   26,   27,   28,   29,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][2] = {  16,   17,   18,   19,   20,   21,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  18,   19,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {  22,   23,   24,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {  26,   27,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");

  c_p[x_a].resize(36);
  c_f[x_a].resize(36);
  c_t[x_a].resize(36);
  c_d[x_a].resize(36);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   4}; //   2
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  2,   5}; //   2
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  1}; //   1
  c_t[x_a][4] = {  6,   7}; //   2
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  8,   9}; //   2
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  2}; //   1
  c_t[x_a][6] = { 10,  11}; //   2
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  2}; //   1
  c_t[x_a][7] = { 12,  13}; //   2
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  2}; //   1
  c_t[x_a][8] = { 10,  14}; //   2
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = {  2}; //   1
  c_t[x_a][9] = { 12,  15}; //   2
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = {  1}; //   1
  c_t[x_a][10] = {  6,  16}; //   2
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  8,  17}; //   2
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 18}; //   1
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  1}; //   1
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 19}; //   1
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  2}; //   1
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 20}; //   1
  c_d[x_a][14] = {  1}; //   1

  c_p[x_a][15] = {  3}; //   1
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 21}; //   1
  c_d[x_a][15] = {  1}; //   1

  c_p[x_a][16] = {  4}; //   1
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 22}; //   1
  c_d[x_a][16] = {  2}; //   1

  c_p[x_a][17] = {  5}; //   1
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 23}; //   1
  c_d[x_a][17] = {  2}; //   1

  c_p[x_a][18] = {  4}; //   1
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  3,   2}; //   2

  c_p[x_a][19] = {  4}; //   1
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  3,   2}; //   2

  c_p[x_a][20] = {  5}; //   1
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  3,   2}; //   2

  c_p[x_a][21] = {  5}; //   1
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  3,   2}; //   2

  c_p[x_a][22] = {  0}; //   1
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  4,   0}; //   2

  c_p[x_a][23] = {  0}; //   1
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  4,   0}; //   2

  c_p[x_a][24] = {  1}; //   1
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = {  4,   0}; //   2

  c_p[x_a][25] = {  1}; //   1
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = {  4,   0}; //   2

  c_p[x_a][26] = {  2}; //   1
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = {  5,   1}; //   2

  c_p[x_a][27] = {  2}; //   1
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = {  5,   1}; //   2

  c_p[x_a][28] = {  3}; //   1
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = {  5,   1}; //   2

  c_p[x_a][29] = {  3}; //   1
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = {  5,   1}; //   2

  c_p[x_a][30] = {  4}; //   1
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = {  2}; //   1

  c_p[x_a][31] = {  5}; //   1
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  2}; //   1
  c_d[x_a][31] = {  2}; //   1

  c_p[x_a][32] = {  0}; //   1
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  6}; //   1
  c_d[x_a][32] = {  0}; //   1

  c_p[x_a][33] = {  1}; //   1
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  8}; //   1
  c_d[x_a][33] = {  0}; //   1

  c_p[x_a][34] = {  2}; //   1
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = { 10}; //   1
  c_d[x_a][34] = {  1}; //   1

  c_p[x_a][35] = {  3}; //   1
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = { 12}; //   1
  c_d[x_a][35] = {  1}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
