#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ax_psp_230_ddx_aaauux(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_230_ddx_aaauux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(58);
  needed_v_smin[x_a].resize(58);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,   60,   61,   62,   63,   64,   65,   96,   97,   98,   99,  100,  101,  114,  115,  116,  117,  118,  119}; //  24
  needed_v_smin[x_a][  1] = {   6,    8,   22,   24,   31,   33,   44,   46,   49,   51,   56,   58,   70,   72,   86,   88,   93,   95,  110,  112}; //  20
  needed_v_smin[x_a][  2] = {   6,    8,   70,   72,  110,  112}; //   6
  needed_v_smin[x_a][  3] = {   7,    9,   23,   25,   30,   32,   45,   47,   48,   50,   57,   59,   71,   73,   87,   89,   92,   94,  111,  113}; //  20
  needed_v_smin[x_a][  4] = {   7,    9,   71,   73,  111,  113}; //   6
  needed_v_smin[x_a][  5] = {  10,   16,   20,   26,   32,   34,   36,   42,   48,   53,   54,   59,   68,   74,   78,   84,   90,   94,  102,  108}; //  20
  needed_v_smin[x_a][  6] = {  10,   16,   68,   74,  102,  108}; //   6
  needed_v_smin[x_a][  7] = {  11,   17,   21,   27,   33,   35,   37,   43,   49,   52,   55,   58,   69,   75,   79,   85,   91,   95,  103,  109}; //  20
  needed_v_smin[x_a][  8] = {  11,   17,   69,   75,  103,  109}; //   6
  needed_v_smin[x_a][  9] = {  12,   14,   18,   28,   30,   35,   38,   40,   50,   52,   55,   57,   66,   76,   80,   82,   91,   92,  104,  106}; //  20
  needed_v_smin[x_a][ 10] = {  12,   14,   66,   76,  104,  106}; //   6
  needed_v_smin[x_a][ 11] = {  13,   15,   19,   29,   31,   34,   39,   41,   51,   53,   54,   56,   67,   77,   81,   83,   90,   93,  105,  107}; //  20
  needed_v_smin[x_a][ 12] = {  13,   15,   67,   77,  105,  107}; //   6
  needed_v_smin[x_a][ 13] = {  18,   40,   52,   82}; //   4
  needed_v_smin[x_a][ 14] = {  18,   24,   82,   88}; //   4
  needed_v_smin[x_a][ 15] = {  19,   41,   53,   83}; //   4
  needed_v_smin[x_a][ 16] = {  19,   25,   83,   89}; //   4
  needed_v_smin[x_a][ 17] = {  20,   42,   54,   84}; //   4
  needed_v_smin[x_a][ 18] = {  20,   22,   84,   86}; //   4
  needed_v_smin[x_a][ 19] = {  21,   43,   55,   85}; //   4
  needed_v_smin[x_a][ 20] = {  21,   23,   85,   87}; //   4
  needed_v_smin[x_a][ 21] = {  22,   44,   56,   86}; //   4
  needed_v_smin[x_a][ 22] = {  23,   45,   57,   87}; //   4
  needed_v_smin[x_a][ 23] = {  24,   46,   58,   88}; //   4
  needed_v_smin[x_a][ 24] = {  25,   47,   59,   89}; //   4
  needed_v_smin[x_a][ 25] = {  26,   36,   48,   78}; //   4
  needed_v_smin[x_a][ 26] = {  26,   28,   78,   80}; //   4
  needed_v_smin[x_a][ 27] = {  27,   37,   49,   79}; //   4
  needed_v_smin[x_a][ 28] = {  27,   29,   79,   81}; //   4
  needed_v_smin[x_a][ 29] = {  28,   38,   50,   80}; //   4
  needed_v_smin[x_a][ 30] = {  29,   39,   51,   81}; //   4
  needed_v_smin[x_a][ 31] = {  30,   92}; //   2
  needed_v_smin[x_a][ 32] = {  31,   93}; //   2
  needed_v_smin[x_a][ 33] = {  32,   94}; //   2
  needed_v_smin[x_a][ 34] = {  33,   95}; //   2
  needed_v_smin[x_a][ 35] = {  34,   90}; //   2
  needed_v_smin[x_a][ 36] = {  35,   91}; //   2
  needed_v_smin[x_a][ 37] = {  36,   38}; //   2
  needed_v_smin[x_a][ 38] = {  37,   39}; //   2
  needed_v_smin[x_a][ 39] = {  40,   46}; //   2
  needed_v_smin[x_a][ 40] = {  41,   47}; //   2
  needed_v_smin[x_a][ 41] = {  42,   44}; //   2
  needed_v_smin[x_a][ 42] = {  43,   45}; //   2
  needed_v_smin[x_a][ 43] = {   0,    3,  116,  119}; //   4
  needed_v_smin[x_a][ 44] = {   0,    3,  116,  119}; //   4
  needed_v_smin[x_a][ 45] = {   1,    2,  117,  118}; //   4
  needed_v_smin[x_a][ 46] = {   1,    2,  117,  118}; //   4
  needed_v_smin[x_a][ 47] = {   4,    5,  114,  115}; //   4
  needed_v_smin[x_a][ 48] = {   4,    5,  114,  115}; //   4
  needed_v_smin[x_a][ 49] = {   6,    7,   62,   70,   71,   98,  112,  113}; //   8
  needed_v_smin[x_a][ 50] = {   8,    9,   63,   72,   73,   99,  110,  111}; //   8
  needed_v_smin[x_a][ 51] = {  10,   11,   64,   74,   75,  100,  108,  109}; //   8
  needed_v_smin[x_a][ 52] = {  12,   13,   65,   76,   77,  101,  106,  107}; //   8
  needed_v_smin[x_a][ 53] = {  14,   15,   60,   66,   67,   96,  104,  105}; //   8
  needed_v_smin[x_a][ 54] = {  16,   17,   61,   68,   69,   97,  102,  103}; //   8
  needed_v_smin[x_a][ 55] = {  60,   65,   96,  101}; //   4
  needed_v_smin[x_a][ 56] = {  61,   64,   97,  100}; //   4
  needed_v_smin[x_a][ 57] = {  62,   63,   98,   99}; //   4

  v_smax[x_a].resize(36);
  needed_v_smax[x_a].resize(36);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   60,   61,   62,   63,   64,   65,   96,   97,   98,   99,  100,  101,  114,  115,  116,  117,  118,  119}; //  24
  needed_v_smax[x_a][  1] = {   6,    8,   22,   24,   44,   46,   56,   58,   70,   72,   86,   88,  110,  112}; //  14
  needed_v_smax[x_a][  2] = {   6,    7,    8,    9,   70,   71,   72,   73,  110,  111,  112,  113,   62,   63,   98,   99}; //  16
  needed_v_smax[x_a][  3] = {   7,    9,   23,   25,   45,   47,   57,   59,   71,   73,   87,   89,  111,  113}; //  14
  needed_v_smax[x_a][  4] = {  10,   16,   20,   26,   32,   34,   36,   42,   48,   54,   68,   74,   78,   84,   90,   94,  102,  108}; //  18
  needed_v_smax[x_a][  5] = {  10,   11,   16,   17,   68,   69,   74,   75,  102,  103,  108,  109,   61,   64,   97,  100}; //  16
  needed_v_smax[x_a][  6] = {  11,   17,   21,   27,   33,   35,   37,   43,   49,   55,   69,   75,   79,   85,   91,   95,  103,  109}; //  18
  needed_v_smax[x_a][  7] = {  12,   14,   18,   28,   30,   38,   40,   50,   52,   66,   76,   80,   82,   92,  104,  106}; //  16
  needed_v_smax[x_a][  8] = {  12,   13,   14,   15,   66,   67,   76,   77,  104,  105,  106,  107,   60,   65,   96,  101}; //  16
  needed_v_smax[x_a][  9] = {  13,   15,   19,   29,   31,   39,   41,   51,   53,   67,   77,   81,   83,   93,  105,  107}; //  16
  needed_v_smax[x_a][ 10] = {  18,   24,   40,   46,   52,   58,   82,   88}; //   8
  needed_v_smax[x_a][ 11] = {  18,   19,   24,   25,   30,   31,   82,   83,   88,   89,   92,   93,    0,    3,    6,    7,   12,   13,   62,   65,   70,   71,   76,   77,   98,  101,  106,  107,  112,  113,  116,  119}; //  32
  needed_v_smax[x_a][ 12] = {  19,   25,   41,   47,   53,   59,   83,   89}; //   8
  needed_v_smax[x_a][ 13] = {  20,   22,   42,   44,   54,   56,   84,   86}; //   8
  needed_v_smax[x_a][ 14] = {  20,   21,   22,   23,   32,   33,   84,   85,   86,   87,   94,   95,    1,    2,    8,    9,   10,   11,   63,   64,   72,   73,   74,   75,   99,  100,  108,  109,  110,  111,  117,  118}; //  32
  needed_v_smax[x_a][ 15] = {  21,   23,   43,   45,   55,   57,   85,   87}; //   8
  needed_v_smax[x_a][ 16] = {  26,   28,   36,   38,   48,   50,   78,   80}; //   8
  needed_v_smax[x_a][ 17] = {  26,   27,   28,   29,   34,   35,   78,   79,   80,   81,   90,   91,    4,    5,   14,   15,   16,   17,   60,   61,   66,   67,   68,   69,   96,   97,  102,  103,  104,  105,  114,  115}; //  32
  needed_v_smax[x_a][ 18] = {  27,   29,   37,   39,   49,   51,   79,   81}; //   8
  needed_v_smax[x_a][ 19] = {  30,   92}; //   2
  needed_v_smax[x_a][ 20] = {  31,   93}; //   2
  needed_v_smax[x_a][ 21] = {  32,   94}; //   2
  needed_v_smax[x_a][ 22] = {  33,   95}; //   2
  needed_v_smax[x_a][ 23] = {  34,   90}; //   2
  needed_v_smax[x_a][ 24] = {  35,   91}; //   2
  needed_v_smax[x_a][ 25] = {  36,   38,   40,   42,   44,   46}; //   6
  needed_v_smax[x_a][ 26] = {  37,   39,   41,   43,   45,   47}; //   6
  needed_v_smax[x_a][ 27] = {  48,   50}; //   2
  needed_v_smax[x_a][ 28] = {  49,   51}; //   2
  needed_v_smax[x_a][ 29] = {  52,   58}; //   2
  needed_v_smax[x_a][ 30] = {  53,   59}; //   2
  needed_v_smax[x_a][ 31] = {  54,   56}; //   2
  needed_v_smax[x_a][ 32] = {  55,   57}; //   2
  needed_v_smax[x_a][ 33] = {   0,    3,  116,  119}; //   4
  needed_v_smax[x_a][ 34] = {   1,    2,  117,  118}; //   4
  needed_v_smax[x_a][ 35] = {   4,    5,  114,  115}; //   4

  g_p[x_a].resize(55);
  needed_g_p[x_a].resize(55);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   60,   61,   62,   63,   64,   65,   96,   97,   98,   99,  100,  101,  114,  115,  116,  117,  118,  119}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   6,    8,   22,   24,   44,   46,   56,   58,   70,   72,   86,   88,  110,  112}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   6,    8,   70,   72,  110,  112}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   7,    9,   23,   25,   45,   47,   57,   59,   71,   73,   87,   89,  111,  113}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   7,    9,   71,   73,  111,  113}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][5] = {  10,   16,   20,   26,   32,   34,   36,   42,   48,   54,   68,   74,   78,   84,   90,   94,  102,  108}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {  10,   16,   68,   74,  102,  108}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {  11,   17,   21,   27,   33,   35,   37,   43,   49,   55,   69,   75,   79,   85,   91,   95,  103,  109}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][8] = {  11,   17,   69,   75,  103,  109}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax5");
  needed_g_p[x_a][9] = {  12,   14,   18,   28,   30,   38,   40,   50,   52,   66,   76,   80,   82,   92,  104,  106}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][10] = {  12,   14,   66,   76,  104,  106}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][11] = {  13,   15,   19,   29,   31,   39,   41,   51,   53,   67,   77,   81,   83,   93,  105,  107}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][12] = {  13,   15,   67,   77,  105,  107}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax8");
  needed_g_p[x_a][13] = {  18,   40,   52,   82}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][14] = {  18,   24,   82,   88}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][15] = {  19,   41,   53,   83}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][16] = {  19,   25,   83,   89}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax11");
  needed_g_p[x_a][17] = {  20,   42,   54,   84}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax13");
  needed_g_p[x_a][18] = {  20,   22,   84,   86}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax14");
  needed_g_p[x_a][19] = {  21,   43,   55,   85}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax15");
  needed_g_p[x_a][20] = {  21,   23,   85,   87}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax14");
  needed_g_p[x_a][21] = {  22,   44,   56,   86}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax13");
  needed_g_p[x_a][22] = {  23,   45,   57,   87}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax15");
  needed_g_p[x_a][23] = {  24,   46,   58,   88}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax10");
  needed_g_p[x_a][24] = {  25,   47,   59,   89}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax12");
  needed_g_p[x_a][25] = {  26,   36,   48,   78}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax16");
  needed_g_p[x_a][26] = {  26,   28,   78,   80}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin26_smax17");
  needed_g_p[x_a][27] = {  27,   37,   49,   79}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin27_smax18");
  needed_g_p[x_a][28] = {  27,   29,   79,   81}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin28_smax17");
  needed_g_p[x_a][29] = {  28,   38,   50,   80}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax16");
  needed_g_p[x_a][30] = {  29,   39,   51,   81}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin30_smax18");
  needed_g_p[x_a][31] = {  30,   92}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax19");
  needed_g_p[x_a][32] = {  30,   92}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin31_smax11");
  needed_g_p[x_a][33] = {  31,   93}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax20");
  needed_g_p[x_a][34] = {  31,   93}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin32_smax11");
  needed_g_p[x_a][35] = {  32,   94}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax21");
  needed_g_p[x_a][36] = {  32,   94}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax14");
  needed_g_p[x_a][37] = {  33,   95}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax22");
  needed_g_p[x_a][38] = {  33,   95}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax14");
  needed_g_p[x_a][39] = {  34,   90}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax23");
  needed_g_p[x_a][40] = {  34,   90}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin35_smax17");
  needed_g_p[x_a][41] = {  35,   91}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax24");
  needed_g_p[x_a][42] = {  35,   91}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin36_smax17");
  needed_g_p[x_a][43] = {  36,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin37_smax25");
  needed_g_p[x_a][44] = {  37,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin38_smax26");
  needed_g_p[x_a][45] = {  40,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin39_smax25");
  needed_g_p[x_a][46] = {  41,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin40_smax26");
  needed_g_p[x_a][47] = {  42,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin41_smax25");
  needed_g_p[x_a][48] = {  43,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin42_smax26");
  needed_g_p[x_a][49] = {  48,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax27");
  needed_g_p[x_a][50] = {  49,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax28");
  needed_g_p[x_a][51] = {  52,   58}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax29");
  needed_g_p[x_a][52] = {  53,   59}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax30");
  needed_g_p[x_a][53] = {  54,   56}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax31");
  needed_g_p[x_a][54] = {  55,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax32");

  g_f[x_a].resize(15);
  needed_g_f[x_a].resize(15);
  needed_g_f[x_a][0] = {   0,    3,  116,  119}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin43_smax33");
  needed_g_f[x_a][1] = {   0,    3,  116,  119}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin44_smax11");
  needed_g_f[x_a][2] = {   1,    2,  117,  118}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin45_smax34");
  needed_g_f[x_a][3] = {   1,    2,  117,  118}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin46_smax14");
  needed_g_f[x_a][4] = {   4,    5,  114,  115}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin47_smax35");
  needed_g_f[x_a][5] = {   4,    5,  114,  115}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin48_smax17");
  needed_g_f[x_a][6] = {   6,    7,   62,   70,   71,   98,  112,  113}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin49_smax11");
  needed_g_f[x_a][7] = {   8,    9,   63,   72,   73,   99,  110,  111}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin50_smax14");
  needed_g_f[x_a][8] = {  10,   11,   64,   74,   75,  100,  108,  109}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin51_smax14");
  needed_g_f[x_a][9] = {  12,   13,   65,   76,   77,  101,  106,  107}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin52_smax11");
  needed_g_f[x_a][10] = {  14,   15,   60,   66,   67,   96,  104,  105}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin53_smax17");
  needed_g_f[x_a][11] = {  16,   17,   61,   68,   69,   97,  102,  103}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin54_smax17");
  needed_g_f[x_a][12] = {  60,   65,   96,  101}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin55_smax8");
  needed_g_f[x_a][13] = {  61,   64,   97,  100}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin56_smax5");
  needed_g_f[x_a][14] = {  62,   63,   98,   99}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin57_smax2");

  g_t[x_a].resize(54);
  needed_g_t[x_a].resize(54);
  needed_g_t[x_a][0] = {   0,    3,    6,    7,   12,   13,   18,   19,   24,   25,   30,   31}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][1] = {   0,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_97__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_97__8_4");
  needed_g_t[x_a][3] = {   1,    2,    8,    9,   10,   11,   20,   21,   22,   23,   32,   33}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][4] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__96_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__96_20");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_97__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_97__16_4");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_97__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_97__4_16");
  needed_g_t[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_97__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_97__4_8");
  needed_g_t[x_a][8] = {   4,    5,   14,   15,   16,   17,   26,   27,   28,   29,   34,   35}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][9] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__96_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__96_24");
  needed_g_t[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_97__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_97__16_8");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_97__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_97__8_16");
  needed_g_t[x_a][12] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__8_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__8_100");
  needed_g_t[x_a][13] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__16_100");
  needed_g_t[x_a][14] = {  10,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__4_112");
  needed_g_t[x_a][15] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__4_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__4_104");
  needed_g_t[x_a][16] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__16_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__16_104");
  needed_g_t[x_a][17] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__8_112");
  needed_g_t[x_a][18] = {  60,   61,   66,   67,   68,   69,   78,   79,   80,   81,   90,   91,   96,   97,  102,  103,  104,  105,  114,  115}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_120");
  needed_g_t[x_a][19] = {  60,   66,   67,   96}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_104");
  needed_g_t[x_a][20] = {  60}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_5__8_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_5__8_96");
  needed_g_t[x_a][21] = {  61,   68,   69,   97}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_112");
  needed_g_t[x_a][22] = {  61}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_5__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_5__16_96");
  needed_g_t[x_a][23] = {  62,   65,   70,   71,   76,   77,   82,   83,   88,   89,   92,   93,   98,  101,  106,  107,  112,  113,  116,  119}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][24] = {  62,   70,   71,   98}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_100");
  needed_g_t[x_a][25] = {  62}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_17__4_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_17__4_96");
  needed_g_t[x_a][26] = {  63,   64,   72,   73,   74,   75,   84,   85,   86,   87,   94,   95,   99,  100,  108,  109,  110,  111,  117,  118}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_116");
  needed_g_t[x_a][27] = {  63,   72,   73,   99}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_100");
  needed_g_t[x_a][28] = {  63}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_9__4_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_9__4_96");
  needed_g_t[x_a][29] = {  64,   74,   75,  100}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_112");
  needed_g_t[x_a][30] = {  64}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_9__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_9__16_96");
  needed_g_t[x_a][31] = {  65,   76,   77,  101}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_104");
  needed_g_t[x_a][32] = {  65}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_17__8_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_17__8_96");
  needed_g_t[x_a][33] = {  96}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_96");
  needed_g_t[x_a][34] = {  97}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_96");
  needed_g_t[x_a][35] = {  98}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__4_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__4_96");
  needed_g_t[x_a][36] = {  99}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__4_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__4_96");
  needed_g_t[x_a][37] = { 100}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_96");
  needed_g_t[x_a][38] = { 101}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__8_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__8_96");
  needed_g_t[x_a][39] = { 102,  103}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__5_2__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__5_2__8_112");
  needed_g_t[x_a][40] = { 104,  105}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__5_2__16_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__5_2__16_104");
  needed_g_t[x_a][41] = { 106,  107}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__4_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__4_104");
  needed_g_t[x_a][42] = { 108,  109}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__9_2__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__9_2__4_112");
  needed_g_t[x_a][43] = { 110,  111}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__9_2__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__9_2__16_100");
  needed_g_t[x_a][44] = { 112,  113}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__8_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__8_100");
  needed_g_t[x_a][45] = { 114,  115}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__96_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__96_24");
  needed_g_t[x_a][46] = { 114}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_98__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_98__8_16");
  needed_g_t[x_a][47] = { 115}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_98__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_98__16_8");
  needed_g_t[x_a][48] = { 116,  119}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");
  needed_g_t[x_a][49] = { 116}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_98__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_98__4_8");
  needed_g_t[x_a][50] = { 117,  118}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__96_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__96_20");
  needed_g_t[x_a][51] = { 117}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_98__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_98__4_16");
  needed_g_t[x_a][52] = { 118}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_98__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_98__16_4");
  needed_g_t[x_a][53] = { 119}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_98__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_98__8_4");

  g_d[x_a].resize(51);
  needed_g_d[x_a].resize(51);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,   60,   61,   62,   63,   64,   65,   96,   97,   98,   99,  100,  101,  114,  115,  116,  117,  118,  119}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][1] = {   6,    8,   70,   72,  110,  112}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][2] = {   6,    8,   22,   24,   31,   33,   44,   46,   49,   51,   56,   58,   70,   72,   86,   88,   93,   95,  110,  112}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][3] = {   7,    9,   71,   73,  111,  113}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__32_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__32_68");
  needed_g_d[x_a][4] = {   7,    9,   23,   25,   30,   32,   45,   47,   48,   50,   57,   59,   71,   73,   87,   89,   92,   94,  111,  113}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][5] = {  10,   16,   68,   74,  102,  108}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][6] = {  10,   16,   20,   26,   32,   34,   36,   42,   48,   53,   54,   59,   68,   74,   78,   84,   90,   94,  102,  108}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][7] = {  11,   17,   69,   75,  103,  109}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");
  needed_g_d[x_a][8] = {  11,   17,   21,   27,   33,   35,   37,   43,   49,   52,   55,   58,   69,   75,   79,   85,   91,   95,  103,  109}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][9] = {  12,   14,   66,   76,  104,  106}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][10] = {  12,   14,   18,   28,   30,   35,   38,   40,   50,   52,   55,   57,   66,   76,   80,   82,   91,   92,  104,  106}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][11] = {  13,   15,   67,   77,  105,  107}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__32_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__32_72");
  needed_g_d[x_a][12] = {  13,   15,   19,   29,   31,   34,   39,   41,   51,   53,   54,   56,   67,   77,   81,   83,   90,   93,  105,  107}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][13] = {  18,   24,   82,   88}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__64_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__64_44");
  needed_g_d[x_a][14] = {  18,   40,   52,   82}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][15] = {  19,   25,   83,   89}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][16] = {  19,   41,   53,   83}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__4_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__4_72");
  needed_g_d[x_a][17] = {  20,   22,   84,   86}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__64_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__64_52");
  needed_g_d[x_a][18] = {  20,   42,   54,   84}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][19] = {  21,   23,   85,   87}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__32_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__32_84");
  needed_g_d[x_a][20] = {  21,   43,   55,   85}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__4_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__4_80");
  needed_g_d[x_a][21] = {  22,   44,   56,   86}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][22] = {  23,   45,   57,   87}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__16_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__16_68");
  needed_g_d[x_a][23] = {  24,   46,   58,   88}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][24] = {  25,   47,   59,   89}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__8_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__8_68");
  needed_g_d[x_a][25] = {  26,   28,   78,   80}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__64_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__64_56");
  needed_g_d[x_a][26] = {  26,   36,   48,   78}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][27] = {  27,   29,   79,   81}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__32_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__32_88");
  needed_g_d[x_a][28] = {  27,   37,   49,   79}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__8_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__8_80");
  needed_g_d[x_a][29] = {  28,   38,   50,   80}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][30] = {  29,   39,   51,   81}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__16_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__16_72");
  needed_g_d[x_a][31] = {  30,   92}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__68_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__68_40");
  needed_g_d[x_a][32] = {  31,   93}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__36_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__36_72");
  needed_g_d[x_a][33] = {  32,   94}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__68_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__68_48");
  needed_g_d[x_a][34] = {  33,   95}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__36_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__36_80");
  needed_g_d[x_a][35] = {  34,   90}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__72_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__72_48");
  needed_g_d[x_a][36] = {  35,   91}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__40_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__40_80");
  needed_g_d[x_a][37] = {  36,   38,   40,   42,   44,   46}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][38] = {  36,   38}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][39] = {  37,   39,   41,   43,   45,   47}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][40] = {  37,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__4_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__4_88");
  needed_g_d[x_a][41] = {  40,   46}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][42] = {  41,   47}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][43] = {  42,   44}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][44] = {  43,   45}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__8_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__8_84");
  needed_g_d[x_a][45] = {  48,   50}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__68_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__68_56");
  needed_g_d[x_a][46] = {  49,   51}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][47] = {  52,   58}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");
  needed_g_d[x_a][48] = {  53,   59}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][49] = {  54,   56}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__72_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__72_52");
  needed_g_d[x_a][50] = {  55,   57}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");

  c_p[x_a].resize(120);
  c_f[x_a].resize(120);
  c_t[x_a].resize(120);
  c_d[x_a].resize(120);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  3,   4,   6}; //   3
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  0,   1}; //   2
  c_t[x_a][3] = {  0,   1,   7}; //   3
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  4,   5}; //   2
  c_t[x_a][4] = {  8,   9,  10}; //   3
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  4,   5}; //   2
  c_t[x_a][5] = {  8,   9,  11}; //   3
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  1,   2}; //   2
  c_f[x_a][6] = {  6}; //   1
  c_t[x_a][6] = {  0,  12}; //   2
  c_d[x_a][6] = {  1,   2}; //   2

  c_p[x_a][7] = {  3,   4}; //   2
  c_f[x_a][7] = {  6}; //   1
  c_t[x_a][7] = {  0,  12}; //   2
  c_d[x_a][7] = {  3,   4}; //   2

  c_p[x_a][8] = {  1,   2}; //   2
  c_f[x_a][8] = {  7}; //   1
  c_t[x_a][8] = {  3,  13}; //   2
  c_d[x_a][8] = {  1,   2}; //   2

  c_p[x_a][9] = {  3,   4}; //   2
  c_f[x_a][9] = {  7}; //   1
  c_t[x_a][9] = {  3,  13}; //   2
  c_d[x_a][9] = {  3,   4}; //   2

  c_p[x_a][10] = {  5,   6}; //   2
  c_f[x_a][10] = {  8}; //   1
  c_t[x_a][10] = {  3,  14}; //   2
  c_d[x_a][10] = {  5,   6}; //   2

  c_p[x_a][11] = {  7,   8}; //   2
  c_f[x_a][11] = {  8}; //   1
  c_t[x_a][11] = {  3,  14}; //   2
  c_d[x_a][11] = {  7,   8}; //   2

  c_p[x_a][12] = {  9,  10}; //   2
  c_f[x_a][12] = {  9}; //   1
  c_t[x_a][12] = {  0,  15}; //   2
  c_d[x_a][12] = {  9,  10}; //   2

  c_p[x_a][13] = { 11,  12}; //   2
  c_f[x_a][13] = {  9}; //   1
  c_t[x_a][13] = {  0,  15}; //   2
  c_d[x_a][13] = { 11,  12}; //   2

  c_p[x_a][14] = {  9,  10}; //   2
  c_f[x_a][14] = { 10}; //   1
  c_t[x_a][14] = {  8,  16}; //   2
  c_d[x_a][14] = {  9,  10}; //   2

  c_p[x_a][15] = { 11,  12}; //   2
  c_f[x_a][15] = { 10}; //   1
  c_t[x_a][15] = {  8,  16}; //   2
  c_d[x_a][15] = { 11,  12}; //   2

  c_p[x_a][16] = {  5,   6}; //   2
  c_f[x_a][16] = { 11}; //   1
  c_t[x_a][16] = {  8,  17}; //   2
  c_d[x_a][16] = {  5,   6}; //   2

  c_p[x_a][17] = {  7,   8}; //   2
  c_f[x_a][17] = { 11}; //   1
  c_t[x_a][17] = {  8,  17}; //   2
  c_d[x_a][17] = {  7,   8}; //   2

  c_p[x_a][18] = {  9,  13,  14}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 13,  14,  10}; //   3

  c_p[x_a][19] = { 11,  15,  16}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 15,  16,  12}; //   3

  c_p[x_a][20] = {  5,  17,  18}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  3}; //   1
  c_d[x_a][20] = { 17,  18,   6}; //   3

  c_p[x_a][21] = {  7,  19,  20}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  3}; //   1
  c_d[x_a][21] = { 19,  20,   8}; //   3

  c_p[x_a][22] = {  1,  21,  18}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  3}; //   1
  c_d[x_a][22] = { 17,  21,   2}; //   3

  c_p[x_a][23] = {  3,  22,  20}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  3}; //   1
  c_d[x_a][23] = { 19,  22,   4}; //   3

  c_p[x_a][24] = {  1,  23,  14}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = { 13,  23,   2}; //   3

  c_p[x_a][25] = {  3,  24,  16}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = { 15,  24,   4}; //   3

  c_p[x_a][26] = {  5,  25,  26}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  8}; //   1
  c_d[x_a][26] = { 25,  26,   6}; //   3

  c_p[x_a][27] = {  7,  27,  28}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  8}; //   1
  c_d[x_a][27] = { 27,  28,   8}; //   3

  c_p[x_a][28] = {  9,  29,  26}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  8}; //   1
  c_d[x_a][28] = { 25,  29,  10}; //   3

  c_p[x_a][29] = { 11,  30,  28}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  8}; //   1
  c_d[x_a][29] = { 27,  30,  12}; //   3

  c_p[x_a][30] = {  9,  31,  32}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = { 31,   4,  10}; //   3

  c_p[x_a][31] = { 11,  33,  34}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 32,   2,  12}; //   3

  c_p[x_a][32] = {  5,  35,  36}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  3}; //   1
  c_d[x_a][32] = { 33,   4,   6}; //   3

  c_p[x_a][33] = {  7,  37,  38}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  3}; //   1
  c_d[x_a][33] = { 34,   2,   8}; //   3

  c_p[x_a][34] = {  5,  39,  40}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  8}; //   1
  c_d[x_a][34] = { 35,  12,   6}; //   3

  c_p[x_a][35] = {  7,  41,  42}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  8}; //   1
  c_d[x_a][35] = { 36,  10,   8}; //   3

  c_p[x_a][36] = {  5,  25,  43}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 37,  38,  26,   6}; //   4

  c_p[x_a][37] = {  7,  27,  44}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 39,  40,  28,   8}; //   4

  c_p[x_a][38] = {  9,  29,  43}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 37,  38,  29,  10}; //   4

  c_p[x_a][39] = { 11,  30,  44}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 39,  40,  30,  12}; //   4

  c_p[x_a][40] = {  9,  13,  45}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 37,  41,  14,  10}; //   4

  c_p[x_a][41] = { 11,  15,  46}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 39,  42,  16,  12}; //   4

  c_p[x_a][42] = {  5,  17,  47}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 37,  43,  18,   6}; //   4

  c_p[x_a][43] = {  7,  19,  48}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = { 39,  44,  20,   8}; //   4

  c_p[x_a][44] = {  1,  21,  47}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = { 37,  43,  21,   2}; //   4

  c_p[x_a][45] = {  3,  22,  48}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = { 39,  44,  22,   4}; //   4

  c_p[x_a][46] = {  1,  23,  45}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = { 37,  41,  23,   2}; //   4

  c_p[x_a][47] = {  3,  24,  46}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {}; //   0
  c_d[x_a][47] = { 39,  42,  24,   4}; //   4

  c_p[x_a][48] = {  5,  25,  49}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {}; //   0
  c_d[x_a][48] = { 45,   4,  26,   6}; //   4

  c_p[x_a][49] = {  7,  27,  50}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {}; //   0
  c_d[x_a][49] = { 46,   2,  28,   8}; //   4

  c_p[x_a][50] = {  9,  29,  49}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {}; //   0
  c_d[x_a][50] = { 45,   4,  29,  10}; //   4

  c_p[x_a][51] = { 11,  30,  50}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {}; //   0
  c_d[x_a][51] = { 46,   2,  30,  12}; //   4

  c_p[x_a][52] = {  9,  13,  51}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {}; //   0
  c_d[x_a][52] = { 47,   8,  14,  10}; //   4

  c_p[x_a][53] = { 11,  15,  52}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {}; //   0
  c_d[x_a][53] = { 48,   6,  16,  12}; //   4

  c_p[x_a][54] = {  5,  17,  53}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {}; //   0
  c_d[x_a][54] = { 49,  12,  18,   6}; //   4

  c_p[x_a][55] = {  7,  19,  54}; //   3
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {}; //   0
  c_d[x_a][55] = { 50,  10,  20,   8}; //   4

  c_p[x_a][56] = {  1,  21,  53}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {}; //   0
  c_d[x_a][56] = { 49,  12,  21,   2}; //   4

  c_p[x_a][57] = {  3,  22,  54}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {}; //   0
  c_d[x_a][57] = { 50,  10,  22,   4}; //   4

  c_p[x_a][58] = {  1,  23,  51}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {}; //   0
  c_d[x_a][58] = { 47,   8,  23,   2}; //   4

  c_p[x_a][59] = {  3,  24,  52}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {}; //   0
  c_d[x_a][59] = { 48,   6,  24,   4}; //   4

  c_p[x_a][60] = {  0}; //   1
  c_f[x_a][60] = { 12,  10}; //   2
  c_t[x_a][60] = { 18,  19,  20}; //   3
  c_d[x_a][60] = {  0}; //   1

  c_p[x_a][61] = {  0}; //   1
  c_f[x_a][61] = { 13,  11}; //   2
  c_t[x_a][61] = { 18,  21,  22}; //   3
  c_d[x_a][61] = {  0}; //   1

  c_p[x_a][62] = {  0}; //   1
  c_f[x_a][62] = { 14,   6}; //   2
  c_t[x_a][62] = { 23,  24,  25}; //   3
  c_d[x_a][62] = {  0}; //   1

  c_p[x_a][63] = {  0}; //   1
  c_f[x_a][63] = { 14,   7}; //   2
  c_t[x_a][63] = { 26,  27,  28}; //   3
  c_d[x_a][63] = {  0}; //   1

  c_p[x_a][64] = {  0}; //   1
  c_f[x_a][64] = { 13,   8}; //   2
  c_t[x_a][64] = { 26,  29,  30}; //   3
  c_d[x_a][64] = {  0}; //   1

  c_p[x_a][65] = {  0}; //   1
  c_f[x_a][65] = { 12,   9}; //   2
  c_t[x_a][65] = { 23,  31,  32}; //   3
  c_d[x_a][65] = {  0}; //   1

  c_p[x_a][66] = {  9,  10}; //   2
  c_f[x_a][66] = { 10}; //   1
  c_t[x_a][66] = { 18,  19}; //   2
  c_d[x_a][66] = {  9,  10}; //   2

  c_p[x_a][67] = { 11,  12}; //   2
  c_f[x_a][67] = { 10}; //   1
  c_t[x_a][67] = { 18,  19}; //   2
  c_d[x_a][67] = { 11,  12}; //   2

  c_p[x_a][68] = {  5,   6}; //   2
  c_f[x_a][68] = { 11}; //   1
  c_t[x_a][68] = { 18,  21}; //   2
  c_d[x_a][68] = {  5,   6}; //   2

  c_p[x_a][69] = {  7,   8}; //   2
  c_f[x_a][69] = { 11}; //   1
  c_t[x_a][69] = { 18,  21}; //   2
  c_d[x_a][69] = {  7,   8}; //   2

  c_p[x_a][70] = {  1,   2}; //   2
  c_f[x_a][70] = {  6}; //   1
  c_t[x_a][70] = { 23,  24}; //   2
  c_d[x_a][70] = {  1,   2}; //   2

  c_p[x_a][71] = {  3,   4}; //   2
  c_f[x_a][71] = {  6}; //   1
  c_t[x_a][71] = { 23,  24}; //   2
  c_d[x_a][71] = {  3,   4}; //   2

  c_p[x_a][72] = {  1,   2}; //   2
  c_f[x_a][72] = {  7}; //   1
  c_t[x_a][72] = { 26,  27}; //   2
  c_d[x_a][72] = {  1,   2}; //   2

  c_p[x_a][73] = {  3,   4}; //   2
  c_f[x_a][73] = {  7}; //   1
  c_t[x_a][73] = { 26,  27}; //   2
  c_d[x_a][73] = {  3,   4}; //   2

  c_p[x_a][74] = {  5,   6}; //   2
  c_f[x_a][74] = {  8}; //   1
  c_t[x_a][74] = { 26,  29}; //   2
  c_d[x_a][74] = {  5,   6}; //   2

  c_p[x_a][75] = {  7,   8}; //   2
  c_f[x_a][75] = {  8}; //   1
  c_t[x_a][75] = { 26,  29}; //   2
  c_d[x_a][75] = {  7,   8}; //   2

  c_p[x_a][76] = {  9,  10}; //   2
  c_f[x_a][76] = {  9}; //   1
  c_t[x_a][76] = { 23,  31}; //   2
  c_d[x_a][76] = {  9,  10}; //   2

  c_p[x_a][77] = { 11,  12}; //   2
  c_f[x_a][77] = {  9}; //   1
  c_t[x_a][77] = { 23,  31}; //   2
  c_d[x_a][77] = { 11,  12}; //   2

  c_p[x_a][78] = {  5,  25,  26}; //   3
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = { 18}; //   1
  c_d[x_a][78] = { 25,  26,   6}; //   3

  c_p[x_a][79] = {  7,  27,  28}; //   3
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 18}; //   1
  c_d[x_a][79] = { 27,  28,   8}; //   3

  c_p[x_a][80] = {  9,  29,  26}; //   3
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = { 18}; //   1
  c_d[x_a][80] = { 25,  29,  10}; //   3

  c_p[x_a][81] = { 11,  30,  28}; //   3
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = { 18}; //   1
  c_d[x_a][81] = { 27,  30,  12}; //   3

  c_p[x_a][82] = {  9,  13,  14}; //   3
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = { 23}; //   1
  c_d[x_a][82] = { 13,  14,  10}; //   3

  c_p[x_a][83] = { 11,  15,  16}; //   3
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = { 23}; //   1
  c_d[x_a][83] = { 15,  16,  12}; //   3

  c_p[x_a][84] = {  5,  17,  18}; //   3
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = { 26}; //   1
  c_d[x_a][84] = { 17,  18,   6}; //   3

  c_p[x_a][85] = {  7,  19,  20}; //   3
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = { 26}; //   1
  c_d[x_a][85] = { 19,  20,   8}; //   3

  c_p[x_a][86] = {  1,  21,  18}; //   3
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = { 26}; //   1
  c_d[x_a][86] = { 17,  21,   2}; //   3

  c_p[x_a][87] = {  3,  22,  20}; //   3
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = { 26}; //   1
  c_d[x_a][87] = { 19,  22,   4}; //   3

  c_p[x_a][88] = {  1,  23,  14}; //   3
  c_f[x_a][88] = {}; //   0
  c_t[x_a][88] = { 23}; //   1
  c_d[x_a][88] = { 13,  23,   2}; //   3

  c_p[x_a][89] = {  3,  24,  16}; //   3
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = { 23}; //   1
  c_d[x_a][89] = { 15,  24,   4}; //   3

  c_p[x_a][90] = {  5,  39,  40}; //   3
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = { 18}; //   1
  c_d[x_a][90] = { 35,  12,   6}; //   3

  c_p[x_a][91] = {  7,  41,  42}; //   3
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = { 18}; //   1
  c_d[x_a][91] = { 36,  10,   8}; //   3

  c_p[x_a][92] = {  9,  31,  32}; //   3
  c_f[x_a][92] = {}; //   0
  c_t[x_a][92] = { 23}; //   1
  c_d[x_a][92] = { 31,   4,  10}; //   3

  c_p[x_a][93] = { 11,  33,  34}; //   3
  c_f[x_a][93] = {}; //   0
  c_t[x_a][93] = { 23}; //   1
  c_d[x_a][93] = { 32,   2,  12}; //   3

  c_p[x_a][94] = {  5,  35,  36}; //   3
  c_f[x_a][94] = {}; //   0
  c_t[x_a][94] = { 26}; //   1
  c_d[x_a][94] = { 33,   4,   6}; //   3

  c_p[x_a][95] = {  7,  37,  38}; //   3
  c_f[x_a][95] = {}; //   0
  c_t[x_a][95] = { 26}; //   1
  c_d[x_a][95] = { 34,   2,   8}; //   3

  c_p[x_a][96] = {  0}; //   1
  c_f[x_a][96] = { 12,  10}; //   2
  c_t[x_a][96] = { 18,  19,  33}; //   3
  c_d[x_a][96] = {  0}; //   1

  c_p[x_a][97] = {  0}; //   1
  c_f[x_a][97] = { 13,  11}; //   2
  c_t[x_a][97] = { 18,  21,  34}; //   3
  c_d[x_a][97] = {  0}; //   1

  c_p[x_a][98] = {  0}; //   1
  c_f[x_a][98] = { 14,   6}; //   2
  c_t[x_a][98] = { 23,  24,  35}; //   3
  c_d[x_a][98] = {  0}; //   1

  c_p[x_a][99] = {  0}; //   1
  c_f[x_a][99] = { 14,   7}; //   2
  c_t[x_a][99] = { 26,  27,  36}; //   3
  c_d[x_a][99] = {  0}; //   1

  c_p[x_a][100] = {  0}; //   1
  c_f[x_a][100] = { 13,   8}; //   2
  c_t[x_a][100] = { 26,  29,  37}; //   3
  c_d[x_a][100] = {  0}; //   1

  c_p[x_a][101] = {  0}; //   1
  c_f[x_a][101] = { 12,   9}; //   2
  c_t[x_a][101] = { 23,  31,  38}; //   3
  c_d[x_a][101] = {  0}; //   1

  c_p[x_a][102] = {  5,   6}; //   2
  c_f[x_a][102] = { 11}; //   1
  c_t[x_a][102] = { 18,  39}; //   2
  c_d[x_a][102] = {  5,   6}; //   2

  c_p[x_a][103] = {  7,   8}; //   2
  c_f[x_a][103] = { 11}; //   1
  c_t[x_a][103] = { 18,  39}; //   2
  c_d[x_a][103] = {  7,   8}; //   2

  c_p[x_a][104] = {  9,  10}; //   2
  c_f[x_a][104] = { 10}; //   1
  c_t[x_a][104] = { 18,  40}; //   2
  c_d[x_a][104] = {  9,  10}; //   2

  c_p[x_a][105] = { 11,  12}; //   2
  c_f[x_a][105] = { 10}; //   1
  c_t[x_a][105] = { 18,  40}; //   2
  c_d[x_a][105] = { 11,  12}; //   2

  c_p[x_a][106] = {  9,  10}; //   2
  c_f[x_a][106] = {  9}; //   1
  c_t[x_a][106] = { 23,  41}; //   2
  c_d[x_a][106] = {  9,  10}; //   2

  c_p[x_a][107] = { 11,  12}; //   2
  c_f[x_a][107] = {  9}; //   1
  c_t[x_a][107] = { 23,  41}; //   2
  c_d[x_a][107] = { 11,  12}; //   2

  c_p[x_a][108] = {  5,   6}; //   2
  c_f[x_a][108] = {  8}; //   1
  c_t[x_a][108] = { 26,  42}; //   2
  c_d[x_a][108] = {  5,   6}; //   2

  c_p[x_a][109] = {  7,   8}; //   2
  c_f[x_a][109] = {  8}; //   1
  c_t[x_a][109] = { 26,  42}; //   2
  c_d[x_a][109] = {  7,   8}; //   2

  c_p[x_a][110] = {  1,   2}; //   2
  c_f[x_a][110] = {  7}; //   1
  c_t[x_a][110] = { 26,  43}; //   2
  c_d[x_a][110] = {  1,   2}; //   2

  c_p[x_a][111] = {  3,   4}; //   2
  c_f[x_a][111] = {  7}; //   1
  c_t[x_a][111] = { 26,  43}; //   2
  c_d[x_a][111] = {  3,   4}; //   2

  c_p[x_a][112] = {  1,   2}; //   2
  c_f[x_a][112] = {  6}; //   1
  c_t[x_a][112] = { 23,  44}; //   2
  c_d[x_a][112] = {  1,   2}; //   2

  c_p[x_a][113] = {  3,   4}; //   2
  c_f[x_a][113] = {  6}; //   1
  c_t[x_a][113] = { 23,  44}; //   2
  c_d[x_a][113] = {  3,   4}; //   2

  c_p[x_a][114] = {  0}; //   1
  c_f[x_a][114] = {  4,   5}; //   2
  c_t[x_a][114] = { 18,  45,  46}; //   3
  c_d[x_a][114] = {  0}; //   1

  c_p[x_a][115] = {  0}; //   1
  c_f[x_a][115] = {  4,   5}; //   2
  c_t[x_a][115] = { 18,  45,  47}; //   3
  c_d[x_a][115] = {  0}; //   1

  c_p[x_a][116] = {  0}; //   1
  c_f[x_a][116] = {  0,   1}; //   2
  c_t[x_a][116] = { 23,  48,  49}; //   3
  c_d[x_a][116] = {  0}; //   1

  c_p[x_a][117] = {  0}; //   1
  c_f[x_a][117] = {  2,   3}; //   2
  c_t[x_a][117] = { 26,  50,  51}; //   3
  c_d[x_a][117] = {  0}; //   1

  c_p[x_a][118] = {  0}; //   1
  c_f[x_a][118] = {  2,   3}; //   2
  c_t[x_a][118] = { 26,  50,  52}; //   3
  c_d[x_a][118] = {  0}; //   1

  c_p[x_a][119] = {  0}; //   1
  c_f[x_a][119] = {  0,   1}; //   2
  c_t[x_a][119] = { 23,  48,  53}; //   3
  c_d[x_a][119] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v111(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel    1: 2v111(1, 2, 32, 64, 4, 16, 8;   0,   0,   0,   0)
// channel    2: 2v111(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel    3: 2v111(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel    4: 2v111(1, 2, 32, 64, 8, 16, 4;   0,   0,   0,   0)
// channel    5: 2v111(1, 2, 32, 64, 16, 8, 4;   0,   0,   0,   0)
// channel    6: 3yv11(1, 2, 64, 4, 32, 8, 16;   0,   0,   0,   0)
// channel    7: 3yv11(1, 2, 32, 4, 64, 8, 16;   0,   0,   0,   0)
// channel    8: 3yv11(1, 2, 64, 4, 32, 16, 8;   0,   0,   0,   0)
// channel    9: 3yv11(1, 2, 32, 4, 64, 16, 8;   0,   0,   0,   0)
// channel   10: 3yv11(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
// channel   11: 3yv11(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   12: 3yv11(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
// channel   13: 3yv11(1, 2, 32, 8, 64, 4, 16;   0,   0,   0,   0)
// channel   14: 3yv11(1, 2, 64, 8, 32, 16, 4;   0,   0,   0,   0)
// channel   15: 3yv11(1, 2, 32, 8, 64, 16, 4;   0,   0,   0,   0)
// channel   16: 3yv11(1, 2, 64, 16, 32, 8, 4;   0,   0,   0,   0)
// channel   17: 3yv11(1, 2, 32, 16, 64, 8, 4;   0,   0,   0,   0)
// channel   18: 4yyv1(1, 2, 64, 4, 8, 32, 16;   0,   0,   0,   0)
// channel   19: 4yyv1(1, 2, 32, 4, 8, 64, 16;   0,   0,   0,   0)
// channel   20: 4yyv1(1, 2, 64, 4, 16, 32, 8;   0,   0,   0,   0)
// channel   21: 4yyv1(1, 2, 32, 4, 16, 64, 8;   0,   0,   0,   0)
// channel   22: 4yyv1(1, 2, 64, 16, 4, 32, 8;   0,   0,   0,   0)
// channel   23: 4yyv1(1, 2, 32, 16, 4, 64, 8;   0,   0,   0,   0)
// channel   24: 4yyv1(1, 2, 64, 8, 4, 32, 16;   0,   0,   0,   0)
// channel   25: 4yyv1(1, 2, 32, 8, 4, 64, 16;   0,   0,   0,   0)
// channel   26: 4yyv1(1, 2, 64, 8, 16, 32, 4;   0,   0,   0,   0)
// channel   27: 4yyv1(1, 2, 32, 8, 16, 64, 4;   0,   0,   0,   0)
// channel   28: 4yyv1(1, 2, 64, 16, 8, 32, 4;   0,   0,   0,   0)
// channel   29: 4yyv1(1, 2, 32, 16, 8, 64, 4;   0,   0,   0,   0)
// channel   30: 42vv1(1, 2, 4, 64, 8, 32, 16;   0,   0,   0,   0)
// channel   31: 42vv1(1, 2, 4, 32, 8, 64, 16;   0,   0,   0,   0)
// channel   32: 42vv1(1, 2, 4, 64, 16, 32, 8;   0,   0,   0,   0)
// channel   33: 42vv1(1, 2, 4, 32, 16, 64, 8;   0,   0,   0,   0)
// channel   34: 42vv1(1, 2, 8, 64, 16, 32, 4;   0,   0,   0,   0)
// channel   35: 42vv1(1, 2, 8, 32, 16, 64, 4;   0,   0,   0,   0)
// channel   36: 5yyyv(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   37: 5yyyv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   38: 5yyyv(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
// channel   39: 5yyyv(1, 2, 32, 4, 16, 8, 64;   0,   0,   0,   0)
// channel   40: 5yyyv(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
// channel   41: 5yyyv(1, 2, 32, 16, 4, 8, 64;   0,   0,   0,   0)
// channel   42: 5yyyv(1, 2, 64, 8, 4, 16, 32;   0,   0,   0,   0)
// channel   43: 5yyyv(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
// channel   44: 5yyyv(1, 2, 64, 8, 16, 4, 32;   0,   0,   0,   0)
// channel   45: 5yyyv(1, 2, 32, 8, 16, 4, 64;   0,   0,   0,   0)
// channel   46: 5yyyv(1, 2, 64, 16, 8, 4, 32;   0,   0,   0,   0)
// channel   47: 5yyyv(1, 2, 32, 16, 8, 4, 64;   0,   0,   0,   0)
// channel   48: 52vyv(1, 2, 4, 64, 8, 16, 32;   0,   0,   0,   0)
// channel   49: 52vyv(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
// channel   50: 52vyv(1, 2, 4, 64, 16, 8, 32;   0,   0,   0,   0)
// channel   51: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,   0,   0,   0)
// channel   52: 52vyv(1, 2, 16, 64, 4, 8, 32;   0,   0,   0,   0)
// channel   53: 52vyv(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel   54: 52vyv(1, 2, 8, 64, 4, 16, 32;   0,   0,   0,   0)
// channel   55: 52vyv(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
// channel   56: 52vyv(1, 2, 8, 64, 16, 4, 32;   0,   0,   0,   0)
// channel   57: 52vyv(1, 2, 8, 32, 16, 4, 64;   0,   0,   0,   0)
// channel   58: 52vyv(1, 2, 16, 64, 8, 4, 32;   0,   0,   0,   0)
// channel   59: 52vyv(1, 2, 16, 32, 8, 4, 64;   0,   0,   0,   0)
// channel   60: 12v11(1, 2, 4, 32, 64, 8, 16;   0,   0,   0,   0)
// channel   61: 12v11(1, 2, 4, 32, 64, 16, 8;   0,   0,   0,   0)
// channel   62: 12v11(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   63: 12v11(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
// channel   64: 12v11(1, 2, 8, 32, 64, 16, 4;   0,   0,   0,   0)
// channel   65: 12v11(1, 2, 16, 32, 64, 8, 4;   0,   0,   0,   0)
// channel   66: 13yv1(1, 2, 4, 64, 8, 32, 16;   0,   0,   0,   0)
// channel   67: 13yv1(1, 2, 4, 32, 8, 64, 16;   0,   0,   0,   0)
// channel   68: 13yv1(1, 2, 4, 64, 16, 32, 8;   0,   0,   0,   0)
// channel   69: 13yv1(1, 2, 4, 32, 16, 64, 8;   0,   0,   0,   0)
// channel   70: 13yv1(1, 2, 16, 64, 4, 32, 8;   0,   0,   0,   0)
// channel   71: 13yv1(1, 2, 16, 32, 4, 64, 8;   0,   0,   0,   0)
// channel   72: 13yv1(1, 2, 8, 64, 4, 32, 16;   0,   0,   0,   0)
// channel   73: 13yv1(1, 2, 8, 32, 4, 64, 16;   0,   0,   0,   0)
// channel   74: 13yv1(1, 2, 8, 64, 16, 32, 4;   0,   0,   0,   0)
// channel   75: 13yv1(1, 2, 8, 32, 16, 64, 4;   0,   0,   0,   0)
// channel   76: 13yv1(1, 2, 16, 64, 8, 32, 4;   0,   0,   0,   0)
// channel   77: 13yv1(1, 2, 16, 32, 8, 64, 4;   0,   0,   0,   0)
// channel   78: 14yyv(1, 2, 4, 64, 8, 16, 32;   0,   0,   0,   0)
// channel   79: 14yyv(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
// channel   80: 14yyv(1, 2, 4, 64, 16, 8, 32;   0,   0,   0,   0)
// channel   81: 14yyv(1, 2, 4, 32, 16, 8, 64;   0,   0,   0,   0)
// channel   82: 14yyv(1, 2, 16, 64, 4, 8, 32;   0,   0,   0,   0)
// channel   83: 14yyv(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel   84: 14yyv(1, 2, 8, 64, 4, 16, 32;   0,   0,   0,   0)
// channel   85: 14yyv(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
// channel   86: 14yyv(1, 2, 8, 64, 16, 4, 32;   0,   0,   0,   0)
// channel   87: 14yyv(1, 2, 8, 32, 16, 4, 64;   0,   0,   0,   0)
// channel   88: 14yyv(1, 2, 16, 64, 8, 4, 32;   0,   0,   0,   0)
// channel   89: 14yyv(1, 2, 16, 32, 8, 4, 64;   0,   0,   0,   0)
// channel   90: 142vv(1, 2, 4, 8, 64, 16, 32;   0,   0,   0,   0)
// channel   91: 142vv(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
// channel   92: 142vv(1, 2, 16, 4, 64, 8, 32;   0,   0,   0,   0)
// channel   93: 142vv(1, 2, 16, 4, 32, 8, 64;   0,   0,   0,   0)
// channel   94: 142vv(1, 2, 8, 4, 64, 16, 32;   0,   0,   0,   0)
// channel   95: 142vv(1, 2, 8, 4, 32, 16, 64;   0,   0,   0,   0)
// channel   96: 112v1(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel   97: 112v1(1, 2, 4, 16, 32, 64, 8;   0,   0,   0,   0)
// channel   98: 112v1(1, 2, 16, 4, 32, 64, 8;   0,   0,   0,   0)
// channel   99: 112v1(1, 2, 8, 4, 32, 64, 16;   0,   0,   0,   0)
// channel  100: 112v1(1, 2, 8, 16, 32, 64, 4;   0,   0,   0,   0)
// channel  101: 112v1(1, 2, 16, 8, 32, 64, 4;   0,   0,   0,   0)
// channel  102: 113yv(1, 2, 4, 8, 64, 16, 32;   0,   0,   0,   0)
// channel  103: 113yv(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
// channel  104: 113yv(1, 2, 4, 16, 64, 8, 32;   0,   0,   0,   0)
// channel  105: 113yv(1, 2, 4, 16, 32, 8, 64;   0,   0,   0,   0)
// channel  106: 113yv(1, 2, 16, 4, 64, 8, 32;   0,   0,   0,   0)
// channel  107: 113yv(1, 2, 16, 4, 32, 8, 64;   0,   0,   0,   0)
// channel  108: 113yv(1, 2, 8, 4, 64, 16, 32;   0,   0,   0,   0)
// channel  109: 113yv(1, 2, 8, 4, 32, 16, 64;   0,   0,   0,   0)
// channel  110: 113yv(1, 2, 8, 16, 64, 4, 32;   0,   0,   0,   0)
// channel  111: 113yv(1, 2, 8, 16, 32, 4, 64;   0,   0,   0,   0)
// channel  112: 113yv(1, 2, 16, 8, 64, 4, 32;   0,   0,   0,   0)
// channel  113: 113yv(1, 2, 16, 8, 32, 4, 64;   0,   0,   0,   0)
// channel  114: 1112v(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel  115: 1112v(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
// channel  116: 1112v(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel  117: 1112v(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel  118: 1112v(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
// channel  119: 1112v(1, 2, 16, 8, 4, 32, 64;   0,   0,   0,   0)
