#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ax_psp_230_gb_aaagb(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_230_gb_aaagb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(65);
  needed_v_smin[x_a].resize(65);
  needed_v_smin[x_a][  0] = {  30,   31,   32,   34,   35,   36,   57,   61,   62,   63,   66,   67,   88,   89,   92,   93,   94,   98,  119,  120,  121,  123,  124,  125,  126,  127,  134,  135,  142,  143}; //  30
  needed_v_smin[x_a][  1] = {  33,   37,   41,   45,   49,   53,   56,   60,   64,   68,   72,   76,   79,   83,   87,   91,   95,   99,  102,  106,  110,  114,  118,  122}; //  24
  needed_v_smin[x_a][  2] = {  38,   39,   40,   50,   51,   52,   58,   59,   65,   70,   71,   77,   78,   84,   85,   90,   96,   97,  103,  104,  105,  115,  116,  117,  128,  131,  133,  136,  138,  141}; //  30
  needed_v_smin[x_a][  3] = {  42,   43,   44,   46,   47,   48,   54,   55,   69,   73,   74,   75,   80,   81,   82,   86,  100,  101,  107,  108,  109,  111,  112,  113,  129,  130,  132,  137,  139,  140}; //  30
  needed_v_smin[x_a][  4] = {  54,   55,   81,   86,  112,  113,  132,  140,  129}; //   9
  needed_v_smin[x_a][  5] = {  56,   60,   87,   91,  118,  122}; //   6
  needed_v_smin[x_a][  6] = {  57,   61,   88,   92,  119,  123}; //   6
  needed_v_smin[x_a][  7] = {  58,   59,   85,   90,  116,  117,  133,  141,  128}; //   9
  needed_v_smin[x_a][  8] = {  62,   63,   89,   94,  120,  121,  134,  142,  127}; //   9
  needed_v_smin[x_a][  9] = {  64,   76,   83,   95,  102,  114}; //   6
  needed_v_smin[x_a][ 10] = {  65,   77,   84,   96,  103,  115}; //   6
  needed_v_smin[x_a][ 11] = {  66,   67,   93,   98,  124,  125,  135,  143,  126}; //   9
  needed_v_smin[x_a][ 12] = {  68,   72,   79,   99,  106,  110}; //   6
  needed_v_smin[x_a][ 13] = {  69,   73,   80,  100,  107,  111}; //   6
  needed_v_smin[x_a][ 14] = {  70,   71,   78,   97,  104,  105,  136,  138,  131}; //   9
  needed_v_smin[x_a][ 15] = {  74,   75,   82,  101,  108,  109,  137,  139,  130}; //   9
  needed_v_smin[x_a][ 16] = {  78,   82,  105,  109,  138,  139,   23,   28,   70,   74,  130,  131,  136,  137}; //  14
  needed_v_smin[x_a][ 17] = {  79,   80,  110,  111,   68,   69}; //   6
  needed_v_smin[x_a][ 18] = {  81,   93,  112,  124,   55,   67}; //   6
  needed_v_smin[x_a][ 19] = {  83,   84,  114,  115,   64,   65}; //   6
  needed_v_smin[x_a][ 20] = {  85,   89,  116,  120,   59,   63}; //   6
  needed_v_smin[x_a][ 21] = {  86,   98,  113,  125,  140,  143,    3,   18,   54,   66,  126,  129,  132,  135}; //  14
  needed_v_smin[x_a][ 22] = {  87,   88,  118,  119,   60,   61}; //   6
  needed_v_smin[x_a][ 23] = {  90,   94,  117,  121,  141,  142,    8,   13,   58,   62,  127,  128,  133,  134}; //  14
  needed_v_smin[x_a][ 24] = {  91,   92,  122,  123,   56,   57}; //   6
  needed_v_smin[x_a][ 25] = {  95,   96,  102,  103,   76,   77}; //   6
  needed_v_smin[x_a][ 26] = {  97,  101,  104,  108,   71,   75}; //   6
  needed_v_smin[x_a][ 27] = {  99,  100,  106,  107,   72,   73}; //   6
  needed_v_smin[x_a][ 28] = {   0,    5,   23,   24,   28,   29,   30,   34,   49,   53}; //  10
  needed_v_smin[x_a][ 29] = {   0,    5}; //   2
  needed_v_smin[x_a][ 30] = {   0,    5,   10,   15,   20,   25}; //   6
  needed_v_smin[x_a][ 31] = {   1,    2,   26,   27,   31,   32,   51,   52}; //   8
  needed_v_smin[x_a][ 32] = {   1,    2}; //   2
  needed_v_smin[x_a][ 33] = {   1,    2,    4,   16,   17,   19}; //   6
  needed_v_smin[x_a][ 34] = {   3,    4,   10,   18,   19,   25,   33,   38,   45,   50}; //  10
  needed_v_smin[x_a][ 35] = {   3,   18}; //   2
  needed_v_smin[x_a][ 36] = {   4,   19}; //   2
  needed_v_smin[x_a][ 37] = {   6,    7,   21,   22,   35,   36,   47,   48}; //   8
  needed_v_smin[x_a][ 38] = {   6,    7}; //   2
  needed_v_smin[x_a][ 39] = {   6,    7,    9,   11,   12,   14}; //   6
  needed_v_smin[x_a][ 40] = {   8,    9,   13,   14,   15,   20,   37,   41,   42,   46}; //  10
  needed_v_smin[x_a][ 41] = {   8,   13}; //   2
  needed_v_smin[x_a][ 42] = {   9,   14}; //   2
  needed_v_smin[x_a][ 43] = {  10,   25}; //   2
  needed_v_smin[x_a][ 44] = {  11,   12,   16,   17,   39,   40,   43,   44}; //   8
  needed_v_smin[x_a][ 45] = {  11,   12}; //   2
  needed_v_smin[x_a][ 46] = {  15,   20}; //   2
  needed_v_smin[x_a][ 47] = {  16,   17}; //   2
  needed_v_smin[x_a][ 48] = {  21,   22}; //   2
  needed_v_smin[x_a][ 49] = {  21,   22,   24,   26,   27,   29}; //   6
  needed_v_smin[x_a][ 50] = {  23,   28}; //   2
  needed_v_smin[x_a][ 51] = {  24,   29}; //   2
  needed_v_smin[x_a][ 52] = {  26,   27}; //   2
  needed_v_smin[x_a][ 53] = {  30,   34}; //   2
  needed_v_smin[x_a][ 54] = {  31,   32}; //   2
  needed_v_smin[x_a][ 55] = {  33,   45}; //   2
  needed_v_smin[x_a][ 56] = {  35,   36}; //   2
  needed_v_smin[x_a][ 57] = {  37,   41}; //   2
  needed_v_smin[x_a][ 58] = {  38,   50}; //   2
  needed_v_smin[x_a][ 59] = {  39,   40}; //   2
  needed_v_smin[x_a][ 60] = {  42,   46}; //   2
  needed_v_smin[x_a][ 61] = {  43,   44}; //   2
  needed_v_smin[x_a][ 62] = {  47,   48}; //   2
  needed_v_smin[x_a][ 63] = {  49,   53}; //   2
  needed_v_smin[x_a][ 64] = {  51,   52}; //   2

  v_smax[x_a].resize(37);
  needed_v_smax[x_a].resize(37);
  needed_v_smax[x_a][  0] = {  30,   31,   32,   34,   35,   36,   57,   61,   62,   63,   66,   67,   88,   89,   92,   93,   94,   98,  119,  120,  121,  123,  124,  125,  126,  127,  134,  135,  142,  143}; //  30
  needed_v_smax[x_a][  1] = {  33,   37,   41,   45,   49,   53,   56,   60,   64,   68,   72,   76,   79,   83,   87,   91,   95,   99,  102,  106,  110,  114,  118,  122}; //  24
  needed_v_smax[x_a][  2] = {  38,   39,   40,   50,   51,   52,   58,   59,   65,   70,   71,   77,   78,   84,   85,   90,   96,   97,  103,  104,  105,  115,  116,  117,  128,  131,  133,  136,  138,  141}; //  30
  needed_v_smax[x_a][  3] = {  42,   43,   44,   46,   47,   48,   54,   55,   69,   73,   74,   75,   80,   81,   82,   86,  100,  101,  107,  108,  109,  111,  112,  113,  129,  130,  132,  137,  139,  140}; //  30
  needed_v_smax[x_a][  4] = {  54,   55,   66,   67,   81,   86,   93,   98,  112,  113,  124,  125,  132,  135,  140,  143,    3,   18,  126,  129}; //  20
  needed_v_smax[x_a][  5] = {  56,   57,   60,   61,   87,   88,   91,   92,  118,  119,  122,  123}; //  12
  needed_v_smax[x_a][  6] = {  58,   59,   62,   63,   85,   89,   90,   94,  116,  117,  120,  121,  133,  134,  141,  142,    8,   13,  127,  128}; //  20
  needed_v_smax[x_a][  7] = {  64,   65,   76,   77,   83,   84,   95,   96,  102,  103,  114,  115}; //  12
  needed_v_smax[x_a][  8] = {  68,   69,   72,   73,   79,   80,   99,  100,  106,  107,  110,  111}; //  12
  needed_v_smax[x_a][  9] = {  70,   71,   74,   75,   78,   82,   97,  101,  104,  105,  108,  109,  136,  137,  138,  139,   23,   28,  130,  131}; //  20
  needed_v_smax[x_a][ 10] = {  78,   82,   86,   90,   94,   98,  105,  109,  113,  117,  121,  125,  138,  139,  140,  141,  142,  143,    3,    8,   13,   18,   23,   28,   30,   34,   38,   42,   46,   50,   54,   58,   62,   66,   70,   74,  126,  127,  128,  129,  130,  131,  132,  133,  134,  135,  136,  137}; //  48
  needed_v_smax[x_a][ 11] = {  79,   80,   81,   91,   92,   93,  110,  111,  112,  122,  123,  124,   31,   32,   33,   43,   44,   45,   55,   56,   57,   67,   68,   69}; //  24
  needed_v_smax[x_a][ 12] = {  83,   84,   85,   87,   88,   89,  114,  115,  116,  118,  119,  120,   35,   36,   37,   39,   40,   41,   59,   60,   61,   63,   64,   65}; //  24
  needed_v_smax[x_a][ 13] = {  95,   96,   97,   99,  100,  101,  102,  103,  104,  106,  107,  108,   47,   48,   49,   51,   52,   53,   71,   72,   73,   75,   76,   77}; //  24
  needed_v_smax[x_a][ 14] = {   0,    5,   23,   24,   28,   29}; //   6
  needed_v_smax[x_a][ 15] = {   0,    5,   10,   15,   20,   25}; //   6
  needed_v_smax[x_a][ 16] = {   0,    1,    2,    4,    5,    6,    7,    9,   10,   11,   12,   14,   15,   16,   17,   19,   20,   21,   22,   24,   25,   26,   27,   29}; //  24
  needed_v_smax[x_a][ 17] = {   1,    2,   26,   27}; //   4
  needed_v_smax[x_a][ 18] = {   1,    2,    4,   16,   17,   19}; //   6
  needed_v_smax[x_a][ 19] = {   3,    4,   10,   18,   19,   25}; //   6
  needed_v_smax[x_a][ 20] = {   6,    7,   21,   22}; //   4
  needed_v_smax[x_a][ 21] = {   6,    7,    9,   11,   12,   14}; //   6
  needed_v_smax[x_a][ 22] = {   8,    9,   13,   14,   15,   20}; //   6
  needed_v_smax[x_a][ 23] = {  11,   12,   16,   17}; //   4
  needed_v_smax[x_a][ 24] = {  21,   22,   24,   26,   27,   29}; //   6
  needed_v_smax[x_a][ 25] = {  30,   34}; //   2
  needed_v_smax[x_a][ 26] = {  31,   32}; //   2
  needed_v_smax[x_a][ 27] = {  33,   45}; //   2
  needed_v_smax[x_a][ 28] = {  35,   36}; //   2
  needed_v_smax[x_a][ 29] = {  37,   41}; //   2
  needed_v_smax[x_a][ 30] = {  38,   50}; //   2
  needed_v_smax[x_a][ 31] = {  39,   40}; //   2
  needed_v_smax[x_a][ 32] = {  42,   46}; //   2
  needed_v_smax[x_a][ 33] = {  43,   44}; //   2
  needed_v_smax[x_a][ 34] = {  47,   48}; //   2
  needed_v_smax[x_a][ 35] = {  49,   53}; //   2
  needed_v_smax[x_a][ 36] = {  51,   52}; //   2

  g_p[x_a].resize(28);
  needed_g_p[x_a].resize(28);
  needed_g_p[x_a][0] = {  30,   31,   32,   34,   35,   36,   57,   61,   62,   63,   66,   67,   88,   89,   92,   93,   94,   98,  119,  120,  121,  123,  124,  125,  126,  127,  134,  135,  142,  143}; //  30
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  33,   37,   41,   45,   49,   53,   56,   60,   64,   68,   72,   76,   79,   83,   87,   91,   95,   99,  102,  106,  110,  114,  118,  122}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {  38,   39,   40,   50,   51,   52,   58,   59,   65,   70,   71,   77,   78,   84,   85,   90,   96,   97,  103,  104,  105,  115,  116,  117,  128,  131,  133,  136,  138,  141}; //  30
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {  42,   43,   44,   46,   47,   48,   54,   55,   69,   73,   74,   75,   80,   81,   82,   86,  100,  101,  107,  108,  109,  111,  112,  113,  129,  130,  132,  137,  139,  140}; //  30
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  54,   55,   81,   86,  112,  113,  132,  140}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {  56,   60,   87,   91,  118,  122}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {  57,   61,   88,   92,  119,  123}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {  58,   59,   85,   90,  116,  117,  133,  141}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][8] = {  62,   63,   89,   94,  120,  121,  134,  142}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][9] = {  64,   76,   83,   95,  102,  114}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][10] = {  65,   77,   84,   96,  103,  115}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][11] = {  66,   67,   93,   98,  124,  125,  135,  143}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax4");
  needed_g_p[x_a][12] = {  68,   72,   79,   99,  106,  110}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax8");
  needed_g_p[x_a][13] = {  69,   73,   80,  100,  107,  111}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax8");
  needed_g_p[x_a][14] = {  70,   71,   78,   97,  104,  105,  136,  138}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax9");
  needed_g_p[x_a][15] = {  74,   75,   82,  101,  108,  109,  137,  139}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax9");
  needed_g_p[x_a][16] = {  78,   82,  105,  109,  138,  139}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax10");
  needed_g_p[x_a][17] = {  79,   80,  110,  111}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax11");
  needed_g_p[x_a][18] = {  81,   93,  112,  124}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax11");
  needed_g_p[x_a][19] = {  83,   84,  114,  115}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax12");
  needed_g_p[x_a][20] = {  85,   89,  116,  120}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax12");
  needed_g_p[x_a][21] = {  86,   98,  113,  125,  140,  143}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax10");
  needed_g_p[x_a][22] = {  87,   88,  118,  119}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax12");
  needed_g_p[x_a][23] = {  90,   94,  117,  121,  141,  142}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax10");
  needed_g_p[x_a][24] = {  91,   92,  122,  123}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax11");
  needed_g_p[x_a][25] = {  95,   96,  102,  103}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax13");
  needed_g_p[x_a][26] = {  97,  101,  104,  108}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin26_smax13");
  needed_g_p[x_a][27] = {  99,  100,  106,  107}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin27_smax13");

  g_f[x_a].resize(67);
  needed_g_f[x_a].resize(67);
  needed_g_f[x_a][0] = {   0,    5,   23,   24,   28,   29}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax14");
  needed_g_f[x_a][1] = {   0,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax15");
  needed_g_f[x_a][2] = {   0,    5,   10,   15,   20,   25}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax16");
  needed_g_f[x_a][3] = {   1,    2,   26,   27}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax17");
  needed_g_f[x_a][4] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax18");
  needed_g_f[x_a][5] = {   1,    2,    4,   16,   17,   19}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin33_smax16");
  needed_g_f[x_a][6] = {   3,    4,   10,   18,   19,   25}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin34_smax19");
  needed_g_f[x_a][7] = {   3,   18}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin35_smax4");
  needed_g_f[x_a][8] = {   3,   18,   54,   66,  126,  129,  132,  135}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax10");
  needed_g_f[x_a][9] = {   4,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin36_smax18");
  needed_g_f[x_a][10] = {   6,    7,   21,   22}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin37_smax20");
  needed_g_f[x_a][11] = {   6,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin38_smax21");
  needed_g_f[x_a][12] = {   6,    7,    9,   11,   12,   14}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin39_smax16");
  needed_g_f[x_a][13] = {   8,    9,   13,   14,   15,   20}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin40_smax22");
  needed_g_f[x_a][14] = {   8,   13}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin41_smax6");
  needed_g_f[x_a][15] = {   8,   13,   58,   62,  127,  128,  133,  134}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax10");
  needed_g_f[x_a][16] = {   9,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin42_smax21");
  needed_g_f[x_a][17] = {  10,   25}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin43_smax15");
  needed_g_f[x_a][18] = {  11,   12,   16,   17}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin44_smax23");
  needed_g_f[x_a][19] = {  11,   12}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin45_smax21");
  needed_g_f[x_a][20] = {  15,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin46_smax15");
  needed_g_f[x_a][21] = {  16,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin47_smax18");
  needed_g_f[x_a][22] = {  21,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin48_smax24");
  needed_g_f[x_a][23] = {  21,   22,   24,   26,   27,   29}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin49_smax16");
  needed_g_f[x_a][24] = {  23,   28}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin50_smax9");
  needed_g_f[x_a][25] = {  23,   28,   70,   74,  130,  131,  136,  137}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax10");
  needed_g_f[x_a][26] = {  24,   29}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin51_smax24");
  needed_g_f[x_a][27] = {  26,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin52_smax24");
  needed_g_f[x_a][28] = {  30,   34}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax25");
  needed_g_f[x_a][29] = {  30,   34}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin53_smax10");
  needed_g_f[x_a][30] = {  31,   32}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax26");
  needed_g_f[x_a][31] = {  31,   32}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin54_smax11");
  needed_g_f[x_a][32] = {  33,   45}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin34_smax27");
  needed_g_f[x_a][33] = {  33,   45}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin55_smax11");
  needed_g_f[x_a][34] = {  35,   36}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin37_smax28");
  needed_g_f[x_a][35] = {  35,   36}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin56_smax12");
  needed_g_f[x_a][36] = {  37,   41}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin40_smax29");
  needed_g_f[x_a][37] = {  37,   41}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin57_smax12");
  needed_g_f[x_a][38] = {  38,   50}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin34_smax30");
  needed_g_f[x_a][39] = {  38,   50}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin58_smax10");
  needed_g_f[x_a][40] = {  39,   40}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin44_smax31");
  needed_g_f[x_a][41] = {  39,   40}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin59_smax12");
  needed_g_f[x_a][42] = {  42,   46}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin40_smax32");
  needed_g_f[x_a][43] = {  42,   46}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin60_smax10");
  needed_g_f[x_a][44] = {  43,   44}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin44_smax33");
  needed_g_f[x_a][45] = {  43,   44}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin61_smax11");
  needed_g_f[x_a][46] = {  47,   48}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin37_smax34");
  needed_g_f[x_a][47] = {  47,   48}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin62_smax13");
  needed_g_f[x_a][48] = {  49,   53}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax35");
  needed_g_f[x_a][49] = {  49,   53}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin63_smax13");
  needed_g_f[x_a][50] = {  51,   52}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax36");
  needed_g_f[x_a][51] = {  51,   52}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin64_smax13");
  needed_g_f[x_a][52] = {  55,   67}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax11");
  needed_g_f[x_a][53] = {  56,   57}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax11");
  needed_g_f[x_a][54] = {  59,   63}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax12");
  needed_g_f[x_a][55] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax12");
  needed_g_f[x_a][56] = {  64,   65}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax12");
  needed_g_f[x_a][57] = {  68,   69}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax11");
  needed_g_f[x_a][58] = {  71,   75}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax13");
  needed_g_f[x_a][59] = {  72,   73}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax13");
  needed_g_f[x_a][60] = {  76,   77}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax13");
  needed_g_f[x_a][61] = { 126}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax4");
  needed_g_f[x_a][62] = { 127}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax6");
  needed_g_f[x_a][63] = { 128}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax6");
  needed_g_f[x_a][64] = { 129}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][65] = { 130}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax9");
  needed_g_f[x_a][66] = { 131}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax9");

  g_t[x_a].resize(82);
  needed_g_t[x_a].resize(82);
  needed_g_t[x_a][0] = {   0,    1,    2,    4,    5,    6,    7,    9,   10,   11,   12,   14,   15,   16,   17,   19,   20,   21,   22,   24,   25,   26,   27,   29}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {   0,    5,   10,   15,   20,   25}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][2] = {   0,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__4_24");
  needed_g_t[x_a][3] = {   0,   30}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_69__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_69__16_8");
  needed_g_t[x_a][4] = {   1,    2,    4,   16,   17,   19}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][5] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__4_40");
  needed_g_t[x_a][6] = {   1,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_69__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_69__32_8");
  needed_g_t[x_a][7] = {   2,   32}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_69__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_69__8_32");
  needed_g_t[x_a][8] = {   3,    8,   13,   18,   23,   28,  126,  127,  128,  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,  139,  140,  141,  142,  143}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][9] = {   3,   18,  126,  129,  132,  135}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][10] = {   3,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][11] = {   3,    4,   33}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_97__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_97__8_4");
  needed_g_t[x_a][12] = {   4,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][13] = {   5,   34}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_69__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_69__8_16");
  needed_g_t[x_a][14] = {   6,    7,    9,   11,   12,   14}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__8_52");
  needed_g_t[x_a][15] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__4_48");
  needed_g_t[x_a][16] = {   6,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_69__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_69__32_16");
  needed_g_t[x_a][17] = {   7,   36}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_69__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_69__16_32");
  needed_g_t[x_a][18] = {   8,   13,  127,  128,  133,  134}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_84");
  needed_g_t[x_a][19] = {   8,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__64_20");
  needed_g_t[x_a][20] = {   8,    9,   37}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_97__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_97__16_4");
  needed_g_t[x_a][21] = {   9,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__32_20");
  needed_g_t[x_a][22] = {  10,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][23] = {  10,   38}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_81__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_81__8_4");
  needed_g_t[x_a][24] = {  11,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__16_36");
  needed_g_t[x_a][25] = {  11,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_81__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_81__32_4");
  needed_g_t[x_a][26] = {  12,   40}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_81__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_81__4_32");
  needed_g_t[x_a][27] = {  13,   14,   41}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_97__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_97__4_16");
  needed_g_t[x_a][28] = {  15,   20}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__8_20");
  needed_g_t[x_a][29] = {  15,   42}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_73__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_73__16_4");
  needed_g_t[x_a][30] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__8_36");
  needed_g_t[x_a][31] = {  16,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_73__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_73__32_4");
  needed_g_t[x_a][32] = {  17,   44}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_73__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_73__4_32");
  needed_g_t[x_a][33] = {  18,   19,   45}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_97__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_97__4_8");
  needed_g_t[x_a][34] = {  20,   46}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_73__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_73__4_16");
  needed_g_t[x_a][35] = {  21,   22,   24,   26,   27,   29}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__4_56");
  needed_g_t[x_a][36] = {  21,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__8_48");
  needed_g_t[x_a][37] = {  21,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_73__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_73__32_16");
  needed_g_t[x_a][38] = {  22,   48}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_73__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_73__16_32");
  needed_g_t[x_a][39] = {  23,   28,  130,  131,  136,  137}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_88");
  needed_g_t[x_a][40] = {  23,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__64_24");
  needed_g_t[x_a][41] = {  23,   24,   49}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_97__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_97__16_8");
  needed_g_t[x_a][42] = {  24,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__32_24");
  needed_g_t[x_a][43] = {  25,   50}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_81__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_81__4_8");
  needed_g_t[x_a][44] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__16_40");
  needed_g_t[x_a][45] = {  26,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_81__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_81__32_8");
  needed_g_t[x_a][46] = {  27,   52}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_81__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_81__8_32");
  needed_g_t[x_a][47] = {  28,   29,   53}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_97__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_97__8_16");
  needed_g_t[x_a][48] = {  30,   34,   38,   42,   46,   50,   54,   58,   62,   66,   70,   74,   78,   82,   86,   90,   94,   98}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][49] = {  30,   34}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__68_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__68_24");
  needed_g_t[x_a][50] = {  31,   32,   33,   43,   44,   45,   55,   56,   57,   67,   68,   69,   79,   80,   81,   91,   92,   93}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][51] = {  31,   32}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__68_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__68_40");
  needed_g_t[x_a][52] = {  33,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][53] = {  35,   36,   37,   39,   40,   41,   59,   60,   61,   63,   64,   65,   83,   84,   85,   87,   88,   89}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][54] = {  35,   36}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__68_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__68_48");
  needed_g_t[x_a][55] = {  37,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__96_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__96_20");
  needed_g_t[x_a][56] = {  38,   50}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__80_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__80_12");
  needed_g_t[x_a][57] = {  39,   40}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__80_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__80_36");
  needed_g_t[x_a][58] = {  42,   46}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__72_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__72_20");
  needed_g_t[x_a][59] = {  43,   44}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__72_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__72_36");
  needed_g_t[x_a][60] = {  47,   48,   49,   51,   52,   53,   71,   72,   73,   75,   76,   77,   95,   96,   97,   99,  100,  101}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][61] = {  47,   48}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__72_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__72_48");
  needed_g_t[x_a][62] = {  49,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__96_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__96_24");
  needed_g_t[x_a][63] = {  51,   52}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__80_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__80_40");
  needed_g_t[x_a][64] = {  54,   66}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__16_76");
  needed_g_t[x_a][65] = {  55,   67}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__32_76");
  needed_g_t[x_a][66] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__8_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__8_100");
  needed_g_t[x_a][67] = {  58,   62}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__8_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__8_84");
  needed_g_t[x_a][68] = {  59,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__32_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__32_84");
  needed_g_t[x_a][69] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__16_100");
  needed_g_t[x_a][70] = {  64,   65}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__4_112");
  needed_g_t[x_a][71] = {  68,   69}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__4_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__4_104");
  needed_g_t[x_a][72] = {  70,   74}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__4_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__4_88");
  needed_g_t[x_a][73] = {  71,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__32_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__32_88");
  needed_g_t[x_a][74] = {  72,   73}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__16_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__16_104");
  needed_g_t[x_a][75] = {  76,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__8_112");
  needed_g_t[x_a][76] = { 126}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_33__8_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_33__8_68");
  needed_g_t[x_a][77] = { 127}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_33__16_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_33__16_68");
  needed_g_t[x_a][78] = { 128}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_33__4_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_33__4_80");
  needed_g_t[x_a][79] = { 129}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_33__4_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_33__4_72");
  needed_g_t[x_a][80] = { 130}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_33__16_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_33__16_72");
  needed_g_t[x_a][81] = { 131}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_33__8_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_33__8_80");

  g_d[x_a].resize(32);
  needed_g_d[x_a].resize(32);
  needed_g_d[x_a][0] = {  30,   31,   32,   34,   35,   36,   57,   61,   62,   63,   66,   67,   88,   89,   92,   93,   94,   98,  119,  120,  121,  123,  124,  125,  126,  127,  134,  135,  142,  143}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][1] = {  33,   37,   41,   45,   49,   53,   56,   60,   64,   68,   72,   76,   79,   83,   87,   91,   95,   99,  102,  106,  110,  114,  118,  122}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][2] = {  38,   39,   40,   50,   51,   52,   58,   59,   65,   70,   71,   77,   78,   84,   85,   90,   96,   97,  103,  104,  105,  115,  116,  117,  128,  131,  133,  136,  138,  141}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][3] = {  42,   43,   44,   46,   47,   48,   54,   55,   69,   73,   74,   75,   80,   81,   82,   86,  100,  101,  107,  108,  109,  111,  112,  113,  129,  130,  132,  137,  139,  140}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][4] = {  54,   55,   81,   86,  112,  113,  132,  140}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__4_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__4_72");
  needed_g_d[x_a][5] = {  56,   60,   87,   91,  118,  122}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__4_96");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__4_96");
  needed_g_d[x_a][6] = {  57,   61,   88,   92,  119,  123}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__32_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__32_68");
  needed_g_d[x_a][7] = {  58,   59,   85,   90,  116,  117,  133,  141}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__4_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__4_80");
  needed_g_d[x_a][8] = {  62,   63,   89,   94,  120,  121,  134,  142}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__16_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__16_68");
  needed_g_d[x_a][9] = {  64,   76,   83,   95,  102,  114}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__16_96");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__16_96");
  needed_g_d[x_a][10] = {  65,   77,   84,   96,  103,  115}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");
  needed_g_d[x_a][11] = {  66,   67,   93,   98,  124,  125,  135,  143}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__8_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__8_68");
  needed_g_d[x_a][12] = {  68,   72,   79,   99,  106,  110}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__8_96");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__8_96");
  needed_g_d[x_a][13] = {  69,   73,   80,  100,  107,  111}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__32_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__32_72");
  needed_g_d[x_a][14] = {  70,   71,   78,   97,  104,  105,  136,  138}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__8_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__8_80");
  needed_g_d[x_a][15] = {  74,   75,   82,  101,  108,  109,  137,  139}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__16_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__16_72");
  needed_g_d[x_a][16] = {  78,   82,  105,  109,  138,  139}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__4_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__4_88");
  needed_g_d[x_a][17] = {  79,   80,  110,  111}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__4_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__4_104");
  needed_g_d[x_a][18] = {  81,   93,  112,  124}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][19] = {  83,   84,  114,  115}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__4_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__4_112");
  needed_g_d[x_a][20] = {  85,   89,  116,  120}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__32_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__32_84");
  needed_g_d[x_a][21] = {  86,   98,  113,  125,  140,  143}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][22] = {  87,   88,  118,  119}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__16_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__16_100");
  needed_g_d[x_a][23] = {  90,   94,  117,  121,  141,  142}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__8_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__8_84");
  needed_g_d[x_a][24] = {  91,   92,  122,  123}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__8_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__8_100");
  needed_g_d[x_a][25] = {  95,   96,  102,  103}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__8_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__8_112");
  needed_g_d[x_a][26] = {  97,  101,  104,  108}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__32_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__32_88");
  needed_g_d[x_a][27] = {  99,  100,  106,  107}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__16_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__16_104");
  needed_g_d[x_a][28] = { 102,  103,  104,  106,  107,  108}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__4_120");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__4_120");
  needed_g_d[x_a][29] = { 105,  109,  113,  117,  121,  125}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][30] = { 110,  111,  112,  122,  123,  124}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][31] = { 114,  115,  116,  118,  119,  120}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__8_116");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__8_116");

  c_p[x_a].resize(144);
  c_f[x_a].resize(144);
  c_t[x_a].resize(144);
  c_d[x_a].resize(144);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  3,   4,   5}; //   3
  c_t[x_a][1] = {  0,   4,   5,   6}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  3,   4,   5}; //   3
  c_t[x_a][2] = {  0,   4,   5,   7}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  6,   7,   8}; //   3
  c_t[x_a][3] = {  8,   9,  10,  11}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  6,   9,   5}; //   3
  c_t[x_a][4] = {  0,   4,  12,  11}; //   4
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  0,   1,   2}; //   3
  c_t[x_a][5] = {  0,   1,   2,  13}; //   4
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = { 10,  11,  12}; //   3
  c_t[x_a][6] = {  0,  14,  15,  16}; //   4
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = { 10,  11,  12}; //   3
  c_t[x_a][7] = {  0,  14,  15,  17}; //   4
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = { 13,  14,  15}; //   3
  c_t[x_a][8] = {  8,  18,  19,  20}; //   4
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = { 13,  16,  12}; //   3
  c_t[x_a][9] = {  0,  14,  21,  20}; //   4
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = {  6,  17,   2}; //   3
  c_t[x_a][10] = {  0,   1,  22,  23}; //   4
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = { 18,  19,  12}; //   3
  c_t[x_a][11] = {  0,  14,  24,  25}; //   4
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {}; //   0
  c_f[x_a][12] = { 18,  19,  12}; //   3
  c_t[x_a][12] = {  0,  14,  24,  26}; //   4
  c_d[x_a][12] = {}; //   0

  c_p[x_a][13] = {}; //   0
  c_f[x_a][13] = { 13,  14,  15}; //   3
  c_t[x_a][13] = {  8,  18,  19,  27}; //   4
  c_d[x_a][13] = {}; //   0

  c_p[x_a][14] = {}; //   0
  c_f[x_a][14] = { 13,  16,  12}; //   3
  c_t[x_a][14] = {  0,  14,  21,  27}; //   4
  c_d[x_a][14] = {}; //   0

  c_p[x_a][15] = {}; //   0
  c_f[x_a][15] = { 13,  20,   2}; //   3
  c_t[x_a][15] = {  0,   1,  28,  29}; //   4
  c_d[x_a][15] = {}; //   0

  c_p[x_a][16] = {}; //   0
  c_f[x_a][16] = { 18,  21,   5}; //   3
  c_t[x_a][16] = {  0,   4,  30,  31}; //   4
  c_d[x_a][16] = {}; //   0

  c_p[x_a][17] = {}; //   0
  c_f[x_a][17] = { 18,  21,   5}; //   3
  c_t[x_a][17] = {  0,   4,  30,  32}; //   4
  c_d[x_a][17] = {}; //   0

  c_p[x_a][18] = {}; //   0
  c_f[x_a][18] = {  6,   7,   8}; //   3
  c_t[x_a][18] = {  8,   9,  10,  33}; //   4
  c_d[x_a][18] = {}; //   0

  c_p[x_a][19] = {}; //   0
  c_f[x_a][19] = {  6,   9,   5}; //   3
  c_t[x_a][19] = {  0,   4,  12,  33}; //   4
  c_d[x_a][19] = {}; //   0

  c_p[x_a][20] = {}; //   0
  c_f[x_a][20] = { 13,  20,   2}; //   3
  c_t[x_a][20] = {  0,   1,  28,  34}; //   4
  c_d[x_a][20] = {}; //   0

  c_p[x_a][21] = {}; //   0
  c_f[x_a][21] = { 10,  22,  23}; //   3
  c_t[x_a][21] = {  0,  35,  36,  37}; //   4
  c_d[x_a][21] = {}; //   0

  c_p[x_a][22] = {}; //   0
  c_f[x_a][22] = { 10,  22,  23}; //   3
  c_t[x_a][22] = {  0,  35,  36,  38}; //   4
  c_d[x_a][22] = {}; //   0

  c_p[x_a][23] = {}; //   0
  c_f[x_a][23] = {  0,  24,  25}; //   3
  c_t[x_a][23] = {  8,  39,  40,  41}; //   4
  c_d[x_a][23] = {}; //   0

  c_p[x_a][24] = {}; //   0
  c_f[x_a][24] = {  0,  26,  23}; //   3
  c_t[x_a][24] = {  0,  35,  42,  41}; //   4
  c_d[x_a][24] = {}; //   0

  c_p[x_a][25] = {}; //   0
  c_f[x_a][25] = {  6,  17,   2}; //   3
  c_t[x_a][25] = {  0,   1,  22,  43}; //   4
  c_d[x_a][25] = {}; //   0

  c_p[x_a][26] = {}; //   0
  c_f[x_a][26] = {  3,  27,  23}; //   3
  c_t[x_a][26] = {  0,  35,  44,  45}; //   4
  c_d[x_a][26] = {}; //   0

  c_p[x_a][27] = {}; //   0
  c_f[x_a][27] = {  3,  27,  23}; //   3
  c_t[x_a][27] = {  0,  35,  44,  46}; //   4
  c_d[x_a][27] = {}; //   0

  c_p[x_a][28] = {}; //   0
  c_f[x_a][28] = {  0,  24,  25}; //   3
  c_t[x_a][28] = {  8,  39,  40,  47}; //   4
  c_d[x_a][28] = {}; //   0

  c_p[x_a][29] = {}; //   0
  c_f[x_a][29] = {  0,  26,  23}; //   3
  c_t[x_a][29] = {  0,  35,  42,  47}; //   4
  c_d[x_a][29] = {}; //   0

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = { 28,  29}; //   2
  c_t[x_a][30] = { 48,  49,   3}; //   3
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  0}; //   1
  c_f[x_a][31] = { 30,  31}; //   2
  c_t[x_a][31] = { 50,  51,   6}; //   3
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  0}; //   1
  c_f[x_a][32] = { 30,  31}; //   2
  c_t[x_a][32] = { 50,  51,   7}; //   3
  c_d[x_a][32] = {  0}; //   1

  c_p[x_a][33] = {  1}; //   1
  c_f[x_a][33] = { 32,  33}; //   2
  c_t[x_a][33] = { 50,  52,  11}; //   3
  c_d[x_a][33] = {  1}; //   1

  c_p[x_a][34] = {  0}; //   1
  c_f[x_a][34] = { 28,  29}; //   2
  c_t[x_a][34] = { 48,  49,  13}; //   3
  c_d[x_a][34] = {  0}; //   1

  c_p[x_a][35] = {  0}; //   1
  c_f[x_a][35] = { 34,  35}; //   2
  c_t[x_a][35] = { 53,  54,  16}; //   3
  c_d[x_a][35] = {  0}; //   1

  c_p[x_a][36] = {  0}; //   1
  c_f[x_a][36] = { 34,  35}; //   2
  c_t[x_a][36] = { 53,  54,  17}; //   3
  c_d[x_a][36] = {  0}; //   1

  c_p[x_a][37] = {  1}; //   1
  c_f[x_a][37] = { 36,  37}; //   2
  c_t[x_a][37] = { 53,  55,  20}; //   3
  c_d[x_a][37] = {  1}; //   1

  c_p[x_a][38] = {  2}; //   1
  c_f[x_a][38] = { 38,  39}; //   2
  c_t[x_a][38] = { 48,  56,  23}; //   3
  c_d[x_a][38] = {  2}; //   1

  c_p[x_a][39] = {  2}; //   1
  c_f[x_a][39] = { 40,  41}; //   2
  c_t[x_a][39] = { 53,  57,  25}; //   3
  c_d[x_a][39] = {  2}; //   1

  c_p[x_a][40] = {  2}; //   1
  c_f[x_a][40] = { 40,  41}; //   2
  c_t[x_a][40] = { 53,  57,  26}; //   3
  c_d[x_a][40] = {  2}; //   1

  c_p[x_a][41] = {  1}; //   1
  c_f[x_a][41] = { 36,  37}; //   2
  c_t[x_a][41] = { 53,  55,  27}; //   3
  c_d[x_a][41] = {  1}; //   1

  c_p[x_a][42] = {  3}; //   1
  c_f[x_a][42] = { 42,  43}; //   2
  c_t[x_a][42] = { 48,  58,  29}; //   3
  c_d[x_a][42] = {  3}; //   1

  c_p[x_a][43] = {  3}; //   1
  c_f[x_a][43] = { 44,  45}; //   2
  c_t[x_a][43] = { 50,  59,  31}; //   3
  c_d[x_a][43] = {  3}; //   1

  c_p[x_a][44] = {  3}; //   1
  c_f[x_a][44] = { 44,  45}; //   2
  c_t[x_a][44] = { 50,  59,  32}; //   3
  c_d[x_a][44] = {  3}; //   1

  c_p[x_a][45] = {  1}; //   1
  c_f[x_a][45] = { 32,  33}; //   2
  c_t[x_a][45] = { 50,  52,  33}; //   3
  c_d[x_a][45] = {  1}; //   1

  c_p[x_a][46] = {  3}; //   1
  c_f[x_a][46] = { 42,  43}; //   2
  c_t[x_a][46] = { 48,  58,  34}; //   3
  c_d[x_a][46] = {  3}; //   1

  c_p[x_a][47] = {  3}; //   1
  c_f[x_a][47] = { 46,  47}; //   2
  c_t[x_a][47] = { 60,  61,  37}; //   3
  c_d[x_a][47] = {  3}; //   1

  c_p[x_a][48] = {  3}; //   1
  c_f[x_a][48] = { 46,  47}; //   2
  c_t[x_a][48] = { 60,  61,  38}; //   3
  c_d[x_a][48] = {  3}; //   1

  c_p[x_a][49] = {  1}; //   1
  c_f[x_a][49] = { 48,  49}; //   2
  c_t[x_a][49] = { 60,  62,  41}; //   3
  c_d[x_a][49] = {  1}; //   1

  c_p[x_a][50] = {  2}; //   1
  c_f[x_a][50] = { 38,  39}; //   2
  c_t[x_a][50] = { 48,  56,  43}; //   3
  c_d[x_a][50] = {  2}; //   1

  c_p[x_a][51] = {  2}; //   1
  c_f[x_a][51] = { 50,  51}; //   2
  c_t[x_a][51] = { 60,  63,  45}; //   3
  c_d[x_a][51] = {  2}; //   1

  c_p[x_a][52] = {  2}; //   1
  c_f[x_a][52] = { 50,  51}; //   2
  c_t[x_a][52] = { 60,  63,  46}; //   3
  c_d[x_a][52] = {  2}; //   1

  c_p[x_a][53] = {  1}; //   1
  c_f[x_a][53] = { 48,  49}; //   2
  c_t[x_a][53] = { 60,  62,  47}; //   3
  c_d[x_a][53] = {  1}; //   1

  c_p[x_a][54] = {  3,   4}; //   2
  c_f[x_a][54] = {  8}; //   1
  c_t[x_a][54] = { 48,  64}; //   2
  c_d[x_a][54] = {  4,   3}; //   2

  c_p[x_a][55] = {  3,   4}; //   2
  c_f[x_a][55] = { 52}; //   1
  c_t[x_a][55] = { 50,  65}; //   2
  c_d[x_a][55] = {  4,   3}; //   2

  c_p[x_a][56] = {  1,   5}; //   2
  c_f[x_a][56] = { 53}; //   1
  c_t[x_a][56] = { 50,  66}; //   2
  c_d[x_a][56] = {  5,   1}; //   2

  c_p[x_a][57] = {  0,   6}; //   2
  c_f[x_a][57] = { 53}; //   1
  c_t[x_a][57] = { 50,  66}; //   2
  c_d[x_a][57] = {  6,   0}; //   2

  c_p[x_a][58] = {  2,   7}; //   2
  c_f[x_a][58] = { 15}; //   1
  c_t[x_a][58] = { 48,  67}; //   2
  c_d[x_a][58] = {  7,   2}; //   2

  c_p[x_a][59] = {  2,   7}; //   2
  c_f[x_a][59] = { 54}; //   1
  c_t[x_a][59] = { 53,  68}; //   2
  c_d[x_a][59] = {  7,   2}; //   2

  c_p[x_a][60] = {  1,   5}; //   2
  c_f[x_a][60] = { 55}; //   1
  c_t[x_a][60] = { 53,  69}; //   2
  c_d[x_a][60] = {  5,   1}; //   2

  c_p[x_a][61] = {  0,   6}; //   2
  c_f[x_a][61] = { 55}; //   1
  c_t[x_a][61] = { 53,  69}; //   2
  c_d[x_a][61] = {  6,   0}; //   2

  c_p[x_a][62] = {  0,   8}; //   2
  c_f[x_a][62] = { 15}; //   1
  c_t[x_a][62] = { 48,  67}; //   2
  c_d[x_a][62] = {  8,   0}; //   2

  c_p[x_a][63] = {  0,   8}; //   2
  c_f[x_a][63] = { 54}; //   1
  c_t[x_a][63] = { 53,  68}; //   2
  c_d[x_a][63] = {  8,   0}; //   2

  c_p[x_a][64] = {  1,   9}; //   2
  c_f[x_a][64] = { 56}; //   1
  c_t[x_a][64] = { 53,  70}; //   2
  c_d[x_a][64] = {  9,   1}; //   2

  c_p[x_a][65] = {  2,  10}; //   2
  c_f[x_a][65] = { 56}; //   1
  c_t[x_a][65] = { 53,  70}; //   2
  c_d[x_a][65] = { 10,   2}; //   2

  c_p[x_a][66] = {  0,  11}; //   2
  c_f[x_a][66] = {  8}; //   1
  c_t[x_a][66] = { 48,  64}; //   2
  c_d[x_a][66] = { 11,   0}; //   2

  c_p[x_a][67] = {  0,  11}; //   2
  c_f[x_a][67] = { 52}; //   1
  c_t[x_a][67] = { 50,  65}; //   2
  c_d[x_a][67] = { 11,   0}; //   2

  c_p[x_a][68] = {  1,  12}; //   2
  c_f[x_a][68] = { 57}; //   1
  c_t[x_a][68] = { 50,  71}; //   2
  c_d[x_a][68] = { 12,   1}; //   2

  c_p[x_a][69] = {  3,  13}; //   2
  c_f[x_a][69] = { 57}; //   1
  c_t[x_a][69] = { 50,  71}; //   2
  c_d[x_a][69] = { 13,   3}; //   2

  c_p[x_a][70] = {  2,  14}; //   2
  c_f[x_a][70] = { 25}; //   1
  c_t[x_a][70] = { 48,  72}; //   2
  c_d[x_a][70] = { 14,   2}; //   2

  c_p[x_a][71] = {  2,  14}; //   2
  c_f[x_a][71] = { 58}; //   1
  c_t[x_a][71] = { 60,  73}; //   2
  c_d[x_a][71] = { 14,   2}; //   2

  c_p[x_a][72] = {  1,  12}; //   2
  c_f[x_a][72] = { 59}; //   1
  c_t[x_a][72] = { 60,  74}; //   2
  c_d[x_a][72] = { 12,   1}; //   2

  c_p[x_a][73] = {  3,  13}; //   2
  c_f[x_a][73] = { 59}; //   1
  c_t[x_a][73] = { 60,  74}; //   2
  c_d[x_a][73] = { 13,   3}; //   2

  c_p[x_a][74] = {  3,  15}; //   2
  c_f[x_a][74] = { 25}; //   1
  c_t[x_a][74] = { 48,  72}; //   2
  c_d[x_a][74] = { 15,   3}; //   2

  c_p[x_a][75] = {  3,  15}; //   2
  c_f[x_a][75] = { 58}; //   1
  c_t[x_a][75] = { 60,  73}; //   2
  c_d[x_a][75] = { 15,   3}; //   2

  c_p[x_a][76] = {  1,   9}; //   2
  c_f[x_a][76] = { 60}; //   1
  c_t[x_a][76] = { 60,  75}; //   2
  c_d[x_a][76] = {  9,   1}; //   2

  c_p[x_a][77] = {  2,  10}; //   2
  c_f[x_a][77] = { 60}; //   1
  c_t[x_a][77] = { 60,  75}; //   2
  c_d[x_a][77] = { 10,   2}; //   2

  c_p[x_a][78] = {  2,  14,  16}; //   3
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = { 48}; //   1
  c_d[x_a][78] = { 16,  14,   2}; //   3

  c_p[x_a][79] = {  1,  12,  17}; //   3
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 50}; //   1
  c_d[x_a][79] = { 17,  12,   1}; //   3

  c_p[x_a][80] = {  3,  13,  17}; //   3
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = { 50}; //   1
  c_d[x_a][80] = { 17,  13,   3}; //   3

  c_p[x_a][81] = {  3,   4,  18}; //   3
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = { 50}; //   1
  c_d[x_a][81] = { 18,   4,   3}; //   3

  c_p[x_a][82] = {  3,  15,  16}; //   3
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = { 48}; //   1
  c_d[x_a][82] = { 16,  15,   3}; //   3

  c_p[x_a][83] = {  1,   9,  19}; //   3
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = { 53}; //   1
  c_d[x_a][83] = { 19,   9,   1}; //   3

  c_p[x_a][84] = {  2,  10,  19}; //   3
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = { 53}; //   1
  c_d[x_a][84] = { 19,  10,   2}; //   3

  c_p[x_a][85] = {  2,   7,  20}; //   3
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = { 53}; //   1
  c_d[x_a][85] = { 20,   7,   2}; //   3

  c_p[x_a][86] = {  3,   4,  21}; //   3
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = { 48}; //   1
  c_d[x_a][86] = { 21,   4,   3}; //   3

  c_p[x_a][87] = {  1,   5,  22}; //   3
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = { 53}; //   1
  c_d[x_a][87] = { 22,   5,   1}; //   3

  c_p[x_a][88] = {  0,   6,  22}; //   3
  c_f[x_a][88] = {}; //   0
  c_t[x_a][88] = { 53}; //   1
  c_d[x_a][88] = { 22,   6,   0}; //   3

  c_p[x_a][89] = {  0,   8,  20}; //   3
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = { 53}; //   1
  c_d[x_a][89] = { 20,   8,   0}; //   3

  c_p[x_a][90] = {  2,   7,  23}; //   3
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = { 48}; //   1
  c_d[x_a][90] = { 23,   7,   2}; //   3

  c_p[x_a][91] = {  1,   5,  24}; //   3
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = { 50}; //   1
  c_d[x_a][91] = { 24,   5,   1}; //   3

  c_p[x_a][92] = {  0,   6,  24}; //   3
  c_f[x_a][92] = {}; //   0
  c_t[x_a][92] = { 50}; //   1
  c_d[x_a][92] = { 24,   6,   0}; //   3

  c_p[x_a][93] = {  0,  11,  18}; //   3
  c_f[x_a][93] = {}; //   0
  c_t[x_a][93] = { 50}; //   1
  c_d[x_a][93] = { 18,  11,   0}; //   3

  c_p[x_a][94] = {  0,   8,  23}; //   3
  c_f[x_a][94] = {}; //   0
  c_t[x_a][94] = { 48}; //   1
  c_d[x_a][94] = { 23,   8,   0}; //   3

  c_p[x_a][95] = {  1,   9,  25}; //   3
  c_f[x_a][95] = {}; //   0
  c_t[x_a][95] = { 60}; //   1
  c_d[x_a][95] = { 25,   9,   1}; //   3

  c_p[x_a][96] = {  2,  10,  25}; //   3
  c_f[x_a][96] = {}; //   0
  c_t[x_a][96] = { 60}; //   1
  c_d[x_a][96] = { 25,  10,   2}; //   3

  c_p[x_a][97] = {  2,  14,  26}; //   3
  c_f[x_a][97] = {}; //   0
  c_t[x_a][97] = { 60}; //   1
  c_d[x_a][97] = { 26,  14,   2}; //   3

  c_p[x_a][98] = {  0,  11,  21}; //   3
  c_f[x_a][98] = {}; //   0
  c_t[x_a][98] = { 48}; //   1
  c_d[x_a][98] = { 21,  11,   0}; //   3

  c_p[x_a][99] = {  1,  12,  27}; //   3
  c_f[x_a][99] = {}; //   0
  c_t[x_a][99] = { 60}; //   1
  c_d[x_a][99] = { 27,  12,   1}; //   3

  c_p[x_a][100] = {  3,  13,  27}; //   3
  c_f[x_a][100] = {}; //   0
  c_t[x_a][100] = { 60}; //   1
  c_d[x_a][100] = { 27,  13,   3}; //   3

  c_p[x_a][101] = {  3,  15,  26}; //   3
  c_f[x_a][101] = {}; //   0
  c_t[x_a][101] = { 60}; //   1
  c_d[x_a][101] = { 26,  15,   3}; //   3

  c_p[x_a][102] = {  1,   9,  25}; //   3
  c_f[x_a][102] = {}; //   0
  c_t[x_a][102] = {}; //   0
  c_d[x_a][102] = { 28,  25,   9,   1}; //   4

  c_p[x_a][103] = {  2,  10,  25}; //   3
  c_f[x_a][103] = {}; //   0
  c_t[x_a][103] = {}; //   0
  c_d[x_a][103] = { 28,  25,  10,   2}; //   4

  c_p[x_a][104] = {  2,  14,  26}; //   3
  c_f[x_a][104] = {}; //   0
  c_t[x_a][104] = {}; //   0
  c_d[x_a][104] = { 28,  26,  14,   2}; //   4

  c_p[x_a][105] = {  2,  14,  16}; //   3
  c_f[x_a][105] = {}; //   0
  c_t[x_a][105] = {}; //   0
  c_d[x_a][105] = { 29,  16,  14,   2}; //   4

  c_p[x_a][106] = {  1,  12,  27}; //   3
  c_f[x_a][106] = {}; //   0
  c_t[x_a][106] = {}; //   0
  c_d[x_a][106] = { 28,  27,  12,   1}; //   4

  c_p[x_a][107] = {  3,  13,  27}; //   3
  c_f[x_a][107] = {}; //   0
  c_t[x_a][107] = {}; //   0
  c_d[x_a][107] = { 28,  27,  13,   3}; //   4

  c_p[x_a][108] = {  3,  15,  26}; //   3
  c_f[x_a][108] = {}; //   0
  c_t[x_a][108] = {}; //   0
  c_d[x_a][108] = { 28,  26,  15,   3}; //   4

  c_p[x_a][109] = {  3,  15,  16}; //   3
  c_f[x_a][109] = {}; //   0
  c_t[x_a][109] = {}; //   0
  c_d[x_a][109] = { 29,  16,  15,   3}; //   4

  c_p[x_a][110] = {  1,  12,  17}; //   3
  c_f[x_a][110] = {}; //   0
  c_t[x_a][110] = {}; //   0
  c_d[x_a][110] = { 30,  17,  12,   1}; //   4

  c_p[x_a][111] = {  3,  13,  17}; //   3
  c_f[x_a][111] = {}; //   0
  c_t[x_a][111] = {}; //   0
  c_d[x_a][111] = { 30,  17,  13,   3}; //   4

  c_p[x_a][112] = {  3,   4,  18}; //   3
  c_f[x_a][112] = {}; //   0
  c_t[x_a][112] = {}; //   0
  c_d[x_a][112] = { 30,  18,   4,   3}; //   4

  c_p[x_a][113] = {  3,   4,  21}; //   3
  c_f[x_a][113] = {}; //   0
  c_t[x_a][113] = {}; //   0
  c_d[x_a][113] = { 29,  21,   4,   3}; //   4

  c_p[x_a][114] = {  1,   9,  19}; //   3
  c_f[x_a][114] = {}; //   0
  c_t[x_a][114] = {}; //   0
  c_d[x_a][114] = { 31,  19,   9,   1}; //   4

  c_p[x_a][115] = {  2,  10,  19}; //   3
  c_f[x_a][115] = {}; //   0
  c_t[x_a][115] = {}; //   0
  c_d[x_a][115] = { 31,  19,  10,   2}; //   4

  c_p[x_a][116] = {  2,   7,  20}; //   3
  c_f[x_a][116] = {}; //   0
  c_t[x_a][116] = {}; //   0
  c_d[x_a][116] = { 31,  20,   7,   2}; //   4

  c_p[x_a][117] = {  2,   7,  23}; //   3
  c_f[x_a][117] = {}; //   0
  c_t[x_a][117] = {}; //   0
  c_d[x_a][117] = { 29,  23,   7,   2}; //   4

  c_p[x_a][118] = {  1,   5,  22}; //   3
  c_f[x_a][118] = {}; //   0
  c_t[x_a][118] = {}; //   0
  c_d[x_a][118] = { 31,  22,   5,   1}; //   4

  c_p[x_a][119] = {  0,   6,  22}; //   3
  c_f[x_a][119] = {}; //   0
  c_t[x_a][119] = {}; //   0
  c_d[x_a][119] = { 31,  22,   6,   0}; //   4

  c_p[x_a][120] = {  0,   8,  20}; //   3
  c_f[x_a][120] = {}; //   0
  c_t[x_a][120] = {}; //   0
  c_d[x_a][120] = { 31,  20,   8,   0}; //   4

  c_p[x_a][121] = {  0,   8,  23}; //   3
  c_f[x_a][121] = {}; //   0
  c_t[x_a][121] = {}; //   0
  c_d[x_a][121] = { 29,  23,   8,   0}; //   4

  c_p[x_a][122] = {  1,   5,  24}; //   3
  c_f[x_a][122] = {}; //   0
  c_t[x_a][122] = {}; //   0
  c_d[x_a][122] = { 30,  24,   5,   1}; //   4

  c_p[x_a][123] = {  0,   6,  24}; //   3
  c_f[x_a][123] = {}; //   0
  c_t[x_a][123] = {}; //   0
  c_d[x_a][123] = { 30,  24,   6,   0}; //   4

  c_p[x_a][124] = {  0,  11,  18}; //   3
  c_f[x_a][124] = {}; //   0
  c_t[x_a][124] = {}; //   0
  c_d[x_a][124] = { 30,  18,  11,   0}; //   4

  c_p[x_a][125] = {  0,  11,  21}; //   3
  c_f[x_a][125] = {}; //   0
  c_t[x_a][125] = {}; //   0
  c_d[x_a][125] = { 29,  21,  11,   0}; //   4

  c_p[x_a][126] = {  0}; //   1
  c_f[x_a][126] = { 61,   8}; //   2
  c_t[x_a][126] = {  8,   9,  76}; //   3
  c_d[x_a][126] = {  0}; //   1

  c_p[x_a][127] = {  0}; //   1
  c_f[x_a][127] = { 62,  15}; //   2
  c_t[x_a][127] = {  8,  18,  77}; //   3
  c_d[x_a][127] = {  0}; //   1

  c_p[x_a][128] = {  2}; //   1
  c_f[x_a][128] = { 63,  15}; //   2
  c_t[x_a][128] = {  8,  18,  78}; //   3
  c_d[x_a][128] = {  2}; //   1

  c_p[x_a][129] = {  3}; //   1
  c_f[x_a][129] = { 64,   8}; //   2
  c_t[x_a][129] = {  8,   9,  79}; //   3
  c_d[x_a][129] = {  3}; //   1

  c_p[x_a][130] = {  3}; //   1
  c_f[x_a][130] = { 65,  25}; //   2
  c_t[x_a][130] = {  8,  39,  80}; //   3
  c_d[x_a][130] = {  3}; //   1

  c_p[x_a][131] = {  2}; //   1
  c_f[x_a][131] = { 66,  25}; //   2
  c_t[x_a][131] = {  8,  39,  81}; //   3
  c_d[x_a][131] = {  2}; //   1

  c_p[x_a][132] = {  3,   4}; //   2
  c_f[x_a][132] = {  8}; //   1
  c_t[x_a][132] = {  8,   9}; //   2
  c_d[x_a][132] = {  4,   3}; //   2

  c_p[x_a][133] = {  2,   7}; //   2
  c_f[x_a][133] = { 15}; //   1
  c_t[x_a][133] = {  8,  18}; //   2
  c_d[x_a][133] = {  7,   2}; //   2

  c_p[x_a][134] = {  0,   8}; //   2
  c_f[x_a][134] = { 15}; //   1
  c_t[x_a][134] = {  8,  18}; //   2
  c_d[x_a][134] = {  8,   0}; //   2

  c_p[x_a][135] = {  0,  11}; //   2
  c_f[x_a][135] = {  8}; //   1
  c_t[x_a][135] = {  8,   9}; //   2
  c_d[x_a][135] = { 11,   0}; //   2

  c_p[x_a][136] = {  2,  14}; //   2
  c_f[x_a][136] = { 25}; //   1
  c_t[x_a][136] = {  8,  39}; //   2
  c_d[x_a][136] = { 14,   2}; //   2

  c_p[x_a][137] = {  3,  15}; //   2
  c_f[x_a][137] = { 25}; //   1
  c_t[x_a][137] = {  8,  39}; //   2
  c_d[x_a][137] = { 15,   3}; //   2

  c_p[x_a][138] = {  2,  14,  16}; //   3
  c_f[x_a][138] = {}; //   0
  c_t[x_a][138] = {  8}; //   1
  c_d[x_a][138] = { 16,  14,   2}; //   3

  c_p[x_a][139] = {  3,  15,  16}; //   3
  c_f[x_a][139] = {}; //   0
  c_t[x_a][139] = {  8}; //   1
  c_d[x_a][139] = { 16,  15,   3}; //   3

  c_p[x_a][140] = {  3,   4,  21}; //   3
  c_f[x_a][140] = {}; //   0
  c_t[x_a][140] = {  8}; //   1
  c_d[x_a][140] = { 21,   4,   3}; //   3

  c_p[x_a][141] = {  2,   7,  23}; //   3
  c_f[x_a][141] = {}; //   0
  c_t[x_a][141] = {  8}; //   1
  c_d[x_a][141] = { 23,   7,   2}; //   3

  c_p[x_a][142] = {  0,   8,  23}; //   3
  c_f[x_a][142] = {}; //   0
  c_t[x_a][142] = {  8}; //   1
  c_d[x_a][142] = { 23,   8,   0}; //   3

  c_p[x_a][143] = {  0,  11,  21}; //   3
  c_f[x_a][143] = {}; //   0
  c_t[x_a][143] = {  8}; //   1
  c_d[x_a][143] = { 21,  11,   0}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 11111(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel    1: 11111(1, 2, 64, 4, 8, 32, 16;   0,   0,   0,   0)
// channel    2: 11111(1, 2, 64, 4, 32, 8, 16;   0,   0,   0,   0)
// channel    3: 11111(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel    4: 11111(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
// channel    5: 11111(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
// channel    6: 11111(1, 2, 64, 4, 16, 32, 8;   0,   0,   0,   0)
// channel    7: 11111(1, 2, 64, 4, 32, 16, 8;   0,   0,   0,   0)
// channel    8: 11111(1, 2, 32, 64, 4, 16, 8;   0,   0,   0,   0)
// channel    9: 11111(1, 2, 64, 32, 4, 16, 8;   0,   0,   0,   0)
// channel   10: 11111(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
// channel   11: 11111(1, 2, 64, 16, 4, 32, 8;   0,   0,   0,   0)
// channel   12: 11111(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
// channel   13: 11111(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel   14: 11111(1, 2, 64, 32, 16, 4, 8;   0,   0,   0,   0)
// channel   15: 11111(1, 2, 64, 8, 4, 16, 32;   0,   0,   0,   0)
// channel   16: 11111(1, 2, 64, 8, 4, 32, 16;   0,   0,   0,   0)
// channel   17: 11111(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
// channel   18: 11111(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   19: 11111(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
// channel   20: 11111(1, 2, 64, 8, 16, 4, 32;   0,   0,   0,   0)
// channel   21: 11111(1, 2, 64, 8, 16, 32, 4;   0,   0,   0,   0)
// channel   22: 11111(1, 2, 64, 8, 32, 16, 4;   0,   0,   0,   0)
// channel   23: 11111(1, 2, 32, 64, 8, 16, 4;   0,   0,   0,   0)
// channel   24: 11111(1, 2, 64, 32, 8, 16, 4;   0,   0,   0,   0)
// channel   25: 11111(1, 2, 64, 16, 8, 4, 32;   0,   0,   0,   0)
// channel   26: 11111(1, 2, 64, 16, 8, 32, 4;   0,   0,   0,   0)
// channel   27: 11111(1, 2, 64, 16, 32, 8, 4;   0,   0,   0,   0)
// channel   28: 11111(1, 2, 32, 64, 16, 8, 4;   0,   0,   0,   0)
// channel   29: 11111(1, 2, 64, 32, 16, 8, 4;   0,   0,   0,   0)
// channel   30: 2v111(1, 2, 4, 64, 8, 16, 32;   0,   0,   0,   0)
// channel   31: 2v111(1, 2, 4, 64, 8, 32, 16;   0,   0,   0,   0)
// channel   32: 2v111(1, 2, 4, 64, 32, 8, 16;   0,   0,   0,   0)
// channel   33: 2v111(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   34: 2v111(1, 2, 4, 64, 16, 8, 32;   0,   0,   0,   0)
// channel   35: 2v111(1, 2, 4, 64, 16, 32, 8;   0,   0,   0,   0)
// channel   36: 2v111(1, 2, 4, 64, 32, 16, 8;   0,   0,   0,   0)
// channel   37: 2v111(1, 2, 32, 64, 4, 16, 8;   0,   0,   0,   0)
// channel   38: 2v111(1, 2, 16, 64, 4, 8, 32;   0,   0,   0,   0)
// channel   39: 2v111(1, 2, 16, 64, 4, 32, 8;   0,   0,   0,   0)
// channel   40: 2v111(1, 2, 16, 64, 32, 4, 8;   0,   0,   0,   0)
// channel   41: 2v111(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel   42: 2v111(1, 2, 8, 64, 4, 16, 32;   0,   0,   0,   0)
// channel   43: 2v111(1, 2, 8, 64, 4, 32, 16;   0,   0,   0,   0)
// channel   44: 2v111(1, 2, 8, 64, 32, 4, 16;   0,   0,   0,   0)
// channel   45: 2v111(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   46: 2v111(1, 2, 8, 64, 16, 4, 32;   0,   0,   0,   0)
// channel   47: 2v111(1, 2, 8, 64, 16, 32, 4;   0,   0,   0,   0)
// channel   48: 2v111(1, 2, 8, 64, 32, 16, 4;   0,   0,   0,   0)
// channel   49: 2v111(1, 2, 32, 64, 8, 16, 4;   0,   0,   0,   0)
// channel   50: 2v111(1, 2, 16, 64, 8, 4, 32;   0,   0,   0,   0)
// channel   51: 2v111(1, 2, 16, 64, 8, 32, 4;   0,   0,   0,   0)
// channel   52: 2v111(1, 2, 16, 64, 32, 8, 4;   0,   0,   0,   0)
// channel   53: 2v111(1, 2, 32, 64, 16, 8, 4;   0,   0,   0,   0)
// channel   54: 3yv11(1, 2, 4, 8, 64, 16, 32;   0,   0,   0,   0)
// channel   55: 3yv11(1, 2, 4, 8, 64, 32, 16;   0,   0,   0,   0)
// channel   56: 3yv11(1, 2, 4, 32, 64, 8, 16;   0,   0,   0,   0)
// channel   57: 3yv11(1, 2, 32, 4, 64, 8, 16;   0,   0,   0,   0)
// channel   58: 3yv11(1, 2, 4, 16, 64, 8, 32;   0,   0,   0,   0)
// channel   59: 3yv11(1, 2, 4, 16, 64, 32, 8;   0,   0,   0,   0)
// channel   60: 3yv11(1, 2, 4, 32, 64, 16, 8;   0,   0,   0,   0)
// channel   61: 3yv11(1, 2, 32, 4, 64, 16, 8;   0,   0,   0,   0)
// channel   62: 3yv11(1, 2, 16, 4, 64, 8, 32;   0,   0,   0,   0)
// channel   63: 3yv11(1, 2, 16, 4, 64, 32, 8;   0,   0,   0,   0)
// channel   64: 3yv11(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   65: 3yv11(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   66: 3yv11(1, 2, 8, 4, 64, 16, 32;   0,   0,   0,   0)
// channel   67: 3yv11(1, 2, 8, 4, 64, 32, 16;   0,   0,   0,   0)
// channel   68: 3yv11(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
// channel   69: 3yv11(1, 2, 32, 8, 64, 4, 16;   0,   0,   0,   0)
// channel   70: 3yv11(1, 2, 8, 16, 64, 4, 32;   0,   0,   0,   0)
// channel   71: 3yv11(1, 2, 8, 16, 64, 32, 4;   0,   0,   0,   0)
// channel   72: 3yv11(1, 2, 8, 32, 64, 16, 4;   0,   0,   0,   0)
// channel   73: 3yv11(1, 2, 32, 8, 64, 16, 4;   0,   0,   0,   0)
// channel   74: 3yv11(1, 2, 16, 8, 64, 4, 32;   0,   0,   0,   0)
// channel   75: 3yv11(1, 2, 16, 8, 64, 32, 4;   0,   0,   0,   0)
// channel   76: 3yv11(1, 2, 16, 32, 64, 8, 4;   0,   0,   0,   0)
// channel   77: 3yv11(1, 2, 32, 16, 64, 8, 4;   0,   0,   0,   0)
// channel   78: 4yyv1(1, 2, 4, 8, 16, 64, 32;   0,   0,   0,   0)
// channel   79: 4yyv1(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel   80: 4yyv1(1, 2, 4, 32, 8, 64, 16;   0,   0,   0,   0)
// channel   81: 4yyv1(1, 2, 32, 4, 8, 64, 16;   0,   0,   0,   0)
// channel   82: 4yyv1(1, 2, 4, 16, 8, 64, 32;   0,   0,   0,   0)
// channel   83: 4yyv1(1, 2, 4, 16, 32, 64, 8;   0,   0,   0,   0)
// channel   84: 4yyv1(1, 2, 4, 32, 16, 64, 8;   0,   0,   0,   0)
// channel   85: 4yyv1(1, 2, 32, 4, 16, 64, 8;   0,   0,   0,   0)
// channel   86: 4yyv1(1, 2, 16, 4, 8, 64, 32;   0,   0,   0,   0)
// channel   87: 4yyv1(1, 2, 16, 4, 32, 64, 8;   0,   0,   0,   0)
// channel   88: 4yyv1(1, 2, 16, 32, 4, 64, 8;   0,   0,   0,   0)
// channel   89: 4yyv1(1, 2, 32, 16, 4, 64, 8;   0,   0,   0,   0)
// channel   90: 4yyv1(1, 2, 8, 4, 16, 64, 32;   0,   0,   0,   0)
// channel   91: 4yyv1(1, 2, 8, 4, 32, 64, 16;   0,   0,   0,   0)
// channel   92: 4yyv1(1, 2, 8, 32, 4, 64, 16;   0,   0,   0,   0)
// channel   93: 4yyv1(1, 2, 32, 8, 4, 64, 16;   0,   0,   0,   0)
// channel   94: 4yyv1(1, 2, 8, 16, 4, 64, 32;   0,   0,   0,   0)
// channel   95: 4yyv1(1, 2, 8, 16, 32, 64, 4;   0,   0,   0,   0)
// channel   96: 4yyv1(1, 2, 8, 32, 16, 64, 4;   0,   0,   0,   0)
// channel   97: 4yyv1(1, 2, 32, 8, 16, 64, 4;   0,   0,   0,   0)
// channel   98: 4yyv1(1, 2, 16, 8, 4, 64, 32;   0,   0,   0,   0)
// channel   99: 4yyv1(1, 2, 16, 8, 32, 64, 4;   0,   0,   0,   0)
// channel  100: 4yyv1(1, 2, 16, 32, 8, 64, 4;   0,   0,   0,   0)
// channel  101: 4yyv1(1, 2, 32, 16, 8, 64, 4;   0,   0,   0,   0)
// channel  102: 5yyyv(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel  103: 5yyyv(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
// channel  104: 5yyyv(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
// channel  105: 5yyyv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel  106: 5yyyv(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
// channel  107: 5yyyv(1, 2, 4, 16, 32, 8, 64;   0,   0,   0,   0)
// channel  108: 5yyyv(1, 2, 4, 32, 16, 8, 64;   0,   0,   0,   0)
// channel  109: 5yyyv(1, 2, 32, 4, 16, 8, 64;   0,   0,   0,   0)
// channel  110: 5yyyv(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel  111: 5yyyv(1, 2, 16, 4, 32, 8, 64;   0,   0,   0,   0)
// channel  112: 5yyyv(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel  113: 5yyyv(1, 2, 32, 16, 4, 8, 64;   0,   0,   0,   0)
// channel  114: 5yyyv(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel  115: 5yyyv(1, 2, 8, 4, 32, 16, 64;   0,   0,   0,   0)
// channel  116: 5yyyv(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
// channel  117: 5yyyv(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
// channel  118: 5yyyv(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
// channel  119: 5yyyv(1, 2, 8, 16, 32, 4, 64;   0,   0,   0,   0)
// channel  120: 5yyyv(1, 2, 8, 32, 16, 4, 64;   0,   0,   0,   0)
// channel  121: 5yyyv(1, 2, 32, 8, 16, 4, 64;   0,   0,   0,   0)
// channel  122: 5yyyv(1, 2, 16, 8, 4, 32, 64;   0,   0,   0,   0)
// channel  123: 5yyyv(1, 2, 16, 8, 32, 4, 64;   0,   0,   0,   0)
// channel  124: 5yyyv(1, 2, 16, 32, 8, 4, 64;   0,   0,   0,   0)
// channel  125: 5yyyv(1, 2, 32, 16, 8, 4, 64;   0,   0,   0,   0)
// channel  126: 12v11(1, 2, 32, 4, 64, 8, 16;   0,   0,   0,   0)
// channel  127: 12v11(1, 2, 32, 4, 64, 16, 8;   0,   0,   0,   0)
// channel  128: 12v11(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel  129: 12v11(1, 2, 32, 8, 64, 4, 16;   0,   0,   0,   0)
// channel  130: 12v11(1, 2, 32, 8, 64, 16, 4;   0,   0,   0,   0)
// channel  131: 12v11(1, 2, 32, 16, 64, 8, 4;   0,   0,   0,   0)
// channel  132: 13yv1(1, 2, 32, 4, 8, 64, 16;   0,   0,   0,   0)
// channel  133: 13yv1(1, 2, 32, 4, 16, 64, 8;   0,   0,   0,   0)
// channel  134: 13yv1(1, 2, 32, 16, 4, 64, 8;   0,   0,   0,   0)
// channel  135: 13yv1(1, 2, 32, 8, 4, 64, 16;   0,   0,   0,   0)
// channel  136: 13yv1(1, 2, 32, 8, 16, 64, 4;   0,   0,   0,   0)
// channel  137: 13yv1(1, 2, 32, 16, 8, 64, 4;   0,   0,   0,   0)
// channel  138: 14yyv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel  139: 14yyv(1, 2, 32, 4, 16, 8, 64;   0,   0,   0,   0)
// channel  140: 14yyv(1, 2, 32, 16, 4, 8, 64;   0,   0,   0,   0)
// channel  141: 14yyv(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
// channel  142: 14yyv(1, 2, 32, 8, 16, 4, 64;   0,   0,   0,   0)
// channel  143: 14yyv(1, 2, 32, 16, 8, 4, 64;   0,   0,   0,   0)
