#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ax_psp_230_uux_aaagg(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_230_uux_aaagg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(63);
  needed_v_smin[x_a].resize(63);
  needed_v_smin[x_a][  0] = { 120,  121,  122,  123,  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,  139,  140,  141,  142,  143,    6,    7,   26,   27,   46,   47,   66,   67,   86,   87,  106,  107}; //  36
  needed_v_smin[x_a][  1] = {   0,    5,   28,   29,   33,   34,   60,   65,   88,   89,   93,   94}; //  12
  needed_v_smin[x_a][  2] = {   0,    5,   89,   94}; //   4
  needed_v_smin[x_a][  3] = {   0,    5,   10,   20,   25,   30}; //   6
  needed_v_smin[x_a][  4] = {   1,    2,   31,   32,   36,   37,   61,   62,   91,   92,   96,   97}; //  12
  needed_v_smin[x_a][  5] = {   1,    2,   96,   97}; //   4
  needed_v_smin[x_a][  6] = {   1,    2,    3,   21,   22,   23}; //   6
  needed_v_smin[x_a][  7] = {   3,    4,   10,   15,   23,   24,   30,   35,   98,   99,  118,  119,  124,  125,  138,  139}; //  16
  needed_v_smin[x_a][  8] = {   3,   23,   98,  118}; //   4
  needed_v_smin[x_a][  9] = {   4,   15,   24,   35}; //   4
  needed_v_smin[x_a][ 10] = {   4,   24,   44,   64,   84,  104}; //   6
  needed_v_smin[x_a][ 11] = {   6,    7,  106,  107,  126,  131,  132,  137}; //   8
  needed_v_smin[x_a][ 12] = {   6,    7,    8,   11,   12,   13,  126,  132}; //   8
  needed_v_smin[x_a][ 13] = {   8,    9,   13,   14,   20,   25,   40,   45,  108,  109,  113,  114}; //  12
  needed_v_smin[x_a][ 14] = {   8,   13,  108,  113}; //   4
  needed_v_smin[x_a][ 15] = {   9,   14,   40,   45}; //   4
  needed_v_smin[x_a][ 16] = {   9,   14,   19,   69,   74,   79}; //   6
  needed_v_smin[x_a][ 17] = {  10,   30,   99,  119}; //   4
  needed_v_smin[x_a][ 18] = {  11,   12,   16,   17,   21,   22,   41,   42,  111,  112,  116,  117}; //  12
  needed_v_smin[x_a][ 19] = {  11,   12,  111,  112}; //   4
  needed_v_smin[x_a][ 20] = {  15,   35,   55,   75,   95,  115}; //   6
  needed_v_smin[x_a][ 21] = {  16,   17,   41,   42}; //   4
  needed_v_smin[x_a][ 22] = {  16,   17,   18,   76,   77,   78}; //   6
  needed_v_smin[x_a][ 23] = {  18,   19,   43,   44,   50,   55,   78,   79,  103,  104,  110,  115,  120,  123,  140,  143}; //  16
  needed_v_smin[x_a][ 24] = {  18,   43,   78,  103}; //   4
  needed_v_smin[x_a][ 25] = {  19,   50,   79,  110}; //   4
  needed_v_smin[x_a][ 26] = {  20,   25,  109,  114}; //   4
  needed_v_smin[x_a][ 27] = {  21,   22,  116,  117}; //   4
  needed_v_smin[x_a][ 28] = {  26,   27,   86,   87,  127,  130,  133,  136}; //   8
  needed_v_smin[x_a][ 29] = {  26,   27,   28,   31,   32,   33,  127,  133}; //   8
  needed_v_smin[x_a][ 30] = {  28,   33,   88,   93}; //   4
  needed_v_smin[x_a][ 31] = {  29,   34,   60,   65}; //   4
  needed_v_smin[x_a][ 32] = {  29,   34,   39,   49,   54,   59}; //   6
  needed_v_smin[x_a][ 33] = {  31,   32,   91,   92}; //   4
  needed_v_smin[x_a][ 34] = {  36,   37,   61,   62}; //   4
  needed_v_smin[x_a][ 35] = {  36,   37,   38,   56,   57,   58}; //   6
  needed_v_smin[x_a][ 36] = {  38,   39,   58,   59,   63,   64,   70,   75,   83,   84,   90,   95,  121,  122,  141,  142}; //  16
  needed_v_smin[x_a][ 37] = {  38,   58,   63,   83}; //   4
  needed_v_smin[x_a][ 38] = {  39,   59,   70,   90}; //   4
  needed_v_smin[x_a][ 39] = {  40,   45,   50,  100,  105,  110}; //   6
  needed_v_smin[x_a][ 40] = {  41,   42,   43,  101,  102,  103}; //   6
  needed_v_smin[x_a][ 41] = {  44,   55,  104,  115}; //   4
  needed_v_smin[x_a][ 42] = {  46,   47,   66,   67,  128,  129,  134,  135}; //   8
  needed_v_smin[x_a][ 43] = {  46,   47,   48,   51,   52,   53,  128,  134}; //   8
  needed_v_smin[x_a][ 44] = {  48,   49,   53,   54,   68,   69,   73,   74,   80,   85,  100,  105}; //  12
  needed_v_smin[x_a][ 45] = {  48,   53,   68,   73}; //   4
  needed_v_smin[x_a][ 46] = {  49,   54,   80,   85}; //   4
  needed_v_smin[x_a][ 47] = {  51,   52,   56,   57,   71,   72,   76,   77,   81,   82,  101,  102}; //  12
  needed_v_smin[x_a][ 48] = {  51,   52,   71,   72}; //   4
  needed_v_smin[x_a][ 49] = {  56,   57,   81,   82}; //   4
  needed_v_smin[x_a][ 50] = {  60,   65,   70,   80,   85,   90}; //   6
  needed_v_smin[x_a][ 51] = {  61,   62,   63,   81,   82,   83}; //   6
  needed_v_smin[x_a][ 52] = {  64,   75,   84,   95}; //   4
  needed_v_smin[x_a][ 53] = {  66,   67,   68,   71,   72,   73,  129,  135}; //   8
  needed_v_smin[x_a][ 54] = {  69,   74,  100,  105}; //   4
  needed_v_smin[x_a][ 55] = {  76,   77,  101,  102}; //   4
  needed_v_smin[x_a][ 56] = {  86,   87,   88,   91,   92,   93,  130,  136}; //   8
  needed_v_smin[x_a][ 57] = {  89,   94,   99,  109,  114,  119}; //   6
  needed_v_smin[x_a][ 58] = {  96,   97,   98,  116,  117,  118}; //   6
  needed_v_smin[x_a][ 59] = { 106,  107,  108,  111,  112,  113,  131,  137}; //   8
  needed_v_smin[x_a][ 60] = { 120,  123,  140,  143}; //   4
  needed_v_smin[x_a][ 61] = { 121,  122,  141,  142}; //   4
  needed_v_smin[x_a][ 62] = { 124,  125,  138,  139}; //   4

  v_smax[x_a].resize(28);
  needed_v_smax[x_a].resize(28);
  needed_v_smax[x_a][  0] = { 120,  121,  122,  123,  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,  139,  140,  141,  142,  143,    6,    7,   26,   27,   46,   47,   66,   67,   86,   87,  106,  107}; //  36
  needed_v_smax[x_a][  1] = {   0,    5,   28,   29,   33,   34,   60,   65,   88,   89,   93,   94}; //  12
  needed_v_smax[x_a][  2] = {   0,    5,   10,   20,   25,   30,   89,   94,   99,  109,  114,  119}; //  12
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3,    5,    6,    7,    8,   10,   11,   12,   13,   20,   21,   22,   23,   25,   26,   27,   28,   30,   31,   32,   33,  124,  125,  126,  127,  132,  133,  138,  139}; //  32
  needed_v_smax[x_a][  4] = {   1,    2,   31,   32,   36,   37,   61,   62,   91,   92,   96,   97}; //  12
  needed_v_smax[x_a][  5] = {   1,    2,    3,   21,   22,   23,   96,   97,   98,  116,  117,  118}; //  12
  needed_v_smax[x_a][  6] = {   3,    4,   10,   15,   23,   24,   30,   35,   98,   99,  118,  119}; //  12
  needed_v_smax[x_a][  7] = {   4,   15,   24,   35,   44,   55,   64,   75,   84,   95,  104,  115}; //  12
  needed_v_smax[x_a][  8] = {   4,    9,   14,   19,   24,   29,   34,   39,   44,   49,   54,   59,   64,   69,   74,   79,   84,   89,   94,   99,  104,  109,  114,  119}; //  24
  needed_v_smax[x_a][  9] = {   6,    7,    8,   11,   12,   13,  106,  107,  108,  111,  112,  113,  126,  131,  132,  137}; //  16
  needed_v_smax[x_a][ 10] = {   8,    9,   13,   14,   20,   25,   40,   45,  108,  109,  113,  114}; //  12
  needed_v_smax[x_a][ 11] = {   9,   14,   19,   40,   45,   50,   69,   74,   79,  100,  105,  110}; //  12
  needed_v_smax[x_a][ 12] = {  11,   12,   16,   17,   21,   22,   41,   42,  111,  112,  116,  117}; //  12
  needed_v_smax[x_a][ 13] = {  15,   16,   17,   18,   35,   36,   37,   38,   55,   56,   57,   58,   75,   76,   77,   78,   95,   96,   97,   98,  115,  116,  117,  118}; //  24
  needed_v_smax[x_a][ 14] = {  16,   17,   18,   41,   42,   43,   76,   77,   78,  101,  102,  103}; //  12
  needed_v_smax[x_a][ 15] = {  18,   19,   43,   44,   50,   55,   78,   79,  103,  104,  110,  115}; //  12
  needed_v_smax[x_a][ 16] = {  26,   27,   28,   31,   32,   33,   86,   87,   88,   91,   92,   93,  127,  130,  133,  136}; //  16
  needed_v_smax[x_a][ 17] = {  29,   34,   39,   49,   54,   59,   60,   65,   70,   80,   85,   90}; //  12
  needed_v_smax[x_a][ 18] = {  36,   37,   38,   56,   57,   58,   61,   62,   63,   81,   82,   83}; //  12
  needed_v_smax[x_a][ 19] = {  38,   39,   58,   59,   63,   64,   70,   75,   83,   84,   90,   95}; //  12
  needed_v_smax[x_a][ 20] = {  40,   41,   42,   43,   45,   46,   47,   48,   50,   51,   52,   53,  100,  101,  102,  103,  105,  106,  107,  108,  110,  111,  112,  113,  120,  123,  128,  131,  134,  137,  140,  143}; //  32
  needed_v_smax[x_a][ 21] = {  46,   47,   48,   51,   52,   53,   66,   67,   68,   71,   72,   73,  128,  129,  134,  135}; //  16
  needed_v_smax[x_a][ 22] = {  48,   49,   53,   54,   68,   69,   73,   74,   80,   85,  100,  105}; //  12
  needed_v_smax[x_a][ 23] = {  51,   52,   56,   57,   71,   72,   76,   77,   81,   82,  101,  102}; //  12
  needed_v_smax[x_a][ 24] = {  60,   61,   62,   63,   65,   66,   67,   68,   70,   71,   72,   73,   80,   81,   82,   83,   85,   86,   87,   88,   90,   91,   92,   93,  121,  122,  129,  130,  135,  136,  141,  142}; //  32
  needed_v_smax[x_a][ 25] = { 120,  123,  140,  143}; //   4
  needed_v_smax[x_a][ 26] = { 121,  122,  141,  142}; //   4
  needed_v_smax[x_a][ 27] = { 124,  125,  138,  139}; //   4

  g_p[x_a].resize(1);
  needed_g_p[x_a].resize(1);
  needed_g_p[x_a][0] = { 120,  121,  122,  123,  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,  139,  140,  141,  142,  143}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");

  g_f[x_a].resize(66);
  needed_g_f[x_a].resize(66);
  needed_g_f[x_a][0] = {   0,    5,   28,   29,   33,   34,   60,   65,   88,   89,   93,   94}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   0,    5,   89,   94}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][2] = {   0,    5,   10,   20,   25,   30}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][3] = {   1,    2,   31,   32,   36,   37,   61,   62,   91,   92,   96,   97}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][4] = {   1,    2,   96,   97}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][5] = {   1,    2,    3,   21,   22,   23}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax3");
  needed_g_f[x_a][6] = {   3,    4,   10,   15,   23,   24,   30,   35,   98,   99,  118,  119}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax6");
  needed_g_f[x_a][7] = {   3,   23,   98,  118}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][8] = {   4,   15,   24,   35}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][9] = {   4,   24,   44,   64,   84,  104}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax8");
  needed_g_f[x_a][10] = {   6,    7,   26,   27,   46,   47,   66,   67,   86,   87,  106,  107}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][11] = {   6,    7,  106,  107,  126,  131,  132,  137}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax9");
  needed_g_f[x_a][12] = {   6,    7,    8,   11,   12,   13,  126,  132}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax3");
  needed_g_f[x_a][13] = {   8,    9,   13,   14,   20,   25,   40,   45,  108,  109,  113,  114}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax10");
  needed_g_f[x_a][14] = {   8,   13,  108,  113}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax9");
  needed_g_f[x_a][15] = {   9,   14,   40,   45}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax11");
  needed_g_f[x_a][16] = {   9,   14,   19,   69,   74,   79}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax8");
  needed_g_f[x_a][17] = {  10,   30,   99,  119}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax2");
  needed_g_f[x_a][18] = {  11,   12,   16,   17,   21,   22,   41,   42,  111,  112,  116,  117}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax12");
  needed_g_f[x_a][19] = {  11,   12,  111,  112}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax9");
  needed_g_f[x_a][20] = {  15,   35,   55,   75,   95,  115}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax13");
  needed_g_f[x_a][21] = {  16,   17,   41,   42}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax14");
  needed_g_f[x_a][22] = {  16,   17,   18,   76,   77,   78}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax13");
  needed_g_f[x_a][23] = {  18,   19,   43,   44,   50,   55,   78,   79,  103,  104,  110,  115}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax15");
  needed_g_f[x_a][24] = {  18,   43,   78,  103}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax14");
  needed_g_f[x_a][25] = {  19,   50,   79,  110}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax11");
  needed_g_f[x_a][26] = {  20,   25,  109,  114}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax2");
  needed_g_f[x_a][27] = {  21,   22,  116,  117}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax5");
  needed_g_f[x_a][28] = {  26,   27,   86,   87,  127,  130,  133,  136}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax16");
  needed_g_f[x_a][29] = {  26,   27,   28,   31,   32,   33,  127,  133}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax3");
  needed_g_f[x_a][30] = {  28,   33,   88,   93}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax16");
  needed_g_f[x_a][31] = {  29,   34,   60,   65}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax17");
  needed_g_f[x_a][32] = {  29,   34,   39,   49,   54,   59}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax8");
  needed_g_f[x_a][33] = {  31,   32,   91,   92}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin33_smax16");
  needed_g_f[x_a][34] = {  36,   37,   61,   62}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin34_smax18");
  needed_g_f[x_a][35] = {  36,   37,   38,   56,   57,   58}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin35_smax13");
  needed_g_f[x_a][36] = {  38,   39,   58,   59,   63,   64,   70,   75,   83,   84,   90,   95}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin36_smax19");
  needed_g_f[x_a][37] = {  38,   58,   63,   83}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin37_smax18");
  needed_g_f[x_a][38] = {  39,   59,   70,   90}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin38_smax17");
  needed_g_f[x_a][39] = {  40,   45,   50,  100,  105,  110}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin39_smax20");
  needed_g_f[x_a][40] = {  41,   42,   43,  101,  102,  103}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin40_smax20");
  needed_g_f[x_a][41] = {  44,   55,  104,  115}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin41_smax7");
  needed_g_f[x_a][42] = {  46,   47,   66,   67,  128,  129,  134,  135}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin42_smax21");
  needed_g_f[x_a][43] = {  46,   47,   48,   51,   52,   53,  128,  134}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin43_smax20");
  needed_g_f[x_a][44] = {  48,   49,   53,   54,   68,   69,   73,   74,   80,   85,  100,  105}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin44_smax22");
  needed_g_f[x_a][45] = {  48,   53,   68,   73}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin45_smax21");
  needed_g_f[x_a][46] = {  49,   54,   80,   85}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin46_smax17");
  needed_g_f[x_a][47] = {  51,   52,   56,   57,   71,   72,   76,   77,   81,   82,  101,  102}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin47_smax23");
  needed_g_f[x_a][48] = {  51,   52,   71,   72}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin48_smax21");
  needed_g_f[x_a][49] = {  56,   57,   81,   82}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin49_smax18");
  needed_g_f[x_a][50] = {  60,   65,   70,   80,   85,   90}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin50_smax24");
  needed_g_f[x_a][51] = {  61,   62,   63,   81,   82,   83}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin51_smax24");
  needed_g_f[x_a][52] = {  64,   75,   84,   95}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin52_smax7");
  needed_g_f[x_a][53] = {  66,   67,   68,   71,   72,   73,  129,  135}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin53_smax24");
  needed_g_f[x_a][54] = {  69,   74,  100,  105}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin54_smax11");
  needed_g_f[x_a][55] = {  76,   77,  101,  102}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin55_smax14");
  needed_g_f[x_a][56] = {  86,   87,   88,   91,   92,   93,  130,  136}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin56_smax24");
  needed_g_f[x_a][57] = {  89,   94,   99,  109,  114,  119}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin57_smax8");
  needed_g_f[x_a][58] = {  96,   97,   98,  116,  117,  118}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin58_smax13");
  needed_g_f[x_a][59] = { 106,  107,  108,  111,  112,  113,  131,  137}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin59_smax20");
  needed_g_f[x_a][60] = { 120,  123,  140,  143}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax25");
  needed_g_f[x_a][61] = { 120,  123,  140,  143}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin60_smax20");
  needed_g_f[x_a][62] = { 121,  122,  141,  142}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin36_smax26");
  needed_g_f[x_a][63] = { 121,  122,  141,  142}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin61_smax24");
  needed_g_f[x_a][64] = { 124,  125,  138,  139}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax27");
  needed_g_f[x_a][65] = { 124,  125,  138,  139}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin62_smax3");

  g_t[x_a].resize(166);
  needed_g_t[x_a].resize(166);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    5,    6,    7,    8,   10,   11,   12,   13,   20,   21,   22,   23,   25,   26,   27,   28,   30,   31,   32,   33,  126,  127,  132,  133,  138,  139}; //  30
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_120");
  needed_g_t[x_a][1] = {   0,    5,   10,   20,   25,   30}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__64_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__64_56");
  needed_g_t[x_a][2] = {   0,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_66__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_66__8_48");
  needed_g_t[x_a][3] = {   0,   60}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][4] = {   1,    2,    3,   21,   22,   23}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_88");
  needed_g_t[x_a][5] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_80");
  needed_g_t[x_a][6] = {   1,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_13__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_13__64_16");
  needed_g_t[x_a][7] = {   2,   62}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_13__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_13__16_64");
  needed_g_t[x_a][8] = {   3,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__64_24");
  needed_g_t[x_a][9] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_69__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_69__16_8");
  needed_g_t[x_a][10] = {   4,    9,   14,   19,   24,   29,   34,   39,   44,   49,   54,   59,   64,   69,   74,   79,   84,   89,   94,   99,  104,  109,  114,  119}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][11] = {   4,   24,   44,   64,   84,  104}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][12] = {   4,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__4_24");
  needed_g_t[x_a][13] = {   5,   65}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__16_32");
  needed_g_t[x_a][14] = {   6,    7,    8,   11,   12,   13,  126,  132}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_104");
  needed_g_t[x_a][15] = {   6,    7,  132}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_96");
  needed_g_t[x_a][16] = {   6,   66}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][17] = {   7,   67}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__32_64");
  needed_g_t[x_a][18] = {   8,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__64_40");
  needed_g_t[x_a][19] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_69__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_69__32_8");
  needed_g_t[x_a][20] = {   9,   14,   19,   69,   74,   79}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][21] = {   9,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__4_40");
  needed_g_t[x_a][22] = {  10,   30}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_66__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_66__32_24");
  needed_g_t[x_a][23] = {  10,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_37__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_37__16_8");
  needed_g_t[x_a][24] = {  11,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__32_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__32_72");
  needed_g_t[x_a][25] = {  11,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_37__64_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_37__64_8");
  needed_g_t[x_a][26] = {  12,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_37__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_37__8_64");
  needed_g_t[x_a][27] = {  13,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_69__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_69__8_32");
  needed_g_t[x_a][28] = {  15,   16,   17,   18,   35,   36,   37,   38,   55,   56,   57,   58,   75,   76,   77,   78,   95,   96,   97,   98,  115,  116,  117,  118}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][29] = {  15,   35,   55,   75,   95,  115}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__64_28");
  needed_g_t[x_a][30] = {  15,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_66__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_66__4_24");
  needed_g_t[x_a][31] = {  16,   17,   18,   76,   77,   78}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][32] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__4_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__4_72");
  needed_g_t[x_a][33] = {  18,   78}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][34] = {  18,   19,  120}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_97__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_97__8_4");
  needed_g_t[x_a][35] = {  19,   79}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][36] = {  20,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_66__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_66__16_40");
  needed_g_t[x_a][37] = {  20,   40}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_21__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_21__32_8");
  needed_g_t[x_a][38] = {  21,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__16_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__16_72");
  needed_g_t[x_a][39] = {  21,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_21__64_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_21__64_8");
  needed_g_t[x_a][40] = {  22,   42}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_21__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_21__8_64");
  needed_g_t[x_a][41] = {  23,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_69__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_69__8_16");
  needed_g_t[x_a][42] = {  25,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_21__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_21__8_32");
  needed_g_t[x_a][43] = {  26,   27,   28,   31,   32,   33,  127,  133}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_112");
  needed_g_t[x_a][44] = {  26,   27,  133}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_96");
  needed_g_t[x_a][45] = {  26,   46}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_21__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_21__64_32");
  needed_g_t[x_a][46] = {  27,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_21__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_21__32_64");
  needed_g_t[x_a][47] = {  28,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__64_48");
  needed_g_t[x_a][48] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_69__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_69__32_16");
  needed_g_t[x_a][49] = {  29,   34,   39,   49,   54,   59}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__8_52");
  needed_g_t[x_a][50] = {  29,   34}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__4_48");
  needed_g_t[x_a][51] = {  30,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_37__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_37__8_16");
  needed_g_t[x_a][52] = {  31,   32}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__32_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__32_80");
  needed_g_t[x_a][53] = {  31,   36}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_37__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_37__64_16");
  needed_g_t[x_a][54] = {  32,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_37__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_37__16_64");
  needed_g_t[x_a][55] = {  33,   34}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_69__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_69__16_32");
  needed_g_t[x_a][56] = {  36,   37,   38,   56,   57,   58}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_84");
  needed_g_t[x_a][57] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__4_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__4_80");
  needed_g_t[x_a][58] = {  38,   58}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__64_20");
  needed_g_t[x_a][59] = {  38,   39,  121}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_97__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_97__16_4");
  needed_g_t[x_a][60] = {  39,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__32_20");
  needed_g_t[x_a][61] = {  40,   41,   42,   43,   45,   46,   47,   48,   50,   51,   52,   53,  100,  101,  102,  103,  105,  106,  107,  108,  110,  111,  112,  113,  128,  131,  134,  137,  140,  143}; //  30
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][62] = {  40,   45,   50,  100,  105,  110}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][63] = {  40,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_66__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_66__4_40");
  needed_g_t[x_a][64] = {  41,   42,   43,  101,  102,  103}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_76");
  needed_g_t[x_a][65] = {  41,   42}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__4_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__4_72");
  needed_g_t[x_a][66] = {  43,  103}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__64_12");
  needed_g_t[x_a][67] = {  43,   44}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_81__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_81__8_4");
  needed_g_t[x_a][68] = {  44,  104}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][69] = {  46,   47,   48,   51,   52,   53,  128,  134}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_100");
  needed_g_t[x_a][70] = {  46,   47,  134}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__4_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__4_96");
  needed_g_t[x_a][71] = {  48,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__64_36");
  needed_g_t[x_a][72] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_81__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_81__32_4");
  needed_g_t[x_a][73] = {  49,   54}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__16_36");
  needed_g_t[x_a][74] = {  50,  110}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_66__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_66__32_12");
  needed_g_t[x_a][75] = {  50,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_49__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_49__8_4");
  needed_g_t[x_a][76] = {  51,   52}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_68");
  needed_g_t[x_a][77] = {  51,   56}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_49__64_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_49__64_4");
  needed_g_t[x_a][78] = {  52,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_49__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_49__4_64");
  needed_g_t[x_a][79] = {  53,   54}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_81__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_81__4_32");
  needed_g_t[x_a][80] = {  55,  115}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_66__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_66__16_12");
  needed_g_t[x_a][81] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__16_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__16_68");
  needed_g_t[x_a][82] = {  58,   59,  122}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_97__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_97__4_16");
  needed_g_t[x_a][83] = {  60,   61,   62,   63,   65,   66,   67,   68,   70,   71,   72,   73,   80,   81,   82,   83,   85,   86,   87,   88,   90,   91,   92,   93,  129,  130,  135,  136,  141,  142}; //  30
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_116");
  needed_g_t[x_a][84] = {  60,   65,   70,   80,   85,   90}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__64_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__64_52");
  needed_g_t[x_a][85] = {  60,   65}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_66__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_66__4_48");
  needed_g_t[x_a][86] = {  61,   62,   63,   81,   82,   83}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_84");
  needed_g_t[x_a][87] = {  61,   62}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_80");
  needed_g_t[x_a][88] = {  63,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__64_20");
  needed_g_t[x_a][89] = {  63,   64}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_73__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_73__16_4");
  needed_g_t[x_a][90] = {  64,   84}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__8_20");
  needed_g_t[x_a][91] = {  66,   67,   68,   71,   72,   73,  129,  135}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_100");
  needed_g_t[x_a][92] = {  66,   67,  135}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__4_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__4_96");
  needed_g_t[x_a][93] = {  68,   73}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__64_36");
  needed_g_t[x_a][94] = {  68,   69}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_73__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_73__32_4");
  needed_g_t[x_a][95] = {  69,   74}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__8_36");
  needed_g_t[x_a][96] = {  70,   90}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_66__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_66__32_20");
  needed_g_t[x_a][97] = {  70,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_41__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_41__16_4");
  needed_g_t[x_a][98] = {  71,   72}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__32_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__32_68");
  needed_g_t[x_a][99] = {  71,   76}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_41__64_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_41__64_4");
  needed_g_t[x_a][100] = {  72,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_41__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_41__4_64");
  needed_g_t[x_a][101] = {  73,   74}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_73__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_73__4_32");
  needed_g_t[x_a][102] = {  75,   95}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_66__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_66__8_20");
  needed_g_t[x_a][103] = {  76,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__8_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__8_68");
  needed_g_t[x_a][104] = {  78,   79,  123}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_97__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_97__4_8");
  needed_g_t[x_a][105] = {  80,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_66__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_66__16_36");
  needed_g_t[x_a][106] = {  80,  100}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_25__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_25__32_4");
  needed_g_t[x_a][107] = {  81,   82}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__16_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__16_68");
  needed_g_t[x_a][108] = {  81,  101}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_25__64_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_25__64_4");
  needed_g_t[x_a][109] = {  82,  102}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_25__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_25__4_64");
  needed_g_t[x_a][110] = {  83,   84}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_73__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_73__4_16");
  needed_g_t[x_a][111] = {  85,  105}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_25__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_25__4_32");
  needed_g_t[x_a][112] = {  86,   87,   88,   91,   92,   93,  130,  136}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_112");
  needed_g_t[x_a][113] = {  86,   87,  136}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_96");
  needed_g_t[x_a][114] = {  86,  106}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_25__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_25__64_32");
  needed_g_t[x_a][115] = {  87,  107}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_25__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_25__32_64");
  needed_g_t[x_a][116] = {  88,   93}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__64_48");
  needed_g_t[x_a][117] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_73__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_73__32_16");
  needed_g_t[x_a][118] = {  89,   94,   99,  109,  114,  119}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__4_56");
  needed_g_t[x_a][119] = {  89,   94}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__8_48");
  needed_g_t[x_a][120] = {  90,   95}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_41__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_41__4_16");
  needed_g_t[x_a][121] = {  91,   92}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__32_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__32_80");
  needed_g_t[x_a][122] = {  91,   96}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_41__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_41__64_16");
  needed_g_t[x_a][123] = {  92,   97}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_41__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_41__16_64");
  needed_g_t[x_a][124] = {  93,   94}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_73__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_73__16_32");
  needed_g_t[x_a][125] = {  96,   97,   98,  116,  117,  118}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_88");
  needed_g_t[x_a][126] = {  96,   97}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__8_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__8_80");
  needed_g_t[x_a][127] = {  98,  118}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__64_24");
  needed_g_t[x_a][128] = {  98,   99,  124}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_97__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_97__16_8");
  needed_g_t[x_a][129] = {  99,  119}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__32_24");
  needed_g_t[x_a][130] = { 100,  105}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_66__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_66__8_36");
  needed_g_t[x_a][131] = { 101,  102}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__8_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__8_68");
  needed_g_t[x_a][132] = { 103,  104}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_81__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_81__4_8");
  needed_g_t[x_a][133] = { 106,  107,  108,  111,  112,  113,  131,  137}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_104");
  needed_g_t[x_a][134] = { 106,  107,  137}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__8_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__8_96");
  needed_g_t[x_a][135] = { 108,  113}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__64_40");
  needed_g_t[x_a][136] = { 108,  109}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_81__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_81__32_8");
  needed_g_t[x_a][137] = { 109,  114}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__16_40");
  needed_g_t[x_a][138] = { 110,  115}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_49__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_49__4_8");
  needed_g_t[x_a][139] = { 111,  112}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_72");
  needed_g_t[x_a][140] = { 111,  116}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_49__64_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_49__64_8");
  needed_g_t[x_a][141] = { 112,  117}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_49__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_49__8_64");
  needed_g_t[x_a][142] = { 113,  114}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_81__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_81__8_32");
  needed_g_t[x_a][143] = { 116,  117}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__16_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__16_72");
  needed_g_t[x_a][144] = { 118,  119,  125}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_97__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_97__8_16");
  needed_g_t[x_a][145] = { 120,  123}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][146] = { 120,  123}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][147] = { 121,  122}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][148] = { 121,  122}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__96_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__96_20");
  needed_g_t[x_a][149] = { 124,  125}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][150] = { 124,  125}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__96_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__96_24");
  needed_g_t[x_a][151] = { 126}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_5__8_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_5__8_96");
  needed_g_t[x_a][152] = { 127}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_5__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_5__16_96");
  needed_g_t[x_a][153] = { 128}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_17__4_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_17__4_96");
  needed_g_t[x_a][154] = { 129}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_9__4_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_9__4_96");
  needed_g_t[x_a][155] = { 130}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_9__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_9__16_96");
  needed_g_t[x_a][156] = { 131}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_17__8_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_17__8_96");
  needed_g_t[x_a][157] = { 138,  139}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__96_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__96_24");
  needed_g_t[x_a][158] = { 138}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_98__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_98__8_16");
  needed_g_t[x_a][159] = { 139}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_98__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_98__16_8");
  needed_g_t[x_a][160] = { 140,  143}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");
  needed_g_t[x_a][161] = { 140}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_98__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_98__4_8");
  needed_g_t[x_a][162] = { 141,  142}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__96_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__96_20");
  needed_g_t[x_a][163] = { 141}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_98__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_98__4_16");
  needed_g_t[x_a][164] = { 142}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_98__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_98__16_4");
  needed_g_t[x_a][165] = { 143}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_98__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_98__8_4");

  g_d[x_a].resize(1);
  needed_g_d[x_a].resize(1);
  needed_g_d[x_a][0] = { 120,  121,  122,  123,  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,  134,  135,  136,  137,  138,  139,  140,  141,  142,  143}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");

  c_p[x_a].resize(144);
  c_f[x_a].resize(144);
  c_t[x_a].resize(144);
  c_d[x_a].resize(144);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  3,   4,   5}; //   3
  c_t[x_a][1] = {  0,   4,   5,   6}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  3,   4,   5}; //   3
  c_t[x_a][2] = {  0,   4,   5,   7}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  6,   7,   5}; //   3
  c_t[x_a][3] = {  0,   4,   8,   9}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  6,   8,   9}; //   3
  c_t[x_a][4] = { 10,  11,  12,   9}; //   4
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  0,   1,   2}; //   3
  c_t[x_a][5] = {  0,   1,   2,  13}; //   4
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = { 10,  11,  12}; //   3
  c_t[x_a][6] = {  0,  14,  15,  16}; //   4
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = { 10,  11,  12}; //   3
  c_t[x_a][7] = {  0,  14,  15,  17}; //   4
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = { 13,  14,  12}; //   3
  c_t[x_a][8] = {  0,  14,  18,  19}; //   4
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = { 13,  15,  16}; //   3
  c_t[x_a][9] = { 10,  20,  21,  19}; //   4
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = {  6,  17,   2}; //   3
  c_t[x_a][10] = {  0,   1,  22,  23}; //   4
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = { 18,  19,  12}; //   3
  c_t[x_a][11] = {  0,  14,  24,  25}; //   4
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {}; //   0
  c_f[x_a][12] = { 18,  19,  12}; //   3
  c_t[x_a][12] = {  0,  14,  24,  26}; //   4
  c_d[x_a][12] = {}; //   0

  c_p[x_a][13] = {}; //   0
  c_f[x_a][13] = { 13,  14,  12}; //   3
  c_t[x_a][13] = {  0,  14,  18,  27}; //   4
  c_d[x_a][13] = {}; //   0

  c_p[x_a][14] = {}; //   0
  c_f[x_a][14] = { 13,  15,  16}; //   3
  c_t[x_a][14] = { 10,  20,  21,  27}; //   4
  c_d[x_a][14] = {}; //   0

  c_p[x_a][15] = {}; //   0
  c_f[x_a][15] = {  6,   8,  20}; //   3
  c_t[x_a][15] = { 28,  29,  30,  23}; //   4
  c_d[x_a][15] = {}; //   0

  c_p[x_a][16] = {}; //   0
  c_f[x_a][16] = { 18,  21,  22}; //   3
  c_t[x_a][16] = { 28,  31,  32,  25}; //   4
  c_d[x_a][16] = {}; //   0

  c_p[x_a][17] = {}; //   0
  c_f[x_a][17] = { 18,  21,  22}; //   3
  c_t[x_a][17] = { 28,  31,  32,  26}; //   4
  c_d[x_a][17] = {}; //   0

  c_p[x_a][18] = {}; //   0
  c_f[x_a][18] = { 23,  24,  22}; //   3
  c_t[x_a][18] = { 28,  31,  33,  34}; //   4
  c_d[x_a][18] = {}; //   0

  c_p[x_a][19] = {}; //   0
  c_f[x_a][19] = { 23,  25,  16}; //   3
  c_t[x_a][19] = { 10,  20,  35,  34}; //   4
  c_d[x_a][19] = {}; //   0

  c_p[x_a][20] = {}; //   0
  c_f[x_a][20] = { 13,  26,   2}; //   3
  c_t[x_a][20] = {  0,   1,  36,  37}; //   4
  c_d[x_a][20] = {}; //   0

  c_p[x_a][21] = {}; //   0
  c_f[x_a][21] = { 18,  27,   5}; //   3
  c_t[x_a][21] = {  0,   4,  38,  39}; //   4
  c_d[x_a][21] = {}; //   0

  c_p[x_a][22] = {}; //   0
  c_f[x_a][22] = { 18,  27,   5}; //   3
  c_t[x_a][22] = {  0,   4,  38,  40}; //   4
  c_d[x_a][22] = {}; //   0

  c_p[x_a][23] = {}; //   0
  c_f[x_a][23] = {  6,   7,   5}; //   3
  c_t[x_a][23] = {  0,   4,   8,  41}; //   4
  c_d[x_a][23] = {}; //   0

  c_p[x_a][24] = {}; //   0
  c_f[x_a][24] = {  6,   8,   9}; //   3
  c_t[x_a][24] = { 10,  11,  12,  41}; //   4
  c_d[x_a][24] = {}; //   0

  c_p[x_a][25] = {}; //   0
  c_f[x_a][25] = { 13,  26,   2}; //   3
  c_t[x_a][25] = {  0,   1,  36,  42}; //   4
  c_d[x_a][25] = {}; //   0

  c_p[x_a][26] = {}; //   0
  c_f[x_a][26] = { 10,  28,  29}; //   3
  c_t[x_a][26] = {  0,  43,  44,  45}; //   4
  c_d[x_a][26] = {}; //   0

  c_p[x_a][27] = {}; //   0
  c_f[x_a][27] = { 10,  28,  29}; //   3
  c_t[x_a][27] = {  0,  43,  44,  46}; //   4
  c_d[x_a][27] = {}; //   0

  c_p[x_a][28] = {}; //   0
  c_f[x_a][28] = {  0,  30,  29}; //   3
  c_t[x_a][28] = {  0,  43,  47,  48}; //   4
  c_d[x_a][28] = {}; //   0

  c_p[x_a][29] = {}; //   0
  c_f[x_a][29] = {  0,  31,  32}; //   3
  c_t[x_a][29] = { 10,  49,  50,  48}; //   4
  c_d[x_a][29] = {}; //   0

  c_p[x_a][30] = {}; //   0
  c_f[x_a][30] = {  6,  17,   2}; //   3
  c_t[x_a][30] = {  0,   1,  22,  51}; //   4
  c_d[x_a][30] = {}; //   0

  c_p[x_a][31] = {}; //   0
  c_f[x_a][31] = {  3,  33,  29}; //   3
  c_t[x_a][31] = {  0,  43,  52,  53}; //   4
  c_d[x_a][31] = {}; //   0

  c_p[x_a][32] = {}; //   0
  c_f[x_a][32] = {  3,  33,  29}; //   3
  c_t[x_a][32] = {  0,  43,  52,  54}; //   4
  c_d[x_a][32] = {}; //   0

  c_p[x_a][33] = {}; //   0
  c_f[x_a][33] = {  0,  30,  29}; //   3
  c_t[x_a][33] = {  0,  43,  47,  55}; //   4
  c_d[x_a][33] = {}; //   0

  c_p[x_a][34] = {}; //   0
  c_f[x_a][34] = {  0,  31,  32}; //   3
  c_t[x_a][34] = { 10,  49,  50,  55}; //   4
  c_d[x_a][34] = {}; //   0

  c_p[x_a][35] = {}; //   0
  c_f[x_a][35] = {  6,   8,  20}; //   3
  c_t[x_a][35] = { 28,  29,  30,  51}; //   4
  c_d[x_a][35] = {}; //   0

  c_p[x_a][36] = {}; //   0
  c_f[x_a][36] = {  3,  34,  35}; //   3
  c_t[x_a][36] = { 28,  56,  57,  53}; //   4
  c_d[x_a][36] = {}; //   0

  c_p[x_a][37] = {}; //   0
  c_f[x_a][37] = {  3,  34,  35}; //   3
  c_t[x_a][37] = { 28,  56,  57,  54}; //   4
  c_d[x_a][37] = {}; //   0

  c_p[x_a][38] = {}; //   0
  c_f[x_a][38] = { 36,  37,  35}; //   3
  c_t[x_a][38] = { 28,  56,  58,  59}; //   4
  c_d[x_a][38] = {}; //   0

  c_p[x_a][39] = {}; //   0
  c_f[x_a][39] = { 36,  38,  32}; //   3
  c_t[x_a][39] = { 10,  49,  60,  59}; //   4
  c_d[x_a][39] = {}; //   0

  c_p[x_a][40] = {}; //   0
  c_f[x_a][40] = { 13,  15,  39}; //   3
  c_t[x_a][40] = { 61,  62,  63,  37}; //   4
  c_d[x_a][40] = {}; //   0

  c_p[x_a][41] = {}; //   0
  c_f[x_a][41] = { 18,  21,  40}; //   3
  c_t[x_a][41] = { 61,  64,  65,  39}; //   4
  c_d[x_a][41] = {}; //   0

  c_p[x_a][42] = {}; //   0
  c_f[x_a][42] = { 18,  21,  40}; //   3
  c_t[x_a][42] = { 61,  64,  65,  40}; //   4
  c_d[x_a][42] = {}; //   0

  c_p[x_a][43] = {}; //   0
  c_f[x_a][43] = { 23,  24,  40}; //   3
  c_t[x_a][43] = { 61,  64,  66,  67}; //   4
  c_d[x_a][43] = {}; //   0

  c_p[x_a][44] = {}; //   0
  c_f[x_a][44] = { 23,  41,   9}; //   3
  c_t[x_a][44] = { 10,  11,  68,  67}; //   4
  c_d[x_a][44] = {}; //   0

  c_p[x_a][45] = {}; //   0
  c_f[x_a][45] = { 13,  15,  39}; //   3
  c_t[x_a][45] = { 61,  62,  63,  42}; //   4
  c_d[x_a][45] = {}; //   0

  c_p[x_a][46] = {}; //   0
  c_f[x_a][46] = { 10,  42,  43}; //   3
  c_t[x_a][46] = { 61,  69,  70,  45}; //   4
  c_d[x_a][46] = {}; //   0

  c_p[x_a][47] = {}; //   0
  c_f[x_a][47] = { 10,  42,  43}; //   3
  c_t[x_a][47] = { 61,  69,  70,  46}; //   4
  c_d[x_a][47] = {}; //   0

  c_p[x_a][48] = {}; //   0
  c_f[x_a][48] = { 44,  45,  43}; //   3
  c_t[x_a][48] = { 61,  69,  71,  72}; //   4
  c_d[x_a][48] = {}; //   0

  c_p[x_a][49] = {}; //   0
  c_f[x_a][49] = { 44,  46,  32}; //   3
  c_t[x_a][49] = { 10,  49,  73,  72}; //   4
  c_d[x_a][49] = {}; //   0

  c_p[x_a][50] = {}; //   0
  c_f[x_a][50] = { 23,  25,  39}; //   3
  c_t[x_a][50] = { 61,  62,  74,  75}; //   4
  c_d[x_a][50] = {}; //   0

  c_p[x_a][51] = {}; //   0
  c_f[x_a][51] = { 47,  48,  43}; //   3
  c_t[x_a][51] = { 61,  69,  76,  77}; //   4
  c_d[x_a][51] = {}; //   0

  c_p[x_a][52] = {}; //   0
  c_f[x_a][52] = { 47,  48,  43}; //   3
  c_t[x_a][52] = { 61,  69,  76,  78}; //   4
  c_d[x_a][52] = {}; //   0

  c_p[x_a][53] = {}; //   0
  c_f[x_a][53] = { 44,  45,  43}; //   3
  c_t[x_a][53] = { 61,  69,  71,  79}; //   4
  c_d[x_a][53] = {}; //   0

  c_p[x_a][54] = {}; //   0
  c_f[x_a][54] = { 44,  46,  32}; //   3
  c_t[x_a][54] = { 10,  49,  73,  79}; //   4
  c_d[x_a][54] = {}; //   0

  c_p[x_a][55] = {}; //   0
  c_f[x_a][55] = { 23,  41,  20}; //   3
  c_t[x_a][55] = { 28,  29,  80,  75}; //   4
  c_d[x_a][55] = {}; //   0

  c_p[x_a][56] = {}; //   0
  c_f[x_a][56] = { 47,  49,  35}; //   3
  c_t[x_a][56] = { 28,  56,  81,  77}; //   4
  c_d[x_a][56] = {}; //   0

  c_p[x_a][57] = {}; //   0
  c_f[x_a][57] = { 47,  49,  35}; //   3
  c_t[x_a][57] = { 28,  56,  81,  78}; //   4
  c_d[x_a][57] = {}; //   0

  c_p[x_a][58] = {}; //   0
  c_f[x_a][58] = { 36,  37,  35}; //   3
  c_t[x_a][58] = { 28,  56,  58,  82}; //   4
  c_d[x_a][58] = {}; //   0

  c_p[x_a][59] = {}; //   0
  c_f[x_a][59] = { 36,  38,  32}; //   3
  c_t[x_a][59] = { 10,  49,  60,  82}; //   4
  c_d[x_a][59] = {}; //   0

  c_p[x_a][60] = {}; //   0
  c_f[x_a][60] = {  0,  31,  50}; //   3
  c_t[x_a][60] = { 83,  84,  85,   3}; //   4
  c_d[x_a][60] = {}; //   0

  c_p[x_a][61] = {}; //   0
  c_f[x_a][61] = {  3,  34,  51}; //   3
  c_t[x_a][61] = { 83,  86,  87,   6}; //   4
  c_d[x_a][61] = {}; //   0

  c_p[x_a][62] = {}; //   0
  c_f[x_a][62] = {  3,  34,  51}; //   3
  c_t[x_a][62] = { 83,  86,  87,   7}; //   4
  c_d[x_a][62] = {}; //   0

  c_p[x_a][63] = {}; //   0
  c_f[x_a][63] = { 36,  37,  51}; //   3
  c_t[x_a][63] = { 83,  86,  88,  89}; //   4
  c_d[x_a][63] = {}; //   0

  c_p[x_a][64] = {}; //   0
  c_f[x_a][64] = { 36,  52,   9}; //   3
  c_t[x_a][64] = { 10,  11,  90,  89}; //   4
  c_d[x_a][64] = {}; //   0

  c_p[x_a][65] = {}; //   0
  c_f[x_a][65] = {  0,  31,  50}; //   3
  c_t[x_a][65] = { 83,  84,  85,  13}; //   4
  c_d[x_a][65] = {}; //   0

  c_p[x_a][66] = {}; //   0
  c_f[x_a][66] = { 10,  42,  53}; //   3
  c_t[x_a][66] = { 83,  91,  92,  16}; //   4
  c_d[x_a][66] = {}; //   0

  c_p[x_a][67] = {}; //   0
  c_f[x_a][67] = { 10,  42,  53}; //   3
  c_t[x_a][67] = { 83,  91,  92,  17}; //   4
  c_d[x_a][67] = {}; //   0

  c_p[x_a][68] = {}; //   0
  c_f[x_a][68] = { 44,  45,  53}; //   3
  c_t[x_a][68] = { 83,  91,  93,  94}; //   4
  c_d[x_a][68] = {}; //   0

  c_p[x_a][69] = {}; //   0
  c_f[x_a][69] = { 44,  54,  16}; //   3
  c_t[x_a][69] = { 10,  20,  95,  94}; //   4
  c_d[x_a][69] = {}; //   0

  c_p[x_a][70] = {}; //   0
  c_f[x_a][70] = { 36,  38,  50}; //   3
  c_t[x_a][70] = { 83,  84,  96,  97}; //   4
  c_d[x_a][70] = {}; //   0

  c_p[x_a][71] = {}; //   0
  c_f[x_a][71] = { 47,  48,  53}; //   3
  c_t[x_a][71] = { 83,  91,  98,  99}; //   4
  c_d[x_a][71] = {}; //   0

  c_p[x_a][72] = {}; //   0
  c_f[x_a][72] = { 47,  48,  53}; //   3
  c_t[x_a][72] = { 83,  91,  98, 100}; //   4
  c_d[x_a][72] = {}; //   0

  c_p[x_a][73] = {}; //   0
  c_f[x_a][73] = { 44,  45,  53}; //   3
  c_t[x_a][73] = { 83,  91,  93, 101}; //   4
  c_d[x_a][73] = {}; //   0

  c_p[x_a][74] = {}; //   0
  c_f[x_a][74] = { 44,  54,  16}; //   3
  c_t[x_a][74] = { 10,  20,  95, 101}; //   4
  c_d[x_a][74] = {}; //   0

  c_p[x_a][75] = {}; //   0
  c_f[x_a][75] = { 36,  52,  20}; //   3
  c_t[x_a][75] = { 28,  29, 102,  97}; //   4
  c_d[x_a][75] = {}; //   0

  c_p[x_a][76] = {}; //   0
  c_f[x_a][76] = { 47,  55,  22}; //   3
  c_t[x_a][76] = { 28,  31, 103,  99}; //   4
  c_d[x_a][76] = {}; //   0

  c_p[x_a][77] = {}; //   0
  c_f[x_a][77] = { 47,  55,  22}; //   3
  c_t[x_a][77] = { 28,  31, 103, 100}; //   4
  c_d[x_a][77] = {}; //   0

  c_p[x_a][78] = {}; //   0
  c_f[x_a][78] = { 23,  24,  22}; //   3
  c_t[x_a][78] = { 28,  31,  33, 104}; //   4
  c_d[x_a][78] = {}; //   0

  c_p[x_a][79] = {}; //   0
  c_f[x_a][79] = { 23,  25,  16}; //   3
  c_t[x_a][79] = { 10,  20,  35, 104}; //   4
  c_d[x_a][79] = {}; //   0

  c_p[x_a][80] = {}; //   0
  c_f[x_a][80] = { 44,  46,  50}; //   3
  c_t[x_a][80] = { 83,  84, 105, 106}; //   4
  c_d[x_a][80] = {}; //   0

  c_p[x_a][81] = {}; //   0
  c_f[x_a][81] = { 47,  49,  51}; //   3
  c_t[x_a][81] = { 83,  86, 107, 108}; //   4
  c_d[x_a][81] = {}; //   0

  c_p[x_a][82] = {}; //   0
  c_f[x_a][82] = { 47,  49,  51}; //   3
  c_t[x_a][82] = { 83,  86, 107, 109}; //   4
  c_d[x_a][82] = {}; //   0

  c_p[x_a][83] = {}; //   0
  c_f[x_a][83] = { 36,  37,  51}; //   3
  c_t[x_a][83] = { 83,  86,  88, 110}; //   4
  c_d[x_a][83] = {}; //   0

  c_p[x_a][84] = {}; //   0
  c_f[x_a][84] = { 36,  52,   9}; //   3
  c_t[x_a][84] = { 10,  11,  90, 110}; //   4
  c_d[x_a][84] = {}; //   0

  c_p[x_a][85] = {}; //   0
  c_f[x_a][85] = { 44,  46,  50}; //   3
  c_t[x_a][85] = { 83,  84, 105, 111}; //   4
  c_d[x_a][85] = {}; //   0

  c_p[x_a][86] = {}; //   0
  c_f[x_a][86] = { 10,  28,  56}; //   3
  c_t[x_a][86] = { 83, 112, 113, 114}; //   4
  c_d[x_a][86] = {}; //   0

  c_p[x_a][87] = {}; //   0
  c_f[x_a][87] = { 10,  28,  56}; //   3
  c_t[x_a][87] = { 83, 112, 113, 115}; //   4
  c_d[x_a][87] = {}; //   0

  c_p[x_a][88] = {}; //   0
  c_f[x_a][88] = {  0,  30,  56}; //   3
  c_t[x_a][88] = { 83, 112, 116, 117}; //   4
  c_d[x_a][88] = {}; //   0

  c_p[x_a][89] = {}; //   0
  c_f[x_a][89] = {  0,   1,  57}; //   3
  c_t[x_a][89] = { 10, 118, 119, 117}; //   4
  c_d[x_a][89] = {}; //   0

  c_p[x_a][90] = {}; //   0
  c_f[x_a][90] = { 36,  38,  50}; //   3
  c_t[x_a][90] = { 83,  84,  96, 120}; //   4
  c_d[x_a][90] = {}; //   0

  c_p[x_a][91] = {}; //   0
  c_f[x_a][91] = {  3,  33,  56}; //   3
  c_t[x_a][91] = { 83, 112, 121, 122}; //   4
  c_d[x_a][91] = {}; //   0

  c_p[x_a][92] = {}; //   0
  c_f[x_a][92] = {  3,  33,  56}; //   3
  c_t[x_a][92] = { 83, 112, 121, 123}; //   4
  c_d[x_a][92] = {}; //   0

  c_p[x_a][93] = {}; //   0
  c_f[x_a][93] = {  0,  30,  56}; //   3
  c_t[x_a][93] = { 83, 112, 116, 124}; //   4
  c_d[x_a][93] = {}; //   0

  c_p[x_a][94] = {}; //   0
  c_f[x_a][94] = {  0,   1,  57}; //   3
  c_t[x_a][94] = { 10, 118, 119, 124}; //   4
  c_d[x_a][94] = {}; //   0

  c_p[x_a][95] = {}; //   0
  c_f[x_a][95] = { 36,  52,  20}; //   3
  c_t[x_a][95] = { 28,  29, 102, 120}; //   4
  c_d[x_a][95] = {}; //   0

  c_p[x_a][96] = {}; //   0
  c_f[x_a][96] = {  3,   4,  58}; //   3
  c_t[x_a][96] = { 28, 125, 126, 122}; //   4
  c_d[x_a][96] = {}; //   0

  c_p[x_a][97] = {}; //   0
  c_f[x_a][97] = {  3,   4,  58}; //   3
  c_t[x_a][97] = { 28, 125, 126, 123}; //   4
  c_d[x_a][97] = {}; //   0

  c_p[x_a][98] = {}; //   0
  c_f[x_a][98] = {  6,   7,  58}; //   3
  c_t[x_a][98] = { 28, 125, 127, 128}; //   4
  c_d[x_a][98] = {}; //   0

  c_p[x_a][99] = {}; //   0
  c_f[x_a][99] = {  6,  17,  57}; //   3
  c_t[x_a][99] = { 10, 118, 129, 128}; //   4
  c_d[x_a][99] = {}; //   0

  c_p[x_a][100] = {}; //   0
  c_f[x_a][100] = { 44,  54,  39}; //   3
  c_t[x_a][100] = { 61,  62, 130, 106}; //   4
  c_d[x_a][100] = {}; //   0

  c_p[x_a][101] = {}; //   0
  c_f[x_a][101] = { 47,  55,  40}; //   3
  c_t[x_a][101] = { 61,  64, 131, 108}; //   4
  c_d[x_a][101] = {}; //   0

  c_p[x_a][102] = {}; //   0
  c_f[x_a][102] = { 47,  55,  40}; //   3
  c_t[x_a][102] = { 61,  64, 131, 109}; //   4
  c_d[x_a][102] = {}; //   0

  c_p[x_a][103] = {}; //   0
  c_f[x_a][103] = { 23,  24,  40}; //   3
  c_t[x_a][103] = { 61,  64,  66, 132}; //   4
  c_d[x_a][103] = {}; //   0

  c_p[x_a][104] = {}; //   0
  c_f[x_a][104] = { 23,  41,   9}; //   3
  c_t[x_a][104] = { 10,  11,  68, 132}; //   4
  c_d[x_a][104] = {}; //   0

  c_p[x_a][105] = {}; //   0
  c_f[x_a][105] = { 44,  54,  39}; //   3
  c_t[x_a][105] = { 61,  62, 130, 111}; //   4
  c_d[x_a][105] = {}; //   0

  c_p[x_a][106] = {}; //   0
  c_f[x_a][106] = { 10,  11,  59}; //   3
  c_t[x_a][106] = { 61, 133, 134, 114}; //   4
  c_d[x_a][106] = {}; //   0

  c_p[x_a][107] = {}; //   0
  c_f[x_a][107] = { 10,  11,  59}; //   3
  c_t[x_a][107] = { 61, 133, 134, 115}; //   4
  c_d[x_a][107] = {}; //   0

  c_p[x_a][108] = {}; //   0
  c_f[x_a][108] = { 13,  14,  59}; //   3
  c_t[x_a][108] = { 61, 133, 135, 136}; //   4
  c_d[x_a][108] = {}; //   0

  c_p[x_a][109] = {}; //   0
  c_f[x_a][109] = { 13,  26,  57}; //   3
  c_t[x_a][109] = { 10, 118, 137, 136}; //   4
  c_d[x_a][109] = {}; //   0

  c_p[x_a][110] = {}; //   0
  c_f[x_a][110] = { 23,  25,  39}; //   3
  c_t[x_a][110] = { 61,  62,  74, 138}; //   4
  c_d[x_a][110] = {}; //   0

  c_p[x_a][111] = {}; //   0
  c_f[x_a][111] = { 18,  19,  59}; //   3
  c_t[x_a][111] = { 61, 133, 139, 140}; //   4
  c_d[x_a][111] = {}; //   0

  c_p[x_a][112] = {}; //   0
  c_f[x_a][112] = { 18,  19,  59}; //   3
  c_t[x_a][112] = { 61, 133, 139, 141}; //   4
  c_d[x_a][112] = {}; //   0

  c_p[x_a][113] = {}; //   0
  c_f[x_a][113] = { 13,  14,  59}; //   3
  c_t[x_a][113] = { 61, 133, 135, 142}; //   4
  c_d[x_a][113] = {}; //   0

  c_p[x_a][114] = {}; //   0
  c_f[x_a][114] = { 13,  26,  57}; //   3
  c_t[x_a][114] = { 10, 118, 137, 142}; //   4
  c_d[x_a][114] = {}; //   0

  c_p[x_a][115] = {}; //   0
  c_f[x_a][115] = { 23,  41,  20}; //   3
  c_t[x_a][115] = { 28,  29,  80, 138}; //   4
  c_d[x_a][115] = {}; //   0

  c_p[x_a][116] = {}; //   0
  c_f[x_a][116] = { 18,  27,  58}; //   3
  c_t[x_a][116] = { 28, 125, 143, 140}; //   4
  c_d[x_a][116] = {}; //   0

  c_p[x_a][117] = {}; //   0
  c_f[x_a][117] = { 18,  27,  58}; //   3
  c_t[x_a][117] = { 28, 125, 143, 141}; //   4
  c_d[x_a][117] = {}; //   0

  c_p[x_a][118] = {}; //   0
  c_f[x_a][118] = {  6,   7,  58}; //   3
  c_t[x_a][118] = { 28, 125, 127, 144}; //   4
  c_d[x_a][118] = {}; //   0

  c_p[x_a][119] = {}; //   0
  c_f[x_a][119] = {  6,  17,  57}; //   3
  c_t[x_a][119] = { 10, 118, 129, 144}; //   4
  c_d[x_a][119] = {}; //   0

  c_p[x_a][120] = {  0}; //   1
  c_f[x_a][120] = { 60,  61}; //   2
  c_t[x_a][120] = {145, 146,  34}; //   3
  c_d[x_a][120] = {  0}; //   1

  c_p[x_a][121] = {  0}; //   1
  c_f[x_a][121] = { 62,  63}; //   2
  c_t[x_a][121] = {147, 148,  59}; //   3
  c_d[x_a][121] = {  0}; //   1

  c_p[x_a][122] = {  0}; //   1
  c_f[x_a][122] = { 62,  63}; //   2
  c_t[x_a][122] = {147, 148,  82}; //   3
  c_d[x_a][122] = {  0}; //   1

  c_p[x_a][123] = {  0}; //   1
  c_f[x_a][123] = { 60,  61}; //   2
  c_t[x_a][123] = {145, 146, 104}; //   3
  c_d[x_a][123] = {  0}; //   1

  c_p[x_a][124] = {  0}; //   1
  c_f[x_a][124] = { 64,  65}; //   2
  c_t[x_a][124] = {149, 150, 128}; //   3
  c_d[x_a][124] = {  0}; //   1

  c_p[x_a][125] = {  0}; //   1
  c_f[x_a][125] = { 64,  65}; //   2
  c_t[x_a][125] = {149, 150, 144}; //   3
  c_d[x_a][125] = {  0}; //   1

  c_p[x_a][126] = {  0}; //   1
  c_f[x_a][126] = { 11,  12}; //   2
  c_t[x_a][126] = {  0,  14, 151}; //   3
  c_d[x_a][126] = {  0}; //   1

  c_p[x_a][127] = {  0}; //   1
  c_f[x_a][127] = { 28,  29}; //   2
  c_t[x_a][127] = {  0,  43, 152}; //   3
  c_d[x_a][127] = {  0}; //   1

  c_p[x_a][128] = {  0}; //   1
  c_f[x_a][128] = { 42,  43}; //   2
  c_t[x_a][128] = { 61,  69, 153}; //   3
  c_d[x_a][128] = {  0}; //   1

  c_p[x_a][129] = {  0}; //   1
  c_f[x_a][129] = { 42,  53}; //   2
  c_t[x_a][129] = { 83,  91, 154}; //   3
  c_d[x_a][129] = {  0}; //   1

  c_p[x_a][130] = {  0}; //   1
  c_f[x_a][130] = { 28,  56}; //   2
  c_t[x_a][130] = { 83, 112, 155}; //   3
  c_d[x_a][130] = {  0}; //   1

  c_p[x_a][131] = {  0}; //   1
  c_f[x_a][131] = { 11,  59}; //   2
  c_t[x_a][131] = { 61, 133, 156}; //   3
  c_d[x_a][131] = {  0}; //   1

  c_p[x_a][132] = {  0}; //   1
  c_f[x_a][132] = { 11,  12}; //   2
  c_t[x_a][132] = {  0,  14,  15}; //   3
  c_d[x_a][132] = {  0}; //   1

  c_p[x_a][133] = {  0}; //   1
  c_f[x_a][133] = { 28,  29}; //   2
  c_t[x_a][133] = {  0,  43,  44}; //   3
  c_d[x_a][133] = {  0}; //   1

  c_p[x_a][134] = {  0}; //   1
  c_f[x_a][134] = { 42,  43}; //   2
  c_t[x_a][134] = { 61,  69,  70}; //   3
  c_d[x_a][134] = {  0}; //   1

  c_p[x_a][135] = {  0}; //   1
  c_f[x_a][135] = { 42,  53}; //   2
  c_t[x_a][135] = { 83,  91,  92}; //   3
  c_d[x_a][135] = {  0}; //   1

  c_p[x_a][136] = {  0}; //   1
  c_f[x_a][136] = { 28,  56}; //   2
  c_t[x_a][136] = { 83, 112, 113}; //   3
  c_d[x_a][136] = {  0}; //   1

  c_p[x_a][137] = {  0}; //   1
  c_f[x_a][137] = { 11,  59}; //   2
  c_t[x_a][137] = { 61, 133, 134}; //   3
  c_d[x_a][137] = {  0}; //   1

  c_p[x_a][138] = {  0}; //   1
  c_f[x_a][138] = { 64,  65}; //   2
  c_t[x_a][138] = {  0, 157, 158}; //   3
  c_d[x_a][138] = {  0}; //   1

  c_p[x_a][139] = {  0}; //   1
  c_f[x_a][139] = { 64,  65}; //   2
  c_t[x_a][139] = {  0, 157, 159}; //   3
  c_d[x_a][139] = {  0}; //   1

  c_p[x_a][140] = {  0}; //   1
  c_f[x_a][140] = { 60,  61}; //   2
  c_t[x_a][140] = { 61, 160, 161}; //   3
  c_d[x_a][140] = {  0}; //   1

  c_p[x_a][141] = {  0}; //   1
  c_f[x_a][141] = { 62,  63}; //   2
  c_t[x_a][141] = { 83, 162, 163}; //   3
  c_d[x_a][141] = {  0}; //   1

  c_p[x_a][142] = {  0}; //   1
  c_f[x_a][142] = { 62,  63}; //   2
  c_t[x_a][142] = { 83, 162, 164}; //   3
  c_d[x_a][142] = {  0}; //   1

  c_p[x_a][143] = {  0}; //   1
  c_f[x_a][143] = { 60,  61}; //   2
  c_t[x_a][143] = { 61, 160, 165}; //   3
  c_d[x_a][143] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 11111(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel    1: 11111(1, 2, 4, 8, 16, 64, 32;   0,   0,   0,   0)
// channel    2: 11111(1, 2, 4, 8, 64, 16, 32;   0,   0,   0,   0)
// channel    3: 11111(1, 2, 4, 64, 8, 16, 32;   0,   0,   0,   0)
// channel    4: 11111(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel    5: 11111(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
// channel    6: 11111(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel    7: 11111(1, 2, 4, 8, 64, 32, 16;   0,   0,   0,   0)
// channel    8: 11111(1, 2, 4, 64, 8, 32, 16;   0,   0,   0,   0)
// channel    9: 11111(1, 2, 64, 4, 8, 32, 16;   0,   0,   0,   0)
// channel   10: 11111(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
// channel   11: 11111(1, 2, 4, 32, 8, 64, 16;   0,   0,   0,   0)
// channel   12: 11111(1, 2, 4, 32, 64, 8, 16;   0,   0,   0,   0)
// channel   13: 11111(1, 2, 4, 64, 32, 8, 16;   0,   0,   0,   0)
// channel   14: 11111(1, 2, 64, 4, 32, 8, 16;   0,   0,   0,   0)
// channel   15: 11111(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   16: 11111(1, 2, 32, 4, 8, 64, 16;   0,   0,   0,   0)
// channel   17: 11111(1, 2, 32, 4, 64, 8, 16;   0,   0,   0,   0)
// channel   18: 11111(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   19: 11111(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
// channel   20: 11111(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
// channel   21: 11111(1, 2, 4, 16, 8, 64, 32;   0,   0,   0,   0)
// channel   22: 11111(1, 2, 4, 16, 64, 8, 32;   0,   0,   0,   0)
// channel   23: 11111(1, 2, 4, 64, 16, 8, 32;   0,   0,   0,   0)
// channel   24: 11111(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
// channel   25: 11111(1, 2, 4, 16, 32, 8, 64;   0,   0,   0,   0)
// channel   26: 11111(1, 2, 4, 16, 32, 64, 8;   0,   0,   0,   0)
// channel   27: 11111(1, 2, 4, 16, 64, 32, 8;   0,   0,   0,   0)
// channel   28: 11111(1, 2, 4, 64, 16, 32, 8;   0,   0,   0,   0)
// channel   29: 11111(1, 2, 64, 4, 16, 32, 8;   0,   0,   0,   0)
// channel   30: 11111(1, 2, 4, 32, 16, 8, 64;   0,   0,   0,   0)
// channel   31: 11111(1, 2, 4, 32, 16, 64, 8;   0,   0,   0,   0)
// channel   32: 11111(1, 2, 4, 32, 64, 16, 8;   0,   0,   0,   0)
// channel   33: 11111(1, 2, 4, 64, 32, 16, 8;   0,   0,   0,   0)
// channel   34: 11111(1, 2, 64, 4, 32, 16, 8;   0,   0,   0,   0)
// channel   35: 11111(1, 2, 32, 4, 16, 8, 64;   0,   0,   0,   0)
// channel   36: 11111(1, 2, 32, 4, 16, 64, 8;   0,   0,   0,   0)
// channel   37: 11111(1, 2, 32, 4, 64, 16, 8;   0,   0,   0,   0)
// channel   38: 11111(1, 2, 32, 64, 4, 16, 8;   0,   0,   0,   0)
// channel   39: 11111(1, 2, 64, 32, 4, 16, 8;   0,   0,   0,   0)
// channel   40: 11111(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel   41: 11111(1, 2, 16, 4, 8, 64, 32;   0,   0,   0,   0)
// channel   42: 11111(1, 2, 16, 4, 64, 8, 32;   0,   0,   0,   0)
// channel   43: 11111(1, 2, 16, 64, 4, 8, 32;   0,   0,   0,   0)
// channel   44: 11111(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
// channel   45: 11111(1, 2, 16, 4, 32, 8, 64;   0,   0,   0,   0)
// channel   46: 11111(1, 2, 16, 4, 32, 64, 8;   0,   0,   0,   0)
// channel   47: 11111(1, 2, 16, 4, 64, 32, 8;   0,   0,   0,   0)
// channel   48: 11111(1, 2, 16, 64, 4, 32, 8;   0,   0,   0,   0)
// channel   49: 11111(1, 2, 64, 16, 4, 32, 8;   0,   0,   0,   0)
// channel   50: 11111(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel   51: 11111(1, 2, 16, 32, 4, 64, 8;   0,   0,   0,   0)
// channel   52: 11111(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   53: 11111(1, 2, 16, 64, 32, 4, 8;   0,   0,   0,   0)
// channel   54: 11111(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
// channel   55: 11111(1, 2, 32, 16, 4, 8, 64;   0,   0,   0,   0)
// channel   56: 11111(1, 2, 32, 16, 4, 64, 8;   0,   0,   0,   0)
// channel   57: 11111(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   58: 11111(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel   59: 11111(1, 2, 64, 32, 16, 4, 8;   0,   0,   0,   0)
// channel   60: 11111(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel   61: 11111(1, 2, 8, 4, 16, 64, 32;   0,   0,   0,   0)
// channel   62: 11111(1, 2, 8, 4, 64, 16, 32;   0,   0,   0,   0)
// channel   63: 11111(1, 2, 8, 64, 4, 16, 32;   0,   0,   0,   0)
// channel   64: 11111(1, 2, 64, 8, 4, 16, 32;   0,   0,   0,   0)
// channel   65: 11111(1, 2, 8, 4, 32, 16, 64;   0,   0,   0,   0)
// channel   66: 11111(1, 2, 8, 4, 32, 64, 16;   0,   0,   0,   0)
// channel   67: 11111(1, 2, 8, 4, 64, 32, 16;   0,   0,   0,   0)
// channel   68: 11111(1, 2, 8, 64, 4, 32, 16;   0,   0,   0,   0)
// channel   69: 11111(1, 2, 64, 8, 4, 32, 16;   0,   0,   0,   0)
// channel   70: 11111(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
// channel   71: 11111(1, 2, 8, 32, 4, 64, 16;   0,   0,   0,   0)
// channel   72: 11111(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
// channel   73: 11111(1, 2, 8, 64, 32, 4, 16;   0,   0,   0,   0)
// channel   74: 11111(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
// channel   75: 11111(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
// channel   76: 11111(1, 2, 32, 8, 4, 64, 16;   0,   0,   0,   0)
// channel   77: 11111(1, 2, 32, 8, 64, 4, 16;   0,   0,   0,   0)
// channel   78: 11111(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   79: 11111(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
// channel   80: 11111(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
// channel   81: 11111(1, 2, 8, 16, 4, 64, 32;   0,   0,   0,   0)
// channel   82: 11111(1, 2, 8, 16, 64, 4, 32;   0,   0,   0,   0)
// channel   83: 11111(1, 2, 8, 64, 16, 4, 32;   0,   0,   0,   0)
// channel   84: 11111(1, 2, 64, 8, 16, 4, 32;   0,   0,   0,   0)
// channel   85: 11111(1, 2, 8, 16, 32, 4, 64;   0,   0,   0,   0)
// channel   86: 11111(1, 2, 8, 16, 32, 64, 4;   0,   0,   0,   0)
// channel   87: 11111(1, 2, 8, 16, 64, 32, 4;   0,   0,   0,   0)
// channel   88: 11111(1, 2, 8, 64, 16, 32, 4;   0,   0,   0,   0)
// channel   89: 11111(1, 2, 64, 8, 16, 32, 4;   0,   0,   0,   0)
// channel   90: 11111(1, 2, 8, 32, 16, 4, 64;   0,   0,   0,   0)
// channel   91: 11111(1, 2, 8, 32, 16, 64, 4;   0,   0,   0,   0)
// channel   92: 11111(1, 2, 8, 32, 64, 16, 4;   0,   0,   0,   0)
// channel   93: 11111(1, 2, 8, 64, 32, 16, 4;   0,   0,   0,   0)
// channel   94: 11111(1, 2, 64, 8, 32, 16, 4;   0,   0,   0,   0)
// channel   95: 11111(1, 2, 32, 8, 16, 4, 64;   0,   0,   0,   0)
// channel   96: 11111(1, 2, 32, 8, 16, 64, 4;   0,   0,   0,   0)
// channel   97: 11111(1, 2, 32, 8, 64, 16, 4;   0,   0,   0,   0)
// channel   98: 11111(1, 2, 32, 64, 8, 16, 4;   0,   0,   0,   0)
// channel   99: 11111(1, 2, 64, 32, 8, 16, 4;   0,   0,   0,   0)
// channel  100: 11111(1, 2, 16, 8, 4, 32, 64;   0,   0,   0,   0)
// channel  101: 11111(1, 2, 16, 8, 4, 64, 32;   0,   0,   0,   0)
// channel  102: 11111(1, 2, 16, 8, 64, 4, 32;   0,   0,   0,   0)
// channel  103: 11111(1, 2, 16, 64, 8, 4, 32;   0,   0,   0,   0)
// channel  104: 11111(1, 2, 64, 16, 8, 4, 32;   0,   0,   0,   0)
// channel  105: 11111(1, 2, 16, 8, 32, 4, 64;   0,   0,   0,   0)
// channel  106: 11111(1, 2, 16, 8, 32, 64, 4;   0,   0,   0,   0)
// channel  107: 11111(1, 2, 16, 8, 64, 32, 4;   0,   0,   0,   0)
// channel  108: 11111(1, 2, 16, 64, 8, 32, 4;   0,   0,   0,   0)
// channel  109: 11111(1, 2, 64, 16, 8, 32, 4;   0,   0,   0,   0)
// channel  110: 11111(1, 2, 16, 32, 8, 4, 64;   0,   0,   0,   0)
// channel  111: 11111(1, 2, 16, 32, 8, 64, 4;   0,   0,   0,   0)
// channel  112: 11111(1, 2, 16, 32, 64, 8, 4;   0,   0,   0,   0)
// channel  113: 11111(1, 2, 16, 64, 32, 8, 4;   0,   0,   0,   0)
// channel  114: 11111(1, 2, 64, 16, 32, 8, 4;   0,   0,   0,   0)
// channel  115: 11111(1, 2, 32, 16, 8, 4, 64;   0,   0,   0,   0)
// channel  116: 11111(1, 2, 32, 16, 8, 64, 4;   0,   0,   0,   0)
// channel  117: 11111(1, 2, 32, 16, 64, 8, 4;   0,   0,   0,   0)
// channel  118: 11111(1, 2, 32, 64, 16, 8, 4;   0,   0,   0,   0)
// channel  119: 11111(1, 2, 64, 32, 16, 8, 4;   0,   0,   0,   0)
// channel  120: 2v111(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel  121: 2v111(1, 2, 32, 64, 4, 16, 8;   0,   0,   0,   0)
// channel  122: 2v111(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel  123: 2v111(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel  124: 2v111(1, 2, 32, 64, 8, 16, 4;   0,   0,   0,   0)
// channel  125: 2v111(1, 2, 32, 64, 16, 8, 4;   0,   0,   0,   0)
// channel  126: 12v11(1, 2, 4, 32, 64, 8, 16;   0,   0,   0,   0)
// channel  127: 12v11(1, 2, 4, 32, 64, 16, 8;   0,   0,   0,   0)
// channel  128: 12v11(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel  129: 12v11(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
// channel  130: 12v11(1, 2, 8, 32, 64, 16, 4;   0,   0,   0,   0)
// channel  131: 12v11(1, 2, 16, 32, 64, 8, 4;   0,   0,   0,   0)
// channel  132: 112v1(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel  133: 112v1(1, 2, 4, 16, 32, 64, 8;   0,   0,   0,   0)
// channel  134: 112v1(1, 2, 16, 4, 32, 64, 8;   0,   0,   0,   0)
// channel  135: 112v1(1, 2, 8, 4, 32, 64, 16;   0,   0,   0,   0)
// channel  136: 112v1(1, 2, 8, 16, 32, 64, 4;   0,   0,   0,   0)
// channel  137: 112v1(1, 2, 16, 8, 32, 64, 4;   0,   0,   0,   0)
// channel  138: 1112v(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel  139: 1112v(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
// channel  140: 1112v(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel  141: 1112v(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel  142: 1112v(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
// channel  143: 1112v(1, 2, 16, 8, 4, 32, 64;   0,   0,   0,   0)
