#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ax_psp_040_dxa_aaadx(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_040_dxa_aaadx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(15);
  needed_v_smin[x_a].resize(15);
  needed_v_smin[x_a][  0] = {   6,    9,   12,   15,   18,   21}; //   6
  needed_v_smin[x_a][  1] = {   6,   12,   18}; //   3
  needed_v_smin[x_a][  2] = {   7,    8,   13,   14,   19,   20}; //   6
  needed_v_smin[x_a][  3] = {   7,   13,   19}; //   3
  needed_v_smin[x_a][  4] = {   8,   14,   20}; //   3
  needed_v_smin[x_a][  5] = {   9,   15,   21}; //   3
  needed_v_smin[x_a][  6] = {  10,   11,   16,   17,   22,   23}; //   6
  needed_v_smin[x_a][  7] = {  10,   16,   22}; //   3
  needed_v_smin[x_a][  8] = {  11,   17,   23}; //   3
  needed_v_smin[x_a][  9] = {   0,    1}; //   2
  needed_v_smin[x_a][ 10] = {   0,    1}; //   2
  needed_v_smin[x_a][ 11] = {   2,    5}; //   2
  needed_v_smin[x_a][ 12] = {   2,    5}; //   2
  needed_v_smin[x_a][ 13] = {   3,    4}; //   2
  needed_v_smin[x_a][ 14] = {   3,    4}; //   2

  v_smax[x_a].resize(9);
  needed_v_smax[x_a].resize(9);
  needed_v_smax[x_a][  0] = {   6,    9,   12,   15,   18,   21}; //   6
  needed_v_smax[x_a][  1] = {   6,    7,   12,   13,    0,    1,   18,   19}; //   8
  needed_v_smax[x_a][  2] = {   7,    8,   13,   14,   19,   20}; //   6
  needed_v_smax[x_a][  3] = {   8,   11,   14,   17,    2,    5,   20,   23}; //   8
  needed_v_smax[x_a][  4] = {   9,   10,   15,   16,    3,    4,   21,   22}; //   8
  needed_v_smax[x_a][  5] = {  10,   11,   16,   17,   22,   23}; //   6
  needed_v_smax[x_a][  6] = {   0,    1}; //   2
  needed_v_smax[x_a][  7] = {   2,    5}; //   2
  needed_v_smax[x_a][  8] = {   3,    4}; //   2

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   6,    9,   12,   15,   18,   21}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   6,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   7,    8,   13,   14,   19,   20}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   7,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax1");
  needed_g_p[x_a][4] = {   8,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][5] = {   9,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {  10,   11,   16,   17,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {  10,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax4");
  needed_g_p[x_a][8] = {  11,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax3");

  g_f[x_a].resize(12);
  needed_g_f[x_a].resize(12);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax6");
  needed_g_f[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax1");
  needed_g_f[x_a][2] = {   2,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax7");
  needed_g_f[x_a][3] = {   2,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax3");
  needed_g_f[x_a][4] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax8");
  needed_g_f[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax4");
  needed_g_f[x_a][6] = {  18}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {  19}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax1");
  needed_g_f[x_a][8] = {  20}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax3");
  needed_g_f[x_a][9] = {  21}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][10] = {  22}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax4");
  needed_g_f[x_a][11] = {  23}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax3");

  g_t[x_a].resize(18);
  needed_g_t[x_a].resize(18);
  needed_g_t[x_a][0] = {   0,    1,   12,   13,   18,   19}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__16_8");
  needed_g_t[x_a][4] = {   2,    5,   14,   17,   20,   23}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][5] = {   2,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__4_8");
  needed_g_t[x_a][7] = {   3,    4,   15,   16,   21,   22}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][8] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__16_4");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__8_4");
  needed_g_t[x_a][12] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__48_8");
  needed_g_t[x_a][13] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__40_16");
  needed_g_t[x_a][14] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__40_4");
  needed_g_t[x_a][15] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__48_4");
  needed_g_t[x_a][16] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__36_16");
  needed_g_t[x_a][17] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__36_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__36_8");

  g_d[x_a].resize(12);
  needed_g_d[x_a].resize(12);
  needed_g_d[x_a][0] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   6,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   6,    9,   12,   15,   18,   21}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   7,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][4] = {   7,    8,   13,   14,   19,   20}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][5] = {   8,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][6] = {   8,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][7] = {   9,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {   9,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][9] = {  10,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][10] = {  10,   11,   16,   17,   22,   23}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][11] = {  11,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  0,   1,   3}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  4,   5,   6}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  4,   5}; //   2
  c_t[x_a][3] = {  7,   8,   9}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  4,   5}; //   2
  c_t[x_a][4] = {  7,   8,  10}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  2,   3}; //   2
  c_t[x_a][5] = {  4,   5,  11}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {  0,   1}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   1,   2}; //   3

  c_p[x_a][7] = {  2,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,   3,   4}; //   3

  c_p[x_a][8] = {  2,   4}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  5,   6,   4}; //   3

  c_p[x_a][9] = {  0,   5}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  7,   8,   2}; //   3

  c_p[x_a][10] = {  6,   7}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  7,   9,  10}; //   3

  c_p[x_a][11] = {  6,   8}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,  11,  10}; //   3

  c_p[x_a][12] = {  0,   1}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  1,   2}; //   2

  c_p[x_a][13] = {  2,   3}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  3,   4}; //   2

  c_p[x_a][14] = {  2,   4}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  4}; //   1
  c_d[x_a][14] = {  6,   4}; //   2

  c_p[x_a][15] = {  0,   5}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  7}; //   1
  c_d[x_a][15] = {  8,   2}; //   2

  c_p[x_a][16] = {  6,   7}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  7}; //   1
  c_d[x_a][16] = {  9,  10}; //   2

  c_p[x_a][17] = {  6,   8}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  4}; //   1
  c_d[x_a][17] = { 11,  10}; //   2

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  6}; //   1
  c_t[x_a][18] = {  0,  12}; //   2
  c_d[x_a][18] = {  2}; //   1

  c_p[x_a][19] = {  2}; //   1
  c_f[x_a][19] = {  7}; //   1
  c_t[x_a][19] = {  0,  13}; //   2
  c_d[x_a][19] = {  4}; //   1

  c_p[x_a][20] = {  2}; //   1
  c_f[x_a][20] = {  8}; //   1
  c_t[x_a][20] = {  4,  14}; //   2
  c_d[x_a][20] = {  4}; //   1

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = {  9}; //   1
  c_t[x_a][21] = {  7,  15}; //   2
  c_d[x_a][21] = {  2}; //   1

  c_p[x_a][22] = {  6}; //   1
  c_f[x_a][22] = { 10}; //   1
  c_t[x_a][22] = {  7,  16}; //   2
  c_d[x_a][22] = { 10}; //   1

  c_p[x_a][23] = {  6}; //   1
  c_f[x_a][23] = { 11}; //   1
  c_t[x_a][23] = {  4,  17}; //   2
  c_d[x_a][23] = { 10}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    1: 1111(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel    2: 1111(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel    3: 1111(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel    4: 1111(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel    5: 1111(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel    6: 4yyv(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    7: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel    8: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel    9: 4yyv(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   10: 4yyv(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   11: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   12: 13yv(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   13: 13yv(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   14: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   15: 13yv(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   16: 13yv(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   17: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   18: 112v(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   19: 112v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   20: 112v(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   21: 112v(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   22: 112v(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   23: 112v(1, 2, 16, 8, 4, 32;   0,   0,   0)
