#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ax_psp_130_gux_aaaux(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_130_gux_aaaux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(15);
  needed_v_smin[x_a].resize(15);
  needed_v_smin[x_a][  0] = {   6,    7,   14,   15,   22,   23}; //   6
  needed_v_smin[x_a][  1] = {   8,   11,   13,   16,   18,   21}; //   6
  needed_v_smin[x_a][  2] = {   9,   10,   12,   17,   19,   20}; //   6
  needed_v_smin[x_a][  3] = {  12,   20,    9}; //   3
  needed_v_smin[x_a][  4] = {  13,   21,    8}; //   3
  needed_v_smin[x_a][  5] = {  14,   22,    7}; //   3
  needed_v_smin[x_a][  6] = {  15,   23,    6}; //   3
  needed_v_smin[x_a][  7] = {  16,   18,   11}; //   3
  needed_v_smin[x_a][  8] = {  17,   19,   10}; //   3
  needed_v_smin[x_a][  9] = {   0,    3}; //   2
  needed_v_smin[x_a][ 10] = {   0,    3}; //   2
  needed_v_smin[x_a][ 11] = {   1,    2}; //   2
  needed_v_smin[x_a][ 12] = {   1,    2}; //   2
  needed_v_smin[x_a][ 13] = {   4,    5}; //   2
  needed_v_smin[x_a][ 14] = {   4,    5}; //   2

  v_smax[x_a].resize(10);
  needed_v_smax[x_a].resize(10);
  needed_v_smax[x_a][  0] = {   6,    7,   14,   15,   22,   23}; //   6
  needed_v_smax[x_a][  1] = {   8,   11,   13,   16,   18,   21}; //   6
  needed_v_smax[x_a][  2] = {   9,   10,   12,   17,   19,   20}; //   6
  needed_v_smax[x_a][  3] = {  12,   15,   20,   23,    6,    9}; //   6
  needed_v_smax[x_a][  4] = {  13,   14,   21,   22,    7,    8}; //   6
  needed_v_smax[x_a][  5] = {  16,   17,   18,   19,   10,   11}; //   6
  needed_v_smax[x_a][  6] = {   0,    3}; //   2
  needed_v_smax[x_a][  7] = {   0,    1,    2,    3,    4,    5}; //   6
  needed_v_smax[x_a][  8] = {   1,    2}; //   2
  needed_v_smax[x_a][  9] = {   4,    5}; //   2

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   6,    7,   14,   15,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   8,   11,   13,   16,   18,   21}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   9,   10,   12,   17,   19,   20}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {  12,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  13,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {  14,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {  15,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax3");
  needed_g_p[x_a][7] = {  16,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {  17,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax5");

  g_f[x_a].resize(12);
  needed_g_f[x_a].resize(12);
  needed_g_f[x_a][0] = {   0,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax6");
  needed_g_f[x_a][1] = {   0,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax7");
  needed_g_f[x_a][2] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax7");
  needed_g_f[x_a][4] = {   4,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax9");
  needed_g_f[x_a][5] = {   4,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax7");
  needed_g_f[x_a][6] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax3");
  needed_g_f[x_a][7] = {   7}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][8] = {   8}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][9] = {   9}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][10] = {  10}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][11] = {  11}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");

  g_t[x_a].resize(19);
  needed_g_t[x_a].resize(19);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][1] = {   0,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__4_8");
  needed_g_t[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_20");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__4_16");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__16_4");
  needed_g_t[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__8_4");
  needed_g_t[x_a][7] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_24");
  needed_g_t[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__8_16");
  needed_g_t[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__16_8");
  needed_g_t[x_a][10] = {   6,    9,   12,   15}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][11] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__36_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__36_8");
  needed_g_t[x_a][12] = {   7,    8,   13,   14}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][13] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__36_16");
  needed_g_t[x_a][14] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][15] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__40_4");
  needed_g_t[x_a][16] = {  10,   11,   16,   17}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][17] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__40_16");
  needed_g_t[x_a][18] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_8");

  g_d[x_a].resize(12);
  needed_g_d[x_a].resize(12);
  needed_g_d[x_a][0] = {   6,    7,   14,   15,   22,   23}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {   8,   11,   13,   16,   18,   21}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {   9,   10,   12,   17,   19,   20}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {  12,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][4] = {  13,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][5] = {  14,   22}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][6] = {  15,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][7] = {  16,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][8] = {  17,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][9] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][10] = {  20,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][11] = {  21,   22}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  0,   3,   5}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0,   1}; //   2
  c_t[x_a][3] = {  0,   1,   6}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  4,   5}; //   2
  c_t[x_a][4] = {  0,   7,   8}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  4,   5}; //   2
  c_t[x_a][5] = {  0,   7,   9}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  6}; //   1
  c_t[x_a][6] = { 10,  11}; //   2
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = {  7}; //   1
  c_t[x_a][7] = { 12,  13}; //   2
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  1}; //   1
  c_f[x_a][8] = {  8}; //   1
  c_t[x_a][8] = { 12,  14}; //   2
  c_d[x_a][8] = {  1}; //   1

  c_p[x_a][9] = {  2}; //   1
  c_f[x_a][9] = {  9}; //   1
  c_t[x_a][9] = { 10,  15}; //   2
  c_d[x_a][9] = {  2}; //   1

  c_p[x_a][10] = {  2}; //   1
  c_f[x_a][10] = { 10}; //   1
  c_t[x_a][10] = { 16,  17}; //   2
  c_d[x_a][10] = {  2}; //   1

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = { 11}; //   1
  c_t[x_a][11] = { 16,  18}; //   2
  c_d[x_a][11] = {  1}; //   1

  c_p[x_a][12] = {  2,   3}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 10}; //   1
  c_d[x_a][12] = {  3,   2}; //   2

  c_p[x_a][13] = {  1,   4}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 12}; //   1
  c_d[x_a][13] = {  4,   1}; //   2

  c_p[x_a][14] = {  0,   5}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 12}; //   1
  c_d[x_a][14] = {  5,   0}; //   2

  c_p[x_a][15] = {  0,   6}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 10}; //   1
  c_d[x_a][15] = {  6,   0}; //   2

  c_p[x_a][16] = {  1,   7}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 16}; //   1
  c_d[x_a][16] = {  7,   1}; //   2

  c_p[x_a][17] = {  2,   8}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 16}; //   1
  c_d[x_a][17] = {  8,   2}; //   2

  c_p[x_a][18] = {  1,   7}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  9,   7,   1}; //   3

  c_p[x_a][19] = {  2,   8}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  9,   8,   2}; //   3

  c_p[x_a][20] = {  2,   3}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 10,   3,   2}; //   3

  c_p[x_a][21] = {  1,   4}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 11,   4,   1}; //   3

  c_p[x_a][22] = {  0,   5}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 11,   5,   0}; //   3

  c_p[x_a][23] = {  0,   6}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 10,   6,   0}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    1: 1111(1, 2, 32, 4, 16, 8;   0,   0,   0)
// channel    2: 1111(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel    3: 1111(1, 2, 32, 8, 4, 16;   0,   0,   0)
// channel    4: 1111(1, 2, 32, 8, 16, 4;   0,   0,   0)
// channel    5: 1111(1, 2, 32, 16, 8, 4;   0,   0,   0)
// channel    6: 2v11(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel    7: 2v11(1, 2, 4, 32, 16, 8;   0,   0,   0)
// channel    8: 2v11(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    9: 2v11(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel   10: 2v11(1, 2, 8, 32, 16, 4;   0,   0,   0)
// channel   11: 2v11(1, 2, 16, 32, 8, 4;   0,   0,   0)
// channel   12: 3yv1(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel   13: 3yv1(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel   14: 3yv1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   15: 3yv1(1, 2, 8, 4, 32, 16;   0,   0,   0)
// channel   16: 3yv1(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel   17: 3yv1(1, 2, 16, 8, 32, 4;   0,   0,   0)
// channel   18: 4yyv(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   19: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   20: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   21: 4yyv(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   22: 4yyv(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   23: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
void ppaaa03_phasespace_set::ax_psp_330_gux_aaaux(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_330_gux_aaaux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(18);
  needed_v_smin[x_a].resize(18);
  int needed_v_smin_0[] = {  30,   31,   32,   33,   46,   47,   48,   49,   56,   57,   64,   65,   77,   78,   96,   97,   10,   11,   25,   26}; //  20
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 20);
  int needed_v_smin_1[] = {  34,   35,   36,   37,   50,   51,   52,   53,   58,   59,   67,   68,   80,   81,   98,   99,   15,   16,   20,   21}; //  20
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 20);
  int needed_v_smin_2[] = {  38,   39,   40,   41,   42,   43,   44,   45,   54,   55,   60,   61,   73,   74,  100,  101,    0,    1,    5,    6}; //  20
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 20);
  int needed_v_smin_3[] = {  42,   43,   44,   45,   54,   55,   73,   74,   38,   39}; //  10
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 10);
  int needed_v_smin_4[] = {  46,   47,   48,   49,   56,   57,   77,   78,   30,   31}; //  10
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 10);
  int needed_v_smin_5[] = {  50,   51,   52,   53,   58,   59,   80,   81,   34,   35}; //  10
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 10);
  int needed_v_smin_6[] = {  62,   71,   75,   76,   86,   87,   88,   89,   98,   99,    2,    3,    4,   27,   28,   29}; //  16
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 16);
  int needed_v_smin_7[] = {  63,   70,   72,   79,   84,   85,   90,   91,   96,   97,    7,    8,    9,   22,   23,   24}; //  16
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 16);
  int needed_v_smin_8[] = {  66,   69,   82,   83,   92,   93,   94,   95,  100,  101,   12,   13,   14,   17,   18,   19}; //  16
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 16);
  int needed_v_smin_9[] = {  72,    7,    8,    9,   63,   84,   85}; //   7
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 7);
  int needed_v_smin_10[] = {  75,    2,    3,    4,   62,   86,   87}; //   7
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 7);
  int needed_v_smin_11[] = {  76,   27,   28,   29,   71,   88,   89}; //   7
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 7);
  int needed_v_smin_12[] = {  79,   22,   23,   24,   70,   90,   91}; //   7
  needed_v_smin[x_a][ 12] = get_vector_from_array_int(needed_v_smin_12, 7);
  int needed_v_smin_13[] = {  82,   17,   18,   19,   69,   92,   93}; //   7
  needed_v_smin[x_a][ 13] = get_vector_from_array_int(needed_v_smin_13, 7);
  int needed_v_smin_14[] = {  83,   12,   13,   14,   66,   94,   95}; //   7
  needed_v_smin[x_a][ 14] = get_vector_from_array_int(needed_v_smin_14, 7);
  int needed_v_smin_15[] = {   0,    1,    5,    6,   40,   41,   60,   61}; //   8
  needed_v_smin[x_a][ 15] = get_vector_from_array_int(needed_v_smin_15, 8);
  int needed_v_smin_16[] = {  10,   11,   25,   26,   32,   33,   64,   65}; //   8
  needed_v_smin[x_a][ 16] = get_vector_from_array_int(needed_v_smin_16, 8);
  int needed_v_smin_17[] = {  15,   16,   20,   21,   36,   37,   67,   68}; //   8
  needed_v_smin[x_a][ 17] = get_vector_from_array_int(needed_v_smin_17, 8);

  v_smax[x_a].resize(13);
  needed_v_smax[x_a].resize(13);
  int needed_v_smax_0[] = {  30,   31,   32,   33,   46,   47,   48,   49,   56,   57,   64,   65,   77,   78,   10,   11,   25,   26}; //  18
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 18);
  int needed_v_smax_1[] = {  34,   35,   36,   37,   50,   51,   52,   53,   58,   59,   67,   68,   80,   81,   15,   16,   20,   21}; //  18
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 18);
  int needed_v_smax_2[] = {  38,   39,   40,   41,   42,   43,   44,   45,   54,   55,   60,   61,   73,   74,    0,    1,    5,    6}; //  18
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 18);
  int needed_v_smax_3[] = {  42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   73,   74,   77,   78,   80,   81,   30,   31,   34,   35,   38,   39}; //  30
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 30);
  int needed_v_smax_4[] = {  62,   71,   75,   76,   86,   87,   88,   89,   98,   99,    2,    3,    4,   27,   28,   29}; //  16
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 16);
  int needed_v_smax_5[] = {  63,   70,   72,   79,   84,   85,   90,   91,   96,   97,    7,    8,    9,   22,   23,   24}; //  16
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 16);
  int needed_v_smax_6[] = {  66,   69,   82,   83,   92,   93,   94,   95,  100,  101,   12,   13,   14,   17,   18,   19}; //  16
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 16);
  int needed_v_smax_7[] = {  72,   75,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   40,   41,   60,   61,   62,   63,   84,   85,   86,   87}; //  22
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 22);
  int needed_v_smax_8[] = {  76,   83,   10,   11,   12,   13,   14,   25,   26,   27,   28,   29,   32,   33,   64,   65,   66,   71,   88,   89,   94,   95}; //  22
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 22);
  int needed_v_smax_9[] = {  79,   82,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   36,   37,   67,   68,   69,   70,   90,   91,   92,   93}; //  22
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 22);
  int needed_v_smax_10[] = {  96,   97}; //   2
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 2);
  int needed_v_smax_11[] = {  98,   99}; //   2
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 2);
  int needed_v_smax_12[] = { 100,  101}; //   2
  needed_v_smax[x_a][ 12] = get_vector_from_array_int(needed_v_smax_12, 2);

  g_p[x_a].resize(27);
  needed_g_p[x_a].resize(27);
  needed_g_p[x_a][0] = {  30,   32,   46,   47,   56,   64,   77}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  31,   33,   48,   49,   57,   65,   78}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin0_smax0");
  needed_g_p[x_a][2] = {  34,   36,   50,   51,   58,   67,   80}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {  35,   37,   52,   53,   59,   68,   81}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin1_smax1");
  needed_g_p[x_a][4] = {  38,   40,   42,   43,   54,   60,   73}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][5] = {  39,   41,   44,   45,   55,   61,   74}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin2_smax2");
  needed_g_p[x_a][6] = {  42,   43,   44,   54,   55,   73,   74}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][7] = {  45}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin3_smax3");
  needed_g_p[x_a][8] = {  46,   47,   48,   56,   57,   77,   78}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][9] = {  49}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin4_smax3");
  needed_g_p[x_a][10] = {  50,   51,   52,   58,   59,   80,   81}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax3");
  needed_g_p[x_a][11] = {  53}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin5_smax3");
  needed_g_p[x_a][12] = {  62,   71,   75,   76,   86,   87,   88,   89,   98,   99}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][13] = {  63,   70,   72,   79,   84,   85,   90,   91,   96,   97}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][14] = {  66,   69,   82,   83,   92,   93,   94,   95,  100,  101}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][15] = {  72}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][16] = {  75}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][17] = {  76}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][18] = {  79}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][19] = {  82}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][20] = {  83}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax8");
  needed_g_p[x_a][21] = {  96}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax10");
  needed_g_p[x_a][22] = {  97}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin0_smax10");
  needed_g_p[x_a][23] = {  98}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax11");
  needed_g_p[x_a][24] = {  99}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin1_smax11");
  needed_g_p[x_a][25] = { 100}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax12");
  needed_g_p[x_a][26] = { 101}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin2_smax12");

  g_f[x_a].resize(18);
  needed_g_f[x_a].resize(18);
  needed_g_f[x_a][0] = {   0,    1,    5,    6}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   0,    1,    5,    6,   40,   41,   60,   61}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax7");
  needed_g_f[x_a][2] = {   2,    3,    4,   27,   28,   29}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][3] = {   2,    3,    4,   62,   86,   87}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax7");
  needed_g_f[x_a][4] = {   7,    8,    9,   22,   23,   24}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][5] = {   7,    8,    9,   63,   84,   85}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][6] = {  10,   11,   25,   26}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][7] = {  10,   11,   25,   26,   32,   33,   64,   65}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax8");
  needed_g_f[x_a][8] = {  12,   13,   14,   17,   18,   19}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax6");
  needed_g_f[x_a][9] = {  12,   13,   14,   66,   94,   95}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax8");
  needed_g_f[x_a][10] = {  15,   16,   20,   21}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][11] = {  15,   16,   20,   21,   36,   37,   67,   68}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax9");
  needed_g_f[x_a][12] = {  17,   18,   19,   69,   92,   93}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax9");
  needed_g_f[x_a][13] = {  22,   23,   24,   70,   90,   91}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax9");
  needed_g_f[x_a][14] = {  27,   28,   29,   71,   88,   89}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][15] = {  30,   31}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax3");
  needed_g_f[x_a][16] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax3");
  needed_g_f[x_a][17] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");

  g_t[x_a].resize(62);
  needed_g_t[x_a].resize(62);
  needed_g_t[x_a][0] = {   0,    2,    4,    5,    7,    9,   60,   62,   63,   72,   75,   84,   86}; //  13
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,    1,    5,    6,   60,   61}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1,    3,    6,    8,   61,   85,   87}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__4_56");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_36__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_36__5_34__8_16");
  needed_g_t[x_a][5] = {   2,    3,    4,   62}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][6] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_32");
  needed_g_t[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__32_8");
  needed_g_t[x_a][8] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__16_8");
  needed_g_t[x_a][9] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_36__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_36__5_34__16_8");
  needed_g_t[x_a][10] = {   7,    8,    9,   63}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][11] = {   7,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_32");
  needed_g_t[x_a][12] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__32_16");
  needed_g_t[x_a][13] = {  10,   12,   14,   25,   27,   29,   64,   66,   71,   76,   83,   88,   94}; //  13
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][14] = {  10,   11,   25,   26,   64,   65}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][15] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__4_8");
  needed_g_t[x_a][16] = {  11,   13,   26,   28,   65,   89,   95}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__16_44");
  needed_g_t[x_a][17] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_36__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_36__17_34__4_8");
  needed_g_t[x_a][18] = {  12,   13,   14,   66}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][19] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__4_32");
  needed_g_t[x_a][20] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][21] = {  15,   17,   19,   20,   22,   24,   67,   69,   70,   79,   82,   90,   92}; //  13
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][22] = {  15,   16,   20,   21,   67,   68}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][23] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][24] = {  16,   18,   21,   23,   68,   91,   93}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__8_52");
  needed_g_t[x_a][25] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_36__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_36__9_34__4_16");
  needed_g_t[x_a][26] = {  17,   18,   19,   69}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_36");
  needed_g_t[x_a][27] = {  17,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__4_32");
  needed_g_t[x_a][28] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__32_4");
  needed_g_t[x_a][29] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__16_4");
  needed_g_t[x_a][30] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_36__9_34__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_36__9_34__16_4");
  needed_g_t[x_a][31] = {  22,   23,   24,   70}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][32] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_32");
  needed_g_t[x_a][33] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__32_16");
  needed_g_t[x_a][34] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__8_4");
  needed_g_t[x_a][35] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_36__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_36__17_34__8_4");
  needed_g_t[x_a][36] = {  27,   28,   29,   71}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][37] = {  27,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__8_32");
  needed_g_t[x_a][38] = {  29}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][39] = {  30,   31,   34,   35,   38,   39,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][40] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][41] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_34__12_16");
  needed_g_t[x_a][42] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][43] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][44] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__20_8");
  needed_g_t[x_a][45] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_34__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_34__20_8");
  needed_g_t[x_a][46] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][47] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__20_32");
  needed_g_t[x_a][48] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__24_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__24_4");
  needed_g_t[x_a][49] = {  39}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_34__24_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_34__24_4");
  needed_g_t[x_a][50] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][51] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__24_32");
  needed_g_t[x_a][52] = {  73,   74,   77,   78,   80,   81}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][53] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__48_8");
  needed_g_t[x_a][54] = {  86,   87}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__40_16");
  needed_g_t[x_a][55] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__40_4");
  needed_g_t[x_a][56] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__48_4");
  needed_g_t[x_a][57] = {  92,   93}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__36_16");
  needed_g_t[x_a][58] = {  94,   95}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__36_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__36_8");
  needed_g_t[x_a][59] = {  96,   97}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][60] = {  98,   99}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][61] = { 100,  101}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(16);
  needed_g_d[x_a].resize(16);
  needed_g_d[x_a][0] = {  30,   31,   32,   33,   46,   47,   48,   49,   56,   57,   64,   65,   77,   78,   96,   97}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  34,   35,   36,   37,   50,   51,   52,   53,   58,   59,   67,   68,   80,   81,   98,   99}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][2] = {  38,   39,   40,   41,   42,   43,   44,   45,   54,   55,   60,   61,   73,   74,  100,  101}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  42,   43,   44,   45,   54,   55,   73,   74}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {  46,   47,   48,   49,   56,   57,   77,   78}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {  50,   51,   52,   53,   58,   59,   80,   81}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][6] = {  54,   55,   56,   57,   58,   59}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {  62,   71,   75,   76,   86,   87,   88,   89,   98,   99}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][8] = {  63,   70,   72,   79,   84,   85,   90,   91,   96,   97}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][9] = {  66,   69,   82,   83,   92,   93,   94,   95,  100,  101}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][10] = {  72}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][11] = {  75}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][12] = {  76}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][13] = {  79}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][14] = {  82}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][15] = {  83}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");

  c_p[x_a].resize(102);
  c_f[x_a].resize(102);
  c_t[x_a].resize(102);
  c_d[x_a].resize(102);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  3,   1,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  0,   5,   6}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  2,   3}; //   2
  c_t[x_a][3] = {  3,   5,   6}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  2,   3}; //   2
  c_t[x_a][4] = {  0,   5,   7}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  0,   1}; //   2
  c_t[x_a][5] = {  0,   1,   8}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  0,   1}; //   2
  c_t[x_a][6] = {  3,   1,   9}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  4,   5}; //   2
  c_t[x_a][7] = {  0,  10,  11}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  4,   5}; //   2
  c_t[x_a][8] = {  3,  10,  11}; //   3
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = {  4,   5}; //   2
  c_t[x_a][9] = {  0,  10,  12}; //   3
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = {  6,   7}; //   2
  c_t[x_a][10] = { 13,  14,  15}; //   3
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  6,   7}; //   2
  c_t[x_a][11] = { 16,  14,  17}; //   3
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {}; //   0
  c_f[x_a][12] = {  8,   9}; //   2
  c_t[x_a][12] = { 13,  18,  19}; //   3
  c_d[x_a][12] = {}; //   0

  c_p[x_a][13] = {}; //   0
  c_f[x_a][13] = {  8,   9}; //   2
  c_t[x_a][13] = { 16,  18,  19}; //   3
  c_d[x_a][13] = {}; //   0

  c_p[x_a][14] = {}; //   0
  c_f[x_a][14] = {  8,   9}; //   2
  c_t[x_a][14] = { 13,  18,  20}; //   3
  c_d[x_a][14] = {}; //   0

  c_p[x_a][15] = {}; //   0
  c_f[x_a][15] = { 10,  11}; //   2
  c_t[x_a][15] = { 21,  22,  23}; //   3
  c_d[x_a][15] = {}; //   0

  c_p[x_a][16] = {}; //   0
  c_f[x_a][16] = { 10,  11}; //   2
  c_t[x_a][16] = { 24,  22,  25}; //   3
  c_d[x_a][16] = {}; //   0

  c_p[x_a][17] = {}; //   0
  c_f[x_a][17] = {  8,  12}; //   2
  c_t[x_a][17] = { 21,  26,  27}; //   3
  c_d[x_a][17] = {}; //   0

  c_p[x_a][18] = {}; //   0
  c_f[x_a][18] = {  8,  12}; //   2
  c_t[x_a][18] = { 24,  26,  27}; //   3
  c_d[x_a][18] = {}; //   0

  c_p[x_a][19] = {}; //   0
  c_f[x_a][19] = {  8,  12}; //   2
  c_t[x_a][19] = { 21,  26,  28}; //   3
  c_d[x_a][19] = {}; //   0

  c_p[x_a][20] = {}; //   0
  c_f[x_a][20] = { 10,  11}; //   2
  c_t[x_a][20] = { 21,  22,  29}; //   3
  c_d[x_a][20] = {}; //   0

  c_p[x_a][21] = {}; //   0
  c_f[x_a][21] = { 10,  11}; //   2
  c_t[x_a][21] = { 24,  22,  30}; //   3
  c_d[x_a][21] = {}; //   0

  c_p[x_a][22] = {}; //   0
  c_f[x_a][22] = {  4,  13}; //   2
  c_t[x_a][22] = { 21,  31,  32}; //   3
  c_d[x_a][22] = {}; //   0

  c_p[x_a][23] = {}; //   0
  c_f[x_a][23] = {  4,  13}; //   2
  c_t[x_a][23] = { 24,  31,  32}; //   3
  c_d[x_a][23] = {}; //   0

  c_p[x_a][24] = {}; //   0
  c_f[x_a][24] = {  4,  13}; //   2
  c_t[x_a][24] = { 21,  31,  33}; //   3
  c_d[x_a][24] = {}; //   0

  c_p[x_a][25] = {}; //   0
  c_f[x_a][25] = {  6,   7}; //   2
  c_t[x_a][25] = { 13,  14,  34}; //   3
  c_d[x_a][25] = {}; //   0

  c_p[x_a][26] = {}; //   0
  c_f[x_a][26] = {  6,   7}; //   2
  c_t[x_a][26] = { 16,  14,  35}; //   3
  c_d[x_a][26] = {}; //   0

  c_p[x_a][27] = {}; //   0
  c_f[x_a][27] = {  2,  14}; //   2
  c_t[x_a][27] = { 13,  36,  37}; //   3
  c_d[x_a][27] = {}; //   0

  c_p[x_a][28] = {}; //   0
  c_f[x_a][28] = {  2,  14}; //   2
  c_t[x_a][28] = { 16,  36,  37}; //   3
  c_d[x_a][28] = {}; //   0

  c_p[x_a][29] = {}; //   0
  c_f[x_a][29] = {  2,  14}; //   2
  c_t[x_a][29] = { 13,  36,  38}; //   3
  c_d[x_a][29] = {}; //   0

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = { 15}; //   1
  c_t[x_a][30] = { 39,  40}; //   2
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  1}; //   1
  c_f[x_a][31] = { 15}; //   1
  c_t[x_a][31] = { 39,  41}; //   2
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  0}; //   1
  c_f[x_a][32] = {  7}; //   1
  c_t[x_a][32] = { 42,  43}; //   2
  c_d[x_a][32] = {  0}; //   1

  c_p[x_a][33] = {  1}; //   1
  c_f[x_a][33] = {  7}; //   1
  c_t[x_a][33] = { 42,  43}; //   2
  c_d[x_a][33] = {  0}; //   1

  c_p[x_a][34] = {  2}; //   1
  c_f[x_a][34] = { 16}; //   1
  c_t[x_a][34] = { 39,  44}; //   2
  c_d[x_a][34] = {  1}; //   1

  c_p[x_a][35] = {  3}; //   1
  c_f[x_a][35] = { 16}; //   1
  c_t[x_a][35] = { 39,  45}; //   2
  c_d[x_a][35] = {  1}; //   1

  c_p[x_a][36] = {  2}; //   1
  c_f[x_a][36] = { 11}; //   1
  c_t[x_a][36] = { 46,  47}; //   2
  c_d[x_a][36] = {  1}; //   1

  c_p[x_a][37] = {  3}; //   1
  c_f[x_a][37] = { 11}; //   1
  c_t[x_a][37] = { 46,  47}; //   2
  c_d[x_a][37] = {  1}; //   1

  c_p[x_a][38] = {  4}; //   1
  c_f[x_a][38] = { 17}; //   1
  c_t[x_a][38] = { 39,  48}; //   2
  c_d[x_a][38] = {  2}; //   1

  c_p[x_a][39] = {  5}; //   1
  c_f[x_a][39] = { 17}; //   1
  c_t[x_a][39] = { 39,  49}; //   2
  c_d[x_a][39] = {  2}; //   1

  c_p[x_a][40] = {  4}; //   1
  c_f[x_a][40] = {  1}; //   1
  c_t[x_a][40] = { 50,  51}; //   2
  c_d[x_a][40] = {  2}; //   1

  c_p[x_a][41] = {  5}; //   1
  c_f[x_a][41] = {  1}; //   1
  c_t[x_a][41] = { 50,  51}; //   2
  c_d[x_a][41] = {  2}; //   1

  c_p[x_a][42] = {  4,   6}; //   2
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 39}; //   1
  c_d[x_a][42] = {  3,   2}; //   2

  c_p[x_a][43] = {  4,   6}; //   2
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 39}; //   1
  c_d[x_a][43] = {  3,   2}; //   2

  c_p[x_a][44] = {  5,   6}; //   2
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 39}; //   1
  c_d[x_a][44] = {  3,   2}; //   2

  c_p[x_a][45] = {  5,   7}; //   2
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = { 39}; //   1
  c_d[x_a][45] = {  3,   2}; //   2

  c_p[x_a][46] = {  0,   8}; //   2
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 39}; //   1
  c_d[x_a][46] = {  4,   0}; //   2

  c_p[x_a][47] = {  0,   8}; //   2
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 39}; //   1
  c_d[x_a][47] = {  4,   0}; //   2

  c_p[x_a][48] = {  1,   8}; //   2
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = { 39}; //   1
  c_d[x_a][48] = {  4,   0}; //   2

  c_p[x_a][49] = {  1,   9}; //   2
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = { 39}; //   1
  c_d[x_a][49] = {  4,   0}; //   2

  c_p[x_a][50] = {  2,  10}; //   2
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = { 39}; //   1
  c_d[x_a][50] = {  5,   1}; //   2

  c_p[x_a][51] = {  2,  10}; //   2
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = { 39}; //   1
  c_d[x_a][51] = {  5,   1}; //   2

  c_p[x_a][52] = {  3,  10}; //   2
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = { 39}; //   1
  c_d[x_a][52] = {  5,   1}; //   2

  c_p[x_a][53] = {  3,  11}; //   2
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = { 39}; //   1
  c_d[x_a][53] = {  5,   1}; //   2

  c_p[x_a][54] = {  4,   6}; //   2
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {}; //   0
  c_d[x_a][54] = {  6,   3,   2}; //   3

  c_p[x_a][55] = {  5,   6}; //   2
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {}; //   0
  c_d[x_a][55] = {  6,   3,   2}; //   3

  c_p[x_a][56] = {  0,   8}; //   2
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {}; //   0
  c_d[x_a][56] = {  6,   4,   0}; //   3

  c_p[x_a][57] = {  1,   8}; //   2
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {}; //   0
  c_d[x_a][57] = {  6,   4,   0}; //   3

  c_p[x_a][58] = {  2,  10}; //   2
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {}; //   0
  c_d[x_a][58] = {  6,   5,   1}; //   3

  c_p[x_a][59] = {  3,  10}; //   2
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {}; //   0
  c_d[x_a][59] = {  6,   5,   1}; //   3

  c_p[x_a][60] = {  4}; //   1
  c_f[x_a][60] = {  1}; //   1
  c_t[x_a][60] = {  0,   1}; //   2
  c_d[x_a][60] = {  2}; //   1

  c_p[x_a][61] = {  5}; //   1
  c_f[x_a][61] = {  1}; //   1
  c_t[x_a][61] = {  3,   1}; //   2
  c_d[x_a][61] = {  2}; //   1

  c_p[x_a][62] = { 12}; //   1
  c_f[x_a][62] = {  3}; //   1
  c_t[x_a][62] = {  0,   5}; //   2
  c_d[x_a][62] = {  7}; //   1

  c_p[x_a][63] = { 13}; //   1
  c_f[x_a][63] = {  5}; //   1
  c_t[x_a][63] = {  0,  10}; //   2
  c_d[x_a][63] = {  8}; //   1

  c_p[x_a][64] = {  0}; //   1
  c_f[x_a][64] = {  7}; //   1
  c_t[x_a][64] = { 13,  14}; //   2
  c_d[x_a][64] = {  0}; //   1

  c_p[x_a][65] = {  1}; //   1
  c_f[x_a][65] = {  7}; //   1
  c_t[x_a][65] = { 16,  14}; //   2
  c_d[x_a][65] = {  0}; //   1

  c_p[x_a][66] = { 14}; //   1
  c_f[x_a][66] = {  9}; //   1
  c_t[x_a][66] = { 13,  18}; //   2
  c_d[x_a][66] = {  9}; //   1

  c_p[x_a][67] = {  2}; //   1
  c_f[x_a][67] = { 11}; //   1
  c_t[x_a][67] = { 21,  22}; //   2
  c_d[x_a][67] = {  1}; //   1

  c_p[x_a][68] = {  3}; //   1
  c_f[x_a][68] = { 11}; //   1
  c_t[x_a][68] = { 24,  22}; //   2
  c_d[x_a][68] = {  1}; //   1

  c_p[x_a][69] = { 14}; //   1
  c_f[x_a][69] = { 12}; //   1
  c_t[x_a][69] = { 21,  26}; //   2
  c_d[x_a][69] = {  9}; //   1

  c_p[x_a][70] = { 13}; //   1
  c_f[x_a][70] = { 13}; //   1
  c_t[x_a][70] = { 21,  31}; //   2
  c_d[x_a][70] = {  8}; //   1

  c_p[x_a][71] = { 12}; //   1
  c_f[x_a][71] = { 14}; //   1
  c_t[x_a][71] = { 13,  36}; //   2
  c_d[x_a][71] = {  7}; //   1

  c_p[x_a][72] = { 13,  15}; //   2
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  0}; //   1
  c_d[x_a][72] = { 10,   8}; //   2

  c_p[x_a][73] = {  4,   6}; //   2
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = { 52}; //   1
  c_d[x_a][73] = {  3,   2}; //   2

  c_p[x_a][74] = {  5,   6}; //   2
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = { 52}; //   1
  c_d[x_a][74] = {  3,   2}; //   2

  c_p[x_a][75] = { 12,  16}; //   2
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  0}; //   1
  c_d[x_a][75] = { 11,   7}; //   2

  c_p[x_a][76] = { 12,  17}; //   2
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = { 13}; //   1
  c_d[x_a][76] = { 12,   7}; //   2

  c_p[x_a][77] = {  0,   8}; //   2
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = { 52}; //   1
  c_d[x_a][77] = {  4,   0}; //   2

  c_p[x_a][78] = {  1,   8}; //   2
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = { 52}; //   1
  c_d[x_a][78] = {  4,   0}; //   2

  c_p[x_a][79] = { 13,  18}; //   2
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 21}; //   1
  c_d[x_a][79] = { 13,   8}; //   2

  c_p[x_a][80] = {  2,  10}; //   2
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = { 52}; //   1
  c_d[x_a][80] = {  5,   1}; //   2

  c_p[x_a][81] = {  3,  10}; //   2
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = { 52}; //   1
  c_d[x_a][81] = {  5,   1}; //   2

  c_p[x_a][82] = { 14,  19}; //   2
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = { 21}; //   1
  c_d[x_a][82] = { 14,   9}; //   2

  c_p[x_a][83] = { 14,  20}; //   2
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = { 13}; //   1
  c_d[x_a][83] = { 15,   9}; //   2

  c_p[x_a][84] = { 13}; //   1
  c_f[x_a][84] = {  5}; //   1
  c_t[x_a][84] = {  0,  53}; //   2
  c_d[x_a][84] = {  8}; //   1

  c_p[x_a][85] = { 13}; //   1
  c_f[x_a][85] = {  5}; //   1
  c_t[x_a][85] = {  3,  53}; //   2
  c_d[x_a][85] = {  8}; //   1

  c_p[x_a][86] = { 12}; //   1
  c_f[x_a][86] = {  3}; //   1
  c_t[x_a][86] = {  0,  54}; //   2
  c_d[x_a][86] = {  7}; //   1

  c_p[x_a][87] = { 12}; //   1
  c_f[x_a][87] = {  3}; //   1
  c_t[x_a][87] = {  3,  54}; //   2
  c_d[x_a][87] = {  7}; //   1

  c_p[x_a][88] = { 12}; //   1
  c_f[x_a][88] = { 14}; //   1
  c_t[x_a][88] = { 13,  55}; //   2
  c_d[x_a][88] = {  7}; //   1

  c_p[x_a][89] = { 12}; //   1
  c_f[x_a][89] = { 14}; //   1
  c_t[x_a][89] = { 16,  55}; //   2
  c_d[x_a][89] = {  7}; //   1

  c_p[x_a][90] = { 13}; //   1
  c_f[x_a][90] = { 13}; //   1
  c_t[x_a][90] = { 21,  56}; //   2
  c_d[x_a][90] = {  8}; //   1

  c_p[x_a][91] = { 13}; //   1
  c_f[x_a][91] = { 13}; //   1
  c_t[x_a][91] = { 24,  56}; //   2
  c_d[x_a][91] = {  8}; //   1

  c_p[x_a][92] = { 14}; //   1
  c_f[x_a][92] = { 12}; //   1
  c_t[x_a][92] = { 21,  57}; //   2
  c_d[x_a][92] = {  9}; //   1

  c_p[x_a][93] = { 14}; //   1
  c_f[x_a][93] = { 12}; //   1
  c_t[x_a][93] = { 24,  57}; //   2
  c_d[x_a][93] = {  9}; //   1

  c_p[x_a][94] = { 14}; //   1
  c_f[x_a][94] = {  9}; //   1
  c_t[x_a][94] = { 13,  58}; //   2
  c_d[x_a][94] = {  9}; //   1

  c_p[x_a][95] = { 14}; //   1
  c_f[x_a][95] = {  9}; //   1
  c_t[x_a][95] = { 16,  58}; //   2
  c_d[x_a][95] = {  9}; //   1

  c_p[x_a][96] = { 13,  21}; //   2
  c_f[x_a][96] = {}; //   0
  c_t[x_a][96] = { 59}; //   1
  c_d[x_a][96] = {  0,   8}; //   2

  c_p[x_a][97] = { 13,  22}; //   2
  c_f[x_a][97] = {}; //   0
  c_t[x_a][97] = { 59}; //   1
  c_d[x_a][97] = {  0,   8}; //   2

  c_p[x_a][98] = { 12,  23}; //   2
  c_f[x_a][98] = {}; //   0
  c_t[x_a][98] = { 60}; //   1
  c_d[x_a][98] = {  1,   7}; //   2

  c_p[x_a][99] = { 12,  24}; //   2
  c_f[x_a][99] = {}; //   0
  c_t[x_a][99] = { 60}; //   1
  c_d[x_a][99] = {  1,   7}; //   2

  c_p[x_a][100] = { 14,  25}; //   2
  c_f[x_a][100] = {}; //   0
  c_t[x_a][100] = { 61}; //   1
  c_d[x_a][100] = {  2,   9}; //   2

  c_p[x_a][101] = { 14,  26}; //   2
  c_f[x_a][101] = {}; //   0
  c_t[x_a][101] = { 61}; //   1
  c_d[x_a][101] = {  2,   9}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
