#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_105(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[2];
z[5] = iW[22];
z[6] = v[4];
z[7] = iW[4];
z[8] = v[3];
z[9] = iW[18];
z[10] = iW[8];
z[11] = v[1];
z[12] = prod_pow(z[4], 2);
z[13] = z[1] * z[12];
z[14] = (T(1) / T(2)) * z[8];
z[15] = -z[13] + z[14];
z[16] = z[1] * z[4];
z[17] = T(1) / T(2) + z[16];
z[18] = z[1] * z[6];
z[19] = z[17] + (T(-1) / T(2)) * z[18];
z[19] = z[6] * z[19];
z[15] = (T(1) / T(2)) * z[15] + z[19];
z[15] = z[6] * z[15];
z[19] = z[4] + z[8];
z[20] = (T(1) / T(2)) * z[4];
z[21] = -z[19] * z[20];
z[15] = z[15] + z[21];
z[15] = z[6] * z[15];
z[21] = z[4] * z[14];
z[22] = prod_pow(z[8], 2);
z[21] = z[21] + z[22];
z[21] = z[4] * z[21];
z[23] = prod_pow(z[8], 3);
z[21] = z[21] + (T(1) / T(2)) * z[23];
z[15] = z[15] + (T(-1) / T(2)) * z[21];
z[15] = z[5] * z[15];
z[23] = T(-121) / T(4) + -199 * z[16];
z[23] = 119 * z[18] + (T(1) / T(2)) * z[23];
z[23] = z[6] * z[23];
z[24] = 13 * z[16];
z[25] = T(-277) / T(6) + -z[24];
z[25] = z[4] * z[25];
z[25] = (T(-199) / T(6)) * z[8] + z[25];
z[23] = (T(1) / T(3)) * z[23] + (T(1) / T(2)) * z[25];
z[23] = z[6] * z[23];
z[25] = (T(277) / T(6)) * z[7];
z[26] = -z[21] * z[25];
z[27] = 13 * z[8];
z[28] = (T(-433) / T(24)) * z[4] + -z[27];
z[28] = z[4] * z[28];
z[15] = (T(277) / T(6)) * z[15] + (T(121) / T(24)) * z[22] + z[23] + z[26] + z[28];
z[15] = z[5] * z[15];
z[23] = T(-1) / T(2) + z[16];
z[20] = -z[20] * z[23];
z[20] = z[8] + z[20];
z[20] = z[4] * z[20];
z[20] = z[20] + (T(1) / T(4)) * z[22];
z[26] = -1 + -z[18];
z[26] = z[6] * z[26];
z[26] = z[8] + z[26];
z[28] = T(1) / T(3) + (T(1) / T(4)) * z[16];
z[28] = z[4] * z[28];
z[26] = (T(1) / T(12)) * z[26] + z[28];
z[26] = z[6] * z[26];
z[20] = (T(1) / T(3)) * z[20] + z[26];
z[20] = z[6] * z[20];
z[26] = T(-1) / T(3) + -z[16] + (T(1) / T(3)) * z[18];
z[26] = z[6] * z[26];
z[28] = (T(1) / T(3)) * z[8];
z[13] = z[13] + z[26] + -z[28];
z[13] = z[6] * z[13];
z[26] = (T(1) / T(4)) * z[4];
z[29] = (T(1) / T(3)) * z[16];
z[30] = 1 + -z[29];
z[30] = z[26] * z[30];
z[28] = z[28] + z[30];
z[28] = z[4] * z[28];
z[13] = (T(1) / T(4)) * z[13] + (T(1) / T(12)) * z[22] + z[28];
z[13] = z[6] * z[13];
z[19] = z[12] * z[19];
z[13] = z[13] + (T(-1) / T(6)) * z[19];
z[13] = z[6] * z[13];
z[19] = z[4] * z[21];
z[13] = z[13] + (T(-1) / T(6)) * z[19];
z[13] = z[5] * z[13];
z[19] = (T(1) / T(3)) * z[4];
z[28] = -z[14] + -z[19];
z[28] = z[4] * z[28];
z[28] = (T(-1) / T(6)) * z[22] + z[28];
z[28] = z[4] * z[28];
z[21] = -z[7] * z[19] * z[21];
z[13] = z[13] + z[20] + z[21] + z[28];
z[13] = z[5] * z[13];
z[20] = z[1] * z[3];
z[21] = -z[20] + -z[23];
z[21] = z[3] * z[21];
z[28] = (T(1) / T(2)) * z[20];
z[17] = z[17] + z[28];
z[17] = z[6] * z[17];
z[23] = -z[4] * z[23];
z[17] = z[14] + z[17] + z[21] + z[23];
z[17] = z[6] * z[17];
z[21] = z[4] * z[8];
z[23] = z[21] + z[22];
z[30] = -z[4] * z[23];
z[31] = -z[3] * z[21];
z[30] = z[30] + z[31];
z[30] = z[7] * z[30];
z[17] = z[17] + z[30];
z[30] = z[8] * z[9];
z[31] = T(-5) / T(2) + z[30];
z[31] = z[28] + (T(1) / T(3)) * z[31];
z[31] = z[3] * z[31];
z[31] = -z[19] + (T(1) / T(2)) * z[31];
z[31] = z[3] * z[31];
z[19] = (T(-1) / T(4)) * z[8] + -z[19];
z[19] = z[4] * z[19];
z[13] = z[13] + (T(1) / T(6)) * z[17] + z[19] + z[31];
z[13] = z[0] * z[13];
z[17] = T(-205) / T(12) + (T(-199) / T(6)) * z[18] + -7 * z[20] + -z[24];
z[17] = z[6] * z[17];
z[19] = -z[3] + -z[8];
z[19] = z[3] * z[19];
z[19] = z[19] + -z[23];
z[19] = z[19] * z[25];
z[23] = 355 * z[1] + -277 * z[9];
z[23] = z[3] * z[23];
z[23] = T(-361) / T(2) + z[23];
z[23] = z[3] * z[23];
z[17] = (T(-505) / T(12)) * z[4] + z[17] + z[19] + (T(1) / T(6)) * z[23] + -z[27];
z[13] = (T(277) / T(2)) * z[13] + z[15] + (T(1) / T(2)) * z[17];
z[13] = z[0] * z[13];
z[15] = 1 + z[16];
z[17] = (T(199) / T(9)) * z[15] + (T(-75) / T(2)) * z[18];
z[17] = z[6] * z[17];
z[15] = -z[15] + z[18];
z[15] = prod_pow(z[6], 2) * z[5] * z[15];
z[15] = (T(277) / T(18)) * z[15] + z[17];
z[15] = z[5] * z[15];
z[17] = z[1] * z[11];
z[19] = -1 + z[16];
z[17] = z[17] + z[19];
z[23] = -z[17] + z[18];
z[23] = z[11] * z[23];
z[23] = z[4] + -z[6] + z[23];
z[23] = z[10] * z[23];
z[13] = (T(1) / T(3)) * z[13] + (T(1) / T(4)) * z[15] + z[17] + (T(163) / T(36)) * z[18] + (T(-193) / T(72)) * z[20] + z[23];
z[15] = z[9] * z[22];
z[15] = z[8] + (T(-1) / T(2)) * z[15] + -z[26];
z[17] = T(-1) / T(2) + z[29] + (T(1) / T(6)) * z[30];
z[17] = z[3] * z[17];
z[15] = (T(1) / T(3)) * z[15] + z[17];
z[17] = prod_pow(z[3], 2);
z[18] = z[0] * z[17];
z[15] = z[15] * z[18];
z[20] = T(-329) / T(16) + (T(79) / T(3)) * z[16] + (T(277) / T(24)) * z[30];
z[20] = z[17] * z[20];
z[15] = (T(277) / T(4)) * z[15] + z[20];
z[15] = z[0] * z[15];
z[20] = z[21] + -z[22];
z[21] = -1 + (T(1) / T(2)) * z[16];
z[21] = z[4] * z[21];
z[21] = z[14] + z[21];
z[21] = z[3] * z[21];
z[20] = (T(1) / T(2)) * z[20] + z[21];
z[18] = z[18] * z[20];
z[19] = z[4] * z[19];
z[14] = z[14] + z[19];
z[14] = z[14] * z[17];
z[14] = z[14] + z[18];
z[14] = z[0] * z[14];
z[12] = z[12] * z[28];
z[12] = z[12] + z[14];
z[12] = z[2] * z[12];
z[14] = z[3] * z[16];
z[12] = (T(277) / T(24)) * z[12] + (T(13) / T(4)) * z[14] + z[15];
z[12] = z[2] * z[12];
return (T(1) / T(3)) * z[12] + (T(1) / T(2)) * z[13];
}



template double eval_coef_2q3y_2l_pmmpp_12345_105(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_105(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
