#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_107(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[28];
z[0] = iW[1];
z[1] = v[0];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[2];
z[5] = iW[3];
z[6] = iW[16];
z[7] = iW[4];
z[8] = iW[19];
z[9] = iW[23];
z[10] = v[3];
z[11] = v[1];
z[12] = prod_pow(z[0], 3);
z[13] = z[2] * z[12];
z[14] = prod_pow(z[0], 2);
z[15] = z[13] + z[14];
z[16] = (T(1) / T(2)) * z[3];
z[17] = z[12] * z[16];
z[17] = -z[15] + z[17];
z[17] = z[3] * z[17];
z[18] = z[3] * z[14];
z[19] = z[2] * z[14];
z[20] = 13 * z[0] + (T(-25) / T(4)) * z[18] + 11 * z[19];
z[20] = z[3] * z[20];
z[21] = z[0] * z[2];
z[22] = z[3] * z[21];
z[23] = 11 + (T(13) / T(2)) * z[21];
z[24] = -z[2] * z[23];
z[24] = (T(19) / T(2)) * z[22] + z[24];
z[25] = (T(1) / T(3)) * z[5];
z[24] = z[24] * z[25];
z[26] = -17 * z[0] + (T(-19) / T(2)) * z[19];
z[26] = z[2] * z[26];
z[26] = T(-9) / T(2) + (T(1) / T(3)) * z[26];
z[20] = (T(1) / T(3)) * z[20] + z[24] + (T(1) / T(2)) * z[26];
z[20] = z[5] * z[20];
z[13] = z[13] + 3 * z[14];
z[24] = (T(1) / T(2)) * z[2];
z[13] = z[13] * z[24];
z[13] = z[0] + z[13] + z[17] + z[20];
z[12] = z[3] * z[12];
z[17] = z[4] * z[18];
z[12] = z[12] + -z[15] + z[17];
z[15] = -2 * z[18] + (T(11) / T(4)) * z[19];
z[17] = (T(13) / T(4)) * z[2];
z[17] = z[14] * z[17];
z[17] = 11 * z[0] + z[17];
z[20] = -z[17] + (T(19) / T(4)) * z[18];
z[20] = z[3] * z[20];
z[20] = T(25) / T(4) + z[20];
z[20] = z[5] * z[20];
z[26] = z[0] * z[3];
z[27] = -1 + z[26];
z[27] = z[4] * z[27];
z[15] = (T(1) / T(3)) * z[15] + (T(1) / T(6)) * z[20] + (T(1) / T(8)) * z[27];
z[15] = z[5] * z[15];
z[12] = (T(1) / T(8)) * z[12] + z[15];
z[12] = z[1] * z[12];
z[15] = -z[0] + z[18];
z[15] = 7 * z[15] + -25 * z[19];
z[20] = z[14] * z[16];
z[27] = -z[0] + z[20];
z[27] = z[3] * z[27];
z[27] = T(1) / T(2) + z[27];
z[27] = z[4] * z[27];
z[17] = z[17] + (T(-11) / T(2)) * z[18];
z[17] = z[3] * z[17];
z[17] = z[17] + (T(-1) / T(2)) * z[23];
z[18] = -3 * z[0] + z[18];
z[18] = z[3] * z[18];
z[18] = 3 + z[18];
z[18] = z[3] * z[18];
z[18] = -z[11] + z[18];
z[18] = z[4] * z[18];
z[17] = (T(1) / T(3)) * z[17] + (T(1) / T(4)) * z[18];
z[17] = z[5] * z[17];
z[15] = (T(1) / T(24)) * z[15] + z[17] + z[27];
z[17] = (T(1) / T(2)) * z[1];
z[15] = z[5] * z[15] * z[17];
z[18] = 17 + 11 * z[21] + -17 * z[26];
z[23] = 4 + (T(13) / T(4)) * z[21];
z[23] = z[2] * z[23];
z[22] = -4 * z[22] + z[23];
z[22] = z[5] * z[22];
z[18] = (T(1) / T(8)) * z[18] + z[22];
z[18] = z[18] * z[25];
z[15] = (T(-1) / T(8)) * z[0] + z[15] + z[18];
z[15] = z[1] * z[15];
z[18] = -z[2] * z[5];
z[18] = -1 + z[18];
z[15] = z[15] + (T(1) / T(8)) * z[18];
z[15] = z[6] * z[15];
z[18] = z[0] + z[19];
z[19] = z[10] * z[18];
z[22] = 1 + z[21];
z[23] = z[0] * z[1];
z[23] = z[19] + -z[22] + z[23];
z[23] = z[7] * z[23];
z[12] = z[12] + (T(1) / T(4)) * z[13] + z[15] + (T(1) / T(8)) * z[23];
z[12] = z[1] * z[12];
z[13] = (T(1) / T(2)) * z[10];
z[15] = z[13] * z[14];
z[23] = -z[21] + z[26];
z[25] = T(-3) / T(2) + z[23];
z[25] = z[5] * z[25];
z[15] = z[0] + z[15] + z[20] + z[25];
z[15] = z[3] * z[15];
z[20] = z[14] * z[24];
z[20] = z[0] + z[20];
z[25] = z[10] * z[20];
z[26] = -5 + -3 * z[21];
z[15] = z[15] + z[25] + (T(1) / T(2)) * z[26];
z[15] = z[15] * z[17];
z[13] = z[13] * z[18];
z[18] = -z[2] * z[20];
z[18] = T(1) / T(2) + z[13] + z[18];
z[18] = z[10] * z[18];
z[20] = z[22] * z[24];
z[18] = -z[11] + z[18] + z[20];
z[20] = -z[2] + z[3] + z[10];
z[20] = (T(1) / T(4)) * z[20];
z[14] = z[14] * z[20];
z[14] = -z[0] + z[14];
z[14] = z[3] * z[14];
z[20] = 1 + (T(1) / T(2)) * z[21];
z[14] = z[14] + (T(3) / T(2)) * z[20];
z[14] = z[3] * z[14];
z[20] = T(5) / T(2) + -z[23];
z[20] = z[3] * z[20];
z[20] = -z[2] + (T(-3) / T(2)) * z[11] + z[20];
z[16] = z[5] * z[16] * z[20];
z[14] = z[14] + z[15] + z[16] + (T(1) / T(2)) * z[18];
z[14] = z[1] * z[14];
z[15] = z[2] + z[11];
z[16] = -z[15] * z[24];
z[18] = -z[19] * z[24];
z[19] = z[2] * z[22];
z[18] = z[18] + z[19];
z[18] = z[10] * z[18];
z[13] = z[13] + -z[22];
z[13] = z[10] * z[13];
z[13] = z[13] + (T(1) / T(2)) * z[15];
z[13] = z[1] * z[13];
z[13] = z[13] + z[16] + z[18];
z[13] = z[7] * z[13] * z[17];
z[13] = z[13] + z[14];
z[13] = z[8] * z[9] * z[13];
return z[12] + (T(1) / T(2)) * z[13];
}



template double eval_coef_2q3y_2l_pmmpp_12345_107(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_107(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
