#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_108(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[36];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[20];
z[3] = v[3];
z[4] = v[4];
z[5] = v[2];
z[6] = iW[3];
z[7] = iW[21];
z[8] = iW[15];
z[9] = v[0];
z[10] = iW[24];
z[11] = v[1];
z[12] = z[1] * z[3];
z[13] = 3 * z[12];
z[14] = z[1] * z[5];
z[15] = -z[13] + z[14];
z[16] = prod_pow(z[2], 2);
z[17] = (T(1) / T(2)) * z[16];
z[18] = z[1] * z[2];
z[19] = z[17] + -z[18];
z[15] = z[15] * z[19];
z[20] = z[2] * z[8];
z[21] = -z[16] + (T(19) / T(3)) * z[20];
z[22] = z[6] * z[9];
z[23] = T(-13) / T(6) + -z[22];
z[23] = z[1] * z[23];
z[23] = (T(-11) / T(3)) * z[2] + (T(-19) / T(3)) * z[8] + -z[10] + z[23];
z[23] = z[1] * z[23];
z[15] = z[15] + -z[21] + z[23];
z[23] = (T(3) / T(2)) * z[12];
z[23] = z[19] * z[23];
z[24] = z[1] + 7 * z[2];
z[24] = z[1] * z[24];
z[24] = (T(-3) / T(4)) * z[16] + z[23] + z[24];
z[24] = z[3] * z[24];
z[25] = (T(1) / T(2)) * z[5];
z[26] = z[16] * z[25];
z[27] = -z[8] + z[26];
z[28] = (T(-19) / T(6)) * z[1] + (T(-25) / T(6)) * z[2] + z[27];
z[24] = z[24] + (T(1) / T(2)) * z[28];
z[24] = z[0] * z[24];
z[12] = z[12] * z[19];
z[18] = z[18] + -z[20];
z[18] = z[12] + (T(19) / T(6)) * z[18];
z[18] = z[0] * z[18];
z[20] = -z[1] * z[19];
z[18] = z[18] + z[20];
z[20] = (T(1) / T(2)) * z[4];
z[18] = z[18] * z[20];
z[15] = (T(1) / T(2)) * z[15] + z[18] + z[24];
z[15] = z[15] * z[20];
z[18] = -z[2] + (T(-19) / T(12)) * z[8];
z[18] = z[1] * z[18];
z[18] = z[17] + z[18];
z[18] = z[14] * z[18];
z[20] = (T(-65) / T(6)) * z[2] + -z[10];
z[20] = -z[1] + (T(-11) / T(3)) * z[8] + (T(1) / T(2)) * z[20];
z[20] = z[1] * z[20];
z[18] = z[18] + z[20] + (T(-1) / T(4)) * z[21] + -z[23];
z[20] = (T(1) / T(2)) * z[3];
z[18] = z[18] * z[20];
z[13] = z[13] * z[19];
z[19] = (T(3) / T(2)) * z[16];
z[23] = 3 * z[1] + (T(37) / T(2)) * z[2];
z[23] = z[1] * z[23];
z[13] = z[13] + -z[19] + z[23];
z[13] = z[3] * z[13];
z[23] = prod_pow(z[1], 2);
z[19] = z[19] + -z[23];
z[19] = z[5] * z[19];
z[13] = -15 * z[1] + -17 * z[2] + z[13] + z[19];
z[13] = z[3] * z[13];
z[19] = z[5] * z[16];
z[24] = (T(31) / T(3)) * z[2] + -z[8] + -z[19];
z[24] = z[5] * z[24];
z[13] = z[13] + z[24];
z[13] = z[0] * z[13];
z[24] = z[1] * z[9];
z[28] = T(1) / T(2) + z[22] + (T(1) / T(2)) * z[24];
z[29] = (T(1) / T(2)) * z[1];
z[28] = z[28] * z[29];
z[30] = 1 + z[22];
z[31] = z[29] * z[30];
z[31] = z[6] + z[31];
z[32] = (T(1) / T(2)) * z[2] + z[10];
z[32] = (T(1) / T(2)) * z[32];
z[33] = (T(7) / T(12)) * z[8] + -z[31] + z[32];
z[33] = z[1] * z[33];
z[16] = (T(1) / T(4)) * z[16];
z[33] = z[16] + z[33];
z[33] = z[25] * z[33];
z[21] = z[11] * z[21];
z[34] = 5 * z[2];
z[35] = (T(19) / T(4)) * z[8] + -z[34];
z[13] = (T(1) / T(4)) * z[13] + z[15] + z[18] + (T(1) / T(8)) * z[21] + z[28] + z[33] + (T(1) / T(3)) * z[35];
z[13] = z[4] * z[13];
z[15] = z[8] * z[23];
z[18] = -z[15] * z[25];
z[21] = z[8] + z[32];
z[21] = z[1] * z[21];
z[18] = z[16] + z[18] + z[21];
z[18] = z[5] * z[18];
z[21] = -z[2] + -z[8];
z[21] = z[1] * z[21];
z[21] = z[17] + z[21];
z[21] = z[14] * z[21];
z[28] = z[1] + (T(-43) / T(6)) * z[2] + -z[8];
z[28] = z[1] * z[28];
z[21] = -z[12] + z[21] + z[28];
z[21] = z[20] * z[21];
z[28] = 1 + -z[24];
z[28] = z[28] * z[29];
z[18] = (T(-31) / T(12)) * z[2] + z[8] + z[18] + z[21] + z[28];
z[18] = z[3] * z[18];
z[21] = (T(31) / T(6)) * z[2] + -z[8] + z[10] + -z[26];
z[21] = z[11] * z[21];
z[21] = T(7) / T(6) + z[21] + -z[22] + -z[24];
z[22] = z[24] + (T(1) / T(2)) * z[30];
z[22] = z[1] * z[22];
z[26] = (T(1) / T(2)) * z[8];
z[28] = z[26] + z[31];
z[29] = -z[1] * z[28];
z[16] = -z[16] + z[29];
z[16] = z[5] * z[16];
z[16] = (T(17) / T(6)) * z[2] + z[6] + z[16] + z[22] + -z[26];
z[16] = z[5] * z[16];
z[15] = z[5] * z[15];
z[22] = z[15] + z[23];
z[22] = z[5] * z[22];
z[26] = 1 + z[24];
z[26] = z[1] * z[26];
z[29] = -z[3] * z[23];
z[22] = z[22] + z[26] + z[29];
z[22] = z[3] * z[22];
z[15] = -z[15] + z[23];
z[15] = z[5] * z[15];
z[26] = -1 + -3 * z[24];
z[26] = z[1] * z[26];
z[15] = z[15] + z[26];
z[15] = z[5] * z[15];
z[15] = z[15] + z[22];
z[15] = z[15] * z[20];
z[14] = -z[14] * z[28];
z[20] = 1 + (T(3) / T(2)) * z[24];
z[20] = z[1] * z[20];
z[14] = z[14] + z[20];
z[20] = prod_pow(z[5], 2);
z[14] = z[14] * z[20];
z[14] = z[14] + z[15];
z[14] = z[7] * z[14];
z[14] = z[14] + z[16] + z[18] + (T(1) / T(2)) * z[21];
z[15] = z[1] + (T(23) / T(3)) * z[2];
z[15] = z[1] * z[15];
z[12] = z[12] + z[15] + -z[17];
z[12] = z[3] * z[12];
z[15] = z[17] + -z[23];
z[15] = z[5] * z[15];
z[16] = -z[1] + -z[2];
z[12] = z[12] + z[15] + (T(43) / T(6)) * z[16];
z[12] = z[3] * z[12];
z[15] = (T(7) / T(2)) * z[1] + z[34];
z[15] = (T(1) / T(3)) * z[15] + (T(-1) / T(8)) * z[19];
z[15] = z[5] * z[15];
z[12] = (T(1) / T(4)) * z[12] + z[15];
z[12] = z[3] * z[12];
z[15] = (T(-37) / T(6)) * z[2] + -z[6] + z[27];
z[15] = z[15] * z[25];
z[15] = 1 + z[15];
z[15] = z[15] * z[25];
z[16] = z[6] + z[8];
z[16] = -z[5] * z[16];
z[16] = -1 + z[16];
z[16] = z[7] * z[16] * z[20];
z[12] = z[12] + z[15] + (T(1) / T(4)) * z[16];
z[12] = z[0] * z[12];
return z[12] + z[13] + (T(1) / T(2)) * z[14];
}



template double eval_coef_2q3y_2l_pmmpp_12345_108(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_108(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
