#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_11(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[14];
z[0] = iW[1];
z[1] = iW[4];
z[2] = iW[18];
z[3] = v[0];
z[4] = v[2];
z[5] = v[3];
z[6] = v[4];
z[7] = v[1];
z[8] = -z[4] + z[6];
z[9] = prod_pow(z[0], 2);
z[8] = z[8] * z[9];
z[10] = -z[4] * z[9];
z[10] = -z[0] + z[10];
z[10] = z[1] * z[10];
z[10] = z[9] + z[10];
z[11] = (T(1) / T(4)) * z[5];
z[10] = z[10] * z[11];
z[12] = z[0] * z[4];
z[13] = 1 + z[12];
z[13] = z[1] * z[13];
z[8] = (T(-3) / T(2)) * z[0] + z[8] + z[10] + (T(1) / T(2)) * z[13];
z[8] = z[5] * z[8];
z[10] = -z[6] + -z[11];
z[9] = z[9] * z[10];
z[9] = z[0] + z[9];
z[9] = z[3] * z[9];
z[10] = -z[0] * z[6];
z[11] = -z[4] + -z[7];
z[11] = z[1] * z[11];
z[8] = T(5) / T(4) + z[8] + z[9] + z[10] + (T(1) / T(4)) * z[11] + z[12];
z[9] = z[2] * z[3];
return prod_pow(z[9], 2) * z[8];
}



template double eval_coef_2q3y_2l_pmmpp_12345_11(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_11(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
