#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_110(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[29];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = iW[16];
z[7] = iW[19];
z[8] = v[1];
z[9] = v[0];
z[10] = iW[17];
z[11] = prod_pow(z[2], 2);
z[12] = z[2] + (T(-3) / T(2)) * z[4];
z[12] = z[4] * z[12];
z[12] = (T(13) / T(2)) * z[11] + 5 * z[12];
z[13] = z[6] * z[11];
z[14] = -z[2] + z[4];
z[15] = -z[13] + (T(5) / T(3)) * z[14];
z[15] = z[9] * z[15];
z[16] = z[2] * z[4];
z[17] = 5 * z[11] + (T(-13) / T(4)) * z[16];
z[17] = z[4] * z[17];
z[18] = prod_pow(z[2], 3);
z[17] = z[17] + (T(-7) / T(4)) * z[18];
z[17] = z[0] * z[17];
z[12] = (T(1) / T(2)) * z[12] + z[15] + (T(1) / T(3)) * z[17];
z[15] = -7 * z[2] + (T(13) / T(4)) * z[4];
z[15] = z[4] * z[15];
z[15] = (T(15) / T(4)) * z[11] + z[15];
z[17] = (T(1) / T(2)) * z[4];
z[15] = z[15] * z[17];
z[19] = z[4] * z[9];
z[20] = 4 * z[2] + (T(-5) / T(2)) * z[4];
z[20] = z[19] * z[20];
z[21] = -z[11] + z[16];
z[22] = z[10] * z[21];
z[23] = prod_pow(z[4], 2);
z[24] = z[22] * z[23];
z[15] = z[15] + (T(1) / T(3)) * z[20] + (T(-1) / T(4)) * z[24];
z[15] = z[1] * z[15];
z[12] = (T(1) / T(2)) * z[12] + z[15];
z[12] = z[1] * z[12];
z[15] = prod_pow(z[4], 3);
z[20] = z[9] * z[23];
z[20] = -z[15] + (T(-13) / T(6)) * z[20];
z[24] = (T(1) / T(2)) * z[1];
z[20] = z[20] * z[24];
z[19] = (T(13) / T(6)) * z[19] + z[20];
z[19] = z[14] * z[19];
z[20] = (T(13) / T(6)) * z[11];
z[25] = (T(-19) / T(6)) * z[2] + z[4];
z[25] = z[4] * z[25];
z[25] = z[20] + z[25];
z[25] = z[4] * z[25];
z[19] = z[19] + z[25];
z[19] = z[1] * z[19];
z[25] = z[4] * z[11];
z[26] = 13 * z[18] + -19 * z[25];
z[26] = z[0] * z[26];
z[27] = z[9] * z[14];
z[28] = (T(8) / T(3)) * z[2] + -z[17];
z[28] = z[4] * z[28];
z[19] = z[19] + -z[20] + (T(1) / T(12)) * z[26] + (T(-13) / T(12)) * z[27] + z[28];
z[19] = z[5] * z[19];
z[20] = z[18] + -z[25];
z[20] = z[6] * z[20];
z[16] = -z[16] + z[20];
z[16] = z[0] * z[16];
z[13] = z[4] + (T(-5) / T(2)) * z[13] + (T(3) / T(2)) * z[16];
z[16] = -z[0] * z[11];
z[16] = z[2] + z[4] + z[16];
z[16] = z[7] * z[16];
z[16] = -1 + z[16];
z[16] = z[8] * z[16];
z[12] = z[12] + (T(1) / T(2)) * z[13] + (T(1) / T(4)) * z[16] + z[19];
z[12] = z[5] * z[12];
z[13] = -z[2] + z[17];
z[13] = z[4] * z[13];
z[13] = (T(1) / T(2)) * z[11] + z[13];
z[16] = -z[3] + z[4];
z[16] = z[13] * z[16];
z[17] = z[17] * z[27];
z[19] = 3 * z[2];
z[20] = -z[4] + z[19];
z[20] = z[4] * z[20];
z[20] = -3 * z[11] + z[20];
z[20] = z[4] * z[20];
z[20] = z[18] + z[20];
z[25] = (T(1) / T(2)) * z[3];
z[20] = z[0] * z[20] * z[25];
z[16] = z[16] + z[17] + z[20];
z[16] = z[1] * z[16];
z[17] = z[14] * z[25];
z[20] = (T(-61) / T(2)) * z[2] + 13 * z[4];
z[20] = z[4] * z[20];
z[20] = (T(35) / T(2)) * z[11] + z[20];
z[26] = -z[4] + -z[25];
z[22] = z[22] * z[26];
z[26] = -z[2] + (T(1) / T(3)) * z[4];
z[26] = z[4] * z[26];
z[26] = z[11] + z[26];
z[26] = z[4] * z[26];
z[18] = (T(-1) / T(3)) * z[18] + z[26];
z[18] = z[0] * z[18];
z[26] = (T(1) / T(2)) * z[2] + -z[4];
z[26] = z[9] * z[26];
z[16] = z[16] + -z[17] + (T(25) / T(4)) * z[18] + (T(1) / T(3)) * z[20] + z[22] + z[26];
z[16] = z[1] * z[16];
z[17] = -3 * z[13] + z[17];
z[17] = z[0] * z[17];
z[18] = -z[3] + -z[4];
z[18] = z[10] * z[14] * z[18];
z[18] = z[9] + z[18] + z[19];
z[16] = z[3] + z[16] + z[17] + (T(1) / T(2)) * z[18];
z[16] = z[16] * z[24];
z[17] = -2 * z[2] + z[4];
z[17] = z[4] * z[17];
z[11] = z[11] + z[17];
z[11] = z[4] * z[11];
z[17] = z[13] * z[25];
z[11] = z[11] + z[17];
z[11] = z[1] * z[11];
z[17] = (T(-1) / T(4)) * z[3] + -z[4];
z[17] = z[14] * z[17];
z[11] = z[11] + z[17];
z[11] = z[1] * z[11];
z[13] = z[1] * z[13];
z[17] = 5 * z[13] + (T(-7) / T(2)) * z[14];
z[17] = z[1] * z[17];
z[17] = T(1) / T(2) + z[17];
z[17] = z[17] * z[23];
z[13] = z[13] + -z[14];
z[13] = z[1] * z[13];
z[13] = T(1) / T(2) + z[13];
z[13] = z[5] * z[13] * z[15];
z[13] = z[13] + (T(1) / T(2)) * z[17];
z[13] = z[5] * z[13];
z[11] = z[11] + z[13];
z[11] = z[7] * z[11];
z[13] = z[0] * z[21];
z[13] = -z[2] + (T(-3) / T(4)) * z[13];
z[13] = z[6] * z[13];
return T(1) / T(2) + z[11] + z[12] + z[13] + z[16];
}



template double eval_coef_2q3y_2l_pmmpp_12345_110(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_110(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
