#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_111(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = v[1];
z[7] = iW[16];
z[8] = iW[19];
z[9] = v[0];
z[10] = iW[2];
z[11] = z[3] * z[8];
z[12] = z[0] * z[3];
z[13] = (T(3) / T(2)) * z[12];
z[14] = z[11] + z[13];
z[15] = z[7] * z[9];
z[16] = z[9] * z[10];
z[17] = T(-53) / T(6) + -z[14] + z[15] + (T(1) / T(2)) * z[16];
z[18] = (T(1) / T(3)) * z[2];
z[19] = z[0] * z[2];
z[20] = T(-49) / T(2) + -5 * z[19];
z[20] = z[18] * z[20];
z[21] = prod_pow(z[9], 2);
z[22] = z[7] * z[21];
z[23] = T(37) / T(6) + z[16];
z[23] = z[9] * z[23];
z[20] = z[20] + z[22] + z[23];
z[23] = (T(1) / T(2)) * z[2];
z[24] = -z[9] + z[23];
z[24] = z[2] * z[24];
z[24] = (T(1) / T(2)) * z[21] + z[24];
z[25] = z[5] * z[24];
z[20] = (T(1) / T(2)) * z[20] + (T(-13) / T(3)) * z[25];
z[20] = z[5] * z[20];
z[25] = 3 * z[12];
z[26] = -1 + z[25];
z[26] = z[23] * z[26];
z[26] = -z[3] + (T(1) / T(2)) * z[9] + z[26];
z[26] = z[1] * z[26];
z[25] = T(59) / T(6) + (T(-25) / T(4)) * z[19] + z[25] + z[26];
z[25] = z[2] * z[25];
z[26] = (T(-3) / T(2)) * z[2] + (T(7) / T(3)) * z[9];
z[26] = z[2] * z[26];
z[26] = (T(-5) / T(6)) * z[21] + z[26];
z[26] = z[5] * z[26];
z[26] = -z[3] + (T(-5) / T(6)) * z[9] + z[26];
z[25] = z[25] + (T(5) / T(2)) * z[26];
z[26] = (T(1) / T(2)) * z[1];
z[25] = z[25] * z[26];
z[27] = (T(-16) / T(3)) * z[0] + -z[8];
z[27] = z[2] * z[27];
z[17] = (T(-1) / T(2)) * z[17] + z[20] + z[25] + z[27];
z[17] = z[1] * z[17];
z[20] = z[2] * z[9];
z[20] = z[20] + -z[21];
z[25] = z[5] * z[20];
z[27] = (T(1) / T(4)) * z[16];
z[28] = T(-8) / T(3) + -z[27];
z[28] = z[9] * z[28];
z[25] = (T(9) / T(2)) * z[2] + (T(-1) / T(4)) * z[22] + (T(-13) / T(12)) * z[25] + z[28];
z[25] = z[5] * z[25];
z[28] = z[3] + -z[9];
z[29] = 1 + -z[13];
z[29] = z[2] * z[29];
z[28] = (T(1) / T(2)) * z[28] + z[29];
z[28] = z[26] * z[28];
z[25] = T(-10) / T(3) + (T(-3) / T(4)) * z[12] + (T(25) / T(8)) * z[19] + z[25] + z[27] + z[28];
z[25] = z[1] * z[25];
z[28] = T(17) / T(2) + z[16];
z[29] = (T(13) / T(12)) * z[0] + -z[8];
z[29] = z[2] * z[29];
z[30] = (T(19) / T(3)) * z[2] + (T(-23) / T(2)) * z[9] + 3 * z[22];
z[30] = z[5] * z[30];
z[28] = (T(-5) / T(2)) * z[15] + (T(3) / T(2)) * z[28] + z[29] + z[30];
z[28] = z[5] * z[28];
z[29] = (T(19) / T(6)) * z[9];
z[22] = -z[22] + z[29];
z[22] = z[5] * z[22];
z[30] = T(-21) / T(2) + -z[16];
z[22] = z[22] + (T(1) / T(2)) * z[30];
z[22] = z[5] * z[22];
z[30] = -1 + z[12];
z[30] = z[26] * z[30];
z[31] = (T(-25) / T(6)) * z[0] + z[10];
z[22] = z[22] + z[30] + (T(1) / T(2)) * z[31];
z[22] = z[22] * z[26];
z[15] = z[5] * z[15];
z[30] = (T(1) / T(2)) * z[8] + -z[15];
z[30] = z[5] * z[30];
z[22] = z[22] + z[30];
z[22] = z[4] * z[22];
z[30] = (T(1) / T(2)) * z[10];
z[22] = (T(35) / T(12)) * z[0] + z[8] + z[22] + z[25] + (T(1) / T(2)) * z[28] + -z[30];
z[22] = z[1] * z[22];
z[25] = 3 * z[0];
z[28] = z[6] * z[25];
z[31] = -5 + -z[28];
z[31] = z[8] * z[31];
z[15] = z[15] + (T(1) / T(4)) * z[31];
z[15] = z[5] * z[15];
z[15] = z[15] + z[22];
z[15] = z[4] * z[15];
z[22] = -1 + (T(1) / T(4)) * z[19];
z[18] = z[18] * z[22];
z[18] = (T(1) / T(4)) * z[9] + z[18];
z[20] = z[7] * z[20];
z[18] = 19 * z[18] + z[20];
z[18] = z[5] * z[18];
z[16] = T(-37) / T(2) + -3 * z[16] + z[28];
z[20] = 5 * z[9];
z[22] = prod_pow(z[2], 2);
z[28] = -z[0] * z[22];
z[28] = z[20] + z[28];
z[31] = (T(1) / T(4)) * z[7];
z[28] = z[28] * z[31];
z[16] = (T(1) / T(4)) * z[16] + z[18] + (T(4) / T(3)) * z[19] + z[28];
z[16] = z[5] * z[16];
z[18] = (T(3) / T(2)) * z[0];
z[28] = -z[6] * z[8];
z[28] = T(-5) / T(2) + z[28];
z[18] = z[18] * z[28];
z[28] = (T(-1) / T(2)) * z[12] + -z[19];
z[28] = z[7] * z[28];
z[18] = -3 * z[8] + z[18] + z[28] + z[30];
z[15] = z[15] + z[16] + z[17] + (T(1) / T(2)) * z[18];
z[15] = z[4] * z[15];
z[16] = -z[6] + z[9];
z[16] = z[16] * z[29];
z[17] = z[0] * z[6];
z[18] = 15 + (T(-19) / T(3)) * z[17] + (T(-13) / T(3)) * z[19];
z[18] = z[18] * z[23];
z[18] = (T(19) / T(3)) * z[6] + (T(-17) / T(2)) * z[9] + z[18];
z[18] = z[2] * z[18];
z[16] = z[16] + z[18];
z[18] = -z[2] * z[7] * z[24];
z[16] = (T(1) / T(2)) * z[16] + z[18];
z[16] = z[5] * z[16];
z[18] = z[6] * z[10];
z[18] = T(-5) / T(3) + (T(1) / T(4)) * z[18] + -z[27];
z[18] = z[9] * z[18];
z[17] = 1 + (T(-1) / T(2)) * z[17];
z[17] = (T(9) / T(4)) * z[17] + (T(-1) / T(3)) * z[19];
z[17] = z[2] * z[17];
z[23] = -5 + z[19];
z[23] = z[2] * z[23];
z[20] = z[20] + z[23];
z[20] = z[2] * z[20];
z[20] = z[20] + -z[21];
z[20] = z[20] * z[31];
z[16] = (T(7) / T(8)) * z[6] + z[16] + z[17] + z[18] + z[20];
z[16] = z[5] * z[16];
z[17] = 5 * z[3];
z[18] = z[17] + z[29];
z[13] = T(-11) / T(3) + -z[13] + (T(25) / T(12)) * z[19];
z[13] = z[2] * z[13];
z[13] = z[13] + (T(1) / T(2)) * z[18];
z[13] = z[2] * z[13];
z[18] = 1 + -z[19];
z[18] = z[3] * z[18] * z[22] * z[26];
z[13] = z[13] + z[18];
z[13] = z[1] * z[13];
z[14] = T(-17) / T(6) + -z[14] + (T(29) / T(6)) * z[19];
z[14] = z[2] * z[14];
z[18] = 11 + 7 * z[19];
z[18] = z[2] * z[18];
z[18] = -43 * z[9] + z[18];
z[18] = z[2] * z[18];
z[18] = z[18] + 25 * z[21];
z[18] = z[5] * z[18];
z[17] = -3 * z[9] + z[17];
z[13] = z[13] + z[14] + (T(1) / T(2)) * z[17] + (T(1) / T(12)) * z[18];
z[13] = z[13] * z[26];
z[14] = -z[3] + z[6];
z[14] = z[14] * z[25];
z[11] = 3 + -z[11] + z[14] + (T(13) / T(2)) * z[19];
z[12] = -1 + (T(1) / T(4)) * z[12] + (T(1) / T(2)) * z[19];
z[12] = z[2] * z[12];
z[14] = (T(-1) / T(2)) * z[3] + z[9];
z[12] = z[12] + (T(1) / T(2)) * z[14];
z[12] = z[7] * z[12];
return (T(1) / T(4)) * z[11] + z[12] + z[13] + z[15] + z[16];
}



template double eval_coef_2q3y_2l_pmmpp_12345_111(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_111(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
