#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_113(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[36];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = v[1];
z[7] = iW[19];
z[8] = iW[17];
z[9] = v[0];
z[10] = iW[12];
z[11] = iW[15];
z[12] = prod_pow(z[2], 2);
z[13] = z[8] * z[12];
z[14] = prod_pow(z[4], 3);
z[15] = z[13] * z[14];
z[16] = z[2] * z[4];
z[17] = -17 * z[12] + (T(41) / T(3)) * z[16];
z[18] = prod_pow(z[4], 2);
z[17] = z[17] * z[18];
z[17] = (T(-19) / T(3)) * z[15] + z[17];
z[19] = (T(1) / T(4)) * z[8];
z[17] = z[17] * z[19];
z[20] = (T(1) / T(2)) * z[4];
z[21] = -z[2] + z[20];
z[22] = z[4] * z[21];
z[23] = (T(1) / T(2)) * z[12];
z[22] = z[22] + z[23];
z[24] = z[7] * z[22];
z[25] = z[2] + z[9];
z[25] = z[4] + (T(5) / T(3)) * z[25];
z[13] = (T(-4) / T(3)) * z[13] + -z[24] + (T(1) / T(2)) * z[25];
z[13] = z[5] * z[13] * z[14];
z[25] = 3 * z[2];
z[26] = (T(-23) / T(12)) * z[4] + (T(13) / T(12)) * z[9] + (T(-5) / T(2)) * z[24] + z[25];
z[26] = z[18] * z[26];
z[13] = z[13] + z[17] + z[26];
z[13] = z[5] * z[13];
z[17] = (T(1) / T(3)) * z[4];
z[26] = (T(29) / T(4)) * z[2] + -8 * z[4];
z[26] = z[17] * z[26];
z[27] = 2 * z[2] + -z[4];
z[27] = z[4] * z[27];
z[27] = -z[12] + z[27];
z[27] = z[4] * z[7] * z[27];
z[24] = z[20] + -z[24];
z[28] = (T(1) / T(2)) * z[3];
z[24] = z[24] * z[28];
z[29] = z[16] + z[23];
z[29] = z[4] * z[29];
z[30] = z[2] * z[3] * z[20];
z[29] = z[29] + z[30];
z[30] = (T(1) / T(2)) * z[8];
z[29] = z[29] * z[30];
z[13] = z[13] + z[24] + z[26] + z[27] + z[29];
z[13] = z[1] * z[13];
z[24] = -z[2] + z[4];
z[26] = z[24] * z[28];
z[27] = z[22] + -z[26];
z[27] = z[0] * z[27];
z[29] = -z[4] + (T(-17) / T(12)) * z[9];
z[29] = z[18] * z[29];
z[31] = z[7] * z[24];
z[32] = z[14] * z[31];
z[29] = z[29] + z[32];
z[29] = z[5] * z[29];
z[32] = z[2] * z[8];
z[33] = (T(7) / T(2)) * z[31] + (T(-73) / T(6)) * z[32];
z[33] = z[18] * z[33];
z[34] = (T(1) / T(2)) * z[2];
z[35] = (T(55) / T(6)) * z[4] + (T(-5) / T(3)) * z[9] + -z[34];
z[35] = z[4] * z[35];
z[33] = z[33] + z[35];
z[29] = z[29] + (T(1) / T(2)) * z[33];
z[29] = z[5] * z[29];
z[33] = z[2] + z[3] + z[4];
z[19] = z[19] * z[33];
z[19] = z[19] + z[31];
z[19] = z[4] * z[19];
z[33] = z[4] + z[34];
z[31] = -1 + z[31];
z[31] = z[3] * z[31];
z[13] = z[13] + z[19] + (T(1) / T(2)) * z[27] + z[29] + (T(1) / T(4)) * z[31] + (T(13) / T(6)) * z[33];
z[13] = z[1] * z[13];
z[19] = z[7] * z[18];
z[25] = (T(-25) / T(9)) * z[4] + -z[9] + -z[19] + z[25];
z[27] = -z[12] + z[16];
z[27] = z[0] * z[27];
z[25] = (T(1) / T(2)) * z[25] + z[27];
z[27] = -z[2] + z[9];
z[20] = z[20] + (T(1) / T(3)) * z[27];
z[20] = z[4] * z[20];
z[14] = z[7] * z[14];
z[14] = (T(-1) / T(2)) * z[14] + z[20];
z[14] = z[5] * z[14];
z[19] = (T(71) / T(9)) * z[2] + -z[4] + z[19];
z[19] = z[0] * z[19];
z[19] = T(-71) / T(9) + z[19];
z[20] = z[0] * z[23];
z[20] = -z[2] + (T(1) / T(2)) * z[9] + z[20];
z[20] = z[5] * z[20];
z[19] = (T(1) / T(2)) * z[19] + z[20];
z[20] = (T(1) / T(2)) * z[6];
z[19] = z[19] * z[20];
z[14] = z[14] + z[19] + (T(1) / T(2)) * z[25];
z[14] = z[5] * z[14];
z[16] = (T(1) / T(3)) * z[16] + -z[23];
z[16] = z[16] * z[18];
z[15] = (T(-1) / T(6)) * z[15] + z[16];
z[15] = z[15] * z[30];
z[16] = z[2] + (T(-1) / T(4)) * z[4];
z[16] = z[16] * z[17];
z[12] = (T(-1) / T(4)) * z[12] + z[16];
z[12] = z[4] * z[12];
z[16] = z[3] * z[22];
z[12] = z[12] + z[15] + (T(-1) / T(6)) * z[16];
z[12] = z[1] * z[12];
z[15] = (T(-5) / T(2)) * z[2] + z[4];
z[15] = z[4] * z[15];
z[15] = z[15] + z[26];
z[16] = -z[18] * z[32];
z[15] = (T(1) / T(2)) * z[15] + z[16];
z[12] = z[12] + (T(1) / T(3)) * z[15];
z[12] = z[1] * z[12];
z[12] = (T(-1) / T(6)) * z[4] + z[12];
z[12] = z[10] * z[12];
z[15] = z[21] + z[28];
z[15] = z[3] * z[15];
z[16] = prod_pow(z[3], 2) * z[1] * z[34];
z[15] = z[15] + z[16];
z[15] = z[1] * z[15];
z[15] = -z[3] + z[15] + z[20] + (T(-1) / T(2)) * z[24];
z[15] = z[11] * z[15];
z[16] = z[0] * z[24];
z[16] = T(19) / T(2) + 4 * z[16];
return 19 * z[12] + z[13] + z[14] + (T(1) / T(2)) * z[15] + (T(5) / T(9)) * z[16];
}



template double eval_coef_2q3y_2l_pmmpp_12345_113(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_113(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
