#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_114(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[12];
z[3] = v[2];
z[4] = v[4];
z[5] = iW[21];
z[6] = v[0];
z[7] = iW[7];
z[8] = iW[15];
z[9] = v[3];
z[10] = v[1];
z[11] = (T(1) / T(2)) * z[9];
z[12] = prod_pow(z[8], 2);
z[13] = z[9] * z[12];
z[14] = -7 * z[8] + -z[13];
z[14] = z[11] * z[14];
z[14] = -3 + z[14];
z[14] = z[9] * z[14];
z[15] = z[1] * z[6];
z[16] = -5 + -3 * z[15];
z[16] = z[6] * z[16];
z[14] = z[14] + (T(1) / T(2)) * z[16];
z[16] = z[8] * z[9];
z[17] = 1 + z[16];
z[17] = z[9] * z[17];
z[18] = z[6] + z[17];
z[19] = z[11] * z[18];
z[20] = prod_pow(z[6], 2);
z[19] = z[19] + z[20];
z[19] = z[5] * z[19];
z[14] = (T(1) / T(2)) * z[14] + z[19];
z[14] = z[5] * z[14];
z[19] = z[8] + z[13];
z[19] = z[11] * z[19];
z[21] = prod_pow(z[1], 2);
z[22] = z[6] * z[21];
z[23] = (T(1) / T(2)) * z[1] + z[22];
z[23] = z[6] * z[23];
z[19] = -z[19] + z[23];
z[23] = 1 + z[15];
z[23] = z[6] * z[23];
z[24] = -z[17] + -z[23];
z[24] = z[5] * z[24];
z[24] = -z[19] + z[24];
z[24] = z[5] * z[24];
z[25] = (T(1) / T(2)) * z[2];
z[24] = z[24] + -z[25];
z[26] = (T(1) / T(2)) * z[3];
z[24] = z[24] * z[26];
z[19] = T(1) / T(2) + -z[19];
z[14] = z[14] + (T(1) / T(2)) * z[19] + z[24];
z[14] = z[3] * z[14];
z[19] = (T(1) / T(2)) * z[16];
z[24] = 3 * z[7];
z[27] = -z[8] + z[24];
z[28] = z[19] * z[27];
z[29] = (T(3) / T(2)) * z[7];
z[30] = -z[8] + -z[28] + -z[29];
z[30] = z[9] * z[30];
z[30] = -3 + z[30];
z[30] = z[9] * z[30];
z[23] = (T(-3) / T(2)) * z[23] + z[30];
z[30] = -z[5] * z[11];
z[30] = 2 + z[30];
z[30] = z[20] * z[30];
z[18] = z[9] * z[18];
z[18] = z[18] + z[30];
z[18] = z[5] * z[18];
z[14] = z[14] + z[18] + (T(1) / T(2)) * z[23];
z[14] = z[3] * z[14];
z[18] = (T(19) / T(6)) * z[13];
z[23] = z[18] + z[24];
z[23] = z[11] * z[23];
z[24] = z[1] * z[2];
z[30] = -z[3] * z[24];
z[30] = z[1] + z[25] + z[30];
z[30] = z[3] * z[30];
z[31] = (T(-13) / T(6)) * z[1] + -z[22];
z[31] = z[6] * z[31];
z[23] = T(-25) / T(12) + z[23] + z[30] + z[31];
z[23] = z[3] * z[23];
z[30] = -1 + (T(-1) / T(2)) * z[15];
z[30] = z[6] * z[30];
z[23] = z[17] + z[23] + z[30];
z[30] = (T(19) / T(8)) * z[1] + -4 * z[22];
z[30] = z[6] * z[30];
z[30] = T(43) / T(8) + (T(25) / T(8)) * z[16] + z[30];
z[31] = -z[2] * z[3];
z[31] = 1 + z[31];
z[21] = z[21] * z[31];
z[21] = z[21] + z[24];
z[21] = z[3] * z[21];
z[21] = -z[1] + z[21] + z[22];
z[21] = z[3] * z[21];
z[31] = z[4] * z[7];
z[21] = (T(1) / T(4)) * z[21] + (T(1) / T(3)) * z[30] + (T(-3) / T(4)) * z[31];
z[21] = z[4] * z[21];
z[21] = z[21] + (T(1) / T(2)) * z[23];
z[21] = z[4] * z[21];
z[23] = z[5] * z[9];
z[30] = 1 + -z[23];
z[20] = z[20] * z[30];
z[14] = z[14] + (T(3) / T(4)) * z[20] + z[21];
z[14] = z[0] * z[14];
z[20] = (T(7) / T(2)) * z[8] + z[13];
z[20] = z[9] * z[20];
z[20] = (T(-5) / T(2)) * z[15] + z[20];
z[21] = T(-1) / T(2) + -z[16];
z[21] = z[21] * z[23];
z[20] = (T(1) / T(2)) * z[20] + z[21];
z[20] = z[5] * z[20];
z[11] = z[11] * z[12];
z[21] = z[11] + z[22];
z[30] = -z[15] + z[16];
z[30] = z[5] * z[30];
z[30] = -z[21] + z[30];
z[31] = z[5] * z[26];
z[30] = z[30] * z[31];
z[21] = -z[21] + -z[25];
z[20] = z[20] + (T(1) / T(2)) * z[21] + z[30];
z[20] = z[3] * z[20];
z[21] = z[7] + z[28];
z[21] = z[9] * z[21];
z[25] = (T(-3) / T(2)) * z[1] + z[22];
z[25] = z[6] * z[25];
z[21] = T(3) / T(2) + 3 * z[21] + z[25];
z[25] = -1 + -2 * z[16];
z[23] = z[23] * z[25];
z[20] = z[20] + (T(1) / T(2)) * z[21] + z[23];
z[20] = z[3] * z[20];
z[21] = z[1] + (T(1) / T(2)) * z[8] + (T(-19) / T(6)) * z[22] + -z[29];
z[23] = -z[24] * z[26];
z[21] = (T(-4) / T(3)) * z[13] + (T(1) / T(2)) * z[21] + z[23];
z[21] = z[3] * z[21];
z[18] = z[18] + z[27];
z[18] = z[4] * z[18];
z[23] = (T(-35) / T(4)) * z[1] + 8 * z[22];
z[23] = z[6] * z[23];
z[24] = -31 * z[8] + (T(19) / T(2)) * z[13];
z[24] = z[9] * z[24];
z[18] = T(-29) / T(8) + (T(1) / T(4)) * z[18] + z[21] + (T(1) / T(3)) * z[23] + (T(1) / T(12)) * z[24];
z[18] = z[4] * z[18];
z[15] = 3 + z[15];
z[15] = z[6] * z[15];
z[15] = z[15] + -z[17];
z[14] = z[14] + (T(1) / T(4)) * z[15] + z[18] + z[20];
z[14] = z[0] * z[14];
z[15] = z[5] + (T(-3) / T(4)) * z[27];
z[15] = z[15] * z[16];
z[16] = z[5] * z[16];
z[11] = -z[11] + z[16];
z[11] = z[11] * z[31];
z[16] = (T(4) / T(3)) * z[22];
z[17] = z[8] + -z[29];
z[11] = z[11] + z[15] + z[16] + (T(1) / T(2)) * z[17];
z[11] = z[3] * z[11];
z[15] = (T(13) / T(2)) * z[3] + (T(-19) / T(2)) * z[4];
z[15] = z[12] * z[15];
z[13] = 25 * z[8] + -19 * z[13] + z[15];
z[13] = z[4] * z[13];
z[15] = z[3] * z[27];
z[15] = -1 + z[15];
z[15] = z[8] * z[15];
z[12] = (T(19) / T(6)) * z[12];
z[12] = z[4] * z[12];
z[12] = z[12] + z[15];
z[12] = z[10] * z[12];
z[15] = (T(17) / T(8)) * z[1] + -z[16];
z[15] = z[6] * z[15];
return T(1) / T(4) + z[11] + (T(1) / T(4)) * z[12] + (T(1) / T(12)) * z[13] + z[14] + z[15] + z[19];
}



template double eval_coef_2q3y_2l_pmmpp_12345_114(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_114(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
