#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_115(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[3];
z[5] = iW[3];
z[6] = v[2];
z[7] = iW[22];
z[8] = v[4];
z[9] = iW[4];
z[10] = iW[15];
z[11] = iW[17];
z[12] = iW[18];
z[13] = z[9] + -z[11];
z[13] = z[7] * z[13];
z[14] = z[7] * z[10];
z[13] = z[13] + z[14];
z[15] = (T(1) / T(2)) * z[4];
z[13] = z[13] * z[15];
z[16] = (T(1) / T(2)) * z[7];
z[17] = z[2] * z[6];
z[18] = T(-1) / T(2) + z[17];
z[18] = z[10] * z[18];
z[19] = z[6] * z[7];
z[20] = T(1) / T(2) + z[19];
z[21] = z[9] * z[20];
z[22] = -z[11] * z[19];
z[13] = z[13] + z[16] + z[18] + z[21] + z[22];
z[13] = z[4] * z[13];
z[18] = z[17] + z[19];
z[21] = 1 + z[19];
z[22] = z[6] * z[9];
z[23] = z[21] * z[22];
z[23] = z[18] + z[23];
z[24] = 1 + (T(1) / T(2)) * z[19];
z[24] = z[6] * z[24];
z[25] = prod_pow(z[6], 2);
z[26] = z[2] * z[25];
z[24] = z[8] + z[24] + (T(1) / T(2)) * z[26];
z[24] = z[10] * z[24];
z[27] = z[11] * z[25];
z[16] = -z[16] * z[27];
z[13] = z[13] + z[16] + (T(1) / T(2)) * z[23] + -z[24];
z[13] = z[4] * z[13];
z[16] = -z[17] + z[21];
z[16] = z[10] * z[16];
z[23] = -1 + z[19];
z[28] = z[11] * z[23];
z[29] = z[9] * z[19];
z[16] = z[16] + -z[28] + z[29];
z[16] = z[15] * z[16];
z[29] = z[7] * z[8];
z[19] = z[19] + z[29];
z[30] = -z[17] + z[19];
z[31] = z[20] * z[22];
z[28] = -z[6] * z[28];
z[16] = z[16] + z[24] + z[28] + (T(1) / T(2)) * z[30] + z[31];
z[16] = z[4] * z[16];
z[24] = z[9] * z[25];
z[24] = z[6] + z[24];
z[24] = z[21] * z[24];
z[25] = 3 * z[21] + -z[29];
z[25] = z[8] * z[25];
z[23] = -z[23] * z[27];
z[23] = z[23] + z[24] + z[25] + z[26];
z[16] = z[16] + (T(1) / T(2)) * z[23];
z[16] = z[4] * z[16];
z[23] = (T(1) / T(2)) * z[6];
z[23] = z[21] * z[23];
z[20] = -z[20] + (T(1) / T(2)) * z[29];
z[20] = z[8] * z[20];
z[20] = z[20] + z[23];
z[23] = prod_pow(z[8], 2);
z[24] = z[5] * z[23];
z[20] = z[20] * z[24];
z[19] = z[8] * z[19];
z[25] = z[6] * z[21];
z[19] = (T(-1) / T(2)) * z[19] + z[25];
z[19] = z[8] * z[19];
z[16] = z[16] + z[19] + z[20];
z[16] = z[0] * z[16];
z[19] = z[21] + -z[29];
z[19] = z[19] * z[24];
z[20] = z[7] * z[23];
z[19] = z[19] + z[20];
z[13] = z[13] + z[16] + (T(1) / T(2)) * z[19];
z[13] = z[0] * z[13];
z[16] = -z[17] + z[22];
z[16] = z[4] * z[16];
z[16] = 3 * z[6] + z[8] + z[16] + z[24] + z[26];
z[16] = z[0] * z[16];
z[19] = -z[8] + z[26];
z[20] = -z[6] + z[19];
z[20] = z[5] * z[20];
z[21] = z[4] * z[9];
z[16] = -1 + z[16] + z[20] + z[21];
z[16] = z[0] * z[16];
z[20] = z[1] + -z[12];
z[21] = z[4] * z[20];
z[22] = 1 + -z[21];
z[22] = z[2] * z[22];
z[20] = z[20] + z[22];
z[20] = z[15] * z[20];
z[19] = z[6] + z[19];
z[19] = z[5] * z[19];
z[17] = T(-3) / T(2) + -z[17] + (T(1) / T(2)) * z[19] + z[20];
z[17] = z[0] * z[17];
z[19] = z[2] * z[21];
z[19] = z[9] + z[12] + z[19];
z[20] = z[5] + z[19];
z[17] = z[17] + (T(1) / T(2)) * z[20];
z[17] = z[0] * z[17];
z[19] = prod_pow(z[0], 2) * z[3] * z[19];
z[17] = z[17] + (T(1) / T(2)) * z[19];
z[17] = z[3] * z[17];
z[16] = (T(1) / T(2)) * z[16] + z[17];
z[16] = z[3] * z[16];
z[17] = -z[10] * z[18];
z[14] = -z[4] * z[14];
z[14] = z[14] + z[17];
z[14] = z[14] * z[15];
z[13] = z[13] + z[14] + z[16];
return (T(1) / T(2)) * z[13];
}



template double eval_coef_2q3y_2l_pmmpp_12345_115(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_115(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
