#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_117(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[1];
z[1] = v[0];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[3];
z[5] = iW[22];
z[6] = iW[4];
z[7] = iW[15];
z[8] = v[3];
z[9] = iW[23];
z[10] = v[1];
z[11] = (T(1) / T(2)) * z[2];
z[12] = prod_pow(z[0], 2);
z[13] = z[11] * z[12];
z[13] = z[0] + z[13];
z[14] = (T(1) / T(2)) * z[3];
z[15] = z[12] * z[14];
z[16] = z[13] + -z[15];
z[16] = z[3] * z[16];
z[17] = z[0] * z[2];
z[18] = -1 + (T(-19) / T(6)) * z[17];
z[18] = z[16] + (T(1) / T(2)) * z[18];
z[18] = z[3] * z[18];
z[19] = 1 + z[17];
z[16] = z[16] + (T(-1) / T(2)) * z[19];
z[16] = z[1] * z[16];
z[20] = z[2] * z[19];
z[16] = (T(13) / T(6)) * z[16] + z[18] + (T(13) / T(12)) * z[20];
z[16] = z[1] * z[16];
z[18] = -z[0] + z[15];
z[20] = (T(3) / T(2)) * z[2];
z[20] = z[12] * z[20];
z[21] = z[18] + -z[20];
z[21] = z[3] * z[21];
z[22] = 2 * z[0] + z[20];
z[22] = z[2] * z[22];
z[21] = T(1) / T(2) + z[21] + z[22];
z[21] = z[3] * z[21];
z[22] = z[2] * z[13];
z[22] = T(1) / T(2) + z[22];
z[23] = z[2] * z[22];
z[21] = z[21] + -z[23];
z[23] = prod_pow(z[3], 2);
z[21] = z[5] * z[21] * z[23];
z[24] = z[2] * z[12];
z[25] = z[0] + z[24];
z[26] = z[15] + -z[25];
z[26] = z[3] * z[26];
z[22] = z[22] + z[26];
z[22] = z[22] * z[23];
z[16] = z[16] + -z[21] + z[22];
z[16] = z[4] * z[16];
z[20] = z[0] + z[20];
z[20] = -z[2] * z[20];
z[22] = z[3] * z[12];
z[26] = -z[0] + z[22];
z[27] = 3 * z[24] + -z[26];
z[27] = z[14] * z[27];
z[20] = z[20] + z[27];
z[20] = z[3] * z[20];
z[27] = prod_pow(z[2], 2);
z[28] = (T(1) / T(2)) * z[27];
z[28] = z[25] * z[28];
z[20] = z[20] + z[28];
z[20] = z[3] * z[20];
z[20] = z[20] + z[21];
z[20] = z[5] * z[20];
z[21] = 3 * z[0];
z[29] = z[21] + (T(19) / T(6)) * z[24];
z[29] = z[2] * z[29];
z[29] = T(-7) / T(6) + z[29];
z[30] = (T(-1) / T(4)) * z[0] + (T(13) / T(24)) * z[22] + (T(-4) / T(3)) * z[24];
z[30] = z[3] * z[30];
z[26] = 4 * z[24] + (T(-13) / T(4)) * z[26];
z[26] = z[1] * z[26];
z[26] = (T(1) / T(3)) * z[26] + (T(1) / T(4)) * z[29] + z[30];
z[26] = z[1] * z[26];
z[29] = z[11] * z[25];
z[30] = (T(1) / T(2)) * z[0];
z[15] = z[15] + -z[30];
z[31] = z[15] + -z[24];
z[31] = z[3] * z[31];
z[29] = z[29] + z[31];
z[29] = z[3] * z[29];
z[16] = z[16] + z[20] + z[26] + z[29];
z[16] = z[4] * z[16];
z[20] = (T(1) / T(2)) * z[8];
z[26] = z[12] * z[20];
z[29] = 2 * z[24] + z[26] + z[30];
z[29] = z[8] * z[29];
z[18] = -z[18] + -z[26];
z[18] = z[3] * z[18];
z[30] = z[12] * z[27];
z[30] = -1 + 3 * z[30];
z[18] = z[18] + z[29] + (T(1) / T(2)) * z[30];
z[18] = z[3] * z[18];
z[29] = -z[2] * z[8];
z[27] = -z[27] + z[29];
z[27] = z[25] * z[27];
z[18] = z[18] + z[27];
z[18] = z[3] * z[18];
z[27] = z[2] + z[20];
z[27] = z[25] * z[27];
z[29] = z[8] * z[27];
z[29] = z[28] + z[29];
z[30] = -z[8] * z[29];
z[18] = z[18] + z[30];
z[18] = z[5] * z[18];
z[29] = -z[6] * z[29];
z[27] = -z[27] + z[29];
z[27] = z[8] * z[27];
z[29] = z[8] * z[12];
z[22] = z[22] + z[29];
z[30] = -z[0] + z[22];
z[23] = z[23] * z[30];
z[18] = z[18] + (T(1) / T(2)) * z[23] + z[27] + -z[28];
z[18] = z[5] * z[18];
z[23] = prod_pow(z[0], 3);
z[27] = -z[14] * z[23];
z[28] = z[2] * z[23];
z[27] = (T(3) / T(2)) * z[12] + z[27] + z[28];
z[27] = z[3] * z[27];
z[30] = -z[3] * z[23];
z[28] = z[12] + z[28] + z[30];
z[30] = (T(1) / T(2)) * z[1];
z[28] = z[28] * z[30];
z[23] = -z[11] * z[23];
z[12] = -z[12] + z[23];
z[12] = z[2] * z[12];
z[23] = -z[6] * z[19];
z[12] = z[12] + z[23] + z[26] + z[27] + z[28];
z[12] = z[12] * z[30];
z[13] = z[13] + z[26];
z[13] = z[8] * z[13];
z[23] = z[8] * z[25];
z[19] = -3 * z[19] + z[23];
z[19] = z[8] * z[19];
z[19] = 3 * z[2] + z[19];
z[19] = z[8] * z[19];
z[23] = -z[2] + 3 * z[8] + -z[10];
z[23] = z[10] * z[23];
z[19] = z[19] + z[23];
z[23] = z[6] + (T(3) / T(2)) * z[9];
z[19] = z[19] * z[23];
z[23] = -z[21] + z[29];
z[23] = z[8] * z[23];
z[23] = 3 + z[23];
z[23] = z[8] * z[23];
z[23] = -z[10] + z[23];
z[19] = z[19] + (T(1) / T(2)) * z[23];
z[19] = z[7] * z[19];
z[22] = z[3] * z[22];
z[23] = (T(-5) / T(2)) * z[0] + -z[24];
z[23] = z[2] * z[23];
z[13] = T(-5) / T(2) + z[13] + z[19] + (T(3) / T(2)) * z[22] + z[23];
z[19] = z[25] + z[29];
z[19] = z[19] * z[20];
z[15] = z[15] + z[29];
z[15] = z[3] * z[15];
z[22] = -z[0] * z[11];
z[15] = -1 + z[15] + z[19] + z[22];
z[14] = z[14] * z[15];
z[15] = (T(3) / T(2)) * z[0] + z[24];
z[15] = z[15] * z[20];
z[15] = T(-3) / T(2) + z[15] + -z[17];
z[15] = z[8] * z[15];
z[14] = (T(3) / T(4)) * z[10] + z[11] + z[14] + z[15];
z[14] = z[9] * z[14];
z[15] = -z[21] + -z[24];
z[15] = z[11] * z[15];
z[15] = -1 + z[15];
z[15] = z[8] * z[15];
z[11] = (T(1) / T(2)) * z[10] + z[11] + z[15];
z[11] = z[6] * z[11];
return z[11] + z[12] + (T(1) / T(2)) * z[13] + 3 * z[14] + z[16] + z[18];
}



template double eval_coef_2q3y_2l_pmmpp_12345_117(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_117(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
