#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_130(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[30];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[1];
z[4] = v[2];
z[5] = v[3];
z[6] = v[4];
z[7] = iW[1];
z[8] = v[0];
z[9] = iW[7];
z[10] = iW[18];
z[11] = iW[17];
z[12] = prod_pow(z[10], 2);
z[13] = prod_pow(z[2], 2);
z[14] = (T(259) / T(18)) * z[12] + z[13];
z[14] = z[4] * z[14];
z[12] = (T(259) / T(36)) * z[12];
z[15] = z[12] + -z[13];
z[15] = z[5] * z[15];
z[14] = z[14] + z[15];
z[16] = z[4] * z[13];
z[17] = (T(1) / T(2)) * z[2] + z[16];
z[18] = z[0] * z[4];
z[19] = z[17] * z[18];
z[20] = (T(337) / T(18)) * z[10];
z[21] = 3 * z[2];
z[22] = z[20] + -z[21];
z[22] = -z[14] + z[19] + (T(1) / T(2)) * z[22];
z[22] = z[5] * z[22];
z[20] = z[9] + z[20] + z[21];
z[23] = (T(259) / T(18)) * z[10];
z[24] = z[9] + z[23];
z[25] = z[10] * z[24];
z[26] = z[13] + (T(-1) / T(2)) * z[25];
z[26] = z[4] * z[26];
z[20] = (T(1) / T(2)) * z[20] + z[26];
z[20] = z[4] * z[20];
z[17] = -z[4] * z[17];
z[17] = T(-13) / T(12) + z[17];
z[17] = z[17] * z[18];
z[17] = T(13) / T(12) + z[17];
z[17] = z[1] * z[17];
z[17] = z[17] + -z[19];
z[17] = z[3] * z[17];
z[19] = z[2] * z[4];
z[26] = T(7) / T(12) + -z[19];
z[18] = z[18] * z[26];
z[26] = (T(1) / T(2)) * z[6];
z[27] = (T(-13) / T(6)) * z[0] + -z[9];
z[26] = z[26] * z[27];
z[17] = T(1) / T(2) + z[17] + z[18] + z[20] + z[22] + z[26];
z[18] = (T(1) / T(2)) * z[4];
z[20] = z[11] + z[23];
z[20] = z[18] * z[20];
z[20] = T(-143) / T(9) + z[20];
z[20] = z[4] * z[20];
z[22] = z[6] * z[9];
z[23] = (T(1) / T(2)) * z[22];
z[26] = z[4] * z[9];
z[26] = T(259) / T(36) + -z[23] + z[26];
z[26] = z[6] * z[26];
z[20] = z[20] + z[26];
z[26] = (T(271) / T(12)) * z[10] + -z[14] + -z[21];
z[27] = (T(1) / T(2)) * z[5];
z[26] = z[26] * z[27];
z[24] = z[4] * z[24];
z[24] = T(545) / T(36) + (T(-1) / T(4)) * z[24];
z[24] = z[10] * z[24];
z[24] = z[2] + z[24];
z[24] = z[4] * z[24];
z[24] = T(-241) / T(36) + z[24] + z[26];
z[24] = z[5] * z[24];
z[20] = (T(1) / T(2)) * z[20] + z[24];
z[20] = z[5] * z[20];
z[24] = z[15] + z[21];
z[26] = 3 * z[4];
z[28] = z[13] * z[26];
z[29] = (T(265) / T(12)) * z[10] + -z[24] + -z[28];
z[27] = z[27] * z[29];
z[29] = z[13] * z[18];
z[29] = z[2] + z[29];
z[26] = z[26] * z[29];
z[21] = -z[16] + -z[21];
z[18] = z[18] * z[21];
z[18] = -1 + z[18];
z[18] = z[4] * z[18];
z[18] = (T(241) / T(72)) * z[6] + z[18];
z[18] = z[1] * z[18];
z[18] = T(-58) / T(9) + z[18] + z[26] + z[27];
z[18] = z[8] * z[18];
z[12] = z[12] + 2 * z[13];
z[12] = z[4] * z[12];
z[21] = (T(-67) / T(3)) * z[10] + z[12] + z[24];
z[21] = z[5] * z[21];
z[24] = 4 * z[2];
z[26] = (T(-527) / T(36)) * z[10] + -z[16] + -z[24];
z[26] = z[4] * z[26];
z[21] = T(473) / T(36) + z[21] + z[26];
z[21] = z[5] * z[21];
z[19] = T(76) / T(9) + z[19];
z[19] = z[4] * z[19];
z[18] = (T(-125) / T(18)) * z[6] + z[18] + z[19] + z[21];
z[18] = z[8] * z[18];
z[19] = z[4] * z[11];
z[19] = -1 + z[19];
z[19] = z[4] * z[19];
z[21] = 1 + -z[22];
z[21] = z[6] * z[21];
z[19] = z[19] + z[21];
z[19] = z[6] * z[19];
z[18] = z[18] + (T(1) / T(4)) * z[19] + z[20];
z[18] = z[7] * z[18];
z[19] = (T(-9) / T(2)) * z[2] + (T(283) / T(9)) * z[10];
z[12] = -z[12] + -z[15] + (T(1) / T(2)) * z[19];
z[12] = z[5] * z[12];
z[15] = (T(277) / T(72)) * z[10] + (T(5) / T(2)) * z[16] + z[24];
z[15] = z[4] * z[15];
z[19] = (T(-13) / T(2)) * z[2] + -z[28];
z[19] = z[4] * z[19];
z[19] = T(151) / T(36) + z[19];
z[19] = z[4] * z[19];
z[19] = (T(13) / T(6)) * z[6] + z[19];
z[19] = z[1] * z[19];
z[20] = z[1] * z[8];
z[12] = T(-1) / T(3) + z[12] + z[15] + (T(1) / T(2)) * z[19] + (T(-241) / T(72)) * z[20];
z[12] = z[8] * z[12];
z[15] = 9 * z[2] + (T(-575) / T(9)) * z[10];
z[14] = z[14] + (T(1) / T(4)) * z[15];
z[14] = z[5] * z[14];
z[13] = -z[13] + z[25];
z[13] = z[4] * z[13];
z[15] = -7 * z[2] + -z[9] + (T(-1427) / T(18)) * z[10] + z[11];
z[13] = z[13] + (T(1) / T(2)) * z[15];
z[13] = z[4] * z[13];
z[13] = T(283) / T(36) + z[13] + z[23];
z[13] = (T(1) / T(2)) * z[13] + z[14];
z[13] = z[5] * z[13];
z[14] = z[2] + (T(-259) / T(36)) * z[10];
z[14] = z[4] * z[14];
z[14] = T(355) / T(36) + z[14];
z[14] = z[4] * z[14];
z[15] = T(-13) / T(6) + z[22];
z[15] = z[6] * z[15];
z[14] = z[14] + z[15];
z[12] = z[12] + z[13] + (T(1) / T(2)) * z[14] + z[18];
z[12] = z[7] * z[12];
z[13] = -2 * z[2] + (T(-3) / T(2)) * z[16];
z[13] = z[4] * z[13];
z[13] = T(5) / T(6) + z[13];
z[13] = z[4] * z[13];
z[13] = (T(-13) / T(24)) * z[6] + z[13];
z[13] = z[1] * z[13];
return z[12] + z[13] + (T(1) / T(2)) * z[17] + (T(-13) / T(12)) * z[20];
}



template double eval_coef_2q3y_2l_pmmpp_12345_130(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_130(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
