#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_135(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[37];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[19];
z[3] = v[1];
z[4] = v[4];
z[5] = v[2];
z[6] = iW[1];
z[7] = v[0];
z[8] = iW[17];
z[9] = iW[12];
z[10] = v[3];
z[11] = (T(3) / T(2)) * z[4];
z[12] = prod_pow(z[1], 3);
z[11] = z[11] * z[12];
z[13] = prod_pow(z[1], 2);
z[14] = (T(7) / T(3)) * z[13];
z[15] = -z[11] + z[14];
z[15] = z[4] * z[15];
z[16] = (T(1) / T(3)) * z[13];
z[17] = z[4] * z[12];
z[18] = z[16] + z[17];
z[18] = z[5] * z[18];
z[19] = (T(-2) / T(3)) * z[13] + -z[17];
z[19] = z[7] * z[19];
z[20] = (T(5) / T(3)) * z[1];
z[15] = z[15] + z[18] + z[19] + z[20];
z[15] = z[7] * z[15];
z[18] = z[2] * z[4];
z[19] = z[12] * z[18];
z[21] = (T(3) / T(2)) * z[19];
z[22] = 2 * z[2];
z[23] = z[13] * z[22];
z[24] = z[21] + z[23];
z[25] = (T(3) / T(2)) * z[12];
z[26] = -z[24] + z[25];
z[26] = z[4] * z[26];
z[27] = z[1] * z[2];
z[26] = 2 * z[13] + z[26] + z[27];
z[26] = z[4] * z[26];
z[26] = (T(-31) / T(12)) * z[1] + -z[9] + z[22] + z[26];
z[26] = z[4] * z[26];
z[28] = (T(1) / T(2)) * z[10];
z[29] = z[2] + -z[9];
z[30] = z[28] * z[29];
z[15] = -1 + z[15] + z[26] + z[30];
z[15] = z[4] * z[15];
z[24] = z[4] * z[24];
z[26] = (T(1) / T(2)) * z[8];
z[30] = (T(3) / T(4)) * z[1] + 2 * z[9] + -z[26];
z[30] = z[8] * z[30];
z[24] = (T(-5) / T(6)) * z[13] + z[24] + -z[27] + z[30];
z[24] = z[4] * z[24];
z[30] = (T(1) / T(3)) * z[1];
z[31] = prod_pow(z[8], 2);
z[32] = z[10] * z[31];
z[24] = (T(-7) / T(4)) * z[8] + (T(5) / T(2)) * z[9] + -z[22] + z[24] + z[30] + -z[32];
z[24] = z[4] * z[24];
z[33] = -z[8] + -z[29] + -z[32];
z[33] = z[28] * z[33];
z[34] = z[4] * z[5];
z[35] = z[16] * z[34];
z[24] = -1 + z[24] + z[33] + z[35];
z[24] = z[5] * z[24];
z[33] = (T(1) / T(2)) * z[12];
z[23] = -z[19] + -z[23] + z[33];
z[23] = z[4] * z[23];
z[35] = (T(1) / T(2)) * z[1] + z[9];
z[35] = z[8] * z[35];
z[23] = (T(1) / T(2)) * z[13] + z[23] + -z[35];
z[23] = z[4] * z[23];
z[36] = (T(-4) / T(3)) * z[1] + -z[9];
z[22] = z[8] + z[22] + z[23] + 2 * z[36];
z[22] = z[4] * z[22];
z[23] = z[26] + z[29];
z[23] = z[10] * z[23];
z[22] = T(-8) / T(3) + z[22] + z[23];
z[22] = z[4] * z[22];
z[23] = z[2] * z[13];
z[19] = (T(1) / T(2)) * z[19] + z[23];
z[35] = z[13] + z[35];
z[35] = z[26] * z[35];
z[35] = z[19] + z[35];
z[35] = z[4] * z[35];
z[26] = z[1] + z[9] + -z[26];
z[26] = z[8] * z[26];
z[26] = (T(3) / T(2)) * z[26] + z[35];
z[26] = z[4] * z[26];
z[26] = -z[2] + (T(3) / T(2)) * z[9] + z[26] + z[30] + (T(-3) / T(4)) * z[32];
z[26] = z[4] * z[26];
z[30] = z[28] * z[31];
z[31] = -z[29] + -z[30];
z[28] = z[28] * z[31];
z[26] = T(1) / T(3) + z[26] + z[28];
z[26] = z[5] * z[26];
z[22] = z[22] + z[26];
z[22] = z[5] * z[22];
z[26] = -z[14] + z[17];
z[28] = (T(1) / T(2)) * z[4];
z[26] = z[26] * z[28];
z[31] = z[13] + z[17];
z[31] = z[7] * z[31];
z[20] = -z[20] + z[26] + (T(1) / T(3)) * z[31];
z[26] = prod_pow(z[4], 2);
z[20] = z[20] * z[26];
z[31] = z[4] * z[13];
z[31] = z[1] + z[31];
z[31] = z[31] * z[34];
z[20] = z[20] + (T(2) / T(3)) * z[31];
z[20] = z[7] * z[20];
z[19] = z[19] + -z[33];
z[19] = z[4] * z[19];
z[19] = -z[13] + z[19];
z[19] = z[4] * z[19];
z[31] = (T(19) / T(6)) * z[1] + z[9];
z[19] = -z[2] + z[19] + (T(1) / T(2)) * z[31];
z[19] = z[4] * z[19];
z[31] = -z[10] * z[29];
z[31] = T(25) / T(6) + z[31];
z[19] = z[19] + (T(1) / T(2)) * z[31];
z[19] = z[19] * z[26];
z[19] = z[19] + z[20] + z[22];
z[19] = z[6] * z[19];
z[15] = z[15] + z[19] + z[24];
z[15] = z[6] * z[15];
z[19] = z[21] + z[23] + -z[25];
z[19] = z[4] * z[19];
z[12] = z[3] * z[12];
z[19] = (T(1) / T(2)) * z[12] + -z[13] + z[19] + (T(-3) / T(2)) * z[27];
z[19] = z[4] * z[19];
z[19] = (T(-1) / T(12)) * z[1] + (T(-3) / T(4)) * z[8] + z[19] + -z[29] + (T(-1) / T(4)) * z[32];
z[19] = z[4] * z[19];
z[11] = -z[11] + z[12] + z[16];
z[11] = z[4] * z[11];
z[16] = z[12] + -z[13];
z[20] = z[0] * z[5];
z[20] = -1 + (T(1) / T(3)) * z[20];
z[20] = z[16] * z[20];
z[13] = -z[12] + (T(5) / T(3)) * z[13];
z[21] = z[0] * z[28];
z[13] = z[13] * z[21];
z[13] = z[13] + z[17] + z[20];
z[13] = z[5] * z[13];
z[20] = -z[12] * z[26];
z[22] = z[1] * z[3];
z[23] = 1 + -z[22];
z[20] = z[20] + (T(13) / T(6)) * z[23];
z[20] = z[0] * z[20];
z[11] = z[11] + z[13] + (T(1) / T(2)) * z[20];
z[11] = z[5] * z[11];
z[13] = -z[12] + -z[14] + 3 * z[17];
z[13] = z[13] * z[28];
z[14] = z[16] + -2 * z[17];
z[14] = z[5] * z[14];
z[16] = (T(-1) / T(3)) * z[16] + z[17];
z[16] = z[7] * z[16];
z[13] = z[13] + z[14] + z[16];
z[13] = z[7] * z[13];
z[14] = -z[8] + -z[30];
z[14] = z[10] * z[14];
z[16] = -29 + 13 * z[22];
z[14] = z[14] + (T(1) / T(6)) * z[16];
z[16] = -1 + z[18];
z[12] = z[4] * z[12] * z[16];
z[16] = -z[3] * z[27];
z[12] = z[12] + z[16];
z[12] = z[4] * z[12];
z[12] = T(-19) / T(6) + z[12] + z[22];
z[12] = z[12] * z[21];
return z[11] + z[12] + z[13] + (T(1) / T(2)) * z[14] + z[15] + z[19];
}



template double eval_coef_2q3y_2l_pmmpp_12345_135(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_135(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
