#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_146(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[38];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = iW[21];
z[7] = iW[22];
z[8] = iW[15];
z[9] = iW[2];
z[10] = v[0];
z[11] = iW[4];
z[12] = iW[17];
z[13] = iW[18];
z[14] = -z[9] + z[13];
z[15] = (T(1) / T(2)) * z[6];
z[16] = z[14] * z[15];
z[17] = z[3] * z[16];
z[17] = -z[13] + z[17];
z[16] = z[10] * z[16];
z[18] = -z[6] + z[8] + -z[9];
z[19] = (T(1) / T(4)) * z[12];
z[18] = z[16] + -z[17] + (T(1) / T(4)) * z[18] + z[19];
z[18] = z[3] * z[18];
z[20] = z[10] * z[13];
z[18] = -1 + z[18] + (T(-3) / T(4)) * z[20];
z[18] = z[3] * z[18];
z[20] = z[10] * z[14];
z[21] = -z[6] * z[20];
z[17] = (T(1) / T(2)) * z[9] + z[15] + z[17] + z[21];
z[17] = z[3] * z[17];
z[16] = -z[9] + (T(3) / T(2)) * z[13] + -z[15] + z[16];
z[16] = z[10] * z[16];
z[16] = T(1) / T(2) + z[16] + z[17];
z[16] = z[3] * z[16];
z[17] = -1 + (T(-1) / T(2)) * z[20];
z[17] = z[10] * z[17];
z[16] = z[16] + z[17];
z[16] = z[3] * z[16];
z[17] = (T(1) / T(2)) * z[4];
z[20] = z[4] * z[5] * z[7];
z[21] = -z[5] + z[20];
z[22] = -z[7] + -z[21];
z[22] = z[17] * z[22];
z[23] = z[5] * z[10];
z[24] = -z[0] * z[3];
z[22] = 1 + z[22] + (T(-1) / T(2)) * z[23] + z[24];
z[22] = z[4] * z[22];
z[24] = 3 * z[10];
z[25] = -z[3] + z[10];
z[25] = z[9] * z[25];
z[25] = -1 + z[25];
z[25] = z[3] * z[25];
z[25] = -z[24] + z[25];
z[22] = z[22] + (T(1) / T(2)) * z[25];
z[22] = z[4] * z[22];
z[16] = z[16] + z[22];
z[22] = (T(1) / T(2)) * z[1];
z[16] = z[16] * z[22];
z[25] = (T(1) / T(2)) * z[3];
z[26] = -z[0] + 3 * z[8];
z[26] = z[25] * z[26];
z[27] = (T(1) / T(2)) * z[7];
z[21] = -z[0] + z[8] + z[21] + z[27];
z[21] = z[4] * z[21];
z[21] = T(-3) / T(2) + z[21] + z[23] + z[26];
z[17] = z[17] * z[21];
z[21] = z[10] * z[11];
z[26] = 5 + z[21];
z[26] = z[10] * z[26];
z[16] = z[16] + z[17] + z[18] + (T(1) / T(4)) * z[26];
z[16] = z[1] * z[16];
z[17] = z[6] + z[7];
z[18] = z[0] * z[8];
z[17] = z[17] * z[18];
z[26] = z[0] * z[7];
z[28] = z[0] * z[6];
z[28] = z[26] + z[28];
z[28] = z[5] * z[28];
z[17] = z[17] + z[28];
z[28] = z[6] * z[8];
z[29] = z[7] * z[8];
z[30] = z[28] + z[29];
z[31] = z[3] * z[30];
z[32] = 1 + z[23];
z[33] = z[6] * z[32];
z[31] = z[31] + z[33];
z[31] = z[22] * z[31];
z[33] = z[5] * z[6];
z[30] = (T(1) / T(2)) * z[30] + z[31] + z[33];
z[30] = z[1] * z[30];
z[17] = (T(1) / T(2)) * z[17] + z[30];
z[17] = z[2] * z[17];
z[30] = z[3] * z[7];
z[31] = z[18] * z[30];
z[33] = (T(3) / T(2)) * z[31];
z[34] = z[5] * z[27];
z[34] = -z[18] + z[34];
z[35] = z[0] * z[15];
z[17] = z[17] + z[26] + z[33] + -z[34] + z[35];
z[26] = -z[11] + z[12];
z[35] = -z[8] + z[26];
z[36] = -z[7] * z[35];
z[28] = -z[28] + z[36];
z[28] = z[25] * z[28];
z[36] = -z[8] + (T(1) / T(2)) * z[12];
z[37] = z[0] + z[27];
z[28] = -z[15] + z[28] + -z[36] + -z[37];
z[28] = z[3] * z[28];
z[24] = -z[6] * z[24];
z[24] = z[24] + z[32];
z[24] = (T(1) / T(2)) * z[24] + z[28];
z[22] = z[22] * z[24];
z[24] = (T(1) / T(2)) * z[8];
z[28] = z[3] * z[29];
z[22] = z[0] + (T(1) / T(2)) * z[5] + (T(-1) / T(4)) * z[7] + -z[15] + z[22] + z[24] + (T(3) / T(4)) * z[28];
z[22] = z[1] * z[22];
z[17] = (T(1) / T(2)) * z[17] + z[22];
z[17] = z[2] * z[17];
z[22] = -z[30] * z[35];
z[28] = z[11] + z[13];
z[15] = (T(1) / T(2)) * z[0] + -z[7] + z[15] + z[22] + z[28] + -z[36];
z[15] = z[3] * z[15];
z[22] = -z[10] * z[28];
z[22] = -7 + z[22] + -z[23];
z[29] = -z[5] + z[8] + -z[37];
z[29] = z[4] * z[29];
z[15] = z[15] + (T(1) / T(2)) * z[22] + z[29];
z[19] = z[19] + z[24] + z[37];
z[19] = z[3] * z[19];
z[20] = 3 * z[7] + z[20];
z[20] = z[4] * z[20];
z[20] = z[20] + z[32];
z[19] = z[19] + (T(1) / T(4)) * z[20];
z[19] = z[4] * z[19];
z[20] = 3 * z[6] + z[28];
z[20] = z[10] * z[20];
z[22] = -z[6] + z[8] + z[12] + -z[13];
z[22] = z[3] * z[22];
z[20] = 3 + z[20] + z[22];
z[20] = z[20] * z[25];
z[20] = -z[10] + z[20];
z[19] = z[19] + (T(1) / T(2)) * z[20];
z[19] = z[1] * z[19];
z[15] = (T(1) / T(2)) * z[15] + z[19];
z[15] = z[1] * z[15];
z[19] = z[0] * z[27];
z[19] = z[18] + z[19] + z[33];
z[19] = z[3] * z[19];
z[20] = z[4] * z[34];
z[22] = -z[7] + -z[28];
z[19] = z[5] + z[19] + -z[20] + (T(1) / T(2)) * z[22];
z[15] = z[15] + z[17] + (T(1) / T(2)) * z[19];
z[15] = z[2] * z[15];
z[14] = z[6] * z[14];
z[17] = -z[7] * z[26];
z[14] = z[14] + z[17] + z[18] + z[31];
z[14] = z[14] * z[25];
z[14] = (T(1) / T(2)) * z[11] + -z[13] + z[14];
z[14] = z[3] * z[14];
z[17] = 3 + z[21] + -z[23];
z[18] = z[3] * z[18];
z[18] = z[5] + z[18];
z[18] = (T(1) / T(2)) * z[18] + -z[20];
z[18] = z[4] * z[18];
z[14] = z[14] + (T(1) / T(2)) * z[17] + z[18];
return (T(1) / T(2)) * z[14] + z[15] + z[16];
}



template double eval_coef_2q3y_2l_pmmpp_12345_146(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_146(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
