#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_148(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[47];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[15];
z[6] = iW[3];
z[7] = iW[22];
z[8] = v[1];
z[9] = v[0];
z[10] = iW[4];
z[11] = iW[23];
z[12] = z[5] * z[6];
z[13] = 5 * z[12];
z[14] = prod_pow(z[6], 2);
z[15] = z[13] + (T(-19) / T(2)) * z[14];
z[16] = (T(1) / T(6)) * z[4];
z[15] = z[15] * z[16];
z[17] = prod_pow(z[7], 2);
z[18] = z[3] * z[17];
z[19] = (T(1) / T(2)) * z[18];
z[15] = (T(-1) / T(3)) * z[6] + z[15] + -z[19];
z[15] = z[0] * z[15];
z[20] = (T(13) / T(3)) * z[14];
z[21] = (T(1) / T(2)) * z[5];
z[22] = z[10] + z[21];
z[23] = z[11] * z[22];
z[24] = -z[20] + z[23];
z[25] = 13 * z[14];
z[26] = (T(-7) / T(2)) * z[12] + z[25];
z[27] = z[0] * z[2];
z[26] = z[26] * z[27];
z[15] = z[15] + (T(1) / T(2)) * z[24] + (T(1) / T(12)) * z[26];
z[15] = z[2] * z[15];
z[24] = z[0] * z[5];
z[26] = z[4] * z[6];
z[28] = z[24] * z[26];
z[29] = z[0] * z[6];
z[28] = 29 * z[14] + (T(-13) / T(4)) * z[28] + 5 * z[29];
z[28] = z[16] * z[28];
z[29] = z[5] + -z[10];
z[30] = (T(17) / T(6)) * z[6] + z[18] + z[29];
z[31] = z[9] * z[14];
z[32] = (T(13) / T(12)) * z[31];
z[33] = -z[5] + -2 * z[10];
z[33] = z[3] * z[33];
z[33] = T(-9) / T(4) + z[33];
z[33] = z[11] * z[33];
z[34] = z[7] + z[18];
z[35] = -z[3] * z[34];
z[35] = T(7) / T(24) + z[35];
z[35] = z[0] * z[35];
z[15] = z[15] + z[28] + (T(1) / T(2)) * z[30] + z[32] + z[33] + z[35];
z[15] = z[2] * z[15];
z[12] = -z[12] + z[24];
z[28] = z[6] * z[7];
z[30] = -z[17] + z[28];
z[33] = z[26] * z[30];
z[35] = (T(3) / T(2)) * z[33];
z[36] = 2 * z[7];
z[37] = (T(-19) / T(6)) * z[6] + z[36];
z[37] = z[6] * z[37];
z[37] = (T(13) / T(24)) * z[12] + (T(-5) / T(2)) * z[17] + z[35] + z[37];
z[37] = z[4] * z[37];
z[38] = (T(3) / T(2)) * z[0];
z[39] = (T(13) / T(6)) * z[31];
z[37] = (T(25) / T(12)) * z[6] + -2 * z[18] + z[37] + z[38] + -z[39];
z[37] = z[4] * z[37];
z[13] = z[13] + -5 * z[24] + z[25];
z[13] = z[13] * z[16];
z[16] = z[3] * z[11];
z[24] = -z[16] * z[22];
z[12] = z[2] * z[12];
z[12] = (T(-3) / T(4)) * z[0] + (T(13) / T(8)) * z[6] + (T(7) / T(24)) * z[12] + z[13] + z[24];
z[12] = z[2] * z[12];
z[13] = z[7] * z[10];
z[24] = z[13] + z[17];
z[24] = z[3] * z[24];
z[25] = -z[7] + -z[21];
z[25] = -z[24] + (T(3) / T(2)) * z[25];
z[25] = z[3] * z[25];
z[22] = z[3] * z[22];
z[40] = T(9) / T(4) + z[22];
z[41] = z[16] * z[40];
z[42] = z[6] * z[9];
z[43] = (T(4) / T(3)) * z[42];
z[12] = T(7) / T(3) + z[12] + z[25] + z[37] + z[41] + -z[43];
z[12] = z[2] * z[12];
z[25] = (T(1) / T(2)) * z[26];
z[25] = z[25] * z[30];
z[26] = (T(-3) / T(2)) * z[17] + z[25] + z[28];
z[26] = z[4] * z[26];
z[28] = (T(5) / T(4)) * z[6] + -z[18];
z[28] = (T(25) / T(4)) * z[0] + 3 * z[28];
z[26] = z[26] + (T(1) / T(2)) * z[28];
z[26] = z[4] * z[26];
z[24] = -z[7] + (T(-1) / T(2)) * z[24];
z[24] = z[3] * z[24];
z[28] = (T(1) / T(2)) * z[23];
z[37] = prod_pow(z[3], 2) * z[28];
z[24] = T(35) / T(12) + z[24] + z[26] + (T(-25) / T(24)) * z[27] + z[37];
z[24] = z[2] * z[24];
z[26] = (T(1) / T(2)) * z[6];
z[37] = z[26] + -z[36];
z[37] = z[6] * z[37];
z[37] = 2 * z[17] + -z[33] + z[37];
z[37] = z[4] * z[37];
z[18] = (T(-25) / T(8)) * z[0] + (T(-7) / T(2)) * z[6] + -z[7] + z[18] + z[32] + z[37];
z[18] = z[4] * z[18];
z[37] = T(-35) / T(3) + 3 * z[16];
z[18] = z[18] + (T(1) / T(2)) * z[37] + z[43];
z[18] = z[4] * z[18];
z[37] = z[3] * z[5];
z[37] = 1 + z[37];
z[37] = z[3] * z[37];
z[37] = z[9] + z[37];
z[37] = (T(1) / T(4)) * z[37];
z[18] = z[18] + z[24] + z[37];
z[18] = z[2] * z[18];
z[24] = (T(1) / T(2)) * z[17];
z[41] = z[7] + -z[26];
z[41] = z[6] * z[41];
z[41] = -z[24] + z[25] + z[41];
z[41] = z[4] * z[41];
z[43] = z[7] + (T(3) / T(2)) * z[11];
z[39] = (T(25) / T(12)) * z[0] + (T(13) / T(4)) * z[6] + -z[39] + z[43];
z[39] = (T(1) / T(2)) * z[39] + z[41];
z[39] = z[4] * z[39];
z[41] = 19 + (T(-13) / T(2)) * z[42];
z[39] = z[39] + (T(1) / T(6)) * z[41];
z[39] = z[4] * z[39];
z[41] = (T(1) / T(2)) * z[9];
z[39] = z[39] + -z[41];
z[39] = z[4] * z[39];
z[44] = z[0] * z[3];
z[45] = -1 + (T(3) / T(2)) * z[44];
z[45] = z[4] * z[45];
z[41] = z[3] + -z[41] + z[45];
z[41] = z[4] * z[41];
z[45] = 1 + -3 * z[44];
z[45] = z[4] * z[45];
z[46] = z[2] * z[44];
z[45] = -z[3] + z[45] + z[46];
z[45] = z[2] * z[45];
z[41] = z[41] + (T(1) / T(2)) * z[45];
z[41] = z[2] * z[41];
z[45] = 1 + -z[44];
z[45] = z[4] * z[45];
z[45] = -z[3] + z[9] + z[45];
z[45] = prod_pow(z[4], 2) * z[45];
z[41] = z[41] + (T(1) / T(2)) * z[45];
z[41] = z[1] * z[41];
z[18] = z[18] + z[39] + (T(1) / T(2)) * z[41];
z[18] = z[1] * z[18];
z[31] = (T(13) / T(2)) * z[31];
z[38] = (T(-71) / T(12)) * z[6] + z[31] + -z[38] + -z[43];
z[39] = (T(3) / T(2)) * z[6];
z[36] = -z[36] + z[39];
z[36] = z[6] * z[36];
z[36] = z[17] + -z[35] + z[36];
z[36] = z[4] * z[36];
z[36] = z[36] + (T(1) / T(2)) * z[38];
z[36] = z[4] * z[36];
z[21] = z[3] * z[21];
z[21] = T(-17) / T(3) + z[21] + (T(13) / T(3)) * z[42];
z[21] = (T(1) / T(2)) * z[21] + z[36];
z[21] = z[4] * z[21];
z[12] = z[12] + z[18] + z[21] + z[37];
z[12] = z[1] * z[12];
z[18] = (T(7) / T(12)) * z[6];
z[21] = -z[18] + -z[34];
z[21] = z[0] * z[21];
z[20] = z[17] + -z[20] + z[21];
z[21] = -1 + z[27];
z[21] = z[21] * z[26] * z[30];
z[17] = (T(19) / T(12)) * z[14] + -z[17];
z[17] = z[0] * z[17];
z[17] = z[17] + z[21];
z[17] = z[2] * z[17];
z[17] = z[17] + (T(1) / T(2)) * z[20] + z[23] + -z[25];
z[17] = z[2] * z[17];
z[14] = z[14] + -z[33];
z[14] = z[4] * z[14];
z[14] = z[14] + z[18] + z[29];
z[18] = -z[11] * z[40];
z[20] = z[8] * z[28];
z[14] = (T(1) / T(2)) * z[14] + z[17] + z[18] + z[20] + z[32];
z[14] = z[8] * z[14];
z[17] = z[7] + -z[39];
z[17] = z[6] * z[17];
z[17] = z[17] + -z[24] + z[35];
z[17] = z[4] * z[17];
z[18] = -z[5] + (T(25) / T(6)) * z[6];
z[18] = (T(-7) / T(12)) * z[0] + 3 * z[11] + (T(1) / T(2)) * z[18] + -z[31];
z[17] = z[17] + (T(1) / T(2)) * z[18];
z[17] = z[4] * z[17];
z[18] = T(9) / T(2) + z[22];
z[16] = z[16] * z[18];
z[13] = -z[3] * z[13];
z[13] = (T(-3) / T(2)) * z[5] + z[13];
z[13] = z[3] * z[13];
z[13] = T(-1) / T(6) + z[13] + z[16];
z[16] = -z[7] + -z[19];
z[16] = z[3] * z[16];
z[16] = T(-1) / T(2) + z[16];
z[16] = z[16] * z[44];
return z[12] + (T(1) / T(2)) * z[13] + z[14] + z[15] + z[16] + z[17] + (T(-13) / T(12)) * z[42];
}



template double eval_coef_2q3y_2l_pmmpp_12345_148(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_148(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
