#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_152(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[49];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = v[1];
z[7] = iW[12];
z[8] = iW[17];
z[9] = iW[2];
z[10] = iW[5];
z[11] = v[0];
z[12] = iW[4];
z[13] = iW[18];
z[14] = z[5] + z[9];
z[14] = z[10] * z[14];
z[15] = prod_pow(z[9], 2);
z[16] = z[14] + -z[15];
z[17] = z[4] * z[10];
z[18] = z[16] * z[17];
z[14] = z[14] + z[15];
z[19] = -z[14] + z[18];
z[19] = z[4] * z[19];
z[19] = z[9] + z[19];
z[19] = z[4] * z[19];
z[20] = z[3] * z[13];
z[19] = z[19] + -z[20];
z[21] = (T(1) / T(4)) * z[11];
z[19] = z[19] * z[21];
z[22] = 2 * z[9];
z[23] = (T(1) / T(2)) * z[5];
z[24] = -z[22] + -z[23];
z[24] = z[10] * z[24];
z[25] = (T(1) / T(2)) * z[15];
z[24] = z[24] + z[25];
z[24] = z[4] * z[24];
z[26] = (T(3) / T(2)) * z[5] + z[9];
z[24] = z[10] + z[24] + (T(-1) / T(2)) * z[26];
z[24] = z[4] * z[24];
z[24] = T(-5) / T(4) + z[24];
z[24] = z[4] * z[24];
z[27] = z[4] * z[15];
z[28] = -z[9] + z[27];
z[28] = z[4] * z[28];
z[20] = T(-3) / T(2) + z[20] + z[28];
z[28] = (T(1) / T(2)) * z[3];
z[20] = z[20] * z[28];
z[19] = z[19] + z[20] + z[24];
z[19] = z[11] * z[19];
z[20] = z[12] + z[13];
z[24] = z[20] * z[21];
z[29] = (T(5) / T(2)) * z[7];
z[30] = (T(3) / T(2)) * z[8];
z[31] = z[0] + z[29] + -z[30];
z[31] = z[4] * z[31];
z[32] = (T(1) / T(2)) * z[13];
z[33] = -z[7] + z[32];
z[34] = (T(-1) / T(2)) * z[12] + -z[33];
z[34] = z[28] * z[34];
z[31] = z[24] + z[31] + z[34];
z[31] = z[3] * z[31];
z[34] = 3 * z[7];
z[35] = -z[8] + z[34];
z[36] = z[23] + -z[35];
z[36] = z[8] * z[36];
z[37] = prod_pow(z[8], 2);
z[38] = z[4] * z[37];
z[39] = -z[7] + -z[23];
z[39] = z[38] * z[39];
z[36] = z[36] + z[39];
z[36] = z[4] * z[36];
z[39] = -z[7] + z[30];
z[36] = z[36] + 3 * z[39];
z[39] = (T(1) / T(2)) * z[4];
z[36] = z[36] * z[39];
z[40] = -z[0] + -z[7];
z[38] = z[8] + (T(1) / T(4)) * z[38] + (T(1) / T(2)) * z[40];
z[38] = z[3] * z[38];
z[36] = z[36] + z[38];
z[36] = z[2] * z[36];
z[38] = 7 * z[7] + -z[23];
z[40] = z[4] * z[7] * z[30];
z[38] = -3 * z[8] + (T(1) / T(2)) * z[38] + z[40];
z[38] = z[4] * z[38];
z[38] = T(-3) / T(4) + z[38];
z[38] = z[4] * z[38];
z[31] = z[31] + z[36] + z[38];
z[31] = z[2] * z[31];
z[36] = (T(3) / T(2)) * z[10];
z[38] = (T(1) / T(2)) * z[8];
z[22] = (T(1) / T(4)) * z[5] + (T(-3) / T(2)) * z[7] + z[22] + -z[36] + z[38];
z[22] = z[4] * z[22];
z[22] = T(-1) / T(4) + z[22];
z[22] = prod_pow(z[4], 2) * z[22];
z[40] = z[7] * z[9];
z[41] = -z[25] + z[40];
z[42] = z[8] * z[10];
z[41] = (T(1) / T(2)) * z[41] + -z[42];
z[41] = z[4] * z[41];
z[43] = (T(1) / T(2)) * z[10];
z[44] = (T(1) / T(4)) * z[9] + -z[43];
z[41] = -z[7] + z[38] + z[41] + z[44];
z[41] = z[4] * z[41];
z[45] = -z[4] * z[42];
z[45] = -z[32] + z[45];
z[45] = z[28] * z[45];
z[41] = T(1) / T(2) + z[41] + z[45];
z[41] = z[3] * z[41];
z[45] = z[40] + -z[42];
z[46] = -z[25] + z[45];
z[46] = z[39] * z[46];
z[47] = (T(1) / T(2)) * z[9];
z[48] = -z[7] + z[47];
z[48] = -z[0] + 5 * z[48];
z[46] = z[8] + -2 * z[10] + z[46] + (T(1) / T(2)) * z[48];
z[46] = z[4] * z[46];
z[46] = T(-1) / T(2) + z[46];
z[46] = z[4] * z[46];
z[41] = z[41] + z[46];
z[41] = z[3] * z[41];
z[19] = z[19] + z[22] + z[31] + z[41];
z[19] = z[1] * z[19];
z[22] = (T(1) / T(4)) * z[15] + -z[40] + (T(1) / T(2)) * z[42];
z[22] = z[4] * z[22];
z[31] = (T(1) / T(2)) * z[0];
z[22] = (T(-7) / T(4)) * z[9] + z[10] + z[22] + -z[30] + -z[31] + z[34];
z[22] = z[4] * z[22];
z[30] = -z[4] * z[45];
z[30] = z[7] + z[30] + z[32];
z[30] = z[28] * z[30];
z[22] = T(-5) / T(4) + z[22] + z[30];
z[22] = z[3] * z[22];
z[18] = z[14] + (T(-3) / T(2)) * z[18];
z[18] = z[4] * z[18];
z[30] = -z[9] + z[12];
z[18] = z[18] + (T(1) / T(2)) * z[30];
z[18] = z[11] * z[18];
z[30] = z[9] + z[23];
z[30] = z[10] * z[30];
z[15] = -z[15] + 5 * z[30];
z[15] = z[4] * z[15];
z[15] = z[5] + z[15] + z[44];
z[15] = z[4] * z[15];
z[20] = -z[9] + -z[20];
z[20] = (T(1) / T(2)) * z[20] + -z[27];
z[20] = z[20] * z[28];
z[15] = T(3) / T(2) + z[15] + (T(1) / T(2)) * z[18] + z[20];
z[15] = z[11] * z[15];
z[18] = -z[5] + -2 * z[7] + z[38];
z[18] = z[4] * z[18];
z[18] = T(5) / T(4) + z[18];
z[18] = z[8] * z[18];
z[18] = -z[5] + z[18] + -z[29];
z[18] = z[4] * z[18];
z[20] = z[37] * z[39];
z[27] = z[0] + z[33];
z[20] = z[8] + (T(1) / T(4)) * z[12] + z[20] + (T(1) / T(2)) * z[27];
z[20] = z[3] * z[20];
z[27] = z[0] * z[2];
z[18] = T(-3) / T(2) + z[18] + z[20] + -z[24] + z[27];
z[18] = z[2] * z[18];
z[20] = -z[0] + -z[5] + (T(-9) / T(2)) * z[9] + z[35] + z[36];
z[20] = z[4] * z[20];
z[20] = T(-1) / T(4) + z[20];
z[20] = z[4] * z[20];
z[15] = z[15] + z[18] + z[19] + z[20] + z[22];
z[15] = z[1] * z[15];
z[18] = z[6] * z[10];
z[17] = 3 * z[17] + -z[18];
z[16] = z[16] * z[17];
z[14] = -z[14] + z[16];
z[14] = z[14] * z[21];
z[16] = (T(7) / T(2)) * z[5];
z[17] = -4 * z[9] + -z[16];
z[17] = z[10] * z[17];
z[17] = z[17] + z[25];
z[17] = z[4] * z[17];
z[18] = z[18] * z[26];
z[19] = -z[5] + z[9];
z[19] = -z[10] + (T(1) / T(2)) * z[19];
z[14] = z[14] + z[17] + z[18] + (T(1) / T(2)) * z[19];
z[14] = z[11] * z[14];
z[17] = z[0] * z[7];
z[18] = z[0] + z[38];
z[18] = z[8] * z[18];
z[17] = z[17] + z[18] + z[45];
z[17] = z[17] * z[39];
z[18] = z[0] * z[8];
z[18] = z[18] + -z[42];
z[18] = z[18] * z[28];
z[18] = -z[0] + z[18];
z[17] = z[17] + z[18] + z[47];
z[17] = z[3] * z[17];
z[16] = -z[9] + -z[16];
z[16] = (T(1) / T(2)) * z[16] + -z[18] + -z[43];
z[16] = z[6] * z[16];
z[18] = (T(5) / T(2)) * z[5] + -z[7] + 3 * z[9] + z[31] + z[43];
z[18] = z[4] * z[18];
z[19] = -z[2] + z[6];
z[19] = z[19] * z[23];
z[20] = -z[4] * z[5];
z[19] = -1 + z[19] + z[20];
z[19] = z[0] * z[19];
z[19] = z[5] + z[19];
z[19] = z[2] * z[19];
return T(3) / T(2) + z[14] + z[15] + z[16] + z[17] + z[18] + z[19];
}



template double eval_coef_2q3y_2l_pmmpp_12345_152(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_152(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
