#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_154(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[45];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[1];
z[4] = v[2];
z[5] = v[4];
z[6] = iW[15];
z[7] = v[3];
z[8] = iW[1];
z[9] = iW[17];
z[10] = v[0];
z[11] = iW[4];
z[12] = iW[7];
z[13] = iW[12];
z[14] = iW[18];
z[15] = (T(1) / T(2)) * z[11];
z[16] = (T(3) / T(2)) * z[12];
z[17] = z[14] + z[15] + -z[16];
z[18] = z[6] * z[17];
z[19] = (T(1) / T(2)) * z[0];
z[20] = -z[1] + z[6];
z[20] = z[19] * z[20];
z[21] = prod_pow(z[1], 2);
z[20] = z[18] + z[20] + (T(-31) / T(6)) * z[21];
z[22] = (T(1) / T(2)) * z[4];
z[20] = z[20] * z[22];
z[23] = z[1] + z[6];
z[24] = z[0] * z[23];
z[24] = (T(19) / T(3)) * z[21] + z[24];
z[24] = z[5] * z[24];
z[25] = (T(1) / T(4)) * z[14];
z[26] = (T(1) / T(2)) * z[6];
z[27] = z[3] * z[26];
z[27] = T(101) / T(36) + z[27];
z[27] = z[11] * z[27];
z[28] = (T(3) / T(4)) * z[12];
z[29] = z[10] * z[21];
z[30] = (T(11) / T(3)) * z[29];
z[31] = z[6] * z[11];
z[32] = z[7] * z[31];
z[20] = (T(-11) / T(3)) * z[1] + -z[19] + z[20] + (T(1) / T(4)) * z[24] + -z[25] + z[27] + -z[28] + z[30] + (T(-5) / T(4)) * z[32];
z[20] = z[4] * z[20];
z[24] = (T(55) / T(9)) * z[11];
z[27] = (T(-101) / T(9)) * z[1] + z[14];
z[27] = -z[24] + (T(1) / T(2)) * z[27] + z[29];
z[27] = z[10] * z[27];
z[27] = T(-263) / T(18) + z[27];
z[33] = 3 * z[1] + (T(95) / T(6)) * z[13] + z[26];
z[34] = z[1] + z[13];
z[34] = z[9] * z[34];
z[35] = z[5] * z[34];
z[30] = -z[30] + (T(1) / T(2)) * z[33] + (T(19) / T(3)) * z[35];
z[30] = z[5] * z[30];
z[33] = -z[26] + 3 * z[29];
z[35] = z[1] + -z[14];
z[35] = z[24] + -z[33] + (T(1) / T(2)) * z[35];
z[36] = z[6] * z[7];
z[17] = -z[17] * z[36];
z[17] = z[17] + (T(1) / T(2)) * z[35];
z[17] = z[4] * z[17];
z[35] = z[9] * z[11];
z[37] = z[31] + (T(-1) / T(4)) * z[35];
z[37] = z[7] * z[37];
z[28] = (T(-1) / T(4)) * z[9] + (T(-23) / T(9)) * z[11] + (T(19) / T(12)) * z[13] + z[14] + z[28] + z[37];
z[28] = z[7] * z[28];
z[17] = z[17] + (T(1) / T(2)) * z[27] + z[28] + z[30];
z[17] = z[4] * z[17];
z[27] = (T(1) / T(2)) * z[10];
z[28] = z[10] * z[14];
z[30] = 1 + z[28];
z[30] = z[27] * z[30];
z[37] = (T(19) / T(3)) * z[13];
z[38] = 3 * z[12];
z[39] = z[37] + z[38];
z[40] = (T(1) / T(2)) * z[5];
z[41] = z[39] * z[40];
z[41] = T(-55) / T(9) + z[41];
z[41] = z[5] * z[41];
z[42] = z[7] * z[14];
z[43] = z[28] + (T(-3) / T(2)) * z[42];
z[43] = z[7] * z[43];
z[30] = z[30] + z[41] + z[43];
z[41] = (T(1) / T(2)) * z[7];
z[30] = z[30] * z[41];
z[15] = -z[9] * z[15];
z[15] = z[15] + z[18];
z[15] = z[7] * z[15];
z[18] = z[14] + z[37];
z[15] = -z[9] + z[15] + (T(1) / T(2)) * z[18] + -z[24] + z[26];
z[15] = z[7] * z[15];
z[18] = z[21] + z[34];
z[18] = z[5] * z[9] * z[18];
z[18] = (T(1) / T(3)) * z[18] + z[34];
z[24] = 19 * z[5];
z[18] = z[18] * z[24];
z[37] = 19 * z[13];
z[18] = -z[9] + z[18] + z[37];
z[18] = z[18] * z[40];
z[43] = (T(1) / T(2)) * z[1] + -z[29];
z[43] = z[10] * z[43];
z[15] = T(-13) / T(6) + z[15] + z[18] + z[43];
z[15] = z[15] * z[22];
z[18] = (T(-1) / T(2)) * z[9] + z[26] + -z[39];
z[18] = z[5] * z[18];
z[35] = z[31] + z[35];
z[44] = -z[35] * z[41];
z[44] = -z[9] + (T(-3) / T(2)) * z[14] + z[44];
z[44] = z[7] * z[44];
z[18] = T(283) / T(18) + z[18] + -z[28] + z[44];
z[18] = z[18] * z[41];
z[34] = (T(-1) / T(2)) * z[21] + -z[34];
z[34] = z[5] * z[34];
z[34] = (T(-1) / T(4)) * z[1] + (T(-1) / T(3)) * z[13] + (T(1) / T(6)) * z[34];
z[24] = z[24] * z[34];
z[34] = (T(-13) / T(3)) * z[1] + -z[29];
z[34] = z[10] * z[34];
z[34] = T(3) / T(2) + z[34];
z[24] = z[24] + (T(1) / T(2)) * z[34];
z[24] = z[5] * z[24];
z[34] = z[1] * z[10];
z[44] = T(-64) / T(9) + (T(3) / T(4)) * z[34];
z[44] = z[10] * z[44];
z[15] = z[15] + z[18] + z[24] + z[44];
z[15] = z[4] * z[15];
z[18] = T(-211) / T(4) + 23 * z[34];
z[24] = (T(1) / T(9)) * z[10];
z[18] = z[18] * z[24];
z[16] = -z[16] + (T(19) / T(6)) * z[29];
z[24] = z[1] + (T(1) / T(2)) * z[13];
z[24] = -z[16] + (T(19) / T(3)) * z[24];
z[24] = z[24] * z[40];
z[44] = 7 * z[1] + (T(-19) / T(4)) * z[29];
z[44] = z[10] * z[44];
z[44] = 1 + z[44];
z[24] = z[24] + (T(1) / T(3)) * z[44];
z[24] = z[5] * z[24];
z[24] = -z[18] + z[24];
z[24] = z[5] * z[24];
z[44] = prod_pow(z[10], 2);
z[15] = z[15] + z[24] + z[30] + (T(-1) / T(4)) * z[44];
z[15] = z[8] * z[15];
z[24] = (T(19) / T(3)) * z[29];
z[30] = (T(-73) / T(2)) * z[1] + -z[37];
z[30] = z[24] + z[26] + (T(1) / T(3)) * z[30] + -z[38];
z[30] = z[5] * z[30];
z[24] = (T(-21) / T(2)) * z[1] + z[24];
z[24] = z[10] * z[24];
z[24] = 3 + z[24] + z[30];
z[24] = z[24] * z[40];
z[30] = z[6] + -z[39];
z[30] = z[5] * z[30];
z[35] = -z[7] * z[35];
z[35] = -z[6] + -z[9] + 5 * z[14] + z[35];
z[35] = z[7] * z[35];
z[30] = T(101) / T(9) + -z[28] + z[30] + z[35];
z[30] = z[7] * z[30];
z[15] = z[15] + z[17] + z[18] + z[24] + (T(1) / T(4)) * z[30];
z[15] = z[8] * z[15];
z[17] = (T(35) / T(2)) * z[1] + z[37];
z[18] = z[0] * z[5] * z[26];
z[16] = -z[16] + (T(1) / T(3)) * z[17] + z[18];
z[16] = z[5] * z[16];
z[17] = z[6] + z[11];
z[18] = z[3] * z[31];
z[18] = -z[17] + z[18] + -3 * z[32];
z[18] = z[3] * z[18];
z[24] = (T(7) / T(2)) * z[1] + (T(-11) / T(3)) * z[11];
z[24] = 5 * z[24] + (T(-19) / T(2)) * z[29];
z[24] = z[10] * z[24];
z[17] = -z[14] + z[17] + (T(3) / T(2)) * z[32];
z[17] = z[7] * z[17];
z[16] = T(-13) / T(2) + z[16] + z[17] + (T(1) / T(2)) * z[18] + (T(1) / T(3)) * z[24];
z[17] = -1 + z[28];
z[18] = z[17] * z[27];
z[24] = z[14] * z[41];
z[24] = -z[17] + z[24];
z[24] = z[7] * z[24];
z[18] = z[18] + z[24];
z[18] = z[7] * z[18];
z[18] = z[18] + (T(-1) / T(2)) * z[44];
z[18] = z[7] * z[18];
z[24] = -7 + 5 * z[34];
z[24] = z[10] * z[24];
z[28] = -1 + -z[36];
z[28] = z[7] * z[28];
z[24] = z[24] + z[28];
z[26] = z[7] * z[26];
z[26] = T(1) / T(2) + z[26] + z[43];
z[26] = z[4] * z[26];
z[24] = (T(1) / T(2)) * z[24] + z[26];
z[24] = z[4] * z[24];
z[26] = -z[7] + 3 * z[10];
z[26] = z[7] * z[26];
z[26] = z[26] + -z[44];
z[24] = z[24] + (T(3) / T(2)) * z[26];
z[24] = z[4] * z[24];
z[18] = z[18] + z[24];
z[18] = z[8] * z[18];
z[17] = z[17] + -z[42];
z[17] = z[7] * z[17];
z[17] = z[17] + -z[27];
z[17] = z[17] * z[41];
z[24] = z[1] + -z[33];
z[24] = z[22] * z[24];
z[24] = -1 + z[24] + (T(3) / T(2)) * z[34];
z[24] = z[4] * z[24];
z[26] = 3 * z[7] + -z[10];
z[24] = z[24] + (T(1) / T(4)) * z[26];
z[24] = z[4] * z[24];
z[17] = z[17] + (T(1) / T(2)) * z[18] + z[24];
z[17] = z[8] * z[17];
z[18] = z[0] * z[3];
z[24] = -3 + -z[18];
z[21] = z[21] * z[24];
z[19] = z[19] * z[23];
z[19] = z[19] + z[21];
z[19] = z[19] * z[22];
z[21] = z[0] + -z[1];
z[22] = -z[1] * z[18];
z[19] = z[19] + (T(3) / T(4)) * z[21] + z[22];
z[19] = z[4] * z[19];
z[21] = z[0] * z[7];
z[18] = -z[18] + z[21];
z[18] = (T(1) / T(2)) * z[18] + z[19];
z[18] = z[4] * z[18];
z[19] = prod_pow(z[7], 2) * z[25];
z[17] = z[17] + z[18] + z[19];
z[17] = z[2] * z[17];
return z[15] + (T(1) / T(2)) * z[16] + z[17] + z[20];
}



template double eval_coef_2q3y_2l_pmmpp_12345_154(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_154(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
