#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_156(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[54];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[2];
z[4] = v[4];
z[5] = iW[22];
z[6] = iW[15];
z[7] = v[3];
z[8] = iW[16];
z[9] = iW[1];
z[10] = v[0];
z[11] = iW[17];
z[12] = iW[18];
z[13] = 3 * z[9];
z[14] = prod_pow(z[9], 2);
z[15] = z[10] * z[14];
z[16] = z[13] + z[15];
z[16] = z[10] * z[16];
z[17] = z[0] * z[3];
z[18] = z[0] * z[4];
z[16] = -3 + -z[16] + z[17] + -z[18];
z[16] = prod_pow(z[3], 3) * z[2] * z[16];
z[19] = (T(1) / T(2)) * z[10];
z[20] = z[14] * z[19];
z[21] = z[9] + z[20];
z[22] = z[3] * z[21];
z[21] = z[10] * z[21];
z[21] = T(1) / T(2) + z[21];
z[21] = 3 * z[21] + z[22];
z[23] = prod_pow(z[3], 2);
z[21] = z[21] * z[23];
z[21] = (T(-1) / T(2)) * z[16] + z[21];
z[21] = z[2] * z[21];
z[24] = (T(1) / T(2)) * z[4];
z[25] = z[14] * z[24];
z[26] = -z[9] + z[25];
z[26] = z[4] * z[26];
z[26] = T(1) / T(2) + z[26];
z[27] = z[4] * z[14];
z[28] = -z[9] + z[27];
z[19] = z[19] * z[28];
z[19] = z[19] + z[26];
z[19] = z[10] * z[19];
z[29] = z[9] + z[25];
z[30] = z[15] + z[29];
z[30] = z[10] * z[30];
z[31] = z[4] * z[9];
z[22] = -1 + z[22] + z[30] + z[31];
z[22] = z[3] * z[22];
z[30] = prod_pow(z[4], 2);
z[31] = z[26] * z[30];
z[32] = z[14] * z[30];
z[32] = -1 + z[32];
z[33] = -z[4] * z[32];
z[17] = 1 + -z[17];
z[17] = z[3] * z[17];
z[17] = z[17] + z[33];
z[33] = (T(1) / T(2)) * z[3];
z[17] = z[17] * z[33];
z[17] = z[17] + z[31];
z[17] = z[5] * z[17];
z[31] = -z[4] * z[26];
z[17] = z[17] + z[19] + z[21] + z[22] + z[31];
z[17] = z[1] * z[17];
z[19] = z[7] * z[14];
z[21] = z[0] + z[9];
z[22] = z[19] + 3 * z[21];
z[31] = prod_pow(z[7], 2);
z[22] = z[22] * z[31];
z[34] = z[19] + z[21];
z[35] = z[3] * z[7];
z[34] = z[34] * z[35];
z[22] = z[22] + z[34];
z[22] = z[22] * z[33];
z[34] = (T(3) / T(2)) * z[0] + z[9];
z[36] = prod_pow(z[7], 3);
z[37] = z[34] * z[36];
z[22] = z[22] + z[37];
z[22] = z[3] * z[22];
z[37] = (T(1) / T(2)) * z[0];
z[38] = prod_pow(z[7], 4) * z[37];
z[22] = z[22] + z[38];
z[22] = z[5] * z[22];
z[38] = (T(1) / T(2)) * z[7];
z[39] = z[14] * z[38];
z[40] = (T(5) / T(2)) * z[9];
z[41] = 3 * z[0];
z[42] = -z[39] + -z[40] + -z[41];
z[42] = z[31] * z[42];
z[43] = -z[19] + (T(-3) / T(2)) * z[21];
z[43] = z[35] * z[43];
z[42] = z[42] + z[43];
z[42] = z[3] * z[42];
z[43] = -z[9] + -z[41];
z[43] = z[36] * z[43];
z[42] = -z[22] + z[42] + (T(1) / T(2)) * z[43];
z[42] = z[5] * z[42];
z[43] = -z[7] + -z[24];
z[43] = z[7] * z[21] * z[43];
z[44] = z[21] + z[39];
z[45] = -z[35] * z[44];
z[42] = z[42] + z[43] + z[45];
z[42] = z[6] * z[42];
z[43] = -z[9] + z[19];
z[45] = -z[20] + z[43];
z[45] = z[10] * z[45];
z[46] = -z[9] + z[39];
z[46] = z[7] * z[46];
z[47] = T(1) / T(2) + z[46];
z[45] = z[45] + -z[47];
z[45] = z[31] * z[45];
z[48] = z[2] * z[45];
z[49] = (T(1) / T(2)) * z[9];
z[50] = -z[19] + z[49];
z[50] = z[10] * z[50];
z[51] = (T(3) / T(2)) * z[9] + -z[19];
z[51] = z[7] * z[51];
z[51] = T(-1) / T(2) + z[51];
z[50] = z[50] + -z[51];
z[50] = z[7] * z[50];
z[52] = z[3] * z[38] * z[43];
z[48] = z[48] + z[50] + z[52];
z[48] = z[12] * z[48];
z[50] = -z[31] * z[49];
z[25] = -z[19] + -z[25];
z[25] = z[25] * z[35];
z[25] = z[25] + z[50];
z[25] = z[11] * z[25];
z[35] = -z[4] * z[28];
z[17] = T(-1) / T(2) + z[17] + z[25] + z[35] + z[42] + z[48];
z[25] = -z[14] * z[33];
z[35] = (T(1) / T(4)) * z[15];
z[25] = z[25] + -z[34] + -z[35] + -z[39];
z[25] = z[3] * z[25];
z[42] = 3 * z[18];
z[48] = 5 + z[42];
z[50] = z[0] + z[49];
z[52] = -z[7] * z[50];
z[53] = z[10] * z[49];
z[25] = z[25] + (T(1) / T(4)) * z[48] + z[52] + z[53];
z[25] = z[3] * z[25];
z[44] = z[7] * z[44];
z[21] = (T(-3) / T(2)) * z[19] + -z[21];
z[21] = z[3] * z[21];
z[21] = z[21] + -3 * z[44];
z[21] = z[21] * z[33];
z[31] = -z[31] * z[34];
z[21] = z[21] + z[31];
z[21] = z[3] * z[21];
z[31] = -z[36] * z[37];
z[21] = z[21] + (T(-1) / T(2)) * z[22] + z[31];
z[21] = z[5] * z[21];
z[22] = 5 * z[9];
z[31] = z[15] + z[22];
z[31] = z[10] * z[31];
z[31] = 7 + z[31] + z[42];
z[34] = -z[35] + -z[50];
z[34] = z[3] * z[34];
z[31] = (T(1) / T(4)) * z[31] + z[34];
z[23] = z[23] * z[31];
z[16] = (T(-1) / T(4)) * z[16] + z[23];
z[16] = z[2] * z[16];
z[23] = -z[0] * z[7];
z[23] = 1 + z[18] + z[23];
z[31] = (T(1) / T(4)) * z[7];
z[23] = z[23] * z[31];
z[16] = z[16] + z[21] + z[23] + z[25];
z[16] = z[8] * z[16];
z[21] = 3 * z[27];
z[22] = -z[21] + z[22] + -z[41];
z[22] = z[22] * z[31];
z[23] = -z[27] + z[49];
z[23] = z[4] * z[23];
z[25] = -z[0] + z[49];
z[31] = (T(3) / T(4)) * z[19] + z[25];
z[31] = z[3] * z[31];
z[22] = T(1) / T(4) + z[22] + z[23] + z[31];
z[22] = z[3] * z[22];
z[23] = -z[24] * z[32];
z[31] = -z[28] + -z[37];
z[31] = z[7] * z[31];
z[21] = z[9] + -z[21];
z[21] = z[4] * z[21];
z[21] = 1 + z[21];
z[21] = (T(1) / T(2)) * z[21] + z[31];
z[21] = z[7] * z[21];
z[25] = z[25] + z[39];
z[25] = z[7] * z[25];
z[31] = -z[0] * z[33];
z[25] = T(1) / T(2) + z[25] + z[31];
z[25] = z[3] * z[25];
z[21] = z[21] + z[23] + z[25];
z[21] = z[3] * z[21];
z[23] = z[28] * z[38];
z[23] = z[23] + z[26];
z[23] = z[23] * z[30];
z[21] = z[21] + z[23];
z[21] = z[5] * z[21];
z[13] = z[13] + -z[27];
z[13] = z[13] * z[24];
z[23] = -z[7] * z[28];
z[13] = -1 + z[13] + z[23];
z[13] = z[4] * z[13];
z[14] = z[3] * z[14];
z[23] = -z[9] + -z[14];
z[23] = z[11] * z[23] * z[36];
z[13] = (T(1) / T(2)) * z[13] + z[21] + z[22] + (T(1) / T(4)) * z[23];
z[13] = z[5] * z[13];
z[21] = T(-3) / T(2) + z[18] + -3 * z[46];
z[22] = 7 * z[19];
z[23] = (T(-17) / T(2)) * z[9] + z[22];
z[23] = -3 * z[15] + (T(1) / T(2)) * z[23];
z[23] = z[10] * z[23];
z[24] = -z[15] + -z[49];
z[24] = z[24] * z[33];
z[21] = (T(1) / T(2)) * z[21] + z[23] + z[24];
z[21] = z[3] * z[21];
z[23] = (T(-3) / T(2)) * z[15] + z[19] + -z[40];
z[23] = z[10] * z[23];
z[24] = z[7] * z[9];
z[18] = -1 + z[18] + z[24];
z[18] = (T(1) / T(2)) * z[18] + z[23];
z[18] = z[3] * z[18];
z[23] = z[7] * z[47];
z[24] = z[10] * z[19];
z[25] = z[7] * z[43];
z[25] = (T(3) / T(2)) * z[24] + -2 * z[25];
z[25] = z[10] * z[25];
z[18] = z[18] + z[23] + z[25];
z[18] = z[3] * z[18];
z[18] = z[18] + z[45];
z[18] = z[2] * z[18];
z[22] = (T(11) / T(2)) * z[9] + -z[22];
z[22] = z[22] * z[38];
z[22] = z[22] + 2 * z[24];
z[22] = z[10] * z[22];
z[23] = z[7] * z[51];
z[18] = z[18] + z[21] + z[22] + (T(-3) / T(2)) * z[23];
z[18] = z[2] * z[18];
z[14] = z[14] + -z[20] + z[27] + z[39];
z[14] = z[14] * z[33];
z[15] = (T(-5) / T(4)) * z[15] + (T(5) / T(2)) * z[19] + -z[29];
z[15] = z[10] * z[15];
z[19] = z[9] + (T(-5) / T(4)) * z[19] + (T(1) / T(4)) * z[27];
z[19] = z[7] * z[19];
return z[13] + z[14] + z[15] + z[16] + (T(1) / T(2)) * z[17] + z[18] + z[19];
}



template double eval_coef_2q3y_2l_pmmpp_12345_156(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_156(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
