#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_158(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[53];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = iW[21];
z[7] = v[1];
z[8] = iW[22];
z[9] = iW[15];
z[10] = iW[2];
z[11] = v[0];
z[12] = iW[4];
z[13] = iW[17];
z[14] = iW[18];
z[15] = z[6] * z[9];
z[16] = z[8] * z[9];
z[17] = z[15] + z[16];
z[18] = (T(1) / T(2)) * z[2];
z[17] = z[17] * z[18];
z[17] = z[9] + z[17];
z[19] = prod_pow(z[8], 2);
z[20] = z[4] * z[19];
z[21] = (T(3) / T(4)) * z[20];
z[22] = (T(1) / T(2)) * z[6];
z[23] = 7 * z[8];
z[24] = -z[13] + z[23];
z[24] = -z[17] + -z[21] + z[22] + (T(1) / T(2)) * z[24];
z[24] = z[2] * z[24];
z[25] = (T(1) / T(2)) * z[4];
z[26] = z[19] * z[25];
z[27] = -z[9] + z[26];
z[28] = -z[13] + -z[23];
z[28] = z[27] + (T(1) / T(2)) * z[28];
z[28] = z[4] * z[28];
z[24] = T(5) / T(2) + z[24] + z[28];
z[24] = z[2] * z[24];
z[28] = z[12] + z[14];
z[29] = prod_pow(z[6], 2);
z[30] = z[2] * z[29];
z[31] = -3 * z[6] + -z[28] + z[30];
z[31] = z[18] * z[31];
z[32] = (T(1) / T(2)) * z[11];
z[33] = (T(3) / T(2)) * z[30];
z[34] = (T(-9) / T(2)) * z[6] + z[14] + z[33];
z[34] = z[32] * z[34];
z[31] = -3 + z[31] + z[34];
z[31] = z[11] * z[31];
z[24] = (T(-7) / T(4)) * z[4] + z[24] + z[31];
z[31] = (T(1) / T(4)) * z[6];
z[34] = -z[14] + z[31];
z[35] = z[6] * z[34];
z[36] = z[11] * z[35];
z[37] = z[6] + (T(1) / T(2)) * z[14];
z[37] = -z[30] + -z[36] + 3 * z[37];
z[37] = z[32] * z[37];
z[34] = -z[3] * z[22] * z[34];
z[34] = (T(-3) / T(8)) * z[6] + -z[14] + (T(1) / T(8)) * z[30] + z[34] + z[36];
z[34] = z[3] * z[34];
z[38] = (T(1) / T(2)) * z[19];
z[39] = z[16] + z[38];
z[39] = (T(1) / T(2)) * z[39];
z[40] = z[8] * z[12];
z[41] = z[39] + -z[40];
z[15] = (T(1) / T(2)) * z[15] + -z[41];
z[15] = z[2] * z[15];
z[42] = z[9] + z[13];
z[15] = -z[14] + z[15] + (T(-1) / T(2)) * z[42];
z[15] = z[15] * z[18];
z[15] = 1 + z[15] + z[34] + z[37];
z[15] = z[3] * z[15];
z[34] = prod_pow(z[4], 2);
z[37] = (T(1) / T(2)) * z[34];
z[43] = -z[4] + z[18];
z[43] = z[2] * z[43];
z[43] = z[37] + z[43];
z[43] = z[0] * z[43];
z[44] = (T(1) / T(4)) * z[4];
z[45] = z[10] * z[44];
z[46] = z[11] * z[45];
z[15] = z[15] + (T(1) / T(2)) * z[24] + z[43] + z[46];
z[15] = z[3] * z[15];
z[24] = 3 * z[8];
z[43] = -z[24] + z[26];
z[43] = z[4] * z[43];
z[46] = z[8] + (T(-1) / T(4)) * z[20];
z[46] = z[2] * z[46];
z[43] = 1 + z[43] + z[46];
z[43] = z[18] * z[34] * z[43];
z[46] = -z[6] + z[30];
z[47] = z[18] * z[46];
z[47] = -1 + z[47];
z[47] = z[2] * z[47];
z[47] = (T(-3) / T(2)) * z[4] + z[47];
z[47] = z[11] * z[47];
z[48] = z[2] * z[6];
z[49] = 1 + z[48];
z[49] = z[2] * z[49];
z[50] = -z[4] + -z[49];
z[50] = z[2] * z[50];
z[47] = 3 * z[34] + z[47] + z[50];
z[47] = z[11] * z[47];
z[50] = -z[8] + (T(1) / T(8)) * z[20];
z[50] = z[4] * z[50];
z[51] = T(-7) / T(8) + -z[50];
z[51] = prod_pow(z[4], 3) * z[51];
z[43] = z[43] + (T(1) / T(4)) * z[47] + z[51];
z[43] = z[5] * z[43];
z[47] = T(-13) / T(8) + -z[50];
z[47] = z[34] * z[47];
z[50] = (T(1) / T(2)) * z[13] + -z[24];
z[51] = -z[21] + -z[50];
z[51] = z[4] * z[51];
z[52] = -z[6] * z[18];
z[51] = T(-1) / T(2) + z[51] + z[52];
z[51] = z[2] * z[51];
z[52] = (T(-13) / T(2)) * z[8] + z[20];
z[52] = z[4] * z[52];
z[52] = 3 + z[52];
z[52] = z[4] * z[52];
z[51] = z[51] + z[52];
z[51] = z[18] * z[51];
z[52] = -z[18] * z[29];
z[52] = z[6] + z[52];
z[52] = z[2] * z[52];
z[52] = 1 + z[52];
z[52] = z[11] * z[52];
z[48] = T(1) / T(2) + z[48];
z[48] = z[2] * z[48];
z[48] = (T(9) / T(2)) * z[4] + z[48] + (T(3) / T(2)) * z[52];
z[48] = z[32] * z[48];
z[52] = prod_pow(z[11], 2);
z[45] = -z[45] * z[52];
z[15] = z[15] + z[43] + z[45] + z[47] + z[48] + z[51];
z[15] = z[1] * z[15];
z[43] = (T(1) / T(2)) * z[29];
z[16] = 3 * z[16];
z[45] = -z[16] + z[43];
z[47] = (T(1) / T(4)) * z[2];
z[45] = z[45] * z[47];
z[48] = (T(5) / T(8)) * z[6];
z[50] = -z[9] + -z[50];
z[45] = -z[26] + z[28] + z[45] + z[48] + (T(1) / T(2)) * z[50];
z[45] = z[2] * z[45];
z[41] = (T(-1) / T(4)) * z[29] + -z[41];
z[41] = z[2] * z[41];
z[50] = z[3] * z[35];
z[36] = 2 * z[14] + -z[31] + -z[36] + z[41] + (T(-1) / T(4)) * z[42] + z[50];
z[36] = z[3] * z[36];
z[41] = z[4] * z[9];
z[42] = -z[2] + z[4];
z[42] = z[0] * z[42];
z[42] = T(1) / T(2) + -3 * z[41] + z[42];
z[46] = (T(-3) / T(2)) * z[14] + z[46];
z[46] = z[32] * z[46];
z[36] = z[36] + (T(1) / T(4)) * z[42] + z[45] + z[46];
z[36] = z[3] * z[36];
z[27] = (T(-3) / T(2)) * z[8] + z[27];
z[27] = z[4] * z[27];
z[27] = 3 + z[27];
z[27] = z[4] * z[27];
z[42] = (T(3) / T(4)) * z[6] + (T(1) / T(2)) * z[8] + -z[17];
z[42] = z[2] * z[42];
z[45] = (T(9) / T(4)) * z[8] + -z[9] + (T(-5) / T(4)) * z[20];
z[45] = z[4] * z[45];
z[42] = T(13) / T(4) + z[42] + z[45];
z[42] = z[2] * z[42];
z[45] = (T(-3) / T(2)) * z[6] + z[28] + (T(-5) / T(2)) * z[30];
z[45] = z[2] * z[45];
z[46] = z[11] * z[12];
z[45] = -7 + z[45] + -z[46];
z[45] = z[32] * z[45];
z[27] = z[27] + z[42] + z[45];
z[42] = (T(3) / T(2)) * z[20] + -z[23];
z[42] = z[4] * z[42];
z[42] = T(11) / T(2) + z[42];
z[42] = z[37] * z[42];
z[23] = -3 * z[20] + z[23];
z[23] = z[23] * z[44];
z[23] = 1 + z[23];
z[23] = z[4] * z[23];
z[23] = z[23] + -z[49];
z[23] = z[2] * z[23];
z[23] = z[23] + z[42];
z[42] = z[6] + z[33];
z[42] = z[2] * z[42];
z[42] = T(1) / T(2) + z[42];
z[42] = z[42] * z[47];
z[42] = -z[4] + (T(3) / T(8)) * z[11] + z[42];
z[42] = z[11] * z[42];
z[23] = (T(1) / T(2)) * z[23] + z[42];
z[23] = z[5] * z[23];
z[42] = -z[2] + z[25];
z[42] = z[2] * z[42];
z[37] = z[37] + z[42];
z[37] = z[0] * z[37];
z[42] = z[10] * z[52];
z[15] = z[15] + z[23] + (T(1) / T(2)) * z[27] + z[36] + z[37] + (T(1) / T(4)) * z[42];
z[15] = z[1] * z[15];
z[20] = z[20] + z[24];
z[23] = (T(1) / T(2)) * z[7];
z[20] = z[20] * z[23];
z[24] = z[19] * z[23];
z[24] = (T(7) / T(2)) * z[6] + z[8] + z[24] + z[33];
z[24] = z[2] * z[24];
z[27] = z[4] * z[8];
z[20] = z[20] + z[24] + z[27];
z[20] = z[18] * z[20];
z[24] = z[8] + z[26];
z[24] = z[4] * z[24];
z[26] = T(-3) / T(2) + z[24];
z[26] = z[23] * z[26];
z[27] = -z[19] + z[29];
z[27] = z[23] * z[27];
z[27] = -z[6] + -z[8] + z[27];
z[18] = z[18] * z[27];
z[27] = z[6] + -z[8];
z[27] = z[7] * z[27];
z[18] = z[18] + z[27];
z[18] = prod_pow(z[2], 2) * z[0] * z[18];
z[21] = z[8] + -z[21];
z[21] = z[4] * z[21];
z[21] = T(-1) / T(4) + z[21];
z[21] = z[4] * z[21];
z[18] = z[18] + z[20] + z[21] + z[26] + z[32];
z[18] = z[5] * z[18];
z[20] = -z[19] + z[43];
z[20] = z[20] * z[23];
z[17] = (T(-5) / T(4)) * z[8] + -z[17] + z[20] + -z[31];
z[17] = z[2] * z[17];
z[17] = z[17] + z[27] + -z[41];
z[17] = z[2] * z[17];
z[20] = -z[9] * z[34];
z[17] = z[17] + z[20];
z[17] = z[0] * z[17];
z[20] = T(-5) / T(2) + -z[24];
z[21] = z[7] * z[19];
z[23] = z[21] + -z[30];
z[23] = (T(-5) / T(4)) * z[6] + (T(3) / T(4)) * z[8] + (T(1) / T(4)) * z[23] + -z[28];
z[23] = z[2] * z[23];
z[17] = z[17] + z[18] + (T(1) / T(2)) * z[20] + z[23] + z[46];
z[18] = -z[16] + -z[38] + -z[43];
z[18] = z[18] * z[47];
z[18] = -z[8] + (T(-1) / T(2)) * z[9] + z[18] + (T(-1) / T(8)) * z[21] + -z[22];
z[18] = z[2] * z[18];
z[20] = -z[9] * z[25];
z[20] = -1 + z[20];
z[18] = z[18] + (T(1) / T(2)) * z[20];
z[18] = z[0] * z[18];
z[16] = -z[16] + -z[19];
z[16] = z[2] * z[16];
z[16] = (T(-5) / T(2)) * z[8] + -z[9] + z[16];
z[20] = -z[3] * z[39];
z[16] = (T(1) / T(2)) * z[16] + z[20];
z[16] = z[0] * z[16];
z[16] = z[16] + -z[35] + z[40];
z[20] = (T(1) / T(2)) * z[3];
z[16] = z[16] * z[20];
z[19] = z[19] + z[29];
z[19] = z[2] * z[19];
z[16] = (T(1) / T(2)) * z[12] + -z[14] + z[16] + z[18] + (T(1) / T(8)) * z[19] + z[48];
z[16] = z[3] * z[16];
return z[15] + z[16] + (T(1) / T(2)) * z[17];
}



template double eval_coef_2q3y_2l_pmmpp_12345_158(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_158(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
