#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_166(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[68];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[2];
z[5] = v[4];
z[6] = iW[17];
z[7] = iW[22];
z[8] = iW[4];
z[9] = iW[15];
z[10] = v[3];
z[11] = iW[7];
z[12] = iW[12];
z[13] = iW[18];
z[14] = iW[16];
z[15] = v[1];
z[16] = z[4] * z[10];
z[17] = prod_pow(z[0], 2);
z[18] = z[16] * z[17];
z[19] = 2 * z[0];
z[20] = z[3] * z[17];
z[21] = z[19] + -z[20];
z[21] = z[4] * z[21];
z[21] = z[18] + -z[21];
z[22] = prod_pow(z[3], 2);
z[23] = z[17] * z[22];
z[21] = -4 * z[21] + (T(-89) / T(6)) * z[23];
z[21] = z[10] * z[21];
z[24] = (T(229) / T(8)) * z[0] + 25 * z[20];
z[24] = z[22] * z[24];
z[25] = 4 * z[0];
z[26] = (T(-73) / T(24)) * z[20] + z[25];
z[26] = z[3] * z[26];
z[26] = -4 + z[26];
z[26] = z[4] * z[26];
z[21] = z[21] + (T(1) / T(3)) * z[24] + z[26];
z[24] = z[0] + z[20];
z[24] = z[22] * z[24];
z[26] = z[10] * z[23];
z[27] = z[24] + -z[26];
z[28] = z[2] * z[10] * z[27];
z[29] = z[0] * z[4];
z[30] = (T(1) / T(3)) * z[18] + -z[29];
z[30] = z[10] * z[30];
z[30] = z[4] + z[30];
z[30] = z[10] * z[30];
z[31] = (T(1) / T(3)) * z[15];
z[32] = z[4] * z[31];
z[30] = z[30] + -z[32];
z[30] = z[9] * z[30];
z[28] = z[28] + z[30];
z[32] = z[4] * z[17];
z[33] = z[22] * z[32];
z[34] = -z[27] + z[33];
z[34] = z[10] * z[34];
z[35] = -z[22] * z[29];
z[34] = z[34] + z[35];
z[34] = z[13] * z[34];
z[21] = (T(1) / T(3)) * z[21] + -4 * z[28] + (T(109) / T(72)) * z[34];
z[21] = z[13] * z[21];
z[28] = z[5] * z[17];
z[34] = prod_pow(z[4], 2);
z[35] = z[28] * z[34];
z[36] = z[0] + z[32];
z[37] = z[34] * z[36];
z[38] = -z[35] + 2 * z[37];
z[38] = z[5] * z[38];
z[39] = prod_pow(z[4], 3);
z[40] = z[17] * z[39];
z[41] = prod_pow(z[5], 2);
z[42] = z[6] * z[40] * z[41];
z[38] = z[38] + z[42];
z[38] = z[6] * z[38];
z[35] = z[35] + -z[37] + -z[38];
z[35] = z[12] * z[35];
z[43] = (T(1) / T(3)) * z[0];
z[44] = (T(7) / T(2)) * z[32];
z[45] = (T(7) / T(2)) * z[20];
z[46] = -z[43] + z[44] + z[45];
z[46] = z[4] * z[46];
z[47] = 2 * z[20];
z[48] = z[10] * z[17];
z[49] = (T(61) / T(4)) * z[32] + z[47] + 2 * z[48];
z[50] = (T(1) / T(3)) * z[10];
z[49] = z[49] * z[50];
z[51] = (T(1) / T(4)) * z[32];
z[52] = (T(25) / T(4)) * z[0] + z[20];
z[52] = (T(-25) / T(12)) * z[28] + -z[51] + (T(1) / T(3)) * z[52];
z[52] = z[5] * z[52];
z[43] = 5 * z[20] + -z[43];
z[43] = z[3] * z[43];
z[21] = T(-1) / T(24) + z[21] + z[35] + z[43] + z[46] + z[49] + z[52];
z[35] = (T(1) / T(2)) * z[22];
z[43] = z[0] * z[3];
z[46] = T(19) / T(3) + z[43];
z[46] = z[35] * z[46];
z[49] = (T(1) / T(2)) * z[3];
z[52] = z[17] * z[49];
z[52] = z[0] + z[52];
z[52] = z[3] * z[52];
z[53] = T(-19) / T(12) + -z[52];
z[53] = z[3] * z[4] * z[53];
z[46] = z[46] + z[53];
z[46] = z[4] * z[46];
z[53] = (T(19) / T(3)) * z[0];
z[54] = (T(-19) / T(6)) * z[28] + z[53];
z[55] = prod_pow(z[3], 3);
z[54] = z[54] * z[55];
z[53] = -z[20] + -z[53];
z[53] = z[4] * z[22] * z[53];
z[53] = z[53] + z[54];
z[54] = (T(1) / T(2)) * z[5];
z[53] = z[53] * z[54];
z[52] = T(1) / T(2) + z[52];
z[56] = z[2] * z[39] * z[52];
z[57] = z[3] * z[56];
z[46] = z[46] + z[53] + (T(-19) / T(12)) * z[55] + -z[57];
z[46] = z[1] * z[46];
z[53] = z[34] * z[49];
z[55] = 1 + z[43];
z[58] = -z[53] * z[55];
z[57] = -z[57] + z[58];
z[57] = z[2] * z[57];
z[46] = z[46] + z[57];
z[57] = (T(1) / T(4)) * z[4];
z[58] = z[43] * z[57];
z[59] = T(-19) / T(4) + -z[43];
z[59] = z[3] * z[59];
z[58] = z[58] + z[59];
z[58] = z[4] * z[58];
z[42] = (T(-19) / T(4)) * z[22] + z[42] + -z[58];
z[58] = z[20] + z[32];
z[58] = z[4] * z[58];
z[58] = (T(25) / T(8)) * z[23] + z[58];
z[58] = z[5] * z[58];
z[59] = (T(1) / T(3)) * z[4];
z[60] = -z[0] + (T(-11) / T(2)) * z[20];
z[60] = z[3] * z[59] * z[60];
z[22] = z[0] * z[22];
z[22] = (T(-21) / T(2)) * z[22] + z[60];
z[22] = (T(1) / T(4)) * z[22] + (T(1) / T(3)) * z[58];
z[22] = z[5] * z[22];
z[22] = z[22] + (T(-1) / T(3)) * z[42] + (T(1) / T(2)) * z[46];
z[22] = z[1] * z[22];
z[42] = z[17] * z[34];
z[46] = -1 + z[42];
z[58] = (T(1) / T(2)) * z[4];
z[46] = z[46] * z[58];
z[60] = (T(3) / T(4)) * z[32];
z[61] = z[0] + -z[60];
z[61] = z[4] * z[61];
z[62] = -z[0] + (T(1) / T(4)) * z[28];
z[62] = z[5] * z[62];
z[61] = T(3) / T(4) + z[61] + z[62];
z[61] = z[5] * z[61];
z[46] = z[46] + z[61];
z[46] = z[5] * z[46];
z[61] = z[17] * z[58];
z[61] = z[0] + z[61];
z[61] = z[4] * z[61];
z[61] = T(1) / T(2) + z[61];
z[62] = z[58] * z[61];
z[63] = (T(1) / T(2)) * z[28];
z[64] = (T(3) / T(2)) * z[32];
z[65] = z[0] + z[64];
z[66] = z[63] + -z[65];
z[67] = -z[54] * z[66];
z[60] = -z[0] + -z[60];
z[60] = z[4] * z[60];
z[60] = T(-1) / T(4) + z[60] + z[67];
z[60] = z[5] * z[60];
z[60] = z[60] + z[62];
z[41] = z[7] * z[41] * z[60];
z[41] = z[41] + z[46];
z[41] = z[7] * z[41];
z[44] = z[19] + (T(13) / T(4)) * z[20] + z[44];
z[44] = z[44] * z[59];
z[46] = z[0] + (T(-13) / T(12)) * z[20] + (T(-5) / T(3)) * z[32];
z[46] = z[46] * z[54];
z[60] = z[0] + (T(5) / T(3)) * z[20];
z[60] = z[3] * z[60];
z[60] = -1 + z[60];
z[44] = z[44] + z[46] + (T(1) / T(2)) * z[60];
z[44] = z[5] * z[44];
z[46] = (T(1) / T(3)) * z[3];
z[47] = (T(-19) / T(4)) * z[0] + -z[47];
z[47] = z[3] * z[47];
z[47] = T(-11) / T(4) + z[47];
z[47] = z[34] * z[46] * z[47];
z[56] = -z[49] * z[56];
z[47] = z[47] + z[56];
z[47] = z[2] * z[47];
z[56] = -13 * z[0] + (T(-29) / T(2)) * z[20];
z[46] = z[46] * z[56];
z[46] = T(1) / T(2) + z[46];
z[46] = z[3] * z[46] * z[58];
z[46] = z[46] + z[47];
z[46] = z[2] * z[46];
z[47] = z[3] * z[51];
z[47] = z[43] + z[47];
z[47] = z[4] * z[47];
z[51] = -z[0] + (T(-17) / T(9)) * z[20];
z[51] = z[3] * z[51];
z[51] = T(-7) / T(24) + z[51];
z[51] = z[3] * z[51];
z[22] = z[22] + (T(-1) / T(3)) * z[38] + z[41] + z[44] + z[46] + (T(1) / T(6)) * z[47] + z[51];
z[22] = z[1] * z[22];
z[38] = -z[24] + -z[33];
z[38] = z[4] * z[38];
z[23] = z[16] * z[23];
z[23] = z[23] + z[38];
z[38] = (T(1) / T(2)) * z[10];
z[23] = z[23] * z[38];
z[39] = -z[14] * z[39] * z[49] * z[52];
z[41] = z[24] * z[34];
z[23] = z[23] + z[39] + z[41];
z[23] = z[2] * z[23];
z[27] = (T(-7) / T(2)) * z[27] + -5 * z[33];
z[27] = z[10] * z[27];
z[24] = z[4] * z[24];
z[24] = (T(17) / T(2)) * z[24] + z[27];
z[27] = (T(-5) / T(2)) * z[0] + -z[20];
z[27] = z[3] * z[27];
z[27] = T(-3) / T(2) + z[27];
z[27] = z[14] * z[27] * z[53];
z[23] = z[23] + (T(1) / T(3)) * z[24] + z[27];
z[23] = z[2] * z[23];
z[24] = 5 * z[0] + 9 * z[20];
z[24] = z[24] * z[35];
z[27] = z[3] * z[14];
z[35] = -z[0] + (T(-1) / T(4)) * z[20];
z[35] = z[3] * z[35];
z[35] = T(-3) / T(4) + z[35];
z[35] = z[4] * z[27] * z[35];
z[23] = z[23] + z[24] + (T(-19) / T(6)) * z[26] + (T(2) / T(3)) * z[33] + z[35];
z[23] = z[2] * z[23];
z[24] = (T(1) / T(4)) * z[48];
z[26] = (T(1) / T(2)) * z[0];
z[33] = z[24] + z[26] + z[32];
z[33] = z[10] * z[33];
z[35] = z[4] * z[65];
z[35] = -1 + 3 * z[35];
z[33] = z[33] + (T(1) / T(2)) * z[35];
z[33] = z[10] * z[33];
z[35] = 3 * z[32];
z[39] = z[26] + -z[35] + (T(-3) / T(2)) * z[48];
z[39] = z[10] * z[39];
z[41] = -11 * z[0] + -9 * z[32];
z[41] = 3 * z[28] + (T(1) / T(2)) * z[41];
z[41] = z[41] * z[54];
z[44] = T(1) / T(2) + z[29];
z[39] = z[39] + z[41] + (T(5) / T(2)) * z[44];
z[39] = z[5] * z[39];
z[35] = z[0] + z[35];
z[35] = z[35] * z[58];
z[35] = -1 + z[35];
z[35] = z[35] * z[58];
z[33] = z[33] + z[35] + z[39];
z[33] = z[5] * z[33];
z[35] = z[17] * z[38];
z[39] = z[35] + -z[66];
z[39] = z[5] * z[39];
z[19] = -z[19] + -z[64];
z[19] = z[4] * z[19];
z[41] = -z[0] + z[35];
z[41] = z[10] * z[41];
z[19] = T(-1) / T(2) + z[19] + z[39] + z[41];
z[19] = z[5] * z[19];
z[39] = 2 * z[32];
z[26] = -z[26] + -z[35] + -z[39];
z[26] = z[10] * z[26];
z[35] = 1 + -3 * z[42];
z[26] = z[26] + (T(1) / T(2)) * z[35];
z[26] = z[10] * z[26];
z[35] = z[4] * z[61];
z[19] = z[19] + z[26] + z[35];
z[19] = z[5] * z[19];
z[16] = z[16] * z[36];
z[16] = z[16] + z[37];
z[16] = z[10] * z[16];
z[16] = z[16] + z[19];
z[16] = z[5] * z[16];
z[19] = z[10] * z[36];
z[26] = z[4] + z[38];
z[26] = z[19] * z[26];
z[34] = (T(1) / T(2)) * z[34];
z[35] = z[34] * z[36];
z[26] = z[26] + z[35];
z[35] = prod_pow(z[10], 2);
z[41] = z[26] * z[35];
z[16] = z[16] + z[41];
z[16] = z[7] * z[16];
z[34] = z[34] * z[65];
z[41] = (T(3) / T(2)) * z[0];
z[44] = z[39] + z[41];
z[44] = z[4] * z[44];
z[46] = (T(5) / T(4)) * z[32];
z[47] = z[0] + z[46];
z[47] = z[10] * z[47];
z[44] = z[44] + z[47];
z[44] = z[10] * z[44];
z[34] = z[34] + z[44];
z[34] = z[10] * z[34];
z[16] = z[16] + z[33] + z[34];
z[16] = z[7] * z[16];
z[33] = -z[32] + z[41] + -z[48] + -z[63];
z[33] = z[5] * z[33];
z[34] = z[36] * z[58];
z[41] = z[0] * z[10];
z[33] = -1 + z[33] + z[34] + z[41];
z[33] = z[5] * z[33];
z[24] = z[24] + z[39];
z[24] = z[10] * z[24];
z[24] = z[24] + (T(11) / T(4)) * z[42];
z[24] = z[10] * z[24];
z[16] = z[16] + z[24] + z[33] + z[40];
z[16] = z[7] * z[16];
z[24] = z[36] * z[50];
z[24] = z[24] + z[34];
z[24] = z[10] * z[24];
z[24] = z[24] + (T(1) / T(6)) * z[37];
z[24] = z[10] * z[24];
z[33] = z[7] * z[35];
z[34] = (T(1) / T(6)) * z[33];
z[34] = z[26] * z[34];
z[24] = z[24] + z[34];
z[24] = z[7] * z[24];
z[34] = -z[48] * z[58];
z[34] = z[34] + -z[42];
z[34] = z[10] * z[34];
z[36] = (T(1) / T(2)) * z[40];
z[34] = z[34] + -z[36];
z[34] = z[10] * z[34];
z[26] = -z[26] * z[33];
z[26] = z[26] + z[34];
z[26] = z[6] * z[26];
z[32] = z[32] + (T(1) / T(8)) * z[48];
z[32] = z[10] * z[32];
z[32] = z[32] + (T(11) / T(8)) * z[42];
z[32] = z[10] * z[32];
z[32] = z[32] + z[36];
z[26] = (T(1) / T(2)) * z[24] + (T(1) / T(12)) * z[26] + (T(1) / T(3)) * z[32];
z[26] = z[6] * z[26];
z[25] = z[25] + z[45];
z[25] = (T(1) / T(3)) * z[25] + z[46];
z[25] = z[4] * z[25];
z[32] = T(1) / T(2) + 7 * z[43];
z[25] = (T(11) / T(6)) * z[19] + z[25] + (T(1) / T(6)) * z[32];
z[25] = z[10] * z[25];
z[32] = 1 + (T(61) / T(6)) * z[43];
z[32] = z[3] * z[32];
z[20] = z[0] + (T(61) / T(6)) * z[20];
z[20] = z[3] * z[20];
z[20] = T(-1) / T(2) + z[20];
z[20] = z[4] * z[20];
z[20] = z[20] + z[32];
z[20] = (T(1) / T(12)) * z[20] + z[25];
z[25] = z[38] + -z[59];
z[25] = z[10] * z[25];
z[32] = -z[10] + (T(1) / T(4)) * z[15] + z[57];
z[32] = z[31] * z[32];
z[25] = z[25] + z[32];
z[25] = z[15] * z[25];
z[19] = -1 + (T(1) / T(4)) * z[19] + -z[29];
z[19] = z[19] * z[50];
z[19] = z[19] + z[58];
z[19] = z[19] * z[35];
z[19] = z[19] + z[25];
z[19] = prod_pow(z[9], 2) * z[19];
z[19] = (T(-1) / T(72)) * z[15] + (T(1) / T(6)) * z[19] + (T(1) / T(3)) * z[20] + (T(5) / T(2)) * z[24];
z[19] = z[8] * z[19];
z[17] = z[17] * z[35];
z[17] = -1 + (T(1) / T(3)) * z[17];
z[17] = z[17] * z[38];
z[20] = z[0] * z[50];
z[20] = -1 + z[20];
z[20] = z[20] * z[35];
z[24] = z[10] + -z[31];
z[24] = z[15] * z[24];
z[20] = z[20] + z[24];
z[20] = z[9] * z[20];
z[17] = z[17] + (T(1) / T(2)) * z[20] + z[31];
z[17] = z[9] * z[17];
z[20] = -z[0] + z[28];
z[20] = z[5] * z[20];
z[20] = -z[18] + z[20] + z[29];
z[20] = z[5] * z[20];
z[18] = z[18] + -2 * z[29];
z[18] = z[10] * z[18];
z[18] = z[4] + z[18] + z[20];
z[18] = (T(1) / T(3)) * z[18] + z[30];
z[18] = z[11] * z[18];
z[20] = z[27] * z[55];
return z[16] + (T(1) / T(12)) * z[17] + (T(4) / T(3)) * z[18] + z[19] + (T(-1) / T(4)) * z[20] + (T(1) / T(3)) * z[21] + z[22] + z[23] + z[26];
}



template double eval_coef_2q3y_2l_pmmpp_12345_166(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_166(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
