#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_167(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[80];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[15];
z[5] = iW[3];
z[6] = iW[16];
z[7] = v[1];
z[8] = iW[19];
z[9] = v[3];
z[10] = iW[17];
z[11] = iW[2];
z[12] = iW[5];
z[13] = v[0];
z[14] = iW[18];
z[15] = iW[4];
z[16] = iW[12];
z[17] = (T(1) / T(4)) * z[4];
z[18] = z[1] * z[3];
z[19] = -z[17] * z[18];
z[20] = z[1] * z[4];
z[21] = prod_pow(z[1], 2);
z[22] = z[20] + -z[21];
z[22] = z[2] * z[22];
z[23] = (T(1) / T(3)) * z[1];
z[24] = z[3] * z[21];
z[25] = (T(3) / T(8)) * z[24];
z[19] = z[19] + (T(1) / T(8)) * z[22] + z[23] + z[25];
z[19] = z[0] * z[19];
z[22] = (T(1) / T(3)) * z[21];
z[26] = prod_pow(z[9], 2);
z[27] = -z[22] * z[26];
z[28] = z[9] * z[21];
z[29] = 3 * z[28];
z[30] = (T(13) / T(3)) * z[24] + z[29];
z[30] = z[3] * z[30];
z[27] = z[27] + z[30];
z[30] = prod_pow(z[9], 3);
z[31] = z[15] * z[30];
z[32] = -z[22] * z[31];
z[27] = (T(1) / T(2)) * z[27] + z[32];
z[32] = (T(1) / T(2)) * z[10];
z[27] = z[27] * z[32];
z[33] = z[24] + z[28];
z[34] = z[15] * z[26];
z[35] = z[22] * z[34];
z[27] = z[27] + z[33] + z[35];
z[27] = z[10] * z[27];
z[35] = (T(1) / T(2)) * z[9];
z[36] = z[21] * z[35];
z[37] = -z[1] + z[36];
z[37] = z[9] * z[37];
z[37] = T(1) / T(2) + z[37];
z[38] = (T(1) / T(3)) * z[7];
z[39] = (T(1) / T(3)) * z[28];
z[40] = z[1] + -z[39];
z[40] = z[9] * z[40];
z[40] = -1 + z[40];
z[40] = z[9] * z[40];
z[40] = z[38] + z[40];
z[40] = z[17] * z[40];
z[40] = (T(1) / T(3)) * z[37] + z[40];
z[40] = z[4] * z[40];
z[41] = (T(3) / T(2)) * z[15];
z[42] = z[37] * z[41];
z[43] = -z[1] + z[28];
z[40] = z[40] + z[42] + (T(7) / T(12)) * z[43];
z[40] = z[15] * z[40];
z[27] = (T(83) / T(36)) * z[21] + z[27] + z[40];
z[40] = -z[21] * z[34];
z[33] = -3 * z[33] + z[40];
z[33] = z[8] * z[33];
z[40] = z[14] * z[37];
z[42] = z[40] + (T(-103) / T(72)) * z[43];
z[42] = z[14] * z[42];
z[19] = z[19] + (T(1) / T(2)) * z[27] + (T(1) / T(4)) * z[33] + z[42];
z[19] = z[2] * z[19];
z[27] = (T(1) / T(4)) * z[1];
z[33] = z[26] * z[27];
z[42] = z[1] * z[9];
z[44] = (T(5) / T(4)) * z[18] + 2 * z[42];
z[44] = z[3] * z[44];
z[45] = (T(1) / T(2)) * z[1];
z[46] = -z[31] * z[45];
z[33] = z[33] + z[44] + z[46];
z[33] = z[10] * z[33];
z[44] = 2 * z[1];
z[36] = z[36] + z[44];
z[46] = z[9] * z[36];
z[47] = 2 * z[24];
z[48] = (T(23) / T(2)) * z[1] + -z[28];
z[48] = -z[47] + (T(1) / T(4)) * z[48];
z[48] = z[3] * z[48];
z[49] = z[1] * z[34];
z[33] = z[33] + z[46] + z[48] + (T(5) / T(4)) * z[49];
z[33] = z[10] * z[33];
z[46] = (T(5) / T(2)) * z[1];
z[48] = -z[28] + z[46];
z[48] = z[9] * z[48];
z[49] = 3 * z[24] + z[29];
z[50] = (T(-7) / T(2)) * z[1] + z[49];
z[50] = z[3] * z[50];
z[51] = -z[34] * z[45];
z[50] = -z[48] + z[50] + z[51];
z[51] = (T(1) / T(2)) * z[8];
z[50] = z[50] * z[51];
z[52] = z[6] * z[7];
z[25] = (T(-2) / T(3)) * z[1] + -z[25];
z[25] = z[3] * z[25];
z[53] = prod_pow(z[3], 2);
z[54] = z[4] * z[53];
z[55] = z[1] * z[54];
z[56] = (T(1) / T(4)) * z[7];
z[57] = -z[8] * z[56];
z[25] = T(-43) / T(24) + z[25] + (T(5) / T(4)) * z[52] + (T(1) / T(8)) * z[55] + z[57];
z[25] = z[0] * z[25];
z[55] = -z[39] + z[45];
z[55] = z[9] * z[55];
z[55] = T(-1) / T(6) + z[55];
z[57] = (T(1) / T(2)) * z[42];
z[58] = -1 + z[57];
z[58] = z[9] * z[58];
z[59] = (T(1) / T(2)) * z[7];
z[58] = z[58] + z[59];
z[60] = (T(1) / T(3)) * z[4];
z[61] = -z[58] * z[60];
z[55] = (T(1) / T(2)) * z[55] + z[61];
z[61] = (T(1) / T(2)) * z[4];
z[55] = z[55] * z[61];
z[62] = 1 + (T(-1) / T(3)) * z[42];
z[62] = z[26] * z[62];
z[63] = -z[9] + z[38];
z[63] = z[7] * z[63];
z[62] = z[62] + z[63];
z[62] = z[4] * z[62];
z[62] = z[58] + z[62];
z[62] = z[17] * z[62];
z[64] = (T(9) / T(8)) * z[1] + -z[28];
z[64] = z[9] * z[64];
z[62] = T(-13) / T(24) + z[62] + z[64];
z[62] = z[15] * z[62];
z[64] = -14 * z[1] + (T(-31) / T(2)) * z[24] + (T(79) / T(4)) * z[28];
z[65] = z[28] + -z[44];
z[65] = z[9] * z[65];
z[65] = 1 + z[65];
z[65] = z[9] * z[14] * z[65];
z[66] = (T(139) / T(2)) * z[1] + (T(-157) / T(3)) * z[28];
z[66] = z[9] * z[66];
z[66] = T(-103) / T(6) + z[66];
z[65] = z[65] + (T(1) / T(12)) * z[66];
z[65] = z[14] * z[65];
z[19] = (T(23) / T(12)) * z[6] + z[19] + z[25] + (T(1) / T(3)) * z[33] + z[50] + z[55] + z[62] + (T(1) / T(9)) * z[64] + z[65];
z[19] = z[2] * z[19];
z[25] = z[14] * z[26];
z[33] = z[21] * z[25];
z[50] = z[6] * z[21] * z[26];
z[55] = -z[1] + z[24];
z[50] = z[28] + (T(-1) / T(6)) * z[33] + (T(5) / T(6)) * z[50] + -z[55];
z[50] = z[12] * z[50];
z[62] = z[2] * z[6];
z[64] = z[21] * z[62];
z[65] = z[6] * z[28];
z[65] = z[64] + -z[65];
z[66] = (T(-151) / T(36)) * z[28] + z[33];
z[66] = z[14] * z[66];
z[67] = (T(-7) / T(3)) * z[1] + z[41];
z[67] = z[15] * z[67];
z[50] = (T(7) / T(9)) * z[21] + z[50] + (T(5) / T(6)) * z[65] + z[66] + (T(1) / T(2)) * z[67];
z[65] = (T(5) / T(4)) * z[28];
z[33] = (T(-5) / T(4)) * z[33] + z[44] + -z[47] + z[65];
z[47] = -z[1] + (T(1) / T(3)) * z[24];
z[47] = z[3] * z[47];
z[47] = 1 + z[47];
z[47] = z[3] * z[47];
z[47] = -z[38] + z[47];
z[66] = z[12] * z[47];
z[67] = (T(1) / T(2)) * z[3];
z[68] = z[21] * z[67];
z[69] = -z[1] + z[68];
z[70] = z[3] * z[69];
z[70] = T(1) / T(2) + z[70];
z[71] = (T(5) / T(8)) * z[66] + (T(1) / T(3)) * z[70];
z[71] = z[12] * z[71];
z[65] = -z[65] + z[69];
z[65] = z[3] * z[65];
z[69] = z[14] * z[21] * z[30];
z[72] = z[1] + z[28];
z[72] = z[9] * z[72];
z[72] = 1 + (T(5) / T(2)) * z[72];
z[65] = z[65] + (T(-5) / T(4)) * z[69] + (T(1) / T(2)) * z[72];
z[65] = (T(1) / T(3)) * z[65] + (T(5) / T(4)) * z[66];
z[69] = (T(1) / T(2)) * z[11];
z[65] = z[65] * z[69];
z[33] = (T(1) / T(3)) * z[33] + z[65] + z[71];
z[33] = z[11] * z[33];
z[65] = z[66] + (T(-25) / T(18)) * z[70];
z[64] = -z[21] + z[64];
z[64] = z[2] * z[64];
z[71] = -z[55] + z[64];
z[72] = (T(1) / T(2)) * z[2];
z[73] = z[71] * z[72];
z[73] = -z[70] + z[73];
z[73] = z[2] * z[73];
z[47] = (T(67) / T(24)) * z[47] + z[73];
z[47] = z[5] * z[47];
z[71] = z[2] * z[71];
z[47] = z[47] + (T(1) / T(2)) * z[65] + z[71];
z[47] = z[5] * z[47];
z[44] = -z[24] + z[44];
z[65] = -z[3] * z[44];
z[65] = 1 + z[65];
z[65] = (T(2) / T(3)) * z[65] + (T(17) / T(8)) * z[66];
z[65] = z[12] * z[65];
z[47] = z[47] + (T(-109) / T(72)) * z[55] + (T(-1) / T(12)) * z[64] + z[65];
z[47] = z[5] * z[47];
z[33] = z[33] + z[47] + (T(1) / T(2)) * z[50];
z[33] = z[13] * z[33];
z[47] = (T(1) / T(3)) * z[3];
z[50] = -z[1] + -z[24];
z[50] = z[47] * z[50];
z[64] = z[1] * z[6];
z[65] = z[26] * z[64];
z[66] = -z[24] + -z[43];
z[66] = z[3] * z[66];
z[66] = 1 + z[57] + z[66];
z[66] = z[3] * z[66];
z[66] = -z[7] + z[35] + z[66];
z[66] = z[12] * z[66];
z[71] = z[1] * z[25];
z[50] = T(2) / T(3) + z[50] + z[57] + (T(5) / T(12)) * z[65] + z[66] + (T(-1) / T(12)) * z[71];
z[50] = z[12] * z[50];
z[57] = z[1] * z[67];
z[57] = -1 + z[57];
z[57] = z[3] * z[57];
z[57] = z[57] + z[59];
z[62] = z[1] * z[62];
z[65] = -z[1] + z[62];
z[65] = z[2] * z[65];
z[66] = 1 + -z[18] + z[65];
z[66] = z[2] * z[66];
z[66] = (T(67) / T(6)) * z[57] + 3 * z[66];
z[66] = z[2] * z[66];
z[71] = 3 * z[1] + -z[24];
z[71] = z[3] * z[71];
z[71] = -3 + z[71];
z[71] = z[3] * z[71];
z[71] = z[7] + z[71];
z[73] = -z[67] * z[71];
z[66] = z[66] + z[73];
z[73] = (T(1) / T(2)) * z[5];
z[66] = z[66] * z[73];
z[74] = (T(127) / T(4)) * z[1] + -16 * z[24];
z[74] = z[3] * z[74];
z[74] = T(-31) / T(2) + z[74];
z[74] = z[3] * z[74];
z[74] = -z[56] + z[74];
z[75] = (T(-37) / T(8)) * z[1] + (T(28) / T(9)) * z[24];
z[75] = z[3] * z[75];
z[65] = T(109) / T(72) + 4 * z[65] + z[75];
z[65] = z[2] * z[65];
z[65] = z[65] + z[66] + (T(1) / T(9)) * z[74];
z[65] = z[5] * z[65];
z[66] = 7 * z[1];
z[74] = (T(19) / T(2)) * z[24] + z[66];
z[74] = z[47] * z[74];
z[74] = T(-11) / T(2) + z[74];
z[75] = (T(61) / T(8)) * z[1] + -z[24];
z[75] = z[3] * z[75];
z[75] = T(-49) / T(4) + z[75];
z[75] = z[47] * z[75];
z[75] = (T(15) / T(8)) * z[7] + z[75];
z[75] = z[12] * z[75];
z[76] = (T(-271) / T(4)) * z[1] + 31 * z[24];
z[62] = (T(7) / T(2)) * z[62] + (T(1) / T(9)) * z[76];
z[62] = z[62] * z[72];
z[62] = z[62] + z[65] + (T(1) / T(6)) * z[74] + z[75];
z[62] = z[5] * z[62];
z[65] = z[14] * z[43];
z[72] = -z[21] + z[65];
z[74] = (T(5) / T(2)) * z[30];
z[72] = z[72] * z[74];
z[75] = 5 * z[1];
z[76] = -z[28] + z[75];
z[77] = (T(-5) / T(2)) * z[24] + z[76];
z[77] = z[3] * z[77];
z[78] = (T(5) / T(2)) * z[28];
z[79] = z[1] + z[78];
z[79] = z[9] * z[79];
z[77] = T(-5) / T(2) + z[77] + z[79];
z[77] = z[3] * z[77];
z[72] = z[72] + z[77];
z[72] = z[11] * z[72];
z[29] = (T(7) / T(12)) * z[1] + (T(1) / T(6)) * z[24] + z[29];
z[29] = z[3] * z[29];
z[77] = (T(-5) / T(6)) * z[1] + z[28];
z[77] = z[25] * z[77];
z[57] = z[12] * z[57];
z[79] = (T(-11) / T(6)) * z[1] + -5 * z[28];
z[79] = z[9] * z[79];
z[79] = T(-3) / T(2) + z[79];
z[29] = z[29] + (T(17) / T(6)) * z[57] + (T(1) / T(3)) * z[72] + (T(5) / T(2)) * z[77] + (T(1) / T(2)) * z[79];
z[29] = z[29] * z[69];
z[57] = -1 + z[42];
z[41] = z[41] * z[57];
z[57] = (T(7) / T(4)) * z[1];
z[41] = z[39] + z[41] + z[57];
z[41] = z[15] * z[41];
z[41] = (T(-167) / T(36)) * z[21] + z[41];
z[72] = (T(-79) / T(2)) * z[1] + 127 * z[28];
z[65] = -z[9] * z[65];
z[65] = z[65] + (T(1) / T(36)) * z[72];
z[65] = z[14] * z[65];
z[41] = (T(1) / T(2)) * z[41] + (T(13) / T(12)) * z[64] + z[65];
z[41] = z[2] * z[41];
z[64] = -23 * z[1] + (T(227) / T(6)) * z[24] + (T(-187) / T(3)) * z[28];
z[65] = T(11) / T(6) + -z[42];
z[65] = z[15] * z[65];
z[64] = (T(1) / T(3)) * z[64] + z[65];
z[65] = -z[25] * z[43];
z[72] = -145 * z[1] + 199 * z[28];
z[72] = z[9] * z[72];
z[65] = z[65] + (T(1) / T(36)) * z[72];
z[65] = z[14] * z[65];
z[72] = z[6] * z[42];
z[29] = z[29] + z[33] + z[41] + z[50] + z[62] + (T(1) / T(4)) * z[64] + z[65] + (T(-5) / T(12)) * z[72];
z[29] = z[13] * z[29];
z[33] = prod_pow(z[3], 3);
z[41] = z[21] * z[33];
z[50] = z[10] * z[41];
z[62] = z[21] * z[53];
z[64] = (T(-1) / T(4)) * z[50] + (T(-5) / T(3)) * z[62];
z[64] = z[10] * z[64];
z[65] = z[3] * z[4];
z[72] = -z[7] * z[8];
z[65] = T(-53) / T(9) + (T(29) / T(3)) * z[52] + z[65] + z[72];
z[72] = (T(1) / T(2)) * z[0];
z[65] = z[65] * z[72];
z[77] = (T(5) / T(3)) * z[24] + z[45];
z[79] = z[4] * z[18];
z[77] = (T(13) / T(3)) * z[77] + z[79];
z[79] = -z[0] * z[4];
z[20] = -z[20] + z[79];
z[20] = z[2] * z[20];
z[20] = (T(17) / T(2)) * z[6] + (T(1) / T(4)) * z[20] + z[64] + z[65] + (T(1) / T(2)) * z[77];
z[20] = z[2] * z[20];
z[64] = -z[45] * z[54];
z[46] = z[24] + -z[46];
z[65] = z[10] * z[53];
z[46] = z[46] * z[65];
z[77] = (T(113) / T(2)) * z[1] + -91 * z[24];
z[77] = z[3] * z[77];
z[77] = -25 + z[77];
z[46] = z[46] + z[64] + (T(1) / T(9)) * z[77];
z[64] = -z[1] * z[53];
z[64] = z[59] + z[64];
z[64] = z[8] * z[64];
z[54] = (T(-1) / T(9)) * z[3] + (T(5) / T(2)) * z[7] + (T(-1) / T(2)) * z[54];
z[54] = z[54] * z[72];
z[20] = z[20] + (T(1) / T(2)) * z[46] + z[54] + z[64];
z[20] = z[2] * z[20];
z[46] = -53 * z[1] + 79 * z[24];
z[46] = z[3] * z[46];
z[46] = 133 + z[46];
z[46] = z[46] * z[47];
z[46] = -53 * z[7] + z[46];
z[54] = T(-3) / T(2) + z[18];
z[54] = z[3] * z[54];
z[54] = z[54] + z[59];
z[64] = z[3] * z[8];
z[54] = z[54] * z[64];
z[20] = z[20] + (T(1) / T(12)) * z[46] + z[54];
z[18] = -143 + 139 * z[18];
z[18] = (T(1) / T(24)) * z[18] + -z[50];
z[46] = z[41] * z[51];
z[50] = (T(67) / T(2)) * z[3] + -13 * z[7];
z[50] = z[0] * z[50];
z[54] = T(-85) / T(72) + 2 * z[52];
z[54] = z[0] * z[54];
z[54] = 5 * z[6] + z[54];
z[54] = z[2] * z[54];
z[18] = (T(1) / T(3)) * z[18] + z[46] + (T(1) / T(36)) * z[50] + z[54];
z[18] = z[2] * z[18];
z[46] = (T(-121) / T(12)) * z[1] + 5 * z[24];
z[46] = z[3] * z[46];
z[46] = T(7) / T(4) + z[46];
z[46] = z[46] * z[67];
z[46] = (T(5) / T(3)) * z[7] + z[46];
z[50] = z[8] * z[33];
z[54] = -z[50] * z[55];
z[18] = z[18] + (T(1) / T(3)) * z[46] + z[54];
z[18] = z[2] * z[18];
z[46] = z[8] * z[59];
z[52] = z[46] + z[52];
z[52] = z[0] * z[52];
z[52] = 3 * z[6] + z[52];
z[52] = z[2] * z[52];
z[54] = z[0] * z[7];
z[46] = -3 + -z[46] + z[52] + (T(85) / T(36)) * z[54];
z[46] = z[2] * z[46];
z[41] = -z[7] + z[41];
z[41] = z[41] * z[64];
z[52] = z[3] + -z[7];
z[41] = z[41] + (T(67) / T(6)) * z[52];
z[41] = (T(1) / T(2)) * z[41] + z[46];
z[41] = z[2] * z[41];
z[46] = -3 + z[62];
z[46] = z[46] * z[67];
z[46] = z[7] + z[46];
z[46] = z[3] * z[46];
z[52] = (T(3) / T(2)) * z[1] + -z[24];
z[52] = z[52] * z[53];
z[52] = z[52] + -z[59];
z[52] = z[8] * z[52] * z[53];
z[41] = z[41] + z[46] + z[52];
z[41] = z[2] * z[41];
z[46] = z[50] + -z[53];
z[50] = -z[46] * z[71];
z[41] = z[41] + (T(1) / T(2)) * z[50];
z[41] = z[41] * z[73];
z[46] = z[46] * z[70];
z[18] = z[18] + z[41] + z[46];
z[18] = z[5] * z[18];
z[18] = z[18] + (T(1) / T(2)) * z[20];
z[18] = z[5] * z[18];
z[20] = -z[21] * z[74];
z[21] = z[3] * z[78];
z[21] = z[21] + -z[48];
z[21] = z[3] * z[21];
z[20] = z[20] + z[21];
z[20] = z[3] * z[20];
z[21] = z[43] * z[74];
z[40] = z[30] * z[40];
z[20] = z[20] + z[21] + -5 * z[40];
z[20] = z[11] * z[20];
z[21] = -z[27] + z[39];
z[21] = z[21] * z[26];
z[40] = -z[28] + z[57];
z[41] = (T(1) / T(3)) * z[9];
z[40] = z[40] * z[41];
z[40] = T(-1) / T(4) + z[40];
z[40] = z[25] * z[40];
z[21] = z[21] + z[40];
z[27] = z[27] + -z[28];
z[40] = 5 * z[9];
z[27] = z[27] * z[40];
z[27] = T(7) / T(4) + z[27];
z[46] = (T(-7) / T(6)) * z[1] + -z[28];
z[46] = z[46] * z[67];
z[27] = (T(1) / T(3)) * z[27] + z[46];
z[27] = z[3] * z[27];
z[20] = (T(1) / T(6)) * z[20] + 5 * z[21] + z[27];
z[20] = z[20] * z[69];
z[21] = -z[9] + z[59];
z[21] = z[7] * z[21];
z[21] = z[21] + (T(1) / T(2)) * z[26];
z[27] = (T(1) / T(4)) * z[3];
z[46] = z[7] + -z[9];
z[46] = z[27] * z[46];
z[46] = -z[21] + z[46];
z[46] = z[4] * z[46];
z[27] = -z[27] + z[46];
z[27] = z[27] * z[60];
z[46] = (T(1) / T(9)) * z[9];
z[48] = (T(-199) / T(2)) * z[1] + 137 * z[28];
z[48] = z[46] * z[48];
z[48] = T(3) / T(2) + z[48];
z[50] = (T(9) / T(4)) * z[1] + (T(7) / T(18)) * z[24] + (T(-25) / T(9)) * z[28];
z[50] = z[3] * z[50];
z[27] = z[27] + (T(1) / T(2)) * z[48] + z[50];
z[48] = z[7] * z[9];
z[48] = -z[26] + z[48];
z[50] = z[3] * z[9];
z[52] = z[48] + -z[50];
z[32] = z[32] * z[52];
z[23] = z[23] + (T(1) / T(8)) * z[24];
z[23] = z[3] * z[23];
z[23] = T(5) / T(8) + z[23];
z[23] = z[3] * z[23];
z[52] = -z[7] + (T(-1) / T(6)) * z[9];
z[38] = z[6] * z[9] * z[38];
z[23] = z[23] + z[32] + z[38] + (T(1) / T(2)) * z[52];
z[23] = z[0] * z[23];
z[36] = -z[36] + z[68];
z[36] = z[3] * z[36];
z[38] = -z[28] + -z[45];
z[38] = z[9] * z[38];
z[36] = -4 + z[36] + z[38];
z[36] = z[3] * z[36];
z[38] = 11 * z[7] + -z[40];
z[36] = z[36] + (T(1) / T(2)) * z[38];
z[38] = z[28] + -z[45];
z[38] = z[9] * z[38];
z[40] = z[28] * z[67];
z[38] = z[38] + z[40];
z[38] = z[3] * z[38];
z[40] = z[9] * z[43];
z[40] = 1 + z[40];
z[35] = z[35] * z[40];
z[35] = z[35] + z[38];
z[35] = z[3] * z[35];
z[35] = z[35] + (T(-1) / T(2)) * z[48];
z[35] = z[12] * z[35];
z[32] = -z[32] + z[35] + (T(1) / T(3)) * z[36];
z[32] = z[12] * z[32];
z[35] = 4 * z[24] + 2 * z[28] + -z[75];
z[35] = z[3] * z[35];
z[36] = z[44] * z[65];
z[35] = z[35] + -2 * z[36] + -z[42];
z[22] = -z[10] * z[22] * z[33];
z[22] = z[22] + -z[62];
z[22] = z[10] * z[22];
z[22] = z[22] + -z[24] + -z[39];
z[22] = z[2] * z[22];
z[22] = z[22] + (T(1) / T(3)) * z[35];
z[22] = z[2] * z[22];
z[24] = -z[28] + z[44];
z[24] = z[3] * z[24];
z[24] = -2 + z[24] + z[42];
z[24] = z[24] * z[47];
z[22] = z[22] + z[24];
z[22] = z[16] * z[22];
z[24] = z[26] + z[63];
z[24] = z[7] * z[24];
z[24] = z[24] + (T(-1) / T(3)) * z[30];
z[24] = z[24] * z[61];
z[21] = (T(1) / T(3)) * z[21] + z[24];
z[17] = z[17] * z[21];
z[21] = -z[9] + -z[56];
z[17] = z[17] + (T(1) / T(3)) * z[21];
z[17] = z[15] * z[17];
z[21] = (T(395) / T(8)) * z[1] + -32 * z[28];
z[21] = z[9] * z[21];
z[21] = T(-139) / T(8) + z[21];
z[21] = z[21] * z[46];
z[24] = z[25] * z[37];
z[21] = z[21] + z[24];
z[21] = z[14] * z[21];
z[24] = z[9] * z[76];
z[25] = -z[49] + z[66];
z[25] = z[3] * z[25];
z[24] = -5 + z[24] + z[25];
z[24] = z[24] * z[67];
z[24] = z[24] + z[58];
z[24] = z[24] * z[51];
z[25] = z[26] + (T(5) / T(3)) * z[50];
z[25] = (T(1) / T(2)) * z[25] + (T(-1) / T(3)) * z[31];
z[25] = z[10] * z[25];
z[25] = (T(7) / T(6)) * z[3] + z[9] + z[25] + z[34];
z[25] = z[10] * z[25];
z[26] = z[6] * z[41];
return z[17] + z[18] + z[19] + z[20] + z[21] + z[22] + z[23] + z[24] + (T(1) / T(4)) * z[25] + z[26] + (T(1) / T(2)) * z[27] + z[29] + z[32];
}



template double eval_coef_2q3y_2l_pmmpp_12345_167(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_167(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
