#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_168(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[82];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[3];
z[5] = iW[16];
z[6] = v[1];
z[7] = iW[19];
z[8] = iW[12];
z[9] = v[3];
z[10] = iW[2];
z[11] = iW[5];
z[12] = v[0];
z[13] = iW[18];
z[14] = iW[17];
z[15] = iW[4];
z[16] = iW[23];
z[17] = iW[15];
z[18] = (T(1) / T(6)) * z[12];
z[19] = prod_pow(z[10], 2);
z[20] = z[18] * z[19];
z[21] = (T(1) / T(2)) * z[19];
z[22] = prod_pow(z[8], 2);
z[23] = -z[21] + -z[22];
z[24] = (T(1) / T(2)) * z[3];
z[23] = z[23] * z[24];
z[25] = z[7] + z[8];
z[26] = (T(3) / T(2)) * z[25];
z[27] = (T(1) / T(3)) * z[10];
z[28] = (T(1) / T(3)) * z[11];
z[20] = z[20] + z[23] + -z[26] + z[27] + -z[28];
z[20] = z[3] * z[20];
z[23] = (T(1) / T(4)) * z[19];
z[29] = z[12] * z[23];
z[30] = (T(-5) / T(3)) * z[10] + z[29];
z[30] = z[12] * z[30];
z[30] = T(73) / T(36) + z[30];
z[20] = z[20] + (T(1) / T(2)) * z[30];
z[20] = z[3] * z[20];
z[30] = (T(1) / T(2)) * z[12];
z[31] = -z[19] * z[30];
z[32] = (T(-1) / T(6)) * z[19] + -z[22];
z[32] = z[3] * z[32];
z[31] = z[10] + -z[25] + -z[28] + z[31] + z[32];
z[31] = z[3] * z[31];
z[32] = z[10] + z[13];
z[33] = 3 * z[13];
z[32] = z[32] * z[33];
z[34] = z[13] * z[19];
z[35] = z[30] * z[34];
z[36] = z[19] + -z[32] + z[35];
z[36] = z[30] * z[36];
z[37] = z[9] * z[13];
z[37] = -1 + z[37];
z[37] = z[23] * z[37];
z[38] = (T(3) / T(4)) * z[13];
z[39] = z[10] + z[38];
z[39] = z[13] * z[39];
z[35] = -z[35] + z[37] + z[39];
z[35] = z[9] * z[35];
z[37] = z[3] * z[23];
z[35] = -z[10] + (T(-1) / T(2)) * z[13] + z[35] + z[36] + z[37];
z[35] = z[9] * z[35];
z[36] = (T(1) / T(2)) * z[10];
z[37] = z[11] + z[36];
z[38] = z[37] + z[38];
z[38] = z[13] * z[38];
z[39] = z[5] * z[11];
z[38] = -z[23] + z[38] + z[39];
z[38] = z[12] * z[38];
z[40] = (T(7) / T(3)) * z[13];
z[41] = 3 * z[10] + z[40];
z[38] = z[38] + (T(1) / T(2)) * z[41];
z[38] = z[12] * z[38];
z[31] = T(1) / T(4) + z[31] + z[35] + z[38];
z[35] = (T(1) / T(2)) * z[9];
z[31] = z[31] * z[35];
z[38] = -z[5] + -z[36];
z[38] = (T(-2) / T(3)) * z[13] + (T(1) / T(2)) * z[38];
z[38] = z[12] * z[38];
z[38] = T(-1) / T(6) + z[38];
z[38] = z[12] * z[38];
z[20] = z[20] + z[31] + z[38];
z[20] = z[9] * z[20];
z[31] = 5 * z[15];
z[38] = prod_pow(z[14], 2);
z[41] = z[31] * z[38];
z[42] = z[15] + -z[17];
z[43] = z[16] * z[42];
z[44] = prod_pow(z[17], 2);
z[43] = z[43] + -z[44];
z[45] = z[16] * z[43];
z[46] = z[13] * z[44];
z[46] = -z[45] + z[46];
z[47] = z[41] + z[46];
z[47] = z[9] * z[47];
z[48] = (T(3) / T(2)) * z[13];
z[49] = (T(1) / T(3)) * z[17];
z[50] = z[48] + -z[49];
z[50] = z[13] * z[50];
z[51] = (T(1) / T(6)) * z[16];
z[52] = z[15] + z[17];
z[53] = -z[51] * z[52];
z[54] = (T(5) / T(6)) * z[14];
z[55] = z[14] + -z[15];
z[55] = z[54] * z[55];
z[56] = prod_pow(z[15], 2);
z[57] = (T(3) / T(4)) * z[56];
z[58] = z[8] * z[25];
z[47] = (T(1) / T(12)) * z[47] + (T(1) / T(2)) * z[50] + z[53] + z[55] + z[57] + -z[58];
z[47] = z[9] * z[47];
z[53] = 3 * z[22];
z[55] = (T(1) / T(4)) * z[38] + -z[53];
z[55] = z[3] * z[55];
z[59] = -z[13] + (T(47) / T(18)) * z[15];
z[60] = 3 * z[25];
z[47] = (T(-5) / T(2)) * z[14] + z[47] + z[55] + z[59] + -z[60];
z[47] = z[35] * z[47];
z[55] = z[8] * z[14];
z[55] = z[22] + z[55];
z[55] = z[3] * z[55];
z[61] = (T(1) / T(3)) * z[14];
z[62] = -z[8] + -z[55] + -z[61];
z[62] = z[14] * z[62];
z[53] = -z[53] + z[62];
z[53] = z[24] * z[53];
z[26] = -z[14] + -z[26] + z[53];
z[26] = z[3] * z[26];
z[26] = T(-107) / T(72) + z[26] + z[47];
z[26] = z[2] * z[26];
z[47] = (T(5) / T(12)) * z[14];
z[53] = z[3] * z[22];
z[62] = (T(1) / T(3)) * z[16];
z[63] = -z[47] + 2 * z[53] + z[60] + -z[62];
z[63] = z[3] * z[63];
z[53] = z[25] + z[53];
z[64] = z[33] + -z[49];
z[65] = (T(1) / T(4)) * z[9];
z[64] = z[64] * z[65];
z[64] = T(-13) / T(12) + z[64];
z[64] = z[13] * z[64];
z[66] = prod_pow(z[13], 2);
z[67] = (T(3) / T(4)) * z[12];
z[68] = -z[66] * z[67];
z[47] = (T(-2) / T(3)) * z[15] + -z[47] + z[53] + z[64] + z[68];
z[47] = z[9] * z[47];
z[40] = z[15] + z[40];
z[40] = z[12] * z[40];
z[40] = T(-23) / T(9) + z[40];
z[40] = (T(1) / T(2)) * z[40] + z[47] + z[63];
z[40] = z[9] * z[40];
z[47] = (T(1) / T(6)) * z[14];
z[55] = z[47] + z[55] + z[60];
z[55] = z[3] * z[55];
z[55] = T(155) / T(36) + z[55];
z[55] = z[3] * z[55];
z[60] = z[5] * z[12];
z[63] = T(143) / T(36) + z[60];
z[63] = z[30] * z[63];
z[26] = z[26] + z[40] + z[55] + z[63];
z[26] = z[2] * z[26];
z[40] = z[10] * z[11];
z[55] = prod_pow(z[11], 2);
z[63] = z[40] + z[55];
z[64] = z[10] * z[30];
z[68] = -z[63] * z[64];
z[68] = z[19] + z[68];
z[68] = z[30] * z[68];
z[69] = (T(1) / T(6)) * z[11];
z[51] = (T(-3) / T(2)) * z[7] + -z[8] + -z[51] + z[68] + -z[69];
z[51] = z[3] * z[51];
z[64] = -z[37] * z[64];
z[64] = z[11] + -z[36] + z[64];
z[64] = z[12] * z[64];
z[64] = T(-143) / T(24) + z[64];
z[51] = z[51] + (T(1) / T(3)) * z[64];
z[51] = z[3] * z[51];
z[64] = (T(1) / T(3)) * z[12];
z[68] = z[10] * z[12];
z[70] = T(-167) / T(24) + z[68];
z[70] = z[64] * z[70];
z[51] = z[51] + z[70];
z[51] = z[3] * z[51];
z[70] = prod_pow(z[12], 2);
z[20] = z[20] + z[26] + z[51] + (T(-1) / T(3)) * z[70];
z[20] = z[1] * z[20];
z[26] = z[41] + -z[45];
z[41] = z[9] * z[26];
z[51] = z[14] + (T(-5) / T(2)) * z[15];
z[51] = z[51] * z[54];
z[54] = (T(5) / T(3)) * z[15] + z[17];
z[54] = z[16] * z[54];
z[71] = (T(5) / T(12)) * z[17] + -z[33];
z[71] = z[13] * z[71];
z[41] = (T(1) / T(6)) * z[41] + z[51] + (T(-1) / T(4)) * z[54] + -z[58] + z[71];
z[41] = z[35] * z[41];
z[51] = z[56] + z[66];
z[51] = z[51] * z[67];
z[58] = -5 * z[22] + (T(-1) / T(3)) * z[38];
z[58] = z[24] * z[58];
z[66] = 5 * z[25];
z[71] = (T(-25) / T(12)) * z[14] + (T(77) / T(18)) * z[15] + -z[16] + -z[66];
z[41] = (T(5) / T(3)) * z[13] + z[41] + z[51] + z[58] + (T(1) / T(2)) * z[71];
z[41] = z[9] * z[41];
z[47] = -7 * z[25] + -z[47];
z[51] = -3 * z[8] + -z[61];
z[51] = z[14] * z[51];
z[51] = -2 * z[22] + (T(1) / T(2)) * z[51];
z[51] = z[3] * z[51];
z[47] = (T(1) / T(2)) * z[47] + z[51];
z[47] = z[3] * z[47];
z[51] = z[52] * z[62];
z[51] = z[50] + -z[51] + (T(3) / T(2)) * z[56];
z[52] = -z[46] * z[65];
z[52] = -z[51] + z[52];
z[52] = z[9] * z[52];
z[52] = (T(5) / T(3)) * z[0] + z[52] + -z[59];
z[58] = (T(1) / T(2)) * z[2];
z[52] = z[52] * z[58];
z[59] = z[0] * z[3];
z[61] = (T(1) / T(12)) * z[13];
z[65] = z[5] + (T(14) / T(9)) * z[15] + z[61];
z[65] = z[12] * z[65];
z[41] = T(-67) / T(36) + z[41] + z[47] + z[52] + (T(-5) / T(3)) * z[59] + z[65];
z[41] = z[2] * z[41];
z[47] = -z[28] + -z[36];
z[52] = z[37] * z[68];
z[47] = (T(1) / T(2)) * z[47] + (T(1) / T(3)) * z[52];
z[47] = z[12] * z[47];
z[52] = (T(5) / T(6)) * z[10];
z[65] = 7 * z[7] + 5 * z[8] + z[28] + z[52] + z[62];
z[63] = z[63] * z[68];
z[68] = -z[10] + (T(-11) / T(12)) * z[11];
z[68] = z[10] * z[68];
z[68] = (T(3) / T(4)) * z[63] + z[68];
z[68] = z[12] * z[68];
z[65] = (T(1) / T(2)) * z[65] + z[68];
z[65] = z[3] * z[65];
z[47] = T(5) / T(2) + z[47] + z[65];
z[47] = z[3] * z[47];
z[65] = -z[9] + z[12];
z[65] = z[34] * z[65];
z[33] = (T(-7) / T(2)) * z[10] + -z[33];
z[33] = z[13] * z[33];
z[21] = z[21] + z[33] + z[65];
z[21] = z[21] * z[35];
z[33] = (T(5) / T(4)) * z[10] + z[11] + z[48];
z[33] = z[13] * z[33];
z[33] = z[33] + z[39];
z[33] = z[12] * z[33];
z[21] = (T(3) / T(4)) * z[10] + z[21] + z[33] + z[53] + z[61];
z[21] = z[21] * z[35];
z[33] = z[28] + z[66];
z[19] = -z[19] * z[64];
z[19] = z[19] + z[33] + -z[36];
z[23] = z[22] + z[23];
z[23] = z[3] * z[23];
z[19] = (T(1) / T(2)) * z[19] + z[23];
z[19] = z[3] * z[19];
z[23] = (T(5) / T(2)) * z[10];
z[36] = z[15] + z[23];
z[29] = -z[5] + -z[13] + -z[29] + (T(1) / T(6)) * z[36];
z[29] = z[12] * z[29];
z[29] = T(-31) / T(36) + z[29];
z[19] = z[19] + z[21] + (T(1) / T(2)) * z[29];
z[19] = z[9] * z[19];
z[21] = (T(-1) / T(4)) * z[15] + -z[27];
z[21] = z[12] * z[21];
z[21] = T(49) / T(36) + z[21];
z[21] = z[12] * z[21];
z[29] = prod_pow(z[3], 2);
z[36] = z[0] * z[29];
z[19] = z[19] + z[20] + z[21] + (T(5) / T(6)) * z[36] + z[41] + z[47];
z[19] = z[1] * z[19];
z[20] = z[0] * z[6];
z[21] = z[5] + z[7];
z[21] = z[20] * z[21];
z[36] = 3 * z[5];
z[21] = z[21] + z[36];
z[21] = z[2] * z[21];
z[39] = (T(-71) / T(9)) * z[0] + -z[7];
z[39] = z[6] * z[39];
z[21] = -3 + z[21] + z[39];
z[39] = (T(1) / T(4)) * z[2];
z[21] = z[21] * z[39];
z[41] = z[3] * z[7];
z[47] = (T(1) / T(4)) * z[41];
z[48] = T(20) / T(3) + -z[47];
z[48] = z[6] * z[48];
z[21] = (T(-20) / T(3)) * z[3] + z[21] + z[48] + z[67];
z[21] = z[2] * z[21];
z[48] = (T(1) / T(2)) * z[41];
z[53] = 1 + -z[48];
z[53] = z[24] * z[53];
z[61] = (T(20) / T(3)) * z[12];
z[53] = z[53] + -z[61];
z[53] = z[6] * z[53];
z[65] = (T(1) / T(4)) * z[70];
z[66] = (T(3) / T(4)) * z[3];
z[68] = (T(40) / T(3)) * z[12] + -z[66];
z[68] = z[3] * z[68];
z[21] = z[21] + z[53] + -z[65] + z[68];
z[21] = z[2] * z[21];
z[53] = 3 * z[12];
z[68] = -z[3] * z[53];
z[71] = z[2] * z[5];
z[72] = -1 + z[71];
z[73] = z[2] * z[12] * z[72];
z[68] = z[68] + z[70] + 3 * z[73];
z[68] = z[39] * z[68];
z[73] = z[7] * z[29];
z[61] = -z[61] + (T(3) / T(4)) * z[73];
z[61] = z[3] * z[61];
z[73] = (T(1) / T(2)) * z[70];
z[61] = z[61] + z[73];
z[61] = z[3] * z[61];
z[61] = z[61] + z[68];
z[61] = z[2] * z[61];
z[68] = prod_pow(z[3], 3);
z[74] = z[7] * z[68];
z[75] = -z[70] + z[74];
z[75] = z[3] * z[75];
z[72] = z[70] * z[72];
z[76] = z[2] * z[72];
z[75] = z[75] + z[76];
z[75] = z[58] * z[75];
z[76] = T(-1) / T(2) + z[41];
z[77] = -z[29] * z[76];
z[77] = -z[73] + z[77];
z[77] = z[29] * z[77];
z[75] = z[75] + z[77];
z[75] = z[58] * z[75];
z[77] = -1 + z[41];
z[78] = z[3] * z[77];
z[79] = z[12] + z[78];
z[80] = (T(1) / T(4)) * z[3];
z[81] = z[79] * z[80];
z[81] = (T(20) / T(9)) * z[70] + -z[81];
z[68] = -z[68] * z[81];
z[68] = z[68] + z[75];
z[68] = z[1] * z[68];
z[66] = z[66] * z[79];
z[66] = -z[66] + (T(20) / T(3)) * z[70];
z[75] = z[29] * z[66];
z[61] = z[61] + z[68] + z[75];
z[61] = z[1] * z[61];
z[66] = -z[3] * z[66];
z[68] = z[6] * z[81];
z[21] = z[21] + z[61] + z[66] + z[68];
z[21] = z[4] * z[21];
z[61] = z[24] * z[77];
z[66] = z[11] * z[30];
z[68] = T(40) / T(3) + -z[66];
z[68] = z[64] * z[68];
z[68] = z[61] + z[68];
z[68] = z[3] * z[68];
z[75] = (T(143) / T(72)) * z[70];
z[68] = z[68] + -z[75];
z[29] = z[29] * z[68];
z[68] = -z[3] * z[76];
z[68] = (T(-71) / T(18)) * z[12] + z[68];
z[68] = z[3] * z[68];
z[68] = z[68] + -z[73];
z[68] = z[3] * z[68];
z[72] = z[72] + z[74];
z[58] = z[58] * z[72];
z[58] = z[58] + z[68];
z[58] = z[2] * z[58];
z[29] = z[29] + z[58];
z[29] = z[1] * z[29];
z[58] = T(71) / T(36) + z[41];
z[58] = z[3] * z[58];
z[53] = -z[53] + z[58];
z[53] = z[3] * z[53];
z[58] = -2 + 2 * z[71];
z[58] = z[12] * z[58];
z[58] = (T(-71) / T(36)) * z[3] + z[58];
z[58] = z[2] * z[58];
z[53] = z[53] + z[58] + z[73];
z[53] = z[2] * z[53];
z[58] = z[11] * z[12];
z[68] = T(-227) / T(9) + z[58];
z[68] = z[30] * z[68];
z[68] = z[68] + -z[78];
z[68] = z[3] * z[68];
z[68] = z[68] + (T(143) / T(36)) * z[70];
z[68] = z[3] * z[68];
z[29] = z[29] + z[53] + z[68];
z[29] = z[1] * z[29];
z[53] = T(-571) / T(2) + -71 * z[59];
z[53] = -61 * z[20] + (T(1) / T(2)) * z[53];
z[68] = (T(71) / T(18)) * z[0] + 5 * z[5];
z[71] = z[5] * z[20];
z[68] = (T(1) / T(2)) * z[68] + z[71];
z[68] = z[2] * z[68];
z[53] = (T(1) / T(18)) * z[53] + z[68];
z[53] = z[2] * z[53];
z[68] = z[6] + z[12];
z[68] = (T(-113) / T(2)) * z[3] + (T(125) / T(3)) * z[68];
z[53] = z[53] + (T(1) / T(6)) * z[68];
z[53] = z[2] * z[53];
z[66] = T(107) / T(9) + -z[66];
z[66] = z[12] * z[66];
z[61] = z[61] + z[66];
z[61] = z[3] * z[61];
z[66] = T(-67) / T(3) + z[58];
z[66] = z[6] * z[18] * z[66];
z[21] = z[21] + z[29] + z[53] + z[61] + z[66] + -z[75];
z[21] = z[4] * z[21];
z[29] = T(61) / T(3) + -z[58];
z[29] = z[18] * z[29];
z[53] = z[12] * z[55];
z[61] = z[28] + (T(-1) / T(4)) * z[53];
z[61] = z[12] * z[61];
z[47] = T(-83) / T(36) + -z[47] + z[61];
z[47] = z[3] * z[47];
z[29] = z[29] + z[47];
z[29] = z[3] * z[29];
z[47] = (T(97) / T(72)) * z[70];
z[29] = z[29] + z[47];
z[29] = z[3] * z[29];
z[61] = z[7] + (T(7) / T(3)) * z[14];
z[61] = z[3] * z[61];
z[61] = T(157) / T(18) + z[61];
z[24] = z[24] * z[61];
z[24] = (T(-23) / T(9)) * z[12] + z[24];
z[24] = z[3] * z[24];
z[61] = -z[5] * z[65];
z[66] = z[3] * z[38];
z[66] = (T(-1) / T(4)) * z[7] + (T(-2) / T(3)) * z[14] + (T(-7) / T(12)) * z[66];
z[66] = z[3] * z[66];
z[66] = T(-71) / T(36) + z[66];
z[66] = z[3] * z[66];
z[61] = z[61] + z[66];
z[61] = z[2] * z[61];
z[24] = z[24] + z[61] + z[65];
z[24] = z[2] * z[24];
z[24] = z[24] + z[29];
z[24] = z[1] * z[24];
z[29] = T(-191) / T(12) + z[58];
z[29] = z[29] * z[64];
z[61] = -5 * z[11] + 3 * z[53];
z[61] = z[12] * z[61];
z[61] = T(235) / T(9) + 5 * z[41] + z[61];
z[61] = z[61] * z[80];
z[29] = z[29] + z[61];
z[29] = z[3] * z[29];
z[61] = -5 * z[7] + (T(-19) / T(3)) * z[14];
z[61] = z[61] * z[80];
z[61] = T(-55) / T(9) + z[61];
z[61] = z[3] * z[61];
z[60] = T(5) / T(3) + z[60];
z[60] = z[39] * z[60];
z[60] = (T(31) / T(72)) * z[12] + z[60] + z[61];
z[60] = z[2] * z[60];
z[24] = z[24] + z[29] + -z[47] + z[60];
z[24] = z[1] * z[24];
z[29] = (T(1) / T(2)) * z[7];
z[47] = z[5] + -z[29];
z[20] = z[20] * z[47];
z[36] = (T(65) / T(18)) * z[0] + z[36];
z[20] = z[20] + (T(1) / T(2)) * z[36];
z[20] = z[2] * z[20];
z[36] = -41 + -23 * z[59];
z[29] = (T(-8) / T(3)) * z[0] + z[29];
z[29] = z[6] * z[29];
z[20] = z[20] + z[29] + (T(1) / T(9)) * z[36];
z[20] = z[2] * z[20];
z[29] = T(23) / T(2) + -z[58];
z[18] = z[18] * z[29];
z[29] = -z[30] * z[55];
z[29] = z[11] + z[29];
z[29] = z[12] * z[29];
z[29] = -z[29] + z[41];
z[29] = T(-62) / T(9) + (T(-3) / T(2)) * z[29];
z[29] = z[3] * z[29];
z[36] = (T(-7) / T(3)) * z[11] + z[53];
z[36] = z[12] * z[36];
z[36] = T(8) / T(3) + (T(1) / T(4)) * z[36] + z[48];
z[36] = z[6] * z[36];
z[18] = z[18] + z[20] + z[21] + z[24] + z[29] + z[36];
z[18] = z[4] * z[18];
z[20] = (T(1) / T(3)) * z[26] + z[34];
z[20] = z[9] * z[20];
z[21] = z[15] + z[49];
z[21] = z[16] * z[21];
z[21] = z[21] + (T(1) / T(3)) * z[44];
z[24] = -z[14] * z[31];
z[20] = z[20] + -z[21] + z[24] + z[32];
z[20] = z[9] * z[20];
z[22] = -z[22] + (T(-1) / T(12)) * z[38];
z[22] = z[3] * z[22];
z[24] = -z[3] * z[8];
z[24] = T(-1) / T(2) + z[24];
z[24] = z[0] * z[24];
z[24] = -z[16] + z[24];
z[20] = (T(1) / T(4)) * z[5] + (T(5) / T(24)) * z[13] + (T(1) / T(3)) * z[15] + (T(1) / T(12)) * z[17] + (T(1) / T(8)) * z[20] + z[22] + (T(1) / T(2)) * z[24] + -z[25] + -z[69];
z[20] = z[9] * z[20];
z[22] = -z[9] * z[45];
z[24] = z[6] * z[43] * z[62];
z[22] = -z[21] + z[22] + z[24];
z[22] = z[6] * z[22];
z[24] = z[35] * z[45];
z[25] = z[0] * z[5];
z[21] = z[21] + z[24] + z[25];
z[21] = z[21] * z[35];
z[25] = (T(-11) / T(3)) * z[40] + z[63];
z[25] = z[25] * z[30];
z[21] = -z[0] + z[7] + z[16] + z[21] + (T(1) / T(4)) * z[22] + z[25] + z[28] + (T(1) / T(6)) * z[42];
z[22] = (T(1) / T(2)) * z[6];
z[21] = z[21] * z[22];
z[25] = z[13] * z[49];
z[25] = z[25] + -z[54];
z[26] = (T(1) / T(6)) * z[6];
z[28] = z[26] * z[45];
z[29] = z[5] + -z[7];
z[29] = z[0] * z[29];
z[25] = -z[24] + (T(1) / T(4)) * z[25] + z[28] + z[29];
z[22] = z[22] * z[25];
z[25] = -z[26] + z[35];
z[25] = z[25] * z[46];
z[25] = z[25] + z[51];
z[25] = z[25] * z[39];
z[24] = z[24] + z[50] + (T(1) / T(2)) * z[54];
z[24] = z[24] * z[35];
z[26] = -z[56] * z[67];
z[28] = (T(-19) / T(9)) * z[15] + z[16];
z[22] = (T(23) / T(12)) * z[0] + z[5] + (T(-7) / T(12)) * z[13] + z[22] + z[24] + z[25] + z[26] + (T(1) / T(2)) * z[28];
z[22] = z[2] * z[22];
z[24] = -z[33] + -z[52];
z[25] = z[10] + (T(11) / T(3)) * z[11];
z[25] = z[10] * z[25];
z[25] = z[25] + (T(-3) / T(2)) * z[63];
z[25] = z[25] * z[30];
z[24] = (T(1) / T(12)) * z[14] + (T(1) / T(2)) * z[24] + z[25] + -z[62];
z[24] = z[3] * z[24];
z[25] = -z[27] * z[37];
z[25] = z[25] + z[57];
z[25] = z[12] * z[25];
z[23] = -z[11] + (T(41) / T(6)) * z[15] + z[23];
z[23] = (T(1) / T(3)) * z[23] + z[25];
z[23] = z[12] * z[23];
z[23] = T(-281) / T(36) + z[23];
return z[18] + z[19] + z[20] + z[21] + z[22] + (T(1) / T(2)) * z[23] + z[24] + (T(-8) / T(3)) * z[59];
}



template double eval_coef_2q3y_2l_pmmpp_12345_168(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_168(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
