#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_169(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[79];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[15];
z[5] = iW[3];
z[6] = iW[21];
z[7] = v[1];
z[8] = iW[22];
z[9] = iW[16];
z[10] = v[3];
z[11] = v[0];
z[12] = iW[17];
z[13] = iW[4];
z[14] = iW[7];
z[15] = iW[12];
z[16] = iW[18];
z[17] = prod_pow(z[1], 2);
z[18] = z[3] * z[17];
z[19] = 5 * z[18];
z[20] = (T(1) / T(2)) * z[1];
z[21] = -z[19] + z[20];
z[22] = z[1] * z[3];
z[23] = z[0] * z[3];
z[23] = z[22] + z[23];
z[24] = (T(1) / T(6)) * z[4];
z[23] = z[23] * z[24];
z[25] = z[0] + z[1];
z[26] = z[2] * z[4];
z[27] = z[25] * z[26];
z[21] = 3 * z[0] + (T(1) / T(6)) * z[21] + z[23] + (T(-1) / T(12)) * z[27];
z[21] = z[2] * z[21];
z[23] = (T(1) / T(2)) * z[3];
z[27] = (T(-15) / T(2)) * z[1] + (T(31) / T(3)) * z[18];
z[27] = z[23] * z[27];
z[28] = (T(1) / T(2)) * z[0];
z[29] = -7 * z[3] + (T(-13) / T(6)) * z[7];
z[29] = z[28] * z[29];
z[30] = prod_pow(z[3], 2);
z[25] = -z[4] * z[25] * z[30];
z[31] = z[11] * z[17];
z[32] = (T(-73) / T(3)) * z[1] + (T(-29) / T(2)) * z[31];
z[32] = z[11] * z[32];
z[21] = -5 + z[21] + (T(1) / T(12)) * z[25] + z[27] + z[29] + (T(1) / T(3)) * z[32];
z[25] = (T(1) / T(2)) * z[2];
z[21] = z[21] * z[25];
z[27] = prod_pow(z[3], 3);
z[29] = prod_pow(z[2], 2);
z[32] = (T(1) / T(3)) * z[17];
z[33] = z[12] * z[27] * z[29] * z[32];
z[34] = (T(1) / T(2)) * z[22];
z[35] = -3 + -z[34];
z[36] = (T(-7) / T(2)) * z[3] + (T(-19) / T(3)) * z[7];
z[36] = z[0] * z[36];
z[35] = 3 * z[35] + z[36];
z[36] = z[0] * z[2];
z[37] = z[1] * z[11];
z[35] = (T(1) / T(2)) * z[35] + (T(5) / T(4)) * z[36] + -z[37];
z[35] = z[25] * z[35];
z[38] = (T(1) / T(3)) * z[18];
z[39] = (T(5) / T(8)) * z[1] + z[38];
z[39] = z[3] * z[39];
z[39] = T(-33) / T(8) + z[39];
z[39] = z[3] * z[39];
z[40] = (T(-1) / T(8)) * z[1] + -z[18];
z[40] = z[3] * z[40];
z[40] = T(9) / T(8) + z[40];
z[40] = z[11] * z[40];
z[35] = (T(19) / T(6)) * z[7] + z[35] + z[39] + z[40];
z[35] = z[2] * z[35];
z[39] = -1 + z[22];
z[40] = -z[1] + z[18];
z[41] = z[11] * z[40];
z[42] = -3 * z[39] + -z[41];
z[42] = z[11] * z[42];
z[43] = 3 * z[1];
z[44] = z[31] + z[43];
z[44] = z[11] * z[44];
z[44] = 3 + z[44];
z[45] = z[0] * z[7];
z[46] = -z[44] + (T(-19) / T(6)) * z[45];
z[46] = z[2] * z[46];
z[47] = -z[3] + z[7];
z[42] = z[42] + z[46] + (T(19) / T(2)) * z[47];
z[42] = z[25] * z[42];
z[34] = -1 + z[34];
z[34] = z[3] * z[34];
z[46] = (T(1) / T(2)) * z[7];
z[34] = z[34] + z[46];
z[47] = (T(1) / T(2)) * z[18];
z[48] = -z[1] + z[47];
z[48] = z[3] * z[48];
z[48] = T(1) / T(2) + z[48];
z[49] = -z[11] * z[48];
z[49] = (T(-19) / T(2)) * z[34] + z[49];
z[49] = z[11] * z[49];
z[42] = z[42] + z[49];
z[42] = z[2] * z[42];
z[49] = (T(1) / T(3)) * z[7];
z[50] = z[1] + -z[38];
z[50] = z[3] * z[50];
z[50] = -1 + z[50];
z[50] = z[3] * z[50];
z[50] = z[49] + z[50];
z[50] = prod_pow(z[11], 2) * z[50];
z[42] = z[42] + (T(19) / T(4)) * z[50];
z[42] = z[5] * z[42];
z[50] = (T(-21) / T(2)) * z[1] + (T(11) / T(3)) * z[18];
z[50] = z[23] * z[50];
z[50] = 5 + z[50];
z[50] = z[3] * z[50];
z[50] = (T(-19) / T(12)) * z[7] + z[50];
z[50] = z[11] * z[50];
z[35] = -z[33] + z[35] + (T(1) / T(2)) * z[42] + z[50];
z[35] = z[5] * z[35];
z[42] = 2 * z[1];
z[50] = -z[18] + z[42];
z[51] = z[30] * z[50];
z[52] = z[17] * z[30];
z[53] = z[2] * z[52];
z[51] = (T(2) / T(3)) * z[51] + z[53];
z[51] = z[2] * z[51];
z[33] = z[33] + z[51];
z[33] = z[12] * z[33];
z[51] = z[18] + -z[20];
z[54] = -z[30] * z[51];
z[53] = z[46] + z[53] + z[54];
z[53] = z[25] * z[53];
z[54] = (T(3) / T(2)) * z[1] + -z[18];
z[54] = z[30] * z[54];
z[54] = -z[46] + z[54];
z[55] = z[3] * z[54];
z[27] = z[17] * z[27];
z[27] = -z[7] + z[27];
z[56] = z[2] * z[45];
z[56] = z[27] + z[56];
z[56] = z[25] * z[56];
z[56] = z[55] + z[56];
z[56] = z[2] * z[56];
z[43] = -z[18] + z[43];
z[43] = z[3] * z[43];
z[43] = -3 + z[43];
z[43] = z[3] * z[43];
z[43] = z[7] + z[43];
z[57] = (T(1) / T(2)) * z[43];
z[58] = -z[30] * z[57];
z[56] = z[56] + z[58];
z[58] = (T(1) / T(2)) * z[8];
z[56] = z[56] * z[58];
z[34] = z[3] * z[34];
z[34] = z[34] + z[53] + z[56];
z[34] = z[8] * z[34];
z[53] = 11 * z[1];
z[56] = (T(-19) / T(4)) * z[18] + z[53];
z[59] = (T(1) / T(3)) * z[3];
z[56] = z[56] * z[59];
z[56] = T(-19) / T(8) + z[56];
z[56] = z[3] * z[56];
z[53] = z[19] + -z[53];
z[53] = z[3] * z[53];
z[41] = 1 + (T(-17) / T(9)) * z[41] + (T(1) / T(6)) * z[53];
z[41] = z[11] * z[41];
z[21] = (T(7) / T(24)) * z[7] + z[21] + -z[33] + z[34] + z[35] + z[41] + z[56];
z[21] = z[5] * z[21];
z[34] = z[10] * z[17];
z[35] = (T(1) / T(3)) * z[34];
z[41] = -z[20] + z[35];
z[41] = z[10] * z[41];
z[41] = T(1) / T(6) + z[41];
z[53] = z[0] * z[20] * z[30];
z[53] = z[41] + z[53];
z[56] = z[1] * z[10];
z[60] = -1 + (T(1) / T(2)) * z[56];
z[60] = z[10] * z[60];
z[60] = z[46] + z[60];
z[61] = z[4] * z[60];
z[53] = (T(1) / T(2)) * z[53] + (T(1) / T(3)) * z[61];
z[53] = z[24] * z[53];
z[22] = -z[22] * z[24];
z[24] = (T(1) / T(3)) * z[1];
z[61] = (T(1) / T(4)) * z[18];
z[22] = z[22] + -z[24] + z[61];
z[22] = z[0] * z[22];
z[62] = z[1] * z[4];
z[62] = -z[17] + z[62];
z[36] = z[36] * z[62];
z[22] = z[22] + z[32] + (T(1) / T(12)) * z[36];
z[22] = z[22] * z[25];
z[24] = (T(-1) / T(8)) * z[18] + z[24];
z[24] = z[3] * z[24];
z[24] = T(19) / T(24) + z[24];
z[24] = z[0] * z[24];
z[32] = (T(19) / T(12)) * z[1] + z[19];
z[22] = z[22] + z[24] + (T(41) / T(36)) * z[31] + (T(1) / T(3)) * z[32] + z[34] + z[53];
z[22] = z[2] * z[22];
z[24] = (T(1) / T(2)) * z[10];
z[32] = (T(-13) / T(3)) * z[1] + z[34];
z[32] = z[24] * z[32];
z[36] = 13 * z[34];
z[53] = 25 * z[1] + -z[36];
z[53] = 5 * z[31] + (T(1) / T(3)) * z[53];
z[53] = z[11] * z[53];
z[62] = -z[7] + z[10];
z[63] = z[0] * z[62];
z[32] = T(5) / T(3) + z[32] + z[53] + (T(5) / T(3)) * z[63];
z[32] = z[2] * z[32];
z[36] = 23 * z[1] + -z[36];
z[36] = z[24] * z[36];
z[36] = -5 + z[36];
z[53] = (T(1) / T(3)) * z[10];
z[36] = z[36] * z[53];
z[64] = (T(-37) / T(2)) * z[1] + 20 * z[34];
z[64] = z[53] * z[64];
z[65] = z[11] * z[34];
z[64] = z[64] + (T(-9) / T(2)) * z[65];
z[64] = z[11] * z[64];
z[32] = z[32] + z[36] + z[64];
z[32] = z[2] * z[32];
z[36] = (T(5) / T(2)) * z[1];
z[64] = (T(3) / T(2)) * z[31] + -z[34] + z[36];
z[64] = z[11] * z[64];
z[63] = 1 + -z[56] + z[63];
z[63] = (T(1) / T(2)) * z[63] + z[64];
z[63] = z[2] * z[63];
z[64] = z[17] * z[24];
z[66] = -z[1] + z[64];
z[66] = z[10] * z[66];
z[66] = T(1) / T(2) + z[66];
z[67] = z[10] * z[66];
z[68] = 2 * z[10];
z[69] = -z[1] + z[34];
z[70] = z[68] * z[69];
z[70] = (T(-3) / T(2)) * z[65] + z[70];
z[70] = z[11] * z[70];
z[63] = z[63] + -z[67] + z[70];
z[63] = z[2] * z[63];
z[70] = prod_pow(z[10], 2);
z[71] = (T(1) / T(2)) * z[70];
z[72] = z[31] * z[71];
z[73] = z[69] * z[70];
z[72] = z[72] + -z[73];
z[72] = z[11] * z[72];
z[74] = z[66] * z[70];
z[72] = z[72] + z[74];
z[63] = z[63] + z[72];
z[63] = z[2] * z[63];
z[44] = z[44] + z[45];
z[74] = prod_pow(z[2], 4);
z[74] = (T(1) / T(4)) * z[74];
z[44] = z[44] * z[74];
z[74] = z[5] * z[44];
z[63] = z[63] + -z[74];
z[63] = z[6] * z[63];
z[75] = (T(-2) / T(3)) * z[31] + -z[36];
z[75] = z[11] * z[75];
z[75] = -3 + (T(-7) / T(6)) * z[45] + z[75];
z[76] = prod_pow(z[2], 3);
z[75] = z[75] * z[76];
z[75] = -z[74] + z[75];
z[75] = z[5] * z[75];
z[32] = z[32] + z[63] + (T(7) / T(3)) * z[72] + z[75];
z[32] = z[6] * z[32];
z[62] = z[28] * z[62];
z[63] = (T(35) / T(3)) * z[1] + 10 * z[31] + -11 * z[34];
z[63] = z[11] * z[63];
z[75] = -z[0] + z[1] + 2 * z[31];
z[75] = z[2] * z[75];
z[41] = 7 * z[41] + z[62] + z[63] + (T(2) / T(3)) * z[75];
z[41] = z[2] * z[41];
z[62] = z[0] * z[46];
z[63] = 1 + z[62];
z[20] = z[11] * z[20];
z[75] = -z[20] + -z[63];
z[75] = z[75] * z[76];
z[74] = -z[74] + z[75];
z[74] = z[5] * z[74];
z[75] = -71 * z[1] + -37 * z[31];
z[75] = z[11] * z[75];
z[75] = -17 + (T(1) / T(2)) * z[75];
z[75] = z[29] * z[75];
z[74] = z[74] + (T(1) / T(6)) * z[75];
z[74] = z[5] * z[74];
z[75] = z[31] * z[70];
z[73] = -2 * z[73] + z[75];
z[73] = z[11] * z[73];
z[75] = -z[34] + z[42];
z[75] = z[10] * z[75];
z[75] = -1 + z[75];
z[77] = -z[70] * z[75];
z[73] = z[73] + z[77];
z[73] = z[16] * z[73];
z[77] = (T(-49) / T(2)) * z[1] + 34 * z[34];
z[77] = z[53] * z[77];
z[77] = -7 * z[65] + z[77];
z[77] = z[11] * z[77];
z[78] = (T(11) / T(2)) * z[1] + (T(-13) / T(3)) * z[34];
z[78] = z[10] * z[78];
z[78] = T(-7) / T(6) + z[78];
z[78] = z[10] * z[78];
z[32] = z[32] + z[41] + (T(4) / T(3)) * z[73] + z[74] + z[77] + z[78];
z[32] = z[6] * z[32];
z[41] = 2 * z[18];
z[73] = z[36] + -z[41];
z[73] = z[30] * z[73];
z[50] = z[3] * z[50];
z[74] = T(-1) / T(2) + z[50] + z[56];
z[74] = z[10] * z[74];
z[73] = -z[46] + z[73] + z[74];
z[73] = z[10] * z[73];
z[74] = 3 * z[18];
z[77] = z[34] + z[74];
z[77] = z[10] * z[77];
z[77] = 3 * z[52] + z[77];
z[77] = z[10] * z[77];
z[27] = z[27] + z[77];
z[77] = z[0] * z[10];
z[78] = z[7] + z[24];
z[78] = z[77] * z[78];
z[62] = z[2] * z[62];
z[27] = (T(1) / T(2)) * z[27] + z[62] + z[78];
z[27] = z[2] * z[27];
z[62] = z[0] * z[70];
z[78] = z[10] + z[46];
z[78] = z[62] * z[78];
z[27] = z[27] + z[55] + z[73] + z[78];
z[27] = z[2] * z[27];
z[48] = z[10] * z[48];
z[48] = z[48] + -z[57];
z[30] = z[30] * z[48];
z[48] = prod_pow(z[10], 4) * z[28];
z[27] = z[27] + z[30] + z[48];
z[27] = z[8] * z[27];
z[30] = z[18] + z[36];
z[48] = z[3] * z[30];
z[55] = (T(7) / T(2)) * z[1] + z[18];
z[55] = z[10] * z[55];
z[48] = T(-3) / T(2) + z[48] + z[55];
z[48] = z[10] * z[48];
z[48] = z[48] + z[54];
z[54] = (T(3) / T(2)) * z[18] + z[34];
z[54] = z[10] * z[54];
z[55] = z[7] + (T(3) / T(4)) * z[10];
z[55] = z[0] * z[55];
z[52] = z[52] + z[54] + z[55];
z[52] = z[2] * z[52];
z[54] = (T(3) / T(4)) * z[7] + z[68];
z[54] = z[54] * z[77];
z[48] = (T(1) / T(2)) * z[48] + z[52] + z[54];
z[48] = z[2] * z[48];
z[43] = z[3] * z[43];
z[52] = 5 * z[1];
z[54] = z[52] + -z[74];
z[23] = z[23] * z[54];
z[23] = -1 + z[23];
z[54] = z[3] * z[10];
z[23] = z[23] * z[54];
z[55] = prod_pow(z[10], 3);
z[57] = z[0] * z[55];
z[23] = z[23] + z[43] + (T(5) / T(2)) * z[57];
z[43] = z[17] * z[25];
z[43] = z[1] + z[43];
z[43] = z[2] * z[43] * z[55];
z[43] = z[43] + (T(1) / T(2)) * z[55];
z[55] = z[13] * z[43];
z[23] = (T(1) / T(2)) * z[23] + z[27] + z[48] + (T(5) / T(12)) * z[55];
z[23] = z[8] * z[23];
z[27] = z[30] + z[34];
z[27] = z[10] * z[27];
z[30] = -z[3] * z[51];
z[30] = T(-1) / T(2) + z[27] + z[30];
z[48] = z[18] + z[34];
z[48] = z[28] + 3 * z[48];
z[48] = z[25] * z[48];
z[30] = (T(1) / T(2)) * z[30] + z[48] + z[77];
z[30] = z[2] * z[30];
z[17] = z[2] * z[17];
z[17] = z[17] + z[36];
z[36] = (T(1) / T(3)) * z[2];
z[17] = z[17] * z[36] * z[70];
z[17] = z[17] + z[71];
z[48] = z[13] * z[17];
z[39] = z[3] * z[39];
z[39] = z[39] + (T(3) / T(2)) * z[62];
z[23] = z[23] + z[30] + (T(1) / T(2)) * z[39] + (T(5) / T(4)) * z[48];
z[23] = z[8] * z[23];
z[30] = z[38] + z[64];
z[30] = z[2] * z[30];
z[27] = (T(1) / T(6)) * z[27] + z[30];
z[27] = z[2] * z[27];
z[30] = z[8] * z[43];
z[17] = z[17] + (T(1) / T(3)) * z[30];
z[17] = z[17] * z[58];
z[38] = -z[34] + -z[47];
z[38] = z[2] * z[10] * z[38];
z[39] = -z[1] * z[70];
z[38] = z[38] + z[39];
z[38] = z[2] * z[38];
z[30] = -z[30] + z[38];
z[30] = z[12] * z[30];
z[17] = z[17] + z[27] + (T(1) / T(6)) * z[30];
z[17] = z[12] * z[17];
z[27] = z[40] * z[54];
z[30] = -2 + z[50];
z[30] = z[3] * z[30];
z[30] = -z[27] + z[30];
z[38] = 4 * z[18] + -z[52];
z[38] = z[3] * z[38];
z[39] = -z[1] + z[41];
z[39] = z[10] * z[39];
z[38] = z[38] + z[39];
z[40] = -z[18] + -z[35];
z[40] = z[2] * z[40];
z[38] = (T(1) / T(3)) * z[38] + z[40];
z[38] = z[2] * z[38];
z[30] = (T(1) / T(3)) * z[30] + -z[33] + z[38];
z[30] = z[15] * z[30];
z[33] = -z[11] * z[24] * z[69];
z[25] = z[25] * z[66];
z[25] = z[25] + z[33] + z[67];
z[25] = z[2] * z[25];
z[25] = z[25] + (T(1) / T(2)) * z[72];
z[25] = z[16] * z[25];
z[33] = (T(635) / T(3)) * z[1] + (T(-251) / T(2)) * z[34];
z[33] = z[10] * z[33];
z[33] = T(-517) / T(6) + z[33];
z[33] = z[33] * z[53];
z[38] = (T(-7) / T(9)) * z[1] + z[34];
z[38] = z[10] * z[38];
z[38] = 59 * z[38] + (T(-103) / T(6)) * z[65];
z[38] = z[11] * z[38];
z[33] = z[33] + z[38];
z[38] = (T(671) / T(2)) * z[1] + -221 * z[34];
z[38] = z[10] * z[38];
z[40] = (T(-91) / T(2)) * z[1] + 191 * z[34];
z[40] = z[11] * z[40];
z[38] = T(-229) / T(2) + z[38] + z[40];
z[40] = z[4] * z[75];
z[40] = 4 * z[40] + (T(-73) / T(24)) * z[69];
z[40] = z[2] * z[40];
z[38] = (T(1) / T(12)) * z[38] + z[40];
z[36] = z[36] * z[38];
z[25] = (T(109) / T(18)) * z[25] + (T(1) / T(4)) * z[33] + z[36];
z[25] = z[16] * z[25];
z[33] = prod_pow(z[7], 2);
z[36] = -1 + (T(1) / T(3)) * z[56];
z[36] = z[10] * z[36];
z[36] = z[7] + z[36];
z[36] = z[10] * z[36];
z[36] = (T(-1) / T(3)) * z[33] + z[36];
z[36] = z[4] * z[36];
z[36] = z[36] + -z[60];
z[36] = z[4] * z[36];
z[38] = -11 + 29 * z[56];
z[36] = z[36] + (T(61) / T(18)) * z[37] + (T(5) / T(18)) * z[38];
z[35] = -z[1] + z[35];
z[35] = z[10] * z[35];
z[35] = 1 + z[35];
z[35] = z[10] * z[35];
z[35] = z[35] + -z[49];
z[35] = z[4] * z[35];
z[35] = (T(1) / T(4)) * z[35] + (T(-1) / T(3)) * z[66];
z[35] = z[4] * z[35];
z[35] = z[35] + (T(61) / T(36)) * z[69];
z[35] = z[2] * z[35];
z[35] = z[35] + (T(1) / T(2)) * z[36];
z[35] = z[2] * z[35];
z[36] = -z[7] + z[24];
z[37] = -z[10] * z[36];
z[37] = (T(-1) / T(2)) * z[33] + z[37];
z[38] = -z[7] + z[53];
z[38] = z[10] * z[38];
z[38] = z[33] + z[38];
z[38] = z[10] * z[38];
z[40] = prod_pow(z[7], 3);
z[38] = z[38] + (T(-1) / T(3)) * z[40];
z[40] = (T(1) / T(2)) * z[4];
z[38] = z[38] * z[40];
z[37] = (T(1) / T(3)) * z[37] + z[38];
z[37] = z[37] * z[40];
z[38] = 7 * z[10] + z[46];
z[35] = (T(61) / T(36)) * z[11] + z[35] + z[37] + (T(1) / T(3)) * z[38];
z[35] = z[13] * z[35];
z[37] = -1 + z[50];
z[37] = z[3] * z[37];
z[26] = -z[26] * z[75];
z[26] = 1 + z[26] + z[39];
z[26] = z[2] * z[26];
z[26] = z[26] + -z[27] + z[37];
z[26] = z[14] * z[26];
z[27] = (T(131) / T(6)) * z[1] + 32 * z[18] + (T(293) / T(6)) * z[31] + (T(-553) / T(6)) * z[34];
z[27] = z[11] * z[27];
z[18] = (T(-106) / T(3)) * z[1] + -13 * z[18] + (T(130) / T(3)) * z[34];
z[18] = z[10] * z[18];
z[19] = 4 * z[1] + -z[19];
z[19] = z[3] * z[19];
z[18] = 7 + z[18] + z[19] + z[27];
z[19] = -z[3] * z[46];
z[19] = z[19] + z[33];
z[27] = (T(1) / T(4)) * z[3];
z[33] = z[27] + z[36];
z[33] = z[10] * z[33];
z[19] = (T(1) / T(2)) * z[19] + z[33];
z[19] = z[4] * z[19];
z[19] = z[19] + z[27];
z[19] = z[4] * z[19];
z[27] = (T(-1) / T(2)) * z[31] + -z[42];
z[27] = z[11] * z[27];
z[27] = T(-5) / T(2) + z[27] + -z[45];
z[27] = z[27] * z[76];
z[33] = -z[6] * z[44];
z[27] = z[27] + z[33];
z[27] = z[6] * z[27];
z[31] = -7 * z[1] + -z[31];
z[31] = z[11] * z[31];
z[31] = (T(1) / T(4)) * z[31] + -3 * z[63];
z[29] = z[29] * z[31];
z[27] = z[27] + z[29];
z[27] = z[6] * z[27];
z[20] = T(-3) / T(2) + -z[20] + -z[45];
z[20] = z[2] * z[20];
z[29] = -1 + -z[45];
z[29] = z[10] * z[29];
z[20] = z[20] + z[27] + (T(1) / T(4)) * z[29];
z[20] = z[9] * z[20];
z[27] = -z[1] + z[61];
z[27] = z[3] * z[27];
z[27] = T(-13) / T(4) + z[27];
z[27] = z[27] * z[59];
z[24] = z[24] + z[27];
z[24] = z[24] * z[28];
return (T(1) / T(2)) * z[17] + (T(1) / T(9)) * z[18] + (T(1) / T(18)) * z[19] + z[20] + z[21] + z[22] + z[23] + z[24] + (T(1) / T(3)) * z[25] + (T(4) / T(9)) * z[26] + z[30] + z[32] + (T(1) / T(6)) * z[35];
}



template double eval_coef_2q3y_2l_pmmpp_12345_169(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_169(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
