#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_171(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[75];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[15];
z[5] = iW[3];
z[6] = iW[22];
z[7] = v[1];
z[8] = iW[21];
z[9] = iW[19];
z[10] = v[3];
z[11] = iW[2];
z[12] = v[0];
z[13] = iW[5];
z[14] = iW[4];
z[15] = iW[23];
z[16] = iW[18];
z[17] = iW[17];
z[18] = prod_pow(z[3], 2);
z[19] = prod_pow(z[1], 2);
z[20] = z[18] * z[19];
z[21] = -3 + z[20];
z[22] = (T(1) / T(2)) * z[3];
z[21] = z[21] * z[22];
z[21] = z[7] + z[21];
z[21] = z[3] * z[21];
z[23] = (T(1) / T(2)) * z[7];
z[24] = z[1] * z[3];
z[25] = -1 + (T(1) / T(2)) * z[24];
z[25] = z[3] * z[25];
z[25] = z[23] + z[25];
z[26] = (T(13) / T(2)) * z[12];
z[25] = z[25] * z[26];
z[27] = z[0] * z[7];
z[28] = z[2] * z[27];
z[29] = z[3] + -z[7];
z[29] = (T(19) / T(3)) * z[28] + 13 * z[29];
z[30] = (T(1) / T(4)) * z[2];
z[29] = z[29] * z[30];
z[21] = z[21] + z[25] + z[29];
z[21] = z[2] * z[21];
z[25] = 3 * z[1];
z[29] = z[3] * z[19];
z[31] = z[25] + -z[29];
z[31] = z[3] * z[31];
z[32] = -3 + z[31];
z[32] = z[3] * z[32];
z[32] = z[7] + z[32];
z[33] = -z[3] * z[32];
z[34] = (T(1) / T(3)) * z[29];
z[35] = -z[1] + z[34];
z[35] = z[3] * z[35];
z[35] = 1 + z[35];
z[35] = z[3] * z[35];
z[36] = (T(1) / T(3)) * z[7];
z[35] = z[35] + -z[36];
z[26] = z[26] * z[35];
z[26] = z[26] + z[33];
z[26] = z[12] * z[26];
z[33] = z[18] * z[32];
z[26] = z[26] + z[33];
z[33] = (T(3) / T(2)) * z[1] + -z[29];
z[37] = z[18] * z[33];
z[37] = -z[23] + z[37];
z[37] = z[18] * z[37];
z[38] = prod_pow(z[3], 3);
z[39] = z[19] * z[38];
z[40] = -z[7] + z[39];
z[40] = z[3] * z[40];
z[28] = -z[7] + z[28];
z[41] = z[2] * z[28];
z[41] = z[40] + z[41];
z[42] = (T(1) / T(2)) * z[2];
z[41] = z[41] * z[42];
z[37] = z[37] + z[41];
z[37] = z[2] * z[37];
z[41] = (T(1) / T(2)) * z[38];
z[32] = z[32] * z[41];
z[32] = -z[32] + z[37];
z[37] = z[6] * z[32];
z[21] = z[21] + (T(1) / T(2)) * z[26] + z[37];
z[21] = z[5] * z[21];
z[26] = (T(-5) / T(2)) * z[2] + (T(7) / T(2)) * z[3] + -z[36];
z[26] = z[0] * z[26];
z[37] = 5 + z[24];
z[26] = z[26] + (T(3) / T(2)) * z[37];
z[26] = z[26] * z[30];
z[37] = (T(3) / T(2)) * z[7];
z[43] = (T(-5) / T(8)) * z[1] + z[29];
z[43] = z[3] * z[43];
z[43] = T(-15) / T(8) + z[43];
z[43] = z[3] * z[43];
z[44] = (T(7) / T(8)) * z[1] + z[29];
z[44] = z[3] * z[44];
z[44] = T(-15) / T(8) + z[44];
z[44] = z[12] * z[44];
z[26] = z[26] + z[37] + z[43] + z[44];
z[26] = z[2] * z[26];
z[43] = (T(1) / T(2)) * z[6];
z[44] = z[32] * z[43];
z[45] = z[27] * z[42];
z[45] = -z[23] + z[39] + z[45];
z[45] = z[2] * z[45];
z[46] = 2 * z[29];
z[47] = (T(5) / T(2)) * z[1];
z[48] = -z[46] + z[47];
z[48] = z[18] * z[48];
z[48] = -z[23] + z[48];
z[48] = z[3] * z[48];
z[45] = z[45] + z[48];
z[45] = z[2] * z[45];
z[48] = -z[29] + z[47];
z[48] = z[3] * z[48];
z[48] = -2 + z[48];
z[48] = z[3] * z[48];
z[48] = z[23] + z[48];
z[49] = z[18] * z[48];
z[45] = -z[44] + z[45] + -z[49];
z[45] = z[6] * z[45];
z[50] = z[19] * z[22];
z[51] = -z[1] + z[50];
z[51] = z[3] * z[51];
z[52] = T(1) / T(2) + z[51];
z[35] = -z[13] * z[35];
z[35] = z[35] + (T(5) / T(4)) * z[52];
z[35] = z[12] * z[35];
z[53] = (T(1) / T(2)) * z[1];
z[54] = -z[29] + -z[53];
z[54] = z[22] * z[54];
z[54] = 2 + z[54];
z[54] = z[3] * z[54];
z[35] = (T(-5) / T(4)) * z[7] + z[35] + z[54];
z[35] = z[12] * z[35];
z[48] = z[3] * z[48];
z[21] = (T(1) / T(2)) * z[21] + z[26] + z[35] + z[45] + z[48];
z[21] = z[5] * z[21];
z[26] = (T(1) / T(4)) * z[1];
z[35] = 11 * z[29];
z[45] = -z[26] + z[35];
z[45] = z[3] * z[45];
z[48] = -z[3] + (T(-5) / T(2)) * z[7];
z[48] = z[0] * z[48];
z[45] = -13 + z[45] + (T(1) / T(2)) * z[48];
z[48] = z[12] * z[19];
z[54] = (T(-191) / T(12)) * z[1] + 7 * z[29];
z[54] = -5 * z[48] + (T(1) / T(2)) * z[54];
z[54] = z[12] * z[54];
z[45] = (T(1) / T(2)) * z[45] + z[54];
z[54] = (T(7) / T(3)) * z[0];
z[55] = (T(5) / T(3)) * z[29] + -z[53] + z[54];
z[30] = z[30] * z[55];
z[30] = z[30] + (T(1) / T(3)) * z[45];
z[30] = z[2] * z[30];
z[28] = z[28] + (T(-1) / T(2)) * z[39];
z[28] = z[2] * z[28];
z[28] = z[28] + z[40];
z[40] = (T(1) / T(3)) * z[2];
z[28] = z[28] * z[40];
z[45] = (T(1) / T(3)) * z[19];
z[55] = -z[18] * z[45];
z[55] = 1 + z[55];
z[55] = z[22] * z[55];
z[55] = -z[36] + z[55];
z[55] = z[18] * z[55];
z[28] = z[28] + z[44] + z[55];
z[28] = z[6] * z[28];
z[44] = (T(37) / T(2)) * z[1];
z[55] = -25 * z[29] + z[44];
z[55] = z[18] * z[55];
z[56] = z[2] * z[20];
z[57] = 5 * z[7];
z[55] = z[55] + (T(35) / T(2)) * z[56] + z[57];
z[55] = z[2] * z[55];
z[56] = (T(7) / T(3)) * z[1];
z[58] = 5 * z[29] + -z[56];
z[58] = z[3] * z[58];
z[58] = T(-7) / T(3) + (T(1) / T(4)) * z[58];
z[58] = z[3] * z[58];
z[58] = (T(5) / T(3)) * z[7] + z[58];
z[58] = z[3] * z[58];
z[28] = z[28] + (T(1) / T(6)) * z[55] + z[58];
z[28] = z[6] * z[28];
z[55] = (T(-17) / T(2)) * z[1] + -z[29];
z[55] = z[3] * z[55];
z[55] = T(19) / T(2) + z[55];
z[58] = -z[1] + z[29];
z[59] = z[3] * z[58];
z[60] = -1 + z[59];
z[60] = z[3] * z[60];
z[60] = z[7] + z[60];
z[60] = z[13] * z[60];
z[61] = z[12] * z[58];
z[55] = (T(1) / T(2)) * z[55] + 2 * z[60] + (T(-77) / T(24)) * z[61];
z[55] = z[12] * z[55];
z[60] = prod_pow(z[2], 2);
z[61] = (T(1) / T(2)) * z[48];
z[62] = z[1] + z[61];
z[62] = z[12] * z[62];
z[62] = T(1) / T(2) + z[62];
z[63] = z[60] * z[62];
z[64] = -z[1] + (T(-1) / T(3)) * z[48];
z[64] = z[12] * z[64];
z[64] = -1 + (T(-1) / T(3)) * z[27] + z[64];
z[65] = (T(1) / T(2)) * z[8];
z[64] = prod_pow(z[2], 3) * z[64] * z[65];
z[63] = (T(-5) / T(3)) * z[63] + z[64];
z[63] = z[8] * z[63];
z[64] = 5 * z[1];
z[66] = (T(-17) / T(6)) * z[29] + z[64];
z[66] = z[3] * z[66];
z[66] = T(-1) / T(4) + z[66];
z[66] = z[3] * z[66];
z[66] = (T(-23) / T(12)) * z[7] + z[66];
z[21] = z[21] + z[28] + z[30] + (T(1) / T(3)) * z[55] + (T(5) / T(2)) * z[63] + (T(1) / T(2)) * z[66];
z[21] = z[5] * z[21];
z[28] = (T(1) / T(2)) * z[10];
z[30] = z[19] * z[28];
z[55] = z[0] + z[29];
z[55] = z[30] + 2 * z[55];
z[55] = z[10] * z[55];
z[55] = T(-1) / T(2) + 3 * z[20] + (T(5) / T(2)) * z[27] + z[55];
z[55] = z[10] * z[55];
z[63] = z[0] * z[28];
z[63] = 2 * z[27] + z[63];
z[63] = z[2] * z[63];
z[37] = -z[37] + 2 * z[39] + z[55] + z[63];
z[37] = z[2] * z[37];
z[55] = (T(5) / T(2)) * z[0] + z[1];
z[55] = z[10] * z[55];
z[31] = T(-3) / T(2) + z[27] + z[31] + z[55];
z[31] = z[10] * z[31];
z[33] = z[3] * z[33];
z[33] = T(-1) / T(2) + 3 * z[33];
z[33] = z[3] * z[33];
z[31] = -z[7] + z[31] + z[33];
z[31] = z[10] * z[31];
z[33] = 4 * z[1];
z[55] = 3 * z[29];
z[63] = z[33] + -z[55];
z[63] = z[18] * z[63];
z[63] = -z[7] + z[63];
z[63] = z[3] * z[63];
z[31] = z[31] + z[37] + z[63];
z[31] = z[2] * z[31];
z[37] = z[18] * z[52];
z[63] = prod_pow(z[10], 2);
z[66] = z[0] * z[10];
z[67] = T(-1) / T(2) + z[66];
z[67] = z[63] * z[67];
z[37] = z[37] + z[67];
z[37] = z[10] * z[37];
z[67] = (T(1) / T(2)) * z[9];
z[32] = z[32] * z[67];
z[31] = z[31] + z[32] + z[37] + -z[49];
z[31] = z[6] * z[31];
z[32] = (T(37) / T(4)) * z[1] + z[29];
z[32] = z[3] * z[32];
z[32] = T(-11) / T(2) + (T(11) / T(2)) * z[27] + z[32];
z[37] = (T(31) / T(3)) * z[0] + (T(35) / T(6)) * z[1] + z[29];
z[37] = z[28] * z[37];
z[32] = (T(1) / T(3)) * z[32] + z[37];
z[32] = z[10] * z[32];
z[37] = z[10] * z[19];
z[49] = (T(11) / T(4)) * z[29] + (T(19) / T(12)) * z[37] + z[54];
z[49] = z[10] * z[49];
z[49] = (T(5) / T(4)) * z[20] + (T(8) / T(3)) * z[27] + z[49];
z[49] = z[2] * z[49];
z[54] = 7 * z[1];
z[68] = z[29] + z[54];
z[68] = z[18] * z[68];
z[57] = -z[57] + z[68];
z[32] = z[32] + z[49] + (T(1) / T(6)) * z[57];
z[32] = z[2] * z[32];
z[49] = T(-17) / T(2) + -11 * z[51];
z[51] = (T(1) / T(3)) * z[3];
z[49] = z[49] * z[51];
z[49] = z[7] + z[49];
z[49] = z[3] * z[49];
z[55] = -z[55] + z[64];
z[55] = z[22] * z[55];
z[55] = -1 + z[55];
z[55] = z[3] * z[55];
z[57] = -1 + (T(17) / T(3)) * z[66];
z[57] = z[10] * z[57];
z[55] = z[55] + z[57];
z[55] = z[10] * z[55];
z[49] = z[49] + z[55];
z[55] = z[38] * z[58];
z[39] = -z[39] * z[42];
z[39] = z[39] + z[55];
z[39] = z[2] * z[39];
z[38] = -z[38] * z[52];
z[38] = z[38] + z[39];
z[38] = z[9] * z[38];
z[31] = z[31] + z[32] + z[38] + (T(1) / T(2)) * z[49];
z[31] = z[6] * z[31];
z[32] = (T(-23) / T(3)) * z[29] + z[64];
z[32] = z[3] * z[32];
z[32] = T(-5) / T(3) + z[32];
z[38] = (T(2) / T(3)) * z[29];
z[39] = (T(8) / T(3)) * z[0] + (T(19) / T(4)) * z[1] + z[30] + -z[38];
z[39] = z[10] * z[39];
z[35] = (T(5) / T(3)) * z[0] + z[35];
z[35] = (T(1) / T(2)) * z[35] + 5 * z[37];
z[35] = z[2] * z[35];
z[32] = (T(1) / T(2)) * z[32] + z[35] + z[39];
z[32] = z[2] * z[32];
z[35] = -z[29] + z[53];
z[35] = z[18] * z[35];
z[39] = z[20] * z[42];
z[35] = z[35] + z[39];
z[35] = z[2] * z[35];
z[39] = z[41] * z[58];
z[35] = z[35] + z[39];
z[35] = z[35] * z[67];
z[39] = z[29] + z[56];
z[39] = z[22] * z[39];
z[39] = T(-5) / T(3) + z[39];
z[39] = z[3] * z[39];
z[41] = z[0] * z[63];
z[31] = z[31] + z[32] + z[35] + z[39] + (T(11) / T(6)) * z[41];
z[31] = z[6] * z[31];
z[32] = (T(1) / T(2)) * z[12];
z[35] = (T(-73) / T(3)) * z[1] + (T(-35) / T(2)) * z[48];
z[35] = z[32] * z[35];
z[39] = -z[0] + (T(29) / T(6)) * z[1] + (T(-29) / T(12)) * z[37] + (T(32) / T(3)) * z[48];
z[39] = z[10] * z[39];
z[35] = T(-29) / T(12) + z[27] + z[35] + z[39];
z[35] = z[10] * z[35];
z[39] = 71 + 7 * z[27];
z[41] = 19 * z[48];
z[49] = (T(121) / T(3)) * z[1] + z[41];
z[49] = z[12] * z[49];
z[39] = (T(1) / T(3)) * z[39] + z[49];
z[49] = z[0] + -z[1];
z[52] = -z[48] + (T(1) / T(2)) * z[49];
z[55] = z[10] * z[52];
z[39] = (T(1) / T(2)) * z[39] + (T(17) / T(3)) * z[55];
z[39] = z[39] * z[42];
z[35] = z[35] + z[39];
z[35] = z[2] * z[35];
z[39] = 3 * z[48];
z[33] = z[33] + z[39];
z[33] = z[12] * z[33];
z[55] = 2 * z[48];
z[56] = -z[1] + -z[55];
z[56] = z[37] + 2 * z[56];
z[56] = z[10] * z[56];
z[33] = 1 + z[33] + z[56];
z[33] = z[33] * z[63];
z[56] = -z[39] + -z[64];
z[56] = z[12] * z[56];
z[49] = -z[49] + z[55];
z[49] = z[10] * z[49];
z[49] = -1 + z[27] + z[49] + z[56];
z[49] = z[10] * z[49];
z[25] = z[25] + z[48];
z[25] = z[12] * z[25];
z[25] = 3 + z[25] + z[27];
z[25] = z[2] * z[25];
z[25] = z[25] + z[49];
z[25] = z[2] * z[25];
z[25] = z[25] + z[33];
z[25] = z[2] * z[25];
z[27] = 2 * z[1];
z[33] = -z[27] + -z[48];
z[33] = z[12] * z[33];
z[49] = z[1] + z[48];
z[49] = -z[37] + 2 * z[49];
z[49] = z[10] * z[49];
z[33] = -1 + z[33] + z[49];
z[49] = prod_pow(z[10], 3);
z[33] = z[33] * z[49];
z[25] = z[25] + z[33];
z[25] = z[8] * z[25];
z[33] = 19 * z[1];
z[55] = -z[33] + (T(47) / T(4)) * z[37] + (T(-53) / T(2)) * z[48];
z[55] = z[10] * z[55];
z[56] = 22 * z[1] + (T(59) / T(4)) * z[48];
z[56] = z[12] * z[56];
z[55] = T(29) / T(4) + z[55] + z[56];
z[56] = (T(1) / T(3)) * z[63];
z[55] = z[55] * z[56];
z[57] = -z[1] + z[30];
z[64] = -z[48] + z[57];
z[64] = z[10] * z[64];
z[62] = z[62] + z[64];
z[64] = z[49] * z[62];
z[66] = z[16] * z[64];
z[25] = z[25] + z[35] + z[55] + (T(-3) / T(4)) * z[66];
z[25] = z[8] * z[25];
z[35] = (T(-73) / T(12)) * z[37] + (T(89) / T(6)) * z[48] + z[54];
z[35] = z[10] * z[35];
z[54] = (T(3) / T(2)) * z[48];
z[55] = (T(-5) / T(3)) * z[1] + -z[54];
z[55] = z[12] * z[55];
z[55] = T(-17) / T(6) + 11 * z[55];
z[35] = z[35] + (T(1) / T(2)) * z[55];
z[35] = z[10] * z[35];
z[55] = z[0] + (T(-13) / T(4)) * z[1] + (T(11) / T(6)) * z[37] + -10 * z[48];
z[55] = z[10] * z[55];
z[52] = z[2] * z[52];
z[66] = (T(137) / T(12)) * z[1] + 9 * z[48];
z[66] = z[12] * z[66];
z[52] = T(29) / T(12) + (T(-5) / T(6)) * z[52] + z[55] + z[66];
z[52] = z[2] * z[52];
z[44] = z[44] + 7 * z[48];
z[44] = z[12] * z[44];
z[44] = T(23) / T(2) + z[44];
z[55] = (T(-55) / T(2)) * z[1] + -23 * z[48];
z[55] = 4 * z[37] + (T(1) / T(4)) * z[55];
z[55] = z[10] * z[55];
z[44] = (T(1) / T(4)) * z[44] + z[55];
z[44] = z[16] * z[44] * z[56];
z[25] = z[25] + z[35] + z[44] + z[52];
z[25] = z[8] * z[25];
z[35] = (T(27) / T(2)) * z[1] + (T(73) / T(27)) * z[48];
z[35] = (T(1) / T(4)) * z[35] + (T(-7) / T(27)) * z[37];
z[35] = z[10] * z[35];
z[44] = -z[1] + z[37];
z[44] = z[2] * z[44];
z[52] = z[1] * z[12];
z[55] = -349 + -17 * z[52];
z[35] = z[35] + (T(19) / T(216)) * z[44] + (T(1) / T(216)) * z[55];
z[35] = z[2] * z[35];
z[55] = z[2] * z[19];
z[56] = (T(19) / T(3)) * z[1] + 3 * z[55];
z[56] = z[42] * z[56];
z[56] = T(5) / T(3) + z[56];
z[56] = z[56] * z[63];
z[66] = z[19] * z[42];
z[66] = z[1] + z[66];
z[66] = z[2] * z[49] * z[66];
z[49] = (T(1) / T(2)) * z[49];
z[66] = z[49] + z[66];
z[66] = z[6] * z[66];
z[67] = (T(1) / T(3)) * z[66];
z[56] = z[56] + z[67];
z[56] = z[6] * z[56];
z[68] = T(253) / T(36) + z[52];
z[68] = z[32] * z[68];
z[68] = (T(-4) / T(3)) * z[7] + z[68];
z[69] = z[1] * z[32];
z[69] = T(35) / T(9) + z[69];
z[69] = z[28] * z[69];
z[70] = z[10] * z[57];
z[70] = T(1) / T(2) + z[70];
z[71] = z[2] * z[70];
z[72] = z[10] * z[52];
z[72] = -z[12] + z[71] + z[72];
z[72] = z[2] * z[72];
z[73] = prod_pow(z[12], 2);
z[73] = (T(1) / T(2)) * z[73];
z[72] = z[72] + z[73];
z[72] = z[14] * z[72];
z[35] = z[35] + z[56] + (T(1) / T(3)) * z[68] + z[69] + (T(55) / T(108)) * z[72];
z[35] = z[14] * z[35];
z[56] = (T(1) / T(3)) * z[37];
z[53] = z[53] + -z[56];
z[53] = z[10] * z[53];
z[68] = -z[1] * z[42];
z[68] = z[24] + z[68];
z[68] = z[0] * z[2] * z[68];
z[69] = -z[0] * z[1] * z[18];
z[69] = T(-1) / T(3) + z[69];
z[53] = z[53] + z[68] + (T(1) / T(2)) * z[69];
z[53] = z[2] * z[53];
z[68] = -z[7] + z[22];
z[69] = -z[10] + -z[68];
z[53] = z[53] + (T(1) / T(3)) * z[69];
z[69] = z[37] + -z[47];
z[69] = z[28] * z[69];
z[69] = 1 + z[69];
z[69] = z[10] * z[69];
z[69] = (T(-1) / T(4)) * z[7] + z[69] + z[71];
z[69] = z[16] * z[40] * z[69];
z[71] = z[0] + z[1];
z[72] = z[42] * z[71];
z[74] = -z[0] * z[3];
z[24] = -z[24] + z[72] + z[74];
z[24] = z[2] * z[24];
z[18] = z[18] * z[71];
z[18] = (T(1) / T(2)) * z[18] + z[24];
z[18] = z[5] * z[18] * z[42];
z[24] = prod_pow(z[7], 2);
z[71] = z[3] * z[7];
z[71] = -z[24] + z[71];
z[68] = -z[28] + -z[68];
z[68] = z[10] * z[68];
z[68] = z[68] + (T(1) / T(2)) * z[71];
z[71] = -z[1] * z[28];
z[71] = 1 + z[71];
z[71] = z[10] * z[71];
z[23] = -z[23] + z[71];
z[23] = z[2] * z[23];
z[23] = z[23] + (T(1) / T(2)) * z[68];
z[68] = z[1] + -z[56];
z[68] = z[10] * z[68];
z[68] = -1 + z[68];
z[68] = z[10] * z[68];
z[36] = z[36] + z[68];
z[36] = z[16] * z[36] * z[60];
z[23] = (T(1) / T(3)) * z[23] + (T(1) / T(4)) * z[36];
z[23] = z[4] * z[23];
z[18] = z[18] + z[23] + (T(1) / T(2)) * z[53] + z[69];
z[18] = z[4] * z[18];
z[23] = z[29] + z[37] + z[47];
z[36] = (T(1) / T(6)) * z[10];
z[23] = z[23] * z[36];
z[34] = z[30] + z[34];
z[34] = z[2] * z[34];
z[23] = z[23] + z[34];
z[23] = z[2] * z[23];
z[34] = z[47] + z[55];
z[34] = z[34] * z[40] * z[63];
z[40] = (T(1) / T(2)) * z[63];
z[34] = z[34] + z[40] + z[67];
z[34] = z[34] * z[43];
z[43] = -z[37] + -z[50];
z[43] = z[2] * z[10] * z[43];
z[50] = -z[1] * z[63];
z[43] = z[43] + z[50];
z[43] = z[2] * z[43];
z[43] = z[43] + -z[66];
z[43] = z[17] * z[43];
z[23] = z[23] + z[34] + (T(1) / T(6)) * z[43];
z[23] = z[17] * z[23];
z[34] = (T(3) / T(4)) * z[1] + z[29] + -z[37] + z[54];
z[34] = z[28] * z[34];
z[43] = (T(3) / T(8)) * z[1] + -z[29] + (T(-1) / T(4)) * z[48];
z[43] = z[12] * z[43];
z[34] = z[34] + z[43];
z[34] = z[10] * z[34];
z[43] = z[47] + z[48];
z[43] = z[12] * z[43];
z[43] = T(3) / T(2) + z[43];
z[39] = (T(-7) / T(2)) * z[1] + -z[39];
z[39] = z[37] + (T(1) / T(2)) * z[39];
z[39] = z[10] * z[39];
z[39] = z[39] + (T(1) / T(2)) * z[43];
z[39] = z[39] * z[63];
z[43] = -z[8] * z[49] * z[62];
z[39] = z[39] + z[43];
z[39] = z[39] * z[65];
z[43] = z[1] + z[29];
z[30] = -z[30] + (T(1) / T(2)) * z[43] + z[48];
z[30] = z[10] * z[30];
z[43] = -z[29] + -z[61];
z[43] = z[12] * z[43];
z[30] = z[30] + z[43];
z[30] = z[10] * z[30];
z[43] = z[58] * z[73];
z[30] = z[30] + z[43];
z[30] = z[10] * z[30];
z[47] = z[8] * z[64];
z[30] = z[30] + z[47];
z[30] = z[11] * z[30];
z[30] = (T(1) / T(4)) * z[30] + z[34] + z[39] + z[43];
z[30] = z[11] * z[30];
z[34] = -z[13] * z[29];
z[34] = (T(629) / T(72)) * z[19] + z[34];
z[34] = z[10] * z[34];
z[39] = (T(-245) / T(3)) * z[1] + -181 * z[29];
z[43] = -z[1] + z[46];
z[43] = z[3] * z[43];
z[46] = -1 + -z[43];
z[46] = z[13] * z[46];
z[34] = z[34] + (T(1) / T(24)) * z[39] + z[46] + (T(-194) / T(9)) * z[48];
z[34] = z[10] * z[34];
z[39] = (T(133) / T(3)) * z[1] + (T(299) / T(2)) * z[29];
z[43] = -1 + z[43];
z[43] = z[13] * z[43];
z[39] = (T(1) / T(12)) * z[39] + z[43] + (T(481) / T(36)) * z[48];
z[39] = z[12] * z[39];
z[43] = -5 + -z[20];
z[22] = z[0] * z[22] * z[43];
z[43] = 25 * z[1] + (T(-49) / T(6)) * z[29];
z[43] = z[3] * z[43];
z[22] = T(89) / T(6) + z[22] + z[43];
z[43] = -1 + -z[59];
z[43] = z[3] * z[43];
z[43] = z[7] + z[43];
z[43] = z[13] * z[43];
z[22] = (T(1) / T(4)) * z[22] + z[34] + z[39] + z[43];
z[20] = T(5) / T(3) + z[20];
z[20] = z[0] * z[20];
z[34] = z[2] * z[45];
z[34] = -z[29] + z[34];
z[34] = z[0] * z[34];
z[19] = (T(11) / T(3)) * z[19] + z[34];
z[19] = z[2] * z[19];
z[19] = z[19] + z[20];
z[20] = (T(8) / T(3)) * z[1] + (T(41) / T(4)) * z[29];
z[19] = (T(1) / T(8)) * z[19] + (T(1) / T(3)) * z[20] + (T(9) / T(2)) * z[37] + (T(71) / T(72)) * z[48];
z[19] = z[2] * z[19];
z[20] = -z[33] + (T(83) / T(2)) * z[48];
z[20] = z[20] * z[32];
z[29] = (T(329) / T(2)) * z[1] + (T(-205) / T(2)) * z[37] + z[41];
z[28] = z[28] * z[29];
z[20] = -31 + z[20] + z[28];
z[20] = z[20] * z[36];
z[26] = z[26] + (T(-19) / T(3)) * z[48];
z[26] = (T(1) / T(2)) * z[26] + -z[56];
z[26] = z[10] * z[26];
z[28] = 1 + -5 * z[52];
z[26] = z[26] + (T(5) / T(24)) * z[28] + (T(-7) / T(24)) * z[44];
z[26] = z[2] * z[26];
z[20] = z[20] + z[26];
z[26] = -z[57] + z[61];
z[26] = z[10] * z[26];
z[28] = -1 + -z[52];
z[26] = z[26] + (T(1) / T(2)) * z[28];
z[26] = z[10] * z[26];
z[28] = -z[42] * z[70];
z[26] = z[26] + z[28];
z[26] = z[2] * z[26];
z[28] = -z[40] * z[62];
z[26] = z[26] + z[28];
z[26] = z[16] * z[26];
z[20] = (T(1) / T(9)) * z[20] + z[26];
z[20] = z[16] * z[20];
z[26] = -z[27] + z[37];
z[26] = z[10] * z[26];
z[26] = 1 + z[26];
z[26] = z[2] * z[26];
z[27] = z[1] * z[10];
z[27] = -2 + z[27];
z[27] = z[10] * z[27];
z[27] = z[7] + z[27];
z[26] = z[26] + 2 * z[27];
z[26] = z[2] * z[26];
z[27] = -2 * z[7] + z[10];
z[27] = z[10] * z[27];
z[24] = z[24] + z[26] + z[27];
z[24] = z[14] * z[24];
z[26] = 2 + z[59];
z[26] = z[26] * z[51];
z[27] = z[1] + z[38];
z[27] = z[10] * z[27];
z[27] = -1 + z[27];
z[27] = z[2] * z[27];
z[24] = -z[7] + z[10] + (T(1) / T(3)) * z[24] + z[26] + z[27];
z[24] = z[15] * z[24];
return (T(1) / T(6)) * z[18] + z[19] + z[20] + z[21] + (T(1) / T(3)) * z[22] + z[23] + (T(4) / T(3)) * z[24] + z[25] + z[30] + z[31] + z[35];
}



template double eval_coef_2q3y_2l_pmmpp_12345_171(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_171(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
