#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_20(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[9];
z[0] = iW[1];
z[1] = iW[3];
z[2] = v[0];
z[3] = v[4];
z[4] = v[2];
z[5] = z[0] * z[4];
z[6] = -3 + -z[5];
z[6] = z[0] * z[6];
z[7] = prod_pow(z[0], 2);
z[8] = z[3] * z[7];
z[6] = z[6] + z[8];
z[8] = (T(1) / T(2)) * z[3];
z[6] = z[6] * z[8];
z[6] = 1 + z[6];
z[6] = z[2] * z[6];
z[7] = -z[7] * z[8];
z[7] = z[0] + z[7];
z[7] = z[3] * z[7];
z[7] = T(-1) / T(2) + z[7];
z[7] = z[2] * z[7];
z[5] = -z[3] * z[5];
z[5] = z[4] + z[5] + z[7];
z[5] = z[2] * z[5];
z[7] = prod_pow(z[4], 2);
z[5] = z[5] + (T(-1) / T(2)) * z[7];
z[5] = z[1] * z[5];
z[5] = -z[4] + z[5] + z[6];
z[5] = z[1] * z[5];
z[5] = T(-3) / T(4) + z[5];
return z[1] * z[2] * z[5];
}



template double eval_coef_2q3y_2l_pmmpp_12345_20(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_20(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
