#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_26(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[25];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[15];
z[3] = iW[21];
z[4] = iW[22];
z[5] = v[0];
z[6] = v[4];
z[7] = v[2];
z[8] = v[3];
z[9] = v[1];
z[10] = prod_pow(z[6], 2);
z[11] = prod_pow(z[0], 2);
z[12] = z[6] * z[11];
z[13] = (T(3) / T(2)) * z[0] + -z[12];
z[13] = z[10] * z[13];
z[14] = (T(1) / T(2)) * z[6];
z[15] = z[11] * z[14];
z[15] = -z[0] + z[15];
z[15] = z[6] * z[15];
z[15] = T(1) / T(2) + z[15];
z[16] = -z[5] * z[15];
z[17] = (T(1) / T(2)) * z[9];
z[13] = z[13] + z[16] + -z[17];
z[16] = (T(1) / T(2)) * z[1];
z[13] = z[13] * z[16];
z[18] = (T(1) / T(2)) * z[8];
z[19] = z[6] + z[18];
z[19] = z[11] * z[19];
z[20] = (T(1) / T(2)) * z[0];
z[19] = z[19] + -z[20];
z[15] = z[1] * z[15];
z[15] = z[15] + (T(1) / T(2)) * z[19];
z[15] = z[7] * z[15];
z[12] = -z[12] + z[20];
z[12] = z[6] * z[12];
z[12] = T(1) / T(2) + z[12];
z[19] = (T(1) / T(4)) * z[8];
z[21] = -z[6] + -z[19];
z[21] = z[11] * z[21];
z[21] = z[20] + z[21];
z[21] = z[8] * z[21];
z[12] = (T(1) / T(2)) * z[12] + z[13] + z[15] + z[21];
z[12] = z[5] * z[12];
z[13] = -z[11] * z[18];
z[13] = z[0] + z[13];
z[13] = z[13] * z[18];
z[15] = z[6] + -z[9];
z[16] = -z[15] * z[16];
z[21] = z[0] * z[6];
z[22] = T(-1) / T(2) + z[21];
z[22] = z[1] * z[22];
z[22] = z[20] + z[22];
z[23] = (T(1) / T(2)) * z[7];
z[22] = z[22] * z[23];
z[13] = T(-3) / T(4) + z[13] + z[16] + z[21] + z[22];
z[13] = z[7] * z[13];
z[16] = (T(3) / T(4)) * z[6] + z[19];
z[11] = z[11] * z[16];
z[11] = -z[0] + z[11];
z[11] = z[8] * z[11];
z[16] = 3 + -7 * z[21];
z[11] = z[11] + (T(1) / T(4)) * z[16];
z[11] = z[8] * z[11];
z[16] = (T(1) / T(2)) * z[21];
z[19] = 1 + -z[16];
z[19] = z[6] * z[19];
z[19] = -z[17] + z[19];
z[19] = z[1] * z[6] * z[19];
z[22] = -1 + z[21];
z[24] = z[6] * z[22];
z[11] = z[11] + z[12] + z[13] + z[19] + (T(-5) / T(4)) * z[24];
z[11] = z[5] * z[11];
z[12] = z[18] * z[21];
z[13] = -z[1] * z[14] * z[15];
z[14] = z[8] * z[20];
z[14] = z[14] + z[22];
z[15] = z[6] + -z[17];
z[15] = z[1] * z[15];
z[15] = -z[14] + z[15];
z[15] = z[15] * z[23];
z[12] = z[12] + z[13] + z[15] + z[24];
z[12] = z[7] * z[12];
z[13] = z[8] * z[14];
z[14] = -1 + -z[16];
z[14] = z[6] * z[14];
z[13] = z[13] + z[14] + z[17];
z[13] = z[8] * z[13];
z[10] = -z[10] * z[22];
z[10] = z[10] + z[13];
z[10] = (T(1) / T(2)) * z[10] + z[11] + z[12];
return (T(3) / T(2)) * z[2] * z[3] * z[4] * z[5] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_26(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_26(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
