#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_34(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[16];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[3];
z[3] = iW[15];
z[4] = v[0];
z[5] = v[4];
z[6] = v[3];
z[7] = iW[4];
z[8] = v[1];
z[9] = z[6] * z[7];
z[10] = z[2] * z[5];
z[9] = z[9] + (T(1) / T(2)) * z[10];
z[11] = (T(1) / T(2)) * z[1];
z[12] = -3 + -z[10];
z[12] = z[5] * z[12];
z[12] = -z[6] + z[12];
z[12] = z[11] * z[12];
z[13] = prod_pow(z[6], 2) * z[7];
z[14] = z[5] + z[6];
z[14] = z[1] * z[5] * z[14];
z[14] = z[6] + z[13] + z[14];
z[15] = (T(1) / T(2)) * z[0];
z[14] = z[14] * z[15];
z[12] = -1 + -z[9] + z[12] + z[14];
z[12] = z[0] * z[12];
z[14] = 1 + z[10];
z[15] = -z[0] * z[5] * z[11] * z[14];
z[10] = T(1) / T(2) + z[10];
z[10] = z[1] * z[10];
z[10] = z[10] + z[15];
z[10] = z[0] * z[10];
z[11] = z[2] * z[11];
z[10] = z[10] + -z[11];
z[10] = z[4] * z[10];
z[15] = z[2] + z[7];
z[14] = z[1] * z[14];
z[11] = -z[8] * z[11];
z[10] = z[10] + z[11] + z[12] + z[14] + (T(1) / T(2)) * z[15];
z[10] = z[4] * z[10];
z[11] = (T(1) / T(2)) * z[8];
z[11] = z[11] * z[15];
z[12] = z[5] + z[13];
z[12] = z[6] + (T(1) / T(2)) * z[12];
z[12] = z[0] * z[12];
z[9] = T(-3) / T(2) + -z[9] + z[10] + z[11] + z[12];
return (T(1) / T(2)) * z[3] * z[4] * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_12345_34(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_34(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
