#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_35(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[18];
z[0] = iW[1];
z[1] = iW[4];
z[2] = iW[18];
z[3] = v[2];
z[4] = v[3];
z[5] = v[0];
z[6] = v[4];
z[7] = v[1];
z[8] = z[3] * z[5];
z[9] = prod_pow(z[3], 2);
z[10] = -z[8] + -z[9];
z[10] = z[1] * z[10];
z[11] = z[5] + -z[6];
z[12] = 2 * z[3];
z[13] = (T(1) / T(2)) * z[9];
z[14] = -z[1] * z[13];
z[14] = z[3] + z[14];
z[14] = z[1] * z[14];
z[14] = T(-1) / T(2) + z[14];
z[14] = z[4] * z[14];
z[10] = z[10] + z[11] + z[12] + z[14];
z[10] = z[4] * z[10];
z[14] = (T(1) / T(2)) * z[5];
z[15] = -z[3] + z[6];
z[15] = -z[14] + 2 * z[15];
z[15] = z[5] * z[15];
z[10] = z[10] + z[15];
z[10] = z[4] * z[10];
z[15] = -prod_pow(z[5], 2) * z[6];
z[10] = z[10] + z[15];
z[10] = z[0] * z[10];
z[15] = -z[3] * z[14];
z[15] = 2 * z[9] + z[15];
z[15] = z[1] * z[15];
z[16] = (T(3) / T(2)) * z[9];
z[8] = -z[8] + z[16];
z[8] = z[1] * z[8];
z[8] = (T(-5) / T(2)) * z[3] + z[8];
z[8] = z[1] * z[8];
z[8] = 1 + z[8];
z[8] = z[4] * z[8];
z[17] = 3 * z[3];
z[8] = -2 * z[5] + z[6] + z[8] + z[15] + -z[17];
z[8] = z[4] * z[8];
z[11] = z[5] * z[11];
z[8] = z[8] + z[10] + z[11];
z[8] = z[0] * z[8];
z[10] = -z[5] + z[17];
z[10] = z[10] * z[14];
z[11] = -z[3] + z[14];
z[11] = z[5] * z[11];
z[11] = z[11] + z[13];
z[11] = z[1] * z[11];
z[13] = -z[3] + z[5];
z[11] = z[11] + (T(1) / T(2)) * z[13];
z[11] = z[7] * z[11];
z[9] = -z[9] + z[10] + z[11];
z[9] = z[1] * z[9];
z[10] = z[12] + -z[14];
z[11] = z[5] * z[10];
z[11] = z[11] + -z[16];
z[11] = z[1] * z[11];
z[10] = z[10] + z[11];
z[10] = z[1] * z[10];
z[10] = T(-1) / T(2) + z[10];
z[10] = z[4] * z[10];
z[8] = z[3] + z[8] + z[9] + z[10] + z[14];
return z[2] * z[8];
}



template double eval_coef_2q3y_2l_pmmpp_12345_35(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_35(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
