#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_38(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[19];
z[0] = iW[1];
z[1] = iW[4];
z[2] = iW[18];
z[3] = v[2];
z[4] = v[3];
z[5] = v[0];
z[6] = v[4];
z[7] = v[1];
z[8] = 2 * z[4];
z[9] = prod_pow(z[0], 2);
z[8] = z[8] * z[9];
z[10] = 3 * z[1];
z[11] = (T(1) / T(2)) * z[4];
z[12] = -z[0] * z[11];
z[12] = 1 + z[12];
z[12] = z[4] * z[12];
z[12] = (T(-1) / T(2)) * z[7] + z[12];
z[12] = z[10] * z[12];
z[13] = z[4] * z[9];
z[14] = (T(-1) / T(2)) * z[0] + -3 * z[13];
z[14] = z[4] * z[14];
z[14] = T(7) / T(2) + z[14];
z[12] = z[12] + (T(1) / T(2)) * z[14];
z[12] = z[1] * z[12];
z[12] = -z[8] + z[12];
z[12] = z[3] * z[12];
z[14] = (T(3) / T(4)) * z[4];
z[9] = z[9] * z[14];
z[14] = (T(3) / T(4)) * z[1];
z[15] = z[4] + -z[7];
z[16] = -z[1] * z[15];
z[16] = -1 + z[16];
z[16] = z[14] * z[16];
z[17] = z[0] * z[6];
z[18] = 1 + -z[17];
z[18] = z[0] * z[18];
z[16] = -z[9] + z[16] + z[18];
z[16] = z[5] * z[16];
z[18] = T(-5) / T(2) + 2 * z[17];
z[18] = z[0] * z[18];
z[18] = (T(3) / T(2)) * z[13] + z[18];
z[18] = z[4] * z[18];
z[15] = -z[14] * z[15];
z[12] = T(1) / T(4) + z[12] + z[15] + z[16] + -z[17] + z[18];
z[12] = z[5] * z[12];
z[15] = 3 * z[0];
z[8] = z[8] + -z[15];
z[8] = z[4] * z[8];
z[16] = (T(-5) / T(2)) * z[0] + z[13];
z[11] = z[11] * z[16];
z[11] = 1 + z[11];
z[11] = z[4] * z[11];
z[11] = (T(-1) / T(4)) * z[7] + z[11];
z[10] = z[10] * z[11];
z[11] = -z[13] + z[15];
z[11] = z[4] * z[11];
z[11] = -3 + z[11];
z[11] = z[4] * z[11];
z[11] = z[7] + z[11];
z[11] = z[11] * z[14];
z[13] = 2 * z[0] + -z[13];
z[13] = z[4] * z[13];
z[11] = -1 + z[11] + z[13];
z[11] = z[1] * z[3] * z[11];
z[8] = 1 + z[8] + z[10] + z[11];
z[8] = z[3] * z[8];
z[10] = T(3) / T(2) + -z[17];
z[10] = z[0] * z[10];
z[9] = -z[9] + z[10];
z[9] = z[4] * z[9];
z[9] = T(-3) / T(4) + z[9] + z[17];
z[9] = z[4] * z[9];
z[8] = z[8] + z[9] + z[12];
return z[2] * z[8];
}



template double eval_coef_2q3y_2l_pmmpp_12345_38(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_38(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
