#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_47(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[28];
z[0] = iW[1];
z[1] = iW[7];
z[2] = iW[15];
z[3] = iW[18];
z[4] = iW[23];
z[5] = v[0];
z[6] = v[4];
z[7] = v[2];
z[8] = v[3];
z[9] = v[1];
z[10] = 5 * z[8];
z[11] = prod_pow(z[0], 2);
z[10] = z[10] * z[11];
z[12] = 11 * z[0] + -z[10];
z[12] = z[8] * z[12];
z[12] = -7 + z[12];
z[12] = z[8] * z[12];
z[12] = z[9] + z[12];
z[13] = (T(1) / T(2)) * z[6];
z[14] = z[8] * z[11];
z[15] = z[0] + -z[14];
z[15] = z[13] * z[15];
z[16] = (T(11) / T(4)) * z[0] + -2 * z[14];
z[16] = z[8] * z[16];
z[15] = T(-3) / T(4) + z[15] + z[16];
z[15] = z[6] * z[15];
z[12] = (T(1) / T(2)) * z[12] + z[15];
z[12] = z[6] * z[12];
z[15] = z[6] * z[11];
z[15] = (T(-9) / T(2)) * z[0] + z[10] + z[15];
z[15] = z[8] * z[15];
z[15] = T(-1) / T(2) + z[15];
z[15] = z[6] * z[15];
z[16] = (T(1) / T(2)) * z[8];
z[17] = z[0] * z[16];
z[18] = -1 + z[17];
z[18] = z[8] * z[18];
z[15] = (T(1) / T(2)) * z[9] + z[15] + z[18];
z[18] = z[0] * z[8];
z[19] = 1 + -z[18];
z[20] = (T(-1) / T(2)) * z[0] + -z[14];
z[20] = z[6] * z[20];
z[19] = (T(1) / T(2)) * z[19] + z[20];
z[19] = z[5] * z[19];
z[15] = (T(1) / T(2)) * z[15] + z[19];
z[15] = z[5] * z[15];
z[19] = 3 * z[9];
z[20] = -3 + z[18];
z[20] = z[8] * z[20];
z[20] = z[19] + z[20];
z[20] = z[8] * z[20];
z[21] = prod_pow(z[9], 2);
z[20] = z[20] + -z[21];
z[12] = z[12] + z[15] + (T(1) / T(4)) * z[20];
z[12] = z[5] * z[12];
z[15] = 3 * z[0];
z[20] = z[14] + -z[15];
z[22] = z[8] * z[20];
z[22] = 3 + z[22];
z[22] = z[8] * z[22];
z[22] = -z[9] + z[22];
z[23] = z[11] * z[16];
z[24] = -z[0] + z[23];
z[25] = z[8] * z[24];
z[25] = T(1) / T(2) + z[25];
z[26] = z[6] * z[25];
z[22] = (T(3) / T(2)) * z[22] + z[26];
z[26] = -z[13] * z[22];
z[25] = -z[5] * z[25];
z[22] = (T(1) / T(2)) * z[22] + z[25];
z[22] = z[5] * z[22];
z[23] = 2 * z[0] + -z[23];
z[23] = z[8] * z[23];
z[23] = -3 + z[23];
z[23] = z[8] * z[23];
z[25] = 2 * z[9];
z[23] = z[23] + z[25];
z[23] = z[8] * z[23];
z[27] = (T(1) / T(2)) * z[21];
z[22] = z[22] + z[23] + z[26] + -z[27];
z[22] = z[7] * z[22];
z[23] = (T(-7) / T(2)) * z[0] + z[14];
z[23] = z[16] * z[23];
z[23] = 2 + z[23];
z[23] = z[8] * z[23];
z[23] = (T(-3) / T(4)) * z[9] + z[23];
z[20] = z[16] * z[20];
z[20] = 1 + z[20];
z[20] = z[6] * z[20];
z[20] = z[20] + 3 * z[23];
z[20] = z[6] * z[20];
z[23] = (T(-19) / T(4)) * z[0] + z[14];
z[23] = z[8] * z[23];
z[23] = T(33) / T(4) + z[23];
z[23] = z[8] * z[23];
z[23] = (T(-25) / T(4)) * z[9] + z[23];
z[23] = z[8] * z[23];
z[20] = z[20] + (T(7) / T(4)) * z[21] + z[23];
z[20] = z[6] * z[20];
z[17] = -2 + z[17];
z[17] = z[8] * z[17];
z[17] = z[17] + z[19];
z[17] = z[8] * z[17];
z[19] = 2 * z[21];
z[17] = z[17] + -z[19];
z[17] = z[8] * z[17];
z[23] = prod_pow(z[9], 3);
z[17] = z[17] + (T(1) / T(2)) * z[23];
z[12] = z[12] + -z[17] + z[20] + z[22];
z[12] = z[7] * z[12];
z[10] = (T(19) / T(2)) * z[0] + -z[10];
z[10] = z[10] * z[16];
z[20] = (T(-1) / T(4)) * z[6] + (T(-5) / T(4)) * z[8];
z[20] = z[11] * z[20];
z[20] = z[0] + z[20];
z[20] = z[6] * z[20];
z[10] = -2 + z[10] + z[20];
z[10] = z[6] * z[10];
z[20] = -5 + 3 * z[18];
z[20] = z[8] * z[20];
z[10] = z[10] + z[20] + z[25];
z[10] = z[6] * z[10];
z[20] = (T(7) / T(2)) * z[8] + z[13];
z[20] = z[11] * z[20];
z[15] = -z[15] + z[20];
z[15] = z[6] * z[15];
z[20] = 9 + -11 * z[18];
z[15] = z[15] + (T(1) / T(2)) * z[20];
z[15] = z[13] * z[15];
z[11] = -z[11] * z[13];
z[11] = z[0] + z[11];
z[11] = z[6] * z[11];
z[11] = T(-1) / T(2) + z[11];
z[11] = z[5] * z[11];
z[11] = z[8] + -z[9] + z[11] + z[15];
z[11] = z[5] * z[11];
z[13] = z[9] + -z[16];
z[13] = z[8] * z[13];
z[13] = z[13] + -z[27];
z[10] = z[10] + z[11] + (T(3) / T(2)) * z[13];
z[10] = z[5] * z[10];
z[11] = 15 + -7 * z[18];
z[11] = z[8] * z[11];
z[11] = -9 * z[9] + z[11];
z[11] = z[8] * z[11];
z[11] = z[11] + z[21];
z[13] = z[6] * z[24];
z[15] = (T(7) / T(4)) * z[14];
z[18] = -4 * z[0] + z[15];
z[18] = z[8] * z[18];
z[13] = T(9) / T(4) + z[13] + z[18];
z[13] = z[6] * z[13];
z[15] = -6 * z[0] + z[15];
z[15] = z[8] * z[15];
z[15] = T(23) / T(4) + z[15];
z[15] = z[8] * z[15];
z[13] = (T(-3) / T(2)) * z[9] + z[13] + z[15];
z[13] = z[6] * z[13];
z[11] = (T(1) / T(4)) * z[11] + z[13];
z[11] = z[6] * z[11];
z[10] = z[10] + z[11];
z[10] = z[5] * z[10];
z[11] = (T(11) / T(2)) * z[0] + -z[14];
z[11] = z[11] * z[16];
z[11] = -6 + z[11];
z[11] = z[8] * z[11];
z[11] = (T(23) / T(4)) * z[9] + z[11];
z[11] = z[8] * z[11];
z[13] = -z[0] + (T(1) / T(4)) * z[14];
z[13] = z[8] * z[13];
z[14] = T(-19) / T(4) + -3 * z[13];
z[14] = z[8] * z[14];
z[13] = -1 + -z[13];
z[13] = z[6] * z[13];
z[13] = (T(5) / T(2)) * z[9] + z[13] + z[14];
z[13] = z[6] * z[13];
z[11] = z[11] + z[13] + -z[19];
z[11] = z[6] * z[11];
z[11] = z[11] + z[17];
z[11] = z[6] * z[11];
z[10] = z[10] + z[11] + z[12];
return z[1] * z[2] * z[3] * z[4] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_47(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_47(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
