#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_50(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[28];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[7];
z[3] = iW[18];
z[4] = iW[21];
z[5] = v[0];
z[6] = v[2];
z[7] = v[4];
z[8] = v[3];
z[9] = v[1];
z[10] = (T(1) / T(2)) * z[7];
z[11] = prod_pow(z[0], 2);
z[12] = z[7] * z[11];
z[13] = (T(-83) / T(3)) * z[0] + 47 * z[12];
z[13] = z[10] * z[13];
z[14] = z[8] * z[11];
z[15] = z[7] * z[14];
z[13] = T(-29) / T(3) + z[13] + (T(109) / T(6)) * z[15];
z[15] = 2 * z[7];
z[16] = z[11] * z[15];
z[17] = (T(61) / T(8)) * z[0] + -z[16];
z[17] = z[7] * z[17];
z[17] = T(-37) / T(4) + z[17];
z[18] = z[1] * z[7];
z[17] = z[17] * z[18];
z[19] = 2 * z[0] + -z[12];
z[19] = z[7] * z[19];
z[19] = -1 + z[19];
z[20] = z[1] * z[5];
z[21] = z[19] * z[20];
z[13] = (T(1) / T(8)) * z[13] + (T(1) / T(3)) * z[17] + (T(2) / T(3)) * z[21];
z[13] = z[5] * z[13];
z[17] = 47 * z[0] + (T(77) / T(3)) * z[12];
z[17] = z[10] * z[17];
z[17] = T(-157) / T(3) + z[17];
z[17] = z[7] * z[17];
z[21] = -4 * z[7] + -z[8];
z[21] = z[11] * z[21];
z[21] = 5 * z[0] + z[21];
z[22] = (T(2) / T(3)) * z[8];
z[21] = z[21] * z[22];
z[23] = 8 * z[0] + (T(-17) / T(16)) * z[12];
z[23] = z[7] * z[23];
z[21] = T(-14) / T(3) + z[21] + z[23];
z[21] = z[8] * z[21];
z[23] = prod_pow(z[7], 2);
z[24] = z[1] * z[23];
z[25] = z[0] * z[10];
z[25] = -1 + z[25];
z[25] = z[24] * z[25];
z[13] = z[13] + (T(1) / T(8)) * z[17] + z[21] + (T(29) / T(12)) * z[25];
z[17] = prod_pow(z[5], 2);
z[13] = z[13] * z[17];
z[21] = -4 * z[0] + -z[12];
z[21] = z[15] * z[21];
z[21] = T(109) / T(16) + z[21];
z[22] = z[7] + z[22];
z[22] = z[11] * z[22];
z[22] = (T(-5) / T(3)) * z[0] + z[22];
z[25] = 2 * z[8];
z[22] = z[22] * z[25];
z[26] = z[0] * z[7];
z[27] = T(15) / T(16) + (T(-2) / T(3)) * z[26];
z[27] = z[18] * z[27];
z[26] = 1 + -z[26];
z[26] = z[1] * z[26];
z[26] = -z[16] + z[26];
z[26] = z[5] * z[26];
z[21] = (T(1) / T(3)) * z[21] + z[22] + (T(2) / T(3)) * z[26] + z[27];
z[21] = z[5] * z[21];
z[22] = z[7] + z[24];
z[21] = z[21] + (T(13) / T(48)) * z[22];
z[21] = z[5] * z[21];
z[14] = z[0] + -z[14];
z[14] = z[6] * z[14] * z[17];
z[14] = (T(2) / T(3)) * z[14] + z[21];
z[14] = z[6] * z[14];
z[13] = z[13] + z[14];
z[13] = z[6] * z[13];
z[14] = z[15] * z[19];
z[16] = -z[8] * z[16];
z[19] = -z[0] + z[12];
z[21] = z[7] * z[19];
z[16] = z[16] + (T(-109) / T(16)) * z[21];
z[16] = z[8] * z[16];
z[14] = z[14] + z[16];
z[10] = z[10] * z[11];
z[10] = -z[0] + z[10];
z[10] = z[7] * z[10];
z[11] = 3 * z[0] + -z[12];
z[11] = z[7] * z[11];
z[11] = -3 + z[11];
z[16] = z[11] * z[18];
z[10] = T(1) / T(2) + z[10] + (T(-1) / T(2)) * z[16];
z[10] = z[5] * z[10];
z[11] = z[11] * z[24];
z[10] = (T(15) / T(8)) * z[10] + (T(-15) / T(16)) * z[11] + (T(1) / T(3)) * z[14];
z[10] = z[5] * z[10];
z[11] = (T(13) / T(3)) * z[0] + (T(-15) / T(2)) * z[12];
z[11] = z[7] * z[11];
z[11] = T(115) / T(6) + z[11];
z[11] = z[11] * z[23];
z[14] = -z[0] + (T(1) / T(3)) * z[12];
z[14] = z[14] * z[15];
z[15] = z[8] * z[19];
z[14] = 1 + z[14] + (T(1) / T(3)) * z[15];
z[14] = z[14] * z[25];
z[12] = -179 * z[0] + -13 * z[12];
z[12] = z[7] * z[12];
z[12] = 6 + (T(1) / T(48)) * z[12];
z[12] = z[7] * z[12];
z[12] = z[12] + z[14];
z[12] = z[8] * z[12];
z[10] = z[10] + (T(1) / T(8)) * z[11] + z[12];
z[10] = z[10] * z[17];
z[11] = z[18] + z[20];
z[12] = 2 + (T(29) / T(24)) * z[11];
z[12] = z[12] * z[17];
z[11] = z[5] * z[11];
z[14] = z[6] * z[11];
z[12] = z[12] + (T(-13) / T(48)) * z[14];
z[12] = z[6] * z[12];
z[14] = (T(-4) / T(3)) * z[7] + -z[8];
z[11] = (T(2) / T(3)) * z[9] + (T(-15) / T(16)) * z[11] + 2 * z[14];
z[11] = z[11] * z[17];
z[11] = z[11] + z[12];
z[11] = z[9] * z[11];
z[10] = z[10] + z[11] + z[13];
return prod_pow(z[4], 2) * z[2] * z[3] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_50(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_50(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
