#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_51(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[25];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[15];
z[3] = iW[16];
z[4] = iW[17];
z[5] = iW[18];
z[6] = v[0];
z[7] = v[2];
z[8] = v[4];
z[9] = v[3];
z[10] = v[1];
z[11] = (T(1) / T(2)) * z[0];
z[12] = z[0] * z[9];
z[13] = T(-7) / T(2) + z[12];
z[13] = z[11] * z[13];
z[14] = (T(1) / T(4)) * z[7];
z[15] = prod_pow(z[0], 2);
z[16] = -z[14] * z[15];
z[17] = z[0] + -z[1];
z[18] = (T(1) / T(4)) * z[8];
z[19] = z[0] * z[17] * z[18];
z[13] = z[1] + z[13] + z[16] + z[19];
z[13] = z[8] * z[13];
z[16] = 3 + -z[12];
z[19] = z[1] * z[7];
z[16] = 3 * z[16] + z[19];
z[16] = z[0] * z[16];
z[16] = (T(-349) / T(18)) * z[1] + z[16];
z[16] = z[7] * z[16];
z[19] = z[1] * z[10];
z[16] = T(-205) / T(9) + -3 * z[12] + z[16] + (T(205) / T(18)) * z[19];
z[13] = z[13] + (T(1) / T(4)) * z[16];
z[13] = z[8] * z[13];
z[16] = -1 + z[12];
z[20] = z[0] * z[16];
z[20] = (T(223) / T(18)) * z[1] + z[20];
z[20] = z[7] * z[20];
z[20] = T(-65) / T(18) + 7 * z[12] + (T(439) / T(18)) * z[19] + z[20];
z[20] = z[7] * z[20];
z[21] = (T(1) / T(18)) * z[10];
z[22] = T(1421) / T(2) + -277 * z[19];
z[22] = z[21] * z[22];
z[23] = prod_pow(z[9], 2);
z[24] = z[0] * z[23];
z[20] = (T(-313) / T(18)) * z[9] + (T(1) / T(2)) * z[20] + z[22] + z[24];
z[13] = z[13] + (T(1) / T(2)) * z[20];
z[13] = z[8] * z[13];
z[20] = z[14] + -z[18];
z[15] = z[1] * z[15] * z[20];
z[20] = z[1] + -z[11];
z[20] = z[0] * z[20];
z[15] = z[15] + z[20];
z[15] = z[8] * z[15];
z[20] = z[0] + (T(-5) / T(2)) * z[1];
z[20] = z[0] * z[7] * z[20];
z[20] = (T(241) / T(36)) * z[1] + z[20];
z[15] = z[15] + (T(1) / T(2)) * z[20];
z[15] = z[8] * z[15];
z[20] = -z[0] + (T(-133) / T(72)) * z[1];
z[20] = z[7] * z[20];
z[15] = T(439) / T(72) + -z[12] + z[15] + (T(-313) / T(36)) * z[19] + z[20];
z[15] = z[8] * z[15];
z[20] = z[1] * z[8];
z[20] = 1 + z[20];
z[11] = z[11] * z[20];
z[11] = -z[1] + z[11];
z[11] = z[8] * z[11];
z[20] = -1 + z[19];
z[11] = z[11] + (T(1) / T(2)) * z[20];
z[11] = z[6] * z[11];
z[20] = z[7] * z[20];
z[22] = -403 + 331 * z[19];
z[22] = z[10] * z[22];
z[11] = z[9] + z[11] + z[15] + (T(205) / T(72)) * z[20] + (T(1) / T(72)) * z[22];
z[11] = z[6] * z[11];
z[15] = -301 + (T(295) / T(3)) * z[19];
z[15] = z[10] * z[15];
z[15] = (T(161) / T(3)) * z[9] + (T(1) / T(4)) * z[15];
z[15] = z[10] * z[15];
z[15] = (T(1) / T(3)) * z[15] + -z[23];
z[22] = T(259) / T(18) + -z[12] + (T(-241) / T(18)) * z[19];
z[14] = z[14] * z[22];
z[22] = T(-8) / T(9) + (T(-1) / T(4)) * z[19];
z[22] = z[10] * z[22];
z[22] = (T(41) / T(36)) * z[9] + z[22];
z[14] = z[14] + 5 * z[22];
z[14] = z[7] * z[14];
z[11] = z[11] + z[13] + z[14] + (T(1) / T(2)) * z[15];
z[11] = z[6] * z[11];
z[13] = z[7] * z[17];
z[12] = T(277) / T(18) + -z[12] + -z[13] + (T(-259) / T(18)) * z[19];
z[12] = z[7] * z[12];
z[13] = z[13] + z[16];
z[13] = z[8] * z[13];
z[14] = z[9] + -z[10];
z[12] = z[12] + z[13] + (T(259) / T(18)) * z[14];
z[12] = z[12] * z[18];
z[13] = (T(-289) / T(4)) * z[9] + (T(143) / T(3)) * z[10];
z[13] = z[10] * z[13];
z[13] = z[13] + (T(295) / T(12)) * z[23];
z[14] = -161 + 143 * z[19];
z[14] = z[14] * z[21];
z[14] = z[9] + z[14] + (T(223) / T(72)) * z[20];
z[14] = z[7] * z[14];
z[12] = z[12] + (T(1) / T(6)) * z[13] + z[14];
z[12] = z[8] * z[12];
z[13] = z[9] + (T(-1) / T(2)) * z[10];
z[13] = z[10] * z[13];
z[13] = z[13] + (T(-1) / T(2)) * z[23];
z[13] = z[10] * z[13];
z[14] = 349 + -295 * z[19];
z[14] = z[10] * z[14];
z[14] = 187 * z[9] + z[14];
z[14] = z[10] * z[14];
z[14] = z[14] + -241 * z[23];
z[15] = 1 + (T(-1) / T(2)) * z[19];
z[15] = z[10] * z[15];
z[15] = (T(-1) / T(2)) * z[9] + z[15];
z[15] = z[7] * z[15];
z[14] = (T(1) / T(2)) * z[14] + 241 * z[15];
z[14] = z[7] * z[14];
z[13] = 295 * z[13] + z[14];
z[11] = z[11] + z[12] + (T(1) / T(36)) * z[13];
return z[2] * z[3] * z[4] * z[5] * z[6] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_51(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_51(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
