#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_52(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[21];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[16];
z[3] = iW[18];
z[4] = v[1];
z[5] = v[2];
z[6] = v[4];
z[7] = v[3];
z[8] = iW[1];
z[9] = v[0];
z[10] = z[1] * z[9];
z[11] = -1 + (T(1) / T(2)) * z[10];
z[11] = z[9] * z[11];
z[12] = (T(1) / T(2)) * z[7];
z[13] = z[11] + z[12];
z[13] = z[8] * z[13];
z[14] = (T(1) / T(2)) * z[4];
z[15] = -z[0] + (T(-3) / T(2)) * z[1];
z[15] = z[14] * z[15];
z[16] = 1 + -z[10] + -z[13];
z[16] = z[8] * z[16];
z[17] = z[0] + z[1];
z[16] = z[16] + (T(1) / T(4)) * z[17];
z[16] = z[6] * z[16];
z[17] = 3 * z[10];
z[18] = z[0] * z[7];
z[19] = -5 + z[18];
z[13] = 3 * z[13] + z[15] + z[16] + z[17] + (T(1) / T(4)) * z[19];
z[13] = z[6] * z[13];
z[15] = (T(1) / T(4)) * z[4];
z[16] = z[0] + 3 * z[1];
z[15] = z[15] * z[16];
z[16] = -1 + (T(-1) / T(2)) * z[18];
z[15] = z[15] + (T(1) / T(2)) * z[16] + -z[17];
z[15] = z[4] * z[15];
z[13] = -3 * z[11] + -z[12] + z[13] + z[15];
z[13] = z[6] * z[13];
z[15] = z[1] * z[4];
z[16] = z[0] * z[15];
z[17] = 3 * z[0] + 7 * z[1] + -z[16];
z[14] = z[14] * z[17];
z[17] = -3 + -z[10];
z[19] = z[7] + -z[9];
z[19] = z[8] * z[19];
z[17] = (T(1) / T(2)) * z[17] + z[19];
z[17] = z[8] * z[17];
z[17] = -z[0] + (T(-7) / T(4)) * z[1] + (T(1) / T(4)) * z[16] + z[17];
z[17] = z[6] * z[17];
z[19] = -2 * z[7] + z[9];
z[19] = z[8] * z[19];
z[14] = T(-3) / T(4) + z[10] + z[14] + z[17] + -z[18] + z[19];
z[14] = z[6] * z[14];
z[17] = z[0] + -z[16];
z[19] = z[7] * z[8];
z[19] = -1 + z[19];
z[20] = -z[8] * z[19];
z[17] = (T(3) / T(2)) * z[17] + z[20];
z[17] = z[6] * z[17];
z[16] = -z[0] + (T(1) / T(2)) * z[16];
z[20] = z[4] * z[16];
z[17] = z[17] + (T(3) / T(2)) * z[18] + z[19] + 3 * z[20];
z[17] = z[5] * z[17];
z[18] = 9 + z[18];
z[16] = (T(-7) / T(2)) * z[1] + z[16];
z[16] = z[4] * z[16];
z[16] = -z[10] + z[16] + (T(1) / T(2)) * z[18];
z[16] = z[4] * z[16];
z[16] = -z[7] + z[16] + z[17];
z[14] = z[14] + (T(1) / T(2)) * z[16];
z[14] = z[5] * z[14];
z[10] = T(3) / T(4) + z[10] + (T(-1) / T(4)) * z[15];
z[10] = z[4] * z[10];
z[10] = z[10] + z[11] + -z[12];
z[10] = z[4] * z[10];
z[10] = z[10] + z[13] + z[14];
return z[2] * z[3] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_52(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_52(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
