#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_66(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[26];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[2];
z[5] = v[4];
z[6] = iW[7];
z[7] = iW[15];
z[8] = iW[18];
z[9] = v[3];
z[10] = iW[14];
z[11] = v[1];
z[12] = 32 * z[9];
z[13] = prod_pow(z[0], 2);
z[12] = z[12] * z[13];
z[14] = (T(-1223) / T(8)) * z[0] + z[12];
z[14] = z[9] * z[14];
z[14] = T(839) / T(4) + z[14];
z[15] = (T(1) / T(9)) * z[9];
z[14] = z[14] * z[15];
z[16] = (T(-199) / T(8)) * z[0] + z[12];
z[17] = (T(1) / T(3)) * z[5];
z[16] = z[16] * z[17];
z[18] = z[9] * z[13];
z[19] = (T(-583) / T(4)) * z[0] + 64 * z[18];
z[19] = z[9] * z[19];
z[16] = T(109) / T(4) + z[16] + (T(1) / T(3)) * z[19];
z[16] = z[16] * z[17];
z[14] = (T(-79) / T(8)) * z[11] + z[14] + z[16];
z[14] = z[5] * z[14];
z[16] = 20 * z[0] + (T(-199) / T(8)) * z[18];
z[16] = z[16] * z[17];
z[19] = 1091 * z[0] + -437 * z[18];
z[19] = z[9] * z[19];
z[19] = -109 + (T(1) / T(6)) * z[19];
z[16] = z[16] + (T(1) / T(4)) * z[19];
z[16] = z[5] * z[16];
z[19] = (T(1) / T(2)) * z[9];
z[20] = z[13] * z[19];
z[20] = -z[0] + z[20];
z[20] = z[9] * z[20];
z[20] = T(1) / T(2) + z[20];
z[21] = -z[0] + z[18];
z[22] = z[5] * z[21];
z[23] = (T(119) / T(3)) * z[20] + (T(-13) / T(4)) * z[22];
z[24] = (T(1) / T(2)) * z[4];
z[23] = z[23] * z[24];
z[25] = 485 * z[0] + -119 * z[18];
z[25] = z[9] * z[25];
z[25] = -613 + z[25];
z[25] = z[9] * z[25];
z[25] = 247 * z[11] + z[25];
z[16] = z[16] + z[23] + (T(1) / T(12)) * z[25];
z[16] = z[4] * z[16];
z[23] = prod_pow(z[11], 2);
z[25] = z[0] * z[9];
z[25] = 1 + (T(-1) / T(3)) * z[25];
z[25] = z[9] * z[25];
z[25] = -z[11] + z[25];
z[25] = z[9] * z[25];
z[23] = (T(1) / T(3)) * z[23] + z[25];
z[14] = z[14] + (T(1) / T(3)) * z[16] + (T(32) / T(3)) * z[23];
z[14] = z[5] * z[14];
z[12] = (T(569) / T(4)) * z[0] + -z[12];
z[12] = z[12] * z[15];
z[15] = (T(-32) / T(3)) * z[5] + (T(-64) / T(3)) * z[9];
z[15] = z[13] * z[15];
z[15] = (T(275) / T(8)) * z[0] + z[15];
z[15] = z[15] * z[17];
z[12] = T(-49) / T(4) + z[12] + z[15];
z[12] = z[5] * z[12];
z[15] = z[0] * z[19];
z[15] = -1 + z[15];
z[15] = z[9] * z[15];
z[15] = (T(1) / T(2)) * z[11] + z[15];
z[12] = z[12] + (T(313) / T(36)) * z[15];
z[12] = z[5] * z[12];
z[15] = -319 * z[0] + (T(331) / T(3)) * z[18];
z[15] = z[15] * z[19];
z[15] = T(313) / T(3) + z[15];
z[16] = (T(32) / T(9)) * z[5] + (T(569) / T(72)) * z[9];
z[16] = z[13] * z[16];
z[16] = -12 * z[0] + z[16];
z[16] = z[5] * z[16];
z[15] = (T(1) / T(12)) * z[15] + z[16];
z[15] = z[5] * z[15];
z[16] = -z[20] + (T(-295) / T(36)) * z[22];
z[16] = z[16] * z[24];
z[17] = -3 * z[0] + z[18];
z[17] = z[9] * z[17];
z[17] = 3 + z[17];
z[17] = z[9] * z[17];
z[17] = -z[11] + z[17];
z[15] = z[15] + z[16] + (T(1) / T(4)) * z[17];
z[15] = z[4] * z[15];
z[12] = z[12] + z[15];
z[12] = z[3] * z[12];
z[12] = z[12] + z[14];
z[12] = z[6] * z[7] * z[8] * z[12];
z[14] = z[4] * z[13];
z[15] = z[4] + -z[9];
z[15] = z[14] * z[15];
z[16] = prod_pow(z[4], 2) * z[1];
z[17] = z[0] * z[16];
z[15] = z[15] + z[17];
z[16] = -z[4] + (T(1) / T(2)) * z[16] + z[19];
z[16] = z[3] * z[13] * z[16];
z[15] = (T(1) / T(2)) * z[15] + z[16];
z[12] = z[12] + (T(1) / T(2)) * z[15];
z[12] = z[2] * z[12];
z[15] = z[0] * z[1];
z[16] = z[8] * z[21];
z[15] = (T(13) / T(2)) * z[13] + (T(19) / T(2)) * z[15] + (T(-277) / T(6)) * z[16];
z[15] = z[4] * z[15];
z[16] = z[5] * z[13];
z[16] = -z[0] + z[16];
z[15] = z[15] + (T(137) / T(3)) * z[16];
z[17] = z[8] * z[9];
z[17] = T(-277) / T(18) + (T(277) / T(18)) * z[17];
z[13] = z[13] * z[17];
z[14] = z[14] + (T(19) / T(6)) * z[16];
z[14] = z[1] * z[14];
z[16] = -z[0] * z[10];
z[13] = z[13] + z[14] + z[16];
z[13] = z[3] * z[13];
z[13] = z[13] + (T(1) / T(3)) * z[15];
z[12] = z[12] + (T(1) / T(4)) * z[13];
return z[3] * z[12];
}



template double eval_coef_2q3y_2l_pmmpp_12345_66(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_66(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
