#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_75(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[29];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[15];
z[3] = iW[17];
z[4] = iW[18];
z[5] = v[2];
z[6] = v[3];
z[7] = v[4];
z[8] = iW[3];
z[9] = v[1];
z[10] = v[0];
z[11] = (T(1) / T(2)) * z[8];
z[12] = z[9] * z[11];
z[12] = -1 + z[12];
z[12] = z[0] * z[12];
z[12] = z[11] + z[12];
z[13] = z[0] * z[6];
z[14] = -1 + z[13];
z[15] = (T(1) / T(2)) * z[1];
z[16] = -z[14] * z[15];
z[16] = -z[12] + z[16];
z[17] = (T(1) / T(2)) * z[5];
z[16] = z[16] * z[17];
z[18] = (T(1) / T(2)) * z[6];
z[19] = -1 + -z[13];
z[19] = z[18] * z[19];
z[20] = z[6] + -z[10];
z[21] = z[6] * z[20];
z[22] = z[1] * z[21];
z[19] = -z[10] + z[19] + (T(3) / T(2)) * z[22];
z[19] = z[15] * z[19];
z[22] = (T(1) / T(4)) * z[13];
z[23] = z[8] * z[9];
z[24] = z[8] * z[10];
z[16] = T(-3) / T(2) + z[16] + z[19] + z[22] + z[23] + z[24];
z[16] = z[5] * z[16];
z[19] = prod_pow(z[10], 2);
z[23] = (T(1) / T(2)) * z[19];
z[25] = -z[10] + z[18];
z[26] = -z[6] * z[25];
z[26] = -z[23] + z[26];
z[26] = z[1] * z[26];
z[27] = z[8] * z[19];
z[22] = 1 + z[22];
z[22] = z[6] * z[22];
z[22] = -2 * z[10] + z[22] + z[26] + (T(3) / T(4)) * z[27];
z[22] = z[1] * z[22];
z[20] = z[15] * z[20];
z[20] = (T(1) / T(2)) * z[13] + z[20] + -z[24];
z[20] = z[1] * z[20];
z[26] = (T(1) / T(2)) * z[0];
z[20] = -z[8] + z[20] + -z[26];
z[17] = z[17] * z[20];
z[20] = -1 + z[24];
z[28] = -z[13] + 3 * z[20];
z[11] = -z[11] * z[19];
z[11] = z[11] + -z[25];
z[11] = z[1] * z[11];
z[11] = z[11] + (T(-1) / T(2)) * z[20];
z[11] = z[7] * z[11] * z[15];
z[11] = z[11] + z[17] + z[22] + (T(1) / T(4)) * z[28];
z[11] = z[7] * z[11];
z[17] = -z[9] * z[28];
z[22] = 3 * z[10] + -z[27];
z[25] = -7 + -z[13];
z[25] = z[6] * z[25];
z[17] = z[17] + 3 * z[22] + z[25];
z[25] = z[6] + (T(-7) / T(4)) * z[10];
z[25] = z[6] * z[25];
z[19] = (T(3) / T(4)) * z[19] + z[25];
z[19] = z[1] * z[19];
z[11] = z[11] + z[16] + (T(1) / T(4)) * z[17] + z[19];
z[11] = z[7] * z[11];
z[16] = -z[8] + z[26];
z[16] = z[9] * z[16];
z[13] = T(5) / T(2) + -z[13] + z[16] + -z[24];
z[13] = z[9] * z[13];
z[12] = z[9] * z[12];
z[16] = prod_pow(z[6], 2) * z[1];
z[17] = z[6] + -z[16];
z[15] = z[15] * z[17];
z[12] = z[12] + (T(1) / T(2)) * z[14] + z[15];
z[12] = z[5] * z[12];
z[14] = z[14] * z[18];
z[12] = z[10] + z[12] + z[13] + z[14] + -z[16];
z[12] = z[5] * z[12];
z[13] = z[9] * z[20];
z[13] = 3 * z[6] + z[13] + -z[22];
z[14] = (T(1) / T(2)) * z[9];
z[13] = z[13] * z[14];
z[12] = z[12] + z[13] + -z[21] + -z[23];
z[11] = z[11] + (T(1) / T(2)) * z[12];
return z[2] * z[3] * z[4] * z[7] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_75(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_75(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
