#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_78(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[31];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[3];
z[3] = iW[5];
z[4] = iW[15];
z[5] = iW[16];
z[6] = v[0];
z[7] = v[4];
z[8] = v[3];
z[9] = v[2];
z[10] = v[1];
z[11] = (T(1) / T(4)) * z[1];
z[12] = (T(4) / T(3)) * z[2];
z[13] = z[11] + -z[12];
z[14] = z[2] * z[7];
z[15] = z[13] * z[14];
z[16] = (T(1) / T(4)) * z[9];
z[17] = prod_pow(z[2], 2);
z[18] = z[16] * z[17];
z[19] = -z[1] + (T(43) / T(6)) * z[2] + -z[15] + z[18];
z[19] = z[7] * z[19];
z[20] = z[9] * z[17];
z[21] = -17 * z[2] + (T(-7) / T(2)) * z[20];
z[21] = z[9] * z[21];
z[19] = 2 + z[19] + (T(1) / T(6)) * z[21];
z[19] = z[7] * z[19];
z[21] = z[2] * z[9];
z[22] = -1 + (T(-13) / T(3)) * z[21];
z[22] = z[16] * z[22];
z[23] = z[1] + (T(-35) / T(3)) * z[2];
z[23] = z[7] * z[23];
z[23] = -1 + (T(7) / T(2)) * z[21] + (T(1) / T(4)) * z[23];
z[23] = z[7] * z[23];
z[22] = z[22] + z[23];
z[22] = z[7] * z[22];
z[23] = prod_pow(z[9], 2);
z[22] = z[22] + (T(1) / T(4)) * z[23];
z[22] = z[0] * z[22];
z[24] = (T(1) / T(2)) * z[9];
z[25] = 3 + z[21];
z[25] = z[24] * z[25];
z[19] = z[19] + z[22] + z[25];
z[19] = z[0] * z[19];
z[13] = z[2] * z[10] * z[13];
z[22] = (T(3) / T(4)) * z[1] + -4 * z[2];
z[22] = z[14] * z[22];
z[13] = z[13] + -z[22];
z[25] = (T(1) / T(2)) * z[1];
z[12] = z[12] + z[13] + z[18] + -z[25];
z[12] = z[10] * z[12];
z[26] = -z[2] + (T(5) / T(3)) * z[20] + z[25];
z[27] = z[22] + z[26];
z[27] = z[7] * z[27];
z[26] = (T(1) / T(2)) * z[26];
z[15] = -z[15] + -z[26];
z[15] = z[7] * z[15];
z[28] = 1 + z[21];
z[29] = (T(1) / T(2)) * z[28];
z[15] = z[15] + z[29];
z[30] = z[0] * z[7];
z[15] = z[15] * z[30];
z[15] = z[15] + z[27] + -z[29];
z[15] = z[0] * z[15];
z[13] = z[13] + z[15] + -z[26];
z[13] = z[6] * z[13];
z[15] = 5 * z[1] + (T(-67) / T(3)) * z[2];
z[15] = (T(1) / T(2)) * z[15] + -z[20];
z[15] = (T(1) / T(2)) * z[15] + z[22];
z[15] = z[7] * z[15];
z[22] = -z[7] * z[25];
z[25] = z[1] * z[7];
z[25] = -3 + z[25];
z[25] = z[7] * z[25];
z[25] = z[9] + z[25];
z[25] = z[0] * z[25];
z[22] = 1 + z[22] + (T(1) / T(4)) * z[25];
z[22] = z[0] * z[22];
z[11] = z[11] + z[22];
z[11] = z[8] * z[11];
z[22] = -2 * z[2] + (T(7) / T(4)) * z[20];
z[22] = z[9] * z[22];
z[11] = -1 + z[11] + z[12] + z[13] + z[15] + z[19] + (T(1) / T(3)) * z[22];
z[11] = z[6] * z[11];
z[12] = prod_pow(z[7], 2);
z[12] = z[12] + -z[23];
z[12] = z[0] * z[12];
z[13] = z[7] + -z[9];
z[15] = z[0] * z[13];
z[19] = T(-3) / T(2) + z[15];
z[19] = z[8] * z[19];
z[12] = (T(-5) / T(2)) * z[7] + -z[9] + z[12] + z[19];
z[12] = z[0] * z[12];
z[12] = T(5) / T(2) + z[12];
z[12] = z[8] * z[12];
z[19] = 5 * z[20];
z[22] = (T(-73) / T(3)) * z[2] + z[19];
z[22] = z[9] * z[22];
z[25] = (T(-7) / T(2)) * z[2] + -13 * z[20];
z[25] = z[7] * z[25];
z[22] = T(-31) / T(3) + z[22] + z[25];
z[25] = -z[2] + (T(13) / T(6)) * z[20];
z[25] = z[10] * z[25];
z[22] = (T(1) / T(3)) * z[22] + z[25];
z[22] = z[10] * z[22];
z[12] = z[12] + z[22];
z[14] = T(-41) / T(4) + (T(-19) / T(4)) * z[14] + 4 * z[21];
z[14] = z[7] * z[14];
z[14] = (T(23) / T(4)) * z[9] + z[14];
z[22] = (T(1) / T(3)) * z[7];
z[14] = z[14] * z[22];
z[25] = (T(19) / T(4)) * z[7] + -8 * z[9];
z[25] = z[7] * z[25];
z[25] = (T(13) / T(4)) * z[23] + z[25];
z[25] = z[25] * z[30];
z[26] = prod_pow(z[9], 3);
z[27] = z[2] * z[26];
z[14] = z[14] + (T(1) / T(3)) * z[25] + (T(-1) / T(4)) * z[27];
z[14] = z[0] * z[14];
z[17] = z[17] * z[24];
z[17] = (T(-37) / T(9)) * z[2] + z[17];
z[17] = z[9] * z[17];
z[17] = T(19) / T(18) + z[17];
z[17] = z[17] * z[24];
z[19] = (T(49) / T(3)) * z[2] + -z[19];
z[19] = z[19] * z[24];
z[25] = 8 * z[2] + (T(13) / T(4)) * z[20];
z[25] = z[7] * z[25];
z[19] = T(32) / T(3) + z[19] + z[25];
z[19] = z[19] * z[22];
z[11] = z[11] + (T(1) / T(2)) * z[12] + z[14] + z[17] + z[19];
z[12] = z[4] * z[5];
z[11] = z[6] * z[11] * z[12];
z[13] = (T(1) / T(2)) * z[13];
z[13] = z[13] * z[30];
z[14] = -49 * z[7] + (T(71) / T(2)) * z[9];
z[15] = -1 + (T(1) / T(2)) * z[15];
z[15] = z[8] * z[15];
z[13] = z[13] + (T(1) / T(9)) * z[14] + z[15];
z[13] = z[8] * z[13];
z[14] = T(71) / T(18) + -z[21];
z[14] = z[14] * z[23];
z[15] = T(-71) / T(9) + 3 * z[21];
z[15] = z[9] * z[15];
z[17] = -z[7] * z[28];
z[15] = z[15] + z[17];
z[15] = z[7] * z[15];
z[17] = z[7] * z[24];
z[17] = z[17] + -z[23];
z[17] = z[7] * z[17];
z[17] = z[17] + (T(1) / T(2)) * z[26];
z[17] = z[0] * z[17];
z[13] = z[13] + z[14] + (T(1) / T(2)) * z[15] + z[17];
z[14] = (T(20) / T(9)) * z[2] + -z[18];
z[14] = z[9] * z[14];
z[15] = T(1) / T(4) + -z[14];
z[15] = z[9] * z[15];
z[14] = T(89) / T(36) + z[14];
z[14] = z[7] * z[14];
z[17] = (T(-71) / T(9)) * z[2] + z[20];
z[16] = z[16] * z[17];
z[16] = T(-20) / T(9) + z[16];
z[16] = z[10] * z[16];
z[14] = (T(49) / T(18)) * z[8] + z[14] + z[15] + z[16];
z[14] = z[10] * z[14];
z[13] = (T(1) / T(2)) * z[13] + z[14];
z[12] = z[12] * z[13];
z[11] = z[11] + z[12];
return z[3] * z[6] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_78(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_78(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
