#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_79(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[29];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[5];
z[3] = iW[16];
z[4] = iW[18];
z[5] = v[0];
z[6] = v[2];
z[7] = v[4];
z[8] = v[3];
z[9] = v[1];
z[10] = (T(1) / T(2)) * z[7];
z[11] = prod_pow(z[0], 2);
z[12] = z[10] * z[11];
z[13] = -z[0] + z[12];
z[14] = z[7] * z[13];
z[14] = T(1) / T(2) + z[14];
z[15] = z[7] * z[11];
z[16] = -3 * z[0] + z[15];
z[16] = z[7] * z[16];
z[17] = 3 + z[16];
z[17] = z[7] * z[17];
z[17] = -z[9] + z[17];
z[18] = 5 * z[1];
z[19] = z[17] * z[18];
z[19] = 13 * z[14] + z[19];
z[19] = z[1] * z[19];
z[20] = -z[0] + z[15];
z[19] = z[19] + z[20];
z[19] = z[6] * z[19];
z[21] = prod_pow(z[9], 2);
z[22] = 4 * z[0] + -z[15];
z[22] = z[7] * z[22];
z[22] = -6 + z[22];
z[22] = z[7] * z[22];
z[22] = 4 * z[9] + z[22];
z[22] = z[7] * z[22];
z[22] = -z[21] + z[22];
z[23] = 2 * z[1];
z[22] = z[22] * z[23];
z[22] = (T(1) / T(4)) * z[17] + z[22];
z[22] = z[1] * z[22];
z[19] = (T(15) / T(2)) * z[14] + (T(1) / T(2)) * z[19] + z[22];
z[19] = z[1] * z[19];
z[19] = z[19] + z[20];
z[19] = z[6] * z[19];
z[22] = 2 * z[0];
z[24] = z[15] + -z[22];
z[24] = z[7] * z[24];
z[25] = (T(1) / T(2)) * z[8];
z[20] = z[20] * z[25];
z[12] = -z[12] + z[22];
z[12] = z[7] * z[12];
z[12] = -3 + z[12];
z[12] = z[7] * z[12];
z[26] = 2 * z[9];
z[12] = z[12] + z[26];
z[12] = z[7] * z[12];
z[12] = z[12] + (T(-1) / T(2)) * z[21];
z[27] = 3 * z[1];
z[12] = z[12] * z[27];
z[12] = z[12] + (T(-5) / T(4)) * z[17];
z[12] = z[1] * z[12];
z[12] = 1 + z[12] + z[19] + z[20] + z[24];
z[12] = z[5] * z[12];
z[17] = (T(49) / T(2)) * z[0] + -9 * z[15];
z[17] = z[10] * z[17];
z[17] = -11 + z[17];
z[17] = z[7] * z[17];
z[19] = 3 * z[9];
z[20] = z[0] * z[7];
z[24] = 3 + -z[20];
z[24] = z[7] * z[24];
z[24] = -z[19] + z[24];
z[24] = z[7] * z[24];
z[24] = z[21] + z[24];
z[24] = z[1] * z[24];
z[17] = (T(13) / T(4)) * z[9] + z[17] + 4 * z[24];
z[17] = z[1] * z[17];
z[24] = (T(17) / T(4)) * z[0] + -z[15];
z[24] = z[7] * z[24];
z[24] = T(-13) / T(4) + z[24];
z[17] = z[17] + 3 * z[24];
z[17] = z[1] * z[17];
z[24] = (T(13) / T(4)) * z[7] + z[8];
z[24] = z[11] * z[24];
z[20] = -2 + z[20];
z[20] = z[7] * z[20];
z[20] = z[9] + z[20];
z[18] = z[18] * z[20];
z[20] = 5 * z[15];
z[28] = (T(13) / T(2)) * z[0] + z[20];
z[28] = z[7] * z[28];
z[28] = T(-23) / T(2) + z[28];
z[18] = z[18] + (T(1) / T(2)) * z[28];
z[18] = z[1] * z[18];
z[18] = (T(13) / T(4)) * z[15] + z[18];
z[18] = z[1] * z[18];
z[18] = (T(1) / T(2)) * z[11] + z[18];
z[18] = z[6] * z[18];
z[17] = z[0] + z[17] + z[18] + z[24];
z[17] = z[6] * z[17];
z[18] = 11 * z[0];
z[24] = -7 * z[15] + z[18];
z[24] = z[7] * z[24];
z[24] = -1 + z[24];
z[24] = z[7] * z[24];
z[19] = -z[19] + z[24];
z[24] = (T(-21) / T(2)) * z[0] + 2 * z[15];
z[24] = z[7] * z[24];
z[24] = T(39) / T(2) + z[24];
z[24] = z[7] * z[24];
z[24] = (T(-31) / T(2)) * z[9] + z[24];
z[24] = z[7] * z[24];
z[24] = (T(9) / T(2)) * z[21] + z[24];
z[24] = z[1] * z[24];
z[19] = (T(1) / T(4)) * z[19] + z[24];
z[19] = z[1] * z[19];
z[11] = z[11] * z[25];
z[11] = z[11] + z[22];
z[11] = z[8] * z[11];
z[20] = (T(23) / T(2)) * z[0] + -z[20];
z[20] = z[7] * z[20];
z[11] = T(-13) / T(2) + z[11] + z[17] + z[19] + z[20];
z[11] = z[6] * z[11];
z[14] = z[7] * z[14];
z[13] = -z[8] * z[13];
z[13] = -2 + z[13] + -z[16];
z[13] = z[8] * z[13];
z[15] = 3 * z[15] + -z[18];
z[15] = z[7] * z[15];
z[15] = 15 + z[15];
z[15] = z[7] * z[15];
z[15] = -9 * z[9] + z[15];
z[10] = z[10] * z[15];
z[10] = z[10] + z[21];
z[10] = z[1] * z[10];
z[10] = z[10] + z[11] + z[12] + z[13] + (T(5) / T(2)) * z[14];
z[10] = z[5] * z[10];
z[11] = -z[7] + z[26];
z[11] = z[7] * z[11];
z[11] = z[11] + -z[21];
z[12] = z[11] * z[27];
z[13] = z[7] + -z[9];
z[12] = z[12] + z[13];
z[12] = z[1] * z[12];
z[14] = z[11] * z[23];
z[14] = 3 * z[13] + z[14];
z[14] = z[1] * z[14];
z[14] = 5 + z[14];
z[14] = z[1] * z[14];
z[15] = z[1] * z[13];
z[15] = 1 + z[15];
z[15] = prod_pow(z[1], 2) * z[6] * z[15];
z[14] = z[14] + (T(5) / T(2)) * z[15];
z[14] = z[6] * z[14];
z[12] = 4 + z[12] + z[14];
z[12] = z[6] * z[12];
z[11] = z[1] * z[11];
z[11] = 2 * z[8] + z[11] + z[12] + z[13];
z[11] = z[6] * z[11];
z[12] = z[8] + z[13];
z[12] = z[12] * z[25];
z[10] = z[10] + z[11] + z[12];
return z[2] * z[3] * z[4] * z[5] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_79(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_79(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
