#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_85(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[19];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[19];
z[3] = v[1];
z[4] = v[2];
z[5] = v[4];
z[6] = iW[1];
z[7] = v[0];
z[8] = prod_pow(z[6], 2);
z[9] = z[5] * z[8];
z[10] = (T(1) / T(2)) * z[6];
z[11] = z[9] + -z[10];
z[11] = z[5] * z[11];
z[12] = (T(1) / T(2)) * z[5];
z[8] = z[8] * z[12];
z[13] = -z[4] + z[7];
z[13] = z[8] * z[13];
z[13] = z[11] + z[13];
z[13] = z[4] * z[13];
z[14] = -z[6] + z[9];
z[15] = prod_pow(z[5], 2);
z[16] = z[14] * z[15];
z[17] = -z[7] * z[11];
z[13] = z[13] + (T(-1) / T(2)) * z[16] + z[17];
z[13] = z[4] * z[13];
z[10] = z[10] * z[15];
z[15] = z[4] + -z[5];
z[15] = z[0] * z[15];
z[17] = z[5] * z[6];
z[15] = -3 + z[15] + -z[17];
z[18] = (T(1) / T(2)) * z[4];
z[15] = z[15] * z[18];
z[14] = -z[5] * z[14];
z[14] = T(3) / T(2) + z[14];
z[14] = z[7] * z[14];
z[10] = z[10] + z[14] + z[15];
z[10] = z[4] * z[10];
z[11] = T(-1) / T(2) + z[11];
z[11] = z[7] * z[11];
z[14] = (T(-5) / T(2)) * z[6] + z[9];
z[14] = z[5] * z[14];
z[14] = T(3) / T(2) + z[14];
z[14] = z[5] * z[14];
z[11] = z[11] + z[14];
z[11] = z[7] * z[11];
z[10] = z[10] + z[11];
z[10] = z[4] * z[10];
z[11] = 3 * z[6];
z[8] = -z[8] + z[11];
z[8] = z[5] * z[8];
z[8] = T(-9) / T(2) + z[8];
z[8] = z[5] * z[8];
z[8] = 2 * z[3] + z[8];
z[14] = prod_pow(z[7], 2);
z[8] = z[8] * z[14];
z[15] = 3 + -z[17];
z[12] = z[12] * z[15];
z[12] = -z[3] + z[12];
z[12] = z[7] * z[12];
z[15] = -z[0] * z[18];
z[15] = 2 + z[15];
z[15] = z[3] * z[15];
z[15] = (T(-3) / T(2)) * z[5] + z[15];
z[15] = z[4] * z[15];
z[12] = 3 * z[12] + z[15];
z[12] = z[4] * z[12];
z[8] = z[8] + z[12];
z[8] = z[4] * z[8];
z[11] = z[9] + -z[11];
z[11] = z[5] * z[11];
z[11] = 3 + z[11];
z[11] = z[5] * z[11];
z[11] = -z[3] + z[11];
z[11] = prod_pow(z[7], 3) * z[11];
z[8] = z[8] + (T(1) / T(2)) * z[11];
z[8] = z[1] * z[8];
z[9] = 2 * z[6] + -z[9];
z[9] = z[5] * z[9];
z[9] = -1 + z[9];
z[9] = z[5] * z[9] * z[14];
z[8] = z[8] + z[9] + z[10];
z[8] = z[1] * z[8];
z[9] = (T(1) / T(2)) * z[7];
z[9] = z[9] * z[16];
z[8] = z[8] + z[9] + z[13];
return z[1] * z[2] * z[8];
}



template double eval_coef_2q3y_2l_pmmpp_12345_85(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_85(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
