#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_87(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[38];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[8];
z[3] = iW[15];
z[4] = iW[21];
z[5] = iW[22];
z[6] = v[2];
z[7] = v[3];
z[8] = v[4];
z[9] = iW[3];
z[10] = v[1];
z[11] = v[0];
z[12] = prod_pow(z[8], 2);
z[13] = (T(1) / T(4)) * z[6];
z[14] = -z[8] + z[13];
z[14] = z[6] * z[14];
z[14] = (T(3) / T(4)) * z[12] + z[14];
z[14] = z[1] * z[14];
z[15] = -z[6] + (T(-7) / T(2)) * z[8];
z[14] = z[14] + (T(1) / T(2)) * z[15];
z[14] = z[1] * z[14];
z[15] = (T(1) / T(2)) * z[1];
z[16] = z[11] * z[15];
z[17] = (T(1) / T(2)) * z[6];
z[18] = -z[8] + z[17];
z[19] = z[1] * z[18];
z[19] = T(3) / T(2) + z[19];
z[19] = z[16] * z[19];
z[14] = T(5) / T(2) + z[14] + z[19];
z[14] = z[11] * z[14];
z[19] = (T(5) / T(2)) * z[8];
z[20] = 2 * z[6];
z[21] = -z[19] + z[20];
z[21] = z[6] * z[21];
z[22] = (T(1) / T(2)) * z[10];
z[23] = (T(3) / T(2)) * z[6];
z[24] = z[8] + -z[23];
z[24] = z[22] * z[24];
z[25] = (T(1) / T(2)) * z[12];
z[21] = z[21] + z[24] + z[25];
z[21] = z[0] * z[21];
z[24] = z[6] + -z[8];
z[26] = -z[15] * z[24];
z[26] = -1 + z[26];
z[26] = z[11] * z[26];
z[26] = z[24] + z[26];
z[26] = z[1] * z[26];
z[26] = -1 + z[26];
z[18] = z[6] * z[18];
z[18] = z[18] + z[25];
z[27] = -z[1] * z[18];
z[24] = (T(1) / T(4)) * z[24] + z[27];
z[24] = z[0] * z[24];
z[24] = z[24] + (T(1) / T(2)) * z[26];
z[24] = z[7] * z[24];
z[26] = (T(5) / T(2)) * z[1];
z[26] = z[18] * z[26];
z[27] = (T(1) / T(4)) * z[8];
z[28] = 3 * z[6];
z[14] = (T(5) / T(4)) * z[10] + z[14] + z[21] + z[24] + z[26] + -z[27] + -z[28];
z[14] = z[7] * z[14];
z[21] = 3 * z[8];
z[24] = -z[6] + z[21];
z[24] = z[6] * z[24];
z[29] = 3 * z[12];
z[24] = z[24] + -z[29];
z[24] = z[6] * z[24];
z[30] = prod_pow(z[8], 3);
z[24] = z[24] + z[30];
z[31] = 2 * z[8];
z[32] = z[17] + -z[31];
z[32] = z[6] * z[32];
z[32] = z[29] + z[32];
z[32] = z[6] * z[32];
z[32] = -2 * z[30] + z[32];
z[32] = z[6] * z[32];
z[33] = prod_pow(z[8], 4);
z[33] = (T(1) / T(2)) * z[33];
z[32] = z[32] + z[33];
z[32] = z[1] * z[32];
z[34] = -z[28] + z[31];
z[34] = z[6] * z[34];
z[35] = -z[8] + z[28];
z[35] = z[10] * z[35];
z[34] = z[34] + (T(1) / T(4)) * z[35];
z[34] = z[10] * z[34];
z[32] = (T(-1) / T(4)) * z[24] + z[32] + z[34];
z[32] = z[0] * z[32];
z[21] = -z[17] + z[21];
z[21] = z[6] * z[21];
z[21] = (T(-7) / T(2)) * z[12] + z[21];
z[21] = z[1] * z[21];
z[21] = 9 * z[8] + z[21];
z[21] = z[1] * z[21];
z[34] = z[1] * z[8];
z[34] = -1 + z[34];
z[16] = z[16] * z[34];
z[16] = T(-11) / T(2) + z[16] + z[21];
z[16] = z[11] * z[16];
z[21] = 5 * z[12];
z[34] = z[6] * z[8];
z[34] = -z[21] + z[34];
z[34] = z[1] * z[34];
z[16] = (T(19) / T(2)) * z[6] + 13 * z[8] + z[16] + z[34];
z[16] = -4 * z[10] + (T(1) / T(2)) * z[16];
z[16] = z[11] * z[16];
z[34] = z[1] * z[24];
z[35] = (T(-5) / T(4)) * z[6] + z[8];
z[35] = z[28] * z[35];
z[36] = (T(1) / T(2)) * z[8];
z[37] = z[20] + z[36];
z[37] = -z[10] + 3 * z[37];
z[37] = z[10] * z[37];
z[14] = (T(-7) / T(4)) * z[12] + z[14] + z[16] + z[32] + (T(5) / T(4)) * z[34] + z[35] + z[37];
z[14] = z[7] * z[14];
z[16] = z[8] * z[17];
z[32] = -z[12] + z[16];
z[32] = z[6] * z[32];
z[35] = (T(1) / T(2)) * z[30];
z[32] = z[32] + z[35];
z[32] = z[1] * z[32];
z[37] = -z[6] + -z[27];
z[37] = z[6] * z[37];
z[21] = z[21] + -z[32] + z[37];
z[21] = z[1] * z[21];
z[37] = -z[8] * z[13];
z[37] = z[12] + z[37];
z[37] = z[1] * z[37];
z[37] = z[13] + -z[31] + z[37];
z[37] = z[1] * z[37];
z[37] = 1 + z[37];
z[37] = z[11] * z[37];
z[21] = -z[6] + (T(-33) / T(4)) * z[8] + (T(15) / T(4)) * z[10] + z[21] + z[37];
z[21] = z[11] * z[21];
z[19] = -z[6] + z[19];
z[19] = (T(5) / T(2)) * z[19] + z[26];
z[19] = z[6] * z[19];
z[26] = -8 * z[6] + (T(-11) / T(2)) * z[8] + (T(5) / T(2)) * z[10];
z[26] = z[10] * z[26];
z[19] = z[19] + z[21] + z[26] + z[29];
z[19] = z[11] * z[19];
z[21] = -z[28] + -z[36];
z[21] = 3 * z[21] + z[22];
z[21] = z[21] * z[22];
z[26] = 5 * z[6] + -z[27];
z[26] = z[6] * z[26];
z[21] = z[21] + z[25] + z[26];
z[21] = z[10] * z[21];
z[26] = -z[18] * z[23];
z[20] = z[20] + -z[36];
z[20] = z[6] * z[20];
z[13] = -z[10] * z[13];
z[13] = z[13] + z[20];
z[13] = z[10] * z[13];
z[13] = z[13] + z[26];
z[13] = z[10] * z[13];
z[20] = z[23] * z[24];
z[13] = z[13] + z[20];
z[13] = z[0] * z[13];
z[20] = z[6] + -z[31];
z[20] = z[6] * z[20];
z[20] = z[12] + z[20];
z[20] = z[6] * z[20];
z[23] = z[17] * z[34];
z[13] = z[13] + z[14] + z[19] + 4 * z[20] + z[21] + z[23];
z[13] = z[7] * z[13];
z[14] = z[8] * z[9];
z[19] = 3 * z[14];
z[20] = T(-5) / T(2) + -z[19];
z[20] = z[12] * z[20];
z[21] = 9 * z[14];
z[23] = 5 + z[21];
z[23] = z[16] * z[23];
z[24] = -z[6] * z[12];
z[24] = z[24] + z[30];
z[26] = T(1) / T(2) + z[14];
z[24] = z[1] * z[24] * z[26];
z[20] = z[20] + z[23] + z[24];
z[15] = z[15] * z[20];
z[20] = 3 * z[9];
z[20] = -z[12] * z[20];
z[23] = z[1] * z[9] * z[30];
z[20] = z[20] + z[23];
z[20] = z[1] * z[20];
z[23] = -z[9] * z[10];
z[20] = z[19] + z[20] + z[23];
z[20] = z[11] * z[20];
z[23] = T(7) / T(2) + z[19];
z[24] = z[23] * z[36];
z[27] = T(3) / T(2) + z[14];
z[29] = z[6] * z[9];
z[31] = -z[27] + (T(5) / T(2)) * z[29];
z[31] = z[22] * z[31];
z[34] = -1 + -z[19];
z[34] = z[6] * z[34];
z[15] = z[15] + (T(1) / T(4)) * z[20] + z[24] + z[31] + z[34];
z[15] = z[11] * z[15];
z[20] = T(-1) / T(2) + z[14];
z[20] = z[12] * z[20];
z[16] = -z[16] * z[23];
z[16] = z[16] + z[20];
z[16] = z[6] * z[16];
z[20] = T(9) / T(2) + z[14];
z[20] = z[20] * z[35];
z[23] = -z[12] * z[17];
z[23] = z[23] + z[30];
z[23] = z[6] * z[23];
z[23] = z[23] + -z[33];
z[23] = z[1] * z[23];
z[16] = z[16] + z[20] + z[23];
z[16] = z[1] * z[16];
z[20] = 5 * z[14];
z[23] = -7 + -z[20];
z[24] = z[9] * z[22];
z[23] = (T(1) / T(2)) * z[23] + z[24] + z[29];
z[23] = z[10] * z[23];
z[24] = 19 + z[21];
z[24] = z[8] * z[24];
z[31] = 1 + -9 * z[29];
z[31] = z[6] * z[31];
z[24] = z[24] + z[31];
z[23] = z[23] + (T(1) / T(2)) * z[24];
z[23] = z[22] * z[23];
z[24] = -19 + -7 * z[14];
z[24] = z[12] * z[24];
z[26] = -z[26] * z[36];
z[31] = 1 + (T(5) / T(4)) * z[14];
z[31] = z[6] * z[31];
z[26] = z[26] + z[31];
z[26] = z[26] * z[28];
z[15] = z[15] + z[16] + z[23] + (T(1) / T(4)) * z[24] + z[26];
z[15] = z[11] * z[15];
z[16] = 7 + z[19];
z[16] = z[16] * z[25];
z[23] = -1 + (T(-1) / T(2)) * z[14];
z[23] = z[23] * z[28];
z[23] = z[23] + -z[36];
z[23] = z[6] * z[23];
z[16] = z[16] + z[23] + z[32];
z[16] = z[6] * z[16];
z[23] = (T(3) / T(2)) * z[8];
z[20] = -11 + -z[20];
z[20] = z[20] * z[23];
z[24] = T(13) / T(2) + z[19] + (T(7) / T(2)) * z[29];
z[24] = z[6] * z[24];
z[20] = z[20] + z[24];
z[20] = z[6] * z[20];
z[20] = -z[12] + z[20];
z[24] = (T(3) / T(2)) * z[29];
z[25] = T(17) / T(4) + z[19] + -z[24];
z[25] = z[6] * z[25];
z[24] = -1 + -z[24];
z[24] = z[22] * z[24];
z[24] = z[8] + z[24] + z[25];
z[24] = z[10] * z[24];
z[20] = (T(1) / T(2)) * z[20] + z[24];
z[20] = z[10] * z[20];
z[15] = z[15] + z[16] + z[20];
z[15] = z[11] * z[15];
z[16] = 13 + z[19];
z[16] = z[16] * z[36];
z[19] = z[9] * z[17];
z[14] = T(-17) / T(4) + -z[14] + -z[19];
z[14] = z[6] * z[14];
z[14] = z[14] + z[16];
z[14] = z[6] * z[14];
z[14] = (T(-9) / T(4)) * z[12] + z[14];
z[14] = z[6] * z[14];
z[16] = z[27] + -z[29];
z[16] = z[6] * z[16];
z[19] = -1 + -z[19];
z[19] = z[10] * z[19];
z[16] = z[16] + z[19] + -z[23];
z[16] = z[16] * z[22];
z[16] = z[16] + 3 * z[18];
z[16] = prod_pow(z[6], 2) * z[0] * z[16];
z[18] = -13 + -z[21];
z[18] = (T(1) / T(2)) * z[18] + 3 * z[29];
z[18] = z[6] * z[18];
z[18] = z[18] + -z[36];
z[17] = z[17] * z[18];
z[18] = 1 + (T(3) / T(4)) * z[29];
z[18] = z[6] * z[10] * z[18];
z[17] = z[17] + z[18];
z[17] = z[10] * z[17];
z[14] = z[14] + z[16] + z[17];
z[14] = z[10] * z[14];
z[16] = z[6] + -z[36];
z[16] = z[6] * z[16];
z[12] = -2 * z[12] + z[16];
z[12] = z[6] * z[12];
z[12] = z[12] + (T(3) / T(2)) * z[30];
z[12] = z[6] * z[12];
z[12] = z[12] + z[13] + z[14] + z[15];
return z[2] * z[3] * z[4] * z[5] * z[12];
}



template double eval_coef_2q3y_2l_pmmpp_12345_87(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_87(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
