#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_89(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[26];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[18];
z[3] = v[2];
z[4] = v[3];
z[5] = v[4];
z[6] = iW[3];
z[7] = iW[16];
z[8] = v[1];
z[9] = iW[17];
z[10] = iW[15];
z[11] = v[0];
z[12] = z[5] * z[7];
z[13] = z[3] * z[7];
z[14] = z[12] + -z[13];
z[15] = z[2] * z[5];
z[16] = z[2] * z[4];
z[15] = z[15] + -z[16];
z[17] = -1 + z[13];
z[12] = -z[12] + z[17];
z[12] = z[3] * z[12];
z[12] = z[5] + (T(295) / T(18)) * z[8] + 3 * z[12];
z[12] = z[6] * z[12];
z[12] = T(-295) / T(18) + z[12] + -3 * z[14] + -z[15];
z[12] = z[3] * z[12];
z[14] = -z[4] * z[15];
z[15] = -1 + z[16];
z[18] = z[4] * z[15];
z[18] = z[5] + z[18];
z[19] = z[4] * z[18];
z[20] = prod_pow(z[5], 2);
z[19] = z[19] + -z[20];
z[18] = -z[3] * z[18];
z[18] = z[18] + -z[19];
z[18] = z[1] * z[18];
z[12] = (T(295) / T(18)) * z[5] + z[12] + z[14] + z[18];
z[12] = z[0] * z[12];
z[14] = z[4] + z[5];
z[18] = z[9] * z[14];
z[12] = T(295) / T(9) + z[12] + z[16] + -z[18];
z[18] = z[4] * z[5];
z[21] = (T(1) / T(2)) * z[18];
z[22] = z[20] + z[21];
z[23] = z[3] * z[9];
z[22] = z[22] * z[23];
z[24] = (T(1) / T(2)) * z[6];
z[25] = -1 + z[23];
z[25] = prod_pow(z[5], 3) * z[24] * z[25];
z[19] = (T(1) / T(2)) * z[19] + z[22] + z[25];
z[19] = z[1] * z[19];
z[18] = z[18] + z[20];
z[22] = (T(-1) / T(2)) * z[4] + -z[5];
z[22] = z[3] * z[22];
z[18] = (T(1) / T(2)) * z[18] + z[22];
z[18] = z[9] * z[18];
z[22] = T(3) / T(2) + (T(-1) / T(2)) * z[23];
z[20] = z[20] * z[22];
z[17] = z[3] * z[17];
z[22] = z[5] + -z[17];
z[22] = z[11] * z[22];
z[20] = z[20] + z[22];
z[20] = z[6] * z[20];
z[16] = T(1) / T(2) + -z[16];
z[16] = z[4] * z[16];
z[16] = -z[5] + z[16] + z[18] + z[19] + z[20];
z[18] = (T(1) / T(2)) * z[1];
z[16] = z[16] * z[18];
z[15] = z[3] * z[15];
z[14] = z[8] + -z[14] + -z[15];
z[18] = -prod_pow(z[4], 2) * z[18];
z[18] = z[4] + z[18];
z[15] = z[15] * z[18];
z[15] = z[15] + z[21];
z[15] = z[1] * z[15];
z[14] = (T(1) / T(2)) * z[14] + z[15];
z[14] = z[10] * z[14];
z[15] = 259 * z[5] + -295 * z[8];
z[15] = -z[11] + (T(1) / T(36)) * z[15] + (T(-5) / T(2)) * z[17];
z[15] = z[15] * z[24];
return (T(1) / T(4)) * z[12] + -z[13] + (T(1) / T(2)) * z[14] + z[15] + z[16];
}



template double eval_coef_2q3y_2l_pmmpp_12345_89(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_89(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
