#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_92(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[22];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[19];
z[3] = v[1];
z[4] = v[4];
z[5] = v[2];
z[6] = v[3];
z[7] = iW[1];
z[8] = iW[2];
z[9] = iW[5];
z[10] = v[0];
z[11] = iW[15];
z[12] = z[6] * z[9];
z[13] = prod_pow(z[7], 2);
z[14] = z[12] * z[13];
z[15] = -z[7] + (T(-5) / T(2)) * z[8];
z[16] = z[9] * z[10];
z[15] = z[15] * z[16];
z[15] = z[8] + (T(-1) / T(2)) * z[9] + z[15];
z[15] = z[7] * z[15];
z[15] = z[14] + z[15];
z[17] = -z[8] + z[9];
z[18] = z[8] * z[16];
z[19] = (T(1) / T(2)) * z[17] + z[18];
z[13] = (T(1) / T(2)) * z[13];
z[19] = z[4] * z[13] * z[19];
z[20] = z[2] * z[7];
z[15] = (T(1) / T(2)) * z[15] + z[19] + -z[20];
z[15] = z[4] * z[15];
z[13] = -prod_pow(z[10], 2) * z[8] * z[9] * z[13];
z[13] = z[13] + -z[20];
z[13] = z[4] * z[13];
z[19] = -z[9] + z[18];
z[19] = z[10] * z[19];
z[19] = 1 + (T(3) / T(2)) * z[19];
z[19] = z[7] * z[19];
z[20] = z[5] * z[7];
z[21] = T(5) / T(2) + z[20];
z[21] = z[2] * z[21];
z[13] = z[13] + z[19] + z[21];
z[13] = z[4] * z[13];
z[19] = z[9] + (T(-1) / T(2)) * z[18];
z[19] = z[10] * z[19];
z[13] = T(169) / T(36) + z[13] + 3 * z[19];
z[13] = z[1] * z[13];
z[19] = -z[7] + -z[9];
z[19] = z[7] * z[19];
z[14] = z[14] + z[19];
z[14] = z[6] * z[14];
z[14] = z[14] + z[17];
z[17] = (T(1) / T(4)) * z[7] + z[8];
z[17] = z[16] * z[17];
z[19] = z[6] * z[7];
z[19] = T(3) / T(2) + (T(-1) / T(2)) * z[19] + z[20];
z[19] = z[2] * z[19];
z[13] = (T(1) / T(2)) * z[13] + (T(1) / T(4)) * z[14] + z[15] + z[17] + z[19];
z[13] = z[4] * z[13];
z[14] = (T(241) / T(18)) * z[5];
z[15] = z[2] * z[4];
z[15] = -1 + z[15];
z[15] = 3 * z[15];
z[17] = z[4] * z[15];
z[17] = z[14] + z[17];
z[17] = z[0] * z[17];
z[19] = -3 * z[9] + z[18];
z[19] = z[10] * z[19];
z[17] = T(-205) / T(18) + z[17] + z[19];
z[17] = z[1] * z[17];
z[15] = z[0] * z[15];
z[15] = -z[9] + z[11] + z[15] + z[17] + -z[18];
z[15] = z[3] * z[15];
z[17] = -1 + -z[20];
z[17] = z[6] * z[17];
z[17] = -z[4] + z[5] + z[17];
z[17] = z[11] * z[17];
z[14] = (T(295) / T(18)) * z[4] + 3 * z[6] + -z[14];
z[14] = z[0] * z[14];
z[14] = z[14] + z[15] + z[17];
z[12] = -3 + z[12] + z[16];
z[15] = T(1) / T(2) + z[20];
z[15] = z[2] * z[6] * z[15];
z[12] = (T(1) / T(2)) * z[12] + z[15];
return (T(1) / T(2)) * z[12] + z[13] + (T(1) / T(4)) * z[14];
}



template double eval_coef_2q3y_2l_pmmpp_12345_92(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_92(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
