#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_99(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[43];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[12];
z[3] = iW[17];
z[4] = iW[19];
z[5] = v[0];
z[6] = v[4];
z[7] = v[2];
z[8] = v[3];
z[9] = prod_pow(z[1], 3);
z[10] = z[4] * z[6];
z[11] = z[9] * z[10];
z[12] = 5 * z[11];
z[13] = prod_pow(z[1], 2);
z[14] = z[4] * z[13];
z[15] = -z[12] + (T(11) / T(2)) * z[14];
z[15] = z[6] * z[15];
z[16] = z[1] * z[4];
z[17] = 2 * z[16];
z[15] = z[15] + z[17];
z[18] = 2 * z[11];
z[19] = z[14] + z[18];
z[20] = 5 * z[7];
z[21] = z[19] * z[20];
z[22] = -z[15] + -z[21];
z[23] = 7 * z[14];
z[24] = -z[12] + z[23];
z[25] = (T(1) / T(6)) * z[6];
z[24] = z[24] * z[25];
z[17] = z[17] + z[24];
z[17] = z[6] * z[17];
z[24] = (T(4) / T(3)) * z[11] + z[14];
z[24] = z[6] * z[24];
z[24] = (T(-1) / T(3)) * z[16] + z[24];
z[24] = z[7] * z[24];
z[17] = z[17] + z[24];
z[17] = z[0] * z[17];
z[17] = z[17] + (T(1) / T(3)) * z[22];
z[17] = z[0] * z[17];
z[22] = 2 * z[4];
z[24] = z[13] * z[22];
z[26] = (T(5) / T(2)) * z[11];
z[24] = z[24] + -z[26];
z[27] = (T(1) / T(3)) * z[24];
z[28] = -z[11] + -z[14];
z[28] = z[0] * z[6] * z[28];
z[28] = z[19] + z[28];
z[28] = z[0] * z[28];
z[29] = z[4] * z[9];
z[28] = z[28] + -z[29];
z[28] = z[5] * z[28];
z[9] = z[7] * z[9];
z[22] = z[9] * z[22];
z[17] = z[17] + z[22] + z[27] + (T(1) / T(3)) * z[28];
z[17] = z[5] * z[17];
z[28] = 10 * z[11] + -11 * z[14];
z[28] = z[6] * z[28];
z[29] = 4 * z[16];
z[28] = z[28] + -z[29];
z[30] = z[21] + -z[28];
z[31] = 2 * z[7];
z[30] = z[30] * z[31];
z[32] = z[10] * z[13];
z[29] = -z[29] + 7 * z[32];
z[33] = 2 * z[6];
z[29] = z[29] * z[33];
z[33] = (T(7) / T(4)) * z[4];
z[29] = z[29] + -z[33];
z[30] = -z[29] + z[30];
z[34] = (T(-14) / T(3)) * z[14] + z[26];
z[34] = z[6] * z[34];
z[34] = (T(-11) / T(2)) * z[16] + z[34];
z[34] = z[6] * z[34];
z[35] = -z[11] + (T(-1) / T(3)) * z[14];
z[35] = z[6] * z[35];
z[35] = (T(2) / T(3)) * z[16] + z[35];
z[35] = z[31] * z[35];
z[36] = (T(5) / T(3)) * z[4];
z[34] = z[34] + z[35] + z[36];
z[34] = z[7] * z[34];
z[35] = (T(-1) / T(4)) * z[16] + z[32];
z[35] = z[6] * z[35];
z[35] = (T(-5) / T(4)) * z[4] + z[35];
z[35] = z[6] * z[35];
z[34] = z[34] + 3 * z[35];
z[34] = z[0] * z[34];
z[30] = (T(1) / T(3)) * z[30] + z[34];
z[30] = z[0] * z[30];
z[34] = z[4] * z[9];
z[27] = -z[27] + -z[34];
z[27] = z[20] * z[27];
z[35] = (T(3) / T(4)) * z[16] + (T(5) / T(3)) * z[32];
z[17] = z[17] + z[27] + z[30] + z[35];
z[17] = z[5] * z[17];
z[19] = z[7] * z[19];
z[27] = (T(-10) / T(3)) * z[19] + z[28];
z[27] = z[7] * z[27];
z[27] = z[27] + z[29];
z[27] = z[7] * z[27];
z[23] = z[23] + -z[26];
z[23] = z[6] * z[23];
z[30] = (T(9) / T(2)) * z[16];
z[23] = z[23] + z[30];
z[23] = z[6] * z[23];
z[18] = -z[14] + z[18];
z[37] = (T(1) / T(3)) * z[6];
z[18] = z[18] * z[37];
z[18] = -z[16] + z[18];
z[18] = z[18] * z[31];
z[31] = 5 * z[4];
z[18] = z[18] + z[23] + -z[31];
z[18] = z[7] * z[18];
z[23] = 9 * z[16] + (T(-41) / T(3)) * z[32];
z[23] = z[6] * z[23];
z[23] = (T(37) / T(2)) * z[4] + z[23];
z[23] = z[6] * z[23];
z[38] = z[4] * z[8];
z[39] = (T(25) / T(6)) * z[38];
z[23] = z[23] + -z[39];
z[18] = z[18] + (T(1) / T(2)) * z[23];
z[18] = z[7] * z[18];
z[23] = z[1] * z[10];
z[40] = (T(-2) / T(3)) * z[4] + (T(-15) / T(4)) * z[23];
z[40] = z[6] * z[40];
z[40] = (T(37) / T(12)) * z[38] + z[40];
z[40] = z[6] * z[40];
z[18] = z[18] + z[40];
z[18] = z[0] * z[18];
z[40] = (T(13) / T(3)) * z[23];
z[41] = (T(7) / T(2)) * z[4] + -z[40];
z[41] = z[6] * z[41];
z[41] = z[38] + z[41];
z[18] = z[18] + z[27] + -z[41];
z[18] = z[0] * z[18];
z[27] = 4 * z[4];
z[13] = z[13] * z[27];
z[12] = -z[12] + z[13];
z[9] = z[9] * z[27];
z[9] = z[9] + z[12];
z[9] = z[7] * z[9];
z[13] = 3 * z[16];
z[27] = z[13] + (T(20) / T(3)) * z[32];
z[9] = (T(5) / T(3)) * z[9] + -z[27];
z[9] = z[7] * z[9];
z[42] = (T(13) / T(3)) * z[4] + (T(-3) / T(2)) * z[23];
z[42] = (T(1) / T(2)) * z[42];
z[9] = z[9] + z[17] + z[18] + -z[42];
z[9] = z[5] * z[9];
z[17] = z[21] + -2 * z[28];
z[18] = (T(1) / T(3)) * z[7];
z[17] = z[17] * z[18];
z[17] = z[17] + -z[29];
z[17] = z[7] * z[17];
z[21] = 2 * z[38];
z[28] = 7 * z[4] + (T(-26) / T(3)) * z[23];
z[28] = z[6] * z[28];
z[17] = z[17] + z[21] + z[28];
z[17] = z[7] * z[17];
z[26] = -14 * z[14] + z[26];
z[26] = z[26] * z[37];
z[26] = (T(-1) / T(2)) * z[16] + z[26];
z[26] = z[6] * z[26];
z[11] = (T(-1) / T(3)) * z[11] + z[14];
z[11] = z[6] * z[11];
z[11] = z[11] + (T(4) / T(3)) * z[16];
z[11] = z[7] * z[11];
z[11] = z[11] + z[26] + z[31];
z[11] = z[7] * z[11];
z[14] = (T(-27) / T(4)) * z[16] + (T(14) / T(3)) * z[32];
z[14] = z[6] * z[14];
z[14] = (T(-29) / T(4)) * z[4] + z[14];
z[14] = z[6] * z[14];
z[11] = z[11] + z[14] + z[39];
z[11] = z[7] * z[11];
z[14] = (T(71) / T(2)) * z[23] + -z[31];
z[14] = z[14] * z[37];
z[14] = z[14] + (T(-23) / T(2)) * z[38];
z[26] = (T(1) / T(2)) * z[6];
z[14] = z[14] * z[26];
z[28] = prod_pow(z[8], 2) * z[4];
z[11] = z[11] + z[14] + z[28];
z[11] = z[7] * z[11];
z[14] = 25 * z[10] + 13 * z[38];
z[14] = z[6] * z[14];
z[14] = (T(1) / T(12)) * z[14] + -z[28];
z[14] = z[6] * z[14];
z[11] = z[11] + z[14];
z[11] = z[0] * z[11];
z[14] = (T(25) / T(12)) * z[10] + -z[21];
z[14] = z[6] * z[14];
z[14] = z[14] + -z[28];
z[11] = z[11] + -z[14] + z[17];
z[11] = z[0] * z[11];
z[12] = (T(-1) / T(3)) * z[12] + -z[34];
z[12] = z[12] * z[20];
z[12] = z[12] + z[30] + 10 * z[32];
z[12] = z[7] * z[12];
z[17] = 13 * z[4] + (T(-9) / T(2)) * z[23];
z[17] = (T(1) / T(2)) * z[17];
z[12] = z[12] + z[17];
z[12] = z[7] * z[12];
z[20] = 19 * z[10];
z[21] = -z[20] + (T(13) / T(2)) * z[38];
z[23] = (T(1) / T(6)) * z[21];
z[9] = z[9] + z[11] + z[12] + z[23];
z[9] = z[5] * z[9];
z[11] = -z[15] + -z[19];
z[11] = z[7] * z[11];
z[11] = z[11] + z[29];
z[11] = z[11] * z[18];
z[11] = z[11] + -z[41];
z[11] = z[7] * z[11];
z[11] = z[11] + z[14];
z[11] = z[7] * z[11];
z[12] = -z[16] + (T(7) / T(3)) * z[32];
z[12] = z[12] * z[26];
z[14] = -z[16] + -z[32];
z[14] = z[14] * z[18];
z[12] = z[12] + z[14] + -z[36];
z[12] = z[7] * z[12];
z[13] = z[13] + (T(-5) / T(6)) * z[32];
z[13] = z[6] * z[13];
z[13] = z[13] + z[33];
z[13] = z[6] * z[13];
z[12] = z[12] + z[13] + (T(-25) / T(12)) * z[38];
z[12] = z[7] * z[12];
z[13] = 3 * z[4] + -z[40];
z[13] = z[13] * z[26];
z[13] = z[13] + (T(8) / T(3)) * z[38];
z[13] = z[6] * z[13];
z[12] = z[12] + z[13] + -z[28];
z[12] = z[7] * z[12];
z[13] = -z[20] + -z[38];
z[13] = z[13] * z[25];
z[13] = z[13] + 3 * z[28];
z[13] = z[13] * z[26];
z[12] = z[12] + z[13];
z[12] = z[7] * z[12];
z[10] = z[8] * z[10];
z[13] = -z[10] + -z[28];
z[13] = prod_pow(z[6], 2) * z[13];
z[12] = z[12] + (T(1) / T(2)) * z[13];
z[12] = z[0] * z[12];
z[13] = z[10] + (T(1) / T(2)) * z[28];
z[13] = z[6] * z[13];
z[11] = z[11] + z[12] + z[13];
z[11] = z[0] * z[11];
z[12] = z[22] + (T(5) / T(3)) * z[24];
z[12] = z[7] * z[12];
z[12] = z[12] + -z[27];
z[12] = z[7] * z[12];
z[12] = z[12] + -z[17];
z[12] = z[7] * z[12];
z[12] = z[12] + (T(-1) / T(3)) * z[21];
z[12] = z[7] * z[12];
z[10] = (T(19) / T(12)) * z[10];
z[9] = z[9] + z[10] + z[11] + z[12];
z[9] = z[5] * z[9];
z[11] = -z[24] + -z[34];
z[11] = z[11] * z[18];
z[11] = z[11] + z[35];
z[11] = z[7] * z[11];
z[11] = z[11] + z[42];
z[11] = z[7] * z[11];
z[11] = z[11] + z[23];
z[11] = z[7] * z[11];
z[10] = -z[10] + z[11];
z[10] = z[7] * z[10];
z[9] = z[9] + z[10];
return prod_pow(z[3], 2) * z[2] * z[5] * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_12345_99(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_99(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
