#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_40(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[17];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[12];
z[3] = v[1];
z[4] = v[2];
z[5] = v[4];
z[6] = iW[1];
z[7] = v[0];
z[8] = v[3];
z[9] = prod_pow(z[7], 2);
z[10] = 2 * z[7];
z[11] = -z[4] * z[10];
z[11] = -z[9] + z[11];
z[11] = z[1] * z[11];
z[12] = -z[1] * z[9];
z[12] = z[10] + z[12];
z[12] = z[1] * z[12];
z[12] = -1 + z[12];
z[12] = z[5] * z[12];
z[13] = -z[8] + z[10];
z[14] = 2 * z[4];
z[11] = z[11] + z[12] + z[13] + z[14];
z[11] = z[5] * z[11];
z[12] = -z[7] + z[8];
z[12] = -z[4] + 2 * z[12];
z[12] = z[4] * z[12];
z[11] = z[11] + z[12];
z[11] = z[5] * z[11];
z[12] = prod_pow(z[4], 2);
z[15] = -z[8] * z[12];
z[11] = z[11] + z[15];
z[11] = z[6] * z[11];
z[15] = z[4] + -z[7];
z[16] = -z[8] + z[15];
z[16] = z[4] * z[16];
z[11] = z[11] + z[16];
z[16] = z[4] * z[7];
z[16] = -z[9] + z[16];
z[16] = z[1] * z[16];
z[13] = z[13] + z[16];
z[16] = -z[10] + -z[16];
z[16] = z[1] * z[16];
z[16] = 1 + z[16];
z[16] = z[5] * z[16];
z[13] = -z[4] + (T(-1) / T(3)) * z[13] + (T(2) / T(3)) * z[16];
z[13] = z[5] * z[13];
z[11] = (T(1) / T(3)) * z[11] + z[13];
z[11] = z[6] * z[11];
z[13] = z[4] * z[5];
z[13] = -z[12] + z[13];
z[13] = z[0] * z[13];
z[12] = z[0] * z[12];
z[12] = z[7] + z[12] + -z[14];
z[12] = z[1] * z[3] * z[12];
z[12] = z[12] + z[13];
z[10] = -z[4] + z[10];
z[10] = z[4] * z[10];
z[9] = -z[9] + z[10];
z[9] = z[1] * z[9];
z[9] = z[9] + (T(-1) / T(3)) * z[15];
z[9] = z[1] * z[9];
z[9] = T(-11) / T(3) + z[9];
z[9] = z[5] * z[9];
z[9] = (T(-13) / T(9)) * z[7] + (T(1) / T(3)) * z[9] + z[11] + (T(5) / T(9)) * z[12] + z[14];
return z[2] * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_40(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_40(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
