#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_43(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[31];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[7];
z[3] = iW[15];
z[4] = iW[18];
z[5] = v[2];
z[6] = v[3];
z[7] = v[4];
z[8] = iW[3];
z[9] = v[1];
z[10] = v[0];
z[11] = z[1] * z[6];
z[12] = -1 + (T(1) / T(2)) * z[11];
z[13] = z[0] * z[6];
z[14] = (T(1) / T(2)) * z[13];
z[15] = z[12] + z[14];
z[15] = z[1] * z[15];
z[16] = z[8] * z[9];
z[17] = (T(1) / T(2)) * z[16];
z[18] = 1 + -z[17];
z[18] = z[0] * z[18];
z[19] = (T(1) / T(2)) * z[8];
z[18] = -z[15] + z[18] + -z[19];
z[18] = z[5] * z[18];
z[20] = prod_pow(z[6], 2);
z[21] = z[1] * z[20];
z[22] = z[0] * z[21];
z[23] = -1 + -z[13];
z[24] = 2 * z[8];
z[25] = z[0] + z[24];
z[25] = z[9] * z[25];
z[18] = z[18] + z[22] + 2 * z[23] + z[25];
z[18] = z[5] * z[18];
z[23] = -2 + z[11];
z[25] = z[13] + z[23];
z[25] = z[1] * z[25];
z[25] = -z[0] + -z[8] + z[25];
z[25] = z[5] * z[25];
z[15] = -z[7] * z[15];
z[14] = -1 + z[14] + z[15] + (T(-1) / T(2)) * z[22] + z[25];
z[14] = z[7] * z[14];
z[15] = 8 * z[1];
z[22] = prod_pow(z[6], 3);
z[25] = z[15] * z[22];
z[26] = (T(23) / T(2)) * z[20] + -z[25];
z[27] = (T(1) / T(3)) * z[1];
z[26] = z[26] * z[27];
z[14] = (T(-1) / T(6)) * z[6] + -z[9] + z[14] + z[18] + z[26];
z[14] = z[7] * z[14];
z[18] = z[1] * z[22];
z[26] = (T(2) / T(3)) * z[6] + z[9];
z[26] = z[9] * z[26];
z[14] = z[14] + (T(8) / T(3)) * z[18] + (T(-13) / T(3)) * z[20] + z[26];
z[25] = -17 * z[20] + z[25];
z[26] = (T(2) / T(3)) * z[1];
z[25] = z[25] * z[26];
z[28] = T(4) / T(3) + -z[16];
z[28] = z[9] * z[28];
z[25] = (T(17) / T(3)) * z[6] + z[25] + z[28];
z[28] = -z[20] * z[27];
z[29] = -1 + (T(1) / T(3)) * z[16];
z[29] = z[9] * z[29];
z[28] = z[28] + z[29];
z[28] = z[0] * z[28];
z[13] = z[13] + z[28];
z[13] = z[5] * z[13];
z[13] = (T(1) / T(2)) * z[13] + (T(1) / T(3)) * z[25];
z[13] = z[5] * z[13];
z[13] = z[13] + (T(1) / T(3)) * z[14];
z[13] = z[7] * z[13];
z[14] = 17 * z[6];
z[25] = z[14] + -16 * z[21];
z[25] = z[25] * z[26];
z[12] = -z[1] * z[12];
z[12] = z[12] + -z[19];
z[12] = z[5] * z[12];
z[12] = T(-5) / T(3) + z[12] + z[16] + z[25];
z[12] = z[5] * z[12];
z[25] = (T(1) / T(2)) * z[9];
z[26] = T(-35) / T(3) + z[16];
z[26] = z[25] * z[26];
z[12] = z[12] + z[14] + (T(-35) / T(3)) * z[21] + z[26];
z[14] = z[1] + z[8];
z[26] = z[5] * z[14];
z[28] = z[1] + -z[19];
z[28] = z[7] * z[28];
z[28] = -z[26] + z[28];
z[28] = z[27] * z[28];
z[29] = -1 + -z[11];
z[29] = z[27] * z[29];
z[29] = z[8] + z[29];
z[28] = z[28] + (T(1) / T(2)) * z[29];
z[28] = z[7] * z[28];
z[15] = z[15] * z[20];
z[29] = (T(-55) / T(6)) * z[6] + z[15];
z[29] = z[27] * z[29];
z[30] = -1 + (T(1) / T(3)) * z[11];
z[30] = z[1] * z[30];
z[30] = (T(1) / T(3)) * z[8] + z[30];
z[30] = z[5] * z[30];
z[28] = T(5) / T(9) + -z[17] + z[28] + z[29] + z[30];
z[28] = z[7] * z[28];
z[12] = (T(1) / T(3)) * z[12] + z[28];
z[12] = z[7] * z[12];
z[26] = T(23) / T(6) + -8 * z[11] + -z[26];
z[26] = z[1] * z[26];
z[28] = prod_pow(z[1], 2) * z[7];
z[29] = -z[19] * z[28];
z[14] = z[1] * z[14];
z[14] = z[14] + z[29];
z[14] = z[7] * z[14];
z[14] = z[14] + z[26];
z[14] = z[7] * z[14];
z[26] = -1 + (T(16) / T(3)) * z[11];
z[26] = z[1] * z[26];
z[24] = z[24] + z[26];
z[24] = z[5] * z[24];
z[11] = T(-32) / T(3) + (T(43) / T(3)) * z[11] + z[14] + -z[16] + z[24];
z[11] = z[7] * z[11];
z[14] = T(35) / T(3) + z[16];
z[14] = z[14] * z[25];
z[23] = -z[16] + -z[23];
z[23] = z[5] * z[23];
z[11] = (T(-19) / T(3)) * z[6] + z[11] + z[14] + z[23];
z[14] = (T(8) / T(9)) * z[1] + z[19];
z[14] = z[1] * z[14];
z[23] = z[8] * z[28];
z[14] = z[14] + (T(-1) / T(6)) * z[23];
z[14] = z[7] * z[14];
z[14] = (T(-16) / T(9)) * z[1] + z[14] + -z[19];
z[14] = z[7] * z[14];
z[19] = T(8) / T(3) + z[17];
z[14] = z[14] + (T(1) / T(3)) * z[19];
z[14] = z[10] * z[14];
z[11] = (T(1) / T(3)) * z[11] + z[14];
z[11] = z[10] * z[11];
z[14] = (T(-29) / T(2)) * z[6] + z[15];
z[14] = z[14] * z[27];
z[14] = T(5) / T(3) + z[14] + z[17];
z[14] = z[5] * z[14];
z[15] = T(17) / T(3) + -z[16];
z[15] = z[9] * z[15];
z[14] = (T(-25) / T(3)) * z[6] + z[14] + z[15] + (T(11) / T(3)) * z[21];
z[14] = z[5] * z[14];
z[15] = -2 * z[6] + z[9];
z[15] = z[9] * z[15];
z[15] = z[15] + z[20];
z[14] = z[14] + (T(11) / T(3)) * z[15];
z[11] = z[11] + z[12] + (T(1) / T(3)) * z[14];
z[11] = z[10] * z[11];
z[12] = -z[22] * z[27];
z[14] = -z[6] + (T(1) / T(3)) * z[9];
z[14] = z[9] * z[14];
z[12] = z[12] + z[14] + z[20];
z[14] = (T(-8) / T(9)) * z[18] + (T(5) / T(2)) * z[20];
z[14] = z[1] * z[14];
z[15] = T(7) / T(3) + z[16];
z[15] = z[9] * z[15];
z[15] = -13 * z[6] + z[15];
z[14] = z[14] + (T(1) / T(6)) * z[15];
z[14] = z[5] * z[14];
z[12] = (T(8) / T(3)) * z[12] + z[14];
z[12] = z[5] * z[12];
z[11] = z[11] + z[12] + z[13];
return z[2] * z[3] * z[4] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_43(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_43(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
