#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_44(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[41];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[15];
z[3] = v[2];
z[4] = v[3];
z[5] = v[4];
z[6] = iW[3];
z[7] = v[1];
z[8] = v[0];
z[9] = (T(1) / T(2)) * z[4];
z[10] = (T(1) / T(3)) * z[8];
z[11] = -z[9] + z[10];
z[11] = z[8] * z[11];
z[12] = (T(1) / T(2)) * z[8];
z[13] = z[6] * z[8];
z[14] = T(-1) / T(3) + z[13];
z[14] = z[12] * z[14];
z[15] = z[0] * z[4];
z[16] = (T(1) / T(2)) * z[15];
z[17] = -1 + z[16];
z[18] = z[4] * z[17];
z[14] = z[14] + z[18];
z[19] = (T(1) / T(2)) * z[5];
z[14] = z[14] * z[19];
z[20] = prod_pow(z[4], 2);
z[11] = z[11] + z[14] + (T(1) / T(12)) * z[20];
z[11] = z[1] * z[11];
z[14] = (T(1) / T(3)) * z[4];
z[21] = prod_pow(z[8], 2);
z[22] = z[6] * z[21];
z[22] = z[14] + z[22];
z[23] = prod_pow(z[6], 2);
z[24] = z[21] * z[23];
z[25] = (T(1) / T(3)) * z[15];
z[24] = T(1) / T(4) + (T(1) / T(3)) * z[24] + -z[25];
z[24] = z[5] * z[24];
z[11] = z[11] + (T(1) / T(4)) * z[22] + z[24];
z[11] = z[1] * z[11];
z[22] = (T(1) / T(2)) * z[0];
z[24] = z[6] * z[22];
z[24] = z[23] + z[24];
z[26] = (T(1) / T(3)) * z[5];
z[24] = z[24] * z[26];
z[27] = z[8] * z[23];
z[28] = -z[0] + z[27];
z[29] = (T(1) / T(2)) * z[6];
z[30] = -z[28] + z[29];
z[31] = (T(1) / T(3)) * z[7];
z[32] = z[0] * z[23] * z[31];
z[33] = z[0] * z[6];
z[32] = z[32] + -z[33];
z[34] = (T(1) / T(2)) * z[7];
z[32] = z[32] * z[34];
z[30] = z[24] + (T(1) / T(2)) * z[30] + z[32];
z[30] = z[7] * z[30];
z[32] = -z[13] + z[15];
z[35] = z[12] + z[18];
z[36] = -z[1] * z[35];
z[32] = (T(1) / T(2)) * z[32] + z[36];
z[32] = z[1] * z[32];
z[36] = z[10] * z[23];
z[36] = -z[6] + z[36];
z[32] = z[22] + (T(1) / T(3)) * z[32] + z[36];
z[37] = z[7] * z[22];
z[37] = 1 + z[37];
z[37] = z[23] * z[37];
z[37] = (T(-5) / T(4)) * z[33] + z[37];
z[37] = z[31] * z[37];
z[32] = (T(1) / T(2)) * z[32] + z[37];
z[32] = z[3] * z[32];
z[37] = z[8] * z[36];
z[38] = -z[0] + -z[6];
z[38] = 2 * z[27] + (T(1) / T(4)) * z[38];
z[38] = z[26] * z[38];
z[39] = T(-5) / T(2) + -z[15];
z[11] = z[11] + z[30] + z[32] + -z[37] + z[38] + (T(1) / T(6)) * z[39];
z[11] = z[3] * z[11];
z[30] = (T(1) / T(2)) * z[20];
z[32] = -2 + (T(1) / T(2)) * z[13];
z[32] = z[8] * z[32];
z[38] = 2 * z[4] + z[32];
z[38] = z[8] * z[38];
z[38] = -z[30] + z[38];
z[39] = T(1) / T(6) + z[37];
z[39] = z[8] * z[39];
z[18] = -z[18] + z[39];
z[18] = z[18] * z[19];
z[18] = z[18] + (T(1) / T(3)) * z[38];
z[18] = z[1] * z[18];
z[19] = 4 * z[6] + -z[27];
z[19] = z[10] * z[19];
z[19] = T(-7) / T(4) + z[19];
z[19] = z[8] * z[19];
z[38] = 2 * z[6] + -z[27];
z[38] = z[8] * z[38];
z[39] = -1 + z[15];
z[40] = -z[38] + (T(5) / T(4)) * z[39];
z[40] = z[26] * z[40];
z[18] = (T(1) / T(4)) * z[4] + z[18] + z[19] + z[40];
z[18] = z[5] * z[18];
z[19] = (T(5) / T(2)) * z[4];
z[32] = -z[19] + -z[32];
z[32] = z[8] * z[32];
z[32] = z[30] + z[32];
z[18] = z[18] + (T(1) / T(3)) * z[32];
z[18] = z[1] * z[18];
z[22] = (T(5) / T(3)) * z[6] + z[22] + -z[27];
z[32] = -z[23] + (T(-1) / T(4)) * z[33];
z[32] = z[31] * z[32];
z[22] = (T(1) / T(2)) * z[22] + z[24] + z[32];
z[22] = z[7] * z[22];
z[16] = -1 + (T(3) / T(2)) * z[13] + -z[16];
z[24] = z[26] * z[28];
z[16] = (T(1) / T(2)) * z[16] + z[22] + z[24];
z[16] = z[7] * z[16];
z[9] = z[9] * z[17];
z[17] = z[12] * z[23];
z[17] = -z[6] + z[17];
z[17] = z[8] * z[17];
z[17] = T(7) / T(4) + z[17];
z[17] = z[8] * z[17];
z[9] = z[9] + z[17];
z[17] = (T(1) / T(6)) * z[5];
z[22] = -z[6] + z[28];
z[22] = z[17] * z[22];
z[23] = T(-5) / T(2) + z[15];
z[22] = z[22] + (T(1) / T(6)) * z[23] + -z[37];
z[22] = z[5] * z[22];
z[9] = (T(1) / T(3)) * z[9] + z[11] + z[16] + z[18] + z[22];
z[11] = prod_pow(z[2], 2);
z[9] = z[3] * z[9] * z[11];
z[16] = z[12] * z[36];
z[16] = T(2) / T(3) + z[16];
z[16] = z[8] * z[16];
z[18] = -z[17] * z[39];
z[14] = -z[14] + z[16] + z[18];
z[14] = z[5] * z[14];
z[16] = -1 + (T(1) / T(3)) * z[13];
z[16] = z[8] * z[16];
z[16] = z[4] + z[16];
z[16] = z[8] * z[16];
z[16] = z[16] + (T(-1) / T(3)) * z[20];
z[14] = z[14] + (T(1) / T(2)) * z[16];
z[14] = z[5] * z[14];
z[16] = z[5] * z[35];
z[12] = -z[4] + z[12];
z[12] = z[8] * z[12];
z[12] = z[12] + z[16] + z[30];
z[12] = prod_pow(z[5], 2) * z[1] * z[12];
z[12] = (T(1) / T(6)) * z[12] + z[14];
z[12] = z[1] * z[12];
z[14] = -z[6] + z[27];
z[16] = z[14] * z[17];
z[17] = -1 + z[25];
z[18] = z[6] + (T(-2) / T(3)) * z[27];
z[18] = z[8] * z[18];
z[16] = z[16] + (T(1) / T(2)) * z[17] + z[18];
z[16] = z[5] * z[16];
z[17] = -z[0] + z[6];
z[17] = (T(1) / T(4)) * z[17] + -z[27];
z[17] = z[5] * z[17];
z[18] = z[27] + z[29];
z[18] = z[18] * z[34];
z[14] = z[8] * z[14];
z[14] = -1 + z[14] + z[17] + z[18];
z[14] = z[14] * z[31];
z[17] = (T(-7) / T(2)) * z[6] + z[27];
z[17] = z[17] * z[21];
z[17] = z[17] + z[19];
z[14] = z[14] + z[16] + (T(1) / T(6)) * z[17];
z[14] = z[7] * z[14];
z[16] = (T(13) / T(4)) * z[6] + -z[27];
z[10] = z[10] * z[16];
z[10] = T(-3) / T(2) + z[10];
z[10] = z[8] * z[10];
z[16] = T(1) / T(2) + -z[38];
z[16] = z[16] * z[26];
z[15] = 7 + -z[15];
z[15] = z[4] * z[15];
z[10] = z[10] + (T(1) / T(12)) * z[15] + z[16];
z[10] = z[5] * z[10];
z[13] = T(1) / T(2) + -z[13];
z[13] = z[8] * z[13];
z[13] = z[4] + z[13];
z[13] = z[8] * z[13];
z[13] = z[13] + -z[20];
z[10] = z[10] + z[12] + (T(1) / T(6)) * z[13] + z[14];
z[10] = z[10] * z[11];
return z[9] + z[10];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_44(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_44(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
