#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_48(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[40];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[9];
z[3] = iW[15];
z[4] = iW[22];
z[5] = iW[23];
z[6] = v[0];
z[7] = v[2];
z[8] = v[4];
z[9] = iW[4];
z[10] = v[3];
z[11] = v[1];
z[12] = z[1] * z[8];
z[13] = 2 * z[12];
z[14] = 19 * z[9];
z[15] = -29 * z[1] + -z[14];
z[15] = z[7] * z[15];
z[15] = T(-179) / T(12) + -z[13] + (T(1) / T(6)) * z[15];
z[15] = z[7] * z[15];
z[16] = (T(1) / T(2)) * z[8];
z[17] = 7 * z[12];
z[18] = 185 + -z[17];
z[18] = z[16] * z[18];
z[19] = -35 + 13 * z[12];
z[19] = z[7] * z[19];
z[18] = z[18] + z[19];
z[19] = z[0] * z[7];
z[18] = z[18] * z[19];
z[20] = 179 + -z[17];
z[20] = z[8] * z[20];
z[15] = z[15] + (T(1) / T(6)) * z[18] + (T(1) / T(12)) * z[20];
z[15] = z[0] * z[15];
z[18] = T(-109) / T(2) + -25 * z[12];
z[20] = (T(1) / T(2)) * z[1];
z[21] = (T(-1) / T(3)) * z[9] + z[20];
z[21] = z[11] * z[21];
z[18] = (T(1) / T(3)) * z[18] + 19 * z[21];
z[21] = (T(1) / T(3)) * z[7];
z[22] = (T(-1) / T(4)) * z[1] + -z[14];
z[22] = z[21] * z[22];
z[23] = -1 + -z[19];
z[23] = z[12] * z[23];
z[24] = z[1] * z[7];
z[23] = z[23] + z[24];
z[23] = z[0] * z[23];
z[23] = z[1] + z[23];
z[23] = z[6] * z[23];
z[15] = z[15] + (T(1) / T(2)) * z[18] + z[22] + (T(8) / T(3)) * z[23];
z[15] = z[6] * z[15];
z[18] = (T(1) / T(3)) * z[8];
z[22] = T(-193) / T(4) + -11 * z[12];
z[22] = z[18] * z[22];
z[23] = (T(1) / T(2)) * z[12];
z[25] = z[9] * z[10];
z[26] = (T(19) / T(2)) * z[25];
z[27] = 16 + -z[26];
z[27] = z[23] + (T(1) / T(3)) * z[27];
z[27] = z[7] * z[27];
z[22] = (T(89) / T(4)) * z[10] + z[22] + z[27];
z[22] = z[7] * z[22];
z[27] = (T(17) / T(4)) * z[12];
z[28] = T(26) / T(3) + z[27];
z[28] = z[8] * z[28];
z[28] = (T(-121) / T(4)) * z[10] + z[28];
z[28] = z[8] * z[28];
z[22] = z[22] + z[28];
z[22] = z[0] * z[21] * z[22];
z[27] = T(23) / T(3) + z[27];
z[27] = z[8] * z[27];
z[27] = (T(-115) / T(4)) * z[10] + z[27];
z[27] = z[18] * z[27];
z[28] = 5 * z[1];
z[29] = z[14] + z[28];
z[29] = z[7] * z[29];
z[29] = T(-53) / T(4) + 22 * z[12] + z[29];
z[29] = z[7] * z[29];
z[30] = T(113) / T(4) + -40 * z[12];
z[30] = z[8] * z[30];
z[29] = z[29] + z[30];
z[29] = (T(51) / T(4)) * z[10] + (T(1) / T(9)) * z[29];
z[29] = z[7] * z[29];
z[22] = z[22] + z[27] + z[29];
z[22] = z[0] * z[22];
z[27] = (T(19) / T(3)) * z[25];
z[29] = T(-41) / T(2) + (T(47) / T(12)) * z[12] + z[27];
z[30] = (T(1) / T(2)) * z[11];
z[31] = (T(19) / T(9)) * z[9];
z[32] = z[1] + -z[31];
z[32] = z[30] * z[32];
z[29] = (T(1) / T(3)) * z[29] + z[32];
z[29] = z[11] * z[29];
z[32] = 19 * z[25];
z[33] = T(-121) / T(2) + (T(43) / T(2)) * z[12] + z[32];
z[34] = (T(1) / T(2)) * z[7];
z[35] = (T(-41) / T(3)) * z[1] + z[14];
z[35] = z[34] * z[35];
z[36] = z[1] * z[11];
z[33] = (T(1) / T(2)) * z[33] + z[35] + -7 * z[36];
z[33] = z[21] * z[33];
z[35] = 8 + (T(-29) / T(9)) * z[12];
z[35] = z[8] * z[35];
z[15] = (T(16) / T(3)) * z[10] + (T(1) / T(3)) * z[15] + z[22] + z[29] + z[33] + z[35];
z[15] = z[6] * z[15];
z[22] = z[14] + z[20];
z[22] = z[22] * z[30];
z[22] = T(139) / T(6) + -z[13] + z[22] + (T(13) / T(4)) * z[24] + -z[32];
z[22] = z[7] * z[22];
z[14] = (T(-37) / T(4)) * z[1] + z[14];
z[14] = z[11] * z[14];
z[14] = T(-77) / T(4) + (T(79) / T(4)) * z[12] + z[14] + -z[32];
z[24] = (T(1) / T(3)) * z[11];
z[14] = z[14] * z[24];
z[29] = -109 + (T(-167) / T(6)) * z[12];
z[29] = z[16] * z[29];
z[14] = (T(158) / T(3)) * z[10] + z[14] + z[22] + z[29];
z[14] = z[7] * z[14];
z[22] = T(-43) / T(2) + (T(77) / T(6)) * z[12] + z[27] + (T(-7) / T(6)) * z[36];
z[22] = z[22] * z[30];
z[29] = 80 + -z[26];
z[29] = z[10] * z[29];
z[33] = -97 + -145 * z[12];
z[33] = z[8] * z[33];
z[29] = z[29] + (T(1) / T(4)) * z[33];
z[22] = z[22] + (T(1) / T(3)) * z[29];
z[22] = z[11] * z[22];
z[29] = prod_pow(z[10], 2);
z[33] = T(109) / T(3) + (T(29) / T(4)) * z[12];
z[33] = z[8] * z[33];
z[33] = (T(-355) / T(12)) * z[10] + z[33];
z[33] = z[8] * z[33];
z[14] = z[14] + z[22] + (T(-185) / T(12)) * z[29] + z[33];
z[22] = 58 + (T(-13) / T(2)) * z[12] + -z[32];
z[33] = z[1] + (T(-19) / T(3)) * z[9];
z[33] = z[33] * z[34];
z[22] = (T(1) / T(3)) * z[22] + z[33];
z[22] = z[7] * z[22];
z[33] = 19 * z[10];
z[35] = T(1) / T(3) + (T(1) / T(2)) * z[25];
z[33] = z[33] * z[35];
z[35] = T(-91) / T(4) + -z[12];
z[35] = z[8] * z[35];
z[22] = z[22] + z[33] + (T(7) / T(3)) * z[35];
z[22] = z[7] * z[22];
z[33] = prod_pow(z[8], 2);
z[35] = T(89) / T(3) + 5 * z[12];
z[35] = z[33] * z[35];
z[35] = (T(-509) / T(3)) * z[29] + 7 * z[35];
z[22] = z[22] + (T(1) / T(4)) * z[35];
z[22] = z[7] * z[22];
z[35] = T(19) / T(2) + z[12];
z[35] = z[8] * z[35];
z[37] = (T(-157) / T(12)) * z[10] + -z[35];
z[37] = z[8] * z[37];
z[37] = (T(281) / T(12)) * z[29] + z[37];
z[37] = z[8] * z[37];
z[22] = z[22] + z[37];
z[37] = T(-31) / T(3) + -z[12];
z[37] = z[16] * z[37];
z[38] = 1 + z[27];
z[38] = z[34] * z[38];
z[39] = -59 + z[32];
z[39] = z[10] * z[39];
z[37] = z[37] + z[38] + (T(1) / T(3)) * z[39];
z[37] = z[21] * z[37];
z[38] = T(157) / T(18) + z[12];
z[38] = z[8] * z[38];
z[38] = (T(391) / T(18)) * z[10] + z[38];
z[38] = z[16] * z[38];
z[37] = -9 * z[29] + z[37] + z[38];
z[37] = z[7] * z[37];
z[35] = (T(-187) / T(12)) * z[10] + -z[35];
z[35] = z[8] * z[35];
z[35] = (T(299) / T(12)) * z[29] + z[35];
z[35] = z[18] * z[35];
z[35] = z[35] + z[37];
z[35] = z[19] * z[35];
z[22] = (T(1) / T(3)) * z[22] + z[35];
z[22] = z[0] * z[22];
z[14] = (T(1) / T(3)) * z[14] + z[15] + z[22];
z[14] = z[6] * z[14];
z[15] = (T(1) / T(2)) * z[10];
z[22] = T(-485) / T(6) + z[32];
z[22] = z[15] * z[22];
z[35] = -104 + (T(29) / T(2)) * z[12];
z[35] = z[18] * z[35];
z[28] = (T(-19) / T(2)) * z[9] + z[28];
z[28] = z[24] * z[28];
z[37] = 103 + (T(-109) / T(3)) * z[12];
z[28] = z[28] + (T(1) / T(4)) * z[37];
z[28] = z[11] * z[28];
z[22] = z[22] + z[28] + z[35];
z[28] = T(103) / T(3) + (T(-49) / T(6)) * z[12] + z[32];
z[31] = z[20] + -z[31];
z[31] = z[11] * z[31];
z[35] = z[1] + (T(-19) / T(6)) * z[9];
z[35] = z[21] * z[35];
z[28] = (T(1) / T(6)) * z[28] + z[31] + z[35];
z[28] = z[7] * z[28];
z[22] = (T(1) / T(3)) * z[22] + z[28];
z[22] = z[7] * z[22];
z[28] = T(-89) / T(2) + -z[27];
z[28] = z[28] * z[29];
z[31] = T(181) / T(2) + z[17];
z[31] = z[16] * z[31];
z[31] = (T(194) / T(3)) * z[10] + z[31];
z[31] = z[8] * z[31];
z[28] = (T(1) / T(2)) * z[28] + z[31];
z[31] = T(13) / T(2) + -3 * z[12] + (T(-19) / T(9)) * z[25] + (T(7) / T(9)) * z[36];
z[30] = z[30] * z[31];
z[31] = (T(5) / T(2)) * z[8];
z[35] = T(-113) / T(2) + z[12];
z[35] = z[31] * z[35];
z[37] = T(-61) / T(4) + z[32];
z[37] = z[10] * z[37];
z[35] = z[35] + z[37];
z[30] = z[30] + (T(1) / T(9)) * z[35];
z[30] = z[11] * z[30];
z[22] = z[22] + (T(1) / T(3)) * z[28] + z[30];
z[22] = z[7] * z[22];
z[28] = (T(1) / T(3)) * z[29];
z[30] = T(29) / T(4) + -z[32];
z[30] = z[28] * z[30];
z[32] = T(187) / T(6) + z[12];
z[32] = z[16] * z[32];
z[32] = (T(179) / T(3)) * z[10] + z[32];
z[32] = z[8] * z[32];
z[30] = z[30] + z[32];
z[32] = -5 + z[12];
z[32] = z[18] * z[32];
z[27] = -z[23] + z[27];
z[27] = z[21] * z[27];
z[27] = -11 * z[10] + z[27] + z[32];
z[27] = z[7] * z[27];
z[27] = z[27] + (T(1) / T(3)) * z[30];
z[27] = z[7] * z[27];
z[30] = T(-59) / T(4) + -z[12];
z[30] = z[8] * z[30];
z[30] = (T(-511) / T(12)) * z[10] + z[30];
z[30] = z[8] * z[30];
z[30] = (T(-77) / T(12)) * z[29] + z[30];
z[30] = z[8] * z[30];
z[32] = prod_pow(z[10], 3);
z[30] = z[30] + (T(197) / T(12)) * z[32];
z[27] = z[27] + (T(1) / T(3)) * z[30];
z[27] = z[7] * z[27];
z[26] = 43 + -z[26];
z[26] = z[26] * z[28];
z[25] = -1 + (T(-19) / T(6)) * z[25];
z[25] = z[10] * z[25];
z[25] = -z[16] + z[25];
z[25] = z[7] * z[25];
z[28] = 2 * z[8];
z[30] = (T(37) / T(6)) * z[10] + z[28];
z[30] = z[8] * z[30];
z[25] = z[25] + z[26] + z[30];
z[25] = z[7] * z[25];
z[26] = -z[8] + (T(-25) / T(6)) * z[10];
z[26] = z[26] * z[31];
z[26] = z[26] + (T(-56) / T(3)) * z[29];
z[26] = z[8] * z[26];
z[25] = z[25] + z[26] + (T(127) / T(12)) * z[32];
z[25] = z[21] * z[25];
z[26] = (T(7) / T(4)) * z[10] + z[18];
z[26] = z[8] * z[26];
z[26] = z[26] + (T(5) / T(2)) * z[29];
z[26] = z[8] * z[26];
z[26] = z[26] + (T(-89) / T(36)) * z[32];
z[26] = z[8] * z[26];
z[25] = z[25] + z[26];
z[19] = z[19] * z[25];
z[25] = (T(23) / T(4)) * z[10] + z[28];
z[25] = z[8] * z[25];
z[25] = z[25] + (T(11) / T(2)) * z[29];
z[25] = z[8] * z[25];
z[25] = z[25] + (T(-83) / T(12)) * z[32];
z[25] = z[18] * z[25];
z[19] = z[19] + z[25] + z[27];
z[19] = z[0] * z[19];
z[25] = T(7) / T(6) + z[12];
z[25] = z[24] * z[25];
z[26] = T(-209) / T(36) + -z[12];
z[26] = z[8] * z[26];
z[26] = (T(10) / T(9)) * z[10] + z[25] + z[26];
z[26] = z[11] * z[26];
z[27] = T(89) / T(9) + z[12];
z[27] = z[8] * z[27];
z[27] = (T(38) / T(9)) * z[10] + z[27];
z[27] = z[8] * z[27];
z[26] = z[26] + z[27] + (T(-31) / T(9)) * z[29];
z[26] = z[11] * z[26];
z[27] = T(-17) / T(4) + (T(-1) / T(3)) * z[12];
z[27] = z[8] * z[27];
z[27] = (T(-169) / T(18)) * z[10] + z[27];
z[27] = z[8] * z[27];
z[27] = z[27] + (T(43) / T(12)) * z[29];
z[27] = z[8] * z[27];
z[14] = z[14] + z[19] + z[22] + z[26] + z[27] + (T(35) / T(18)) * z[32];
z[14] = z[6] * z[14];
z[17] = T(37) / T(6) + z[17];
z[17] = z[8] * z[17];
z[15] = z[15] + z[17];
z[17] = 1 + (T(-23) / T(12)) * z[12] + (T(-7) / T(12)) * z[36];
z[17] = z[11] * z[17];
z[15] = (T(1) / T(2)) * z[15] + z[17];
z[15] = z[11] * z[15];
z[17] = -5 + -z[12];
z[17] = z[8] * z[17];
z[17] = (T(4) / T(3)) * z[10] + z[17];
z[17] = z[8] * z[17];
z[15] = z[15] + z[17] + (T(-7) / T(6)) * z[29];
z[17] = z[11] * z[20];
z[19] = 7 + (T(-17) / T(2)) * z[12] + -z[17];
z[19] = z[11] * z[19];
z[20] = (T(25) / T(18)) * z[10];
z[22] = T(29) / T(18) + z[12];
z[22] = z[8] * z[22];
z[19] = (T(1) / T(9)) * z[19] + -z[20] + z[22];
z[17] = -1 + z[17] + -z[23];
z[17] = z[17] * z[21];
z[17] = z[17] + (T(1) / T(2)) * z[19];
z[17] = z[7] * z[17];
z[15] = (T(1) / T(3)) * z[15] + z[17];
z[15] = z[7] * z[15];
z[13] = T(1) / T(6) + z[13];
z[13] = z[13] * z[18];
z[13] = (T(3) / T(4)) * z[10] + z[13] + -z[25];
z[13] = z[11] * z[13];
z[12] = -1 + -z[12];
z[12] = z[8] * z[12];
z[12] = (T(53) / T(12)) * z[10] + z[12];
z[12] = z[8] * z[12];
z[12] = z[12] + -z[29];
z[12] = (T(1) / T(3)) * z[12] + z[13];
z[12] = z[11] * z[12];
z[13] = (T(4) / T(3)) * z[8] + (T(-3) / T(2)) * z[10];
z[13] = z[8] * z[13];
z[13] = z[13] + (T(-31) / T(36)) * z[29];
z[13] = z[8] * z[13];
z[12] = z[12] + z[13] + z[15] + (T(-1) / T(36)) * z[32];
z[12] = z[7] * z[12];
z[13] = z[8] + z[20];
z[13] = z[8] * z[13];
z[13] = z[13] + (T(7) / T(9)) * z[29];
z[15] = -z[8] + (T(-7) / T(12)) * z[10];
z[15] = z[15] * z[24];
z[13] = (T(1) / T(2)) * z[13] + z[15];
z[13] = z[11] * z[13];
z[15] = (T(1) / T(6)) * z[8] + -z[10];
z[15] = z[8] * z[15];
z[15] = z[15] + (T(-1) / T(36)) * z[29];
z[15] = z[8] * z[15];
z[13] = z[13] + z[15] + (T(-7) / T(36)) * z[32];
z[13] = z[11] * z[13];
z[15] = z[8] + z[10];
z[15] = z[15] * z[34];
z[17] = -z[10] + -z[28];
z[17] = z[8] * z[17];
z[15] = z[15] + z[17] + z[29];
z[15] = z[15] * z[21];
z[17] = (T(-5) / T(6)) * z[29] + z[33];
z[17] = z[8] * z[17];
z[15] = z[15] + z[17] + (T(1) / T(6)) * z[32];
z[15] = z[7] * z[15];
z[17] = z[10] + -z[28];
z[17] = z[8] * z[17];
z[17] = z[17] + 2 * z[29];
z[17] = z[8] * z[17];
z[17] = z[17] + -z[32];
z[17] = z[17] * z[18];
z[15] = z[15] + z[17];
z[15] = z[7] * z[15];
z[17] = z[8] + -z[10];
z[17] = z[8] * z[17];
z[17] = z[17] + -z[29];
z[17] = z[8] * z[17];
z[17] = z[17] + z[32];
z[17] = z[17] * z[33];
z[15] = z[15] + (T(1) / T(6)) * z[17];
z[15] = z[0] * z[15];
z[16] = (T(2) / T(3)) * z[10] + -z[16];
z[16] = z[8] * z[16];
z[16] = z[16] + (T(1) / T(6)) * z[29];
z[16] = z[8] * z[16];
z[16] = z[16] + (T(-1) / T(3)) * z[32];
z[16] = z[8] * z[16];
z[12] = z[12] + z[13] + z[14] + z[15] + z[16];
return prod_pow(z[4], 2) * z[2] * z[3] * z[5] * z[6] * z[12];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_48(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_48(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
