#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_56(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[39];
z[0] = iW[0];
z[1] = iW[3];
z[2] = v[1];
z[3] = v[2];
z[4] = v[4];
z[5] = iW[15];
z[6] = iW[1];
z[7] = v[0];
z[8] = iW[4];
z[9] = v[3];
z[10] = iW[23];
z[11] = iW[18];
z[12] = prod_pow(z[6], 2);
z[13] = z[9] * z[12];
z[14] = -z[6] + z[13];
z[15] = (T(1) / T(2)) * z[13];
z[16] = -z[6] + z[15];
z[16] = z[9] * z[16];
z[16] = T(1) / T(2) + z[16];
z[17] = z[8] * z[16];
z[17] = (T(1) / T(2)) * z[14] + z[17];
z[18] = 2 * z[6] + -z[13];
z[18] = z[9] * z[18];
z[18] = -1 + z[18];
z[19] = z[10] * z[18];
z[17] = (T(19) / T(3)) * z[17] + z[19];
z[17] = z[8] * z[17];
z[16] = z[5] * z[16];
z[16] = -z[14] + z[16];
z[16] = z[5] * z[16];
z[19] = (T(8) / T(3)) * z[11];
z[20] = -z[14] * z[19];
z[21] = z[1] * z[2];
z[21] = -1 + z[21];
z[22] = z[0] * z[1];
z[23] = z[21] * z[22];
z[24] = prod_pow(z[1], 2);
z[16] = z[12] + z[16] + z[17] + z[20] + z[23] + z[24];
z[17] = (T(1) / T(3)) * z[3];
z[16] = z[16] * z[17];
z[20] = (T(1) / T(2)) * z[6];
z[23] = z[6] * z[9];
z[25] = -1 + z[23];
z[26] = z[8] * z[25];
z[26] = z[13] + z[20] + z[26];
z[26] = z[8] * z[26];
z[27] = 2 * z[1];
z[28] = z[20] + -z[27];
z[28] = z[1] * z[28];
z[26] = z[12] + (T(19) / T(3)) * z[26] + z[28];
z[28] = (T(1) / T(3)) * z[7];
z[26] = z[26] * z[28];
z[29] = (T(1) / T(3)) * z[8];
z[30] = (T(17) / T(2)) * z[6] + (T(-19) / T(3)) * z[13];
z[30] = z[9] * z[30];
z[30] = T(-13) / T(6) + z[30];
z[30] = z[29] * z[30];
z[23] = -2 + z[23];
z[23] = z[9] * z[23];
z[23] = z[2] + z[23];
z[31] = prod_pow(z[5], 2);
z[32] = z[23] * z[31];
z[33] = -z[6] + 2 * z[13];
z[33] = z[28] * z[33];
z[34] = (T(2) / T(3)) * z[13];
z[35] = z[6] + -z[34];
z[35] = z[9] * z[35];
z[33] = T(-1) / T(3) + z[33] + z[35];
z[33] = z[19] * z[33];
z[35] = (T(1) / T(6)) * z[0];
z[36] = -z[21] * z[35];
z[23] = z[8] * z[23];
z[23] = (T(-2) / T(3)) * z[23] + -z[25];
z[23] = z[10] * z[23];
z[37] = z[1] * z[21];
z[16] = (T(1) / T(6)) * z[6] + -z[13] + z[16] + z[23] + z[26] + z[30] + (T(1) / T(3)) * z[32] + z[33] + z[36] + (T(-2) / T(3)) * z[37];
z[16] = z[3] * z[16];
z[23] = z[1] * z[6];
z[26] = z[5] * z[6];
z[26] = z[12] + (T(-1) / T(2)) * z[23] + z[26];
z[26] = z[5] * z[26];
z[30] = z[12] + z[23];
z[27] = -z[27] * z[30];
z[32] = (T(1) / T(2)) * z[5];
z[33] = -z[22] * z[32];
z[26] = z[26] + z[27] + z[33];
z[26] = z[17] * z[26];
z[27] = z[12] + (T(-5) / T(3)) * z[23] + z[31];
z[33] = -z[12] + z[23];
z[33] = z[1] * z[33];
z[36] = z[24] * z[28];
z[38] = z[12] * z[36];
z[33] = z[33] + z[38];
z[33] = z[7] * z[33];
z[38] = (T(1) / T(3)) * z[10];
z[36] = (T(1) / T(2)) * z[1] + -z[36] + -z[38];
z[36] = z[12] * z[36];
z[31] = z[31] * z[35];
z[31] = z[31] + z[36];
z[31] = z[4] * z[31];
z[36] = z[6] * z[38];
z[26] = z[26] + (T(1) / T(2)) * z[27] + z[31] + z[33] + z[36];
z[26] = z[4] * z[26];
z[27] = -z[12] + z[24];
z[30] = z[1] * z[7] * z[30];
z[27] = 2 * z[27] + z[30];
z[25] = z[5] * z[25];
z[25] = (T(1) / T(3)) * z[13] + -z[20] + (T(2) / T(3)) * z[25];
z[25] = z[5] * z[25];
z[30] = z[14] * z[32];
z[30] = -z[12] + z[30];
z[30] = z[5] * z[30];
z[24] = -z[0] * z[24];
z[24] = z[24] + z[30];
z[17] = z[17] * z[24];
z[24] = -z[10] * z[34];
z[17] = z[17] + (T(1) / T(3)) * z[22] + z[24] + z[25] + (T(2) / T(3)) * z[27];
z[17] = z[3] * z[17];
z[22] = (T(1) / T(2)) * z[12] + -2 * z[23];
z[22] = z[22] * z[28];
z[22] = -z[1] + (T(4) / T(3)) * z[6] + z[22];
z[22] = z[1] * z[22];
z[22] = (T(-2) / T(3)) * z[12] + z[22];
z[22] = z[7] * z[22];
z[23] = z[2] + -z[9];
z[24] = -z[5] * z[23];
z[24] = 1 + z[24];
z[24] = z[24] * z[32];
z[15] = (T(1) / T(6)) * z[1] + (T(-1) / T(3)) * z[6] + (T(-2) / T(3)) * z[10] + z[15] + z[17] + z[22] + z[24] + z[26] + -z[35];
z[15] = z[4] * z[15];
z[17] = z[1] + -z[20];
z[17] = z[1] * z[17];
z[20] = prod_pow(z[8], 2);
z[12] = (T(35) / T(6)) * z[12] + z[17] + (T(19) / T(6)) * z[20];
z[12] = z[7] * z[12];
z[17] = 35 * z[13];
z[20] = 22 * z[6] + -z[17];
z[12] = (T(19) / T(6)) * z[8] + z[12] + (T(1) / T(3)) * z[20] + z[37];
z[12] = z[7] * z[12];
z[17] = -41 * z[6] + z[17];
z[17] = z[9] * z[17];
z[17] = (T(1) / T(3)) * z[17] + z[21];
z[20] = prod_pow(z[9], 2);
z[21] = (T(1) / T(2)) * z[2] + -z[9];
z[21] = z[2] * z[21];
z[21] = (T(1) / T(2)) * z[20] + z[21];
z[21] = z[5] * z[21];
z[21] = z[21] + -z[23];
z[21] = z[5] * z[21];
z[22] = 2 * z[9];
z[14] = z[14] * z[22];
z[13] = -z[7] * z[13];
z[13] = z[13] + z[14];
z[13] = z[7] * z[13];
z[14] = z[9] * z[18];
z[13] = z[13] + z[14];
z[13] = z[13] * z[19];
z[14] = z[8] * z[23];
z[12] = z[12] + z[13] + z[14] + (T(1) / T(2)) * z[17] + z[21];
z[13] = -z[2] + z[22];
z[13] = z[2] * z[13];
z[13] = z[13] + -z[20];
z[13] = z[13] * z[29];
z[13] = z[13] + z[23];
z[13] = z[10] * z[13];
return (T(1) / T(3)) * z[12] + z[13] + z[15] + z[16];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_56(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_56(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
