#include "header.hpp"

#include "ppeeexex04.phasespace.set.hpp"

void ppeeexex04_phasespace_set::ax_psp_140_gdx_ememepepdx(int x_a){
  static Logger logger("ppeeexex04_phasespace_set::ax_psp_140_gdx_ememepepdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(22);
  needed_v_smin[x_a].resize(22);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   48,   49,   50,   51}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,    8,    9,   10,   11,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  needed_v_smin[x_a][  3] = {   4,    5,    6,    7,   52,   53,   54,   55}; //   8
  needed_v_smin[x_a][  4] = {   4,    5,    6,    7,   20,   21,   22,   23,   52,   53,   54,   55,   68,   69,   70,   71}; //  16
  needed_v_smin[x_a][  5] = {   8,    9,   10,   11,   12,   13,   14,   15,   36,   37,   38,   39,   40,   41,   42,   43,   56,   57,   58,   59,   60,   61,   62,   63,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  needed_v_smin[x_a][  6] = {   8,    9,   10,   11,   56,   57,   58,   59}; //   8
  needed_v_smin[x_a][  7] = {  12,   13,   14,   15,   60,   61,   62,   63}; //   8
  needed_v_smin[x_a][  8] = {  12,   13,   14,   15,   28,   29,   30,   31,   60,   61,   62,   63,   76,   77,   78,   79}; //  16
  needed_v_smin[x_a][  9] = {  16,   17,   18,   19,   20,   21,   22,   23,   36,   37,   38,   39,   40,   41,   42,   43,   64,   65,   66,   67,   68,   69,   70,   71,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  needed_v_smin[x_a][ 10] = {  16,   17,   18,   19,   64,   65,   66,   67}; //   8
  needed_v_smin[x_a][ 11] = {  16,   17,   18,   19,   24,   25,   26,   27,   64,   65,   66,   67,   72,   73,   74,   75}; //  16
  needed_v_smin[x_a][ 12] = {  20,   21,   22,   23,   68,   69,   70,   71}; //   8
  needed_v_smin[x_a][ 13] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   44,   45,   46,   47,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  needed_v_smin[x_a][ 14] = {  24,   25,   26,   27,   72,   73,   74,   75}; //   8
  needed_v_smin[x_a][ 15] = {  28,   29,   30,   31,   76,   77,   78,   79}; //   8
  needed_v_smin[x_a][ 16] = {  32,   33,   34,   35,   92,   93,   94,   95}; //   8
  needed_v_smin[x_a][ 17] = {  36,   37,   38,   39,   88,   89,   90,   91}; //   8
  needed_v_smin[x_a][ 18] = {  40,   41,   42,   43,   84,   85,   86,   87}; //   8
  needed_v_smin[x_a][ 19] = {  44,   45,   46,   47,   80,   81,   82,   83}; //   8
  needed_v_smin[x_a][ 20] = {  96,   97,   98,   99,  108,  109,  110,  111}; //   8
  needed_v_smin[x_a][ 21] = { 100,  101,  102,  103,  104,  105,  106,  107}; //   8

  v_smax[x_a].resize(25);
  needed_v_smax[x_a].resize(25);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   48,   49,   50,   51,   52,   53,   54,   55,   80,   81,   82,   83,   96,   97,   98,   99}; //  28
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,    8,    9,   10,   11,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111}; //  80
  needed_v_smax[x_a][  3] = {   4,    5,    6,    7,   20,   21,   22,   23,   52,   53,   54,   55,   68,   69,   70,   71}; //  16
  needed_v_smax[x_a][  4] = {   8,    9,   10,   11,   12,   13,   14,   15,   36,   37,   38,   39,   56,   57,   58,   59,   60,   61,   62,   63,   84,   85,   86,   87,  100,  101,  102,  103}; //  28
  needed_v_smax[x_a][  5] = {  12,   13,   14,   15,   28,   29,   30,   31,   60,   61,   62,   63,   76,   77,   78,   79}; //  16
  needed_v_smax[x_a][  6] = {  16,   17,   18,   19,   20,   21,   22,   23,   40,   41,   42,   43,   64,   65,   66,   67,   68,   69,   70,   71,   88,   89,   90,   91,  104,  105,  106,  107}; //  28
  needed_v_smax[x_a][  7] = {  16,   17,   18,   19,   24,   25,   26,   27,   64,   65,   66,   67,   72,   73,   74,   75}; //  16
  needed_v_smax[x_a][  8] = {  24,   25,   26,   27,   28,   29,   30,   31,   44,   45,   46,   47,   72,   73,   74,   75,   76,   77,   78,   79,   92,   93,   94,   95,  108,  109,  110,  111}; //  28
  needed_v_smax[x_a][  9] = {  32,   33,   34,   35}; //   4
  needed_v_smax[x_a][ 10] = {  32,   33,   34,   35}; //   4
  needed_v_smax[x_a][ 11] = {  36,   37,   38,   39}; //   4
  needed_v_smax[x_a][ 12] = {  36,   37,   38,   39}; //   4
  needed_v_smax[x_a][ 13] = {  40,   41,   42,   43}; //   4
  needed_v_smax[x_a][ 14] = {  40,   41,   42,   43}; //   4
  needed_v_smax[x_a][ 15] = {  44,   45,   46,   47}; //   4
  needed_v_smax[x_a][ 16] = {  44,   45,   46,   47}; //   4
  needed_v_smax[x_a][ 17] = {  80,   81,   82,   83,   96,   97,   98,   99}; //   8
  needed_v_smax[x_a][ 18] = {  80,   81,   82,   83}; //   4
  needed_v_smax[x_a][ 19] = {  84,   85,   86,   87,  100,  101,  102,  103}; //   8
  needed_v_smax[x_a][ 20] = {  84,   85,   86,   87}; //   4
  needed_v_smax[x_a][ 21] = {  88,   89,   90,   91,  104,  105,  106,  107}; //   8
  needed_v_smax[x_a][ 22] = {  88,   89,   90,   91}; //   4
  needed_v_smax[x_a][ 23] = {  92,   93,   94,   95,  108,  109,  110,  111}; //   8
  needed_v_smax[x_a][ 24] = {  92,   93,   94,   95}; //   4

  g_p[x_a].resize(48);
  needed_g_p[x_a].resize(48);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   32,   33,   48,   49,   52,   53,   80,   81,   96,   97}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   48,   49,   50,   51}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,    8,   10,   48,   50,   56,   58}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,    9,   11,   49,   51,   57,   59}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    6,    7,   34,   35,   50,   51,   54,   55,   82,   83,   98,   99}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][5] = {   4,    5,    6,    7,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   4,    6,   20,   22,   52,   54,   68,   70}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][7] = {   5,    7,   21,   23,   53,   55,   69,   71}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][8] = {   8,    9,   12,   13,   36,   37,   56,   57,   60,   61,   84,   85,  100,  101}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][9] = {   8,    9,   10,   11,   56,   57,   58,   59}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");
  needed_g_p[x_a][10] = {  10,   11,   14,   15,   38,   39,   58,   59,   62,   63,   86,   87,  102,  103}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax4");
  needed_g_p[x_a][11] = {  12,   13,   14,   15,   60,   61,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][12] = {  12,   14,   28,   30,   60,   62,   76,   78}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][13] = {  13,   15,   29,   31,   61,   63,   77,   79}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax2");
  needed_g_p[x_a][14] = {  16,   17,   20,   21,   40,   41,   64,   65,   68,   69,   88,   89,  104,  105}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax6");
  needed_g_p[x_a][15] = {  16,   17,   18,   19,   64,   65,   66,   67}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][16] = {  16,   18,   24,   26,   64,   66,   72,   74}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax2");
  needed_g_p[x_a][17] = {  17,   19,   25,   27,   65,   67,   73,   75}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][18] = {  18,   19,   22,   23,   42,   43,   66,   67,   70,   71,   90,   91,  106,  107}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax6");
  needed_g_p[x_a][19] = {  20,   21,   22,   23,   68,   69,   70,   71}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax3");
  needed_g_p[x_a][20] = {  24,   25,   28,   29,   44,   45,   72,   73,   76,   77,   92,   93,  108,  109}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax8");
  needed_g_p[x_a][21] = {  24,   25,   26,   27,   72,   73,   74,   75}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][22] = {  26,   27,   30,   31,   46,   47,   74,   75,   78,   79,   94,   95,  110,  111}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax8");
  needed_g_p[x_a][23] = {  28,   29,   30,   31,   76,   77,   78,   79}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax5");
  needed_g_p[x_a][24] = {  32,   33,   34,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax9");
  needed_g_p[x_a][25] = {  32,   34}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][26] = {  33,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax10");
  needed_g_p[x_a][27] = {  36,   37,   38,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax11");
  needed_g_p[x_a][28] = {  36,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax12");
  needed_g_p[x_a][29] = {  37,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax12");
  needed_g_p[x_a][30] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax13");
  needed_g_p[x_a][31] = {  40,   42}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax14");
  needed_g_p[x_a][32] = {  41,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax14");
  needed_g_p[x_a][33] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax15");
  needed_g_p[x_a][34] = {  44,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax16");
  needed_g_p[x_a][35] = {  45,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][36] = {  80,   82,   96,   98}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax17");
  needed_g_p[x_a][37] = {  80,   81,   82,   83}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax18");
  needed_g_p[x_a][38] = {  81,   83,   97,   99}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax17");
  needed_g_p[x_a][39] = {  84,   86,  100,  102}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax19");
  needed_g_p[x_a][40] = {  84,   85,   86,   87}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax20");
  needed_g_p[x_a][41] = {  85,   87,  101,  103}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax19");
  needed_g_p[x_a][42] = {  88,   90,  104,  106}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax21");
  needed_g_p[x_a][43] = {  88,   89,   90,   91}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax22");
  needed_g_p[x_a][44] = {  89,   91,  105,  107}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax21");
  needed_g_p[x_a][45] = {  92,   94,  108,  110}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax23");
  needed_g_p[x_a][46] = {  92,   93,   94,   95}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax24");
  needed_g_p[x_a][47] = {  93,   95,  109,  111}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax23");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {  96,   97,   98,   99,  108,  109,  110,  111}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax2");
  needed_g_f[x_a][1] = { 100,  101,  102,  103,  104,  105,  106,  107}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax2");

  g_t[x_a].resize(9);
  needed_g_t[x_a].resize(9);
  needed_g_t[x_a][0] = {  48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111}; //  48
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {  80,   81,   82,   83}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__24_100");
  needed_g_t[x_a][2] = {  84,   85,   86,   87}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_84");
  needed_g_t[x_a][3] = {  88,   89,   90,   91}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_104");
  needed_g_t[x_a][4] = {  92,   93,   94,   95}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_88");
  needed_g_t[x_a][5] = {  96,   97,   98,   99}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__24_36");
  needed_g_t[x_a][6] = { 100,  101,  102,  103}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_20");
  needed_g_t[x_a][7] = { 104,  105,  106,  107}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_40");
  needed_g_t[x_a][8] = { 108,  109,  110,  111}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_24");

  g_d[x_a].resize(25);
  needed_g_d[x_a].resize(25);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  32
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    8,    9,   10,   11,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,   48,   49,   50,   51}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   4,    5,    6,    7,   20,   21,   22,   23,   52,   53,   54,   55,   68,   69,   70,   71}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   4,    5,    6,    7,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][6] = {   8,    9,   10,   11,   56,   57,   58,   59}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][7] = {   8,    9,   10,   11,   12,   13,   14,   15,   36,   37,   38,   39,   40,   41,   42,   43,   56,   57,   58,   59,   60,   61,   62,   63,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][8] = {  12,   13,   14,   15,   28,   29,   30,   31,   60,   61,   62,   63,   76,   77,   78,   79}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  12,   13,   14,   15,   60,   61,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][10] = {  16,   17,   18,   19,   24,   25,   26,   27,   64,   65,   66,   67,   72,   73,   74,   75}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][11] = {  16,   17,   18,   19,   64,   65,   66,   67}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][12] = {  16,   17,   18,   19,   20,   21,   22,   23,   36,   37,   38,   39,   40,   41,   42,   43,   64,   65,   66,   67,   68,   69,   70,   71,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][13] = {  20,   21,   22,   23,   68,   69,   70,   71}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][14] = {  24,   25,   26,   27,   72,   73,   74,   75}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][15] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   44,   45,   46,   47,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][16] = {  28,   29,   30,   31,   76,   77,   78,   79}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][17] = {  32,   33,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][18] = {  32,   33,   34,   35,   92,   93,   94,   95}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][19] = {  36,   37,   38,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][20] = {  36,   37,   38,   39,   88,   89,   90,   91}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][21] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][22] = {  40,   41,   42,   43,   84,   85,   86,   87}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][23] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][24] = {  44,   45,   46,   47,   80,   81,   82,   83}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");

  c_p[x_a].resize(112);
  c_f[x_a].resize(112);
  c_t[x_a].resize(112);
  c_d[x_a].resize(112);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  4,   1,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   2,   3}; //   4

  c_p[x_a][3] = {  4,   1,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   2,   3}; //   4

  c_p[x_a][4] = {  0,   5,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   4,   5,   3}; //   4

  c_p[x_a][5] = {  0,   5,   7}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   4,   5,   3}; //   4

  c_p[x_a][6] = {  4,   5,   6}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   4,   5,   3}; //   4

  c_p[x_a][7] = {  4,   5,   7}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,   4,   5,   3}; //   4

  c_p[x_a][8] = {  8,   9,   2}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   1,   6,   7}; //   4

  c_p[x_a][9] = {  8,   9,   3}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,   1,   6,   7}; //   4

  c_p[x_a][10] = { 10,   9,   2}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,   1,   6,   7}; //   4

  c_p[x_a][11] = { 10,   9,   3}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,   1,   6,   7}; //   4

  c_p[x_a][12] = {  8,  11,  12}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,   8,   9,   7}; //   4

  c_p[x_a][13] = {  8,  11,  13}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  0,   8,   9,   7}; //   4

  c_p[x_a][14] = { 10,  11,  12}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  0,   8,   9,   7}; //   4

  c_p[x_a][15] = { 10,  11,  13}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  0,   8,   9,   7}; //   4

  c_p[x_a][16] = { 14,  15,  16}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  0,  10,  11,  12}; //   4

  c_p[x_a][17] = { 14,  15,  17}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  0,  10,  11,  12}; //   4

  c_p[x_a][18] = { 18,  15,  16}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  0,  10,  11,  12}; //   4

  c_p[x_a][19] = { 18,  15,  17}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  0,  10,  11,  12}; //   4

  c_p[x_a][20] = { 14,  19,   6}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  0,   4,  13,  12}; //   4

  c_p[x_a][21] = { 14,  19,   7}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  0,   4,  13,  12}; //   4

  c_p[x_a][22] = { 18,  19,   6}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  0,   4,  13,  12}; //   4

  c_p[x_a][23] = { 18,  19,   7}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  0,   4,  13,  12}; //   4

  c_p[x_a][24] = { 20,  21,  16}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = {  0,  10,  14,  15}; //   4

  c_p[x_a][25] = { 20,  21,  17}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = {  0,  10,  14,  15}; //   4

  c_p[x_a][26] = { 22,  21,  16}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = {  0,  10,  14,  15}; //   4

  c_p[x_a][27] = { 22,  21,  17}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = {  0,  10,  14,  15}; //   4

  c_p[x_a][28] = { 20,  23,  12}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = {  0,   8,  16,  15}; //   4

  c_p[x_a][29] = { 20,  23,  13}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = {  0,   8,  16,  15}; //   4

  c_p[x_a][30] = { 22,  23,  12}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = {  0,   8,  16,  15}; //   4

  c_p[x_a][31] = { 22,  23,  13}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = {  0,   8,  16,  15}; //   4

  c_p[x_a][32] = {  0,  24,  25}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 17,  15,  18,   3}; //   4

  c_p[x_a][33] = {  0,  24,  26}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 17,  15,  18,   3}; //   4

  c_p[x_a][34] = {  4,  24,  25}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 17,  15,  18,   3}; //   4

  c_p[x_a][35] = {  4,  24,  26}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 17,  15,  18,   3}; //   4

  c_p[x_a][36] = {  8,  27,  28}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 19,  12,  20,   7}; //   4

  c_p[x_a][37] = {  8,  27,  29}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 19,  12,  20,   7}; //   4

  c_p[x_a][38] = { 10,  27,  28}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 19,  12,  20,   7}; //   4

  c_p[x_a][39] = { 10,  27,  29}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 19,  12,  20,   7}; //   4

  c_p[x_a][40] = { 14,  30,  31}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 21,   7,  22,  12}; //   4

  c_p[x_a][41] = { 14,  30,  32}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 21,   7,  22,  12}; //   4

  c_p[x_a][42] = { 18,  30,  31}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 21,   7,  22,  12}; //   4

  c_p[x_a][43] = { 18,  30,  32}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = { 21,   7,  22,  12}; //   4

  c_p[x_a][44] = { 20,  33,  34}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = { 23,   3,  24,  15}; //   4

  c_p[x_a][45] = { 20,  33,  35}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = { 23,   3,  24,  15}; //   4

  c_p[x_a][46] = { 22,  33,  34}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = { 23,   3,  24,  15}; //   4

  c_p[x_a][47] = { 22,  33,  35}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {}; //   0
  c_d[x_a][47] = { 23,   3,  24,  15}; //   4

  c_p[x_a][48] = {  0,   1,   2}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  0}; //   1
  c_d[x_a][48] = {  1,   2,   3}; //   3

  c_p[x_a][49] = {  0,   1,   3}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  0}; //   1
  c_d[x_a][49] = {  1,   2,   3}; //   3

  c_p[x_a][50] = {  4,   1,   2}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  0}; //   1
  c_d[x_a][50] = {  1,   2,   3}; //   3

  c_p[x_a][51] = {  4,   1,   3}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  0}; //   1
  c_d[x_a][51] = {  1,   2,   3}; //   3

  c_p[x_a][52] = {  0,   5,   6}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  0}; //   1
  c_d[x_a][52] = {  4,   5,   3}; //   3

  c_p[x_a][53] = {  0,   5,   7}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  0}; //   1
  c_d[x_a][53] = {  4,   5,   3}; //   3

  c_p[x_a][54] = {  4,   5,   6}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  0}; //   1
  c_d[x_a][54] = {  4,   5,   3}; //   3

  c_p[x_a][55] = {  4,   5,   7}; //   3
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  0}; //   1
  c_d[x_a][55] = {  4,   5,   3}; //   3

  c_p[x_a][56] = {  8,   9,   2}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  0}; //   1
  c_d[x_a][56] = {  1,   6,   7}; //   3

  c_p[x_a][57] = {  8,   9,   3}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  0}; //   1
  c_d[x_a][57] = {  1,   6,   7}; //   3

  c_p[x_a][58] = { 10,   9,   2}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  0}; //   1
  c_d[x_a][58] = {  1,   6,   7}; //   3

  c_p[x_a][59] = { 10,   9,   3}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  0}; //   1
  c_d[x_a][59] = {  1,   6,   7}; //   3

  c_p[x_a][60] = {  8,  11,  12}; //   3
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  0}; //   1
  c_d[x_a][60] = {  8,   9,   7}; //   3

  c_p[x_a][61] = {  8,  11,  13}; //   3
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  0}; //   1
  c_d[x_a][61] = {  8,   9,   7}; //   3

  c_p[x_a][62] = { 10,  11,  12}; //   3
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  0}; //   1
  c_d[x_a][62] = {  8,   9,   7}; //   3

  c_p[x_a][63] = { 10,  11,  13}; //   3
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  0}; //   1
  c_d[x_a][63] = {  8,   9,   7}; //   3

  c_p[x_a][64] = { 14,  15,  16}; //   3
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  0}; //   1
  c_d[x_a][64] = { 10,  11,  12}; //   3

  c_p[x_a][65] = { 14,  15,  17}; //   3
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  0}; //   1
  c_d[x_a][65] = { 10,  11,  12}; //   3

  c_p[x_a][66] = { 18,  15,  16}; //   3
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  0}; //   1
  c_d[x_a][66] = { 10,  11,  12}; //   3

  c_p[x_a][67] = { 18,  15,  17}; //   3
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  0}; //   1
  c_d[x_a][67] = { 10,  11,  12}; //   3

  c_p[x_a][68] = { 14,  19,   6}; //   3
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  0}; //   1
  c_d[x_a][68] = {  4,  13,  12}; //   3

  c_p[x_a][69] = { 14,  19,   7}; //   3
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  0}; //   1
  c_d[x_a][69] = {  4,  13,  12}; //   3

  c_p[x_a][70] = { 18,  19,   6}; //   3
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  0}; //   1
  c_d[x_a][70] = {  4,  13,  12}; //   3

  c_p[x_a][71] = { 18,  19,   7}; //   3
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  0}; //   1
  c_d[x_a][71] = {  4,  13,  12}; //   3

  c_p[x_a][72] = { 20,  21,  16}; //   3
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  0}; //   1
  c_d[x_a][72] = { 10,  14,  15}; //   3

  c_p[x_a][73] = { 20,  21,  17}; //   3
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {  0}; //   1
  c_d[x_a][73] = { 10,  14,  15}; //   3

  c_p[x_a][74] = { 22,  21,  16}; //   3
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {  0}; //   1
  c_d[x_a][74] = { 10,  14,  15}; //   3

  c_p[x_a][75] = { 22,  21,  17}; //   3
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  0}; //   1
  c_d[x_a][75] = { 10,  14,  15}; //   3

  c_p[x_a][76] = { 20,  23,  12}; //   3
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  0}; //   1
  c_d[x_a][76] = {  8,  16,  15}; //   3

  c_p[x_a][77] = { 20,  23,  13}; //   3
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {  0}; //   1
  c_d[x_a][77] = {  8,  16,  15}; //   3

  c_p[x_a][78] = { 22,  23,  12}; //   3
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = {  0}; //   1
  c_d[x_a][78] = {  8,  16,  15}; //   3

  c_p[x_a][79] = { 22,  23,  13}; //   3
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = {  0}; //   1
  c_d[x_a][79] = {  8,  16,  15}; //   3

  c_p[x_a][80] = {  0,  36,  37}; //   3
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {  1}; //   1
  c_d[x_a][80] = { 24,  15,   3}; //   3

  c_p[x_a][81] = {  0,  38,  37}; //   3
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {  1}; //   1
  c_d[x_a][81] = { 24,  15,   3}; //   3

  c_p[x_a][82] = {  4,  36,  37}; //   3
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = {  1}; //   1
  c_d[x_a][82] = { 24,  15,   3}; //   3

  c_p[x_a][83] = {  4,  38,  37}; //   3
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = {  1}; //   1
  c_d[x_a][83] = { 24,  15,   3}; //   3

  c_p[x_a][84] = {  8,  39,  40}; //   3
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = {  2}; //   1
  c_d[x_a][84] = { 22,  12,   7}; //   3

  c_p[x_a][85] = {  8,  41,  40}; //   3
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = {  2}; //   1
  c_d[x_a][85] = { 22,  12,   7}; //   3

  c_p[x_a][86] = { 10,  39,  40}; //   3
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = {  2}; //   1
  c_d[x_a][86] = { 22,  12,   7}; //   3

  c_p[x_a][87] = { 10,  41,  40}; //   3
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = {  2}; //   1
  c_d[x_a][87] = { 22,  12,   7}; //   3

  c_p[x_a][88] = { 14,  42,  43}; //   3
  c_f[x_a][88] = {}; //   0
  c_t[x_a][88] = {  3}; //   1
  c_d[x_a][88] = { 20,   7,  12}; //   3

  c_p[x_a][89] = { 14,  44,  43}; //   3
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = {  3}; //   1
  c_d[x_a][89] = { 20,   7,  12}; //   3

  c_p[x_a][90] = { 18,  42,  43}; //   3
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = {  3}; //   1
  c_d[x_a][90] = { 20,   7,  12}; //   3

  c_p[x_a][91] = { 18,  44,  43}; //   3
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = {  3}; //   1
  c_d[x_a][91] = { 20,   7,  12}; //   3

  c_p[x_a][92] = { 20,  45,  46}; //   3
  c_f[x_a][92] = {}; //   0
  c_t[x_a][92] = {  4}; //   1
  c_d[x_a][92] = { 18,   3,  15}; //   3

  c_p[x_a][93] = { 20,  47,  46}; //   3
  c_f[x_a][93] = {}; //   0
  c_t[x_a][93] = {  4}; //   1
  c_d[x_a][93] = { 18,   3,  15}; //   3

  c_p[x_a][94] = { 22,  45,  46}; //   3
  c_f[x_a][94] = {}; //   0
  c_t[x_a][94] = {  4}; //   1
  c_d[x_a][94] = { 18,   3,  15}; //   3

  c_p[x_a][95] = { 22,  47,  46}; //   3
  c_f[x_a][95] = {}; //   0
  c_t[x_a][95] = {  4}; //   1
  c_d[x_a][95] = { 18,   3,  15}; //   3

  c_p[x_a][96] = {  0,  36}; //   2
  c_f[x_a][96] = {  0}; //   1
  c_t[x_a][96] = {  0,   5}; //   2
  c_d[x_a][96] = { 15,   3}; //   2

  c_p[x_a][97] = {  0,  38}; //   2
  c_f[x_a][97] = {  0}; //   1
  c_t[x_a][97] = {  0,   5}; //   2
  c_d[x_a][97] = { 15,   3}; //   2

  c_p[x_a][98] = {  4,  36}; //   2
  c_f[x_a][98] = {  0}; //   1
  c_t[x_a][98] = {  0,   5}; //   2
  c_d[x_a][98] = { 15,   3}; //   2

  c_p[x_a][99] = {  4,  38}; //   2
  c_f[x_a][99] = {  0}; //   1
  c_t[x_a][99] = {  0,   5}; //   2
  c_d[x_a][99] = { 15,   3}; //   2

  c_p[x_a][100] = {  8,  39}; //   2
  c_f[x_a][100] = {  1}; //   1
  c_t[x_a][100] = {  0,   6}; //   2
  c_d[x_a][100] = { 12,   7}; //   2

  c_p[x_a][101] = {  8,  41}; //   2
  c_f[x_a][101] = {  1}; //   1
  c_t[x_a][101] = {  0,   6}; //   2
  c_d[x_a][101] = { 12,   7}; //   2

  c_p[x_a][102] = { 10,  39}; //   2
  c_f[x_a][102] = {  1}; //   1
  c_t[x_a][102] = {  0,   6}; //   2
  c_d[x_a][102] = { 12,   7}; //   2

  c_p[x_a][103] = { 10,  41}; //   2
  c_f[x_a][103] = {  1}; //   1
  c_t[x_a][103] = {  0,   6}; //   2
  c_d[x_a][103] = { 12,   7}; //   2

  c_p[x_a][104] = { 14,  42}; //   2
  c_f[x_a][104] = {  1}; //   1
  c_t[x_a][104] = {  0,   7}; //   2
  c_d[x_a][104] = {  7,  12}; //   2

  c_p[x_a][105] = { 14,  44}; //   2
  c_f[x_a][105] = {  1}; //   1
  c_t[x_a][105] = {  0,   7}; //   2
  c_d[x_a][105] = {  7,  12}; //   2

  c_p[x_a][106] = { 18,  42}; //   2
  c_f[x_a][106] = {  1}; //   1
  c_t[x_a][106] = {  0,   7}; //   2
  c_d[x_a][106] = {  7,  12}; //   2

  c_p[x_a][107] = { 18,  44}; //   2
  c_f[x_a][107] = {  1}; //   1
  c_t[x_a][107] = {  0,   7}; //   2
  c_d[x_a][107] = {  7,  12}; //   2

  c_p[x_a][108] = { 20,  45}; //   2
  c_f[x_a][108] = {  0}; //   1
  c_t[x_a][108] = {  0,   8}; //   2
  c_d[x_a][108] = {  3,  15}; //   2

  c_p[x_a][109] = { 20,  47}; //   2
  c_f[x_a][109] = {  0}; //   1
  c_t[x_a][109] = {  0,   8}; //   2
  c_d[x_a][109] = {  3,  15}; //   2

  c_p[x_a][110] = { 22,  45}; //   2
  c_f[x_a][110] = {  0}; //   1
  c_t[x_a][110] = {  0,   8}; //   2
  c_d[x_a][110] = {  3,  15}; //   2

  c_p[x_a][111] = { 22,  47}; //   2
  c_f[x_a][111] = {  0}; //   1
  c_t[x_a][111] = {  0,   8}; //   2
  c_d[x_a][111] = {  3,  15}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_gdx_ememepepdx
//  channel    0: 5yyyv(1, 2, 64, 4, 32, 8, 16;   0,   0,   0,   0)
//  channel    1: 5yyyv(1, 2, 64, 4, 32, 8, 16;   0,   0,  23,   0)
//  channel    2: 5yyyv(1, 2, 64, 4, 32, 8, 16;  23,   0,   0,   0)
//  channel    3: 5yyyv(1, 2, 64, 4, 32, 8, 16;  23,   0,  23,   0)
//  channel    4: 5yyyv(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
//  channel    5: 5yyyv(1, 2, 64, 32, 4, 8, 16;   0,   0,  23,   0)
//  channel    6: 5yyyv(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
//  channel    7: 5yyyv(1, 2, 64, 32, 4, 8, 16;  23,   0,  23,   0)
//  channel    8: 5yyyv(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
//  channel    9: 5yyyv(1, 2, 64, 4, 16, 8, 32;   0,   0,  23,   0)
//  channel   10: 5yyyv(1, 2, 64, 4, 16, 8, 32;  23,   0,   0,   0)
//  channel   11: 5yyyv(1, 2, 64, 4, 16, 8, 32;  23,   0,  23,   0)
//  channel   12: 5yyyv(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
//  channel   13: 5yyyv(1, 2, 64, 16, 4, 8, 32;   0,   0,  23,   0)
//  channel   14: 5yyyv(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
//  channel   15: 5yyyv(1, 2, 64, 16, 4, 8, 32;  23,   0,  23,   0)
//  channel   16: 5yyyv(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
//  channel   17: 5yyyv(1, 2, 64, 8, 32, 4, 16;   0,   0,  23,   0)
//  channel   18: 5yyyv(1, 2, 64, 8, 32, 4, 16;  23,   0,   0,   0)
//  channel   19: 5yyyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  23,   0)
//  channel   20: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
//  channel   21: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  23,   0)
//  channel   22: 5yyyv(1, 2, 64, 32, 8, 4, 16;  23,   0,   0,   0)
//  channel   23: 5yyyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  23,   0)
//  channel   24: 5yyyv(1, 2, 64, 8, 16, 4, 32;   0,   0,   0,   0)
//  channel   25: 5yyyv(1, 2, 64, 8, 16, 4, 32;   0,   0,  23,   0)
//  channel   26: 5yyyv(1, 2, 64, 8, 16, 4, 32;  23,   0,   0,   0)
//  channel   27: 5yyyv(1, 2, 64, 8, 16, 4, 32;  23,   0,  23,   0)
//  channel   28: 5yyyv(1, 2, 64, 16, 8, 4, 32;   0,   0,   0,   0)
//  channel   29: 5yyyv(1, 2, 64, 16, 8, 4, 32;   0,   0,  23,   0)
//  channel   30: 5yyyv(1, 2, 64, 16, 8, 4, 32;  23,   0,   0,   0)
//  channel   31: 5yyyv(1, 2, 64, 16, 8, 4, 32;  23,   0,  23,   0)
//  channel   32: 52vyv(1, 2, 4, 32, 64, 8, 16;   0,   0,   0,   0)
//  channel   33: 52vyv(1, 2, 4, 32, 64, 8, 16;   0,   0,  23,   0)
//  channel   34: 52vyv(1, 2, 4, 32, 64, 8, 16;  23,   0,   0,   0)
//  channel   35: 52vyv(1, 2, 4, 32, 64, 8, 16;  23,   0,  23,   0)
//  channel   36: 52vyv(1, 2, 4, 16, 64, 8, 32;   0,   0,   0,   0)
//  channel   37: 52vyv(1, 2, 4, 16, 64, 8, 32;   0,   0,  23,   0)
//  channel   38: 52vyv(1, 2, 4, 16, 64, 8, 32;  23,   0,   0,   0)
//  channel   39: 52vyv(1, 2, 4, 16, 64, 8, 32;  23,   0,  23,   0)
//  channel   40: 52vyv(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
//  channel   41: 52vyv(1, 2, 8, 32, 64, 4, 16;   0,   0,  23,   0)
//  channel   42: 52vyv(1, 2, 8, 32, 64, 4, 16;  23,   0,   0,   0)
//  channel   43: 52vyv(1, 2, 8, 32, 64, 4, 16;  23,   0,  23,   0)
//  channel   44: 52vyv(1, 2, 8, 16, 64, 4, 32;   0,   0,   0,   0)
//  channel   45: 52vyv(1, 2, 8, 16, 64, 4, 32;   0,   0,  23,   0)
//  channel   46: 52vyv(1, 2, 8, 16, 64, 4, 32;  23,   0,   0,   0)
//  channel   47: 52vyv(1, 2, 8, 16, 64, 4, 32;  23,   0,  23,   0)
//  channel   48: 14yyv(1, 2, 64, 4, 32, 8, 16;   0,   0,   0,   0)
//  channel   49: 14yyv(1, 2, 64, 4, 32, 8, 16;   0,   0,  23,   0)
//  channel   50: 14yyv(1, 2, 64, 4, 32, 8, 16;  23,   0,   0,   0)
//  channel   51: 14yyv(1, 2, 64, 4, 32, 8, 16;  23,   0,  23,   0)
//  channel   52: 14yyv(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
//  channel   53: 14yyv(1, 2, 64, 32, 4, 8, 16;   0,   0,  23,   0)
//  channel   54: 14yyv(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
//  channel   55: 14yyv(1, 2, 64, 32, 4, 8, 16;  23,   0,  23,   0)
//  channel   56: 14yyv(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
//  channel   57: 14yyv(1, 2, 64, 4, 16, 8, 32;   0,   0,  23,   0)
//  channel   58: 14yyv(1, 2, 64, 4, 16, 8, 32;  23,   0,   0,   0)
//  channel   59: 14yyv(1, 2, 64, 4, 16, 8, 32;  23,   0,  23,   0)
//  channel   60: 14yyv(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
//  channel   61: 14yyv(1, 2, 64, 16, 4, 8, 32;   0,   0,  23,   0)
//  channel   62: 14yyv(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
//  channel   63: 14yyv(1, 2, 64, 16, 4, 8, 32;  23,   0,  23,   0)
//  channel   64: 14yyv(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
//  channel   65: 14yyv(1, 2, 64, 8, 32, 4, 16;   0,   0,  23,   0)
//  channel   66: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,   0,   0)
//  channel   67: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  23,   0)
//  channel   68: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
//  channel   69: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  23,   0)
//  channel   70: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,   0,   0)
//  channel   71: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  23,   0)
//  channel   72: 14yyv(1, 2, 64, 8, 16, 4, 32;   0,   0,   0,   0)
//  channel   73: 14yyv(1, 2, 64, 8, 16, 4, 32;   0,   0,  23,   0)
//  channel   74: 14yyv(1, 2, 64, 8, 16, 4, 32;  23,   0,   0,   0)
//  channel   75: 14yyv(1, 2, 64, 8, 16, 4, 32;  23,   0,  23,   0)
//  channel   76: 14yyv(1, 2, 64, 16, 8, 4, 32;   0,   0,   0,   0)
//  channel   77: 14yyv(1, 2, 64, 16, 8, 4, 32;   0,   0,  23,   0)
//  channel   78: 14yyv(1, 2, 64, 16, 8, 4, 32;  23,   0,   0,   0)
//  channel   79: 14yyv(1, 2, 64, 16, 8, 4, 32;  23,   0,  23,   0)
//  channel   80: 3yv2v(1, 2, 64, 4, 32, 8, 16;   0,   0,   0,   0)
//  channel   81: 3yv2v(1, 2, 64, 4, 32, 8, 16;   0,  23,   0,   0)
//  channel   82: 3yv2v(1, 2, 64, 4, 32, 8, 16;  23,   0,   0,   0)
//  channel   83: 3yv2v(1, 2, 64, 4, 32, 8, 16;  23,  23,   0,   0)
//  channel   84: 3yv2v(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
//  channel   85: 3yv2v(1, 2, 64, 4, 16, 8, 32;   0,  23,   0,   0)
//  channel   86: 3yv2v(1, 2, 64, 4, 16, 8, 32;  23,   0,   0,   0)
//  channel   87: 3yv2v(1, 2, 64, 4, 16, 8, 32;  23,  23,   0,   0)
//  channel   88: 3yv2v(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
//  channel   89: 3yv2v(1, 2, 64, 8, 32, 4, 16;   0,  23,   0,   0)
//  channel   90: 3yv2v(1, 2, 64, 8, 32, 4, 16;  23,   0,   0,   0)
//  channel   91: 3yv2v(1, 2, 64, 8, 32, 4, 16;  23,  23,   0,   0)
//  channel   92: 3yv2v(1, 2, 64, 8, 16, 4, 32;   0,   0,   0,   0)
//  channel   93: 3yv2v(1, 2, 64, 8, 16, 4, 32;   0,  23,   0,   0)
//  channel   94: 3yv2v(1, 2, 64, 8, 16, 4, 32;  23,   0,   0,   0)
//  channel   95: 3yv2v(1, 2, 64, 8, 16, 4, 32;  23,  23,   0,   0)
//  channel   96: 12v2v(1, 2, 64, 4, 32, 8, 16;   0,   0,   0,   0)
//  channel   97: 12v2v(1, 2, 64, 4, 32, 8, 16;   0,  23,   0,   0)
//  channel   98: 12v2v(1, 2, 64, 4, 32, 8, 16;  23,   0,   0,   0)
//  channel   99: 12v2v(1, 2, 64, 4, 32, 8, 16;  23,  23,   0,   0)
//  channel  100: 12v2v(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
//  channel  101: 12v2v(1, 2, 64, 4, 16, 8, 32;   0,  23,   0,   0)
//  channel  102: 12v2v(1, 2, 64, 4, 16, 8, 32;  23,   0,   0,   0)
//  channel  103: 12v2v(1, 2, 64, 4, 16, 8, 32;  23,  23,   0,   0)
//  channel  104: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
//  channel  105: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,  23,   0,   0)
//  channel  106: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,   0,   0,   0)
//  channel  107: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,  23,   0,   0)
//  channel  108: 12v2v(1, 2, 64, 8, 16, 4, 32;   0,   0,   0,   0)
//  channel  109: 12v2v(1, 2, 64, 8, 16, 4, 32;   0,  23,   0,   0)
//  channel  110: 12v2v(1, 2, 64, 8, 16, 4, 32;  23,   0,   0,   0)
//  channel  111: 12v2v(1, 2, 64, 8, 16, 4, 32;  23,  23,   0,   0)

void ppeeexex04_phasespace_set::ax_psp_340_gdx_ememepepdx(int x_a){
  static Logger logger("ppeeexex04_phasespace_set::ax_psp_340_gdx_ememepepdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(22);
  needed_v_smin[x_a].resize(22);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   94,   95,   96,   97,   98,   99,  100,  101,  110,  111,  112,  113}; //  49
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 49);
  int needed_v_smin_1[] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 8);
  int needed_v_smin_3[] = {   4,    5,    6,    7}; //   4
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 4);
  int needed_v_smin_4[] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 8);
  int needed_v_smin_5[] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   86,   87,   88,   89,   90,   91,   92,   93,  102,  103,  104,  105,  106,  107,  108,  109}; //  49
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 49);
  int needed_v_smin_6[] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 4);
  int needed_v_smin_7[] = {  12,   13,   14,   15}; //   4
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 4);
  int needed_v_smin_8[] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 8);
  int needed_v_smin_9[] = {  16,   17,   18,   19,   20,   21,   22,   23,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   86,   87,   88,   89,   90,   91,   92,   93,  102,  103,  104,  105,  106,  107,  108,  109}; //  49
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 49);
  int needed_v_smin_10[] = {  16,   17,   18,   19}; //   4
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 4);
  int needed_v_smin_11[] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 8);
  int needed_v_smin_12[] = {  20,   21,   22,   23}; //   4
  needed_v_smin[x_a][ 12] = get_vector_from_array_int(needed_v_smin_12, 4);
  int needed_v_smin_13[] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   94,   95,   96,   97,   98,   99,  100,  101,  110,  111,  112,  113}; //  49
  needed_v_smin[x_a][ 13] = get_vector_from_array_int(needed_v_smin_13, 49);
  int needed_v_smin_14[] = {  24,   25,   26,   27}; //   4
  needed_v_smin[x_a][ 14] = get_vector_from_array_int(needed_v_smin_14, 4);
  int needed_v_smin_15[] = {  28,   29,   30,   31}; //   4
  needed_v_smin[x_a][ 15] = get_vector_from_array_int(needed_v_smin_15, 4);
  int needed_v_smin_16[] = {  32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81}; //  25
  needed_v_smin[x_a][ 16] = get_vector_from_array_int(needed_v_smin_16, 25);
  int needed_v_smin_17[] = {  41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73}; //  25
  needed_v_smin[x_a][ 17] = get_vector_from_array_int(needed_v_smin_17, 25);
  int needed_v_smin_18[] = {  82,   83,   84,   85,   98,   99,  100,  101}; //   8
  needed_v_smin[x_a][ 18] = get_vector_from_array_int(needed_v_smin_18, 8);
  int needed_v_smin_19[] = {  86,   87,   88,   89,  102,  103,  104,  105}; //   8
  needed_v_smin[x_a][ 19] = get_vector_from_array_int(needed_v_smin_19, 8);
  int needed_v_smin_20[] = {  90,   91,   92,   93,  106,  107,  108,  109}; //   8
  needed_v_smin[x_a][ 20] = get_vector_from_array_int(needed_v_smin_20, 8);
  int needed_v_smin_21[] = {  94,   95,   96,   97,  110,  111,  112,  113}; //   8
  needed_v_smin[x_a][ 21] = get_vector_from_array_int(needed_v_smin_21, 8);

  v_smax[x_a].resize(25);
  needed_v_smax[x_a].resize(25);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   82,   83,   84,   85,   98,   99,  100,  101}; //  33
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 33);
  int needed_v_smax_1[] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 8);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81}; //  82
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 82);
  int needed_v_smax_3[] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 8);
  int needed_v_smax_4[] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   86,   87,   88,   89,  102,  103,  104,  105}; //  33
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 33);
  int needed_v_smax_5[] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 8);
  int needed_v_smax_6[] = {  16,   17,   18,   19,   20,   21,   22,   23,   66,   67,   68,   69,   70,   71,   72,   73,   90,   91,   92,   93,  106,  107,  108,  109}; //  24
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 24);
  int needed_v_smax_7[] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 8);
  int needed_v_smax_8[] = {  24,   25,   26,   27,   28,   29,   30,   31,   74,   75,   76,   77,   78,   79,   80,   81,   94,   95,   96,   97,  110,  111,  112,  113}; //  24
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 24);
  int needed_v_smax_9[] = {  32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   98,   99,  100,  101}; //  21
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 21);
  int needed_v_smax_10[] = {  41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,  102,  103,  104,  105}; //  21
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 21);
  int needed_v_smax_11[] = {  66,   67,   68,   69,   70,   71,   72,   73,  106,  107,  108,  109}; //  12
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 12);
  int needed_v_smax_12[] = {  74,   75,   76,   77,   78,   79,   80,   81,  110,  111,  112,  113}; //  12
  needed_v_smax[x_a][ 12] = get_vector_from_array_int(needed_v_smax_12, 12);
  int needed_v_smax_13[] = {  82,   83,   84,   85}; //   4
  needed_v_smax[x_a][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  82,   83,   84,   85}; //   4
  needed_v_smax[x_a][ 14] = get_vector_from_array_int(needed_v_smax_14, 4);
  int needed_v_smax_15[] = {  86,   87,   88,   89}; //   4
  needed_v_smax[x_a][ 15] = get_vector_from_array_int(needed_v_smax_15, 4);
  int needed_v_smax_16[] = {  86,   87,   88,   89}; //   4
  needed_v_smax[x_a][ 16] = get_vector_from_array_int(needed_v_smax_16, 4);
  int needed_v_smax_17[] = {  90,   91,   92,   93}; //   4
  needed_v_smax[x_a][ 17] = get_vector_from_array_int(needed_v_smax_17, 4);
  int needed_v_smax_18[] = {  90,   91,   92,   93}; //   4
  needed_v_smax[x_a][ 18] = get_vector_from_array_int(needed_v_smax_18, 4);
  int needed_v_smax_19[] = {  94,   95,   96,   97}; //   4
  needed_v_smax[x_a][ 19] = get_vector_from_array_int(needed_v_smax_19, 4);
  int needed_v_smax_20[] = {  94,   95,   96,   97}; //   4
  needed_v_smax[x_a][ 20] = get_vector_from_array_int(needed_v_smax_20, 4);
  int needed_v_smax_21[] = {  98,   99,  100,  101}; //   4
  needed_v_smax[x_a][ 21] = get_vector_from_array_int(needed_v_smax_21, 4);
  int needed_v_smax_22[] = { 102,  103,  104,  105}; //   4
  needed_v_smax[x_a][ 22] = get_vector_from_array_int(needed_v_smax_22, 4);
  int needed_v_smax_23[] = { 106,  107,  108,  109}; //   4
  needed_v_smax[x_a][ 23] = get_vector_from_array_int(needed_v_smax_23, 4);
  int needed_v_smax_24[] = { 110,  111,  112,  113}; //   4
  needed_v_smax[x_a][ 24] = get_vector_from_array_int(needed_v_smax_24, 4);

  g_p[x_a].resize(50);
  needed_g_p[x_a].resize(50);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   32,   33,   34,   35,   50,   51,   52,   53,   82,   83,   98,   99}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,    8,   10}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,    9,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    6,    7,   36,   37,   38,   39,   40,   54,   55,   56,   57,   84,   85,  100,  101}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][5] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   4,    6,   20,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][7] = {   5,    7,   21,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][8] = {   8,    9,   12,   13,   41,   42,   43,   44,   58,   59,   60,   61,   86,   87,  102,  103}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][9] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");
  needed_g_p[x_a][10] = {  10,   11,   14,   15,   45,   46,   47,   48,   49,   62,   63,   64,   65,   88,   89,  104,  105}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax4");
  needed_g_p[x_a][11] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][12] = {  12,   14,   28,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][13] = {  13,   15,   29,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax2");
  needed_g_p[x_a][14] = {  16,   17,   20,   21,   66,   67,   68,   69,   90,   91,  106,  107}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax6");
  needed_g_p[x_a][15] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][16] = {  16,   18,   24,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax2");
  needed_g_p[x_a][17] = {  17,   19,   25,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][18] = {  18,   19,   22,   23,   70,   71,   72,   73,   92,   93,  108,  109}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax6");
  needed_g_p[x_a][19] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax3");
  needed_g_p[x_a][20] = {  24,   25,   28,   29,   74,   75,   76,   77,   94,   95,  110,  111}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax8");
  needed_g_p[x_a][21] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][22] = {  26,   27,   30,   31,   78,   79,   80,   81,   96,   97,  112,  113}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax8");
  needed_g_p[x_a][23] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax5");
  needed_g_p[x_a][24] = {  32,   33,   36,   37,   50,   51,   54,   55,   98,  100}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][25] = {  32,   34,   36,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax2");
  needed_g_p[x_a][26] = {  33,   35,   37,   40}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin16_smax2");
  needed_g_p[x_a][27] = {  34,   35,   38,   39,   40,   52,   53,   56,   57,   99,  101}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax9");
  needed_g_p[x_a][28] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin16_smax2");
  needed_g_p[x_a][29] = {  41,   42,   45,   46,   58,   59,   62,   63,  102,  104}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax10");
  needed_g_p[x_a][30] = {  41,   43,   45,   48}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax2");
  needed_g_p[x_a][31] = {  42,   44,   46,   49}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin17_smax2");
  needed_g_p[x_a][32] = {  43,   44,   47,   48,   49,   60,   61,   64,   65,  103,  105}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax10");
  needed_g_p[x_a][33] = {  47}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin17_smax2");
  needed_g_p[x_a][34] = {  66,   67,   70,   71,  106,  108}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax11");
  needed_g_p[x_a][35] = {  68,   69,   72,   73,  107,  109}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax11");
  needed_g_p[x_a][36] = {  74,   75,   78,   79,  110,  112}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax12");
  needed_g_p[x_a][37] = {  76,   77,   80,   81,  111,  113}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax12");
  needed_g_p[x_a][38] = {  82,   83,   84,   85}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax13");
  needed_g_p[x_a][39] = {  82,   84}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax14");
  needed_g_p[x_a][40] = {  83,   85}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax14");
  needed_g_p[x_a][41] = {  86,   87,   88,   89}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax15");
  needed_g_p[x_a][42] = {  86,   88}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax16");
  needed_g_p[x_a][43] = {  87,   89}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax16");
  needed_g_p[x_a][44] = {  90,   91,   92,   93}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax17");
  needed_g_p[x_a][45] = {  90,   92}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax18");
  needed_g_p[x_a][46] = {  91,   93}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax18");
  needed_g_p[x_a][47] = {  94,   95,   96,   97}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax19");
  needed_g_p[x_a][48] = {  94,   96}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax20");
  needed_g_p[x_a][49] = {  95,   97}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax20");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {  50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax2");
  needed_g_f[x_a][1] = {  58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax2");
  needed_g_f[x_a][2] = {  98,   99,  100,  101}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax21");
  needed_g_f[x_a][3] = { 102,  103,  104,  105}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax22");
  needed_g_f[x_a][4] = { 106,  107,  108,  109}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax23");
  needed_g_f[x_a][5] = { 110,  111,  112,  113}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax24");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81}; //  82
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  50,   52,   54,   56}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__36_24");
  needed_g_t[x_a][2] = {  51,   53,   55,   57}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__36_24");
  needed_g_t[x_a][3] = {  58,   60,   62,   64}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__20_40");
  needed_g_t[x_a][4] = {  59,   61,   63,   65}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__20_40");
  needed_g_t[x_a][5] = {  66,   68,   70,   72}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__40_20");
  needed_g_t[x_a][6] = {  67,   69,   71,   73}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__40_20");
  needed_g_t[x_a][7] = {  74,   76,   78,   80}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__24_36");
  needed_g_t[x_a][8] = {  75,   77,   79,   81}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__24_36");
  needed_g_t[x_a][9] = {  82,   83,   84,   85,   98,   99,  100,  101}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_88");
  needed_g_t[x_a][10] = {  86,   87,   88,   89,  102,  103,  104,  105}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_104");
  needed_g_t[x_a][11] = {  90,   91,   92,   93,  106,  107,  108,  109}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_84");
  needed_g_t[x_a][12] = {  94,   95,   96,   97,  110,  111,  112,  113}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_100");
  needed_g_t[x_a][13] = {  98,   99,  100,  101}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__24_64");
  needed_g_t[x_a][14] = { 102,  103,  104,  105}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_64");
  needed_g_t[x_a][15] = { 106,  107,  108,  109}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_64");
  needed_g_t[x_a][16] = { 110,  111,  112,  113}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__36_64");

  g_d[x_a].resize(22);
  needed_g_d[x_a].resize(22);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   94,   95,   96,   97,   98,   99,  100,  101,  110,  111,  112,  113}; //  49
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][6] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   86,   87,   88,   89,   90,   91,   92,   93,  102,  103,  104,  105,  106,  107,  108,  109}; //  49
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][7] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][9] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][11] = {  16,   17,   18,   19,   20,   21,   22,   23,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   86,   87,   88,   89,   90,   91,   92,   93,  102,  103,  104,  105,  106,  107,  108,  109}; //  49
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][12] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][13] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   94,   95,   96,   97,   98,   99,  100,  101,  110,  111,  112,  113}; //  49
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][16] = {  32,   33,   34,   35,   36,   37,   38,   39,   40}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][17] = {  41,   42,   43,   44,   45,   46,   47,   48,   49}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][18] = {  82,   83,   84,   85}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][19] = {  86,   87,   88,   89}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][20] = {  90,   91,   92,   93}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][21] = {  94,   95,   96,   97}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");

  c_p[x_a].resize(114);
  c_f[x_a].resize(114);
  c_t[x_a].resize(114);
  c_d[x_a].resize(114);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   1,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  4,   1,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   5,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   5,   7}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  4,   5,   6}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  3,   4,   2}; //   3

  c_p[x_a][7] = {  4,   5,   7}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  3,   4,   2}; //   3

  c_p[x_a][8] = {  8,   9,   2}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  0,   5,   6}; //   3

  c_p[x_a][9] = {  8,   9,   3}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  0,   5,   6}; //   3

  c_p[x_a][10] = { 10,   9,   2}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  0,   5,   6}; //   3

  c_p[x_a][11] = { 10,   9,   3}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  0,   5,   6}; //   3

  c_p[x_a][12] = {  8,  11,  12}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  7,   8,   6}; //   3

  c_p[x_a][13] = {  8,  11,  13}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  7,   8,   6}; //   3

  c_p[x_a][14] = { 10,  11,  12}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = {  7,   8,   6}; //   3

  c_p[x_a][15] = { 10,  11,  13}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = {  7,   8,   6}; //   3

  c_p[x_a][16] = { 14,  15,  16}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = {  9,  10,  11}; //   3

  c_p[x_a][17] = { 14,  15,  17}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = {  9,  10,  11}; //   3

  c_p[x_a][18] = { 18,  15,  16}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = {  9,  10,  11}; //   3

  c_p[x_a][19] = { 18,  15,  17}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = {  9,  10,  11}; //   3

  c_p[x_a][20] = { 14,  19,   6}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = {  3,  12,  11}; //   3

  c_p[x_a][21] = { 14,  19,   7}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = {  3,  12,  11}; //   3

  c_p[x_a][22] = { 18,  19,   6}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = {  3,  12,  11}; //   3

  c_p[x_a][23] = { 18,  19,   7}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = {  3,  12,  11}; //   3

  c_p[x_a][24] = { 20,  21,  16}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  9,  13,  14}; //   3

  c_p[x_a][25] = { 20,  21,  17}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  9,  13,  14}; //   3

  c_p[x_a][26] = { 22,  21,  16}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  9,  13,  14}; //   3

  c_p[x_a][27] = { 22,  21,  17}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  9,  13,  14}; //   3

  c_p[x_a][28] = { 20,  23,  12}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = {  7,  15,  14}; //   3

  c_p[x_a][29] = { 20,  23,  13}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = {  7,  15,  14}; //   3

  c_p[x_a][30] = { 22,  23,  12}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = {  7,  15,  14}; //   3

  c_p[x_a][31] = { 22,  23,  13}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = {  7,  15,  14}; //   3

  c_p[x_a][32] = {  0,  24,  25}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  0}; //   1
  c_d[x_a][32] = { 16,  14,   2}; //   3

  c_p[x_a][33] = {  0,  24,  26}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  0}; //   1
  c_d[x_a][33] = { 16,  14,   2}; //   3

  c_p[x_a][34] = {  0,  27,  25}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  0}; //   1
  c_d[x_a][34] = { 16,  14,   2}; //   3

  c_p[x_a][35] = {  0,  27,  26}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  0}; //   1
  c_d[x_a][35] = { 16,  14,   2}; //   3

  c_p[x_a][36] = {  4,  24,  25}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  0}; //   1
  c_d[x_a][36] = { 16,  14,   2}; //   3

  c_p[x_a][37] = {  4,  24,  26}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  0}; //   1
  c_d[x_a][37] = { 16,  14,   2}; //   3

  c_p[x_a][38] = {  4,  27,  28}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  0}; //   1
  c_d[x_a][38] = { 16,  14,   2}; //   3

  c_p[x_a][39] = {  4,  27,  25}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  0}; //   1
  c_d[x_a][39] = { 16,  14,   2}; //   3

  c_p[x_a][40] = {  4,  27,  26}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  0}; //   1
  c_d[x_a][40] = { 16,  14,   2}; //   3

  c_p[x_a][41] = {  8,  29,  30}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  0}; //   1
  c_d[x_a][41] = { 17,  11,   6}; //   3

  c_p[x_a][42] = {  8,  29,  31}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  0}; //   1
  c_d[x_a][42] = { 17,  11,   6}; //   3

  c_p[x_a][43] = {  8,  32,  30}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  0}; //   1
  c_d[x_a][43] = { 17,  11,   6}; //   3

  c_p[x_a][44] = {  8,  32,  31}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  0}; //   1
  c_d[x_a][44] = { 17,  11,   6}; //   3

  c_p[x_a][45] = { 10,  29,  30}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  0}; //   1
  c_d[x_a][45] = { 17,  11,   6}; //   3

  c_p[x_a][46] = { 10,  29,  31}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  0}; //   1
  c_d[x_a][46] = { 17,  11,   6}; //   3

  c_p[x_a][47] = { 10,  32,  33}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  0}; //   1
  c_d[x_a][47] = { 17,  11,   6}; //   3

  c_p[x_a][48] = { 10,  32,  30}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  0}; //   1
  c_d[x_a][48] = { 17,  11,   6}; //   3

  c_p[x_a][49] = { 10,  32,  31}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  0}; //   1
  c_d[x_a][49] = { 17,  11,   6}; //   3

  c_p[x_a][50] = {  0,  24}; //   2
  c_f[x_a][50] = {  0}; //   1
  c_t[x_a][50] = {  0,   1}; //   2
  c_d[x_a][50] = { 14,   2}; //   2

  c_p[x_a][51] = {  0,  24}; //   2
  c_f[x_a][51] = {  0}; //   1
  c_t[x_a][51] = {  0,   2}; //   2
  c_d[x_a][51] = { 14,   2}; //   2

  c_p[x_a][52] = {  0,  27}; //   2
  c_f[x_a][52] = {  0}; //   1
  c_t[x_a][52] = {  0,   1}; //   2
  c_d[x_a][52] = { 14,   2}; //   2

  c_p[x_a][53] = {  0,  27}; //   2
  c_f[x_a][53] = {  0}; //   1
  c_t[x_a][53] = {  0,   2}; //   2
  c_d[x_a][53] = { 14,   2}; //   2

  c_p[x_a][54] = {  4,  24}; //   2
  c_f[x_a][54] = {  0}; //   1
  c_t[x_a][54] = {  0,   1}; //   2
  c_d[x_a][54] = { 14,   2}; //   2

  c_p[x_a][55] = {  4,  24}; //   2
  c_f[x_a][55] = {  0}; //   1
  c_t[x_a][55] = {  0,   2}; //   2
  c_d[x_a][55] = { 14,   2}; //   2

  c_p[x_a][56] = {  4,  27}; //   2
  c_f[x_a][56] = {  0}; //   1
  c_t[x_a][56] = {  0,   1}; //   2
  c_d[x_a][56] = { 14,   2}; //   2

  c_p[x_a][57] = {  4,  27}; //   2
  c_f[x_a][57] = {  0}; //   1
  c_t[x_a][57] = {  0,   2}; //   2
  c_d[x_a][57] = { 14,   2}; //   2

  c_p[x_a][58] = {  8,  29}; //   2
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  0,   3}; //   2
  c_d[x_a][58] = { 11,   6}; //   2

  c_p[x_a][59] = {  8,  29}; //   2
  c_f[x_a][59] = {  1}; //   1
  c_t[x_a][59] = {  0,   4}; //   2
  c_d[x_a][59] = { 11,   6}; //   2

  c_p[x_a][60] = {  8,  32}; //   2
  c_f[x_a][60] = {  1}; //   1
  c_t[x_a][60] = {  0,   3}; //   2
  c_d[x_a][60] = { 11,   6}; //   2

  c_p[x_a][61] = {  8,  32}; //   2
  c_f[x_a][61] = {  1}; //   1
  c_t[x_a][61] = {  0,   4}; //   2
  c_d[x_a][61] = { 11,   6}; //   2

  c_p[x_a][62] = { 10,  29}; //   2
  c_f[x_a][62] = {  1}; //   1
  c_t[x_a][62] = {  0,   3}; //   2
  c_d[x_a][62] = { 11,   6}; //   2

  c_p[x_a][63] = { 10,  29}; //   2
  c_f[x_a][63] = {  1}; //   1
  c_t[x_a][63] = {  0,   4}; //   2
  c_d[x_a][63] = { 11,   6}; //   2

  c_p[x_a][64] = { 10,  32}; //   2
  c_f[x_a][64] = {  1}; //   1
  c_t[x_a][64] = {  0,   3}; //   2
  c_d[x_a][64] = { 11,   6}; //   2

  c_p[x_a][65] = { 10,  32}; //   2
  c_f[x_a][65] = {  1}; //   1
  c_t[x_a][65] = {  0,   4}; //   2
  c_d[x_a][65] = { 11,   6}; //   2

  c_p[x_a][66] = { 14,  34}; //   2
  c_f[x_a][66] = {  1}; //   1
  c_t[x_a][66] = {  0,   5}; //   2
  c_d[x_a][66] = {  6,  11}; //   2

  c_p[x_a][67] = { 14,  34}; //   2
  c_f[x_a][67] = {  1}; //   1
  c_t[x_a][67] = {  0,   6}; //   2
  c_d[x_a][67] = {  6,  11}; //   2

  c_p[x_a][68] = { 14,  35}; //   2
  c_f[x_a][68] = {  1}; //   1
  c_t[x_a][68] = {  0,   5}; //   2
  c_d[x_a][68] = {  6,  11}; //   2

  c_p[x_a][69] = { 14,  35}; //   2
  c_f[x_a][69] = {  1}; //   1
  c_t[x_a][69] = {  0,   6}; //   2
  c_d[x_a][69] = {  6,  11}; //   2

  c_p[x_a][70] = { 18,  34}; //   2
  c_f[x_a][70] = {  1}; //   1
  c_t[x_a][70] = {  0,   5}; //   2
  c_d[x_a][70] = {  6,  11}; //   2

  c_p[x_a][71] = { 18,  34}; //   2
  c_f[x_a][71] = {  1}; //   1
  c_t[x_a][71] = {  0,   6}; //   2
  c_d[x_a][71] = {  6,  11}; //   2

  c_p[x_a][72] = { 18,  35}; //   2
  c_f[x_a][72] = {  1}; //   1
  c_t[x_a][72] = {  0,   5}; //   2
  c_d[x_a][72] = {  6,  11}; //   2

  c_p[x_a][73] = { 18,  35}; //   2
  c_f[x_a][73] = {  1}; //   1
  c_t[x_a][73] = {  0,   6}; //   2
  c_d[x_a][73] = {  6,  11}; //   2

  c_p[x_a][74] = { 20,  36}; //   2
  c_f[x_a][74] = {  0}; //   1
  c_t[x_a][74] = {  0,   7}; //   2
  c_d[x_a][74] = {  2,  14}; //   2

  c_p[x_a][75] = { 20,  36}; //   2
  c_f[x_a][75] = {  0}; //   1
  c_t[x_a][75] = {  0,   8}; //   2
  c_d[x_a][75] = {  2,  14}; //   2

  c_p[x_a][76] = { 20,  37}; //   2
  c_f[x_a][76] = {  0}; //   1
  c_t[x_a][76] = {  0,   7}; //   2
  c_d[x_a][76] = {  2,  14}; //   2

  c_p[x_a][77] = { 20,  37}; //   2
  c_f[x_a][77] = {  0}; //   1
  c_t[x_a][77] = {  0,   8}; //   2
  c_d[x_a][77] = {  2,  14}; //   2

  c_p[x_a][78] = { 22,  36}; //   2
  c_f[x_a][78] = {  0}; //   1
  c_t[x_a][78] = {  0,   7}; //   2
  c_d[x_a][78] = {  2,  14}; //   2

  c_p[x_a][79] = { 22,  36}; //   2
  c_f[x_a][79] = {  0}; //   1
  c_t[x_a][79] = {  0,   8}; //   2
  c_d[x_a][79] = {  2,  14}; //   2

  c_p[x_a][80] = { 22,  37}; //   2
  c_f[x_a][80] = {  0}; //   1
  c_t[x_a][80] = {  0,   7}; //   2
  c_d[x_a][80] = {  2,  14}; //   2

  c_p[x_a][81] = { 22,  37}; //   2
  c_f[x_a][81] = {  0}; //   1
  c_t[x_a][81] = {  0,   8}; //   2
  c_d[x_a][81] = {  2,  14}; //   2

  c_p[x_a][82] = {  0,  38,  39}; //   3
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = {  9}; //   1
  c_d[x_a][82] = { 14,  18,   2}; //   3

  c_p[x_a][83] = {  0,  38,  40}; //   3
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = {  9}; //   1
  c_d[x_a][83] = { 14,  18,   2}; //   3

  c_p[x_a][84] = {  4,  38,  39}; //   3
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = {  9}; //   1
  c_d[x_a][84] = { 14,  18,   2}; //   3

  c_p[x_a][85] = {  4,  38,  40}; //   3
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = {  9}; //   1
  c_d[x_a][85] = { 14,  18,   2}; //   3

  c_p[x_a][86] = {  8,  41,  42}; //   3
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = { 10}; //   1
  c_d[x_a][86] = { 11,  19,   6}; //   3

  c_p[x_a][87] = {  8,  41,  43}; //   3
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = { 10}; //   1
  c_d[x_a][87] = { 11,  19,   6}; //   3

  c_p[x_a][88] = { 10,  41,  42}; //   3
  c_f[x_a][88] = {}; //   0
  c_t[x_a][88] = { 10}; //   1
  c_d[x_a][88] = { 11,  19,   6}; //   3

  c_p[x_a][89] = { 10,  41,  43}; //   3
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = { 10}; //   1
  c_d[x_a][89] = { 11,  19,   6}; //   3

  c_p[x_a][90] = { 14,  44,  45}; //   3
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = { 11}; //   1
  c_d[x_a][90] = {  6,  20,  11}; //   3

  c_p[x_a][91] = { 14,  44,  46}; //   3
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = { 11}; //   1
  c_d[x_a][91] = {  6,  20,  11}; //   3

  c_p[x_a][92] = { 18,  44,  45}; //   3
  c_f[x_a][92] = {}; //   0
  c_t[x_a][92] = { 11}; //   1
  c_d[x_a][92] = {  6,  20,  11}; //   3

  c_p[x_a][93] = { 18,  44,  46}; //   3
  c_f[x_a][93] = {}; //   0
  c_t[x_a][93] = { 11}; //   1
  c_d[x_a][93] = {  6,  20,  11}; //   3

  c_p[x_a][94] = { 20,  47,  48}; //   3
  c_f[x_a][94] = {}; //   0
  c_t[x_a][94] = { 12}; //   1
  c_d[x_a][94] = {  2,  21,  14}; //   3

  c_p[x_a][95] = { 20,  47,  49}; //   3
  c_f[x_a][95] = {}; //   0
  c_t[x_a][95] = { 12}; //   1
  c_d[x_a][95] = {  2,  21,  14}; //   3

  c_p[x_a][96] = { 22,  47,  48}; //   3
  c_f[x_a][96] = {}; //   0
  c_t[x_a][96] = { 12}; //   1
  c_d[x_a][96] = {  2,  21,  14}; //   3

  c_p[x_a][97] = { 22,  47,  49}; //   3
  c_f[x_a][97] = {}; //   0
  c_t[x_a][97] = { 12}; //   1
  c_d[x_a][97] = {  2,  21,  14}; //   3

  c_p[x_a][98] = {  0,  24}; //   2
  c_f[x_a][98] = {  2}; //   1
  c_t[x_a][98] = {  9,  13}; //   2
  c_d[x_a][98] = { 14,   2}; //   2

  c_p[x_a][99] = {  0,  27}; //   2
  c_f[x_a][99] = {  2}; //   1
  c_t[x_a][99] = {  9,  13}; //   2
  c_d[x_a][99] = { 14,   2}; //   2

  c_p[x_a][100] = {  4,  24}; //   2
  c_f[x_a][100] = {  2}; //   1
  c_t[x_a][100] = {  9,  13}; //   2
  c_d[x_a][100] = { 14,   2}; //   2

  c_p[x_a][101] = {  4,  27}; //   2
  c_f[x_a][101] = {  2}; //   1
  c_t[x_a][101] = {  9,  13}; //   2
  c_d[x_a][101] = { 14,   2}; //   2

  c_p[x_a][102] = {  8,  29}; //   2
  c_f[x_a][102] = {  3}; //   1
  c_t[x_a][102] = { 10,  14}; //   2
  c_d[x_a][102] = { 11,   6}; //   2

  c_p[x_a][103] = {  8,  32}; //   2
  c_f[x_a][103] = {  3}; //   1
  c_t[x_a][103] = { 10,  14}; //   2
  c_d[x_a][103] = { 11,   6}; //   2

  c_p[x_a][104] = { 10,  29}; //   2
  c_f[x_a][104] = {  3}; //   1
  c_t[x_a][104] = { 10,  14}; //   2
  c_d[x_a][104] = { 11,   6}; //   2

  c_p[x_a][105] = { 10,  32}; //   2
  c_f[x_a][105] = {  3}; //   1
  c_t[x_a][105] = { 10,  14}; //   2
  c_d[x_a][105] = { 11,   6}; //   2

  c_p[x_a][106] = { 14,  34}; //   2
  c_f[x_a][106] = {  4}; //   1
  c_t[x_a][106] = { 11,  15}; //   2
  c_d[x_a][106] = {  6,  11}; //   2

  c_p[x_a][107] = { 14,  35}; //   2
  c_f[x_a][107] = {  4}; //   1
  c_t[x_a][107] = { 11,  15}; //   2
  c_d[x_a][107] = {  6,  11}; //   2

  c_p[x_a][108] = { 18,  34}; //   2
  c_f[x_a][108] = {  4}; //   1
  c_t[x_a][108] = { 11,  15}; //   2
  c_d[x_a][108] = {  6,  11}; //   2

  c_p[x_a][109] = { 18,  35}; //   2
  c_f[x_a][109] = {  4}; //   1
  c_t[x_a][109] = { 11,  15}; //   2
  c_d[x_a][109] = {  6,  11}; //   2

  c_p[x_a][110] = { 20,  36}; //   2
  c_f[x_a][110] = {  5}; //   1
  c_t[x_a][110] = { 12,  16}; //   2
  c_d[x_a][110] = {  2,  14}; //   2

  c_p[x_a][111] = { 20,  37}; //   2
  c_f[x_a][111] = {  5}; //   1
  c_t[x_a][111] = { 12,  16}; //   2
  c_d[x_a][111] = {  2,  14}; //   2

  c_p[x_a][112] = { 22,  36}; //   2
  c_f[x_a][112] = {  5}; //   1
  c_t[x_a][112] = { 12,  16}; //   2
  c_d[x_a][112] = {  2,  14}; //   2

  c_p[x_a][113] = { 22,  37}; //   2
  c_f[x_a][113] = {  5}; //   1
  c_t[x_a][113] = { 12,  16}; //   2
  c_d[x_a][113] = {  2,  14}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_gdx_ememepepdx
//  channel    0: 4yyv1(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
//  channel    1: 4yyv1(1, 2, 4, 32, 8, 16, 64;   0,   0,  23,   0)
//  channel    2: 4yyv1(1, 2, 4, 32, 8, 16, 64;  23,   0,   0,   0)
//  channel    3: 4yyv1(1, 2, 4, 32, 8, 16, 64;  23,   0,  23,   0)
//  channel    4: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
//  channel    5: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,   0,  23,   0)
//  channel    6: 4yyv1(1, 2, 32, 4, 8, 16, 64;  23,   0,   0,   0)
//  channel    7: 4yyv1(1, 2, 32, 4, 8, 16, 64;  23,   0,  23,   0)
//  channel    8: 4yyv1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
//  channel    9: 4yyv1(1, 2, 4, 16, 8, 32, 64;   0,   0,  23,   0)
//  channel   10: 4yyv1(1, 2, 4, 16, 8, 32, 64;  23,   0,   0,   0)
//  channel   11: 4yyv1(1, 2, 4, 16, 8, 32, 64;  23,   0,  23,   0)
//  channel   12: 4yyv1(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
//  channel   13: 4yyv1(1, 2, 16, 4, 8, 32, 64;   0,   0,  23,   0)
//  channel   14: 4yyv1(1, 2, 16, 4, 8, 32, 64;  23,   0,   0,   0)
//  channel   15: 4yyv1(1, 2, 16, 4, 8, 32, 64;  23,   0,  23,   0)
//  channel   16: 4yyv1(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
//  channel   17: 4yyv1(1, 2, 8, 32, 4, 16, 64;   0,   0,  23,   0)
//  channel   18: 4yyv1(1, 2, 8, 32, 4, 16, 64;  23,   0,   0,   0)
//  channel   19: 4yyv1(1, 2, 8, 32, 4, 16, 64;  23,   0,  23,   0)
//  channel   20: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
//  channel   21: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,  23,   0)
//  channel   22: 4yyv1(1, 2, 32, 8, 4, 16, 64;  23,   0,   0,   0)
//  channel   23: 4yyv1(1, 2, 32, 8, 4, 16, 64;  23,   0,  23,   0)
//  channel   24: 4yyv1(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
//  channel   25: 4yyv1(1, 2, 8, 16, 4, 32, 64;   0,   0,  23,   0)
//  channel   26: 4yyv1(1, 2, 8, 16, 4, 32, 64;  23,   0,   0,   0)
//  channel   27: 4yyv1(1, 2, 8, 16, 4, 32, 64;  23,   0,  23,   0)
//  channel   28: 4yyv1(1, 2, 16, 8, 4, 32, 64;   0,   0,   0,   0)
//  channel   29: 4yyv1(1, 2, 16, 8, 4, 32, 64;   0,   0,  23,   0)
//  channel   30: 4yyv1(1, 2, 16, 8, 4, 32, 64;  23,   0,   0,   0)
//  channel   31: 4yyv1(1, 2, 16, 8, 4, 32, 64;  23,   0,  23,   0)
//  channel   32: 42vv1(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
//  channel   33: 42vv1(1, 2, 4, 32, 8, 16, 64;   0,   0,  36,   0)
//  channel   34: 42vv1(1, 2, 4, 32, 8, 16, 64;   0,  23,   0,   0)
//  channel   35: 42vv1(1, 2, 4, 32, 8, 16, 64;   0,  23,  36,   0)
//  channel   36: 42vv1(1, 2, 4, 32, 8, 16, 64;  23,   0,   0,   0)
//  channel   37: 42vv1(1, 2, 4, 32, 8, 16, 64;  23,   0,  36,   0)
//  channel   38: 42vv1(1, 2, 4, 32, 8, 16, 64;  23,  23,  25,   0)
//  channel   39: 42vv1(1, 2, 4, 32, 8, 16, 64;  23,  23,   0,   0)
//  channel   40: 42vv1(1, 2, 4, 32, 8, 16, 64;  23,  23,  36,   0)
//  channel   41: 42vv1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
//  channel   42: 42vv1(1, 2, 4, 16, 8, 32, 64;   0,   0,  36,   0)
//  channel   43: 42vv1(1, 2, 4, 16, 8, 32, 64;   0,  23,   0,   0)
//  channel   44: 42vv1(1, 2, 4, 16, 8, 32, 64;   0,  23,  36,   0)
//  channel   45: 42vv1(1, 2, 4, 16, 8, 32, 64;  23,   0,   0,   0)
//  channel   46: 42vv1(1, 2, 4, 16, 8, 32, 64;  23,   0,  36,   0)
//  channel   47: 42vv1(1, 2, 4, 16, 8, 32, 64;  23,  23,  25,   0)
//  channel   48: 42vv1(1, 2, 4, 16, 8, 32, 64;  23,  23,   0,   0)
//  channel   49: 42vv1(1, 2, 4, 16, 8, 32, 64;  23,  23,  36,   0)
//  channel   50: 2v2v1(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
//  channel   51: 2v2v1(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,  36)
//  channel   52: 2v2v1(1, 2, 4, 32, 8, 16, 64;   0,  23,   0,   0)
//  channel   53: 2v2v1(1, 2, 4, 32, 8, 16, 64;   0,  23,   0,  36)
//  channel   54: 2v2v1(1, 2, 4, 32, 8, 16, 64;  23,   0,   0,   0)
//  channel   55: 2v2v1(1, 2, 4, 32, 8, 16, 64;  23,   0,   0,  36)
//  channel   56: 2v2v1(1, 2, 4, 32, 8, 16, 64;  23,  23,   0,   0)
//  channel   57: 2v2v1(1, 2, 4, 32, 8, 16, 64;  23,  23,   0,  36)
//  channel   58: 2v2v1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
//  channel   59: 2v2v1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,  36)
//  channel   60: 2v2v1(1, 2, 4, 16, 8, 32, 64;   0,  23,   0,   0)
//  channel   61: 2v2v1(1, 2, 4, 16, 8, 32, 64;   0,  23,   0,  36)
//  channel   62: 2v2v1(1, 2, 4, 16, 8, 32, 64;  23,   0,   0,   0)
//  channel   63: 2v2v1(1, 2, 4, 16, 8, 32, 64;  23,   0,   0,  36)
//  channel   64: 2v2v1(1, 2, 4, 16, 8, 32, 64;  23,  23,   0,   0)
//  channel   65: 2v2v1(1, 2, 4, 16, 8, 32, 64;  23,  23,   0,  36)
//  channel   66: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
//  channel   67: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,  36)
//  channel   68: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,  23,   0,   0)
//  channel   69: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,  23,   0,  36)
//  channel   70: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,   0,   0,   0)
//  channel   71: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,   0,   0,  36)
//  channel   72: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,  23,   0,   0)
//  channel   73: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,  23,   0,  36)
//  channel   74: 2v2v1(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
//  channel   75: 2v2v1(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,  36)
//  channel   76: 2v2v1(1, 2, 8, 16, 4, 32, 64;   0,  23,   0,   0)
//  channel   77: 2v2v1(1, 2, 8, 16, 4, 32, 64;   0,  23,   0,  36)
//  channel   78: 2v2v1(1, 2, 8, 16, 4, 32, 64;  23,   0,   0,   0)
//  channel   79: 2v2v1(1, 2, 8, 16, 4, 32, 64;  23,   0,   0,  36)
//  channel   80: 2v2v1(1, 2, 8, 16, 4, 32, 64;  23,  23,   0,   0)
//  channel   81: 2v2v1(1, 2, 8, 16, 4, 32, 64;  23,  23,   0,  36)
//  channel   82: 2v3yv(1, 2, 4, 32, 64, 8, 16;   0,   0,   0,   0)
//  channel   83: 2v3yv(1, 2, 4, 32, 64, 8, 16;   0,   0,  23,   0)
//  channel   84: 2v3yv(1, 2, 4, 32, 64, 8, 16;  23,   0,   0,   0)
//  channel   85: 2v3yv(1, 2, 4, 32, 64, 8, 16;  23,   0,  23,   0)
//  channel   86: 2v3yv(1, 2, 4, 16, 64, 8, 32;   0,   0,   0,   0)
//  channel   87: 2v3yv(1, 2, 4, 16, 64, 8, 32;   0,   0,  23,   0)
//  channel   88: 2v3yv(1, 2, 4, 16, 64, 8, 32;  23,   0,   0,   0)
//  channel   89: 2v3yv(1, 2, 4, 16, 64, 8, 32;  23,   0,  23,   0)
//  channel   90: 2v3yv(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
//  channel   91: 2v3yv(1, 2, 8, 32, 64, 4, 16;   0,   0,  23,   0)
//  channel   92: 2v3yv(1, 2, 8, 32, 64, 4, 16;  23,   0,   0,   0)
//  channel   93: 2v3yv(1, 2, 8, 32, 64, 4, 16;  23,   0,  23,   0)
//  channel   94: 2v3yv(1, 2, 8, 16, 64, 4, 32;   0,   0,   0,   0)
//  channel   95: 2v3yv(1, 2, 8, 16, 64, 4, 32;   0,   0,  23,   0)
//  channel   96: 2v3yv(1, 2, 8, 16, 64, 4, 32;  23,   0,   0,   0)
//  channel   97: 2v3yv(1, 2, 8, 16, 64, 4, 32;  23,   0,  23,   0)
//  channel   98: 2v12v(1, 2, 4, 32, 64, 8, 16;   0,   0,   0,   0)
//  channel   99: 2v12v(1, 2, 4, 32, 64, 8, 16;   0,  23,   0,   0)
//  channel  100: 2v12v(1, 2, 4, 32, 64, 8, 16;  23,   0,   0,   0)
//  channel  101: 2v12v(1, 2, 4, 32, 64, 8, 16;  23,  23,   0,   0)
//  channel  102: 2v12v(1, 2, 4, 16, 64, 8, 32;   0,   0,   0,   0)
//  channel  103: 2v12v(1, 2, 4, 16, 64, 8, 32;   0,  23,   0,   0)
//  channel  104: 2v12v(1, 2, 4, 16, 64, 8, 32;  23,   0,   0,   0)
//  channel  105: 2v12v(1, 2, 4, 16, 64, 8, 32;  23,  23,   0,   0)
//  channel  106: 2v12v(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
//  channel  107: 2v12v(1, 2, 8, 32, 64, 4, 16;   0,  23,   0,   0)
//  channel  108: 2v12v(1, 2, 8, 32, 64, 4, 16;  23,   0,   0,   0)
//  channel  109: 2v12v(1, 2, 8, 32, 64, 4, 16;  23,  23,   0,   0)
//  channel  110: 2v12v(1, 2, 8, 16, 64, 4, 32;   0,   0,   0,   0)
//  channel  111: 2v12v(1, 2, 8, 16, 64, 4, 32;   0,  23,   0,   0)
//  channel  112: 2v12v(1, 2, 8, 16, 64, 4, 32;  23,   0,   0,   0)
//  channel  113: 2v12v(1, 2, 8, 16, 64, 4, 32;  23,  23,   0,   0)
