#include "header.hpp"

#include "ppeeexnex04.phasespace.set.hpp"

void ppeeexnex04_phasespace_set::ax_psp_040_dux_ememepvex(int x_a){
  static Logger logger("ppeeexnex04_phasespace_set::ax_psp_040_dux_ememepvex");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(10);
  needed_v_smin[x_a].resize(10);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    8,    9,   12,   13,   18,   19}; //   9
  needed_v_smin[x_a][  1] = {   0}; //   1
  needed_v_smin[x_a][  2] = {   1,    2}; //   2
  needed_v_smin[x_a][  3] = {   3,   10,   11,   14,   15,   16,   17}; //   7
  needed_v_smin[x_a][  4] = {   3}; //   1
  needed_v_smin[x_a][  5] = {   4,    5,    6,   10,   11,   14,   15,   16,   17}; //   9
  needed_v_smin[x_a][  6] = {   4}; //   1
  needed_v_smin[x_a][  7] = {   5,    6}; //   2
  needed_v_smin[x_a][  8] = {   7,    8,    9,   12,   13,   18,   19}; //   7
  needed_v_smin[x_a][  9] = {   7}; //   1

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    8,    9,   12,   13}; //   7
  needed_v_smax[x_a][  1] = {   0,    3}; //   2
  needed_v_smax[x_a][  2] = {   1,    2,    5,    6}; //   4
  needed_v_smax[x_a][  3] = {   3,   10,   11,   14,   15}; //   5
  needed_v_smax[x_a][  4] = {   4,    5,    6,   16,   17}; //   5
  needed_v_smax[x_a][  5] = {   4,    7}; //   2
  needed_v_smax[x_a][  6] = {   7,   18,   19}; //   3
  needed_v_smax[x_a][  7] = {   8,    9,   12,   13}; //   4
  needed_v_smax[x_a][  8] = {  10,   11,   14,   15}; //   4
  needed_v_smax[x_a][  9] = {  16,   17}; //   2
  needed_v_smax[x_a][ 10] = {  18,   19}; //   2

  g_p[x_a].resize(18);
  needed_g_p[x_a].resize(18);
  needed_g_p[x_a][0] = {   0,    2,    9,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    8,   12}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   3,   10,   11,   14,   15}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {   4,    6,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax4");
  needed_g_p[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   5,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][9] = {   5,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][10] = {   7,   18,   19}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax6");
  needed_g_p[x_a][11] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax5");
  needed_g_p[x_a][12] = {   8,    9,   12,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax7");
  needed_g_p[x_a][13] = {  10,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax8");
  needed_g_p[x_a][14] = {  11,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax8");
  needed_g_p[x_a][15] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax9");
  needed_g_p[x_a][16] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax10");
  needed_g_p[x_a][17] = {  19}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax10");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_24");
  needed_g_t[x_a][1] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][2] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");
  needed_g_t[x_a][3] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(15);
  needed_g_d[x_a].resize(15);
  needed_g_d[x_a][0] = {   0,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    8,    9,   12,   13,   18,   19}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   1,    2,    5,    6}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   1,    2}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][6] = {   3,   10,   11,   14,   15,   16,   17}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][7] = {   4,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][9] = {   4,    5,    6,   10,   11,   14,   15,   16,   17}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][10] = {   5,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][11] = {   7}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][12] = {   7,    8,    9,   12,   13,   18,   19}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][13] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][14] = {  10,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(20);
  c_f[x_a].resize(20);
  c_t[x_a].resize(20);
  c_d[x_a].resize(20);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  2,   3}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  3,   4,   2}; //   3

  c_p[x_a][2] = {  0,   3}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  4,   5}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   5,   6}; //   3

  c_p[x_a][4] = {  6,   7}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  7,   8,   9}; //   3

  c_p[x_a][5] = {  8,   9}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  3,  10,   9}; //   3

  c_p[x_a][6] = {  6,   9}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  3,  10,   9}; //   3

  c_p[x_a][7] = { 10,  11}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  7,  11,  12}; //   3

  c_p[x_a][8] = {  2,  12}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 13,  12,   2}; //   3

  c_p[x_a][9] = {  0,  12}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 13,  12,   2}; //   3

  c_p[x_a][10] = {  4,  13}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 14,   9,   6}; //   3

  c_p[x_a][11] = {  4,  14}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 14,   9,   6}; //   3

  c_p[x_a][12] = {  2,  12}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 12,   2}; //   2

  c_p[x_a][13] = {  0,  12}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 12,   2}; //   2

  c_p[x_a][14] = {  4,  13}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  1}; //   1
  c_d[x_a][14] = {  9,   6}; //   2

  c_p[x_a][15] = {  4,  14}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  1}; //   1
  c_d[x_a][15] = {  9,   6}; //   2

  c_p[x_a][16] = {  8,  15}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = {  6,   9}; //   2

  c_p[x_a][17] = {  6,  15}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  2}; //   1
  c_d[x_a][17] = {  6,   9}; //   2

  c_p[x_a][18] = { 10,  16}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  3}; //   1
  c_d[x_a][18] = {  2,  12}; //   2

  c_p[x_a][19] = { 10,  17}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  3}; //   1
  c_d[x_a][19] = {  2,  12}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_040_dux_ememepvex
//  channel    0: 4yyv(1, 2, 4, 32, 8, 16;  23,   0,  24)
//  channel    1: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,  24)
//  channel    2: 4yyv(1, 2, 32, 4, 8, 16;  23,   0,  24)
//  channel    3: 4yyv(1, 2, 4, 16, 8, 32;  24,   0,  24)
//  channel    4: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,  24)
//  channel    5: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,  24)
//  channel    6: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,  24)
//  channel    7: 4yyv(1, 2, 8, 16, 4, 32;  24,   0,  24)
//  channel    8: 42vv(1, 2, 4, 32, 8, 16;   0,  24,  24)
//  channel    9: 42vv(1, 2, 4, 32, 8, 16;  23,  24,  24)
//  channel   10: 42vv(1, 2, 4, 16, 8, 32;  24,   0,  24)
//  channel   11: 42vv(1, 2, 4, 16, 8, 32;  24,  23,  24)
//  channel   12: 2v2v(1, 2, 4, 32, 8, 16;   0,  24,   0)
//  channel   13: 2v2v(1, 2, 4, 32, 8, 16;  23,  24,   0)
//  channel   14: 2v2v(1, 2, 4, 16, 8, 32;  24,   0,   0)
//  channel   15: 2v2v(1, 2, 4, 16, 8, 32;  24,  23,   0)
//  channel   16: 2v2v(1, 2, 8, 32, 4, 16;   0,  24,   0)
//  channel   17: 2v2v(1, 2, 8, 32, 4, 16;  23,  24,   0)
//  channel   18: 2v2v(1, 2, 8, 16, 4, 32;  24,   0,   0)
//  channel   19: 2v2v(1, 2, 8, 16, 4, 32;  24,  23,   0)
