#include "header.hpp"

#include "ppeeexnex04.phasespace.set.hpp"

void ppeeexnex04_phasespace_set::ax_psp_240_dux_ememepvexccx(int x_a){
  static Logger logger("ppeeexnex04_phasespace_set::ax_psp_240_dux_ememepvexccx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(28);
  needed_v_smin[x_a].resize(28);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,   16,   17,   20,   21,   22,   32,   33,   34,   35,   36,   37,   40,   41,   42,   43,   44,   45,   58,   59,   60,   61,   62,   63}; //  30
  needed_v_smin[x_a][  1] = {   0,    1,   32,   33}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,   32,   33}; //   4
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,   15,   16,   17,   31,   32,   33,   34,   35,   36,   37,   40,   41,   42,   43,   44,   45,   58,   59,   60,   61,   62,   63}; //  26
  needed_v_smin[x_a][  4] = {   2,    3,   34,   35}; //   4
  needed_v_smin[x_a][  5] = {   2,    3,   34,   35}; //   4
  needed_v_smin[x_a][  6] = {   4,   20}; //   2
  needed_v_smin[x_a][  7] = {   4,    7,   20,   23}; //   4
  needed_v_smin[x_a][  8] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  needed_v_smin[x_a][  9] = {   5,    6,   21,   22}; //   4
  needed_v_smin[x_a][ 10] = {   5,    6,   13,   14,   21,   22,   29,   30}; //   8
  needed_v_smin[x_a][ 11] = {   7,    8,    9,   10,   11,   18,   19,   23,   24,   25,   26,   27,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57}; //  26
  needed_v_smin[x_a][ 12] = {   7,   23}; //   2
  needed_v_smin[x_a][ 13] = {   8,    9,   10,   11,   12,   13,   14,   18,   19,   24,   25,   26,   27,   28,   29,   30,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57}; //  30
  needed_v_smin[x_a][ 14] = {   8,    9,   24,   25}; //   4
  needed_v_smin[x_a][ 15] = {   8,    9,   24,   25}; //   4
  needed_v_smin[x_a][ 16] = {  10,   11,   26,   27}; //   4
  needed_v_smin[x_a][ 17] = {  10,   11,   26,   27}; //   4
  needed_v_smin[x_a][ 18] = {  12,   28}; //   2
  needed_v_smin[x_a][ 19] = {  12,   15,   28,   31}; //   4
  needed_v_smin[x_a][ 20] = {  13,   14,   29,   30}; //   4
  needed_v_smin[x_a][ 21] = {  15,   31}; //   2
  needed_v_smin[x_a][ 22] = {  16,   17,   36,   37,   44,   45,   62,   63}; //   8
  needed_v_smin[x_a][ 23] = {  18,   19,   38,   39,   50,   51,   56,   57}; //   8
  needed_v_smin[x_a][ 24] = {  40,   41,   42,   43}; //   4
  needed_v_smin[x_a][ 25] = {  46,   47,   48,   49}; //   4
  needed_v_smin[x_a][ 26] = {  52,   53,   54,   55}; //   4
  needed_v_smin[x_a][ 27] = {  58,   59,   60,   61}; //   4

  v_smax[x_a].resize(48);
  needed_v_smax[x_a].resize(48);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,   16,   17,   42,   43,   44,   45}; //  13
  needed_v_smax[x_a][  1] = {   0,    1}; //   2
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  4] = {   2,    3}; //   2
  needed_v_smax[x_a][  5] = {   4,    7}; //   2
  needed_v_smax[x_a][  6] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19}; //  12
  needed_v_smax[x_a][  7] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19}; //  12
  needed_v_smax[x_a][  8] = {   5,    6,   13,   14}; //   4
  needed_v_smax[x_a][  9] = {   7,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51}; //  11
  needed_v_smax[x_a][ 10] = {   8,    9,   10,   11,   12,   13,   14,   54,   55,   56,   57}; //  11
  needed_v_smax[x_a][ 11] = {   8,    9}; //   2
  needed_v_smax[x_a][ 12] = {   8,    9,   10,   11}; //   4
  needed_v_smax[x_a][ 13] = {   8,    9,   10,   11}; //   4
  needed_v_smax[x_a][ 14] = {  10,   11}; //   2
  needed_v_smax[x_a][ 15] = {  12,   15}; //   2
  needed_v_smax[x_a][ 16] = {  15,   32,   33,   34,   35,   60,   61,   62,   63}; //   9
  needed_v_smax[x_a][ 17] = {  16,   17,   44,   45}; //   4
  needed_v_smax[x_a][ 18] = {  18,   19,   24,   25,   26,   27,   50,   51}; //   8
  needed_v_smax[x_a][ 19] = {  20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   40,   41,   46,   47,   52,   53,   58,   59}; //  20
  needed_v_smax[x_a][ 20] = {  20,   21,   22,   36,   37,   40,   41}; //   7
  needed_v_smax[x_a][ 21] = {  20,   23}; //   2
  needed_v_smax[x_a][ 22] = {  20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   44,   45,   50,   51,   56,   57,   62,   63}; //  20
  needed_v_smax[x_a][ 23] = {  21,   22,   29,   30}; //   4
  needed_v_smax[x_a][ 24] = {  23,   38,   39,   46,   47}; //   5
  needed_v_smax[x_a][ 25] = {  24,   25}; //   2
  needed_v_smax[x_a][ 26] = {  24,   25,   26,   27,   52,   53,   54,   55}; //   8
  needed_v_smax[x_a][ 27] = {  26,   27}; //   2
  needed_v_smax[x_a][ 28] = {  28,   29,   30,   52,   53}; //   5
  needed_v_smax[x_a][ 29] = {  28,   31}; //   2
  needed_v_smax[x_a][ 30] = {  31,   58,   59}; //   3
  needed_v_smax[x_a][ 31] = {  32,   33,   34,   35,   62,   63}; //   6
  needed_v_smax[x_a][ 32] = {  32,   33}; //   2
  needed_v_smax[x_a][ 33] = {  32,   33,   34,   35,   40,   41,   42,   43}; //   8
  needed_v_smax[x_a][ 34] = {  34,   35}; //   2
  needed_v_smax[x_a][ 35] = {  36,   37,   40,   41,   42,   43}; //   6
  needed_v_smax[x_a][ 36] = {  38,   39,   46,   47,   48,   49}; //   6
  needed_v_smax[x_a][ 37] = {  42,   43}; //   2
  needed_v_smax[x_a][ 38] = {  44,   45,   62,   63}; //   4
  needed_v_smax[x_a][ 39] = {  48,   49}; //   2
  needed_v_smax[x_a][ 40] = {  50,   51,   56,   57}; //   4
  needed_v_smax[x_a][ 41] = {  52,   53,   54,   55}; //   4
  needed_v_smax[x_a][ 42] = {  54,   55}; //   2
  needed_v_smax[x_a][ 43] = {  56,   57}; //   2
  needed_v_smax[x_a][ 44] = {  58,   59,   60,   61}; //   4
  needed_v_smax[x_a][ 45] = {  60,   61}; //   2
  needed_v_smax[x_a][ 46] = {  46,   47,   48,   49}; //   4
  needed_v_smax[x_a][ 47] = {  58,   59,   60,   61}; //   4

  g_p[x_a].resize(72);
  needed_g_p[x_a].resize(72);
  needed_g_p[x_a][0] = {   0,    2,    5,   16,   42,   44}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    4,    6,   17,   43,   45}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax2");
  needed_g_p[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   4,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax6");
  needed_g_p[x_a][9] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {   5,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax8");
  needed_g_p[x_a][11] = {   5,    6,   13,   14}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax6");
  needed_g_p[x_a][12] = {   7,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax9");
  needed_g_p[x_a][13] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax5");
  needed_g_p[x_a][14] = {   8,   10,   13,   54,   56}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][15] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][16] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][17] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax13");
  needed_g_p[x_a][18] = {   9,   11,   12,   14,   55,   57}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax10");
  needed_g_p[x_a][19] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax14");
  needed_g_p[x_a][20] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax12");
  needed_g_p[x_a][21] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax15");
  needed_g_p[x_a][22] = {  12,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin19_smax6");
  needed_g_p[x_a][23] = {  13,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax8");
  needed_g_p[x_a][24] = {  15,   32,   33,   34,   35,   60,   61,   62,   63}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax16");
  needed_g_p[x_a][25] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax15");
  needed_g_p[x_a][26] = {  16,   17,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax17");
  needed_g_p[x_a][27] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin22_smax6");
  needed_g_p[x_a][28] = {  18,   24,   26,   50}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax18");
  needed_g_p[x_a][29] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin23_smax6");
  needed_g_p[x_a][30] = {  19,   25,   27,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax18");
  needed_g_p[x_a][31] = {  20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   40,   41,   46,   47,   52,   53,   58,   59}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax19");
  needed_g_p[x_a][32] = {  20,   22,   37,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax20");
  needed_g_p[x_a][33] = {  20}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax21");
  needed_g_p[x_a][34] = {  20,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax22");
  needed_g_p[x_a][35] = {  21,   36,   40}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax20");
  needed_g_p[x_a][36] = {  21,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax23");
  needed_g_p[x_a][37] = {  21,   22,   29,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax22");
  needed_g_p[x_a][38] = {  23,   38,   39,   46,   47}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax24");
  needed_g_p[x_a][39] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax21");
  needed_g_p[x_a][40] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax25");
  needed_g_p[x_a][41] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax26");
  needed_g_p[x_a][42] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax27");
  needed_g_p[x_a][43] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax26");
  needed_g_p[x_a][44] = {  28,   30,   53}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax28");
  needed_g_p[x_a][45] = {  28}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax29");
  needed_g_p[x_a][46] = {  28,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin19_smax22");
  needed_g_p[x_a][47] = {  29,   52}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax28");
  needed_g_p[x_a][48] = {  29,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax23");
  needed_g_p[x_a][49] = {  31,   58,   59}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax30");
  needed_g_p[x_a][50] = {  31}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax29");
  needed_g_p[x_a][51] = {  32,   34,   62}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax31");
  needed_g_p[x_a][52] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax32");
  needed_g_p[x_a][53] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax33");
  needed_g_p[x_a][54] = {  33,   35,   63}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax31");
  needed_g_p[x_a][55] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax34");
  needed_g_p[x_a][56] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax33");
  needed_g_p[x_a][57] = {  36,   37,   40,   41,   42,   43}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax35");
  needed_g_p[x_a][58] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin22_smax22");
  needed_g_p[x_a][59] = {  38,   46,   48}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax36");
  needed_g_p[x_a][60] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin23_smax22");
  needed_g_p[x_a][61] = {  39,   47,   49}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax36");
  needed_g_p[x_a][62] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax37");
  needed_g_p[x_a][63] = {  44,   45,   62,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax38");
  needed_g_p[x_a][64] = {  48,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax39");
  needed_g_p[x_a][65] = {  50,   51,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax40");
  needed_g_p[x_a][66] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax41");
  needed_g_p[x_a][67] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax42");
  needed_g_p[x_a][68] = {  56,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax43");
  needed_g_p[x_a][69] = {  58,   60}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax44");
  needed_g_p[x_a][70] = {  59,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax44");
  needed_g_p[x_a][71] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax45");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax33");
  needed_g_f[x_a][1] = {  44,   45,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax22");
  needed_g_f[x_a][2] = {  46,   47,   48,   49}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax46");
  needed_g_f[x_a][3] = {  50,   51,   56,   57}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax22");
  needed_g_f[x_a][4] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax26");
  needed_g_f[x_a][5] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax47");

  g_t[x_a].resize(20);
  needed_g_t[x_a].resize(20);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,   40,   41,   42,   43}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_216");
  needed_g_t[x_a][1] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19,   44,   45,   50,   51,   56,   57,   62,   63}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][2] = {   8,    9,   10,   11,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_212");
  needed_g_t[x_a][3] = {  20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][4] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_212");
  needed_g_t[x_a][5] = {  32,   33,   34,   35}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_216");
  needed_g_t[x_a][6] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__192_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__192_24");
  needed_g_t[x_a][7] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__24_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__24_192");
  needed_g_t[x_a][8] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__24_36");
  needed_g_t[x_a][9] = {  46,   47,   48,   49}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_232");
  needed_g_t[x_a][10] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__192_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__192_40");
  needed_g_t[x_a][11] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_192");
  needed_g_t[x_a][12] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__40_20");
  needed_g_t[x_a][13] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__192_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__192_20");
  needed_g_t[x_a][14] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_192");
  needed_g_t[x_a][15] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__20_40");
  needed_g_t[x_a][16] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_228");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_228");
  needed_g_t[x_a][17] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__192_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__192_36");
  needed_g_t[x_a][18] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__36_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__36_192");
  needed_g_t[x_a][19] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__36_24");

  g_d[x_a].resize(24);
  needed_g_d[x_a].resize(24);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   15,   16,   17,   31,   32,   33,   34,   35,   36,   37,   40,   41,   42,   43,   44,   45,   58,   59,   60,   61,   62,   63}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {   0,    1,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_216__64_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_216__64_152");
  needed_g_d[x_a][2] = {   0,    1,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_152__128_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_152__128_24");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,    4,    5,    6,   16,   17,   20,   21,   22,   32,   33,   34,   35,   36,   37,   40,   41,   42,   43,   44,   45,   58,   59,   60,   61,   62,   63}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   2,    3,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_216__128_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_216__128_88");
  needed_g_d[x_a][5] = {   2,    3,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][6] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][7] = {   4,    7,   20,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][8] = {   4,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][9] = {   5,    6,   13,   14,   21,   22,   29,   30}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][10] = {   5,    6,   21,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][11] = {   7,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][12] = {   7,    8,    9,   10,   11,   18,   19,   23,   24,   25,   26,   27,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][13] = {   8,    9,   24,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_212__64_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_212__64_148");
  needed_g_d[x_a][14] = {   8,    9,   24,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][15] = {   8,    9,   10,   11,   12,   13,   14,   18,   19,   24,   25,   26,   27,   28,   29,   30,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][16] = {  10,   11,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_212__128_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_212__128_84");
  needed_g_d[x_a][17] = {  10,   11,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][18] = {  12,   15,   28,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][19] = {  12,   28}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][20] = {  13,   14,   29,   30}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][21] = {  15,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][22] = {  16,   17,   36,   37}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][23] = {  18,   19,   38,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   1,   2,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  0,   5,   6,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  4,   5,   6,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   4,   5,   3}; //   4

  c_p[x_a][4] = {  4,   7,   8,   9}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  1}; //   1
  c_d[x_a][4] = {  6,   7,   8,   3}; //   4

  c_p[x_a][5] = {  0,  10,  11,   9}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  1}; //   1
  c_d[x_a][5] = {  6,   9,  10,   3}; //   4

  c_p[x_a][6] = {  4,  10,  11,   9}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  1}; //   1
  c_d[x_a][6] = {  6,   9,  10,   3}; //   4

  c_p[x_a][7] = { 12,  13,   8,   9}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  1}; //   1
  c_d[x_a][7] = {  6,   7,  11,  12}; //   4

  c_p[x_a][8] = { 14,  15,  16,  17}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  2}; //   1
  c_d[x_a][8] = { 12,  13,  14,  15}; //   4

  c_p[x_a][9] = { 18,  15,  16,  17}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  2}; //   1
  c_d[x_a][9] = { 12,  13,  14,  15}; //   4

  c_p[x_a][10] = { 14,  19,  20,  17}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  2}; //   1
  c_d[x_a][10] = { 12,  16,  17,  15}; //   4

  c_p[x_a][11] = { 18,  19,  20,  17}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  2}; //   1
  c_d[x_a][11] = { 12,  16,  17,  15}; //   4

  c_p[x_a][12] = { 18,  21,  22,   9}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  1}; //   1
  c_d[x_a][12] = {  6,  18,  19,  15}; //   4

  c_p[x_a][13] = { 14,  23,  11,   9}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  1}; //   1
  c_d[x_a][13] = {  6,   9,  20,  15}; //   4

  c_p[x_a][14] = { 18,  23,  11,   9}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  1}; //   1
  c_d[x_a][14] = {  6,   9,  20,  15}; //   4

  c_p[x_a][15] = { 24,  25,  22,   9}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  1}; //   1
  c_d[x_a][15] = {  6,  18,  21,   0}; //   4

  c_p[x_a][16] = {  0,  26,  27,   9}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  1}; //   1
  c_d[x_a][16] = {  6,  22,   0,   3}; //   4

  c_p[x_a][17] = {  4,  26,  27,   9}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  1}; //   1
  c_d[x_a][17] = {  6,  22,   0,   3}; //   4

  c_p[x_a][18] = { 12,  28,  29,   9}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  1}; //   1
  c_d[x_a][18] = {  6,  23,  15,  12}; //   4

  c_p[x_a][19] = { 12,  30,  29,   9}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  1}; //   1
  c_d[x_a][19] = {  6,  23,  15,  12}; //   4

  c_p[x_a][20] = { 31,  32,  33,  34}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  3}; //   1
  c_d[x_a][20] = {  7,   8,   3,   6}; //   4

  c_p[x_a][21] = { 31,  35,  36,  37}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  3}; //   1
  c_d[x_a][21] = {  9,  10,   3,   6}; //   4

  c_p[x_a][22] = { 31,  32,  36,  37}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  3}; //   1
  c_d[x_a][22] = {  9,  10,   3,   6}; //   4

  c_p[x_a][23] = { 31,  38,  39,  34}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  3}; //   1
  c_d[x_a][23] = {  7,  11,  12,   6}; //   4

  c_p[x_a][24] = { 12,  28,  40,  41}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  4}; //   1
  c_d[x_a][24] = { 13,  14,  15,  12}; //   4

  c_p[x_a][25] = { 12,  30,  40,  41}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  4}; //   1
  c_d[x_a][25] = { 13,  14,  15,  12}; //   4

  c_p[x_a][26] = { 12,  28,  42,  43}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  4}; //   1
  c_d[x_a][26] = { 16,  17,  15,  12}; //   4

  c_p[x_a][27] = { 12,  30,  42,  43}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  4}; //   1
  c_d[x_a][27] = { 16,  17,  15,  12}; //   4

  c_p[x_a][28] = { 31,  44,  45,  46}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  3}; //   1
  c_d[x_a][28] = { 18,  19,  15,   6}; //   4

  c_p[x_a][29] = { 31,  47,  48,  37}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  3}; //   1
  c_d[x_a][29] = {  9,  20,  15,   6}; //   4

  c_p[x_a][30] = { 31,  44,  48,  37}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  3}; //   1
  c_d[x_a][30] = {  9,  20,  15,   6}; //   4

  c_p[x_a][31] = { 31,  49,  50,  46}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  3}; //   1
  c_d[x_a][31] = { 18,  21,   0,   6}; //   4

  c_p[x_a][32] = { 24,  51,  52,  53}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  5}; //   1
  c_d[x_a][32] = {  1,   2,   3,   0}; //   4

  c_p[x_a][33] = { 24,  54,  52,  53}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  5}; //   1
  c_d[x_a][33] = {  1,   2,   3,   0}; //   4

  c_p[x_a][34] = { 24,  51,  55,  56}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  5}; //   1
  c_d[x_a][34] = {  4,   5,   3,   0}; //   4

  c_p[x_a][35] = { 24,  54,  55,  56}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  5}; //   1
  c_d[x_a][35] = {  4,   5,   3,   0}; //   4

  c_p[x_a][36] = { 31,  35,  57,  58}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  3}; //   1
  c_d[x_a][36] = { 22,   0,   3,   6}; //   4

  c_p[x_a][37] = { 31,  32,  57,  58}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  3}; //   1
  c_d[x_a][37] = { 22,   0,   3,   6}; //   4

  c_p[x_a][38] = { 31,  38,  59,  60}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  3}; //   1
  c_d[x_a][38] = { 23,  15,  12,   6}; //   4

  c_p[x_a][39] = { 31,  38,  61,  60}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  3}; //   1
  c_d[x_a][39] = { 23,  15,  12,   6}; //   4

  c_p[x_a][40] = { 31,  35,  57}; //   3
  c_f[x_a][40] = {  0}; //   1
  c_t[x_a][40] = {  0,   6}; //   2
  c_d[x_a][40] = {  0,   3,   6}; //   3

  c_p[x_a][41] = { 31,  32,  57}; //   3
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  0,   6}; //   2
  c_d[x_a][41] = {  0,   3,   6}; //   3

  c_p[x_a][42] = {  0,  62,  57}; //   3
  c_f[x_a][42] = {  0}; //   1
  c_t[x_a][42] = {  0,   7}; //   2
  c_d[x_a][42] = {  0,   6,   3}; //   3

  c_p[x_a][43] = {  4,  62,  57}; //   3
  c_f[x_a][43] = {  0}; //   1
  c_t[x_a][43] = {  0,   7}; //   2
  c_d[x_a][43] = {  0,   6,   3}; //   3

  c_p[x_a][44] = {  0,  26,  63}; //   3
  c_f[x_a][44] = {  1}; //   1
  c_t[x_a][44] = {  1,   8}; //   2
  c_d[x_a][44] = {  6,   0,   3}; //   3

  c_p[x_a][45] = {  4,  26,  63}; //   3
  c_f[x_a][45] = {  1}; //   1
  c_t[x_a][45] = {  1,   8}; //   2
  c_d[x_a][45] = {  6,   0,   3}; //   3

  c_p[x_a][46] = { 31,  38,  59}; //   3
  c_f[x_a][46] = {  2}; //   1
  c_t[x_a][46] = {  9,  10}; //   2
  c_d[x_a][46] = { 15,  12,   6}; //   3

  c_p[x_a][47] = { 31,  38,  61}; //   3
  c_f[x_a][47] = {  2}; //   1
  c_t[x_a][47] = {  9,  10}; //   2
  c_d[x_a][47] = { 15,  12,   6}; //   3

  c_p[x_a][48] = { 12,  64,  59}; //   3
  c_f[x_a][48] = {  2}; //   1
  c_t[x_a][48] = {  9,  11}; //   2
  c_d[x_a][48] = { 15,   6,  12}; //   3

  c_p[x_a][49] = { 12,  64,  61}; //   3
  c_f[x_a][49] = {  2}; //   1
  c_t[x_a][49] = {  9,  11}; //   2
  c_d[x_a][49] = { 15,   6,  12}; //   3

  c_p[x_a][50] = { 12,  28,  65}; //   3
  c_f[x_a][50] = {  3}; //   1
  c_t[x_a][50] = {  1,  12}; //   2
  c_d[x_a][50] = {  6,  15,  12}; //   3

  c_p[x_a][51] = { 12,  30,  65}; //   3
  c_f[x_a][51] = {  3}; //   1
  c_t[x_a][51] = {  1,  12}; //   2
  c_d[x_a][51] = {  6,  15,  12}; //   3

  c_p[x_a][52] = { 31,  47,  66}; //   3
  c_f[x_a][52] = {  4}; //   1
  c_t[x_a][52] = {  2,  13}; //   2
  c_d[x_a][52] = { 12,  15,   6}; //   3

  c_p[x_a][53] = { 31,  44,  66}; //   3
  c_f[x_a][53] = {  4}; //   1
  c_t[x_a][53] = {  2,  13}; //   2
  c_d[x_a][53] = { 12,  15,   6}; //   3

  c_p[x_a][54] = { 14,  67,  66}; //   3
  c_f[x_a][54] = {  4}; //   1
  c_t[x_a][54] = {  2,  14}; //   2
  c_d[x_a][54] = { 12,   6,  15}; //   3

  c_p[x_a][55] = { 18,  67,  66}; //   3
  c_f[x_a][55] = {  4}; //   1
  c_t[x_a][55] = {  2,  14}; //   2
  c_d[x_a][55] = { 12,   6,  15}; //   3

  c_p[x_a][56] = { 14,  68,  65}; //   3
  c_f[x_a][56] = {  3}; //   1
  c_t[x_a][56] = {  1,  15}; //   2
  c_d[x_a][56] = {  6,  12,  15}; //   3

  c_p[x_a][57] = { 18,  68,  65}; //   3
  c_f[x_a][57] = {  3}; //   1
  c_t[x_a][57] = {  1,  15}; //   2
  c_d[x_a][57] = {  6,  12,  15}; //   3

  c_p[x_a][58] = { 31,  49,  69}; //   3
  c_f[x_a][58] = {  5}; //   1
  c_t[x_a][58] = { 16,  17}; //   2
  c_d[x_a][58] = {  3,   0,   6}; //   3

  c_p[x_a][59] = { 31,  49,  70}; //   3
  c_f[x_a][59] = {  5}; //   1
  c_t[x_a][59] = { 16,  17}; //   2
  c_d[x_a][59] = {  3,   0,   6}; //   3

  c_p[x_a][60] = { 24,  71,  69}; //   3
  c_f[x_a][60] = {  5}; //   1
  c_t[x_a][60] = { 16,  18}; //   2
  c_d[x_a][60] = {  3,   6,   0}; //   3

  c_p[x_a][61] = { 24,  71,  70}; //   3
  c_f[x_a][61] = {  5}; //   1
  c_t[x_a][61] = { 16,  18}; //   2
  c_d[x_a][61] = {  3,   6,   0}; //   3

  c_p[x_a][62] = { 24,  51,  63}; //   3
  c_f[x_a][62] = {  1}; //   1
  c_t[x_a][62] = {  1,  19}; //   2
  c_d[x_a][62] = {  6,   3,   0}; //   3

  c_p[x_a][63] = { 24,  54,  63}; //   3
  c_f[x_a][63] = {  1}; //   1
  c_t[x_a][63] = {  1,  19}; //   2
  c_d[x_a][63] = {  6,   3,   0}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_dux_ememepvexccx
//  channel    0: 2v4yyv(1, 2, 4, 32, 64, 128, 8, 16;   0,   0,   0,  24,   0)
//  channel    1: 2v4yyv(1, 2, 4, 32, 64, 128, 8, 16;  23,   0,   0,  24,   0)
//  channel    2: 2v4yyv(1, 2, 4, 32, 128, 64, 8, 16;   0,   0,   0,  24,   0)
//  channel    3: 2v4yyv(1, 2, 4, 32, 128, 64, 8, 16;  23,   0,   0,  24,   0)
//  channel    4: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  23,   0,  24,   0,   0)
//  channel    5: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;   0,   0,  24,   0,   0)
//  channel    6: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;  23,   0,  24,   0,   0)
//  channel    7: 2v4yyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel    8: 2v4yyv(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,   0,  24,   0)
//  channel    9: 2v4yyv(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,   0,  24,   0)
//  channel   10: 2v4yyv(1, 2, 8, 32, 128, 64, 4, 16;   0,   0,   0,  24,   0)
//  channel   11: 2v4yyv(1, 2, 8, 32, 128, 64, 4, 16;  23,   0,   0,  24,   0)
//  channel   12: 2v4yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   13: 2v4yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   14: 2v4yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   15: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  24,   0,   0)
//  channel   16: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;   0,  24,  24,   0,   0)
//  channel   17: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  23,  24,  24,   0,   0)
//  channel   18: 2v42vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   19: 2v42vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   20: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  23,   0,  24,   0)
//  channel   21: 4yyv2v(1, 2, 32, 4, 8, 16, 64, 128;   0,   0,   0,  24,   0)
//  channel   22: 4yyv2v(1, 2, 32, 4, 8, 16, 64, 128;   0,  23,   0,  24,   0)
//  channel   23: 4yyv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,  24,   0)
//  channel   24: 4yyv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   25: 4yyv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   26: 4yyv2v(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   27: 4yyv2v(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   28: 4yyv2v(1, 2, 8, 32, 4, 16, 64, 128;   0,  23,   0,  24,   0)
//  channel   29: 4yyv2v(1, 2, 32, 8, 4, 16, 64, 128;   0,   0,   0,  24,   0)
//  channel   30: 4yyv2v(1, 2, 32, 8, 4, 16, 64, 128;   0,  23,   0,  24,   0)
//  channel   31: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,  24,   0)
//  channel   32: 4yyv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   33: 4yyv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  23,   0,   0,   0)
//  channel   34: 4yyv2v(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   35: 4yyv2v(1, 2, 128, 64, 8, 16, 4, 32;  24,  23,   0,   0,   0)
//  channel   36: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,   0,  24,  24,   0)
//  channel   37: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  23,  24,  24,   0)
//  channel   38: 42vv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,  24,   0)
//  channel   39: 42vv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,  23,  24,   0)
//  channel   40: 2v2v2v(1, 2, 4, 32, 8, 16, 64, 128;   0,   0,  24,   0,   0)
//  channel   41: 2v2v2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  23,  24,   0,   0)
//  channel   42: 2v2v2v(1, 2, 4, 32, 64, 128, 8, 16;   0,   0,  24,   0,   0)
//  channel   43: 2v2v2v(1, 2, 4, 32, 64, 128, 8, 16;  23,   0,  24,   0,   0)
//  channel   44: 2v2v2v(1, 2, 64, 128, 4, 32, 8, 16;   0,  24,   0,   0,   0)
//  channel   45: 2v2v2v(1, 2, 64, 128, 4, 32, 8, 16;  23,  24,   0,   0,   0)
//  channel   46: 2v2v2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,   0,   0)
//  channel   47: 2v2v2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,  23,   0,   0)
//  channel   48: 2v2v2v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   49: 2v2v2v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,  23,   0,   0)
//  channel   50: 2v2v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   51: 2v2v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   52: 2v2v2v(1, 2, 8, 32, 4, 16, 64, 128;   0,   0,  24,   0,   0)
//  channel   53: 2v2v2v(1, 2, 8, 32, 4, 16, 64, 128;   0,  23,  24,   0,   0)
//  channel   54: 2v2v2v(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   55: 2v2v2v(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   56: 2v2v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel   57: 2v2v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
//  channel   58: 2v2v2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,   0,   0)
//  channel   59: 2v2v2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,  23,   0,   0)
//  channel   60: 2v2v2v(1, 2, 8, 16, 64, 128, 4, 32;  24,   0,   0,   0,   0)
//  channel   61: 2v2v2v(1, 2, 8, 16, 64, 128, 4, 32;  24,   0,  23,   0,   0)
//  channel   62: 2v2v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   63: 2v2v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  23,   0,   0,   0)
