#include "header.hpp"

#include "ppeeexnex04.phasespace.set.hpp"

void ppeeexnex04_phasespace_set::ax_psp_140_dux_ememepvexg(int x_a){
  static Logger logger("ppeeexnex04_phasespace_set::ax_psp_140_dux_ememepvexg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    8,    9,   12,   13,   14,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47}; //  22
  needed_v_smin[x_a][  1] = {   0,   12}; //   2
  needed_v_smin[x_a][  2] = {   0,    3,   12,   15}; //   4
  needed_v_smin[x_a][  3] = {   1,    2,   13,   14}; //   4
  needed_v_smin[x_a][  4] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  needed_v_smin[x_a][  5] = {   3,   10,   11,   15,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45}; //  18
  needed_v_smin[x_a][  6] = {   3,   15}; //   2
  needed_v_smin[x_a][  7] = {   4,    5,    6,   10,   11,   16,   17,   18,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45}; //  22
  needed_v_smin[x_a][  8] = {   4,   16}; //   2
  needed_v_smin[x_a][  9] = {   4,    7,   16,   19}; //   4
  needed_v_smin[x_a][ 10] = {   5,    6,   17,   18}; //   4
  needed_v_smin[x_a][ 11] = {   7,    8,    9,   19,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47}; //  18
  needed_v_smin[x_a][ 12] = {   7,   19}; //   2
  needed_v_smin[x_a][ 13] = {   8,    9,   20,   21,   24,   25,   30,   31,   40,   41,   46,   47}; //  12
  needed_v_smin[x_a][ 14] = {  10,   11,   22,   23,   26,   27,   28,   29,   42,   43,   44,   45}; //  12
  needed_v_smin[x_a][ 15] = {  32,   33}; //   2
  needed_v_smin[x_a][ 16] = {  34,   35}; //   2
  needed_v_smin[x_a][ 17] = {  36,   37}; //   2
  needed_v_smin[x_a][ 18] = {  38,   39}; //   2

  v_smax[x_a].resize(16);
  needed_v_smax[x_a].resize(16);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    8,    9,   12,   13,   14,   20,   21,   24,   25,   32,   33,   40,   41}; //  16
  needed_v_smax[x_a][  1] = {   0,    3,   12,   15}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47}; //  40
  needed_v_smax[x_a][  3] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  needed_v_smax[x_a][  4] = {   3,   10,   11,   15,   22,   23,   26,   27,   34,   35,   42,   43}; //  12
  needed_v_smax[x_a][  5] = {   4,    5,    6,   16,   17,   18,   28,   29,   36,   37,   44,   45}; //  12
  needed_v_smax[x_a][  6] = {   4,    7,   16,   19}; //   4
  needed_v_smax[x_a][  7] = {   7,   19,   30,   31,   38,   39,   46,   47}; //   8
  needed_v_smax[x_a][  8] = {   8,    9,   20,   21,   24,   25,   32,   33,   40,   41}; //  10
  needed_v_smax[x_a][  9] = {  10,   11,   22,   23,   26,   27,   34,   35,   42,   43}; //  10
  needed_v_smax[x_a][ 10] = {  28,   29,   36,   37,   44,   45}; //   6
  needed_v_smax[x_a][ 11] = {  30,   31,   38,   39,   46,   47}; //   6
  needed_v_smax[x_a][ 12] = {  32,   33}; //   2
  needed_v_smax[x_a][ 13] = {  34,   35}; //   2
  needed_v_smax[x_a][ 14] = {  36,   37}; //   2
  needed_v_smax[x_a][ 15] = {  38,   39}; //   2

  g_p[x_a].resize(23);
  needed_g_p[x_a].resize(23);
  needed_g_p[x_a][0] = {   0,    2,    9,   12,   14,   21,   25,   33,   41}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    3,   12,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    8,   13,   20,   24,   32,   40}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][4] = {   1,    2,   13,   14}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][6] = {   3,   10,   11,   15,   22,   23,   26,   27,   34,   35,   42,   43}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");
  needed_g_p[x_a][8] = {   4,    6,   16,   18,   29,   37,   45}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   4,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4,    7,   16,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][11] = {   5,   17,   28,   36,   44}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][12] = {   5,    6,   17,   18}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax3");
  needed_g_p[x_a][13] = {   7,   19,   30,   31,   38,   39,   46,   47}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax7");
  needed_g_p[x_a][14] = {   7,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax6");
  needed_g_p[x_a][15] = {   8,    9,   20,   21,   24,   25,   32,   33,   40,   41}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax8");
  needed_g_p[x_a][16] = {   8,    9,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax2");
  needed_g_p[x_a][17] = {  10,   22,   26,   34,   42}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax9");
  needed_g_p[x_a][18] = {  10,   11,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax2");
  needed_g_p[x_a][19] = {  11,   23,   27,   35,   43}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax9");
  needed_g_p[x_a][20] = {  28,   29,   36,   37,   44,   45}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax10");
  needed_g_p[x_a][21] = {  30,   38,   46}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax11");
  needed_g_p[x_a][22] = {  31,   39,   47}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {  24,   25,   30,   31,   40,   41,   46,   47}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax2");
  needed_g_f[x_a][1] = {  26,   27,   28,   29,   42,   43,   44,   45}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax2");
  needed_g_f[x_a][2] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax12");
  needed_g_f[x_a][3] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax13");
  needed_g_f[x_a][4] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax14");
  needed_g_f[x_a][5] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax15");

  g_t[x_a].resize(18);
  needed_g_t[x_a].resize(18);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   24,   25,   26,   27,   28,   29,   30,   31}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   40,   41,   42,   43,   44,   45,   46,   47}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__36_24");
  needed_g_t[x_a][3] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__20_40");
  needed_g_t[x_a][4] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__40_20");
  needed_g_t[x_a][5] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__24_36");
  needed_g_t[x_a][6] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_88");
  needed_g_t[x_a][7] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__24_64");
  needed_g_t[x_a][8] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_104");
  needed_g_t[x_a][9] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_64");
  needed_g_t[x_a][10] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_84");
  needed_g_t[x_a][11] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_64");
  needed_g_t[x_a][12] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_100");
  needed_g_t[x_a][13] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__36_64");
  needed_g_t[x_a][14] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__24_36");
  needed_g_t[x_a][15] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_20");
  needed_g_t[x_a][16] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_40");
  needed_g_t[x_a][17] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_24");

  g_d[x_a].resize(15);
  needed_g_d[x_a].resize(15);
  needed_g_d[x_a][0] = {   0,    3,   12,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    8,    9,   12,   13,   14,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47}; //  22
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   1,    2,   13,   14}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][6] = {   3,   10,   11,   15,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][7] = {   4,    7,   16,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {   4,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][9] = {   4,    5,    6,   10,   11,   16,   17,   18,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45}; //  22
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][10] = {   5,    6,   17,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][11] = {   7,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][12] = {   7,    8,    9,   19,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][13] = {   8,    9,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][14] = {  10,   11,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(48);
  c_f[x_a].resize(48);
  c_t[x_a].resize(48);
  c_d[x_a].resize(48);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  3,   4,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   2}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   5,   6}; //   3

  c_p[x_a][4] = {  8,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  7,   8,   9}; //   3

  c_p[x_a][5] = { 11,  12,   5}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  3,  10,   9}; //   3

  c_p[x_a][6] = {  8,  12,   5}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  3,  10,   9}; //   3

  c_p[x_a][7] = { 13,  14,  10}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  7,  11,  12}; //   3

  c_p[x_a][8] = {  3,  15,  16}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 13,  12,   2}; //   3

  c_p[x_a][9] = {  0,  15,  16}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 13,  12,   2}; //   3

  c_p[x_a][10] = {  6,  17,  18}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 14,   9,   6}; //   3

  c_p[x_a][11] = {  6,  19,  18}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = { 14,   9,   6}; //   3

  c_p[x_a][12] = {  0,   1,   2}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  1}; //   1
  c_d[x_a][12] = {  0,   1,   2}; //   3

  c_p[x_a][13] = {  3,   4,   5}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  1}; //   1
  c_d[x_a][13] = {  3,   4,   2}; //   3

  c_p[x_a][14] = {  0,   4,   5}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  1}; //   1
  c_d[x_a][14] = {  3,   4,   2}; //   3

  c_p[x_a][15] = {  6,   7,   2}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  1}; //   1
  c_d[x_a][15] = {  0,   5,   6}; //   3

  c_p[x_a][16] = {  8,   9,  10}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  1}; //   1
  c_d[x_a][16] = {  7,   8,   9}; //   3

  c_p[x_a][17] = { 11,  12,   5}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  1}; //   1
  c_d[x_a][17] = {  3,  10,   9}; //   3

  c_p[x_a][18] = {  8,  12,   5}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  1}; //   1
  c_d[x_a][18] = {  3,  10,   9}; //   3

  c_p[x_a][19] = { 13,  14,  10}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  1}; //   1
  c_d[x_a][19] = {  7,  11,  12}; //   3

  c_p[x_a][20] = {  3,  15,  16}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  1}; //   1
  c_d[x_a][20] = { 13,  12,   2}; //   3

  c_p[x_a][21] = {  0,  15,  16}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  1}; //   1
  c_d[x_a][21] = { 13,  12,   2}; //   3

  c_p[x_a][22] = {  6,  17,  18}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  1}; //   1
  c_d[x_a][22] = { 14,   9,   6}; //   3

  c_p[x_a][23] = {  6,  19,  18}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  1}; //   1
  c_d[x_a][23] = { 14,   9,   6}; //   3

  c_p[x_a][24] = {  3,  15}; //   2
  c_f[x_a][24] = {  0}; //   1
  c_t[x_a][24] = {  0,   2}; //   2
  c_d[x_a][24] = { 12,   2}; //   2

  c_p[x_a][25] = {  0,  15}; //   2
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  0,   2}; //   2
  c_d[x_a][25] = { 12,   2}; //   2

  c_p[x_a][26] = {  6,  17}; //   2
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  0,   3}; //   2
  c_d[x_a][26] = {  9,   6}; //   2

  c_p[x_a][27] = {  6,  19}; //   2
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  0,   3}; //   2
  c_d[x_a][27] = {  9,   6}; //   2

  c_p[x_a][28] = { 11,  20}; //   2
  c_f[x_a][28] = {  1}; //   1
  c_t[x_a][28] = {  0,   4}; //   2
  c_d[x_a][28] = {  6,   9}; //   2

  c_p[x_a][29] = {  8,  20}; //   2
  c_f[x_a][29] = {  1}; //   1
  c_t[x_a][29] = {  0,   4}; //   2
  c_d[x_a][29] = {  6,   9}; //   2

  c_p[x_a][30] = { 13,  21}; //   2
  c_f[x_a][30] = {  0}; //   1
  c_t[x_a][30] = {  0,   5}; //   2
  c_d[x_a][30] = {  2,  12}; //   2

  c_p[x_a][31] = { 13,  22}; //   2
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  0,   5}; //   2
  c_d[x_a][31] = {  2,  12}; //   2

  c_p[x_a][32] = {  3,  15}; //   2
  c_f[x_a][32] = {  2}; //   1
  c_t[x_a][32] = {  6,   7}; //   2
  c_d[x_a][32] = { 12,   2}; //   2

  c_p[x_a][33] = {  0,  15}; //   2
  c_f[x_a][33] = {  2}; //   1
  c_t[x_a][33] = {  6,   7}; //   2
  c_d[x_a][33] = { 12,   2}; //   2

  c_p[x_a][34] = {  6,  17}; //   2
  c_f[x_a][34] = {  3}; //   1
  c_t[x_a][34] = {  8,   9}; //   2
  c_d[x_a][34] = {  9,   6}; //   2

  c_p[x_a][35] = {  6,  19}; //   2
  c_f[x_a][35] = {  3}; //   1
  c_t[x_a][35] = {  8,   9}; //   2
  c_d[x_a][35] = {  9,   6}; //   2

  c_p[x_a][36] = { 11,  20}; //   2
  c_f[x_a][36] = {  4}; //   1
  c_t[x_a][36] = { 10,  11}; //   2
  c_d[x_a][36] = {  6,   9}; //   2

  c_p[x_a][37] = {  8,  20}; //   2
  c_f[x_a][37] = {  4}; //   1
  c_t[x_a][37] = { 10,  11}; //   2
  c_d[x_a][37] = {  6,   9}; //   2

  c_p[x_a][38] = { 13,  21}; //   2
  c_f[x_a][38] = {  5}; //   1
  c_t[x_a][38] = { 12,  13}; //   2
  c_d[x_a][38] = {  2,  12}; //   2

  c_p[x_a][39] = { 13,  22}; //   2
  c_f[x_a][39] = {  5}; //   1
  c_t[x_a][39] = { 12,  13}; //   2
  c_d[x_a][39] = {  2,  12}; //   2

  c_p[x_a][40] = {  3,  15}; //   2
  c_f[x_a][40] = {  0}; //   1
  c_t[x_a][40] = {  1,  14}; //   2
  c_d[x_a][40] = { 12,   2}; //   2

  c_p[x_a][41] = {  0,  15}; //   2
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  1,  14}; //   2
  c_d[x_a][41] = { 12,   2}; //   2

  c_p[x_a][42] = {  6,  17}; //   2
  c_f[x_a][42] = {  1}; //   1
  c_t[x_a][42] = {  1,  15}; //   2
  c_d[x_a][42] = {  9,   6}; //   2

  c_p[x_a][43] = {  6,  19}; //   2
  c_f[x_a][43] = {  1}; //   1
  c_t[x_a][43] = {  1,  15}; //   2
  c_d[x_a][43] = {  9,   6}; //   2

  c_p[x_a][44] = { 11,  20}; //   2
  c_f[x_a][44] = {  1}; //   1
  c_t[x_a][44] = {  1,  16}; //   2
  c_d[x_a][44] = {  6,   9}; //   2

  c_p[x_a][45] = {  8,  20}; //   2
  c_f[x_a][45] = {  1}; //   1
  c_t[x_a][45] = {  1,  16}; //   2
  c_d[x_a][45] = {  6,   9}; //   2

  c_p[x_a][46] = { 13,  21}; //   2
  c_f[x_a][46] = {  0}; //   1
  c_t[x_a][46] = {  1,  17}; //   2
  c_d[x_a][46] = {  2,  12}; //   2

  c_p[x_a][47] = { 13,  22}; //   2
  c_f[x_a][47] = {  0}; //   1
  c_t[x_a][47] = {  1,  17}; //   2
  c_d[x_a][47] = {  2,  12}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_dux_ememepvexg
//  channel    0: 4yyv1(1, 2, 4, 32, 8, 16, 64;  23,   0,  24,   0)
//  channel    1: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,   0,  24,   0)
//  channel    2: 4yyv1(1, 2, 32, 4, 8, 16, 64;  23,   0,  24,   0)
//  channel    3: 4yyv1(1, 2, 4, 16, 8, 32, 64;  24,   0,  24,   0)
//  channel    4: 4yyv1(1, 2, 8, 32, 4, 16, 64;  23,   0,  24,   0)
//  channel    5: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,  24,   0)
//  channel    6: 4yyv1(1, 2, 32, 8, 4, 16, 64;  23,   0,  24,   0)
//  channel    7: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  24,   0)
//  channel    8: 42vv1(1, 2, 4, 32, 8, 16, 64;   0,  24,  24,   0)
//  channel    9: 42vv1(1, 2, 4, 32, 8, 16, 64;  23,  24,  24,   0)
//  channel   10: 42vv1(1, 2, 4, 16, 8, 32, 64;  24,   0,  24,   0)
//  channel   11: 42vv1(1, 2, 4, 16, 8, 32, 64;  24,  23,  24,   0)
//  channel   12: 14yyv(1, 2, 64, 4, 32, 8, 16;  23,   0,  24,   0)
//  channel   13: 14yyv(1, 2, 64, 32, 4, 8, 16;   0,   0,  24,   0)
//  channel   14: 14yyv(1, 2, 64, 32, 4, 8, 16;  23,   0,  24,   0)
//  channel   15: 14yyv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
//  channel   16: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  24,   0)
//  channel   17: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,   0)
//  channel   18: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,   0)
//  channel   19: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  24,   0)
//  channel   20: 142vv(1, 2, 64, 4, 32, 8, 16;   0,  24,  24,   0)
//  channel   21: 142vv(1, 2, 64, 4, 32, 8, 16;  23,  24,  24,   0)
//  channel   22: 142vv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
//  channel   23: 142vv(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,   0)
//  channel   24: 2v2v1(1, 2, 4, 32, 8, 16, 64;   0,  24,   0,   0)
//  channel   25: 2v2v1(1, 2, 4, 32, 8, 16, 64;  23,  24,   0,   0)
//  channel   26: 2v2v1(1, 2, 4, 16, 8, 32, 64;  24,   0,   0,   0)
//  channel   27: 2v2v1(1, 2, 4, 16, 8, 32, 64;  24,  23,   0,   0)
//  channel   28: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,  24,   0,   0)
//  channel   29: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,  24,   0,   0)
//  channel   30: 2v2v1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   0)
//  channel   31: 2v2v1(1, 2, 8, 16, 4, 32, 64;  24,  23,   0,   0)
//  channel   32: 2v12v(1, 2, 4, 32, 64, 8, 16;   0,  24,   0,   0)
//  channel   33: 2v12v(1, 2, 4, 32, 64, 8, 16;  23,  24,   0,   0)
//  channel   34: 2v12v(1, 2, 4, 16, 64, 8, 32;  24,   0,   0,   0)
//  channel   35: 2v12v(1, 2, 4, 16, 64, 8, 32;  24,  23,   0,   0)
//  channel   36: 2v12v(1, 2, 8, 32, 64, 4, 16;   0,  24,   0,   0)
//  channel   37: 2v12v(1, 2, 8, 32, 64, 4, 16;  23,  24,   0,   0)
//  channel   38: 2v12v(1, 2, 8, 16, 64, 4, 32;  24,   0,   0,   0)
//  channel   39: 2v12v(1, 2, 8, 16, 64, 4, 32;  24,  23,   0,   0)
//  channel   40: 12v2v(1, 2, 64, 4, 32, 8, 16;   0,  24,   0,   0)
//  channel   41: 12v2v(1, 2, 64, 4, 32, 8, 16;  23,  24,   0,   0)
//  channel   42: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,   0,   0,   0)
//  channel   43: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,  23,   0,   0)
//  channel   44: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,  24,   0,   0)
//  channel   45: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,  24,   0,   0)
//  channel   46: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
//  channel   47: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  23,   0,   0)
