#include "header.hpp"

#include "ppeex02.phasespace.set.hpp"

void ppeex02_phasespace_set::ax_psp_220_ddx_emepbbx(int x_a){
  static Logger logger("ppeex02_phasespace_set::ax_psp_220_ddx_emepbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(4);
  needed_v_smin[x_a].resize(4);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7}; //   8
  needed_v_smin[x_a][  1] = {   0,    1}; //   2
  needed_v_smin[x_a][  2] = {   2,    3}; //   2
  needed_v_smin[x_a][  3] = {   4,    5,    6,    7}; //   4

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    6,    7}; //   6
  needed_v_smax[x_a][  1] = {   0,    1}; //   2
  needed_v_smax[x_a][  2] = {   2,    3}; //   2
  needed_v_smax[x_a][  3] = {   4,    5}; //   2
  needed_v_smax[x_a][  4] = {   4,    5}; //   2
  needed_v_smax[x_a][  5] = {   6,    7}; //   2

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   0,    2,    6}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    3,    7}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   4,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax4");
  needed_g_p[x_a][6] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax4");
  needed_g_p[x_a][7] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax5");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(2);
  needed_g_t[x_a].resize(2);
  needed_g_t[x_a][0] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][1] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(6);
  needed_g_d[x_a].resize(6);
  needed_g_d[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(8);
  c_f[x_a].resize(8);
  c_t[x_a].resize(8);
  c_d[x_a].resize(8);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  2,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   3}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  2,   3}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  3,   4,   2}; //   3

  c_p[x_a][4] = {  4,   5}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  2,   5}; //   2

  c_p[x_a][5] = {  4,   6}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  2,   5}; //   2

  c_p[x_a][6] = {  0,   7}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  1}; //   1
  c_d[x_a][6] = {  5,   2}; //   2

  c_p[x_a][7] = {  2,   7}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  1}; //   1
  c_d[x_a][7] = {  5,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_ddx_emepbbx
//  channel    0: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    1: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel    2: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel    3: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel    4: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    5: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel    6: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    7: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)
