#include "header.hpp"

#include "ppeex02.phasespace.set.hpp"

void ppeex02_phasespace_set::ax_psp_220_uxux_emepuxux(int x_a){
  static Logger logger("ppeex02_phasespace_set::ax_psp_220_uxux_emepuxux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  needed_v_smin[x_a][  1] = {   4,    5,    8,    9,    2,    3,   12,   13}; //   8
  needed_v_smin[x_a][  2] = {   6,    7,   10,   11,    0,    1,   14,   15}; //   8

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  needed_v_smax[x_a][  1] = {   4,    5,    8,    9,    2,    3,   12,   13}; //   8
  needed_v_smax[x_a][  2] = {   6,    7,   10,   11,    0,    1,   14,   15}; //   8

  g_p[x_a].resize(4);
  needed_g_p[x_a].resize(4);
  needed_g_p[x_a][0] = {   0,    2,    4,    6,    8,   10,   12,   14}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   1,    3,    5,    7,    9,   11,   13,   15}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   4,    5,    8,    9}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   6,    7,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1,   14,   15}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   2,    3,   12,   13}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(8);
  needed_g_t[x_a].resize(8);
  needed_g_t[x_a][0] = {   0,    1,    6,    7}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   2,    3,    4,    5}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][4] = {   8,    9,   12,   13}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][5] = {  10,   11,   14,   15}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][6] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][7] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");

  g_d[x_a].resize(3);
  needed_g_d[x_a].resize(3);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,    5,    8,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   6,    7,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");

  c_p[x_a].resize(16);
  c_f[x_a].resize(16);
  c_t[x_a].resize(16);
  c_d[x_a].resize(16);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  1}; //   1
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0,   2}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  2}; //   1
  c_d[x_a][4] = {  1,   0}; //   2

  c_p[x_a][5] = {  1,   2}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  2}; //   1
  c_d[x_a][5] = {  1,   0}; //   2

  c_p[x_a][6] = {  0,   3}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  2,   0}; //   2

  c_p[x_a][7] = {  1,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  2,   0}; //   2

  c_p[x_a][8] = {  0,   2}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  4}; //   1
  c_d[x_a][8] = {  1,   0}; //   2

  c_p[x_a][9] = {  1,   2}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  4}; //   1
  c_d[x_a][9] = {  1,   0}; //   2

  c_p[x_a][10] = {  0,   3}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  5}; //   1
  c_d[x_a][10] = {  2,   0}; //   2

  c_p[x_a][11] = {  1,   3}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  5}; //   1
  c_d[x_a][11] = {  2,   0}; //   2

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  1}; //   1
  c_t[x_a][12] = {  4,   6}; //   2
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  1}; //   1
  c_f[x_a][13] = {  1}; //   1
  c_t[x_a][13] = {  4,   6}; //   2
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  0}; //   1
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  5,   7}; //   2
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  1}; //   1
  c_f[x_a][15] = {  0}; //   1
  c_t[x_a][15] = {  5,   7}; //   2
  c_d[x_a][15] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_uxux_emepuxux
//  channel    0: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    1: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    2: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel    3: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel    4: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    5: 3yv1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel    6: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    7: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel    8: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    9: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   10: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   11: 13yv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   12: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   13: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   14: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   15: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
