#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_230_bbx_emepabbx(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_230_bbx_emepabbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(23);
  needed_v_smin[x_a].resize(23);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   16,   17,   20,   21,   26,   27,   28,   29,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   50,   51,   52,   53,   54,   55,   58,   59,   60,   61,   64,   65,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   84,   85,   88,   89,   90,   91,   92,   93,   94,   95,   98,   99,  100,  101,  102,  103,  106,  107,  108,  109,  110,  111}; //  80
  needed_v_smin[x_a][  1] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83,   96,   97}; //  16
  needed_v_smin[x_a][  2] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83,   96,   97}; //  16
  needed_v_smin[x_a][  3] = {   6,    7,   14,   15,   16,   17,   26,   27,   40,   41,   46,   47,   52,   53,   98,   99,   42,   43}; //  18
  needed_v_smin[x_a][  4] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87,  104,  105}; //  16
  needed_v_smin[x_a][  5] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87,  104,  105}; //  16
  needed_v_smin[x_a][  6] = {  10,   11,   18,   19,   24,   25,   32,   33,    4,    5,    8,    9}; //  12
  needed_v_smin[x_a][  7] = {  12,   13,   28,   29,   38,   39,   44,   45,   50,   51,   54,   55,   64,   65,   84,   85,   60,   61,   92,   93}; //  20
  needed_v_smin[x_a][  8] = {  12,   13,   50,   51,   64,   65}; //   6
  needed_v_smin[x_a][  9] = {  14,   15,   52,   53,    6,    7,   42,   43,   46,   47}; //  10
  needed_v_smin[x_a][ 10] = {  16,   17,   26,   27}; //   4
  needed_v_smin[x_a][ 11] = {  20,   21,   34,   35,   38,   39,   72,   73,   78,   79,   84,   85,   92,   93,  100,  101,    0,    1}; //  18
  needed_v_smin[x_a][ 12] = {  20,   21,   34,   35,    0,    1,   72,   73}; //   8
  needed_v_smin[x_a][ 13] = {  22,   23,   30,   31,   48,   49,   56,   57,   62,   63,   66,   67}; //  12
  needed_v_smin[x_a][ 14] = {  28,   29,   54,   55,   44,   45,   60,   61}; //   8
  needed_v_smin[x_a][ 15] = {  36,   37,   40,   41,   58,   59,   80,   81,   90,   91,   98,   99,  102,  103,  110,  111,   70,   71}; //  18
  needed_v_smin[x_a][ 16] = {  36,   37,   58,   59,   70,   71,  110,  111}; //   8
  needed_v_smin[x_a][ 17] = {  74,   75,   76,   77,   82,   83,   86,   87,   88,   89,   94,   95,   96,   97,  104,  105,  106,  107,  108,  109,    2,    3,   68,   69}; //  24
  needed_v_smin[x_a][ 18] = {  78,   79,  100,  101}; //   4
  needed_v_smin[x_a][ 19] = {  80,   81,  102,  103,   90,   91}; //   6
  needed_v_smin[x_a][ 20] = {   2,    3,   68,   69,   74,   75,   76,   77,  106,  107,  108,  109}; //  12
  needed_v_smin[x_a][ 21] = {  88,   89}; //   2
  needed_v_smin[x_a][ 22] = {  94,   95}; //   2

  v_smax[x_a].resize(29);
  needed_v_smax[x_a].resize(29);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   16,   17,   26,   27,   28,   29,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   50,   51,   52,   53,   54,   55,   60,   61,   64,   65,   68,   69,   70,   71,   76,   77,   84,   85,   92,   93,   94,   95,  100,  101,  102,  103,  108,  109,  110,  111}; //  56
  needed_v_smax[x_a][  1] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83}; //  14
  needed_v_smax[x_a][  2] = {   4,    5,    8,    9,   10,   11,   18,   19,   22,   23,   24,   25,   30,   31,   32,   33,   48,   49,   56,   57,   62,   63,   66,   67,   82,   83,   86,   87}; //  28
  needed_v_smax[x_a][  3] = {   6,    7,   14,   15,   16,   17,   26,   27,   40,   41,   46,   47,   52,   53,   42,   43}; //  16
  needed_v_smax[x_a][  4] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87}; //  14
  needed_v_smax[x_a][  5] = {  10,   11,   16,   17,   18,   19,   20,   21,   24,   25,   26,   27,   32,   33,   34,   35,    0,    1,    4,    5,    8,    9,   72,   73}; //  24
  needed_v_smax[x_a][  6] = {  12,   13,   28,   29,   38,   39,   44,   45,   50,   51,   54,   55,   64,   65,   84,   85,   60,   61}; //  18
  needed_v_smax[x_a][  7] = {  12,   13,   14,   15,   50,   51,   52,   53,    2,    3,    6,    7,   42,   43,   46,   47,   64,   65,   68,   69,   74,   75,   76,   77,  106,  107,  108,  109}; //  28
  needed_v_smax[x_a][  8] = {  20,   21,   34,   35,   72,   73,   78,   79}; //   8
  needed_v_smax[x_a][  9] = {  20,   21,   34,   35,   72,   73}; //   6
  needed_v_smax[x_a][ 10] = {  22,   23,   28,   29,   30,   31,   36,   37,   48,   49,   54,   55,   56,   57,   58,   59,   44,   45,   60,   61,   62,   63,   66,   67,   70,   71,  110,  111}; //  28
  needed_v_smax[x_a][ 11] = {  36,   37,   58,   59,   80,   81,   90,   91,   98,   99}; //  10
  needed_v_smax[x_a][ 12] = {  36,   37,   58,   59,   90,   91,   98,   99}; //   8
  needed_v_smax[x_a][ 13] = {  38,   39,   84,   85}; //   4
  needed_v_smax[x_a][ 14] = {  40,   41}; //   2
  needed_v_smax[x_a][ 15] = {  74,   75,   88,   89,   96,   97,  104,  105,  106,  107}; //  10
  needed_v_smax[x_a][ 16] = {  74,   75,   88,   89,  106,  107}; //   6
  needed_v_smax[x_a][ 17] = {  76,   77,   94,   95,  108,  109,    2,    3,   68,   69}; //  10
  needed_v_smax[x_a][ 18] = {  78,   79,   80,   81}; //   4
  needed_v_smax[x_a][ 19] = {  78,   79,   80,   81}; //   4
  needed_v_smax[x_a][ 20] = {  82,   83,   86,   87}; //   4
  needed_v_smax[x_a][ 21] = {  92,   93,  100,  101,    0,    1}; //   6
  needed_v_smax[x_a][ 22] = {  96,   97}; //   2
  needed_v_smax[x_a][ 23] = {  96,   97,  104,  105,   94,   95}; //   6
  needed_v_smax[x_a][ 24] = {  98,   99}; //   2
  needed_v_smax[x_a][ 25] = { 100,  101,  102,  103,   88,   89,   90,   91}; //   8
  needed_v_smax[x_a][ 26] = { 102,  103,  110,  111,   70,   71}; //   6
  needed_v_smax[x_a][ 27] = { 104,  105}; //   2
  needed_v_smax[x_a][ 28] = {  92,   93}; //   2

  g_p[x_a].resize(46);
  needed_g_p[x_a].resize(46);
  needed_g_p[x_a][0] = {   0,    2,    6,   12,   14,   16,   26,   28,   38,   40,   42,   44,   46,   50,   52,   54,   60,   64,   68,   70,   76,   84,   92,   94,  100,  102,  108,  110}; //  28
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   1,    3,    7,   13,   15,   17,   27,   29,   39,   41,   43,   45,   47,   51,   53,   55,   61,   65,   69,   71,   77,   85,   93,   95,  101,  103,  109,  111}; //  28
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   4,   10,   22,   24,   48,   62,   82}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   5,   11,   23,   25,   49,   63,   83}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   6,    7,   14,   15,   16,   17,   26,   27,   40,   41,   46,   47,   52,   53}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][7] = {   8,   18,   30,   32,   56,   66,   86}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax2");
  needed_g_p[x_a][8] = {   9,   19,   31,   33,   57,   67,   87}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][9] = {  10,   11,   18,   19,   24,   25,   32,   33}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][10] = {  12,   13,   28,   29,   38,   39,   44,   45,   50,   51,   54,   55,   64,   65,   84,   85}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][11] = {  12,   13,   50,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][12] = {  14,   15,   52,   53}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {  16,   17,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax5");
  needed_g_p[x_a][14] = {  20,   21,   34,   35,   72,   73,   78,   79}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][15] = {  20,   34,   72}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax9");
  needed_g_p[x_a][16] = {  20,   21,   34,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax5");
  needed_g_p[x_a][17] = {  21,   35,   73}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][18] = {  22,   23,   30,   31,   48,   49,   56,   57}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][19] = {  28,   29,   54,   55}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax10");
  needed_g_p[x_a][20] = {  36,   37,   58,   59,   80,   81,   90,   91,   98,   99}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax11");
  needed_g_p[x_a][21] = {  36,   58,   90,   98}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax12");
  needed_g_p[x_a][22] = {  36,   37,   58,   59}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax10");
  needed_g_p[x_a][23] = {  37,   59,   91,   99}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax12");
  needed_g_p[x_a][24] = {  38,   39,   84,   85}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax13");
  needed_g_p[x_a][25] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax14");
  needed_g_p[x_a][26] = {  74,   75,   88,   89,   96,   97,  104,  105,  106,  107}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax15");
  needed_g_p[x_a][27] = {  74,   88,  106}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax16");
  needed_g_p[x_a][28] = {  75,   89,  107}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][29] = {  76,   77,   94,   95,  108,  109}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax17");
  needed_g_p[x_a][30] = {  78,   79}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax18");
  needed_g_p[x_a][31] = {  78,   80}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax19");
  needed_g_p[x_a][32] = {  79,   81}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax19");
  needed_g_p[x_a][33] = {  80,   81}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax18");
  needed_g_p[x_a][34] = {  82,   83,   86,   87}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax20");
  needed_g_p[x_a][35] = {  92,   93,  100,  101}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax21");
  needed_g_p[x_a][36] = {  96,   97}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax22");
  needed_g_p[x_a][37] = {  96}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax23");
  needed_g_p[x_a][38] = {  97}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax23");
  needed_g_p[x_a][39] = {  98,   99}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax24");
  needed_g_p[x_a][40] = { 100,  101}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax25");
  needed_g_p[x_a][41] = { 102,  103,  110,  111}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax26");
  needed_g_p[x_a][42] = { 102,  103}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax25");
  needed_g_p[x_a][43] = { 104,  105}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax27");
  needed_g_p[x_a][44] = { 104}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax23");
  needed_g_p[x_a][45] = { 105}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax23");

  g_f[x_a].resize(17);
  needed_g_f[x_a].resize(17);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax21");
  needed_g_f[x_a][1] = {   0,    1,   72,   73}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax5");
  needed_g_f[x_a][2] = {   2,    3,   68,   69}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax17");
  needed_g_f[x_a][3] = {   2,    3,   68,   69,   74,   75,   76,   77,  106,  107,  108,  109}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax7");
  needed_g_f[x_a][4] = {   4,    5,    8,    9}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax5");
  needed_g_f[x_a][5] = {   6,    7,   42,   43,   46,   47}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][6] = {  42,   43}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][7] = {  44,   45,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax10");
  needed_g_f[x_a][8] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax6");
  needed_g_f[x_a][9] = {  62,   63,   66,   67}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax10");
  needed_g_f[x_a][10] = {  64,   65}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax7");
  needed_g_f[x_a][11] = {  70,   71}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax26");
  needed_g_f[x_a][12] = {  70,   71,  110,  111}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax10");
  needed_g_f[x_a][13] = {  88,   89}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax25");
  needed_g_f[x_a][14] = {  90,   91}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax25");
  needed_g_f[x_a][15] = {  92,   93}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax28");
  needed_g_f[x_a][16] = {  94,   95}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax23");

  g_t[x_a].resize(32);
  needed_g_t[x_a].resize(32);
  needed_g_t[x_a][0] = {   0,    1,    4,    5,    8,    9,   10,   11,   16,   17,   18,   19,   20,   21,   72,   73}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,    1,   72,   73}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   2,    3,    6,    7,   12,   13,   14,   15,   74,   75,   76,   77}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][4] = {   2,    3,   74,   75}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][6] = {   4,    5,    8,    9}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__32_28");
  needed_g_t[x_a][7] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][8] = {  42,   43,   46,   47,   50,   51,   52,   53,   64,   65,   68,   69,  106,  107,  108,  109}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][9] = {  42,   43,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][10] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][11] = {  44,   45,   48,   49,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   66,   67,   70,   71,  110,  111}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][12] = {  44,   45,   60,   61}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][13] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][14] = {  62,   63,   66,   67}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__64_28");
  needed_g_t[x_a][15] = {  64,   65}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__32_76");
  needed_g_t[x_a][16] = {  68,   69,  108,  109}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][17] = {  68,   69}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][18] = {  70,   71,  110,  111}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][19] = {  70,   71}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][20] = {  76,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][21] = {  78,   79,   80,   81,   88,   89,   90,   91}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][22] = {  82,   83,   86,   87,   94,   95}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][23] = {  84,   85,   92,   93}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][24] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__96_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__96_16");
  needed_g_t[x_a][25] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__80_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__80_32");
  needed_g_t[x_a][26] = {  92,   93}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][27] = {  94,   95}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][28] = {  96,   97,  104,  105}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__96_28");
  needed_g_t[x_a][29] = {  98,   99}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");
  needed_g_t[x_a][30] = { 100,  101,  102,  103}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][31] = { 106,  107}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");

  g_d[x_a].resize(24);
  needed_g_d[x_a].resize(24);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   16,   17,   20,   21,   26,   27,   28,   29,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   50,   51,   52,   53,   54,   55,   58,   59,   60,   61,   64,   65,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   84,   85,   88,   89,   90,   91,   92,   93,   94,   95,   98,   99,  100,  101,  102,  103,  106,  107,  108,  109,  110,  111}; //  80
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83,   96,   97}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83,   96,   97}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   6,    7,   14,   15,   16,   17,   26,   27,   40,   41,   46,   47,   52,   53,   98,   99}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][4] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87,  104,  105}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][5] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87,  104,  105}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {  10,   11,   18,   19,   24,   25,   32,   33}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {  12,   13,   50,   51}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][8] = {  12,   13,   28,   29,   38,   39,   44,   45,   50,   51,   54,   55,   64,   65,   84,   85}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][9] = {  14,   15,   52,   53}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__64_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__64_44");
  needed_g_d[x_a][10] = {  16,   17,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][11] = {  20,   21,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][12] = {  20,   21,   34,   35,   38,   39,   72,   73,   78,   79,   84,   85,   92,   93,  100,  101}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][13] = {  22,   23,   28,   29,   30,   31,   36,   37}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][14] = {  22,   23,   30,   31,   48,   49,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][15] = {  24,   25,   26,   27,   32,   33,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][16] = {  28,   29,   54,   55}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][17] = {  36,   37,   58,   59}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][18] = {  36,   37,   40,   41,   58,   59,   80,   81,   90,   91,   98,   99,  102,  103,  110,  111}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][19] = {  38,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][20] = {  40,   41}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");
  needed_g_d[x_a][21] = {  74,   75,   76,   77,   82,   83,   86,   87,   88,   89,   94,   95,   96,   97,  104,  105,  106,  107,  108,  109}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][22] = {  78,   79,  100,  101}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][23] = {  80,   81,  102,  103}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");

  c_p[x_a].resize(112);
  c_f[x_a].resize(112);
  c_t[x_a].resize(112);
  c_d[x_a].resize(112);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  1}; //   1
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  0,   1,   2}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  3,   4,   5}; //   3
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  2,   3}; //   2
  c_t[x_a][3] = {  3,   4,   5}; //   3
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  2,   3}; //   2
  c_f[x_a][4] = {  4}; //   1
  c_t[x_a][4] = {  0,   6}; //   2
  c_d[x_a][4] = {  1,   2}; //   2

  c_p[x_a][5] = {  2,   4}; //   2
  c_f[x_a][5] = {  4}; //   1
  c_t[x_a][5] = {  0,   6}; //   2
  c_d[x_a][5] = {  1,   2}; //   2

  c_p[x_a][6] = {  0,   5}; //   2
  c_f[x_a][6] = {  5}; //   1
  c_t[x_a][6] = {  3,   7}; //   2
  c_d[x_a][6] = {  3,   0}; //   2

  c_p[x_a][7] = {  1,   5}; //   2
  c_f[x_a][7] = {  5}; //   1
  c_t[x_a][7] = {  3,   7}; //   2
  c_d[x_a][7] = {  3,   0}; //   2

  c_p[x_a][8] = {  6,   7}; //   2
  c_f[x_a][8] = {  4}; //   1
  c_t[x_a][8] = {  0,   6}; //   2
  c_d[x_a][8] = {  4,   5}; //   2

  c_p[x_a][9] = {  6,   8}; //   2
  c_f[x_a][9] = {  4}; //   1
  c_t[x_a][9] = {  0,   6}; //   2
  c_d[x_a][9] = {  4,   5}; //   2

  c_p[x_a][10] = {  2,   3,   9}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  6,   1,   2}; //   3

  c_p[x_a][11] = {  2,   4,   9}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  6,   1,   2}; //   3

  c_p[x_a][12] = {  0,  10,  11}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  3}; //   1
  c_d[x_a][12] = {  7,   8,   0}; //   3

  c_p[x_a][13] = {  1,  10,  11}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  3}; //   1
  c_d[x_a][13] = {  7,   8,   0}; //   3

  c_p[x_a][14] = {  0,   5,  12}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  3}; //   1
  c_d[x_a][14] = {  9,   3,   0}; //   3

  c_p[x_a][15] = {  1,   5,  12}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  3}; //   1
  c_d[x_a][15] = {  9,   3,   0}; //   3

  c_p[x_a][16] = {  0,   5,  13}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 10,   3,   0}; //   3

  c_p[x_a][17] = {  1,   5,  13}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 10,   3,   0}; //   3

  c_p[x_a][18] = {  6,   7,   9}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = {  6,   4,   5}; //   3

  c_p[x_a][19] = {  6,   8,   9}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = {  6,   4,   5}; //   3

  c_p[x_a][20] = { 14,  15,  16}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = { 11,   0,  12}; //   3

  c_p[x_a][21] = { 14,  17,  16}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = { 11,   0,  12}; //   3

  c_p[x_a][22] = {  2,   3,  18}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 13,  14,   1,   2}; //   4

  c_p[x_a][23] = {  2,   4,  18}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 13,  14,   1,   2}; //   4

  c_p[x_a][24] = {  2,   3,   9}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 15,   6,   1,   2}; //   4

  c_p[x_a][25] = {  2,   4,   9}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 15,   6,   1,   2}; //   4

  c_p[x_a][26] = {  0,   5,  13}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 15,  10,   3,   0}; //   4

  c_p[x_a][27] = {  1,   5,  13}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 15,  10,   3,   0}; //   4

  c_p[x_a][28] = {  0,  10,  19}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 13,  16,   8,   0}; //   4

  c_p[x_a][29] = {  1,  10,  19}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 13,  16,   8,   0}; //   4

  c_p[x_a][30] = {  6,   7,  18}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 13,  14,   4,   5}; //   4

  c_p[x_a][31] = {  6,   8,  18}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 13,  14,   4,   5}; //   4

  c_p[x_a][32] = {  6,   7,   9}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 15,   6,   4,   5}; //   4

  c_p[x_a][33] = {  6,   8,   9}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 15,   6,   4,   5}; //   4

  c_p[x_a][34] = { 14,  15,  16}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 15,  11,   0,  12}; //   4

  c_p[x_a][35] = { 14,  17,  16}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 15,  11,   0,  12}; //   4

  c_p[x_a][36] = { 20,  21,  22}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 13,  17,   0,  18}; //   4

  c_p[x_a][37] = { 20,  23,  22}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 13,  17,   0,  18}; //   4

  c_p[x_a][38] = {  0,  10,  24}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 19,  12,   8,   0}; //   4

  c_p[x_a][39] = {  1,  10,  24}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 19,  12,   8,   0}; //   4

  c_p[x_a][40] = {  0,   5,  25}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 20,  18,   3,   0}; //   4

  c_p[x_a][41] = {  1,   5,  25}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 20,  18,   3,   0}; //   4

  c_p[x_a][42] = {  0}; //   1
  c_f[x_a][42] = {  6,   5}; //   2
  c_t[x_a][42] = {  8,   9,  10}; //   3
  c_d[x_a][42] = {  0}; //   1

  c_p[x_a][43] = {  1}; //   1
  c_f[x_a][43] = {  6,   5}; //   2
  c_t[x_a][43] = {  8,   9,  10}; //   3
  c_d[x_a][43] = {  0}; //   1

  c_p[x_a][44] = {  0,  10}; //   2
  c_f[x_a][44] = {  7}; //   1
  c_t[x_a][44] = { 11,  12}; //   2
  c_d[x_a][44] = {  8,   0}; //   2

  c_p[x_a][45] = {  1,  10}; //   2
  c_f[x_a][45] = {  7}; //   1
  c_t[x_a][45] = { 11,  12}; //   2
  c_d[x_a][45] = {  8,   0}; //   2

  c_p[x_a][46] = {  0,   5}; //   2
  c_f[x_a][46] = {  5}; //   1
  c_t[x_a][46] = {  8,   9}; //   2
  c_d[x_a][46] = {  3,   0}; //   2

  c_p[x_a][47] = {  1,   5}; //   2
  c_f[x_a][47] = {  5}; //   1
  c_t[x_a][47] = {  8,   9}; //   2
  c_d[x_a][47] = {  3,   0}; //   2

  c_p[x_a][48] = {  2,   3,  18}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = { 11}; //   1
  c_d[x_a][48] = { 14,   1,   2}; //   3

  c_p[x_a][49] = {  2,   4,  18}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = { 11}; //   1
  c_d[x_a][49] = { 14,   1,   2}; //   3

  c_p[x_a][50] = {  0,  10,  11}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  8}; //   1
  c_d[x_a][50] = {  7,   8,   0}; //   3

  c_p[x_a][51] = {  1,  10,  11}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  8}; //   1
  c_d[x_a][51] = {  7,   8,   0}; //   3

  c_p[x_a][52] = {  0,   5,  12}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  8}; //   1
  c_d[x_a][52] = {  9,   3,   0}; //   3

  c_p[x_a][53] = {  1,   5,  12}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  8}; //   1
  c_d[x_a][53] = {  9,   3,   0}; //   3

  c_p[x_a][54] = {  0,  10,  19}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = { 11}; //   1
  c_d[x_a][54] = { 16,   8,   0}; //   3

  c_p[x_a][55] = {  1,  10,  19}; //   3
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = { 11}; //   1
  c_d[x_a][55] = { 16,   8,   0}; //   3

  c_p[x_a][56] = {  6,   7,  18}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = { 11}; //   1
  c_d[x_a][56] = { 14,   4,   5}; //   3

  c_p[x_a][57] = {  6,   8,  18}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = { 11}; //   1
  c_d[x_a][57] = { 14,   4,   5}; //   3

  c_p[x_a][58] = { 20,  21,  22}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = { 11}; //   1
  c_d[x_a][58] = { 17,   0,  18}; //   3

  c_p[x_a][59] = { 20,  23,  22}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = { 11}; //   1
  c_d[x_a][59] = { 17,   0,  18}; //   3

  c_p[x_a][60] = {  0}; //   1
  c_f[x_a][60] = {  8,   7}; //   2
  c_t[x_a][60] = { 11,  12,  13}; //   3
  c_d[x_a][60] = {  0}; //   1

  c_p[x_a][61] = {  1}; //   1
  c_f[x_a][61] = {  8,   7}; //   2
  c_t[x_a][61] = { 11,  12,  13}; //   3
  c_d[x_a][61] = {  0}; //   1

  c_p[x_a][62] = {  2,   3}; //   2
  c_f[x_a][62] = {  9}; //   1
  c_t[x_a][62] = { 11,  14}; //   2
  c_d[x_a][62] = {  1,   2}; //   2

  c_p[x_a][63] = {  2,   4}; //   2
  c_f[x_a][63] = {  9}; //   1
  c_t[x_a][63] = { 11,  14}; //   2
  c_d[x_a][63] = {  1,   2}; //   2

  c_p[x_a][64] = {  0,  10}; //   2
  c_f[x_a][64] = { 10}; //   1
  c_t[x_a][64] = {  8,  15}; //   2
  c_d[x_a][64] = {  8,   0}; //   2

  c_p[x_a][65] = {  1,  10}; //   2
  c_f[x_a][65] = { 10}; //   1
  c_t[x_a][65] = {  8,  15}; //   2
  c_d[x_a][65] = {  8,   0}; //   2

  c_p[x_a][66] = {  6,   7}; //   2
  c_f[x_a][66] = {  9}; //   1
  c_t[x_a][66] = { 11,  14}; //   2
  c_d[x_a][66] = {  4,   5}; //   2

  c_p[x_a][67] = {  6,   8}; //   2
  c_f[x_a][67] = {  9}; //   1
  c_t[x_a][67] = { 11,  14}; //   2
  c_d[x_a][67] = {  4,   5}; //   2

  c_p[x_a][68] = {  0}; //   1
  c_f[x_a][68] = {  2,   3}; //   2
  c_t[x_a][68] = {  8,  16,  17}; //   3
  c_d[x_a][68] = {  0}; //   1

  c_p[x_a][69] = {  1}; //   1
  c_f[x_a][69] = {  2,   3}; //   2
  c_t[x_a][69] = {  8,  16,  17}; //   3
  c_d[x_a][69] = {  0}; //   1

  c_p[x_a][70] = {  0}; //   1
  c_f[x_a][70] = { 11,  12}; //   2
  c_t[x_a][70] = { 11,  18,  19}; //   3
  c_d[x_a][70] = {  0}; //   1

  c_p[x_a][71] = {  1}; //   1
  c_f[x_a][71] = { 11,  12}; //   2
  c_t[x_a][71] = { 11,  18,  19}; //   3
  c_d[x_a][71] = {  0}; //   1

  c_p[x_a][72] = { 14,  15}; //   2
  c_f[x_a][72] = {  1}; //   1
  c_t[x_a][72] = {  0,   1}; //   2
  c_d[x_a][72] = {  0,  12}; //   2

  c_p[x_a][73] = { 14,  17}; //   2
  c_f[x_a][73] = {  1}; //   1
  c_t[x_a][73] = {  0,   1}; //   2
  c_d[x_a][73] = {  0,  12}; //   2

  c_p[x_a][74] = { 26,  27}; //   2
  c_f[x_a][74] = {  3}; //   1
  c_t[x_a][74] = {  3,   4}; //   2
  c_d[x_a][74] = {  0,  21}; //   2

  c_p[x_a][75] = { 26,  28}; //   2
  c_f[x_a][75] = {  3}; //   1
  c_t[x_a][75] = {  3,   4}; //   2
  c_d[x_a][75] = {  0,  21}; //   2

  c_p[x_a][76] = {  0,  29}; //   2
  c_f[x_a][76] = {  3}; //   1
  c_t[x_a][76] = {  3,  20}; //   2
  c_d[x_a][76] = { 21,   0}; //   2

  c_p[x_a][77] = {  1,  29}; //   2
  c_f[x_a][77] = {  3}; //   1
  c_t[x_a][77] = {  3,  20}; //   2
  c_d[x_a][77] = { 21,   0}; //   2

  c_p[x_a][78] = { 14,  30,  31}; //   3
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = { 21}; //   1
  c_d[x_a][78] = {  0,  22,  12}; //   3

  c_p[x_a][79] = { 14,  30,  32}; //   3
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 21}; //   1
  c_d[x_a][79] = {  0,  22,  12}; //   3

  c_p[x_a][80] = { 20,  33,  31}; //   3
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = { 21}; //   1
  c_d[x_a][80] = {  0,  23,  18}; //   3

  c_p[x_a][81] = { 20,  33,  32}; //   3
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = { 21}; //   1
  c_d[x_a][81] = {  0,  23,  18}; //   3

  c_p[x_a][82] = {  2,   3,  34}; //   3
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = { 22}; //   1
  c_d[x_a][82] = { 21,   1,   2}; //   3

  c_p[x_a][83] = {  2,   4,  34}; //   3
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = { 22}; //   1
  c_d[x_a][83] = { 21,   1,   2}; //   3

  c_p[x_a][84] = {  0,  10,  24}; //   3
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = { 23}; //   1
  c_d[x_a][84] = { 12,   8,   0}; //   3

  c_p[x_a][85] = {  1,  10,  24}; //   3
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = { 23}; //   1
  c_d[x_a][85] = { 12,   8,   0}; //   3

  c_p[x_a][86] = {  6,   7,  34}; //   3
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = { 22}; //   1
  c_d[x_a][86] = { 21,   4,   5}; //   3

  c_p[x_a][87] = {  6,   8,  34}; //   3
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = { 22}; //   1
  c_d[x_a][87] = { 21,   4,   5}; //   3

  c_p[x_a][88] = { 26,  27}; //   2
  c_f[x_a][88] = { 13}; //   1
  c_t[x_a][88] = { 21,  24}; //   2
  c_d[x_a][88] = {  0,  21}; //   2

  c_p[x_a][89] = { 26,  28}; //   2
  c_f[x_a][89] = { 13}; //   1
  c_t[x_a][89] = { 21,  24}; //   2
  c_d[x_a][89] = {  0,  21}; //   2

  c_p[x_a][90] = { 20,  21}; //   2
  c_f[x_a][90] = { 14}; //   1
  c_t[x_a][90] = { 21,  25}; //   2
  c_d[x_a][90] = {  0,  18}; //   2

  c_p[x_a][91] = { 20,  23}; //   2
  c_f[x_a][91] = { 14}; //   1
  c_t[x_a][91] = { 21,  25}; //   2
  c_d[x_a][91] = {  0,  18}; //   2

  c_p[x_a][92] = {  0,  35}; //   2
  c_f[x_a][92] = { 15}; //   1
  c_t[x_a][92] = { 23,  26}; //   2
  c_d[x_a][92] = { 12,   0}; //   2

  c_p[x_a][93] = {  1,  35}; //   2
  c_f[x_a][93] = { 15}; //   1
  c_t[x_a][93] = { 23,  26}; //   2
  c_d[x_a][93] = { 12,   0}; //   2

  c_p[x_a][94] = {  0,  29}; //   2
  c_f[x_a][94] = { 16}; //   1
  c_t[x_a][94] = { 22,  27}; //   2
  c_d[x_a][94] = { 21,   0}; //   2

  c_p[x_a][95] = {  1,  29}; //   2
  c_f[x_a][95] = { 16}; //   1
  c_t[x_a][95] = { 22,  27}; //   2
  c_d[x_a][95] = { 21,   0}; //   2

  c_p[x_a][96] = { 26,  36,  37}; //   3
  c_f[x_a][96] = {}; //   0
  c_t[x_a][96] = { 28}; //   1
  c_d[x_a][96] = {  1,   2,  21}; //   3

  c_p[x_a][97] = { 26,  36,  38}; //   3
  c_f[x_a][97] = {}; //   0
  c_t[x_a][97] = { 28}; //   1
  c_d[x_a][97] = {  1,   2,  21}; //   3

  c_p[x_a][98] = { 20,  21,  39}; //   3
  c_f[x_a][98] = {}; //   0
  c_t[x_a][98] = { 29}; //   1
  c_d[x_a][98] = {  3,   0,  18}; //   3

  c_p[x_a][99] = { 20,  23,  39}; //   3
  c_f[x_a][99] = {}; //   0
  c_t[x_a][99] = { 29}; //   1
  c_d[x_a][99] = {  3,   0,  18}; //   3

  c_p[x_a][100] = {  0,  35,  40}; //   3
  c_f[x_a][100] = {}; //   0
  c_t[x_a][100] = { 30}; //   1
  c_d[x_a][100] = { 22,  12,   0}; //   3

  c_p[x_a][101] = {  1,  35,  40}; //   3
  c_f[x_a][101] = {}; //   0
  c_t[x_a][101] = { 30}; //   1
  c_d[x_a][101] = { 22,  12,   0}; //   3

  c_p[x_a][102] = {  0,  41,  42}; //   3
  c_f[x_a][102] = {}; //   0
  c_t[x_a][102] = { 30}; //   1
  c_d[x_a][102] = { 23,  18,   0}; //   3

  c_p[x_a][103] = {  1,  41,  42}; //   3
  c_f[x_a][103] = {}; //   0
  c_t[x_a][103] = { 30}; //   1
  c_d[x_a][103] = { 23,  18,   0}; //   3

  c_p[x_a][104] = { 26,  43,  44}; //   3
  c_f[x_a][104] = {}; //   0
  c_t[x_a][104] = { 28}; //   1
  c_d[x_a][104] = {  4,   5,  21}; //   3

  c_p[x_a][105] = { 26,  43,  45}; //   3
  c_f[x_a][105] = {}; //   0
  c_t[x_a][105] = { 28}; //   1
  c_d[x_a][105] = {  4,   5,  21}; //   3

  c_p[x_a][106] = { 26,  27}; //   2
  c_f[x_a][106] = {  3}; //   1
  c_t[x_a][106] = {  8,  31}; //   2
  c_d[x_a][106] = {  0,  21}; //   2

  c_p[x_a][107] = { 26,  28}; //   2
  c_f[x_a][107] = {  3}; //   1
  c_t[x_a][107] = {  8,  31}; //   2
  c_d[x_a][107] = {  0,  21}; //   2

  c_p[x_a][108] = {  0,  29}; //   2
  c_f[x_a][108] = {  3}; //   1
  c_t[x_a][108] = {  8,  16}; //   2
  c_d[x_a][108] = { 21,   0}; //   2

  c_p[x_a][109] = {  1,  29}; //   2
  c_f[x_a][109] = {  3}; //   1
  c_t[x_a][109] = {  8,  16}; //   2
  c_d[x_a][109] = { 21,   0}; //   2

  c_p[x_a][110] = {  0,  41}; //   2
  c_f[x_a][110] = { 12}; //   1
  c_t[x_a][110] = { 11,  18}; //   2
  c_d[x_a][110] = { 18,   0}; //   2

  c_p[x_a][111] = {  1,  41}; //   2
  c_f[x_a][111] = { 12}; //   1
  c_t[x_a][111] = { 11,  18}; //   2
  c_d[x_a][111] = { 18,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_bbx_emepabbx
//  channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
//  channel    1: 2v111(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel    2: 2v111(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
//  channel    3: 2v111(1, 2, 4, 8, 32, 64, 16;  23,   0,   0,   0)
//  channel    4: 3yv11(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
//  channel    5: 3yv11(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel    6: 3yv11(1, 2, 32, 4, 8, 64, 16;   0,   0,   0,   0)
//  channel    7: 3yv11(1, 2, 32, 4, 8, 64, 16;  23,   0,   0,   0)
//  channel    8: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
//  channel    9: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,  23,   0,   0)
//  channel   10: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
//  channel   11: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   12: 4yyv1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel   13: 4yyv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   14: 4yyv1(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
//  channel   15: 4yyv1(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
//  channel   16: 4yyv1(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
//  channel   17: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
//  channel   18: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
//  channel   19: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,  23,   0,   0)
//  channel   20: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
//  channel   21: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel   22: 5yyyv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel   23: 5yyyv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
//  channel   24: 5yyyv(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
//  channel   25: 5yyyv(1, 2, 64, 32, 4, 8, 16;   0,  23,   0,   0)
//  channel   26: 5yyyv(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
//  channel   27: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel   28: 5yyyv(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
//  channel   29: 5yyyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel   30: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
//  channel   31: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
//  channel   32: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
//  channel   33: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,  23,   0,   0)
//  channel   34: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
//  channel   35: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
//  channel   36: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
//  channel   37: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   38: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
//  channel   39: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   40: 52vyv(1, 2, 16, 64, 32, 4, 8;   0,   0,   0,   0)
//  channel   41: 52vyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   42: 12v11(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
//  channel   43: 12v11(1, 2, 16, 4, 8, 32, 64;  23,   0,   0,   0)
//  channel   44: 13yv1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel   45: 13yv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   46: 13yv1(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
//  channel   47: 13yv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
//  channel   48: 14yyv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel   49: 14yyv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
//  channel   50: 14yyv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
//  channel   51: 14yyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   52: 14yyv(1, 2, 16, 64, 32, 4, 8;   0,   0,   0,   0)
//  channel   53: 14yyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   54: 14yyv(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
//  channel   55: 14yyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel   56: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
//  channel   57: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
//  channel   58: 142vv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
//  channel   59: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   60: 112v1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel   61: 112v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   62: 113yv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel   63: 113yv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
//  channel   64: 113yv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
//  channel   65: 113yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   66: 113yv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
//  channel   67: 113yv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
//  channel   68: 1112v(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
//  channel   69: 1112v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   70: 1112v(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
//  channel   71: 1112v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
//  channel   72: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
//  channel   73: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel   74: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
//  channel   75: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,  23,   0,   0)
//  channel   76: 2v2v1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel   77: 2v2v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   78: 2v3yv(1, 2, 4, 8, 64, 16, 32;   0,   0,   0,   0)
//  channel   79: 2v3yv(1, 2, 4, 8, 64, 16, 32;   0,   0,  23,   0)
//  channel   80: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
//  channel   81: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,   0,  23,   0)
//  channel   82: 2v3yv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel   83: 2v3yv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
//  channel   84: 2v3yv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
//  channel   85: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   86: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
//  channel   87: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
//  channel   88: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
//  channel   89: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel   90: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
//  channel   91: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,  23,   0,   0)
//  channel   92: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
//  channel   93: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   94: 2v12v(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
//  channel   95: 2v12v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
//  channel   96: 3yv2v(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
//  channel   97: 3yv2v(1, 2, 4, 8, 16, 32, 64;   0,   0,  23,   0)
//  channel   98: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
//  channel   99: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel  100: 3yv2v(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
//  channel  101: 3yv2v(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel  102: 3yv2v(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
//  channel  103: 3yv2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel  104: 3yv2v(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
//  channel  105: 3yv2v(1, 2, 8, 4, 16, 32, 64;   0,   0,  23,   0)
//  channel  106: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
//  channel  107: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,  23,   0,   0)
//  channel  108: 12v2v(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
//  channel  109: 12v2v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel  110: 12v2v(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
//  channel  111: 12v2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
