#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_040_ba_emepab(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_040_ba_emepab");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(14);
  needed_v_smin[x_a].resize(14);
  needed_v_smin[x_a][  0] = {   8,    9,   20,   21,   24,   25,   28,   29,   32,   33,   38,   39}; //  12
  needed_v_smin[x_a][  1] = {  10,   11,   12,   13,   24,   25,   38,   39}; //   8
  needed_v_smin[x_a][  2] = {  14,   15,   18,   19,   30,   31,   34,   35,    4,    5}; //  10
  needed_v_smin[x_a][  3] = {  14,   15,   18,   19,    4,    5,   30,   31,   34,   35}; //  10
  needed_v_smin[x_a][  4] = {  16,   17,   22,   23,   26,   27,   36,   37,    0,    1}; //  10
  needed_v_smin[x_a][  5] = {  16,   17,   22,   23,    0,    1,   26,   27,   36,   37}; //  10
  needed_v_smin[x_a][  6] = {  20,   21,   32,   33,   28,   29}; //   6
  needed_v_smin[x_a][  7] = {   2,    3}; //   2
  needed_v_smin[x_a][  8] = {   2,    3}; //   2
  needed_v_smin[x_a][  9] = {   6,    7}; //   2
  needed_v_smin[x_a][ 10] = {   6,    7}; //   2
  needed_v_smin[x_a][ 11] = {   8,    9}; //   2
  needed_v_smin[x_a][ 12] = {  10,   11}; //   2
  needed_v_smin[x_a][ 13] = {  12,   13}; //   2

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   8,    9,   20,   21,   28,   29,   32,   33}; //   8
  needed_v_smax[x_a][  1] = {  10,   11,   12,   13,   24,   25,   38,   39}; //   8
  needed_v_smax[x_a][  2] = {  14,   15,   18,   19,   30,   31,   34,   35,    4,    5}; //  10
  needed_v_smax[x_a][  3] = {  14,   15,   16,   17,   18,   19,   22,   23,    0,    1,    4,    5,    8,    9,   26,   27,   30,   31,   34,   35,   36,   37}; //  22
  needed_v_smax[x_a][  4] = {  16,   17,   22,   23,   26,   27,   36,   37,    0,    1}; //  10
  needed_v_smax[x_a][  5] = {  20,   21,   32,   33,    2,    3,    6,    7,   28,   29}; //  10
  needed_v_smax[x_a][  6] = {  24,   25,   38,   39}; //   4
  needed_v_smax[x_a][  7] = {   2,    3}; //   2
  needed_v_smax[x_a][  8] = {   6,    7}; //   2
  needed_v_smax[x_a][  9] = {  10,   11}; //   2
  needed_v_smax[x_a][ 10] = {  12,   13}; //   2

  g_p[x_a].resize(12);
  needed_g_p[x_a].resize(12);
  needed_g_p[x_a][0] = {   8,   20,   28,   32}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   9,   21,   29,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {  10,   11,   12,   13,   24,   25,   38,   39}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {  14,   15,   18,   19,   30,   31,   34,   35}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {  14,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {  15,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][6] = {  16,   17,   22,   23,   26,   27,   36,   37}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][7] = {  16,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax3");
  needed_g_p[x_a][8] = {  17,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax3");
  needed_g_p[x_a][9] = {  20,   21,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][10] = {  24,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][11] = {  25,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");

  g_f[x_a].resize(12);
  needed_g_f[x_a].resize(12);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][1] = {   0,    1,   26,   27,   36,   37}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax3");
  needed_g_f[x_a][2] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax7");
  needed_g_f[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][4] = {   4,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][5] = {   4,    5,   30,   31,   34,   35}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][6] = {   6,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax8");
  needed_g_f[x_a][7] = {   6,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax5");
  needed_g_f[x_a][8] = {   8,    9}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax3");
  needed_g_f[x_a][9] = {  10,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax9");
  needed_g_f[x_a][10] = {  12,   13}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax10");
  needed_g_f[x_a][11] = {  28,   29}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax5");

  g_t[x_a].resize(25);
  needed_g_t[x_a].resize(25);
  needed_g_t[x_a][0] = {   0,    4,   26,   30,   34,   36}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][1] = {   0,    1,   26,   27}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_20");
  needed_g_t[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__4_16");
  needed_g_t[x_a][3] = {   1,    5,   27,   31,   35,   37}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__1_2__32_28");
  needed_g_t[x_a][4] = {   2,    3,    6,    7,   28,   29,   32,   33}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__17_10__32_4");
  needed_g_t[x_a][8] = {   4,    5,   30,   31}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_24");
  needed_g_t[x_a][9] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__8_16");
  needed_g_t[x_a][10] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][11] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][12] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__17_6__32_8");
  needed_g_t[x_a][13] = {   8,    9,   14,   15,   16,   17}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][14] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][15] = {  10,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][16] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][17] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__1_10__48_4");
  needed_g_t[x_a][18] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][19] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_8");
  needed_g_t[x_a][20] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__1_6__48_8");
  needed_g_t[x_a][21] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][22] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__24_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__24_4");
  needed_g_t[x_a][23] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__20_8");
  needed_g_t[x_a][24] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   8,    9,   20,   21,   24,   25,   28,   29,   32,   33,   38,   39}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  10,   11,   12,   13,   24,   25,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {  14,   15,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][3] = {  14,   15,   18,   19,   30,   31,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {  16,   17,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][5] = {  16,   17,   22,   23,   26,   27,   36,   37}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {  18,   19,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {  20,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {  20,   21,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {  24,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");

  c_p[x_a].resize(40);
  c_f[x_a].resize(40);
  c_t[x_a].resize(40);
  c_d[x_a].resize(40);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  3,   1,   2}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  4,   5,   6}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  2,   3}; //   2
  c_t[x_a][3] = {  4,   5,   7}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  4,   5}; //   2
  c_t[x_a][4] = {  0,   8,   9}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  4,   5}; //   2
  c_t[x_a][5] = {  3,   8,   9}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  6,   7}; //   2
  c_t[x_a][6] = {  4,  10,  11}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  6,   7}; //   2
  c_t[x_a][7] = {  4,  10,  12}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  8}; //   1
  c_t[x_a][8] = { 13,  14}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  1}; //   1
  c_f[x_a][9] = {  8}; //   1
  c_t[x_a][9] = { 13,  14}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  2}; //   1
  c_f[x_a][10] = {  9}; //   1
  c_t[x_a][10] = { 15,  16}; //   2
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  2}; //   1
  c_f[x_a][11] = {  9}; //   1
  c_t[x_a][11] = { 15,  17}; //   2
  c_d[x_a][11] = {  1}; //   1

  c_p[x_a][12] = {  2}; //   1
  c_f[x_a][12] = { 10}; //   1
  c_t[x_a][12] = { 18,  19}; //   2
  c_d[x_a][12] = {  1}; //   1

  c_p[x_a][13] = {  2}; //   1
  c_f[x_a][13] = { 10}; //   1
  c_t[x_a][13] = { 18,  20}; //   2
  c_d[x_a][13] = {  1}; //   1

  c_p[x_a][14] = {  3,   4}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 13}; //   1
  c_d[x_a][14] = {  2,   3}; //   2

  c_p[x_a][15] = {  3,   5}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 13}; //   1
  c_d[x_a][15] = {  2,   3}; //   2

  c_p[x_a][16] = {  6,   7}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 13}; //   1
  c_d[x_a][16] = {  4,   5}; //   2

  c_p[x_a][17] = {  6,   8}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 13}; //   1
  c_d[x_a][17] = {  4,   5}; //   2

  c_p[x_a][18] = {  3,   4}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  6,   2,   3}; //   3

  c_p[x_a][19] = {  3,   5}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  6,   2,   3}; //   3

  c_p[x_a][20] = {  0,   9}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  7,   8,   0}; //   3

  c_p[x_a][21] = {  1,   9}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  7,   8,   0}; //   3

  c_p[x_a][22] = {  6,   7}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  6,   4,   5}; //   3

  c_p[x_a][23] = {  6,   8}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  6,   4,   5}; //   3

  c_p[x_a][24] = {  2,  10}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = {  9,   0,   1}; //   3

  c_p[x_a][25] = {  2,  11}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = {  9,   0,   1}; //   3

  c_p[x_a][26] = {  6}; //   1
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  0,   1}; //   2
  c_d[x_a][26] = {  5}; //   1

  c_p[x_a][27] = {  6}; //   1
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  3,   1}; //   2
  c_d[x_a][27] = {  5}; //   1

  c_p[x_a][28] = {  0}; //   1
  c_f[x_a][28] = { 11}; //   1
  c_t[x_a][28] = {  4,  21}; //   2
  c_d[x_a][28] = {  0}; //   1

  c_p[x_a][29] = {  1}; //   1
  c_f[x_a][29] = { 11}; //   1
  c_t[x_a][29] = {  4,  21}; //   2
  c_d[x_a][29] = {  0}; //   1

  c_p[x_a][30] = {  3}; //   1
  c_f[x_a][30] = {  5}; //   1
  c_t[x_a][30] = {  0,   8}; //   2
  c_d[x_a][30] = {  3}; //   1

  c_p[x_a][31] = {  3}; //   1
  c_f[x_a][31] = {  5}; //   1
  c_t[x_a][31] = {  3,   8}; //   2
  c_d[x_a][31] = {  3}; //   1

  c_p[x_a][32] = {  0,   9}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  4}; //   1
  c_d[x_a][32] = {  8,   0}; //   2

  c_p[x_a][33] = {  1,   9}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  4}; //   1
  c_d[x_a][33] = {  8,   0}; //   2

  c_p[x_a][34] = {  3}; //   1
  c_f[x_a][34] = {  5}; //   1
  c_t[x_a][34] = {  0,  22}; //   2
  c_d[x_a][34] = {  3}; //   1

  c_p[x_a][35] = {  3}; //   1
  c_f[x_a][35] = {  5}; //   1
  c_t[x_a][35] = {  3,  22}; //   2
  c_d[x_a][35] = {  3}; //   1

  c_p[x_a][36] = {  6}; //   1
  c_f[x_a][36] = {  1}; //   1
  c_t[x_a][36] = {  0,  23}; //   2
  c_d[x_a][36] = {  5}; //   1

  c_p[x_a][37] = {  6}; //   1
  c_f[x_a][37] = {  1}; //   1
  c_t[x_a][37] = {  3,  23}; //   2
  c_d[x_a][37] = {  5}; //   1

  c_p[x_a][38] = {  2,  10}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 24}; //   1
  c_d[x_a][38] = {  0,   1}; //   2

  c_p[x_a][39] = {  2,  11}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 24}; //   1
  c_d[x_a][39] = {  0,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_040_ba_emepab
//  channel    0: 1111(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel    1: 1111(1, 2, 32, 4, 16, 8;  23,   0,   0)
//  channel    2: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    3: 1111(1, 2, 16, 32, 4, 8;   0,   0,  23)
//  channel    4: 1111(1, 2, 32, 8, 16, 4;   0,   0,   0)
//  channel    5: 1111(1, 2, 32, 8, 16, 4;  23,   0,   0)
//  channel    6: 1111(1, 2, 16, 32, 8, 4;   0,   0,   0)
//  channel    7: 1111(1, 2, 16, 32, 8, 4;   0,   0,  23)
//  channel    8: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    9: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel   10: 2v11(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   11: 2v11(1, 2, 16, 32, 4, 8;   0,   0,  23)
//  channel   12: 2v11(1, 2, 16, 32, 8, 4;   0,   0,   0)
//  channel   13: 2v11(1, 2, 16, 32, 8, 4;   0,   0,  23)
//  channel   14: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   15: 3yv1(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   16: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   17: 3yv1(1, 2, 8, 4, 16, 32;   0,  23,   0)
//  channel   18: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   19: 4yyv(1, 2, 32, 4, 8, 16;   0,  23,   0)
//  channel   20: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   21: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   22: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   23: 4yyv(1, 2, 32, 8, 4, 16;   0,  23,   0)
//  channel   24: 42vv(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   25: 42vv(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   26: 12v1(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel   27: 12v1(1, 2, 32, 4, 16, 8;   0,  23,   0)
//  channel   28: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   29: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   30: 12v1(1, 2, 32, 8, 16, 4;   0,   0,   0)
//  channel   31: 12v1(1, 2, 32, 8, 16, 4;   0,  23,   0)
//  channel   32: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   33: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   34: 112v(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   35: 112v(1, 2, 32, 4, 8, 16;   0,  23,   0)
//  channel   36: 112v(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   37: 112v(1, 2, 32, 8, 4, 16;   0,  23,   0)
//  channel   38: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   39: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
