#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_130_gb_emepab(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_130_gb_emepab");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(8);
  needed_v_smin[x_a].resize(8);
  needed_v_smin[x_a][  0] = {   0,    1,    4,    5,    8,    9,   10,   11,   16,   17,   18,   19}; //  12
  needed_v_smin[x_a][  1] = {   0,    1,    4,    5}; //   4
  needed_v_smin[x_a][  2] = {   2,    3,   12,   13}; //   4
  needed_v_smin[x_a][  3] = {   2,    3,   12,   13}; //   4
  needed_v_smin[x_a][  4] = {   6,    7,   14,   15}; //   4
  needed_v_smin[x_a][  5] = {   6,    7,   14,   15}; //   4
  needed_v_smin[x_a][  6] = {   8,    9,   18,   19}; //   4
  needed_v_smin[x_a][  7] = {  10,   11,   16,   17}; //   4

  v_smax[x_a].resize(8);
  needed_v_smax[x_a].resize(8);
  needed_v_smax[x_a][  0] = {   0,    1,    4,    5,   10,   11,   16,   17,   18,   19}; //  10
  needed_v_smax[x_a][  1] = {   0,    1,    4,    5}; //   4
  needed_v_smax[x_a][  2] = {   2,    3,   12,   13}; //   4
  needed_v_smax[x_a][  3] = {   2,    3,    6,    7,   12,   13,   14,   15,   10,   11,   16,   17}; //  12
  needed_v_smax[x_a][  4] = {   6,    7,   14,   15}; //   4
  needed_v_smax[x_a][  5] = {   8,    9}; //   2
  needed_v_smax[x_a][  6] = {   8,    9}; //   2
  needed_v_smax[x_a][  7] = {  18,   19}; //   2

  g_p[x_a].resize(13);
  needed_g_p[x_a].resize(13);
  needed_g_p[x_a][0] = {   0,    4,   10,   16,   18}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    4,    5}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    5,   11,   17,   19}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {   2,    3,   12,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   2,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   3,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][6] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][7] = {   6,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax3");
  needed_g_p[x_a][8] = {   7,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax3");
  needed_g_p[x_a][9] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][10] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][11] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][12] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax7");

  g_f[x_a].resize(1);
  needed_g_f[x_a].resize(1);
  needed_g_f[x_a][0] = {  10,   11,   16,   17}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax3");

  g_t[x_a].resize(5);
  needed_g_t[x_a].resize(5);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][1] = {  10,   11,   12,   13,   14,   15,   16,   17}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][2] = {  10,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][3] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");
  needed_g_t[x_a][4] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   0,    1,    4,    5}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][1] = {   0,    1,    4,    5,    8,    9,   10,   11,   16,   17,   18,   19}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   2,    3,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][3] = {   2,    3,   12,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {   2,    3,   12,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][6] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][7] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][8] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][9] = {   8,    9,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(20);
  c_f[x_a].resize(20);
  c_t[x_a].resize(20);
  c_d[x_a].resize(20);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  2,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1}; //   2

  c_p[x_a][2] = {  3,   4}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  2,   3,   4}; //   3

  c_p[x_a][3] = {  3,   5}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  2,   3,   4}; //   3

  c_p[x_a][4] = {  0,   1}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  5,   0,   1}; //   3

  c_p[x_a][5] = {  2,   1}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,   0,   1}; //   3

  c_p[x_a][6] = {  6,   7}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  2,   6,   7}; //   3

  c_p[x_a][7] = {  6,   8}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  2,   6,   7}; //   3

  c_p[x_a][8] = {  9,  10}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  8,   1,   9}; //   3

  c_p[x_a][9] = {  9,  11}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  8,   1,   9}; //   3

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  1,   2}; //   2
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  2}; //   1
  c_f[x_a][11] = {  0}; //   1
  c_t[x_a][11] = {  1,   2}; //   2
  c_d[x_a][11] = {  1}; //   1

  c_p[x_a][12] = {  3,   4}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  1}; //   1
  c_d[x_a][12] = {  3,   4}; //   2

  c_p[x_a][13] = {  3,   5}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  1}; //   1
  c_d[x_a][13] = {  3,   4}; //   2

  c_p[x_a][14] = {  6,   7}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  1}; //   1
  c_d[x_a][14] = {  6,   7}; //   2

  c_p[x_a][15] = {  6,   8}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  1}; //   1
  c_d[x_a][15] = {  6,   7}; //   2

  c_p[x_a][16] = {  0}; //   1
  c_f[x_a][16] = {  0}; //   1
  c_t[x_a][16] = {  1,   3}; //   2
  c_d[x_a][16] = {  1}; //   1

  c_p[x_a][17] = {  2}; //   1
  c_f[x_a][17] = {  0}; //   1
  c_t[x_a][17] = {  1,   3}; //   2
  c_d[x_a][17] = {  1}; //   1

  c_p[x_a][18] = {  0,  12}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  4}; //   1
  c_d[x_a][18] = {  9,   1}; //   2

  c_p[x_a][19] = {  2,  12}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  4}; //   1
  c_d[x_a][19] = {  9,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_130_gb_emepab
//  channel    0: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    1: 3yv1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel    2: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    3: 4yyv(1, 2, 32, 4, 8, 16;   0,  23,   0)
//  channel    4: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    5: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel    6: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel    7: 4yyv(1, 2, 32, 8, 4, 16;   0,  23,   0)
//  channel    8: 42vv(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    9: 42vv(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   10: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   11: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel   12: 13yv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   13: 13yv(1, 2, 32, 4, 8, 16;   0,  23,   0)
//  channel   14: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   15: 13yv(1, 2, 32, 8, 4, 16;   0,  23,   0)
//  channel   16: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   17: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   18: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   19: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)

void ppeexa03_phasespace_set::ax_psp_330_gb_emepab(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_330_gb_emepab");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(8);
  needed_v_smin[x_a].resize(8);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  20
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 20);
  int needed_v_smin_1[] = {   6,    7}; //   2
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   6,    7}; //   2
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   8,    9,   10,   11,    0,    1,    2,    3}; //   8
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 8);
  int needed_v_smin_4[] = {  12,   13}; //   2
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 2);
  int needed_v_smin_5[] = {  12,   13}; //   2
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 2);
  int needed_v_smin_6[] = {  18,   19,    4,    5,   14,   15,   16,   17,   20,   21}; //  10
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 10);
  int needed_v_smin_7[] = {  22,   23}; //   2
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 2);

  v_smax[x_a].resize(7);
  needed_v_smax[x_a].resize(7);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21}; //  18
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 18);
  int needed_v_smax_1[] = {   6,    7}; //   2
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   6,    7,    8,    9,   10,   11,   12,   13,    0,    1,    2,    3}; //  12
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 12);
  int needed_v_smax_3[] = {  12,   13}; //   2
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 2);
  int needed_v_smax_4[] = {  18,   19,    4,    5,   14,   15,   16,   17,   20,   21}; //  10
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 10);
  int needed_v_smax_5[] = {  22,   23}; //   2
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 2);
  int needed_v_smax_6[] = {  22,   23}; //   2
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 2);

  g_p[x_a].resize(14);
  needed_g_p[x_a].resize(14);
  needed_g_p[x_a][0] = {   0,    1,    4,    8,    9,   14,   15,   18,   20}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    3,    5,   10,   11,   16,   17,   19,   21}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   8,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax2");
  needed_g_p[x_a][6] = {   9,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin3_smax2");
  needed_g_p[x_a][7] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][8] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax2");
  needed_g_p[x_a][9] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][10] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][11] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][12] = {  22}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][13] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax2");
  needed_g_f[x_a][1] = {   4,    5,   14,   15,   16,   17,   20,   21}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    6,    7,    8,    9,   10,   11,   12,   13}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   1,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_34__12_16");
  needed_g_t[x_a][3] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][4] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][5] = {  14,   16,   18,   19,   20,   21}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {  14,   15,   16,   17}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][7] = {  15,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__16_44");
  needed_g_t[x_a][8] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][9] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");

  g_d[x_a].resize(8);
  needed_g_d[x_a].resize(8);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][4] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][5] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][7] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   2}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  1}; //   1
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   2}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  1}; //   1
  c_t[x_a][4] = {  3,   4}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  3,   4}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  2,   3}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  1,   2}; //   2

  c_p[x_a][7] = {  2,   4}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  1,   2}; //   2

  c_p[x_a][8] = {  0,   5}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  3,   0}; //   2

  c_p[x_a][9] = {  0,   6}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  3,   0}; //   2

  c_p[x_a][10] = {  1,   5}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  3,   0}; //   2

  c_p[x_a][11] = {  1,   6}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  3,   0}; //   2

  c_p[x_a][12] = {  7,   8}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  4,   5}; //   2

  c_p[x_a][13] = {  7,   9}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  4,   5}; //   2

  c_p[x_a][14] = {  0}; //   1
  c_f[x_a][14] = {  1}; //   1
  c_t[x_a][14] = {  5,   6}; //   2
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  0}; //   1
  c_f[x_a][15] = {  1}; //   1
  c_t[x_a][15] = {  7,   6}; //   2
  c_d[x_a][15] = {  0}; //   1

  c_p[x_a][16] = {  1}; //   1
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  5,   6}; //   2
  c_d[x_a][16] = {  0}; //   1

  c_p[x_a][17] = {  1}; //   1
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  7,   6}; //   2
  c_d[x_a][17] = {  0}; //   1

  c_p[x_a][18] = {  0,  10}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  5}; //   1
  c_d[x_a][18] = {  6,   0}; //   2

  c_p[x_a][19] = {  1,  10}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  5}; //   1
  c_d[x_a][19] = {  6,   0}; //   2

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = {  1}; //   1
  c_t[x_a][20] = {  5,   8}; //   2
  c_d[x_a][20] = {  0}; //   1

  c_p[x_a][21] = {  1}; //   1
  c_f[x_a][21] = {  1}; //   1
  c_t[x_a][21] = {  5,   8}; //   2
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = { 11,  12}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  9}; //   1
  c_d[x_a][22] = {  0,   7}; //   2

  c_p[x_a][23] = { 11,  13}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  9}; //   1
  c_d[x_a][23] = {  0,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_130_gb_emepab
//  channel    0: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    1: 2v11(1, 2, 4, 8, 16, 32;   0,   0,  36)
//  channel    2: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    3: 2v11(1, 2, 4, 8, 16, 32;  23,   0,  36)
//  channel    4: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel    5: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel    6: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    7: 3yv1(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel    8: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    9: 3yv1(1, 2, 16, 4, 8, 32;   0,  36,   0)
//  channel   10: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   11: 3yv1(1, 2, 16, 4, 8, 32;  23,  36,   0)
//  channel   12: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   13: 3yv1(1, 2, 8, 4, 16, 32;   0,  23,   0)
//  channel   14: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   15: 12v1(1, 2, 16, 4, 8, 32;   0,  36,   0)
//  channel   16: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   17: 12v1(1, 2, 16, 4, 8, 32;  23,  36,   0)
//  channel   18: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   19: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   20: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   21: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   22: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   23: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
