#include "header.hpp"

#include "ppeexexne04.phasespace.set.hpp"

void ppeexexne04_phasespace_set::ax_psp_040_udx_emepepve(int x_a){
  static Logger logger("ppeexexne04_phasespace_set::ax_psp_040_udx_emepepve");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(10);
  needed_v_smin[x_a].resize(10);
  needed_v_smin[x_a][  0] = {   0,   10,   11,   14,   15,   18,   19}; //   7
  needed_v_smin[x_a][  1] = {   0}; //   1
  needed_v_smin[x_a][  2] = {   1,    2,    3,    8,    9,   12,   13,   16,   17}; //   9
  needed_v_smin[x_a][  3] = {   1}; //   1
  needed_v_smin[x_a][  4] = {   2,    3}; //   2
  needed_v_smin[x_a][  5] = {   4,    8,    9,   12,   13,   16,   17}; //   7
  needed_v_smin[x_a][  6] = {   4}; //   1
  needed_v_smin[x_a][  7] = {   5,    6,    7,   10,   11,   14,   15,   18,   19}; //   9
  needed_v_smin[x_a][  8] = {   5}; //   1
  needed_v_smin[x_a][  9] = {   6,    7}; //   2

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   0,   10,   11,   14,   15}; //   5
  needed_v_smax[x_a][  1] = {   0,    1}; //   2
  needed_v_smax[x_a][  2] = {   1,    2,    3,   16,   17}; //   5
  needed_v_smax[x_a][  3] = {   2,    3,    6,    7}; //   4
  needed_v_smax[x_a][  4] = {   4,    8,    9,   12,   13}; //   5
  needed_v_smax[x_a][  5] = {   4,    5}; //   2
  needed_v_smax[x_a][  6] = {   5,    6,    7,   18,   19}; //   5
  needed_v_smax[x_a][  7] = {   8,    9,   12,   13}; //   4
  needed_v_smax[x_a][  8] = {  10,   11,   14,   15}; //   4
  needed_v_smax[x_a][  9] = {  16,   17}; //   2
  needed_v_smax[x_a][ 10] = {  18,   19}; //   2

  g_p[x_a].resize(18);
  needed_g_p[x_a].resize(18);
  needed_g_p[x_a][0] = {   0,   10,   11,   14,   15}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    3,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax1");
  needed_g_p[x_a][4] = {   2,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][6] = {   4,    8,    9,   12,   13}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   5,    7,   19}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax6");
  needed_g_p[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax5");
  needed_g_p[x_a][10] = {   6,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][11] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax3");
  needed_g_p[x_a][12] = {   8,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax7");
  needed_g_p[x_a][13] = {   9,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax7");
  needed_g_p[x_a][14] = {  10,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax8");
  needed_g_p[x_a][15] = {  11,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax8");
  needed_g_p[x_a][16] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax9");
  needed_g_p[x_a][17] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax10");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][1] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][2] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");
  needed_g_t[x_a][3] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");

  g_d[x_a].resize(15);
  needed_g_d[x_a].resize(15);
  needed_g_d[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][2] = {   0,   10,   11,   14,   15,   18,   19}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][4] = {   1,    2,    3,    8,    9,   12,   13,   16,   17}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][5] = {   2,    3,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][7] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][9] = {   4,    8,    9,   12,   13,   16,   17}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][10] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][11] = {   5,    6,    7,   10,   11,   14,   15,   18,   19}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][12] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][13] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][14] = {  10,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(20);
  c_f[x_a].resize(20);
  c_t[x_a].resize(20);
  c_d[x_a].resize(20);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  2,   3}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   3,   4}; //   3

  c_p[x_a][2] = {  4,   5}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  5,   6,   4}; //   3

  c_p[x_a][3] = {  2,   5}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  5,   6,   4}; //   3

  c_p[x_a][4] = {  6,   7}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  7,   8,   9}; //   3

  c_p[x_a][5] = {  8,   9}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  7,  10,  11}; //   3

  c_p[x_a][6] = { 10,  11}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  5,  12,  11}; //   3

  c_p[x_a][7] = {  8,  11}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,  12,  11}; //   3

  c_p[x_a][8] = {  6,  12}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 13,   4,   9}; //   3

  c_p[x_a][9] = {  6,  13}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 13,   4,   9}; //   3

  c_p[x_a][10] = {  0,  14}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 14,  11,   2}; //   3

  c_p[x_a][11] = {  0,  15}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 14,  11,   2}; //   3

  c_p[x_a][12] = {  6,  12}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  4,   9}; //   2

  c_p[x_a][13] = {  6,  13}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  4,   9}; //   2

  c_p[x_a][14] = {  0,  14}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  1}; //   1
  c_d[x_a][14] = { 11,   2}; //   2

  c_p[x_a][15] = {  0,  15}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  1}; //   1
  c_d[x_a][15] = { 11,   2}; //   2

  c_p[x_a][16] = {  4,  16}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = {  9,   4}; //   2

  c_p[x_a][17] = {  2,  16}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  2}; //   1
  c_d[x_a][17] = {  9,   4}; //   2

  c_p[x_a][18] = { 10,  17}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  3}; //   1
  c_d[x_a][18] = {  2,  11}; //   2

  c_p[x_a][19] = {  8,  17}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  3}; //   1
  c_d[x_a][19] = {  2,  11}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_040_udx_emepepve
//  channel    0: 4yyv(1, 2, 16, 4, 8, 32;  24,   0,  24)
//  channel    1: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,  24)
//  channel    2: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,  24)
//  channel    3: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,  24)
//  channel    4: 4yyv(1, 2, 8, 4, 16, 32;  24,   0,  24)
//  channel    5: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,  24)
//  channel    6: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,  24)
//  channel    7: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,  24)
//  channel    8: 42vv(1, 2, 4, 8, 16, 32;  24,   0,  24)
//  channel    9: 42vv(1, 2, 4, 8, 16, 32;  24,  23,  24)
//  channel   10: 42vv(1, 2, 4, 16, 8, 32;  24,   0,  24)
//  channel   11: 42vv(1, 2, 4, 16, 8, 32;  24,  23,  24)
//  channel   12: 2v2v(1, 2, 4, 8, 16, 32;  24,   0,   0)
//  channel   13: 2v2v(1, 2, 4, 8, 16, 32;  24,  23,   0)
//  channel   14: 2v2v(1, 2, 4, 16, 8, 32;  24,   0,   0)
//  channel   15: 2v2v(1, 2, 4, 16, 8, 32;  24,  23,   0)
//  channel   16: 2v2v(1, 2, 16, 32, 4, 8;   0,  24,   0)
//  channel   17: 2v2v(1, 2, 16, 32, 4, 8;  23,  24,   0)
//  channel   18: 2v2v(1, 2, 8, 32, 4, 16;   0,  24,   0)
//  channel   19: 2v2v(1, 2, 8, 32, 4, 16;  23,  24,   0)
