#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_050_udx_emepmupvma(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_050_udx_emepmupvma");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(23);
  needed_v_smin[x_a].resize(23);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    7,   10,   11,   12,   13,   20,   21,   22,   23,   25,   26,   27,   28,   31,   35,   36,   37,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   53,   54,   55,   56,   59,   60,   61,   62,   65,   66,   67,   68}; //  44
  needed_v_smin[x_a][  1] = {   0,    7,   31,   35}; //   4
  needed_v_smin[x_a][  2] = {   0,    7,   35}; //   3
  needed_v_smin[x_a][  3] = {   1,    2,   10,   11,   12,   13,   36,   37}; //   8
  needed_v_smin[x_a][  4] = {   1,    2,   12,   13,   36,   37}; //   6
  needed_v_smin[x_a][  5] = {   3,    4,    5,   14,   15,   20,   21,   24,   25,   26,   29,   30,   32,   33,   34,   38,   39,   40,   41,   42,   43,   44,   45,   46,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   63,   64,   65,   66,   67,   68}; //  42
  needed_v_smin[x_a][  6] = {   3,   15,   32,   38}; //   4
  needed_v_smin[x_a][  7] = {   3,   15,   38}; //   3
  needed_v_smin[x_a][  8] = {   4,    5,   20,   21,   39,   40,   41,   42,   43,   44,   65,   66,   67,   68}; //  14
  needed_v_smin[x_a][  9] = {   6,    8,    9,   29,   30,   32,   49,   50,   57,   58}; //  10
  needed_v_smin[x_a][ 10] = {   6,    8,    9,   29,   30,   49,   50,   57,   58}; //   9
  needed_v_smin[x_a][ 11] = {   6,   17}; //   2
  needed_v_smin[x_a][ 12] = {   8,    9,   18,   19}; //   4
  needed_v_smin[x_a][ 13] = {  10,   11}; //   2
  needed_v_smin[x_a][ 14] = {  14,   25,   26,   45,   46,   59,   60,   53,   54}; //   9
  needed_v_smin[x_a][ 15] = {  14,   16}; //   2
  needed_v_smin[x_a][ 16] = {  16,   22,   23,   27,   28,   31,   47,   48,   61,   62}; //  10
  needed_v_smin[x_a][ 17] = {  16,   27,   28,   47,   48,   61,   62}; //   7
  needed_v_smin[x_a][ 18] = {  17,   18,   19,   24,   33,   34,   51,   52,   63,   64}; //  10
  needed_v_smin[x_a][ 19] = {  17,   18,   19,   33,   34,   51,   52,   63,   64}; //   9
  needed_v_smin[x_a][ 20] = {  22,   23}; //   2
  needed_v_smin[x_a][ 21] = {  24}; //   1
  needed_v_smin[x_a][ 22] = {  55,   56}; //   2

  v_smax[x_a].resize(26);
  needed_v_smax[x_a].resize(26);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    7,   10,   11,   12,   13,   31,   35,   36,   37,   43,   44,   55,   56,   59,   60,   61,   62,   67,   68}; //  22
  needed_v_smax[x_a][  1] = {   0,    7,   31,   35}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    7,   12,   13,   15,   20,   21,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   65,   66,   67,   68}; //  26
  needed_v_smax[x_a][  3] = {   1,    2,   10,   11,   12,   13,   36,   37}; //   8
  needed_v_smax[x_a][  4] = {   3,    4,    5,   14,   15,   20,   21,   24,   25,   26,   32,   38,   39,   40,   41,   42,   45,   46,   53,   54,   57,   58,   63,   64,   65,   66}; //  26
  needed_v_smax[x_a][  5] = {   3,   15,   32,   38}; //   4
  needed_v_smax[x_a][  6] = {   4,    5,   20,   21,   39,   40,   41,   42,   53,   54,   65,   66}; //  12
  needed_v_smax[x_a][  7] = {   6,    8,    9,   29,   30,   49,   50}; //   7
  needed_v_smax[x_a][  8] = {   6,    8,    9,   17,   18,   19,   29,   30,   33,   34,   49,   50,   51,   52}; //  14
  needed_v_smax[x_a][  9] = {   6,   17}; //   2
  needed_v_smax[x_a][ 10] = {   8,    9,   10,   11,   18,   19,   22,   23}; //   8
  needed_v_smax[x_a][ 11] = {  14,   16,   25,   26,   27,   28,   45,   46,   47,   48}; //  10
  needed_v_smax[x_a][ 12] = {  14,   16,   24}; //   3
  needed_v_smax[x_a][ 13] = {  16,   22,   23,   27,   28,   47,   48}; //   7
  needed_v_smax[x_a][ 14] = {  17,   18,   19,   33,   34,   51,   52}; //   7
  needed_v_smax[x_a][ 15] = {  22,   23}; //   2
  needed_v_smax[x_a][ 16] = {  24,   63,   64}; //   3
  needed_v_smax[x_a][ 17] = {  25,   26,   27,   28,   45,   46,   47,   48}; //   8
  needed_v_smax[x_a][ 18] = {  29,   30,   33,   34,   49,   50,   51,   52}; //   8
  needed_v_smax[x_a][ 19] = {  31}; //   1
  needed_v_smax[x_a][ 20] = {  32}; //   1
  needed_v_smax[x_a][ 21] = {  43,   44,   55,   56,   59,   60,   67,   68}; //   8
  needed_v_smax[x_a][ 22] = {  57,   58}; //   2
  needed_v_smax[x_a][ 23] = {  57,   58,   63,   64,   55,   56}; //   6
  needed_v_smax[x_a][ 24] = {  59,   60,   61,   62,   53,   54}; //   6
  needed_v_smax[x_a][ 25] = {  61,   62}; //   2

  g_p[x_a].resize(44);
  needed_g_p[x_a].resize(44);
  needed_g_p[x_a][0] = {   0,    2,    7,   11,   13,   31,   35,   37,   44,   56,   60,   62,   68}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    7,   31,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    7,   35}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,   10,   12,   36,   43,   55,   59,   61,   67}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][4] = {   1,    2,   10,   11,   12,   13,   36,   37}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   1,    2,   12,   13,   36,   37}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,   14,   15,   20,   21,   24,   25,   26,   32,   38,   39,   40,   41,   42,   45,   46,   53,   54,   57,   58,   63,   64,   65,   66}; //  26
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,   15,   32,   38}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   15,   38}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   20,   39,   41,   53,   65}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][10] = {   4,    5,   20,   21,   39,   40}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   21,   40,   42,   54,   66}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][12] = {   6,    8,    9,   29,   30,   49,   50}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {   6,    9,   30,   50}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax8");
  needed_g_p[x_a][14] = {   6,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][15] = {   8,   29,   49}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][16] = {   8,    9,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][17] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][18] = {  14,   25,   26,   45,   46}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax11");
  needed_g_p[x_a][19] = {  14,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][20] = {  16,   22,   23,   27,   28,   47,   48}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax13");
  needed_g_p[x_a][21] = {  16,   27,   28,   47,   48}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin17_smax11");
  needed_g_p[x_a][22] = {  17,   18,   19,   33,   34,   51,   52}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax14");
  needed_g_p[x_a][23] = {  17,   19,   34,   52}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin19_smax8");
  needed_g_p[x_a][24] = {  18,   33,   51}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax8");
  needed_g_p[x_a][25] = {  22}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax15");
  needed_g_p[x_a][26] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax10");
  needed_g_p[x_a][27] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax15");
  needed_g_p[x_a][28] = {  24,   63,   64}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax16");
  needed_g_p[x_a][29] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax12");
  needed_g_p[x_a][30] = {  25,   27,   45,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax17");
  needed_g_p[x_a][31] = {  26,   28,   46,   48}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax17");
  needed_g_p[x_a][32] = {  29,   30,   33,   34,   49,   50,   51,   52}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax18");
  needed_g_p[x_a][33] = {  31}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax19");
  needed_g_p[x_a][34] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax20");
  needed_g_p[x_a][35] = {  43,   44,   55,   56,   59,   60,   67,   68}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax21");
  needed_g_p[x_a][36] = {  57,   58}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax22");
  needed_g_p[x_a][37] = {  57}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax23");
  needed_g_p[x_a][38] = {  58}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax23");
  needed_g_p[x_a][39] = {  59,   60}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax24");
  needed_g_p[x_a][40] = {  61,   62}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax25");
  needed_g_p[x_a][41] = {  61,   62}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin17_smax24");
  needed_g_p[x_a][42] = {  63}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax23");
  needed_g_p[x_a][43] = {  64}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin19_smax23");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  41,   42,   43,   44,   65,   66,   67,   68}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax2");
  needed_g_f[x_a][1] = {  53,   54}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax24");
  needed_g_f[x_a][2] = {  55,   56}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax23");

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,   41,   42,   43,   44}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  35,   36,   37,   38,   39,   40,   65,   66,   67,   68}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  41,   42}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][3] = {  43,   44}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][4] = {  45,   46,   47,   48,   53,   54}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][5] = {  49,   50,   51,   52,   55,   56}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][6] = {  53,   54}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_64");
  needed_g_t[x_a][7] = {  55,   56}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][8] = {  57,   58,   63,   64}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][9] = {  59,   60,   61,   62}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][10] = {  65,   66}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][11] = {  67,   68}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");

  g_d[x_a].resize(30);
  needed_g_d[x_a].resize(30);
  needed_g_d[x_a][0] = {   0,    7,   35}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][1] = {   0,    7,   31,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   0,    1,    2,    4,    5,    7,   10,   11,   12,   13,   20,   21,   22,   23,   25,   26,   27,   28,   31,   35,   36,   37,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   53,   54,   55,   56,   59,   60,   61,   62,   65,   66,   67,   68}; //  44
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][3] = {   1,    2,   12,   13,   36,   37}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   1,    2,   10,   11,   12,   13,   36,   37}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   3,   15,   38}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,   15,   32,   38}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][7] = {   3,    4,    5,   14,   15,   20,   21,   24,   25,   26,   29,   30,   32,   33,   34,   38,   39,   40,   41,   42,   43,   44,   45,   46,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   63,   64,   65,   66,   67,   68}; //  42
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][8] = {   4,    5,   20,   21,   39,   40}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][9] = {   6,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][10] = {   6,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][11] = {   6,    8,    9,   29,   30,   49,   50,   57,   58}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__4_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__4_72");
  needed_g_d[x_a][12] = {   6,    8,    9,   29,   30,   32,   49,   50,   57,   58}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][13] = {   7,   12,   13,   15,   20,   21}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][14] = {   8,    9,   10,   11,   18,   19,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][15] = {   8,    9,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][16] = {  10,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][17] = {  14,   16,   24}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__8_116");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__8_116");
  needed_g_d[x_a][18] = {  14,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__4_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__4_112");
  needed_g_d[x_a][19] = {  14,   25,   26,   45,   46,   59,   60}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][20] = {  16,   27,   28,   47,   48,   61,   62}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");
  needed_g_d[x_a][21] = {  16,   22,   23,   27,   28,   31,   47,   48,   61,   62}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][22] = {  17,   18,   19,   33,   34,   51,   52,   63,   64}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__8_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__8_68");
  needed_g_d[x_a][23] = {  17,   18,   19,   24,   33,   34,   51,   52,   63,   64}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][24] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][25] = {  24}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__68_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__68_48");
  needed_g_d[x_a][26] = {  25,   26,   27,   28}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][27] = {  29,   30,   33,   34}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][28] = {  31}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");
  needed_g_d[x_a][29] = {  32}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__72_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__72_52");

  c_p[x_a].resize(69);
  c_f[x_a].resize(69);
  c_t[x_a].resize(69);
  c_d[x_a].resize(69);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  3,   4,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  8,   2,   7}; //   3

  c_p[x_a][5] = {  6,  11,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   2,   7}; //   3

  c_p[x_a][6] = { 12,  13,  14}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  9,  10,  11,  12}; //   4

  c_p[x_a][7] = {  0,   1,   2}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 13,   0,   1,   2}; //   4

  c_p[x_a][8] = { 12,  15,  16}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 14,  15,  11,  12}; //   4

  c_p[x_a][9] = { 12,  13,  16}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 14,  15,  11,  12}; //   4

  c_p[x_a][10] = {  3,   4,  17}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 14,  16,   4,   2}; //   4

  c_p[x_a][11] = {  0,   4,  17}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 14,  16,   4,   2}; //   4

  c_p[x_a][12] = {  3,   4,   5}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 13,   3,   4,   2}; //   4

  c_p[x_a][13] = {  0,   4,   5}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 13,   3,   4,   2}; //   4

  c_p[x_a][14] = {  6,  18,  19}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 17,  18,  19,   7}; //   4

  c_p[x_a][15] = {  6,   7,   8}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 13,   5,   6,   7}; //   4

  c_p[x_a][16] = { 20,  21,  19}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 17,  18,  20,  21}; //   4

  c_p[x_a][17] = { 22,  23,  14}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  9,  10,  22,  23}; //   4

  c_p[x_a][18] = { 22,  24,  16}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 14,  15,  22,  23}; //   4

  c_p[x_a][19] = { 22,  23,  16}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 14,  15,  22,  23}; //   4

  c_p[x_a][20] = {  6,   9,  10}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 13,   8,   2,   7}; //   4

  c_p[x_a][21] = {  6,  11,  10}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 13,   8,   2,   7}; //   4

  c_p[x_a][22] = { 20,  25,  26}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 14,  24,   2,  21}; //   4

  c_p[x_a][23] = { 20,  27,  26}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 14,  24,   2,  21}; //   4

  c_p[x_a][24] = {  6,  28,  29}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 17,  25,  23,   7}; //   4

  c_p[x_a][25] = {  6,  18,  30}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 26,   2,  19,   7}; //   4

  c_p[x_a][26] = {  6,  18,  31}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 26,   2,  19,   7}; //   4

  c_p[x_a][27] = { 20,  21,  30}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 26,   2,  20,  21}; //   4

  c_p[x_a][28] = { 20,  21,  31}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 26,   2,  20,  21}; //   4

  c_p[x_a][29] = { 12,  15,  32}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 27,   7,  11,  12}; //   4

  c_p[x_a][30] = { 12,  13,  32}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 27,   7,  11,  12}; //   4

  c_p[x_a][31] = {  0,   1,  33}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 28,  21,   1,   2}; //   4

  c_p[x_a][32] = {  6,   7,  34}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 29,  12,   6,   7}; //   4

  c_p[x_a][33] = { 22,  24,  32}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 27,   7,  22,  23}; //   4

  c_p[x_a][34] = { 22,  23,  32}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 27,   7,  22,  23}; //   4

  c_p[x_a][35] = {  0,   1,   2}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  1}; //   1
  c_d[x_a][35] = {  0,   1,   2}; //   3

  c_p[x_a][36] = {  3,   4,   5}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  1}; //   1
  c_d[x_a][36] = {  3,   4,   2}; //   3

  c_p[x_a][37] = {  0,   4,   5}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  1}; //   1
  c_d[x_a][37] = {  3,   4,   2}; //   3

  c_p[x_a][38] = {  6,   7,   8}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  1}; //   1
  c_d[x_a][38] = {  5,   6,   7}; //   3

  c_p[x_a][39] = {  6,   9,  10}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  1}; //   1
  c_d[x_a][39] = {  8,   2,   7}; //   3

  c_p[x_a][40] = {  6,  11,  10}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  1}; //   1
  c_d[x_a][40] = {  8,   2,   7}; //   3

  c_p[x_a][41] = {  6,   9}; //   2
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  0,   2}; //   2
  c_d[x_a][41] = {  2,   7}; //   2

  c_p[x_a][42] = {  6,  11}; //   2
  c_f[x_a][42] = {  0}; //   1
  c_t[x_a][42] = {  0,   2}; //   2
  c_d[x_a][42] = {  2,   7}; //   2

  c_p[x_a][43] = {  3,  35}; //   2
  c_f[x_a][43] = {  0}; //   1
  c_t[x_a][43] = {  0,   3}; //   2
  c_d[x_a][43] = {  7,   2}; //   2

  c_p[x_a][44] = {  0,  35}; //   2
  c_f[x_a][44] = {  0}; //   1
  c_t[x_a][44] = {  0,   3}; //   2
  c_d[x_a][44] = {  7,   2}; //   2

  c_p[x_a][45] = {  6,  18,  30}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  4}; //   1
  c_d[x_a][45] = {  2,  19,   7}; //   3

  c_p[x_a][46] = {  6,  18,  31}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  4}; //   1
  c_d[x_a][46] = {  2,  19,   7}; //   3

  c_p[x_a][47] = { 20,  21,  30}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  4}; //   1
  c_d[x_a][47] = {  2,  20,  21}; //   3

  c_p[x_a][48] = { 20,  21,  31}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  4}; //   1
  c_d[x_a][48] = {  2,  20,  21}; //   3

  c_p[x_a][49] = { 12,  15,  32}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  5}; //   1
  c_d[x_a][49] = {  7,  11,  12}; //   3

  c_p[x_a][50] = { 12,  13,  32}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  5}; //   1
  c_d[x_a][50] = {  7,  11,  12}; //   3

  c_p[x_a][51] = { 22,  24,  32}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  5}; //   1
  c_d[x_a][51] = {  7,  22,  23}; //   3

  c_p[x_a][52] = { 22,  23,  32}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  5}; //   1
  c_d[x_a][52] = {  7,  22,  23}; //   3

  c_p[x_a][53] = {  6,   9}; //   2
  c_f[x_a][53] = {  1}; //   1
  c_t[x_a][53] = {  4,   6}; //   2
  c_d[x_a][53] = {  2,   7}; //   2

  c_p[x_a][54] = {  6,  11}; //   2
  c_f[x_a][54] = {  1}; //   1
  c_t[x_a][54] = {  4,   6}; //   2
  c_d[x_a][54] = {  2,   7}; //   2

  c_p[x_a][55] = {  3,  35}; //   2
  c_f[x_a][55] = {  2}; //   1
  c_t[x_a][55] = {  5,   7}; //   2
  c_d[x_a][55] = {  7,   2}; //   2

  c_p[x_a][56] = {  0,  35}; //   2
  c_f[x_a][56] = {  2}; //   1
  c_t[x_a][56] = {  5,   7}; //   2
  c_d[x_a][56] = {  7,   2}; //   2

  c_p[x_a][57] = {  6,  36,  37}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  8}; //   1
  c_d[x_a][57] = { 11,  12,   7}; //   3

  c_p[x_a][58] = {  6,  36,  38}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  8}; //   1
  c_d[x_a][58] = { 11,  12,   7}; //   3

  c_p[x_a][59] = {  3,  35,  39}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  9}; //   1
  c_d[x_a][59] = { 19,   7,   2}; //   3

  c_p[x_a][60] = {  0,  35,  39}; //   3
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  9}; //   1
  c_d[x_a][60] = { 19,   7,   2}; //   3

  c_p[x_a][61] = {  3,  40,  41}; //   3
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  9}; //   1
  c_d[x_a][61] = { 20,  21,   2}; //   3

  c_p[x_a][62] = {  0,  40,  41}; //   3
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  9}; //   1
  c_d[x_a][62] = { 20,  21,   2}; //   3

  c_p[x_a][63] = {  6,  28,  42}; //   3
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  8}; //   1
  c_d[x_a][63] = { 22,  23,   7}; //   3

  c_p[x_a][64] = {  6,  28,  43}; //   3
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  8}; //   1
  c_d[x_a][64] = { 22,  23,   7}; //   3

  c_p[x_a][65] = {  6,   9}; //   2
  c_f[x_a][65] = {  0}; //   1
  c_t[x_a][65] = {  1,  10}; //   2
  c_d[x_a][65] = {  2,   7}; //   2

  c_p[x_a][66] = {  6,  11}; //   2
  c_f[x_a][66] = {  0}; //   1
  c_t[x_a][66] = {  1,  10}; //   2
  c_d[x_a][66] = {  2,   7}; //   2

  c_p[x_a][67] = {  3,  35}; //   2
  c_f[x_a][67] = {  0}; //   1
  c_t[x_a][67] = {  1,  11}; //   2
  c_d[x_a][67] = {  7,   2}; //   2

  c_p[x_a][68] = {  0,  35}; //   2
  c_f[x_a][68] = {  0}; //   1
  c_t[x_a][68] = {  1,  11}; //   2
  c_d[x_a][68] = {  7,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_050_udx_emepmupvma
//  channel    0: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  24,   0)
//  channel    1: 4yyv1(1, 2, 32, 16, 4, 8, 64;   0,   0,  24,   0)
//  channel    2: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  24,   0)
//  channel    3: 4yyv1(1, 2, 8, 4, 16, 32, 64;  24,   0,  24,   0)
//  channel    4: 42vv1(1, 2, 4, 8, 16, 32, 64;  24,   0,  24,   0)
//  channel    5: 42vv1(1, 2, 4, 8, 16, 32, 64;  24,  23,  24,   0)
//  channel    6: 5yyyv(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,  24)
//  channel    7: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  24,  24)
//  channel    8: 5yyyv(1, 2, 32, 16, 4, 8, 64;   0,   0,   0,  24)
//  channel    9: 5yyyv(1, 2, 32, 16, 4, 8, 64;   0,  23,   0,  24)
//  channel   10: 5yyyv(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,  24)
//  channel   11: 5yyyv(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,  24)
//  channel   12: 5yyyv(1, 2, 64, 32, 16, 4, 8;   0,   0,  24,  24)
//  channel   13: 5yyyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  24,  24)
//  channel   14: 5yyyv(1, 2, 8, 4, 64, 16, 32;  24,  24,   0,  24)
//  channel   15: 5yyyv(1, 2, 64, 8, 4, 16, 32;  24,   0,  24,  24)
//  channel   16: 5yyyv(1, 2, 8, 4, 32, 16, 64;   0,  24,   0,  24)
//  channel   17: 5yyyv(1, 2, 16, 32, 8, 4, 64;   0,  23,   0,  24)
//  channel   18: 5yyyv(1, 2, 32, 16, 8, 4, 64;   0,   0,   0,  24)
//  channel   19: 5yyyv(1, 2, 32, 16, 8, 4, 64;   0,  23,   0,  24)
//  channel   20: 5y2vv(1, 2, 64, 4, 8, 16, 32;  24,   0,  24,  24)
//  channel   21: 5y2vv(1, 2, 64, 4, 8, 16, 32;  24,  23,  24,  24)
//  channel   22: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,  24)
//  channel   23: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,  24)
//  channel   24: 5y2vv(1, 2, 8, 4, 64, 16, 32;  24,   0,   0,  24)
//  channel   25: 52vyv(1, 2, 4, 8, 64, 16, 32;  24,  24,   0,  24)
//  channel   26: 52vyv(1, 2, 4, 8, 64, 16, 32;  24,  24,  23,  24)
//  channel   27: 52vyv(1, 2, 4, 8, 32, 16, 64;   0,  24,   0,  24)
//  channel   28: 52vyv(1, 2, 4, 8, 32, 16, 64;   0,  24,  23,  24)
//  channel   29: 52vyv(1, 2, 16, 32, 4, 8, 64;   0,   0,  24,  24)
//  channel   30: 52vyv(1, 2, 16, 32, 4, 8, 64;   0,  23,  24,  24)
//  channel   31: 52vyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,  24)
//  channel   32: 52vyv(1, 2, 8, 64, 4, 16, 32;  24,   0,   0,  24)
//  channel   33: 52vyv(1, 2, 16, 32, 8, 4, 64;   0,   0,  24,  24)
//  channel   34: 52vyv(1, 2, 16, 32, 8, 4, 64;   0,  23,  24,  24)
//  channel   35: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  24,   0)
//  channel   36: 14yyv(1, 2, 64, 32, 16, 4, 8;   0,   0,  24,   0)
//  channel   37: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  24,   0)
//  channel   38: 14yyv(1, 2, 64, 8, 4, 16, 32;  24,   0,  24,   0)
//  channel   39: 142vv(1, 2, 64, 4, 8, 16, 32;  24,   0,  24,   0)
//  channel   40: 142vv(1, 2, 64, 4, 8, 16, 32;  24,  23,  24,   0)
//  channel   41: 2v2v1(1, 2, 4, 8, 16, 32, 64;  24,   0,   0,   0)
//  channel   42: 2v2v1(1, 2, 4, 8, 16, 32, 64;  24,  23,   0,   0)
//  channel   43: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  24,   0,   0)
//  channel   44: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  24,   0,   0)
//  channel   45: 2v3yv(1, 2, 4, 8, 64, 16, 32;  24,  24,   0,   0)
//  channel   46: 2v3yv(1, 2, 4, 8, 64, 16, 32;  24,  24,  23,   0)
//  channel   47: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,  24,   0,   0)
//  channel   48: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,  24,  23,   0)
//  channel   49: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,   0,  24,   0)
//  channel   50: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,  23,  24,   0)
//  channel   51: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,   0,  24,   0)
//  channel   52: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,  23,  24,   0)
//  channel   53: 2v12v(1, 2, 4, 8, 64, 16, 32;  24,   0,   0,   0)
//  channel   54: 2v12v(1, 2, 4, 8, 64, 16, 32;  24,  23,   0,   0)
//  channel   55: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,  24,   0,   0)
//  channel   56: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,  24,   0,   0)
//  channel   57: 3yv2v(1, 2, 4, 8, 64, 16, 32;  24,   0,   0,   0)
//  channel   58: 3yv2v(1, 2, 4, 8, 64, 16, 32;  24,   0,  23,   0)
//  channel   59: 3yv2v(1, 2, 64, 16, 32, 4, 8;   0,  24,  24,   0)
//  channel   60: 3yv2v(1, 2, 64, 16, 32, 4, 8;  23,  24,  24,   0)
//  channel   61: 3yv2v(1, 2, 32, 16, 64, 4, 8;   0,   0,  24,   0)
//  channel   62: 3yv2v(1, 2, 32, 16, 64, 4, 8;  23,   0,  24,   0)
//  channel   63: 3yv2v(1, 2, 8, 4, 64, 16, 32;  24,   0,   0,   0)
//  channel   64: 3yv2v(1, 2, 8, 4, 64, 16, 32;  24,   0,  23,   0)
//  channel   65: 12v2v(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
//  channel   66: 12v2v(1, 2, 64, 4, 8, 16, 32;  24,  23,   0,   0)
//  channel   67: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  24,   0,   0)
//  channel   68: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  24,   0,   0)
