#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_140_udx_emepmupvmg(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_140_udx_emepmupvmg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(11);
  needed_v_smin[x_a].resize(11);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  22
  needed_v_smin[x_a][  1] = {   0,    6}; //   2
  needed_v_smin[x_a][  2] = {   0,    6}; //   2
  needed_v_smin[x_a][  3] = {   1,    2,    7,    8}; //   4
  needed_v_smin[x_a][  4] = {   1,    2,    7,    8}; //   4
  needed_v_smin[x_a][  5] = {   3,    4,    5,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  18
  needed_v_smin[x_a][  6] = {   3,    9}; //   2
  needed_v_smin[x_a][  7] = {   3,    9}; //   2
  needed_v_smin[x_a][  8] = {   4,    5,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23}; //  12
  needed_v_smin[x_a][  9] = {  16,   17}; //   2
  needed_v_smin[x_a][ 10] = {  18,   19}; //   2

  v_smax[x_a].resize(10);
  needed_v_smax[x_a].resize(10);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,   14,   15,   18,   19,   22,   23}; //  12
  needed_v_smax[x_a][  1] = {   0,    6}; //   2
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23}; //  20
  needed_v_smax[x_a][  3] = {   1,    2,    7,    8}; //   4
  needed_v_smax[x_a][  4] = {   3,    4,    5,    9,   10,   11,   12,   13,   16,   17,   20,   21}; //  12
  needed_v_smax[x_a][  5] = {   3,    9}; //   2
  needed_v_smax[x_a][  6] = {   4,    5,   10,   11,   12,   13,   16,   17,   20,   21}; //  10
  needed_v_smax[x_a][  7] = {  14,   15,   18,   19,   22,   23}; //   6
  needed_v_smax[x_a][  8] = {  16,   17}; //   2
  needed_v_smax[x_a][  9] = {  18,   19}; //   2

  g_p[x_a].resize(13);
  needed_g_p[x_a].resize(13);
  needed_g_p[x_a][0] = {   0,    2,    6,    8,   15,   19,   23}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    7,   14,   18,   22}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][4] = {   1,    2,    7,    8}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   1,    2,    7,    8}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,    9,   10,   11,   12,   13,   16,   17,   20,   21}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   10,   12,   16,   20}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][10] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   11,   13,   17,   21}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][12] = {  14,   15,   18,   19,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  12,   13,   14,   15,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax2");
  needed_g_f[x_a][1] = {  16,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax8");
  needed_g_f[x_a][2] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax9");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   6,    7,    8,    9,   10,   11,   20,   21,   22,   23}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][3] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][4] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][5] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_64");
  needed_g_t[x_a][6] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][7] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][8] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][9] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");

  g_d[x_a].resize(9);
  needed_g_d[x_a].resize(9);
  needed_g_d[x_a][0] = {   0,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][1] = {   0,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   0,    1,    2,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  22
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][3] = {   1,    2,    7,    8}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   1,    2,    7,    8}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   3,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][7] = {   3,    4,    5,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][8] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  3,   4,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  8,   2,   7}; //   3

  c_p[x_a][5] = {  6,  11,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   2,   7}; //   3

  c_p[x_a][6] = {  0,   1,   2}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  1}; //   1
  c_d[x_a][6] = {  0,   1,   2}; //   3

  c_p[x_a][7] = {  3,   4,   5}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  1}; //   1
  c_d[x_a][7] = {  3,   4,   2}; //   3

  c_p[x_a][8] = {  0,   4,   5}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  1}; //   1
  c_d[x_a][8] = {  3,   4,   2}; //   3

  c_p[x_a][9] = {  6,   7,   8}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  1}; //   1
  c_d[x_a][9] = {  5,   6,   7}; //   3

  c_p[x_a][10] = {  6,   9,  10}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  1}; //   1
  c_d[x_a][10] = {  8,   2,   7}; //   3

  c_p[x_a][11] = {  6,  11,  10}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  1}; //   1
  c_d[x_a][11] = {  8,   2,   7}; //   3

  c_p[x_a][12] = {  6,   9}; //   2
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   2}; //   2
  c_d[x_a][12] = {  2,   7}; //   2

  c_p[x_a][13] = {  6,  11}; //   2
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   2}; //   2
  c_d[x_a][13] = {  2,   7}; //   2

  c_p[x_a][14] = {  3,  12}; //   2
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  0,   3}; //   2
  c_d[x_a][14] = {  7,   2}; //   2

  c_p[x_a][15] = {  0,  12}; //   2
  c_f[x_a][15] = {  0}; //   1
  c_t[x_a][15] = {  0,   3}; //   2
  c_d[x_a][15] = {  7,   2}; //   2

  c_p[x_a][16] = {  6,   9}; //   2
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  4,   5}; //   2
  c_d[x_a][16] = {  2,   7}; //   2

  c_p[x_a][17] = {  6,  11}; //   2
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  4,   5}; //   2
  c_d[x_a][17] = {  2,   7}; //   2

  c_p[x_a][18] = {  3,  12}; //   2
  c_f[x_a][18] = {  2}; //   1
  c_t[x_a][18] = {  6,   7}; //   2
  c_d[x_a][18] = {  7,   2}; //   2

  c_p[x_a][19] = {  0,  12}; //   2
  c_f[x_a][19] = {  2}; //   1
  c_t[x_a][19] = {  6,   7}; //   2
  c_d[x_a][19] = {  7,   2}; //   2

  c_p[x_a][20] = {  6,   9}; //   2
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  1,   8}; //   2
  c_d[x_a][20] = {  2,   7}; //   2

  c_p[x_a][21] = {  6,  11}; //   2
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  1,   8}; //   2
  c_d[x_a][21] = {  2,   7}; //   2

  c_p[x_a][22] = {  3,  12}; //   2
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  1,   9}; //   2
  c_d[x_a][22] = {  7,   2}; //   2

  c_p[x_a][23] = {  0,  12}; //   2
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  1,   9}; //   2
  c_d[x_a][23] = {  7,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_udx_emepmupvmg
//  channel    0: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  24,   0)
//  channel    1: 4yyv1(1, 2, 32, 16, 4, 8, 64;   0,   0,  24,   0)
//  channel    2: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  24,   0)
//  channel    3: 4yyv1(1, 2, 8, 4, 16, 32, 64;  24,   0,  24,   0)
//  channel    4: 42vv1(1, 2, 4, 8, 16, 32, 64;  24,   0,  24,   0)
//  channel    5: 42vv1(1, 2, 4, 8, 16, 32, 64;  24,  23,  24,   0)
//  channel    6: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  24,   0)
//  channel    7: 14yyv(1, 2, 64, 32, 16, 4, 8;   0,   0,  24,   0)
//  channel    8: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  24,   0)
//  channel    9: 14yyv(1, 2, 64, 8, 4, 16, 32;  24,   0,  24,   0)
//  channel   10: 142vv(1, 2, 64, 4, 8, 16, 32;  24,   0,  24,   0)
//  channel   11: 142vv(1, 2, 64, 4, 8, 16, 32;  24,  23,  24,   0)
//  channel   12: 2v2v1(1, 2, 4, 8, 16, 32, 64;  24,   0,   0,   0)
//  channel   13: 2v2v1(1, 2, 4, 8, 16, 32, 64;  24,  23,   0,   0)
//  channel   14: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  24,   0,   0)
//  channel   15: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  24,   0,   0)
//  channel   16: 2v12v(1, 2, 4, 8, 64, 16, 32;  24,   0,   0,   0)
//  channel   17: 2v12v(1, 2, 4, 8, 64, 16, 32;  24,  23,   0,   0)
//  channel   18: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,  24,   0,   0)
//  channel   19: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,  24,   0,   0)
//  channel   20: 12v2v(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
//  channel   21: 12v2v(1, 2, 64, 4, 8, 16, 32;  24,  23,   0,   0)
//  channel   22: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  24,   0,   0)
//  channel   23: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  24,   0,   0)
