#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_240_ddx_emepvevexbbx(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_240_ddx_emepvevexbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(40);
  needed_v_smin[x_a].resize(40);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,   14,   15,   16,   17,   24,   25,   32,   33,   34,   35,   37,   38,   39,   40,   42,   43,   44,   45,   47,   48,   49,   50,   51,   52,   56,   57,   58,   59,   62,   63,   69,   70,   71,   72,   73,   74,   79,   80,   81,   82,   84,   85,   91,   92,   93,   94,   95,   96,  100,  101,  102,  103,  104,  105}; //  58
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   51,   52,   69,   70}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,   51,   52,   53,   54,   69,   70,   75,   76}; //  16
  needed_v_smin[x_a][  3] = {   0,    1,    4,    5,    8,   10,   12,   14,   15,   18,   19,   22,   24,   26,   27,   28}; //  16
  needed_v_smin[x_a][  4] = {   2,    3,    6,    7,    9,   11,   13,   16,   17,   20,   21,   23,   25,   29,   30,   31}; //  16
  needed_v_smin[x_a][  5] = {   4,    5,    6,    7,    8,    9,   26,   27,   28,   29,   30,   31,   36,   41,   46,   53,   54,   55,   67,   68,   75,   76,   77,   89,   90,   97,   98,   99}; //  28
  needed_v_smin[x_a][  6] = {   4,    5,    6,    7,   53,   54,   75,   76}; //   8
  needed_v_smin[x_a][  7] = {   8,    9,   55,   77}; //   4
  needed_v_smin[x_a][  8] = {   8,    9,   12,   13,   55,   61,   77,   83}; //   8
  needed_v_smin[x_a][  9] = {  10,   11,   12,   13,   24,   25,   32,   33,   34,   35,   37,   38,   39,   40,   42,   43,   44,   45,   47,   48,   49,   50,   56,   57,   58,   59,   60,   61,   71,   72,   73,   74,   78,   79,   80,   81,   82,   83,   91,   92,   93,   94,   95,   96,  100,  101,  102,  103,  104,  105}; //  50
  needed_v_smin[x_a][ 10] = {  10,   11,   60,   78}; //   4
  needed_v_smin[x_a][ 11] = {  10,   11,   22,   23,   60,   66,   78,   88}; //   8
  needed_v_smin[x_a][ 12] = {  12,   13,   61,   83}; //   4
  needed_v_smin[x_a][ 13] = {  14,   15,   16,   17,   62,   63,   84,   85}; //   8
  needed_v_smin[x_a][ 14] = {  14,   15,   16,   17,   18,   19,   20,   21,   62,   63,   64,   65,   84,   85,   86,   87}; //  16
  needed_v_smin[x_a][ 15] = {  18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   30,   31,   36,   41,   46,   64,   65,   66,   67,   68,   86,   87,   88,   89,   90,   97,   98,   99}; //  28
  needed_v_smin[x_a][ 16] = {  18,   19,   20,   21,   64,   65,   86,   87}; //   8
  needed_v_smin[x_a][ 17] = {  22,   23,   66,   88}; //   4
  needed_v_smin[x_a][ 18] = {  24,   25,   95,   96,  104,  105}; //   6
  needed_v_smin[x_a][ 19] = {  26,   27,   28,   29,   30,   31,   67,   68,   89,   90,   99}; //  11
  needed_v_smin[x_a][ 20] = {  32,   33,   44,   45,   49,   50,   81,   82}; //   8
  needed_v_smin[x_a][ 21] = {  32,   33}; //   2
  needed_v_smin[x_a][ 22] = {  34,   35,   42,   43,   47,   48,   79,   80}; //   8
  needed_v_smin[x_a][ 23] = {  34,   35}; //   2
  needed_v_smin[x_a][ 24] = {  36,   46}; //   2
  needed_v_smin[x_a][ 25] = {  36}; //   1
  needed_v_smin[x_a][ 26] = {  37,   38,   42,   43,   58,   59,   73,   74}; //   8
  needed_v_smin[x_a][ 27] = {  37,   38}; //   2
  needed_v_smin[x_a][ 28] = {  39,   40,   44,   45,   56,   57,   71,   72}; //   8
  needed_v_smin[x_a][ 29] = {  39,   40}; //   2
  needed_v_smin[x_a][ 30] = {  41,   46}; //   2
  needed_v_smin[x_a][ 31] = {  41}; //   1
  needed_v_smin[x_a][ 32] = {  47,   48,   79,   80}; //   4
  needed_v_smin[x_a][ 33] = {  49,   50,   81,   82}; //   4
  needed_v_smin[x_a][ 34] = {  51,   52,   53,   54,   55,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   75,   76,   77,   78,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105}; //  43
  needed_v_smin[x_a][ 35] = {  56,   57,   71,   72}; //   4
  needed_v_smin[x_a][ 36] = {  58,   59,   73,   74}; //   4
  needed_v_smin[x_a][ 37] = {  91,   92,   93,   94}; //   4
  needed_v_smin[x_a][ 38] = {  97,   98}; //   2
  needed_v_smin[x_a][ 39] = { 100,  101,  102,  103}; //   4

  v_smax[x_a].resize(61);
  needed_v_smax[x_a].resize(61);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,   14,   15,   16,   17,   24,   25,   32,   33,   34,   35,   42,   43,   47,   48,   49,   50,   51,   52,   62,   63,   71,   72,   73,   74,   93,   94,   95,   96}; //  32
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,    4,    5,    6,    7,   51,   52,   53,   54}; //  12
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   51,   52,   53,   54,   55,   60,   61,   62,   63,   64,   65,   66,   67,   68}; //  46
  needed_v_smax[x_a][  3] = {   0,    1,    4,    5,    8,   10,   12,   14,   15,   18,   19,   22,   24,   26,   27,   28,   34,   35,   39,   40,   41}; //  21
  needed_v_smax[x_a][  4] = {   2,    3,    6,    7,    9,   11,   13,   16,   17,   20,   21,   23,   25,   29,   30,   31,   32,   33,   36,   37,   38}; //  21
  needed_v_smax[x_a][  5] = {   4,    5,    6,    7,    8,    9,   26,   27,   28,   29,   30,   31,   36,   53,   54,   55,   67,   68,   98,   99}; //  20
  needed_v_smax[x_a][  6] = {   8,    9,   12,   13,   55,   61}; //   6
  needed_v_smax[x_a][  7] = {  10,   11,   12,   13,   37,   38,   39,   40,   44,   45,   56,   57,   58,   59,   60,   61,   79,   80,   81,   82,  102,  103,  104,  105}; //  24
  needed_v_smax[x_a][  8] = {  10,   11,   22,   23,   60,   66}; //   6
  needed_v_smax[x_a][  9] = {  14,   15,   16,   17,   18,   19,   20,   21,   62,   63,   64,   65}; //  12
  needed_v_smax[x_a][ 10] = {  18,   19,   20,   21,   22,   23,   41,   46,   64,   65,   66}; //  11
  needed_v_smax[x_a][ 11] = {  24,   25,   42,   43,   71,   72,   73,   74,   95,   96}; //  10
  needed_v_smax[x_a][ 12] = {  26,   27,   28,   29,   30,   31,   67,   68,   99}; //   9
  needed_v_smax[x_a][ 13] = {  32,   33,   49,   50}; //   4
  needed_v_smax[x_a][ 14] = {  32,   33}; //   2
  needed_v_smax[x_a][ 15] = {  34,   35,   47,   48}; //   4
  needed_v_smax[x_a][ 16] = {  34,   35}; //   2
  needed_v_smax[x_a][ 17] = {  36}; //   1
  needed_v_smax[x_a][ 18] = {  36}; //   1
  needed_v_smax[x_a][ 19] = {  37,   38,   58,   59}; //   4
  needed_v_smax[x_a][ 20] = {  37,   38}; //   2
  needed_v_smax[x_a][ 21] = {  39,   40,   56,   57}; //   4
  needed_v_smax[x_a][ 22] = {  39,   40}; //   2
  needed_v_smax[x_a][ 23] = {  41}; //   1
  needed_v_smax[x_a][ 24] = {  41}; //   1
  needed_v_smax[x_a][ 25] = {  42,   43,   79,   80}; //   4
  needed_v_smax[x_a][ 26] = {  42,   43}; //   2
  needed_v_smax[x_a][ 27] = {  44,   45,   79,   80,   81,   82,  104,  105}; //   8
  needed_v_smax[x_a][ 28] = {  44,   45,   71,   72}; //   4
  needed_v_smax[x_a][ 29] = {  44,   45}; //   2
  needed_v_smax[x_a][ 30] = {  46}; //   1
  needed_v_smax[x_a][ 31] = {  46}; //   1
  needed_v_smax[x_a][ 32] = {  46}; //   1
  needed_v_smax[x_a][ 33] = {  47,   48,   49,   50}; //   4
  needed_v_smax[x_a][ 34] = {  47,   48,   49,   50}; //   4
  needed_v_smax[x_a][ 35] = {  51,   52,   53,   54,   55,   60,   61,   62,   63,   64,   65,   66,   67,   68}; //  14
  needed_v_smax[x_a][ 36] = {  56,   57,   58,   59}; //   4
  needed_v_smax[x_a][ 37] = {  56,   57,   58,   59}; //   4
  needed_v_smax[x_a][ 38] = {  69,   70,   75,   76,   77,   78,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   97,  100,  101}; //  19
  needed_v_smax[x_a][ 39] = {  69,   70,   84,   85,   91,   92}; //   6
  needed_v_smax[x_a][ 40] = {  69,   70,   75,   76}; //   4
  needed_v_smax[x_a][ 41] = {  69,   70,   75,   76,   77,   78,   83,   84,   85,   86,   87,   88,   89,   90,   95,   96,   99,  104,  105}; //  19
  needed_v_smax[x_a][ 42] = {  71,   72,   73,   74,  100,  101,  102,  103}; //   8
  needed_v_smax[x_a][ 43] = {  73,   74}; //   2
  needed_v_smax[x_a][ 44] = {  75,   76,   77,   89,   90,   97}; //   6
  needed_v_smax[x_a][ 45] = {  77,   83}; //   2
  needed_v_smax[x_a][ 46] = {  78,   83,  100,  101}; //   4
  needed_v_smax[x_a][ 47] = {  78,   88}; //   2
  needed_v_smax[x_a][ 48] = {  79,   80,   81,   82,   91,   92,   93,   94}; //   8
  needed_v_smax[x_a][ 49] = {  81,   82}; //   2
  needed_v_smax[x_a][ 50] = {  84,   85,   86,   87}; //   4
  needed_v_smax[x_a][ 51] = {  86,   87,   88}; //   3
  needed_v_smax[x_a][ 52] = {  89,   90,   97,   98}; //   4
  needed_v_smax[x_a][ 53] = {  91,   92,   93,   94}; //   4
  needed_v_smax[x_a][ 54] = {  93,   94}; //   2
  needed_v_smax[x_a][ 55] = {  95,   96,  104,  105}; //   4
  needed_v_smax[x_a][ 56] = {  98}; //   1
  needed_v_smax[x_a][ 57] = {  99}; //   1
  needed_v_smax[x_a][ 58] = { 100,  101,  102,  103}; //   4
  needed_v_smax[x_a][ 59] = { 102,  103}; //   2
  needed_v_smax[x_a][ 60] = {  97,   98}; //   2

  g_p[x_a].resize(101);
  needed_g_p[x_a].resize(101);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,   14,   15,   16,   17,   24,   25,   32,   33,   34,   35,   42,   43,   47,   48,   49,   50,   51,   52,   62,   63,   71,   72,   73,   74,   93,   94,   95,   96}; //  32
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   51,   52}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,    4,    6,   51,   53}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    4,    5,    8,   10,   12,   14,   15,   18,   19,   22,   24,   26,   27,   28}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    5,    7,   52,   54}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   2,    3,    6,    7,    9,   11,   13,   16,   17,   20,   21,   23,   25,   29,   30,   31}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin4_smax4");
  needed_g_p[x_a][6] = {   4,    5,    6,    7,    8,    9,   26,   27,   28,   29,   30,   31,   36,   53,   54,   55,   67,   68,   98,   99}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax5");
  needed_g_p[x_a][7] = {   4,    5,    6,    7,   53,   54}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");
  needed_g_p[x_a][8] = {   8,    9,   55}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   8,    9,   12,   13,   55,   61}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax2");
  needed_g_p[x_a][10] = {  10,   11,   12,   13,   38,   40,   45,   57,   59,   60,   61,   80,   82,  103,  105}; //  15
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax7");
  needed_g_p[x_a][11] = {  10,   11,   60}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][12] = {  10,   11,   22,   23,   60,   66}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][13] = {  12,   13,   61}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax6");
  needed_g_p[x_a][14] = {  14,   15,   16,   17,   62,   63}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][15] = {  14,   16,   18,   20,   62,   64}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax2");
  needed_g_p[x_a][16] = {  15,   17,   19,   21,   63,   65}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin14_smax2");
  needed_g_p[x_a][17] = {  18,   19,   20,   21,   22,   23,   41,   46,   64,   65,   66}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax10");
  needed_g_p[x_a][18] = {  18,   19,   20,   21,   64,   65}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax9");
  needed_g_p[x_a][19] = {  22,   23,   66}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax8");
  needed_g_p[x_a][20] = {  24,   25,   43,   72,   74,   96}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax11");
  needed_g_p[x_a][21] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin18_smax2");
  needed_g_p[x_a][22] = {  26,   27,   28,   29,   30,   31,   67,   68,   99}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax12");
  needed_g_p[x_a][23] = {  26,   29,   67}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax2");
  needed_g_p[x_a][24] = {  27,   30,   68}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin19_smax2");
  needed_g_p[x_a][25] = {  28,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin19_smax2");
  needed_g_p[x_a][26] = {  32,   33,   49,   50}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin20_smax13");
  needed_g_p[x_a][27] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax14");
  needed_g_p[x_a][28] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin21_smax4");
  needed_g_p[x_a][29] = {  33}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax14");
  needed_g_p[x_a][30] = {  34,   35,   47,   48}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin22_smax15");
  needed_g_p[x_a][31] = {  34}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax16");
  needed_g_p[x_a][32] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin23_smax3");
  needed_g_p[x_a][33] = {  35}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax16");
  needed_g_p[x_a][34] = {  36}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin24_smax17");
  needed_g_p[x_a][35] = {  36}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax18");
  needed_g_p[x_a][36] = {  36}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin25_smax4");
  needed_g_p[x_a][37] = {  37,   39,   44,   56,   58,   79,   81,  102,  104}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][38] = {  37,   38,   58,   59}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin26_smax19");
  needed_g_p[x_a][39] = {  37,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax20");
  needed_g_p[x_a][40] = {  37,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin27_smax4");
  needed_g_p[x_a][41] = {  39,   40,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin28_smax21");
  needed_g_p[x_a][42] = {  39,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax22");
  needed_g_p[x_a][43] = {  39,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin29_smax3");
  needed_g_p[x_a][44] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin30_smax23");
  needed_g_p[x_a][45] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax24");
  needed_g_p[x_a][46] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin31_smax3");
  needed_g_p[x_a][47] = {  42,   71,   73,   95}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax11");
  needed_g_p[x_a][48] = {  42,   43,   79,   80}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin22_smax25");
  needed_g_p[x_a][49] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin26_smax26");
  needed_g_p[x_a][50] = {  44,   45,   79,   80,   81,   82,  104,  105}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax27");
  needed_g_p[x_a][51] = {  44,   45,   71,   72}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin28_smax28");
  needed_g_p[x_a][52] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin20_smax29");
  needed_g_p[x_a][53] = {  46}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax30");
  needed_g_p[x_a][54] = {  46}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin30_smax31");
  needed_g_p[x_a][55] = {  46}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin24_smax32");
  needed_g_p[x_a][56] = {  47,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin32_smax33");
  needed_g_p[x_a][57] = {  47,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax34");
  needed_g_p[x_a][58] = {  48,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax34");
  needed_g_p[x_a][59] = {  49,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax33");
  needed_g_p[x_a][60] = {  51,   52,   53,   54,   55,   60,   61,   62,   63,   64,   65,   66,   67,   68}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax35");
  needed_g_p[x_a][61] = {  56,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin35_smax36");
  needed_g_p[x_a][62] = {  56,   57,   58,   59}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax37");
  needed_g_p[x_a][63] = {  58,   59}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin36_smax36");
  needed_g_p[x_a][64] = {  69,   70,   75,   76,   77,   78,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   97,  100,  101}; //  19
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax38");
  needed_g_p[x_a][65] = {  69,   70,   84,   85,   91,   92}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax39");
  needed_g_p[x_a][66] = {  69,   70}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax40");
  needed_g_p[x_a][67] = {  69,   75}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax41");
  needed_g_p[x_a][68] = {  70,   76}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax41");
  needed_g_p[x_a][69] = {  71,   72}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin35_smax42");
  needed_g_p[x_a][70] = {  73,   74}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin26_smax43");
  needed_g_p[x_a][71] = {  73,   74}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin36_smax42");
  needed_g_p[x_a][72] = {  75,   76,   77,   89,   90,   97}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax44");
  needed_g_p[x_a][73] = {  75,   76}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax40");
  needed_g_p[x_a][74] = {  77}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax45");
  needed_g_p[x_a][75] = {  77,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax41");
  needed_g_p[x_a][76] = {  78,   83,  101}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax46");
  needed_g_p[x_a][77] = {  78}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax47");
  needed_g_p[x_a][78] = {  78,   88}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax41");
  needed_g_p[x_a][79] = {  79,   80}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin32_smax48");
  needed_g_p[x_a][80] = {  81,   82}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin20_smax49");
  needed_g_p[x_a][81] = {  81,   82}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax48");
  needed_g_p[x_a][82] = {  83}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax45");
  needed_g_p[x_a][83] = {  84,   85}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax50");
  needed_g_p[x_a][84] = {  84,   86}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax41");
  needed_g_p[x_a][85] = {  85,   87}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin14_smax41");
  needed_g_p[x_a][86] = {  86,   87,   88}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax51");
  needed_g_p[x_a][87] = {  86,   87}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax50");
  needed_g_p[x_a][88] = {  88}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax47");
  needed_g_p[x_a][89] = {  89,   90,   97,   98}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax52");
  needed_g_p[x_a][90] = {  89}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax41");
  needed_g_p[x_a][91] = {  90}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin19_smax41");
  needed_g_p[x_a][92] = {  91,   93}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax53");
  needed_g_p[x_a][93] = {  92,   94}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax53");
  needed_g_p[x_a][94] = {  93,   94}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax54");
  needed_g_p[x_a][95] = {  95,   96,  104,  105}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax55");
  needed_g_p[x_a][96] = {  98}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax56");
  needed_g_p[x_a][97] = {  99}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax57");
  needed_g_p[x_a][98] = { 100}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax46");
  needed_g_p[x_a][99] = { 100,  101,  102,  103}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax58");
  needed_g_p[x_a][100] = { 102,  103}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax59");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {  91,   92,   93,   94}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin37_smax48");
  needed_g_f[x_a][1] = {  95,   96,  104,  105}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax41");
  needed_g_f[x_a][2] = {  97,   98}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin38_smax60");
  needed_g_f[x_a][3] = {  99}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax41");
  needed_g_f[x_a][4] = { 100,  101,  102,  103}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin39_smax42");

  g_t[x_a].resize(16);
  needed_g_t[x_a].resize(16);
  needed_g_t[x_a][0] = {  47,   48,   49,   50,   91,   92,   93,   94}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][1] = {  51,   52,   53,   54,   55,   60,   61,   62,   63,   64,   65,   66,   67,   68,   95,   96,   99,  104,  105}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][2] = {  56,   57,   58,   59,  100,  101,  102,  103}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][3] = {  69,   70,   75,   76,   77,   78,   83,   84,   85,   86,   87,   88,   89,   90}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][4] = {  71,   72,   73,   74}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][5] = {  79,   80,   81,   82}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][6] = {  91,   92}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__192_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__192_48");
  needed_g_t[x_a][7] = {  93,   94}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][8] = {  95,   96}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__48_12");
  needed_g_t[x_a][9] = {  97,   98}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_216");
  needed_g_t[x_a][10] = {  97}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__192_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__192_24");
  needed_g_t[x_a][11] = {  98}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__24_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__24_192");
  needed_g_t[x_a][12] = {  99}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__24_36");
  needed_g_t[x_a][13] = { 100,  101}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__192_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__192_12");
  needed_g_t[x_a][14] = { 102,  103}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][15] = { 104,  105}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__12_48");

  g_d[x_a].resize(42);
  needed_g_d[x_a].resize(42);
  needed_g_d[x_a][0] = {   0,    1,    4,    5,    8,   10,   12,   14,   15,   18,   19,   22,   24,   26,   27,   28,   34,   35,   39,   40,   41}; //  21
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][1] = {   0,    1,    4,    5,    8,   10,   12,   14,   15,   18,   19,   22,   24,   26,   27,   28}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7,   51,   52,   53,   54,   69,   70,   75,   76}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,   51,   52,   69,   70}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][4] = {   0,    1,    2,    3,   14,   15,   16,   17,   24,   25,   32,   33,   34,   35,   37,   38,   39,   40,   42,   43,   44,   45,   47,   48,   49,   50,   51,   52,   56,   57,   58,   59,   62,   63,   69,   70,   71,   72,   73,   74,   79,   80,   81,   82,   84,   85,   91,   92,   93,   94,   95,   96,  100,  101,  102,  103,  104,  105}; //  58
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][5] = {   2,    3,    6,    7,    9,   11,   13,   16,   17,   20,   21,   23,   25,   29,   30,   31,   32,   33,   36,   37,   38}; //  21
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][6] = {   2,    3,    6,    7,    9,   11,   13,   16,   17,   20,   21,   23,   25,   29,   30,   31}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][7] = {   4,    5,    6,    7,   53,   54,   75,   76}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][8] = {   4,    5,    6,    7,    8,    9,   26,   27,   28,   29,   30,   31,   36,   41,   46,   53,   54,   55,   67,   68,   75,   76,   77,   89,   90,   97,   98,   99}; //  28
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][9] = {   8,    9,   12,   13,   55,   61,   77,   83}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][10] = {   8,    9,   55,   77}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][11] = {  10,   11,   22,   23,   60,   66,   78,   88}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][12] = {  10,   11,   60,   78}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][13] = {  10,   11,   12,   13,   24,   25,   32,   33,   34,   35,   37,   38,   39,   40,   42,   43,   44,   45,   47,   48,   49,   50,   56,   57,   58,   59,   60,   61,   71,   72,   73,   74,   78,   79,   80,   81,   82,   83,   91,   92,   93,   94,   95,   96,  100,  101,  102,  103,  104,  105}; //  50
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][14] = {  12,   13,   61,   83}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][15] = {  14,   15,   16,   17,   18,   19,   20,   21,   62,   63,   64,   65,   84,   85,   86,   87}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][16] = {  14,   15,   16,   17,   62,   63,   84,   85}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][17] = {  18,   19,   20,   21,   64,   65,   86,   87}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][18] = {  18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   30,   31,   36,   41,   46,   64,   65,   66,   67,   68,   86,   87,   88,   89,   90,   97,   98,   99}; //  28
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][19] = {  22,   23,   66,   88}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][20] = {  24,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][21] = {  26,   27,   28,   29,   30,   31,   67,   68,   89,   90}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][22] = {  32,   33}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][23] = {  32,   33,   44,   45,   49,   50,   81,   82}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][24] = {  34,   35}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][25] = {  34,   35,   42,   43,   47,   48,   79,   80}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][26] = {  36}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][27] = {  36,   46}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][28] = {  37,   38}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][29] = {  37,   38,   42,   43,   58,   59,   73,   74}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][30] = {  39,   40}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][31] = {  39,   40,   44,   45,   56,   57,   71,   72}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][32] = {  41}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__24_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__24_164");
  needed_g_d[x_a][33] = {  41,   46}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");
  needed_g_d[x_a][34] = {  42,   43}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__76_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__76_176");
  needed_g_d[x_a][35] = {  44,   45}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__112_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__112_140");
  needed_g_d[x_a][36] = {  46}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__88_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__88_164");
  needed_g_d[x_a][37] = {  47,   48,   79,   80}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__64_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__64_176");
  needed_g_d[x_a][38] = {  49,   50,   81,   82}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__128_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__128_112");
  needed_g_d[x_a][39] = {  51,   52,   53,   54,   55,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   75,   76,   77,   78,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105}; //  43
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][40] = {  56,   57,   71,   72}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__64_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__64_140");
  needed_g_d[x_a][41] = {  58,   59,   73,   74}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__128_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__128_76");

  c_p[x_a].resize(106);
  c_f[x_a].resize(106);
  c_t[x_a].resize(106);
  c_d[x_a].resize(106);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][1] = {  0,   1,   4,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][2] = {  0,   1,   2,   5}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][3] = {  0,   1,   4,   5}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][4] = {  6,   7,   2,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   1,   2,   7,   8}; //   5

  c_p[x_a][5] = {  6,   7,   4,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   1,   2,   7,   8}; //   5

  c_p[x_a][6] = {  6,   7,   2,   5}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  5,   6,   2,   7,   8}; //   5

  c_p[x_a][7] = {  6,   7,   4,   5}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,   6,   2,   7,   8}; //   5

  c_p[x_a][8] = {  6,   8,   9,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   1,   9,  10,   8}; //   5

  c_p[x_a][9] = {  6,   8,   9,   5}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  5,   6,   9,  10,   8}; //   5

  c_p[x_a][10] = { 10,  11,  12,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,   1,  11,  12,  13}; //   5

  c_p[x_a][11] = { 10,  11,  12,   5}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   6,  11,  12,  13}; //   5

  c_p[x_a][12] = { 10,  13,   9,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,   1,   9,  14,  13}; //   5

  c_p[x_a][13] = { 10,  13,   9,   5}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  5,   6,   9,  14,  13}; //   5

  c_p[x_a][14] = {  0,  14,  15,   3}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  0,   1,  15,  16,   4}; //   5

  c_p[x_a][15] = {  0,  14,  16,   3}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  0,   1,  15,  16,   4}; //   5

  c_p[x_a][16] = {  0,  14,  15,   5}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  5,   6,  15,  16,   4}; //   5

  c_p[x_a][17] = {  0,  14,  16,   5}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  5,   6,  15,  16,   4}; //   5

  c_p[x_a][18] = { 17,  18,  15,   3}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  0,   1,  15,  17,  18}; //   5

  c_p[x_a][19] = { 17,  18,  16,   3}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  0,   1,  15,  17,  18}; //   5

  c_p[x_a][20] = { 17,  18,  15,   5}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  5,   6,  15,  17,  18}; //   5

  c_p[x_a][21] = { 17,  18,  16,   5}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  5,   6,  15,  17,  18}; //   5

  c_p[x_a][22] = { 17,  19,  12,   3}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  0,   1,  11,  19,  18}; //   5

  c_p[x_a][23] = { 17,  19,  12,   5}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  5,   6,  11,  19,  18}; //   5

  c_p[x_a][24] = {  0,  20,  21,   3}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = {  0,   1,  20,  13,   4}; //   5

  c_p[x_a][25] = {  0,  20,  21,   5}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = {  5,   6,  20,  13,   4}; //   5

  c_p[x_a][26] = {  6,  22,  23,   3}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = {  0,   1,  21,  18,   8}; //   5

  c_p[x_a][27] = {  6,  22,  24,   3}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = {  0,   1,  21,  18,   8}; //   5

  c_p[x_a][28] = {  6,  22,  25,   3}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = {  0,   1,  21,  18,   8}; //   5

  c_p[x_a][29] = {  6,  22,  23,   5}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = {  5,   6,  21,  18,   8}; //   5

  c_p[x_a][30] = {  6,  22,  24,   5}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = {  5,   6,  21,  18,   8}; //   5

  c_p[x_a][31] = {  6,  22,  25,   5}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = {  5,   6,  21,  18,   8}; //   5

  c_p[x_a][32] = {  0,  26,  27,  28}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = {  5,  22,  13,  23,   4}; //   5

  c_p[x_a][33] = {  0,  26,  29,  28}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = {  5,  22,  13,  23,   4}; //   5

  c_p[x_a][34] = {  0,  30,  31,  32}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = {  0,  24,  13,  25,   4}; //   5

  c_p[x_a][35] = {  0,  30,  33,  32}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = {  0,  24,  13,  25,   4}; //   5

  c_p[x_a][36] = {  6,  34,  35,  36}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = {  5,  26,  18,  27,   8}; //   5

  c_p[x_a][37] = { 37,  38,  39,  40}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = {  5,  28,   4,  29,  13}; //   5

  c_p[x_a][38] = { 10,  38,  39,  40}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = {  5,  28,   4,  29,  13}; //   5

  c_p[x_a][39] = { 37,  41,  42,  43}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = {  0,  30,   4,  31,  13}; //   5

  c_p[x_a][40] = { 10,  41,  42,  43}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = {  0,  30,   4,  31,  13}; //   5

  c_p[x_a][41] = { 17,  44,  45,  46}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = {  0,  32,   8,  33,  18}; //   5

  c_p[x_a][42] = {  0,  47,  48,  49}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 34,  29,  25,  13,   4}; //   5

  c_p[x_a][43] = {  0,  20,  48,  49}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = { 34,  29,  25,  13,   4}; //   5

  c_p[x_a][44] = { 37,  50,  51,  52}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = { 35,  23,  31,   4,  13}; //   5

  c_p[x_a][45] = { 10,  50,  51,  52}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = { 35,  23,  31,   4,  13}; //   5

  c_p[x_a][46] = { 17,  53,  54,  55}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = { 36,  27,  33,   8,  18}; //   5

  c_p[x_a][47] = {  0,  30,  56,  57}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  0}; //   1
  c_d[x_a][47] = { 13,  37,  25,   4}; //   4

  c_p[x_a][48] = {  0,  30,  56,  58}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  0}; //   1
  c_d[x_a][48] = { 13,  37,  25,   4}; //   4

  c_p[x_a][49] = {  0,  26,  59,  57}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  0}; //   1
  c_d[x_a][49] = { 13,  38,  23,   4}; //   4

  c_p[x_a][50] = {  0,  26,  59,  58}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  0}; //   1
  c_d[x_a][50] = { 13,  38,  23,   4}; //   4

  c_p[x_a][51] = {  0,   1,   2,  60}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  1}; //   1
  c_d[x_a][51] = { 39,   2,   3,   4}; //   4

  c_p[x_a][52] = {  0,   1,   4,  60}; //   4
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  1}; //   1
  c_d[x_a][52] = { 39,   2,   3,   4}; //   4

  c_p[x_a][53] = {  6,   7,   2,  60}; //   4
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  1}; //   1
  c_d[x_a][53] = { 39,   2,   7,   8}; //   4

  c_p[x_a][54] = {  6,   7,   4,  60}; //   4
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  1}; //   1
  c_d[x_a][54] = { 39,   2,   7,   8}; //   4

  c_p[x_a][55] = {  6,   8,   9,  60}; //   4
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  1}; //   1
  c_d[x_a][55] = { 39,   9,  10,   8}; //   4

  c_p[x_a][56] = { 37,  41,  61,  62}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  2}; //   1
  c_d[x_a][56] = {  4,  40,  31,  13}; //   4

  c_p[x_a][57] = { 10,  41,  61,  62}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  2}; //   1
  c_d[x_a][57] = {  4,  40,  31,  13}; //   4

  c_p[x_a][58] = { 37,  38,  63,  62}; //   4
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  2}; //   1
  c_d[x_a][58] = {  4,  41,  29,  13}; //   4

  c_p[x_a][59] = { 10,  38,  63,  62}; //   4
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  2}; //   1
  c_d[x_a][59] = {  4,  41,  29,  13}; //   4

  c_p[x_a][60] = { 10,  11,  12,  60}; //   4
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  1}; //   1
  c_d[x_a][60] = { 39,  11,  12,  13}; //   4

  c_p[x_a][61] = { 10,  13,   9,  60}; //   4
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  1}; //   1
  c_d[x_a][61] = { 39,   9,  14,  13}; //   4

  c_p[x_a][62] = {  0,  14,  15,  60}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  1}; //   1
  c_d[x_a][62] = { 39,  15,  16,   4}; //   4

  c_p[x_a][63] = {  0,  14,  16,  60}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  1}; //   1
  c_d[x_a][63] = { 39,  15,  16,   4}; //   4

  c_p[x_a][64] = { 17,  18,  15,  60}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  1}; //   1
  c_d[x_a][64] = { 39,  15,  17,  18}; //   4

  c_p[x_a][65] = { 17,  18,  16,  60}; //   4
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  1}; //   1
  c_d[x_a][65] = { 39,  15,  17,  18}; //   4

  c_p[x_a][66] = { 17,  19,  12,  60}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  1}; //   1
  c_d[x_a][66] = { 39,  11,  19,  18}; //   4

  c_p[x_a][67] = {  6,  22,  23,  60}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  1}; //   1
  c_d[x_a][67] = { 39,  21,  18,   8}; //   4

  c_p[x_a][68] = {  6,  22,  24,  60}; //   4
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  1}; //   1
  c_d[x_a][68] = { 39,  21,  18,   8}; //   4

  c_p[x_a][69] = { 64,  65,  66,  67}; //   4
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  3}; //   1
  c_d[x_a][69] = {  2,   3,   4,  39}; //   4

  c_p[x_a][70] = { 64,  65,  66,  68}; //   4
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  3}; //   1
  c_d[x_a][70] = {  2,   3,   4,  39}; //   4

  c_p[x_a][71] = {  0,  47,  51,  69}; //   4
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  4}; //   1
  c_d[x_a][71] = { 40,  31,  13,   4}; //   4

  c_p[x_a][72] = {  0,  20,  51,  69}; //   4
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  4}; //   1
  c_d[x_a][72] = { 40,  31,  13,   4}; //   4

  c_p[x_a][73] = {  0,  47,  70,  71}; //   4
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {  4}; //   1
  c_d[x_a][73] = { 41,  29,  13,   4}; //   4

  c_p[x_a][74] = {  0,  20,  70,  71}; //   4
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {  4}; //   1
  c_d[x_a][74] = { 41,  29,  13,   4}; //   4

  c_p[x_a][75] = { 64,  72,  73,  67}; //   4
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  3}; //   1
  c_d[x_a][75] = {  2,   7,   8,  39}; //   4

  c_p[x_a][76] = { 64,  72,  73,  68}; //   4
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  3}; //   1
  c_d[x_a][76] = {  2,   7,   8,  39}; //   4

  c_p[x_a][77] = { 64,  72,  74,  75}; //   4
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {  3}; //   1
  c_d[x_a][77] = {  9,  10,   8,  39}; //   4

  c_p[x_a][78] = { 64,  76,  77,  78}; //   4
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = {  3}; //   1
  c_d[x_a][78] = { 11,  12,  13,  39}; //   4

  c_p[x_a][79] = { 37,  50,  48,  79}; //   4
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = {  5}; //   1
  c_d[x_a][79] = { 37,  25,   4,  13}; //   4

  c_p[x_a][80] = { 10,  50,  48,  79}; //   4
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {  5}; //   1
  c_d[x_a][80] = { 37,  25,   4,  13}; //   4

  c_p[x_a][81] = { 37,  50,  80,  81}; //   4
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {  5}; //   1
  c_d[x_a][81] = { 38,  23,   4,  13}; //   4

  c_p[x_a][82] = { 10,  50,  80,  81}; //   4
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = {  5}; //   1
  c_d[x_a][82] = { 38,  23,   4,  13}; //   4

  c_p[x_a][83] = { 64,  76,  82,  75}; //   4
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = {  3}; //   1
  c_d[x_a][83] = {  9,  14,  13,  39}; //   4

  c_p[x_a][84] = { 64,  65,  83,  84}; //   4
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = {  3}; //   1
  c_d[x_a][84] = { 15,  16,   4,  39}; //   4

  c_p[x_a][85] = { 64,  65,  83,  85}; //   4
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = {  3}; //   1
  c_d[x_a][85] = { 15,  16,   4,  39}; //   4

  c_p[x_a][86] = { 64,  86,  87,  84}; //   4
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = {  3}; //   1
  c_d[x_a][86] = { 15,  17,  18,  39}; //   4

  c_p[x_a][87] = { 64,  86,  87,  85}; //   4
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = {  3}; //   1
  c_d[x_a][87] = { 15,  17,  18,  39}; //   4

  c_p[x_a][88] = { 64,  86,  88,  78}; //   4
  c_f[x_a][88] = {}; //   0
  c_t[x_a][88] = {  3}; //   1
  c_d[x_a][88] = { 11,  19,  18,  39}; //   4

  c_p[x_a][89] = { 64,  72,  89,  90}; //   4
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = {  3}; //   1
  c_d[x_a][89] = { 21,  18,   8,  39}; //   4

  c_p[x_a][90] = { 64,  72,  89,  91}; //   4
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = {  3}; //   1
  c_d[x_a][90] = { 21,  18,   8,  39}; //   4

  c_p[x_a][91] = { 64,  65,  92}; //   3
  c_f[x_a][91] = {  0}; //   1
  c_t[x_a][91] = {  0,   6}; //   2
  c_d[x_a][91] = { 13,   4,  39}; //   3

  c_p[x_a][92] = { 64,  65,  93}; //   3
  c_f[x_a][92] = {  0}; //   1
  c_t[x_a][92] = {  0,   6}; //   2
  c_d[x_a][92] = { 13,   4,  39}; //   3

  c_p[x_a][93] = {  0,  94,  92}; //   3
  c_f[x_a][93] = {  0}; //   1
  c_t[x_a][93] = {  0,   7}; //   2
  c_d[x_a][93] = { 13,  39,   4}; //   3

  c_p[x_a][94] = {  0,  94,  93}; //   3
  c_f[x_a][94] = {  0}; //   1
  c_t[x_a][94] = {  0,   7}; //   2
  c_d[x_a][94] = { 13,  39,   4}; //   3

  c_p[x_a][95] = {  0,  47,  95}; //   3
  c_f[x_a][95] = {  1}; //   1
  c_t[x_a][95] = {  1,   8}; //   2
  c_d[x_a][95] = { 39,  13,   4}; //   3

  c_p[x_a][96] = {  0,  20,  95}; //   3
  c_f[x_a][96] = {  1}; //   1
  c_t[x_a][96] = {  1,   8}; //   2
  c_d[x_a][96] = { 39,  13,   4}; //   3

  c_p[x_a][97] = { 64,  72,  89}; //   3
  c_f[x_a][97] = {  2}; //   1
  c_t[x_a][97] = {  9,  10}; //   2
  c_d[x_a][97] = { 18,   8,  39}; //   3

  c_p[x_a][98] = {  6,  96,  89}; //   3
  c_f[x_a][98] = {  2}; //   1
  c_t[x_a][98] = {  9,  11}; //   2
  c_d[x_a][98] = { 18,  39,   8}; //   3

  c_p[x_a][99] = {  6,  22,  97}; //   3
  c_f[x_a][99] = {  3}; //   1
  c_t[x_a][99] = {  1,  12}; //   2
  c_d[x_a][99] = { 39,  18,   8}; //   3

  c_p[x_a][100] = { 64,  98,  99}; //   3
  c_f[x_a][100] = {  4}; //   1
  c_t[x_a][100] = {  2,  13}; //   2
  c_d[x_a][100] = {  4,  13,  39}; //   3

  c_p[x_a][101] = { 64,  76,  99}; //   3
  c_f[x_a][101] = {  4}; //   1
  c_t[x_a][101] = {  2,  13}; //   2
  c_d[x_a][101] = {  4,  13,  39}; //   3

  c_p[x_a][102] = { 37, 100,  99}; //   3
  c_f[x_a][102] = {  4}; //   1
  c_t[x_a][102] = {  2,  14}; //   2
  c_d[x_a][102] = {  4,  39,  13}; //   3

  c_p[x_a][103] = { 10, 100,  99}; //   3
  c_f[x_a][103] = {  4}; //   1
  c_t[x_a][103] = {  2,  14}; //   2
  c_d[x_a][103] = {  4,  39,  13}; //   3

  c_p[x_a][104] = { 37,  50,  95}; //   3
  c_f[x_a][104] = {  1}; //   1
  c_t[x_a][104] = {  1,  15}; //   2
  c_d[x_a][104] = { 39,   4,  13}; //   3

  c_p[x_a][105] = { 10,  50,  95}; //   3
  c_f[x_a][105] = {  1}; //   1
  c_t[x_a][105] = {  1,  15}; //   2
  c_d[x_a][105] = { 39,   4,  13}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_ddx_emepvevexbbx
//  channel    0: 6yyyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   5,   0)
//  channel    1: 6yyyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   5,   0)
//  channel    2: 6yyyyv(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,   0,   5,   0)
//  channel    3: 6yyyyv(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,  23,   5,   0)
//  channel    4: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   0)
//  channel    5: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   0)
//  channel    6: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   5,   0)
//  channel    7: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   5,   0)
//  channel    8: 6yyyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   0)
//  channel    9: 6yyyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   5,   0)
//  channel   10: 6yyyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   5,   0)
//  channel   11: 6yyyyv(1, 2, 128, 64, 16, 32, 4, 8;  23,   0,  23,   5,   0)
//  channel   12: 6yyyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   5,   0)
//  channel   13: 6yyyyv(1, 2, 128, 64, 32, 16, 4, 8;  23,   0,  23,   5,   0)
//  channel   14: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   5,   0)
//  channel   15: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   5,   0)
//  channel   16: 6yyyyv(1, 2, 128, 64, 8, 4, 16, 32;  23,   0,   0,   5,   0)
//  channel   17: 6yyyyv(1, 2, 128, 64, 8, 4, 16, 32;  23,   0,  23,   5,   0)
//  channel   18: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   0)
//  channel   19: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   0)
//  channel   20: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   5,   0)
//  channel   21: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   5,   0)
//  channel   22: 6yyyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   0)
//  channel   23: 6yyyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   5,   0)
//  channel   24: 6yy2vv(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,  25,   5,   0)
//  channel   25: 6yy2vv(1, 2, 128, 64, 4, 8, 16, 32;  23,  23,  25,   5,   0)
//  channel   26: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   0)
//  channel   27: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   0)
//  channel   28: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   0)
//  channel   29: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   5,   0)
//  channel   30: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   5,   0)
//  channel   31: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  25,   5,   0)
//  channel   32: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  23,   5,   0,   5,   0)
//  channel   33: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  23,   5,  23,   5,   0)
//  channel   34: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   5,   0,   5,   0)
//  channel   35: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   5,  23,   5,   0)
//  channel   36: 6y2vyv(1, 2, 128, 4, 32, 64, 8, 16;  24,   6,  24,   5,   0)
//  channel   37: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;   0,   5,  23,   5,   0)
//  channel   38: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;  23,   5,  23,   5,   0)
//  channel   39: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   5,  23,   5,   0)
//  channel   40: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   5,  23,   5,   0)
//  channel   41: 6y2vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   6,  24,   5,   0)
//  channel   42: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   5,   5,   0)
//  channel   43: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  23,  23,   5,   5,   0)
//  channel   44: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;   0,  23,   5,   5,   0)
//  channel   45: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;  23,  23,   5,   5,   0)
//  channel   46: 63yvyv(1, 2, 64, 8, 16, 128, 4, 32;  24,  24,   6,   6,   0)
//  channel   47: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  23,   5,   0,   0,   0)
//  channel   48: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  23,   5,   0,  23,   0)
//  channel   49: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  23,   5,   0,   0,   0)
//  channel   50: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  23,   5,   0,  23,   0)
//  channel   51: 2v4yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   52: 2v4yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   0)
//  channel   53: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   54: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   55: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   56: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;   0,   5,   0,  23,   0)
//  channel   57: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;  23,   5,   0,  23,   0)
//  channel   58: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;   0,   5,   0,  23,   0)
//  channel   59: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;  23,   5,   0,  23,   0)
//  channel   60: 2v4yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   0)
//  channel   61: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   0)
//  channel   62: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   0)
//  channel   63: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   0)
//  channel   64: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   65: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   66: 2v4yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   67: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   68: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   69: 4yyv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,   0,   0)
//  channel   70: 4yyv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,  23,   0)
//  channel   71: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   5,   0,   0)
//  channel   72: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   5,   0,   0)
//  channel   73: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,   5,   0,   0)
//  channel   74: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  23,  23,   5,   0,   0)
//  channel   75: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,   0,   0)
//  channel   76: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,  23,   0)
//  channel   77: 4yyv2v(1, 2, 32, 4, 8, 16, 64, 128;   0,  24,   0,  23,   0)
//  channel   78: 4yyv2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,  23,   0)
//  channel   79: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   5,   0,   0)
//  channel   80: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   5,   0,   0)
//  channel   81: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;   0,  23,   5,   0,   0)
//  channel   82: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;  23,  23,   5,   0,   0)
//  channel   83: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,  23,   0,  23,   0)
//  channel   84: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  23,   0,   0,   0)
//  channel   85: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  23,   0,  23,   0)
//  channel   86: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,   0,   0)
//  channel   87: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,  23,   0)
//  channel   88: 4yyv2v(1, 2, 16, 8, 4, 32, 64, 128;   0,  24,   0,  23,   0)
//  channel   89: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   0)
//  channel   90: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,  23,   0)
//  channel   91: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,   0,   0)
//  channel   92: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,  23,   0,   0)
//  channel   93: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   94: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,  23,   0,   0)
//  channel   95: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   96: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   0,   0)
//  channel   97: 2v2v2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   0)
//  channel   98: 2v2v2v(1, 2, 4, 32, 64, 128, 8, 16;  24,   0,  24,   0,   0)
//  channel   99: 2v2v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel  100: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,   0,  23,   0,   0)
//  channel  101: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,  23,   0,   0)
//  channel  102: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  23,   0,   0)
//  channel  103: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  23,   0,   0)
//  channel  104: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   0,   0)
//  channel  105: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   0,   0)
