#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_240_dxcx_emepvevexdxcx(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_240_dxcx_emepvevexdxcx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(38);
  needed_v_smin[x_a].resize(38);
  needed_v_smin[x_a][  0] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   30,   31,   33,   34,   40,   41,   47,   48,   50,   51,   52,   53,   59,   60,   66,   67,   68,   69,   71,   72,   73,   74,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   97,   98,   99,  100}; //  56
  needed_v_smin[x_a][  1] = {   0,    1,   14,   15,   33,   34,   52,   53}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   14,   15,   16,   17,   33,   34,   35,   36,   52,   53,   54,   55}; //  16
  needed_v_smin[x_a][  3] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   32,   35,   36,   37,   45,   46,   49,   54,   55,   56,   64,   65,   70,   75,   96,  101}; //  26
  needed_v_smin[x_a][  4] = {   2,    3,   16,   17,   35,   36,   54,   55}; //   8
  needed_v_smin[x_a][  5] = {   4,   18,   37,   56}; //   4
  needed_v_smin[x_a][  6] = {   4,    6,   18,   20,   37,   39,   56,   58}; //   8
  needed_v_smin[x_a][  7] = {   5,    6,   19,   20,   28,   29,   30,   31,   38,   39,   47,   48,   50,   51,   57,   58,   66,   67,   68,   69,   71,   72,   73,   74,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   97,   98,   99,  100}; //  48
  needed_v_smin[x_a][  8] = {   5,   19,   38,   57}; //   4
  needed_v_smin[x_a][  9] = {   5,   11,   19,   25,   38,   44,   57,   63}; //   8
  needed_v_smin[x_a][ 10] = {   6,   20,   39,   58}; //   4
  needed_v_smin[x_a][ 11] = {   7,    8,   21,   22,   40,   41,   59,   60}; //   8
  needed_v_smin[x_a][ 12] = {   7,    8,    9,   10,   21,   22,   23,   24,   40,   41,   42,   43,   59,   60,   61,   62}; //  16
  needed_v_smin[x_a][ 13] = {   9,   10,   11,   12,   13,   23,   24,   25,   26,   27,   32,   42,   43,   44,   45,   46,   49,   61,   62,   63,   64,   65,   70,   75,   96,  101}; //  26
  needed_v_smin[x_a][ 14] = {   9,   10,   23,   24,   42,   43,   61,   62}; //   8
  needed_v_smin[x_a][ 15] = {  11,   25,   44,   63}; //   4
  needed_v_smin[x_a][ 16] = {  12,   13,   26,   27,   45,   46,   64,   65}; //   8
  needed_v_smin[x_a][ 17] = {  14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13}; //  28
  needed_v_smin[x_a][ 18] = {  28,   29,   71,   72,   86,   87,   90,   91,   66,   67}; //  10
  needed_v_smin[x_a][ 19] = {  28,   29,   66,   67,   71,   72}; //   6
  needed_v_smin[x_a][ 20] = {  30,   31,   73,   74,   84,   85,   88,   89,   68,   69}; //  10
  needed_v_smin[x_a][ 21] = {  30,   31,   68,   69,   73,   74}; //   6
  needed_v_smin[x_a][ 22] = {  32,   75,   70}; //   3
  needed_v_smin[x_a][ 23] = {  32,   70,   75}; //   3
  needed_v_smin[x_a][ 24] = {  33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65}; //  28
  needed_v_smin[x_a][ 25] = {  47,   48,   76,   77,   84,   85,   94,   95,   99,  100}; //  10
  needed_v_smin[x_a][ 26] = {  47,   48,   94,   95,   99,  100}; //   6
  needed_v_smin[x_a][ 27] = {  49,   96,  101}; //   3
  needed_v_smin[x_a][ 28] = {  49,   96,  101}; //   3
  needed_v_smin[x_a][ 29] = {  50,   51,   78,   79,   86,   87,   92,   93,   97,   98}; //  10
  needed_v_smin[x_a][ 30] = {  50,   51,   92,   93,   97,   98}; //   6
  needed_v_smin[x_a][ 31] = {  76,   77}; //   2
  needed_v_smin[x_a][ 32] = {  78,   79}; //   2
  needed_v_smin[x_a][ 33] = {  80,   81,   82,   83}; //   4
  needed_v_smin[x_a][ 34] = {  80,   81}; //   2
  needed_v_smin[x_a][ 35] = {  82,   83}; //   2
  needed_v_smin[x_a][ 36] = {  88,   89}; //   2
  needed_v_smin[x_a][ 37] = {  90,   91}; //   2

  v_smax[x_a].resize(38);
  needed_v_smax[x_a].resize(38);
  needed_v_smax[x_a][  0] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   33,   34,   40,   41,   47,   48,   52,   53,   59,   60,   66,   67,   71,   72,   76,   77,   80,   81,   84,   85,   88,   89,   92,   93,   97,   98}; //  36
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   14,   15,   16,   17,   33,   34,   35,   36,   52,   53,   54,   55}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65}; //  56
  needed_v_smax[x_a][  3] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   35,   36,   37,   45,   46,   49,   54,   55,   56,   64,   65}; //  21
  needed_v_smax[x_a][  4] = {   4,    6,   18,   20,   37,   39,   56,   58}; //   8
  needed_v_smax[x_a][  5] = {   5,    6,   19,   20,   30,   31,   38,   39,   50,   51,   57,   58,   68,   69,   73,   74,   78,   79,   82,   83,   86,   87,   90,   91,   94,   95,   99,  100}; //  28
  needed_v_smax[x_a][  6] = {   5,   11,   19,   25,   38,   44,   57,   63}; //   8
  needed_v_smax[x_a][  7] = {   7,    8,    9,   10,   21,   22,   23,   24,   40,   41,   42,   43,   59,   60,   61,   62}; //  16
  needed_v_smax[x_a][  8] = {   9,   10,   11,   23,   24,   25,   32,   42,   43,   44,   61,   62,   63,   70,   75,   96,  101}; //  17
  needed_v_smax[x_a][  9] = {  12,   13,   26,   27,   45,   46,   64,   65}; //   8
  needed_v_smax[x_a][ 10] = {  14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75}; //  43
  needed_v_smax[x_a][ 11] = {  28,   29,   71,   72}; //   4
  needed_v_smax[x_a][ 12] = {  28,   29,   71,   72}; //   4
  needed_v_smax[x_a][ 13] = {  30,   31,   73,   74}; //   4
  needed_v_smax[x_a][ 14] = {  30,   31,   73,   74}; //   4
  needed_v_smax[x_a][ 15] = {  32,   75}; //   2
  needed_v_smax[x_a][ 16] = {  32,   75}; //   2
  needed_v_smax[x_a][ 17] = {  33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101}; //  43
  needed_v_smax[x_a][ 18] = {  47,   48,   76,   77,   84,   85}; //   6
  needed_v_smax[x_a][ 19] = {  47,   48,   76,   77,   84,   85}; //   6
  needed_v_smax[x_a][ 20] = {  49}; //   1
  needed_v_smax[x_a][ 21] = {  49}; //   1
  needed_v_smax[x_a][ 22] = {  50,   51,   78,   79,   86,   87}; //   6
  needed_v_smax[x_a][ 23] = {  50,   51,   78,   79,   86,   87}; //   6
  needed_v_smax[x_a][ 24] = {  66,   67,   80,   81,   88,   89,   92,   93,   97,   98}; //  10
  needed_v_smax[x_a][ 25] = {  68,   69,   82,   83,   90,   91,   94,   95,   99,  100}; //  10
  needed_v_smax[x_a][ 26] = {  70,   96,  101}; //   3
  needed_v_smax[x_a][ 27] = {  84,   85}; //   2
  needed_v_smax[x_a][ 28] = {  86,   87}; //   2
  needed_v_smax[x_a][ 29] = {  88,   89,   68,   69}; //   4
  needed_v_smax[x_a][ 30] = {  90,   91,   66,   67}; //   4
  needed_v_smax[x_a][ 31] = {  92,   93,   97,   98}; //   4
  needed_v_smax[x_a][ 32] = {  94,   95,   99,  100}; //   4
  needed_v_smax[x_a][ 33] = {  96,  101}; //   2
  needed_v_smax[x_a][ 34] = {  70}; //   1
  needed_v_smax[x_a][ 35] = {  76,   77,   80,   81,   90,   91}; //   6
  needed_v_smax[x_a][ 36] = {  78,   79,   82,   83,   88,   89}; //   6
  needed_v_smax[x_a][ 37] = {  80,   81,   82,   83}; //   4

  g_p[x_a].resize(55);
  needed_g_p[x_a].resize(55);
  needed_g_p[x_a][0] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   33,   34,   40,   41,   47,   48,   52,   53,   59,   60,   66,   67,   71,   72,   76,   77,   80,   81,   84,   85,   88,   89,   92,   93,   97,   98}; //  36
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   14,   15,   33,   34,   52,   53}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   14,   16,   33,   35,   52,   54}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   15,   17,   34,   36,   53,   55}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   35,   36,   37,   45,   46,   49,   54,   55,   56,   64,   65}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    3,   16,   17,   35,   36,   54,   55}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {   4,   18,   37,   56}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   4,    6,   18,   20,   37,   39,   56,   58}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   5,    6,   19,   20,   31,   38,   39,   51,   57,   58,   69,   74,   79,   83,   87,   91,   95,  100}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   5,   19,   38,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   5,   11,   19,   25,   38,   44,   57,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][11] = {   6,   20,   39,   58}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][12] = {   7,    8,   21,   22,   40,   41,   59,   60}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][13] = {   7,    9,   21,   23,   40,   42,   59,   61}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][14] = {   8,   10,   22,   24,   41,   43,   60,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][15] = {   9,   10,   11,   23,   24,   25,   32,   42,   43,   44,   61,   62,   63,   70,   75,   96,  101}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax8");
  needed_g_p[x_a][16] = {   9,   10,   23,   24,   42,   43,   61,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][17] = {  11,   25,   44,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax6");
  needed_g_p[x_a][18] = {  12,   13,   26,   27,   45,   46,   64,   65}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax9");
  needed_g_p[x_a][19] = {  12,   26,   45,   64}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax2");
  needed_g_p[x_a][20] = {  13,   27,   46,   65}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin16_smax2");
  needed_g_p[x_a][21] = {  14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax10");
  needed_g_p[x_a][22] = {  28,   29,   71,   72}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax11");
  needed_g_p[x_a][23] = {  28,   71}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax12");
  needed_g_p[x_a][24] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax10");
  needed_g_p[x_a][25] = {  29,   72}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax12");
  needed_g_p[x_a][26] = {  30,   50,   68,   73,   78,   82,   86,   90,   94,   99}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][27] = {  30,   31,   73,   74}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax13");
  needed_g_p[x_a][28] = {  30,   31,   73,   74}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax14");
  needed_g_p[x_a][29] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax10");
  needed_g_p[x_a][30] = {  32,   75}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax15");
  needed_g_p[x_a][31] = {  32,   75}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax16");
  needed_g_p[x_a][32] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax10");
  needed_g_p[x_a][33] = {  33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax17");
  needed_g_p[x_a][34] = {  47,   48,   76,   77,   84,   85}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax18");
  needed_g_p[x_a][35] = {  47,   76,   84}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax19");
  needed_g_p[x_a][36] = {  47,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin26_smax17");
  needed_g_p[x_a][37] = {  48,   77,   85}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax19");
  needed_g_p[x_a][38] = {  49}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin27_smax20");
  needed_g_p[x_a][39] = {  49}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax21");
  needed_g_p[x_a][40] = {  49}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin28_smax17");
  needed_g_p[x_a][41] = {  50,   51,   78,   79,   86,   87}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax22");
  needed_g_p[x_a][42] = {  50,   51,   78,   79,   86,   87}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax23");
  needed_g_p[x_a][43] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin30_smax17");
  needed_g_p[x_a][44] = {  66,   80,   88,   92,   97}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax24");
  needed_g_p[x_a][45] = {  67,   81,   89,   93,   98}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax24");
  needed_g_p[x_a][46] = {  68,   69,   82,   83,   90,   91,   94,   95,   99,  100}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax25");
  needed_g_p[x_a][47] = {  70,   96,  101}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax26");
  needed_g_p[x_a][48] = {  84,   85}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax27");
  needed_g_p[x_a][49] = {  86,   87}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax28");
  needed_g_p[x_a][50] = {  88,   89}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax29");
  needed_g_p[x_a][51] = {  90,   91}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax30");
  needed_g_p[x_a][52] = {  92,   93}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax31");
  needed_g_p[x_a][53] = {  94,   95}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax32");
  needed_g_p[x_a][54] = {  96}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin27_smax33");

  g_f[x_a].resize(21);
  needed_g_f[x_a].resize(21);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13}; //  14
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax10");
  needed_g_f[x_a][1] = {  52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65}; //  14
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax17");
  needed_g_f[x_a][2] = {  66,   67}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax30");
  needed_g_f[x_a][3] = {  66,   67,   71,   72}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax10");
  needed_g_f[x_a][4] = {  68,   69}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax29");
  needed_g_f[x_a][5] = {  68,   69,   73,   74}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax10");
  needed_g_f[x_a][6] = {  70}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax34");
  needed_g_f[x_a][7] = {  70,   75}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax10");
  needed_g_f[x_a][8] = {  76,   77}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax35");
  needed_g_f[x_a][9] = {  78,   79}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax36");
  needed_g_f[x_a][10] = {  80,   81,   82,   83}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin33_smax37");
  needed_g_f[x_a][11] = {  80,   81}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin34_smax35");
  needed_g_f[x_a][12] = {  82,   83}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin35_smax36");
  needed_g_f[x_a][13] = {  88,   89}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin36_smax36");
  needed_g_f[x_a][14] = {  90,   91}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin37_smax35");
  needed_g_f[x_a][15] = {  92,   93,   97,   98}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax17");
  needed_g_f[x_a][16] = {  94,   95,   99,  100}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax17");
  needed_g_f[x_a][17] = {  96,  101}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax17");
  needed_g_f[x_a][18] = {  97,   98}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax31");
  needed_g_f[x_a][19] = {  99,  100}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax32");
  needed_g_f[x_a][20] = { 101}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax33");

  g_t[x_a].resize(30);
  needed_g_t[x_a].resize(30);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75}; //  43
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {  33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101}; //  43
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][3] = {  52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][4] = {  66,   67,   71,   72}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__12_112");
  needed_g_t[x_a][5] = {  66,   67}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_13__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_13__64_48");
  needed_g_t[x_a][6] = {  68,   69,   73,   74}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__48_76");
  needed_g_t[x_a][7] = {  68,   69}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_49__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_49__64_12");
  needed_g_t[x_a][8] = {  70,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__24_100");
  needed_g_t[x_a][9] = {  70}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_25__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_25__64_36");
  needed_g_t[x_a][10] = {  76,   77,   80,   81}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][11] = {  76,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__176_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__176_64");
  needed_g_t[x_a][12] = {  78,   79,   82,   83}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][13] = {  78,   79}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__140_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__140_64");
  needed_g_t[x_a][14] = {  80,   81}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][15] = {  80,   81}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__13_50__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__13_50__64_128");
  needed_g_t[x_a][16] = {  82,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][17] = {  82,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__49_14__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__49_14__64_128");
  needed_g_t[x_a][18] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__76_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__76_176");
  needed_g_t[x_a][19] = {  86,   87}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__112_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__112_140");
  needed_g_t[x_a][20] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][21] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_50__76_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_50__76_128");
  needed_g_t[x_a][22] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][23] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_14__112_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_14__112_128");
  needed_g_t[x_a][24] = {  92,   93,   97,   98}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_140");
  needed_g_t[x_a][25] = {  94,   95,   99,  100}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_176");
  needed_g_t[x_a][26] = {  96,  101}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_152");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_152");
  needed_g_t[x_a][27] = {  97,   98}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_50__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_50__128_12");
  needed_g_t[x_a][28] = {  99,  100}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__128_48");
  needed_g_t[x_a][29] = { 101}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__128_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__128_24");

  g_d[x_a].resize(31);
  needed_g_d[x_a].resize(31);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   14,   15,   16,   17,   33,   34,   35,   36,   52,   53,   54,   55}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,   14,   15,   33,   34,   52,   53}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    7,    8,   14,   15,   21,   22,   28,   29,   30,   31,   33,   34,   40,   41,   47,   48,   50,   51,   52,   53,   59,   60,   66,   67,   68,   69,   71,   72,   73,   74,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   97,   98,   99,  100}; //  56
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,    3,   16,   17,   35,   36,   54,   55}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][4] = {   2,    3,    4,   12,   13,   16,   17,   18,   26,   27,   32,   35,   36,   37,   45,   46,   49,   54,   55,   56,   64,   65,   70,   75,   96,  101}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   4,    6,   18,   20,   37,   39,   56,   58}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   4,   18,   37,   56}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {   5,   11,   19,   25,   38,   44,   57,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   5,   19,   38,   57}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   5,    6,   19,   20,   28,   29,   30,   31,   38,   39,   47,   48,   50,   51,   57,   58,   66,   67,   68,   69,   71,   72,   73,   74,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   97,   98,   99,  100}; //  48
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][10] = {   6,   20,   39,   58}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   7,    8,    9,   10,   21,   22,   23,   24,   40,   41,   42,   43,   59,   60,   61,   62}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {   7,    8,   21,   22,   40,   41,   59,   60}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][13] = {   9,   10,   23,   24,   42,   43,   61,   62}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {   9,   10,   11,   12,   13,   23,   24,   25,   26,   27,   32,   42,   43,   44,   45,   46,   49,   61,   62,   63,   64,   65,   70,   75,   96,  101}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  11,   25,   44,   63}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][16] = {  12,   13,   26,   27,   45,   46,   64,   65}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][17] = {  14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  14
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][18] = {  28,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][19] = {  28,   29,   71,   72,   86,   87,   90,   91}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][20] = {  30,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][21] = {  30,   31,   73,   74,   84,   85,   88,   89}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][22] = {  32}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][23] = {  32,   75}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][24] = {  33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46}; //  14
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][25] = {  47,   48}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][26] = {  47,   48,   76,   77,   84,   85,   94,   95}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][27] = {  49}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__36_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__36_152");
  needed_g_d[x_a][28] = {  49,   96}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_152__128_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_152__128_24");
  needed_g_d[x_a][29] = {  50,   51}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][30] = {  50,   51,   78,   79,   86,   87,   92,   93}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");

  c_p[x_a].resize(102);
  c_f[x_a].resize(102);
  c_t[x_a].resize(102);
  c_d[x_a].resize(102);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   2}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  0,   3,   4}; //   3

  c_p[x_a][3] = {  4,   5,   3}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  0,   3,   4}; //   3

  c_p[x_a][4] = {  4,   6,   7}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  5,   6,   4}; //   3

  c_p[x_a][5] = {  8,   9,  10}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  7,   8,   9}; //   3

  c_p[x_a][6] = {  8,  11,   7}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = {  5,  10,   9}; //   3

  c_p[x_a][7] = {  0,  12,  13}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = { 11,  12,   2}; //   3

  c_p[x_a][8] = {  0,  12,  14}; //   3
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  0,   1}; //   2
  c_d[x_a][8] = { 11,  12,   2}; //   3

  c_p[x_a][9] = { 15,  16,  13}; //   3
  c_f[x_a][9] = {  0}; //   1
  c_t[x_a][9] = {  0,   1}; //   2
  c_d[x_a][9] = { 11,  13,  14}; //   3

  c_p[x_a][10] = { 15,  16,  14}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = { 11,  13,  14}; //   3

  c_p[x_a][11] = { 15,  17,  10}; //   3
  c_f[x_a][11] = {  0}; //   1
  c_t[x_a][11] = {  0,   1}; //   2
  c_d[x_a][11] = {  7,  15,  14}; //   3

  c_p[x_a][12] = {  4,  18,  19}; //   3
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   1}; //   2
  c_d[x_a][12] = { 16,  14,   4}; //   3

  c_p[x_a][13] = {  4,  18,  20}; //   3
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   1}; //   2
  c_d[x_a][13] = { 16,  14,   4}; //   3

  c_p[x_a][14] = {  0,   1,   2,  21}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 17,   0,   1,   2}; //   4

  c_p[x_a][15] = {  0,   1,   3,  21}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 17,   0,   1,   2}; //   4

  c_p[x_a][16] = {  4,   5,   2,  21}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 17,   0,   3,   4}; //   4

  c_p[x_a][17] = {  4,   5,   3,  21}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 17,   0,   3,   4}; //   4

  c_p[x_a][18] = {  4,   6,   7,  21}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 17,   5,   6,   4}; //   4

  c_p[x_a][19] = {  8,   9,  10,  21}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 17,   7,   8,   9}; //   4

  c_p[x_a][20] = {  8,  11,   7,  21}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = { 17,   5,  10,   9}; //   4

  c_p[x_a][21] = {  0,  12,  13,  21}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = { 17,  11,  12,   2}; //   4

  c_p[x_a][22] = {  0,  12,  14,  21}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = { 17,  11,  12,   2}; //   4

  c_p[x_a][23] = { 15,  16,  13,  21}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = { 17,  11,  13,  14}; //   4

  c_p[x_a][24] = { 15,  16,  14,  21}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = { 17,  11,  13,  14}; //   4

  c_p[x_a][25] = { 15,  17,  10,  21}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = { 17,   7,  15,  14}; //   4

  c_p[x_a][26] = {  4,  18,  19,  21}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = { 17,  16,  14,   4}; //   4

  c_p[x_a][27] = {  4,  18,  20,  21}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = { 17,  16,  14,   4}; //   4

  c_p[x_a][28] = {  0,  22,  23,  24}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = { 18,   9,  19,   2}; //   4

  c_p[x_a][29] = {  0,  22,  25,  24}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = { 18,   9,  19,   2}; //   4

  c_p[x_a][30] = { 26,  27,  28,  29}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = { 20,   2,  21,   9}; //   4

  c_p[x_a][31] = {  8,  27,  28,  29}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 20,   2,  21,   9}; //   4

  c_p[x_a][32] = { 15,  30,  31,  32}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  0}; //   1
  c_d[x_a][32] = { 22,   4,  23,  14}; //   4

  c_p[x_a][33] = {  0,   1,   2,  33}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  2}; //   1
  c_d[x_a][33] = { 24,   0,   1,   2}; //   4

  c_p[x_a][34] = {  0,   1,   3,  33}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  2}; //   1
  c_d[x_a][34] = { 24,   0,   1,   2}; //   4

  c_p[x_a][35] = {  4,   5,   2,  33}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  2}; //   1
  c_d[x_a][35] = { 24,   0,   3,   4}; //   4

  c_p[x_a][36] = {  4,   5,   3,  33}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  2}; //   1
  c_d[x_a][36] = { 24,   0,   3,   4}; //   4

  c_p[x_a][37] = {  4,   6,   7,  33}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  2}; //   1
  c_d[x_a][37] = { 24,   5,   6,   4}; //   4

  c_p[x_a][38] = {  8,   9,  10,  33}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  2}; //   1
  c_d[x_a][38] = { 24,   7,   8,   9}; //   4

  c_p[x_a][39] = {  8,  11,   7,  33}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  2}; //   1
  c_d[x_a][39] = { 24,   5,  10,   9}; //   4

  c_p[x_a][40] = {  0,  12,  13,  33}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  2}; //   1
  c_d[x_a][40] = { 24,  11,  12,   2}; //   4

  c_p[x_a][41] = {  0,  12,  14,  33}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  2}; //   1
  c_d[x_a][41] = { 24,  11,  12,   2}; //   4

  c_p[x_a][42] = { 15,  16,  13,  33}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  2}; //   1
  c_d[x_a][42] = { 24,  11,  13,  14}; //   4

  c_p[x_a][43] = { 15,  16,  14,  33}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  2}; //   1
  c_d[x_a][43] = { 24,  11,  13,  14}; //   4

  c_p[x_a][44] = { 15,  17,  10,  33}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  2}; //   1
  c_d[x_a][44] = { 24,   7,  15,  14}; //   4

  c_p[x_a][45] = {  4,  18,  19,  33}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  2}; //   1
  c_d[x_a][45] = { 24,  16,  14,   4}; //   4

  c_p[x_a][46] = {  4,  18,  20,  33}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  2}; //   1
  c_d[x_a][46] = { 24,  16,  14,   4}; //   4

  c_p[x_a][47] = {  0,  34,  35,  36}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  2}; //   1
  c_d[x_a][47] = { 25,   9,  26,   2}; //   4

  c_p[x_a][48] = {  0,  34,  37,  36}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  2}; //   1
  c_d[x_a][48] = { 25,   9,  26,   2}; //   4

  c_p[x_a][49] = {  4,  38,  39,  40}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  2}; //   1
  c_d[x_a][49] = { 27,  14,  28,   4}; //   4

  c_p[x_a][50] = { 26,  41,  42,  43}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  2}; //   1
  c_d[x_a][50] = { 29,   2,  30,   9}; //   4

  c_p[x_a][51] = {  8,  41,  42,  43}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  2}; //   1
  c_d[x_a][51] = { 29,   2,  30,   9}; //   4

  c_p[x_a][52] = {  0,   1,   2}; //   3
  c_f[x_a][52] = {  1}; //   1
  c_t[x_a][52] = {  2,   3}; //   2
  c_d[x_a][52] = {  0,   1,   2}; //   3

  c_p[x_a][53] = {  0,   1,   3}; //   3
  c_f[x_a][53] = {  1}; //   1
  c_t[x_a][53] = {  2,   3}; //   2
  c_d[x_a][53] = {  0,   1,   2}; //   3

  c_p[x_a][54] = {  4,   5,   2}; //   3
  c_f[x_a][54] = {  1}; //   1
  c_t[x_a][54] = {  2,   3}; //   2
  c_d[x_a][54] = {  0,   3,   4}; //   3

  c_p[x_a][55] = {  4,   5,   3}; //   3
  c_f[x_a][55] = {  1}; //   1
  c_t[x_a][55] = {  2,   3}; //   2
  c_d[x_a][55] = {  0,   3,   4}; //   3

  c_p[x_a][56] = {  4,   6,   7}; //   3
  c_f[x_a][56] = {  1}; //   1
  c_t[x_a][56] = {  2,   3}; //   2
  c_d[x_a][56] = {  5,   6,   4}; //   3

  c_p[x_a][57] = {  8,   9,  10}; //   3
  c_f[x_a][57] = {  1}; //   1
  c_t[x_a][57] = {  2,   3}; //   2
  c_d[x_a][57] = {  7,   8,   9}; //   3

  c_p[x_a][58] = {  8,  11,   7}; //   3
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  2,   3}; //   2
  c_d[x_a][58] = {  5,  10,   9}; //   3

  c_p[x_a][59] = {  0,  12,  13}; //   3
  c_f[x_a][59] = {  1}; //   1
  c_t[x_a][59] = {  2,   3}; //   2
  c_d[x_a][59] = { 11,  12,   2}; //   3

  c_p[x_a][60] = {  0,  12,  14}; //   3
  c_f[x_a][60] = {  1}; //   1
  c_t[x_a][60] = {  2,   3}; //   2
  c_d[x_a][60] = { 11,  12,   2}; //   3

  c_p[x_a][61] = { 15,  16,  13}; //   3
  c_f[x_a][61] = {  1}; //   1
  c_t[x_a][61] = {  2,   3}; //   2
  c_d[x_a][61] = { 11,  13,  14}; //   3

  c_p[x_a][62] = { 15,  16,  14}; //   3
  c_f[x_a][62] = {  1}; //   1
  c_t[x_a][62] = {  2,   3}; //   2
  c_d[x_a][62] = { 11,  13,  14}; //   3

  c_p[x_a][63] = { 15,  17,  10}; //   3
  c_f[x_a][63] = {  1}; //   1
  c_t[x_a][63] = {  2,   3}; //   2
  c_d[x_a][63] = {  7,  15,  14}; //   3

  c_p[x_a][64] = {  4,  18,  19}; //   3
  c_f[x_a][64] = {  1}; //   1
  c_t[x_a][64] = {  2,   3}; //   2
  c_d[x_a][64] = { 16,  14,   4}; //   3

  c_p[x_a][65] = {  4,  18,  20}; //   3
  c_f[x_a][65] = {  1}; //   1
  c_t[x_a][65] = {  2,   3}; //   2
  c_d[x_a][65] = { 16,  14,   4}; //   3

  c_p[x_a][66] = {  0,  44}; //   2
  c_f[x_a][66] = {  2,   3}; //   2
  c_t[x_a][66] = {  0,   4,   5}; //   3
  c_d[x_a][66] = {  9,   2}; //   2

  c_p[x_a][67] = {  0,  45}; //   2
  c_f[x_a][67] = {  2,   3}; //   2
  c_t[x_a][67] = {  0,   4,   5}; //   3
  c_d[x_a][67] = {  9,   2}; //   2

  c_p[x_a][68] = { 26,  46}; //   2
  c_f[x_a][68] = {  4,   5}; //   2
  c_t[x_a][68] = {  0,   6,   7}; //   3
  c_d[x_a][68] = {  2,   9}; //   2

  c_p[x_a][69] = {  8,  46}; //   2
  c_f[x_a][69] = {  4,   5}; //   2
  c_t[x_a][69] = {  0,   6,   7}; //   3
  c_d[x_a][69] = {  2,   9}; //   2

  c_p[x_a][70] = { 15,  47}; //   2
  c_f[x_a][70] = {  6,   7}; //   2
  c_t[x_a][70] = {  0,   8,   9}; //   3
  c_d[x_a][70] = {  4,  14}; //   2

  c_p[x_a][71] = {  0,  22,  23}; //   3
  c_f[x_a][71] = {  3}; //   1
  c_t[x_a][71] = {  0,   4}; //   2
  c_d[x_a][71] = {  9,  19,   2}; //   3

  c_p[x_a][72] = {  0,  22,  25}; //   3
  c_f[x_a][72] = {  3}; //   1
  c_t[x_a][72] = {  0,   4}; //   2
  c_d[x_a][72] = {  9,  19,   2}; //   3

  c_p[x_a][73] = { 26,  27,  28}; //   3
  c_f[x_a][73] = {  5}; //   1
  c_t[x_a][73] = {  0,   6}; //   2
  c_d[x_a][73] = {  2,  21,   9}; //   3

  c_p[x_a][74] = {  8,  27,  28}; //   3
  c_f[x_a][74] = {  5}; //   1
  c_t[x_a][74] = {  0,   6}; //   2
  c_d[x_a][74] = {  2,  21,   9}; //   3

  c_p[x_a][75] = { 15,  30,  31}; //   3
  c_f[x_a][75] = {  7}; //   1
  c_t[x_a][75] = {  0,   8}; //   2
  c_d[x_a][75] = {  4,  23,  14}; //   3

  c_p[x_a][76] = {  0,  34,  35}; //   3
  c_f[x_a][76] = {  8}; //   1
  c_t[x_a][76] = { 10,  11}; //   2
  c_d[x_a][76] = {  9,  26,   2}; //   3

  c_p[x_a][77] = {  0,  34,  37}; //   3
  c_f[x_a][77] = {  8}; //   1
  c_t[x_a][77] = { 10,  11}; //   2
  c_d[x_a][77] = {  9,  26,   2}; //   3

  c_p[x_a][78] = { 26,  41,  42}; //   3
  c_f[x_a][78] = {  9}; //   1
  c_t[x_a][78] = { 12,  13}; //   2
  c_d[x_a][78] = {  2,  30,   9}; //   3

  c_p[x_a][79] = {  8,  41,  42}; //   3
  c_f[x_a][79] = {  9}; //   1
  c_t[x_a][79] = { 12,  13}; //   2
  c_d[x_a][79] = {  2,  30,   9}; //   3

  c_p[x_a][80] = {  0,  44}; //   2
  c_f[x_a][80] = { 10,  11}; //   2
  c_t[x_a][80] = { 10,  14,  15}; //   3
  c_d[x_a][80] = {  9,   2}; //   2

  c_p[x_a][81] = {  0,  45}; //   2
  c_f[x_a][81] = { 10,  11}; //   2
  c_t[x_a][81] = { 10,  14,  15}; //   3
  c_d[x_a][81] = {  9,   2}; //   2

  c_p[x_a][82] = { 26,  46}; //   2
  c_f[x_a][82] = { 10,  12}; //   2
  c_t[x_a][82] = { 12,  16,  17}; //   3
  c_d[x_a][82] = {  2,   9}; //   2

  c_p[x_a][83] = {  8,  46}; //   2
  c_f[x_a][83] = { 10,  12}; //   2
  c_t[x_a][83] = { 12,  16,  17}; //   3
  c_d[x_a][83] = {  2,   9}; //   2

  c_p[x_a][84] = {  0,  34,  35,  48}; //   4
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = { 18}; //   1
  c_d[x_a][84] = { 21,   9,  26,   2}; //   4

  c_p[x_a][85] = {  0,  34,  37,  48}; //   4
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = { 18}; //   1
  c_d[x_a][85] = { 21,   9,  26,   2}; //   4

  c_p[x_a][86] = { 26,  41,  42,  49}; //   4
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = { 19}; //   1
  c_d[x_a][86] = { 19,   2,  30,   9}; //   4

  c_p[x_a][87] = {  8,  41,  42,  49}; //   4
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = { 19}; //   1
  c_d[x_a][87] = { 19,   2,  30,   9}; //   4

  c_p[x_a][88] = {  0,  44,  50}; //   3
  c_f[x_a][88] = { 13}; //   1
  c_t[x_a][88] = { 20,  21}; //   2
  c_d[x_a][88] = { 21,   9,   2}; //   3

  c_p[x_a][89] = {  0,  45,  50}; //   3
  c_f[x_a][89] = { 13}; //   1
  c_t[x_a][89] = { 20,  21}; //   2
  c_d[x_a][89] = { 21,   9,   2}; //   3

  c_p[x_a][90] = { 26,  46,  51}; //   3
  c_f[x_a][90] = { 14}; //   1
  c_t[x_a][90] = { 22,  23}; //   2
  c_d[x_a][90] = { 19,   2,   9}; //   3

  c_p[x_a][91] = {  8,  46,  51}; //   3
  c_f[x_a][91] = { 14}; //   1
  c_t[x_a][91] = { 22,  23}; //   2
  c_d[x_a][91] = { 19,   2,   9}; //   3

  c_p[x_a][92] = {  0,  44,  52}; //   3
  c_f[x_a][92] = { 15}; //   1
  c_t[x_a][92] = {  2,  24}; //   2
  c_d[x_a][92] = { 30,   9,   2}; //   3

  c_p[x_a][93] = {  0,  45,  52}; //   3
  c_f[x_a][93] = { 15}; //   1
  c_t[x_a][93] = {  2,  24}; //   2
  c_d[x_a][93] = { 30,   9,   2}; //   3

  c_p[x_a][94] = { 26,  46,  53}; //   3
  c_f[x_a][94] = { 16}; //   1
  c_t[x_a][94] = {  2,  25}; //   2
  c_d[x_a][94] = { 26,   2,   9}; //   3

  c_p[x_a][95] = {  8,  46,  53}; //   3
  c_f[x_a][95] = { 16}; //   1
  c_t[x_a][95] = {  2,  25}; //   2
  c_d[x_a][95] = { 26,   2,   9}; //   3

  c_p[x_a][96] = { 15,  47,  54}; //   3
  c_f[x_a][96] = { 17}; //   1
  c_t[x_a][96] = {  2,  26}; //   2
  c_d[x_a][96] = { 28,   4,  14}; //   3

  c_p[x_a][97] = {  0,  44}; //   2
  c_f[x_a][97] = { 18,  15}; //   2
  c_t[x_a][97] = {  2,  24,  27}; //   3
  c_d[x_a][97] = {  9,   2}; //   2

  c_p[x_a][98] = {  0,  45}; //   2
  c_f[x_a][98] = { 18,  15}; //   2
  c_t[x_a][98] = {  2,  24,  27}; //   3
  c_d[x_a][98] = {  9,   2}; //   2

  c_p[x_a][99] = { 26,  46}; //   2
  c_f[x_a][99] = { 19,  16}; //   2
  c_t[x_a][99] = {  2,  25,  28}; //   3
  c_d[x_a][99] = {  2,   9}; //   2

  c_p[x_a][100] = {  8,  46}; //   2
  c_f[x_a][100] = { 19,  16}; //   2
  c_t[x_a][100] = {  2,  25,  28}; //   3
  c_d[x_a][100] = {  2,   9}; //   2

  c_p[x_a][101] = { 15,  47}; //   2
  c_f[x_a][101] = { 20,  17}; //   2
  c_t[x_a][101] = {  2,  26,  29}; //   3
  c_d[x_a][101] = {  4,  14}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_dxcx_emepvevexdxcx
//  channel    0: 4yyv11(1, 2, 4, 8, 16, 32, 64, 128;  23,   0,   0,   0,   0)
//  channel    1: 4yyv11(1, 2, 4, 8, 16, 32, 64, 128;  23,   0,  23,   0,   0)
//  channel    2: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,   0,   0,   0)
//  channel    3: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,  23,   0,   0)
//  channel    4: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  24,   0,  23,   0,   0)
//  channel    5: 4yyv11(1, 2, 16, 32, 4, 8, 64, 128;  23,   0,  23,   0,   0)
//  channel    6: 4yyv11(1, 2, 32, 16, 4, 8, 64, 128;  23,   0,  23,   0,   0)
//  channel    7: 4yyv11(1, 2, 8, 4, 16, 32, 64, 128;  23,   0,   0,   0,   0)
//  channel    8: 4yyv11(1, 2, 8, 4, 16, 32, 64, 128;  23,   0,  23,   0,   0)
//  channel    9: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   0,   0)
//  channel   10: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  23,   0,   0)
//  channel   11: 4yyv11(1, 2, 16, 8, 4, 32, 64, 128;  24,   0,  23,   0,   0)
//  channel   12: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   0)
//  channel   13: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  23,   0,   0)
//  channel   14: 5yyyv1(1, 2, 64, 4, 8, 16, 32, 128;  23,   0,   0,   0,   0)
//  channel   15: 5yyyv1(1, 2, 64, 4, 8, 16, 32, 128;  23,   0,  23,   0,   0)
//  channel   16: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   0,   0)
//  channel   17: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   0,   0)
//  channel   18: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   0,   0)
//  channel   19: 5yyyv1(1, 2, 64, 16, 32, 4, 8, 128;  23,   0,  23,   0,   0)
//  channel   20: 5yyyv1(1, 2, 64, 32, 16, 4, 8, 128;  23,   0,  23,   0,   0)
//  channel   21: 5yyyv1(1, 2, 64, 8, 4, 16, 32, 128;  23,   0,   0,   0,   0)
//  channel   22: 5yyyv1(1, 2, 64, 8, 4, 16, 32, 128;  23,   0,  23,   0,   0)
//  channel   23: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   0,   0)
//  channel   24: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   0,   0)
//  channel   25: 5yyyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   0,   0)
//  channel   26: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   0,   0)
//  channel   27: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   0,   0)
//  channel   28: 52vyv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,   0,   0,   0)
//  channel   29: 52vyv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,  23,   0,   0)
//  channel   30: 52vyv1(1, 2, 16, 32, 64, 4, 8, 128;   0,   0,  23,   0,   0)
//  channel   31: 52vyv1(1, 2, 16, 32, 64, 4, 8, 128;  23,   0,  23,   0,   0)
//  channel   32: 52vyv1(1, 2, 8, 16, 64, 4, 32, 128;  24,   0,  24,   0,   0)
//  channel   33: 15yyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   34: 15yyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   0)
//  channel   35: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   36: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   37: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   38: 15yyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   0)
//  channel   39: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   0)
//  channel   40: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   0)
//  channel   41: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   0)
//  channel   42: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   43: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   44: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   45: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   46: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   47: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   48: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,  23,   0,   0)
//  channel   49: 152vyv(1, 2, 64, 4, 32, 128, 8, 16;  24,   0,  24,   0,   0)
//  channel   50: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  23,   0,   0)
//  channel   51: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  23,   0,   0)
//  channel   52: 114yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   53: 114yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   0)
//  channel   54: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   55: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   56: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   57: 114yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   0)
//  channel   58: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   0)
//  channel   59: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   0)
//  channel   60: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   0)
//  channel   61: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   62: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   63: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   64: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   65: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   66: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  23,   0,   0,   0,   0)
//  channel   67: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  23,  23,   0,   0,   0)
//  channel   68: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,   0,   0)
//  channel   69: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;  23,  23,   0,   0,   0)
//  channel   70: 2v2v11(1, 2, 8, 16, 4, 32, 64, 128;  24,  24,   0,   0,   0)
//  channel   71: 2v3yv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,   0,   0,   0)
//  channel   72: 2v3yv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,  23,   0,   0)
//  channel   73: 2v3yv1(1, 2, 16, 32, 64, 4, 8, 128;   0,   0,  23,   0,   0)
//  channel   74: 2v3yv1(1, 2, 16, 32, 64, 4, 8, 128;  23,   0,  23,   0,   0)
//  channel   75: 2v3yv1(1, 2, 8, 16, 64, 4, 32, 128;  24,   0,  24,   0,   0)
//  channel   76: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   77: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,  23,   0,   0)
//  channel   78: 2v13yv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  23,   0,   0)
//  channel   79: 2v13yv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  23,   0,   0)
//  channel   80: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   81: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  23,  23,   0,   0,   0)
//  channel   82: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;   0,  23,   0,   0,   0)
//  channel   83: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;  23,  23,   0,   0,   0)
//  channel   84: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   85: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,  23,   0,   0)
//  channel   86: 3yv3yv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  23,   0,   0)
//  channel   87: 3yv3yv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  23,   0,   0)
//  channel   88: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   89: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  23,  23,   0,   0,   0)
//  channel   90: 3yv12v(1, 2, 64, 16, 32, 128, 4, 8;   0,  23,   0,   0,   0)
//  channel   91: 3yv12v(1, 2, 64, 16, 32, 128, 4, 8;  23,  23,   0,   0,   0)
//  channel   92: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   93: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   0,   0)
//  channel   94: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   0,   0)
//  channel   95: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   0,   0)
//  channel   96: 13yv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   0,   0)
//  channel   97: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   98: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   0,   0)
//  channel   99: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   0,   0)
//  channel  100: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   0,   0)
//  channel  101: 112v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   0,   0)
