#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_050_ba_emepvevexb(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_050_ba_emepvevexb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(34);
  needed_v_smin[x_a].resize(34);
  needed_v_smin[x_a][  0] = {  10,   29,   30,   31,   33,   34,   35,   45,   46,   47,   49,   50,   51,   54,   57,   58,   59,   67,   68,   75,   85,   86,   90,   91,   92,   95,  100,  103,  104,  105,  106,  107,  108,  109,  110,    3,   87,   88,   89}; //  39
  needed_v_smin[x_a][  1] = {  11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   27,   28,   32,   36,   37,   43,   44,   48,   52,   53,   55,   56,   60,   64,   65,   66,   69,   70,   73,   74,   76,   77,   79,   80,   83,   84,   93,   94,   96,   97,   98,   99,  101,  102,    0,    1,    5,    6}; //  48
  needed_v_smin[x_a][  2] = {  15,   16,   18,   19,   52,   53,   98,   99}; //   8
  needed_v_smin[x_a][  3] = {  17,   22,   23,   24,   33,   34,   35,   38,   39,   40,   49,   50,   51,   54,   61,   62,   63,   71,   72,   78,   81,   82,   87,   88,   89,   95,  100,  103,  104,  105,  106,  107,  108,  109,  110,    9,   90,   91,   92}; //  39
  needed_v_smin[x_a][  4] = {  17,   54,  100,  104,  103}; //   5
  needed_v_smin[x_a][  5] = {  20,   21,   36,   37,   69,   70,   79,   80,    5,    6,   64,   76,   77}; //  13
  needed_v_smin[x_a][  6] = {  20,   21,   22,   23,   36,   37,   38,   39,    5,    6,    7,    8,    9,   61,   62,   63,   64,   69,   70,   71,   72,   76,   77,   78,   79,   80,   81,   82}; //  28
  needed_v_smin[x_a][  7] = {  22,   23,   38,   39,   71,   72,   81,   82,    9,   61,   62,   63,   78}; //  13
  needed_v_smin[x_a][  8] = {  24,   40}; //   2
  needed_v_smin[x_a][  9] = {  24,   26,   40,   42}; //   4
  needed_v_smin[x_a][ 10] = {  25,   26,   32,   41,   42,   48,   52,   53,   55,   56,   93,   94,   96,   97,   98,   99,  101,  102}; //  18
  needed_v_smin[x_a][ 11] = {  25,   41}; //   2
  needed_v_smin[x_a][ 12] = {  25,   31,   41,   47}; //   4
  needed_v_smin[x_a][ 13] = {  26,   42}; //   2
  needed_v_smin[x_a][ 14] = {  27,   28,   43,   44,   65,   66,   83,   84,    0,    1,   60,   73,   74}; //  13
  needed_v_smin[x_a][ 15] = {  27,   28,   29,   30,   43,   44,   45,   46,    0,    1,    2,    3,    4,   57,   58,   59,   60,   65,   66,   67,   68,   73,   74,   75,   83,   84,   85,   86}; //  28
  needed_v_smin[x_a][ 16] = {  29,   30,   45,   46,   67,   68,   85,   86,    3,   57,   58,   59,   75}; //  13
  needed_v_smin[x_a][ 17] = {  31,   47}; //   2
  needed_v_smin[x_a][ 18] = {  32,   48,   93,   94,   96,   97}; //   6
  needed_v_smin[x_a][ 19] = {  33,   34,   35,   49,   50,   51,   87,   88,   89,   90,   91,   92,   95,  105,  106,  107,  108,  109,  110}; //  19
  needed_v_smin[x_a][ 20] = {  55,   56,  101,  102}; //   4
  needed_v_smin[x_a][ 21] = {   2,    4}; //   2
  needed_v_smin[x_a][ 22] = {   2,    4}; //   2
  needed_v_smin[x_a][ 23] = {   7,    8}; //   2
  needed_v_smin[x_a][ 24] = {   7,    8}; //   2
  needed_v_smin[x_a][ 25] = {  10}; //   1
  needed_v_smin[x_a][ 26] = {  10}; //   1
  needed_v_smin[x_a][ 27] = {  11,   12}; //   2
  needed_v_smin[x_a][ 28] = {  11,   12}; //   2
  needed_v_smin[x_a][ 29] = {  13,   14}; //   2
  needed_v_smin[x_a][ 30] = {  13,   14}; //   2
  needed_v_smin[x_a][ 31] = {  15,   16}; //   2
  needed_v_smin[x_a][ 32] = {  17}; //   1
  needed_v_smin[x_a][ 33] = {  18,   19}; //   2

  v_smax[x_a].resize(27);
  needed_v_smax[x_a].resize(27);
  needed_v_smax[x_a][  0] = {  10,   29,   30,   31,   45,   46,   47,   57,   58,   59,   67,   68,   75,   85,   86,   90,   91,   92,  104,  108,  109,  110,    3}; //  23
  needed_v_smax[x_a][  1] = {  11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   27,   28,   32,   36,   37,   43,   44,   48,   52,   53,   60,   64,   65,   66,   69,   70,   73,   74,   76,   77,   79,   80,   83,   84,   93,   94,   98,   99,    0,    1,    5,    6}; //  42
  needed_v_smax[x_a][  2] = {  15,   16,   18,   19,   52,   53,   98,   99}; //   8
  needed_v_smax[x_a][  3] = {  17,   22,   23,   24,   33,   34,   35,   38,   39,   40,   49,   50,   51,   54,   61,   62,   63,   71,   72,   78,   81,   82,   87,   88,   89,   95,  100,  103,  105,  106,  107,    9}; //  32
  needed_v_smax[x_a][  4] = {  17,   54,  100}; //   3
  needed_v_smax[x_a][  5] = {  20,   21,   22,   23,   36,   37,   38,   39,   69,   70,   71,   72,   79,   80,   81,   82,    5,    6,    7,    8,    9,   61,   62,   63,   64,   76,   77,   78}; //  28
  needed_v_smax[x_a][  6] = {  20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,  105,  106,  107,  108,  109,  110}; //  89
  needed_v_smax[x_a][  7] = {  24,   26,   40,   42}; //   4
  needed_v_smax[x_a][  8] = {  25,   26,   41,   42,   55,   56,   96,   97,  101,  102}; //  10
  needed_v_smax[x_a][  9] = {  25,   31,   41,   47}; //   4
  needed_v_smax[x_a][ 10] = {  27,   28,   29,   30,   43,   44,   45,   46,   65,   66,   67,   68,   83,   84,   85,   86,    0,    1,    2,    3,    4,   57,   58,   59,   60,   73,   74,   75}; //  28
  needed_v_smax[x_a][ 11] = {  32,   48,   93,   94}; //   4
  needed_v_smax[x_a][ 12] = {  33,   34,   35,   49,   50,   51,   95,  103,  105,  106,  107,   87,   88,   89}; //  14
  needed_v_smax[x_a][ 13] = {  52,   53,   98,   99}; //   4
  needed_v_smax[x_a][ 14] = {  54,  100}; //   2
  needed_v_smax[x_a][ 15] = {  55,   56,  101,  102}; //   4
  needed_v_smax[x_a][ 16] = {  55,   56,  101,  102}; //   4
  needed_v_smax[x_a][ 17] = {  96,   97}; //   2
  needed_v_smax[x_a][ 18] = { 104,  108,  109,  110,   90,   91,   92}; //   7
  needed_v_smax[x_a][ 19] = { 104,  103}; //   2
  needed_v_smax[x_a][ 20] = {   2,    4}; //   2
  needed_v_smax[x_a][ 21] = {   7,    8}; //   2
  needed_v_smax[x_a][ 22] = {  10}; //   1
  needed_v_smax[x_a][ 23] = {  10,   11,   12,   15,   16}; //   5
  needed_v_smax[x_a][ 24] = {  11,   12}; //   2
  needed_v_smax[x_a][ 25] = {  13,   14}; //   2
  needed_v_smax[x_a][ 26] = {  13,   14,   17,   18,   19}; //   5

  g_p[x_a].resize(36);
  needed_g_p[x_a].resize(36);
  needed_g_p[x_a][0] = {  10,   29,   30,   31,   45,   46,   47,   57,   58,   59,   67,   68,   75,   85,   86,   90,   91,   92,  104,  108,  109,  110}; //  22
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {  11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   27,   28,   32,   36,   37,   43,   44,   48,   52,   53,   60,   64,   65,   66,   69,   70,   73,   74,   76,   77,   79,   80,   83,   84,   93,   94,   98,   99}; //  38
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin1_smax1");
  needed_g_p[x_a][2] = {  15,   16,   18,   19,   52,   53,   98,   99}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin2_smax2");
  needed_g_p[x_a][3] = {  17,   22,   23,   24,   33,   34,   35,   38,   39,   40,   49,   50,   51,   54,   61,   62,   63,   71,   72,   78,   81,   82,   87,   88,   89,   95,  100,  103,  105,  106,  107}; //  31
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][4] = {  17,   54,  100}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin4_smax4");
  needed_g_p[x_a][5] = {  20,   21,   36,   37,   69,   70,   79,   80}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {  20,   22,   36,   38}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][7] = {  21,   23,   37,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax6");
  needed_g_p[x_a][8] = {  22,   23,   38,   39,   71,   72,   81,   82}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][9] = {  24,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {  24,   26,   40,   42}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax6");
  needed_g_p[x_a][11] = {  25,   26,   41,   42,   56,   97,  102}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax8");
  needed_g_p[x_a][12] = {  25,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][13] = {  25,   31,   41,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax6");
  needed_g_p[x_a][14] = {  26,   42}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax7");
  needed_g_p[x_a][15] = {  27,   28,   43,   44,   65,   66,   83,   84}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax10");
  needed_g_p[x_a][16] = {  27,   29,   43,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax6");
  needed_g_p[x_a][17] = {  28,   30,   44,   46}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin15_smax6");
  needed_g_p[x_a][18] = {  29,   30,   45,   46,   67,   68,   85,   86}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax10");
  needed_g_p[x_a][19] = {  31,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax9");
  needed_g_p[x_a][20] = {  32,   48,   94}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax11");
  needed_g_p[x_a][21] = {  32,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin18_smax6");
  needed_g_p[x_a][22] = {  33,   34,   35,   49,   50,   51,   95,  103,  105,  106,  107}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax12");
  needed_g_p[x_a][23] = {  33,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax6");
  needed_g_p[x_a][24] = {  34,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin19_smax6");
  needed_g_p[x_a][25] = {  35,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin19_smax6");
  needed_g_p[x_a][26] = {  52,   98}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax13");
  needed_g_p[x_a][27] = {  53,   99}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax13");
  needed_g_p[x_a][28] = {  54,  100}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][29] = {  55,   96,  101}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][30] = {  55,   56,  101,  102}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin20_smax15");
  needed_g_p[x_a][31] = {  55,   56,  101,  102}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin1_smax16");
  needed_g_p[x_a][32] = {  93}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax11");
  needed_g_p[x_a][33] = {  96,   97}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin1_smax17");
  needed_g_p[x_a][34] = { 104,  108,  109,  110}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax18");
  needed_g_p[x_a][35] = { 104}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin4_smax19");

  g_f[x_a].resize(27);
  needed_g_f[x_a].resize(27);
  needed_g_f[x_a][0] = {   0,    1,    5,    6}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   0,    1,   60,   73,   74}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax10");
  needed_g_f[x_a][2] = {   0,    1,    2,    3,    4,   57,   58,   59,   60,   65,   66,   67,   68,   73,   74,   75,   83,   84,   85,   86}; //  20
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax6");
  needed_g_f[x_a][3] = {   2,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax20");
  needed_g_f[x_a][4] = {   2,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax10");
  needed_g_f[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][6] = {   3,   57,   58,   59,   75}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax10");
  needed_g_f[x_a][7] = {   5,    6,   64,   76,   77}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][8] = {   5,    6,    7,    8,    9,   61,   62,   63,   64,   69,   70,   71,   72,   76,   77,   78,   79,   80,   81,   82}; //  20
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax6");
  needed_g_f[x_a][9] = {   7,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax21");
  needed_g_f[x_a][10] = {   7,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax5");
  needed_g_f[x_a][11] = {   9}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][12] = {   9,   61,   62,   63,   78}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][13] = {  10}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax22");
  needed_g_f[x_a][14] = {  10}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax23");
  needed_g_f[x_a][15] = {  11,   12}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax24");
  needed_g_f[x_a][16] = {  11,   12}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax23");
  needed_g_f[x_a][17] = {  13,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax25");
  needed_g_f[x_a][18] = {  13,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax26");
  needed_g_f[x_a][19] = {  15,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax23");
  needed_g_f[x_a][20] = {  17}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax26");
  needed_g_f[x_a][21] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin33_smax26");
  needed_g_f[x_a][22] = {  87,   88,   89}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax12");
  needed_g_f[x_a][23] = {  87,   88,   89,   90,   91,   92,   95,  105,  106,  107,  108,  109,  110}; //  13
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax6");
  needed_g_f[x_a][24] = {  90,   91,   92}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax18");
  needed_g_f[x_a][25] = {  93,   94,   96,   97}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax6");
  needed_g_f[x_a][26] = { 103}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax19");

  g_t[x_a].resize(55);
  needed_g_t[x_a].resize(55);
  needed_g_t[x_a][0] = {   0,    5,   57,   61,   65,   67,   69,   71,   73,   76,   79,   81,   83,   85,   87,   90,  105,  108}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,   57,   58,   59,   60,   65,   66,   67,   68,   73,   74,   75}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__8_52");
  needed_g_t[x_a][2] = {   0,    1,   73,   74}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__4_48");
  needed_g_t[x_a][3] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_69__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_69__16_32");
  needed_g_t[x_a][4] = {   1,    2,    3,    4,    6,    7,    8,    9,   58,   62,   66,   68,   70,   72,   74,   75,   77,   78,   80,   82,   84,   86,   88,   89,   91,   92,  106,  109}; //  28
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__1_2__64_60");
  needed_g_t[x_a][5] = {   2,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__32_20");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_97__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_97__16_4");
  needed_g_t[x_a][7] = {   3,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__16_36");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_81__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_81__4_32");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_97__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_97__4_16");
  needed_g_t[x_a][10] = {   5,    6,    7,    8,    9,   61,   62,   63,   64,   69,   70,   71,   72,   76,   77,   78}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__4_56");
  needed_g_t[x_a][11] = {   5,    6,   76,   77}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__8_48");
  needed_g_t[x_a][12] = {   5,    6}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_73__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_73__32_16");
  needed_g_t[x_a][13] = {   7,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__16_40");
  needed_g_t[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_81__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_81__32_8");
  needed_g_t[x_a][15] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_81__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_81__8_32");
  needed_g_t[x_a][16] = {   9,   78}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__32_24");
  needed_g_t[x_a][17] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_97__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_97__8_16");
  needed_g_t[x_a][18] = {  10,   11,   12,   15,   16}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][19] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_10__36_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_10__36_80");
  needed_g_t[x_a][20] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_37__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_37__16_64");
  needed_g_t[x_a][21] = {  11,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_10__48_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_10__48_68");
  needed_g_t[x_a][22] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_49__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_49__4_64");
  needed_g_t[x_a][23] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_49__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_49__4_64");
  needed_g_t[x_a][24] = {  13,   14,   17,   18,   19}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][25] = {  13,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_6__48_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_6__48_72");
  needed_g_t[x_a][26] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_49__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_49__8_64");
  needed_g_t[x_a][27] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_49__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_49__8_64");
  needed_g_t[x_a][28] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__4_112");
  needed_g_t[x_a][29] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__10_1__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__10_1__4_112");
  needed_g_t[x_a][30] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__6_1__32_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__6_1__32_88");
  needed_g_t[x_a][31] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__8_112");
  needed_g_t[x_a][32] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__6_1__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__6_1__8_112");
  needed_g_t[x_a][33] = {  20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   93,   94,   95,   96,   97}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__64_60");
  needed_g_t[x_a][34] = {  57,   58,   59}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_65__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_65__16_36");
  needed_g_t[x_a][35] = {  59,   60,   63,   64,  107,  110}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_25__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_25__1_2__64_60");
  needed_g_t[x_a][36] = {  60}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_65__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_65__4_48");
  needed_g_t[x_a][37] = {  61,   62,   63}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_65__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_65__32_24");
  needed_g_t[x_a][38] = {  64}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_65__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_65__8_48");
  needed_g_t[x_a][39] = {  79,   80,   81,   82}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__4_56");
  needed_g_t[x_a][40] = {  83,   84,   85,   86}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__8_52");
  needed_g_t[x_a][41] = {  87,   88,   89,  105,  106,  107}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_65__24_36");
  needed_g_t[x_a][42] = {  87,   88}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__4_32");
  needed_g_t[x_a][43] = {  89}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__32_4");
  needed_g_t[x_a][44] = {  90,   91,   92,  108,  109,  110}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_65__36_24");
  needed_g_t[x_a][45] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__8_16");
  needed_g_t[x_a][46] = {  92}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__16_8");
  needed_g_t[x_a][47] = {  93,   94}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_66__12_48");
  needed_g_t[x_a][48] = {  95}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_66__36_24");
  needed_g_t[x_a][49] = {  96,   97}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_66__48_12");
  needed_g_t[x_a][50] = {  98,   99}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__12_112");
  needed_g_t[x_a][51] = { 100,  103}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__36_88");
  needed_g_t[x_a][52] = { 101,  102}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__48_76");
  needed_g_t[x_a][53] = { 103}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_37__24_64");
  needed_g_t[x_a][54] = { 104}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__36_88");

  g_d[x_a].resize(25);
  needed_g_d[x_a].resize(25);
  needed_g_d[x_a][0] = {  10,   29,   30,   31,   33,   34,   35,   45,   46,   47,   49,   50,   51,   54,   57,   58,   59,   67,   68,   75,   85,   86,   90,   91,   92,   95,  100,  103,  104,  105,  106,  107,  108,  109,  110}; //  35
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {  11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   27,   28,   32,   36,   37,   43,   44,   48,   52,   53,   55,   56,   60,   64,   65,   66,   69,   70,   73,   74,   76,   77,   79,   80,   83,   84,   93,   94,   96,   97,   98,   99,  101,  102}; //  44
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {  15,   16,   18,   19,   52,   53,   98,   99}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][3] = {  17,   54,  100,  104}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][4] = {  17,   22,   23,   24,   33,   34,   35,   38,   39,   40,   49,   50,   51,   54,   61,   62,   63,   71,   72,   78,   81,   82,   87,   88,   89,   95,  100,  103,  104,  105,  106,  107,  108,  109,  110}; //  35
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {  20,   21,   22,   23,   36,   37,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][6] = {  20,   21,   36,   37,   69,   70,   79,   80}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][7] = {  22,   23,   38,   39,   71,   72,   81,   82}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][8] = {  24,   26,   40,   42}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {  24,   40}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][10] = {  25,   31,   41,   47}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][11] = {  25,   41}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][12] = {  25,   26,   32,   41,   42,   48,   52,   53,   55,   56,   93,   94,   96,   97,   98,   99,  101,  102}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][13] = {  26,   42}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][14] = {  27,   28,   29,   30,   43,   44,   45,   46}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][15] = {  27,   28,   43,   44,   65,   66,   83,   84}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][16] = {  29,   30,   45,   46,   67,   68,   85,   86}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][17] = {  31,   47}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][18] = {  32,   48}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][19] = {  33,   34,   35,   49,   50,   51}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][20] = {  36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][21] = {  52,   53}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][22] = {  54}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][23] = {  55,   56}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][24] = {  55,   56,  101,  102}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(111);
  c_f[x_a].resize(111);
  c_t[x_a].resize(111);
  c_d[x_a].resize(111);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1,   2}; //   3
  c_t[x_a][1] = {  4,   1,   2,   3}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  3,   4,   2}; //   3
  c_t[x_a][2] = {  4,   1,   5,   6}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  5,   6,   2}; //   3
  c_t[x_a][3] = {  4,   1,   7,   8}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  3,   4,   2}; //   3
  c_t[x_a][4] = {  4,   1,   5,   9}; //   4
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  0,   7,   8}; //   3
  c_t[x_a][5] = {  0,  10,  11,  12}; //   4
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  0,   7,   8}; //   3
  c_t[x_a][6] = {  4,  10,  11,  12}; //   4
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  9,  10,   8}; //   3
  c_t[x_a][7] = {  4,  10,  13,  14}; //   4
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  9,  10,   8}; //   3
  c_t[x_a][8] = {  4,  10,  13,  15}; //   4
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = { 11,  12,   8}; //   3
  c_t[x_a][9] = {  4,  10,  16,  17}; //   4
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = { 13,  14}; //   2
  c_t[x_a][10] = { 18,  19,  20}; //   3
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = { 15,  16}; //   2
  c_t[x_a][11] = { 18,  21,  22}; //   3
  c_d[x_a][11] = {  1}; //   1

  c_p[x_a][12] = {  1}; //   1
  c_f[x_a][12] = { 15,  16}; //   2
  c_t[x_a][12] = { 18,  21,  23}; //   3
  c_d[x_a][12] = {  1}; //   1

  c_p[x_a][13] = {  1}; //   1
  c_f[x_a][13] = { 17,  18}; //   2
  c_t[x_a][13] = { 24,  25,  26}; //   3
  c_d[x_a][13] = {  1}; //   1

  c_p[x_a][14] = {  1}; //   1
  c_f[x_a][14] = { 17,  18}; //   2
  c_t[x_a][14] = { 24,  25,  27}; //   3
  c_d[x_a][14] = {  1}; //   1

  c_p[x_a][15] = {  1,   2}; //   2
  c_f[x_a][15] = { 19}; //   1
  c_t[x_a][15] = { 18,  28}; //   2
  c_d[x_a][15] = {  2,   1}; //   2

  c_p[x_a][16] = {  1,   2}; //   2
  c_f[x_a][16] = { 19}; //   1
  c_t[x_a][16] = { 18,  29}; //   2
  c_d[x_a][16] = {  2,   1}; //   2

  c_p[x_a][17] = {  3,   4}; //   2
  c_f[x_a][17] = { 20}; //   1
  c_t[x_a][17] = { 24,  30}; //   2
  c_d[x_a][17] = {  3,   4}; //   2

  c_p[x_a][18] = {  1,   2}; //   2
  c_f[x_a][18] = { 21}; //   1
  c_t[x_a][18] = { 24,  31}; //   2
  c_d[x_a][18] = {  2,   1}; //   2

  c_p[x_a][19] = {  1,   2}; //   2
  c_f[x_a][19] = { 21}; //   1
  c_t[x_a][19] = { 24,  32}; //   2
  c_d[x_a][19] = {  2,   1}; //   2

  c_p[x_a][20] = {  1,   5,   6}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = { 33}; //   1
  c_d[x_a][20] = {  5,   6,   1}; //   3

  c_p[x_a][21] = {  1,   5,   7}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 33}; //   1
  c_d[x_a][21] = {  5,   6,   1}; //   3

  c_p[x_a][22] = {  3,   8,   6}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 33}; //   1
  c_d[x_a][22] = {  5,   7,   4}; //   3

  c_p[x_a][23] = {  3,   8,   7}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 33}; //   1
  c_d[x_a][23] = {  5,   7,   4}; //   3

  c_p[x_a][24] = {  3,   9,  10}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = { 33}; //   1
  c_d[x_a][24] = {  8,   9,   4}; //   3

  c_p[x_a][25] = { 11,  12,  13}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = { 33}; //   1
  c_d[x_a][25] = { 10,  11,  12}; //   3

  c_p[x_a][26] = { 11,  14,  10}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = { 33}; //   1
  c_d[x_a][26] = {  8,  13,  12}; //   3

  c_p[x_a][27] = {  1,  15,  16}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 33}; //   1
  c_d[x_a][27] = { 14,  15,   1}; //   3

  c_p[x_a][28] = {  1,  15,  17}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 33}; //   1
  c_d[x_a][28] = { 14,  15,   1}; //   3

  c_p[x_a][29] = {  0,  18,  16}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = { 33}; //   1
  c_d[x_a][29] = { 14,  16,   0}; //   3

  c_p[x_a][30] = {  0,  18,  17}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = { 33}; //   1
  c_d[x_a][30] = { 14,  16,   0}; //   3

  c_p[x_a][31] = {  0,  19,  13}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = { 33}; //   1
  c_d[x_a][31] = { 10,  17,   0}; //   3

  c_p[x_a][32] = {  1,  20,  21}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = { 33}; //   1
  c_d[x_a][32] = { 18,  12,   1}; //   3

  c_p[x_a][33] = {  3,  22,  23}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = { 33}; //   1
  c_d[x_a][33] = { 19,   0,   4}; //   3

  c_p[x_a][34] = {  3,  22,  24}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = { 33}; //   1
  c_d[x_a][34] = { 19,   0,   4}; //   3

  c_p[x_a][35] = {  3,  22,  25}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = { 33}; //   1
  c_d[x_a][35] = { 19,   0,   4}; //   3

  c_p[x_a][36] = {  1,   5,   6}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 20,   5,   6,   1}; //   4

  c_p[x_a][37] = {  1,   5,   7}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 20,   5,   6,   1}; //   4

  c_p[x_a][38] = {  3,   8,   6}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 20,   5,   7,   4}; //   4

  c_p[x_a][39] = {  3,   8,   7}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 20,   5,   7,   4}; //   4

  c_p[x_a][40] = {  3,   9,  10}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 20,   8,   9,   4}; //   4

  c_p[x_a][41] = { 11,  12,  13}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 20,  10,  11,  12}; //   4

  c_p[x_a][42] = { 11,  14,  10}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 20,   8,  13,  12}; //   4

  c_p[x_a][43] = {  1,  15,  16}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = { 20,  14,  15,   1}; //   4

  c_p[x_a][44] = {  1,  15,  17}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = { 20,  14,  15,   1}; //   4

  c_p[x_a][45] = {  0,  18,  16}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = { 20,  14,  16,   0}; //   4

  c_p[x_a][46] = {  0,  18,  17}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = { 20,  14,  16,   0}; //   4

  c_p[x_a][47] = {  0,  19,  13}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {}; //   0
  c_d[x_a][47] = { 20,  10,  17,   0}; //   4

  c_p[x_a][48] = {  1,  20,  21}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {}; //   0
  c_d[x_a][48] = { 20,  18,  12,   1}; //   4

  c_p[x_a][49] = {  3,  22,  23}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {}; //   0
  c_d[x_a][49] = { 20,  19,   0,   4}; //   4

  c_p[x_a][50] = {  3,  22,  24}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {}; //   0
  c_d[x_a][50] = { 20,  19,   0,   4}; //   4

  c_p[x_a][51] = {  3,  22,  25}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {}; //   0
  c_d[x_a][51] = { 20,  19,   0,   4}; //   4

  c_p[x_a][52] = {  1,   2,  26}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {}; //   0
  c_d[x_a][52] = { 21,  12,   2,   1}; //   4

  c_p[x_a][53] = {  1,   2,  27}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {}; //   0
  c_d[x_a][53] = { 21,  12,   2,   1}; //   4

  c_p[x_a][54] = {  3,   4,  28}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {}; //   0
  c_d[x_a][54] = { 22,   0,   3,   4}; //   4

  c_p[x_a][55] = { 29,  30,  31}; //   3
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {}; //   0
  c_d[x_a][55] = { 23,   1,  24,  12}; //   4

  c_p[x_a][56] = { 11,  30,  31}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {}; //   0
  c_d[x_a][56] = { 23,   1,  24,  12}; //   4

  c_p[x_a][57] = {  0}; //   1
  c_f[x_a][57] = {  6,   2}; //   2
  c_t[x_a][57] = {  0,   1,  34}; //   3
  c_d[x_a][57] = {  0}; //   1

  c_p[x_a][58] = {  0}; //   1
  c_f[x_a][58] = {  6,   2}; //   2
  c_t[x_a][58] = {  4,   1,  34}; //   3
  c_d[x_a][58] = {  0}; //   1

  c_p[x_a][59] = {  0}; //   1
  c_f[x_a][59] = {  6,   2}; //   2
  c_t[x_a][59] = { 35,   1,  34}; //   3
  c_d[x_a][59] = {  0}; //   1

  c_p[x_a][60] = {  1}; //   1
  c_f[x_a][60] = {  1,   2}; //   2
  c_t[x_a][60] = { 35,   1,  36}; //   3
  c_d[x_a][60] = {  1}; //   1

  c_p[x_a][61] = {  3}; //   1
  c_f[x_a][61] = { 12,   8}; //   2
  c_t[x_a][61] = {  0,  10,  37}; //   3
  c_d[x_a][61] = {  4}; //   1

  c_p[x_a][62] = {  3}; //   1
  c_f[x_a][62] = { 12,   8}; //   2
  c_t[x_a][62] = {  4,  10,  37}; //   3
  c_d[x_a][62] = {  4}; //   1

  c_p[x_a][63] = {  3}; //   1
  c_f[x_a][63] = { 12,   8}; //   2
  c_t[x_a][63] = { 35,  10,  37}; //   3
  c_d[x_a][63] = {  4}; //   1

  c_p[x_a][64] = {  1}; //   1
  c_f[x_a][64] = {  7,   8}; //   2
  c_t[x_a][64] = { 35,  10,  38}; //   3
  c_d[x_a][64] = {  1}; //   1

  c_p[x_a][65] = {  1,  15}; //   2
  c_f[x_a][65] = {  2}; //   1
  c_t[x_a][65] = {  0,   1}; //   2
  c_d[x_a][65] = { 15,   1}; //   2

  c_p[x_a][66] = {  1,  15}; //   2
  c_f[x_a][66] = {  2}; //   1
  c_t[x_a][66] = {  4,   1}; //   2
  c_d[x_a][66] = { 15,   1}; //   2

  c_p[x_a][67] = {  0,  18}; //   2
  c_f[x_a][67] = {  2}; //   1
  c_t[x_a][67] = {  0,   1}; //   2
  c_d[x_a][67] = { 16,   0}; //   2

  c_p[x_a][68] = {  0,  18}; //   2
  c_f[x_a][68] = {  2}; //   1
  c_t[x_a][68] = {  4,   1}; //   2
  c_d[x_a][68] = { 16,   0}; //   2

  c_p[x_a][69] = {  1,   5}; //   2
  c_f[x_a][69] = {  8}; //   1
  c_t[x_a][69] = {  0,  10}; //   2
  c_d[x_a][69] = {  6,   1}; //   2

  c_p[x_a][70] = {  1,   5}; //   2
  c_f[x_a][70] = {  8}; //   1
  c_t[x_a][70] = {  4,  10}; //   2
  c_d[x_a][70] = {  6,   1}; //   2

  c_p[x_a][71] = {  3,   8}; //   2
  c_f[x_a][71] = {  8}; //   1
  c_t[x_a][71] = {  0,  10}; //   2
  c_d[x_a][71] = {  7,   4}; //   2

  c_p[x_a][72] = {  3,   8}; //   2
  c_f[x_a][72] = {  8}; //   1
  c_t[x_a][72] = {  4,  10}; //   2
  c_d[x_a][72] = {  7,   4}; //   2

  c_p[x_a][73] = {  1}; //   1
  c_f[x_a][73] = {  1,   2}; //   2
  c_t[x_a][73] = {  0,   1,   2}; //   3
  c_d[x_a][73] = {  1}; //   1

  c_p[x_a][74] = {  1}; //   1
  c_f[x_a][74] = {  1,   2}; //   2
  c_t[x_a][74] = {  4,   1,   2}; //   3
  c_d[x_a][74] = {  1}; //   1

  c_p[x_a][75] = {  0}; //   1
  c_f[x_a][75] = {  6,   2}; //   2
  c_t[x_a][75] = {  4,   1,   7}; //   3
  c_d[x_a][75] = {  0}; //   1

  c_p[x_a][76] = {  1}; //   1
  c_f[x_a][76] = {  7,   8}; //   2
  c_t[x_a][76] = {  0,  10,  11}; //   3
  c_d[x_a][76] = {  1}; //   1

  c_p[x_a][77] = {  1}; //   1
  c_f[x_a][77] = {  7,   8}; //   2
  c_t[x_a][77] = {  4,  10,  11}; //   3
  c_d[x_a][77] = {  1}; //   1

  c_p[x_a][78] = {  3}; //   1
  c_f[x_a][78] = { 12,   8}; //   2
  c_t[x_a][78] = {  4,  10,  16}; //   3
  c_d[x_a][78] = {  4}; //   1

  c_p[x_a][79] = {  1,   5}; //   2
  c_f[x_a][79] = {  8}; //   1
  c_t[x_a][79] = {  0,  39}; //   2
  c_d[x_a][79] = {  6,   1}; //   2

  c_p[x_a][80] = {  1,   5}; //   2
  c_f[x_a][80] = {  8}; //   1
  c_t[x_a][80] = {  4,  39}; //   2
  c_d[x_a][80] = {  6,   1}; //   2

  c_p[x_a][81] = {  3,   8}; //   2
  c_f[x_a][81] = {  8}; //   1
  c_t[x_a][81] = {  0,  39}; //   2
  c_d[x_a][81] = {  7,   4}; //   2

  c_p[x_a][82] = {  3,   8}; //   2
  c_f[x_a][82] = {  8}; //   1
  c_t[x_a][82] = {  4,  39}; //   2
  c_d[x_a][82] = {  7,   4}; //   2

  c_p[x_a][83] = {  1,  15}; //   2
  c_f[x_a][83] = {  2}; //   1
  c_t[x_a][83] = {  0,  40}; //   2
  c_d[x_a][83] = { 15,   1}; //   2

  c_p[x_a][84] = {  1,  15}; //   2
  c_f[x_a][84] = {  2}; //   1
  c_t[x_a][84] = {  4,  40}; //   2
  c_d[x_a][84] = { 15,   1}; //   2

  c_p[x_a][85] = {  0,  18}; //   2
  c_f[x_a][85] = {  2}; //   1
  c_t[x_a][85] = {  0,  40}; //   2
  c_d[x_a][85] = { 16,   0}; //   2

  c_p[x_a][86] = {  0,  18}; //   2
  c_f[x_a][86] = {  2}; //   1
  c_t[x_a][86] = {  4,  40}; //   2
  c_d[x_a][86] = { 16,   0}; //   2

  c_p[x_a][87] = {  3}; //   1
  c_f[x_a][87] = { 22,  23}; //   2
  c_t[x_a][87] = {  0,  41,  42}; //   3
  c_d[x_a][87] = {  4}; //   1

  c_p[x_a][88] = {  3}; //   1
  c_f[x_a][88] = { 22,  23}; //   2
  c_t[x_a][88] = {  4,  41,  42}; //   3
  c_d[x_a][88] = {  4}; //   1

  c_p[x_a][89] = {  3}; //   1
  c_f[x_a][89] = { 22,  23}; //   2
  c_t[x_a][89] = {  4,  41,  43}; //   3
  c_d[x_a][89] = {  4}; //   1

  c_p[x_a][90] = {  0}; //   1
  c_f[x_a][90] = { 24,  23}; //   2
  c_t[x_a][90] = {  0,  44,  45}; //   3
  c_d[x_a][90] = {  0}; //   1

  c_p[x_a][91] = {  0}; //   1
  c_f[x_a][91] = { 24,  23}; //   2
  c_t[x_a][91] = {  4,  44,  45}; //   3
  c_d[x_a][91] = {  0}; //   1

  c_p[x_a][92] = {  0}; //   1
  c_f[x_a][92] = { 24,  23}; //   2
  c_t[x_a][92] = {  4,  44,  46}; //   3
  c_d[x_a][92] = {  0}; //   1

  c_p[x_a][93] = {  1,  32}; //   2
  c_f[x_a][93] = { 25}; //   1
  c_t[x_a][93] = { 33,  47}; //   2
  c_d[x_a][93] = { 12,   1}; //   2

  c_p[x_a][94] = {  1,  20}; //   2
  c_f[x_a][94] = { 25}; //   1
  c_t[x_a][94] = { 33,  47}; //   2
  c_d[x_a][94] = { 12,   1}; //   2

  c_p[x_a][95] = {  3,  22}; //   2
  c_f[x_a][95] = { 23}; //   1
  c_t[x_a][95] = { 33,  48}; //   2
  c_d[x_a][95] = {  0,   4}; //   2

  c_p[x_a][96] = { 29,  33}; //   2
  c_f[x_a][96] = { 25}; //   1
  c_t[x_a][96] = { 33,  49}; //   2
  c_d[x_a][96] = {  1,  12}; //   2

  c_p[x_a][97] = { 11,  33}; //   2
  c_f[x_a][97] = { 25}; //   1
  c_t[x_a][97] = { 33,  49}; //   2
  c_d[x_a][97] = {  1,  12}; //   2

  c_p[x_a][98] = {  1,   2,  26}; //   3
  c_f[x_a][98] = {}; //   0
  c_t[x_a][98] = { 50}; //   1
  c_d[x_a][98] = { 12,   2,   1}; //   3

  c_p[x_a][99] = {  1,   2,  27}; //   3
  c_f[x_a][99] = {}; //   0
  c_t[x_a][99] = { 50}; //   1
  c_d[x_a][99] = { 12,   2,   1}; //   3

  c_p[x_a][100] = {  3,   4,  28}; //   3
  c_f[x_a][100] = {}; //   0
  c_t[x_a][100] = { 51}; //   1
  c_d[x_a][100] = {  0,   3,   4}; //   3

  c_p[x_a][101] = { 29,  30,  31}; //   3
  c_f[x_a][101] = {}; //   0
  c_t[x_a][101] = { 52}; //   1
  c_d[x_a][101] = {  1,  24,  12}; //   3

  c_p[x_a][102] = { 11,  30,  31}; //   3
  c_f[x_a][102] = {}; //   0
  c_t[x_a][102] = { 52}; //   1
  c_d[x_a][102] = {  1,  24,  12}; //   3

  c_p[x_a][103] = {  3,  22}; //   2
  c_f[x_a][103] = { 26}; //   1
  c_t[x_a][103] = { 51,  53}; //   2
  c_d[x_a][103] = {  0,   4}; //   2

  c_p[x_a][104] = {  0,  34,  35}; //   3
  c_f[x_a][104] = {}; //   0
  c_t[x_a][104] = { 54}; //   1
  c_d[x_a][104] = {  3,   4,   0}; //   3

  c_p[x_a][105] = {  3,  22}; //   2
  c_f[x_a][105] = { 23}; //   1
  c_t[x_a][105] = {  0,  41}; //   2
  c_d[x_a][105] = {  0,   4}; //   2

  c_p[x_a][106] = {  3,  22}; //   2
  c_f[x_a][106] = { 23}; //   1
  c_t[x_a][106] = {  4,  41}; //   2
  c_d[x_a][106] = {  0,   4}; //   2

  c_p[x_a][107] = {  3,  22}; //   2
  c_f[x_a][107] = { 23}; //   1
  c_t[x_a][107] = { 35,  41}; //   2
  c_d[x_a][107] = {  0,   4}; //   2

  c_p[x_a][108] = {  0,  34}; //   2
  c_f[x_a][108] = { 23}; //   1
  c_t[x_a][108] = {  0,  44}; //   2
  c_d[x_a][108] = {  4,   0}; //   2

  c_p[x_a][109] = {  0,  34}; //   2
  c_f[x_a][109] = { 23}; //   1
  c_t[x_a][109] = {  4,  44}; //   2
  c_d[x_a][109] = {  4,   0}; //   2

  c_p[x_a][110] = {  0,  34}; //   2
  c_f[x_a][110] = { 23}; //   1
  c_t[x_a][110] = { 35,  44}; //   2
  c_d[x_a][110] = {  4,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_050_ba_emepvevexb
//  channel    0: 11111(1, 2, 64, 4, 32, 16, 8;   0,   0,   0,  24)
//  channel    1: 11111(1, 2, 64, 4, 32, 16, 8;  23,   0,   0,  24)
//  channel    2: 11111(1, 2, 64, 32, 4, 16, 8;  23,   0,   0,  24)
//  channel    3: 11111(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,  23)
//  channel    4: 11111(1, 2, 64, 32, 16, 4, 8;  23,   0,   0,  23)
//  channel    5: 11111(1, 2, 64, 8, 16, 32, 4;   0,   0,   0,  24)
//  channel    6: 11111(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,  24)
//  channel    7: 11111(1, 2, 64, 16, 8, 32, 4;  23,   0,   0,  24)
//  channel    8: 11111(1, 2, 64, 16, 32, 8, 4;  23,   0,   0,  23)
//  channel    9: 11111(1, 2, 64, 32, 16, 8, 4;  23,   0,   0,  23)
//  channel   10: 2v111(1, 2, 4, 32, 64, 16, 8;  24,   0,   6,  24)
//  channel   11: 2v111(1, 2, 16, 32, 64, 4, 8;  23,   0,   5,   0)
//  channel   12: 2v111(1, 2, 16, 32, 64, 4, 8;  23,   0,   5,  23)
//  channel   13: 2v111(1, 2, 16, 32, 64, 8, 4;  23,   0,   5,   0)
//  channel   14: 2v111(1, 2, 16, 32, 64, 8, 4;  23,   0,   5,  23)
//  channel   15: 3yv11(1, 2, 64, 16, 32, 4, 8;  23,   5,   0,   0)
//  channel   16: 3yv11(1, 2, 64, 16, 32, 4, 8;  23,   5,   0,  23)
//  channel   17: 3yv11(1, 2, 64, 8, 16, 32, 4;  24,   6,   0,  24)
//  channel   18: 3yv11(1, 2, 64, 16, 32, 8, 4;  23,   5,   0,   0)
//  channel   19: 3yv11(1, 2, 64, 16, 32, 8, 4;  23,   5,   0,  23)
//  channel   20: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   5)
//  channel   21: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   5)
//  channel   22: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   5)
//  channel   23: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   5)
//  channel   24: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   5)
//  channel   25: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   5)
//  channel   26: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   5)
//  channel   27: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   5)
//  channel   28: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   5)
//  channel   29: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   5)
//  channel   30: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   5)
//  channel   31: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   5)
//  channel   32: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,  23,  25,   5)
//  channel   33: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   5)
//  channel   34: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   5)
//  channel   35: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  25,   5)
//  channel   36: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   5)
//  channel   37: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   5)
//  channel   38: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   5)
//  channel   39: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   5)
//  channel   40: 5yyyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   5)
//  channel   41: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   5)
//  channel   42: 5yyyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   5)
//  channel   43: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   5)
//  channel   44: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   5)
//  channel   45: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   5)
//  channel   46: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   5)
//  channel   47: 5yyyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   5)
//  channel   48: 5y2vv(1, 2, 64, 4, 8, 16, 32;  23,  23,  25,   5)
//  channel   49: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   5)
//  channel   50: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   5)
//  channel   51: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  25,   5)
//  channel   52: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   5,   0,   5)
//  channel   53: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   5,  23,   5)
//  channel   54: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,   6,  24,   5)
//  channel   55: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   5,  23,   5)
//  channel   56: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   5,  23,   5)
//  channel   57: 12v11(1, 2, 64, 4, 32, 16, 8;  24,   0,   0,  24)
//  channel   58: 12v11(1, 2, 64, 4, 32, 16, 8;  24,  23,   0,  24)
//  channel   59: 12v11(1, 2, 64, 4, 32, 16, 8;  24,  25,   0,  24)
//  channel   60: 12v11(1, 2, 64, 16, 32, 4, 8;  23,  25,   0,  23)
//  channel   61: 12v11(1, 2, 64, 8, 16, 32, 4;  24,   0,   0,  24)
//  channel   62: 12v11(1, 2, 64, 8, 16, 32, 4;  24,  23,   0,  24)
//  channel   63: 12v11(1, 2, 64, 8, 16, 32, 4;  24,  25,   0,  24)
//  channel   64: 12v11(1, 2, 64, 16, 32, 8, 4;  23,  25,   0,  23)
//  channel   65: 13yv1(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,   0)
//  channel   66: 13yv1(1, 2, 64, 4, 16, 32, 8;  23,   0,  23,   0)
//  channel   67: 13yv1(1, 2, 64, 16, 4, 32, 8;  24,   0,   0,   0)
//  channel   68: 13yv1(1, 2, 64, 16, 4, 32, 8;  24,   0,  23,   0)
//  channel   69: 13yv1(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,   0)
//  channel   70: 13yv1(1, 2, 64, 8, 16, 32, 4;  23,   0,  23,   0)
//  channel   71: 13yv1(1, 2, 64, 32, 8, 16, 4;  24,   0,   0,   0)
//  channel   72: 13yv1(1, 2, 64, 32, 8, 16, 4;  24,   0,  23,   0)
//  channel   73: 112v1(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,   0)
//  channel   74: 112v1(1, 2, 64, 4, 16, 32, 8;  23,  23,   0,   0)
//  channel   75: 112v1(1, 2, 64, 16, 4, 32, 8;  24,  23,   0,   0)
//  channel   76: 112v1(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,   0)
//  channel   77: 112v1(1, 2, 64, 8, 16, 32, 4;  23,  23,   0,   0)
//  channel   78: 112v1(1, 2, 64, 32, 8, 16, 4;  24,  23,   0,   0)
//  channel   79: 113yv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   80: 113yv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
//  channel   81: 113yv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
//  channel   82: 113yv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
//  channel   83: 113yv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
//  channel   84: 113yv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
//  channel   85: 113yv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
//  channel   86: 113yv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
//  channel   87: 1112v(1, 2, 64, 4, 32, 8, 16;  24,   0,  24,   0)
//  channel   88: 1112v(1, 2, 64, 4, 32, 8, 16;  24,  23,  24,   0)
//  channel   89: 1112v(1, 2, 64, 32, 4, 8, 16;  24,  23,  24,   0)
//  channel   90: 1112v(1, 2, 64, 8, 16, 4, 32;  24,   0,  24,   0)
//  channel   91: 1112v(1, 2, 64, 8, 16, 4, 32;  24,  23,  24,   0)
//  channel   92: 1112v(1, 2, 64, 16, 8, 4, 32;  24,  23,  24,   0)
//  channel   93: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   5,   5)
//  channel   94: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   5,   5)
//  channel   95: 2v2v1(1, 2, 4, 32, 8, 16, 64;  24,  24,   5,   6)
//  channel   96: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   5,   5)
//  channel   97: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   5,   5)
//  channel   98: 2v3yv(1, 2, 4, 8, 64, 16, 32;  23,   5,   0,   5)
//  channel   99: 2v3yv(1, 2, 4, 8, 64, 16, 32;  23,   5,  23,   5)
//  channel  100: 2v3yv(1, 2, 4, 32, 64, 8, 16;  24,   6,  24,   6)
//  channel  101: 2v3yv(1, 2, 16, 32, 64, 4, 8;   0,   5,  23,   5)
//  channel  102: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   5,  23,   5)
//  channel  103: 2v12v(1, 2, 4, 32, 64, 8, 16;  24,  24,   6,  24)
//  channel  104: 3yv2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   6,  24)
//  channel  105: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,  24)
//  channel  106: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,  24)
//  channel  107: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,  25,  24)
//  channel  108: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   0,  24)
//  channel  109: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,  23,  24)
//  channel  110: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,  25,  24)
