#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_050_dxa_emepvevexdx(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_050_dxa_emepvevexdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(34);
  needed_v_smin[x_a].resize(34);
  needed_v_smin[x_a][  0] = {  10,   11,   13,   14,   16,   17,   18,   19,   20,   21,   27,   28,   34,   35,   41,   42,   48,   49,   50,   51,   57,   58,   61,   62,   65,   66,   68,   69,   71,   72,   75,   76,   85,   86,   87,   88,   90,   91,   92,   93,    0,    1,    5,    6}; //  44
  needed_v_smin[x_a][  1] = {  12,   22,   23,   24,   32,   33,   36,   37,   38,   46,   47,   52,   55,   56,   63,   64,   70,   73,   74,   79,   80,   81,   89,   94,   95,   96,   97,   98,   99,  100,    9,   82,   83,   84}; //  34
  needed_v_smin[x_a][  2] = {  15,   29,   30,   31,   32,   33,   43,   44,   45,   46,   47,   52,   53,   54,   59,   60,   67,   77,   78,   82,   83,   84,   89,   94,   95,   96,   97,   98,   99,  100,    3,   79,   80,   81}; //  34
  needed_v_smin[x_a][  3] = {  15,   52,   94,   96,   95}; //   5
  needed_v_smin[x_a][  4] = {  16,   17,   18,   19,   48,   49,   90,   91}; //   8
  needed_v_smin[x_a][  5] = {  20,   21,   34,   35,   61,   62,   71,   72,    5,    6,   68,   69}; //  12
  needed_v_smin[x_a][  6] = {  20,   21,   22,   23,   34,   35,   36,   37,    5,    6,    7,    8,    9,   55,   56,   61,   62,   63,   64,   68,   69,   70,   71,   72,   73,   74}; //  26
  needed_v_smin[x_a][  7] = {  22,   23,   36,   37,   63,   64,   73,   74,    9,   55,   56,   70}; //  12
  needed_v_smin[x_a][  8] = {  24,   38}; //   2
  needed_v_smin[x_a][  9] = {  24,   26,   38,   40}; //   4
  needed_v_smin[x_a][ 10] = {  25,   26,   39,   40,   48,   49,   50,   51,   85,   86,   87,   88,   90,   91,   92,   93}; //  16
  needed_v_smin[x_a][ 11] = {  25,   39}; //   2
  needed_v_smin[x_a][ 12] = {  25,   31,   39,   45}; //   4
  needed_v_smin[x_a][ 13] = {  26,   40}; //   2
  needed_v_smin[x_a][ 14] = {  27,   28,   41,   42,   57,   58,   75,   76,    0,    1,   65,   66}; //  12
  needed_v_smin[x_a][ 15] = {  27,   28,   29,   30,   41,   42,   43,   44,    0,    1,    2,    3,    4,   53,   54,   57,   58,   59,   60,   65,   66,   67,   75,   76,   77,   78}; //  26
  needed_v_smin[x_a][ 16] = {  29,   30,   43,   44,   59,   60,   77,   78,    3,   53,   54,   67}; //  12
  needed_v_smin[x_a][ 17] = {  31,   45}; //   2
  needed_v_smin[x_a][ 18] = {  32,   33,   46,   47,   79,   80,   81,   82,   83,   84,   89,   97,   98,   99,  100}; //  15
  needed_v_smin[x_a][ 19] = {  50,   51,   92,   93}; //   4
  needed_v_smin[x_a][ 20] = {   2,    4}; //   2
  needed_v_smin[x_a][ 21] = {   2,    4}; //   2
  needed_v_smin[x_a][ 22] = {   7,    8}; //   2
  needed_v_smin[x_a][ 23] = {   7,    8}; //   2
  needed_v_smin[x_a][ 24] = {  10,   11}; //   2
  needed_v_smin[x_a][ 25] = {  10,   11}; //   2
  needed_v_smin[x_a][ 26] = {  12}; //   1
  needed_v_smin[x_a][ 27] = {  12}; //   1
  needed_v_smin[x_a][ 28] = {  13,   14}; //   2
  needed_v_smin[x_a][ 29] = {  13,   14}; //   2
  needed_v_smin[x_a][ 30] = {  15}; //   1
  needed_v_smin[x_a][ 31] = {  16,   17}; //   2
  needed_v_smin[x_a][ 32] = {  18,   19}; //   2
  needed_v_smin[x_a][ 33] = {  85,   86,   87,   88}; //   4

  v_smax[x_a].resize(27);
  needed_v_smax[x_a].resize(27);
  needed_v_smax[x_a][  0] = {  10,   11,   13,   14,   16,   17,   18,   19,   20,   21,   27,   28,   34,   35,   41,   42,   48,   49,   57,   58,   61,   62,   65,   66,   68,   69,   71,   72,   75,   76,   85,   86,   90,   91,    0,    1,    5,    6}; //  38
  needed_v_smax[x_a][  1] = {  12,   22,   23,   24,   32,   33,   36,   37,   38,   46,   47,   55,   56,   63,   64,   70,   73,   74,   79,   80,   81,   96,   97,   98,    9}; //  25
  needed_v_smax[x_a][  2] = {  15,   29,   30,   31,   43,   44,   45,   52,   53,   54,   59,   60,   67,   77,   78,   82,   83,   84,   89,   94,   95,   99,  100,    3}; //  24
  needed_v_smax[x_a][  3] = {  15,   52,   94}; //   3
  needed_v_smax[x_a][  4] = {  16,   17,   18,   19,   48,   49,   90,   91}; //   8
  needed_v_smax[x_a][  5] = {  20,   21,   22,   23,   34,   35,   36,   37,   61,   62,   63,   64,   71,   72,   73,   74,    5,    6,    7,    8,    9,   55,   56,   68,   69,   70}; //  26
  needed_v_smax[x_a][  6] = {  20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   97,   98,   99,  100}; //  79
  needed_v_smax[x_a][  7] = {  24,   26,   38,   40}; //   4
  needed_v_smax[x_a][  8] = {  25,   26,   39,   40,   50,   51,   87,   88,   92,   93}; //  10
  needed_v_smax[x_a][  9] = {  25,   31,   39,   45}; //   4
  needed_v_smax[x_a][ 10] = {  27,   28,   29,   30,   41,   42,   43,   44,   57,   58,   59,   60,   75,   76,   77,   78,    0,    1,    2,    3,    4,   53,   54,   65,   66,   67}; //  26
  needed_v_smax[x_a][ 11] = {  32,   33,   46,   47,   96,   97,   98,   79,   80,   81}; //  10
  needed_v_smax[x_a][ 12] = {  48,   49,   90,   91}; //   4
  needed_v_smax[x_a][ 13] = {  50,   51,   92,   93}; //   4
  needed_v_smax[x_a][ 14] = {  50,   51,   92,   93}; //   4
  needed_v_smax[x_a][ 15] = {  52,   94}; //   2
  needed_v_smax[x_a][ 16] = {  85,   86}; //   2
  needed_v_smax[x_a][ 17] = {  87,   88}; //   2
  needed_v_smax[x_a][ 18] = {  89,   95,   99,  100,   82,   83,   84}; //   7
  needed_v_smax[x_a][ 19] = {  96,   95}; //   2
  needed_v_smax[x_a][ 20] = {   2,    4}; //   2
  needed_v_smax[x_a][ 21] = {   7,    8}; //   2
  needed_v_smax[x_a][ 22] = {  10,   11}; //   2
  needed_v_smax[x_a][ 23] = {  10,   11,   15,   16,   17}; //   5
  needed_v_smax[x_a][ 24] = {  12}; //   1
  needed_v_smax[x_a][ 25] = {  12,   13,   14,   18,   19}; //   5
  needed_v_smax[x_a][ 26] = {  13,   14}; //   2

  g_p[x_a].resize(34);
  needed_g_p[x_a].resize(34);
  needed_g_p[x_a][0] = {  10,   11,   13,   14,   16,   17,   18,   19,   20,   21,   27,   28,   34,   35,   41,   42,   48,   49,   57,   58,   61,   62,   65,   66,   68,   69,   71,   72,   75,   76,   85,   86,   90,   91}; //  34
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {  12,   22,   23,   24,   32,   33,   36,   37,   38,   46,   47,   55,   56,   63,   64,   70,   73,   74,   79,   80,   81,   96,   97,   98}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][2] = {  15,   29,   30,   31,   43,   44,   45,   52,   53,   54,   59,   60,   67,   77,   78,   82,   83,   84,   89,   94,   95,   99,  100}; //  23
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {  15,   52,   94}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  16,   17,   18,   19,   48,   49,   90,   91}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {  20,   21,   34,   35,   61,   62,   71,   72}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {  20,   22,   34,   36}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][7] = {  21,   23,   35,   37}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax6");
  needed_g_p[x_a][8] = {  22,   23,   36,   37,   63,   64,   73,   74}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][9] = {  24,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {  24,   26,   38,   40}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax6");
  needed_g_p[x_a][11] = {  25,   26,   39,   40,   51,   88,   93}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax8");
  needed_g_p[x_a][12] = {  25,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][13] = {  25,   31,   39,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax6");
  needed_g_p[x_a][14] = {  26,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax7");
  needed_g_p[x_a][15] = {  27,   28,   41,   42,   57,   58,   75,   76}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax10");
  needed_g_p[x_a][16] = {  27,   29,   41,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax6");
  needed_g_p[x_a][17] = {  28,   30,   42,   44}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin15_smax6");
  needed_g_p[x_a][18] = {  29,   30,   43,   44,   59,   60,   77,   78}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax10");
  needed_g_p[x_a][19] = {  31,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax9");
  needed_g_p[x_a][20] = {  32,   33,   46,   47,   96,   97,   98}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax11");
  needed_g_p[x_a][21] = {  32,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax6");
  needed_g_p[x_a][22] = {  33,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin18_smax6");
  needed_g_p[x_a][23] = {  48,   90}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax12");
  needed_g_p[x_a][24] = {  49,   91}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax12");
  needed_g_p[x_a][25] = {  50,   87,   92}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][26] = {  50,   51,   92,   93}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax13");
  needed_g_p[x_a][27] = {  50,   51,   92,   93}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax14");
  needed_g_p[x_a][28] = {  52,   94}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax15");
  needed_g_p[x_a][29] = {  85}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax16");
  needed_g_p[x_a][30] = {  86}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax16");
  needed_g_p[x_a][31] = {  87,   88}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax17");
  needed_g_p[x_a][32] = {  89,   95,   99,  100}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax18");
  needed_g_p[x_a][33] = {  96}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax19");

  g_f[x_a].resize(27);
  needed_g_f[x_a].resize(27);
  needed_g_f[x_a][0] = {   0,    1,    5,    6}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][1] = {   0,    1,   65,   66}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax10");
  needed_g_f[x_a][2] = {   0,    1,    2,    3,    4,   53,   54,   57,   58,   59,   60,   65,   66,   67,   75,   76,   77,   78}; //  18
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax6");
  needed_g_f[x_a][3] = {   2,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax20");
  needed_g_f[x_a][4] = {   2,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax10");
  needed_g_f[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][6] = {   3,   53,   54,   67}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax10");
  needed_g_f[x_a][7] = {   5,    6,   68,   69}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][8] = {   5,    6,    7,    8,    9,   55,   56,   61,   62,   63,   64,   68,   69,   70,   71,   72,   73,   74}; //  18
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax6");
  needed_g_f[x_a][9] = {   7,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax21");
  needed_g_f[x_a][10] = {   7,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax5");
  needed_g_f[x_a][11] = {   9}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][12] = {   9,   55,   56,   70}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][13] = {  10,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax22");
  needed_g_f[x_a][14] = {  10,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax23");
  needed_g_f[x_a][15] = {  12}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax24");
  needed_g_f[x_a][16] = {  12}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax25");
  needed_g_f[x_a][17] = {  13,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax26");
  needed_g_f[x_a][18] = {  13,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax25");
  needed_g_f[x_a][19] = {  15}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax23");
  needed_g_f[x_a][20] = {  16,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax23");
  needed_g_f[x_a][21] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax25");
  needed_g_f[x_a][22] = {  79,   80,   81}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax11");
  needed_g_f[x_a][23] = {  79,   80,   81,   82,   83,   84,   89,   97,   98,   99,  100}; //  11
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax6");
  needed_g_f[x_a][24] = {  82,   83,   84}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax18");
  needed_g_f[x_a][25] = {  85,   86,   87,   88}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin33_smax6");
  needed_g_f[x_a][26] = {  95}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax19");

  g_t[x_a].resize(52);
  needed_g_t[x_a].resize(52);
  needed_g_t[x_a][0] = {   0,    5,   53,   55,   57,   59,   61,   63,   65,   68,   71,   73,   75,   77,   79,   82,   97,   99}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,   53,   54,   57,   58,   59,   60,   65,   66,   67}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__8_52");
  needed_g_t[x_a][2] = {   0,    1,   65,   66}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__4_48");
  needed_g_t[x_a][3] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_69__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_69__16_32");
  needed_g_t[x_a][4] = {   1,    2,    3,    4,    6,    7,    8,    9,   54,   56,   58,   60,   62,   64,   66,   67,   69,   70,   72,   74,   76,   78,   80,   81,   83,   84,   98,  100}; //  28
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__1_2__64_60");
  needed_g_t[x_a][5] = {   2,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__32_20");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_97__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_97__16_4");
  needed_g_t[x_a][7] = {   3,   67}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__16_36");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_81__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_81__4_32");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_97__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_97__4_16");
  needed_g_t[x_a][10] = {   5,    6,    7,    8,    9,   55,   56,   61,   62,   63,   64,   68,   69,   70}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__4_56");
  needed_g_t[x_a][11] = {   5,    6,   68,   69}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__8_48");
  needed_g_t[x_a][12] = {   5,    6}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_73__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_73__32_16");
  needed_g_t[x_a][13] = {   7,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__16_40");
  needed_g_t[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_81__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_81__32_8");
  needed_g_t[x_a][15] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_81__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_81__8_32");
  needed_g_t[x_a][16] = {   9,   70}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__32_24");
  needed_g_t[x_a][17] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_97__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_97__8_16");
  needed_g_t[x_a][18] = {  10,   11,   15,   16,   17}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][19] = {  10,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_68");
  needed_g_t[x_a][20] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_49__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_49__4_64");
  needed_g_t[x_a][21] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_49__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_49__4_64");
  needed_g_t[x_a][22] = {  12,   13,   14,   18,   19}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][23] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__24_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__24_96");
  needed_g_t[x_a][24] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_25__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_25__32_64");
  needed_g_t[x_a][25] = {  13,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_72");
  needed_g_t[x_a][26] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_49__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_49__8_64");
  needed_g_t[x_a][27] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_49__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_49__8_64");
  needed_g_t[x_a][28] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__10_1__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__10_1__16_100");
  needed_g_t[x_a][29] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__4_112");
  needed_g_t[x_a][30] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__10_1__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__10_1__4_112");
  needed_g_t[x_a][31] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__8_112");
  needed_g_t[x_a][32] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__6_1__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__6_1__8_112");
  needed_g_t[x_a][33] = {  20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   85,   86,   87,   88,   89}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][34] = {  53,   54}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_65__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_65__16_36");
  needed_g_t[x_a][35] = {  55,   56}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_65__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_65__32_24");
  needed_g_t[x_a][36] = {  71,   72,   73,   74}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__4_56");
  needed_g_t[x_a][37] = {  75,   76,   77,   78}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__8_52");
  needed_g_t[x_a][38] = {  79,   80,   81,   97,   98}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_65__24_36");
  needed_g_t[x_a][39] = {  79,   80}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__4_32");
  needed_g_t[x_a][40] = {  81}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__32_4");
  needed_g_t[x_a][41] = {  82,   83,   84,   99,  100}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_65__36_24");
  needed_g_t[x_a][42] = {  82,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__8_16");
  needed_g_t[x_a][43] = {  84}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__16_8");
  needed_g_t[x_a][44] = {  85,   86}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][45] = {  87,   88}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][46] = {  89}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__24_36");
  needed_g_t[x_a][47] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][48] = {  92,   93}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][49] = {  94,   95}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_100");
  needed_g_t[x_a][50] = {  95}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_25__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_25__36_64");
  needed_g_t[x_a][51] = {  96}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__24_100");

  g_d[x_a].resize(24);
  needed_g_d[x_a].resize(24);
  needed_g_d[x_a][0] = {  10,   11,   13,   14,   16,   17,   18,   19,   20,   21,   27,   28,   34,   35,   41,   42,   48,   49,   50,   51,   57,   58,   61,   62,   65,   66,   68,   69,   71,   72,   75,   76,   85,   86,   87,   88,   90,   91,   92,   93}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][1] = {  12,   22,   23,   24,   32,   33,   36,   37,   38,   46,   47,   52,   55,   56,   63,   64,   70,   73,   74,   79,   80,   81,   89,   94,   95,   96,   97,   98,   99,  100}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][2] = {  15,   52,   94,   96}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][3] = {  15,   29,   30,   31,   32,   33,   43,   44,   45,   46,   47,   52,   53,   54,   59,   60,   67,   77,   78,   82,   83,   84,   89,   94,   95,   96,   97,   98,   99,  100}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][4] = {  16,   17,   18,   19,   48,   49,   90,   91}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][5] = {  20,   21,   22,   23,   34,   35,   36,   37}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][6] = {  20,   21,   34,   35,   61,   62,   71,   72}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][7] = {  22,   23,   36,   37,   63,   64,   73,   74}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][8] = {  24,   26,   38,   40}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {  24,   38}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][10] = {  25,   31,   39,   45}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][11] = {  25,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][12] = {  25,   26,   39,   40,   48,   49,   50,   51,   85,   86,   87,   88,   90,   91,   92,   93}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][13] = {  26,   40}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][14] = {  27,   28,   29,   30,   41,   42,   43,   44}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][15] = {  27,   28,   41,   42,   57,   58,   75,   76}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][16] = {  29,   30,   43,   44,   59,   60,   77,   78}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][17] = {  31,   45}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][18] = {  32,   33,   46,   47}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][19] = {  34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  14
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][20] = {  48,   49}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][21] = {  50,   51}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][22] = {  50,   51,   92,   93}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][23] = {  52}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");

  c_p[x_a].resize(101);
  c_f[x_a].resize(101);
  c_t[x_a].resize(101);
  c_d[x_a].resize(101);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1,   2}; //   3
  c_t[x_a][1] = {  4,   1,   2,   3}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  3,   4,   2}; //   3
  c_t[x_a][2] = {  4,   1,   5,   6}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  5,   6,   2}; //   3
  c_t[x_a][3] = {  4,   1,   7,   8}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  3,   4,   2}; //   3
  c_t[x_a][4] = {  4,   1,   5,   9}; //   4
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  0,   7,   8}; //   3
  c_t[x_a][5] = {  0,  10,  11,  12}; //   4
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  0,   7,   8}; //   3
  c_t[x_a][6] = {  4,  10,  11,  12}; //   4
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  9,  10,   8}; //   3
  c_t[x_a][7] = {  4,  10,  13,  14}; //   4
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  9,  10,   8}; //   3
  c_t[x_a][8] = {  4,  10,  13,  15}; //   4
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = { 11,  12,   8}; //   3
  c_t[x_a][9] = {  4,  10,  16,  17}; //   4
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = { 13,  14}; //   2
  c_t[x_a][10] = { 18,  19,  20}; //   3
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  0}; //   1
  c_f[x_a][11] = { 13,  14}; //   2
  c_t[x_a][11] = { 18,  19,  21}; //   3
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  1}; //   1
  c_f[x_a][12] = { 15,  16}; //   2
  c_t[x_a][12] = { 22,  23,  24}; //   3
  c_d[x_a][12] = {  1}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = { 17,  18}; //   2
  c_t[x_a][13] = { 22,  25,  26}; //   3
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  0}; //   1
  c_f[x_a][14] = { 17,  18}; //   2
  c_t[x_a][14] = { 22,  25,  27}; //   3
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  2,   3}; //   2
  c_f[x_a][15] = { 19}; //   1
  c_t[x_a][15] = { 18,  28}; //   2
  c_d[x_a][15] = {  2,   3}; //   2

  c_p[x_a][16] = {  0,   4}; //   2
  c_f[x_a][16] = { 20}; //   1
  c_t[x_a][16] = { 18,  29}; //   2
  c_d[x_a][16] = {  4,   0}; //   2

  c_p[x_a][17] = {  0,   4}; //   2
  c_f[x_a][17] = { 20}; //   1
  c_t[x_a][17] = { 18,  30}; //   2
  c_d[x_a][17] = {  4,   0}; //   2

  c_p[x_a][18] = {  0,   4}; //   2
  c_f[x_a][18] = { 21}; //   1
  c_t[x_a][18] = { 22,  31}; //   2
  c_d[x_a][18] = {  4,   0}; //   2

  c_p[x_a][19] = {  0,   4}; //   2
  c_f[x_a][19] = { 21}; //   1
  c_t[x_a][19] = { 22,  32}; //   2
  c_d[x_a][19] = {  4,   0}; //   2

  c_p[x_a][20] = {  0,   5,   6}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = { 33}; //   1
  c_d[x_a][20] = {  5,   6,   0}; //   3

  c_p[x_a][21] = {  0,   5,   7}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 33}; //   1
  c_d[x_a][21] = {  5,   6,   0}; //   3

  c_p[x_a][22] = {  1,   8,   6}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 33}; //   1
  c_d[x_a][22] = {  5,   7,   1}; //   3

  c_p[x_a][23] = {  1,   8,   7}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 33}; //   1
  c_d[x_a][23] = {  5,   7,   1}; //   3

  c_p[x_a][24] = {  1,   9,  10}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = { 33}; //   1
  c_d[x_a][24] = {  8,   9,   1}; //   3

  c_p[x_a][25] = { 11,  12,  13}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = { 33}; //   1
  c_d[x_a][25] = { 10,  11,  12}; //   3

  c_p[x_a][26] = { 11,  14,  10}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = { 33}; //   1
  c_d[x_a][26] = {  8,  13,  12}; //   3

  c_p[x_a][27] = {  0,  15,  16}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 33}; //   1
  c_d[x_a][27] = { 14,  15,   0}; //   3

  c_p[x_a][28] = {  0,  15,  17}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 33}; //   1
  c_d[x_a][28] = { 14,  15,   0}; //   3

  c_p[x_a][29] = {  2,  18,  16}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = { 33}; //   1
  c_d[x_a][29] = { 14,  16,   3}; //   3

  c_p[x_a][30] = {  2,  18,  17}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = { 33}; //   1
  c_d[x_a][30] = { 14,  16,   3}; //   3

  c_p[x_a][31] = {  2,  19,  13}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = { 33}; //   1
  c_d[x_a][31] = { 10,  17,   3}; //   3

  c_p[x_a][32] = {  1,  20,  21}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = { 33}; //   1
  c_d[x_a][32] = { 18,   3,   1}; //   3

  c_p[x_a][33] = {  1,  20,  22}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = { 33}; //   1
  c_d[x_a][33] = { 18,   3,   1}; //   3

  c_p[x_a][34] = {  0,   5,   6}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 19,   5,   6,   0}; //   4

  c_p[x_a][35] = {  0,   5,   7}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 19,   5,   6,   0}; //   4

  c_p[x_a][36] = {  1,   8,   6}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 19,   5,   7,   1}; //   4

  c_p[x_a][37] = {  1,   8,   7}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 19,   5,   7,   1}; //   4

  c_p[x_a][38] = {  1,   9,  10}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 19,   8,   9,   1}; //   4

  c_p[x_a][39] = { 11,  12,  13}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 19,  10,  11,  12}; //   4

  c_p[x_a][40] = { 11,  14,  10}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 19,   8,  13,  12}; //   4

  c_p[x_a][41] = {  0,  15,  16}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 19,  14,  15,   0}; //   4

  c_p[x_a][42] = {  0,  15,  17}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 19,  14,  15,   0}; //   4

  c_p[x_a][43] = {  2,  18,  16}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = { 19,  14,  16,   3}; //   4

  c_p[x_a][44] = {  2,  18,  17}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = { 19,  14,  16,   3}; //   4

  c_p[x_a][45] = {  2,  19,  13}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = { 19,  10,  17,   3}; //   4

  c_p[x_a][46] = {  1,  20,  21}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = { 19,  18,   3,   1}; //   4

  c_p[x_a][47] = {  1,  20,  22}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {}; //   0
  c_d[x_a][47] = { 19,  18,   3,   1}; //   4

  c_p[x_a][48] = {  0,   4,  23}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {}; //   0
  c_d[x_a][48] = { 20,  12,   4,   0}; //   4

  c_p[x_a][49] = {  0,   4,  24}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {}; //   0
  c_d[x_a][49] = { 20,  12,   4,   0}; //   4

  c_p[x_a][50] = { 25,  26,  27}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {}; //   0
  c_d[x_a][50] = { 21,   0,  22,  12}; //   4

  c_p[x_a][51] = { 11,  26,  27}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {}; //   0
  c_d[x_a][51] = { 21,   0,  22,  12}; //   4

  c_p[x_a][52] = {  2,   3,  28}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {}; //   0
  c_d[x_a][52] = { 23,   1,   2,   3}; //   4

  c_p[x_a][53] = {  2}; //   1
  c_f[x_a][53] = {  6,   2}; //   2
  c_t[x_a][53] = {  0,   1,  34}; //   3
  c_d[x_a][53] = {  3}; //   1

  c_p[x_a][54] = {  2}; //   1
  c_f[x_a][54] = {  6,   2}; //   2
  c_t[x_a][54] = {  4,   1,  34}; //   3
  c_d[x_a][54] = {  3}; //   1

  c_p[x_a][55] = {  1}; //   1
  c_f[x_a][55] = { 12,   8}; //   2
  c_t[x_a][55] = {  0,  10,  35}; //   3
  c_d[x_a][55] = {  1}; //   1

  c_p[x_a][56] = {  1}; //   1
  c_f[x_a][56] = { 12,   8}; //   2
  c_t[x_a][56] = {  4,  10,  35}; //   3
  c_d[x_a][56] = {  1}; //   1

  c_p[x_a][57] = {  0,  15}; //   2
  c_f[x_a][57] = {  2}; //   1
  c_t[x_a][57] = {  0,   1}; //   2
  c_d[x_a][57] = { 15,   0}; //   2

  c_p[x_a][58] = {  0,  15}; //   2
  c_f[x_a][58] = {  2}; //   1
  c_t[x_a][58] = {  4,   1}; //   2
  c_d[x_a][58] = { 15,   0}; //   2

  c_p[x_a][59] = {  2,  18}; //   2
  c_f[x_a][59] = {  2}; //   1
  c_t[x_a][59] = {  0,   1}; //   2
  c_d[x_a][59] = { 16,   3}; //   2

  c_p[x_a][60] = {  2,  18}; //   2
  c_f[x_a][60] = {  2}; //   1
  c_t[x_a][60] = {  4,   1}; //   2
  c_d[x_a][60] = { 16,   3}; //   2

  c_p[x_a][61] = {  0,   5}; //   2
  c_f[x_a][61] = {  8}; //   1
  c_t[x_a][61] = {  0,  10}; //   2
  c_d[x_a][61] = {  6,   0}; //   2

  c_p[x_a][62] = {  0,   5}; //   2
  c_f[x_a][62] = {  8}; //   1
  c_t[x_a][62] = {  4,  10}; //   2
  c_d[x_a][62] = {  6,   0}; //   2

  c_p[x_a][63] = {  1,   8}; //   2
  c_f[x_a][63] = {  8}; //   1
  c_t[x_a][63] = {  0,  10}; //   2
  c_d[x_a][63] = {  7,   1}; //   2

  c_p[x_a][64] = {  1,   8}; //   2
  c_f[x_a][64] = {  8}; //   1
  c_t[x_a][64] = {  4,  10}; //   2
  c_d[x_a][64] = {  7,   1}; //   2

  c_p[x_a][65] = {  0}; //   1
  c_f[x_a][65] = {  1,   2}; //   2
  c_t[x_a][65] = {  0,   1,   2}; //   3
  c_d[x_a][65] = {  0}; //   1

  c_p[x_a][66] = {  0}; //   1
  c_f[x_a][66] = {  1,   2}; //   2
  c_t[x_a][66] = {  4,   1,   2}; //   3
  c_d[x_a][66] = {  0}; //   1

  c_p[x_a][67] = {  2}; //   1
  c_f[x_a][67] = {  6,   2}; //   2
  c_t[x_a][67] = {  4,   1,   7}; //   3
  c_d[x_a][67] = {  3}; //   1

  c_p[x_a][68] = {  0}; //   1
  c_f[x_a][68] = {  7,   8}; //   2
  c_t[x_a][68] = {  0,  10,  11}; //   3
  c_d[x_a][68] = {  0}; //   1

  c_p[x_a][69] = {  0}; //   1
  c_f[x_a][69] = {  7,   8}; //   2
  c_t[x_a][69] = {  4,  10,  11}; //   3
  c_d[x_a][69] = {  0}; //   1

  c_p[x_a][70] = {  1}; //   1
  c_f[x_a][70] = { 12,   8}; //   2
  c_t[x_a][70] = {  4,  10,  16}; //   3
  c_d[x_a][70] = {  1}; //   1

  c_p[x_a][71] = {  0,   5}; //   2
  c_f[x_a][71] = {  8}; //   1
  c_t[x_a][71] = {  0,  36}; //   2
  c_d[x_a][71] = {  6,   0}; //   2

  c_p[x_a][72] = {  0,   5}; //   2
  c_f[x_a][72] = {  8}; //   1
  c_t[x_a][72] = {  4,  36}; //   2
  c_d[x_a][72] = {  6,   0}; //   2

  c_p[x_a][73] = {  1,   8}; //   2
  c_f[x_a][73] = {  8}; //   1
  c_t[x_a][73] = {  0,  36}; //   2
  c_d[x_a][73] = {  7,   1}; //   2

  c_p[x_a][74] = {  1,   8}; //   2
  c_f[x_a][74] = {  8}; //   1
  c_t[x_a][74] = {  4,  36}; //   2
  c_d[x_a][74] = {  7,   1}; //   2

  c_p[x_a][75] = {  0,  15}; //   2
  c_f[x_a][75] = {  2}; //   1
  c_t[x_a][75] = {  0,  37}; //   2
  c_d[x_a][75] = { 15,   0}; //   2

  c_p[x_a][76] = {  0,  15}; //   2
  c_f[x_a][76] = {  2}; //   1
  c_t[x_a][76] = {  4,  37}; //   2
  c_d[x_a][76] = { 15,   0}; //   2

  c_p[x_a][77] = {  2,  18}; //   2
  c_f[x_a][77] = {  2}; //   1
  c_t[x_a][77] = {  0,  37}; //   2
  c_d[x_a][77] = { 16,   3}; //   2

  c_p[x_a][78] = {  2,  18}; //   2
  c_f[x_a][78] = {  2}; //   1
  c_t[x_a][78] = {  4,  37}; //   2
  c_d[x_a][78] = { 16,   3}; //   2

  c_p[x_a][79] = {  1}; //   1
  c_f[x_a][79] = { 22,  23}; //   2
  c_t[x_a][79] = {  0,  38,  39}; //   3
  c_d[x_a][79] = {  1}; //   1

  c_p[x_a][80] = {  1}; //   1
  c_f[x_a][80] = { 22,  23}; //   2
  c_t[x_a][80] = {  4,  38,  39}; //   3
  c_d[x_a][80] = {  1}; //   1

  c_p[x_a][81] = {  1}; //   1
  c_f[x_a][81] = { 22,  23}; //   2
  c_t[x_a][81] = {  4,  38,  40}; //   3
  c_d[x_a][81] = {  1}; //   1

  c_p[x_a][82] = {  2}; //   1
  c_f[x_a][82] = { 24,  23}; //   2
  c_t[x_a][82] = {  0,  41,  42}; //   3
  c_d[x_a][82] = {  3}; //   1

  c_p[x_a][83] = {  2}; //   1
  c_f[x_a][83] = { 24,  23}; //   2
  c_t[x_a][83] = {  4,  41,  42}; //   3
  c_d[x_a][83] = {  3}; //   1

  c_p[x_a][84] = {  2}; //   1
  c_f[x_a][84] = { 24,  23}; //   2
  c_t[x_a][84] = {  4,  41,  43}; //   3
  c_d[x_a][84] = {  3}; //   1

  c_p[x_a][85] = {  0,  29}; //   2
  c_f[x_a][85] = { 25}; //   1
  c_t[x_a][85] = { 33,  44}; //   2
  c_d[x_a][85] = { 12,   0}; //   2

  c_p[x_a][86] = {  0,  30}; //   2
  c_f[x_a][86] = { 25}; //   1
  c_t[x_a][86] = { 33,  44}; //   2
  c_d[x_a][86] = { 12,   0}; //   2

  c_p[x_a][87] = { 25,  31}; //   2
  c_f[x_a][87] = { 25}; //   1
  c_t[x_a][87] = { 33,  45}; //   2
  c_d[x_a][87] = {  0,  12}; //   2

  c_p[x_a][88] = { 11,  31}; //   2
  c_f[x_a][88] = { 25}; //   1
  c_t[x_a][88] = { 33,  45}; //   2
  c_d[x_a][88] = {  0,  12}; //   2

  c_p[x_a][89] = {  2,  32}; //   2
  c_f[x_a][89] = { 23}; //   1
  c_t[x_a][89] = { 33,  46}; //   2
  c_d[x_a][89] = {  1,   3}; //   2

  c_p[x_a][90] = {  0,   4,  23}; //   3
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = { 47}; //   1
  c_d[x_a][90] = { 12,   4,   0}; //   3

  c_p[x_a][91] = {  0,   4,  24}; //   3
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = { 47}; //   1
  c_d[x_a][91] = { 12,   4,   0}; //   3

  c_p[x_a][92] = { 25,  26,  27}; //   3
  c_f[x_a][92] = {}; //   0
  c_t[x_a][92] = { 48}; //   1
  c_d[x_a][92] = {  0,  22,  12}; //   3

  c_p[x_a][93] = { 11,  26,  27}; //   3
  c_f[x_a][93] = {}; //   0
  c_t[x_a][93] = { 48}; //   1
  c_d[x_a][93] = {  0,  22,  12}; //   3

  c_p[x_a][94] = {  2,   3,  28}; //   3
  c_f[x_a][94] = {}; //   0
  c_t[x_a][94] = { 49}; //   1
  c_d[x_a][94] = {  1,   2,   3}; //   3

  c_p[x_a][95] = {  2,  32}; //   2
  c_f[x_a][95] = { 26}; //   1
  c_t[x_a][95] = { 49,  50}; //   2
  c_d[x_a][95] = {  1,   3}; //   2

  c_p[x_a][96] = {  1,  20,  33}; //   3
  c_f[x_a][96] = {}; //   0
  c_t[x_a][96] = { 51}; //   1
  c_d[x_a][96] = {  2,   3,   1}; //   3

  c_p[x_a][97] = {  1,  20}; //   2
  c_f[x_a][97] = { 23}; //   1
  c_t[x_a][97] = {  0,  38}; //   2
  c_d[x_a][97] = {  3,   1}; //   2

  c_p[x_a][98] = {  1,  20}; //   2
  c_f[x_a][98] = { 23}; //   1
  c_t[x_a][98] = {  4,  38}; //   2
  c_d[x_a][98] = {  3,   1}; //   2

  c_p[x_a][99] = {  2,  32}; //   2
  c_f[x_a][99] = { 23}; //   1
  c_t[x_a][99] = {  0,  41}; //   2
  c_d[x_a][99] = {  1,   3}; //   2

  c_p[x_a][100] = {  2,  32}; //   2
  c_f[x_a][100] = { 23}; //   1
  c_t[x_a][100] = {  4,  41}; //   2
  c_d[x_a][100] = {  1,   3}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_050_dxa_emepvevexdx
//  channel    0: 11111(1, 2, 64, 4, 32, 16, 8;   0,   0,   0,  24)
//  channel    1: 11111(1, 2, 64, 4, 32, 16, 8;  23,   0,   0,  24)
//  channel    2: 11111(1, 2, 64, 32, 4, 16, 8;  23,   0,   0,  24)
//  channel    3: 11111(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,  23)
//  channel    4: 11111(1, 2, 64, 32, 16, 4, 8;  23,   0,   0,  23)
//  channel    5: 11111(1, 2, 64, 8, 16, 32, 4;   0,   0,   0,  24)
//  channel    6: 11111(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,  24)
//  channel    7: 11111(1, 2, 64, 16, 8, 32, 4;  23,   0,   0,  24)
//  channel    8: 11111(1, 2, 64, 16, 32, 8, 4;  23,   0,   0,  23)
//  channel    9: 11111(1, 2, 64, 32, 16, 8, 4;  23,   0,   0,  23)
//  channel   10: 2v111(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   11: 2v111(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,  23)
//  channel   12: 2v111(1, 2, 8, 16, 64, 32, 4;  24,   0,   0,  24)
//  channel   13: 2v111(1, 2, 16, 32, 64, 8, 4;  23,   0,   0,   0)
//  channel   14: 2v111(1, 2, 16, 32, 64, 8, 4;  23,   0,   0,  23)
//  channel   15: 3yv11(1, 2, 64, 4, 32, 16, 8;  24,   0,   0,  24)
//  channel   16: 3yv11(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel   17: 3yv11(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,  23)
//  channel   18: 3yv11(1, 2, 64, 16, 32, 8, 4;  23,   0,   0,   0)
//  channel   19: 3yv11(1, 2, 64, 16, 32, 8, 4;  23,   0,   0,  23)
//  channel   20: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel   21: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   0)
//  channel   22: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   0)
//  channel   23: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   0)
//  channel   24: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   0)
//  channel   25: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   0)
//  channel   26: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   0)
//  channel   27: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   0)
//  channel   28: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   0)
//  channel   29: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   0)
//  channel   30: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   0)
//  channel   31: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   0)
//  channel   32: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   0)
//  channel   33: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   0)
//  channel   34: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   35: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
//  channel   36: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
//  channel   37: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
//  channel   38: 5yyyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   0)
//  channel   39: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   0)
//  channel   40: 5yyyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   0)
//  channel   41: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
//  channel   42: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
//  channel   43: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
//  channel   44: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
//  channel   45: 5yyyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   0)
//  channel   46: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
//  channel   47: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   0)
//  channel   48: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   49: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   0,  23,   0)
//  channel   50: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   0,  23,   0)
//  channel   51: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,  23,   0)
//  channel   52: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,   0,  24,   0)
//  channel   53: 12v11(1, 2, 64, 4, 32, 16, 8;  24,   0,   0,  24)
//  channel   54: 12v11(1, 2, 64, 4, 32, 16, 8;  24,  23,   0,  24)
//  channel   55: 12v11(1, 2, 64, 8, 16, 32, 4;  24,   0,   0,  24)
//  channel   56: 12v11(1, 2, 64, 8, 16, 32, 4;  24,  23,   0,  24)
//  channel   57: 13yv1(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,   0)
//  channel   58: 13yv1(1, 2, 64, 4, 16, 32, 8;  23,   0,  23,   0)
//  channel   59: 13yv1(1, 2, 64, 16, 4, 32, 8;  24,   0,   0,   0)
//  channel   60: 13yv1(1, 2, 64, 16, 4, 32, 8;  24,   0,  23,   0)
//  channel   61: 13yv1(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,   0)
//  channel   62: 13yv1(1, 2, 64, 8, 16, 32, 4;  23,   0,  23,   0)
//  channel   63: 13yv1(1, 2, 64, 32, 8, 16, 4;  24,   0,   0,   0)
//  channel   64: 13yv1(1, 2, 64, 32, 8, 16, 4;  24,   0,  23,   0)
//  channel   65: 112v1(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,   0)
//  channel   66: 112v1(1, 2, 64, 4, 16, 32, 8;  23,  23,   0,   0)
//  channel   67: 112v1(1, 2, 64, 16, 4, 32, 8;  24,  23,   0,   0)
//  channel   68: 112v1(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,   0)
//  channel   69: 112v1(1, 2, 64, 8, 16, 32, 4;  23,  23,   0,   0)
//  channel   70: 112v1(1, 2, 64, 32, 8, 16, 4;  24,  23,   0,   0)
//  channel   71: 113yv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   72: 113yv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
//  channel   73: 113yv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
//  channel   74: 113yv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
//  channel   75: 113yv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
//  channel   76: 113yv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
//  channel   77: 113yv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
//  channel   78: 113yv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
//  channel   79: 1112v(1, 2, 64, 4, 32, 8, 16;  24,   0,  24,   0)
//  channel   80: 1112v(1, 2, 64, 4, 32, 8, 16;  24,  23,  24,   0)
//  channel   81: 1112v(1, 2, 64, 32, 4, 8, 16;  24,  23,  24,   0)
//  channel   82: 1112v(1, 2, 64, 8, 16, 4, 32;  24,   0,  24,   0)
//  channel   83: 1112v(1, 2, 64, 8, 16, 4, 32;  24,  23,  24,   0)
//  channel   84: 1112v(1, 2, 64, 16, 8, 4, 32;  24,  23,  24,   0)
//  channel   85: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel   86: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   0,   0)
//  channel   87: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,   0)
//  channel   88: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   0,   0)
//  channel   89: 2v2v1(1, 2, 8, 16, 4, 32, 64;  24,  24,   0,   0)
//  channel   90: 2v3yv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   91: 2v3yv(1, 2, 4, 8, 64, 16, 32;  23,   0,  23,   0)
//  channel   92: 2v3yv(1, 2, 16, 32, 64, 4, 8;   0,   0,  23,   0)
//  channel   93: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   0,  23,   0)
//  channel   94: 2v3yv(1, 2, 8, 16, 64, 4, 32;  24,   0,  24,   0)
//  channel   95: 2v12v(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,  24)
//  channel   96: 3yv2v(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,  24)
//  channel   97: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,  24)
//  channel   98: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,  24)
//  channel   99: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   0,  24)
//  channel  100: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,  23,  24)
