#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_050_uux_emepvevexa(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_050_uux_emepvevexa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(40);
  needed_v_smin[x_a].resize(40);
  needed_v_smin[x_a][  0] = {   0,    1,    7,    8,   14,   15,   26,   27,   38,   39,   42,   43,   44,   45,   52,   53,   60,   61,   67,   68,   74,   75,   76,   77,   79,   80,   83,   84,   85,   86,   87,   88,   90,   91,   92,   93,   96,   97,   98,   99}; //  40
  needed_v_smin[x_a][  1] = {   0,    1,   14,   15,   44,   45,   60,   61}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   60,   61,   62,   63}; //   8
  needed_v_smin[x_a][  3] = {   2,    3,    4,   12,   13,   16,   17,   18,   19,   20,   40,   46,   47,   48,   49,   54,   55,   58,   59,   62,   63,   64,   72,   73,   78,   81,   82,   89,   94,  100}; //  30
  needed_v_smin[x_a][  4] = {   2,    3,   18,   19,   48,   49,   62,   63}; //   8
  needed_v_smin[x_a][  5] = {   4,   64}; //   2
  needed_v_smin[x_a][  6] = {   4,    6,   64,   66}; //   4
  needed_v_smin[x_a][  7] = {   5,    6,   65,   66,   74,   75,   76,   77,   85,   86,   87,   88,   96,   97,   98,   99}; //  16
  needed_v_smin[x_a][  8] = {   5,   65}; //   2
  needed_v_smin[x_a][  9] = {   5,   11,   65,   71}; //   4
  needed_v_smin[x_a][ 10] = {   6,   66}; //   2
  needed_v_smin[x_a][ 11] = {   7,    8,   26,   27,   52,   53,   67,   68}; //   8
  needed_v_smin[x_a][ 12] = {   7,    8,    9,   10,   67,   68,   69,   70}; //   8
  needed_v_smin[x_a][ 13] = {   9,   10,   11,   12,   13,   28,   29,   30,   31,   34,   41,   46,   47,   50,   51,   54,   55,   56,   57,   69,   70,   71,   72,   73,   78,   81,   89,   94,   95,  100}; //  30
  needed_v_smin[x_a][ 14] = {   9,   10,   30,   31,   56,   57,   69,   70}; //   8
  needed_v_smin[x_a][ 15] = {  11,   71}; //   2
  needed_v_smin[x_a][ 16] = {  12,   13,   72,   73,   78,  100}; //   6
  needed_v_smin[x_a][ 17] = {  14,   15,   18,   19}; //   4
  needed_v_smin[x_a][ 18] = {  16,   17,   20,   46,   47,   94}; //   6
  needed_v_smin[x_a][ 19] = {  16,   17,   21,   22}; //   4
  needed_v_smin[x_a][ 20] = {  20,   23}; //   2
  needed_v_smin[x_a][ 21] = {  21,   22,   23,   24,   25,   38,   39,   41,   50,   51,   52,   53,   56,   57,   79,   80,   90,   91,   95}; //  19
  needed_v_smin[x_a][ 22] = {  21,   22,   23,   50,   51,   95}; //   6
  needed_v_smin[x_a][ 23] = {  24,   25,   79,   80,   90,   91}; //   6
  needed_v_smin[x_a][ 24] = {  24,   36}; //   2
  needed_v_smin[x_a][ 25] = {  25,   37}; //   2
  needed_v_smin[x_a][ 26] = {  26,   27,   30,   31}; //   4
  needed_v_smin[x_a][ 27] = {  28,   29,   34,   54,   55,   81,   89}; //   7
  needed_v_smin[x_a][ 28] = {  28,   29,   32,   33}; //   4
  needed_v_smin[x_a][ 29] = {  32,   33,   35,   36,   37,   40,   42,   43,   44,   45,   48,   49,   58,   59,   82,   83,   84,   92,   93}; //  19
  needed_v_smin[x_a][ 30] = {  32,   33,   35,   58,   59,   82}; //   6
  needed_v_smin[x_a][ 31] = {  34,   35}; //   2
  needed_v_smin[x_a][ 32] = {  36,   37,   83,   84,   92,   93}; //   6
  needed_v_smin[x_a][ 33] = {  38,   39}; //   2
  needed_v_smin[x_a][ 34] = {  40}; //   1
  needed_v_smin[x_a][ 35] = {  41}; //   1
  needed_v_smin[x_a][ 36] = {  42,   43}; //   2
  needed_v_smin[x_a][ 37] = {  74,   75,   76,   77,   96,   97,   98,   99}; //   8
  needed_v_smin[x_a][ 38] = {  85,   86}; //   2
  needed_v_smin[x_a][ 39] = {  87,   88}; //   2

  v_smax[x_a].resize(36);
  needed_v_smax[x_a].resize(36);
  needed_v_smax[x_a][  0] = {   0,    1,    7,    8,   14,   15,   26,   27,   38,   39,   42,   43,   44,   45,   52,   53,   60,   61,   67,   68,   74,   75,   85,   86,   90,   91,   92,   93,   96,   97}; //  30
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   14,   15,   18,   19,   44,   45,   48,   49,   60,   61,   62,   63}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   96,   97,   98,   99,  100}; //  38
  needed_v_smax[x_a][  3] = {   2,    3,    4,   12,   13,   16,   17,   18,   19,   20,   40,   46,   47,   48,   49,   62,   63,   64,   72,   73}; //  20
  needed_v_smax[x_a][  4] = {   4,    6,   64,   66}; //   4
  needed_v_smax[x_a][  5] = {   5,    6,   65,   66,   76,   77,   87,   88,   98,   99}; //  10
  needed_v_smax[x_a][  6] = {   5,   11,   65,   71}; //   4
  needed_v_smax[x_a][  7] = {   7,    8,    9,   10,   26,   27,   30,   31,   52,   53,   56,   57,   67,   68,   69,   70}; //  16
  needed_v_smax[x_a][  8] = {   9,   10,   11,   28,   29,   30,   31,   34,   54,   55,   56,   57,   69,   70,   71,   78,   81,   89,   94,   95,  100}; //  21
  needed_v_smax[x_a][  9] = {  12,   13,   72,   73}; //   4
  needed_v_smax[x_a][ 10] = {  14,   15,   16,   17,   18,   19,   21,   22,   38,   39}; //  10
  needed_v_smax[x_a][ 11] = {  16,   17,   20,   21,   22,   23,   46,   47,   50,   51}; //  10
  needed_v_smax[x_a][ 12] = {  20,   23,   25,   37,   40}; //   5
  needed_v_smax[x_a][ 13] = {  21,   22,   23,   24,   25,   41,   50,   51,   79,   80}; //  10
  needed_v_smax[x_a][ 14] = {  24,   25,   36,   37,   79,   80,   83,   84}; //   8
  needed_v_smax[x_a][ 15] = {  24,   34,   35,   36,   41}; //   5
  needed_v_smax[x_a][ 16] = {  26,   27,   28,   29,   30,   31,   32,   33,   42,   43}; //  10
  needed_v_smax[x_a][ 17] = {  28,   29,   32,   33,   34,   35,   54,   55,   58,   59,   81,   82}; //  12
  needed_v_smax[x_a][ 18] = {  32,   33,   35,   36,   37,   58,   59,   82,   83,   84}; //  10
  needed_v_smax[x_a][ 19] = {  38,   39,   90,   91}; //   4
  needed_v_smax[x_a][ 20] = {  40}; //   1
  needed_v_smax[x_a][ 21] = {  41}; //   1
  needed_v_smax[x_a][ 22] = {  42,   43,   92,   93}; //   4
  needed_v_smax[x_a][ 23] = {  44,   45,   48,   49}; //   4
  needed_v_smax[x_a][ 24] = {  46,   47,   50,   51}; //   4
  needed_v_smax[x_a][ 25] = {  52,   53,   56,   57}; //   4
  needed_v_smax[x_a][ 26] = {  54,   55,   58,   59,   81,   82}; //   6
  needed_v_smax[x_a][ 27] = {  74,   75,   85,   86,   96,   97}; //   6
  needed_v_smax[x_a][ 28] = {  76,   77,   87,   88,   98,   99}; //   6
  needed_v_smax[x_a][ 29] = {  78,   89,   94,  100}; //   4
  needed_v_smax[x_a][ 30] = {  79,   80,   83,   84}; //   4
  needed_v_smax[x_a][ 31] = {  90,   91,   92,   93,   87,   88}; //   6
  needed_v_smax[x_a][ 32] = {  94,   95}; //   2
  needed_v_smax[x_a][ 33] = {  95}; //   1
  needed_v_smax[x_a][ 34] = {  85,   86}; //   2
  needed_v_smax[x_a][ 35] = {  89}; //   1

  g_p[x_a].resize(64);
  needed_g_p[x_a].resize(64);
  needed_g_p[x_a][0] = {   0,    1,    7,    8,   14,   15,   26,   27,   38,   39,   42,   43,   44,   45,   52,   53,   60,   61,   67,   68,   74,   75,   85,   86,   90,   91,   92,   93,   96,   97}; //  30
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   14,   15,   44,   45,   60,   61}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   60,   62}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   61,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    4,   12,   13,   16,   17,   18,   19,   20,   40,   46,   47,   48,   49,   62,   63,   64,   72,   73}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    3,   18,   19,   48,   49,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {   4,   64}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   4,    6,   64,   66}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   5,    6,   65,   66,   77,   88,   99}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   5,   65}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   5,   11,   65,   71}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][11] = {   6,   66}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][12] = {   7,    8,   26,   27,   52,   53,   67,   68}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][13] = {   7,    9,   67,   69}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][14] = {   8,   10,   68,   70}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][15] = {   9,   10,   11,   28,   29,   30,   31,   34,   54,   55,   56,   57,   69,   70,   71,   78,   81,   89,   94,   95,  100}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax8");
  needed_g_p[x_a][16] = {   9,   10,   30,   31,   56,   57,   69,   70}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][17] = {  11,   71}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax6");
  needed_g_p[x_a][18] = {  12,   13,   72,   73}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax9");
  needed_g_p[x_a][19] = {  12,   72}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax2");
  needed_g_p[x_a][20] = {  13,   73}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin16_smax2");
  needed_g_p[x_a][21] = {  14,   15,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax10");
  needed_g_p[x_a][22] = {  16,   17,   20,   46,   47}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin18_smax11");
  needed_g_p[x_a][23] = {  16,   17,   21,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax10");
  needed_g_p[x_a][24] = {  20,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax12");
  needed_g_p[x_a][25] = {  21,   22,   23,   24,   25,   41,   50,   51,   79,   80}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax13");
  needed_g_p[x_a][26] = {  21,   22,   23,   50,   51}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin22_smax11");
  needed_g_p[x_a][27] = {  24,   25,   80}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin23_smax14");
  needed_g_p[x_a][28] = {  24,   36}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax15");
  needed_g_p[x_a][29] = {  25,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax12");
  needed_g_p[x_a][30] = {  26,   27,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin26_smax16");
  needed_g_p[x_a][31] = {  28,   29,   34,   54,   55,   81}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin27_smax17");
  needed_g_p[x_a][32] = {  28,   29,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin28_smax16");
  needed_g_p[x_a][33] = {  32,   33,   35,   36,   37,   58,   59,   82,   83,   84}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax18");
  needed_g_p[x_a][34] = {  32,   33,   35,   58,   59,   82}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin30_smax17");
  needed_g_p[x_a][35] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin31_smax15");
  needed_g_p[x_a][36] = {  36,   37,   84}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin32_smax14");
  needed_g_p[x_a][37] = {  38,   39,   90,   91}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax19");
  needed_g_p[x_a][38] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax10");
  needed_g_p[x_a][39] = {  40}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax20");
  needed_g_p[x_a][40] = {  40}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax12");
  needed_g_p[x_a][41] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax21");
  needed_g_p[x_a][42] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin35_smax15");
  needed_g_p[x_a][43] = {  42,   43,   92,   93}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax22");
  needed_g_p[x_a][44] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin36_smax16");
  needed_g_p[x_a][45] = {  44,   45,   48,   49}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax23");
  needed_g_p[x_a][46] = {  46,   47,   50,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax24");
  needed_g_p[x_a][47] = {  52,   53,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax25");
  needed_g_p[x_a][48] = {  54,   55,   58,   59,   81,   82}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax26");
  needed_g_p[x_a][49] = {  74,   85,   96}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax27");
  needed_g_p[x_a][50] = {  75,   86,   97}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax27");
  needed_g_p[x_a][51] = {  76,   87,   98}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][52] = {  76,   77,   87,   88,   98,   99}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax28");
  needed_g_p[x_a][53] = {  78,   89,   94,  100}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax29");
  needed_g_p[x_a][54] = {  79}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax14");
  needed_g_p[x_a][55] = {  79,   80,   83,   84}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax30");
  needed_g_p[x_a][56] = {  83}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin32_smax14");
  needed_g_p[x_a][57] = {  90}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax31");
  needed_g_p[x_a][58] = {  91}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin23_smax31");
  needed_g_p[x_a][59] = {  92}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin32_smax31");
  needed_g_p[x_a][60] = {  93}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin32_smax31");
  needed_g_p[x_a][61] = {  94}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin18_smax32");
  needed_g_p[x_a][62] = {  95}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax33");
  needed_g_p[x_a][63] = {  95}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin22_smax32");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {  74,   75,   76,   77,   96,   97,   98,   99}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin37_smax2");
  needed_g_f[x_a][1] = {  78,  100}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax2");
  needed_g_f[x_a][2] = {  85,   86}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin38_smax34");
  needed_g_f[x_a][3] = {  87,   88}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin39_smax31");
  needed_g_f[x_a][4] = {  89}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax35");

  g_t[x_a].resize(16);
  needed_g_t[x_a].resize(16);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   74,   75,   76,   77,   78}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   96,   97,   98,   99,  100}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  74,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][3] = {  76,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][4] = {  78}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__24_36");
  needed_g_t[x_a][5] = {  79,   80,   83,   84,   87,   88}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][6] = {  81,   82,   89}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_100");
  needed_g_t[x_a][7] = {  85,   86}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][8] = {  85,   86}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_64");
  needed_g_t[x_a][9] = {  87,   88}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][10] = {  89}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__36_64");
  needed_g_t[x_a][11] = {  90,   91,   92,   93}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][12] = {  94,   95}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_88");
  needed_g_t[x_a][13] = {  96,   97}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][14] = {  98,   99}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][15] = { 100}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_24");

  g_d[x_a].resize(45);
  needed_g_d[x_a].resize(45);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   60,   61,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,   14,   15,   44,   45,   60,   61}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    7,    8,   14,   15,   26,   27,   38,   39,   42,   43,   44,   45,   52,   53,   60,   61,   67,   68,   74,   75,   76,   77,   79,   80,   83,   84,   85,   86,   87,   88,   90,   91,   92,   93,   96,   97,   98,   99}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,    3,   18,   19,   48,   49,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][4] = {   2,    3,    4,   12,   13,   16,   17,   18,   19,   20,   40,   46,   47,   48,   49,   54,   55,   58,   59,   62,   63,   64,   72,   73,   78,   81,   82,   89,   94,  100}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   4,    6,   64,   66}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   4,   64}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {   5,   11,   65,   71}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   5,   65}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   5,    6,   65,   66,   74,   75,   76,   77,   85,   86,   87,   88,   96,   97,   98,   99}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][10] = {   6,   66}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   7,    8,    9,   10,   67,   68,   69,   70}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {   7,    8,   26,   27,   52,   53,   67,   68}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][13] = {   9,   10,   30,   31,   56,   57,   69,   70}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {   9,   10,   11,   12,   13,   28,   29,   30,   31,   34,   41,   46,   47,   50,   51,   54,   55,   56,   57,   69,   70,   71,   72,   73,   78,   81,   89,   94,   95,  100}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  11,   71}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][16] = {  12,   13,   72,   73}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][17] = {  14,   15,   16,   17,   18,   19,   21,   22,   38,   39}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__4_120");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__4_120");
  needed_g_d[x_a][18] = {  14,   15,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__64_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__64_56");
  needed_g_d[x_a][19] = {  16,   17,   21,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__32_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__32_88");
  needed_g_d[x_a][20] = {  16,   17,   20,   46,   47,   94}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][21] = {  20,   23,   25,   37,   40}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][22] = {  20,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__4_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__4_88");
  needed_g_d[x_a][23] = {  21,   22,   23,   50,   51,   95}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__16_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__16_72");
  needed_g_d[x_a][24] = {  21,   22,   23,   24,   25,   38,   39,   41,   50,   51,   52,   53,   56,   57,   79,   80,   90,   91,   95}; //  19
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][25] = {  24,   34,   35,   36,   41}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][26] = {  24,   36}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][27] = {  24,   25,   79,   80,   90,   91}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__4_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__4_72");
  needed_g_d[x_a][28] = {  25,   37}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][29] = {  26,   27,   28,   29,   30,   31,   32,   33,   42,   43}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__8_116");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__8_116");
  needed_g_d[x_a][30] = {  26,   27,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__64_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__64_52");
  needed_g_d[x_a][31] = {  28,   29,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__16_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__16_100");
  needed_g_d[x_a][32] = {  28,   29,   34,   54,   55,   81}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][33] = {  32,   33,   35,   58,   59,   82}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__32_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__32_68");
  needed_g_d[x_a][34] = {  32,   33,   35,   36,   37,   40,   42,   43,   44,   45,   48,   49,   58,   59,   82,   83,   84,   92,   93}; //  19
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][35] = {  34,   35}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__8_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__8_100");
  needed_g_d[x_a][36] = {  36,   37,   83,   84,   92,   93}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__8_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__8_68");
  needed_g_d[x_a][37] = {  38,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__72_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__72_48");
  needed_g_d[x_a][38] = {  40}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__68_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__68_24");
  needed_g_d[x_a][39] = {  41}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__36_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__36_72");
  needed_g_d[x_a][40] = {  42,   43}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__68_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__68_48");
  needed_g_d[x_a][41] = {  44,   45,   48,   49}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__68_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__68_56");
  needed_g_d[x_a][42] = {  46,   47,   50,   51}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][43] = {  52,   53,   56,   57}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__72_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__72_52");
  needed_g_d[x_a][44] = {  54,   55,   58,   59}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");

  c_p[x_a].resize(101);
  c_f[x_a].resize(101);
  c_t[x_a].resize(101);
  c_d[x_a].resize(101);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   3,   4}; //   3

  c_p[x_a][3] = {  4,   5,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   3,   4}; //   3

  c_p[x_a][4] = {  4,   6,   7}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  5,   6,   4}; //   3

  c_p[x_a][5] = {  8,   9,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  7,   8,   9}; //   3

  c_p[x_a][6] = {  8,  11,   7}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  5,  10,   9}; //   3

  c_p[x_a][7] = {  0,  12,  13}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 11,  12,   2}; //   3

  c_p[x_a][8] = {  0,  12,  14}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 11,  12,   2}; //   3

  c_p[x_a][9] = { 15,  16,  13}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 11,  13,  14}; //   3

  c_p[x_a][10] = { 15,  16,  14}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 11,  13,  14}; //   3

  c_p[x_a][11] = { 15,  17,  10}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  7,  15,  14}; //   3

  c_p[x_a][12] = {  4,  18,  19}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 16,  14,   4}; //   3

  c_p[x_a][13] = {  4,  18,  20}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 16,  14,   4}; //   3

  c_p[x_a][14] = {  0,   1,  21}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 17,  18,   1,   2}; //   4

  c_p[x_a][15] = {  0,   1,  21}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 17,  18,   1,   2}; //   4

  c_p[x_a][16] = {  4,  22,  23}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 17,  19,  20,   4}; //   4

  c_p[x_a][17] = {  4,  22,  23}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 17,  19,  20,   4}; //   4

  c_p[x_a][18] = {  4,   5,  21}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 17,  18,   3,   4}; //   4

  c_p[x_a][19] = {  4,   5,  21}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 17,  18,   3,   4}; //   4

  c_p[x_a][20] = {  4,  22,  24}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 21,  22,  20,   4}; //   4

  c_p[x_a][21] = { 25,  26,  23}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 17,  19,  23,  24}; //   4

  c_p[x_a][22] = { 25,  26,  23}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 17,  19,  23,  24}; //   4

  c_p[x_a][23] = { 25,  26,  24}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 21,  22,  23,  24}; //   4

  c_p[x_a][24] = { 25,  27,  28}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 25,  26,  27,  24}; //   4

  c_p[x_a][25] = { 25,  27,  29}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 21,  28,  27,  24}; //   4

  c_p[x_a][26] = {  0,  12,  30}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 29,  30,  12,   2}; //   4

  c_p[x_a][27] = {  0,  12,  30}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 29,  30,  12,   2}; //   4

  c_p[x_a][28] = { 15,  31,  32}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 29,  31,  32,  14}; //   4

  c_p[x_a][29] = { 15,  31,  32}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 29,  31,  32,  14}; //   4

  c_p[x_a][30] = { 15,  16,  30}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 29,  30,  13,  14}; //   4

  c_p[x_a][31] = { 15,  16,  30}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 29,  30,  13,  14}; //   4

  c_p[x_a][32] = { 33,  34,  32}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 29,  31,  33,  34}; //   4

  c_p[x_a][33] = { 33,  34,  32}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 29,  31,  33,  34}; //   4

  c_p[x_a][34] = { 15,  31,  35}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 25,  35,  32,  14}; //   4

  c_p[x_a][35] = { 33,  34,  35}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 25,  35,  33,  34}; //   4

  c_p[x_a][36] = { 33,  36,  28}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 25,  26,  36,  34}; //   4

  c_p[x_a][37] = { 33,  36,  29}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 21,  28,  36,  34}; //   4

  c_p[x_a][38] = {  0,  37,  38}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 17,  37,  24,   2}; //   4

  c_p[x_a][39] = {  0,  37,  38}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 17,  37,  24,   2}; //   4

  c_p[x_a][40] = {  4,  39,  40}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 21,  38,  34,   4}; //   4

  c_p[x_a][41] = { 25,  41,  42}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 25,  39,  14,  24}; //   4

  c_p[x_a][42] = {  0,  43,  44}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 29,  40,  34,   2}; //   4

  c_p[x_a][43] = {  0,  43,  44}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = { 29,  40,  34,   2}; //   4

  c_p[x_a][44] = {  0,   1,  45}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = { 41,  34,   1,   2}; //   4

  c_p[x_a][45] = {  0,   1,  45}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = { 41,  34,   1,   2}; //   4

  c_p[x_a][46] = {  4,  22,  46}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = { 42,  14,  20,   4}; //   4

  c_p[x_a][47] = {  4,  22,  46}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {}; //   0
  c_d[x_a][47] = { 42,  14,  20,   4}; //   4

  c_p[x_a][48] = {  4,   5,  45}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {}; //   0
  c_d[x_a][48] = { 41,  34,   3,   4}; //   4

  c_p[x_a][49] = {  4,   5,  45}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {}; //   0
  c_d[x_a][49] = { 41,  34,   3,   4}; //   4

  c_p[x_a][50] = { 25,  26,  46}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {}; //   0
  c_d[x_a][50] = { 42,  14,  23,  24}; //   4

  c_p[x_a][51] = { 25,  26,  46}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {}; //   0
  c_d[x_a][51] = { 42,  14,  23,  24}; //   4

  c_p[x_a][52] = {  0,  12,  47}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {}; //   0
  c_d[x_a][52] = { 43,  24,  12,   2}; //   4

  c_p[x_a][53] = {  0,  12,  47}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {}; //   0
  c_d[x_a][53] = { 43,  24,  12,   2}; //   4

  c_p[x_a][54] = { 15,  31,  48}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {}; //   0
  c_d[x_a][54] = { 44,   4,  32,  14}; //   4

  c_p[x_a][55] = { 15,  31,  48}; //   3
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {}; //   0
  c_d[x_a][55] = { 44,   4,  32,  14}; //   4

  c_p[x_a][56] = { 15,  16,  47}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {}; //   0
  c_d[x_a][56] = { 43,  24,  13,  14}; //   4

  c_p[x_a][57] = { 15,  16,  47}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {}; //   0
  c_d[x_a][57] = { 43,  24,  13,  14}; //   4

  c_p[x_a][58] = { 33,  34,  48}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {}; //   0
  c_d[x_a][58] = { 44,   4,  33,  34}; //   4

  c_p[x_a][59] = { 33,  34,  48}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {}; //   0
  c_d[x_a][59] = { 44,   4,  33,  34}; //   4

  c_p[x_a][60] = {  0,   1,   2}; //   3
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  1}; //   1
  c_d[x_a][60] = {  0,   1,   2}; //   3

  c_p[x_a][61] = {  0,   1,   3}; //   3
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  1}; //   1
  c_d[x_a][61] = {  0,   1,   2}; //   3

  c_p[x_a][62] = {  4,   5,   2}; //   3
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  1}; //   1
  c_d[x_a][62] = {  0,   3,   4}; //   3

  c_p[x_a][63] = {  4,   5,   3}; //   3
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  1}; //   1
  c_d[x_a][63] = {  0,   3,   4}; //   3

  c_p[x_a][64] = {  4,   6,   7}; //   3
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  1}; //   1
  c_d[x_a][64] = {  5,   6,   4}; //   3

  c_p[x_a][65] = {  8,   9,  10}; //   3
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  1}; //   1
  c_d[x_a][65] = {  7,   8,   9}; //   3

  c_p[x_a][66] = {  8,  11,   7}; //   3
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  1}; //   1
  c_d[x_a][66] = {  5,  10,   9}; //   3

  c_p[x_a][67] = {  0,  12,  13}; //   3
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  1}; //   1
  c_d[x_a][67] = { 11,  12,   2}; //   3

  c_p[x_a][68] = {  0,  12,  14}; //   3
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  1}; //   1
  c_d[x_a][68] = { 11,  12,   2}; //   3

  c_p[x_a][69] = { 15,  16,  13}; //   3
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  1}; //   1
  c_d[x_a][69] = { 11,  13,  14}; //   3

  c_p[x_a][70] = { 15,  16,  14}; //   3
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  1}; //   1
  c_d[x_a][70] = { 11,  13,  14}; //   3

  c_p[x_a][71] = { 15,  17,  10}; //   3
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  1}; //   1
  c_d[x_a][71] = {  7,  15,  14}; //   3

  c_p[x_a][72] = {  4,  18,  19}; //   3
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  1}; //   1
  c_d[x_a][72] = { 16,  14,   4}; //   3

  c_p[x_a][73] = {  4,  18,  20}; //   3
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {  1}; //   1
  c_d[x_a][73] = { 16,  14,   4}; //   3

  c_p[x_a][74] = {  0,  49}; //   2
  c_f[x_a][74] = {  0}; //   1
  c_t[x_a][74] = {  0,   2}; //   2
  c_d[x_a][74] = {  9,   2}; //   2

  c_p[x_a][75] = {  0,  50}; //   2
  c_f[x_a][75] = {  0}; //   1
  c_t[x_a][75] = {  0,   2}; //   2
  c_d[x_a][75] = {  9,   2}; //   2

  c_p[x_a][76] = { 51,  52}; //   2
  c_f[x_a][76] = {  0}; //   1
  c_t[x_a][76] = {  0,   3}; //   2
  c_d[x_a][76] = {  2,   9}; //   2

  c_p[x_a][77] = {  8,  52}; //   2
  c_f[x_a][77] = {  0}; //   1
  c_t[x_a][77] = {  0,   3}; //   2
  c_d[x_a][77] = {  2,   9}; //   2

  c_p[x_a][78] = { 15,  53}; //   2
  c_f[x_a][78] = {  1}; //   1
  c_t[x_a][78] = {  0,   4}; //   2
  c_d[x_a][78] = {  4,  14}; //   2

  c_p[x_a][79] = { 25,  54,  55}; //   3
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = {  5}; //   1
  c_d[x_a][79] = {  2,  27,  24}; //   3

  c_p[x_a][80] = { 25,  27,  55}; //   3
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {  5}; //   1
  c_d[x_a][80] = {  2,  27,  24}; //   3

  c_p[x_a][81] = { 15,  31,  48}; //   3
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {  6}; //   1
  c_d[x_a][81] = {  4,  32,  14}; //   3

  c_p[x_a][82] = { 33,  34,  48}; //   3
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = {  6}; //   1
  c_d[x_a][82] = {  4,  33,  34}; //   3

  c_p[x_a][83] = { 33,  56,  55}; //   3
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = {  5}; //   1
  c_d[x_a][83] = {  2,  36,  34}; //   3

  c_p[x_a][84] = { 33,  36,  55}; //   3
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = {  5}; //   1
  c_d[x_a][84] = {  2,  36,  34}; //   3

  c_p[x_a][85] = {  0,  49}; //   2
  c_f[x_a][85] = {  2}; //   1
  c_t[x_a][85] = {  7,   8}; //   2
  c_d[x_a][85] = {  9,   2}; //   2

  c_p[x_a][86] = {  0,  50}; //   2
  c_f[x_a][86] = {  2}; //   1
  c_t[x_a][86] = {  7,   8}; //   2
  c_d[x_a][86] = {  9,   2}; //   2

  c_p[x_a][87] = { 51,  52}; //   2
  c_f[x_a][87] = {  3}; //   1
  c_t[x_a][87] = {  5,   9}; //   2
  c_d[x_a][87] = {  2,   9}; //   2

  c_p[x_a][88] = {  8,  52}; //   2
  c_f[x_a][88] = {  3}; //   1
  c_t[x_a][88] = {  5,   9}; //   2
  c_d[x_a][88] = {  2,   9}; //   2

  c_p[x_a][89] = { 15,  53}; //   2
  c_f[x_a][89] = {  4}; //   1
  c_t[x_a][89] = {  6,  10}; //   2
  c_d[x_a][89] = {  4,  14}; //   2

  c_p[x_a][90] = {  0,  37,  57}; //   3
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = { 11}; //   1
  c_d[x_a][90] = { 27,  24,   2}; //   3

  c_p[x_a][91] = {  0,  37,  58}; //   3
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = { 11}; //   1
  c_d[x_a][91] = { 27,  24,   2}; //   3

  c_p[x_a][92] = {  0,  43,  59}; //   3
  c_f[x_a][92] = {}; //   0
  c_t[x_a][92] = { 11}; //   1
  c_d[x_a][92] = { 36,  34,   2}; //   3

  c_p[x_a][93] = {  0,  43,  60}; //   3
  c_f[x_a][93] = {}; //   0
  c_t[x_a][93] = { 11}; //   1
  c_d[x_a][93] = { 36,  34,   2}; //   3

  c_p[x_a][94] = { 15,  53,  61}; //   3
  c_f[x_a][94] = {}; //   0
  c_t[x_a][94] = { 12}; //   1
  c_d[x_a][94] = { 20,   4,  14}; //   3

  c_p[x_a][95] = { 15,  62,  63}; //   3
  c_f[x_a][95] = {}; //   0
  c_t[x_a][95] = { 12}; //   1
  c_d[x_a][95] = { 23,  24,  14}; //   3

  c_p[x_a][96] = {  0,  49}; //   2
  c_f[x_a][96] = {  0}; //   1
  c_t[x_a][96] = {  1,  13}; //   2
  c_d[x_a][96] = {  9,   2}; //   2

  c_p[x_a][97] = {  0,  50}; //   2
  c_f[x_a][97] = {  0}; //   1
  c_t[x_a][97] = {  1,  13}; //   2
  c_d[x_a][97] = {  9,   2}; //   2

  c_p[x_a][98] = { 51,  52}; //   2
  c_f[x_a][98] = {  0}; //   1
  c_t[x_a][98] = {  1,  14}; //   2
  c_d[x_a][98] = {  2,   9}; //   2

  c_p[x_a][99] = {  8,  52}; //   2
  c_f[x_a][99] = {  0}; //   1
  c_t[x_a][99] = {  1,  14}; //   2
  c_d[x_a][99] = {  2,   9}; //   2

  c_p[x_a][100] = { 15,  53}; //   2
  c_f[x_a][100] = {  1}; //   1
  c_t[x_a][100] = {  1,  15}; //   2
  c_d[x_a][100] = {  4,  14}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_050_uux_emepvevexa
//  channel    0: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel    1: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   0)
//  channel    2: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   0)
//  channel    3: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   0)
//  channel    4: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   0)
//  channel    5: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   0)
//  channel    6: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   0)
//  channel    7: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   0)
//  channel    8: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   0)
//  channel    9: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   0)
//  channel   10: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   0)
//  channel   11: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   0)
//  channel   12: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   0)
//  channel   13: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   0)
//  channel   14: 5yyyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
//  channel   15: 5yyyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,  23)
//  channel   16: 5yyyv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,   0)
//  channel   17: 5yyyv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,  23)
//  channel   18: 5yyyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
//  channel   19: 5yyyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,  23)
//  channel   20: 5yyyv(1, 2, 32, 4, 64, 8, 16;  24,  24,   0,  23)
//  channel   21: 5yyyv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,   0)
//  channel   22: 5yyyv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,  23)
//  channel   23: 5yyyv(1, 2, 32, 4, 16, 8, 64;   0,  24,   0,  23)
//  channel   24: 5yyyv(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,  23)
//  channel   25: 5yyyv(1, 2, 32, 16, 4, 8, 64;   0,  23,   0,  23)
//  channel   26: 5yyyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
//  channel   27: 5yyyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,  23)
//  channel   28: 5yyyv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,   0)
//  channel   29: 5yyyv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,  23)
//  channel   30: 5yyyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
//  channel   31: 5yyyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,  23)
//  channel   32: 5yyyv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,   0)
//  channel   33: 5yyyv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,  23)
//  channel   34: 5yyyv(1, 2, 16, 8, 64, 4, 32;  24,  24,   0,  23)
//  channel   35: 5yyyv(1, 2, 16, 8, 32, 4, 64;   0,  24,   0,  23)
//  channel   36: 5yyyv(1, 2, 16, 32, 8, 4, 64;   0,  23,   0,  23)
//  channel   37: 5yyyv(1, 2, 32, 16, 8, 4, 64;   0,  23,   0,  23)
//  channel   38: 5y2vv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   39: 5y2vv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,  23)
//  channel   40: 5y2vv(1, 2, 32, 4, 64, 8, 16;  24,   0,   0,  23)
//  channel   41: 5y2vv(1, 2, 16, 4, 32, 8, 64;   0,  24,   0,  23)
//  channel   42: 5y2vv(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,   0)
//  channel   43: 5y2vv(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,  23)
//  channel   44: 52vyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
//  channel   45: 52vyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,  23)
//  channel   46: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,   0)
//  channel   47: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,  23)
//  channel   48: 52vyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
//  channel   49: 52vyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,  23)
//  channel   50: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,   0)
//  channel   51: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,  23)
//  channel   52: 52vyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
//  channel   53: 52vyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,  23)
//  channel   54: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,   0)
//  channel   55: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,  23)
//  channel   56: 52vyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
//  channel   57: 52vyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,  23)
//  channel   58: 52vyv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,   0)
//  channel   59: 52vyv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,  23)
//  channel   60: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   61: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
//  channel   62: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
//  channel   63: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
//  channel   64: 14yyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   0)
//  channel   65: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   0)
//  channel   66: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   0)
//  channel   67: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
//  channel   68: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
//  channel   69: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
//  channel   70: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
//  channel   71: 14yyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   0)
//  channel   72: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
//  channel   73: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   0)
//  channel   74: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel   75: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   0,   0)
//  channel   76: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,   0)
//  channel   77: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   0,   0)
//  channel   78: 2v2v1(1, 2, 8, 16, 4, 32, 64;  24,  24,   0,   0)
//  channel   79: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,   0,  23,   0)
//  channel   80: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,  23,  23,   0)
//  channel   81: 2v3yv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,   0)
//  channel   82: 2v3yv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,   0)
//  channel   83: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,   0,  23,   0)
//  channel   84: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,  23,  23,   0)
//  channel   85: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   86: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,  23,   0,   0)
//  channel   87: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,  23,   0,   0)
//  channel   88: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,  23,   0,   0)
//  channel   89: 2v12v(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,   0)
//  channel   90: 3yv2v(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   91: 3yv2v(1, 2, 4, 8, 64, 16, 32;  23,   0,  23,   0)
//  channel   92: 3yv2v(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,   0)
//  channel   93: 3yv2v(1, 2, 8, 4, 64, 16, 32;  23,   0,  23,   0)
//  channel   94: 3yv2v(1, 2, 64, 8, 16, 4, 32;  24,  24,  24,   0)
//  channel   95: 3yv2v(1, 2, 16, 8, 64, 4, 32;  24,   0,  24,   0)
//  channel   96: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   97: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,  23,   0,   0)
//  channel   98: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  23,   0,   0)
//  channel   99: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  23,   0,   0)
//  channel  100: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   0,   0)
