#include "header.hpp"

#include "ppemexmx04.phasespace.set.hpp"

void ppemexmx04_phasespace_set::ax_psp_040_aa_emmumepmup(int x_a){
  static Logger logger("ppemexmx04_phasespace_set::ax_psp_040_aa_emmumepmup");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(18);
  needed_v_smin[x_a].resize(18);
  needed_v_smin[x_a][  0] = {  16,   17,   22,   23,   24,   25,   30,   31,   32,   33,   34,   35}; //  12
  needed_v_smin[x_a][  1] = {  16,   17,   34,   35,   30,   31}; //   6
  needed_v_smin[x_a][  2] = {  18,   19,   20,   21,   26,   27,   28,   29,   36,   37,   38,   39}; //  12
  needed_v_smin[x_a][  3] = {  18,   19,   36,   37,   28,   29}; //   6
  needed_v_smin[x_a][  4] = {  20,   21,   38,   39,   26,   27}; //   6
  needed_v_smin[x_a][  5] = {  22,   23,   32,   33,   24,   25}; //   6
  needed_v_smin[x_a][  6] = {   0,    1,   14,   15}; //   4
  needed_v_smin[x_a][  7] = {   0,    1}; //   2
  needed_v_smin[x_a][  8] = {   2,    3,   12,   13}; //   4
  needed_v_smin[x_a][  9] = {   2,    3}; //   2
  needed_v_smin[x_a][ 10] = {   4,    5,   10,   11}; //   4
  needed_v_smin[x_a][ 11] = {   4,    5}; //   2
  needed_v_smin[x_a][ 12] = {   6,    7,    8,    9}; //   4
  needed_v_smin[x_a][ 13] = {   6,    7}; //   2
  needed_v_smin[x_a][ 14] = {   8,    9}; //   2
  needed_v_smin[x_a][ 15] = {  10,   11}; //   2
  needed_v_smin[x_a][ 16] = {  12,   13}; //   2
  needed_v_smin[x_a][ 17] = {  14,   15}; //   2

  v_smax[x_a].resize(10);
  needed_v_smax[x_a].resize(10);
  needed_v_smax[x_a][  0] = {  16,   17,   22,   23,   24,   25,   30,   31,   32,   33,   34,   35}; //  12
  needed_v_smax[x_a][  1] = {  16,   17,   34,   35,    4,    5,    6,    7,   30,   31}; //  10
  needed_v_smax[x_a][  2] = {  18,   19,   20,   21,   26,   27,   28,   29,   36,   37,   38,   39}; //  12
  needed_v_smax[x_a][  3] = {  18,   19,   36,   37,    8,    9,   12,   13,   28,   29}; //  10
  needed_v_smax[x_a][  4] = {  20,   21,   38,   39,   10,   11,   14,   15,   26,   27}; //  10
  needed_v_smax[x_a][  5] = {  22,   23,   32,   33,    0,    1,    2,    3,   24,   25}; //  10
  needed_v_smax[x_a][  6] = {   0,    1,   14,   15}; //   4
  needed_v_smax[x_a][  7] = {   2,    3,   12,   13}; //   4
  needed_v_smax[x_a][  8] = {   4,    5,   10,   11}; //   4
  needed_v_smax[x_a][  9] = {   6,    7,    8,    9}; //   4

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {  16,   22,   24,   30,   32,   34}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  16,   17,   34,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {  17,   23,   25,   31,   33,   35}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {  18,   20,   26,   28,   36,   38}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {  18,   19,   36,   37}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {  19,   21,   27,   29,   37,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][6] = {  20,   21,   38,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][7] = {  22,   23,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");

  g_f[x_a].resize(16);
  needed_g_f[x_a].resize(16);
  needed_g_f[x_a][0] = {   0,    1,   14,   15}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax6");
  needed_g_f[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][2] = {   2,    3,   12,   13}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax7");
  needed_g_f[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax5");
  needed_g_f[x_a][4] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax8");
  needed_g_f[x_a][5] = {   4,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax1");
  needed_g_f[x_a][6] = {   6,    7,    8,    9}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax9");
  needed_g_f[x_a][7] = {   6,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax1");
  needed_g_f[x_a][8] = {   8,    9}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax3");
  needed_g_f[x_a][9] = {  10,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax4");
  needed_g_f[x_a][10] = {  12,   13}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax3");
  needed_g_f[x_a][11] = {  14,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax4");
  needed_g_f[x_a][12] = {  24,   25}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][13] = {  26,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][14] = {  28,   29}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][15] = {  30,   31}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(36);
  needed_g_t[x_a].resize(36);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,   24,   25,   32,   33}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__16_8");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__5_34__16_8");
  needed_g_t[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_32");
  needed_g_t[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__5_10__16_32");
  needed_g_t[x_a][7] = {   4,    5,    6,    7,   30,   31,   34,   35}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][8] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__4_8");
  needed_g_t[x_a][10] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__17_34__4_8");
  needed_g_t[x_a][11] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][12] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__4_32");
  needed_g_t[x_a][13] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__17_10__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__17_10__4_32");
  needed_g_t[x_a][14] = {   8,    9,   12,   13,   28,   29,   36,   37}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][15] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_36");
  needed_g_t[x_a][16] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__32_4");
  needed_g_t[x_a][17] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__9_18__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__9_18__32_4");
  needed_g_t[x_a][18] = {  10,   11,   14,   15,   26,   27,   38,   39}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][19] = {  10,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][20] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__8_4");
  needed_g_t[x_a][21] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__33_18__8_4");
  needed_g_t[x_a][22] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][23] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__32_16");
  needed_g_t[x_a][24] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__9_6__32_16");
  needed_g_t[x_a][25] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_24");
  needed_g_t[x_a][26] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__8_16");
  needed_g_t[x_a][27] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__33_6__8_16");
  needed_g_t[x_a][28] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][29] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][30] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][31] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][32] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][33] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_20");
  needed_g_t[x_a][34] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][35] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");

  g_d[x_a].resize(6);
  needed_g_d[x_a].resize(6);
  needed_g_d[x_a][0] = {  16,   17,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][1] = {  16,   17,   22,   23,   24,   25,   30,   31,   32,   33,   34,   35}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][2] = {  18,   19,   36,   37}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][3] = {  18,   19,   20,   21,   26,   27,   28,   29,   36,   37,   38,   39}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][4] = {  20,   21,   38,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][5] = {  22,   23,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");

  c_p[x_a].resize(40);
  c_f[x_a].resize(40);
  c_t[x_a].resize(40);
  c_d[x_a].resize(40);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  0,   1,   3}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  0,   4,   5}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  2,   3}; //   2
  c_t[x_a][3] = {  0,   4,   6}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  4,   5}; //   2
  c_t[x_a][4] = {  7,   8,   9}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  4,   5}; //   2
  c_t[x_a][5] = {  7,   8,  10}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  6,   7}; //   2
  c_t[x_a][6] = {  7,  11,  12}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  6,   7}; //   2
  c_t[x_a][7] = {  7,  11,  13}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  6,   8}; //   2
  c_t[x_a][8] = { 14,  15,  16}; //   3
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = {  6,   8}; //   2
  c_t[x_a][9] = { 14,  15,  17}; //   3
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = {  4,   9}; //   2
  c_t[x_a][10] = { 18,  19,  20}; //   3
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  4,   9}; //   2
  c_t[x_a][11] = { 18,  19,  21}; //   3
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {}; //   0
  c_f[x_a][12] = {  2,  10}; //   2
  c_t[x_a][12] = { 14,  22,  23}; //   3
  c_d[x_a][12] = {}; //   0

  c_p[x_a][13] = {}; //   0
  c_f[x_a][13] = {  2,  10}; //   2
  c_t[x_a][13] = { 14,  22,  24}; //   3
  c_d[x_a][13] = {}; //   0

  c_p[x_a][14] = {}; //   0
  c_f[x_a][14] = {  0,  11}; //   2
  c_t[x_a][14] = { 18,  25,  26}; //   3
  c_d[x_a][14] = {}; //   0

  c_p[x_a][15] = {}; //   0
  c_f[x_a][15] = {  0,  11}; //   2
  c_t[x_a][15] = { 18,  25,  27}; //   3
  c_d[x_a][15] = {}; //   0

  c_p[x_a][16] = {  0,   1}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 28}; //   1
  c_d[x_a][16] = {  0,   1}; //   2

  c_p[x_a][17] = {  2,   1}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 28}; //   1
  c_d[x_a][17] = {  0,   1}; //   2

  c_p[x_a][18] = {  3,   4}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 29}; //   1
  c_d[x_a][18] = {  2,   3}; //   2

  c_p[x_a][19] = {  5,   4}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = { 29}; //   1
  c_d[x_a][19] = {  2,   3}; //   2

  c_p[x_a][20] = {  3,   6}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = { 30}; //   1
  c_d[x_a][20] = {  4,   3}; //   2

  c_p[x_a][21] = {  5,   6}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 30}; //   1
  c_d[x_a][21] = {  4,   3}; //   2

  c_p[x_a][22] = {  0,   7}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 31}; //   1
  c_d[x_a][22] = {  5,   1}; //   2

  c_p[x_a][23] = {  2,   7}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 31}; //   1
  c_d[x_a][23] = {  5,   1}; //   2

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = { 12}; //   1
  c_t[x_a][24] = {  0,  32}; //   2
  c_d[x_a][24] = {  1}; //   1

  c_p[x_a][25] = {  2}; //   1
  c_f[x_a][25] = { 12}; //   1
  c_t[x_a][25] = {  0,  32}; //   2
  c_d[x_a][25] = {  1}; //   1

  c_p[x_a][26] = {  3}; //   1
  c_f[x_a][26] = { 13}; //   1
  c_t[x_a][26] = { 18,  33}; //   2
  c_d[x_a][26] = {  3}; //   1

  c_p[x_a][27] = {  5}; //   1
  c_f[x_a][27] = { 13}; //   1
  c_t[x_a][27] = { 18,  33}; //   2
  c_d[x_a][27] = {  3}; //   1

  c_p[x_a][28] = {  3}; //   1
  c_f[x_a][28] = { 14}; //   1
  c_t[x_a][28] = { 14,  34}; //   2
  c_d[x_a][28] = {  3}; //   1

  c_p[x_a][29] = {  5}; //   1
  c_f[x_a][29] = { 14}; //   1
  c_t[x_a][29] = { 14,  34}; //   2
  c_d[x_a][29] = {  3}; //   1

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = { 15}; //   1
  c_t[x_a][30] = {  7,  35}; //   2
  c_d[x_a][30] = {  1}; //   1

  c_p[x_a][31] = {  2}; //   1
  c_f[x_a][31] = { 15}; //   1
  c_t[x_a][31] = {  7,  35}; //   2
  c_d[x_a][31] = {  1}; //   1

  c_p[x_a][32] = {  0,   7}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  0}; //   1
  c_d[x_a][32] = {  5,   1}; //   2

  c_p[x_a][33] = {  2,   7}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  0}; //   1
  c_d[x_a][33] = {  5,   1}; //   2

  c_p[x_a][34] = {  0,   1}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  7}; //   1
  c_d[x_a][34] = {  0,   1}; //   2

  c_p[x_a][35] = {  2,   1}; //   2
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  7}; //   1
  c_d[x_a][35] = {  0,   1}; //   2

  c_p[x_a][36] = {  3,   4}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = { 14}; //   1
  c_d[x_a][36] = {  2,   3}; //   2

  c_p[x_a][37] = {  5,   4}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 14}; //   1
  c_d[x_a][37] = {  2,   3}; //   2

  c_p[x_a][38] = {  3,   6}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 18}; //   1
  c_d[x_a][38] = {  4,   3}; //   2

  c_p[x_a][39] = {  5,   6}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 18}; //   1
  c_d[x_a][39] = {  4,   3}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_040_aa_emmumepmup
//  channel    0: 1111(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel    1: 1111(1, 2, 4, 16, 8, 32;   0,   0,  23)
//  channel    2: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
//  channel    3: 1111(1, 2, 4, 16, 32, 8;   0,   0,  23)
//  channel    4: 1111(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    5: 1111(1, 2, 16, 4, 8, 32;   0,   0,  23)
//  channel    6: 1111(1, 2, 16, 4, 32, 8;   0,   0,   0)
//  channel    7: 1111(1, 2, 16, 4, 32, 8;   0,   0,  23)
//  channel    8: 1111(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel    9: 1111(1, 2, 8, 32, 4, 16;   0,   0,  23)
//  channel   10: 1111(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   11: 1111(1, 2, 32, 8, 4, 16;   0,   0,  23)
//  channel   12: 1111(1, 2, 8, 32, 16, 4;   0,   0,   0)
//  channel   13: 1111(1, 2, 8, 32, 16, 4;   0,   0,  23)
//  channel   14: 1111(1, 2, 32, 8, 16, 4;   0,   0,   0)
//  channel   15: 1111(1, 2, 32, 8, 16, 4;   0,   0,  23)
//  channel   16: 3yv1(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel   17: 3yv1(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel   18: 3yv1(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel   19: 3yv1(1, 2, 32, 4, 16, 8;  23,   0,   0)
//  channel   20: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   21: 3yv1(1, 2, 8, 4, 16, 32;  23,   0,   0)
//  channel   22: 3yv1(1, 2, 16, 8, 32, 4;   0,   0,   0)
//  channel   23: 3yv1(1, 2, 16, 8, 32, 4;  23,   0,   0)
//  channel   24: 12v1(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel   25: 12v1(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel   26: 12v1(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel   27: 12v1(1, 2, 32, 4, 16, 8;  23,   0,   0)
//  channel   28: 12v1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   29: 12v1(1, 2, 8, 4, 16, 32;  23,   0,   0)
//  channel   30: 12v1(1, 2, 16, 8, 32, 4;   0,   0,   0)
//  channel   31: 12v1(1, 2, 16, 8, 32, 4;  23,   0,   0)
//  channel   32: 13yv(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel   33: 13yv(1, 2, 4, 16, 8, 32;  23,   0,   0)
//  channel   34: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   35: 13yv(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   36: 13yv(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel   37: 13yv(1, 2, 8, 32, 4, 16;  23,   0,   0)
//  channel   38: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   39: 13yv(1, 2, 32, 8, 4, 16;  23,   0,   0)
