#include "header.hpp"

#include "ppemexmx04.phasespace.set.hpp"

void ppemexmx04_phasespace_set::ax_psp_040_uux_emmumepmup(int x_a){
  static Logger logger("ppemexmx04_phasespace_set::ax_psp_040_uux_emmumepmup");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(6);
  needed_v_smin[x_a].resize(6);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23}; //  16
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  2] = {   4,    5,    6,    7}; //   4
  needed_v_smin[x_a][  3] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  16
  needed_v_smin[x_a][  4] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][  5] = {  12,   13,   14,   15}; //   4

  v_smax[x_a].resize(8);
  needed_v_smax[x_a].resize(8);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19}; //  12
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  2] = {   4,    5,    6,    7}; //   4
  needed_v_smax[x_a][  3] = {   8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23}; //  12
  needed_v_smax[x_a][  4] = {   8,    9,   10,   11}; //   4
  needed_v_smax[x_a][  5] = {  12,   13,   14,   15}; //   4
  needed_v_smax[x_a][  6] = {  16,   17,   18,   19}; //   4
  needed_v_smax[x_a][  7] = {  20,   21,   22,   23}; //   4

  g_p[x_a].resize(12);
  needed_g_p[x_a].resize(12);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   16,   17}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    3,    6,    7,   18,   19}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   8,    9,   12,   13,   20,   21}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {  10,   11,   14,   15,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][7] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][8] = {  16,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax6");
  needed_g_p[x_a][9] = {  17,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax6");
  needed_g_p[x_a][10] = {  20,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax7");
  needed_g_p[x_a][11] = {  21,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax7");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(2);
  needed_g_t[x_a].resize(2);
  needed_g_t[x_a][0] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][1] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][5] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][7] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][8] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  2,   1}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  2,   1}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   3}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   3}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  2,   3}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  3,   4,   2}; //   3

  c_p[x_a][7] = {  2,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  3,   4,   2}; //   3

  c_p[x_a][8] = {  4,   5}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  5,   6,   7}; //   3

  c_p[x_a][9] = {  4,   5}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  5,   6,   7}; //   3

  c_p[x_a][10] = {  6,   5}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  5,   6,   7}; //   3

  c_p[x_a][11] = {  6,   5}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   6,   7}; //   3

  c_p[x_a][12] = {  4,   7}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  8,   9,   7}; //   3

  c_p[x_a][13] = {  4,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  8,   9,   7}; //   3

  c_p[x_a][14] = {  6,   7}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  8,   9,   7}; //   3

  c_p[x_a][15] = {  6,   7}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  8,   9,   7}; //   3

  c_p[x_a][16] = {  0,   8}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = {  7,   2}; //   2

  c_p[x_a][17] = {  0,   9}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = {  7,   2}; //   2

  c_p[x_a][18] = {  2,   8}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = {  7,   2}; //   2

  c_p[x_a][19] = {  2,   9}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = {  7,   2}; //   2

  c_p[x_a][20] = {  4,  10}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  1}; //   1
  c_d[x_a][20] = {  2,   7}; //   2

  c_p[x_a][21] = {  4,  11}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  1}; //   1
  c_d[x_a][21] = {  2,   7}; //   2

  c_p[x_a][22] = {  6,  10}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  1}; //   1
  c_d[x_a][22] = {  2,   7}; //   2

  c_p[x_a][23] = {  6,  11}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  1}; //   1
  c_d[x_a][23] = {  2,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_040_uux_emmumepmup
//  channel    0: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel    1: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,  23)
//  channel    2: 4yyv(1, 2, 4, 16, 8, 32;  23,   0,   0)
//  channel    3: 4yyv(1, 2, 4, 16, 8, 32;  23,   0,  23)
//  channel    4: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    5: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,  23)
//  channel    6: 4yyv(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel    7: 4yyv(1, 2, 16, 4, 8, 32;  23,   0,  23)
//  channel    8: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel    9: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,  23)
//  channel   10: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,   0)
//  channel   11: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,  23)
//  channel   12: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   13: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,  23)
//  channel   14: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,   0)
//  channel   15: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,  23)
//  channel   16: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel   17: 2v2v(1, 2, 4, 16, 8, 32;   0,  23,   0)
//  channel   18: 2v2v(1, 2, 4, 16, 8, 32;  23,   0,   0)
//  channel   19: 2v2v(1, 2, 4, 16, 8, 32;  23,  23,   0)
//  channel   20: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel   21: 2v2v(1, 2, 8, 32, 4, 16;   0,  23,   0)
//  channel   22: 2v2v(1, 2, 8, 32, 4, 16;  23,   0,   0)
//  channel   23: 2v2v(1, 2, 8, 32, 4, 16;  23,  23,   0)
