#include "header.hpp"

#include "ppemexmx04.phasespace.set.hpp"

void ppemexmx04_phasespace_set::ax_psp_140_gdx_emmumepmupdx(int x_a){
  static Logger logger("ppemexmx04_phasespace_set::ax_psp_140_gdx_emmumepmupdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(13);
  needed_v_smin[x_a].resize(13);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  needed_v_smin[x_a][  3] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  needed_v_smin[x_a][  4] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  needed_v_smin[x_a][  5] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  needed_v_smin[x_a][  6] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  needed_v_smin[x_a][  7] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  needed_v_smin[x_a][  8] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  needed_v_smin[x_a][  9] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  needed_v_smin[x_a][ 10] = {  16,   17,   18,   19,   44,   45,   46,   47}; //   8
  needed_v_smin[x_a][ 11] = {  20,   21,   22,   23,   40,   41,   42,   43}; //   8
  needed_v_smin[x_a][ 12] = {  48,   49,   50,   51,   52,   53,   54,   55}; //   8

  v_smax[x_a].resize(15);
  needed_v_smax[x_a].resize(15);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   48,   49,   50,   51}; //  28
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  needed_v_smax[x_a][  3] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  needed_v_smax[x_a][  4] = {   8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23,   32,   33,   34,   35,   36,   37,   38,   39,   44,   45,   46,   47,   52,   53,   54,   55}; //  28
  needed_v_smax[x_a][  5] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  needed_v_smax[x_a][  6] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  needed_v_smax[x_a][  7] = {  16,   17,   18,   19}; //   4
  needed_v_smax[x_a][  8] = {  16,   17,   18,   19}; //   4
  needed_v_smax[x_a][  9] = {  20,   21,   22,   23}; //   4
  needed_v_smax[x_a][ 10] = {  20,   21,   22,   23}; //   4
  needed_v_smax[x_a][ 11] = {  40,   41,   42,   43,   48,   49,   50,   51}; //   8
  needed_v_smax[x_a][ 12] = {  40,   41,   42,   43}; //   4
  needed_v_smax[x_a][ 13] = {  44,   45,   46,   47,   52,   53,   54,   55}; //   8
  needed_v_smax[x_a][ 14] = {  44,   45,   46,   47}; //   4

  g_p[x_a].resize(28);
  needed_g_p[x_a].resize(28);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   16,   17,   24,   25,   28,   29,   40,   41,   48,   49}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   24,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   25,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    6,    7,   18,   19,   26,   27,   30,   31,   42,   43,   50,   51}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][5] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   4,    6,   28,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][7] = {   5,    7,   29,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][8] = {   8,    9,   12,   13,   20,   21,   32,   33,   36,   37,   44,   45,   52,   53}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][9] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][10] = {   8,   10,   32,   34}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][11] = {   9,   11,   33,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][12] = {  10,   11,   14,   15,   22,   23,   34,   35,   38,   39,   46,   47,   54,   55}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax4");
  needed_g_p[x_a][13] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][14] = {  12,   14,   36,   38}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][15] = {  13,   15,   37,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][16] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][17] = {  16,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax8");
  needed_g_p[x_a][18] = {  17,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax8");
  needed_g_p[x_a][19] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][20] = {  20,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax10");
  needed_g_p[x_a][21] = {  21,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax10");
  needed_g_p[x_a][22] = {  40,   42,   48,   50}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax11");
  needed_g_p[x_a][23] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax12");
  needed_g_p[x_a][24] = {  41,   43,   49,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax11");
  needed_g_p[x_a][25] = {  44,   46,   52,   54}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax13");
  needed_g_p[x_a][26] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax14");
  needed_g_p[x_a][27] = {  45,   47,   53,   55}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax13");

  g_f[x_a].resize(1);
  needed_g_f[x_a].resize(1);
  needed_g_f[x_a][0] = {  48,   49,   50,   51,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax2");

  g_t[x_a].resize(5);
  needed_g_t[x_a].resize(5);
  needed_g_t[x_a][0] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   48,   49,   50,   51,   52,   53,   54,   55}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_84");
  needed_g_t[x_a][2] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_104");
  needed_g_t[x_a][3] = {  48,   49,   50,   51}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_20");
  needed_g_t[x_a][4] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_40");

  g_d[x_a].resize(15);
  needed_g_d[x_a].resize(15);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][5] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][6] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][7] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][8] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][9] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][10] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][11] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][12] = {  16,   17,   18,   19,   44,   45,   46,   47}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][13] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][14] = {  20,   21,   22,   23,   40,   41,   42,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");

  c_p[x_a].resize(56);
  c_f[x_a].resize(56);
  c_t[x_a].resize(56);
  c_d[x_a].resize(56);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  4,   1,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   2,   3}; //   4

  c_p[x_a][3] = {  4,   1,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   2,   3}; //   4

  c_p[x_a][4] = {  0,   5,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   4,   5,   3}; //   4

  c_p[x_a][5] = {  0,   5,   7}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   4,   5,   3}; //   4

  c_p[x_a][6] = {  4,   5,   6}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   4,   5,   3}; //   4

  c_p[x_a][7] = {  4,   5,   7}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,   4,   5,   3}; //   4

  c_p[x_a][8] = {  8,   9,  10}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   6,   7,   8}; //   4

  c_p[x_a][9] = {  8,   9,  11}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,   6,   7,   8}; //   4

  c_p[x_a][10] = { 12,   9,  10}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,   6,   7,   8}; //   4

  c_p[x_a][11] = { 12,   9,  11}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,   6,   7,   8}; //   4

  c_p[x_a][12] = {  8,  13,  14}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,   9,  10,   8}; //   4

  c_p[x_a][13] = {  8,  13,  15}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  0,   9,  10,   8}; //   4

  c_p[x_a][14] = { 12,  13,  14}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  0,   9,  10,   8}; //   4

  c_p[x_a][15] = { 12,  13,  15}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  0,   9,  10,   8}; //   4

  c_p[x_a][16] = {  0,  16,  17}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 11,   8,  12,   3}; //   4

  c_p[x_a][17] = {  0,  16,  18}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 11,   8,  12,   3}; //   4

  c_p[x_a][18] = {  4,  16,  17}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 11,   8,  12,   3}; //   4

  c_p[x_a][19] = {  4,  16,  18}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 11,   8,  12,   3}; //   4

  c_p[x_a][20] = {  8,  19,  20}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 13,   3,  14,   8}; //   4

  c_p[x_a][21] = {  8,  19,  21}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 13,   3,  14,   8}; //   4

  c_p[x_a][22] = { 12,  19,  20}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 13,   3,  14,   8}; //   4

  c_p[x_a][23] = { 12,  19,  21}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 13,   3,  14,   8}; //   4

  c_p[x_a][24] = {  0,   1,   2}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  1,   2,   3}; //   3

  c_p[x_a][25] = {  0,   1,   3}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  1,   2,   3}; //   3

  c_p[x_a][26] = {  4,   1,   2}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  1,   2,   3}; //   3

  c_p[x_a][27] = {  4,   1,   3}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  1,   2,   3}; //   3

  c_p[x_a][28] = {  0,   5,   6}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = {  4,   5,   3}; //   3

  c_p[x_a][29] = {  0,   5,   7}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = {  4,   5,   3}; //   3

  c_p[x_a][30] = {  4,   5,   6}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = {  4,   5,   3}; //   3

  c_p[x_a][31] = {  4,   5,   7}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = {  4,   5,   3}; //   3

  c_p[x_a][32] = {  8,   9,  10}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  0}; //   1
  c_d[x_a][32] = {  6,   7,   8}; //   3

  c_p[x_a][33] = {  8,   9,  11}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  0}; //   1
  c_d[x_a][33] = {  6,   7,   8}; //   3

  c_p[x_a][34] = { 12,   9,  10}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  0}; //   1
  c_d[x_a][34] = {  6,   7,   8}; //   3

  c_p[x_a][35] = { 12,   9,  11}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  0}; //   1
  c_d[x_a][35] = {  6,   7,   8}; //   3

  c_p[x_a][36] = {  8,  13,  14}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  0}; //   1
  c_d[x_a][36] = {  9,  10,   8}; //   3

  c_p[x_a][37] = {  8,  13,  15}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  0}; //   1
  c_d[x_a][37] = {  9,  10,   8}; //   3

  c_p[x_a][38] = { 12,  13,  14}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  0}; //   1
  c_d[x_a][38] = {  9,  10,   8}; //   3

  c_p[x_a][39] = { 12,  13,  15}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  0}; //   1
  c_d[x_a][39] = {  9,  10,   8}; //   3

  c_p[x_a][40] = {  0,  22,  23}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  1}; //   1
  c_d[x_a][40] = { 14,   8,   3}; //   3

  c_p[x_a][41] = {  0,  24,  23}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  1}; //   1
  c_d[x_a][41] = { 14,   8,   3}; //   3

  c_p[x_a][42] = {  4,  22,  23}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  1}; //   1
  c_d[x_a][42] = { 14,   8,   3}; //   3

  c_p[x_a][43] = {  4,  24,  23}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  1}; //   1
  c_d[x_a][43] = { 14,   8,   3}; //   3

  c_p[x_a][44] = {  8,  25,  26}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  2}; //   1
  c_d[x_a][44] = { 12,   3,   8}; //   3

  c_p[x_a][45] = {  8,  27,  26}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  2}; //   1
  c_d[x_a][45] = { 12,   3,   8}; //   3

  c_p[x_a][46] = { 12,  25,  26}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  2}; //   1
  c_d[x_a][46] = { 12,   3,   8}; //   3

  c_p[x_a][47] = { 12,  27,  26}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  2}; //   1
  c_d[x_a][47] = { 12,   3,   8}; //   3

  c_p[x_a][48] = {  0,  22}; //   2
  c_f[x_a][48] = {  0}; //   1
  c_t[x_a][48] = {  0,   3}; //   2
  c_d[x_a][48] = {  8,   3}; //   2

  c_p[x_a][49] = {  0,  24}; //   2
  c_f[x_a][49] = {  0}; //   1
  c_t[x_a][49] = {  0,   3}; //   2
  c_d[x_a][49] = {  8,   3}; //   2

  c_p[x_a][50] = {  4,  22}; //   2
  c_f[x_a][50] = {  0}; //   1
  c_t[x_a][50] = {  0,   3}; //   2
  c_d[x_a][50] = {  8,   3}; //   2

  c_p[x_a][51] = {  4,  24}; //   2
  c_f[x_a][51] = {  0}; //   1
  c_t[x_a][51] = {  0,   3}; //   2
  c_d[x_a][51] = {  8,   3}; //   2

  c_p[x_a][52] = {  8,  25}; //   2
  c_f[x_a][52] = {  0}; //   1
  c_t[x_a][52] = {  0,   4}; //   2
  c_d[x_a][52] = {  3,   8}; //   2

  c_p[x_a][53] = {  8,  27}; //   2
  c_f[x_a][53] = {  0}; //   1
  c_t[x_a][53] = {  0,   4}; //   2
  c_d[x_a][53] = {  3,   8}; //   2

  c_p[x_a][54] = { 12,  25}; //   2
  c_f[x_a][54] = {  0}; //   1
  c_t[x_a][54] = {  0,   4}; //   2
  c_d[x_a][54] = {  3,   8}; //   2

  c_p[x_a][55] = { 12,  27}; //   2
  c_f[x_a][55] = {  0}; //   1
  c_t[x_a][55] = {  0,   4}; //   2
  c_d[x_a][55] = {  3,   8}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_gdx_emmumepmupdx
//  channel    0: 5yyyv(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
//  channel    1: 5yyyv(1, 2, 64, 4, 16, 8, 32;   0,   0,  23,   0)
//  channel    2: 5yyyv(1, 2, 64, 4, 16, 8, 32;  23,   0,   0,   0)
//  channel    3: 5yyyv(1, 2, 64, 4, 16, 8, 32;  23,   0,  23,   0)
//  channel    4: 5yyyv(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
//  channel    5: 5yyyv(1, 2, 64, 16, 4, 8, 32;   0,   0,  23,   0)
//  channel    6: 5yyyv(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
//  channel    7: 5yyyv(1, 2, 64, 16, 4, 8, 32;  23,   0,  23,   0)
//  channel    8: 5yyyv(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
//  channel    9: 5yyyv(1, 2, 64, 8, 32, 4, 16;   0,   0,  23,   0)
//  channel   10: 5yyyv(1, 2, 64, 8, 32, 4, 16;  23,   0,   0,   0)
//  channel   11: 5yyyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  23,   0)
//  channel   12: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
//  channel   13: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  23,   0)
//  channel   14: 5yyyv(1, 2, 64, 32, 8, 4, 16;  23,   0,   0,   0)
//  channel   15: 5yyyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  23,   0)
//  channel   16: 52vyv(1, 2, 4, 16, 64, 8, 32;   0,   0,   0,   0)
//  channel   17: 52vyv(1, 2, 4, 16, 64, 8, 32;   0,   0,  23,   0)
//  channel   18: 52vyv(1, 2, 4, 16, 64, 8, 32;  23,   0,   0,   0)
//  channel   19: 52vyv(1, 2, 4, 16, 64, 8, 32;  23,   0,  23,   0)
//  channel   20: 52vyv(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
//  channel   21: 52vyv(1, 2, 8, 32, 64, 4, 16;   0,   0,  23,   0)
//  channel   22: 52vyv(1, 2, 8, 32, 64, 4, 16;  23,   0,   0,   0)
//  channel   23: 52vyv(1, 2, 8, 32, 64, 4, 16;  23,   0,  23,   0)
//  channel   24: 14yyv(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
//  channel   25: 14yyv(1, 2, 64, 4, 16, 8, 32;   0,   0,  23,   0)
//  channel   26: 14yyv(1, 2, 64, 4, 16, 8, 32;  23,   0,   0,   0)
//  channel   27: 14yyv(1, 2, 64, 4, 16, 8, 32;  23,   0,  23,   0)
//  channel   28: 14yyv(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
//  channel   29: 14yyv(1, 2, 64, 16, 4, 8, 32;   0,   0,  23,   0)
//  channel   30: 14yyv(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
//  channel   31: 14yyv(1, 2, 64, 16, 4, 8, 32;  23,   0,  23,   0)
//  channel   32: 14yyv(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
//  channel   33: 14yyv(1, 2, 64, 8, 32, 4, 16;   0,   0,  23,   0)
//  channel   34: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,   0,   0)
//  channel   35: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  23,   0)
//  channel   36: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
//  channel   37: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  23,   0)
//  channel   38: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,   0,   0)
//  channel   39: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  23,   0)
//  channel   40: 3yv2v(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
//  channel   41: 3yv2v(1, 2, 64, 4, 16, 8, 32;   0,  23,   0,   0)
//  channel   42: 3yv2v(1, 2, 64, 4, 16, 8, 32;  23,   0,   0,   0)
//  channel   43: 3yv2v(1, 2, 64, 4, 16, 8, 32;  23,  23,   0,   0)
//  channel   44: 3yv2v(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
//  channel   45: 3yv2v(1, 2, 64, 8, 32, 4, 16;   0,  23,   0,   0)
//  channel   46: 3yv2v(1, 2, 64, 8, 32, 4, 16;  23,   0,   0,   0)
//  channel   47: 3yv2v(1, 2, 64, 8, 32, 4, 16;  23,  23,   0,   0)
//  channel   48: 12v2v(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
//  channel   49: 12v2v(1, 2, 64, 4, 16, 8, 32;   0,  23,   0,   0)
//  channel   50: 12v2v(1, 2, 64, 4, 16, 8, 32;  23,   0,   0,   0)
//  channel   51: 12v2v(1, 2, 64, 4, 16, 8, 32;  23,  23,   0,   0)
//  channel   52: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
//  channel   53: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,  23,   0,   0)
//  channel   54: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,   0,   0,   0)
//  channel   55: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,  23,   0,   0)

void ppemexmx04_phasespace_set::ax_psp_340_gdx_emmumepmupdx(int x_a){
  static Logger logger("ppemexmx04_phasespace_set::ax_psp_340_gdx_emmumepmupdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(13);
  needed_v_smin[x_a].resize(13);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56}; //  49
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 49);
  int needed_v_smin_1[] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   4,    5,    6,    7}; //   4
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 4);
  int needed_v_smin_4[] = {   4,    5,    6,    7}; //   4
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56}; //  49
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 49);
  int needed_v_smin_6[] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 4);
  int needed_v_smin_7[] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 4);
  int needed_v_smin_8[] = {  12,   13,   14,   15}; //   4
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 4);
  int needed_v_smin_9[] = {  12,   13,   14,   15}; //   4
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 4);
  int needed_v_smin_10[] = {  16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  25
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 25);
  int needed_v_smin_11[] = {  41,   42,   43,   44,   49,   50,   51,   52}; //   8
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 8);
  int needed_v_smin_12[] = {  45,   46,   47,   48,   53,   54,   55,   56}; //   8
  needed_v_smin[x_a][ 12] = get_vector_from_array_int(needed_v_smin_12, 8);

  v_smax[x_a].resize(15);
  needed_v_smax[x_a].resize(15);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   41,   42,   43,   44,   49,   50,   51,   52}; //  33
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 33);
  int needed_v_smax_1[] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 4);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  41
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 41);
  int needed_v_smax_3[] = {   4,    5,    6,    7}; //   4
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 4);
  int needed_v_smax_4[] = {   8,    9,   10,   11,   12,   13,   14,   15,   33,   34,   35,   36,   37,   38,   39,   40,   45,   46,   47,   48,   53,   54,   55,   56}; //  24
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 24);
  int needed_v_smax_5[] = {   8,    9,   10,   11}; //   4
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 4);
  int needed_v_smax_6[] = {  12,   13,   14,   15}; //   4
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 4);
  int needed_v_smax_7[] = {  16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   49,   50,   51,   52}; //  21
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 21);
  int needed_v_smax_8[] = {  33,   34,   35,   36,   37,   38,   39,   40,   53,   54,   55,   56}; //  12
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 12);
  int needed_v_smax_9[] = {  41,   42,   43,   44}; //   4
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 4);
  int needed_v_smax_10[] = {  41,   42,   43,   44}; //   4
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 4);
  int needed_v_smax_11[] = {  45,   46,   47,   48}; //   4
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 4);
  int needed_v_smax_12[] = {  45,   46,   47,   48}; //   4
  needed_v_smax[x_a][ 12] = get_vector_from_array_int(needed_v_smax_12, 4);
  int needed_v_smax_13[] = {  49,   50,   51,   52}; //   4
  needed_v_smax[x_a][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  53,   54,   55,   56}; //   4
  needed_v_smax[x_a][ 14] = get_vector_from_array_int(needed_v_smax_14, 4);

  g_p[x_a].resize(29);
  needed_g_p[x_a].resize(29);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   16,   17,   18,   19,   25,   26,   27,   28,   41,   42,   49,   50}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    6,    7,   20,   21,   22,   23,   24,   29,   30,   31,   32,   43,   44,   51,   52}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][5] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   4,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][7] = {   5,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][8] = {   8,    9,   12,   13,   33,   34,   35,   36,   45,   46,   53,   54}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][9] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][10] = {   8,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][11] = {   9,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][12] = {  10,   11,   14,   15,   37,   38,   39,   40,   47,   48,   55,   56}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax4");
  needed_g_p[x_a][13] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][14] = {  12,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][15] = {  13,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][16] = {  16,   17,   20,   21,   25,   26,   29,   30,   49,   51}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax7");
  needed_g_p[x_a][17] = {  16,   18,   20,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][18] = {  17,   19,   21,   24}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin10_smax2");
  needed_g_p[x_a][19] = {  18,   19,   22,   23,   24,   27,   28,   31,   32,   50,   52}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax7");
  needed_g_p[x_a][20] = {  22}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][21] = {  33,   34,   37,   38,   53,   55}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax8");
  needed_g_p[x_a][22] = {  35,   36,   39,   40,   54,   56}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax8");
  needed_g_p[x_a][23] = {  41,   42,   43,   44}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][24] = {  41,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax10");
  needed_g_p[x_a][25] = {  42,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax10");
  needed_g_p[x_a][26] = {  45,   46,   47,   48}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax11");
  needed_g_p[x_a][27] = {  45,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax12");
  needed_g_p[x_a][28] = {  46,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax12");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax2");
  needed_g_f[x_a][1] = {  49,   50,   51,   52}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax13");
  needed_g_f[x_a][2] = {  53,   54,   55,   56}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax14");

  g_t[x_a].resize(9);
  needed_g_t[x_a].resize(9);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  41
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  25,   27,   29,   31}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__20_40");
  needed_g_t[x_a][2] = {  26,   28,   30,   32}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__20_40");
  needed_g_t[x_a][3] = {  33,   35,   37,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__40_20");
  needed_g_t[x_a][4] = {  34,   36,   38,   40}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__40_20");
  needed_g_t[x_a][5] = {  41,   42,   43,   44,   49,   50,   51,   52}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_104");
  needed_g_t[x_a][6] = {  45,   46,   47,   48,   53,   54,   55,   56}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_84");
  needed_g_t[x_a][7] = {  49,   50,   51,   52}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_64");
  needed_g_t[x_a][8] = {  53,   54,   55,   56}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_64");

  g_d[x_a].resize(13);
  needed_g_d[x_a].resize(13);
  needed_g_d[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56}; //  49
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][5] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][7] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56}; //  49
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][8] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][10] = {  16,   17,   18,   19,   20,   21,   22,   23,   24}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][11] = {  41,   42,   43,   44}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][12] = {  45,   46,   47,   48}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");

  c_p[x_a].resize(57);
  c_f[x_a].resize(57);
  c_t[x_a].resize(57);
  c_d[x_a].resize(57);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   1,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  4,   1,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   5,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   5,   7}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  4,   5,   6}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  3,   4,   2}; //   3

  c_p[x_a][7] = {  4,   5,   7}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  3,   4,   2}; //   3

  c_p[x_a][8] = {  8,   9,  10}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  5,   6,   7}; //   3

  c_p[x_a][9] = {  8,   9,  11}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  5,   6,   7}; //   3

  c_p[x_a][10] = { 12,   9,  10}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  5,   6,   7}; //   3

  c_p[x_a][11] = { 12,   9,  11}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  5,   6,   7}; //   3

  c_p[x_a][12] = {  8,  13,  14}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  8,   9,   7}; //   3

  c_p[x_a][13] = {  8,  13,  15}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  8,   9,   7}; //   3

  c_p[x_a][14] = { 12,  13,  14}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = {  8,   9,   7}; //   3

  c_p[x_a][15] = { 12,  13,  15}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = {  8,   9,   7}; //   3

  c_p[x_a][16] = {  0,  16,  17}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 10,   7,   2}; //   3

  c_p[x_a][17] = {  0,  16,  18}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 10,   7,   2}; //   3

  c_p[x_a][18] = {  0,  19,  17}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 10,   7,   2}; //   3

  c_p[x_a][19] = {  0,  19,  18}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 10,   7,   2}; //   3

  c_p[x_a][20] = {  4,  16,  17}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = { 10,   7,   2}; //   3

  c_p[x_a][21] = {  4,  16,  18}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = { 10,   7,   2}; //   3

  c_p[x_a][22] = {  4,  19,  20}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = { 10,   7,   2}; //   3

  c_p[x_a][23] = {  4,  19,  17}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = { 10,   7,   2}; //   3

  c_p[x_a][24] = {  4,  19,  18}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = { 10,   7,   2}; //   3

  c_p[x_a][25] = {  0,  16}; //   2
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  0,   1}; //   2
  c_d[x_a][25] = {  7,   2}; //   2

  c_p[x_a][26] = {  0,  16}; //   2
  c_f[x_a][26] = {  0}; //   1
  c_t[x_a][26] = {  0,   2}; //   2
  c_d[x_a][26] = {  7,   2}; //   2

  c_p[x_a][27] = {  0,  19}; //   2
  c_f[x_a][27] = {  0}; //   1
  c_t[x_a][27] = {  0,   1}; //   2
  c_d[x_a][27] = {  7,   2}; //   2

  c_p[x_a][28] = {  0,  19}; //   2
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  0,   2}; //   2
  c_d[x_a][28] = {  7,   2}; //   2

  c_p[x_a][29] = {  4,  16}; //   2
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  0,   1}; //   2
  c_d[x_a][29] = {  7,   2}; //   2

  c_p[x_a][30] = {  4,  16}; //   2
  c_f[x_a][30] = {  0}; //   1
  c_t[x_a][30] = {  0,   2}; //   2
  c_d[x_a][30] = {  7,   2}; //   2

  c_p[x_a][31] = {  4,  19}; //   2
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  0,   1}; //   2
  c_d[x_a][31] = {  7,   2}; //   2

  c_p[x_a][32] = {  4,  19}; //   2
  c_f[x_a][32] = {  0}; //   1
  c_t[x_a][32] = {  0,   2}; //   2
  c_d[x_a][32] = {  7,   2}; //   2

  c_p[x_a][33] = {  8,  21}; //   2
  c_f[x_a][33] = {  0}; //   1
  c_t[x_a][33] = {  0,   3}; //   2
  c_d[x_a][33] = {  2,   7}; //   2

  c_p[x_a][34] = {  8,  21}; //   2
  c_f[x_a][34] = {  0}; //   1
  c_t[x_a][34] = {  0,   4}; //   2
  c_d[x_a][34] = {  2,   7}; //   2

  c_p[x_a][35] = {  8,  22}; //   2
  c_f[x_a][35] = {  0}; //   1
  c_t[x_a][35] = {  0,   3}; //   2
  c_d[x_a][35] = {  2,   7}; //   2

  c_p[x_a][36] = {  8,  22}; //   2
  c_f[x_a][36] = {  0}; //   1
  c_t[x_a][36] = {  0,   4}; //   2
  c_d[x_a][36] = {  2,   7}; //   2

  c_p[x_a][37] = { 12,  21}; //   2
  c_f[x_a][37] = {  0}; //   1
  c_t[x_a][37] = {  0,   3}; //   2
  c_d[x_a][37] = {  2,   7}; //   2

  c_p[x_a][38] = { 12,  21}; //   2
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  0,   4}; //   2
  c_d[x_a][38] = {  2,   7}; //   2

  c_p[x_a][39] = { 12,  22}; //   2
  c_f[x_a][39] = {  0}; //   1
  c_t[x_a][39] = {  0,   3}; //   2
  c_d[x_a][39] = {  2,   7}; //   2

  c_p[x_a][40] = { 12,  22}; //   2
  c_f[x_a][40] = {  0}; //   1
  c_t[x_a][40] = {  0,   4}; //   2
  c_d[x_a][40] = {  2,   7}; //   2

  c_p[x_a][41] = {  0,  23,  24}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  5}; //   1
  c_d[x_a][41] = {  7,  11,   2}; //   3

  c_p[x_a][42] = {  0,  23,  25}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  5}; //   1
  c_d[x_a][42] = {  7,  11,   2}; //   3

  c_p[x_a][43] = {  4,  23,  24}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  5}; //   1
  c_d[x_a][43] = {  7,  11,   2}; //   3

  c_p[x_a][44] = {  4,  23,  25}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  5}; //   1
  c_d[x_a][44] = {  7,  11,   2}; //   3

  c_p[x_a][45] = {  8,  26,  27}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  6}; //   1
  c_d[x_a][45] = {  2,  12,   7}; //   3

  c_p[x_a][46] = {  8,  26,  28}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  6}; //   1
  c_d[x_a][46] = {  2,  12,   7}; //   3

  c_p[x_a][47] = { 12,  26,  27}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  6}; //   1
  c_d[x_a][47] = {  2,  12,   7}; //   3

  c_p[x_a][48] = { 12,  26,  28}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  6}; //   1
  c_d[x_a][48] = {  2,  12,   7}; //   3

  c_p[x_a][49] = {  0,  16}; //   2
  c_f[x_a][49] = {  1}; //   1
  c_t[x_a][49] = {  5,   7}; //   2
  c_d[x_a][49] = {  7,   2}; //   2

  c_p[x_a][50] = {  0,  19}; //   2
  c_f[x_a][50] = {  1}; //   1
  c_t[x_a][50] = {  5,   7}; //   2
  c_d[x_a][50] = {  7,   2}; //   2

  c_p[x_a][51] = {  4,  16}; //   2
  c_f[x_a][51] = {  1}; //   1
  c_t[x_a][51] = {  5,   7}; //   2
  c_d[x_a][51] = {  7,   2}; //   2

  c_p[x_a][52] = {  4,  19}; //   2
  c_f[x_a][52] = {  1}; //   1
  c_t[x_a][52] = {  5,   7}; //   2
  c_d[x_a][52] = {  7,   2}; //   2

  c_p[x_a][53] = {  8,  21}; //   2
  c_f[x_a][53] = {  2}; //   1
  c_t[x_a][53] = {  6,   8}; //   2
  c_d[x_a][53] = {  2,   7}; //   2

  c_p[x_a][54] = {  8,  22}; //   2
  c_f[x_a][54] = {  2}; //   1
  c_t[x_a][54] = {  6,   8}; //   2
  c_d[x_a][54] = {  2,   7}; //   2

  c_p[x_a][55] = { 12,  21}; //   2
  c_f[x_a][55] = {  2}; //   1
  c_t[x_a][55] = {  6,   8}; //   2
  c_d[x_a][55] = {  2,   7}; //   2

  c_p[x_a][56] = { 12,  22}; //   2
  c_f[x_a][56] = {  2}; //   1
  c_t[x_a][56] = {  6,   8}; //   2
  c_d[x_a][56] = {  2,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_gdx_emmumepmupdx
//  channel    0: 4yyv1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
//  channel    1: 4yyv1(1, 2, 4, 16, 8, 32, 64;   0,   0,  23,   0)
//  channel    2: 4yyv1(1, 2, 4, 16, 8, 32, 64;  23,   0,   0,   0)
//  channel    3: 4yyv1(1, 2, 4, 16, 8, 32, 64;  23,   0,  23,   0)
//  channel    4: 4yyv1(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
//  channel    5: 4yyv1(1, 2, 16, 4, 8, 32, 64;   0,   0,  23,   0)
//  channel    6: 4yyv1(1, 2, 16, 4, 8, 32, 64;  23,   0,   0,   0)
//  channel    7: 4yyv1(1, 2, 16, 4, 8, 32, 64;  23,   0,  23,   0)
//  channel    8: 4yyv1(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
//  channel    9: 4yyv1(1, 2, 8, 32, 4, 16, 64;   0,   0,  23,   0)
//  channel   10: 4yyv1(1, 2, 8, 32, 4, 16, 64;  23,   0,   0,   0)
//  channel   11: 4yyv1(1, 2, 8, 32, 4, 16, 64;  23,   0,  23,   0)
//  channel   12: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
//  channel   13: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,  23,   0)
//  channel   14: 4yyv1(1, 2, 32, 8, 4, 16, 64;  23,   0,   0,   0)
//  channel   15: 4yyv1(1, 2, 32, 8, 4, 16, 64;  23,   0,  23,   0)
//  channel   16: 42vv1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
//  channel   17: 42vv1(1, 2, 4, 16, 8, 32, 64;   0,   0,  36,   0)
//  channel   18: 42vv1(1, 2, 4, 16, 8, 32, 64;   0,  23,   0,   0)
//  channel   19: 42vv1(1, 2, 4, 16, 8, 32, 64;   0,  23,  36,   0)
//  channel   20: 42vv1(1, 2, 4, 16, 8, 32, 64;  23,   0,   0,   0)
//  channel   21: 42vv1(1, 2, 4, 16, 8, 32, 64;  23,   0,  36,   0)
//  channel   22: 42vv1(1, 2, 4, 16, 8, 32, 64;  23,  23,  25,   0)
//  channel   23: 42vv1(1, 2, 4, 16, 8, 32, 64;  23,  23,   0,   0)
//  channel   24: 42vv1(1, 2, 4, 16, 8, 32, 64;  23,  23,  36,   0)
//  channel   25: 2v2v1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
//  channel   26: 2v2v1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,  36)
//  channel   27: 2v2v1(1, 2, 4, 16, 8, 32, 64;   0,  23,   0,   0)
//  channel   28: 2v2v1(1, 2, 4, 16, 8, 32, 64;   0,  23,   0,  36)
//  channel   29: 2v2v1(1, 2, 4, 16, 8, 32, 64;  23,   0,   0,   0)
//  channel   30: 2v2v1(1, 2, 4, 16, 8, 32, 64;  23,   0,   0,  36)
//  channel   31: 2v2v1(1, 2, 4, 16, 8, 32, 64;  23,  23,   0,   0)
//  channel   32: 2v2v1(1, 2, 4, 16, 8, 32, 64;  23,  23,   0,  36)
//  channel   33: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
//  channel   34: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,  36)
//  channel   35: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,  23,   0,   0)
//  channel   36: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,  23,   0,  36)
//  channel   37: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,   0,   0,   0)
//  channel   38: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,   0,   0,  36)
//  channel   39: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,  23,   0,   0)
//  channel   40: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,  23,   0,  36)
//  channel   41: 2v3yv(1, 2, 4, 16, 64, 8, 32;   0,   0,   0,   0)
//  channel   42: 2v3yv(1, 2, 4, 16, 64, 8, 32;   0,   0,  23,   0)
//  channel   43: 2v3yv(1, 2, 4, 16, 64, 8, 32;  23,   0,   0,   0)
//  channel   44: 2v3yv(1, 2, 4, 16, 64, 8, 32;  23,   0,  23,   0)
//  channel   45: 2v3yv(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
//  channel   46: 2v3yv(1, 2, 8, 32, 64, 4, 16;   0,   0,  23,   0)
//  channel   47: 2v3yv(1, 2, 8, 32, 64, 4, 16;  23,   0,   0,   0)
//  channel   48: 2v3yv(1, 2, 8, 32, 64, 4, 16;  23,   0,  23,   0)
//  channel   49: 2v12v(1, 2, 4, 16, 64, 8, 32;   0,   0,   0,   0)
//  channel   50: 2v12v(1, 2, 4, 16, 64, 8, 32;   0,  23,   0,   0)
//  channel   51: 2v12v(1, 2, 4, 16, 64, 8, 32;  23,   0,   0,   0)
//  channel   52: 2v12v(1, 2, 4, 16, 64, 8, 32;  23,  23,   0,   0)
//  channel   53: 2v12v(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
//  channel   54: 2v12v(1, 2, 8, 32, 64, 4, 16;   0,  23,   0,   0)
//  channel   55: 2v12v(1, 2, 8, 32, 64, 4, 16;  23,   0,   0,   0)
//  channel   56: 2v12v(1, 2, 8, 32, 64, 4, 16;  23,  23,   0,   0)
