#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_240_ddx_emmumepvmxudx(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_240_ddx_emmumepvmxudx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(24);
  needed_v_smin[x_a].resize(24);
  needed_v_smin[x_a][  0] = {   0,    4,    5,    6,   10,   11,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  needed_v_smin[x_a][  1] = {   0,    6,   16,   17}; //   4
  needed_v_smin[x_a][  2] = {   0,    6,   16,   17}; //   4
  needed_v_smin[x_a][  3] = {   1,    2,    3,    4,    5,    7,    8,    9,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  needed_v_smin[x_a][  4] = {   1,    7,   18,   19}; //   4
  needed_v_smin[x_a][  5] = {   1,    7,   18,   19}; //   4
  needed_v_smin[x_a][  6] = {   2,    3,    8,    9,   20,   21,   22,   23}; //   8
  needed_v_smin[x_a][  7] = {   2,    3,    8,    9,   20,   21,   22,   23}; //   8
  needed_v_smin[x_a][  8] = {   4,    5,   10,   11,   24,   25,   26,   27}; //   8
  needed_v_smin[x_a][  9] = {   6,    7,    8,    9,   10,   11,   17,   19,   22,   23,   26,   27,    0,    1,    2,    3,    4,    5}; //  18
  needed_v_smin[x_a][ 10] = {  12,   13,   28,   29,   38,   39,   44,   45,   50,   51,   56,   57,   58,   59,   62,   63,   40,   41}; //  18
  needed_v_smin[x_a][ 11] = {  12,   13,   28,   29,   40,   41,   44,   45}; //   8
  needed_v_smin[x_a][ 12] = {  14,   15,   32,   33,   36,   37,   46,   47,   42,   43}; //  10
  needed_v_smin[x_a][ 13] = {  14,   15,   32,   33,   42,   43,   46,   47}; //   8
  needed_v_smin[x_a][ 14] = {  16,   18,   20,   21,   24,   25}; //   6
  needed_v_smin[x_a][ 15] = {  30,   31,   36,   37,   48,   49,   60,   61}; //   8
  needed_v_smin[x_a][ 16] = {  30,   31}; //   2
  needed_v_smin[x_a][ 17] = {  34,   35,   38,   39,   52,   53,   56,   57}; //   8
  needed_v_smin[x_a][ 18] = {  34,   35}; //   2
  needed_v_smin[x_a][ 19] = {  48,   49,   60,   61}; //   4
  needed_v_smin[x_a][ 20] = {  50,   51,   62,   63,   58,   59}; //   6
  needed_v_smin[x_a][ 21] = {  52,   53}; //   2
  needed_v_smin[x_a][ 22] = {  54,   55}; //   2
  needed_v_smin[x_a][ 23] = {  54,   55}; //   2

  v_smax[x_a].resize(29);
  needed_v_smax[x_a].resize(29);
  needed_v_smax[x_a][  0] = {   0,    4,    5,    6,   10,   11,   12,   13,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   36,   37,   40,   41,   44,   45,   48,   49,   50,   51}; //  28
  needed_v_smax[x_a][  1] = {   0,    6,   16,   17}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  needed_v_smax[x_a][  3] = {   1,    2,    3,    7,    8,    9,   14,   15,   18,   19,   20,   21,   22,   23,   32,   33,   34,   35,   38,   39,   42,   43,   46,   47,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  36
  needed_v_smax[x_a][  4] = {   1,    7,   18,   19}; //   4
  needed_v_smax[x_a][  5] = {   2,    3,    8,    9,   20,   21,   22,   23}; //   8
  needed_v_smax[x_a][  6] = {   4,    5,   10,   11,   24,   25,   26,   27,   36,   37,   40,   41}; //  12
  needed_v_smax[x_a][  7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   17,   19,   22,   23,   26,   27,   28,   29,   32,   33,    0,    1,    2,    3,    4,    5,   40,   41,   42,   43,   44,   45,   46,   47}; //  34
  needed_v_smax[x_a][  8] = {  12,   13,   28,   29,   44,   45,   50,   51}; //   8
  needed_v_smax[x_a][  9] = {  12,   13,   28,   29,   44,   45}; //   6
  needed_v_smax[x_a][ 10] = {  14,   15,   32,   33,   46,   47}; //   6
  needed_v_smax[x_a][ 11] = {  14,   15,   32,   33,   46,   47}; //   6
  needed_v_smax[x_a][ 12] = {  16,   18,   20,   21,   24,   25,   30,   31,   34,   35}; //  10
  needed_v_smax[x_a][ 13] = {  30,   31,   48,   49}; //   4
  needed_v_smax[x_a][ 14] = {  30,   31}; //   2
  needed_v_smax[x_a][ 15] = {  34,   35,   52,   53,   56,   57}; //   6
  needed_v_smax[x_a][ 16] = {  34,   35,   52,   53,   56,   57}; //   6
  needed_v_smax[x_a][ 17] = {  36,   37,   60,   61}; //   4
  needed_v_smax[x_a][ 18] = {  36,   37}; //   2
  needed_v_smax[x_a][ 19] = {  38,   39,   42,   43,   54,   55,   58,   59,   60,   61,   62,   63}; //  12
  needed_v_smax[x_a][ 20] = {  38,   39}; //   2
  needed_v_smax[x_a][ 21] = {  38,   39,   56,   57}; //   4
  needed_v_smax[x_a][ 22] = {  48,   49,   50,   51}; //   4
  needed_v_smax[x_a][ 23] = {  48,   49,   50,   51}; //   4
  needed_v_smax[x_a][ 24] = {  58,   59,   62,   63,   40,   41}; //   6
  needed_v_smax[x_a][ 25] = {  60,   61,   62,   63,   58,   59}; //   6
  needed_v_smax[x_a][ 26] = {  42,   43}; //   2
  needed_v_smax[x_a][ 27] = {  52,   53,   54,   55}; //   4
  needed_v_smax[x_a][ 28] = {  54,   55}; //   2

  g_p[x_a].resize(40);
  needed_g_p[x_a].resize(40);
  needed_g_p[x_a][0] = {   0,    4,    5,    6,   10,   11,   12,   13,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   36,   37,   40,   41,   44,   45,   48,   49,   50,   51}; //  28
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    6,   16,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    6,   16,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,    7,    9,   15,   18,   19,   21,   23,   33,   35,   39,   43,   47,   53,   55,   57,   59,   61,   63}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    7,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   1,    7,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax2");
  needed_g_p[x_a][6] = {   2,    8,   14,   20,   22,   32,   34,   38,   42,   46,   52,   54,   56,   58,   60,   62}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][7] = {   2,    3,    8,    9,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   2,    3,    8,    9,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   10,   24,   26,   36,   40}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax6");
  needed_g_p[x_a][10] = {   4,    5,   10,   11,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   11,   25,   27,   37,   41}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax6");
  needed_g_p[x_a][12] = {   6,    7,    8,    9,   10,   11,   17,   19,   22,   23,   26,   27}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {  12,   13,   28,   29,   44,   45,   50,   51}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {  12,   28,   44}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax9");
  needed_g_p[x_a][15] = {  12,   13,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][16] = {  13,   29,   45}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax9");
  needed_g_p[x_a][17] = {  14,   15,   32,   33,   46,   47}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][18] = {  14,   15,   32,   33,   46,   47}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][19] = {  14,   15,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax7");
  needed_g_p[x_a][20] = {  16,   18,   20,   21,   24,   25}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax12");
  needed_g_p[x_a][21] = {  30,   31,   48,   49}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax13");
  needed_g_p[x_a][22] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax14");
  needed_g_p[x_a][23] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax12");
  needed_g_p[x_a][24] = {  31}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax14");
  needed_g_p[x_a][25] = {  34,   35,   52,   53,   56,   57}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax15");
  needed_g_p[x_a][26] = {  34,   35,   52,   53,   56,   57}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax16");
  needed_g_p[x_a][27] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax12");
  needed_g_p[x_a][28] = {  36,   37,   60,   61}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax17");
  needed_g_p[x_a][29] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax18");
  needed_g_p[x_a][30] = {  38,   39,   42,   43,   54,   55,   58,   59,   60,   61,   62,   63}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax19");
  needed_g_p[x_a][31] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax20");
  needed_g_p[x_a][32] = {  38,   39,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax21");
  needed_g_p[x_a][33] = {  48,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax22");
  needed_g_p[x_a][34] = {  48,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax23");
  needed_g_p[x_a][35] = {  49,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax23");
  needed_g_p[x_a][36] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax22");
  needed_g_p[x_a][37] = {  58,   59,   62,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax24");
  needed_g_p[x_a][38] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax25");
  needed_g_p[x_a][39] = {  62,   63}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax25");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][1] = {  40,   41}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax24");
  needed_g_f[x_a][2] = {  40,   41,   44,   45}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax7");
  needed_g_f[x_a][3] = {  42,   43}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax26");
  needed_g_f[x_a][4] = {  42,   43,   46,   47}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax7");
  needed_g_f[x_a][5] = {  52,   53}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax27");
  needed_g_f[x_a][6] = {  54,   55}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax28");
  needed_g_f[x_a][7] = {  54,   55}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax27");
  needed_g_f[x_a][8] = {  58,   59}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax25");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45,   46,   47}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {  40,   41,   44,   45}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__20_104");
  needed_g_t[x_a][3] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_21__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_21__64_40");
  needed_g_t[x_a][4] = {  42,   43,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__40_84");
  needed_g_t[x_a][5] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_41__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_41__64_20");
  needed_g_t[x_a][6] = {  48,   49,   50,   51}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_232");
  needed_g_t[x_a][7] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_212");
  needed_g_t[x_a][8] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__148_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__148_64");
  needed_g_t[x_a][9] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_192");
  needed_g_t[x_a][10] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__41_22__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__41_22__64_128");
  needed_g_t[x_a][11] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__104_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__104_148");
  needed_g_t[x_a][12] = {  58,   59,   60,   61,   62,   63}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_232");
  needed_g_t[x_a][13] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_22__104_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_22__104_128");

  g_d[x_a].resize(25);
  needed_g_d[x_a].resize(25);
  needed_g_d[x_a][0] = {   0,    6,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    6,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][2] = {   0,    4,    5,    6,   10,   11,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   1,    7,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][4] = {   1,    7,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][5] = {   1,    2,    3,    4,    5,    7,    8,    9,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {   2,    3,    8,    9,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   2,    3,    8,    9,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {   4,    5,   10,   11,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][9] = {   6,    7,    8,    9,   10,   11,   17,   19,   22,   23,   26,   27}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][10] = {  12,   13,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][11] = {  12,   13,   28,   29,   38,   39,   44,   45,   50,   51,   56,   57,   58,   59,   62,   63}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][12] = {  14,   15,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][13] = {  14,   15,   32,   33,   36,   37,   46,   47}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][14] = {  16,   18,   20,   21,   24,   25,   30,   31,   34,   35}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][15] = {  16,   18,   20,   21,   24,   25}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][16] = {  17,   19,   22,   23,   26,   27,   28,   29,   32,   33}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][17] = {  30,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__20_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__20_168");
  needed_g_d[x_a][18] = {  30,   31,   36,   37,   48,   49,   60,   61}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_168__128_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_168__128_40");
  needed_g_d[x_a][19] = {  34,   35}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__40_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__40_148");
  needed_g_d[x_a][20] = {  34,   35,   38,   39,   52,   53,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][21] = {  36,   37}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__84_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__84_168");
  needed_g_d[x_a][22] = {  38,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__104_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__104_148");
  needed_g_d[x_a][23] = {  48,   49,   60,   61}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_232__64_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_232__64_168");
  needed_g_d[x_a][24] = {  50,   51,   62,   63}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_232__128_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_232__128_104");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  3,   4,   5}; //   3

  c_p[x_a][2] = {  6,   7,   8}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  6,   7,   5}; //   3

  c_p[x_a][3] = {  3,   7,   8}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  8,   5,   2}; //   3

  c_p[x_a][5] = {  0,  11,  10}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  8,   5,   2}; //   3

  c_p[x_a][6] = {  0,   1,   2,  12}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  9,   0,   1,   2}; //   4

  c_p[x_a][7] = {  3,   4,   5,  12}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  9,   3,   4,   5}; //   4

  c_p[x_a][8] = {  6,   7,   8,  12}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  9,   6,   7,   5}; //   4

  c_p[x_a][9] = {  3,   7,   8,  12}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  9,   6,   7,   5}; //   4

  c_p[x_a][10] = {  0,   9,  10,  12}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  9,   8,   5,   2}; //   4

  c_p[x_a][11] = {  0,  11,  10,  12}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  9,   8,   5,   2}; //   4

  c_p[x_a][12] = {  0,  13,  14,  15}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 10,   5,  11,   2}; //   4

  c_p[x_a][13] = {  0,  13,  16,  15}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 10,   5,  11,   2}; //   4

  c_p[x_a][14] = {  6,  17,  18,  19}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 12,   2,  13,   5}; //   4

  c_p[x_a][15] = {  3,  17,  18,  19}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 12,   2,  13,   5}; //   4

  c_p[x_a][16] = {  0,   1,   2,  20}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 14,  15,   0,   1,   2}; //   5

  c_p[x_a][17] = {  0,   1,   2,  12}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 16,   9,   0,   1,   2}; //   5

  c_p[x_a][18] = {  3,   4,   5,  20}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 14,  15,   3,   4,   5}; //   5

  c_p[x_a][19] = {  3,   4,   5,  12}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 16,   9,   3,   4,   5}; //   5

  c_p[x_a][20] = {  6,   7,   8,  20}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 14,  15,   6,   7,   5}; //   5

  c_p[x_a][21] = {  3,   7,   8,  20}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 14,  15,   6,   7,   5}; //   5

  c_p[x_a][22] = {  6,   7,   8,  12}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 16,   9,   6,   7,   5}; //   5

  c_p[x_a][23] = {  3,   7,   8,  12}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 16,   9,   6,   7,   5}; //   5

  c_p[x_a][24] = {  0,   9,  10,  20}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 14,  15,   8,   5,   2}; //   5

  c_p[x_a][25] = {  0,  11,  10,  20}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 14,  15,   8,   5,   2}; //   5

  c_p[x_a][26] = {  0,   9,  10,  12}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 16,   9,   8,   5,   2}; //   5

  c_p[x_a][27] = {  0,  11,  10,  12}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 16,   9,   8,   5,   2}; //   5

  c_p[x_a][28] = {  0,  13,  14,  15}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 16,  10,   5,  11,   2}; //   5

  c_p[x_a][29] = {  0,  13,  16,  15}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 16,  10,   5,  11,   2}; //   5

  c_p[x_a][30] = {  0,  21,  22,  23}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 14,  17,   5,  18,   2}; //   5

  c_p[x_a][31] = {  0,  21,  24,  23}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 14,  17,   5,  18,   2}; //   5

  c_p[x_a][32] = {  6,  17,  18,  19}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 16,  12,   2,  13,   5}; //   5

  c_p[x_a][33] = {  3,  17,  18,  19}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 16,  12,   2,  13,   5}; //   5

  c_p[x_a][34] = {  6,  25,  26,  27}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 14,  19,   2,  20,   5}; //   5

  c_p[x_a][35] = {  3,  25,  26,  27}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 14,  19,   2,  20,   5}; //   5

  c_p[x_a][36] = {  0,   9,  28,  29}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 21,  13,  18,   5,   2}; //   5

  c_p[x_a][37] = {  0,  11,  28,  29}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 21,  13,  18,   5,   2}; //   5

  c_p[x_a][38] = {  6,  30,  31,  32}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 22,  11,  20,   2,   5}; //   5

  c_p[x_a][39] = {  3,  30,  31,  32}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 22,  11,  20,   2,   5}; //   5

  c_p[x_a][40] = {  0,   9}; //   2
  c_f[x_a][40] = {  1,   2}; //   2
  c_t[x_a][40] = {  0,   2,   3}; //   3
  c_d[x_a][40] = {  5,   2}; //   2

  c_p[x_a][41] = {  0,  11}; //   2
  c_f[x_a][41] = {  1,   2}; //   2
  c_t[x_a][41] = {  0,   2,   3}; //   3
  c_d[x_a][41] = {  5,   2}; //   2

  c_p[x_a][42] = {  6,  30}; //   2
  c_f[x_a][42] = {  3,   4}; //   2
  c_t[x_a][42] = {  0,   4,   5}; //   3
  c_d[x_a][42] = {  2,   5}; //   2

  c_p[x_a][43] = {  3,  30}; //   2
  c_f[x_a][43] = {  3,   4}; //   2
  c_t[x_a][43] = {  0,   4,   5}; //   3
  c_d[x_a][43] = {  2,   5}; //   2

  c_p[x_a][44] = {  0,  13,  14}; //   3
  c_f[x_a][44] = {  2}; //   1
  c_t[x_a][44] = {  0,   2}; //   2
  c_d[x_a][44] = {  5,  11,   2}; //   3

  c_p[x_a][45] = {  0,  13,  16}; //   3
  c_f[x_a][45] = {  2}; //   1
  c_t[x_a][45] = {  0,   2}; //   2
  c_d[x_a][45] = {  5,  11,   2}; //   3

  c_p[x_a][46] = {  6,  17,  18}; //   3
  c_f[x_a][46] = {  4}; //   1
  c_t[x_a][46] = {  0,   4}; //   2
  c_d[x_a][46] = {  2,  13,   5}; //   3

  c_p[x_a][47] = {  3,  17,  18}; //   3
  c_f[x_a][47] = {  4}; //   1
  c_t[x_a][47] = {  0,   4}; //   2
  c_d[x_a][47] = {  2,  13,   5}; //   3

  c_p[x_a][48] = {  0,  21,  33,  34}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  6}; //   1
  c_d[x_a][48] = {  5,  23,  18,   2}; //   4

  c_p[x_a][49] = {  0,  21,  33,  35}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  6}; //   1
  c_d[x_a][49] = {  5,  23,  18,   2}; //   4

  c_p[x_a][50] = {  0,  13,  36,  34}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  6}; //   1
  c_d[x_a][50] = {  5,  24,  11,   2}; //   4

  c_p[x_a][51] = {  0,  13,  36,  35}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  6}; //   1
  c_d[x_a][51] = {  5,  24,  11,   2}; //   4

  c_p[x_a][52] = {  6,  25,  26}; //   3
  c_f[x_a][52] = {  5}; //   1
  c_t[x_a][52] = {  7,   8}; //   2
  c_d[x_a][52] = {  2,  20,   5}; //   3

  c_p[x_a][53] = {  3,  25,  26}; //   3
  c_f[x_a][53] = {  5}; //   1
  c_t[x_a][53] = {  7,   8}; //   2
  c_d[x_a][53] = {  2,  20,   5}; //   3

  c_p[x_a][54] = {  6,  30}; //   2
  c_f[x_a][54] = {  6,   7}; //   2
  c_t[x_a][54] = {  7,   9,  10}; //   3
  c_d[x_a][54] = {  2,   5}; //   2

  c_p[x_a][55] = {  3,  30}; //   2
  c_f[x_a][55] = {  6,   7}; //   2
  c_t[x_a][55] = {  7,   9,  10}; //   3
  c_d[x_a][55] = {  2,   5}; //   2

  c_p[x_a][56] = {  6,  25,  26,  32}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = { 11}; //   1
  c_d[x_a][56] = { 11,   2,  20,   5}; //   4

  c_p[x_a][57] = {  3,  25,  26,  32}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = { 11}; //   1
  c_d[x_a][57] = { 11,   2,  20,   5}; //   4

  c_p[x_a][58] = {  6,  30,  37}; //   3
  c_f[x_a][58] = {  8}; //   1
  c_t[x_a][58] = { 12,  13}; //   2
  c_d[x_a][58] = { 11,   2,   5}; //   3

  c_p[x_a][59] = {  3,  30,  37}; //   3
  c_f[x_a][59] = {  8}; //   1
  c_t[x_a][59] = { 12,  13}; //   2
  c_d[x_a][59] = { 11,   2,   5}; //   3

  c_p[x_a][60] = {  6,  30,  28,  38}; //   4
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = { 12}; //   1
  c_d[x_a][60] = { 23,  18,   2,   5}; //   4

  c_p[x_a][61] = {  3,  30,  28,  38}; //   4
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = { 12}; //   1
  c_d[x_a][61] = { 23,  18,   2,   5}; //   4

  c_p[x_a][62] = {  6,  30,  37,  39}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = { 12}; //   1
  c_d[x_a][62] = { 24,  11,   2,   5}; //   4

  c_p[x_a][63] = {  3,  30,  37,  39}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = { 12}; //   1
  c_d[x_a][63] = { 24,  11,   2,   5}; //   4

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_ddx_emmumepvmxudx
//  channel    0: 4yyv11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel    1: 4yyv11(1, 2, 8, 32, 4, 16, 64, 128;  23,   0,  24,   0,   0)
//  channel    2: 4yyv11(1, 2, 32, 8, 4, 16, 64, 128;   0,   0,  24,   0,   0)
//  channel    3: 4yyv11(1, 2, 32, 8, 4, 16, 64, 128;  23,   0,  24,   0,   0)
//  channel    4: 42vv11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel    5: 42vv11(1, 2, 4, 16, 8, 32, 64, 128;  24,  23,  24,   0,   0)
//  channel    6: 5yyyv1(1, 2, 64, 4, 16, 8, 32, 128;  24,   0,  24,   0,   0)
//  channel    7: 5yyyv1(1, 2, 64, 8, 32, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel    8: 5yyyv1(1, 2, 64, 32, 8, 4, 16, 128;   0,   0,  24,   0,   0)
//  channel    9: 5yyyv1(1, 2, 64, 32, 8, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   10: 5y2vv1(1, 2, 64, 4, 16, 8, 32, 128;  24,   0,  24,   0,   0)
//  channel   11: 5y2vv1(1, 2, 64, 4, 16, 8, 32, 128;  24,  23,  24,   0,   0)
//  channel   12: 52vyv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,   0,   0,   0)
//  channel   13: 52vyv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,  23,   0,   0)
//  channel   14: 52vyv1(1, 2, 8, 32, 64, 4, 16, 128;   0,   0,  24,   0,   0)
//  channel   15: 52vyv1(1, 2, 8, 32, 64, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   16: 6yyyyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   17: 6yyyyv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   18: 6yyyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   19: 6yyyyv(1, 2, 128, 64, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   20: 6yyyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   21: 6yyyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   22: 6yyyyv(1, 2, 128, 64, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   23: 6yyyyv(1, 2, 128, 64, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   24: 6yy2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   25: 6yy2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   26: 6yy2vv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   27: 6yy2vv(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   28: 6y2vyv(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,   0,   0,   0)
//  channel   29: 6y2vyv(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,  23,   0,   0)
//  channel   30: 6y2vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   31: 6y2vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
//  channel   32: 6y2vyv(1, 2, 128, 8, 32, 64, 4, 16;   0,   0,  24,   0,   0)
//  channel   33: 6y2vyv(1, 2, 128, 8, 32, 64, 4, 16;  23,   0,  24,   0,   0)
//  channel   34: 6y2vyv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   35: 6y2vyv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   36: 63yvyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   37: 63yvyv(1, 2, 64, 4, 16, 128, 8, 32;  24,  23,   0,   0,   0)
//  channel   38: 63yvyv(1, 2, 64, 8, 32, 128, 4, 16;   0,  24,   0,   0,   0)
//  channel   39: 63yvyv(1, 2, 64, 8, 32, 128, 4, 16;  23,  24,   0,   0,   0)
//  channel   40: 2v2v11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,   0,   0,   0)
//  channel   41: 2v2v11(1, 2, 4, 16, 8, 32, 64, 128;  24,  23,   0,   0,   0)
//  channel   42: 2v2v11(1, 2, 8, 32, 4, 16, 64, 128;   0,  24,   0,   0,   0)
//  channel   43: 2v2v11(1, 2, 8, 32, 4, 16, 64, 128;  23,  24,   0,   0,   0)
//  channel   44: 2v3yv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,   0,   0,   0)
//  channel   45: 2v3yv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,  23,   0,   0)
//  channel   46: 2v3yv1(1, 2, 8, 32, 64, 4, 16, 128;   0,   0,  24,   0,   0)
//  channel   47: 2v3yv1(1, 2, 8, 32, 64, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   48: 2v4yyv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   49: 2v4yyv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,  23,   0)
//  channel   50: 2v4yyv(1, 2, 4, 16, 128, 64, 8, 32;  24,   0,   0,   0,   0)
//  channel   51: 2v4yyv(1, 2, 4, 16, 128, 64, 8, 32;  24,   0,   0,  23,   0)
//  channel   52: 2v13yv(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   53: 2v13yv(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   54: 2v112v(1, 2, 8, 32, 64, 128, 4, 16;   0,  24,   0,   0,   0)
//  channel   55: 2v112v(1, 2, 8, 32, 64, 128, 4, 16;  23,  24,   0,   0,   0)
//  channel   56: 3yv3yv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   57: 3yv3yv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   58: 3yv12v(1, 2, 64, 8, 32, 128, 4, 16;   0,  24,   0,   0,   0)
//  channel   59: 3yv12v(1, 2, 64, 8, 32, 128, 4, 16;  23,  24,   0,   0,   0)
//  channel   60: 4yyv2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel   61: 4yyv2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
//  channel   62: 4yyv2v(1, 2, 128, 64, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel   63: 4yyv2v(1, 2, 128, 64, 8, 32, 4, 16;  23,  24,   0,   0,   0)
