#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_240_gd_emmumepvmxgu(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_240_gd_emmumepvmxgu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(24);
  needed_v_smin[x_a].resize(24);
  needed_v_smin[x_a][  0] = {   0,    4,    5,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   28,   29,   30,   31,   32,   33,   34,   38,   39,   40,   44,   45,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; //  84
  needed_v_smin[x_a][  1] = {   0,   10,   22,   34,   40,   50,   51,   62}; //   8
  needed_v_smin[x_a][  2] = {   0,   10,   22,   34,   40,   50,   51,   62}; //   8
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45,   50,   52,   54,   55,   58,   59}; //  24
  needed_v_smin[x_a][  4] = {   1,    2,    3,    4,    5,    6,    7,    8,    9,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   35,   36,   37,   38,   39,   41,   42,   43,   44,   45,   46,   47,   48,   49,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; // 100
  needed_v_smin[x_a][  5] = {   1,   11,   25,   35,   41,   52,   53,   63}; //   8
  needed_v_smin[x_a][  6] = {   1,   11,   25,   35,   41,   52,   53,   63}; //   8
  needed_v_smin[x_a][  7] = {   2,    3,   12,   13,   26,   27,   36,   37,   42,   43,   54,   55,   56,   57,   64,   65}; //  16
  needed_v_smin[x_a][  8] = {   2,    3,   12,   13,   26,   27,   36,   37,   42,   43,   54,   55,   56,   57,   64,   65}; //  16
  needed_v_smin[x_a][  9] = {   4,    5,   14,   15,   30,   31,   38,   39,   44,   45,   58,   59,   60,   61,   66,   67,   84,   85,   86,   87,  104,  105,  106,  107}; //  24
  needed_v_smin[x_a][ 10] = {   6,    7,   16,   17,   20,   21,   46,   47,   70,   71,   74,   75,   78,   79,   94,   95,  100,  101}; //  18
  needed_v_smin[x_a][ 11] = {   6,    7,   16,   17,   46,   47,   70,   71,   94,   95,  100,  101}; //  12
  needed_v_smin[x_a][ 12] = {   8,    9,   18,   19,   23,   24,   48,   49,   68,   69,   72,   73,   76,   77,   92,   93,   96,   97}; //  18
  needed_v_smin[x_a][ 13] = {   8,    9,   18,   19,   48,   49,   68,   69,   92,   93,   96,   97}; //  12
  needed_v_smin[x_a][ 14] = {  20,   21,   78,   79,   74,   75}; //   6
  needed_v_smin[x_a][ 15] = {  22,   25,   26,   27,   28,   29,   30,   31,   32,   33,   62,   63,   64,   65,   66,   67,   80,   81,   82,   83,  104,  105,  106,  107}; //  24
  needed_v_smin[x_a][ 16] = {  23,   24,   76,   77,   72,   73}; //   6
  needed_v_smin[x_a][ 17] = {  28,   29,   82,   83}; //   4
  needed_v_smin[x_a][ 18] = {  32,   33,   80,   81}; //   4
  needed_v_smin[x_a][ 19] = {  34,   35,   36,   37,   38,   39,   51,   53,   56,   57,   60,   61,   84,   85,   86,   87}; //  16
  needed_v_smin[x_a][ 20] = {  88,   89,   98,   99}; //   4
  needed_v_smin[x_a][ 21] = {  88,   89,   98,   99}; //   4
  needed_v_smin[x_a][ 22] = {  90,   91,  102,  103}; //   4
  needed_v_smin[x_a][ 23] = {  90,   91,  102,  103}; //   4

  v_smax[x_a].resize(34);
  needed_v_smax[x_a].resize(34);
  needed_v_smax[x_a][  0] = {   0,    4,    5,    6,    7,   10,   14,   15,   16,   17,   20,   21,   22,   30,   31,   34,   38,   39,   40,   44,   45,   46,   47,   50,   51,   58,   59,   60,   61,   62,   66,   67,   68,   69,   72,   73,   76,   77,   80,   81,   84,   85,   88,   89,   92,   93,   96,   97,   98,   99,  104,  105}; //  52
  needed_v_smax[x_a][  1] = {   0,   10,   22,   34,   40,   50,   51,   62}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   22,   25,   26,   27,   30,   31,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   84,   85,   86,   87}; //  52
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   52,   54,   55,   58,   59,   68,   69,   70,   71,   92,   93,   94,   95,   96,   97,  100,  101}; //  48
  needed_v_smax[x_a][  4] = {   1,    2,    3,    8,    9,   11,   12,   13,   18,   19,   23,   24,   25,   26,   27,   35,   36,   37,   41,   42,   43,   48,   49,   52,   53,   54,   55,   56,   57,   63,   64,   65,   70,   71,   74,   75,   78,   79,   82,   83,   86,   87,   90,   91,   94,   95,  100,  101,  102,  103,  106,  107}; //  52
  needed_v_smax[x_a][  5] = {   1,   11,   25,   35,   41,   52,   53,   63}; //   8
  needed_v_smax[x_a][  6] = {   2,    3,   12,   13,   26,   27,   36,   37,   42,   43,   54,   55,   56,   57,   64,   65}; //  16
  needed_v_smax[x_a][  7] = {   4,    5,   14,   15,   30,   31,   38,   39,   44,   45,   58,   59,   60,   61,   66,   67,   68,   69,   72,   73,   76,   77,   84,   85,   88,   89,   92,   93,   96,   97,   98,   99,  104,  105}; //  34
  needed_v_smax[x_a][  8] = {   6,    7,   16,   17,   20,   21,   46,   47}; //   8
  needed_v_smax[x_a][  9] = {   6,    7,   16,   17,   46,   47}; //   6
  needed_v_smax[x_a][ 10] = {   8,    9,   18,   19,   23,   24,   48,   49}; //   8
  needed_v_smax[x_a][ 11] = {   8,    9,   18,   19,   48,   49}; //   6
  needed_v_smax[x_a][ 12] = {  20,   21,   28,   29}; //   4
  needed_v_smax[x_a][ 13] = {  20,   21,   28,   29}; //   4
  needed_v_smax[x_a][ 14] = {  22,   25,   26,   27,   30,   31,   62,   63,   64,   65,   66,   67}; //  12
  needed_v_smax[x_a][ 15] = {  23,   24,   32,   33}; //   4
  needed_v_smax[x_a][ 16] = {  23,   24,   32,   33}; //   4
  needed_v_smax[x_a][ 17] = {  28,   29,   32,   33}; //   4
  needed_v_smax[x_a][ 18] = {  28,   29}; //   2
  needed_v_smax[x_a][ 19] = {  32,   33}; //   2
  needed_v_smax[x_a][ 20] = {  68,   69,   72,   73,   76,   77,   92,   93,   96,   97}; //  10
  needed_v_smax[x_a][ 21] = {  70,   71,   74,   75,   78,   79,   86,   87,   90,   91,   94,   95,  100,  101,  102,  103,  106,  107}; //  18
  needed_v_smax[x_a][ 22] = {  70,   71,   74,   75,   78,   79,   94,   95,  100,  101}; //  10
  needed_v_smax[x_a][ 23] = {  76,   77,   80,   81,   72,   73}; //   6
  needed_v_smax[x_a][ 24] = {  78,   79,   82,   83,   74,   75}; //   6
  needed_v_smax[x_a][ 25] = {  80,   81}; //   2
  needed_v_smax[x_a][ 26] = {  80,   81}; //   2
  needed_v_smax[x_a][ 27] = {  82,   83}; //   2
  needed_v_smax[x_a][ 28] = {  82,   83}; //   2
  needed_v_smax[x_a][ 29] = { 104,  105,  106,  107}; //   4
  needed_v_smax[x_a][ 30] = {  34,   35,   36,   37,   38,   39,   51,   53,   56,   57,   60,   61,   84,   85,   86,   87,   88,   89,   90,   91,   98,   99,  102,  103}; //  24
  needed_v_smax[x_a][ 31] = {  88,   89,   98,   99}; //   4
  needed_v_smax[x_a][ 32] = {  90,   91,  102,  103}; //   4
  needed_v_smax[x_a][ 33] = { 104,  105,  106,  107}; //   4

  g_p[x_a].resize(45);
  needed_g_p[x_a].resize(45);
  needed_g_p[x_a][0] = {   0,    4,    5,    6,    7,   10,   14,   15,   16,   17,   20,   21,   22,   30,   31,   34,   38,   39,   40,   44,   45,   46,   47,   50,   51,   58,   59,   60,   61,   62,   66,   67,   68,   69,   72,   73,   76,   77,   80,   81,   84,   85,   88,   89,   92,   93,   96,   97,   98,   99,  104,  105}; //  52
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   10,   22,   34,   40,   50,   51,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   10,   22,   34,   40,   50,   51,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    9,   11,   13,   19,   24,   25,   27,   35,   37,   41,   43,   49,   52,   53,   55,   57,   63,   65,   71,   75,   79,   83,   87,   91,   95,  101,  103,  107}; //  30
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][5] = {   1,   11,   25,   35,   41,   52,   53,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {   1,   11,   25,   35,   41,   52,   53,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax2");
  needed_g_p[x_a][7] = {   2,    8,   12,   18,   23,   26,   36,   42,   48,   54,   56,   64,   70,   74,   78,   82,   86,   90,   94,  100,  102,  106}; //  22
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][8] = {   2,    3,   12,   13,   26,   27,   36,   37,   42,   43,   54,   55,   56,   57,   64,   65}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   2,    3,   12,   13,   26,   27,   36,   37,   42,   43,   54,   55,   56,   57,   64,   65}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][10] = {   4,   14,   30,   38,   44,   58,   60,   66,   68,   72,   76,   84,   88,   92,   96,   98,  104}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax7");
  needed_g_p[x_a][11] = {   4,    5,   14,   15,   30,   31,   38,   39,   44,   45,   58,   59,   60,   61,   66,   67}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][12] = {   5,   15,   31,   39,   45,   59,   61,   67,   69,   73,   77,   85,   89,   93,   97,   99,  105}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax7");
  needed_g_p[x_a][13] = {   6,    7,   16,   17,   20,   21,   46,   47}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {   6,   16,   46}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax9");
  needed_g_p[x_a][15] = {   6,    7,   16,   17,   46,   47}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax3");
  needed_g_p[x_a][16] = {   7,   17,   47}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax9");
  needed_g_p[x_a][17] = {   8,    9,   18,   19,   23,   24,   48,   49}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][18] = {   8,    9,   18,   19,   48,   49}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][19] = {   8,    9,   18,   19,   48,   49}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax3");
  needed_g_p[x_a][20] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax12");
  needed_g_p[x_a][21] = {  20,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax13");
  needed_g_p[x_a][22] = {  21,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax13");
  needed_g_p[x_a][23] = {  22,   25,   26,   27,   30,   31,   62,   63,   64,   65,   66,   67}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax14");
  needed_g_p[x_a][24] = {  23,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax15");
  needed_g_p[x_a][25] = {  23,   24,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax16");
  needed_g_p[x_a][26] = {  28,   29,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax17");
  needed_g_p[x_a][27] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax18");
  needed_g_p[x_a][28] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax12");
  needed_g_p[x_a][29] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax19");
  needed_g_p[x_a][30] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax15");
  needed_g_p[x_a][31] = {  33}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax19");
  needed_g_p[x_a][32] = {  68,   69,   72,   73,   76,   77,   92,   93}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax20");
  needed_g_p[x_a][33] = {  70,   71,   74,   75,   78,   79,   86,   87,   90,   91,   94,   95,  100,  101,  102,  103,  106,  107}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax21");
  needed_g_p[x_a][34] = {  70,   71,   74,   75,   78,   79,   94,   95}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax22");
  needed_g_p[x_a][35] = {  76,   77}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax23");
  needed_g_p[x_a][36] = {  78,   79}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax24");
  needed_g_p[x_a][37] = {  80,   81}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax25");
  needed_g_p[x_a][38] = {  80}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax26");
  needed_g_p[x_a][39] = {  80,   81}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax23");
  needed_g_p[x_a][40] = {  81}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax26");
  needed_g_p[x_a][41] = {  82,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax27");
  needed_g_p[x_a][42] = {  82,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax28");
  needed_g_p[x_a][43] = {  82,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax24");
  needed_g_p[x_a][44] = { 104,  105,  106,  107}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax29");

  g_f[x_a].resize(14);
  needed_g_f[x_a].resize(14);
  needed_g_f[x_a][0] = {  34,   35,   36,   37,   38,   39,   51,   53,   56,   57,   60,   61,   84,   85,   86,   87}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax30");
  needed_g_f[x_a][1] = {  50,   52,   54,   55,   58,   59}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][2] = {  68,   69,   92,   93,   96,   97}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax3");
  needed_g_f[x_a][3] = {  70,   71,   94,   95,  100,  101}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax3");
  needed_g_f[x_a][4] = {  72,   73}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax23");
  needed_g_f[x_a][5] = {  74,   75}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax24");
  needed_g_f[x_a][6] = {  84,   85,   86,   87}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax2");
  needed_g_f[x_a][7] = {  88,   89,   98,   99}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax31");
  needed_g_f[x_a][8] = {  88,   89,   98,   99}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax30");
  needed_g_f[x_a][9] = {  90,   91,  102,  103}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax32");
  needed_g_f[x_a][10] = {  90,   91,  102,  103}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax30");
  needed_g_f[x_a][11] = {  96,   97}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax20");
  needed_g_f[x_a][12] = { 100,  101}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax22");
  needed_g_f[x_a][13] = { 104,  105,  106,  107}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax33");

  g_t[x_a].resize(27);
  needed_g_t[x_a].resize(27);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   68,   69,   70,   71}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_188");
  needed_g_t[x_a][1] = {  34,   35,   36,   37,   38,   39,   51,   53,   56,   57,   60,   61,   84,   85,   86,   87,   88,   89,   90,   91,   98,   99,  102,  103}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__128_124");
  needed_g_t[x_a][2] = {  34,   35,   36,   37,   38,   39,   84,   85,   86,   87}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__64_60");
  needed_g_t[x_a][3] = {  40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   52,   54,   55,   58,   59,   92,   93,   94,   95,   96,   97,  100,  101}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][4] = {  50,   52,   54,   55,   58,   59}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][5] = {  51,   53,   56,   57,   60,   61}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__129_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__129_2__64_60");
  needed_g_t[x_a][6] = {  62,   63,   64,   65,   66,   67,  104,  105,  106,  107}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][7] = {  68,   69}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__148_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__148_40");
  needed_g_t[x_a][8] = {  70,   71}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__168_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__168_20");
  needed_g_t[x_a][9] = {  72,   73,   76,   77,   80,   81}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_212");
  needed_g_t[x_a][10] = {  72,   73}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_42__148_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_42__148_64");
  needed_g_t[x_a][11] = {  74,   75,   78,   79,   82,   83}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_232");
  needed_g_t[x_a][12] = {  74,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_22__168_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_22__168_64");
  needed_g_t[x_a][13] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_66__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_66__20_40");
  needed_g_t[x_a][14] = {  86,   87}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_66__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_66__40_20");
  needed_g_t[x_a][15] = {  88,   89,   98,   99}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__40_84");
  needed_g_t[x_a][16] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_42__20_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_42__20_64");
  needed_g_t[x_a][17] = {  90,   91,  102,  103}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__20_104");
  needed_g_t[x_a][18] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_22__40_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_22__40_64");
  needed_g_t[x_a][19] = {  92,   93,   96,   97}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_148");
  needed_g_t[x_a][20] = {  94,   95,  100,  101}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_168");
  needed_g_t[x_a][21] = {  96,   97}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_42__128_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_42__128_20");
  needed_g_t[x_a][22] = {  98,   99}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_42__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_42__64_20");
  needed_g_t[x_a][23] = { 100,  101}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_22__128_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_22__128_40");
  needed_g_t[x_a][24] = { 102,  103}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_22__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_22__64_40");
  needed_g_t[x_a][25] = { 104,  105}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__40_20");
  needed_g_t[x_a][26] = { 106,  107}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__20_40");

  g_d[x_a].resize(23);
  needed_g_d[x_a].resize(23);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,   10,   22,   34,   40,   50,   51,   62}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,   10,   22,   34,   40,   50,   51,   62}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][3] = {   0,    4,    5,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   28,   29,   30,   31,   32,   33,   34,   38,   39,   40,   44,   45,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; //  84
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {   1,   11,   25,   35,   41,   52,   53,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][5] = {   1,   11,   25,   35,   41,   52,   53,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][6] = {   1,    2,    3,    4,    5,    6,    7,    8,    9,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   35,   36,   37,   38,   39,   41,   42,   43,   44,   45,   46,   47,   48,   49,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; // 100
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][7] = {   2,    3,   12,   13,   26,   27,   36,   37,   42,   43,   54,   55,   56,   57,   64,   65}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {   2,    3,   12,   13,   26,   27,   36,   37,   42,   43,   54,   55,   56,   57,   64,   65}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][9] = {   4,    5,   14,   15,   30,   31,   38,   39,   44,   45,   58,   59,   60,   61,   66,   67}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][10] = {   6,    7,   16,   17,   46,   47}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__20_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__20_168");
  needed_g_d[x_a][11] = {   6,    7,   16,   17,   20,   21,   46,   47,   70,   71,   74,   75,   78,   79,   94,   95}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_168__128_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_168__128_40");
  needed_g_d[x_a][12] = {   8,    9,   18,   19,   48,   49}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__40_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__40_148");
  needed_g_d[x_a][13] = {   8,    9,   18,   19,   23,   24,   48,   49,   68,   69,   72,   73,   76,   77,   92,   93}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][14] = {  10,   11,   12,   13,   14,   15,   16,   17,   18,   19}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][15] = {  20,   21,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__20_232");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__20_232");
  needed_g_d[x_a][16] = {  20,   21,   78,   79}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_232__64_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_232__64_168");
  needed_g_d[x_a][17] = {  22,   25,   26,   27,   30,   31}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__192_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__192_60");
  needed_g_d[x_a][18] = {  22,   25,   26,   27,   28,   29,   30,   31,   32,   33,   62,   63,   64,   65,   66,   67,   80,   81,   82,   83,  104,  105,  106,  107}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][19] = {  23,   24,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__40_212");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__40_212");
  needed_g_d[x_a][20] = {  23,   24,   76,   77}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_212__64_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_212__64_148");
  needed_g_d[x_a][21] = {  28,   29,   82,   83}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_232__40_192");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_232__40_192");
  needed_g_d[x_a][22] = {  32,   33,   80,   81}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_212__20_192");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_212__20_192");

  c_p[x_a].resize(108);
  c_f[x_a].resize(108);
  c_t[x_a].resize(108);
  c_d[x_a].resize(108);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   5,   6,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   4,   5,   6}; //   4

  c_p[x_a][2] = {  7,   8,   9,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   7,   8,   6}; //   4

  c_p[x_a][3] = {  4,   8,   9,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   7,   8,   6}; //   4

  c_p[x_a][4] = {  0,  10,  11,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   9,   6,   3}; //   4

  c_p[x_a][5] = {  0,  12,  11,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   9,   6,   3}; //   4

  c_p[x_a][6] = {  0,  13,  14,  15}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   6,  11,   3}; //   4

  c_p[x_a][7] = {  0,  13,  16,  15}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 10,   6,  11,   3}; //   4

  c_p[x_a][8] = {  7,  17,  18,  19}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 12,   3,  13,   6}; //   4

  c_p[x_a][9] = {  4,  17,  18,  19}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 12,   3,  13,   6}; //   4

  c_p[x_a][10] = {  0,   1,   2,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 14,   0,   1,   2,   3}; //   5

  c_p[x_a][11] = {  4,   5,   6,   3}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 14,   0,   4,   5,   6}; //   5

  c_p[x_a][12] = {  7,   8,   9,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 14,   0,   7,   8,   6}; //   5

  c_p[x_a][13] = {  4,   8,   9,   3}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 14,   0,   7,   8,   6}; //   5

  c_p[x_a][14] = {  0,  10,  11,   3}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 14,   0,   9,   6,   3}; //   5

  c_p[x_a][15] = {  0,  12,  11,   3}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 14,   0,   9,   6,   3}; //   5

  c_p[x_a][16] = {  0,  13,  14,  15}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 14,  10,   6,  11,   3}; //   5

  c_p[x_a][17] = {  0,  13,  16,  15}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 14,  10,   6,  11,   3}; //   5

  c_p[x_a][18] = {  7,  17,  18,  19}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 14,  12,   3,  13,   6}; //   5

  c_p[x_a][19] = {  4,  17,  18,  19}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 14,  12,   3,  13,   6}; //   5

  c_p[x_a][20] = {  0,  13,  20,  21}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 15,   6,  16,  11,   3}; //   5

  c_p[x_a][21] = {  0,  13,  20,  22}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 15,   6,  16,  11,   3}; //   5

  c_p[x_a][22] = {  0,   1,   2,  23}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 17,  18,   1,   2,   3}; //   5

  c_p[x_a][23] = {  7,  17,  24,  25}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 19,   3,  20,  13,   6}; //   5

  c_p[x_a][24] = {  4,  17,  24,  25}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 19,   3,  20,  13,   6}; //   5

  c_p[x_a][25] = {  4,   5,   6,  23}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 17,  18,   4,   5,   6}; //   5

  c_p[x_a][26] = {  7,   8,   9,  23}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 17,  18,   7,   8,   6}; //   5

  c_p[x_a][27] = {  4,   8,   9,  23}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 17,  18,   7,   8,   6}; //   5

  c_p[x_a][28] = { 26,  27,  28,  21}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 15,   6,  21,   3,  18}; //   5

  c_p[x_a][29] = { 26,  27,  28,  22}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 15,   6,  21,   3,  18}; //   5

  c_p[x_a][30] = {  0,  10,  11,  23}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 17,  18,   9,   6,   3}; //   5

  c_p[x_a][31] = {  0,  12,  11,  23}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 17,  18,   9,   6,   3}; //   5

  c_p[x_a][32] = { 26,  29,  30,  25}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 19,   3,  22,   6,  18}; //   5

  c_p[x_a][33] = { 26,  31,  30,  25}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 19,   3,  22,   6,  18}; //   5

  c_p[x_a][34] = {  0,   1,   2}; //   3
  c_f[x_a][34] = {  0}; //   1
  c_t[x_a][34] = {  1,   2}; //   2
  c_d[x_a][34] = {  1,   2,   3}; //   3

  c_p[x_a][35] = {  4,   5,   6}; //   3
  c_f[x_a][35] = {  0}; //   1
  c_t[x_a][35] = {  1,   2}; //   2
  c_d[x_a][35] = {  4,   5,   6}; //   3

  c_p[x_a][36] = {  7,   8,   9}; //   3
  c_f[x_a][36] = {  0}; //   1
  c_t[x_a][36] = {  1,   2}; //   2
  c_d[x_a][36] = {  7,   8,   6}; //   3

  c_p[x_a][37] = {  4,   8,   9}; //   3
  c_f[x_a][37] = {  0}; //   1
  c_t[x_a][37] = {  1,   2}; //   2
  c_d[x_a][37] = {  7,   8,   6}; //   3

  c_p[x_a][38] = {  0,  10,  11}; //   3
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  1,   2}; //   2
  c_d[x_a][38] = {  9,   6,   3}; //   3

  c_p[x_a][39] = {  0,  12,  11}; //   3
  c_f[x_a][39] = {  0}; //   1
  c_t[x_a][39] = {  1,   2}; //   2
  c_d[x_a][39] = {  9,   6,   3}; //   3

  c_p[x_a][40] = {  0,   1,   2,   3}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  3}; //   1
  c_d[x_a][40] = {  0,   1,   2,   3}; //   4

  c_p[x_a][41] = {  4,   5,   6,   3}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  3}; //   1
  c_d[x_a][41] = {  0,   4,   5,   6}; //   4

  c_p[x_a][42] = {  7,   8,   9,   3}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  3}; //   1
  c_d[x_a][42] = {  0,   7,   8,   6}; //   4

  c_p[x_a][43] = {  4,   8,   9,   3}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  3}; //   1
  c_d[x_a][43] = {  0,   7,   8,   6}; //   4

  c_p[x_a][44] = {  0,  10,  11,   3}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  3}; //   1
  c_d[x_a][44] = {  0,   9,   6,   3}; //   4

  c_p[x_a][45] = {  0,  12,  11,   3}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  3}; //   1
  c_d[x_a][45] = {  0,   9,   6,   3}; //   4

  c_p[x_a][46] = {  0,  13,  14,  15}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  3}; //   1
  c_d[x_a][46] = { 10,   6,  11,   3}; //   4

  c_p[x_a][47] = {  0,  13,  16,  15}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  3}; //   1
  c_d[x_a][47] = { 10,   6,  11,   3}; //   4

  c_p[x_a][48] = {  7,  17,  18,  19}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  3}; //   1
  c_d[x_a][48] = { 12,   3,  13,   6}; //   4

  c_p[x_a][49] = {  4,  17,  18,  19}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  3}; //   1
  c_d[x_a][49] = { 12,   3,  13,   6}; //   4

  c_p[x_a][50] = {  0,   1,   2}; //   3
  c_f[x_a][50] = {  1}; //   1
  c_t[x_a][50] = {  3,   4}; //   2
  c_d[x_a][50] = {  1,   2,   3}; //   3

  c_p[x_a][51] = {  0,   1,   2}; //   3
  c_f[x_a][51] = {  0}; //   1
  c_t[x_a][51] = {  1,   5}; //   2
  c_d[x_a][51] = {  1,   2,   3}; //   3

  c_p[x_a][52] = {  4,   5,   6}; //   3
  c_f[x_a][52] = {  1}; //   1
  c_t[x_a][52] = {  3,   4}; //   2
  c_d[x_a][52] = {  4,   5,   6}; //   3

  c_p[x_a][53] = {  4,   5,   6}; //   3
  c_f[x_a][53] = {  0}; //   1
  c_t[x_a][53] = {  1,   5}; //   2
  c_d[x_a][53] = {  4,   5,   6}; //   3

  c_p[x_a][54] = {  7,   8,   9}; //   3
  c_f[x_a][54] = {  1}; //   1
  c_t[x_a][54] = {  3,   4}; //   2
  c_d[x_a][54] = {  7,   8,   6}; //   3

  c_p[x_a][55] = {  4,   8,   9}; //   3
  c_f[x_a][55] = {  1}; //   1
  c_t[x_a][55] = {  3,   4}; //   2
  c_d[x_a][55] = {  7,   8,   6}; //   3

  c_p[x_a][56] = {  7,   8,   9}; //   3
  c_f[x_a][56] = {  0}; //   1
  c_t[x_a][56] = {  1,   5}; //   2
  c_d[x_a][56] = {  7,   8,   6}; //   3

  c_p[x_a][57] = {  4,   8,   9}; //   3
  c_f[x_a][57] = {  0}; //   1
  c_t[x_a][57] = {  1,   5}; //   2
  c_d[x_a][57] = {  7,   8,   6}; //   3

  c_p[x_a][58] = {  0,  10,  11}; //   3
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  3,   4}; //   2
  c_d[x_a][58] = {  9,   6,   3}; //   3

  c_p[x_a][59] = {  0,  12,  11}; //   3
  c_f[x_a][59] = {  1}; //   1
  c_t[x_a][59] = {  3,   4}; //   2
  c_d[x_a][59] = {  9,   6,   3}; //   3

  c_p[x_a][60] = {  0,  10,  11}; //   3
  c_f[x_a][60] = {  0}; //   1
  c_t[x_a][60] = {  1,   5}; //   2
  c_d[x_a][60] = {  9,   6,   3}; //   3

  c_p[x_a][61] = {  0,  12,  11}; //   3
  c_f[x_a][61] = {  0}; //   1
  c_t[x_a][61] = {  1,   5}; //   2
  c_d[x_a][61] = {  9,   6,   3}; //   3

  c_p[x_a][62] = {  0,   1,   2,  23}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  6}; //   1
  c_d[x_a][62] = { 18,   1,   2,   3}; //   4

  c_p[x_a][63] = {  4,   5,   6,  23}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  6}; //   1
  c_d[x_a][63] = { 18,   4,   5,   6}; //   4

  c_p[x_a][64] = {  7,   8,   9,  23}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  6}; //   1
  c_d[x_a][64] = { 18,   7,   8,   6}; //   4

  c_p[x_a][65] = {  4,   8,   9,  23}; //   4
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  6}; //   1
  c_d[x_a][65] = { 18,   7,   8,   6}; //   4

  c_p[x_a][66] = {  0,  10,  11,  23}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  6}; //   1
  c_d[x_a][66] = { 18,   9,   6,   3}; //   4

  c_p[x_a][67] = {  0,  12,  11,  23}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  6}; //   1
  c_d[x_a][67] = { 18,   9,   6,   3}; //   4

  c_p[x_a][68] = {  0,  10,  32}; //   3
  c_f[x_a][68] = {  2}; //   1
  c_t[x_a][68] = {  0,   7}; //   2
  c_d[x_a][68] = { 13,   6,   3}; //   3

  c_p[x_a][69] = {  0,  12,  32}; //   3
  c_f[x_a][69] = {  2}; //   1
  c_t[x_a][69] = {  0,   7}; //   2
  c_d[x_a][69] = { 13,   6,   3}; //   3

  c_p[x_a][70] = {  7,  33,  34}; //   3
  c_f[x_a][70] = {  3}; //   1
  c_t[x_a][70] = {  0,   8}; //   2
  c_d[x_a][70] = { 11,   3,   6}; //   3

  c_p[x_a][71] = {  4,  33,  34}; //   3
  c_f[x_a][71] = {  3}; //   1
  c_t[x_a][71] = {  0,   8}; //   2
  c_d[x_a][71] = { 11,   3,   6}; //   3

  c_p[x_a][72] = {  0,  10,  32}; //   3
  c_f[x_a][72] = {  4}; //   1
  c_t[x_a][72] = {  9,  10}; //   2
  c_d[x_a][72] = { 13,   6,   3}; //   3

  c_p[x_a][73] = {  0,  12,  32}; //   3
  c_f[x_a][73] = {  4}; //   1
  c_t[x_a][73] = {  9,  10}; //   2
  c_d[x_a][73] = { 13,   6,   3}; //   3

  c_p[x_a][74] = {  7,  33,  34}; //   3
  c_f[x_a][74] = {  5}; //   1
  c_t[x_a][74] = { 11,  12}; //   2
  c_d[x_a][74] = { 11,   3,   6}; //   3

  c_p[x_a][75] = {  4,  33,  34}; //   3
  c_f[x_a][75] = {  5}; //   1
  c_t[x_a][75] = { 11,  12}; //   2
  c_d[x_a][75] = { 11,   3,   6}; //   3

  c_p[x_a][76] = {  0,  10,  32,  35}; //   4
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  9}; //   1
  c_d[x_a][76] = { 20,  13,   6,   3}; //   4

  c_p[x_a][77] = {  0,  12,  32,  35}; //   4
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {  9}; //   1
  c_d[x_a][77] = { 20,  13,   6,   3}; //   4

  c_p[x_a][78] = {  7,  33,  34,  36}; //   4
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = { 11}; //   1
  c_d[x_a][78] = { 16,  11,   3,   6}; //   4

  c_p[x_a][79] = {  4,  33,  34,  36}; //   4
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 11}; //   1
  c_d[x_a][79] = { 16,  11,   3,   6}; //   4

  c_p[x_a][80] = {  0,  37,  38,  39}; //   4
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {  9}; //   1
  c_d[x_a][80] = { 22,   6,  18,   3}; //   4

  c_p[x_a][81] = {  0,  37,  40,  39}; //   4
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {  9}; //   1
  c_d[x_a][81] = { 22,   6,  18,   3}; //   4

  c_p[x_a][82] = {  7,  41,  42,  43}; //   4
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = { 11}; //   1
  c_d[x_a][82] = { 21,   3,  18,   6}; //   4

  c_p[x_a][83] = {  4,  41,  42,  43}; //   4
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = { 11}; //   1
  c_d[x_a][83] = { 21,   3,  18,   6}; //   4

  c_p[x_a][84] = {  0,  10}; //   2
  c_f[x_a][84] = {  6,   0}; //   2
  c_t[x_a][84] = {  1,   2,  13}; //   3
  c_d[x_a][84] = {  6,   3}; //   2

  c_p[x_a][85] = {  0,  12}; //   2
  c_f[x_a][85] = {  6,   0}; //   2
  c_t[x_a][85] = {  1,   2,  13}; //   3
  c_d[x_a][85] = {  6,   3}; //   2

  c_p[x_a][86] = {  7,  33}; //   2
  c_f[x_a][86] = {  6,   0}; //   2
  c_t[x_a][86] = {  1,   2,  14}; //   3
  c_d[x_a][86] = {  3,   6}; //   2

  c_p[x_a][87] = {  4,  33}; //   2
  c_f[x_a][87] = {  6,   0}; //   2
  c_t[x_a][87] = {  1,   2,  14}; //   3
  c_d[x_a][87] = {  3,   6}; //   2

  c_p[x_a][88] = {  0,  10}; //   2
  c_f[x_a][88] = {  7,   8}; //   2
  c_t[x_a][88] = {  1,  15,  16}; //   3
  c_d[x_a][88] = {  6,   3}; //   2

  c_p[x_a][89] = {  0,  12}; //   2
  c_f[x_a][89] = {  7,   8}; //   2
  c_t[x_a][89] = {  1,  15,  16}; //   3
  c_d[x_a][89] = {  6,   3}; //   2

  c_p[x_a][90] = {  7,  33}; //   2
  c_f[x_a][90] = {  9,  10}; //   2
  c_t[x_a][90] = {  1,  17,  18}; //   3
  c_d[x_a][90] = {  3,   6}; //   2

  c_p[x_a][91] = {  4,  33}; //   2
  c_f[x_a][91] = {  9,  10}; //   2
  c_t[x_a][91] = {  1,  17,  18}; //   3
  c_d[x_a][91] = {  3,   6}; //   2

  c_p[x_a][92] = {  0,  10,  32}; //   3
  c_f[x_a][92] = {  2}; //   1
  c_t[x_a][92] = {  3,  19}; //   2
  c_d[x_a][92] = { 13,   6,   3}; //   3

  c_p[x_a][93] = {  0,  12,  32}; //   3
  c_f[x_a][93] = {  2}; //   1
  c_t[x_a][93] = {  3,  19}; //   2
  c_d[x_a][93] = { 13,   6,   3}; //   3

  c_p[x_a][94] = {  7,  33,  34}; //   3
  c_f[x_a][94] = {  3}; //   1
  c_t[x_a][94] = {  3,  20}; //   2
  c_d[x_a][94] = { 11,   3,   6}; //   3

  c_p[x_a][95] = {  4,  33,  34}; //   3
  c_f[x_a][95] = {  3}; //   1
  c_t[x_a][95] = {  3,  20}; //   2
  c_d[x_a][95] = { 11,   3,   6}; //   3

  c_p[x_a][96] = {  0,  10}; //   2
  c_f[x_a][96] = { 11,   2}; //   2
  c_t[x_a][96] = {  3,  19,  21}; //   3
  c_d[x_a][96] = {  6,   3}; //   2

  c_p[x_a][97] = {  0,  12}; //   2
  c_f[x_a][97] = { 11,   2}; //   2
  c_t[x_a][97] = {  3,  19,  21}; //   3
  c_d[x_a][97] = {  6,   3}; //   2

  c_p[x_a][98] = {  0,  10}; //   2
  c_f[x_a][98] = {  7,   8}; //   2
  c_t[x_a][98] = {  1,  15,  22}; //   3
  c_d[x_a][98] = {  6,   3}; //   2

  c_p[x_a][99] = {  0,  12}; //   2
  c_f[x_a][99] = {  7,   8}; //   2
  c_t[x_a][99] = {  1,  15,  22}; //   3
  c_d[x_a][99] = {  6,   3}; //   2

  c_p[x_a][100] = {  7,  33}; //   2
  c_f[x_a][100] = { 12,   3}; //   2
  c_t[x_a][100] = {  3,  20,  23}; //   3
  c_d[x_a][100] = {  3,   6}; //   2

  c_p[x_a][101] = {  4,  33}; //   2
  c_f[x_a][101] = { 12,   3}; //   2
  c_t[x_a][101] = {  3,  20,  23}; //   3
  c_d[x_a][101] = {  3,   6}; //   2

  c_p[x_a][102] = {  7,  33}; //   2
  c_f[x_a][102] = {  9,  10}; //   2
  c_t[x_a][102] = {  1,  17,  24}; //   3
  c_d[x_a][102] = {  3,   6}; //   2

  c_p[x_a][103] = {  4,  33}; //   2
  c_f[x_a][103] = {  9,  10}; //   2
  c_t[x_a][103] = {  1,  17,  24}; //   3
  c_d[x_a][103] = {  3,   6}; //   2

  c_p[x_a][104] = {  0,  10,  44}; //   3
  c_f[x_a][104] = { 13}; //   1
  c_t[x_a][104] = {  6,  25}; //   2
  c_d[x_a][104] = { 18,   6,   3}; //   3

  c_p[x_a][105] = {  0,  12,  44}; //   3
  c_f[x_a][105] = { 13}; //   1
  c_t[x_a][105] = {  6,  25}; //   2
  c_d[x_a][105] = { 18,   6,   3}; //   3

  c_p[x_a][106] = {  7,  33,  44}; //   3
  c_f[x_a][106] = { 13}; //   1
  c_t[x_a][106] = {  6,  26}; //   2
  c_d[x_a][106] = { 18,   3,   6}; //   3

  c_p[x_a][107] = {  4,  33,  44}; //   3
  c_f[x_a][107] = { 13}; //   1
  c_t[x_a][107] = {  6,  26}; //   2
  c_d[x_a][107] = { 18,   3,   6}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_gd_emmumepvmxgu
//  channel    0: 5yyyv1(1, 2, 128, 4, 16, 8, 32, 64;  24,   0,  24,   0,   0)
//  channel    1: 5yyyv1(1, 2, 128, 8, 32, 4, 16, 64;  23,   0,  24,   0,   0)
//  channel    2: 5yyyv1(1, 2, 128, 32, 8, 4, 16, 64;   0,   0,  24,   0,   0)
//  channel    3: 5yyyv1(1, 2, 128, 32, 8, 4, 16, 64;  23,   0,  24,   0,   0)
//  channel    4: 5y2vv1(1, 2, 128, 4, 16, 8, 32, 64;  24,   0,  24,   0,   0)
//  channel    5: 5y2vv1(1, 2, 128, 4, 16, 8, 32, 64;  24,  23,  24,   0,   0)
//  channel    6: 52vyv1(1, 2, 4, 16, 128, 8, 32, 64;  24,   0,   0,   0,   0)
//  channel    7: 52vyv1(1, 2, 4, 16, 128, 8, 32, 64;  24,   0,  23,   0,   0)
//  channel    8: 52vyv1(1, 2, 8, 32, 128, 4, 16, 64;   0,   0,  24,   0,   0)
//  channel    9: 52vyv1(1, 2, 8, 32, 128, 4, 16, 64;  23,   0,  24,   0,   0)
//  channel   10: 6yyyyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   11: 6yyyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   12: 6yyyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   13: 6yyyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   14: 6yy2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   15: 6yy2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   16: 6y2vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   17: 6y2vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
//  channel   18: 6y2vyv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   19: 6y2vyv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   20: 62vyyv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   21: 62vyyv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,  23,   0)
//  channel   22: 62vyyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   23: 62vyyv(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,   0,  24,   0)
//  channel   24: 62vyyv(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,   0,  24,   0)
//  channel   25: 62vyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   26: 62vyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   27: 62vyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   28: 62v2vv(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,   0,   0)
//  channel   29: 62v2vv(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,  23,   0)
//  channel   30: 62v2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   31: 62v2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   32: 62v2vv(1, 2, 8, 32, 4, 16, 64, 128;   0,   0,   0,  24,   0)
//  channel   33: 62v2vv(1, 2, 8, 32, 4, 16, 64, 128;   0,  23,   0,  24,   0)
//  channel   34: 14yyv1(1, 2, 128, 4, 16, 8, 32, 64;  24,   0,  24,   0,   0)
//  channel   35: 14yyv1(1, 2, 128, 8, 32, 4, 16, 64;  23,   0,  24,   0,   0)
//  channel   36: 14yyv1(1, 2, 128, 32, 8, 4, 16, 64;   0,   0,  24,   0,   0)
//  channel   37: 14yyv1(1, 2, 128, 32, 8, 4, 16, 64;  23,   0,  24,   0,   0)
//  channel   38: 142vv1(1, 2, 128, 4, 16, 8, 32, 64;  24,   0,  24,   0,   0)
//  channel   39: 142vv1(1, 2, 128, 4, 16, 8, 32, 64;  24,  23,  24,   0,   0)
//  channel   40: 15yyyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   41: 15yyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   42: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   43: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   44: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   45: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   46: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   47: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
//  channel   48: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   49: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   50: 114yyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   51: 114yyv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   52: 114yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   53: 114yyv(1, 2, 128, 64, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   54: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   55: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   56: 114yyv(1, 2, 128, 64, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   57: 114yyv(1, 2, 128, 64, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   58: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   59: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   60: 1142vv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   61: 1142vv(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   62: 2v4yyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   63: 2v4yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   64: 2v4yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   65: 2v4yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   66: 2v42vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   67: 2v42vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   68: 3yv2v1(1, 2, 128, 4, 16, 8, 32, 64;  24,   0,   0,   0,   0)
//  channel   69: 3yv2v1(1, 2, 128, 4, 16, 8, 32, 64;  24,  23,   0,   0,   0)
//  channel   70: 3yv2v1(1, 2, 128, 8, 32, 4, 16, 64;   0,  24,   0,   0,   0)
//  channel   71: 3yv2v1(1, 2, 128, 8, 32, 4, 16, 64;  23,  24,   0,   0,   0)
//  channel   72: 3yv12v(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,   0,   0,   0)
//  channel   73: 3yv12v(1, 2, 128, 4, 16, 64, 8, 32;  24,  23,   0,   0,   0)
//  channel   74: 3yv12v(1, 2, 128, 8, 32, 64, 4, 16;   0,  24,   0,   0,   0)
//  channel   75: 3yv12v(1, 2, 128, 8, 32, 64, 4, 16;  23,  24,   0,   0,   0)
//  channel   76: 4yyv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   77: 4yyv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   78: 4yyv2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel   79: 4yyv2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
//  channel   80: 42vv2v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   81: 42vv2v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,  23,   0,   0)
//  channel   82: 42vv2v(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   83: 42vv2v(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   84: 12v2v1(1, 2, 128, 4, 16, 8, 32, 64;  24,   0,   0,   0,   0)
//  channel   85: 12v2v1(1, 2, 128, 4, 16, 8, 32, 64;  24,  23,   0,   0,   0)
//  channel   86: 12v2v1(1, 2, 128, 8, 32, 4, 16, 64;   0,  24,   0,   0,   0)
//  channel   87: 12v2v1(1, 2, 128, 8, 32, 4, 16, 64;  23,  24,   0,   0,   0)
//  channel   88: 12v12v(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,   0,   0,   0)
//  channel   89: 12v12v(1, 2, 128, 4, 16, 64, 8, 32;  24,  23,   0,   0,   0)
//  channel   90: 12v12v(1, 2, 128, 8, 32, 64, 4, 16;   0,  24,   0,   0,   0)
//  channel   91: 12v12v(1, 2, 128, 8, 32, 64, 4, 16;  23,  24,   0,   0,   0)
//  channel   92: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   93: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   94: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel   95: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
//  channel   96: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   97: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   98: 112v2v(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   99: 112v2v(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel  100: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel  101: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
//  channel  102: 112v2v(1, 2, 128, 64, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel  103: 112v2v(1, 2, 128, 64, 8, 32, 4, 16;  23,  24,   0,   0,   0)
//  channel  104: 2v2v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel  105: 2v2v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel  106: 2v2v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel  107: 2v2v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
