#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_240_uux_emmumepvmxudx(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_240_uux_emmumepvmxudx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(24);
  needed_v_smin[x_a].resize(24);
  needed_v_smin[x_a][  0] = {   0,    1,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   28,   29,   30,   31,   32,   33,   34,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  needed_v_smin[x_a][  1] = {   0,    1,   24,   34}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,   24,   34}; //   4
  needed_v_smin[x_a][  3] = {   0,    2,    4,    5,    8,    9,   24,   25,   26,   27,   28,   29,   34,   35,   36,   37,   38,   39}; //  18
  needed_v_smin[x_a][  4] = {   1,    3,    6,    7,   10,   11}; //   6
  needed_v_smin[x_a][  5] = {   2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   25,   26,   27,   28,   29,   30,   31,   32,   33,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  needed_v_smin[x_a][  6] = {   2,    3,   25,   35}; //   4
  needed_v_smin[x_a][  7] = {   2,    3,   25,   35}; //   4
  needed_v_smin[x_a][  8] = {   4,    5,    6,    7,   26,   27,   36,   37}; //   8
  needed_v_smin[x_a][  9] = {   4,    5,    6,    7,   26,   27,   36,   37}; //   8
  needed_v_smin[x_a][ 10] = {   8,    9,   10,   11,   28,   29,   38,   39}; //   8
  needed_v_smin[x_a][ 11] = {  12,   13,   22,   23,   42,   43,   54,   55}; //   8
  needed_v_smin[x_a][ 12] = {  12,   13}; //   2
  needed_v_smin[x_a][ 13] = {  14,   15,   20,   21,   30,   31,   40,   41,   44,   45,   48,   49,   52,   53,   58,   59,   62,   63}; //  18
  needed_v_smin[x_a][ 14] = {  14,   15,   30,   31,   58,   59,   62,   63}; //   8
  needed_v_smin[x_a][ 15] = {  16,   17,   20,   21,   48,   49,   50,   51}; //   8
  needed_v_smin[x_a][ 16] = {  16,   17}; //   2
  needed_v_smin[x_a][ 17] = {  18,   19,   22,   23,   32,   33,   56,   57,   60,   61}; //  10
  needed_v_smin[x_a][ 18] = {  18,   19,   32,   33,   56,   57,   60,   61}; //   8
  needed_v_smin[x_a][ 19] = {  40,   41,   52,   53,   44,   45}; //   6
  needed_v_smin[x_a][ 20] = {  42,   43,   54,   55}; //   4
  needed_v_smin[x_a][ 21] = {  46,   47}; //   2
  needed_v_smin[x_a][ 22] = {  46,   47}; //   2
  needed_v_smin[x_a][ 23] = {  50,   51}; //   2

  v_smax[x_a].resize(29);
  needed_v_smax[x_a].resize(29);
  needed_v_smax[x_a][  0] = {   0,    1,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   24,   28,   29,   30,   31,   34,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   56,   57,   60,   61}; //  36
  needed_v_smax[x_a][  1] = {   0,    1,   24,   34}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   24,   25,   26,   27,   28,   29,   34,   35,   36,   37,   38,   39}; //  24
  needed_v_smax[x_a][  3] = {   0,    2,    4,    5,    8,    9,   14,   15,   18,   19,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   56,   57,   58,   59,   60,   61,   62,   63}; //  34
  needed_v_smax[x_a][  4] = {   1,    3,    6,    7,   10,   11,   12,   13,   16,   17}; //  10
  needed_v_smax[x_a][  5] = {   2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   22,   23,   25,   26,   27,   32,   33,   35,   36,   37,   52,   53,   54,   55,   58,   59,   62,   63}; //  28
  needed_v_smax[x_a][  6] = {   2,    3,   25,   35}; //   4
  needed_v_smax[x_a][  7] = {   4,    5,    6,    7,   26,   27,   36,   37}; //   8
  needed_v_smax[x_a][  8] = {   8,    9,   10,   11,   20,   21,   28,   29,   38,   39,   46,   47,   50,   51,   56,   57,   60,   61}; //  18
  needed_v_smax[x_a][  9] = {  12,   13,   42,   43}; //   4
  needed_v_smax[x_a][ 10] = {  12,   13}; //   2
  needed_v_smax[x_a][ 11] = {  14,   15,   30,   31,   40,   41,   44,   45,   48,   49}; //  10
  needed_v_smax[x_a][ 12] = {  14,   15,   30,   31,   44,   45,   48,   49}; //   8
  needed_v_smax[x_a][ 13] = {  16,   17}; //   2
  needed_v_smax[x_a][ 14] = {  16,   17}; //   2
  needed_v_smax[x_a][ 15] = {  18,   19,   32,   33}; //   4
  needed_v_smax[x_a][ 16] = {  18,   19,   32,   33}; //   4
  needed_v_smax[x_a][ 17] = {  20,   21,   52,   53,   58,   59,   62,   63}; //   8
  needed_v_smax[x_a][ 18] = {  20,   21,   48,   49}; //   4
  needed_v_smax[x_a][ 19] = {  22,   23,   52,   53,   54,   55,   58,   59,   62,   63}; //  10
  needed_v_smax[x_a][ 20] = {  22,   23,   56,   57,   60,   61}; //   6
  needed_v_smax[x_a][ 21] = {  22,   23}; //   2
  needed_v_smax[x_a][ 22] = {  40,   41,   42,   43}; //   4
  needed_v_smax[x_a][ 23] = {  40,   41,   42,   43}; //   4
  needed_v_smax[x_a][ 24] = {  50,   51}; //   2
  needed_v_smax[x_a][ 25] = {  52,   53,   54,   55,   44,   45,   46,   47}; //   8
  needed_v_smax[x_a][ 26] = {  54,   55}; //   2
  needed_v_smax[x_a][ 27] = {  46,   47}; //   2
  needed_v_smax[x_a][ 28] = {  50,   51}; //   2

  g_p[x_a].resize(41);
  needed_g_p[x_a].resize(41);
  needed_g_p[x_a][0] = {   0,    1,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   24,   28,   29,   30,   31,   34,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   56,   57,   60,   61}; //  36
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   24,   34}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1,   24,   34}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    2,    4,    5,    8,    9,   24,   25,   26,   27,   28,   29}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    6,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   2,    3,    5,    7,   17,   19,   23,   25,   27,   33,   35,   37,   53,   55,   59,   63}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax5");
  needed_g_p[x_a][6] = {   2,    3,   25,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][7] = {   2,    3,   25,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][8] = {   4,    6,   16,   18,   22,   26,   32,   36,   52,   54,   58,   62}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][9] = {   4,    5,    6,    7,   26,   27,   36,   37}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {   4,    5,    6,    7,   26,   27,   36,   37}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][11] = {   8,   10,   20,   28,   38,   46,   50,   56,   60}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax8");
  needed_g_p[x_a][12] = {   8,    9,   10,   11,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax2");
  needed_g_p[x_a][13] = {   9,   11,   21,   29,   39,   47,   51,   57,   61}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax8");
  needed_g_p[x_a][14] = {  12,   13,   42,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][15] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax10");
  needed_g_p[x_a][16] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax4");
  needed_g_p[x_a][17] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax10");
  needed_g_p[x_a][18] = {  14,   15,   30,   31,   40,   41,   44,   45,   48,   49}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax11");
  needed_g_p[x_a][19] = {  14,   30,   44,   48}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax12");
  needed_g_p[x_a][20] = {  14,   15,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax3");
  needed_g_p[x_a][21] = {  15,   31,   45,   49}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax12");
  needed_g_p[x_a][22] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax13");
  needed_g_p[x_a][23] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][24] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax4");
  needed_g_p[x_a][25] = {  18,   19,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax15");
  needed_g_p[x_a][26] = {  18,   19,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax16");
  needed_g_p[x_a][27] = {  18,   19,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax3");
  needed_g_p[x_a][28] = {  20,   21,   52,   53,   58,   59}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax17");
  needed_g_p[x_a][29] = {  20,   21,   48,   49}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax18");
  needed_g_p[x_a][30] = {  22,   23,   52,   53,   54,   55,   58,   59,   62,   63}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax19");
  needed_g_p[x_a][31] = {  22,   23,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax20");
  needed_g_p[x_a][32] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax21");
  needed_g_p[x_a][33] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax22");
  needed_g_p[x_a][34] = {  40,   42}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax23");
  needed_g_p[x_a][35] = {  41,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax23");
  needed_g_p[x_a][36] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax22");
  needed_g_p[x_a][37] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax24");
  needed_g_p[x_a][38] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax25");
  needed_g_p[x_a][39] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax26");
  needed_g_p[x_a][40] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax25");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {  34,   35,   36,   37,   38,   39}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {  44,   45}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax25");
  needed_g_f[x_a][2] = {  46,   47}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax27");
  needed_g_f[x_a][3] = {  46,   47}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax25");
  needed_g_f[x_a][4] = {  50,   51}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax28");
  needed_g_f[x_a][5] = {  56,   57,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax3");
  needed_g_f[x_a][6] = {  58,   59,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax3");
  needed_g_f[x_a][7] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax20");
  needed_g_f[x_a][8] = {  62,   63}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax17");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   56,   57,   58,   59,   60,   61,   62,   63}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][1] = {  34,   35,   36,   37,   38,   39}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][2] = {  40,   41,   42,   43,   44,   45,   46,   47}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_232");
  needed_g_t[x_a][3] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__168_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__168_64");
  needed_g_t[x_a][4] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_192");
  needed_g_t[x_a][5] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__21_42__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__21_42__64_128");
  needed_g_t[x_a][6] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__84_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__84_168");
  needed_g_t[x_a][7] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_212");
  needed_g_t[x_a][8] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_42__84_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_42__84_128");
  needed_g_t[x_a][9] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_232");
  needed_g_t[x_a][10] = {  56,   57,   60,   61}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_148");
  needed_g_t[x_a][11] = {  58,   59,   62,   63}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_168");
  needed_g_t[x_a][12] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_42__128_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_42__128_20");
  needed_g_t[x_a][13] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_22__128_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_22__128_40");

  g_d[x_a].resize(25);
  needed_g_d[x_a].resize(25);
  needed_g_d[x_a][0] = {   0,    2,    4,    5,    8,    9,   14,   15,   18,   19}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][1] = {   0,    2,    4,    5,    8,    9,   24,   25,   26,   27,   28,   29}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][2] = {   0,    1,   24,   34}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][3] = {   0,    1,   24,   34}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][4] = {   0,    1,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   28,   29,   30,   31,   32,   33,   34,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][5] = {   1,    3,    6,    7,   10,   11,   12,   13,   16,   17}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][6] = {   1,    3,    6,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][7] = {   2,    3,   25,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {   2,    3,   25,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][9] = {   2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   25,   26,   27,   28,   29,   30,   31,   32,   33,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][10] = {   4,    5,    6,    7,   26,   27,   36,   37}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][11] = {   4,    5,    6,    7,   26,   27,   36,   37}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][12] = {   8,    9,   10,   11,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][13] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][14] = {  12,   13,   22,   23,   42,   43,   54,   55}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][15] = {  14,   15,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__20_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__20_168");
  needed_g_d[x_a][16] = {  14,   15,   20,   21,   30,   31,   40,   41,   44,   45,   48,   49,   52,   53,   58,   59}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_168__128_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_168__128_40");
  needed_g_d[x_a][17] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][18] = {  16,   17,   20,   21,   48,   49,   50,   51}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][19] = {  18,   19,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__40_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__40_148");
  needed_g_d[x_a][20] = {  18,   19,   22,   23,   32,   33,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][21] = {  20,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__84_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__84_168");
  needed_g_d[x_a][22] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__104_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__104_148");
  needed_g_d[x_a][23] = {  40,   41,   52,   53}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_232__64_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_232__64_168");
  needed_g_d[x_a][24] = {  42,   43,   54,   55}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_232__128_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_232__128_104");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][1] = {  0,   1,   2,   4}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][2] = {  5,   6,   7,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   7,   8,   9}; //   5

  c_p[x_a][3] = {  5,   6,   7,   4}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  5,   6,   7,   8,   9}; //   5

  c_p[x_a][4] = {  8,   9,  10,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   1,  10,  11,   9}; //   5

  c_p[x_a][5] = {  5,   9,  10,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   1,  10,  11,   9}; //   5

  c_p[x_a][6] = {  8,   9,  10,   4}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  5,   6,  10,  11,   9}; //   5

  c_p[x_a][7] = {  5,   9,  10,   4}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,   6,  10,  11,   9}; //   5

  c_p[x_a][8] = {  0,  11,  12,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   1,  12,   9,   4}; //   5

  c_p[x_a][9] = {  0,  13,  12,   3}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,   1,  12,   9,   4}; //   5

  c_p[x_a][10] = {  0,  11,  12,   4}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  5,   6,  12,   9,   4}; //   5

  c_p[x_a][11] = {  0,  13,  12,   4}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   6,  12,   9,   4}; //   5

  c_p[x_a][12] = {  0,  14,  15,  16}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  5,  13,   9,  14,   4}; //   5

  c_p[x_a][13] = {  0,  14,  17,  16}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  5,  13,   9,  14,   4}; //   5

  c_p[x_a][14] = {  0,  18,  19,  20}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  0,  15,   9,  16,   4}; //   5

  c_p[x_a][15] = {  0,  18,  21,  20}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  0,  15,   9,  16,   4}; //   5

  c_p[x_a][16] = {  8,  22,  23,  24}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  5,  17,   4,  18,   9}; //   5

  c_p[x_a][17] = {  5,  22,  23,  24}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  5,  17,   4,  18,   9}; //   5

  c_p[x_a][18] = {  8,  25,  26,  27}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  0,  19,   4,  20,   9}; //   5

  c_p[x_a][19] = {  5,  25,  26,  27}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  0,  19,   4,  20,   9}; //   5

  c_p[x_a][20] = {  0,  11,  28,  29}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 21,  18,  16,   9,   4}; //   5

  c_p[x_a][21] = {  0,  13,  28,  29}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 21,  18,  16,   9,   4}; //   5

  c_p[x_a][22] = {  8,  30,  31,  32}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 22,  14,  20,   4,   9}; //   5

  c_p[x_a][23] = {  5,  30,  31,  32}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 22,  14,  20,   4,   9}; //   5

  c_p[x_a][24] = {  0,   1,   2,   3}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  1,   2,   3,   4}; //   4

  c_p[x_a][25] = {  5,   6,   7,   3}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  1,   7,   8,   9}; //   4

  c_p[x_a][26] = {  8,   9,  10,   3}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  1,  10,  11,   9}; //   4

  c_p[x_a][27] = {  5,   9,  10,   3}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  1,  10,  11,   9}; //   4

  c_p[x_a][28] = {  0,  11,  12,   3}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = {  1,  12,   9,   4}; //   4

  c_p[x_a][29] = {  0,  13,  12,   3}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = {  1,  12,   9,   4}; //   4

  c_p[x_a][30] = {  0,  18,  19,  20}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = { 15,   9,  16,   4}; //   4

  c_p[x_a][31] = {  0,  18,  21,  20}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 15,   9,  16,   4}; //   4

  c_p[x_a][32] = {  8,  25,  26,  27}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  0}; //   1
  c_d[x_a][32] = { 19,   4,  20,   9}; //   4

  c_p[x_a][33] = {  5,  25,  26,  27}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  0}; //   1
  c_d[x_a][33] = { 19,   4,  20,   9}; //   4

  c_p[x_a][34] = {  0,   1,   2}; //   3
  c_f[x_a][34] = {  0}; //   1
  c_t[x_a][34] = {  0,   1}; //   2
  c_d[x_a][34] = {  2,   3,   4}; //   3

  c_p[x_a][35] = {  5,   6,   7}; //   3
  c_f[x_a][35] = {  0}; //   1
  c_t[x_a][35] = {  0,   1}; //   2
  c_d[x_a][35] = {  7,   8,   9}; //   3

  c_p[x_a][36] = {  8,   9,  10}; //   3
  c_f[x_a][36] = {  0}; //   1
  c_t[x_a][36] = {  0,   1}; //   2
  c_d[x_a][36] = { 10,  11,   9}; //   3

  c_p[x_a][37] = {  5,   9,  10}; //   3
  c_f[x_a][37] = {  0}; //   1
  c_t[x_a][37] = {  0,   1}; //   2
  c_d[x_a][37] = { 10,  11,   9}; //   3

  c_p[x_a][38] = {  0,  11,  12}; //   3
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  0,   1}; //   2
  c_d[x_a][38] = { 12,   9,   4}; //   3

  c_p[x_a][39] = {  0,  13,  12}; //   3
  c_f[x_a][39] = {  0}; //   1
  c_t[x_a][39] = {  0,   1}; //   2
  c_d[x_a][39] = { 12,   9,   4}; //   3

  c_p[x_a][40] = {  0,  18,  33,  34}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  2}; //   1
  c_d[x_a][40] = {  9,  23,  16,   4}; //   4

  c_p[x_a][41] = {  0,  18,  33,  35}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  2}; //   1
  c_d[x_a][41] = {  9,  23,  16,   4}; //   4

  c_p[x_a][42] = {  0,  14,  36,  34}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  2}; //   1
  c_d[x_a][42] = {  9,  24,  14,   4}; //   4

  c_p[x_a][43] = {  0,  14,  36,  35}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  2}; //   1
  c_d[x_a][43] = {  9,  24,  14,   4}; //   4

  c_p[x_a][44] = {  0,  18,  19}; //   3
  c_f[x_a][44] = {  1}; //   1
  c_t[x_a][44] = {  2,   3}; //   2
  c_d[x_a][44] = {  9,  16,   4}; //   3

  c_p[x_a][45] = {  0,  18,  21}; //   3
  c_f[x_a][45] = {  1}; //   1
  c_t[x_a][45] = {  2,   3}; //   2
  c_d[x_a][45] = {  9,  16,   4}; //   3

  c_p[x_a][46] = {  0,  11}; //   2
  c_f[x_a][46] = {  2,   3}; //   2
  c_t[x_a][46] = {  2,   4,   5}; //   3
  c_d[x_a][46] = {  9,   4}; //   2

  c_p[x_a][47] = {  0,  13}; //   2
  c_f[x_a][47] = {  2,   3}; //   2
  c_t[x_a][47] = {  2,   4,   5}; //   3
  c_d[x_a][47] = {  9,   4}; //   2

  c_p[x_a][48] = {  0,  18,  19,  29}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  6}; //   1
  c_d[x_a][48] = { 18,   9,  16,   4}; //   4

  c_p[x_a][49] = {  0,  18,  21,  29}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  6}; //   1
  c_d[x_a][49] = { 18,   9,  16,   4}; //   4

  c_p[x_a][50] = {  0,  11,  37}; //   3
  c_f[x_a][50] = {  4}; //   1
  c_t[x_a][50] = {  7,   8}; //   2
  c_d[x_a][50] = { 18,   9,   4}; //   3

  c_p[x_a][51] = {  0,  13,  37}; //   3
  c_f[x_a][51] = {  4}; //   1
  c_t[x_a][51] = {  7,   8}; //   2
  c_d[x_a][51] = { 18,   9,   4}; //   3

  c_p[x_a][52] = {  8,  30,  28,  38}; //   4
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  9}; //   1
  c_d[x_a][52] = { 23,  16,   4,   9}; //   4

  c_p[x_a][53] = {  5,  30,  28,  38}; //   4
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  9}; //   1
  c_d[x_a][53] = { 23,  16,   4,   9}; //   4

  c_p[x_a][54] = {  8,  30,  39,  40}; //   4
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  9}; //   1
  c_d[x_a][54] = { 24,  14,   4,   9}; //   4

  c_p[x_a][55] = {  5,  30,  39,  40}; //   4
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  9}; //   1
  c_d[x_a][55] = { 24,  14,   4,   9}; //   4

  c_p[x_a][56] = {  0,  11,  31}; //   3
  c_f[x_a][56] = {  5}; //   1
  c_t[x_a][56] = {  0,  10}; //   2
  c_d[x_a][56] = { 20,   9,   4}; //   3

  c_p[x_a][57] = {  0,  13,  31}; //   3
  c_f[x_a][57] = {  5}; //   1
  c_t[x_a][57] = {  0,  10}; //   2
  c_d[x_a][57] = { 20,   9,   4}; //   3

  c_p[x_a][58] = {  8,  30,  28}; //   3
  c_f[x_a][58] = {  6}; //   1
  c_t[x_a][58] = {  0,  11}; //   2
  c_d[x_a][58] = { 16,   4,   9}; //   3

  c_p[x_a][59] = {  5,  30,  28}; //   3
  c_f[x_a][59] = {  6}; //   1
  c_t[x_a][59] = {  0,  11}; //   2
  c_d[x_a][59] = { 16,   4,   9}; //   3

  c_p[x_a][60] = {  0,  11}; //   2
  c_f[x_a][60] = {  7,   5}; //   2
  c_t[x_a][60] = {  0,  10,  12}; //   3
  c_d[x_a][60] = {  9,   4}; //   2

  c_p[x_a][61] = {  0,  13}; //   2
  c_f[x_a][61] = {  7,   5}; //   2
  c_t[x_a][61] = {  0,  10,  12}; //   3
  c_d[x_a][61] = {  9,   4}; //   2

  c_p[x_a][62] = {  8,  30}; //   2
  c_f[x_a][62] = {  8,   6}; //   2
  c_t[x_a][62] = {  0,  11,  13}; //   3
  c_d[x_a][62] = {  4,   9}; //   2

  c_p[x_a][63] = {  5,  30}; //   2
  c_f[x_a][63] = {  8,   6}; //   2
  c_t[x_a][63] = {  0,  11,  13}; //   3
  c_d[x_a][63] = {  4,   9}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_uux_emmumepvmxudx
//  channel    0: 6yyyyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel    1: 6yyyyv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel    2: 6yyyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel    3: 6yyyyv(1, 2, 128, 64, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel    4: 6yyyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel    5: 6yyyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel    6: 6yyyyv(1, 2, 128, 64, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel    7: 6yyyyv(1, 2, 128, 64, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel    8: 6yy2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel    9: 6yy2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   10: 6yy2vv(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   11: 6yy2vv(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   12: 6y2vyv(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,   0,   0,   0)
//  channel   13: 6y2vyv(1, 2, 128, 4, 16, 64, 8, 32;  24,   0,  23,   0,   0)
//  channel   14: 6y2vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   15: 6y2vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
//  channel   16: 6y2vyv(1, 2, 128, 8, 32, 64, 4, 16;   0,   0,  24,   0,   0)
//  channel   17: 6y2vyv(1, 2, 128, 8, 32, 64, 4, 16;  23,   0,  24,   0,   0)
//  channel   18: 6y2vyv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   19: 6y2vyv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   20: 63yvyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   21: 63yvyv(1, 2, 64, 4, 16, 128, 8, 32;  24,  23,   0,   0,   0)
//  channel   22: 63yvyv(1, 2, 64, 8, 32, 128, 4, 16;   0,  24,   0,   0,   0)
//  channel   23: 63yvyv(1, 2, 64, 8, 32, 128, 4, 16;  23,  24,   0,   0,   0)
//  channel   24: 15yyyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   25: 15yyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   26: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   27: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   28: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   29: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   30: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   31: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
//  channel   32: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   33: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   34: 114yyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   35: 114yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   36: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   37: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   38: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   39: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   40: 2v4yyv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   41: 2v4yyv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,  23,   0)
//  channel   42: 2v4yyv(1, 2, 4, 16, 128, 64, 8, 32;  24,   0,   0,   0,   0)
//  channel   43: 2v4yyv(1, 2, 4, 16, 128, 64, 8, 32;  24,   0,   0,  23,   0)
//  channel   44: 2v13yv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   45: 2v13yv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,  23,   0,   0)
//  channel   46: 2v112v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   47: 2v112v(1, 2, 4, 16, 64, 128, 8, 32;  24,  23,   0,   0,   0)
//  channel   48: 3yv3yv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   49: 3yv3yv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
//  channel   50: 3yv12v(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   51: 3yv12v(1, 2, 64, 4, 16, 128, 8, 32;  24,  23,   0,   0,   0)
//  channel   52: 4yyv2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel   53: 4yyv2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
//  channel   54: 4yyv2v(1, 2, 128, 64, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel   55: 4yyv2v(1, 2, 128, 64, 8, 32, 4, 16;  23,  24,   0,   0,   0)
//  channel   56: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   57: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   58: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel   59: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
//  channel   60: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   61: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   62: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel   63: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
