#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_140_dux_emmumepvmxg(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_140_dux_emmumepvmxg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(11);
  needed_v_smin[x_a].resize(11);
  needed_v_smin[x_a][  0] = {   0,    4,    5,    6,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  18
  needed_v_smin[x_a][  1] = {   0,    6}; //   2
  needed_v_smin[x_a][  2] = {   0,    6}; //   2
  needed_v_smin[x_a][  3] = {   1,    2,    3,    4,    5,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  22
  needed_v_smin[x_a][  4] = {   1,    7}; //   2
  needed_v_smin[x_a][  5] = {   1,    7}; //   2
  needed_v_smin[x_a][  6] = {   2,    3,    8,    9}; //   4
  needed_v_smin[x_a][  7] = {   2,    3,    8,    9}; //   4
  needed_v_smin[x_a][  8] = {   4,    5,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23}; //  12
  needed_v_smin[x_a][  9] = {  16,   17}; //   2
  needed_v_smin[x_a][ 10] = {  18,   19}; //   2

  v_smax[x_a].resize(10);
  needed_v_smax[x_a].resize(10);
  needed_v_smax[x_a][  0] = {   0,    4,    5,    6,   10,   11,   12,   13,   16,   17,   20,   21}; //  12
  needed_v_smax[x_a][  1] = {   0,    6}; //   2
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23}; //  20
  needed_v_smax[x_a][  3] = {   1,    2,    3,    7,    8,    9,   14,   15,   18,   19,   22,   23}; //  12
  needed_v_smax[x_a][  4] = {   1,    7}; //   2
  needed_v_smax[x_a][  5] = {   2,    3,    8,    9}; //   4
  needed_v_smax[x_a][  6] = {   4,    5,   10,   11,   12,   13,   16,   17,   20,   21}; //  10
  needed_v_smax[x_a][  7] = {  14,   15,   18,   19,   22,   23}; //   6
  needed_v_smax[x_a][  8] = {  16,   17}; //   2
  needed_v_smax[x_a][  9] = {  18,   19}; //   2

  g_p[x_a].resize(13);
  needed_g_p[x_a].resize(13);
  needed_g_p[x_a][0] = {   0,    4,    5,    6,   10,   11,   12,   13,   16,   17,   20,   21}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,    7,    9,   15,   19,   23}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   1,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax2");
  needed_g_p[x_a][6] = {   2,    8,   14,   18,   22}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][7] = {   2,    3,    8,    9}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   2,    3,    8,    9}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   10,   12,   16,   20}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax6");
  needed_g_p[x_a][10] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   11,   13,   17,   21}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax6");
  needed_g_p[x_a][12] = {  14,   15,   18,   19,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax7");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  12,   13,   14,   15,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax2");
  needed_g_f[x_a][1] = {  16,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax8");
  needed_g_f[x_a][2] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax9");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   6,    7,    8,    9,   10,   11,   20,   21,   22,   23}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__20_40");
  needed_g_t[x_a][3] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__40_20");
  needed_g_t[x_a][4] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_104");
  needed_g_t[x_a][5] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_64");
  needed_g_t[x_a][6] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_84");
  needed_g_t[x_a][7] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_64");
  needed_g_t[x_a][8] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_20");
  needed_g_t[x_a][9] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_40");

  g_d[x_a].resize(9);
  needed_g_d[x_a].resize(9);
  needed_g_d[x_a][0] = {   0,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][2] = {   0,    4,    5,    6,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   1,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][4] = {   1,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][5] = {   1,    2,    3,    4,    5,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  22
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {   2,    3,    8,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   2,    3,    8,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  3,   4,   5}; //   3

  c_p[x_a][2] = {  6,   7,   8}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  6,   7,   5}; //   3

  c_p[x_a][3] = {  3,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  8,   5,   2}; //   3

  c_p[x_a][5] = {  0,  11,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   5,   2}; //   3

  c_p[x_a][6] = {  0,   1,   2}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  1}; //   1
  c_d[x_a][6] = {  0,   1,   2}; //   3

  c_p[x_a][7] = {  3,   4,   5}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  1}; //   1
  c_d[x_a][7] = {  3,   4,   5}; //   3

  c_p[x_a][8] = {  6,   7,   8}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  1}; //   1
  c_d[x_a][8] = {  6,   7,   5}; //   3

  c_p[x_a][9] = {  3,   7,   8}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  1}; //   1
  c_d[x_a][9] = {  6,   7,   5}; //   3

  c_p[x_a][10] = {  0,   9,  10}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  1}; //   1
  c_d[x_a][10] = {  8,   5,   2}; //   3

  c_p[x_a][11] = {  0,  11,  10}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  1}; //   1
  c_d[x_a][11] = {  8,   5,   2}; //   3

  c_p[x_a][12] = {  0,   9}; //   2
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   2}; //   2
  c_d[x_a][12] = {  5,   2}; //   2

  c_p[x_a][13] = {  0,  11}; //   2
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   2}; //   2
  c_d[x_a][13] = {  5,   2}; //   2

  c_p[x_a][14] = {  6,  12}; //   2
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  0,   3}; //   2
  c_d[x_a][14] = {  2,   5}; //   2

  c_p[x_a][15] = {  3,  12}; //   2
  c_f[x_a][15] = {  0}; //   1
  c_t[x_a][15] = {  0,   3}; //   2
  c_d[x_a][15] = {  2,   5}; //   2

  c_p[x_a][16] = {  0,   9}; //   2
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  4,   5}; //   2
  c_d[x_a][16] = {  5,   2}; //   2

  c_p[x_a][17] = {  0,  11}; //   2
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  4,   5}; //   2
  c_d[x_a][17] = {  5,   2}; //   2

  c_p[x_a][18] = {  6,  12}; //   2
  c_f[x_a][18] = {  2}; //   1
  c_t[x_a][18] = {  6,   7}; //   2
  c_d[x_a][18] = {  2,   5}; //   2

  c_p[x_a][19] = {  3,  12}; //   2
  c_f[x_a][19] = {  2}; //   1
  c_t[x_a][19] = {  6,   7}; //   2
  c_d[x_a][19] = {  2,   5}; //   2

  c_p[x_a][20] = {  0,   9}; //   2
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  1,   8}; //   2
  c_d[x_a][20] = {  5,   2}; //   2

  c_p[x_a][21] = {  0,  11}; //   2
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  1,   8}; //   2
  c_d[x_a][21] = {  5,   2}; //   2

  c_p[x_a][22] = {  6,  12}; //   2
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  1,   9}; //   2
  c_d[x_a][22] = {  2,   5}; //   2

  c_p[x_a][23] = {  3,  12}; //   2
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  1,   9}; //   2
  c_d[x_a][23] = {  2,   5}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_dux_emmumepvmxg
//  channel    0: 4yyv1(1, 2, 4, 16, 8, 32, 64;  24,   0,  24,   0)
//  channel    1: 4yyv1(1, 2, 8, 32, 4, 16, 64;  23,   0,  24,   0)
//  channel    2: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,  24,   0)
//  channel    3: 4yyv1(1, 2, 32, 8, 4, 16, 64;  23,   0,  24,   0)
//  channel    4: 42vv1(1, 2, 4, 16, 8, 32, 64;  24,   0,  24,   0)
//  channel    5: 42vv1(1, 2, 4, 16, 8, 32, 64;  24,  23,  24,   0)
//  channel    6: 14yyv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
//  channel    7: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  24,   0)
//  channel    8: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,   0)
//  channel    9: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,   0)
//  channel   10: 142vv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
//  channel   11: 142vv(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,   0)
//  channel   12: 2v2v1(1, 2, 4, 16, 8, 32, 64;  24,   0,   0,   0)
//  channel   13: 2v2v1(1, 2, 4, 16, 8, 32, 64;  24,  23,   0,   0)
//  channel   14: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,  24,   0,   0)
//  channel   15: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,  24,   0,   0)
//  channel   16: 2v12v(1, 2, 4, 16, 64, 8, 32;  24,   0,   0,   0)
//  channel   17: 2v12v(1, 2, 4, 16, 64, 8, 32;  24,  23,   0,   0)
//  channel   18: 2v12v(1, 2, 8, 32, 64, 4, 16;   0,  24,   0,   0)
//  channel   19: 2v12v(1, 2, 8, 32, 64, 4, 16;  23,  24,   0,   0)
//  channel   20: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,   0,   0,   0)
//  channel   21: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,  23,   0,   0)
//  channel   22: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,  24,   0,   0)
//  channel   23: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,  24,   0,   0)
