#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ac_psp_240_dc_emmupvmvexus(int x_a, int channel){
  static Logger logger("ppemxnmnex04_phasespace_set::ac_psp_240_dc_emmupvmvexus");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][24];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][228], 2);
      c_propagator(x_a,  24,  24, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][152]);
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][100], 2);
      c_propagator(x_a,   0, 152, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  2] = smin_opt[x_a][36];
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][152], sqrtsmin_opt[x_a][216]), 2);
      c_propagator(x_a,  24,  36, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  2] = smin_opt[x_a][36];
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][192] + xbsqrts_all[x_a][24], sqrtsmin_opt[x_a][216]), 2);
      c_propagator(x_a,  24,  36, v_smin[x_a][  2], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][152], 2);
      c_propagator(x_a,   0, 100, v_smin[x_a][  3], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][24], sqrtsmin_opt[x_a][152]), 2);
      c_propagator(x_a,   0, 100, v_smin[x_a][  3], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 5));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][152], 2), smin_opt[x_a][216]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][36], 2);
      c_timelikeinvariant(x_a, 216, v_smin[x_a][  4], v_smax[x_a][  6], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][  5] = smin_opt[x_a][192];
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(xbsqrts_all[x_a][24] + xbsqrts_all[x_a][36], sqrtsmin_opt[x_a][60]), 2);
      c_timelikeinvariant(x_a, 192, v_smin[x_a][  5], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][24] + xbsqrts_all[x_a][192], 2), smin_opt[x_a][216]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][36], 2);
      c_timelikeinvariant(x_a, 216, v_smin[x_a][  6], v_smax[x_a][  6], random_manager.get_random(x_a, 1, 2));
    }
    else if (c_f[x_a][channel][i_f] ==   3){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][100], 2), smin_opt[x_a][228]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][24], 2);
      c_timelikeinvariant(x_a, 228, v_smin[x_a][  7], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 3));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0, 252,   1,   2,  36, 216, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0, 216,   2,  37, 152,  64, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel_opt(x_a,   0, 216,   2,  37,  24, 192, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel(x_a,   0, 192,  37,  26,  64, 128, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel_opt(x_a,   0, 252,   1,   2, 100, 152, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel_opt(x_a,   0, 252,   2,   1,  24, 228, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel_opt(x_a,   0, 228,   1,  26, 100, 128, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  36,   4,  32, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a, 152, 128,  24, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  24,   8,  16, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a, 100,  64,  36, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
