#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_bbx_emmupvmvexddx(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_bbx_emmupvmvexddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  28
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   19,   20,   28,   29}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   19,   20,   28,   29}; //   8
  needed_v_smin[x_a][  3] = {   0,    1,    4,    6,    7,   10,   12,   13}; //   8
  needed_v_smin[x_a][  4] = {   2,    3,    5,    8,    9,   11,   14,   15}; //   8
  needed_v_smin[x_a][  5] = {   4,    5,   21,   30}; //   4
  needed_v_smin[x_a][  6] = {   4,    5,   21,   30}; //   4
  needed_v_smin[x_a][  7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   22,   23,   24,   25,   26,   27,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  28
  needed_v_smin[x_a][  8] = {   6,    7,    8,    9,   22,   23,   31,   32}; //   8
  needed_v_smin[x_a][  9] = {   6,    7,    8,    9,   22,   23,   31,   32}; //   8
  needed_v_smin[x_a][ 10] = {  10,   11,   24,   33}; //   4
  needed_v_smin[x_a][ 11] = {  10,   11,   24,   33}; //   4
  needed_v_smin[x_a][ 12] = {  12,   13,   14,   15,   25,   26,   27,   34,   35,   36,   39}; //  11
  needed_v_smin[x_a][ 13] = {  16,   18}; //   2
  needed_v_smin[x_a][ 14] = {  16}; //   1
  needed_v_smin[x_a][ 15] = {  17,   18}; //   2
  needed_v_smin[x_a][ 16] = {  17}; //   1
  needed_v_smin[x_a][ 17] = {  19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  21
  needed_v_smin[x_a][ 18] = {  37,   38}; //   2

  v_smax[x_a].resize(30);
  needed_v_smax[x_a].resize(30);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   19,   20,   21,   25,   26,   27,   38,   39}; //  19
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   19,   20}; //   6
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  25
  needed_v_smax[x_a][  3] = {   0,    1,    4,    6,    7,   10,   12,   13,   17}; //   9
  needed_v_smax[x_a][  4] = {   2,    3,    5,    8,    9,   11,   14,   15,   16}; //   9
  needed_v_smax[x_a][  5] = {   4,    5,   21}; //   3
  needed_v_smax[x_a][  6] = {   6,    7,    8,    9,   10,   11,   17,   18,   22,   23,   24}; //  11
  needed_v_smax[x_a][  7] = {   6,    7,    8,    9,   22,   23}; //   6
  needed_v_smax[x_a][  8] = {  10,   11,   24}; //   3
  needed_v_smax[x_a][  9] = {  12,   13,   14,   15,   25,   26,   27,   39}; //   8
  needed_v_smax[x_a][ 10] = {  16}; //   1
  needed_v_smax[x_a][ 11] = {  16}; //   1
  needed_v_smax[x_a][ 12] = {  17}; //   1
  needed_v_smax[x_a][ 13] = {  17}; //   1
  needed_v_smax[x_a][ 14] = {  18}; //   1
  needed_v_smax[x_a][ 15] = {  18}; //   1
  needed_v_smax[x_a][ 16] = {  18}; //   1
  needed_v_smax[x_a][ 17] = {  19,   20,   21,   22,   23,   24,   25,   26,   27}; //   9
  needed_v_smax[x_a][ 18] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   37}; //  10
  needed_v_smax[x_a][ 19] = {  28,   29,   30,   34,   35,   36,   37}; //   7
  needed_v_smax[x_a][ 20] = {  28,   29}; //   2
  needed_v_smax[x_a][ 21] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   39}; //  10
  needed_v_smax[x_a][ 22] = {  30}; //   1
  needed_v_smax[x_a][ 23] = {  31,   32,   33}; //   3
  needed_v_smax[x_a][ 24] = {  31,   32}; //   2
  needed_v_smax[x_a][ 25] = {  33}; //   1
  needed_v_smax[x_a][ 26] = {  34,   35,   36,   37,   38}; //   5
  needed_v_smax[x_a][ 27] = {  38}; //   1
  needed_v_smax[x_a][ 28] = {  39}; //   1
  needed_v_smax[x_a][ 29] = {  37,   38}; //   2

  g_p[x_a].resize(47);
  needed_g_p[x_a].resize(47);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   19,   20,   21,   25,   26,   27,   38,   39}; //  19
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   19,   20}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   19}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    4,    6,    7,   10,   12,   13}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,   20}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   2,    3,    5,    8,    9,   11,   14,   15}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   4,    5,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][7] = {   4,    5,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   6,    7,    8,    9,   10,   11,   17,   18,   22,   23,   24}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax6");
  needed_g_p[x_a][9] = {   6,    7,    8,    9,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {   6,    8,   22}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][11] = {   7,    9,   23}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {  10,   11,   24}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][13] = {  10,   11,   24}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][14] = {  12,   13,   14,   15,   25,   26,   27,   39}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax9");
  needed_g_p[x_a][15] = {  12,   14,   25}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][16] = {  13,   15,   26}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][17] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][18] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax11");
  needed_g_p[x_a][19] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax4");
  needed_g_p[x_a][20] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][21] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax13");
  needed_g_p[x_a][22] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax3");
  needed_g_p[x_a][23] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][24] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax15");
  needed_g_p[x_a][25] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax16");
  needed_g_p[x_a][26] = {  19,   20,   21,   22,   23,   24,   25,   26,   27}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax17");
  needed_g_p[x_a][27] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin12_smax2");
  needed_g_p[x_a][28] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   37}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax18");
  needed_g_p[x_a][29] = {  28,   29,   30,   34,   35,   36,   37}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax19");
  needed_g_p[x_a][30] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax20");
  needed_g_p[x_a][31] = {  28}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax21");
  needed_g_p[x_a][32] = {  29}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax21");
  needed_g_p[x_a][33] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax22");
  needed_g_p[x_a][34] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax21");
  needed_g_p[x_a][35] = {  31,   32,   33}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax23");
  needed_g_p[x_a][36] = {  31,   32}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax24");
  needed_g_p[x_a][37] = {  31}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax21");
  needed_g_p[x_a][38] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax21");
  needed_g_p[x_a][39] = {  33}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax25");
  needed_g_p[x_a][40] = {  33}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax21");
  needed_g_p[x_a][41] = {  34,   35,   36,   37,   38}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax26");
  needed_g_p[x_a][42] = {  34}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax21");
  needed_g_p[x_a][43] = {  35}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax21");
  needed_g_p[x_a][44] = {  36}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin12_smax21");
  needed_g_p[x_a][45] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax27");
  needed_g_p[x_a][46] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax28");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {  37,   38}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax29");
  needed_g_f[x_a][1] = {  39}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax21");

  g_t[x_a].resize(6);
  needed_g_t[x_a].resize(6);
  needed_g_t[x_a][0] = {  19,   20,   21,   22,   23,   24,   25,   26,   27,   39}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__192_60");
  needed_g_t[x_a][1] = {  28,   29,   30,   31,   32,   33,   34,   35,   36}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__192_60");
  needed_g_t[x_a][2] = {  37,   38}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__36_216");
  needed_g_t[x_a][3] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_37__192_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_37__192_24");
  needed_g_t[x_a][4] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_37__24_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_37__24_192");
  needed_g_t[x_a][5] = {  39}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_193__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_193__24_36");

  g_d[x_a].resize(21);
  needed_g_d[x_a].resize(21);
  needed_g_d[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   17}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][1] = {   0,    1,    4,    6,    7,   10,   12,   13}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,   19,   20,   28,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,   19,   20,   28,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][4] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  28
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   2,    3,    5,    8,    9,   11,   14,   15,   16}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][6] = {   2,    3,    5,    8,    9,   11,   14,   15}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][7] = {   4,    5,   21,   30}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {   4,    5,   21,   30}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][9] = {   6,    7,    8,    9,   22,   23,   31,   32}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {   6,    7,    8,    9,   22,   23,   31,   32}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][11] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   22,   23,   24,   25,   26,   27,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  28
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][12] = {  10,   11,   24,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][13] = {  10,   11,   24,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][14] = {  12,   13,   14,   15,   25,   26,   27,   34,   35,   36}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][15] = {  16}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][16] = {  16,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][17] = {  17}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__24_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__24_164");
  needed_g_d[x_a][18] = {  17,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");
  needed_g_d[x_a][19] = {  18}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__88_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__88_164");
  needed_g_d[x_a][20] = {  19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  21
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");

  c_p[x_a].resize(40);
  c_f[x_a].resize(40);
  c_t[x_a].resize(40);
  c_d[x_a].resize(40);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][1] = {  0,   1,   4,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][2] = {  0,   1,   2,   5}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][3] = {  0,   1,   4,   5}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][4] = {  0,   6,   7,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   1,   7,   8,   4}; //   5

  c_p[x_a][5] = {  0,   6,   7,   5}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,   6,   7,   8,   4}; //   5

  c_p[x_a][6] = {  8,   9,  10,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   1,   9,  10,  11}; //   5

  c_p[x_a][7] = {  8,   9,  11,   3}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,   1,   9,  10,  11}; //   5

  c_p[x_a][8] = {  8,   9,  10,   5}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  5,   6,   9,  10,  11}; //   5

  c_p[x_a][9] = {  8,   9,  11,   5}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  5,   6,   9,  10,  11}; //   5

  c_p[x_a][10] = {  8,  12,  13,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,   1,  12,  13,  11}; //   5

  c_p[x_a][11] = {  8,  12,  13,   5}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   6,  12,  13,  11}; //   5

  c_p[x_a][12] = {  0,  14,  15,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,   1,  14,  11,   4}; //   5

  c_p[x_a][13] = {  0,  14,  16,   3}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  0,   1,  14,  11,   4}; //   5

  c_p[x_a][14] = {  0,  14,  15,   5}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  5,   6,  14,  11,   4}; //   5

  c_p[x_a][15] = {  0,  14,  16,   5}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  5,   6,  14,  11,   4}; //   5

  c_p[x_a][16] = {  0,  17,  18,  19}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  5,  15,  11,  16,   4}; //   5

  c_p[x_a][17] = {  8,  20,  21,  22}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  0,  17,   4,  18,  11}; //   5

  c_p[x_a][18] = {  8,  23,  24,  25}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 19,  16,  18,   4,  11}; //   5

  c_p[x_a][19] = {  0,   1,   2,  26}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 20,   2,   3,   4}; //   4

  c_p[x_a][20] = {  0,   1,   4,  26}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = { 20,   2,   3,   4}; //   4

  c_p[x_a][21] = {  0,   6,   7,  26}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = { 20,   7,   8,   4}; //   4

  c_p[x_a][22] = {  8,   9,  10,  26}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = { 20,   9,  10,  11}; //   4

  c_p[x_a][23] = {  8,   9,  11,  26}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = { 20,   9,  10,  11}; //   4

  c_p[x_a][24] = {  8,  12,  13,  26}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = { 20,  12,  13,  11}; //   4

  c_p[x_a][25] = {  0,  14,  15,  26}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = { 20,  14,  11,   4}; //   4

  c_p[x_a][26] = {  0,  14,  16,  26}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = { 20,  14,  11,   4}; //   4

  c_p[x_a][27] = {  0,  14,  27,  26}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = { 20,  14,  11,   4}; //   4

  c_p[x_a][28] = { 28,  29,  30,  31}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  1}; //   1
  c_d[x_a][28] = {  2,   3,   4,  20}; //   4

  c_p[x_a][29] = { 28,  29,  30,  32}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  1}; //   1
  c_d[x_a][29] = {  2,   3,   4,  20}; //   4

  c_p[x_a][30] = { 28,  29,  33,  34}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  1}; //   1
  c_d[x_a][30] = {  7,   8,   4,  20}; //   4

  c_p[x_a][31] = { 28,  35,  36,  37}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  1}; //   1
  c_d[x_a][31] = {  9,  10,  11,  20}; //   4

  c_p[x_a][32] = { 28,  35,  36,  38}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  1}; //   1
  c_d[x_a][32] = {  9,  10,  11,  20}; //   4

  c_p[x_a][33] = { 28,  35,  39,  40}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  1}; //   1
  c_d[x_a][33] = { 12,  13,  11,  20}; //   4

  c_p[x_a][34] = { 28,  29,  41,  42}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  1}; //   1
  c_d[x_a][34] = { 14,  11,   4,  20}; //   4

  c_p[x_a][35] = { 28,  29,  41,  43}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  1}; //   1
  c_d[x_a][35] = { 14,  11,   4,  20}; //   4

  c_p[x_a][36] = { 28,  29,  41,  44}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  1}; //   1
  c_d[x_a][36] = { 14,  11,   4,  20}; //   4

  c_p[x_a][37] = { 28,  29,  41}; //   3
  c_f[x_a][37] = {  0}; //   1
  c_t[x_a][37] = {  2,   3}; //   2
  c_d[x_a][37] = { 11,   4,  20}; //   3

  c_p[x_a][38] = {  0,  45,  41}; //   3
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  2,   4}; //   2
  c_d[x_a][38] = { 11,  20,   4}; //   3

  c_p[x_a][39] = {  0,  14,  46}; //   3
  c_f[x_a][39] = {  1}; //   1
  c_t[x_a][39] = {  0,   5}; //   2
  c_d[x_a][39] = { 20,  11,   4}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_bbx_emmupvmvexddx
//  channel    0: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel    1: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel    2: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel    3: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel    4: 6yyyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel    5: 6yyyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel    6: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel    7: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel    8: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel    9: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   10: 6yyyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   11: 6yyyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   12: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   13: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   14: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   15: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   16: 6y2vyv(1, 2, 128, 4, 32, 64, 8, 16;  24,   0,  24,   0,   0)
//  channel   17: 6y2vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  24,   0,   0)
//  channel   18: 63yvyv(1, 2, 64, 8, 16, 128, 4, 32;  24,  24,   0,   0,   0)
//  channel   19: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   5)
//  channel   20: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   5)
//  channel   21: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   5)
//  channel   22: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   5)
//  channel   23: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   5)
//  channel   24: 2v4yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   5)
//  channel   25: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   5)
//  channel   26: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   5)
//  channel   27: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   0,   5)
//  channel   28: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,   0,   5)
//  channel   29: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,  23,   5)
//  channel   30: 4yyv2v(1, 2, 32, 4, 8, 16, 64, 128;   0,  24,   0,  23,   5)
//  channel   31: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,   0,   5)
//  channel   32: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,  23,   5)
//  channel   33: 4yyv2v(1, 2, 16, 8, 4, 32, 64, 128;   0,  24,   0,  23,   5)
//  channel   34: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   5)
//  channel   35: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,  23,   5)
//  channel   36: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,  25,   5)
//  channel   37: 2v2v2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   6,   5)
//  channel   38: 2v2v2v(1, 2, 4, 32, 64, 128, 8, 16;  24,   0,  24,   6,   6)
//  channel   39: 2v2v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   6)
