#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_gbx_emmupvmvexgbx(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_gbx_emmupvmvexgbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(20);
  needed_v_smin[x_a].resize(20);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   16,   17,   18,   19,   20,   21,   22,   23,   27,   28,   29,   30,   31,   32,   33,   37,   38,   39,   40,   41,   42,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   62,   63,   64,   65,   66,   67,   68,   69,   70,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  needed_v_smin[x_a][  1] = {   0,    1,   10,   11,   20,   21,   31,   32,   40,   41,   50,   51,   52,   53,   68,   69}; //  16
  needed_v_smin[x_a][  2] = {   0,    1,   10,   11,   20,   21,   31,   32,   40,   41,   50,   51,   52,   53,   68,   69}; //  16
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   40,   41,   42,   43,   44,   45,   46,   47,   48,   50,   51,   54,   56,   57,   60,   62,   63,   64}; //  36
  needed_v_smin[x_a][  4] = {   2,   12,   22,   33,   42,   54,   55,   70}; //   8
  needed_v_smin[x_a][  5] = {   2,   12,   22,   33,   42,   54,   55,   70}; //   8
  needed_v_smin[x_a][  6] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  needed_v_smin[x_a][  7] = {   3,    4,   13,   14,   24,   25,   34,   35,   43,   44,   56,   57,   58,   59,   71,   72}; //  16
  needed_v_smin[x_a][  8] = {   3,    4,   13,   14,   24,   25,   34,   35,   43,   44,   56,   57,   58,   59,   71,   72}; //  16
  needed_v_smin[x_a][  9] = {   5,   15,   26,   36,   45,   60,   61,   73}; //   8
  needed_v_smin[x_a][ 10] = {   5,   15,   26,   36,   45,   60,   61,   73}; //   8
  needed_v_smin[x_a][ 11] = {   6,    7,    8,   16,   17,   18,   27,   28,   29,   37,   38,   39,   46,   47,   48,   62,   63,   64,   65,   66,   67,   74,   75,   76,   81,   86}; //  26
  needed_v_smin[x_a][ 12] = {   9,   19,   23,   49,   77,   78,   79,   83,   84}; //   9
  needed_v_smin[x_a][ 13] = {   9,   19,   49,   77,   83,   84}; //   6
  needed_v_smin[x_a][ 14] = {  20,   21,   22,   24,   25,   26,   27,   28,   29,   30,   68,   69,   70,   71,   72,   73,   74,   75,   76,   80,   86}; //  21
  needed_v_smin[x_a][ 15] = {  23,   79,   78}; //   3
  needed_v_smin[x_a][ 16] = {  30,   80}; //   2
  needed_v_smin[x_a][ 17] = {  31,   32,   33,   34,   35,   36,   37,   38,   39,   52,   53,   55,   58,   59,   61,   65,   66,   67,   81}; //  19
  needed_v_smin[x_a][ 18] = {  82,   85}; //   2
  needed_v_smin[x_a][ 19] = {  82,   85}; //   2

  v_smax[x_a].resize(24);
  needed_v_smax[x_a].resize(24);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,   10,   11,   12,   16,   17,   18,   20,   21,   22,   27,   28,   29,   31,   32,   33,   37,   38,   39,   40,   41,   42,   46,   47,   48,   50,   51,   52,   53,   54,   55,   62,   63,   64,   65,   66,   67,   68,   69,   70,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  58
  needed_v_smax[x_a][  1] = {   0,    1,   10,   11,   20,   21,   31,   32,   40,   41,   50,   51,   52,   53,   68,   69}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   20,   21,   22,   24,   25,   26,   27,   28,   29,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   81}; //  73
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   54,   56,   57,   60,   62,   63,   64,   77,   83,   84}; //  42
  needed_v_smax[x_a][  4] = {   2,   12,   22,   33,   42,   54,   55,   70}; //   8
  needed_v_smax[x_a][  5] = {   3,    4,    5,    9,   13,   14,   15,   19,   23,   24,   25,   26,   34,   35,   36,   43,   44,   45,   49,   56,   57,   58,   59,   60,   61,   71,   72,   73}; //  28
  needed_v_smax[x_a][  6] = {   3,    4,   13,   14,   24,   25,   34,   35,   43,   44,   56,   57,   58,   59,   71,   72}; //  16
  needed_v_smax[x_a][  7] = {   5,   15,   26,   36,   45,   60,   61,   73}; //   8
  needed_v_smax[x_a][  8] = {   6,    7,    8,   16,   17,   18,   27,   28,   29,   37,   38,   39,   46,   47,   48,   62,   63,   64,   65,   66,   67,   74,   75,   76,   77,   78,   79,   81,   82,   83,   84,   85,   86}; //  33
  needed_v_smax[x_a][  9] = {   9,   19,   23,   49}; //   4
  needed_v_smax[x_a][ 10] = {   9,   19,   49}; //   3
  needed_v_smax[x_a][ 11] = {  20,   21,   22,   24,   25,   26,   27,   28,   29,   68,   69,   70,   71,   72,   73,   74,   75,   76}; //  18
  needed_v_smax[x_a][ 12] = {  23,   30}; //   2
  needed_v_smax[x_a][ 13] = {  23,   30}; //   2
  needed_v_smax[x_a][ 14] = {  30}; //   1
  needed_v_smax[x_a][ 15] = {  30}; //   1
  needed_v_smax[x_a][ 16] = {  77,   78,   79,   83,   84}; //   5
  needed_v_smax[x_a][ 17] = {  79,   80,   78}; //   3
  needed_v_smax[x_a][ 18] = {  80}; //   1
  needed_v_smax[x_a][ 19] = {  80}; //   1
  needed_v_smax[x_a][ 20] = {  86}; //   1
  needed_v_smax[x_a][ 21] = {  31,   32,   33,   34,   35,   36,   37,   38,   39,   52,   53,   55,   58,   59,   61,   65,   66,   67,   81,   82,   85}; //  21
  needed_v_smax[x_a][ 22] = {  82,   85}; //   2
  needed_v_smax[x_a][ 23] = {  86}; //   1

  g_p[x_a].resize(32);
  needed_g_p[x_a].resize(32);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,   10,   11,   12,   16,   17,   18,   20,   21,   22,   27,   28,   29,   31,   32,   33,   37,   38,   39,   40,   41,   42,   46,   47,   48,   50,   51,   52,   53,   54,   55,   62,   63,   64,   65,   66,   67,   68,   69,   70,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  58
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   10,   11,   20,   21,   31,   32,   40,   41,   50,   51,   52,   53,   68,   69}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   10,   20,   31,   40,   50,   52,   68}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   40,   41,   42,   43,   44,   45,   46,   47,   48}; //  27
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin3_smax3");
  needed_g_p[x_a][4] = {   1,   11,   21,   32,   41,   51,   53,   69}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   2,   12,   22,   33,   42,   54,   55,   70}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2,   12,   22,   33,   42,   54,   55,   70}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][7] = {   3,    4,    5,    9,   13,   14,   15,   19,   23,   24,   25,   26,   34,   35,   36,   43,   44,   45,   49,   56,   57,   58,   59,   60,   61,   71,   72,   73}; //  28
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax5");
  needed_g_p[x_a][8] = {   3,    4,   13,   14,   24,   25,   34,   35,   43,   44,   56,   57,   58,   59,   71,   72}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   3,   13,   24,   34,   43,   56,   58,   71}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][10] = {   4,   14,   25,   35,   44,   57,   59,   72}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   15,   26,   36,   45,   60,   61,   73}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][12] = {   5,   15,   26,   36,   45,   60,   61,   73}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][13] = {   6,    7,    8,   16,   17,   18,   27,   28,   29,   37,   38,   39,   46,   47,   48,   62,   63,   64,   65,   66,   67,   74,   75,   76,   77,   78,   79,   81,   82,   83,   84,   85,   86}; //  33
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax8");
  needed_g_p[x_a][14] = {   6,   16,   27,   37,   46,   62,   65,   74}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax2");
  needed_g_p[x_a][15] = {   7,   17,   28,   38,   47,   63,   66,   75}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][16] = {   8,   18,   29,   39,   48,   64,   67,   76}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin11_smax2");
  needed_g_p[x_a][17] = {   9,   19,   23,   49}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin12_smax9");
  needed_g_p[x_a][18] = {   9,   19,   49}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax10");
  needed_g_p[x_a][19] = {   9,   19,   49}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin13_smax3");
  needed_g_p[x_a][20] = {  20,   21,   22,   24,   25,   26,   27,   28,   29,   68,   69,   70,   71,   72,   73,   74,   75,   76}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin14_smax11");
  needed_g_p[x_a][21] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax12");
  needed_g_p[x_a][22] = {  23,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax13");
  needed_g_p[x_a][23] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin14_smax14");
  needed_g_p[x_a][24] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax15");
  needed_g_p[x_a][25] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin16_smax12");
  needed_g_p[x_a][26] = {  77,   78,   79,   83}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin12_smax16");
  needed_g_p[x_a][27] = {  79}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax17");
  needed_g_p[x_a][28] = {  80}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin14_smax18");
  needed_g_p[x_a][29] = {  80}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax19");
  needed_g_p[x_a][30] = {  80}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin16_smax17");
  needed_g_p[x_a][31] = {  86}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin14_smax20");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {  31,   32,   33,   34,   35,   36,   37,   38,   39,   52,   53,   55,   58,   59,   61,   65,   66,   67,   81}; //  19
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax21");
  needed_g_f[x_a][1] = {  50,   51,   54,   56,   57,   60,   62,   63,   64}; //   9
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][2] = {  77,   83,   84}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax3");
  needed_g_f[x_a][3] = {  78}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax17");
  needed_g_f[x_a][4] = {  81}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax2");
  needed_g_f[x_a][5] = {  82,   85}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax22");
  needed_g_f[x_a][6] = {  82,   85}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax21");
  needed_g_f[x_a][7] = {  84}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax16");
  needed_g_f[x_a][8] = {  86}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax23");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   77}; //  11
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__64_188");
  needed_g_t[x_a][1] = {  31,   32,   33,   34,   35,   36,   37,   38,   39,   52,   53,   55,   58,   59,   61,   65,   66,   67,   81,   82,   85}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__128_124");
  needed_g_t[x_a][2] = {  31,   32,   33,   34,   35,   36,   37,   38,   39,   81}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_129__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_129__64_60");
  needed_g_t[x_a][3] = {  40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   54,   56,   57,   60,   62,   63,   64,   83,   84}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][4] = {  50,   51,   54,   56,   57,   60,   62,   63,   64}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__65_2__128_60");
  needed_g_t[x_a][5] = {  52,   53,   55,   58,   59,   61,   65,   66,   67}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__129_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__129_2__64_60");
  needed_g_t[x_a][6] = {  68,   69,   70,   71,   72,   73,   74,   75,   76,   86}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__192_60");
  needed_g_t[x_a][7] = {  77}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_66__164_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_66__164_24");
  needed_g_t[x_a][8] = {  78,   79,   80}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__24_228");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__24_228");
  needed_g_t[x_a][9] = {  78}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_26__164_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_26__164_64");
  needed_g_t[x_a][10] = {  81}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__129_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__129_66__36_24");
  needed_g_t[x_a][11] = {  82,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_129__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_129__24_100");
  needed_g_t[x_a][12] = {  82}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__129_26__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__129_26__36_64");
  needed_g_t[x_a][13] = {  83,   84}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_65__24_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_65__24_164");
  needed_g_t[x_a][14] = {  84}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__65_26__128_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__65_26__128_36");
  needed_g_t[x_a][15] = {  85}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__129_26__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__129_26__64_36");
  needed_g_t[x_a][16] = {  86}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_193__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_193__24_36");

  g_d[x_a].resize(20);
  needed_g_d[x_a].resize(20);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   40,   41,   42,   43,   44,   45,   46,   47,   48}; //  27
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,    1,   10,   11,   20,   21,   31,   32,   40,   41,   50,   51,   52,   53,   68,   69}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1,   10,   11,   20,   21,   31,   32,   40,   41,   50,   51,   52,   53,   68,   69}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][3] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   16,   17,   18,   19,   20,   21,   22,   23,   27,   28,   29,   30,   31,   32,   33,   37,   38,   39,   40,   41,   42,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   62,   63,   64,   65,   66,   67,   68,   69,   70,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   2,   12,   22,   33,   42,   54,   55,   70}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   2,   12,   22,   33,   42,   54,   55,   70}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][6] = {   3,    4,   13,   14,   24,   25,   34,   35,   43,   44,   56,   57,   58,   59,   71,   72}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][7] = {   3,    4,   13,   14,   24,   25,   34,   35,   43,   44,   56,   57,   58,   59,   71,   72}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][8] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][9] = {   5,   15,   26,   36,   45,   60,   61,   73}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][10] = {   5,   15,   26,   36,   45,   60,   61,   73}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][11] = {   6,    7,    8,   16,   17,   18,   27,   28,   29,   37,   38,   39,   46,   47,   48,   62,   63,   64,   65,   66,   67,   74,   75,   76}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][12] = {   9,   19,   49}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__24_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__24_164");
  needed_g_d[x_a][13] = {   9,   19,   23,   49,   77,   78,   79,   83}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");
  needed_g_d[x_a][14] = {  10,   11,   12,   13,   14,   15,   16,   17,   18,   19}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][15] = {  20,   21,   22,   24,   25,   26,   27,   28,   29}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__192_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__192_60");
  needed_g_d[x_a][16] = {  20,   21,   22,   24,   25,   26,   27,   28,   29,   30,   68,   69,   70,   71,   72,   73,   74,   75,   76,   80,   86}; //  21
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][17] = {  23,   30}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__24_228");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__24_228");
  needed_g_d[x_a][18] = {  23,   79}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_228__64_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_228__64_164");
  needed_g_d[x_a][19] = {  30,   80}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_228__36_192");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_228__36_192");

  c_p[x_a].resize(87);
  c_f[x_a].resize(87);
  c_t[x_a].resize(87);
  c_d[x_a].resize(87);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   4,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  0,   5,   6,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  7,   8,   9,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   6,   7,   8}; //   4

  c_p[x_a][4] = {  7,   8,  10,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   6,   7,   8}; //   4

  c_p[x_a][5] = {  7,  11,  12,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   9,  10,   8}; //   4

  c_p[x_a][6] = {  0,  13,  14,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  0,  11,   8,   3}; //   4

  c_p[x_a][7] = {  0,  13,  15,   3}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  0,  11,   8,   3}; //   4

  c_p[x_a][8] = {  0,  13,  16,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  0,  11,   8,   3}; //   4

  c_p[x_a][9] = {  7,  17,  18,  19}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 12,   3,  13,   8}; //   4

  c_p[x_a][10] = {  0,   1,   2,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 14,   0,   1,   2,   3}; //   5

  c_p[x_a][11] = {  0,   1,   4,   3}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 14,   0,   1,   2,   3}; //   5

  c_p[x_a][12] = {  0,   5,   6,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 14,   0,   4,   5,   3}; //   5

  c_p[x_a][13] = {  7,   8,   9,   3}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 14,   0,   6,   7,   8}; //   5

  c_p[x_a][14] = {  7,   8,  10,   3}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 14,   0,   6,   7,   8}; //   5

  c_p[x_a][15] = {  7,  11,  12,   3}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 14,   0,   9,  10,   8}; //   5

  c_p[x_a][16] = {  0,  13,  14,   3}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 14,   0,  11,   8,   3}; //   5

  c_p[x_a][17] = {  0,  13,  15,   3}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 14,   0,  11,   8,   3}; //   5

  c_p[x_a][18] = {  0,  13,  16,   3}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 14,   0,  11,   8,   3}; //   5

  c_p[x_a][19] = {  7,  17,  18,  19}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 14,  12,   3,  13,   8}; //   5

  c_p[x_a][20] = {  0,   1,   2,  20}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 15,  16,   1,   2,   3}; //   5

  c_p[x_a][21] = {  0,   1,   4,  20}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 15,  16,   1,   2,   3}; //   5

  c_p[x_a][22] = {  0,   5,   6,  20}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 15,  16,   4,   5,   3}; //   5

  c_p[x_a][23] = {  7,  17,  21,  22}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 17,   3,  18,  13,   8}; //   5

  c_p[x_a][24] = {  7,   8,   9,  20}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 15,  16,   6,   7,   8}; //   5

  c_p[x_a][25] = {  7,   8,  10,  20}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 15,  16,   6,   7,   8}; //   5

  c_p[x_a][26] = {  7,  11,  12,  20}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 15,  16,   9,  10,   8}; //   5

  c_p[x_a][27] = {  0,  13,  14,  20}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 15,  16,  11,   8,   3}; //   5

  c_p[x_a][28] = {  0,  13,  15,  20}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 15,  16,  11,   8,   3}; //   5

  c_p[x_a][29] = {  0,  13,  16,  20}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 15,  16,  11,   8,   3}; //   5

  c_p[x_a][30] = { 23,  24,  25,  22}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 17,   3,  19,   8,  16}; //   5

  c_p[x_a][31] = {  0,   1,   2}; //   3
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  1,   2}; //   2
  c_d[x_a][31] = {  1,   2,   3}; //   3

  c_p[x_a][32] = {  0,   1,   4}; //   3
  c_f[x_a][32] = {  0}; //   1
  c_t[x_a][32] = {  1,   2}; //   2
  c_d[x_a][32] = {  1,   2,   3}; //   3

  c_p[x_a][33] = {  0,   5,   6}; //   3
  c_f[x_a][33] = {  0}; //   1
  c_t[x_a][33] = {  1,   2}; //   2
  c_d[x_a][33] = {  4,   5,   3}; //   3

  c_p[x_a][34] = {  7,   8,   9}; //   3
  c_f[x_a][34] = {  0}; //   1
  c_t[x_a][34] = {  1,   2}; //   2
  c_d[x_a][34] = {  6,   7,   8}; //   3

  c_p[x_a][35] = {  7,   8,  10}; //   3
  c_f[x_a][35] = {  0}; //   1
  c_t[x_a][35] = {  1,   2}; //   2
  c_d[x_a][35] = {  6,   7,   8}; //   3

  c_p[x_a][36] = {  7,  11,  12}; //   3
  c_f[x_a][36] = {  0}; //   1
  c_t[x_a][36] = {  1,   2}; //   2
  c_d[x_a][36] = {  9,  10,   8}; //   3

  c_p[x_a][37] = {  0,  13,  14}; //   3
  c_f[x_a][37] = {  0}; //   1
  c_t[x_a][37] = {  1,   2}; //   2
  c_d[x_a][37] = { 11,   8,   3}; //   3

  c_p[x_a][38] = {  0,  13,  15}; //   3
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  1,   2}; //   2
  c_d[x_a][38] = { 11,   8,   3}; //   3

  c_p[x_a][39] = {  0,  13,  16}; //   3
  c_f[x_a][39] = {  0}; //   1
  c_t[x_a][39] = {  1,   2}; //   2
  c_d[x_a][39] = { 11,   8,   3}; //   3

  c_p[x_a][40] = {  0,   1,   2,   3}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  3}; //   1
  c_d[x_a][40] = {  0,   1,   2,   3}; //   4

  c_p[x_a][41] = {  0,   1,   4,   3}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  3}; //   1
  c_d[x_a][41] = {  0,   1,   2,   3}; //   4

  c_p[x_a][42] = {  0,   5,   6,   3}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  3}; //   1
  c_d[x_a][42] = {  0,   4,   5,   3}; //   4

  c_p[x_a][43] = {  7,   8,   9,   3}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  3}; //   1
  c_d[x_a][43] = {  0,   6,   7,   8}; //   4

  c_p[x_a][44] = {  7,   8,  10,   3}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  3}; //   1
  c_d[x_a][44] = {  0,   6,   7,   8}; //   4

  c_p[x_a][45] = {  7,  11,  12,   3}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  3}; //   1
  c_d[x_a][45] = {  0,   9,  10,   8}; //   4

  c_p[x_a][46] = {  0,  13,  14,   3}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  3}; //   1
  c_d[x_a][46] = {  0,  11,   8,   3}; //   4

  c_p[x_a][47] = {  0,  13,  15,   3}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  3}; //   1
  c_d[x_a][47] = {  0,  11,   8,   3}; //   4

  c_p[x_a][48] = {  0,  13,  16,   3}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  3}; //   1
  c_d[x_a][48] = {  0,  11,   8,   3}; //   4

  c_p[x_a][49] = {  7,  17,  18,  19}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  3}; //   1
  c_d[x_a][49] = { 12,   3,  13,   8}; //   4

  c_p[x_a][50] = {  0,   1,   2}; //   3
  c_f[x_a][50] = {  1}; //   1
  c_t[x_a][50] = {  3,   4}; //   2
  c_d[x_a][50] = {  1,   2,   3}; //   3

  c_p[x_a][51] = {  0,   1,   4}; //   3
  c_f[x_a][51] = {  1}; //   1
  c_t[x_a][51] = {  3,   4}; //   2
  c_d[x_a][51] = {  1,   2,   3}; //   3

  c_p[x_a][52] = {  0,   1,   2}; //   3
  c_f[x_a][52] = {  0}; //   1
  c_t[x_a][52] = {  1,   5}; //   2
  c_d[x_a][52] = {  1,   2,   3}; //   3

  c_p[x_a][53] = {  0,   1,   4}; //   3
  c_f[x_a][53] = {  0}; //   1
  c_t[x_a][53] = {  1,   5}; //   2
  c_d[x_a][53] = {  1,   2,   3}; //   3

  c_p[x_a][54] = {  0,   5,   6}; //   3
  c_f[x_a][54] = {  1}; //   1
  c_t[x_a][54] = {  3,   4}; //   2
  c_d[x_a][54] = {  4,   5,   3}; //   3

  c_p[x_a][55] = {  0,   5,   6}; //   3
  c_f[x_a][55] = {  0}; //   1
  c_t[x_a][55] = {  1,   5}; //   2
  c_d[x_a][55] = {  4,   5,   3}; //   3

  c_p[x_a][56] = {  7,   8,   9}; //   3
  c_f[x_a][56] = {  1}; //   1
  c_t[x_a][56] = {  3,   4}; //   2
  c_d[x_a][56] = {  6,   7,   8}; //   3

  c_p[x_a][57] = {  7,   8,  10}; //   3
  c_f[x_a][57] = {  1}; //   1
  c_t[x_a][57] = {  3,   4}; //   2
  c_d[x_a][57] = {  6,   7,   8}; //   3

  c_p[x_a][58] = {  7,   8,   9}; //   3
  c_f[x_a][58] = {  0}; //   1
  c_t[x_a][58] = {  1,   5}; //   2
  c_d[x_a][58] = {  6,   7,   8}; //   3

  c_p[x_a][59] = {  7,   8,  10}; //   3
  c_f[x_a][59] = {  0}; //   1
  c_t[x_a][59] = {  1,   5}; //   2
  c_d[x_a][59] = {  6,   7,   8}; //   3

  c_p[x_a][60] = {  7,  11,  12}; //   3
  c_f[x_a][60] = {  1}; //   1
  c_t[x_a][60] = {  3,   4}; //   2
  c_d[x_a][60] = {  9,  10,   8}; //   3

  c_p[x_a][61] = {  7,  11,  12}; //   3
  c_f[x_a][61] = {  0}; //   1
  c_t[x_a][61] = {  1,   5}; //   2
  c_d[x_a][61] = {  9,  10,   8}; //   3

  c_p[x_a][62] = {  0,  13,  14}; //   3
  c_f[x_a][62] = {  1}; //   1
  c_t[x_a][62] = {  3,   4}; //   2
  c_d[x_a][62] = { 11,   8,   3}; //   3

  c_p[x_a][63] = {  0,  13,  15}; //   3
  c_f[x_a][63] = {  1}; //   1
  c_t[x_a][63] = {  3,   4}; //   2
  c_d[x_a][63] = { 11,   8,   3}; //   3

  c_p[x_a][64] = {  0,  13,  16}; //   3
  c_f[x_a][64] = {  1}; //   1
  c_t[x_a][64] = {  3,   4}; //   2
  c_d[x_a][64] = { 11,   8,   3}; //   3

  c_p[x_a][65] = {  0,  13,  14}; //   3
  c_f[x_a][65] = {  0}; //   1
  c_t[x_a][65] = {  1,   5}; //   2
  c_d[x_a][65] = { 11,   8,   3}; //   3

  c_p[x_a][66] = {  0,  13,  15}; //   3
  c_f[x_a][66] = {  0}; //   1
  c_t[x_a][66] = {  1,   5}; //   2
  c_d[x_a][66] = { 11,   8,   3}; //   3

  c_p[x_a][67] = {  0,  13,  16}; //   3
  c_f[x_a][67] = {  0}; //   1
  c_t[x_a][67] = {  1,   5}; //   2
  c_d[x_a][67] = { 11,   8,   3}; //   3

  c_p[x_a][68] = {  0,   1,   2,  20}; //   4
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  6}; //   1
  c_d[x_a][68] = { 16,   1,   2,   3}; //   4

  c_p[x_a][69] = {  0,   1,   4,  20}; //   4
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  6}; //   1
  c_d[x_a][69] = { 16,   1,   2,   3}; //   4

  c_p[x_a][70] = {  0,   5,   6,  20}; //   4
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  6}; //   1
  c_d[x_a][70] = { 16,   4,   5,   3}; //   4

  c_p[x_a][71] = {  7,   8,   9,  20}; //   4
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  6}; //   1
  c_d[x_a][71] = { 16,   6,   7,   8}; //   4

  c_p[x_a][72] = {  7,   8,  10,  20}; //   4
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  6}; //   1
  c_d[x_a][72] = { 16,   6,   7,   8}; //   4

  c_p[x_a][73] = {  7,  11,  12,  20}; //   4
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {  6}; //   1
  c_d[x_a][73] = { 16,   9,  10,   8}; //   4

  c_p[x_a][74] = {  0,  13,  14,  20}; //   4
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {  6}; //   1
  c_d[x_a][74] = { 16,  11,   8,   3}; //   4

  c_p[x_a][75] = {  0,  13,  15,  20}; //   4
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  6}; //   1
  c_d[x_a][75] = { 16,  11,   8,   3}; //   4

  c_p[x_a][76] = {  0,  13,  16,  20}; //   4
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  6}; //   1
  c_d[x_a][76] = { 16,  11,   8,   3}; //   4

  c_p[x_a][77] = {  0,  13,  26}; //   3
  c_f[x_a][77] = {  2}; //   1
  c_t[x_a][77] = {  0,   7}; //   2
  c_d[x_a][77] = { 13,   8,   3}; //   3

  c_p[x_a][78] = {  0,  13,  26}; //   3
  c_f[x_a][78] = {  3}; //   1
  c_t[x_a][78] = {  8,   9}; //   2
  c_d[x_a][78] = { 13,   8,   3}; //   3

  c_p[x_a][79] = {  0,  13,  26,  27}; //   4
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = {  8}; //   1
  c_d[x_a][79] = { 18,  13,   8,   3}; //   4

  c_p[x_a][80] = {  0,  28,  29,  30}; //   4
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {  8}; //   1
  c_d[x_a][80] = { 19,   8,  16,   3}; //   4

  c_p[x_a][81] = {  0,  13}; //   2
  c_f[x_a][81] = {  4,   0}; //   2
  c_t[x_a][81] = {  1,   2,  10}; //   3
  c_d[x_a][81] = {  8,   3}; //   2

  c_p[x_a][82] = {  0,  13}; //   2
  c_f[x_a][82] = {  5,   6}; //   2
  c_t[x_a][82] = {  1,  11,  12}; //   3
  c_d[x_a][82] = {  8,   3}; //   2

  c_p[x_a][83] = {  0,  13,  26}; //   3
  c_f[x_a][83] = {  2}; //   1
  c_t[x_a][83] = {  3,  13}; //   2
  c_d[x_a][83] = { 13,   8,   3}; //   3

  c_p[x_a][84] = {  0,  13}; //   2
  c_f[x_a][84] = {  7,   2}; //   2
  c_t[x_a][84] = {  3,  13,  14}; //   3
  c_d[x_a][84] = {  8,   3}; //   2

  c_p[x_a][85] = {  0,  13}; //   2
  c_f[x_a][85] = {  5,   6}; //   2
  c_t[x_a][85] = {  1,  11,  15}; //   3
  c_d[x_a][85] = {  8,   3}; //   2

  c_p[x_a][86] = {  0,  13,  31}; //   3
  c_f[x_a][86] = {  8}; //   1
  c_t[x_a][86] = {  6,  16}; //   2
  c_d[x_a][86] = { 16,   8,   3}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_gbx_emmupvmvexgbx
//  channel    0: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   5,   5)
//  channel    1: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   5,   5)
//  channel    2: 5yyyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   5,   5)
//  channel    3: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   5,   5)
//  channel    4: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   5,   5)
//  channel    5: 5yyyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   5,   5)
//  channel    6: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   5,   5)
//  channel    7: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   5,   5)
//  channel    8: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  25,   5,   5)
//  channel    9: 52vyv1(1, 2, 8, 16, 128, 4, 32, 64;  24,   6,  24,   5,   5)
//  channel   10: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   5)
//  channel   11: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   5)
//  channel   12: 6yyyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   5)
//  channel   13: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   5)
//  channel   14: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   5)
//  channel   15: 6yyyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   5)
//  channel   16: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   5)
//  channel   17: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   5)
//  channel   18: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   5)
//  channel   19: 6y2vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   6,  24,   5,   5)
//  channel   20: 62vyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   5)
//  channel   21: 62vyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   5)
//  channel   22: 62vyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   5)
//  channel   23: 62vyyv(1, 2, 8, 16, 64, 128, 4, 32;  24,   6,   6,  24,   5)
//  channel   24: 62vyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   5)
//  channel   25: 62vyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   5)
//  channel   26: 62vyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   5)
//  channel   27: 62v2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   5)
//  channel   28: 62v2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   5)
//  channel   29: 62v2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   5)
//  channel   30: 62v2vv(1, 2, 8, 16, 4, 32, 64, 128;   5,  24,   6,  24,   5)
//  channel   31: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   5,   5)
//  channel   32: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   5,   5)
//  channel   33: 14yyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   5,   5)
//  channel   34: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   5,   5)
//  channel   35: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   5,   5)
//  channel   36: 14yyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   5,   5)
//  channel   37: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   5,   5)
//  channel   38: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   5,   5)
//  channel   39: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  25,   5,   5)
//  channel   40: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   0)
//  channel   41: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   0)
//  channel   42: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   0)
//  channel   43: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   0)
//  channel   44: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   0)
//  channel   45: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   0)
//  channel   46: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   0)
//  channel   47: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   0)
//  channel   48: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   0)
//  channel   49: 152vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   6,  24,   5,   0)
//  channel   50: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   5)
//  channel   51: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   5)
//  channel   52: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   5,   5)
//  channel   53: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   5,   5)
//  channel   54: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   5)
//  channel   55: 114yyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   5,   5)
//  channel   56: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   5)
//  channel   57: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   5)
//  channel   58: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   5,   5)
//  channel   59: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   5,   5)
//  channel   60: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   5)
//  channel   61: 114yyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   5,   5)
//  channel   62: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   5)
//  channel   63: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   5)
//  channel   64: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   0,   5)
//  channel   65: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   5,   5)
//  channel   66: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   5,   5)
//  channel   67: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  25,   5,   5)
//  channel   68: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   5)
//  channel   69: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   5)
//  channel   70: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   5)
//  channel   71: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   5)
//  channel   72: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   5)
//  channel   73: 2v4yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   5)
//  channel   74: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   5)
//  channel   75: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   5)
//  channel   76: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   5)
//  channel   77: 3yv2v1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   6,   5,   6)
//  channel   78: 3yv12v(1, 2, 128, 4, 32, 64, 8, 16;  24,  24,   6,   6,   6)
//  channel   79: 4yyv2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   6,   6,   6)
//  channel   80: 42vv2v(1, 2, 4, 32, 64, 128, 8, 16;  24,   5,  24,   6,   6)
//  channel   81: 12v2v1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   5,   5,   6)
//  channel   82: 12v12v(1, 2, 128, 4, 32, 64, 8, 16;  24,  24,   5,   6,   6)
//  channel   83: 13yv2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   6,   0,   6)
//  channel   84: 112v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   6,   5)
//  channel   85: 112v2v(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   5,   6,   5)
//  channel   86: 2v2v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   5,   5,   6)
