#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_gg_emmupvmvexbbx(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_gg_emmupvmvexbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(17);
  needed_v_smin[x_a].resize(17);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   20,   21,   22,   23,   41,   42,   43,   44,   59,   60,   61,   62}; //  16
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   20,   21,   22,   23,   41,   42,   43,   44,   59,   60,   61,   62}; //  16
  needed_v_smin[x_a][  3] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   20,   21,   24,   26,   27,   30,   32,   33,   34,   59,   60,   63,   65,   66,   69,   71,   72,   73,   43,   44,   46,   49,   50,   52,   56,   57,   58,   84}; //  37
  needed_v_smin[x_a][  4] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   22,   23,   25,   28,   29,   31,   35,   36,   37,   61,   62,   64,   67,   68,   70,   74,   75,   76,   41,   42,   45,   47,   48,   51,   53,   54,   55,   83}; //  37
  needed_v_smin[x_a][  5] = {   4,    5,   24,   25,   45,   46,   63,   64}; //   8
  needed_v_smin[x_a][  6] = {   4,    5,   24,   25,   45,   46,   63,   64}; //   8
  needed_v_smin[x_a][  7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  needed_v_smin[x_a][  8] = {   6,    7,    8,    9,   26,   27,   28,   29,   47,   48,   49,   50,   65,   66,   67,   68}; //  16
  needed_v_smin[x_a][  9] = {   6,    7,    8,    9,   26,   27,   28,   29,   47,   48,   49,   50,   65,   66,   67,   68}; //  16
  needed_v_smin[x_a][ 10] = {  10,   11,   30,   31,   51,   52,   69,   70}; //   8
  needed_v_smin[x_a][ 11] = {  10,   11,   30,   31,   51,   52,   69,   70}; //   8
  needed_v_smin[x_a][ 12] = {  12,   13,   14,   15,   16,   17,   32,   33,   34,   35,   36,   37,   53,   54,   55,   56,   57,   58,   71,   72,   73,   74,   75,   76,   83,   84}; //  26
  needed_v_smin[x_a][ 13] = {  18,   38,   40,   77,   80,   81,   82,   85}; //   8
  needed_v_smin[x_a][ 14] = {  18,   38,   77,   80,   85}; //   5
  needed_v_smin[x_a][ 15] = {  19,   39,   40,   78,   79,   81,   82,   86}; //   8
  needed_v_smin[x_a][ 16] = {  19,   39,   78,   79,   86}; //   5

  v_smax[x_a].resize(19);
  needed_v_smax[x_a].resize(19);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   20,   21,   22,   23,   24,   25,   32,   33,   34,   35,   36,   37,   38,   41,   42,   43,   44,   45,   46,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   71,   72,   73,   74,   75,   76,   77,   79,   81,   83,   85}; //  55
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   20,   21,   22,   23,   41,   42,   43,   44,   59,   60,   61,   62}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   83,   84}; //  74
  needed_v_smax[x_a][  3] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   19,   20,   21,   24,   26,   27,   30,   32,   33,   34,   39,   59,   60,   63,   65,   66,   69,   71,   72,   73,   78,   43,   44,   46,   49,   50,   52,   56,   57,   58,   79,   84,   86}; //  42
  needed_v_smax[x_a][  4] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   18,   22,   23,   25,   28,   29,   31,   35,   36,   37,   38,   61,   62,   64,   67,   68,   70,   74,   75,   76,   77,   41,   42,   45,   47,   48,   51,   53,   54,   55,   80,   83,   85}; //  42
  needed_v_smax[x_a][  5] = {   4,    5,   24,   25,   45,   46,   63,   64}; //   8
  needed_v_smax[x_a][  6] = {   6,    7,    8,    9,   10,   11,   19,   26,   27,   28,   29,   30,   31,   39,   40,   47,   48,   49,   50,   51,   52,   65,   66,   67,   68,   69,   70,   78,   80,   82,   84,   86}; //  32
  needed_v_smax[x_a][  7] = {   6,    7,    8,    9,   26,   27,   28,   29,   47,   48,   49,   50,   65,   66,   67,   68}; //  16
  needed_v_smax[x_a][  8] = {  10,   11,   30,   31,   51,   52,   69,   70}; //   8
  needed_v_smax[x_a][  9] = {  12,   13,   14,   15,   16,   17,   32,   33,   34,   35,   36,   37,   53,   54,   55,   56,   57,   58,   71,   72,   73,   74,   75,   76,   79,   83}; //  26
  needed_v_smax[x_a][ 10] = {  18,   38,   77,   81,   85}; //   5
  needed_v_smax[x_a][ 11] = {  18,   38,   77,   81,   85}; //   5
  needed_v_smax[x_a][ 12] = {  19,   39,   78,   82,   86}; //   5
  needed_v_smax[x_a][ 13] = {  19,   39,   78,   82,   86}; //   5
  needed_v_smax[x_a][ 14] = {  40,   80,   84}; //   3
  needed_v_smax[x_a][ 15] = {  40,   79}; //   2
  needed_v_smax[x_a][ 16] = {  40,   82}; //   2
  needed_v_smax[x_a][ 17] = {  80}; //   1
  needed_v_smax[x_a][ 18] = {  81}; //   1

  g_p[x_a].resize(29);
  needed_g_p[x_a].resize(29);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   20,   21,   22,   23,   24,   25,   32,   33,   34,   35,   36,   37,   38,   41,   42,   43,   44,   45,   46,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   71,   72,   73,   74,   75,   76,   77,   79,   81,   83,   85}; //  55
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   20,   21,   22,   23,   41,   42,   43,   44,   59,   60,   61,   62}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   20,   22,   41,   43,   59,   61}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   20,   21,   24,   26,   27,   30,   32,   33,   34,   59,   60,   63,   65,   66,   69,   71,   72,   73}; //  27
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,   21,   23,   42,   44,   60,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   22,   23,   25,   28,   29,   31,   35,   36,   37,   61,   62,   64,   67,   68,   70,   74,   75,   76}; //  27
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin4_smax4");
  needed_g_p[x_a][6] = {   4,    5,   24,   25,   45,   46,   63,   64}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][7] = {   4,    5,   24,   25,   45,   46,   63,   64}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   6,    7,    8,    9,   10,   11,   19,   26,   27,   28,   29,   30,   31,   39,   40,   47,   48,   49,   50,   51,   52,   65,   66,   67,   68,   69,   70,   78,   80,   82,   84,   86}; //  32
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax6");
  needed_g_p[x_a][9] = {   6,    7,    8,    9,   26,   27,   28,   29,   47,   48,   49,   50,   65,   66,   67,   68}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {   6,    8,   26,   28,   47,   49,   65,   67}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][11] = {   7,    9,   27,   29,   48,   50,   66,   68}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {  10,   11,   30,   31,   51,   52,   69,   70}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][13] = {  10,   11,   30,   31,   51,   52,   69,   70}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][14] = {  12,   13,   14,   15,   16,   17,   32,   33,   34,   35,   36,   37,   53,   54,   55,   56,   57,   58,   71,   72,   73,   74,   75,   76,   79,   83}; //  26
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax9");
  needed_g_p[x_a][15] = {  12,   15,   32,   35,   53,   56,   71,   74}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][16] = {  13,   16,   33,   36,   54,   57,   72,   75}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][17] = {  14,   17,   34,   37,   55,   58,   73,   76}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin12_smax2");
  needed_g_p[x_a][18] = {  18,   38,   77,   81,   85}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin13_smax10");
  needed_g_p[x_a][19] = {  18,   38,   77,   81,   85}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax11");
  needed_g_p[x_a][20] = {  18,   38,   77}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin14_smax4");
  needed_g_p[x_a][21] = {  19,   39,   78,   82,   86}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax12");
  needed_g_p[x_a][22] = {  19,   39,   78,   82,   86}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax13");
  needed_g_p[x_a][23] = {  19,   39,   78}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin16_smax3");
  needed_g_p[x_a][24] = {  40,   80,   84}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][25] = {  40,   79}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax15");
  needed_g_p[x_a][26] = {  40,   82}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin13_smax16");
  needed_g_p[x_a][27] = {  80}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin13_smax17");
  needed_g_p[x_a][28] = {  81}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax18");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {  41,   42,   45,   47,   48,   51,   53,   54,   55,   83}; //  10
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][1] = {  43,   44,   46,   49,   50,   52,   56,   57,   58,   84}; //  10
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][2] = {  79,   86}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax3");
  needed_g_f[x_a][3] = {  80,   85}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax4");
  needed_g_f[x_a][4] = {  83,   84}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax2");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   19,   79}; //  11
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__64_188");
  needed_g_t[x_a][1] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   18,   80}; //  11
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__128_124");
  needed_g_t[x_a][2] = {  41,   42,   45,   47,   48,   51,   53,   54,   55,   61,   62,   64,   67,   68,   70,   74,   75,   76,   77,   83,   85}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__128_124");
  needed_g_t[x_a][3] = {  41,   42,   45,   47,   48,   51,   53,   54,   55,   83}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_129__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_129__64_60");
  needed_g_t[x_a][4] = {  43,   44,   46,   49,   50,   52,   56,   57,   58,   59,   60,   63,   65,   66,   69,   71,   72,   73,   78,   84,   86}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__64_188");
  needed_g_t[x_a][5] = {  43,   44,   46,   49,   50,   52,   56,   57,   58,   84}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_65__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_65__128_60");
  needed_g_t[x_a][6] = {  79}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_66__164_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_66__164_24");
  needed_g_t[x_a][7] = {  80}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_130__88_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_130__88_36");
  needed_g_t[x_a][8] = {  81}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__164_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__164_88");
  needed_g_t[x_a][9] = {  82}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__88_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__88_164");
  needed_g_t[x_a][10] = {  83}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__129_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__129_66__36_24");
  needed_g_t[x_a][11] = {  84}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__65_130__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__65_130__24_36");
  needed_g_t[x_a][12] = {  85}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_129__88_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_129__88_36");
  needed_g_t[x_a][13] = {  86}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_65__164_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_65__164_24");

  g_d[x_a].resize(20);
  needed_g_d[x_a].resize(20);
  needed_g_d[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   14,   20,   21,   24,   26,   27,   30,   32,   33,   34,   59,   60,   63,   65,   66,   69,   71,   72,   73}; //  27
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,   20,   21,   22,   23,   41,   42,   43,   44,   59,   60,   61,   62}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,   20,   21,   22,   23,   41,   42,   43,   44,   59,   60,   61,   62}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   2,    3,    5,    8,    9,   11,   15,   16,   17,   22,   23,   25,   28,   29,   31,   35,   36,   37,   61,   62,   64,   67,   68,   70,   74,   75,   76}; //  27
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][5] = {   4,    5,   24,   25,   45,   46,   63,   64}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   4,    5,   24,   25,   45,   46,   63,   64}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {   6,    7,    8,    9,   26,   27,   28,   29,   47,   48,   49,   50,   65,   66,   67,   68}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {   6,    7,    8,    9,   26,   27,   28,   29,   47,   48,   49,   50,   65,   66,   67,   68}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][9] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86}; //  63
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][10] = {  10,   11,   30,   31,   51,   52,   69,   70}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][11] = {  10,   11,   30,   31,   51,   52,   69,   70}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][12] = {  12,   13,   14,   15,   16,   17,   32,   33,   34,   35,   36,   37,   53,   54,   55,   56,   57,   58,   71,   72,   73,   74,   75,   76}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][13] = {  18,   38,   77}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][14] = {  18,   38,   40,   77,   80,   81,   82,   85}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][15] = {  19,   39,   78}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__24_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__24_164");
  needed_g_d[x_a][16] = {  19,   39,   40,   78,   79,   81,   82,   86}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");
  needed_g_d[x_a][17] = {  20,   21,   24,   26,   27,   30,   32,   33,   34,   39}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][18] = {  22,   23,   25,   28,   29,   31,   35,   36,   37,   38}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][19] = {  40}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__88_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__88_164");

  c_p[x_a].resize(87);
  c_f[x_a].resize(87);
  c_t[x_a].resize(87);
  c_d[x_a].resize(87);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   4,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  0,   1,   2,   5}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  1}; //   1
  c_d[x_a][2] = {  4,   1,   2,   3}; //   4

  c_p[x_a][3] = {  0,   1,   4,   5}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  1}; //   1
  c_d[x_a][3] = {  4,   1,   2,   3}; //   4

  c_p[x_a][4] = {  0,   6,   7,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   5,   6,   3}; //   4

  c_p[x_a][5] = {  0,   6,   7,   5}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  1}; //   1
  c_d[x_a][5] = {  4,   5,   6,   3}; //   4

  c_p[x_a][6] = {  8,   9,  10,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  0,   7,   8,   9}; //   4

  c_p[x_a][7] = {  8,   9,  11,   3}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  0,   7,   8,   9}; //   4

  c_p[x_a][8] = {  8,   9,  10,   5}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  1}; //   1
  c_d[x_a][8] = {  4,   7,   8,   9}; //   4

  c_p[x_a][9] = {  8,   9,  11,   5}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  1}; //   1
  c_d[x_a][9] = {  4,   7,   8,   9}; //   4

  c_p[x_a][10] = {  8,  12,  13,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  0,  10,  11,   9}; //   4

  c_p[x_a][11] = {  8,  12,  13,   5}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  1}; //   1
  c_d[x_a][11] = {  4,  10,  11,   9}; //   4

  c_p[x_a][12] = {  0,  14,  15,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  0,  12,   9,   3}; //   4

  c_p[x_a][13] = {  0,  14,  16,   3}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  0,  12,   9,   3}; //   4

  c_p[x_a][14] = {  0,  14,  17,   3}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = {  0,  12,   9,   3}; //   4

  c_p[x_a][15] = {  0,  14,  15,   5}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  1}; //   1
  c_d[x_a][15] = {  4,  12,   9,   3}; //   4

  c_p[x_a][16] = {  0,  14,  16,   5}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  1}; //   1
  c_d[x_a][16] = {  4,  12,   9,   3}; //   4

  c_p[x_a][17] = {  0,  14,  17,   5}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  1}; //   1
  c_d[x_a][17] = {  4,  12,   9,   3}; //   4

  c_p[x_a][18] = {  0,  18,  19,  20}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  1}; //   1
  c_d[x_a][18] = { 13,   9,  14,   3}; //   4

  c_p[x_a][19] = {  8,  21,  22,  23}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 15,   3,  16,   9}; //   4

  c_p[x_a][20] = {  0,   1,   2,   3}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 17,   0,   1,   2,   3}; //   5

  c_p[x_a][21] = {  0,   1,   4,   3}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 17,   0,   1,   2,   3}; //   5

  c_p[x_a][22] = {  0,   1,   2,   5}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 18,   4,   1,   2,   3}; //   5

  c_p[x_a][23] = {  0,   1,   4,   5}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 18,   4,   1,   2,   3}; //   5

  c_p[x_a][24] = {  0,   6,   7,   3}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 17,   0,   5,   6,   3}; //   5

  c_p[x_a][25] = {  0,   6,   7,   5}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 18,   4,   5,   6,   3}; //   5

  c_p[x_a][26] = {  8,   9,  10,   3}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 17,   0,   7,   8,   9}; //   5

  c_p[x_a][27] = {  8,   9,  11,   3}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 17,   0,   7,   8,   9}; //   5

  c_p[x_a][28] = {  8,   9,  10,   5}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 18,   4,   7,   8,   9}; //   5

  c_p[x_a][29] = {  8,   9,  11,   5}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 18,   4,   7,   8,   9}; //   5

  c_p[x_a][30] = {  8,  12,  13,   3}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 17,   0,  10,  11,   9}; //   5

  c_p[x_a][31] = {  8,  12,  13,   5}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 18,   4,  10,  11,   9}; //   5

  c_p[x_a][32] = {  0,  14,  15,   3}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 17,   0,  12,   9,   3}; //   5

  c_p[x_a][33] = {  0,  14,  16,   3}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 17,   0,  12,   9,   3}; //   5

  c_p[x_a][34] = {  0,  14,  17,   3}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 17,   0,  12,   9,   3}; //   5

  c_p[x_a][35] = {  0,  14,  15,   5}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 18,   4,  12,   9,   3}; //   5

  c_p[x_a][36] = {  0,  14,  16,   5}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 18,   4,  12,   9,   3}; //   5

  c_p[x_a][37] = {  0,  14,  17,   5}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 18,   4,  12,   9,   3}; //   5

  c_p[x_a][38] = {  0,  18,  19,  20}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 18,  13,   9,  14,   3}; //   5

  c_p[x_a][39] = {  8,  21,  22,  23}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 17,  15,   3,  16,   9}; //   5

  c_p[x_a][40] = {  8,  24,  25,  26}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 19,  14,  16,   3,   9}; //   5

  c_p[x_a][41] = {  0,   1,   2}; //   3
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  2,   3}; //   2
  c_d[x_a][41] = {  1,   2,   3}; //   3

  c_p[x_a][42] = {  0,   1,   4}; //   3
  c_f[x_a][42] = {  0}; //   1
  c_t[x_a][42] = {  2,   3}; //   2
  c_d[x_a][42] = {  1,   2,   3}; //   3

  c_p[x_a][43] = {  0,   1,   2}; //   3
  c_f[x_a][43] = {  1}; //   1
  c_t[x_a][43] = {  4,   5}; //   2
  c_d[x_a][43] = {  1,   2,   3}; //   3

  c_p[x_a][44] = {  0,   1,   4}; //   3
  c_f[x_a][44] = {  1}; //   1
  c_t[x_a][44] = {  4,   5}; //   2
  c_d[x_a][44] = {  1,   2,   3}; //   3

  c_p[x_a][45] = {  0,   6,   7}; //   3
  c_f[x_a][45] = {  0}; //   1
  c_t[x_a][45] = {  2,   3}; //   2
  c_d[x_a][45] = {  5,   6,   3}; //   3

  c_p[x_a][46] = {  0,   6,   7}; //   3
  c_f[x_a][46] = {  1}; //   1
  c_t[x_a][46] = {  4,   5}; //   2
  c_d[x_a][46] = {  5,   6,   3}; //   3

  c_p[x_a][47] = {  8,   9,  10}; //   3
  c_f[x_a][47] = {  0}; //   1
  c_t[x_a][47] = {  2,   3}; //   2
  c_d[x_a][47] = {  7,   8,   9}; //   3

  c_p[x_a][48] = {  8,   9,  11}; //   3
  c_f[x_a][48] = {  0}; //   1
  c_t[x_a][48] = {  2,   3}; //   2
  c_d[x_a][48] = {  7,   8,   9}; //   3

  c_p[x_a][49] = {  8,   9,  10}; //   3
  c_f[x_a][49] = {  1}; //   1
  c_t[x_a][49] = {  4,   5}; //   2
  c_d[x_a][49] = {  7,   8,   9}; //   3

  c_p[x_a][50] = {  8,   9,  11}; //   3
  c_f[x_a][50] = {  1}; //   1
  c_t[x_a][50] = {  4,   5}; //   2
  c_d[x_a][50] = {  7,   8,   9}; //   3

  c_p[x_a][51] = {  8,  12,  13}; //   3
  c_f[x_a][51] = {  0}; //   1
  c_t[x_a][51] = {  2,   3}; //   2
  c_d[x_a][51] = { 10,  11,   9}; //   3

  c_p[x_a][52] = {  8,  12,  13}; //   3
  c_f[x_a][52] = {  1}; //   1
  c_t[x_a][52] = {  4,   5}; //   2
  c_d[x_a][52] = { 10,  11,   9}; //   3

  c_p[x_a][53] = {  0,  14,  15}; //   3
  c_f[x_a][53] = {  0}; //   1
  c_t[x_a][53] = {  2,   3}; //   2
  c_d[x_a][53] = { 12,   9,   3}; //   3

  c_p[x_a][54] = {  0,  14,  16}; //   3
  c_f[x_a][54] = {  0}; //   1
  c_t[x_a][54] = {  2,   3}; //   2
  c_d[x_a][54] = { 12,   9,   3}; //   3

  c_p[x_a][55] = {  0,  14,  17}; //   3
  c_f[x_a][55] = {  0}; //   1
  c_t[x_a][55] = {  2,   3}; //   2
  c_d[x_a][55] = { 12,   9,   3}; //   3

  c_p[x_a][56] = {  0,  14,  15}; //   3
  c_f[x_a][56] = {  1}; //   1
  c_t[x_a][56] = {  4,   5}; //   2
  c_d[x_a][56] = { 12,   9,   3}; //   3

  c_p[x_a][57] = {  0,  14,  16}; //   3
  c_f[x_a][57] = {  1}; //   1
  c_t[x_a][57] = {  4,   5}; //   2
  c_d[x_a][57] = { 12,   9,   3}; //   3

  c_p[x_a][58] = {  0,  14,  17}; //   3
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  4,   5}; //   2
  c_d[x_a][58] = { 12,   9,   3}; //   3

  c_p[x_a][59] = {  0,   1,   2,   3}; //   4
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  4}; //   1
  c_d[x_a][59] = {  0,   1,   2,   3}; //   4

  c_p[x_a][60] = {  0,   1,   4,   3}; //   4
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  4}; //   1
  c_d[x_a][60] = {  0,   1,   2,   3}; //   4

  c_p[x_a][61] = {  0,   1,   2,   5}; //   4
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  2}; //   1
  c_d[x_a][61] = {  4,   1,   2,   3}; //   4

  c_p[x_a][62] = {  0,   1,   4,   5}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  2}; //   1
  c_d[x_a][62] = {  4,   1,   2,   3}; //   4

  c_p[x_a][63] = {  0,   6,   7,   3}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  4}; //   1
  c_d[x_a][63] = {  0,   5,   6,   3}; //   4

  c_p[x_a][64] = {  0,   6,   7,   5}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  2}; //   1
  c_d[x_a][64] = {  4,   5,   6,   3}; //   4

  c_p[x_a][65] = {  8,   9,  10,   3}; //   4
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  4}; //   1
  c_d[x_a][65] = {  0,   7,   8,   9}; //   4

  c_p[x_a][66] = {  8,   9,  11,   3}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  4}; //   1
  c_d[x_a][66] = {  0,   7,   8,   9}; //   4

  c_p[x_a][67] = {  8,   9,  10,   5}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  2}; //   1
  c_d[x_a][67] = {  4,   7,   8,   9}; //   4

  c_p[x_a][68] = {  8,   9,  11,   5}; //   4
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  2}; //   1
  c_d[x_a][68] = {  4,   7,   8,   9}; //   4

  c_p[x_a][69] = {  8,  12,  13,   3}; //   4
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  4}; //   1
  c_d[x_a][69] = {  0,  10,  11,   9}; //   4

  c_p[x_a][70] = {  8,  12,  13,   5}; //   4
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  2}; //   1
  c_d[x_a][70] = {  4,  10,  11,   9}; //   4

  c_p[x_a][71] = {  0,  14,  15,   3}; //   4
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  4}; //   1
  c_d[x_a][71] = {  0,  12,   9,   3}; //   4

  c_p[x_a][72] = {  0,  14,  16,   3}; //   4
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  4}; //   1
  c_d[x_a][72] = {  0,  12,   9,   3}; //   4

  c_p[x_a][73] = {  0,  14,  17,   3}; //   4
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {  4}; //   1
  c_d[x_a][73] = {  0,  12,   9,   3}; //   4

  c_p[x_a][74] = {  0,  14,  15,   5}; //   4
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {  2}; //   1
  c_d[x_a][74] = {  4,  12,   9,   3}; //   4

  c_p[x_a][75] = {  0,  14,  16,   5}; //   4
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  2}; //   1
  c_d[x_a][75] = {  4,  12,   9,   3}; //   4

  c_p[x_a][76] = {  0,  14,  17,   5}; //   4
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  2}; //   1
  c_d[x_a][76] = {  4,  12,   9,   3}; //   4

  c_p[x_a][77] = {  0,  18,  19,  20}; //   4
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {  2}; //   1
  c_d[x_a][77] = { 13,   9,  14,   3}; //   4

  c_p[x_a][78] = {  8,  21,  22,  23}; //   4
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = {  4}; //   1
  c_d[x_a][78] = { 15,   3,  16,   9}; //   4

  c_p[x_a][79] = {  0,  14,  25}; //   3
  c_f[x_a][79] = {  2}; //   1
  c_t[x_a][79] = {  0,   6}; //   2
  c_d[x_a][79] = { 16,   9,   3}; //   3

  c_p[x_a][80] = {  8,  24,  27}; //   3
  c_f[x_a][80] = {  3}; //   1
  c_t[x_a][80] = {  1,   7}; //   2
  c_d[x_a][80] = { 14,   3,   9}; //   3

  c_p[x_a][81] = {  0,  18,  19,  28}; //   4
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {  8}; //   1
  c_d[x_a][81] = { 16,   9,  14,   3}; //   4

  c_p[x_a][82] = {  8,  21,  22,  26}; //   4
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = {  9}; //   1
  c_d[x_a][82] = { 14,   3,  16,   9}; //   4

  c_p[x_a][83] = {  0,  14}; //   2
  c_f[x_a][83] = {  4,   0}; //   2
  c_t[x_a][83] = {  2,   3,  10}; //   3
  c_d[x_a][83] = {  9,   3}; //   2

  c_p[x_a][84] = {  8,  24}; //   2
  c_f[x_a][84] = {  4,   1}; //   2
  c_t[x_a][84] = {  4,   5,  11}; //   3
  c_d[x_a][84] = {  3,   9}; //   2

  c_p[x_a][85] = {  0,  18,  19}; //   3
  c_f[x_a][85] = {  3}; //   1
  c_t[x_a][85] = {  2,  12}; //   2
  c_d[x_a][85] = {  9,  14,   3}; //   3

  c_p[x_a][86] = {  8,  21,  22}; //   3
  c_f[x_a][86] = {  2}; //   1
  c_t[x_a][86] = {  4,  13}; //   2
  c_d[x_a][86] = {  3,  16,   9}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_gg_emmupvmvexbbx
//  channel    0: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   5,   5)
//  channel    1: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   5,   5)
//  channel    2: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   5,   5)
//  channel    3: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   5,   5)
//  channel    4: 5yyyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   5,   5)
//  channel    5: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   5,   5)
//  channel    6: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   5,   5)
//  channel    7: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   5,   5)
//  channel    8: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   5,   5)
//  channel    9: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   5,   5)
//  channel   10: 5yyyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   5,   5)
//  channel   11: 5yyyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   5,   5)
//  channel   12: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   5,   5)
//  channel   13: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   5,   5)
//  channel   14: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  25,   5,   5)
//  channel   15: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   5,   5)
//  channel   16: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   5,   5)
//  channel   17: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  25,   5,   5)
//  channel   18: 52vyv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   6,  24,   5,   5)
//  channel   19: 52vyv1(1, 2, 8, 16, 128, 4, 32, 64;  24,   6,  24,   5,   5)
//  channel   20: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   0)
//  channel   21: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   0)
//  channel   22: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   5,   0)
//  channel   23: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   5,   0)
//  channel   24: 6yyyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   0)
//  channel   25: 6yyyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   5,   0)
//  channel   26: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   0)
//  channel   27: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   0)
//  channel   28: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   5,   0)
//  channel   29: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   5,   0)
//  channel   30: 6yyyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   0)
//  channel   31: 6yyyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   5,   0)
//  channel   32: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   0)
//  channel   33: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   0)
//  channel   34: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   0)
//  channel   35: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   5,   0)
//  channel   36: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   5,   0)
//  channel   37: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  25,   5,   0)
//  channel   38: 6y2vyv(1, 2, 128, 4, 32, 64, 8, 16;  24,   6,  24,   5,   0)
//  channel   39: 6y2vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   6,  24,   5,   0)
//  channel   40: 63yvyv(1, 2, 64, 8, 16, 128, 4, 32;  24,  24,   6,   6,   0)
//  channel   41: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   5,   5)
//  channel   42: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   5,   5)
//  channel   43: 14yyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   5,   5)
//  channel   44: 14yyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   5,   5)
//  channel   45: 14yyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   5,   5)
//  channel   46: 14yyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   5,   5)
//  channel   47: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   5,   5)
//  channel   48: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   5,   5)
//  channel   49: 14yyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   5,   5)
//  channel   50: 14yyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   5,   5)
//  channel   51: 14yyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   5,   5)
//  channel   52: 14yyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   5,   5)
//  channel   53: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   5,   5)
//  channel   54: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   5,   5)
//  channel   55: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  25,   5,   5)
//  channel   56: 142vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   5,   5)
//  channel   57: 142vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   5,   5)
//  channel   58: 142vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  25,   5,   5)
//  channel   59: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   5)
//  channel   60: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   5)
//  channel   61: 15yyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   5,   5)
//  channel   62: 15yyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   5,   5)
//  channel   63: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   5)
//  channel   64: 15yyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   5,   5)
//  channel   65: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   5)
//  channel   66: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   5)
//  channel   67: 15yyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   5,   5)
//  channel   68: 15yyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   5,   5)
//  channel   69: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   5)
//  channel   70: 15yyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   5,   5)
//  channel   71: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   5)
//  channel   72: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   5)
//  channel   73: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   5)
//  channel   74: 15y2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   5,   5)
//  channel   75: 15y2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   5,   5)
//  channel   76: 15y2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  25,   5,   5)
//  channel   77: 152vyv(1, 2, 128, 4, 32, 64, 8, 16;  24,   6,  24,   5,   5)
//  channel   78: 152vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   6,  24,   5,   5)
//  channel   79: 3yv2v1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   6,   5,   6)
//  channel   80: 3yv2v1(1, 2, 64, 8, 16, 4, 32, 128;  24,  24,   6,   5,   6)
//  channel   81: 3yv3yv(1, 2, 128, 4, 32, 64, 8, 16;  24,   6,  24,   6,   6)
//  channel   82: 3yv3yv(1, 2, 64, 8, 16, 128, 4, 32;  24,   6,  24,   6,   6)
//  channel   83: 12v2v1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   5,   5,   6)
//  channel   84: 12v2v1(1, 2, 64, 8, 16, 4, 32, 128;  24,  24,   5,   5,   6)
//  channel   85: 12v3yv(1, 2, 128, 4, 32, 64, 8, 16;  24,   6,  24,   5,   6)
//  channel   86: 12v3yv(1, 2, 64, 8, 16, 128, 4, 32;  24,   6,  24,   5,   6)
