#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_gg_emmupvmvexddx(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_gg_emmupvmvexddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(17);
  needed_v_smin[x_a].resize(17);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   18,   19,   20,   21,   37,   38,   39,   40,   53,   54,   55,   56}; //  16
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   18,   19,   20,   21,   37,   38,   39,   40,   53,   54,   55,   56}; //  16
  needed_v_smin[x_a][  3] = {   0,    1,    4,    6,    7,   10,   12,   13,   18,   19,   22,   24,   25,   28,   30,   31,   53,   54,   57,   59,   60,   63,   65,   66,   39,   40,   42,   45,   46,   48,   51,   52,   76}; //  33
  needed_v_smin[x_a][  4] = {   2,    3,    5,    8,    9,   11,   14,   15,   20,   21,   23,   26,   27,   29,   32,   33,   55,   56,   58,   61,   62,   64,   67,   68,   37,   38,   41,   43,   44,   47,   49,   50,   75}; //  33
  needed_v_smin[x_a][  5] = {   4,    5,   22,   23,   41,   42,   57,   58}; //   8
  needed_v_smin[x_a][  6] = {   4,    5,   22,   23,   41,   42,   57,   58}; //   8
  needed_v_smin[x_a][  7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  needed_v_smin[x_a][  8] = {   6,    7,    8,    9,   24,   25,   26,   27,   43,   44,   45,   46,   59,   60,   61,   62}; //  16
  needed_v_smin[x_a][  9] = {   6,    7,    8,    9,   24,   25,   26,   27,   43,   44,   45,   46,   59,   60,   61,   62}; //  16
  needed_v_smin[x_a][ 10] = {  10,   11,   28,   29,   47,   48,   63,   64}; //   8
  needed_v_smin[x_a][ 11] = {  10,   11,   28,   29,   47,   48,   63,   64}; //   8
  needed_v_smin[x_a][ 12] = {  12,   13,   14,   15,   30,   31,   32,   33,   49,   50,   51,   52,   65,   66,   67,   68,   75,   76}; //  18
  needed_v_smin[x_a][ 13] = {  16,   34,   36,   69,   72,   73,   74,   77}; //   8
  needed_v_smin[x_a][ 14] = {  16,   34,   69,   72,   77}; //   5
  needed_v_smin[x_a][ 15] = {  17,   35,   36,   70,   71,   73,   74,   78}; //   8
  needed_v_smin[x_a][ 16] = {  17,   35,   70,   71,   78}; //   5

  v_smax[x_a].resize(19);
  needed_v_smax[x_a].resize(19);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   37,   38,   39,   40,   41,   42,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   65,   66,   67,   68,   69,   71,   73,   75,   77}; //  47
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   18,   19,   20,   21,   37,   38,   39,   40,   53,   54,   55,   56}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   75,   76}; //  66
  needed_v_smax[x_a][  3] = {   0,    1,    4,    6,    7,   10,   12,   13,   17,   18,   19,   22,   24,   25,   28,   30,   31,   35,   53,   54,   57,   59,   60,   63,   65,   66,   70,   39,   40,   42,   45,   46,   48,   51,   52,   71,   76,   78}; //  38
  needed_v_smax[x_a][  4] = {   2,    3,    5,    8,    9,   11,   14,   15,   16,   20,   21,   23,   26,   27,   29,   32,   33,   34,   55,   56,   58,   61,   62,   64,   67,   68,   69,   37,   38,   41,   43,   44,   47,   49,   50,   72,   75,   77}; //  38
  needed_v_smax[x_a][  5] = {   4,    5,   22,   23,   41,   42,   57,   58}; //   8
  needed_v_smax[x_a][  6] = {   6,    7,    8,    9,   10,   11,   17,   24,   25,   26,   27,   28,   29,   35,   36,   43,   44,   45,   46,   47,   48,   59,   60,   61,   62,   63,   64,   70,   72,   74,   76,   78}; //  32
  needed_v_smax[x_a][  7] = {   6,    7,    8,    9,   24,   25,   26,   27,   43,   44,   45,   46,   59,   60,   61,   62}; //  16
  needed_v_smax[x_a][  8] = {  10,   11,   28,   29,   47,   48,   63,   64}; //   8
  needed_v_smax[x_a][  9] = {  12,   13,   14,   15,   30,   31,   32,   33,   49,   50,   51,   52,   65,   66,   67,   68,   71,   75}; //  18
  needed_v_smax[x_a][ 10] = {  16,   34,   69,   73,   77}; //   5
  needed_v_smax[x_a][ 11] = {  16,   34,   69,   73,   77}; //   5
  needed_v_smax[x_a][ 12] = {  17,   35,   70,   74,   78}; //   5
  needed_v_smax[x_a][ 13] = {  17,   35,   70,   74,   78}; //   5
  needed_v_smax[x_a][ 14] = {  36,   72,   76}; //   3
  needed_v_smax[x_a][ 15] = {  36,   71}; //   2
  needed_v_smax[x_a][ 16] = {  36,   74}; //   2
  needed_v_smax[x_a][ 17] = {  72}; //   1
  needed_v_smax[x_a][ 18] = {  73}; //   1

  g_p[x_a].resize(28);
  needed_g_p[x_a].resize(28);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   37,   38,   39,   40,   41,   42,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   65,   66,   67,   68,   69,   71,   73,   75,   77}; //  47
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   18,   19,   20,   21,   37,   38,   39,   40,   53,   54,   55,   56}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   18,   20,   37,   39,   53,   55}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    4,    6,    7,   10,   12,   13,   18,   19,   22,   24,   25,   28,   30,   31,   53,   54,   57,   59,   60,   63,   65,   66}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,   19,   21,   38,   40,   54,   56}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   2,    3,    5,    8,    9,   11,   14,   15,   20,   21,   23,   26,   27,   29,   32,   33,   55,   56,   58,   61,   62,   64,   67,   68}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   4,    5,   22,   23,   41,   42,   57,   58}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][7] = {   4,    5,   22,   23,   41,   42,   57,   58}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   6,    7,    8,    9,   10,   11,   17,   24,   25,   26,   27,   28,   29,   35,   36,   43,   44,   45,   46,   47,   48,   59,   60,   61,   62,   63,   64,   70,   72,   74,   76,   78}; //  32
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax6");
  needed_g_p[x_a][9] = {   6,    7,    8,    9,   24,   25,   26,   27,   43,   44,   45,   46,   59,   60,   61,   62}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {   6,    8,   24,   26,   43,   45,   59,   61}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][11] = {   7,    9,   25,   27,   44,   46,   60,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {  10,   11,   28,   29,   47,   48,   63,   64}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][13] = {  10,   11,   28,   29,   47,   48,   63,   64}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][14] = {  12,   13,   14,   15,   30,   31,   32,   33,   49,   50,   51,   52,   65,   66,   67,   68,   71,   75}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax9");
  needed_g_p[x_a][15] = {  12,   14,   30,   32,   49,   51,   65,   67}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][16] = {  13,   15,   31,   33,   50,   52,   66,   68}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][17] = {  16,   34,   69,   73,   77}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][18] = {  16,   34,   69,   73,   77}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax11");
  needed_g_p[x_a][19] = {  16,   34,   69}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax4");
  needed_g_p[x_a][20] = {  17,   35,   70,   74,   78}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][21] = {  17,   35,   70,   74,   78}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax13");
  needed_g_p[x_a][22] = {  17,   35,   70}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax3");
  needed_g_p[x_a][23] = {  36,   72,   76}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][24] = {  36,   71}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax15");
  needed_g_p[x_a][25] = {  36,   74}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax16");
  needed_g_p[x_a][26] = {  72}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax17");
  needed_g_p[x_a][27] = {  73}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax18");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {  37,   38,   41,   43,   44,   47,   49,   50,   75}; //   9
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][1] = {  39,   40,   42,   45,   46,   48,   51,   52,   76}; //   9
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][2] = {  71,   78}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax3");
  needed_g_f[x_a][3] = {  72,   77}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax4");
  needed_g_f[x_a][4] = {  75,   76}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax2");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   17,   71}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_188");
  needed_g_t[x_a][1] = {   2,    3,    5,    8,    9,   11,   14,   15,   16,   72}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][2] = {  37,   38,   41,   43,   44,   47,   49,   50,   55,   56,   58,   61,   62,   64,   67,   68,   69,   75,   77}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__128_124");
  needed_g_t[x_a][3] = {  37,   38,   41,   43,   44,   47,   49,   50,   75}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__64_60");
  needed_g_t[x_a][4] = {  39,   40,   42,   45,   46,   48,   51,   52,   53,   54,   57,   59,   60,   63,   65,   66,   70,   76,   78}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][5] = {  39,   40,   42,   45,   46,   48,   51,   52,   76}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__128_60");
  needed_g_t[x_a][6] = {  71}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__164_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__164_24");
  needed_g_t[x_a][7] = {  72}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__88_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__88_36");
  needed_g_t[x_a][8] = {  73}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__164_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__164_88");
  needed_g_t[x_a][9] = {  74}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__88_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__88_164");
  needed_g_t[x_a][10] = {  75}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_66__36_24");
  needed_g_t[x_a][11] = {  76}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_130__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_130__24_36");
  needed_g_t[x_a][12] = {  77}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__88_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__88_36");
  needed_g_t[x_a][13] = {  78}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__164_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__164_24");

  g_d[x_a].resize(20);
  needed_g_d[x_a].resize(20);
  needed_g_d[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   18,   19,   22,   24,   25,   28,   30,   31,   53,   54,   57,   59,   60,   63,   65,   66}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,   18,   19,   20,   21,   37,   38,   39,   40,   53,   54,   55,   56}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,   18,   19,   20,   21,   37,   38,   39,   40,   53,   54,   55,   56}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   2,    3,    5,    8,    9,   11,   14,   15,   20,   21,   23,   26,   27,   29,   32,   33,   55,   56,   58,   61,   62,   64,   67,   68}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][5] = {   4,    5,   22,   23,   41,   42,   57,   58}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   4,    5,   22,   23,   41,   42,   57,   58}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {   6,    7,    8,    9,   24,   25,   26,   27,   43,   44,   45,   46,   59,   60,   61,   62}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {   6,    7,    8,    9,   24,   25,   26,   27,   43,   44,   45,   46,   59,   60,   61,   62}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][9] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][10] = {  10,   11,   28,   29,   47,   48,   63,   64}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][11] = {  10,   11,   28,   29,   47,   48,   63,   64}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][12] = {  12,   13,   14,   15,   30,   31,   32,   33,   49,   50,   51,   52,   65,   66,   67,   68}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][13] = {  16,   34,   69}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][14] = {  16,   34,   36,   69,   72,   73,   74,   77}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][15] = {  17,   35,   70}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__24_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__24_164");
  needed_g_d[x_a][16] = {  17,   35,   36,   70,   71,   73,   74,   78}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");
  needed_g_d[x_a][17] = {  18,   19,   22,   24,   25,   28,   30,   31,   35}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][18] = {  20,   21,   23,   26,   27,   29,   32,   33,   34}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][19] = {  36}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__88_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__88_164");

  c_p[x_a].resize(79);
  c_f[x_a].resize(79);
  c_t[x_a].resize(79);
  c_d[x_a].resize(79);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   4,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  0,   1,   2,   5}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  1}; //   1
  c_d[x_a][2] = {  4,   1,   2,   3}; //   4

  c_p[x_a][3] = {  0,   1,   4,   5}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  1}; //   1
  c_d[x_a][3] = {  4,   1,   2,   3}; //   4

  c_p[x_a][4] = {  0,   6,   7,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   5,   6,   3}; //   4

  c_p[x_a][5] = {  0,   6,   7,   5}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  1}; //   1
  c_d[x_a][5] = {  4,   5,   6,   3}; //   4

  c_p[x_a][6] = {  8,   9,  10,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  0,   7,   8,   9}; //   4

  c_p[x_a][7] = {  8,   9,  11,   3}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  0,   7,   8,   9}; //   4

  c_p[x_a][8] = {  8,   9,  10,   5}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  1}; //   1
  c_d[x_a][8] = {  4,   7,   8,   9}; //   4

  c_p[x_a][9] = {  8,   9,  11,   5}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  1}; //   1
  c_d[x_a][9] = {  4,   7,   8,   9}; //   4

  c_p[x_a][10] = {  8,  12,  13,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  0,  10,  11,   9}; //   4

  c_p[x_a][11] = {  8,  12,  13,   5}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  1}; //   1
  c_d[x_a][11] = {  4,  10,  11,   9}; //   4

  c_p[x_a][12] = {  0,  14,  15,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  0,  12,   9,   3}; //   4

  c_p[x_a][13] = {  0,  14,  16,   3}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  0,  12,   9,   3}; //   4

  c_p[x_a][14] = {  0,  14,  15,   5}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  1}; //   1
  c_d[x_a][14] = {  4,  12,   9,   3}; //   4

  c_p[x_a][15] = {  0,  14,  16,   5}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  1}; //   1
  c_d[x_a][15] = {  4,  12,   9,   3}; //   4

  c_p[x_a][16] = {  0,  17,  18,  19}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  1}; //   1
  c_d[x_a][16] = { 13,   9,  14,   3}; //   4

  c_p[x_a][17] = {  8,  20,  21,  22}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 15,   3,  16,   9}; //   4

  c_p[x_a][18] = {  0,   1,   2,   3}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 17,   0,   1,   2,   3}; //   5

  c_p[x_a][19] = {  0,   1,   4,   3}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 17,   0,   1,   2,   3}; //   5

  c_p[x_a][20] = {  0,   1,   2,   5}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 18,   4,   1,   2,   3}; //   5

  c_p[x_a][21] = {  0,   1,   4,   5}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 18,   4,   1,   2,   3}; //   5

  c_p[x_a][22] = {  0,   6,   7,   3}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 17,   0,   5,   6,   3}; //   5

  c_p[x_a][23] = {  0,   6,   7,   5}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 18,   4,   5,   6,   3}; //   5

  c_p[x_a][24] = {  8,   9,  10,   3}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 17,   0,   7,   8,   9}; //   5

  c_p[x_a][25] = {  8,   9,  11,   3}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 17,   0,   7,   8,   9}; //   5

  c_p[x_a][26] = {  8,   9,  10,   5}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 18,   4,   7,   8,   9}; //   5

  c_p[x_a][27] = {  8,   9,  11,   5}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 18,   4,   7,   8,   9}; //   5

  c_p[x_a][28] = {  8,  12,  13,   3}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 17,   0,  10,  11,   9}; //   5

  c_p[x_a][29] = {  8,  12,  13,   5}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 18,   4,  10,  11,   9}; //   5

  c_p[x_a][30] = {  0,  14,  15,   3}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 17,   0,  12,   9,   3}; //   5

  c_p[x_a][31] = {  0,  14,  16,   3}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 17,   0,  12,   9,   3}; //   5

  c_p[x_a][32] = {  0,  14,  15,   5}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 18,   4,  12,   9,   3}; //   5

  c_p[x_a][33] = {  0,  14,  16,   5}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 18,   4,  12,   9,   3}; //   5

  c_p[x_a][34] = {  0,  17,  18,  19}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 18,  13,   9,  14,   3}; //   5

  c_p[x_a][35] = {  8,  20,  21,  22}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 17,  15,   3,  16,   9}; //   5

  c_p[x_a][36] = {  8,  23,  24,  25}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 19,  14,  16,   3,   9}; //   5

  c_p[x_a][37] = {  0,   1,   2}; //   3
  c_f[x_a][37] = {  0}; //   1
  c_t[x_a][37] = {  2,   3}; //   2
  c_d[x_a][37] = {  1,   2,   3}; //   3

  c_p[x_a][38] = {  0,   1,   4}; //   3
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  2,   3}; //   2
  c_d[x_a][38] = {  1,   2,   3}; //   3

  c_p[x_a][39] = {  0,   1,   2}; //   3
  c_f[x_a][39] = {  1}; //   1
  c_t[x_a][39] = {  4,   5}; //   2
  c_d[x_a][39] = {  1,   2,   3}; //   3

  c_p[x_a][40] = {  0,   1,   4}; //   3
  c_f[x_a][40] = {  1}; //   1
  c_t[x_a][40] = {  4,   5}; //   2
  c_d[x_a][40] = {  1,   2,   3}; //   3

  c_p[x_a][41] = {  0,   6,   7}; //   3
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  2,   3}; //   2
  c_d[x_a][41] = {  5,   6,   3}; //   3

  c_p[x_a][42] = {  0,   6,   7}; //   3
  c_f[x_a][42] = {  1}; //   1
  c_t[x_a][42] = {  4,   5}; //   2
  c_d[x_a][42] = {  5,   6,   3}; //   3

  c_p[x_a][43] = {  8,   9,  10}; //   3
  c_f[x_a][43] = {  0}; //   1
  c_t[x_a][43] = {  2,   3}; //   2
  c_d[x_a][43] = {  7,   8,   9}; //   3

  c_p[x_a][44] = {  8,   9,  11}; //   3
  c_f[x_a][44] = {  0}; //   1
  c_t[x_a][44] = {  2,   3}; //   2
  c_d[x_a][44] = {  7,   8,   9}; //   3

  c_p[x_a][45] = {  8,   9,  10}; //   3
  c_f[x_a][45] = {  1}; //   1
  c_t[x_a][45] = {  4,   5}; //   2
  c_d[x_a][45] = {  7,   8,   9}; //   3

  c_p[x_a][46] = {  8,   9,  11}; //   3
  c_f[x_a][46] = {  1}; //   1
  c_t[x_a][46] = {  4,   5}; //   2
  c_d[x_a][46] = {  7,   8,   9}; //   3

  c_p[x_a][47] = {  8,  12,  13}; //   3
  c_f[x_a][47] = {  0}; //   1
  c_t[x_a][47] = {  2,   3}; //   2
  c_d[x_a][47] = { 10,  11,   9}; //   3

  c_p[x_a][48] = {  8,  12,  13}; //   3
  c_f[x_a][48] = {  1}; //   1
  c_t[x_a][48] = {  4,   5}; //   2
  c_d[x_a][48] = { 10,  11,   9}; //   3

  c_p[x_a][49] = {  0,  14,  15}; //   3
  c_f[x_a][49] = {  0}; //   1
  c_t[x_a][49] = {  2,   3}; //   2
  c_d[x_a][49] = { 12,   9,   3}; //   3

  c_p[x_a][50] = {  0,  14,  16}; //   3
  c_f[x_a][50] = {  0}; //   1
  c_t[x_a][50] = {  2,   3}; //   2
  c_d[x_a][50] = { 12,   9,   3}; //   3

  c_p[x_a][51] = {  0,  14,  15}; //   3
  c_f[x_a][51] = {  1}; //   1
  c_t[x_a][51] = {  4,   5}; //   2
  c_d[x_a][51] = { 12,   9,   3}; //   3

  c_p[x_a][52] = {  0,  14,  16}; //   3
  c_f[x_a][52] = {  1}; //   1
  c_t[x_a][52] = {  4,   5}; //   2
  c_d[x_a][52] = { 12,   9,   3}; //   3

  c_p[x_a][53] = {  0,   1,   2,   3}; //   4
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  4}; //   1
  c_d[x_a][53] = {  0,   1,   2,   3}; //   4

  c_p[x_a][54] = {  0,   1,   4,   3}; //   4
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  4}; //   1
  c_d[x_a][54] = {  0,   1,   2,   3}; //   4

  c_p[x_a][55] = {  0,   1,   2,   5}; //   4
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  2}; //   1
  c_d[x_a][55] = {  4,   1,   2,   3}; //   4

  c_p[x_a][56] = {  0,   1,   4,   5}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  2}; //   1
  c_d[x_a][56] = {  4,   1,   2,   3}; //   4

  c_p[x_a][57] = {  0,   6,   7,   3}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  4}; //   1
  c_d[x_a][57] = {  0,   5,   6,   3}; //   4

  c_p[x_a][58] = {  0,   6,   7,   5}; //   4
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  2}; //   1
  c_d[x_a][58] = {  4,   5,   6,   3}; //   4

  c_p[x_a][59] = {  8,   9,  10,   3}; //   4
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  4}; //   1
  c_d[x_a][59] = {  0,   7,   8,   9}; //   4

  c_p[x_a][60] = {  8,   9,  11,   3}; //   4
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  4}; //   1
  c_d[x_a][60] = {  0,   7,   8,   9}; //   4

  c_p[x_a][61] = {  8,   9,  10,   5}; //   4
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  2}; //   1
  c_d[x_a][61] = {  4,   7,   8,   9}; //   4

  c_p[x_a][62] = {  8,   9,  11,   5}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  2}; //   1
  c_d[x_a][62] = {  4,   7,   8,   9}; //   4

  c_p[x_a][63] = {  8,  12,  13,   3}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  4}; //   1
  c_d[x_a][63] = {  0,  10,  11,   9}; //   4

  c_p[x_a][64] = {  8,  12,  13,   5}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  2}; //   1
  c_d[x_a][64] = {  4,  10,  11,   9}; //   4

  c_p[x_a][65] = {  0,  14,  15,   3}; //   4
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  4}; //   1
  c_d[x_a][65] = {  0,  12,   9,   3}; //   4

  c_p[x_a][66] = {  0,  14,  16,   3}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  4}; //   1
  c_d[x_a][66] = {  0,  12,   9,   3}; //   4

  c_p[x_a][67] = {  0,  14,  15,   5}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  2}; //   1
  c_d[x_a][67] = {  4,  12,   9,   3}; //   4

  c_p[x_a][68] = {  0,  14,  16,   5}; //   4
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  2}; //   1
  c_d[x_a][68] = {  4,  12,   9,   3}; //   4

  c_p[x_a][69] = {  0,  17,  18,  19}; //   4
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  2}; //   1
  c_d[x_a][69] = { 13,   9,  14,   3}; //   4

  c_p[x_a][70] = {  8,  20,  21,  22}; //   4
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  4}; //   1
  c_d[x_a][70] = { 15,   3,  16,   9}; //   4

  c_p[x_a][71] = {  0,  14,  24}; //   3
  c_f[x_a][71] = {  2}; //   1
  c_t[x_a][71] = {  0,   6}; //   2
  c_d[x_a][71] = { 16,   9,   3}; //   3

  c_p[x_a][72] = {  8,  23,  26}; //   3
  c_f[x_a][72] = {  3}; //   1
  c_t[x_a][72] = {  1,   7}; //   2
  c_d[x_a][72] = { 14,   3,   9}; //   3

  c_p[x_a][73] = {  0,  17,  18,  27}; //   4
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {  8}; //   1
  c_d[x_a][73] = { 16,   9,  14,   3}; //   4

  c_p[x_a][74] = {  8,  20,  21,  25}; //   4
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {  9}; //   1
  c_d[x_a][74] = { 14,   3,  16,   9}; //   4

  c_p[x_a][75] = {  0,  14}; //   2
  c_f[x_a][75] = {  4,   0}; //   2
  c_t[x_a][75] = {  2,   3,  10}; //   3
  c_d[x_a][75] = {  9,   3}; //   2

  c_p[x_a][76] = {  8,  23}; //   2
  c_f[x_a][76] = {  4,   1}; //   2
  c_t[x_a][76] = {  4,   5,  11}; //   3
  c_d[x_a][76] = {  3,   9}; //   2

  c_p[x_a][77] = {  0,  17,  18}; //   3
  c_f[x_a][77] = {  3}; //   1
  c_t[x_a][77] = {  2,  12}; //   2
  c_d[x_a][77] = {  9,  14,   3}; //   3

  c_p[x_a][78] = {  8,  20,  21}; //   3
  c_f[x_a][78] = {  2}; //   1
  c_t[x_a][78] = {  4,  13}; //   2
  c_d[x_a][78] = {  3,  16,   9}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_gg_emmupvmvexddx
//  channel    0: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   0,   0)
//  channel    1: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   0,   0)
//  channel    2: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   0,   0)
//  channel    3: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   0,   0)
//  channel    4: 5yyyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   0,   0)
//  channel    5: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   0,   0)
//  channel    6: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   0,   0)
//  channel    7: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   0,   0)
//  channel    8: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   0,   0)
//  channel    9: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   0,   0)
//  channel   10: 5yyyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   0,   0)
//  channel   11: 5yyyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   0,   0)
//  channel   12: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   0,   0)
//  channel   13: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   0,   0)
//  channel   14: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   0,   0)
//  channel   15: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   0,   0)
//  channel   16: 52vyv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   0,  24,   0,   0)
//  channel   17: 52vyv1(1, 2, 8, 16, 128, 4, 32, 64;  24,   0,  24,   0,   0)
//  channel   18: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   19: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   20: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   21: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   22: 6yyyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   23: 6yyyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   24: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   25: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   26: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   27: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   28: 6yyyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   29: 6yyyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   30: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   31: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   32: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   33: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   34: 6y2vyv(1, 2, 128, 4, 32, 64, 8, 16;  24,   0,  24,   0,   0)
//  channel   35: 6y2vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  24,   0,   0)
//  channel   36: 63yvyv(1, 2, 64, 8, 16, 128, 4, 32;  24,  24,   0,   0,   0)
//  channel   37: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   0,   0)
//  channel   38: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   0,   0)
//  channel   39: 14yyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   0,   0)
//  channel   40: 14yyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   0,   0)
//  channel   41: 14yyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   0,   0)
//  channel   42: 14yyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   0,   0)
//  channel   43: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   0,   0)
//  channel   44: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   0,   0)
//  channel   45: 14yyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   0,   0)
//  channel   46: 14yyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   0,   0)
//  channel   47: 14yyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   0,   0)
//  channel   48: 14yyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   0,   0)
//  channel   49: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   0,   0)
//  channel   50: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   0,   0)
//  channel   51: 142vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   0,   0)
//  channel   52: 142vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   0,   0)
//  channel   53: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   54: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   55: 15yyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   56: 15yyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   57: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   58: 15yyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   59: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   60: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   61: 15yyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   62: 15yyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   63: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   64: 15yyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   65: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   66: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   67: 15y2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   68: 15y2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   69: 152vyv(1, 2, 128, 4, 32, 64, 8, 16;  24,   0,  24,   0,   0)
//  channel   70: 152vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  24,   0,   0)
//  channel   71: 3yv2v1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   0,   0)
//  channel   72: 3yv2v1(1, 2, 64, 8, 16, 4, 32, 128;  24,  24,   0,   0,   0)
//  channel   73: 3yv3yv(1, 2, 128, 4, 32, 64, 8, 16;  24,   0,  24,   0,   0)
//  channel   74: 3yv3yv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  24,   0,   0)
//  channel   75: 12v2v1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   0,   0)
//  channel   76: 12v2v1(1, 2, 64, 8, 16, 4, 32, 128;  24,  24,   0,   0,   0)
//  channel   77: 12v3yv(1, 2, 128, 4, 32, 64, 8, 16;  24,   0,  24,   0,   0)
//  channel   78: 12v3yv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  24,   0,   0)
