#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_050_aa_emmupvmvexa(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_050_aa_emmupvmvexa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(26);
  needed_v_smin[x_a].resize(26);
  needed_v_smin[x_a][  0] = {   6,    7,   12,   14,   18,   19,   27,   28,   33,   34,   39,   40,   42,   44,   45,   46,   48,   50,   51,   52,   54,   56,   57,   59}; //  24
  needed_v_smin[x_a][  1] = {   8,   13,   20,   29,   35,   41,   43,   47,   49,   53,   55,   58}; //  12
  needed_v_smin[x_a][  2] = {   9,   10,   15,   16,   21,   22,   24,   25,   30,   31,   36,   37,   42,   43,   45,   47,   48,   49,   51,   53,   54,   55,   57,   58}; //  24
  needed_v_smin[x_a][  3] = {  11,   17,   23,   26,   32,   38,   44,   46,   50,   52,   56,   59}; //  12
  needed_v_smin[x_a][  4] = {  12,   18,   27,   33,   45,   54,   51}; //   7
  needed_v_smin[x_a][  5] = {  13,   20,   29,   35,   47,   55,   53}; //   7
  needed_v_smin[x_a][  6] = {  14,   19,   28,   34,   46,   56,   52}; //   7
  needed_v_smin[x_a][  7] = {  15,   21,   24,   30,   42,   57,   48}; //   7
  needed_v_smin[x_a][  8] = {  16,   22,   25,   31,   43,   58,   49}; //   7
  needed_v_smin[x_a][  9] = {  17,   23,   26,   32,   44,   59,   50}; //   7
  needed_v_smin[x_a][ 10] = {  18,   20,   27,   29,   12,   13,   33,   35}; //   8
  needed_v_smin[x_a][ 11] = {  19,   28,   14,   34}; //   4
  needed_v_smin[x_a][ 12] = {  21,   23,   24,   26,   15,   17,   30,   32}; //   8
  needed_v_smin[x_a][ 13] = {  22,   25,   16,   31}; //   4
  needed_v_smin[x_a][ 14] = {   0,    1,    6,    7,   39,   40}; //   6
  needed_v_smin[x_a][ 15] = {   0,    1}; //   2
  needed_v_smin[x_a][ 16] = {   0,    1,    2}; //   3
  needed_v_smin[x_a][ 17] = {   2,    5,    8,   11,   38,   41}; //   6
  needed_v_smin[x_a][ 18] = {   2,    5}; //   2
  needed_v_smin[x_a][ 19] = {   3,    4,    9,   10,   36,   37}; //   6
  needed_v_smin[x_a][ 20] = {   3,    4}; //   2
  needed_v_smin[x_a][ 21] = {   3,    4,    5}; //   3
  needed_v_smin[x_a][ 22] = {   6,    7,   39,   40}; //   4
  needed_v_smin[x_a][ 23] = {   8,   41}; //   2
  needed_v_smin[x_a][ 24] = {   9,   10,   36,   37}; //   4
  needed_v_smin[x_a][ 25] = {  11,   38}; //   2

  v_smax[x_a].resize(32);
  needed_v_smax[x_a].resize(32);
  needed_v_smax[x_a][  0] = {   6,    7,   12,   14,   18,   19,   27,   28,   33,   34,   39,   40,   45,   46,   51,   52,   57,   59}; //  18
  needed_v_smax[x_a][  1] = {   8,   13,   20,   29,   35,   41,   47,   53,   58}; //   9
  needed_v_smax[x_a][  2] = {   9,   10,   15,   16,   21,   22,   24,   25,   30,   31,   36,   37,   42,   43,   48,   49,   54,   55}; //  18
  needed_v_smax[x_a][  3] = {  11,   17,   23,   26,   32,   38,   44,   50,   56}; //   9
  needed_v_smax[x_a][  4] = {  12,   13,   18,   20,   27,   29,   33,   35,   45,   47}; //  10
  needed_v_smax[x_a][  5] = {  14,   19,   28,   34,   46}; //   5
  needed_v_smax[x_a][  6] = {  15,   17,   21,   23,   24,   26,   30,   32,   42,   44}; //  10
  needed_v_smax[x_a][  7] = {  16,   22,   25,   31,   43}; //   5
  needed_v_smax[x_a][  8] = {  18,   19,   20,   27,   28,   29,    3,    4,    5,    6,    7,    8,   12,   13,   14,   33,   34,   35,   39,   40,   41}; //  21
  needed_v_smax[x_a][  9] = {  21,   22,   23,   24,   25,   26,    0,    1,    2,    9,   10,   11,   15,   16,   17,   30,   31,   32,   36,   37,   38}; //  21
  needed_v_smax[x_a][ 10] = {  42,   44}; //   2
  needed_v_smax[x_a][ 11] = {  43}; //   1
  needed_v_smax[x_a][ 12] = {  45,   47}; //   2
  needed_v_smax[x_a][ 13] = {  46}; //   1
  needed_v_smax[x_a][ 14] = {  48,   54}; //   2
  needed_v_smax[x_a][ 15] = {  49,   55}; //   2
  needed_v_smax[x_a][ 16] = {  50,   56}; //   2
  needed_v_smax[x_a][ 17] = {  51,   57}; //   2
  needed_v_smax[x_a][ 18] = {  52,   59}; //   2
  needed_v_smax[x_a][ 19] = {  53,   58}; //   2
  needed_v_smax[x_a][ 20] = {  54,   55,   51,   53}; //   4
  needed_v_smax[x_a][ 21] = {  56,   52}; //   2
  needed_v_smax[x_a][ 22] = {  57,   59,   48,   50}; //   4
  needed_v_smax[x_a][ 23] = {  58,   49}; //   2
  needed_v_smax[x_a][ 24] = {   0,    1}; //   2
  needed_v_smax[x_a][ 25] = {   0,    1,    2,    3,    4,    5}; //   6
  needed_v_smax[x_a][ 26] = {   2,    5}; //   2
  needed_v_smax[x_a][ 27] = {   3,    4}; //   2
  needed_v_smax[x_a][ 28] = {   6,    7,   39,   40}; //   4
  needed_v_smax[x_a][ 29] = {   8,   41}; //   2
  needed_v_smax[x_a][ 30] = {   9,   10,   36,   37}; //   4
  needed_v_smax[x_a][ 31] = {  11,   38}; //   2

  g_p[x_a].resize(30);
  needed_g_p[x_a].resize(30);
  needed_g_p[x_a][0] = {   6,    7,   12,   14,   18,   19,   27,   28,   33,   34,   39,   40,   45,   46,   51,   52,   57,   59}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   8,   13,   20,   29,   35,   41,   47,   53,   58}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   9,   10,   15,   16,   21,   22,   24,   25,   30,   31,   36,   37,   42,   43,   48,   49,   54,   55}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {  11,   17,   23,   26,   32,   38,   44,   50,   56}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  12,   18,   27,   33,   45}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax4");
  needed_g_p[x_a][5] = {  13,   20,   29,   35,   47}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][6] = {  14,   19,   28,   34,   46}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {  15,   21,   24,   30,   42}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax6");
  needed_g_p[x_a][8] = {  16,   22,   25,   31,   43}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][9] = {  17,   23,   26,   32,   44}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax6");
  needed_g_p[x_a][10] = {  18,   20,   27,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][11] = {  19,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][12] = {  21,   23,   24,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][13] = {  22,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][14] = {  42,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax10");
  needed_g_p[x_a][15] = {  43}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax11");
  needed_g_p[x_a][16] = {  45,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax12");
  needed_g_p[x_a][17] = {  46}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax13");
  needed_g_p[x_a][18] = {  48,   54}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][19] = {  49,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax15");
  needed_g_p[x_a][20] = {  50,   56}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax16");
  needed_g_p[x_a][21] = {  51,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax17");
  needed_g_p[x_a][22] = {  52,   59}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax18");
  needed_g_p[x_a][23] = {  53,   58}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax19");
  needed_g_p[x_a][24] = {  54}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax20");
  needed_g_p[x_a][25] = {  55}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax20");
  needed_g_p[x_a][26] = {  56}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax21");
  needed_g_p[x_a][27] = {  57}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax22");
  needed_g_p[x_a][28] = {  58}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax23");
  needed_g_p[x_a][29] = {  59}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax22");

  g_f[x_a].resize(26);
  needed_g_f[x_a].resize(26);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax24");
  needed_g_f[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax25");
  needed_g_f[x_a][2] = {   0,    1,    2}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax9");
  needed_g_f[x_a][3] = {   2,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax26");
  needed_g_f[x_a][4] = {   2,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax25");
  needed_g_f[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax27");
  needed_g_f[x_a][6] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax25");
  needed_g_f[x_a][7] = {   3,    4,    5}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax8");
  needed_g_f[x_a][8] = {   6,    7,   39,   40}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax28");
  needed_g_f[x_a][9] = {   6,    7,   39,   40}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax8");
  needed_g_f[x_a][10] = {   8,   41}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax29");
  needed_g_f[x_a][11] = {   8,   41}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax8");
  needed_g_f[x_a][12] = {   9,   10,   36,   37}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax30");
  needed_g_f[x_a][13] = {   9,   10,   36,   37}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax9");
  needed_g_f[x_a][14] = {  11,   38}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax31");
  needed_g_f[x_a][15] = {  11,   38}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax9");
  needed_g_f[x_a][16] = {  12,   13,   33,   35}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax8");
  needed_g_f[x_a][17] = {  14,   34}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][18] = {  15,   17,   30,   32}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax9");
  needed_g_f[x_a][19] = {  16,   31}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax9");
  needed_g_f[x_a][20] = {  48}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax22");
  needed_g_f[x_a][21] = {  49}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax23");
  needed_g_f[x_a][22] = {  50}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax22");
  needed_g_f[x_a][23] = {  51}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax20");
  needed_g_f[x_a][24] = {  52}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax21");
  needed_g_f[x_a][25] = {  53}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax20");

  g_t[x_a].resize(52);
  needed_g_t[x_a].resize(52);
  needed_g_t[x_a][0] = {   0,    1,    2,   24,   25,   26,   30,   31,   32,   36,   37,   38}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_120");
  needed_g_t[x_a][1] = {   0,    1,    2}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_112");
  needed_g_t[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__5_10__32_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__5_10__32_80");
  needed_g_t[x_a][3] = {   0,    6}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_37__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_37__64_16");
  needed_g_t[x_a][4] = {   1,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_37__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_37__16_64");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__64_48");
  needed_g_t[x_a][6] = {   2,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_69__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_69__16_32");
  needed_g_t[x_a][7] = {   3,    4,    5,   27,   28,   29,   33,   34,   35,   39,   40,   41}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_116");
  needed_g_t[x_a][8] = {   3,    4,    5}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_112");
  needed_g_t[x_a][9] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__9_6__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__9_6__16_96");
  needed_g_t[x_a][10] = {   3,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_25__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_25__64_32");
  needed_g_t[x_a][11] = {   4,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_25__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_25__32_64");
  needed_g_t[x_a][12] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__64_48");
  needed_g_t[x_a][13] = {   5,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_73__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_73__32_16");
  needed_g_t[x_a][14] = {   6,    7,    8,   12,   13,   14,   18,   19,   20}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][15] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_10__36_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_10__36_80");
  needed_g_t[x_a][16] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__68_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__68_48");
  needed_g_t[x_a][17] = {   9,   10,   11,   15,   16,   17,   21,   22,   23}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][18] = {   9,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_6__24_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_6__24_96");
  needed_g_t[x_a][19] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__72_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__72_48");
  needed_g_t[x_a][20] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__10_1__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__10_1__16_100");
  needed_g_t[x_a][21] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__64_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__64_52");
  needed_g_t[x_a][22] = {  15,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__6_1__32_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__6_1__32_88");
  needed_g_t[x_a][23] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__64_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__64_56");
  needed_g_t[x_a][24] = {  30,   32}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__5_2__32_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__5_2__32_88");
  needed_g_t[x_a][25] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__5_2__64_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__5_2__64_56");
  needed_g_t[x_a][26] = {  33,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__9_2__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__9_2__16_100");
  needed_g_t[x_a][27] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__9_2__64_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__9_2__64_52");
  needed_g_t[x_a][28] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_5__24_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_5__24_96");
  needed_g_t[x_a][29] = {  36}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__5_26__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__5_26__32_64");
  needed_g_t[x_a][30] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_26__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_26__64_32");
  needed_g_t[x_a][31] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__72_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__72_48");
  needed_g_t[x_a][32] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__5_74__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__5_74__32_16");
  needed_g_t[x_a][33] = {  39,   40}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_9__36_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_9__36_80");
  needed_g_t[x_a][34] = {  39}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__9_38__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__9_38__16_64");
  needed_g_t[x_a][35] = {  40}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_38__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_38__64_16");
  needed_g_t[x_a][36] = {  41}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__68_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__68_48");
  needed_g_t[x_a][37] = {  41}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__9_70__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__9_70__16_32");
  needed_g_t[x_a][38] = {  42,   44,   48,   50}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__36_88");
  needed_g_t[x_a][39] = {  43,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__68_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__68_56");
  needed_g_t[x_a][40] = {  45,   47,   51,   53}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__24_100");
  needed_g_t[x_a][41] = {  46,   52}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__72_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__72_52");
  needed_g_t[x_a][42] = {  48}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_37__24_64");
  needed_g_t[x_a][43] = {  49}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_69__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_69__24_32");
  needed_g_t[x_a][44] = {  50}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__72_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__72_16");
  needed_g_t[x_a][45] = {  51}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_25__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_25__36_64");
  needed_g_t[x_a][46] = {  52}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_73__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_73__36_16");
  needed_g_t[x_a][47] = {  53}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__68_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__68_32");
  needed_g_t[x_a][48] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__24_100");
  needed_g_t[x_a][49] = {  56}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__72_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__72_52");
  needed_g_t[x_a][50] = {  57,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__36_88");
  needed_g_t[x_a][51] = {  58}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__68_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__68_56");

  g_d[x_a].resize(14);
  needed_g_d[x_a].resize(14);
  needed_g_d[x_a][0] = {   6,    7,   12,   14,   18,   19,   27,   28,   33,   34,   39,   40,   42,   44,   45,   46,   48,   50,   51,   52,   54,   56,   57,   59}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {   8,   13,   20,   29,   35,   41,   43,   47,   49,   53,   55,   58}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][2] = {   9,   10,   15,   16,   21,   22,   24,   25,   30,   31,   36,   37,   42,   43,   45,   47,   48,   49,   51,   53,   54,   55,   57,   58}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  11,   17,   23,   26,   32,   38,   44,   46,   50,   52,   56,   59}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][4] = {  12,   18,   27,   33,   45,   54}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][5] = {  13,   20,   29,   35,   47,   55}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__32_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__32_68");
  needed_g_d[x_a][6] = {  14,   19,   28,   34,   46,   56}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {  15,   21,   24,   30,   42,   57}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][8] = {  16,   22,   25,   31,   43,   58}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][9] = {  17,   23,   26,   32,   44,   59}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__16_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__16_72");
  needed_g_d[x_a][10] = {  18,   20,   27,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__16_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__16_100");
  needed_g_d[x_a][11] = {  19,   28}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__64_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__64_52");
  needed_g_d[x_a][12] = {  21,   23,   24,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__32_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__32_88");
  needed_g_d[x_a][13] = {  22,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__64_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__64_56");

  c_p[x_a].resize(60);
  c_f[x_a].resize(60);
  c_t[x_a].resize(60);
  c_d[x_a].resize(60);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1,   2}; //   3
  c_t[x_a][1] = {  0,   1,   2,   4}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  3,   4,   2}; //   3
  c_t[x_a][2] = {  0,   1,   5,   6}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  5,   6,   7}; //   3
  c_t[x_a][3] = {  7,   8,   9,  10}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  5,   6,   7}; //   3
  c_t[x_a][4] = {  7,   8,   9,  11}; //   4
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  3,   4,   7}; //   3
  c_t[x_a][5] = {  7,   8,  12,  13}; //   4
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  8,   9}; //   2
  c_t[x_a][6] = { 14,  15,   3}; //   3
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = {  8,   9}; //   2
  c_t[x_a][7] = { 14,  15,   4}; //   3
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  1}; //   1
  c_f[x_a][8] = { 10,  11}; //   2
  c_t[x_a][8] = { 14,  16,   6}; //   3
  c_d[x_a][8] = {  1}; //   1

  c_p[x_a][9] = {  2}; //   1
  c_f[x_a][9] = { 12,  13}; //   2
  c_t[x_a][9] = { 17,  18,  10}; //   3
  c_d[x_a][9] = {  2}; //   1

  c_p[x_a][10] = {  2}; //   1
  c_f[x_a][10] = { 12,  13}; //   2
  c_t[x_a][10] = { 17,  18,  11}; //   3
  c_d[x_a][10] = {  2}; //   1

  c_p[x_a][11] = {  3}; //   1
  c_f[x_a][11] = { 14,  15}; //   2
  c_t[x_a][11] = { 17,  19,  13}; //   3
  c_d[x_a][11] = {  3}; //   1

  c_p[x_a][12] = {  0,   4}; //   2
  c_f[x_a][12] = { 16}; //   1
  c_t[x_a][12] = { 14,  20}; //   2
  c_d[x_a][12] = {  4,   0}; //   2

  c_p[x_a][13] = {  1,   5}; //   2
  c_f[x_a][13] = { 16}; //   1
  c_t[x_a][13] = { 14,  20}; //   2
  c_d[x_a][13] = {  5,   1}; //   2

  c_p[x_a][14] = {  0,   6}; //   2
  c_f[x_a][14] = { 17}; //   1
  c_t[x_a][14] = { 14,  21}; //   2
  c_d[x_a][14] = {  6,   0}; //   2

  c_p[x_a][15] = {  2,   7}; //   2
  c_f[x_a][15] = { 18}; //   1
  c_t[x_a][15] = { 17,  22}; //   2
  c_d[x_a][15] = {  7,   2}; //   2

  c_p[x_a][16] = {  2,   8}; //   2
  c_f[x_a][16] = { 19}; //   1
  c_t[x_a][16] = { 17,  23}; //   2
  c_d[x_a][16] = {  8,   2}; //   2

  c_p[x_a][17] = {  3,   9}; //   2
  c_f[x_a][17] = { 18}; //   1
  c_t[x_a][17] = { 17,  22}; //   2
  c_d[x_a][17] = {  9,   3}; //   2

  c_p[x_a][18] = {  0,   4,  10}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 14}; //   1
  c_d[x_a][18] = { 10,   4,   0}; //   3

  c_p[x_a][19] = {  0,   6,  11}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = { 14}; //   1
  c_d[x_a][19] = { 11,   6,   0}; //   3

  c_p[x_a][20] = {  1,   5,  10}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = { 14}; //   1
  c_d[x_a][20] = { 10,   5,   1}; //   3

  c_p[x_a][21] = {  2,   7,  12}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 17}; //   1
  c_d[x_a][21] = { 12,   7,   2}; //   3

  c_p[x_a][22] = {  2,   8,  13}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 17}; //   1
  c_d[x_a][22] = { 13,   8,   2}; //   3

  c_p[x_a][23] = {  3,   9,  12}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 17}; //   1
  c_d[x_a][23] = { 12,   9,   3}; //   3

  c_p[x_a][24] = {  2,   7,  12}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = { 12,   7,   2}; //   3

  c_p[x_a][25] = {  2,   8,  13}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = { 13,   8,   2}; //   3

  c_p[x_a][26] = {  3,   9,  12}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = { 12,   9,   3}; //   3

  c_p[x_a][27] = {  0,   4,  10}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  7}; //   1
  c_d[x_a][27] = { 10,   4,   0}; //   3

  c_p[x_a][28] = {  0,   6,  11}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  7}; //   1
  c_d[x_a][28] = { 11,   6,   0}; //   3

  c_p[x_a][29] = {  1,   5,  10}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  7}; //   1
  c_d[x_a][29] = { 10,   5,   1}; //   3

  c_p[x_a][30] = {  2,   7}; //   2
  c_f[x_a][30] = { 18}; //   1
  c_t[x_a][30] = {  0,  24}; //   2
  c_d[x_a][30] = {  7,   2}; //   2

  c_p[x_a][31] = {  2,   8}; //   2
  c_f[x_a][31] = { 19}; //   1
  c_t[x_a][31] = {  0,  25}; //   2
  c_d[x_a][31] = {  8,   2}; //   2

  c_p[x_a][32] = {  3,   9}; //   2
  c_f[x_a][32] = { 18}; //   1
  c_t[x_a][32] = {  0,  24}; //   2
  c_d[x_a][32] = {  9,   3}; //   2

  c_p[x_a][33] = {  0,   4}; //   2
  c_f[x_a][33] = { 16}; //   1
  c_t[x_a][33] = {  7,  26}; //   2
  c_d[x_a][33] = {  4,   0}; //   2

  c_p[x_a][34] = {  0,   6}; //   2
  c_f[x_a][34] = { 17}; //   1
  c_t[x_a][34] = {  7,  27}; //   2
  c_d[x_a][34] = {  6,   0}; //   2

  c_p[x_a][35] = {  1,   5}; //   2
  c_f[x_a][35] = { 16}; //   1
  c_t[x_a][35] = {  7,  26}; //   2
  c_d[x_a][35] = {  5,   1}; //   2

  c_p[x_a][36] = {  2}; //   1
  c_f[x_a][36] = { 12,  13}; //   2
  c_t[x_a][36] = {  0,  28,  29}; //   3
  c_d[x_a][36] = {  2}; //   1

  c_p[x_a][37] = {  2}; //   1
  c_f[x_a][37] = { 12,  13}; //   2
  c_t[x_a][37] = {  0,  28,  30}; //   3
  c_d[x_a][37] = {  2}; //   1

  c_p[x_a][38] = {  3}; //   1
  c_f[x_a][38] = { 14,  15}; //   2
  c_t[x_a][38] = {  0,  31,  32}; //   3
  c_d[x_a][38] = {  3}; //   1

  c_p[x_a][39] = {  0}; //   1
  c_f[x_a][39] = {  8,   9}; //   2
  c_t[x_a][39] = {  7,  33,  34}; //   3
  c_d[x_a][39] = {  0}; //   1

  c_p[x_a][40] = {  0}; //   1
  c_f[x_a][40] = {  8,   9}; //   2
  c_t[x_a][40] = {  7,  33,  35}; //   3
  c_d[x_a][40] = {  0}; //   1

  c_p[x_a][41] = {  1}; //   1
  c_f[x_a][41] = { 10,  11}; //   2
  c_t[x_a][41] = {  7,  36,  37}; //   3
  c_d[x_a][41] = {  1}; //   1

  c_p[x_a][42] = {  2,   7,  14}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 38}; //   1
  c_d[x_a][42] = {  0,   7,   2}; //   3

  c_p[x_a][43] = {  2,   8,  15}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 39}; //   1
  c_d[x_a][43] = {  1,   8,   2}; //   3

  c_p[x_a][44] = {  3,   9,  14}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 38}; //   1
  c_d[x_a][44] = {  0,   9,   3}; //   3

  c_p[x_a][45] = {  0,   4,  16}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = { 40}; //   1
  c_d[x_a][45] = {  2,   4,   0}; //   3

  c_p[x_a][46] = {  0,   6,  17}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 41}; //   1
  c_d[x_a][46] = {  3,   6,   0}; //   3

  c_p[x_a][47] = {  1,   5,  16}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 40}; //   1
  c_d[x_a][47] = {  2,   5,   1}; //   3

  c_p[x_a][48] = {  2,  18}; //   2
  c_f[x_a][48] = { 20}; //   1
  c_t[x_a][48] = { 38,  42}; //   2
  c_d[x_a][48] = {  0,   2}; //   2

  c_p[x_a][49] = {  2,  19}; //   2
  c_f[x_a][49] = { 21}; //   1
  c_t[x_a][49] = { 39,  43}; //   2
  c_d[x_a][49] = {  1,   2}; //   2

  c_p[x_a][50] = {  3,  20}; //   2
  c_f[x_a][50] = { 22}; //   1
  c_t[x_a][50] = { 38,  44}; //   2
  c_d[x_a][50] = {  0,   3}; //   2

  c_p[x_a][51] = {  0,  21}; //   2
  c_f[x_a][51] = { 23}; //   1
  c_t[x_a][51] = { 40,  45}; //   2
  c_d[x_a][51] = {  2,   0}; //   2

  c_p[x_a][52] = {  0,  22}; //   2
  c_f[x_a][52] = { 24}; //   1
  c_t[x_a][52] = { 41,  46}; //   2
  c_d[x_a][52] = {  3,   0}; //   2

  c_p[x_a][53] = {  1,  23}; //   2
  c_f[x_a][53] = { 25}; //   1
  c_t[x_a][53] = { 40,  47}; //   2
  c_d[x_a][53] = {  2,   1}; //   2

  c_p[x_a][54] = {  2,  18,  24}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = { 48}; //   1
  c_d[x_a][54] = {  4,   0,   2}; //   3

  c_p[x_a][55] = {  2,  19,  25}; //   3
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = { 48}; //   1
  c_d[x_a][55] = {  5,   1,   2}; //   3

  c_p[x_a][56] = {  3,  20,  26}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = { 49}; //   1
  c_d[x_a][56] = {  6,   0,   3}; //   3

  c_p[x_a][57] = {  0,  21,  27}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = { 50}; //   1
  c_d[x_a][57] = {  7,   2,   0}; //   3

  c_p[x_a][58] = {  1,  23,  28}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = { 51}; //   1
  c_d[x_a][58] = {  8,   2,   1}; //   3

  c_p[x_a][59] = {  0,  22,  29}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = { 50}; //   1
  c_d[x_a][59] = {  9,   3,   0}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_050_aa_emmupvmvexa
//  channel    0: 11111(1, 2, 4, 32, 16, 64, 8;   0,   0,  24,   0)
//  channel    1: 11111(1, 2, 4, 32, 64, 16, 8;   0,   0,  24,  24)
//  channel    2: 11111(1, 2, 4, 64, 32, 16, 8;   0,   0,   0,  24)
//  channel    3: 11111(1, 2, 8, 16, 32, 64, 4;   0,   0,  24,   0)
//  channel    4: 11111(1, 2, 8, 16, 64, 32, 4;   0,   0,  24,  24)
//  channel    5: 11111(1, 2, 8, 64, 16, 32, 4;   0,   0,   0,  24)
//  channel    6: 2v111(1, 2, 4, 32, 16, 64, 8;  24,   0,  24,   0)
//  channel    7: 2v111(1, 2, 4, 32, 64, 16, 8;  24,   0,  24,  24)
//  channel    8: 2v111(1, 2, 4, 64, 32, 16, 8;   0,   0,   0,  24)
//  channel    9: 2v111(1, 2, 8, 16, 32, 64, 4;  24,   0,  24,   0)
//  channel   10: 2v111(1, 2, 8, 16, 64, 32, 4;  24,   0,  24,  24)
//  channel   11: 2v111(1, 2, 8, 64, 16, 32, 4;   0,   0,   0,  24)
//  channel   12: 3yv11(1, 2, 64, 4, 32, 16, 8;  24,  24,   0,  24)
//  channel   13: 3yv11(1, 2, 32, 4, 64, 16, 8;   0,  24,   0,  24)
//  channel   14: 3yv11(1, 2, 16, 4, 32, 64, 8;  24,   0,   0,   0)
//  channel   15: 3yv11(1, 2, 64, 8, 16, 32, 4;  24,  24,   0,  24)
//  channel   16: 3yv11(1, 2, 32, 8, 16, 64, 4;  24,   0,   0,   0)
//  channel   17: 3yv11(1, 2, 16, 8, 64, 32, 4;   0,  24,   0,  24)
//  channel   18: 4yyv1(1, 2, 16, 64, 4, 32, 8;  24,  24,   0,   0)
//  channel   19: 4yyv1(1, 2, 64, 16, 4, 32, 8;  24,   0,   0,   0)
//  channel   20: 4yyv1(1, 2, 16, 32, 4, 64, 8;   0,  24,   0,   0)
//  channel   21: 4yyv1(1, 2, 32, 64, 8, 16, 4;  24,  24,   0,   0)
//  channel   22: 4yyv1(1, 2, 64, 32, 8, 16, 4;  24,   0,   0,   0)
//  channel   23: 4yyv1(1, 2, 32, 16, 8, 64, 4;   0,  24,   0,   0)
//  channel   24: 14yyv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,   0)
//  channel   25: 14yyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
//  channel   26: 14yyv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,   0)
//  channel   27: 14yyv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,   0)
//  channel   28: 14yyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
//  channel   29: 14yyv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,   0)
//  channel   30: 113yv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,  24)
//  channel   31: 113yv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
//  channel   32: 113yv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,  24)
//  channel   33: 113yv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,  24)
//  channel   34: 113yv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
//  channel   35: 113yv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,  24)
//  channel   36: 1112v(1, 2, 4, 32, 64, 8, 16;  24,   0,  24,  24)
//  channel   37: 1112v(1, 2, 4, 64, 32, 8, 16;  24,   0,  24,   0)
//  channel   38: 1112v(1, 2, 4, 32, 16, 8, 64;   0,   0,   0,  24)
//  channel   39: 1112v(1, 2, 8, 16, 64, 4, 32;  24,   0,  24,  24)
//  channel   40: 1112v(1, 2, 8, 64, 16, 4, 32;  24,   0,  24,   0)
//  channel   41: 1112v(1, 2, 8, 16, 32, 4, 64;   0,   0,   0,  24)
//  channel   42: 2v3yv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,  24)
//  channel   43: 2v3yv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
//  channel   44: 2v3yv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,  24)
//  channel   45: 2v3yv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,  24)
//  channel   46: 2v3yv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
//  channel   47: 2v3yv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,  24)
//  channel   48: 2v12v(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,  24)
//  channel   49: 2v12v(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,  24)
//  channel   50: 2v12v(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,   0)
//  channel   51: 2v12v(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,  24)
//  channel   52: 2v12v(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,  24)
//  channel   53: 2v12v(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,   0)
//  channel   54: 3yv2v(1, 2, 64, 4, 32, 8, 16;  24,  24,  24,  24)
//  channel   55: 3yv2v(1, 2, 32, 4, 64, 8, 16;  24,   0,  24,  24)
//  channel   56: 3yv2v(1, 2, 16, 4, 32, 8, 64;   0,  24,   0,   0)
//  channel   57: 3yv2v(1, 2, 64, 8, 16, 4, 32;  24,  24,  24,  24)
//  channel   58: 3yv2v(1, 2, 32, 8, 16, 4, 64;   0,  24,   0,   0)
//  channel   59: 3yv2v(1, 2, 16, 8, 64, 4, 32;  24,   0,  24,  24)
