#include "header.hpp"

#include "ppenexa03.phasespace.set.hpp"

void ppenexa03_phasespace_set::ax_psp_230_ddx_emvexacsx(int x_a){
  static Logger logger("ppenexa03_phasespace_set::ax_psp_230_ddx_emvexacsx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(16);
  needed_v_smin[x_a].resize(16);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13}; //  12
  needed_v_smin[x_a][  1] = {   0,    3,   10,   12}; //   4
  needed_v_smin[x_a][  2] = {   0,   12}; //   2
  needed_v_smin[x_a][  3] = {   1,    2,   11,   13}; //   4
  needed_v_smin[x_a][  4] = {   1,   13}; //   2
  needed_v_smin[x_a][  5] = {   2}; //   1
  needed_v_smin[x_a][  6] = {   3}; //   1
  needed_v_smin[x_a][  7] = {   4,    5}; //   2
  needed_v_smin[x_a][  8] = {   4,    6}; //   2
  needed_v_smin[x_a][  9] = {   5,    7}; //   2
  needed_v_smin[x_a][ 10] = {   6,    7}; //   2
  needed_v_smin[x_a][ 11] = {   6,    7}; //   2
  needed_v_smin[x_a][ 12] = {   8,   10}; //   2
  needed_v_smin[x_a][ 13] = {   8}; //   1
  needed_v_smin[x_a][ 14] = {   9,   11}; //   2
  needed_v_smin[x_a][ 15] = {   9}; //   1

  v_smax[x_a].resize(14);
  needed_v_smax[x_a].resize(14);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13}; //  10
  needed_v_smax[x_a][  1] = {   0,    3,   10,   12}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,   12,   13}; //   4
  needed_v_smax[x_a][  3] = {   1,    2,   11,   13}; //   4
  needed_v_smax[x_a][  4] = {   2,    5,    7,    8}; //   4
  needed_v_smax[x_a][  5] = {   3,    4,    6,    9}; //   4
  needed_v_smax[x_a][  6] = {   4,    5,    6,    7}; //   4
  needed_v_smax[x_a][  7] = {   6,    7}; //   2
  needed_v_smax[x_a][  8] = {   8}; //   1
  needed_v_smax[x_a][  9] = {   8}; //   1
  needed_v_smax[x_a][ 10] = {   9}; //   1
  needed_v_smax[x_a][ 11] = {   9}; //   1
  needed_v_smax[x_a][ 12] = {  10}; //   1
  needed_v_smax[x_a][ 13] = {  11}; //   1

  g_p[x_a].resize(20);
  needed_g_p[x_a].resize(20);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    3,   10,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    2,   11,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {   4,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax6");
  needed_g_p[x_a][8] = {   4,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax5");
  needed_g_p[x_a][9] = {   5,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax4");
  needed_g_p[x_a][10] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][11] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax6");
  needed_g_p[x_a][12] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax8");
  needed_g_p[x_a][13] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax9");
  needed_g_p[x_a][14] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax4");
  needed_g_p[x_a][15] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax10");
  needed_g_p[x_a][16] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][17] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax5");
  needed_g_p[x_a][18] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax12");
  needed_g_p[x_a][19] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax13");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(2);
  needed_g_t[x_a].resize(2);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][1] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");

  g_d[x_a].resize(20);
  needed_g_d[x_a].resize(20);
  needed_g_d[x_a][0] = {   0,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][1] = {   0,    3,   10,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][3] = {   1,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__64_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__64_44");
  needed_g_d[x_a][4] = {   1,    2,   11,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   2,    5,    7,    8}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][7] = {   3,    4,    6,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][9] = {   4,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][10] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   5,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][12] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][13] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][14] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][15] = {   8,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][16] = {   9}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][17] = {   9,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][18] = {  10}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][19] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");

  c_p[x_a].resize(14);
  c_f[x_a].resize(14);
  c_t[x_a].resize(14);
  c_d[x_a].resize(14);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   3,   4}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  3,   4,   2}; //   3

  c_p[x_a][2] = {  0,   3,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  5,   6,   4,   2}; //   4

  c_p[x_a][3] = {  0,   1,   6}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  7,   8,   1,   2}; //   4

  c_p[x_a][4] = {  0,   7,   8}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  7,   9,  10,   2}; //   4

  c_p[x_a][5] = {  0,   7,   9}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,  11,  10,   2}; //   4

  c_p[x_a][6] = { 10,  11,   8}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  7,   9,  12,  13}; //   4

  c_p[x_a][7] = { 10,  11,   9}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,  11,  12,  13}; //   4

  c_p[x_a][8] = { 12,  13,  14}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  5,  14,   2,  15}; //   4

  c_p[x_a][9] = { 15,  16,  17}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  7,  16,   2,  17}; //   4

  c_p[x_a][10] = {  0,   1,  18}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 18,  15,   1,   2}; //   4

  c_p[x_a][11] = {  0,   3,  19}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 19,  17,   4,   2}; //   4

  c_p[x_a][12] = {  0,   1,   2}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  1}; //   1
  c_d[x_a][12] = {  0,   1,   2}; //   3

  c_p[x_a][13] = {  0,   3,   4}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  1}; //   1
  c_d[x_a][13] = {  3,   4,   2}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_ddx_emvexacsx
//  channel    0: 4yyv1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel    1: 4yyv1(1, 2, 64, 32, 4, 8, 16;  24,   0,   0,   0)
//  channel    2: 5yyyv(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
//  channel    3: 5yyyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
//  channel    4: 5yyyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel    5: 5yyyv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
//  channel    6: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel    7: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
//  channel    8: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,  24,   0,   0)
//  channel    9: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
//  channel   10: 52vyv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   11: 52vyv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
//  channel   12: 14yyv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   13: 14yyv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
