#include "header.hpp"

#include "ppenexa03.phasespace.set.hpp"

void ppenexa03_phasespace_set::ax_psp_230_dux_emvexaddx(int x_a){
  static Logger logger("ppenexa03_phasespace_set::ax_psp_230_dux_emvexaddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(16);
  needed_v_smin[x_a].resize(16);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    7,    9,   10,   11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   22,   23,   25,   26,   27}; //  24
  needed_v_smin[x_a][  1] = {   0,    1,    6,   15,    5,   19}; //   6
  needed_v_smin[x_a][  2] = {   1,    0,    5}; //   3
  needed_v_smin[x_a][  3] = {   2,    7,   16,   21,   20}; //   5
  needed_v_smin[x_a][  4] = {   2,    3,    7,    8}; //   4
  needed_v_smin[x_a][  5] = {   3,    8,   17,   24}; //   4
  needed_v_smin[x_a][  6] = {   3,    8,   17,   24}; //   4
  needed_v_smin[x_a][  7] = {   4,   14,   23,   27,   10}; //   5
  needed_v_smin[x_a][  8] = {   4,   10,   27}; //   3
  needed_v_smin[x_a][  9] = {  11,   12,   16,   17,   18,   20,   21,   24,   25,   26,    9}; //  11
  needed_v_smin[x_a][ 10] = {  13,   15,   19,   22}; //   4
  needed_v_smin[x_a][ 11] = {  13,   22}; //   2
  needed_v_smin[x_a][ 12] = {  14,   23}; //   2
  needed_v_smin[x_a][ 13] = {   6}; //   1
  needed_v_smin[x_a][ 14] = {   9,   11,   12,   25,   26}; //   5
  needed_v_smin[x_a][ 15] = {  18}; //   1

  v_smax[x_a].resize(22);
  needed_v_smax[x_a].resize(22);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    5,    6,    7,    9,   10,   12,   15,   16,   19,   20,   22,   23,   26,   27}; //  17
  needed_v_smax[x_a][  1] = {   0,    1,    6,   15,    5}; //   5
  needed_v_smax[x_a][  2] = {   1,    2,    3,    4,    0,    5,    7,    8,   10,   27}; //  10
  needed_v_smax[x_a][  3] = {   2,    3,    7,    8,   16,   17}; //   6
  needed_v_smax[x_a][  4] = {   3,    8,   17}; //   3
  needed_v_smax[x_a][  5] = {   4,   14}; //   2
  needed_v_smax[x_a][  6] = {   4}; //   1
  needed_v_smax[x_a][  7] = {  11,   18,   21,   24,   25}; //   5
  needed_v_smax[x_a][  8] = {  11,   18,   21,   25}; //   4
  needed_v_smax[x_a][  9] = {  12,   20,   26,    9}; //   4
  needed_v_smax[x_a][ 10] = {  13}; //   1
  needed_v_smax[x_a][ 11] = {  13,   14}; //   2
  needed_v_smax[x_a][ 12] = {  13,   14}; //   2
  needed_v_smax[x_a][ 13] = {  15}; //   1
  needed_v_smax[x_a][ 14] = {  16,   17}; //   2
  needed_v_smax[x_a][ 15] = {  19,   22}; //   2
  needed_v_smax[x_a][ 16] = {  21,   24,   20}; //   3
  needed_v_smax[x_a][ 17] = {  22,   23,   18}; //   3
  needed_v_smax[x_a][ 18] = {  23,   27,   10}; //   3
  needed_v_smax[x_a][ 19] = {  24}; //   1
  needed_v_smax[x_a][ 20] = {   6,    9,   11,   12,   25,   26}; //   6
  needed_v_smax[x_a][ 21] = {  19}; //   1

  g_p[x_a].resize(26);
  needed_g_p[x_a].resize(26);
  needed_g_p[x_a][0] = {   0,    1,    2,    5,    6,    7,    9,   10,   12,   15,   16,   19,   20,   22,   23,   26,   27}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    6,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   2,    7,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][5] = {   3,    8,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   3,    8,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax3");
  needed_g_p[x_a][7] = {   4,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax6");
  needed_g_p[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][10] = {  11,   18,   21,   24,   25}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][11] = {  11,   18,   21,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax8");
  needed_g_p[x_a][12] = {  12,   20,   26}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax9");
  needed_g_p[x_a][13] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax10");
  needed_g_p[x_a][14] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax11");
  needed_g_p[x_a][15] = {  13,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax12");
  needed_g_p[x_a][16] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax11");
  needed_g_p[x_a][17] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax13");
  needed_g_p[x_a][18] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax14");
  needed_g_p[x_a][19] = {  19,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax15");
  needed_g_p[x_a][20] = {  21}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax16");
  needed_g_p[x_a][21] = {  22}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax17");
  needed_g_p[x_a][22] = {  23,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax18");
  needed_g_p[x_a][23] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax17");
  needed_g_p[x_a][24] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax19");
  needed_g_p[x_a][25] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax16");

  g_f[x_a].resize(11);
  needed_g_f[x_a].resize(11);
  needed_g_f[x_a][0] = {   0,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][2] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax20");
  needed_g_f[x_a][3] = {   7,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");
  needed_g_f[x_a][4] = {   9}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax9");
  needed_g_f[x_a][5] = {   9,   11,   12,   25,   26}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax20");
  needed_g_f[x_a][6] = {  10}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax18");
  needed_g_f[x_a][7] = {  10,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax2");
  needed_g_f[x_a][8] = {  18}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax17");
  needed_g_f[x_a][9] = {  19}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax21");
  needed_g_f[x_a][10] = {  20}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax16");

  g_t[x_a].resize(22);
  needed_g_t[x_a].resize(22);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    7,    8,   10,   27}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][1] = {   0,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][2] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][3] = {   6,    9,   25,   26}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][4] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__32_76");
  needed_g_t[x_a][5] = {   7,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__64_28");
  needed_g_t[x_a][6] = {   9,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][7] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][8] = {  10,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][9] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][10] = {  11,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][11] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][12] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][13] = {  13,   14,   18}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][14] = {  15,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][15] = {  16,   17,   20}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][16] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__96_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__96_16");
  needed_g_t[x_a][17] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][18] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][19] = {  21,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__96_28");
  needed_g_t[x_a][20] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][21] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");

  g_d[x_a].resize(13);
  needed_g_d[x_a].resize(13);
  needed_g_d[x_a][0] = {   0,    1,    6,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    4,    5,    6,    7,    9,   10,   11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   22,   23,   25,   26,   27}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][4] = {   2,    7,   16,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   3,    8,   17,   24}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][6] = {   3,    8,   17,   24}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][8] = {   4,   14,   23,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][9] = {  11,   12,   16,   17,   18,   20,   21,   24,   25,   26}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][10] = {  13,   22}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][11] = {  13,   15,   19,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][12] = {  14,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");

  c_p[x_a].resize(28);
  c_f[x_a].resize(28);
  c_t[x_a].resize(28);
  c_d[x_a].resize(28);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   1,   2}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  2,   0,   1}; //   3

  c_p[x_a][2] = {  0,   3,   4}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   1}; //   3

  c_p[x_a][3] = {  5,   6,   4}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  3,   5,   6}; //   3

  c_p[x_a][4] = {  7,   8,   9}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  7,   1,   8}; //   3

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  1,   0}; //   2
  c_t[x_a][5] = {  0,   1,   2}; //   3
  c_d[x_a][5] = {  1}; //   1

  c_p[x_a][6] = {  0,   1}; //   2
  c_f[x_a][6] = {  2}; //   1
  c_t[x_a][6] = {  3,   4}; //   2
  c_d[x_a][6] = {  0,   1}; //   2

  c_p[x_a][7] = {  0,   3}; //   2
  c_f[x_a][7] = {  3}; //   1
  c_t[x_a][7] = {  0,   5}; //   2
  c_d[x_a][7] = {  4,   1}; //   2

  c_p[x_a][8] = {  5,   6}; //   2
  c_f[x_a][8] = {  3}; //   1
  c_t[x_a][8] = {  0,   5}; //   2
  c_d[x_a][8] = {  5,   6}; //   2

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  4,   5}; //   2
  c_t[x_a][9] = {  3,   6,   7}; //   3
  c_d[x_a][9] = {  1}; //   1

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  6,   7}; //   2
  c_t[x_a][10] = {  0,   8,   9}; //   3
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = { 10,  11}; //   2
  c_f[x_a][11] = {  5}; //   1
  c_t[x_a][11] = { 10,  11}; //   2
  c_d[x_a][11] = {  1,   9}; //   2

  c_p[x_a][12] = {  0,  12}; //   2
  c_f[x_a][12] = {  5}; //   1
  c_t[x_a][12] = { 10,  12}; //   2
  c_d[x_a][12] = {  9,   1}; //   2

  c_p[x_a][13] = { 13,  14,  15}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 13}; //   1
  c_d[x_a][13] = {  1,  10,  11}; //   3

  c_p[x_a][14] = {  7,  16,  15}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 13}; //   1
  c_d[x_a][14] = {  1,  12,   8}; //   3

  c_p[x_a][15] = {  0,   1,  17}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 14}; //   1
  c_d[x_a][15] = { 11,   0,   1}; //   3

  c_p[x_a][16] = {  0,   3,  18}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 15}; //   1
  c_d[x_a][16] = {  9,   4,   1}; //   3

  c_p[x_a][17] = {  5,   6,  18}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 15}; //   1
  c_d[x_a][17] = {  9,   5,   6}; //   3

  c_p[x_a][18] = { 10,  11}; //   2
  c_f[x_a][18] = {  8}; //   1
  c_t[x_a][18] = { 13,  16}; //   2
  c_d[x_a][18] = {  1,   9}; //   2

  c_p[x_a][19] = {  0,  19}; //   2
  c_f[x_a][19] = {  9}; //   1
  c_t[x_a][19] = { 14,  17}; //   2
  c_d[x_a][19] = { 11,   1}; //   2

  c_p[x_a][20] = {  0,  12}; //   2
  c_f[x_a][20] = { 10}; //   1
  c_t[x_a][20] = { 15,  18}; //   2
  c_d[x_a][20] = {  9,   1}; //   2

  c_p[x_a][21] = { 10,  11,  20}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 19}; //   1
  c_d[x_a][21] = {  4,   1,   9}; //   3

  c_p[x_a][22] = {  0,  19,  21}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 20}; //   1
  c_d[x_a][22] = { 10,  11,   1}; //   3

  c_p[x_a][23] = {  0,  22,  23}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 20}; //   1
  c_d[x_a][23] = { 12,   8,   1}; //   3

  c_p[x_a][24] = { 10,  24,  25}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = { 19}; //   1
  c_d[x_a][24] = {  5,   6,   9}; //   3

  c_p[x_a][25] = { 10,  11}; //   2
  c_f[x_a][25] = {  5}; //   1
  c_t[x_a][25] = {  3,  21}; //   2
  c_d[x_a][25] = {  1,   9}; //   2

  c_p[x_a][26] = {  0,  12}; //   2
  c_f[x_a][26] = {  5}; //   1
  c_t[x_a][26] = {  3,   6}; //   2
  c_d[x_a][26] = {  9,   1}; //   2

  c_p[x_a][27] = {  0,  22}; //   2
  c_f[x_a][27] = {  7}; //   1
  c_t[x_a][27] = {  0,   8}; //   2
  c_d[x_a][27] = {  8,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_dux_emvexaddx
//  channel    0: 13yv1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel    1: 14yyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
//  channel    2: 14yyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel    3: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel    4: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
//  channel    5: 112v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel    6: 113yv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel    7: 113yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel    8: 113yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel    9: 1112v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   10: 1112v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
//  channel   11: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,  24,   0,   0)
//  channel   12: 2v2v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel   13: 2v3yv(1, 2, 4, 8, 64, 16, 32;   0,   0,  24,   0)
//  channel   14: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,   0,  24,   0)
//  channel   15: 2v3yv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   16: 2v3yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel   17: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel   18: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
//  channel   19: 2v12v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   20: 2v12v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
//  channel   21: 3yv2v(1, 2, 16, 4, 8, 32, 64;   0,  24,  24,   0)
//  channel   22: 3yv2v(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
//  channel   23: 3yv2v(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
//  channel   24: 3yv2v(1, 2, 8, 4, 16, 32, 64;   0,   0,  24,   0)
//  channel   25: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,  24,   0,   0)
//  channel   26: 12v2v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   27: 12v2v(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
