#include "header.hpp"

#include "ppenexa03.phasespace.set.hpp"

void ppenexa03_phasespace_set::ax_psp_230_dux_emvexagg(int x_a){
  static Logger logger("ppenexa03_phasespace_set::ax_psp_230_dux_emvexagg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35,   36,   37,   38,   40,   41,   42,   44,   45}; //  38
  needed_v_smin[x_a][  1] = {   6,    7,   16,   17,   26,   27,   38,   42,   10,   12,   23,   25,   41}; //  13
  needed_v_smin[x_a][  2] = {   8,    9,   18,   19,   28,   29,   39,   43}; //   8
  needed_v_smin[x_a][  3] = {   8,    9,   18,   19,   28,   29,   39,   43}; //   8
  needed_v_smin[x_a][  4] = {  36,   37,   38,   39,   40,   41,   42,   43,   44,   45,    4,    5,   30,   31}; //  14
  needed_v_smin[x_a][  5] = {   0,    3,   32,   35}; //   4
  needed_v_smin[x_a][  6] = {   0,    3,   32,   35}; //   4
  needed_v_smin[x_a][  7] = {   1,    2,   33,   34}; //   4
  needed_v_smin[x_a][  8] = {   1,    2,   33,   34}; //   4
  needed_v_smin[x_a][  9] = {   4,    5,   30,   31,   36,   37,   44,   45}; //   8
  needed_v_smin[x_a][ 10] = {   6,    8,   10,   16,   18,   23,   27,   29}; //   8
  needed_v_smin[x_a][ 11] = {   7,    9,   12,   17,   19,   25,   26,   28}; //   8
  needed_v_smin[x_a][ 12] = {  11,   14,   21,   24}; //   4
  needed_v_smin[x_a][ 13] = {  11,   21}; //   2
  needed_v_smin[x_a][ 14] = {  13,   15,   20,   22}; //   4
  needed_v_smin[x_a][ 15] = {  13,   20}; //   2
  needed_v_smin[x_a][ 16] = {  14,   24}; //   2
  needed_v_smin[x_a][ 17] = {  15,   22}; //   2
  needed_v_smin[x_a][ 18] = {  40}; //   1

  v_smax[x_a].resize(17);
  needed_v_smax[x_a].resize(17);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35,   37,   38,   41,   45}; //  34
  needed_v_smax[x_a][  1] = {   6,    7,    8,    9,   16,   17,   18,   19,   26,   27,   28,   29,   38,   39,   10,   12,   23,   25}; //  18
  needed_v_smax[x_a][  2] = {   8,    9,   18,   19,   28,   29,   39}; //   7
  needed_v_smax[x_a][  3] = {  36,   40,   42,   43,   44}; //   5
  needed_v_smax[x_a][  4] = {  36,   40,   42,   44}; //   4
  needed_v_smax[x_a][  5] = {  37,   41,   45,    4,    5,   30,   31}; //   7
  needed_v_smax[x_a][  6] = {  38,   39}; //   2
  needed_v_smax[x_a][  7] = {  42,   43,   41}; //   3
  needed_v_smax[x_a][  8] = {  43}; //   1
  needed_v_smax[x_a][  9] = {   0,    3,   32,   35}; //   4
  needed_v_smax[x_a][ 10] = {   0,    3,    6,    8,   10,   11,   16,   18,   21,   23,   27,   29,   32,   35}; //  14
  needed_v_smax[x_a][ 11] = {   1,    2,   33,   34}; //   4
  needed_v_smax[x_a][ 12] = {   1,    2,    7,    9,   12,   13,   17,   19,   20,   25,   26,   28,   33,   34}; //  14
  needed_v_smax[x_a][ 13] = {   4,    5,   14,   15,   22,   24,   30,   31,   36,   37,   44,   45}; //  12
  needed_v_smax[x_a][ 14] = {  11,   14,   21,   24}; //   4
  needed_v_smax[x_a][ 15] = {  13,   15,   20,   22}; //   4
  needed_v_smax[x_a][ 16] = {  40}; //   1

  g_p[x_a].resize(11);
  needed_g_p[x_a].resize(11);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35,   37,   38,   41,   45}; //  34
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   6,    7,   16,   17,   26,   27,   38}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][2] = {   8,    9,   18,   19,   28,   29,   39}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   8,    9,   18,   19,   28,   29,   39}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax1");
  needed_g_p[x_a][4] = {  36,   40,   42,   43,   44}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][5] = {  36,   40,   42,   44}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax4");
  needed_g_p[x_a][6] = {  37,   41,   45}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax5");
  needed_g_p[x_a][7] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax6");
  needed_g_p[x_a][8] = {  42}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax7");
  needed_g_p[x_a][9] = {  43}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax8");
  needed_g_p[x_a][10] = {  43}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax7");

  g_f[x_a].resize(17);
  needed_g_f[x_a].resize(17);
  needed_g_f[x_a][0] = {   0,    3,   32,   35}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax9");
  needed_g_f[x_a][1] = {   0,    3,   32,   35}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax10");
  needed_g_f[x_a][2] = {   1,    2,   33,   34}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax11");
  needed_g_f[x_a][3] = {   1,    2,   33,   34}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax12");
  needed_g_f[x_a][4] = {   4,    5,   30,   31}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax5");
  needed_g_f[x_a][5] = {   4,    5,   30,   31,   36,   37,   44,   45}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax13");
  needed_g_f[x_a][6] = {   6,    8,   10,   16,   18,   23,   27,   29}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax10");
  needed_g_f[x_a][7] = {   7,    9,   12,   17,   19,   25,   26,   28}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax12");
  needed_g_f[x_a][8] = {  10,   12,   23,   25}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][9] = {  11,   14,   21,   24}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax14");
  needed_g_f[x_a][10] = {  11,   21}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax10");
  needed_g_f[x_a][11] = {  13,   15,   20,   22}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax15");
  needed_g_f[x_a][12] = {  13,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax12");
  needed_g_f[x_a][13] = {  14,   24}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax13");
  needed_g_f[x_a][14] = {  15,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax13");
  needed_g_f[x_a][15] = {  40}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax16");
  needed_g_f[x_a][16] = {  41}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax7");

  g_t[x_a].resize(53);
  needed_g_t[x_a].resize(53);
  needed_g_t[x_a][0] = {   0,    3,    6,    8}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   1,    2,    7,    9}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][4] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_80");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_13__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_13__64_16");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_13__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_13__16_64");
  needed_g_t[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__16_32");
  needed_g_t[x_a][8] = {   4,    5,   36,   37}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][9] = {   4,    5,   36}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__32_64");
  needed_g_t[x_a][12] = {   6,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__32_28");
  needed_g_t[x_a][13] = {   7,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__64_28");
  needed_g_t[x_a][14] = {  10,   11,   16,   18,   21,   23,   27,   29,   32,   35}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][15] = {  10,   16,   18,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][16] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_65__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_65__16_12");
  needed_g_t[x_a][17] = {  11,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][18] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_65__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_65__32_12");
  needed_g_t[x_a][19] = {  12,   13,   17,   19,   20,   25,   26,   28,   33,   34}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][20] = {  12,   17,   19,   25}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__64_28");
  needed_g_t[x_a][21] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_33__16_12");
  needed_g_t[x_a][22] = {  13,   20}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][23] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_33__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_33__64_12");
  needed_g_t[x_a][24] = {  14,   15,   22,   24,   30,   31,   44,   45}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][25] = {  14,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][26] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][27] = {  15,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_76");
  needed_g_t[x_a][28] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_17__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_17__64_12");
  needed_g_t[x_a][29] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][30] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][31] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__64_12");
  needed_g_t[x_a][32] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][33] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_66__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_66__32_12");
  needed_g_t[x_a][34] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_66__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_66__16_12");
  needed_g_t[x_a][35] = {  26,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__64_28");
  needed_g_t[x_a][36] = {  27,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__32_28");
  needed_g_t[x_a][37] = {  30,   31,   45}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][38] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][39] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__64_32");
  needed_g_t[x_a][40] = {  32,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][41] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__16_32");
  needed_g_t[x_a][42] = {  33,   34}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][43] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__16_64");
  needed_g_t[x_a][44] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][45] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__32_16");
  needed_g_t[x_a][46] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][47] = {  38,   39,   41}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][48] = {  40}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][49] = {  40}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__96_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__96_16");
  needed_g_t[x_a][50] = {  41}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][51] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__96_28");
  needed_g_t[x_a][52] = {  44}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");

  g_d[x_a].resize(5);
  needed_g_d[x_a].resize(5);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35,   36,   37,   38,   40,   41,   42,   44,   45}; //  38
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   6,    7,   16,   17,   26,   27,   38,   42}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][2] = {   8,    9,   18,   19,   28,   29,   39,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][3] = {   8,    9,   18,   19,   28,   29,   39,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][4] = {  36,   37,   38,   39,   40,   41,   42,   43,   44,   45}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");

  c_p[x_a].resize(46);
  c_f[x_a].resize(46);
  c_t[x_a].resize(46);
  c_d[x_a].resize(46);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  3,   4,   6}; //   3
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  0,   1}; //   2
  c_t[x_a][3] = {  0,   1,   7}; //   3
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  4,   5}; //   2
  c_t[x_a][4] = {  8,   9,  10}; //   3
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  4,   5}; //   2
  c_t[x_a][5] = {  8,   9,  11}; //   3
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0,   1}; //   2
  c_f[x_a][6] = {  6}; //   1
  c_t[x_a][6] = {  0,  12}; //   2
  c_d[x_a][6] = {  1,   0}; //   2

  c_p[x_a][7] = {  0,   1}; //   2
  c_f[x_a][7] = {  7}; //   1
  c_t[x_a][7] = {  3,  13}; //   2
  c_d[x_a][7] = {  1,   0}; //   2

  c_p[x_a][8] = {  2,   3}; //   2
  c_f[x_a][8] = {  6}; //   1
  c_t[x_a][8] = {  0,  12}; //   2
  c_d[x_a][8] = {  2,   3}; //   2

  c_p[x_a][9] = {  2,   3}; //   2
  c_f[x_a][9] = {  7}; //   1
  c_t[x_a][9] = {  3,  13}; //   2
  c_d[x_a][9] = {  2,   3}; //   2

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  8,   6}; //   2
  c_t[x_a][10] = { 14,  15,  16}; //   3
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  0}; //   1
  c_f[x_a][11] = {  9,  10}; //   2
  c_t[x_a][11] = { 14,  17,  18}; //   3
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  8,   7}; //   2
  c_t[x_a][12] = { 19,  20,  21}; //   3
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = { 11,  12}; //   2
  c_t[x_a][13] = { 19,  22,  23}; //   3
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  0}; //   1
  c_f[x_a][14] = {  9,  13}; //   2
  c_t[x_a][14] = { 24,  25,  26}; //   3
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  0}; //   1
  c_f[x_a][15] = { 11,  14}; //   2
  c_t[x_a][15] = { 24,  27,  28}; //   3
  c_d[x_a][15] = {  0}; //   1

  c_p[x_a][16] = {  0,   1}; //   2
  c_f[x_a][16] = {  6}; //   1
  c_t[x_a][16] = { 14,  15}; //   2
  c_d[x_a][16] = {  1,   0}; //   2

  c_p[x_a][17] = {  0,   1}; //   2
  c_f[x_a][17] = {  7}; //   1
  c_t[x_a][17] = { 19,  20}; //   2
  c_d[x_a][17] = {  1,   0}; //   2

  c_p[x_a][18] = {  2,   3}; //   2
  c_f[x_a][18] = {  6}; //   1
  c_t[x_a][18] = { 14,  15}; //   2
  c_d[x_a][18] = {  2,   3}; //   2

  c_p[x_a][19] = {  2,   3}; //   2
  c_f[x_a][19] = {  7}; //   1
  c_t[x_a][19] = { 19,  20}; //   2
  c_d[x_a][19] = {  2,   3}; //   2

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = { 11,  12}; //   2
  c_t[x_a][20] = { 19,  22,  29}; //   3
  c_d[x_a][20] = {  0}; //   1

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = {  9,  10}; //   2
  c_t[x_a][21] = { 14,  17,  30}; //   3
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  0}; //   1
  c_f[x_a][22] = { 11,  14}; //   2
  c_t[x_a][22] = { 24,  27,  31}; //   3
  c_d[x_a][22] = {  0}; //   1

  c_p[x_a][23] = {  0}; //   1
  c_f[x_a][23] = {  8,   6}; //   2
  c_t[x_a][23] = { 14,  15,  32}; //   3
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = {  9,  13}; //   2
  c_t[x_a][24] = { 24,  25,  33}; //   3
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  0}; //   1
  c_f[x_a][25] = {  8,   7}; //   2
  c_t[x_a][25] = { 19,  20,  34}; //   3
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  0,   1}; //   2
  c_f[x_a][26] = {  7}; //   1
  c_t[x_a][26] = { 19,  35}; //   2
  c_d[x_a][26] = {  1,   0}; //   2

  c_p[x_a][27] = {  0,   1}; //   2
  c_f[x_a][27] = {  6}; //   1
  c_t[x_a][27] = { 14,  36}; //   2
  c_d[x_a][27] = {  1,   0}; //   2

  c_p[x_a][28] = {  2,   3}; //   2
  c_f[x_a][28] = {  7}; //   1
  c_t[x_a][28] = { 19,  35}; //   2
  c_d[x_a][28] = {  2,   3}; //   2

  c_p[x_a][29] = {  2,   3}; //   2
  c_f[x_a][29] = {  6}; //   1
  c_t[x_a][29] = { 14,  36}; //   2
  c_d[x_a][29] = {  2,   3}; //   2

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = {  4,   5}; //   2
  c_t[x_a][30] = { 24,  37,  38}; //   3
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  0}; //   1
  c_f[x_a][31] = {  4,   5}; //   2
  c_t[x_a][31] = { 24,  37,  39}; //   3
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  0}; //   1
  c_f[x_a][32] = {  0,   1}; //   2
  c_t[x_a][32] = { 14,  40,  41}; //   3
  c_d[x_a][32] = {  0}; //   1

  c_p[x_a][33] = {  0}; //   1
  c_f[x_a][33] = {  2,   3}; //   2
  c_t[x_a][33] = { 19,  42,  43}; //   3
  c_d[x_a][33] = {  0}; //   1

  c_p[x_a][34] = {  0}; //   1
  c_f[x_a][34] = {  2,   3}; //   2
  c_t[x_a][34] = { 19,  42,  44}; //   3
  c_d[x_a][34] = {  0}; //   1

  c_p[x_a][35] = {  0}; //   1
  c_f[x_a][35] = {  0,   1}; //   2
  c_t[x_a][35] = { 14,  40,  45}; //   3
  c_d[x_a][35] = {  0}; //   1

  c_p[x_a][36] = {  4,   5}; //   2
  c_f[x_a][36] = {  5}; //   1
  c_t[x_a][36] = {  8,   9}; //   2
  c_d[x_a][36] = {  0,   4}; //   2

  c_p[x_a][37] = {  0,   6}; //   2
  c_f[x_a][37] = {  5}; //   1
  c_t[x_a][37] = {  8,  46}; //   2
  c_d[x_a][37] = {  4,   0}; //   2

  c_p[x_a][38] = {  0,   1,   7}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 47}; //   1
  c_d[x_a][38] = {  4,   1,   0}; //   3

  c_p[x_a][39] = {  2,   3,   7}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 47}; //   1
  c_d[x_a][39] = {  4,   2,   3}; //   3

  c_p[x_a][40] = {  4,   5}; //   2
  c_f[x_a][40] = { 15}; //   1
  c_t[x_a][40] = { 48,  49}; //   2
  c_d[x_a][40] = {  0,   4}; //   2

  c_p[x_a][41] = {  0,   6}; //   2
  c_f[x_a][41] = { 16}; //   1
  c_t[x_a][41] = { 47,  50}; //   2
  c_d[x_a][41] = {  4,   0}; //   2

  c_p[x_a][42] = {  4,   5,   8}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 51}; //   1
  c_d[x_a][42] = {  1,   0,   4}; //   3

  c_p[x_a][43] = {  4,   9,  10}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 51}; //   1
  c_d[x_a][43] = {  2,   3,   4}; //   3

  c_p[x_a][44] = {  4,   5}; //   2
  c_f[x_a][44] = {  5}; //   1
  c_t[x_a][44] = { 24,  52}; //   2
  c_d[x_a][44] = {  0,   4}; //   2

  c_p[x_a][45] = {  0,   6}; //   2
  c_f[x_a][45] = {  5}; //   1
  c_t[x_a][45] = { 24,  37}; //   2
  c_d[x_a][45] = {  4,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_dux_emvexagg
//  channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;  24,   0,   0,   0)
//  channel    1: 2v111(1, 2, 4, 8, 16, 64, 32;  24,   0,   0,   0)
//  channel    2: 2v111(1, 2, 4, 8, 64, 16, 32;  24,   0,   0,   0)
//  channel    3: 2v111(1, 2, 4, 8, 32, 16, 64;  24,   0,   0,   0)
//  channel    4: 2v111(1, 2, 4, 8, 32, 64, 16;  24,   0,   0,   0)
//  channel    5: 2v111(1, 2, 4, 8, 64, 32, 16;  24,   0,   0,   0)
//  channel    6: 3yv11(1, 2, 16, 4, 8, 32, 64;  24,  24,   0,   0)
//  channel    7: 3yv11(1, 2, 16, 4, 8, 64, 32;  24,  24,   0,   0)
//  channel    8: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,  24,   0,   0)
//  channel    9: 3yv11(1, 2, 8, 4, 16, 64, 32;   0,  24,   0,   0)
//  channel   10: 12v11(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
//  channel   11: 12v11(1, 2, 64, 4, 8, 32, 16;  24,   0,   0,   0)
//  channel   12: 12v11(1, 2, 32, 4, 8, 16, 64;  24,   0,   0,   0)
//  channel   13: 12v11(1, 2, 32, 4, 8, 64, 16;  24,   0,   0,   0)
//  channel   14: 12v11(1, 2, 16, 4, 8, 32, 64;  24,   0,   0,   0)
//  channel   15: 12v11(1, 2, 16, 4, 8, 64, 32;  24,   0,   0,   0)
//  channel   16: 13yv1(1, 2, 64, 16, 4, 8, 32;  24,  24,   0,   0)
//  channel   17: 13yv1(1, 2, 32, 16, 4, 8, 64;  24,  24,   0,   0)
//  channel   18: 13yv1(1, 2, 64, 8, 4, 16, 32;   0,  24,   0,   0)
//  channel   19: 13yv1(1, 2, 32, 8, 4, 16, 64;   0,  24,   0,   0)
//  channel   20: 112v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel   21: 112v1(1, 2, 64, 32, 4, 8, 16;  24,   0,   0,   0)
//  channel   22: 112v1(1, 2, 16, 64, 4, 8, 32;  24,   0,   0,   0)
//  channel   23: 112v1(1, 2, 64, 16, 4, 8, 32;  24,   0,   0,   0)
//  channel   24: 112v1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
//  channel   25: 112v1(1, 2, 32, 16, 4, 8, 64;  24,   0,   0,   0)
//  channel   26: 113yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel   27: 113yv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
//  channel   28: 113yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel   29: 113yv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
//  channel   30: 1112v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   31: 1112v(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
//  channel   32: 1112v(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
//  channel   33: 1112v(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
//  channel   34: 1112v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
//  channel   35: 1112v(1, 2, 64, 32, 16, 4, 8;  24,   0,   0,   0)
//  channel   36: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,  24,   0,   0)
//  channel   37: 2v2v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel   38: 2v3yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel   39: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel   40: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
//  channel   41: 2v12v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
//  channel   42: 3yv2v(1, 2, 16, 4, 8, 32, 64;   0,  24,  24,   0)
//  channel   43: 3yv2v(1, 2, 8, 4, 16, 32, 64;   0,   0,  24,   0)
//  channel   44: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,  24,   0,   0)
//  channel   45: 12v2v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
