#include "header.hpp"

#include "ppexne02.phasespace.set.hpp"

void ppexne02_phasespace_set::ac_psp_220_bbx_epvedcx(int x_a, int channel){
  static Logger logger("ppexne02_phasespace_set::ac_psp_220_bbx_epvedcx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,  24,  12, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 2));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  60,  16,  44, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  44,  32,  12, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  12,   4,   8, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  60,  32,  28, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  28,  16,  12, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
