#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

void ppexnea03_phasespace_set::ax_psp_230_ddx_epveadux(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_230_ddx_epveadux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(18);
  needed_v_smin[x_a].resize(18);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   23,   24,   25,   26,   27}; //  24
  needed_v_smin[x_a][  1] = {   0,    3,   10,   12,   13,   15,   20,   25,   19,   26}; //  10
  needed_v_smin[x_a][  2] = {   0,   13,   20}; //   3
  needed_v_smin[x_a][  3] = {   1,    2,   11,   14}; //   4
  needed_v_smin[x_a][  4] = {   1,   14}; //   2
  needed_v_smin[x_a][  5] = {   2}; //   1
  needed_v_smin[x_a][  6] = {   3,   15,   12,   19}; //   4
  needed_v_smin[x_a][  7] = {   4,    5,   16,   21}; //   4
  needed_v_smin[x_a][  8] = {   4,    6,   16,   17,   21,   22}; //   6
  needed_v_smin[x_a][  9] = {   5,    7}; //   2
  needed_v_smin[x_a][ 10] = {   6,    7,   17,   22}; //   4
  needed_v_smin[x_a][ 11] = {   6,    7,   17,   22}; //   4
  needed_v_smin[x_a][ 12] = {   8,   10,   25,   26}; //   4
  needed_v_smin[x_a][ 13] = {   8}; //   1
  needed_v_smin[x_a][ 14] = {   9,   11,   18,   27,   24}; //   5
  needed_v_smin[x_a][ 15] = {   9,   18,   24,   27}; //   4
  needed_v_smin[x_a][ 16] = {  23}; //   1
  needed_v_smin[x_a][ 17] = {  23}; //   1

  v_smax[x_a].resize(18);
  needed_v_smax[x_a].resize(18);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   16,   19,   20,   21,   23,   24,   25,   26,   27}; //  21
  needed_v_smax[x_a][  1] = {   0,    3,   10,   12,   13,   15,   20,   25,   19}; //   9
  needed_v_smax[x_a][  2] = {   0,    1,   13,   14,   20,   23}; //   6
  needed_v_smax[x_a][  3] = {   1,    2,   11,   14}; //   4
  needed_v_smax[x_a][  4] = {   2,    5,    7,    8}; //   4
  needed_v_smax[x_a][  5] = {   3,    4,    6,    9,   15,   16,   17,   18,   12,   19,   21,   22,   24,   27}; //  14
  needed_v_smax[x_a][  6] = {   4,    5,    6,    7,   16,   17,   21,   22}; //   8
  needed_v_smax[x_a][  7] = {   6,    7,   17,   22}; //   4
  needed_v_smax[x_a][  8] = {   8}; //   1
  needed_v_smax[x_a][  9] = {   8}; //   1
  needed_v_smax[x_a][ 10] = {   9,   18}; //   2
  needed_v_smax[x_a][ 11] = {   9,   18}; //   2
  needed_v_smax[x_a][ 12] = {  10,   25}; //   2
  needed_v_smax[x_a][ 13] = {  11}; //   1
  needed_v_smax[x_a][ 14] = {  26}; //   1
  needed_v_smax[x_a][ 15] = {  27,   24}; //   2
  needed_v_smax[x_a][ 16] = {  23}; //   1
  needed_v_smax[x_a][ 17] = {  26}; //   1

  g_p[x_a].resize(22);
  needed_g_p[x_a].resize(22);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   16,   19,   20,   21,   23,   24,   25,   26,   27}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    3,   10,   12,   13,   15,   20,   25}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    2,   11,   14}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   3,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {   4,    5,   16,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax6");
  needed_g_p[x_a][8] = {   4,    6,   16,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax5");
  needed_g_p[x_a][9] = {   5,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax4");
  needed_g_p[x_a][10] = {   6,    7,   17,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][11] = {   6,    7,   17,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax6");
  needed_g_p[x_a][12] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax8");
  needed_g_p[x_a][13] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax9");
  needed_g_p[x_a][14] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax4");
  needed_g_p[x_a][15] = {   9,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax10");
  needed_g_p[x_a][16] = {   9,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][17] = {   9,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax5");
  needed_g_p[x_a][18] = {  10,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax12");
  needed_g_p[x_a][19] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax13");
  needed_g_p[x_a][20] = {  26}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax14");
  needed_g_p[x_a][21] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax15");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {  12,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax5");
  needed_g_f[x_a][1] = {  19}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][2] = {  20}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][3] = {  21,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][4] = {  23}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax16");
  needed_g_f[x_a][5] = {  23}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax2");
  needed_g_f[x_a][6] = {  24}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax15");
  needed_g_f[x_a][7] = {  24,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax5");
  needed_g_f[x_a][8] = {  26}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax17");

  g_t[x_a].resize(13);
  needed_g_t[x_a].resize(13);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][1] = {  12,   15,   16,   17,   18,   19,   21,   22,   24,   27}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][2] = {  12,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][3] = {  13,   14,   20,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][4] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][5] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__32_76");
  needed_g_t[x_a][6] = {  21,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__64_28");
  needed_g_t[x_a][7] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][8] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][9] = {  24,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][10] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][11] = {  25,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][12] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");

  g_d[x_a].resize(20);
  needed_g_d[x_a].resize(20);
  needed_g_d[x_a][0] = {   0,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][1] = {   0,    3,   10,   12,   13,   15,   20,   25}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   23,   24,   25,   26,   27}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][3] = {   1,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__64_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__64_44");
  needed_g_d[x_a][4] = {   1,    2,   11,   14}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   2,    5,    7,    8}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][7] = {   3,    4,    6,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][8] = {   3,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][9] = {   4,    6,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][10] = {   4,    5,   16,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   5,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][12] = {   6,    7,   17,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][13] = {   6,    7,   17,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][14] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][15] = {   8,   10,   25,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][16] = {   9,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][17] = {   9,   11,   18,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][18] = {  10}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][19] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");

  c_p[x_a].resize(28);
  c_f[x_a].resize(28);
  c_t[x_a].resize(28);
  c_d[x_a].resize(28);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   3,   4}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  3,   4,   2}; //   3

  c_p[x_a][2] = {  0,   3,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  5,   6,   4,   2}; //   4

  c_p[x_a][3] = {  0,   1,   6}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  7,   8,   1,   2}; //   4

  c_p[x_a][4] = {  0,   7,   8}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  7,   9,  10,   2}; //   4

  c_p[x_a][5] = {  0,   7,   9}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,  11,  10,   2}; //   4

  c_p[x_a][6] = { 10,  11,   8}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  7,   9,  12,  13}; //   4

  c_p[x_a][7] = { 10,  11,   9}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,  11,  12,  13}; //   4

  c_p[x_a][8] = { 12,  13,  14}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  5,  14,   2,  15}; //   4

  c_p[x_a][9] = { 15,  16,  17}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  7,  16,   2,  17}; //   4

  c_p[x_a][10] = {  0,   1,  18}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 18,  15,   1,   2}; //   4

  c_p[x_a][11] = {  0,   3,  19}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 19,  17,   4,   2}; //   4

  c_p[x_a][12] = {  0,   1}; //   2
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  1,   2}; //   2
  c_d[x_a][12] = {  1,   2}; //   2

  c_p[x_a][13] = {  0,   1,   2}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  3}; //   1
  c_d[x_a][13] = {  0,   1,   2}; //   3

  c_p[x_a][14] = {  0,   3,   4}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  3}; //   1
  c_d[x_a][14] = {  3,   4,   2}; //   3

  c_p[x_a][15] = {  0,   1,   6}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  1}; //   1
  c_d[x_a][15] = {  8,   1,   2}; //   3

  c_p[x_a][16] = {  0,   7,   8}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  1}; //   1
  c_d[x_a][16] = {  9,  10,   2}; //   3

  c_p[x_a][17] = { 10,  11,   8}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  1}; //   1
  c_d[x_a][17] = {  9,  12,  13}; //   3

  c_p[x_a][18] = { 15,  16,  17}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  1}; //   1
  c_d[x_a][18] = { 16,   2,  17}; //   3

  c_p[x_a][19] = {  0}; //   1
  c_f[x_a][19] = {  1,   0}; //   2
  c_t[x_a][19] = {  1,   2,   4}; //   3
  c_d[x_a][19] = {  2}; //   1

  c_p[x_a][20] = {  0,   1}; //   2
  c_f[x_a][20] = {  2}; //   1
  c_t[x_a][20] = {  3,   5}; //   2
  c_d[x_a][20] = {  1,   2}; //   2

  c_p[x_a][21] = {  0,   7}; //   2
  c_f[x_a][21] = {  3}; //   1
  c_t[x_a][21] = {  1,   6}; //   2
  c_d[x_a][21] = { 10,   2}; //   2

  c_p[x_a][22] = { 10,  11}; //   2
  c_f[x_a][22] = {  3}; //   1
  c_t[x_a][22] = {  1,   6}; //   2
  c_d[x_a][22] = { 12,  13}; //   2

  c_p[x_a][23] = {  0}; //   1
  c_f[x_a][23] = {  4,   5}; //   2
  c_t[x_a][23] = {  3,   7,   8}; //   3
  c_d[x_a][23] = {  2}; //   1

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = {  6,   7}; //   2
  c_t[x_a][24] = {  1,   9,  10}; //   3
  c_d[x_a][24] = {  2}; //   1

  c_p[x_a][25] = {  0,   1,  18}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = { 11}; //   1
  c_d[x_a][25] = { 15,   1,   2}; //   3

  c_p[x_a][26] = {  0,  20}; //   2
  c_f[x_a][26] = {  8}; //   1
  c_t[x_a][26] = { 11,  12}; //   2
  c_d[x_a][26] = { 15,   2}; //   2

  c_p[x_a][27] = {  0,  21}; //   2
  c_f[x_a][27] = {  7}; //   1
  c_t[x_a][27] = {  1,   9}; //   2
  c_d[x_a][27] = { 17,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_ddx_epveadux
//  channel    0: 4yyv1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel    1: 4yyv1(1, 2, 64, 32, 4, 8, 16;  24,   0,   0,   0)
//  channel    2: 5yyyv(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
//  channel    3: 5yyyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
//  channel    4: 5yyyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel    5: 5yyyv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
//  channel    6: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel    7: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
//  channel    8: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,  24,   0,   0)
//  channel    9: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
//  channel   10: 52vyv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   11: 52vyv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
//  channel   12: 13yv1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel   13: 14yyv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   14: 14yyv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
//  channel   15: 14yyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
//  channel   16: 14yyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel   17: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel   18: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
//  channel   19: 112v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel   20: 113yv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   21: 113yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel   22: 113yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel   23: 1112v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   24: 1112v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
//  channel   25: 2v3yv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   26: 2v12v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   27: 12v2v(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
