#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

void ppexnea03_phasespace_set::ax_psp_230_udx_epveaccx(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_230_udx_epveaccx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(11);
  needed_v_smin[x_a].resize(11);
  needed_v_smin[x_a][  0] = {   0,    1,    4,    5,    6,    7,    8,   11,   12,   13}; //  10
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,    4,    6,    7,    8,    9,   10,   12,   13}; //  12
  needed_v_smin[x_a][  2] = {   2,    9}; //   2
  needed_v_smin[x_a][  3] = {   2,    9}; //   2
  needed_v_smin[x_a][  4] = {   3,   10}; //   2
  needed_v_smin[x_a][  5] = {   3,   10}; //   2
  needed_v_smin[x_a][  6] = {   4,    8,    7}; //   3
  needed_v_smin[x_a][  7] = {   5,   11}; //   2
  needed_v_smin[x_a][  8] = {   5,   11}; //   2
  needed_v_smin[x_a][  9] = {   0,    1,   12,   13}; //   4
  needed_v_smin[x_a][ 10] = {   6}; //   1

  v_smax[x_a].resize(17);
  needed_v_smax[x_a].resize(17);
  needed_v_smax[x_a][  0] = {   0,    6,    8,   11,   12}; //   5
  needed_v_smax[x_a][  1] = {   0,    6,    8,   12}; //   4
  needed_v_smax[x_a][  2] = {   1,    4,    7,    9,   10,   13}; //   6
  needed_v_smax[x_a][  3] = {   1,    7,   13}; //   3
  needed_v_smax[x_a][  4] = {   2}; //   1
  needed_v_smax[x_a][  5] = {   2,    3}; //   2
  needed_v_smax[x_a][  6] = {   2,    3}; //   2
  needed_v_smax[x_a][  7] = {   3}; //   1
  needed_v_smax[x_a][  8] = {   4,    5}; //   2
  needed_v_smax[x_a][  9] = {   4,    5}; //   2
  needed_v_smax[x_a][ 10] = {   5}; //   1
  needed_v_smax[x_a][ 11] = {   8,   11,    7}; //   3
  needed_v_smax[x_a][ 12] = {   9}; //   1
  needed_v_smax[x_a][ 13] = {   9,   10,    6}; //   3
  needed_v_smax[x_a][ 14] = {  10}; //   1
  needed_v_smax[x_a][ 15] = {  11}; //   1
  needed_v_smax[x_a][ 16] = {   0,    1,   12,   13}; //   4

  g_p[x_a].resize(20);
  needed_g_p[x_a].resize(20);
  needed_g_p[x_a][0] = {   0,    6,    8,   11,   12}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    6,    8,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    4,    7,    9,   10,   13}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax2");
  needed_g_p[x_a][3] = {   1,    7,   13}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax3");
  needed_g_p[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax4");
  needed_g_p[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax5");
  needed_g_p[x_a][6] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax6");
  needed_g_p[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax7");
  needed_g_p[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax8");
  needed_g_p[x_a][10] = {   4,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax9");
  needed_g_p[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax10");
  needed_g_p[x_a][12] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax8");
  needed_g_p[x_a][13] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax11");
  needed_g_p[x_a][14] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax12");
  needed_g_p[x_a][15] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax13");
  needed_g_p[x_a][16] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax14");
  needed_g_p[x_a][17] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax13");
  needed_g_p[x_a][18] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax15");
  needed_g_p[x_a][19] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax11");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {   0,    1,   12,   13}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax16");
  needed_g_f[x_a][1] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax13");
  needed_g_f[x_a][2] = {   7}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax11");

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][3] = {   2,    3,    6}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][4] = {   4,    5,    7}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][5] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__96_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__96_16");
  needed_g_t[x_a][6] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][7] = {   8,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__96_28");
  needed_g_t[x_a][8] = {   9,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][9] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][10] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");
  needed_g_t[x_a][11] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");

  g_d[x_a].resize(9);
  needed_g_d[x_a].resize(9);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    6,    7,    8,    9,   10,   12,   13}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   0,    1,    4,    5,    6,    7,    8,   11,   12,   13}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][2] = {   2,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][3] = {   2,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][4] = {   3,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");
  needed_g_d[x_a][5] = {   3,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][6] = {   4,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][7] = {   5,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {   5,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");

  c_p[x_a].resize(14);
  c_f[x_a].resize(14);
  c_t[x_a].resize(14);
  c_d[x_a].resize(14);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  2,   3}; //   2
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   2}; //   2
  c_d[x_a][1] = {  1,   0}; //   2

  c_p[x_a][2] = {  4,   5,   6}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  3}; //   1
  c_d[x_a][2] = {  0,   2,   3}; //   3

  c_p[x_a][3] = {  7,   8,   6}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  3}; //   1
  c_d[x_a][3] = {  0,   4,   5}; //   3

  c_p[x_a][4] = {  2,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  4}; //   1
  c_d[x_a][4] = {  1,   6,   0}; //   3

  c_p[x_a][5] = { 11,  12,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  4}; //   1
  c_d[x_a][5] = {  1,   7,   8}; //   3

  c_p[x_a][6] = {  0,   1}; //   2
  c_f[x_a][6] = {  1}; //   1
  c_t[x_a][6] = {  3,   5}; //   2
  c_d[x_a][6] = {  0,   1}; //   2

  c_p[x_a][7] = {  2,   3}; //   2
  c_f[x_a][7] = {  2}; //   1
  c_t[x_a][7] = {  4,   6}; //   2
  c_d[x_a][7] = {  1,   0}; //   2

  c_p[x_a][8] = {  0,   1,  13}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  7}; //   1
  c_d[x_a][8] = {  6,   0,   1}; //   3

  c_p[x_a][9] = {  2,  14,  15}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  8}; //   1
  c_d[x_a][9] = {  2,   3,   0}; //   3

  c_p[x_a][10] = {  2,  16,  17}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  8}; //   1
  c_d[x_a][10] = {  4,   5,   0}; //   3

  c_p[x_a][11] = {  0,  18,  19}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  7}; //   1
  c_d[x_a][11] = {  7,   8,   1}; //   3

  c_p[x_a][12] = {  0,   1}; //   2
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  9,  10}; //   2
  c_d[x_a][12] = {  0,   1}; //   2

  c_p[x_a][13] = {  2,   3}; //   2
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  9,  11}; //   2
  c_d[x_a][13] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_udx_epveaccx
//  channel    0: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,  24,   0,   0)
//  channel    1: 2v2v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel    2: 2v3yv(1, 2, 4, 8, 64, 16, 32;   0,   0,  24,   0)
//  channel    3: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,   0,  24,   0)
//  channel    4: 2v3yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel    5: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel    6: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
//  channel    7: 2v12v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
//  channel    8: 3yv2v(1, 2, 16, 4, 8, 32, 64;   0,  24,  24,   0)
//  channel    9: 3yv2v(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
//  channel   10: 3yv2v(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
//  channel   11: 3yv2v(1, 2, 8, 4, 16, 32, 64;   0,   0,  24,   0)
//  channel   12: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,  24,   0,   0)
//  channel   13: 12v2v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
