#include "header.hpp"

#include "ppnenexa03.phasespace.set.hpp"

void ppnenexa03_phasespace_set::ax_psp_230_uu_vevexauu(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_230_uu_vevexauu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(15);
  needed_v_smin[x_a].resize(15);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  40
  needed_v_smin[x_a][  1] = {   4,    6,   12,   14,   17,   22,   30,   36,   11,   20,   34}; //  11
  needed_v_smin[x_a][  2] = {   5,    7,   13,   15,   16,   23,   31,   37,   10,   21,   35}; //  11
  needed_v_smin[x_a][  3] = {   6,   17,   12,   20}; //   4
  needed_v_smin[x_a][  4] = {   7,   16,   13,   21}; //   4
  needed_v_smin[x_a][  5] = {   8,   18,   28,   30,   32,   34,   36,   38,    0,   27}; //  10
  needed_v_smin[x_a][  6] = {   8,   18,    0,   27,   28,   38}; //   6
  needed_v_smin[x_a][  7] = {   9,   19,   29,   31,   33,   35,   37,   39,    1,   26}; //  10
  needed_v_smin[x_a][  8] = {   9,   19,    1,   26,   29,   39}; //   6
  needed_v_smin[x_a][  9] = {   2,    3,   24,   25}; //   4
  needed_v_smin[x_a][ 10] = {   2,    3,   24,   25}; //   4
  needed_v_smin[x_a][ 11] = {   4,   11,   14,   22}; //   4
  needed_v_smin[x_a][ 12] = {   5,   10,   15,   23}; //   4
  needed_v_smin[x_a][ 13] = {  32}; //   1
  needed_v_smin[x_a][ 14] = {  33}; //   1

  v_smax[x_a].resize(18);
  needed_v_smax[x_a].resize(18);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   34,   35,   38,   39}; //  30
  needed_v_smax[x_a][  1] = {   4,    6,   12,   14,   17,   22,   30,   11,   20}; //   9
  needed_v_smax[x_a][  2] = {   5,    7,   13,   15,   16,   23,   31,   10,   21}; //   9
  needed_v_smax[x_a][  3] = {   6,    9,   17,   19,    1,   12,   20,   26,   29,   39}; //  10
  needed_v_smax[x_a][  4] = {   7,    8,   16,   18,    0,   13,   21,   27,   28,   38}; //  10
  needed_v_smax[x_a][  5] = {   8,   18,   28,   32,   36}; //   5
  needed_v_smax[x_a][  6] = {   8,   18,   28,   32,   36}; //   5
  needed_v_smax[x_a][  7] = {   9,   19,   29,   33,   37}; //   5
  needed_v_smax[x_a][  8] = {   9,   19,   29,   33,   37}; //   5
  needed_v_smax[x_a][  9] = {  30}; //   1
  needed_v_smax[x_a][ 10] = {  31}; //   1
  needed_v_smax[x_a][ 11] = {  34,   38,    0,   27}; //   4
  needed_v_smax[x_a][ 12] = {  35,   39,    1,   26}; //   4
  needed_v_smax[x_a][ 13] = {  36,   34}; //   2
  needed_v_smax[x_a][ 14] = {  37,   35}; //   2
  needed_v_smax[x_a][ 15] = {   2,    3,   24,   25}; //   4
  needed_v_smax[x_a][ 16] = {   2,    3,    4,    5,   10,   11,   14,   15,   22,   23,   24,   25}; //  12
  needed_v_smax[x_a][ 17] = {  32,   33}; //   2

  g_p[x_a].resize(17);
  needed_g_p[x_a].resize(17);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   34,   35,   38,   39}; //  30
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   4,    6,   12,   14,   17,   22,   30}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   5,    7,   13,   15,   16,   23,   31}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   6,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   7,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   8,   18,   28,   32,   36}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {   8,   18,   28,   32,   36}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][7] = {   8,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][8] = {   9,   19,   29,   33,   37}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax7");
  needed_g_p[x_a][9] = {   9,   19,   29,   33,   37}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax8");
  needed_g_p[x_a][10] = {   9,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax3");
  needed_g_p[x_a][11] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax9");
  needed_g_p[x_a][12] = {  31}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax10");
  needed_g_p[x_a][13] = {  34,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax11");
  needed_g_p[x_a][14] = {  35,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax12");
  needed_g_p[x_a][15] = {  36}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax13");
  needed_g_p[x_a][16] = {  37}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax14");

  g_f[x_a].resize(16);
  needed_g_f[x_a].resize(16);
  needed_g_f[x_a][0] = {   0,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax11");
  needed_g_f[x_a][1] = {   0,   27,   28,   38}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][2] = {   1,   26}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax12");
  needed_g_f[x_a][3] = {   1,   26,   29,   39}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax3");
  needed_g_f[x_a][4] = {   2,    3,   24,   25}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax15");
  needed_g_f[x_a][5] = {   2,    3,   24,   25}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax16");
  needed_g_f[x_a][6] = {   4,   11,   14,   22}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax16");
  needed_g_f[x_a][7] = {   5,   10,   15,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax16");
  needed_g_f[x_a][8] = {  10,   21}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][9] = {  11,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][10] = {  12,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][11] = {  13,   21}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][12] = {  32}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax17");
  needed_g_f[x_a][13] = {  33}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax17");
  needed_g_f[x_a][14] = {  34}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax13");
  needed_g_f[x_a][15] = {  35}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax14");

  g_t[x_a].resize(41);
  needed_g_t[x_a].resize(41);
  needed_g_t[x_a][0] = {   0,    7,    8,   28}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   1,    6,    9,   29}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][4] = {   1,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_80");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_13__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_13__64_16");
  needed_g_t[x_a][6] = {   2,    3,    4,    5}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][7] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][8] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__32_64");
  needed_g_t[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__32_76");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][12] = {  10,   11,   14,   15,   22,   23,   24,   25}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][13] = {  10,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][14] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][15] = {  11,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_76");
  needed_g_t[x_a][16] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_17__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_17__64_12");
  needed_g_t[x_a][17] = {  12,   17,   19,   20,   26,   39}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][18] = {  12,   20}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][19] = {  13,   16,   18,   21,   27,   38}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][20] = {  13,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][21] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][22] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][23] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__32_76");
  needed_g_t[x_a][24] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__64_44");
  needed_g_t[x_a][25] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][26] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][27] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__64_32");
  needed_g_t[x_a][28] = {  26,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][29] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][30] = {  27,   38}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][31] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__32_16");
  needed_g_t[x_a][32] = {  30,   34}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][33] = {  31,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__80_44");
  needed_g_t[x_a][34] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][35] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_64");
  needed_g_t[x_a][36] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__80_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__80_32");
  needed_g_t[x_a][37] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][38] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_81__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_81__12_32");
  needed_g_t[x_a][39] = {  36}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][40] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");

  g_d[x_a].resize(9);
  needed_g_d[x_a].resize(9);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,    6,   12,   14,   17,   22,   30,   36}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][2] = {   5,    7,   13,   15,   16,   23,   31,   37}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   6,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][4] = {   7,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][5] = {   8,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][6] = {   8,   18,   28,   30,   32,   34,   36,   38}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][7] = {   9,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][8] = {   9,   19,   29,   31,   33,   35,   37,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");

  c_p[x_a].resize(40);
  c_f[x_a].resize(40);
  c_t[x_a].resize(40);
  c_d[x_a].resize(40);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  6,   7,   8}; //   3
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  4,   5}; //   2
  c_t[x_a][3] = {  6,   7,   9}; //   3
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0,   1}; //   2
  c_f[x_a][4] = {  6}; //   1
  c_t[x_a][4] = {  6,  10}; //   2
  c_d[x_a][4] = {  1,   0}; //   2

  c_p[x_a][5] = {  0,   2}; //   2
  c_f[x_a][5] = {  7}; //   1
  c_t[x_a][5] = {  6,  11}; //   2
  c_d[x_a][5] = {  2,   0}; //   2

  c_p[x_a][6] = {  0,   1,   3}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  3}; //   1
  c_d[x_a][6] = {  3,   1,   0}; //   3

  c_p[x_a][7] = {  0,   2,   4}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  4,   2,   0}; //   3

  c_p[x_a][8] = {  5,   6,   7}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  5,   0,   6}; //   3

  c_p[x_a][9] = {  8,   9,  10}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  3}; //   1
  c_d[x_a][9] = {  7,   0,   8}; //   3

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  8,   7}; //   2
  c_t[x_a][10] = { 12,  13,  14}; //   3
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  0}; //   1
  c_f[x_a][11] = {  9,   6}; //   2
  c_t[x_a][11] = { 12,  15,  16}; //   3
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  0,   1}; //   2
  c_f[x_a][12] = { 10}; //   1
  c_t[x_a][12] = { 17,  18}; //   2
  c_d[x_a][12] = {  1,   0}; //   2

  c_p[x_a][13] = {  0,   2}; //   2
  c_f[x_a][13] = { 11}; //   1
  c_t[x_a][13] = { 19,  20}; //   2
  c_d[x_a][13] = {  2,   0}; //   2

  c_p[x_a][14] = {  0,   1}; //   2
  c_f[x_a][14] = {  6}; //   1
  c_t[x_a][14] = { 12,  15}; //   2
  c_d[x_a][14] = {  1,   0}; //   2

  c_p[x_a][15] = {  0,   2}; //   2
  c_f[x_a][15] = {  7}; //   1
  c_t[x_a][15] = { 12,  13}; //   2
  c_d[x_a][15] = {  2,   0}; //   2

  c_p[x_a][16] = {  0,   2,   4}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 19}; //   1
  c_d[x_a][16] = {  4,   2,   0}; //   3

  c_p[x_a][17] = {  0,   1,   3}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 17}; //   1
  c_d[x_a][17] = {  3,   1,   0}; //   3

  c_p[x_a][18] = {  5,   6,   7}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 19}; //   1
  c_d[x_a][18] = {  5,   0,   6}; //   3

  c_p[x_a][19] = {  8,   9,  10}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = { 17}; //   1
  c_d[x_a][19] = {  7,   0,   8}; //   3

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = {  9,  10}; //   2
  c_t[x_a][20] = { 17,  18,  21}; //   3
  c_d[x_a][20] = {  0}; //   1

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = {  8,  11}; //   2
  c_t[x_a][21] = { 19,  20,  22}; //   3
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  0,   1}; //   2
  c_f[x_a][22] = {  6}; //   1
  c_t[x_a][22] = { 12,  23}; //   2
  c_d[x_a][22] = {  1,   0}; //   2

  c_p[x_a][23] = {  0,   2}; //   2
  c_f[x_a][23] = {  7}; //   1
  c_t[x_a][23] = { 12,  24}; //   2
  c_d[x_a][23] = {  2,   0}; //   2

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = {  4,   5}; //   2
  c_t[x_a][24] = { 12,  25,  26}; //   3
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  0}; //   1
  c_f[x_a][25] = {  4,   5}; //   2
  c_t[x_a][25] = { 12,  25,  27}; //   3
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  0}; //   1
  c_f[x_a][26] = {  2,   3}; //   2
  c_t[x_a][26] = { 17,  28,  29}; //   3
  c_d[x_a][26] = {  0}; //   1

  c_p[x_a][27] = {  0}; //   1
  c_f[x_a][27] = {  0,   1}; //   2
  c_t[x_a][27] = { 19,  30,  31}; //   3
  c_d[x_a][27] = {  0}; //   1

  c_p[x_a][28] = {  5,   6}; //   2
  c_f[x_a][28] = {  1}; //   1
  c_t[x_a][28] = {  0,   1}; //   2
  c_d[x_a][28] = {  0,   6}; //   2

  c_p[x_a][29] = {  8,   9}; //   2
  c_f[x_a][29] = {  3}; //   1
  c_t[x_a][29] = {  3,   4}; //   2
  c_d[x_a][29] = {  0,   8}; //   2

  c_p[x_a][30] = {  0,   1,  11}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = { 32}; //   1
  c_d[x_a][30] = {  6,   1,   0}; //   3

  c_p[x_a][31] = {  0,   2,  12}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = { 33}; //   1
  c_d[x_a][31] = {  8,   2,   0}; //   3

  c_p[x_a][32] = {  5,   6}; //   2
  c_f[x_a][32] = { 12}; //   1
  c_t[x_a][32] = { 34,  35}; //   2
  c_d[x_a][32] = {  0,   6}; //   2

  c_p[x_a][33] = {  8,   9}; //   2
  c_f[x_a][33] = { 13}; //   1
  c_t[x_a][33] = { 34,  36}; //   2
  c_d[x_a][33] = {  0,   8}; //   2

  c_p[x_a][34] = {  0,  13}; //   2
  c_f[x_a][34] = { 14}; //   1
  c_t[x_a][34] = { 32,  37}; //   2
  c_d[x_a][34] = {  6,   0}; //   2

  c_p[x_a][35] = {  0,  14}; //   2
  c_f[x_a][35] = { 15}; //   1
  c_t[x_a][35] = { 33,  38}; //   2
  c_d[x_a][35] = {  8,   0}; //   2

  c_p[x_a][36] = {  5,   6,  15}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = { 39}; //   1
  c_d[x_a][36] = {  1,   0,   6}; //   3

  c_p[x_a][37] = {  8,   9,  16}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 40}; //   1
  c_d[x_a][37] = {  2,   0,   8}; //   3

  c_p[x_a][38] = {  0,  13}; //   2
  c_f[x_a][38] = {  1}; //   1
  c_t[x_a][38] = { 19,  30}; //   2
  c_d[x_a][38] = {  6,   0}; //   2

  c_p[x_a][39] = {  0,  14}; //   2
  c_f[x_a][39] = {  3}; //   1
  c_t[x_a][39] = { 17,  28}; //   2
  c_d[x_a][39] = {  8,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_uu_vevexauu
//  channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel    1: 2v111(1, 2, 4, 8, 16, 64, 32;  23,   0,   0,   0)
//  channel    2: 2v111(1, 2, 4, 8, 32, 64, 16;  23,   0,   0,   0)
//  channel    3: 2v111(1, 2, 4, 8, 64, 32, 16;  23,   0,   0,   0)
//  channel    4: 3yv11(1, 2, 64, 4, 8, 32, 16;  23,   0,   0,   0)
//  channel    5: 3yv11(1, 2, 32, 4, 8, 64, 16;  23,   0,   0,   0)
//  channel    6: 4yyv1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
//  channel    7: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
//  channel    8: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel    9: 42vv1(1, 2, 4, 8, 16, 64, 32;   0,  23,   0,   0)
//  channel   10: 12v11(1, 2, 16, 4, 8, 32, 64;  23,   0,   0,   0)
//  channel   11: 12v11(1, 2, 16, 4, 8, 64, 32;  23,   0,   0,   0)
//  channel   12: 13yv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   13: 13yv1(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
//  channel   14: 13yv1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
//  channel   15: 13yv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
//  channel   16: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel   17: 14yyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel   18: 142vv(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
//  channel   19: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   20: 112v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   21: 112v1(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
//  channel   22: 113yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   23: 113yv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   24: 1112v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   25: 1112v(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   26: 1112v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
//  channel   27: 1112v(1, 2, 64, 32, 16, 4, 8;  23,   0,   0,   0)
//  channel   28: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel   29: 2v2v1(1, 2, 4, 8, 16, 64, 32;   0,  23,   0,   0)
//  channel   30: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   31: 2v3yv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   32: 2v12v(1, 2, 4, 8, 64, 16, 32;   0,  23,   0,   0)
//  channel   33: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,  23,   0,   0)
//  channel   34: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   35: 2v12v(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   36: 3yv2v(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
//  channel   37: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   38: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel   39: 12v2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
