#include "header.hpp"

#include "ppnenexa03.phasespace.set.hpp"

void ppnenexa03_phasespace_set::ax_psp_230_uux_vevexagg(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_230_uux_vevexagg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(17);
  needed_v_smin[x_a].resize(17);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  30
  needed_v_smin[x_a][  1] = {  24,   25,   26,   27,   28,   29,    4,    5,   18,   19}; //  10
  needed_v_smin[x_a][  2] = {   0,    3,   20,   23}; //   4
  needed_v_smin[x_a][  3] = {   0,    3,   20,   23}; //   4
  needed_v_smin[x_a][  4] = {   1,    2,   21,   22}; //   4
  needed_v_smin[x_a][  5] = {   1,    2,   21,   22}; //   4
  needed_v_smin[x_a][  6] = {   4,    5,   18,   19,   24,   25,   28,   29}; //   8
  needed_v_smin[x_a][  7] = {   6,    8,   15,   17,   27}; //   5
  needed_v_smin[x_a][  8] = {   6,   15}; //   2
  needed_v_smin[x_a][  9] = {   7,   10,   13,   16}; //   4
  needed_v_smin[x_a][ 10] = {   7,   13}; //   2
  needed_v_smin[x_a][ 11] = {   8,   17}; //   2
  needed_v_smin[x_a][ 12] = {   9,   11,   12,   14}; //   4
  needed_v_smin[x_a][ 13] = {   9,   12}; //   2
  needed_v_smin[x_a][ 14] = {  10,   16}; //   2
  needed_v_smin[x_a][ 15] = {  11,   14}; //   2
  needed_v_smin[x_a][ 16] = {  26}; //   1

  v_smax[x_a].resize(14);
  needed_v_smax[x_a].resize(14);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   25,   27,   29}; //  27
  needed_v_smax[x_a][  1] = {  24,   26,   28}; //   3
  needed_v_smax[x_a][  2] = {  24,   26,   28}; //   3
  needed_v_smax[x_a][  3] = {  25,   27,   29,    4,    5,   18,   19}; //   7
  needed_v_smax[x_a][  4] = {   0,    3,   20,   23}; //   4
  needed_v_smax[x_a][  5] = {   0,    3,    6,    7,   13,   15,   20,   23}; //   8
  needed_v_smax[x_a][  6] = {   1,    2,   21,   22}; //   4
  needed_v_smax[x_a][  7] = {   1,    2,    8,    9,   12,   17,   21,   22}; //   8
  needed_v_smax[x_a][  8] = {   4,    5,   10,   11,   14,   16,   18,   19,   24,   25,   28,   29}; //  12
  needed_v_smax[x_a][  9] = {   6,    8,   15,   17}; //   4
  needed_v_smax[x_a][ 10] = {   7,   10,   13,   16}; //   4
  needed_v_smax[x_a][ 11] = {   9,   11,   12,   14}; //   4
  needed_v_smax[x_a][ 12] = {  26}; //   1
  needed_v_smax[x_a][ 13] = {  27}; //   1

  g_p[x_a].resize(4);
  needed_g_p[x_a].resize(4);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   25,   27,   29}; //  27
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {  24,   26,   28}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {  24,   26,   28}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax2");
  needed_g_p[x_a][3] = {  25,   27,   29}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax3");

  g_f[x_a].resize(17);
  needed_g_f[x_a].resize(17);
  needed_g_f[x_a][0] = {   0,    3,   20,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax4");
  needed_g_f[x_a][1] = {   0,    3,   20,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax5");
  needed_g_f[x_a][2] = {   1,    2,   21,   22}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax6");
  needed_g_f[x_a][3] = {   1,    2,   21,   22}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax7");
  needed_g_f[x_a][4] = {   4,    5,   18,   19}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax3");
  needed_g_f[x_a][5] = {   4,    5,   18,   19,   24,   25,   28,   29}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax8");
  needed_g_f[x_a][6] = {   6,    8,   15,   17}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax9");
  needed_g_f[x_a][7] = {   6,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][8] = {   7,   10,   13,   16}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax10");
  needed_g_f[x_a][9] = {   7,   13}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax5");
  needed_g_f[x_a][10] = {   8,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax7");
  needed_g_f[x_a][11] = {   9,   11,   12,   14}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax11");
  needed_g_f[x_a][12] = {   9,   12}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax7");
  needed_g_f[x_a][13] = {  10,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax8");
  needed_g_f[x_a][14] = {  11,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax8");
  needed_g_f[x_a][15] = {  26}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax12");
  needed_g_f[x_a][16] = {  27}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax13");

  g_t[x_a].resize(48);
  needed_g_t[x_a].resize(48);
  needed_g_t[x_a][0] = {   0,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][4] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_80");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_13__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_13__64_16");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_13__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_13__16_64");
  needed_g_t[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__16_32");
  needed_g_t[x_a][8] = {   4,    5,   24,   25}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][9] = {   4,    5,   24}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__32_64");
  needed_g_t[x_a][12] = {   6,    7,   13,   15,   20,   23}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][13] = {   6,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][14] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_65__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_65__16_12");
  needed_g_t[x_a][15] = {   7,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][16] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_65__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_65__32_12");
  needed_g_t[x_a][17] = {   8,    9,   12,   17,   21,   22}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][18] = {   8,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__64_28");
  needed_g_t[x_a][19] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_33__16_12");
  needed_g_t[x_a][20] = {   9,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][21] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_33__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_33__64_12");
  needed_g_t[x_a][22] = {  10,   11,   14,   16,   18,   19,   28,   29}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][23] = {  10,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][24] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][25] = {  11,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_76");
  needed_g_t[x_a][26] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_17__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_17__64_12");
  needed_g_t[x_a][27] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][28] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][29] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__64_12");
  needed_g_t[x_a][30] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][31] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_66__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_66__32_12");
  needed_g_t[x_a][32] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_66__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_66__16_12");
  needed_g_t[x_a][33] = {  18,   19,   29}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][34] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][35] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__64_32");
  needed_g_t[x_a][36] = {  20,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][37] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__16_32");
  needed_g_t[x_a][38] = {  21,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][39] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__16_64");
  needed_g_t[x_a][40] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][41] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__32_16");
  needed_g_t[x_a][42] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][43] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][44] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__96_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__96_16");
  needed_g_t[x_a][45] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][46] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][47] = {  28}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  24,   25,   26,   27,   28,   29}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");

  c_p[x_a].resize(30);
  c_f[x_a].resize(30);
  c_t[x_a].resize(30);
  c_d[x_a].resize(30);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  3,   4,   6}; //   3
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  0,   1}; //   2
  c_t[x_a][3] = {  0,   1,   7}; //   3
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  4,   5}; //   2
  c_t[x_a][4] = {  8,   9,  10}; //   3
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  4,   5}; //   2
  c_t[x_a][5] = {  8,   9,  11}; //   3
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  6,   7}; //   2
  c_t[x_a][6] = { 12,  13,  14}; //   3
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = {  8,   9}; //   2
  c_t[x_a][7] = { 12,  15,  16}; //   3
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  6,  10}; //   2
  c_t[x_a][8] = { 17,  18,  19}; //   3
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = { 11,  12}; //   2
  c_t[x_a][9] = { 17,  20,  21}; //   3
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  8,  13}; //   2
  c_t[x_a][10] = { 22,  23,  24}; //   3
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  0}; //   1
  c_f[x_a][11] = { 11,  14}; //   2
  c_t[x_a][11] = { 22,  25,  26}; //   3
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = { 11,  12}; //   2
  c_t[x_a][12] = { 17,  20,  27}; //   3
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {  8,   9}; //   2
  c_t[x_a][13] = { 12,  15,  28}; //   3
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  0}; //   1
  c_f[x_a][14] = { 11,  14}; //   2
  c_t[x_a][14] = { 22,  25,  29}; //   3
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  0}; //   1
  c_f[x_a][15] = {  6,   7}; //   2
  c_t[x_a][15] = { 12,  13,  30}; //   3
  c_d[x_a][15] = {  0}; //   1

  c_p[x_a][16] = {  0}; //   1
  c_f[x_a][16] = {  8,  13}; //   2
  c_t[x_a][16] = { 22,  23,  31}; //   3
  c_d[x_a][16] = {  0}; //   1

  c_p[x_a][17] = {  0}; //   1
  c_f[x_a][17] = {  6,  10}; //   2
  c_t[x_a][17] = { 17,  18,  32}; //   3
  c_d[x_a][17] = {  0}; //   1

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  4,   5}; //   2
  c_t[x_a][18] = { 22,  33,  34}; //   3
  c_d[x_a][18] = {  0}; //   1

  c_p[x_a][19] = {  0}; //   1
  c_f[x_a][19] = {  4,   5}; //   2
  c_t[x_a][19] = { 22,  33,  35}; //   3
  c_d[x_a][19] = {  0}; //   1

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = {  0,   1}; //   2
  c_t[x_a][20] = { 12,  36,  37}; //   3
  c_d[x_a][20] = {  0}; //   1

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = {  2,   3}; //   2
  c_t[x_a][21] = { 17,  38,  39}; //   3
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  0}; //   1
  c_f[x_a][22] = {  2,   3}; //   2
  c_t[x_a][22] = { 17,  38,  40}; //   3
  c_d[x_a][22] = {  0}; //   1

  c_p[x_a][23] = {  0}; //   1
  c_f[x_a][23] = {  0,   1}; //   2
  c_t[x_a][23] = { 12,  36,  41}; //   3
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  1,   2}; //   2
  c_f[x_a][24] = {  5}; //   1
  c_t[x_a][24] = {  8,   9}; //   2
  c_d[x_a][24] = {  0,   1}; //   2

  c_p[x_a][25] = {  0,   3}; //   2
  c_f[x_a][25] = {  5}; //   1
  c_t[x_a][25] = {  8,  42}; //   2
  c_d[x_a][25] = {  1,   0}; //   2

  c_p[x_a][26] = {  1,   2}; //   2
  c_f[x_a][26] = { 15}; //   1
  c_t[x_a][26] = { 43,  44}; //   2
  c_d[x_a][26] = {  0,   1}; //   2

  c_p[x_a][27] = {  0,   3}; //   2
  c_f[x_a][27] = { 16}; //   1
  c_t[x_a][27] = { 45,  46}; //   2
  c_d[x_a][27] = {  1,   0}; //   2

  c_p[x_a][28] = {  1,   2}; //   2
  c_f[x_a][28] = {  5}; //   1
  c_t[x_a][28] = { 22,  47}; //   2
  c_d[x_a][28] = {  0,   1}; //   2

  c_p[x_a][29] = {  0,   3}; //   2
  c_f[x_a][29] = {  5}; //   1
  c_t[x_a][29] = { 22,  33}; //   2
  c_d[x_a][29] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_uux_vevexagg
//  channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel    1: 2v111(1, 2, 4, 8, 16, 64, 32;  23,   0,   0,   0)
//  channel    2: 2v111(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel    3: 2v111(1, 2, 4, 8, 32, 16, 64;  23,   0,   0,   0)
//  channel    4: 2v111(1, 2, 4, 8, 32, 64, 16;  23,   0,   0,   0)
//  channel    5: 2v111(1, 2, 4, 8, 64, 32, 16;  23,   0,   0,   0)
//  channel    6: 12v11(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel    7: 12v11(1, 2, 64, 4, 8, 32, 16;  23,   0,   0,   0)
//  channel    8: 12v11(1, 2, 32, 4, 8, 16, 64;  23,   0,   0,   0)
//  channel    9: 12v11(1, 2, 32, 4, 8, 64, 16;  23,   0,   0,   0)
//  channel   10: 12v11(1, 2, 16, 4, 8, 32, 64;  23,   0,   0,   0)
//  channel   11: 12v11(1, 2, 16, 4, 8, 64, 32;  23,   0,   0,   0)
//  channel   12: 112v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   13: 112v1(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
//  channel   14: 112v1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
//  channel   15: 112v1(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
//  channel   16: 112v1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
//  channel   17: 112v1(1, 2, 32, 16, 4, 8, 64;  23,   0,   0,   0)
//  channel   18: 1112v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   19: 1112v(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   20: 1112v(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel   21: 1112v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel   22: 1112v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
//  channel   23: 1112v(1, 2, 64, 32, 16, 4, 8;  23,   0,   0,   0)
//  channel   24: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,  23,   0,   0)
//  channel   25: 2v2v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   26: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel   27: 2v12v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
//  channel   28: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,  23,   0,   0)
//  channel   29: 12v2v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
