#include "header.hpp"

#include "ppnenexa03.phasespace.set.hpp"

void ppnenexa03_phasespace_set::ax_psp_130_bbx_vevexag(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_130_bbx_vevexag");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5}; //   6
  needed_v_smin[x_a][  1] = {   0,    2,    5}; //   3
  needed_v_smin[x_a][  2] = {   1,    3,    4}; //   3

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5}; //   6
  needed_v_smax[x_a][  1] = {   0,    2,    5}; //   3
  needed_v_smax[x_a][  2] = {   1,    3,    4}; //   3

  g_p[x_a].resize(1);
  needed_g_p[x_a].resize(1);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    2,    5}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   1,    3,    4}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][4] = {   2,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][6] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");

  g_d[x_a].resize(1);
  needed_g_d[x_a].resize(1);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");

  c_p[x_a].resize(6);
  c_f[x_a].resize(6);
  c_t[x_a].resize(6);
  c_d[x_a].resize(6);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  4,   5}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  6,   7}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  1}; //   1
  c_t[x_a][4] = {  6,   8}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  4,   9}; //   2
  c_d[x_a][5] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_130_bbx_vevexag
//  channel    0: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    1: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel    2: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel    3: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel    4: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel    5: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)

void ppnenexa03_phasespace_set::ax_psp_330_bbx_vevexag(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_330_bbx_vevexag");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(4);
  needed_v_smin[x_a].resize(4);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9}; //  10
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 10);
  int needed_v_smin_1[] = {   0,    1,    2,    7}; //   4
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   3,    4}; //   2
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   5,    6,    8,    9}; //   4
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 4);

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    7,    9}; //   7
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 7);
  int needed_v_smax_1[] = {   0,    1,    2,    7}; //   4
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 4);
  int needed_v_smax_2[] = {   3,    4}; //   2
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 2);
  int needed_v_smax_3[] = {   5,    6,    8}; //   3
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 3);
  int needed_v_smax_4[] = {   5,    6,    8}; //   3
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 3);
  int needed_v_smax_5[] = {   9}; //   1
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 1);

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    7,    9}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    7}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin1_smax1");
  needed_g_p[x_a][3] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin2_smax2");
  needed_g_p[x_a][5] = {   5,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   5,    6,    8}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax4");
  needed_g_p[x_a][7] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin3_smax3");
  needed_g_p[x_a][8] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax5");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][1] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][2] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][3] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(7);
  needed_g_d[x_a].resize(7);
  needed_g_d[x_a][0] = {   0,    1,    2,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   1,    2}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][3] = {   3,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   3,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   5,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][6] = {   5,    6,    8,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(10);
  c_f[x_a].resize(10);
  c_t[x_a].resize(10);
  c_d[x_a].resize(10);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  2,   0,   1}; //   3

  c_p[x_a][2] = {  0,   2}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  2,   0,   1}; //   3

  c_p[x_a][3] = {  0,   3}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  3,   4,   1}; //   3

  c_p[x_a][4] = {  0,   4}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  3,   4,   1}; //   3

  c_p[x_a][5] = {  5,   6}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,   1,   6}; //   3

  c_p[x_a][6] = {  7,   6}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  5,   1,   6}; //   3

  c_p[x_a][7] = {  0,   1}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  1}; //   1
  c_d[x_a][7] = {  0,   1}; //   2

  c_p[x_a][8] = {  5,   6}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  2}; //   1
  c_d[x_a][8] = {  1,   6}; //   2

  c_p[x_a][9] = {  0,   8}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  3}; //   1
  c_d[x_a][9] = {  6,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_130_bbx_vevexag
//  channel    0: 3yv1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel    1: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel    2: 4yyv(1, 2, 16, 32, 4, 8;  23,  36,   0)
//  channel    3: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel    4: 4yyv(1, 2, 32, 16, 4, 8;  23,  36,   0)
//  channel    5: 42vv(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel    6: 42vv(1, 2, 4, 8, 16, 32;  36,  23,   0)
//  channel    7: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel    8: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel    9: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)
