#include "header.hpp"

#include "ppttx20.phasespace.set.hpp"

void ppttx20_phasespace_set::ag_psp_400_ddx_ttxbbx(int x_a, int zero){
  static Logger logger("ppttx20_phasespace_set::ag_psp_400_ddx_ttxbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][12] == nullvector){xbp_all[x_a][12] = xbp_all[x_a][4] + xbp_all[x_a][8];}
  if (xbs_all[x_a][12] == 0.){xbs_all[x_a][12] = xbp_all[x_a][12].m2();}
  if (xbs_all[x_a][12] < 0.){xbs_all[x_a][12] = 0.;}
  if (xbsqrts_all[x_a][12] == 0.){xbsqrts_all[x_a][12] = sqrt(xbs_all[x_a][12]);}
  if (xbp_all[x_a][48] == nullvector){xbp_all[x_a][48] = xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][48] == 0.){xbs_all[x_a][48] = xbp_all[x_a][48].m2();}
  if (xbs_all[x_a][48] < 0.){xbs_all[x_a][48] = 0.;}
  if (xbsqrts_all[x_a][48] == 0.){xbsqrts_all[x_a][48] = sqrt(xbs_all[x_a][48]);}
  if (xbp_all[x_a][13] == nullvector){xbp_all[x_a][13] = xbp_all[x_a][1] - xbp_all[x_a][4] - xbp_all[x_a][8];}
  if (xbs_all[x_a][13] == 0.){xbs_all[x_a][13] = xbp_all[x_a][13].m2();}
  if (xbs_all[x_a][13] > 0.){xbs_all[x_a][13] = 0.;}
  if (xbp_all[x_a][28] == nullvector){xbp_all[x_a][28] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][28] == 0.){xbs_all[x_a][28] = xbp_all[x_a][28].m2();}
  if (xbs_all[x_a][28] < 0.){xbs_all[x_a][28] = 0.;}
  if (xbp_all[x_a][44] == nullvector){xbp_all[x_a][44] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][32];}
  if (xbs_all[x_a][44] == 0.){xbs_all[x_a][44] = xbp_all[x_a][44].m2();}
  if (xbs_all[x_a][44] < 0.){xbs_all[x_a][44] = 0.;}
  if (xbp_all[x_a][49] == nullvector){xbp_all[x_a][49] = xbp_all[x_a][1] - xbp_all[x_a][16] - xbp_all[x_a][32];}
  if (xbs_all[x_a][49] == 0.){xbs_all[x_a][49] = xbp_all[x_a][49].m2();}
  if (xbs_all[x_a][49] > 0.){xbs_all[x_a][49] = 0.;}
  if (xbp_all[x_a][52] == nullvector){xbp_all[x_a][52] = xbp_all[x_a][4] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][52] == 0.){xbs_all[x_a][52] = xbp_all[x_a][52].m2();}
  if (xbs_all[x_a][52] < 0.){xbs_all[x_a][52] = 0.;}
  if (xbp_all[x_a][56] == nullvector){xbp_all[x_a][56] = xbp_all[x_a][8] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][56] == 0.){xbs_all[x_a][56] = xbp_all[x_a][56].m2();}
  if (xbs_all[x_a][56] < 0.){xbs_all[x_a][56] = 0.;}
  if (xbp_all[x_a][60] == nullvector){xbp_all[x_a][60] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][60] == 0.){xbs_all[x_a][60] = xbp_all[x_a][60].m2();}
  if (xbs_all[x_a][60] < 0.){xbs_all[x_a][60] = 0.;}

  v_smin[x_a][  0] = smin_opt[x_a][48]; // 5 times
  v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]); // 1 times
  v_smin[x_a][  2] = smin_opt[x_a][12]; // 5 times
  v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]); // 1 times
  v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]); // 1 times
  v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]); // 1 times

  v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2); // 4 times
  v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2); // 1 times
  v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2); // 3 times
  v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2); // 1 times
  v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2); // 1 times
  v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2); // 1 times
  v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2); // 2 times
  v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2); // 1 times

  //  vector<double> g_p(8);
  {g_p[x_a][  0] = g_propagator(x_a,   0,  48, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 4 times
  {g_p[x_a][  1] = g_propagator(x_a,   6,  56, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 3 */} // 1 times
  {g_p[x_a][  2] = g_propagator(x_a,   0,  12, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 2 */} // 3 times
  {g_p[x_a][  3] = g_propagator(x_a,   5,  44, v_smin[x_a][  3], v_smax[x_a][  3]); /* npp 3 */} // 1 times
  {g_p[x_a][  4] = g_propagator(x_a,   5,  28, v_smin[x_a][  4], v_smax[x_a][  4]); /* npp 3 */} // 1 times
  {g_p[x_a][  5] = g_propagator(x_a,   6,  52, v_smin[x_a][  5], v_smax[x_a][  5]); /* npp 3 */} // 1 times
  {g_p[x_a][  6] = g_propagator(x_a,   0,  12, v_smin[x_a][  2], v_smax[x_a][  6]); /* npp 2 */} // 2 times
  {g_p[x_a][  7] = g_propagator(x_a,   0,  48, v_smin[x_a][  0], v_smax[x_a][  7]); /* npp 2 */} // 1 times

  //  vector<double> g_t(2);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  60,   1,   2,  12,  48); /* ntp 0 */} // 1 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,   0,  60,   1,   2,  48,  12); /* ntp 0 */} // 1 times

  //  vector<double> g_d(11);
  {g_d[x_a][  0] = g_decay(x_a,  60,   4,  56); /* ndp 4 */} // 1 times
  {g_d[x_a][  1] = g_decay(x_a,  56,   8,  48); /* ndp 3 */} // 1 times
  {g_d[x_a][  2] = g_decay(x_a,  48,  16,  32); /* ndp 2 */} // 5 times
  {g_d[x_a][  3] = g_decay(x_a,  60,  16,  44); /* ndp 4 */} // 1 times
  {g_d[x_a][  4] = g_decay(x_a,  44,  32,  12); /* ndp 3 */} // 1 times
  {g_d[x_a][  5] = g_decay(x_a,  12,   4,   8); /* ndp 2 */} // 5 times
  {g_d[x_a][  6] = g_decay(x_a,  60,  32,  28); /* ndp 4 */} // 1 times
  {g_d[x_a][  7] = g_decay(x_a,  28,  16,  12); /* ndp 3 */} // 1 times
  {g_d[x_a][  8] = g_decay(x_a,  60,   8,  52); /* ndp 4 */} // 1 times
  {g_d[x_a][  9] = g_decay(x_a,  52,   4,  48); /* ndp 3 */} // 1 times
  {g_d[x_a][ 10] = g_decay(x_a,  60,  12,  48); /* ndp 4 */} // 1 times

  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(8);
    inv_r[1].resize(0);
    inv_r[2].resize(2);
    inv_r[3].resize(2);
    inv_r[4].resize(11);
    inv_r[5].resize(11);

    {inv_propagator(x_a,   0,  48, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][0]);} // 4 times
    {inv_propagator(x_a,   6,  56, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][1]);} // 1 times
    {inv_propagator(x_a,   0,  12, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][2]);} // 3 times
    {inv_propagator(x_a,   5,  44, v_smin[x_a][  3], v_smax[x_a][  3], inv_r[0][3]);} // 1 times
    {inv_propagator(x_a,   5,  28, v_smin[x_a][  4], v_smax[x_a][  4], inv_r[0][4]);} // 1 times
    {inv_propagator(x_a,   6,  52, v_smin[x_a][  5], v_smax[x_a][  5], inv_r[0][5]);} // 1 times
    {inv_propagator(x_a,   0,  12, v_smin[x_a][  2], v_smax[x_a][  6], inv_r[0][6]);} // 2 times
    {inv_propagator(x_a,   0,  48, v_smin[x_a][  0], v_smax[x_a][  7], inv_r[0][7]);} // 1 times

    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  12,  48, inv_r[2][0], inv_r[3][0]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  48,  12, inv_r[2][1], inv_r[3][1]);} // 1 times

    {inv_decay(x_a,  60,   4,  56, inv_r[4][0], inv_r[5][0]);} // 1 times
    {inv_decay(x_a,  56,   8,  48, inv_r[4][1], inv_r[5][1]);} // 1 times
    {inv_decay(x_a,  48,  16,  32, inv_r[4][2], inv_r[5][2]);} // 5 times
    {inv_decay(x_a,  60,  16,  44, inv_r[4][3], inv_r[5][3]);} // 1 times
    {inv_decay(x_a,  44,  32,  12, inv_r[4][4], inv_r[5][4]);} // 1 times
    {inv_decay(x_a,  12,   4,   8, inv_r[4][5], inv_r[5][5]);} // 5 times
    {inv_decay(x_a,  60,  32,  28, inv_r[4][6], inv_r[5][6]);} // 1 times
    {inv_decay(x_a,  28,  16,  12, inv_r[4][7], inv_r[5][7]);} // 1 times
    {inv_decay(x_a,  60,   8,  52, inv_r[4][8], inv_r[5][8]);} // 1 times
    {inv_decay(x_a,  52,   4,  48, inv_r[4][9], inv_r[5][9]);} // 1 times
    {inv_decay(x_a,  60,  12,  48, inv_r[4][10], inv_r[5][10]);} // 1 times

    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(7, vector<double> (8));
      vector<double> g_IS(7, 1.);
      for (int i_c = 0; i_c < 7; i_c++){
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        int ran = 0;
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 8; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_p[x_a][  0] * g_p[x_a][  1] * g_d[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_p[x_a][  2] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  5];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_IS[  2] * g_p[x_a][  2] * g_p[x_a][  4] * g_d[x_a][  6] * g_d[x_a][  7] * g_d[x_a][  5];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_IS[  3] * g_p[x_a][  0] * g_p[x_a][  5] * g_d[x_a][  8] * g_d[x_a][  9] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_IS[  4] * g_p[x_a][  0] * g_p[x_a][  6] * g_d[x_a][ 10] * g_d[x_a][  5] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_IS[  5] * g_p[x_a][  0] * g_p[x_a][  6] * g_t[x_a][  0] * g_d[x_a][  5] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_IS[  6] * g_p[x_a][  2] * g_p[x_a][  7] * g_t[x_a][  1] * g_d[x_a][  2] * g_d[x_a][  5];}
    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(8, 1.);
      g_IS[1].resize(0, 1.);
      g_IS[2].resize(2, 1.);
      g_IS[3].resize(11, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  1] * g_IS[3][  1] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  3] * g_IS[0][  3] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  5] * g_IS[3][  5];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  4] * g_IS[0][  4] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  7] * g_IS[3][  7] * g_d[x_a][  5] * g_IS[3][  5];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  5] * g_IS[0][  5] * g_d[x_a][  8] * g_IS[3][  8] * g_d[x_a][  9] * g_IS[3][  9] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  6] * g_IS[0][  6] * g_d[x_a][ 10] * g_IS[3][ 10] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  6] * g_IS[0][  6] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  7] * g_IS[0][  7] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  5] * g_IS[3][  5];}
    }
  }
  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_p[x_a][  0] * g_p[x_a][  1] * g_d[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  2] * g_p[x_a][  3] * g_d[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  5];}
    if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  2] * g_p[x_a][  4] * g_d[x_a][  6] * g_d[x_a][  7] * g_d[x_a][  5];}
    if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  0] * g_p[x_a][  5] * g_d[x_a][  8] * g_d[x_a][  9] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_p[x_a][  0] * g_p[x_a][  6] * g_d[x_a][ 10] * g_d[x_a][  5] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_p[x_a][  0] * g_p[x_a][  6] * g_t[x_a][  0] * g_d[x_a][  5] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_p[x_a][  2] * g_p[x_a][  7] * g_t[x_a][  1] * g_d[x_a][  2] * g_d[x_a][  5];}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
