#include "header.hpp"

#include "ppttx20.phasespace.set.hpp"

void ppttx20_phasespace_set::ax_psp_400_bbx_ttxgg(int x_a){
  static Logger logger("ppttx20_phasespace_set::ax_psp_400_bbx_ttxgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(18);
  needed_v_smin[x_a].resize(18);
  needed_v_smin[x_a][  0] = {   0,    1,    4,    5,   13,   14,   20,   23,   24,   27,   28,   31,   32,   33,   34}; //  15
  needed_v_smin[x_a][  1] = {   2,    9,   10,   21,   25}; //   5
  needed_v_smin[x_a][  2] = {   2,   10,   25}; //   3
  needed_v_smin[x_a][  3] = {   3,   11,   12,   22,   26}; //   5
  needed_v_smin[x_a][  4] = {   3,   12,   26}; //   3
  needed_v_smin[x_a][  5] = {   4,   13,   27,    1,   24,   31}; //   6
  needed_v_smin[x_a][  6] = {   5,   14,   28,    0,   23,   32}; //   6
  needed_v_smin[x_a][  7] = {   6,   16,   17,   22,   29}; //   5
  needed_v_smin[x_a][  8] = {   6,   17,   29}; //   3
  needed_v_smin[x_a][  9] = {   7,   18,   19,   21,   30}; //   5
  needed_v_smin[x_a][ 10] = {   7,   19,   30}; //   3
  needed_v_smin[x_a][ 11] = {   8,   15,   20,   33,   34}; //   5
  needed_v_smin[x_a][ 12] = {   8}; //   1
  needed_v_smin[x_a][ 13] = {   9}; //   1
  needed_v_smin[x_a][ 14] = {  11}; //   1
  needed_v_smin[x_a][ 15] = {  15}; //   1
  needed_v_smin[x_a][ 16] = {  16}; //   1
  needed_v_smin[x_a][ 17] = {  18}; //   1

  v_smax[x_a].resize(14);
  needed_v_smax[x_a].resize(14);
  needed_v_smax[x_a][  0] = {   0,    1,    4,    5,   13,   14,   23,   24,   27,   28,   31,   32,   34}; //  13
  needed_v_smax[x_a][  1] = {   2,    9,   10,   21,   25}; //   5
  needed_v_smax[x_a][  2] = {   2,    5,    6,   10,   14,   17,   25,   28,   29,    0,   23,   32}; //  12
  needed_v_smax[x_a][  3] = {   3,   11,   12,   22,   26}; //   5
  needed_v_smax[x_a][  4] = {   3,    4,    7,   12,   13,   19,   26,   27,   30,    1,   24,   31}; //  12
  needed_v_smax[x_a][  5] = {   6,   16,   17,   29}; //   4
  needed_v_smax[x_a][  6] = {   7,   18,   19,   30}; //   4
  needed_v_smax[x_a][  7] = {   8,   15,   20,   33}; //   4
  needed_v_smax[x_a][  8] = {   8,    9,   11}; //   3
  needed_v_smax[x_a][  9] = {  15,   16,   18}; //   3
  needed_v_smax[x_a][ 10] = {  20,   33}; //   2
  needed_v_smax[x_a][ 11] = {  21}; //   1
  needed_v_smax[x_a][ 12] = {  22}; //   1
  needed_v_smax[x_a][ 13] = {  34}; //   1

  g_p[x_a].resize(22);
  needed_g_p[x_a].resize(22);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   13,   14,   23,   24,   27,   28,   31,   32,   34}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    9,   10,   21,   25}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin1_smax1");
  needed_g_p[x_a][2] = {   2,   10,   25}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   3,   11,   12,   22,   26}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin3_smax3");
  needed_g_p[x_a][4] = {   3,   12,   26}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   4,   13,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   5,   14,   28}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax2");
  needed_g_p[x_a][7] = {   6,   16,   17,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin7_smax5");
  needed_g_p[x_a][8] = {   6,   17,   29}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][9] = {   7,   18,   19,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin9_smax6");
  needed_g_p[x_a][10] = {   7,   19,   30}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][11] = {   8,   15,   20,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][12] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin12_smax8");
  needed_g_p[x_a][13] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin13_smax8");
  needed_g_p[x_a][14] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin14_smax8");
  needed_g_p[x_a][15] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax9");
  needed_g_p[x_a][16] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin16_smax9");
  needed_g_p[x_a][17] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin17_smax9");
  needed_g_p[x_a][18] = {  20,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax10");
  needed_g_p[x_a][19] = {  21}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin9_smax11");
  needed_g_p[x_a][20] = {  22}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin7_smax12");
  needed_g_p[x_a][21] = {  34}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax13");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,   23,   32}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax2");
  needed_g_f[x_a][1] = {   1,   24,   31}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {   0,    2,    5,    6}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__32_28");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_34__12_16");
  needed_g_t[x_a][2] = {   1,    3,    4,    7}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__16_44");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_18__12_32");
  needed_g_t[x_a][4] = {  23,   25,   28,   29,   32}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__32_28");
  needed_g_t[x_a][5] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_33__16_12");
  needed_g_t[x_a][6] = {  24,   26,   27,   30,   31}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__16_44");
  needed_g_t[x_a][7] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_17__32_12");
  needed_g_t[x_a][8] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_17__12_32");
  needed_g_t[x_a][9] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_33__12_16");
  needed_g_t[x_a][10] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__12_48");
  needed_g_t[x_a][11] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__48_12");

  g_d[x_a].resize(25);
  needed_g_d[x_a].resize(25);
  needed_g_d[x_a][0] = {   0,    1,    4,    5,   13,   14,   20,   23,   24,   27,   28,   31,   32,   33,   34}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   2,   10,   25}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {   2,    9,   10,   21,   25}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   3,   12,   26}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][4] = {   3,   11,   12,   22,   26}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][5] = {   4,   13,   27}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {   5,   14,   28}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][7] = {   6,   17,   29}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {   6,   16,   17,   22,   29}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][9] = {   7,   19,   30}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {   7,   18,   19,   21,   30}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][11] = {   8,    9,   11}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][12] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][13] = {   8,   15,   20,   33,   34}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][14] = {   9}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][15] = {  10,   14,   17}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][16] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][17] = {  12,   13,   19}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][18] = {  15,   16,   18}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][19] = {  15}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][20] = {  16}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][21] = {  18}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][22] = {  20}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][23] = {  21}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][24] = {  22}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(35);
  c_f[x_a].resize(35);
  c_t[x_a].resize(35);
  c_d[x_a].resize(35);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  1,   2}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  1,   2}; //   2

  c_p[x_a][3] = {  3,   4}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  2}; //   1
  c_d[x_a][3] = {  3,   4}; //   2

  c_p[x_a][4] = {  0,   5}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  2}; //   1
  c_d[x_a][4] = {  5,   0}; //   2

  c_p[x_a][5] = {  0,   6}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  6,   0}; //   2

  c_p[x_a][6] = {  7,   8}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  7,   8}; //   2

  c_p[x_a][7] = {  9,  10}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  2}; //   1
  c_d[x_a][7] = {  9,  10}; //   2

  c_p[x_a][8] = { 11,  12}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 11,  12,  13}; //   3

  c_p[x_a][9] = {  1,  13}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 11,  14,   2}; //   3

  c_p[x_a][10] = {  1,   2}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 15,   1,   2}; //   3

  c_p[x_a][11] = {  3,  14}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 11,  16,   4}; //   3

  c_p[x_a][12] = {  3,   4}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 17,   3,   4}; //   3

  c_p[x_a][13] = {  0,   5}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 17,   5,   0}; //   3

  c_p[x_a][14] = {  0,   6}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 15,   6,   0}; //   3

  c_p[x_a][15] = { 11,  15}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 18,  19,  13}; //   3

  c_p[x_a][16] = {  7,  16}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 18,  20,   8}; //   3

  c_p[x_a][17] = {  7,   8}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 15,   7,   8}; //   3

  c_p[x_a][18] = {  9,  17}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 18,  21,  10}; //   3

  c_p[x_a][19] = {  9,  10}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 17,   9,  10}; //   3

  c_p[x_a][20] = { 11,  18}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 22,   0,  13}; //   3

  c_p[x_a][21] = {  1,  19}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 23,  10,   2}; //   3

  c_p[x_a][22] = {  3,  20}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 24,   8,   4}; //   3

  c_p[x_a][23] = {  0}; //   1
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  4,   5}; //   2
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = {  1}; //   1
  c_t[x_a][24] = {  6,   7}; //   2
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  1,   2}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  4}; //   1
  c_d[x_a][25] = {  1,   2}; //   2

  c_p[x_a][26] = {  3,   4}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  6}; //   1
  c_d[x_a][26] = {  3,   4}; //   2

  c_p[x_a][27] = {  0,   5}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  6}; //   1
  c_d[x_a][27] = {  5,   0}; //   2

  c_p[x_a][28] = {  0,   6}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  4}; //   1
  c_d[x_a][28] = {  6,   0}; //   2

  c_p[x_a][29] = {  7,   8}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  4}; //   1
  c_d[x_a][29] = {  7,   8}; //   2

  c_p[x_a][30] = {  9,  10}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  6}; //   1
  c_d[x_a][30] = {  9,  10}; //   2

  c_p[x_a][31] = {  0}; //   1
  c_f[x_a][31] = {  1}; //   1
  c_t[x_a][31] = {  6,   8}; //   2
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  0}; //   1
  c_f[x_a][32] = {  0}; //   1
  c_t[x_a][32] = {  4,   9}; //   2
  c_d[x_a][32] = {  0}; //   1

  c_p[x_a][33] = { 11,  18}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = { 10}; //   1
  c_d[x_a][33] = {  0,  13}; //   2

  c_p[x_a][34] = {  0,  21}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = { 11}; //   1
  c_d[x_a][34] = { 13,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_400_bbx_ttxgg
//  channel    0: 2v11(1, 2, 4, 8, 16, 32;   0,   5,   5)
//  channel    1: 2v11(1, 2, 4, 8, 32, 16;   0,   5,   5)
//  channel    2: 3yv1(1, 2, 4, 8, 16, 32;   6,   0,   5)
//  channel    3: 3yv1(1, 2, 4, 8, 32, 16;   6,   0,   5)
//  channel    4: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   5)
//  channel    5: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   5)
//  channel    6: 3yv1(1, 2, 8, 4, 16, 32;   6,   0,   5)
//  channel    7: 3yv1(1, 2, 8, 4, 32, 16;   6,   0,   5)
//  channel    8: 4yyv(1, 2, 4, 8, 16, 32;   0,   6,   0)
//  channel    9: 4yyv(1, 2, 4, 32, 8, 16;   6,   6,   0)
//  channel   10: 4yyv(1, 2, 32, 4, 8, 16;   6,   0,   0)
//  channel   11: 4yyv(1, 2, 4, 16, 8, 32;   6,   6,   0)
//  channel   12: 4yyv(1, 2, 16, 4, 8, 32;   6,   0,   0)
//  channel   13: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   14: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   15: 4yyv(1, 2, 8, 4, 16, 32;   0,   6,   0)
//  channel   16: 4yyv(1, 2, 8, 32, 4, 16;   6,   6,   0)
//  channel   17: 4yyv(1, 2, 32, 8, 4, 16;   6,   0,   0)
//  channel   18: 4yyv(1, 2, 8, 16, 4, 32;   6,   6,   0)
//  channel   19: 4yyv(1, 2, 16, 8, 4, 32;   6,   0,   0)
//  channel   20: 42vv(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   21: 42vv(1, 2, 4, 32, 8, 16;   6,   6,   0)
//  channel   22: 42vv(1, 2, 4, 16, 8, 32;   6,   6,   0)
//  channel   23: 12v1(1, 2, 32, 4, 8, 16;   0,   5,   5)
//  channel   24: 12v1(1, 2, 16, 4, 8, 32;   0,   5,   5)
//  channel   25: 13yv(1, 2, 32, 4, 8, 16;   6,   0,   5)
//  channel   26: 13yv(1, 2, 16, 4, 8, 32;   6,   0,   5)
//  channel   27: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   5)
//  channel   28: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   5)
//  channel   29: 13yv(1, 2, 32, 8, 4, 16;   6,   0,   5)
//  channel   30: 13yv(1, 2, 16, 8, 4, 32;   6,   0,   5)
//  channel   31: 112v(1, 2, 16, 32, 4, 8;   0,   5,   5)
//  channel   32: 112v(1, 2, 32, 16, 4, 8;   0,   5,   5)
//  channel   33: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   5)
//  channel   34: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   5)
