#include "header.hpp"

#include "ppttx20.phasespace.set.hpp"

void ppttx20_phasespace_set::ax_psp_400_gg_ttxgg(int x_a){
  static Logger logger("ppttx20_phasespace_set::ax_psp_400_gg_ttxgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(18);
  needed_v_smin[x_a].resize(18);
  needed_v_smin[x_a][  0] = {  24,   25,   38,   41,   53,   54,   60,   65,   68,   80,   81,   92,   93,   99,  102,    3,    8,   15,   20}; //  19
  needed_v_smin[x_a][  1] = {  26,   29,   42,   44,   58,   59,   61,   69,   71,   85,   86,   97,   98,  100,  104,    9,   10,   13,   14}; //  19
  needed_v_smin[x_a][  2] = {  27,   28,   40,   43,   56,   57,   62,   67,   70,   83,   84,   95,   96,  101,  103,    7,   11,   12,   16}; //  19
  needed_v_smin[x_a][  3] = {  30,   35,   39,   45,   48,   55,   60,   66,   72,   75,   82,   87,   94,   99,  102,    5,    6,   17,   18}; //  19
  needed_v_smin[x_a][  4] = {  31,   34,   37,   47,   51,   52,   62,   64,   74,   78,   79,   90,   91,  101,  103,    1,    2,   21,   22}; //  19
  needed_v_smin[x_a][  5] = {  32,   33,   36,   46,   49,   50,   61,   63,   73,   76,   77,   88,   89,  100,  104,    0,    4,   19,   23}; //  19
  needed_v_smin[x_a][  6] = {  36,   50,   77,   19,   23,   32,   73,   89}; //   8
  needed_v_smin[x_a][  7] = {  37,   52,   79,   21,   22,   31,   74,   91}; //   8
  needed_v_smin[x_a][  8] = {  38,   53,   80,    8,   20,   25,   68,   92}; //   8
  needed_v_smin[x_a][  9] = {  39,   55,   82,   17,   18,   30,   72,   94}; //   8
  needed_v_smin[x_a][ 10] = {  40,   56,   83,   12,   16,   28,   70,   95}; //   8
  needed_v_smin[x_a][ 11] = {  41,   54,   81,    3,   15,   24,   65,   93}; //   8
  needed_v_smin[x_a][ 12] = {  42,   58,   85,   13,   14,   29,   71,   97}; //   8
  needed_v_smin[x_a][ 13] = {  43,   57,   84,    7,   11,   27,   67,   96}; //   8
  needed_v_smin[x_a][ 14] = {  44,   59,   86,    9,   10,   26,   69,   98}; //   8
  needed_v_smin[x_a][ 15] = {  45,   48,   75,    5,    6,   35,   66,   87}; //   8
  needed_v_smin[x_a][ 16] = {  46,   49,   76,    0,    4,   33,   63,   88}; //   8
  needed_v_smin[x_a][ 17] = {  47,   51,   78,    1,    2,   34,   64,   90}; //   8

  v_smax[x_a].resize(16);
  needed_v_smax[x_a].resize(16);
  needed_v_smax[x_a][  0] = {  24,   25,   38,   41,   53,   54,   65,   68,   80,   81,   92,   93,  102,    3,    8,   15,   20}; //  17
  needed_v_smax[x_a][  1] = {  26,   29,   42,   44,   58,   59,   69,   71,   85,   86,   97,   98,  104,    9,   10,   13,   14}; //  17
  needed_v_smax[x_a][  2] = {  27,   28,   40,   43,   56,   57,   67,   70,   83,   84,   95,   96,  103,    7,   11,   12,   16}; //  17
  needed_v_smax[x_a][  3] = {  30,   35,   39,   45,   48,   55,   60,   66,   72,   75,   82,   87,   94,   99,    5,    6,   17,   18}; //  18
  needed_v_smax[x_a][  4] = {  31,   34,   37,   47,   51,   52,   62,   64,   74,   78,   79,   90,   91,  101,    1,    2,   21,   22}; //  18
  needed_v_smax[x_a][  5] = {  32,   33,   36,   46,   49,   50,   61,   63,   73,   76,   77,   88,   89,  100,    0,    4,   19,   23}; //  18
  needed_v_smax[x_a][  6] = {  36,   41,   43,   50,   54,   57,   77,   81,   84,    3,    7,   11,   15,   19,   23,   24,   27,   32,   65,   67,   73,   89,   93,   96}; //  24
  needed_v_smax[x_a][  7] = {  37,   38,   44,   52,   53,   59,   79,   80,   86,    8,    9,   10,   20,   21,   22,   25,   26,   31,   68,   69,   74,   91,   92,   98}; //  24
  needed_v_smax[x_a][  8] = {  39,   40,   42,   55,   56,   58,   82,   83,   85,   12,   13,   14,   16,   17,   18,   28,   29,   30,   70,   71,   72,   94,   95,   97}; //  24
  needed_v_smax[x_a][  9] = {  45,   46,   47,   48,   49,   51,   75,   76,   78,    0,    1,    2,    4,    5,    6,   33,   34,   35,   63,   64,   66,   87,   88,   90}; //  24
  needed_v_smax[x_a][ 10] = {  60,   99}; //   2
  needed_v_smax[x_a][ 11] = {  61,  100}; //   2
  needed_v_smax[x_a][ 12] = {  62,  101}; //   2
  needed_v_smax[x_a][ 13] = { 102}; //   1
  needed_v_smax[x_a][ 14] = { 103}; //   1
  needed_v_smax[x_a][ 15] = { 104}; //   1

  g_p[x_a].resize(24);
  needed_g_p[x_a].resize(24);
  needed_g_p[x_a][0] = {  24,   25,   38,   41,   53,   54,   65,   68,   80,   81,   92,   93,  102}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  26,   29,   42,   44,   58,   59,   69,   71,   85,   86,   97,   98,  104}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin1_smax1");
  needed_g_p[x_a][2] = {  27,   28,   40,   43,   56,   57,   67,   70,   83,   84,   95,   96,  103}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin2_smax2");
  needed_g_p[x_a][3] = {  30,   35,   39,   45,   48,   55,   60,   66,   72,   75,   82,   87,   94,   99}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  31,   34,   37,   47,   51,   52,   62,   64,   74,   78,   79,   90,   91,  101}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin4_smax4");
  needed_g_p[x_a][5] = {  32,   33,   36,   46,   49,   50,   61,   63,   73,   76,   77,   88,   89,  100}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin5_smax5");
  needed_g_p[x_a][6] = {  36,   50,   77}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][7] = {  37,   52,   79}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax7");
  needed_g_p[x_a][8] = {  38,   53,   80}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][9] = {  39,   55,   82}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin9_smax8");
  needed_g_p[x_a][10] = {  40,   56,   83}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin10_smax8");
  needed_g_p[x_a][11] = {  41,   54,   81}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax6");
  needed_g_p[x_a][12] = {  42,   58,   85}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin12_smax8");
  needed_g_p[x_a][13] = {  43,   57,   84}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax6");
  needed_g_p[x_a][14] = {  44,   59,   86}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][15] = {  45,   48,   75}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax9");
  needed_g_p[x_a][16] = {  46,   49,   76}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin16_smax9");
  needed_g_p[x_a][17] = {  47,   51,   78}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin17_smax9");
  needed_g_p[x_a][18] = {  60,   99}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax10");
  needed_g_p[x_a][19] = {  61,  100}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin1_smax11");
  needed_g_p[x_a][20] = {  62,  101}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin2_smax12");
  needed_g_p[x_a][21] = { 102}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax13");
  needed_g_p[x_a][22] = { 103}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin4_smax14");
  needed_g_p[x_a][23] = { 104}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin5_smax15");

  g_f[x_a].resize(18);
  needed_g_f[x_a].resize(18);
  needed_g_f[x_a][0] = {   0,    4,   19,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][1] = {   0,    4,   33,   63,   88}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax9");
  needed_g_f[x_a][2] = {   1,    2,   21,   22}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][3] = {   1,    2,   34,   64,   90}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax9");
  needed_g_f[x_a][4] = {   3,    8,   15,   20}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][5] = {   3,   15,   24,   65,   93}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax6");
  needed_g_f[x_a][6] = {   5,    6,   17,   18}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][7] = {   5,    6,   35,   66,   87}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax9");
  needed_g_f[x_a][8] = {   7,   11,   12,   16}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][9] = {   7,   11,   27,   67,   96}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax6");
  needed_g_f[x_a][10] = {   8,   20,   25,   68,   92}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax7");
  needed_g_f[x_a][11] = {   9,   10,   13,   14}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][12] = {   9,   10,   26,   69,   98}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax7");
  needed_g_f[x_a][13] = {  12,   16,   28,   70,   95}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax8");
  needed_g_f[x_a][14] = {  13,   14,   29,   71,   97}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax8");
  needed_g_f[x_a][15] = {  17,   18,   30,   72,   94}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax8");
  needed_g_f[x_a][16] = {  19,   23,   32,   73,   89}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax6");
  needed_g_f[x_a][17] = {  21,   22,   31,   74,   91}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax7");

  g_t[x_a].resize(74);
  needed_g_t[x_a].resize(74);
  needed_g_t[x_a][0] = {   0,    1,    2,    4,    5,    6,   63,   64,   66,   75,   76,   78,   87,   88,   90}; //  15
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__4_56");
  needed_g_t[x_a][1] = {   0,    4,   63}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1,    2,   64}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_32");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__5_18__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__5_18__32_8");
  needed_g_t[x_a][6] = {   3,    7,   11,   15,   19,   23,   65,   67,   73,   77,   81,   84,   89,   93,   96}; //  15
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][7] = {   3,   15,   65}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_18__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_18__4_8");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__5_34__16_8");
  needed_g_t[x_a][10] = {   5,    6,   66}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_5__8_48");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__5_10__16_32");
  needed_g_t[x_a][12] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__5_10__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__5_10__32_16");
  needed_g_t[x_a][13] = {   7,   11,   67}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__8_20");
  needed_g_t[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_10__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_10__4_16");
  needed_g_t[x_a][15] = {   8,    9,   10,   20,   21,   22,   68,   69,   74,   79,   80,   86,   91,   92,   98}; //  15
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][16] = {   8,   20,   68}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][17] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__4_8");
  needed_g_t[x_a][18] = {   9,   10,   69}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__8_36");
  needed_g_t[x_a][19] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_10__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_10__4_32");
  needed_g_t[x_a][20] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][21] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__16_4");
  needed_g_t[x_a][22] = {  12,   13,   14,   16,   17,   18,   70,   71,   72,   82,   83,   85,   94,   95,   97}; //  15
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__8_52");
  needed_g_t[x_a][23] = {  12,   16,   70}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][24] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][25] = {  13,   14,   71}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_36");
  needed_g_t[x_a][26] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__4_32");
  needed_g_t[x_a][27] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__9_18__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__9_18__32_4");
  needed_g_t[x_a][28] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_18__8_4");
  needed_g_t[x_a][29] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__9_34__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__9_34__16_4");
  needed_g_t[x_a][30] = {  17,   18,   72}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_9__4_48");
  needed_g_t[x_a][31] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__9_6__16_32");
  needed_g_t[x_a][32] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__9_6__32_16");
  needed_g_t[x_a][33] = {  19,   23,   73}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__4_24");
  needed_g_t[x_a][34] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_6__8_16");
  needed_g_t[x_a][35] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__8_4");
  needed_g_t[x_a][36] = {  21,   22,   74}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__4_40");
  needed_g_t[x_a][37] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_6__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_6__8_32");
  needed_g_t[x_a][38] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][39] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__16_8");
  needed_g_t[x_a][40] = {  24,   27,   32,   36,   41,   43}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][41] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][42] = {  25,   26,   31,   37,   38,   44}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][43] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][44] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_18__36_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_18__36_8");
  needed_g_t[x_a][45] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_34__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_34__20_8");
  needed_g_t[x_a][46] = {  28,   29,   30,   39,   40,   42}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__8_52");
  needed_g_t[x_a][47] = {  28}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_10__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_10__20_32");
  needed_g_t[x_a][48] = {  29}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_10__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_10__36_16");
  needed_g_t[x_a][49] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][50] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_18__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_18__40_4");
  needed_g_t[x_a][51] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_34__24_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_34__24_4");
  needed_g_t[x_a][52] = {  33,   34,   35,   45,   46,   47}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__4_56");
  needed_g_t[x_a][53] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_6__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_6__24_32");
  needed_g_t[x_a][54] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_6__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_6__40_16");
  needed_g_t[x_a][55] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_8");
  needed_g_t[x_a][56] = {  87}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__48_8");
  needed_g_t[x_a][57] = {  88}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_5__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_5__24_32");
  needed_g_t[x_a][58] = {  89}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__24_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__24_4");
  needed_g_t[x_a][59] = {  90}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_5__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_5__40_16");
  needed_g_t[x_a][60] = {  91}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__40_4");
  needed_g_t[x_a][61] = {  92}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][62] = {  93}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");
  needed_g_t[x_a][63] = {  94}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__48_4");
  needed_g_t[x_a][64] = {  95}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_9__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_9__20_32");
  needed_g_t[x_a][65] = {  96}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__20_8");
  needed_g_t[x_a][66] = {  97}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_9__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_9__36_16");
  needed_g_t[x_a][67] = {  98}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__36_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__36_8");
  needed_g_t[x_a][68] = {  99}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][69] = { 100}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__36_24");
  needed_g_t[x_a][70] = { 101}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__20_40");
  needed_g_t[x_a][71] = { 102}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");
  needed_g_t[x_a][72] = { 103}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__40_20");
  needed_g_t[x_a][73] = { 104}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__24_36");

  g_d[x_a].resize(25);
  needed_g_d[x_a].resize(25);
  needed_g_d[x_a][0] = {  24,   25,   38,   41,   53,   54,   60,   65,   68,   80,   81,   92,   93,   99,  102}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  26,   29,   42,   44,   58,   59,   61,   69,   71,   85,   86,   97,   98,  100,  104}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][2] = {  27,   28,   40,   43,   56,   57,   62,   67,   70,   83,   84,   95,   96,  101,  103}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][3] = {  30,   35,   39,   45,   48,   55,   60,   66,   72,   75,   82,   87,   94,   99,  102}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][4] = {  31,   34,   37,   47,   51,   52,   62,   64,   74,   78,   79,   90,   91,  101,  103}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][5] = {  32,   33,   36,   46,   49,   50,   61,   63,   73,   76,   77,   88,   89,  100,  104}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][6] = {  36,   50,   77}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {  37,   52,   79}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][8] = {  38,   53,   80}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {  39,   55,   82}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][10] = {  40,   56,   83}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][11] = {  41,   54,   81}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][12] = {  42,   58,   85}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][13] = {  43,   57,   84}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][14] = {  44,   59,   86}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][15] = {  45,   48,   75}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][16] = {  46,   49,   76}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][17] = {  47,   51,   78}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][18] = {  48,   49,   51}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][19] = {  50,   54,   57}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][20] = {  52,   53,   59}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][21] = {  55,   56,   58}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][22] = {  60}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][23] = {  61}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][24] = {  62}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(105);
  c_f[x_a].resize(105);
  c_t[x_a].resize(105);
  c_d[x_a].resize(105);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  0,   3,   5}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  4,   5}; //   2
  c_t[x_a][3] = {  6,   7,   8}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  0,   1}; //   2
  c_t[x_a][4] = {  0,   1,   9}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  6,   7}; //   2
  c_t[x_a][5] = {  0,  10,  11}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  6,   7}; //   2
  c_t[x_a][6] = {  0,  10,  12}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  8,   9}; //   2
  c_t[x_a][7] = {  6,  13,  14}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  4,  10}; //   2
  c_t[x_a][8] = { 15,  16,  17}; //   3
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = { 11,  12}; //   2
  c_t[x_a][9] = { 15,  18,  19}; //   3
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = { 11,  12}; //   2
  c_t[x_a][10] = { 15,  18,  20}; //   3
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  8,   9}; //   2
  c_t[x_a][11] = {  6,  13,  21}; //   3
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {}; //   0
  c_f[x_a][12] = {  8,  13}; //   2
  c_t[x_a][12] = { 22,  23,  24}; //   3
  c_d[x_a][12] = {}; //   0

  c_p[x_a][13] = {}; //   0
  c_f[x_a][13] = { 11,  14}; //   2
  c_t[x_a][13] = { 22,  25,  26}; //   3
  c_d[x_a][13] = {}; //   0

  c_p[x_a][14] = {}; //   0
  c_f[x_a][14] = { 11,  14}; //   2
  c_t[x_a][14] = { 22,  25,  27}; //   3
  c_d[x_a][14] = {}; //   0

  c_p[x_a][15] = {}; //   0
  c_f[x_a][15] = {  4,   5}; //   2
  c_t[x_a][15] = {  6,   7,  28}; //   3
  c_d[x_a][15] = {}; //   0

  c_p[x_a][16] = {}; //   0
  c_f[x_a][16] = {  8,  13}; //   2
  c_t[x_a][16] = { 22,  23,  29}; //   3
  c_d[x_a][16] = {}; //   0

  c_p[x_a][17] = {}; //   0
  c_f[x_a][17] = {  6,  15}; //   2
  c_t[x_a][17] = { 22,  30,  31}; //   3
  c_d[x_a][17] = {}; //   0

  c_p[x_a][18] = {}; //   0
  c_f[x_a][18] = {  6,  15}; //   2
  c_t[x_a][18] = { 22,  30,  32}; //   3
  c_d[x_a][18] = {}; //   0

  c_p[x_a][19] = {}; //   0
  c_f[x_a][19] = {  0,  16}; //   2
  c_t[x_a][19] = {  6,  33,  34}; //   3
  c_d[x_a][19] = {}; //   0

  c_p[x_a][20] = {}; //   0
  c_f[x_a][20] = {  4,  10}; //   2
  c_t[x_a][20] = { 15,  16,  35}; //   3
  c_d[x_a][20] = {}; //   0

  c_p[x_a][21] = {}; //   0
  c_f[x_a][21] = {  2,  17}; //   2
  c_t[x_a][21] = { 15,  36,  37}; //   3
  c_d[x_a][21] = {}; //   0

  c_p[x_a][22] = {}; //   0
  c_f[x_a][22] = {  2,  17}; //   2
  c_t[x_a][22] = { 15,  36,  38}; //   3
  c_d[x_a][22] = {}; //   0

  c_p[x_a][23] = {}; //   0
  c_f[x_a][23] = {  0,  16}; //   2
  c_t[x_a][23] = {  6,  33,  39}; //   3
  c_d[x_a][23] = {}; //   0

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = {  5}; //   1
  c_t[x_a][24] = { 40,  41}; //   2
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  0}; //   1
  c_f[x_a][25] = { 10}; //   1
  c_t[x_a][25] = { 42,  43}; //   2
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  1}; //   1
  c_f[x_a][26] = { 12}; //   1
  c_t[x_a][26] = { 42,  44}; //   2
  c_d[x_a][26] = {  1}; //   1

  c_p[x_a][27] = {  2}; //   1
  c_f[x_a][27] = {  9}; //   1
  c_t[x_a][27] = { 40,  45}; //   2
  c_d[x_a][27] = {  2}; //   1

  c_p[x_a][28] = {  2}; //   1
  c_f[x_a][28] = { 13}; //   1
  c_t[x_a][28] = { 46,  47}; //   2
  c_d[x_a][28] = {  2}; //   1

  c_p[x_a][29] = {  1}; //   1
  c_f[x_a][29] = { 14}; //   1
  c_t[x_a][29] = { 46,  48}; //   2
  c_d[x_a][29] = {  1}; //   1

  c_p[x_a][30] = {  3}; //   1
  c_f[x_a][30] = { 15}; //   1
  c_t[x_a][30] = { 46,  49}; //   2
  c_d[x_a][30] = {  3}; //   1

  c_p[x_a][31] = {  4}; //   1
  c_f[x_a][31] = { 17}; //   1
  c_t[x_a][31] = { 42,  50}; //   2
  c_d[x_a][31] = {  4}; //   1

  c_p[x_a][32] = {  5}; //   1
  c_f[x_a][32] = { 16}; //   1
  c_t[x_a][32] = { 40,  51}; //   2
  c_d[x_a][32] = {  5}; //   1

  c_p[x_a][33] = {  5}; //   1
  c_f[x_a][33] = {  1}; //   1
  c_t[x_a][33] = { 52,  53}; //   2
  c_d[x_a][33] = {  5}; //   1

  c_p[x_a][34] = {  4}; //   1
  c_f[x_a][34] = {  3}; //   1
  c_t[x_a][34] = { 52,  54}; //   2
  c_d[x_a][34] = {  4}; //   1

  c_p[x_a][35] = {  3}; //   1
  c_f[x_a][35] = {  7}; //   1
  c_t[x_a][35] = { 52,  55}; //   2
  c_d[x_a][35] = {  3}; //   1

  c_p[x_a][36] = {  5,   6}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = { 40}; //   1
  c_d[x_a][36] = {  6,   5}; //   2

  c_p[x_a][37] = {  4,   7}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 42}; //   1
  c_d[x_a][37] = {  7,   4}; //   2

  c_p[x_a][38] = {  0,   8}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 42}; //   1
  c_d[x_a][38] = {  8,   0}; //   2

  c_p[x_a][39] = {  3,   9}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 46}; //   1
  c_d[x_a][39] = {  9,   3}; //   2

  c_p[x_a][40] = {  2,  10}; //   2
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 46}; //   1
  c_d[x_a][40] = { 10,   2}; //   2

  c_p[x_a][41] = {  0,  11}; //   2
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 40}; //   1
  c_d[x_a][41] = { 11,   0}; //   2

  c_p[x_a][42] = {  1,  12}; //   2
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 46}; //   1
  c_d[x_a][42] = { 12,   1}; //   2

  c_p[x_a][43] = {  2,  13}; //   2
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 40}; //   1
  c_d[x_a][43] = { 13,   2}; //   2

  c_p[x_a][44] = {  1,  14}; //   2
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 42}; //   1
  c_d[x_a][44] = { 14,   1}; //   2

  c_p[x_a][45] = {  3,  15}; //   2
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = { 52}; //   1
  c_d[x_a][45] = { 15,   3}; //   2

  c_p[x_a][46] = {  5,  16}; //   2
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 52}; //   1
  c_d[x_a][46] = { 16,   5}; //   2

  c_p[x_a][47] = {  4,  17}; //   2
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 52}; //   1
  c_d[x_a][47] = { 17,   4}; //   2

  c_p[x_a][48] = {  3,  15}; //   2
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {}; //   0
  c_d[x_a][48] = { 18,  15,   3}; //   3

  c_p[x_a][49] = {  5,  16}; //   2
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {}; //   0
  c_d[x_a][49] = { 18,  16,   5}; //   3

  c_p[x_a][50] = {  5,   6}; //   2
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {}; //   0
  c_d[x_a][50] = { 19,   6,   5}; //   3

  c_p[x_a][51] = {  4,  17}; //   2
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {}; //   0
  c_d[x_a][51] = { 18,  17,   4}; //   3

  c_p[x_a][52] = {  4,   7}; //   2
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {}; //   0
  c_d[x_a][52] = { 20,   7,   4}; //   3

  c_p[x_a][53] = {  0,   8}; //   2
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {}; //   0
  c_d[x_a][53] = { 20,   8,   0}; //   3

  c_p[x_a][54] = {  0,  11}; //   2
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {}; //   0
  c_d[x_a][54] = { 19,  11,   0}; //   3

  c_p[x_a][55] = {  3,   9}; //   2
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {}; //   0
  c_d[x_a][55] = { 21,   9,   3}; //   3

  c_p[x_a][56] = {  2,  10}; //   2
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {}; //   0
  c_d[x_a][56] = { 21,  10,   2}; //   3

  c_p[x_a][57] = {  2,  13}; //   2
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {}; //   0
  c_d[x_a][57] = { 19,  13,   2}; //   3

  c_p[x_a][58] = {  1,  12}; //   2
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {}; //   0
  c_d[x_a][58] = { 21,  12,   1}; //   3

  c_p[x_a][59] = {  1,  14}; //   2
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {}; //   0
  c_d[x_a][59] = { 20,  14,   1}; //   3

  c_p[x_a][60] = {  3,  18}; //   2
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {}; //   0
  c_d[x_a][60] = { 22,   0,   3}; //   3

  c_p[x_a][61] = {  5,  19}; //   2
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {}; //   0
  c_d[x_a][61] = { 23,   1,   5}; //   3

  c_p[x_a][62] = {  4,  20}; //   2
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {}; //   0
  c_d[x_a][62] = { 24,   2,   4}; //   3

  c_p[x_a][63] = {  5}; //   1
  c_f[x_a][63] = {  1}; //   1
  c_t[x_a][63] = {  0,   1}; //   2
  c_d[x_a][63] = {  5}; //   1

  c_p[x_a][64] = {  4}; //   1
  c_f[x_a][64] = {  3}; //   1
  c_t[x_a][64] = {  0,   3}; //   2
  c_d[x_a][64] = {  4}; //   1

  c_p[x_a][65] = {  0}; //   1
  c_f[x_a][65] = {  5}; //   1
  c_t[x_a][65] = {  6,   7}; //   2
  c_d[x_a][65] = {  0}; //   1

  c_p[x_a][66] = {  3}; //   1
  c_f[x_a][66] = {  7}; //   1
  c_t[x_a][66] = {  0,  10}; //   2
  c_d[x_a][66] = {  3}; //   1

  c_p[x_a][67] = {  2}; //   1
  c_f[x_a][67] = {  9}; //   1
  c_t[x_a][67] = {  6,  13}; //   2
  c_d[x_a][67] = {  2}; //   1

  c_p[x_a][68] = {  0}; //   1
  c_f[x_a][68] = { 10}; //   1
  c_t[x_a][68] = { 15,  16}; //   2
  c_d[x_a][68] = {  0}; //   1

  c_p[x_a][69] = {  1}; //   1
  c_f[x_a][69] = { 12}; //   1
  c_t[x_a][69] = { 15,  18}; //   2
  c_d[x_a][69] = {  1}; //   1

  c_p[x_a][70] = {  2}; //   1
  c_f[x_a][70] = { 13}; //   1
  c_t[x_a][70] = { 22,  23}; //   2
  c_d[x_a][70] = {  2}; //   1

  c_p[x_a][71] = {  1}; //   1
  c_f[x_a][71] = { 14}; //   1
  c_t[x_a][71] = { 22,  25}; //   2
  c_d[x_a][71] = {  1}; //   1

  c_p[x_a][72] = {  3}; //   1
  c_f[x_a][72] = { 15}; //   1
  c_t[x_a][72] = { 22,  30}; //   2
  c_d[x_a][72] = {  3}; //   1

  c_p[x_a][73] = {  5}; //   1
  c_f[x_a][73] = { 16}; //   1
  c_t[x_a][73] = {  6,  33}; //   2
  c_d[x_a][73] = {  5}; //   1

  c_p[x_a][74] = {  4}; //   1
  c_f[x_a][74] = { 17}; //   1
  c_t[x_a][74] = { 15,  36}; //   2
  c_d[x_a][74] = {  4}; //   1

  c_p[x_a][75] = {  3,  15}; //   2
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  0}; //   1
  c_d[x_a][75] = { 15,   3}; //   2

  c_p[x_a][76] = {  5,  16}; //   2
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  0}; //   1
  c_d[x_a][76] = { 16,   5}; //   2

  c_p[x_a][77] = {  5,   6}; //   2
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {  6}; //   1
  c_d[x_a][77] = {  6,   5}; //   2

  c_p[x_a][78] = {  4,  17}; //   2
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = {  0}; //   1
  c_d[x_a][78] = { 17,   4}; //   2

  c_p[x_a][79] = {  4,   7}; //   2
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 15}; //   1
  c_d[x_a][79] = {  7,   4}; //   2

  c_p[x_a][80] = {  0,   8}; //   2
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = { 15}; //   1
  c_d[x_a][80] = {  8,   0}; //   2

  c_p[x_a][81] = {  0,  11}; //   2
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {  6}; //   1
  c_d[x_a][81] = { 11,   0}; //   2

  c_p[x_a][82] = {  3,   9}; //   2
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = { 22}; //   1
  c_d[x_a][82] = {  9,   3}; //   2

  c_p[x_a][83] = {  2,  10}; //   2
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = { 22}; //   1
  c_d[x_a][83] = { 10,   2}; //   2

  c_p[x_a][84] = {  2,  13}; //   2
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = {  6}; //   1
  c_d[x_a][84] = { 13,   2}; //   2

  c_p[x_a][85] = {  1,  12}; //   2
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = { 22}; //   1
  c_d[x_a][85] = { 12,   1}; //   2

  c_p[x_a][86] = {  1,  14}; //   2
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = { 15}; //   1
  c_d[x_a][86] = { 14,   1}; //   2

  c_p[x_a][87] = {  3}; //   1
  c_f[x_a][87] = {  7}; //   1
  c_t[x_a][87] = {  0,  56}; //   2
  c_d[x_a][87] = {  3}; //   1

  c_p[x_a][88] = {  5}; //   1
  c_f[x_a][88] = {  1}; //   1
  c_t[x_a][88] = {  0,  57}; //   2
  c_d[x_a][88] = {  5}; //   1

  c_p[x_a][89] = {  5}; //   1
  c_f[x_a][89] = { 16}; //   1
  c_t[x_a][89] = {  6,  58}; //   2
  c_d[x_a][89] = {  5}; //   1

  c_p[x_a][90] = {  4}; //   1
  c_f[x_a][90] = {  3}; //   1
  c_t[x_a][90] = {  0,  59}; //   2
  c_d[x_a][90] = {  4}; //   1

  c_p[x_a][91] = {  4}; //   1
  c_f[x_a][91] = { 17}; //   1
  c_t[x_a][91] = { 15,  60}; //   2
  c_d[x_a][91] = {  4}; //   1

  c_p[x_a][92] = {  0}; //   1
  c_f[x_a][92] = { 10}; //   1
  c_t[x_a][92] = { 15,  61}; //   2
  c_d[x_a][92] = {  0}; //   1

  c_p[x_a][93] = {  0}; //   1
  c_f[x_a][93] = {  5}; //   1
  c_t[x_a][93] = {  6,  62}; //   2
  c_d[x_a][93] = {  0}; //   1

  c_p[x_a][94] = {  3}; //   1
  c_f[x_a][94] = { 15}; //   1
  c_t[x_a][94] = { 22,  63}; //   2
  c_d[x_a][94] = {  3}; //   1

  c_p[x_a][95] = {  2}; //   1
  c_f[x_a][95] = { 13}; //   1
  c_t[x_a][95] = { 22,  64}; //   2
  c_d[x_a][95] = {  2}; //   1

  c_p[x_a][96] = {  2}; //   1
  c_f[x_a][96] = {  9}; //   1
  c_t[x_a][96] = {  6,  65}; //   2
  c_d[x_a][96] = {  2}; //   1

  c_p[x_a][97] = {  1}; //   1
  c_f[x_a][97] = { 14}; //   1
  c_t[x_a][97] = { 22,  66}; //   2
  c_d[x_a][97] = {  1}; //   1

  c_p[x_a][98] = {  1}; //   1
  c_f[x_a][98] = { 12}; //   1
  c_t[x_a][98] = { 15,  67}; //   2
  c_d[x_a][98] = {  1}; //   1

  c_p[x_a][99] = {  3,  18}; //   2
  c_f[x_a][99] = {}; //   0
  c_t[x_a][99] = { 68}; //   1
  c_d[x_a][99] = {  0,   3}; //   2

  c_p[x_a][100] = {  5,  19}; //   2
  c_f[x_a][100] = {}; //   0
  c_t[x_a][100] = { 69}; //   1
  c_d[x_a][100] = {  1,   5}; //   2

  c_p[x_a][101] = {  4,  20}; //   2
  c_f[x_a][101] = {}; //   0
  c_t[x_a][101] = { 70}; //   1
  c_d[x_a][101] = {  2,   4}; //   2

  c_p[x_a][102] = {  0,  21}; //   2
  c_f[x_a][102] = {}; //   0
  c_t[x_a][102] = { 71}; //   1
  c_d[x_a][102] = {  3,   0}; //   2

  c_p[x_a][103] = {  2,  22}; //   2
  c_f[x_a][103] = {}; //   0
  c_t[x_a][103] = { 72}; //   1
  c_d[x_a][103] = {  4,   2}; //   2

  c_p[x_a][104] = {  1,  23}; //   2
  c_f[x_a][104] = {}; //   0
  c_t[x_a][104] = { 73}; //   1
  c_d[x_a][104] = {  5,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_400_gg_ttxgg
//  channel    0: 1111(1, 2, 4, 8, 16, 32;   6,   0,   0)
//  channel    1: 1111(1, 2, 4, 8, 32, 16;   6,   0,   0)
//  channel    2: 1111(1, 2, 4, 32, 8, 16;   6,   0,   6)
//  channel    3: 1111(1, 2, 32, 4, 8, 16;   0,   0,   6)
//  channel    4: 1111(1, 2, 4, 16, 8, 32;   6,   0,   6)
//  channel    5: 1111(1, 2, 4, 16, 32, 8;   6,   6,   6)
//  channel    6: 1111(1, 2, 4, 32, 16, 8;   6,   6,   6)
//  channel    7: 1111(1, 2, 32, 4, 16, 8;   0,   6,   6)
//  channel    8: 1111(1, 2, 16, 4, 8, 32;   0,   0,   6)
//  channel    9: 1111(1, 2, 16, 4, 32, 8;   0,   6,   6)
//  channel   10: 1111(1, 2, 16, 32, 4, 8;   0,   6,   0)
//  channel   11: 1111(1, 2, 32, 16, 4, 8;   0,   6,   0)
//  channel   12: 1111(1, 2, 8, 4, 16, 32;   6,   0,   0)
//  channel   13: 1111(1, 2, 8, 4, 32, 16;   6,   0,   0)
//  channel   14: 1111(1, 2, 8, 32, 4, 16;   6,   0,   6)
//  channel   15: 1111(1, 2, 32, 8, 4, 16;   0,   0,   6)
//  channel   16: 1111(1, 2, 8, 16, 4, 32;   6,   0,   6)
//  channel   17: 1111(1, 2, 8, 16, 32, 4;   6,   6,   6)
//  channel   18: 1111(1, 2, 8, 32, 16, 4;   6,   6,   6)
//  channel   19: 1111(1, 2, 32, 8, 16, 4;   0,   6,   6)
//  channel   20: 1111(1, 2, 16, 8, 4, 32;   0,   0,   6)
//  channel   21: 1111(1, 2, 16, 8, 32, 4;   0,   6,   6)
//  channel   22: 1111(1, 2, 16, 32, 8, 4;   0,   6,   0)
//  channel   23: 1111(1, 2, 32, 16, 8, 4;   0,   6,   0)
//  channel   24: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   25: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel   26: 2v11(1, 2, 4, 32, 8, 16;   6,   0,   6)
//  channel   27: 2v11(1, 2, 4, 16, 8, 32;   6,   0,   6)
//  channel   28: 2v11(1, 2, 4, 16, 32, 8;   6,   6,   6)
//  channel   29: 2v11(1, 2, 4, 32, 16, 8;   6,   6,   6)
//  channel   30: 2v11(1, 2, 16, 32, 4, 8;   0,   6,   0)
//  channel   31: 2v11(1, 2, 8, 32, 4, 16;   6,   0,   6)
//  channel   32: 2v11(1, 2, 8, 16, 4, 32;   6,   0,   6)
//  channel   33: 2v11(1, 2, 8, 16, 32, 4;   6,   6,   6)
//  channel   34: 2v11(1, 2, 8, 32, 16, 4;   6,   6,   6)
//  channel   35: 2v11(1, 2, 16, 32, 8, 4;   0,   6,   0)
//  channel   36: 3yv1(1, 2, 4, 8, 16, 32;   6,   0,   0)
//  channel   37: 3yv1(1, 2, 4, 8, 32, 16;   6,   0,   0)
//  channel   38: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   39: 3yv1(1, 2, 4, 16, 32, 8;   0,   6,   6)
//  channel   40: 3yv1(1, 2, 32, 4, 16, 8;   6,   6,   6)
//  channel   41: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   42: 3yv1(1, 2, 16, 4, 32, 8;   6,   6,   6)
//  channel   43: 3yv1(1, 2, 8, 4, 16, 32;   6,   0,   0)
//  channel   44: 3yv1(1, 2, 8, 4, 32, 16;   6,   0,   0)
//  channel   45: 3yv1(1, 2, 8, 16, 32, 4;   0,   6,   6)
//  channel   46: 3yv1(1, 2, 32, 8, 16, 4;   6,   6,   6)
//  channel   47: 3yv1(1, 2, 16, 8, 32, 4;   6,   6,   6)
//  channel   48: 4yyv(1, 2, 4, 8, 16, 32;   0,   6,   0)
//  channel   49: 4yyv(1, 2, 4, 32, 8, 16;   6,   6,   0)
//  channel   50: 4yyv(1, 2, 32, 4, 8, 16;   6,   0,   0)
//  channel   51: 4yyv(1, 2, 4, 16, 8, 32;   6,   6,   0)
//  channel   52: 4yyv(1, 2, 16, 4, 8, 32;   6,   0,   0)
//  channel   53: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   54: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   55: 4yyv(1, 2, 8, 4, 16, 32;   0,   6,   0)
//  channel   56: 4yyv(1, 2, 8, 32, 4, 16;   6,   6,   0)
//  channel   57: 4yyv(1, 2, 32, 8, 4, 16;   6,   0,   0)
//  channel   58: 4yyv(1, 2, 8, 16, 4, 32;   6,   6,   0)
//  channel   59: 4yyv(1, 2, 16, 8, 4, 32;   6,   0,   0)
//  channel   60: 42vv(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   61: 42vv(1, 2, 4, 32, 8, 16;   6,   6,   0)
//  channel   62: 42vv(1, 2, 4, 16, 8, 32;   6,   6,   0)
//  channel   63: 12v1(1, 2, 4, 8, 16, 32;   6,   6,   0)
//  channel   64: 12v1(1, 2, 4, 8, 32, 16;   6,   6,   0)
//  channel   65: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   66: 12v1(1, 2, 4, 16, 32, 8;   0,   6,   6)
//  channel   67: 12v1(1, 2, 32, 4, 16, 8;   6,   0,   6)
//  channel   68: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   69: 12v1(1, 2, 16, 4, 32, 8;   6,   0,   6)
//  channel   70: 12v1(1, 2, 8, 4, 16, 32;   6,   6,   0)
//  channel   71: 12v1(1, 2, 8, 4, 32, 16;   6,   6,   0)
//  channel   72: 12v1(1, 2, 8, 16, 32, 4;   0,   6,   6)
//  channel   73: 12v1(1, 2, 32, 8, 16, 4;   6,   0,   6)
//  channel   74: 12v1(1, 2, 16, 8, 32, 4;   6,   0,   6)
//  channel   75: 13yv(1, 2, 4, 8, 16, 32;   0,   6,   6)
//  channel   76: 13yv(1, 2, 4, 32, 8, 16;   6,   6,   6)
//  channel   77: 13yv(1, 2, 32, 4, 8, 16;   6,   0,   0)
//  channel   78: 13yv(1, 2, 4, 16, 8, 32;   6,   6,   6)
//  channel   79: 13yv(1, 2, 16, 4, 8, 32;   6,   0,   0)
//  channel   80: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   81: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   82: 13yv(1, 2, 8, 4, 16, 32;   0,   6,   6)
//  channel   83: 13yv(1, 2, 8, 32, 4, 16;   6,   6,   6)
//  channel   84: 13yv(1, 2, 32, 8, 4, 16;   6,   0,   0)
//  channel   85: 13yv(1, 2, 8, 16, 4, 32;   6,   6,   6)
//  channel   86: 13yv(1, 2, 16, 8, 4, 32;   6,   0,   0)
//  channel   87: 112v(1, 2, 4, 8, 16, 32;   0,   6,   0)
//  channel   88: 112v(1, 2, 4, 32, 8, 16;   6,   6,   6)
//  channel   89: 112v(1, 2, 32, 4, 8, 16;   6,   0,   6)
//  channel   90: 112v(1, 2, 4, 16, 8, 32;   6,   6,   6)
//  channel   91: 112v(1, 2, 16, 4, 8, 32;   6,   0,   6)
//  channel   92: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   93: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   94: 112v(1, 2, 8, 4, 16, 32;   0,   6,   0)
//  channel   95: 112v(1, 2, 8, 32, 4, 16;   6,   6,   6)
//  channel   96: 112v(1, 2, 32, 8, 4, 16;   6,   0,   6)
//  channel   97: 112v(1, 2, 8, 16, 4, 32;   6,   6,   6)
//  channel   98: 112v(1, 2, 16, 8, 4, 32;   6,   0,   6)
//  channel   99: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel  100: 2v2v(1, 2, 4, 32, 8, 16;   6,   6,   6)
//  channel  101: 2v2v(1, 2, 4, 16, 8, 32;   6,   6,   6)
//  channel  102: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel  103: 2v2v(1, 2, 8, 32, 4, 16;   6,   6,   6)
//  channel  104: 2v2v(1, 2, 8, 16, 4, 32;   6,   6,   6)
