#include "header.hpp"

#include "ppttx20.phasespace.set.hpp"

void ppttx20_phasespace_set::ax_psp_400_gux_ttxgux(int x_a){
  static Logger logger("ppttx20_phasespace_set::ax_psp_400_gux_ttxgux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(16);
  needed_v_smin[x_a].resize(16);
  needed_v_smin[x_a][  0] = {   8,    9,   13,   14,   17,   18,   20,   22,   23,   26,   27,   30,   31,   33,   34,    3,    7}; //  17
  needed_v_smin[x_a][  1] = {  10,   15,   19,   24,   28,    4,    6}; //   7
  needed_v_smin[x_a][  2] = {  11,   12,   16,   21,   25,    0,    2}; //   7
  needed_v_smin[x_a][  3] = {  12,   16,   25,   11}; //   4
  needed_v_smin[x_a][  4] = {  13,   17,   26,    3,    7,    9,   23,   30}; //   8
  needed_v_smin[x_a][  5] = {  14,   18,   27,    8,   22,   31}; //   6
  needed_v_smin[x_a][  6] = {  15,   19,   28,   10}; //   4
  needed_v_smin[x_a][  7] = {  20,   29,   32,   33,   34}; //   5
  needed_v_smin[x_a][  8] = {   0,    2,   21}; //   3
  needed_v_smin[x_a][  9] = {   1}; //   1
  needed_v_smin[x_a][ 10] = {   1}; //   1
  needed_v_smin[x_a][ 11] = {   4,    6,   24}; //   3
  needed_v_smin[x_a][ 12] = {   5}; //   1
  needed_v_smin[x_a][ 13] = {   5}; //   1
  needed_v_smin[x_a][ 14] = {  29}; //   1
  needed_v_smin[x_a][ 15] = {  32}; //   1

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  needed_v_smax[x_a][  0] = {   8,    9,   13,   14,   17,   18,   22,   23,   26,   27,   30,   31,   34,    3,    7}; //  15
  needed_v_smax[x_a][  1] = {  10,   15,   19,   24,   28,    4,    6}; //   7
  needed_v_smax[x_a][  2] = {  11,   12,   16,   21,   25,    0,    2}; //   7
  needed_v_smax[x_a][  3] = {  12,   14,   15,   16,   18,   19,   25,   27,   28,    8,   10,   11,   22,   31}; //  14
  needed_v_smax[x_a][  4] = {  13,   17,   26,    3,    7,    9,   23,   30}; //   8
  needed_v_smax[x_a][  5] = {  20,   29,   32,   33}; //   4
  needed_v_smax[x_a][  6] = {  20,   33}; //   2
  needed_v_smax[x_a][  7] = {  34}; //   1
  needed_v_smax[x_a][  8] = {   0,    1,    2,   21,   29}; //   5
  needed_v_smax[x_a][  9] = {   1}; //   1
  needed_v_smax[x_a][ 10] = {   4,    5,    6,   24,   32}; //   5
  needed_v_smax[x_a][ 11] = {   5}; //   1

  g_p[x_a].resize(10);
  needed_g_p[x_a].resize(10);
  needed_g_p[x_a][0] = {   8,    9,   13,   14,   17,   18,   22,   23,   26,   27,   30,   31,   34}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  10,   15,   19,   24,   28}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin1_smax1");
  needed_g_p[x_a][2] = {  11,   12,   16,   21,   25}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin2_smax2");
  needed_g_p[x_a][3] = {  12,   16,   25}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  13,   17,   26}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {  14,   18,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax3");
  needed_g_p[x_a][6] = {  15,   19,   28}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax3");
  needed_g_p[x_a][7] = {  20,   29,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {  20,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][9] = {  34}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax7");

  g_f[x_a].resize(15);
  needed_g_f[x_a].resize(15);
  needed_g_f[x_a][0] = {   0,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   0,    2,   21}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax8");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax9");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax8");
  needed_g_f[x_a][4] = {   3,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][5] = {   3,    7,    9,   23,   30}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][6] = {   4,    6}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {   4,    6,   24}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax10");
  needed_g_f[x_a][8] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax11");
  needed_g_f[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax10");
  needed_g_f[x_a][10] = {   8,   22,   31}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax3");
  needed_g_f[x_a][11] = {  10}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax3");
  needed_g_f[x_a][12] = {  11}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][13] = {  29}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax8");
  needed_g_f[x_a][14] = {  32}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax10");

  g_t[x_a].resize(30);
  needed_g_t[x_a].resize(30);
  needed_g_t[x_a][0] = {   0,    1,    2,   21,   29}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__4_56");
  needed_g_t[x_a][1] = {   0,    2,   21}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_32");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__5_34__16_8");
  needed_g_t[x_a][6] = {   3,    7,   23,   26,   30}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][7] = {   3,    7,   23}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__4_8");
  needed_g_t[x_a][9] = {   4,    5,    6,   24,   32}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__8_52");
  needed_g_t[x_a][10] = {   4,    6,   24}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][11] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][12] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_36");
  needed_g_t[x_a][13] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__4_32");
  needed_g_t[x_a][14] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__9_34__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__9_34__16_4");
  needed_g_t[x_a][15] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__8_4");
  needed_g_t[x_a][16] = {   8,   10,   11,   12,   14,   15}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][17] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][18] = {   9,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][19] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][20] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_34__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_34__20_8");
  needed_g_t[x_a][21] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_34__24_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_34__24_4");
  needed_g_t[x_a][22] = {  22,   25,   27,   28,   31}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][23] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][24] = {  29}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__48_8");
  needed_g_t[x_a][25] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][26] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");
  needed_g_t[x_a][27] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__48_4");
  needed_g_t[x_a][28] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][29] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   8,    9,   13,   14,   17,   18,   20,   22,   23,   26,   27,   30,   31,   33,   34}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  10,   15,   19,   24,   28}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][2] = {  11,   12,   16,   21,   25}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  12,   16,   25}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {  13,   17,   26}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {  14,   18,   27}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][6] = {  15,   19,   28}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][7] = {  16,   18,   19}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {  17}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  20}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][10] = {  20,   29,   32,   33,   34}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(35);
  c_f[x_a].resize(35);
  c_t[x_a].resize(35);
  c_d[x_a].resize(35);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  0,   1}; //   2
  c_t[x_a][2] = {  0,   1,   5}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  4,   5}; //   2
  c_t[x_a][3] = {  6,   7,   8}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  6,   7}; //   2
  c_t[x_a][4] = {  9,  10,  11}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  8,   9}; //   2
  c_t[x_a][5] = {  9,  12,  13}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  6,   7}; //   2
  c_t[x_a][6] = {  9,  10,  14}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  4,   5}; //   2
  c_t[x_a][7] = {  6,   7,  15}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = { 10}; //   1
  c_t[x_a][8] = { 16,  17}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  5}; //   1
  c_t[x_a][9] = { 18,  19}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  1}; //   1
  c_f[x_a][10] = { 11}; //   1
  c_t[x_a][10] = { 16,  20}; //   2
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  2}; //   1
  c_f[x_a][11] = { 12}; //   1
  c_t[x_a][11] = { 16,  21}; //   2
  c_d[x_a][11] = {  2}; //   1

  c_p[x_a][12] = {  2,   3}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 16}; //   1
  c_d[x_a][12] = {  3,   2}; //   2

  c_p[x_a][13] = {  0,   4}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 18}; //   1
  c_d[x_a][13] = {  4,   0}; //   2

  c_p[x_a][14] = {  0,   5}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 16}; //   1
  c_d[x_a][14] = {  5,   0}; //   2

  c_p[x_a][15] = {  1,   6}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 16}; //   1
  c_d[x_a][15] = {  6,   1}; //   2

  c_p[x_a][16] = {  2,   3}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  7,   3,   2}; //   3

  c_p[x_a][17] = {  0,   4}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  8,   4,   0}; //   3

  c_p[x_a][18] = {  0,   5}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  7,   5,   0}; //   3

  c_p[x_a][19] = {  1,   6}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  7,   6,   1}; //   3

  c_p[x_a][20] = {  7,   8}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  9,   0,  10}; //   3

  c_p[x_a][21] = {  2}; //   1
  c_f[x_a][21] = {  1}; //   1
  c_t[x_a][21] = {  0,   1}; //   2
  c_d[x_a][21] = {  2}; //   1

  c_p[x_a][22] = {  0}; //   1
  c_f[x_a][22] = { 10}; //   1
  c_t[x_a][22] = { 22,  23}; //   2
  c_d[x_a][22] = {  0}; //   1

  c_p[x_a][23] = {  0}; //   1
  c_f[x_a][23] = {  5}; //   1
  c_t[x_a][23] = {  6,   7}; //   2
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  1}; //   1
  c_f[x_a][24] = {  7}; //   1
  c_t[x_a][24] = {  9,  10}; //   2
  c_d[x_a][24] = {  1}; //   1

  c_p[x_a][25] = {  2,   3}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = { 22}; //   1
  c_d[x_a][25] = {  3,   2}; //   2

  c_p[x_a][26] = {  0,   4}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  6}; //   1
  c_d[x_a][26] = {  4,   0}; //   2

  c_p[x_a][27] = {  0,   5}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 22}; //   1
  c_d[x_a][27] = {  5,   0}; //   2

  c_p[x_a][28] = {  1,   6}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 22}; //   1
  c_d[x_a][28] = {  6,   1}; //   2

  c_p[x_a][29] = {  7}; //   1
  c_f[x_a][29] = { 13}; //   1
  c_t[x_a][29] = {  0,  24}; //   2
  c_d[x_a][29] = { 10}; //   1

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = {  5}; //   1
  c_t[x_a][30] = {  6,  25}; //   2
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  0}; //   1
  c_f[x_a][31] = { 10}; //   1
  c_t[x_a][31] = { 22,  26}; //   2
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  7}; //   1
  c_f[x_a][32] = { 14}; //   1
  c_t[x_a][32] = {  9,  27}; //   2
  c_d[x_a][32] = { 10}; //   1

  c_p[x_a][33] = {  7,   8}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = { 28}; //   1
  c_d[x_a][33] = {  0,  10}; //   2

  c_p[x_a][34] = {  0,   9}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = { 29}; //   1
  c_d[x_a][34] = { 10,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_400_gux_ttxgux
//  channel    0: 1111(1, 2, 4, 8, 16, 32;   6,   0,   0)
//  channel    1: 1111(1, 2, 4, 8, 32, 16;   6,   0,   0)
//  channel    2: 1111(1, 2, 4, 16, 8, 32;   6,   0,   6)
//  channel    3: 1111(1, 2, 16, 4, 8, 32;   0,   0,   6)
//  channel    4: 1111(1, 2, 8, 4, 16, 32;   6,   0,   0)
//  channel    5: 1111(1, 2, 8, 4, 32, 16;   6,   0,   0)
//  channel    6: 1111(1, 2, 8, 16, 4, 32;   6,   0,   6)
//  channel    7: 1111(1, 2, 16, 8, 4, 32;   0,   0,   6)
//  channel    8: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    9: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel   10: 2v11(1, 2, 4, 16, 8, 32;   6,   0,   6)
//  channel   11: 2v11(1, 2, 8, 16, 4, 32;   6,   0,   6)
//  channel   12: 3yv1(1, 2, 4, 8, 16, 32;   6,   0,   0)
//  channel   13: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   14: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   15: 3yv1(1, 2, 8, 4, 16, 32;   6,   0,   0)
//  channel   16: 4yyv(1, 2, 32, 4, 8, 16;   6,   0,   0)
//  channel   17: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   18: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   19: 4yyv(1, 2, 32, 8, 4, 16;   6,   0,   0)
//  channel   20: 42vv(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   21: 12v1(1, 2, 4, 8, 16, 32;   6,   6,   0)
//  channel   22: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   23: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   24: 12v1(1, 2, 8, 4, 16, 32;   6,   6,   0)
//  channel   25: 13yv(1, 2, 32, 4, 8, 16;   6,   0,   0)
//  channel   26: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   27: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   28: 13yv(1, 2, 32, 8, 4, 16;   6,   0,   0)
//  channel   29: 112v(1, 2, 4, 8, 16, 32;   0,   6,   0)
//  channel   30: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   31: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   32: 112v(1, 2, 8, 4, 16, 32;   0,   6,   0)
//  channel   33: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   34: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
