#include "header.hpp"

#include "ppw01.phasespace.set.hpp"

void ppw01_phasespace_set::ax_psp_210_ssx_wmubx(int x_a){
  static Logger logger("ppw01_phasespace_set::ax_psp_210_ssx_wmubx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(2);
  needed_v_smin[x_a].resize(2);
  needed_v_smin[x_a][  0] = {   0}; //   1
  needed_v_smin[x_a][  1] = {   1}; //   1

  v_smax[x_a].resize(2);
  needed_v_smax[x_a].resize(2);
  needed_v_smax[x_a][  0] = {   0}; //   1
  needed_v_smax[x_a][  1] = {   1}; //   1

  g_p[x_a].resize(2);
  needed_g_p[x_a].resize(2);
  needed_g_p[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(0);
  needed_g_t[x_a].resize(0);

  g_d[x_a].resize(4);
  needed_g_d[x_a].resize(4);
  needed_g_d[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");

  c_p[x_a].resize(2);
  c_f[x_a].resize(2);
  c_t[x_a].resize(2);
  c_d[x_a].resize(2);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  1}; //   1
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  2,   3}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_210_ssx_wmubx
//  channel    0: 3yv(1, 2, 16, 4, 8;   0,   0)
//  channel    1: 3yv(1, 2, 8, 4, 16;   0,   0)
