#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ag_psp_320_gg_wpwmg(int x_a, int zero){
  static Logger logger("ppwxw02_phasespace_set::ag_psp_320_gg_wpwmg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][5] == nullvector){xbp_all[x_a][5] = xbp_all[x_a][1] - xbp_all[x_a][4];}
  if (xbs_all[x_a][5] == 0.){xbs_all[x_a][5] = xbp_all[x_a][5].m2();}
  if (xbs_all[x_a][5] > 0.){xbs_all[x_a][5] = 0.;}
  if (xbp_all[x_a][6] == nullvector){xbp_all[x_a][6] = xbp_all[x_a][2] - xbp_all[x_a][4];}
  if (xbs_all[x_a][6] == 0.){xbs_all[x_a][6] = xbp_all[x_a][6].m2();}
  if (xbs_all[x_a][6] > 0.){xbs_all[x_a][6] = 0.;}
  if (xbp_all[x_a][9] == nullvector){xbp_all[x_a][9] = xbp_all[x_a][1] - xbp_all[x_a][8];}
  if (xbs_all[x_a][9] == 0.){xbs_all[x_a][9] = xbp_all[x_a][9].m2();}
  if (xbs_all[x_a][9] > 0.){xbs_all[x_a][9] = 0.;}
  if (xbp_all[x_a][10] == nullvector){xbp_all[x_a][10] = xbp_all[x_a][2] - xbp_all[x_a][8];}
  if (xbs_all[x_a][10] == 0.){xbs_all[x_a][10] = xbp_all[x_a][10].m2();}
  if (xbs_all[x_a][10] > 0.){xbs_all[x_a][10] = 0.;}
  if (xbp_all[x_a][12] == nullvector){xbp_all[x_a][12] = xbp_all[x_a][4] + xbp_all[x_a][8];}
  if (xbs_all[x_a][12] == 0.){xbs_all[x_a][12] = xbp_all[x_a][12].m2();}
  if (xbs_all[x_a][12] < 0.){xbs_all[x_a][12] = 0.;}
  if (xbp_all[x_a][17] == nullvector){xbp_all[x_a][17] = xbp_all[x_a][1] - xbp_all[x_a][16];}
  if (xbs_all[x_a][17] == 0.){xbs_all[x_a][17] = xbp_all[x_a][17].m2();}
  if (xbs_all[x_a][17] > 0.){xbs_all[x_a][17] = 0.;}
  if (xbp_all[x_a][18] == nullvector){xbp_all[x_a][18] = xbp_all[x_a][2] - xbp_all[x_a][16];}
  if (xbs_all[x_a][18] == 0.){xbs_all[x_a][18] = xbp_all[x_a][18].m2();}
  if (xbs_all[x_a][18] > 0.){xbs_all[x_a][18] = 0.;}
  if (xbp_all[x_a][20] == nullvector){xbp_all[x_a][20] = xbp_all[x_a][4] + xbp_all[x_a][16];}
  if (xbs_all[x_a][20] == 0.){xbs_all[x_a][20] = xbp_all[x_a][20].m2();}
  if (xbs_all[x_a][20] < 0.){xbs_all[x_a][20] = 0.;}
  if (xbp_all[x_a][24] == nullvector){xbp_all[x_a][24] = xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][24] == 0.){xbs_all[x_a][24] = xbp_all[x_a][24].m2();}
  if (xbs_all[x_a][24] < 0.){xbs_all[x_a][24] = 0.;}
  if (xbp_all[x_a][28] == nullvector){xbp_all[x_a][28] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][28] == 0.){xbs_all[x_a][28] = xbp_all[x_a][28].m2();}
  if (xbs_all[x_a][28] < 0.){xbs_all[x_a][28] = 0.;}

  v_smin[x_a][  0] = smin_opt[x_a][12]; // 63 times
  v_smin[x_a][  1] = smin_opt[x_a][20]; // 21 times
  v_smin[x_a][  2] = smin_opt[x_a][24]; // 21 times

  v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2); // 63 times
  v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2); // 21 times
  v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2); // 21 times

  //  vector<double> g_p(11);
  {g_p[x_a][  0] = g_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 18 times
  {g_p[x_a][  1] = g_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 12 times
  {g_p[x_a][  2] = g_propagator(x_a,  25,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 9 times
  {g_p[x_a][  3] = g_propagator(x_a,  35,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 6 times
  {g_p[x_a][  4] = g_propagator(x_a,  36,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 6 times
  {g_p[x_a][  5] = g_propagator(x_a,   0,  20, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 2 */} // 4 times
  {g_p[x_a][  6] = g_propagator(x_a,  36,  20, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 2 */} // 4 times
  {g_p[x_a][  7] = g_propagator(x_a,  35,  20, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 2 */} // 4 times
  {g_p[x_a][  8] = g_propagator(x_a,   0,  24, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 2 */} // 4 times
  {g_p[x_a][  9] = g_propagator(x_a,  35,  24, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 2 */} // 4 times
  {g_p[x_a][ 10] = g_propagator(x_a,  36,  24, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 2 */} // 4 times

  //  vector<double> g_f(3);
  {g_f[x_a][  0] = g_timelikeinvariant(v_smin[x_a][  2], v_smax[x_a][  2]); /* nfp 2 */} // 9 times
  {g_f[x_a][  1] = g_timelikeinvariant(v_smin[x_a][  0], v_smax[x_a][  0]); /* nfp 2 */} // 12 times
  {g_f[x_a][  2] = g_timelikeinvariant(v_smin[x_a][  1], v_smax[x_a][  1]); /* nfp 2 */} // 9 times

  //  vector<double> g_t(36);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  28,   1,   2,   4,  24); /* ntp 0 */} // 4 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,   0,  24,   2,   5,  16,   8); /* ntp 1 */} // 4 times
  {g_t[x_a][  2] = g_tchannel_opt(x_a,  35,  28,   1,   2,   4,  24); /* ntp 0 */} // 4 times
  {g_t[x_a][  3] = g_tchannel_opt(x_a,  36,  24,   2,   5,  16,   8); /* ntp 1 */} // 1 times
  {g_t[x_a][  4] = g_tchannel_opt(x_a,  36,  28,   1,   2,   4,  24); /* ntp 0 */} // 4 times
  {g_t[x_a][  5] = g_tchannel_opt(x_a,  35,  24,   2,   5,  16,   8); /* ntp 1 */} // 1 times
  {g_t[x_a][  6] = g_tchannel_opt(x_a,   0,  24,   2,   5,   8,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][  7] = g_tchannel_opt(x_a,  35,  24,   2,   5,   8,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][  8] = g_tchannel_opt(x_a,  36,  24,   2,   5,   8,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][  9] = g_tchannel_opt(x_a,   0,  28,   1,   2,  16,  12); /* ntp 0 */} // 17 times
  {g_t[x_a][ 10] = g_tchannel_opt(x_a,   0,  12,   2,  17,   8,   4); /* ntp 1 */} // 2 times
  {g_t[x_a][ 11] = g_tchannel_opt(x_a,  36,  12,   2,  17,   8,   4); /* ntp 1 */} // 2 times
  {g_t[x_a][ 12] = g_tchannel_opt(x_a,  35,  12,   2,  17,   8,   4); /* ntp 1 */} // 2 times
  {g_t[x_a][ 13] = g_tchannel_opt(x_a,  36,  28,   1,   2,  16,  12); /* ntp 0 */} // 6 times
  {g_t[x_a][ 14] = g_tchannel_opt(x_a,  35,  28,   1,   2,  16,  12); /* ntp 0 */} // 6 times
  {g_t[x_a][ 15] = g_tchannel_opt(x_a,   0,  28,   1,   2,   8,  20); /* ntp 0 */} // 4 times
  {g_t[x_a][ 16] = g_tchannel_opt(x_a,   0,  20,   2,   9,  16,   4); /* ntp 1 */} // 4 times
  {g_t[x_a][ 17] = g_tchannel_opt(x_a,  36,  28,   1,   2,   8,  20); /* ntp 0 */} // 4 times
  {g_t[x_a][ 18] = g_tchannel_opt(x_a,  35,  20,   2,   9,  16,   4); /* ntp 1 */} // 1 times
  {g_t[x_a][ 19] = g_tchannel_opt(x_a,  35,  28,   1,   2,   8,  20); /* ntp 0 */} // 4 times
  {g_t[x_a][ 20] = g_tchannel_opt(x_a,  36,  20,   2,   9,  16,   4); /* ntp 1 */} // 1 times
  {g_t[x_a][ 21] = g_tchannel_opt(x_a,   0,  20,   2,   9,   4,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][ 22] = g_tchannel_opt(x_a,  36,  20,   2,   9,   4,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][ 23] = g_tchannel_opt(x_a,  35,  20,   2,   9,   4,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][ 24] = g_tchannel_opt(x_a,   0,  12,   2,  17,   4,   8); /* ntp 1 */} // 2 times
  {g_t[x_a][ 25] = g_tchannel_opt(x_a,  35,  12,   2,  17,   4,   8); /* ntp 1 */} // 2 times
  {g_t[x_a][ 26] = g_tchannel_opt(x_a,  36,  12,   2,  17,   4,   8); /* ntp 1 */} // 2 times
  {g_t[x_a][ 27] = g_tchannel_opt(x_a,   0,  28,   2,   1,  16,  12); /* ntp 0 */} // 9 times
  {g_t[x_a][ 28] = g_tchannel_opt(x_a,  35,  28,   2,   1,  16,  12); /* ntp 0 */} // 4 times
  {g_t[x_a][ 29] = g_tchannel_opt(x_a,  36,  28,   2,   1,  16,  12); /* ntp 0 */} // 4 times
  {g_t[x_a][ 30] = g_tchannel_opt(x_a,   0,  28,   2,   1,   8,  20); /* ntp 0 */} // 1 times
  {g_t[x_a][ 31] = g_tchannel_opt(x_a,  36,  28,   2,   1,   8,  20); /* ntp 0 */} // 1 times
  {g_t[x_a][ 32] = g_tchannel_opt(x_a,  35,  28,   2,   1,   8,  20); /* ntp 0 */} // 1 times
  {g_t[x_a][ 33] = g_tchannel_opt(x_a,   0,  28,   2,   1,   4,  24); /* ntp 0 */} // 1 times
  {g_t[x_a][ 34] = g_tchannel_opt(x_a,  35,  28,   2,   1,   4,  24); /* ntp 0 */} // 1 times
  {g_t[x_a][ 35] = g_tchannel_opt(x_a,  36,  28,   2,   1,   4,  24); /* ntp 0 */} // 1 times

  //  vector<double> g_d(6);
  {g_d[x_a][  0] = g_decay(x_a,  12,   4,   8); /* ndp 2 */} // 51 times
  {g_d[x_a][  1] = g_decay(x_a,  20,   4,  16); /* ndp 2 */} // 12 times
  {g_d[x_a][  2] = g_decay(x_a,  24,   8,  16); /* ndp 2 */} // 12 times
  {g_d[x_a][  3] = g_decay(x_a,  28,   4,  24); /* ndp 3 */} // 6 times
  {g_d[x_a][  4] = g_decay(x_a,  28,  16,  12); /* ndp 3 */} // 17 times
  {g_d[x_a][  5] = g_decay(x_a,  28,   8,  20); /* ndp 3 */} // 6 times

  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(11);
    inv_r[1].resize(3);
    inv_r[2].resize(36);
    inv_r[3].resize(36);
    inv_r[4].resize(6);
    inv_r[5].resize(6);

    {inv_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][0]);} // 18 times
    {inv_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][1]);} // 12 times
    {inv_propagator(x_a,  25,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][2]);} // 9 times
    {inv_propagator(x_a,  35,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][3]);} // 6 times
    {inv_propagator(x_a,  36,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][4]);} // 6 times
    {inv_propagator(x_a,   0,  20, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][5]);} // 4 times
    {inv_propagator(x_a,  36,  20, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][6]);} // 4 times
    {inv_propagator(x_a,  35,  20, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][7]);} // 4 times
    {inv_propagator(x_a,   0,  24, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][8]);} // 4 times
    {inv_propagator(x_a,  35,  24, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][9]);} // 4 times
    {inv_propagator(x_a,  36,  24, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][10]);} // 4 times

    {inv_timelikeinvariant(x_a,  24, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[1][0]);} // 9 times
    {inv_timelikeinvariant(x_a,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[1][1]);} // 12 times
    {inv_timelikeinvariant(x_a,  20, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[1][2]);} // 9 times

    {inv_tchannel_opt(x_a,   0,  28,   1,   2,   4,  24, inv_r[2][0], inv_r[3][0]);} // 4 times
    {inv_tchannel_opt(x_a,   0,  24,   2,   5,  16,   8, inv_r[2][1], inv_r[3][1]);} // 4 times
    {inv_tchannel_opt(x_a,  35,  28,   1,   2,   4,  24, inv_r[2][2], inv_r[3][2]);} // 4 times
    {inv_tchannel_opt(x_a,  36,  24,   2,   5,  16,   8, inv_r[2][3], inv_r[3][3]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  28,   1,   2,   4,  24, inv_r[2][4], inv_r[3][4]);} // 4 times
    {inv_tchannel_opt(x_a,  35,  24,   2,   5,  16,   8, inv_r[2][5], inv_r[3][5]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  24,   2,   5,   8,  16, inv_r[2][6], inv_r[3][6]);} // 1 times
    {inv_tchannel_opt(x_a,  35,  24,   2,   5,   8,  16, inv_r[2][7], inv_r[3][7]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  24,   2,   5,   8,  16, inv_r[2][8], inv_r[3][8]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  28,   1,   2,  16,  12, inv_r[2][9], inv_r[3][9]);} // 17 times
    {inv_tchannel_opt(x_a,   0,  12,   2,  17,   8,   4, inv_r[2][10], inv_r[3][10]);} // 2 times
    {inv_tchannel_opt(x_a,  36,  12,   2,  17,   8,   4, inv_r[2][11], inv_r[3][11]);} // 2 times
    {inv_tchannel_opt(x_a,  35,  12,   2,  17,   8,   4, inv_r[2][12], inv_r[3][12]);} // 2 times
    {inv_tchannel_opt(x_a,  36,  28,   1,   2,  16,  12, inv_r[2][13], inv_r[3][13]);} // 6 times
    {inv_tchannel_opt(x_a,  35,  28,   1,   2,  16,  12, inv_r[2][14], inv_r[3][14]);} // 6 times
    {inv_tchannel_opt(x_a,   0,  28,   1,   2,   8,  20, inv_r[2][15], inv_r[3][15]);} // 4 times
    {inv_tchannel_opt(x_a,   0,  20,   2,   9,  16,   4, inv_r[2][16], inv_r[3][16]);} // 4 times
    {inv_tchannel_opt(x_a,  36,  28,   1,   2,   8,  20, inv_r[2][17], inv_r[3][17]);} // 4 times
    {inv_tchannel_opt(x_a,  35,  20,   2,   9,  16,   4, inv_r[2][18], inv_r[3][18]);} // 1 times
    {inv_tchannel_opt(x_a,  35,  28,   1,   2,   8,  20, inv_r[2][19], inv_r[3][19]);} // 4 times
    {inv_tchannel_opt(x_a,  36,  20,   2,   9,  16,   4, inv_r[2][20], inv_r[3][20]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  20,   2,   9,   4,  16, inv_r[2][21], inv_r[3][21]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  20,   2,   9,   4,  16, inv_r[2][22], inv_r[3][22]);} // 1 times
    {inv_tchannel_opt(x_a,  35,  20,   2,   9,   4,  16, inv_r[2][23], inv_r[3][23]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  12,   2,  17,   4,   8, inv_r[2][24], inv_r[3][24]);} // 2 times
    {inv_tchannel_opt(x_a,  35,  12,   2,  17,   4,   8, inv_r[2][25], inv_r[3][25]);} // 2 times
    {inv_tchannel_opt(x_a,  36,  12,   2,  17,   4,   8, inv_r[2][26], inv_r[3][26]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  28,   2,   1,  16,  12, inv_r[2][27], inv_r[3][27]);} // 9 times
    {inv_tchannel_opt(x_a,  35,  28,   2,   1,  16,  12, inv_r[2][28], inv_r[3][28]);} // 4 times
    {inv_tchannel_opt(x_a,  36,  28,   2,   1,  16,  12, inv_r[2][29], inv_r[3][29]);} // 4 times
    {inv_tchannel_opt(x_a,   0,  28,   2,   1,   8,  20, inv_r[2][30], inv_r[3][30]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  28,   2,   1,   8,  20, inv_r[2][31], inv_r[3][31]);} // 1 times
    {inv_tchannel_opt(x_a,  35,  28,   2,   1,   8,  20, inv_r[2][32], inv_r[3][32]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  28,   2,   1,   4,  24, inv_r[2][33], inv_r[3][33]);} // 1 times
    {inv_tchannel_opt(x_a,  35,  28,   2,   1,   4,  24, inv_r[2][34], inv_r[3][34]);} // 1 times
    {inv_tchannel_opt(x_a,  36,  28,   2,   1,   4,  24, inv_r[2][35], inv_r[3][35]);} // 1 times

    {inv_decay(x_a,  12,   4,   8, inv_r[4][0], inv_r[5][0]);} // 51 times
    {inv_decay(x_a,  20,   4,  16, inv_r[4][1], inv_r[5][1]);} // 12 times
    {inv_decay(x_a,  24,   8,  16, inv_r[4][2], inv_r[5][2]);} // 12 times
    {inv_decay(x_a,  28,   4,  24, inv_r[4][3], inv_r[5][3]);} // 6 times
    {inv_decay(x_a,  28,  16,  12, inv_r[4][4], inv_r[5][4]);} // 17 times
    {inv_decay(x_a,  28,   8,  20, inv_r[4][5], inv_r[5][5]);} // 6 times

    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(105, vector<double> (5));
      vector<double> g_IS(105, 1.);
      for (int i_c = 0; i_c < 105; i_c++){
        int ran = 0;
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 5; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_IS[  2] * g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  1];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_IS[  3] * g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  3];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_IS[  4] * g_f[x_a][  0] * g_t[x_a][  4] * g_t[x_a][  1];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_IS[  5] * g_f[x_a][  0] * g_t[x_a][  4] * g_t[x_a][  5];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_IS[  6] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  6];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_IS[  7] * g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  7];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_IS[  8] * g_f[x_a][  0] * g_t[x_a][  4] * g_t[x_a][  8];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_IS[  9] * g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 10];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_IS[ 10] * g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 11];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_IS[ 11] * g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 12];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_IS[ 12] * g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 10];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_IS[ 13] * g_f[x_a][  1] * g_t[x_a][ 13] * g_t[x_a][ 12];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_IS[ 14] * g_f[x_a][  1] * g_t[x_a][ 14] * g_t[x_a][ 11];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_IS[ 15] * g_f[x_a][  2] * g_t[x_a][ 15] * g_t[x_a][ 16];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_IS[ 16] * g_f[x_a][  2] * g_t[x_a][ 15] * g_t[x_a][ 16];}
      if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_IS[ 17] * g_f[x_a][  2] * g_t[x_a][ 17] * g_t[x_a][ 16];}
      if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_IS[ 18] * g_f[x_a][  2] * g_t[x_a][ 17] * g_t[x_a][ 18];}
      if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_IS[ 19] * g_f[x_a][  2] * g_t[x_a][ 19] * g_t[x_a][ 16];}
      if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_IS[ 20] * g_f[x_a][  2] * g_t[x_a][ 19] * g_t[x_a][ 20];}
      if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_IS[ 21] * g_f[x_a][  2] * g_t[x_a][ 15] * g_t[x_a][ 21];}
      if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_IS[ 22] * g_f[x_a][  2] * g_t[x_a][ 17] * g_t[x_a][ 22];}
      if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_IS[ 23] * g_f[x_a][  2] * g_t[x_a][ 19] * g_t[x_a][ 23];}
      if (MC_phasespace.alpha[zero +  24] != 0.){MC_phasespace.g_channel[zero +  24] = g_IS[ 24] * g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 24];}
      if (MC_phasespace.alpha[zero +  25] != 0.){MC_phasespace.g_channel[zero +  25] = g_IS[ 25] * g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 25];}
      if (MC_phasespace.alpha[zero +  26] != 0.){MC_phasespace.g_channel[zero +  26] = g_IS[ 26] * g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 26];}
      if (MC_phasespace.alpha[zero +  27] != 0.){MC_phasespace.g_channel[zero +  27] = g_IS[ 27] * g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 24];}
      if (MC_phasespace.alpha[zero +  28] != 0.){MC_phasespace.g_channel[zero +  28] = g_IS[ 28] * g_f[x_a][  1] * g_t[x_a][ 14] * g_t[x_a][ 26];}
      if (MC_phasespace.alpha[zero +  29] != 0.){MC_phasespace.g_channel[zero +  29] = g_IS[ 29] * g_f[x_a][  1] * g_t[x_a][ 13] * g_t[x_a][ 25];}
      if (MC_phasespace.alpha[zero +  30] != 0.){MC_phasespace.g_channel[zero +  30] = g_IS[ 30] * g_p[x_a][  0] * g_t[x_a][ 27] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  31] != 0.){MC_phasespace.g_channel[zero +  31] = g_IS[ 31] * g_p[x_a][  0] * g_t[x_a][ 27] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  32] != 0.){MC_phasespace.g_channel[zero +  32] = g_IS[ 32] * g_p[x_a][  0] * g_t[x_a][ 28] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  33] != 0.){MC_phasespace.g_channel[zero +  33] = g_IS[ 33] * g_p[x_a][  0] * g_t[x_a][ 29] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  34] != 0.){MC_phasespace.g_channel[zero +  34] = g_IS[ 34] * g_p[x_a][  1] * g_t[x_a][ 27] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  35] != 0.){MC_phasespace.g_channel[zero +  35] = g_IS[ 35] * g_p[x_a][  1] * g_t[x_a][ 27] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  36] != 0.){MC_phasespace.g_channel[zero +  36] = g_IS[ 36] * g_p[x_a][  1] * g_t[x_a][ 28] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  37] != 0.){MC_phasespace.g_channel[zero +  37] = g_IS[ 37] * g_p[x_a][  1] * g_t[x_a][ 29] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  38] != 0.){MC_phasespace.g_channel[zero +  38] = g_IS[ 38] * g_p[x_a][  2] * g_t[x_a][ 27] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  39] != 0.){MC_phasespace.g_channel[zero +  39] = g_IS[ 39] * g_p[x_a][  2] * g_t[x_a][ 28] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  40] != 0.){MC_phasespace.g_channel[zero +  40] = g_IS[ 40] * g_p[x_a][  2] * g_t[x_a][ 29] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  41] != 0.){MC_phasespace.g_channel[zero +  41] = g_IS[ 41] * g_p[x_a][  0] * g_t[x_a][ 27] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  42] != 0.){MC_phasespace.g_channel[zero +  42] = g_IS[ 42] * g_p[x_a][  0] * g_t[x_a][ 27] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  43] != 0.){MC_phasespace.g_channel[zero +  43] = g_IS[ 43] * g_p[x_a][  3] * g_t[x_a][ 27] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  44] != 0.){MC_phasespace.g_channel[zero +  44] = g_IS[ 44] * g_p[x_a][  3] * g_t[x_a][ 28] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  45] != 0.){MC_phasespace.g_channel[zero +  45] = g_IS[ 45] * g_p[x_a][  4] * g_t[x_a][ 27] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  46] != 0.){MC_phasespace.g_channel[zero +  46] = g_IS[ 46] * g_p[x_a][  4] * g_t[x_a][ 29] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  47] != 0.){MC_phasespace.g_channel[zero +  47] = g_IS[ 47] * g_p[x_a][  5] * g_t[x_a][ 30] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  48] != 0.){MC_phasespace.g_channel[zero +  48] = g_IS[ 48] * g_p[x_a][  6] * g_t[x_a][ 31] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  49] != 0.){MC_phasespace.g_channel[zero +  49] = g_IS[ 49] * g_p[x_a][  7] * g_t[x_a][ 32] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  50] != 0.){MC_phasespace.g_channel[zero +  50] = g_IS[ 50] * g_p[x_a][  8] * g_t[x_a][ 33] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  51] != 0.){MC_phasespace.g_channel[zero +  51] = g_IS[ 51] * g_p[x_a][  9] * g_t[x_a][ 34] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  52] != 0.){MC_phasespace.g_channel[zero +  52] = g_IS[ 52] * g_p[x_a][ 10] * g_t[x_a][ 35] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  53] != 0.){MC_phasespace.g_channel[zero +  53] = g_IS[ 53] * g_p[x_a][  8] * g_d[x_a][  3] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  54] != 0.){MC_phasespace.g_channel[zero +  54] = g_IS[ 54] * g_p[x_a][  8] * g_d[x_a][  3] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  55] != 0.){MC_phasespace.g_channel[zero +  55] = g_IS[ 55] * g_p[x_a][  9] * g_d[x_a][  3] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  56] != 0.){MC_phasespace.g_channel[zero +  56] = g_IS[ 56] * g_p[x_a][  9] * g_d[x_a][  3] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  57] != 0.){MC_phasespace.g_channel[zero +  57] = g_IS[ 57] * g_p[x_a][ 10] * g_d[x_a][  3] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  58] != 0.){MC_phasespace.g_channel[zero +  58] = g_IS[ 58] * g_p[x_a][ 10] * g_d[x_a][  3] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  59] != 0.){MC_phasespace.g_channel[zero +  59] = g_IS[ 59] * g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  60] != 0.){MC_phasespace.g_channel[zero +  60] = g_IS[ 60] * g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  61] != 0.){MC_phasespace.g_channel[zero +  61] = g_IS[ 61] * g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  62] != 0.){MC_phasespace.g_channel[zero +  62] = g_IS[ 62] * g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  63] != 0.){MC_phasespace.g_channel[zero +  63] = g_IS[ 63] * g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  64] != 0.){MC_phasespace.g_channel[zero +  64] = g_IS[ 64] * g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  65] != 0.){MC_phasespace.g_channel[zero +  65] = g_IS[ 65] * g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  66] != 0.){MC_phasespace.g_channel[zero +  66] = g_IS[ 66] * g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  67] != 0.){MC_phasespace.g_channel[zero +  67] = g_IS[ 67] * g_p[x_a][  2] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  68] != 0.){MC_phasespace.g_channel[zero +  68] = g_IS[ 68] * g_p[x_a][  2] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  69] != 0.){MC_phasespace.g_channel[zero +  69] = g_IS[ 69] * g_p[x_a][  2] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  70] != 0.){MC_phasespace.g_channel[zero +  70] = g_IS[ 70] * g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  71] != 0.){MC_phasespace.g_channel[zero +  71] = g_IS[ 71] * g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  72] != 0.){MC_phasespace.g_channel[zero +  72] = g_IS[ 72] * g_p[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  73] != 0.){MC_phasespace.g_channel[zero +  73] = g_IS[ 73] * g_p[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  74] != 0.){MC_phasespace.g_channel[zero +  74] = g_IS[ 74] * g_p[x_a][  4] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  75] != 0.){MC_phasespace.g_channel[zero +  75] = g_IS[ 75] * g_p[x_a][  4] * g_d[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  76] != 0.){MC_phasespace.g_channel[zero +  76] = g_IS[ 76] * g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  77] != 0.){MC_phasespace.g_channel[zero +  77] = g_IS[ 77] * g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  78] != 0.){MC_phasespace.g_channel[zero +  78] = g_IS[ 78] * g_p[x_a][  6] * g_d[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  79] != 0.){MC_phasespace.g_channel[zero +  79] = g_IS[ 79] * g_p[x_a][  6] * g_d[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  80] != 0.){MC_phasespace.g_channel[zero +  80] = g_IS[ 80] * g_p[x_a][  7] * g_d[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  81] != 0.){MC_phasespace.g_channel[zero +  81] = g_IS[ 81] * g_p[x_a][  7] * g_d[x_a][  5] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  82] != 0.){MC_phasespace.g_channel[zero +  82] = g_IS[ 82] * g_p[x_a][  8] * g_t[x_a][  0] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  83] != 0.){MC_phasespace.g_channel[zero +  83] = g_IS[ 83] * g_p[x_a][  9] * g_t[x_a][  2] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  84] != 0.){MC_phasespace.g_channel[zero +  84] = g_IS[ 84] * g_p[x_a][ 10] * g_t[x_a][  4] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +  85] != 0.){MC_phasespace.g_channel[zero +  85] = g_IS[ 85] * g_p[x_a][  0] * g_t[x_a][  9] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  86] != 0.){MC_phasespace.g_channel[zero +  86] = g_IS[ 86] * g_p[x_a][  0] * g_t[x_a][  9] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  87] != 0.){MC_phasespace.g_channel[zero +  87] = g_IS[ 87] * g_p[x_a][  0] * g_t[x_a][ 14] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  88] != 0.){MC_phasespace.g_channel[zero +  88] = g_IS[ 88] * g_p[x_a][  0] * g_t[x_a][ 13] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  89] != 0.){MC_phasespace.g_channel[zero +  89] = g_IS[ 89] * g_p[x_a][  1] * g_t[x_a][  9] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  90] != 0.){MC_phasespace.g_channel[zero +  90] = g_IS[ 90] * g_p[x_a][  1] * g_t[x_a][  9] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  91] != 0.){MC_phasespace.g_channel[zero +  91] = g_IS[ 91] * g_p[x_a][  1] * g_t[x_a][ 14] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  92] != 0.){MC_phasespace.g_channel[zero +  92] = g_IS[ 92] * g_p[x_a][  1] * g_t[x_a][ 13] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  93] != 0.){MC_phasespace.g_channel[zero +  93] = g_IS[ 93] * g_p[x_a][  2] * g_t[x_a][  9] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  94] != 0.){MC_phasespace.g_channel[zero +  94] = g_IS[ 94] * g_p[x_a][  2] * g_t[x_a][ 14] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  95] != 0.){MC_phasespace.g_channel[zero +  95] = g_IS[ 95] * g_p[x_a][  2] * g_t[x_a][ 13] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  96] != 0.){MC_phasespace.g_channel[zero +  96] = g_IS[ 96] * g_p[x_a][  0] * g_t[x_a][  9] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  97] != 0.){MC_phasespace.g_channel[zero +  97] = g_IS[ 97] * g_p[x_a][  0] * g_t[x_a][  9] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  98] != 0.){MC_phasespace.g_channel[zero +  98] = g_IS[ 98] * g_p[x_a][  3] * g_t[x_a][  9] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  99] != 0.){MC_phasespace.g_channel[zero +  99] = g_IS[ 99] * g_p[x_a][  3] * g_t[x_a][ 14] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero + 100] != 0.){MC_phasespace.g_channel[zero + 100] = g_IS[100] * g_p[x_a][  4] * g_t[x_a][  9] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero + 101] != 0.){MC_phasespace.g_channel[zero + 101] = g_IS[101] * g_p[x_a][  4] * g_t[x_a][ 13] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero + 102] != 0.){MC_phasespace.g_channel[zero + 102] = g_IS[102] * g_p[x_a][  5] * g_t[x_a][ 15] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero + 103] != 0.){MC_phasespace.g_channel[zero + 103] = g_IS[103] * g_p[x_a][  6] * g_t[x_a][ 17] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero + 104] != 0.){MC_phasespace.g_channel[zero + 104] = g_IS[104] * g_p[x_a][  7] * g_t[x_a][ 19] * g_d[x_a][  1];}
    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(11, 1.);
      g_IS[1].resize(3, 1.);
      g_IS[2].resize(36, 1.);
      g_IS[3].resize(6, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  1] * g_IS[2][  1];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  1] * g_IS[2][  1];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  2] * g_IS[2][  2] * g_t[x_a][  1] * g_IS[2][  1];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  2] * g_IS[2][  2] * g_t[x_a][  3] * g_IS[2][  3];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  4] * g_IS[2][  4] * g_t[x_a][  1] * g_IS[2][  1];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  4] * g_IS[2][  4] * g_t[x_a][  5] * g_IS[2][  5];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  6] * g_IS[2][  6];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  2] * g_IS[2][  2] * g_t[x_a][  7] * g_IS[2][  7];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  4] * g_IS[2][  4] * g_t[x_a][  8] * g_IS[2][  8];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  9] * g_IS[2][  9] * g_t[x_a][ 10] * g_IS[2][ 10];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  9] * g_IS[2][  9] * g_t[x_a][ 11] * g_IS[2][ 11];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  9] * g_IS[2][  9] * g_t[x_a][ 12] * g_IS[2][ 12];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  9] * g_IS[2][  9] * g_t[x_a][ 10] * g_IS[2][ 10];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][ 13] * g_IS[2][ 13] * g_t[x_a][ 12] * g_IS[2][ 12];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][ 14] * g_IS[2][ 14] * g_t[x_a][ 11] * g_IS[2][ 11];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 15] * g_IS[2][ 15] * g_t[x_a][ 16] * g_IS[2][ 16];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 15] * g_IS[2][ 15] * g_t[x_a][ 16] * g_IS[2][ 16];}
      if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 17] * g_IS[2][ 17] * g_t[x_a][ 16] * g_IS[2][ 16];}
      if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 17] * g_IS[2][ 17] * g_t[x_a][ 18] * g_IS[2][ 18];}
      if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 19] * g_IS[2][ 19] * g_t[x_a][ 16] * g_IS[2][ 16];}
      if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 19] * g_IS[2][ 19] * g_t[x_a][ 20] * g_IS[2][ 20];}
      if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 15] * g_IS[2][ 15] * g_t[x_a][ 21] * g_IS[2][ 21];}
      if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 17] * g_IS[2][ 17] * g_t[x_a][ 22] * g_IS[2][ 22];}
      if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_f[x_a][  2] * g_IS[1][  2] * g_t[x_a][ 19] * g_IS[2][ 19] * g_t[x_a][ 23] * g_IS[2][ 23];}
      if (MC_phasespace.alpha[zero +  24] != 0.){MC_phasespace.g_channel[zero +  24] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  9] * g_IS[2][  9] * g_t[x_a][ 24] * g_IS[2][ 24];}
      if (MC_phasespace.alpha[zero +  25] != 0.){MC_phasespace.g_channel[zero +  25] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  9] * g_IS[2][  9] * g_t[x_a][ 25] * g_IS[2][ 25];}
      if (MC_phasespace.alpha[zero +  26] != 0.){MC_phasespace.g_channel[zero +  26] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  9] * g_IS[2][  9] * g_t[x_a][ 26] * g_IS[2][ 26];}
      if (MC_phasespace.alpha[zero +  27] != 0.){MC_phasespace.g_channel[zero +  27] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  9] * g_IS[2][  9] * g_t[x_a][ 24] * g_IS[2][ 24];}
      if (MC_phasespace.alpha[zero +  28] != 0.){MC_phasespace.g_channel[zero +  28] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][ 14] * g_IS[2][ 14] * g_t[x_a][ 26] * g_IS[2][ 26];}
      if (MC_phasespace.alpha[zero +  29] != 0.){MC_phasespace.g_channel[zero +  29] = g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][ 13] * g_IS[2][ 13] * g_t[x_a][ 25] * g_IS[2][ 25];}
      if (MC_phasespace.alpha[zero +  30] != 0.){MC_phasespace.g_channel[zero +  30] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][ 27] * g_IS[2][ 27] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  31] != 0.){MC_phasespace.g_channel[zero +  31] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][ 27] * g_IS[2][ 27] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  32] != 0.){MC_phasespace.g_channel[zero +  32] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][ 28] * g_IS[2][ 28] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  33] != 0.){MC_phasespace.g_channel[zero +  33] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][ 29] * g_IS[2][ 29] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  34] != 0.){MC_phasespace.g_channel[zero +  34] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][ 27] * g_IS[2][ 27] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  35] != 0.){MC_phasespace.g_channel[zero +  35] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][ 27] * g_IS[2][ 27] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  36] != 0.){MC_phasespace.g_channel[zero +  36] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][ 28] * g_IS[2][ 28] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  37] != 0.){MC_phasespace.g_channel[zero +  37] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][ 29] * g_IS[2][ 29] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  38] != 0.){MC_phasespace.g_channel[zero +  38] = g_p[x_a][  2] * g_IS[0][  2] * g_t[x_a][ 27] * g_IS[2][ 27] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  39] != 0.){MC_phasespace.g_channel[zero +  39] = g_p[x_a][  2] * g_IS[0][  2] * g_t[x_a][ 28] * g_IS[2][ 28] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  40] != 0.){MC_phasespace.g_channel[zero +  40] = g_p[x_a][  2] * g_IS[0][  2] * g_t[x_a][ 29] * g_IS[2][ 29] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  41] != 0.){MC_phasespace.g_channel[zero +  41] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][ 27] * g_IS[2][ 27] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  42] != 0.){MC_phasespace.g_channel[zero +  42] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][ 27] * g_IS[2][ 27] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  43] != 0.){MC_phasespace.g_channel[zero +  43] = g_p[x_a][  3] * g_IS[0][  3] * g_t[x_a][ 27] * g_IS[2][ 27] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  44] != 0.){MC_phasespace.g_channel[zero +  44] = g_p[x_a][  3] * g_IS[0][  3] * g_t[x_a][ 28] * g_IS[2][ 28] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  45] != 0.){MC_phasespace.g_channel[zero +  45] = g_p[x_a][  4] * g_IS[0][  4] * g_t[x_a][ 27] * g_IS[2][ 27] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  46] != 0.){MC_phasespace.g_channel[zero +  46] = g_p[x_a][  4] * g_IS[0][  4] * g_t[x_a][ 29] * g_IS[2][ 29] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  47] != 0.){MC_phasespace.g_channel[zero +  47] = g_p[x_a][  5] * g_IS[0][  5] * g_t[x_a][ 30] * g_IS[2][ 30] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  48] != 0.){MC_phasespace.g_channel[zero +  48] = g_p[x_a][  6] * g_IS[0][  6] * g_t[x_a][ 31] * g_IS[2][ 31] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  49] != 0.){MC_phasespace.g_channel[zero +  49] = g_p[x_a][  7] * g_IS[0][  7] * g_t[x_a][ 32] * g_IS[2][ 32] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  50] != 0.){MC_phasespace.g_channel[zero +  50] = g_p[x_a][  8] * g_IS[0][  8] * g_t[x_a][ 33] * g_IS[2][ 33] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  51] != 0.){MC_phasespace.g_channel[zero +  51] = g_p[x_a][  9] * g_IS[0][  9] * g_t[x_a][ 34] * g_IS[2][ 34] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  52] != 0.){MC_phasespace.g_channel[zero +  52] = g_p[x_a][ 10] * g_IS[0][ 10] * g_t[x_a][ 35] * g_IS[2][ 35] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  53] != 0.){MC_phasespace.g_channel[zero +  53] = g_p[x_a][  8] * g_IS[0][  8] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  54] != 0.){MC_phasespace.g_channel[zero +  54] = g_p[x_a][  8] * g_IS[0][  8] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  55] != 0.){MC_phasespace.g_channel[zero +  55] = g_p[x_a][  9] * g_IS[0][  9] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  56] != 0.){MC_phasespace.g_channel[zero +  56] = g_p[x_a][  9] * g_IS[0][  9] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  57] != 0.){MC_phasespace.g_channel[zero +  57] = g_p[x_a][ 10] * g_IS[0][ 10] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  58] != 0.){MC_phasespace.g_channel[zero +  58] = g_p[x_a][ 10] * g_IS[0][ 10] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  59] != 0.){MC_phasespace.g_channel[zero +  59] = g_p[x_a][  0] * g_IS[0][  0] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  60] != 0.){MC_phasespace.g_channel[zero +  60] = g_p[x_a][  0] * g_IS[0][  0] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  61] != 0.){MC_phasespace.g_channel[zero +  61] = g_p[x_a][  0] * g_IS[0][  0] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  62] != 0.){MC_phasespace.g_channel[zero +  62] = g_p[x_a][  0] * g_IS[0][  0] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  63] != 0.){MC_phasespace.g_channel[zero +  63] = g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  64] != 0.){MC_phasespace.g_channel[zero +  64] = g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  65] != 0.){MC_phasespace.g_channel[zero +  65] = g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  66] != 0.){MC_phasespace.g_channel[zero +  66] = g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  67] != 0.){MC_phasespace.g_channel[zero +  67] = g_p[x_a][  2] * g_IS[0][  2] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  68] != 0.){MC_phasespace.g_channel[zero +  68] = g_p[x_a][  2] * g_IS[0][  2] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  69] != 0.){MC_phasespace.g_channel[zero +  69] = g_p[x_a][  2] * g_IS[0][  2] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  70] != 0.){MC_phasespace.g_channel[zero +  70] = g_p[x_a][  0] * g_IS[0][  0] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  71] != 0.){MC_phasespace.g_channel[zero +  71] = g_p[x_a][  0] * g_IS[0][  0] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  72] != 0.){MC_phasespace.g_channel[zero +  72] = g_p[x_a][  3] * g_IS[0][  3] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  73] != 0.){MC_phasespace.g_channel[zero +  73] = g_p[x_a][  3] * g_IS[0][  3] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  74] != 0.){MC_phasespace.g_channel[zero +  74] = g_p[x_a][  4] * g_IS[0][  4] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  75] != 0.){MC_phasespace.g_channel[zero +  75] = g_p[x_a][  4] * g_IS[0][  4] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  76] != 0.){MC_phasespace.g_channel[zero +  76] = g_p[x_a][  5] * g_IS[0][  5] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  77] != 0.){MC_phasespace.g_channel[zero +  77] = g_p[x_a][  5] * g_IS[0][  5] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  78] != 0.){MC_phasespace.g_channel[zero +  78] = g_p[x_a][  6] * g_IS[0][  6] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  79] != 0.){MC_phasespace.g_channel[zero +  79] = g_p[x_a][  6] * g_IS[0][  6] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  80] != 0.){MC_phasespace.g_channel[zero +  80] = g_p[x_a][  7] * g_IS[0][  7] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  81] != 0.){MC_phasespace.g_channel[zero +  81] = g_p[x_a][  7] * g_IS[0][  7] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  82] != 0.){MC_phasespace.g_channel[zero +  82] = g_p[x_a][  8] * g_IS[0][  8] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  83] != 0.){MC_phasespace.g_channel[zero +  83] = g_p[x_a][  9] * g_IS[0][  9] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  84] != 0.){MC_phasespace.g_channel[zero +  84] = g_p[x_a][ 10] * g_IS[0][ 10] * g_t[x_a][  4] * g_IS[2][  4] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +  85] != 0.){MC_phasespace.g_channel[zero +  85] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  86] != 0.){MC_phasespace.g_channel[zero +  86] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  87] != 0.){MC_phasespace.g_channel[zero +  87] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][ 14] * g_IS[2][ 14] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  88] != 0.){MC_phasespace.g_channel[zero +  88] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][ 13] * g_IS[2][ 13] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  89] != 0.){MC_phasespace.g_channel[zero +  89] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  90] != 0.){MC_phasespace.g_channel[zero +  90] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  91] != 0.){MC_phasespace.g_channel[zero +  91] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][ 14] * g_IS[2][ 14] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  92] != 0.){MC_phasespace.g_channel[zero +  92] = g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][ 13] * g_IS[2][ 13] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  93] != 0.){MC_phasespace.g_channel[zero +  93] = g_p[x_a][  2] * g_IS[0][  2] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  94] != 0.){MC_phasespace.g_channel[zero +  94] = g_p[x_a][  2] * g_IS[0][  2] * g_t[x_a][ 14] * g_IS[2][ 14] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  95] != 0.){MC_phasespace.g_channel[zero +  95] = g_p[x_a][  2] * g_IS[0][  2] * g_t[x_a][ 13] * g_IS[2][ 13] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  96] != 0.){MC_phasespace.g_channel[zero +  96] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  97] != 0.){MC_phasespace.g_channel[zero +  97] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  98] != 0.){MC_phasespace.g_channel[zero +  98] = g_p[x_a][  3] * g_IS[0][  3] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  99] != 0.){MC_phasespace.g_channel[zero +  99] = g_p[x_a][  3] * g_IS[0][  3] * g_t[x_a][ 14] * g_IS[2][ 14] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero + 100] != 0.){MC_phasespace.g_channel[zero + 100] = g_p[x_a][  4] * g_IS[0][  4] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero + 101] != 0.){MC_phasespace.g_channel[zero + 101] = g_p[x_a][  4] * g_IS[0][  4] * g_t[x_a][ 13] * g_IS[2][ 13] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero + 102] != 0.){MC_phasespace.g_channel[zero + 102] = g_p[x_a][  5] * g_IS[0][  5] * g_t[x_a][ 15] * g_IS[2][ 15] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero + 103] != 0.){MC_phasespace.g_channel[zero + 103] = g_p[x_a][  6] * g_IS[0][  6] * g_t[x_a][ 17] * g_IS[2][ 17] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero + 104] != 0.){MC_phasespace.g_channel[zero + 104] = g_p[x_a][  7] * g_IS[0][  7] * g_t[x_a][ 19] * g_IS[2][ 19] * g_d[x_a][  1] * g_IS[3][  1];}
    }
  }
  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1];}
    if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  1];}
    if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  3];}
    if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_f[x_a][  0] * g_t[x_a][  4] * g_t[x_a][  1];}
    if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_f[x_a][  0] * g_t[x_a][  4] * g_t[x_a][  5];}
    if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  6];}
    if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_f[x_a][  0] * g_t[x_a][  2] * g_t[x_a][  7];}
    if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_f[x_a][  0] * g_t[x_a][  4] * g_t[x_a][  8];}
    if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 10];}
    if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 11];}
    if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 12];}
    if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 10];}
    if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_f[x_a][  1] * g_t[x_a][ 13] * g_t[x_a][ 12];}
    if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_f[x_a][  1] * g_t[x_a][ 14] * g_t[x_a][ 11];}
    if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_f[x_a][  2] * g_t[x_a][ 15] * g_t[x_a][ 16];}
    if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_f[x_a][  2] * g_t[x_a][ 15] * g_t[x_a][ 16];}
    if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_f[x_a][  2] * g_t[x_a][ 17] * g_t[x_a][ 16];}
    if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_f[x_a][  2] * g_t[x_a][ 17] * g_t[x_a][ 18];}
    if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_f[x_a][  2] * g_t[x_a][ 19] * g_t[x_a][ 16];}
    if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_f[x_a][  2] * g_t[x_a][ 19] * g_t[x_a][ 20];}
    if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_f[x_a][  2] * g_t[x_a][ 15] * g_t[x_a][ 21];}
    if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_f[x_a][  2] * g_t[x_a][ 17] * g_t[x_a][ 22];}
    if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_f[x_a][  2] * g_t[x_a][ 19] * g_t[x_a][ 23];}
    if (MC_phasespace.alpha[zero +  24] != 0.){MC_phasespace.g_channel[zero +  24] = g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 24];}
    if (MC_phasespace.alpha[zero +  25] != 0.){MC_phasespace.g_channel[zero +  25] = g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 25];}
    if (MC_phasespace.alpha[zero +  26] != 0.){MC_phasespace.g_channel[zero +  26] = g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 26];}
    if (MC_phasespace.alpha[zero +  27] != 0.){MC_phasespace.g_channel[zero +  27] = g_f[x_a][  1] * g_t[x_a][  9] * g_t[x_a][ 24];}
    if (MC_phasespace.alpha[zero +  28] != 0.){MC_phasespace.g_channel[zero +  28] = g_f[x_a][  1] * g_t[x_a][ 14] * g_t[x_a][ 26];}
    if (MC_phasespace.alpha[zero +  29] != 0.){MC_phasespace.g_channel[zero +  29] = g_f[x_a][  1] * g_t[x_a][ 13] * g_t[x_a][ 25];}
    if (MC_phasespace.alpha[zero +  30] != 0.){MC_phasespace.g_channel[zero +  30] = g_p[x_a][  0] * g_t[x_a][ 27] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  31] != 0.){MC_phasespace.g_channel[zero +  31] = g_p[x_a][  0] * g_t[x_a][ 27] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  32] != 0.){MC_phasespace.g_channel[zero +  32] = g_p[x_a][  0] * g_t[x_a][ 28] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  33] != 0.){MC_phasespace.g_channel[zero +  33] = g_p[x_a][  0] * g_t[x_a][ 29] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  34] != 0.){MC_phasespace.g_channel[zero +  34] = g_p[x_a][  1] * g_t[x_a][ 27] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  35] != 0.){MC_phasespace.g_channel[zero +  35] = g_p[x_a][  1] * g_t[x_a][ 27] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  36] != 0.){MC_phasespace.g_channel[zero +  36] = g_p[x_a][  1] * g_t[x_a][ 28] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  37] != 0.){MC_phasespace.g_channel[zero +  37] = g_p[x_a][  1] * g_t[x_a][ 29] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  38] != 0.){MC_phasespace.g_channel[zero +  38] = g_p[x_a][  2] * g_t[x_a][ 27] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  39] != 0.){MC_phasespace.g_channel[zero +  39] = g_p[x_a][  2] * g_t[x_a][ 28] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  40] != 0.){MC_phasespace.g_channel[zero +  40] = g_p[x_a][  2] * g_t[x_a][ 29] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  41] != 0.){MC_phasespace.g_channel[zero +  41] = g_p[x_a][  0] * g_t[x_a][ 27] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  42] != 0.){MC_phasespace.g_channel[zero +  42] = g_p[x_a][  0] * g_t[x_a][ 27] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  43] != 0.){MC_phasespace.g_channel[zero +  43] = g_p[x_a][  3] * g_t[x_a][ 27] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  44] != 0.){MC_phasespace.g_channel[zero +  44] = g_p[x_a][  3] * g_t[x_a][ 28] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  45] != 0.){MC_phasespace.g_channel[zero +  45] = g_p[x_a][  4] * g_t[x_a][ 27] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  46] != 0.){MC_phasespace.g_channel[zero +  46] = g_p[x_a][  4] * g_t[x_a][ 29] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  47] != 0.){MC_phasespace.g_channel[zero +  47] = g_p[x_a][  5] * g_t[x_a][ 30] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  48] != 0.){MC_phasespace.g_channel[zero +  48] = g_p[x_a][  6] * g_t[x_a][ 31] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  49] != 0.){MC_phasespace.g_channel[zero +  49] = g_p[x_a][  7] * g_t[x_a][ 32] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  50] != 0.){MC_phasespace.g_channel[zero +  50] = g_p[x_a][  8] * g_t[x_a][ 33] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  51] != 0.){MC_phasespace.g_channel[zero +  51] = g_p[x_a][  9] * g_t[x_a][ 34] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  52] != 0.){MC_phasespace.g_channel[zero +  52] = g_p[x_a][ 10] * g_t[x_a][ 35] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  53] != 0.){MC_phasespace.g_channel[zero +  53] = g_p[x_a][  8] * g_d[x_a][  3] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  54] != 0.){MC_phasespace.g_channel[zero +  54] = g_p[x_a][  8] * g_d[x_a][  3] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  55] != 0.){MC_phasespace.g_channel[zero +  55] = g_p[x_a][  9] * g_d[x_a][  3] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  56] != 0.){MC_phasespace.g_channel[zero +  56] = g_p[x_a][  9] * g_d[x_a][  3] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  57] != 0.){MC_phasespace.g_channel[zero +  57] = g_p[x_a][ 10] * g_d[x_a][  3] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  58] != 0.){MC_phasespace.g_channel[zero +  58] = g_p[x_a][ 10] * g_d[x_a][  3] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  59] != 0.){MC_phasespace.g_channel[zero +  59] = g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  60] != 0.){MC_phasespace.g_channel[zero +  60] = g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  61] != 0.){MC_phasespace.g_channel[zero +  61] = g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  62] != 0.){MC_phasespace.g_channel[zero +  62] = g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  63] != 0.){MC_phasespace.g_channel[zero +  63] = g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  64] != 0.){MC_phasespace.g_channel[zero +  64] = g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  65] != 0.){MC_phasespace.g_channel[zero +  65] = g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  66] != 0.){MC_phasespace.g_channel[zero +  66] = g_p[x_a][  1] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  67] != 0.){MC_phasespace.g_channel[zero +  67] = g_p[x_a][  2] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  68] != 0.){MC_phasespace.g_channel[zero +  68] = g_p[x_a][  2] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  69] != 0.){MC_phasespace.g_channel[zero +  69] = g_p[x_a][  2] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  70] != 0.){MC_phasespace.g_channel[zero +  70] = g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  71] != 0.){MC_phasespace.g_channel[zero +  71] = g_p[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  72] != 0.){MC_phasespace.g_channel[zero +  72] = g_p[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  73] != 0.){MC_phasespace.g_channel[zero +  73] = g_p[x_a][  3] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  74] != 0.){MC_phasespace.g_channel[zero +  74] = g_p[x_a][  4] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  75] != 0.){MC_phasespace.g_channel[zero +  75] = g_p[x_a][  4] * g_d[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  76] != 0.){MC_phasespace.g_channel[zero +  76] = g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  77] != 0.){MC_phasespace.g_channel[zero +  77] = g_p[x_a][  5] * g_d[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  78] != 0.){MC_phasespace.g_channel[zero +  78] = g_p[x_a][  6] * g_d[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  79] != 0.){MC_phasespace.g_channel[zero +  79] = g_p[x_a][  6] * g_d[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  80] != 0.){MC_phasespace.g_channel[zero +  80] = g_p[x_a][  7] * g_d[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  81] != 0.){MC_phasespace.g_channel[zero +  81] = g_p[x_a][  7] * g_d[x_a][  5] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  82] != 0.){MC_phasespace.g_channel[zero +  82] = g_p[x_a][  8] * g_t[x_a][  0] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  83] != 0.){MC_phasespace.g_channel[zero +  83] = g_p[x_a][  9] * g_t[x_a][  2] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  84] != 0.){MC_phasespace.g_channel[zero +  84] = g_p[x_a][ 10] * g_t[x_a][  4] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +  85] != 0.){MC_phasespace.g_channel[zero +  85] = g_p[x_a][  0] * g_t[x_a][  9] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  86] != 0.){MC_phasespace.g_channel[zero +  86] = g_p[x_a][  0] * g_t[x_a][  9] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  87] != 0.){MC_phasespace.g_channel[zero +  87] = g_p[x_a][  0] * g_t[x_a][ 14] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  88] != 0.){MC_phasespace.g_channel[zero +  88] = g_p[x_a][  0] * g_t[x_a][ 13] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  89] != 0.){MC_phasespace.g_channel[zero +  89] = g_p[x_a][  1] * g_t[x_a][  9] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  90] != 0.){MC_phasespace.g_channel[zero +  90] = g_p[x_a][  1] * g_t[x_a][  9] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  91] != 0.){MC_phasespace.g_channel[zero +  91] = g_p[x_a][  1] * g_t[x_a][ 14] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  92] != 0.){MC_phasespace.g_channel[zero +  92] = g_p[x_a][  1] * g_t[x_a][ 13] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  93] != 0.){MC_phasespace.g_channel[zero +  93] = g_p[x_a][  2] * g_t[x_a][  9] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  94] != 0.){MC_phasespace.g_channel[zero +  94] = g_p[x_a][  2] * g_t[x_a][ 14] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  95] != 0.){MC_phasespace.g_channel[zero +  95] = g_p[x_a][  2] * g_t[x_a][ 13] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  96] != 0.){MC_phasespace.g_channel[zero +  96] = g_p[x_a][  0] * g_t[x_a][  9] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  97] != 0.){MC_phasespace.g_channel[zero +  97] = g_p[x_a][  0] * g_t[x_a][  9] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  98] != 0.){MC_phasespace.g_channel[zero +  98] = g_p[x_a][  3] * g_t[x_a][  9] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  99] != 0.){MC_phasespace.g_channel[zero +  99] = g_p[x_a][  3] * g_t[x_a][ 14] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero + 100] != 0.){MC_phasespace.g_channel[zero + 100] = g_p[x_a][  4] * g_t[x_a][  9] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero + 101] != 0.){MC_phasespace.g_channel[zero + 101] = g_p[x_a][  4] * g_t[x_a][ 13] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero + 102] != 0.){MC_phasespace.g_channel[zero + 102] = g_p[x_a][  5] * g_t[x_a][ 15] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero + 103] != 0.){MC_phasespace.g_channel[zero + 103] = g_p[x_a][  6] * g_t[x_a][ 17] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero + 104] != 0.){MC_phasespace.g_channel[zero + 104] = g_p[x_a][  7] * g_t[x_a][ 19] * g_d[x_a][  1];}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
