#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_bbx_wpwmgg(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_bbx_wpwmgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(14);
  needed_v_smin[x_a].resize(14);
  needed_v_smin[x_a][  0] = {  12,   13,   14,   15,   16,   17,   19,   20,   21,   22,   23,   24,   26,   27,   28,   29,   30,   31,   33,   34,   35,   36,   37,   38,    3,    8}; //  26
  needed_v_smin[x_a][  1] = {  18,   25,   32,   33,   34,   35,   36,   37,   38,    5,    6}; //  11
  needed_v_smin[x_a][  2] = {   0,    4}; //   2
  needed_v_smin[x_a][  3] = {   0,    4}; //   2
  needed_v_smin[x_a][  4] = {   1,    2}; //   2
  needed_v_smin[x_a][  5] = {   1,    2}; //   2
  needed_v_smin[x_a][  6] = {   3,   12,   13,   14,   19,   20,   21,   29,   30,   31}; //  10
  needed_v_smin[x_a][  7] = {   5,    6,   25,   32}; //   4
  needed_v_smin[x_a][  8] = {   7,   11}; //   2
  needed_v_smin[x_a][  9] = {   7,   11}; //   2
  needed_v_smin[x_a][ 10] = {   8,   15,   16,   17,   22,   23,   24,   26,   27,   28}; //  10
  needed_v_smin[x_a][ 11] = {   9,   10}; //   2
  needed_v_smin[x_a][ 12] = {   9,   10}; //   2
  needed_v_smin[x_a][ 13] = {  18}; //   1

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  needed_v_smax[x_a][  0] = {  12,   13,   14,   15,   16,   17,   19,   20,   21,   22,   23,   24,   26,   27,   28,   29,   30,   31,   36,   37,   38,    3,    8}; //  23
  needed_v_smax[x_a][  1] = {  18,   25,   32,   33,   34,   35,    5,    6}; //   8
  needed_v_smax[x_a][  2] = {  33,   34,   35}; //   3
  needed_v_smax[x_a][  3] = {  36,   37,   38}; //   3
  needed_v_smax[x_a][  4] = {   0,    4}; //   2
  needed_v_smax[x_a][  5] = {   0,    1,    2,    4,    5,    6,   25,   32}; //   8
  needed_v_smax[x_a][  6] = {   1,    2}; //   2
  needed_v_smax[x_a][  7] = {   3,    7,   11,   12,   13,   14,   19,   20,   21,   29,   30,   31}; //  12
  needed_v_smax[x_a][  8] = {   7,   11}; //   2
  needed_v_smax[x_a][  9] = {   8,    9,   10,   15,   16,   17,   22,   23,   24,   26,   27,   28}; //  12
  needed_v_smax[x_a][ 10] = {   9,   10}; //   2
  needed_v_smax[x_a][ 11] = {  18}; //   1

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {  12,   15,   19,   22,   26,   29,   36}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  13,   16,   20,   23,   27,   30,   37}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {  14,   17,   21,   24,   28,   31,   38}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin0_smax0");
  needed_g_p[x_a][3] = {  18,   25,   32,   33,   34,   35}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][4] = {  33}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax2");
  needed_g_p[x_a][5] = {  34}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax2");
  needed_g_p[x_a][6] = {  35}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin0_smax2");
  needed_g_p[x_a][7] = {  36,   37,   38}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax3");

  g_f[x_a].resize(14);
  needed_g_f[x_a].resize(14);
  needed_g_f[x_a][0] = {   0,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax4");
  needed_g_f[x_a][1] = {   0,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax5");
  needed_g_f[x_a][2] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax6");
  needed_g_f[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][4] = {   3,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][5] = {   3,   12,   13,   14,   19,   20,   21,   29,   30,   31}; //  10
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax7");
  needed_g_f[x_a][6] = {   5,    6}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {   5,    6,   25,   32}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][8] = {   7,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax8");
  needed_g_f[x_a][9] = {   7,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][10] = {   8,   15,   16,   17,   22,   23,   24,   26,   27,   28}; //  10
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax9");
  needed_g_f[x_a][11] = {   9,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax10");
  needed_g_f[x_a][12] = {   9,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax9");
  needed_g_f[x_a][13] = {  18}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax11");

  g_t[x_a].resize(33);
  needed_g_t[x_a].resize(33);
  needed_g_t[x_a][0] = {   0,    1,    2,    4,    5,    6,   25,   32}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__8_52");
  needed_g_t[x_a][1] = {   0,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_9__32_20");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__9_34__4_16");
  needed_g_t[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_9__16_36");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__9_18__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__9_18__4_32");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__9_18__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__9_18__32_4");
  needed_g_t[x_a][6] = {   3,    7,   11,   19,   20,   21,   29,   30,   31}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__32_28");
  needed_g_t[x_a][7] = {   3,   19,   20,   21}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_33__16_12");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_18__8_4");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__9_34__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__9_34__16_4");
  needed_g_t[x_a][10] = {   5,    6,   25}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_9__4_48");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__9_6__16_32");
  needed_g_t[x_a][12] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__9_6__32_16");
  needed_g_t[x_a][13] = {   7,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__4_24");
  needed_g_t[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_6__8_16");
  needed_g_t[x_a][15] = {   8,    9,   10,   22,   23,   24,   26,   27,   28}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__16_44");
  needed_g_t[x_a][16] = {   8,   22,   23,   24}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_17__32_12");
  needed_g_t[x_a][17] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__8_4");
  needed_g_t[x_a][18] = {   9,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__4_40");
  needed_g_t[x_a][19] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_6__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_6__8_32");
  needed_g_t[x_a][20] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__17_6__32_8");
  needed_g_t[x_a][21] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__33_6__16_8");
  needed_g_t[x_a][22] = {  12,   13,   14}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__32_28");
  needed_g_t[x_a][23] = {  12,   13,   14}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_34__12_16");
  needed_g_t[x_a][24] = {  15,   16,   17}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__16_44");
  needed_g_t[x_a][25] = {  15,   16,   17}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_18__12_32");
  needed_g_t[x_a][26] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__4_56");
  needed_g_t[x_a][27] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_6__48_8");
  needed_g_t[x_a][28] = {  26,   27,   28}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_17__12_32");
  needed_g_t[x_a][29] = {  29,   30,   31}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_33__12_16");
  needed_g_t[x_a][30] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_9__48_4");
  needed_g_t[x_a][31] = {  33,   34,   35}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__12_48");
  needed_g_t[x_a][32] = {  36,   37,   38}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__48_12");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {  12,   13,   14,   15,   16,   17,   19,   20,   21,   22,   23,   24,   26,   27,   28,   29,   30,   31,   33,   34,   35,   36,   37,   38}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  18,   25,   32,   33,   34,   35,   36,   37,   38}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(39);
  c_f[x_a].resize(39);
  c_t[x_a].resize(39);
  c_d[x_a].resize(39);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  0,   3,   5}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  4,   5}; //   2
  c_t[x_a][3] = {  6,   7,   8}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  0,   1}; //   2
  c_t[x_a][4] = {  0,   1,   9}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  6,   7}; //   2
  c_t[x_a][5] = {  0,  10,  11}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  6,   7}; //   2
  c_t[x_a][6] = {  0,  10,  12}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  8,   9}; //   2
  c_t[x_a][7] = {  6,  13,  14}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  4,  10}; //   2
  c_t[x_a][8] = { 15,  16,  17}; //   3
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = { 11,  12}; //   2
  c_t[x_a][9] = { 15,  18,  19}; //   3
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = { 11,  12}; //   2
  c_t[x_a][10] = { 15,  18,  20}; //   3
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  8,   9}; //   2
  c_t[x_a][11] = {  6,  13,  21}; //   3
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  5}; //   1
  c_t[x_a][12] = { 22,  23}; //   2
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  1}; //   1
  c_f[x_a][13] = {  5}; //   1
  c_t[x_a][13] = { 22,  23}; //   2
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  2}; //   1
  c_f[x_a][14] = {  5}; //   1
  c_t[x_a][14] = { 22,  23}; //   2
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  0}; //   1
  c_f[x_a][15] = { 10}; //   1
  c_t[x_a][15] = { 24,  25}; //   2
  c_d[x_a][15] = {  0}; //   1

  c_p[x_a][16] = {  1}; //   1
  c_f[x_a][16] = { 10}; //   1
  c_t[x_a][16] = { 24,  25}; //   2
  c_d[x_a][16] = {  0}; //   1

  c_p[x_a][17] = {  2}; //   1
  c_f[x_a][17] = { 10}; //   1
  c_t[x_a][17] = { 24,  25}; //   2
  c_d[x_a][17] = {  0}; //   1

  c_p[x_a][18] = {  3}; //   1
  c_f[x_a][18] = { 13}; //   1
  c_t[x_a][18] = { 26,  27}; //   2
  c_d[x_a][18] = {  1}; //   1

  c_p[x_a][19] = {  0}; //   1
  c_f[x_a][19] = {  5}; //   1
  c_t[x_a][19] = {  6,   7}; //   2
  c_d[x_a][19] = {  0}; //   1

  c_p[x_a][20] = {  1}; //   1
  c_f[x_a][20] = {  5}; //   1
  c_t[x_a][20] = {  6,   7}; //   2
  c_d[x_a][20] = {  0}; //   1

  c_p[x_a][21] = {  2}; //   1
  c_f[x_a][21] = {  5}; //   1
  c_t[x_a][21] = {  6,   7}; //   2
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  0}; //   1
  c_f[x_a][22] = { 10}; //   1
  c_t[x_a][22] = { 15,  16}; //   2
  c_d[x_a][22] = {  0}; //   1

  c_p[x_a][23] = {  1}; //   1
  c_f[x_a][23] = { 10}; //   1
  c_t[x_a][23] = { 15,  16}; //   2
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  2}; //   1
  c_f[x_a][24] = { 10}; //   1
  c_t[x_a][24] = { 15,  16}; //   2
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  3}; //   1
  c_f[x_a][25] = {  7}; //   1
  c_t[x_a][25] = {  0,  10}; //   2
  c_d[x_a][25] = {  1}; //   1

  c_p[x_a][26] = {  0}; //   1
  c_f[x_a][26] = { 10}; //   1
  c_t[x_a][26] = { 15,  28}; //   2
  c_d[x_a][26] = {  0}; //   1

  c_p[x_a][27] = {  1}; //   1
  c_f[x_a][27] = { 10}; //   1
  c_t[x_a][27] = { 15,  28}; //   2
  c_d[x_a][27] = {  0}; //   1

  c_p[x_a][28] = {  2}; //   1
  c_f[x_a][28] = { 10}; //   1
  c_t[x_a][28] = { 15,  28}; //   2
  c_d[x_a][28] = {  0}; //   1

  c_p[x_a][29] = {  0}; //   1
  c_f[x_a][29] = {  5}; //   1
  c_t[x_a][29] = {  6,  29}; //   2
  c_d[x_a][29] = {  0}; //   1

  c_p[x_a][30] = {  1}; //   1
  c_f[x_a][30] = {  5}; //   1
  c_t[x_a][30] = {  6,  29}; //   2
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  2}; //   1
  c_f[x_a][31] = {  5}; //   1
  c_t[x_a][31] = {  6,  29}; //   2
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  3}; //   1
  c_f[x_a][32] = {  7}; //   1
  c_t[x_a][32] = {  0,  30}; //   2
  c_d[x_a][32] = {  1}; //   1

  c_p[x_a][33] = {  3,   4}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = { 31}; //   1
  c_d[x_a][33] = {  0,   1}; //   2

  c_p[x_a][34] = {  3,   5}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = { 31}; //   1
  c_d[x_a][34] = {  0,   1}; //   2

  c_p[x_a][35] = {  3,   6}; //   2
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = { 31}; //   1
  c_d[x_a][35] = {  0,   1}; //   2

  c_p[x_a][36] = {  0,   7}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = { 32}; //   1
  c_d[x_a][36] = {  1,   0}; //   2

  c_p[x_a][37] = {  1,   7}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 32}; //   1
  c_d[x_a][37] = {  1,   0}; //   2

  c_p[x_a][38] = {  2,   7}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 32}; //   1
  c_d[x_a][38] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_bbx_wpwmgg
//  channel    0: 1111(1, 2, 8, 4, 16, 32;   6,   5,   5)
//  channel    1: 1111(1, 2, 8, 4, 32, 16;   6,   5,   5)
//  channel    2: 1111(1, 2, 8, 32, 4, 16;   6,   5,   6)
//  channel    3: 1111(1, 2, 32, 8, 4, 16;   5,   5,   6)
//  channel    4: 1111(1, 2, 8, 16, 4, 32;   6,   5,   6)
//  channel    5: 1111(1, 2, 8, 16, 32, 4;   6,   6,   6)
//  channel    6: 1111(1, 2, 8, 32, 16, 4;   6,   6,   6)
//  channel    7: 1111(1, 2, 32, 8, 16, 4;   5,   6,   6)
//  channel    8: 1111(1, 2, 16, 8, 4, 32;   5,   5,   6)
//  channel    9: 1111(1, 2, 16, 8, 32, 4;   5,   6,   6)
//  channel   10: 1111(1, 2, 16, 32, 8, 4;   5,   6,   5)
//  channel   11: 1111(1, 2, 32, 16, 8, 4;   5,   6,   5)
//  channel   12: 2v11(1, 2, 4, 8, 16, 32;   0,   5,   5)
//  channel   13: 2v11(1, 2, 4, 8, 16, 32;  23,   5,   5)
//  channel   14: 2v11(1, 2, 4, 8, 16, 32;  25,   5,   5)
//  channel   15: 2v11(1, 2, 4, 8, 32, 16;   0,   5,   5)
//  channel   16: 2v11(1, 2, 4, 8, 32, 16;  23,   5,   5)
//  channel   17: 2v11(1, 2, 4, 8, 32, 16;  25,   5,   5)
//  channel   18: 2v11(1, 2, 16, 32, 8, 4;   0,   6,   5)
//  channel   19: 12v1(1, 2, 32, 4, 8, 16;   0,   5,   5)
//  channel   20: 12v1(1, 2, 32, 4, 8, 16;  23,   5,   5)
//  channel   21: 12v1(1, 2, 32, 4, 8, 16;  25,   5,   5)
//  channel   22: 12v1(1, 2, 16, 4, 8, 32;   0,   5,   5)
//  channel   23: 12v1(1, 2, 16, 4, 8, 32;  23,   5,   5)
//  channel   24: 12v1(1, 2, 16, 4, 8, 32;  25,   5,   5)
//  channel   25: 12v1(1, 2, 8, 16, 32, 4;   0,   6,   6)
//  channel   26: 112v(1, 2, 16, 32, 4, 8;   0,   5,   5)
//  channel   27: 112v(1, 2, 16, 32, 4, 8;  23,   5,   5)
//  channel   28: 112v(1, 2, 16, 32, 4, 8;  25,   5,   5)
//  channel   29: 112v(1, 2, 32, 16, 4, 8;   0,   5,   5)
//  channel   30: 112v(1, 2, 32, 16, 4, 8;  23,   5,   5)
//  channel   31: 112v(1, 2, 32, 16, 4, 8;  25,   5,   5)
//  channel   32: 112v(1, 2, 8, 4, 16, 32;   0,   6,   5)
//  channel   33: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   5)
//  channel   34: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   5)
//  channel   35: 2v2v(1, 2, 4, 8, 16, 32;   0,  25,   5)
//  channel   36: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   5)
//  channel   37: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   5)
//  channel   38: 2v2v(1, 2, 16, 32, 4, 8;  25,   0,   5)
