#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_bbx_wpwmuux(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_bbx_wpwmuux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(10);
  needed_v_smin[x_a].resize(10);
  needed_v_smin[x_a][  0] = {   0,    8,    9,   10,   11,   12,   13,   14,   15}; //   9
  needed_v_smin[x_a][  1] = {   1,    7}; //   2
  needed_v_smin[x_a][  2] = {   1}; //   1
  needed_v_smin[x_a][  3] = {   2,    3,    4,    5,   10,   11,   12,   13,   14,   15}; //  10
  needed_v_smin[x_a][  4] = {   2,    3}; //   2
  needed_v_smin[x_a][  5] = {   4,    5}; //   2
  needed_v_smin[x_a][  6] = {   6,    7}; //   2
  needed_v_smin[x_a][  7] = {   6}; //   1
  needed_v_smin[x_a][  8] = {   0}; //   1
  needed_v_smin[x_a][  9] = {   8,    9}; //   2

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   0,    8,    9,   10,   11,   12}; //   6
  needed_v_smax[x_a][  1] = {   1,    7}; //   2
  needed_v_smax[x_a][  2] = {   1,    4,    5}; //   3
  needed_v_smax[x_a][  3] = {   2,    3,    4,    5,   13,   14,   15}; //   7
  needed_v_smax[x_a][  4] = {   2,    3,    6}; //   3
  needed_v_smax[x_a][  5] = {   6}; //   1
  needed_v_smax[x_a][  6] = {   7}; //   1
  needed_v_smax[x_a][  7] = {  10,   11,   12}; //   3
  needed_v_smax[x_a][  8] = {  13,   14,   15}; //   3
  needed_v_smax[x_a][  9] = {   0}; //   1
  needed_v_smax[x_a][ 10] = {   8,    9}; //   2

  g_p[x_a].resize(15);
  needed_g_p[x_a].resize(15);
  needed_g_p[x_a][0] = {   0,    8,    9,   10,   11,   12}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   1,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   2,    4,   13}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   3,    5,   14}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][6] = {   4,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax2");
  needed_g_p[x_a][7] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax4");
  needed_g_p[x_a][9] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][10] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax7");
  needed_g_p[x_a][11] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax7");
  needed_g_p[x_a][12] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin3_smax7");
  needed_g_p[x_a][13] = {  13,   14,   15}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax8");
  needed_g_p[x_a][14] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin3_smax3");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax9");
  needed_g_f[x_a][1] = {   8,    9}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax10");

  g_t[x_a].resize(7);
  needed_g_t[x_a].resize(7);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__4_56");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_6__48_8");
  needed_g_t[x_a][2] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__8_52");
  needed_g_t[x_a][3] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_9__4_48");
  needed_g_t[x_a][4] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_9__48_4");
  needed_g_t[x_a][5] = {  10,   11,   12}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__12_48");
  needed_g_t[x_a][6] = {  13,   14,   15}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__48_12");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   0,    8,    9,   10,   11,   12,   13,   14,   15}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][1] = {   1,    4,    5}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][3] = {   1,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   2,    3,    6}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {   2,    3,    4,    5,   10,   11,   12,   13,   14,   15}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][7] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][8] = {   6}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][9] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][10] = {   7}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");

  c_p[x_a].resize(16);
  c_f[x_a].resize(16);
  c_t[x_a].resize(16);
  c_d[x_a].resize(16);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  1,   2}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  1,   2,   3}; //   3

  c_p[x_a][2] = {  3,   4}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  4,   5,   6}; //   3

  c_p[x_a][3] = {  5,   4}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  4,   5,   6}; //   3

  c_p[x_a][4] = {  3,   6}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  1,   7,   6}; //   3

  c_p[x_a][5] = {  5,   6}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  1,   7,   6}; //   3

  c_p[x_a][6] = {  7,   8}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  4,   8,   9}; //   3

  c_p[x_a][7] = {  1,   9}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 10,   9,   3}; //   3

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = {  2,   3}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  2,   4}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0,  10}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  5}; //   1
  c_d[x_a][10] = {  6,   0}; //   2

  c_p[x_a][11] = {  0,  11}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  5}; //   1
  c_d[x_a][11] = {  6,   0}; //   2

  c_p[x_a][12] = {  0,  12}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  5}; //   1
  c_d[x_a][12] = {  6,   0}; //   2

  c_p[x_a][13] = {  3,  13}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  6}; //   1
  c_d[x_a][13] = {  0,   6}; //   2

  c_p[x_a][14] = {  5,  13}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  6}; //   1
  c_d[x_a][14] = {  0,   6}; //   2

  c_p[x_a][15] = { 14,  13}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  6}; //   1
  c_d[x_a][15] = {  0,   6}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_bbx_wpwmuux
//  channel    0: 2v11(1, 2, 16, 32, 8, 4;   0,   6,   5)
//  channel    1: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    2: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    3: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel    4: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel    5: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel    6: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel    7: 42vv(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel    8: 12v1(1, 2, 8, 16, 32, 4;   0,   6,   6)
//  channel    9: 112v(1, 2, 8, 4, 16, 32;   0,   6,   5)
//  channel   10: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   5)
//  channel   11: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   5)
//  channel   12: 2v2v(1, 2, 4, 8, 16, 32;   0,  25,   5)
//  channel   13: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   5)
//  channel   14: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   5)
//  channel   15: 2v2v(1, 2, 16, 32, 4, 8;  25,   0,   5)
