#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_gg_wpwmbbx(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_gg_wpwmbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(7);
  needed_v_smin[x_a].resize(7);
  needed_v_smin[x_a][  0] = {   2,   11,   19,   20,   34,   36,   37,   38}; //   8
  needed_v_smin[x_a][  1] = {   3,    4,   12,   20,   27,   35,   37,   38}; //   8
  needed_v_smin[x_a][  2] = {   4,   12,   27,    3,   35}; //   5
  needed_v_smin[x_a][  3] = {   5,    6,    7,    8,    9,   10,   13,   14,   15,   16,   17,   18,   21,   22,   23,   24,   25,   26,   28,   29,   30,   31,   32,   33,    0,    1}; //  26
  needed_v_smin[x_a][  4] = {   5,    6,    7,   13,   14,   15,   28,   29,   30,    0,   24,   25,   26}; //  13
  needed_v_smin[x_a][  5] = {   8,    9,   10,   16,   17,   18,   31,   32,   33,    1,   21,   22,   23}; //  13
  needed_v_smin[x_a][  6] = {  11,   19,   34,    2,   36}; //   5

  v_smax[x_a].resize(7);
  needed_v_smax[x_a].resize(7);
  needed_v_smax[x_a][  0] = {   2,   11,   19,   34,   36,   38}; //   6
  needed_v_smax[x_a][  1] = {   3,    4,   12,   20,   27,   35,   37}; //   7
  needed_v_smax[x_a][  2] = {   4,    5,    6,    7,   12,   13,   14,   15,   27,   28,   29,   30,    0,    3,   24,   25,   26,   35}; //  18
  needed_v_smax[x_a][  3] = {   5,    6,    7,    8,    9,   10,   13,   14,   15,   16,   17,   18,   21,   22,   23,   24,   25,   26,   28,   29,   30,   31,   32,   33,    0,    1}; //  26
  needed_v_smax[x_a][  4] = {   8,    9,   10,   11,   16,   17,   18,   19,   31,   32,   33,   34,    1,    2,   21,   22,   23,   36}; //  18
  needed_v_smax[x_a][  5] = {  20,   37}; //   2
  needed_v_smax[x_a][  6] = {  38}; //   1

  g_p[x_a].resize(11);
  needed_g_p[x_a].resize(11);
  needed_g_p[x_a][0] = {   2,   11,   19,   34,   36,   38}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin0_smax0");
  needed_g_p[x_a][1] = {   3,    4,   12,   20,   27,   35,   37}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin1_smax1");
  needed_g_p[x_a][2] = {   4,   12,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin2_smax2");
  needed_g_p[x_a][3] = {   5,    8,   13,   16,   21,   24,   28,   31}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   5,    6,    7,   13,   14,   15,   28,   29,   30}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin4_smax2");
  needed_g_p[x_a][5] = {   6,    9,   14,   17,   22,   25,   29,   32}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][6] = {   7,   10,   15,   18,   23,   26,   30,   33}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin3_smax3");
  needed_g_p[x_a][7] = {   8,    9,   10,   16,   17,   18,   31,   32,   33}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin5_smax4");
  needed_g_p[x_a][8] = {  11,   19,   34}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin6_smax4");
  needed_g_p[x_a][9] = {  20,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin0_smax5");
  needed_g_p[x_a][10] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin1_smax6");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {   0,   24,   25,   26}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");
  needed_g_f[x_a][2] = {   1,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][3] = {   2,   36}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][4] = {   3,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,   24,   25,   26,   27,   28,   29,   30,   35}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__16_44");
  needed_g_t[x_a][1] = {   0,   24,   25,   26}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_17__32_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__4_8");
  needed_g_t[x_a][3] = {   1,   21,   22,   23,   31,   32,   33,   34,   36}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__32_28");
  needed_g_t[x_a][4] = {   1,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_33__16_12");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_18__8_4");
  needed_g_t[x_a][6] = {   2,    8,    9,   10,   11}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__32_28");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_34__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_34__20_8");
  needed_g_t[x_a][8] = {   3,    4,    5,    6,    7}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__16_44");
  needed_g_t[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_18__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_18__40_4");
  needed_g_t[x_a][10] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__40_4");
  needed_g_t[x_a][11] = {  36}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__20_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__20_8");
  needed_g_t[x_a][12] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__20_40");
  needed_g_t[x_a][13] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__40_20");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   2,   11,   19,   20,   34,   36,   37,   38}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][1] = {   3,    4,   12,   20,   27,   35,   37,   38}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][2] = {   4,   12,   27}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][3] = {   5,    6,    7,   13,   14,   15,   28,   29,   30}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][4] = {   5,    6,    7,    8,    9,   10,   13,   14,   15,   16,   17,   18,   21,   22,   23,   24,   25,   26,   28,   29,   30,   31,   32,   33}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][5] = {   8,    9,   10,   16,   17,   18,   31,   32,   33}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][6] = {  11,   19,   34}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][7] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {  20}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(39);
  c_f[x_a].resize(39);
  c_t[x_a].resize(39);
  c_d[x_a].resize(39);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   2}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  3}; //   1
  c_t[x_a][2] = {  6,   7}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  4}; //   1
  c_t[x_a][3] = {  8,   9}; //   2
  c_d[x_a][3] = {  1}; //   1

  c_p[x_a][4] = {  1,   2}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  8}; //   1
  c_d[x_a][4] = {  2,   1}; //   2

  c_p[x_a][5] = {  3,   4}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  8}; //   1
  c_d[x_a][5] = {  3,   4}; //   2

  c_p[x_a][6] = {  5,   4}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  8}; //   1
  c_d[x_a][6] = {  3,   4}; //   2

  c_p[x_a][7] = {  6,   4}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  8}; //   1
  c_d[x_a][7] = {  3,   4}; //   2

  c_p[x_a][8] = {  3,   7}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  6}; //   1
  c_d[x_a][8] = {  5,   4}; //   2

  c_p[x_a][9] = {  5,   7}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  6}; //   1
  c_d[x_a][9] = {  5,   4}; //   2

  c_p[x_a][10] = {  6,   7}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  6}; //   1
  c_d[x_a][10] = {  5,   4}; //   2

  c_p[x_a][11] = {  0,   8}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  6}; //   1
  c_d[x_a][11] = {  6,   0}; //   2

  c_p[x_a][12] = {  1,   2}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  7,   2,   1}; //   3

  c_p[x_a][13] = {  3,   4}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  7,   3,   4}; //   3

  c_p[x_a][14] = {  5,   4}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  7,   3,   4}; //   3

  c_p[x_a][15] = {  6,   4}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  7,   3,   4}; //   3

  c_p[x_a][16] = {  3,   7}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  8,   5,   4}; //   3

  c_p[x_a][17] = {  5,   7}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  8,   5,   4}; //   3

  c_p[x_a][18] = {  6,   7}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  8,   5,   4}; //   3

  c_p[x_a][19] = {  0,   8}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  8,   6,   0}; //   3

  c_p[x_a][20] = {  1,   9}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  9,   0,   1}; //   3

  c_p[x_a][21] = {  3}; //   1
  c_f[x_a][21] = {  2}; //   1
  c_t[x_a][21] = {  3,   4}; //   2
  c_d[x_a][21] = {  4}; //   1

  c_p[x_a][22] = {  5}; //   1
  c_f[x_a][22] = {  2}; //   1
  c_t[x_a][22] = {  3,   4}; //   2
  c_d[x_a][22] = {  4}; //   1

  c_p[x_a][23] = {  6}; //   1
  c_f[x_a][23] = {  2}; //   1
  c_t[x_a][23] = {  3,   4}; //   2
  c_d[x_a][23] = {  4}; //   1

  c_p[x_a][24] = {  3}; //   1
  c_f[x_a][24] = {  1}; //   1
  c_t[x_a][24] = {  0,   1}; //   2
  c_d[x_a][24] = {  4}; //   1

  c_p[x_a][25] = {  5}; //   1
  c_f[x_a][25] = {  1}; //   1
  c_t[x_a][25] = {  0,   1}; //   2
  c_d[x_a][25] = {  4}; //   1

  c_p[x_a][26] = {  6}; //   1
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  0,   1}; //   2
  c_d[x_a][26] = {  4}; //   1

  c_p[x_a][27] = {  1,   2}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  2,   1}; //   2

  c_p[x_a][28] = {  3,   4}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = {  3,   4}; //   2

  c_p[x_a][29] = {  5,   4}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = {  3,   4}; //   2

  c_p[x_a][30] = {  6,   4}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = {  3,   4}; //   2

  c_p[x_a][31] = {  3,   7}; //   2
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  3}; //   1
  c_d[x_a][31] = {  5,   4}; //   2

  c_p[x_a][32] = {  5,   7}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  3}; //   1
  c_d[x_a][32] = {  5,   4}; //   2

  c_p[x_a][33] = {  6,   7}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  3}; //   1
  c_d[x_a][33] = {  5,   4}; //   2

  c_p[x_a][34] = {  0,   8}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  3}; //   1
  c_d[x_a][34] = {  6,   0}; //   2

  c_p[x_a][35] = {  1}; //   1
  c_f[x_a][35] = {  4}; //   1
  c_t[x_a][35] = {  0,  10}; //   2
  c_d[x_a][35] = {  1}; //   1

  c_p[x_a][36] = {  0}; //   1
  c_f[x_a][36] = {  3}; //   1
  c_t[x_a][36] = {  3,  11}; //   2
  c_d[x_a][36] = {  0}; //   1

  c_p[x_a][37] = {  1,   9}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 12}; //   1
  c_d[x_a][37] = {  0,   1}; //   2

  c_p[x_a][38] = {  0,  10}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 13}; //   1
  c_d[x_a][38] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_gg_wpwmbbx
//  channel    0: 1111(1, 2, 16, 4, 8, 32;   5,   5,   6)
//  channel    1: 1111(1, 2, 32, 8, 4, 16;   5,   5,   6)
//  channel    2: 2v11(1, 2, 4, 16, 8, 32;   6,   5,   6)
//  channel    3: 2v11(1, 2, 8, 32, 4, 16;   6,   5,   6)
//  channel    4: 3yv1(1, 2, 4, 8, 32, 16;   6,   5,   5)
//  channel    5: 3yv1(1, 2, 32, 4, 8, 16;   0,   5,   5)
//  channel    6: 3yv1(1, 2, 32, 4, 8, 16;  23,   5,   5)
//  channel    7: 3yv1(1, 2, 32, 4, 8, 16;  25,   5,   5)
//  channel    8: 3yv1(1, 2, 16, 4, 8, 32;   0,   5,   5)
//  channel    9: 3yv1(1, 2, 16, 4, 8, 32;  23,   5,   5)
//  channel   10: 3yv1(1, 2, 16, 4, 8, 32;  25,   5,   5)
//  channel   11: 3yv1(1, 2, 8, 4, 16, 32;   6,   5,   5)
//  channel   12: 4yyv(1, 2, 16, 4, 8, 32;   6,   5,   0)
//  channel   13: 4yyv(1, 2, 16, 32, 4, 8;   0,   5,   0)
//  channel   14: 4yyv(1, 2, 16, 32, 4, 8;  23,   5,   0)
//  channel   15: 4yyv(1, 2, 16, 32, 4, 8;  25,   5,   0)
//  channel   16: 4yyv(1, 2, 32, 16, 4, 8;   0,   5,   0)
//  channel   17: 4yyv(1, 2, 32, 16, 4, 8;  23,   5,   0)
//  channel   18: 4yyv(1, 2, 32, 16, 4, 8;  25,   5,   0)
//  channel   19: 4yyv(1, 2, 32, 8, 4, 16;   6,   5,   0)
//  channel   20: 42vv(1, 2, 4, 16, 8, 32;   6,   6,   0)
//  channel   21: 12v1(1, 2, 32, 4, 8, 16;   0,   5,   5)
//  channel   22: 12v1(1, 2, 32, 4, 8, 16;  23,   5,   5)
//  channel   23: 12v1(1, 2, 32, 4, 8, 16;  25,   5,   5)
//  channel   24: 12v1(1, 2, 16, 4, 8, 32;   0,   5,   5)
//  channel   25: 12v1(1, 2, 16, 4, 8, 32;  23,   5,   5)
//  channel   26: 12v1(1, 2, 16, 4, 8, 32;  25,   5,   5)
//  channel   27: 13yv(1, 2, 16, 4, 8, 32;   6,   5,   5)
//  channel   28: 13yv(1, 2, 16, 32, 4, 8;   0,   5,   5)
//  channel   29: 13yv(1, 2, 16, 32, 4, 8;  23,   5,   5)
//  channel   30: 13yv(1, 2, 16, 32, 4, 8;  25,   5,   5)
//  channel   31: 13yv(1, 2, 32, 16, 4, 8;   0,   5,   5)
//  channel   32: 13yv(1, 2, 32, 16, 4, 8;  23,   5,   5)
//  channel   33: 13yv(1, 2, 32, 16, 4, 8;  25,   5,   5)
//  channel   34: 13yv(1, 2, 32, 8, 4, 16;   6,   5,   5)
//  channel   35: 112v(1, 2, 16, 4, 8, 32;   6,   5,   6)
//  channel   36: 112v(1, 2, 32, 8, 4, 16;   6,   5,   6)
//  channel   37: 2v2v(1, 2, 4, 16, 8, 32;   6,   6,   6)
//  channel   38: 2v2v(1, 2, 8, 32, 4, 16;   6,   6,   6)
