#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_uux_wpwmuux(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_uux_wpwmuux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(11);
  needed_v_smin[x_a].resize(11);
  needed_v_smin[x_a][  0] = {   2,    3,    6,    7,    9,   10,   11,   12,   18,   19,   22,   23,   24,   25,   26,   27}; //  16
  needed_v_smin[x_a][  1] = {   4,   16,   21,   24,   25,   26,   27}; //   7
  needed_v_smin[x_a][  2] = {   5,    8,   14,   15,    0}; //   5
  needed_v_smin[x_a][  3] = {   5,    8}; //   2
  needed_v_smin[x_a][  4] = {   6,    7,   11,   12,    2,    3}; //   6
  needed_v_smin[x_a][  5] = {   9,   10,   18,   19,   22,   23}; //   6
  needed_v_smin[x_a][  6] = {  13,   14,   17,   20,    1}; //   5
  needed_v_smin[x_a][  7] = {  13,   20,    1,   17}; //   4
  needed_v_smin[x_a][  8] = {   0,   15}; //   2
  needed_v_smin[x_a][  9] = {   4}; //   1
  needed_v_smin[x_a][ 10] = {  16,   21}; //   2

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   2,    3,    6,    7,    9,   10,   11,   12,   18,   19,   22,   23,   26,   27}; //  14
  needed_v_smax[x_a][  1] = {   4,   16,   21,   24,   25}; //   5
  needed_v_smax[x_a][  2] = {   5,    8,   14,   15,    0}; //   5
  needed_v_smax[x_a][  3] = {   5,    6,    7,    8,   11,   12,    2,    3}; //   8
  needed_v_smax[x_a][  4] = {   9,   10,   13,   18,   19,   20,    1,   17,   22,   23}; //  10
  needed_v_smax[x_a][  5] = {  13,   17,   20,    1}; //   4
  needed_v_smax[x_a][  6] = {  14}; //   1
  needed_v_smax[x_a][  7] = {  24,   25}; //   2
  needed_v_smax[x_a][  8] = {  26,   27}; //   2
  needed_v_smax[x_a][  9] = {   0,   15,   16,   21}; //   4
  needed_v_smax[x_a][ 10] = {   4}; //   1

  g_p[x_a].resize(13);
  needed_g_p[x_a].resize(13);
  needed_g_p[x_a][0] = {   2,    6,    9,   11,   18,   22,   26}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   3,    7,   10,   12,   19,   23,   27}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   4,   16,   21,   24,   25}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   5,    8,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   5,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   6,    7,   11,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][6] = {   9,   10,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {  13,   17,   20}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {  13,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax4");
  needed_g_p[x_a][9] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][10] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax7");
  needed_g_p[x_a][11] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax7");
  needed_g_p[x_a][12] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax8");

  g_f[x_a].resize(8);
  needed_g_f[x_a].resize(8);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   0,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax9");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax5");
  needed_g_f[x_a][3] = {   1,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax4");
  needed_g_f[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax3");
  needed_g_f[x_a][5] = {   4}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax10");
  needed_g_f[x_a][6] = {  16,   21}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax9");
  needed_g_f[x_a][7] = {  22,   23}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");

  g_t[x_a].resize(15);
  needed_g_t[x_a].resize(15);
  needed_g_t[x_a][0] = {   0,   15,   16,   21}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1,   17,   18,   19,   20,   22,   23}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][4] = {   1,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][6] = {   2,    3,    5,    6,    7}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][7] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][10] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][11] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__48_8");
  needed_g_t[x_a][12] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][13] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][14] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   2,    3,    6,    7,    9,   10,   11,   12,   18,   19,   22,   23,   24,   25,   26,   27}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,   16,   21,   24,   25,   26,   27}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {   5,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][3] = {   5,    8,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   6,    7,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   8,   11,   12}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   9,   10,   13}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][7] = {   9,   10,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][8] = {  13,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][9] = {  13,   14,   17,   20}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][10] = {  14}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");

  c_p[x_a].resize(28);
  c_f[x_a].resize(28);
  c_t[x_a].resize(28);
  c_d[x_a].resize(28);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  4}; //   1
  c_t[x_a][2] = {  6,   7}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  4}; //   1
  c_t[x_a][3] = {  6,   7}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  2}; //   1
  c_f[x_a][4] = {  5}; //   1
  c_t[x_a][4] = {  8,   9}; //   2
  c_d[x_a][4] = {  1}; //   1

  c_p[x_a][5] = {  3,   4}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  6}; //   1
  c_d[x_a][5] = {  2,   3}; //   2

  c_p[x_a][6] = {  0,   5}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  6}; //   1
  c_d[x_a][6] = {  4,   0}; //   2

  c_p[x_a][7] = {  1,   5}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  6}; //   1
  c_d[x_a][7] = {  4,   0}; //   2

  c_p[x_a][8] = {  3,   4}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  5,   2,   3}; //   3

  c_p[x_a][9] = {  0,   6}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  6,   7,   0}; //   3

  c_p[x_a][10] = {  1,   6}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  6,   7,   0}; //   3

  c_p[x_a][11] = {  0,   5}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   4,   0}; //   3

  c_p[x_a][12] = {  1,   5}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  5,   4,   0}; //   3

  c_p[x_a][13] = {  7,   8}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  6,   8,   9}; //   3

  c_p[x_a][14] = {  3,   9}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 10,   9,   3}; //   3

  c_p[x_a][15] = {  3}; //   1
  c_f[x_a][15] = {  1}; //   1
  c_t[x_a][15] = {  0,   1}; //   2
  c_d[x_a][15] = {  3}; //   1

  c_p[x_a][16] = {  2}; //   1
  c_f[x_a][16] = {  6}; //   1
  c_t[x_a][16] = {  0,  10}; //   2
  c_d[x_a][16] = {  1}; //   1

  c_p[x_a][17] = {  7}; //   1
  c_f[x_a][17] = {  3}; //   1
  c_t[x_a][17] = {  3,   4}; //   2
  c_d[x_a][17] = {  9}; //   1

  c_p[x_a][18] = {  0,   6}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  3}; //   1
  c_d[x_a][18] = {  7,   0}; //   2

  c_p[x_a][19] = {  1,   6}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  3}; //   1
  c_d[x_a][19] = {  7,   0}; //   2

  c_p[x_a][20] = {  7,   8}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  3}; //   1
  c_d[x_a][20] = {  8,   9}; //   2

  c_p[x_a][21] = {  2}; //   1
  c_f[x_a][21] = {  6}; //   1
  c_t[x_a][21] = {  0,  11}; //   2
  c_d[x_a][21] = {  1}; //   1

  c_p[x_a][22] = {  0}; //   1
  c_f[x_a][22] = {  7}; //   1
  c_t[x_a][22] = {  3,  12}; //   2
  c_d[x_a][22] = {  0}; //   1

  c_p[x_a][23] = {  1}; //   1
  c_f[x_a][23] = {  7}; //   1
  c_t[x_a][23] = {  3,  12}; //   2
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  2,  10}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = { 13}; //   1
  c_d[x_a][24] = {  0,   1}; //   2

  c_p[x_a][25] = {  2,  11}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = { 13}; //   1
  c_d[x_a][25] = {  0,   1}; //   2

  c_p[x_a][26] = {  0,  12}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = { 14}; //   1
  c_d[x_a][26] = {  1,   0}; //   2

  c_p[x_a][27] = {  1,  12}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 14}; //   1
  c_d[x_a][27] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_uux_wpwmuux
//  channel    0: 1111(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    1: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    2: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    3: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    4: 2v11(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    5: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    6: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    7: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel    8: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    9: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   10: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   11: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   12: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   13: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   14: 42vv(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel   15: 12v1(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   16: 12v1(1, 2, 4, 16, 32, 8;   0,   0,   0)
//  channel   17: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
//  channel   18: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   19: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   20: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   21: 112v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   22: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   23: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   24: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   25: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   26: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   27: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)
